/*  Is the graph G triconnected ?   */
#include	<stdio.h>
#include	<stdlib.h>
#include	<math.h>
#include	<cstdlib> 

#define		MAXVTX	150
#define		MAXX	1000
/* N̓OtG̒_ */
/* A̓OtG̗אڍs*/
int		N;
int		**A;

/*---------------------------*/
/*e_̎\̂łЂƂɂ܂Ƃ߂*/
struct vertex {
	int flag;
	int number, lowpt1, lowpt2, nd, father, number_v;
	int newnum, highpt;
	int degree;
};
/*---------------------------*/
/*"L"\\. source-ӂ̌, sink-ӂ̐*/
struct edge{
	int source, sink;
	struct edge *next;
};
/* \ ELIST  */
typedef struct elist{
	struct edge *elst;
} ELIST;

/* \ VLIST  */
typedef struct v_list{
	struct v_list *next;
	int vnum;
} VLIST;

/* \ ADPLIST  */
typedef struct ad_pathlist_tag{
	VLIST *vlst;
	struct ad_pathlist_tag *next;
} ADPLIST;

/* \VLIST̗̈mۂB*/
VLIST *getmemory(void)
{
	return((VLIST *)malloc(sizeof (VLIST)));
}

/* \struct edgë̗mۂB*/
struct edge *getmemory_e(void)
{
	return((struct edge *)malloc(sizeof (struct edge)));
}

/* \ADPLIST̗̈mۂB*/
ADPLIST *getmemory_path(void)
{
	return((ADPLIST *)malloc(sizeof (ADPLIST)));
}
/*---------------------------*/
int		nn = 0;
ADPLIST ad_list[2*MAXX+2];
ADPLIST head_a[2*MAXX+2];
ADPLIST *path = NULL;

/*separation point郊Xg*/
VLIST *bic_list, *head_bic_list;

/* separation-pairtype1, type2ʂɓ郊Xg */
struct edge *sp_type1;
struct edge *head_sp_type1;
struct edge *sp_type2;
struct edge *head_sp_type2;

void Procedure1(struct vertex *,int,int);
void Procedure4(struct vertex *);
void Procedure5(struct vertex *);
void lemma13(struct vertex *,int *,int *);
void print_splist(struct vertex *);
void change_a(struct vertex *);
void change3(struct vertex *);
void path_ch(struct vertex *);
void lowpt_ch(struct vertex *ver);
int biconnected(struct vertex *ver);
void print_spoint(struct vertex *);
int check_frond1(int, int, int);
int check_frond2(struct vertex *, int, int);
int is_not_frond(int, int);
int CheckType1(struct vertex *);
int CheckType2(struct vertex *);
int	check_x(int, int, int);
int	check_y(int, int);
void	pathfinder(int, struct vertex *, int *, int *, VLIST *);
void	get_des(ADPLIST *,ADPLIST *,int,int);
int		get_s(int *, int, ADPLIST *,ADPLIST *head_sub);
void	get_des(ADPLIST *,ADPLIST *, int, int);
int		getedge(int *, int *, int *, int *);
int		compute(struct vertex *, int, int);
int		get_w(int, int *, int *);

/* ꂼ̍\̂Ԍɒǉ֐*/	
VLIST *addition(VLIST *head,int i);
struct edge *setout(int,ELIST *,int,int);
VLIST *listad(int,ADPLIST *,int);
ADPLIST *listpath(ADPLIST *,VLIST *);
struct edge *sptype(struct edge *head_sp_type,int a,int b);

/*--------------------------------------------------*/
/*אڍspӂ*/
void Get_Matrix(int n, int ***A)
{
	int		i, j;

	(*A) = (int **)malloc(sizeof(int *)*n);
	if ((*A) == NULL) {
		printf("Memory exhaused\n");
		exit(1);
	}
	else {
		for (i = 0; i < n; i++) {
			(*A)[i] = (int *)malloc(sizeof(int)*n);
			if ((*A)[i] == NULL) {
				printf("Memory exhaused\n");
				for (j = 0; j < i; j++)
					free((char*)(*A)[j]);
				exit(1);			
			}
		}
	}
}

void Free_Matrix(int n, int **A)
{
	int		i;

	for (i = 0; i < n; i++) {
		free((char*)A[i]);
	}
	free((char*)A);
}

/*---------------------------------------------------*/
int triconnected(int mm[][MAXVTX], long len)
//int triconnected(int mm[], long len)
{

	int		i, j, k, start;
	int		type1, type2;
	/* _verƂ\̂N */
	struct vertex ver[MAXX];
	int		e, u;
	int		biconnected1;

	nn = 0;	/* Don't remove, (see at the top in Procedure1()) */
	biconnected1 = 0;
	type1 = type2 = 0;
	start = 1;
	path = NULL;	/* BugFix 2004/2/13 by M. Ochiai */

	/* אڍsz`ɑ */
	N = len;
//	N = sqrt(len);
	Get_Matrix(N, &A);
	for (j=0; j<N; j++)
		for (k=0; k<N; k++)
			A[j][k] = mm[j+1][k+1];
//			A[j][k] = mm[j*N+k];

	/* _number, flag̒l */
	for(i=0; i<N; i++){
		ver[i].number = 0;
		ver[i].father = 0;/*	_̐1炾Az0Ȃ̂ō킹
     	start_father̒l */
		ver[i].flag = 1;
		ver[i].newnum = ver[i].highpt = 0;
		ver[i].lowpt1 = ver[i].lowpt2 = ver[i].nd = ver[i].number_v = 0;
		ver[i].degree = 0;
	}
	
	/*OtGDFS */
	Procedure1(ver, start, 0);
	
	/*͂OtAȂ΁AuAvƏo*/
	for(u=0; u<N; u++){
		if(ver[u].number==0){
//			printf("The graph is disconnected.\n");
			Free_Matrix(N, A);
		    return 3;
		}
	}

	/* depth-feast-searchŐVtꂽԍ̏
	   אڍsׂB*/
	change_a(ver);  
	change3(ver);    /* father,lowpt1,lowpt2,nd̒lB*/

	/*͂Ot2-AʓIOtłȂA2Ԃ*/
	biconnected1 = biconnected(ver);
	if(biconnected1){
//		printf("The graph G has a separation point.\n");
//		printf("This is not biconnected.\n");
	    print_spoint(ver);
		Free_Matrix(N, A);
	    return 2;
	}

	Procedure4(ver);  /* Procedure4:tꂽאڃXg̍\z*/

	Procedure5(ver); /*OtG̃p[؂Path𐶐 */

	/* ԍtB*/
	for(e=0; e<N; e++){
		ver[e].number_v=ver[e].number;
		ver[e].number=ver[e].newnum;
	}

	change_a(ver);  /*VtꂽԍɗאڍsׂB*/
    lowpt_ch(ver);  /* father,loept1,lowpt2̒lB*/

	path_ch(ver);   /*  path̔ԍVԍɏB*/

	/* lemma13Atype1type2separation-pair*/
	lemma13(ver, &type1, &type2);

	/*	lemma13ŁAtype1type2separation-pair΁A
@@	ꂼtype1,type2̒ltrue 1ɂȂ̂ŁCif̒\ */
	if( type1 || type2 ){
//		printf("The graph G has a separation pair.\n");
//		printf("This is not triconnected.\n");
		/* separation-point̃Xgt@Cɏo i0Ԃj*/
		print_splist(ver);
		Free_Matrix(N, A);
		return 0;
	}
	/* separation-pointꍇAOtG͎OAł iPԂj*/
	else {
//		printf("This graph is triconnected because it has no separation pairs.\n");
		Free_Matrix(N, A);
		return 1;
	}
	Free_Matrix(N, A);
	return 0;
}
/*---------------------------------------------------------------*/
/* separation-pair̃XgCtype1, type2ɕāCt@Co */
void print_splist(struct vertex *ver)
{
	int		a,b,c,d;
	int		a1,b1,c1,d1;
	int		i,h,ii,hh;
	FILE	*out;

	out = fopen("separation_pairs.txt", "w");

	fprintf(out, "type1: ");
	while(sp_type1 != NULL) {      /*DFSŕtԍɖ߂*/
		for(i=0; i<N; i++) {
			if(ver[i].number==sp_type1->source)
				a=i+1;
			if(ver[i].number==sp_type1->sink)
				b=i+1;
		}
		for(h=0; h<N; h++) {         /*ŏ̒_̔ԍɖ߂*/
			if(ver[h].number_v==a)
				a1=h+1;
			if(ver[h].number_v==b)
				b1=h+1;
		}
		fprintf(out, "(%2d, %2d), ",a1,b1);
		sp_type1=sp_type1->next;
	}
	fprintf(out, "\n");
	
	fprintf(out, "type2: ");
	while(sp_type2 != NULL) {     /*DFSŕtԍɖ߂*/
		for(ii=0; ii<N; ii++){
			if(ver[ii].number==sp_type2->source)
				c=ii+1;
			if(ver[ii].number==sp_type2->sink)
				d=ii+1;
		}
		for(hh=0; hh<N; hh++){        /*ŏ̒_̔ԍɖ߂*/
			if(ver[hh].number_v==c)
				c1=hh+1;
			if(ver[hh].number_v==d)
				d1=hh+1;
		}
		fprintf(out, "(%2d, %2d), ",c1,d1);
		sp_type2=sp_type2->next;
	}
	fprintf(out, "\n");
	fclose(out);
	return;
}

/*----------------------------------------------------------------*/
/* lemma13ɑ֐CheckType1Function:
   "sub"r̎q(descendant)XgAbv(sub͒_݂̐) */
void get_des(ADPLIST *sub,ADPLIST *head_sub, int r, int point)
{
	int		i;
	VLIST	*eda,*head_eda;

	head_eda = NULL;
	head_sub[r].vlst = listad(r,head_sub,point+1);  /*qɂ͎܂܂*/ 
	sub[r].vlst = head_sub[r].vlst;

	/* A[][](אڍs)Cp[؂ǂ */
	for(i=point+1; i<N; i++) { 
		if(A[point][i] == 1) {
			/*p[؂Ɋ܂܂钸_Xg"eda"ɃXgbN */
			head_eda = addition(head_eda,i);
		}
	}
	eda = head_eda;
	
	while(eda != NULL) {
		/* "eda"ǂāCe_ɑ΂CċA */    
		get_des(sub, head_sub, r, eda->vnum); 
		eda = eda->next;
	}
	sub[r].vlst = head_sub[r].vlst;
}
/*---------------------------*/
/* lemma13ɑ֐CheckType1Function:
   šCr̎q(descendant)Xg"sub"瓾D
@@r̎qł͂Ȃ_(Xg"sub"ɖ_), š */
int get_s(int *s_ref, int r, ADPLIST *sub,ADPLIST *head_sub)
{
	int		i;
	VLIST	*get_iter;

	for(i=(*s_ref)+1; i<N+1; i++) {  
		get_iter=NULL;
		while(sub[r].vlst !=NULL){
			if( sub[r].vlst->vnum == i ) { 
				get_iter = sub[r].vlst;
			}
			sub[r].vlst=sub[r].vlst->next;
		}
		sub[r].vlst=head_sub[r].vlst;
		/* isN܂ŉ񂵂āCi_"sub"Ɋ܂܂Ă
	@@	get_iterɒlԂ */
		if(get_iter == NULL) {        /* i_Cr̎qł͂Ȃ̂ŁCš */
			(*s_ref) = i;
			return 1;           /*š₪_ŁC1ԂCI*/
		}
	}
	return 0;               /*š₪ȂƂ */
}
/*---------------------------*/
/* lemma13Function: type1separation-pairT
	ȉ̏ɍ_TD̓_type1separation-pointɂȂD
	r != a,b ; s != a,b ; b->r; LOWPT1(r)=a; LOWPT2(r)>=b; sr̎qł͂Ȃ*/
int CheckType1(struct vertex *ver)
{
	int			ret_val; 
	int			a, r, b, s, father;
	int			j;
	ADPLIST		sub[MAXX];
	ADPLIST		head_sub[MAXX];
	struct edge *get_iter;

	ret_val = 0;
	a = r = b = s = father = 0;
	sp_type1=NULL;
	head_sp_type1=NULL;
	
	for(j=0; j<N; j++) {
		head_sub[j].vlst=NULL;
	}

	for(r=0; r<N; r++) {       /* r ߂ */
		a = ver[r].lowpt1 ;   /* r CLOWPT1(r)=a a */
		b = ver[r].father ;   /* r Cb->r lCb.(br̕) */
		if(a < b){            /* a < b ̃`FbN */
			if( a != r+1 && b != r+1 ) {  /* r != a,b ̃`FbN */
				if(ver[r].lowpt2 >= b) {  /* LOWPT2(r)>=b ̃`FbN */
					/* "sub"r̎q(descendant)XgAbv */
					get_des(sub,head_sub, r, r);   
					while( get_s(&s, r, sub,head_sub) ) {/*get_sš𓾂*/
						if( s != a && s != b ){ 
							/* SĂ̏𖞂̂ŁĈƂ(a,b)
							   separation-pair.C(a,b)łsp_type1
							   Xgɑ݂ꍇ́CXgɉȂ */
							get_iter=NULL;
							while(sp_type1 !=NULL) {
								if( sp_type1->source == a && sp_type1->sink == b )
									get_iter = sp_type1;
								sp_type1=sp_type1->next;
							}
							/* sp_type1(a,b)݂͑Ȃ̂ŁCXgɉ*/
							if(get_iter == NULL) { 
								head_sp_type1=sptype(head_sp_type1,a,b); 
								ret_val = 1;/*type1sp݂̂ŁC1Ԃ*/
							}	
						}
						sp_type1=head_sp_type1;
					}
					s=0;     /* s0ɖ߂ */
				}
			}
		}
	}
    /* SĂ̑gݍ킹𒲂ׂāCID */	
	return ret_val;
}
/*----------------------------------------------------------*/
/* lemma13ɑ֐CheckType2Function"check_frond1""check_x"̈ꕔ:
	"r<=x<b 𖞂SĂ̗t x-->y  a <= y𖞂,
	(tȂꍇ́CĂ̂Ƃ); "̃`FbN̈ꕔD*/
int check_y(int x, int a)
{
	int		y;

	/* ĂxɂāC*/
	for(y=0; y<(x-1); y++) {
		if(A[x-1][y] == 2) {    /* x-->y ƂȂyTC */
			if( a > y+1 ) {     /* a<=y ǂ`FbND*/
				return 0; /*Ȃ̂ꍇ́C 0 Ԃ */
			}
		}
	}
	return 1; /*SĂya<=y𖞂 or xtȂƂC1 Ԃ*/
}
/*---------------------------*/
/*lemma13ɑ֐CheckType2Function"check_frond1"̈ꕔ:
	"r<=x<b 𖞂SĂ̗t x-->y  a <= y𖞂,
	(tȂꍇ́CĂ̂Ƃ); "̃`FbN̈ꕔD*/
int check_x(int a, int b, int r)
{
	int		x;
	int		checky; 

	checky = 0; 
	for(x=1; x<N+1; x++) {
        /* r<=x<b Cx̌I,x蓱y"check_y"ŒׂD
		   y𖞂ȂƂCfalse 0ԂėC
		   ̎_ł͖̏ȂƂɂȂ(false 0Ԃ) */
		if( r <= x && x < b ) {
			checky = check_y(x, a);
			if( !checky )
				return 0;   
		}
	}
	if( checky ) 
		return 1; 
	return 1;  
}
/*---------------------------*/
/* lemma13ɑ֐CheckType2Function:
	"r<=x<b 𖞂SĂ̗t x-->y  a <= y𖞂,
	(tȂꍇ́CĂ̂Ƃ);" ̃`FbNsD
	Ă΁Ctrue 1 Ԃ */
int check_frond1(int a, int b, int r)
{
	int		checkx;  

	checkx = check_x(a, b, r);
	return checkx;
}
/*-------------------------------------------------*/
/* lemma13ɑ֐CheckType2Function:
    "a<y<b, b->w*->x 𖞂SĂ̗t x-->y  LOWPT1(w) >= a 𖞂
   (tȂꍇ́CĂ̂Ƃ);"̃`FbNsD
   b𖞂ƁCtrue 1ԂD*/
int check_frond2(struct vertex *ver, int a, int b)
{
	int		x, w,i;
	VLIST	*y_list, *x_list, *w_list,*heady,*headx,*headw;
	int		point, pre_point;
	
	x=w=0;
	point=pre_point=0;
	headx=heady=headw=NULL;
	y_list=x_list=w_list=NULL;

	/* a<y<b Cy̌TC"y_list"ɓ */
	for(i=1; i<N+1; i++) {
		if( a < i && i < b )
			heady=addition(heady,i); 
	}
    /* y̌₩Cx-->ygCA[][](אڍs), x̌T */
	y_list=heady;
	while(y_list!=NULL) {
		for(i=(y_list->vnum)-1; i<N; i++) {
			if(A[i][(y_list->vnum)-1] == 2)
				headx=addition(headx,i+1); /*x̌x_listɓ*/
		}
		y_list=y_list->next;
	}

	/* x̌₩Cb->w*->xgCw̌T*/
	x_list=headx;
	while(x_list!=NULL) {
		x = x_list->vnum;
		/* bx肵̂ŁA
		   fatherǂboCw肷(b̎w) */
		point = x;
		pre_point = ver[point-1].father;
		for( ; pre_point != 0 ; pre_point = ver[point-1].father) {
			if(pre_point == b) {
				headw=addition(headw,point); 
			}
			point = pre_point;
		}
		x_list=x_list->next;
	}

    /*  w̌₪C LOWPT1(w) >= a 𖞂ǂ̃`FbN
	    ĂȂ̂ł΁C̏͐Ȃ
    	(̎_false 0Ԃ) */
	w_list=headw;
	while(w_list!=NULL) {
		w = w_list->vnum;
		if( ver[w-1].lowpt1 < a )
			return 0;  
		w_list=w_list->next;
	}
	/* SĂw"LOWPT1(w) >= a"𖞂ĂƂ̂,
	   true 1 Ԃ(͐) */
	return 1;  
}
/*---------------------------*/
/* lemma13CheckType2̊֐
   אڍs񂩂tǂo (t͋p) */
int is_not_frond(int is_b, int sub_r)
{
	if ( A[sub_r -1][is_b -1] == 2 )
		return 0;  
	return 1; 
}
/*---------------------------*/
/* lemma13Function: type2separation-pairT */
int CheckType2(struct vertex *ver)
{
	/*	ȉ̏ɍ_TD̓_type2separation-pointɂȂD
	r != b; a->r*->b; br̍ŏ̎qł; a != 1;
	r<=x<b 𖞂SĂ̗t x-->y  a <= y𖞂();
	a<y<b, b->w*->x 𖞂SĂ̗t x-->y  LOWPT1(w) >= a 𖞂();
	(tȂꍇ́C𖞂Ă̂Ƃ)*/
	int		ret_val;  
	int		a, b, r, s;
	int		size;
	int		check_frond_1; 
	int		check_frond_2;
	VLIST	*list_p,*tmp_iter,*b_tmp_iter,*head_b;
	VLIST	*b_list;      /* _b̌ɂȂ̂̃Xg b_list */
	ADPLIST *head_pa;
	struct	edge *sp_get_iter;

	ret_val = 0;
	a = b = r = s = 0;
	check_frond_1 = 0;
	check_frond_2 = 0;
	list_p = NULL;

	head_sp_type2 = NULL;
	head_pa = path;

	for(r=0; r<N; r++) {            /* r܂߂ */	
		a = ver[r].father ;			/* Ca  r ̐eł */
		if( a != 0 && a != 1) {     /* a != 1 */
			/* a->r*->b; br̎qł; Ca->r Path
			   b ̌TCb_listɓ */
			path=head_pa;
			head_b=NULL;
			while(path != NULL) {
				b_tmp_iter=NULL;
				tmp_iter=NULL;	
				size = 0;
				list_p = path->vlst;
				while(list_p != NULL) {
					size++;
					list_p=list_p->next;
				}
			    list_p=path->vlst;
				
				/* a->r*->bA*->͗t܂܂Ȃ */
				for( ; size > 2 ; size--) {
					tmp_iter = list_p;		
					if( tmp_iter->vnum == a ) {						
						tmp_iter=tmp_iter->next;
						if( tmp_iter->vnum == r+1 ) {
							tmp_iter=tmp_iter->next;		
								b_tmp_iter = tmp_iter;
								while(b_tmp_iter->next !=NULL) {
									if ( is_not_frond(b_tmp_iter->vnum, r+1) ) { 
										/*   *-> ͗tȂ */
										head_b=addition(head_b,b_tmp_iter->vnum); 
									}
									b_tmp_iter=b_tmp_iter->next;
								}
							
						}
					}
					list_p=list_p->next;
				}
				path=path->next;
			}
			
            /* b ̌₩Cɏɍ̂T */
			b_list=head_b;
			while(b_list != NULL) {
				b = b_list->vnum;
				if( a < b ){ 
					if ( b != r+1 ) { 
						
						check_frond_1 = 0;  
						check_frond_1 = check_frond1(a, b, r+1);
						check_frond_2 = 0;  
						/* "a<y<b, b->w*->x 𖞂SĂ̗t x-->y 
						   LOWPT1(w) >= a 𖞂;"̃`FbNsD
						   b𖞂ƁCtrue 1ԂĂD*/	
						check_frond_2 = check_frond2(ver, a, b);	
						if (check_frond_1 && check_frond_2) { 
							/* b2̏𖞂ĂƂ */
							/* (a,b)separation-pairƂăXg"sp_type2"
							  ̂Csp_type2ɂł(a,b)݂
							  ͉Ȃ */
							/* sp_type2ɂł(a,b)邩̃`FbND
							(ꍇ́Csp_get_iterɒlԂDsp_get_iter
							 NULLԂ́Csp_type2(a,b)݂Ȃ̂ŁC
							 Ăǂ)*/
							sp_get_iter =NULL;
							while(sp_type2 != NULL){
								if(sp_type2->source == a && sp_type2->sink == b)
									sp_get_iter = sp_type2;
								sp_type2=sp_type2->next;
							}
							/* sp_type2(a,b)݂Ȃ̂ŁC 
							   sp_type2Xg(a,b) */
							if(sp_get_iter == NULL) { 
								head_sp_type2=sptype(head_sp_type2,a,b); 
								/*type2sp݂̂ŁCԂltrue 1 */ 
								ret_val = 1 ; 
							}
						}
					}
				}
				b_list=b_list->next;
			}
			free((VLIST *)b_list);      /* b̌XV */
		}
	}
	sp_type2=head_sp_type2;
	path=head_pa;
	return ret_val;
}
/*---------------------------*/
/* lemma13̏Ctype1,type2separation-pairT */
void lemma13(struct vertex *ver, int *istype1, int *istype2)
{
	/* type1, 2separation-paiȑa<b
	   type1separation-pairǂ肷 */
	*istype1 = CheckType1(ver);
	/* type2separation-pairǂ肷 */
	*istype2 = CheckType2(ver);
	/* typeseparation-pairtureԂ */
	return;
}
/*----------------------------------------------------------------------------*/
/* Procedure5Function:OtGPathT(A[][]-אڍs-g) */
void pathfinder(int v, struct vertex *ver, int *s_ref, int *m_ref, VLIST *head)
{
	int		w;
	VLIST	*my_p;
	
	w=0;
	ver[v-1].newnum = (*m_ref) - ver[v-1].nd + 1;

	while(ad_list[v].vlst!=NULL) {     /* ad_list͗אڃXgA() */
		w = ad_list[v].vlst->vnum;
		if( (*s_ref) == 0 ) {
			(*s_ref) = v;
			head=NULL;    
			head=addition(head,v);    /* ݂Path(my_p)ɓ_w */
		}
			
		head=addition(head,w);    
		my_p=head;
			
		if(A[v-1][w-1] == 1){  /* v -> w :vwɎ}Ƃ */
			pathfinder(w, ver, s_ref, m_ref, my_p);
			(*m_ref) -= 1;
		}
		else { 
			if (ver[ver[w-1].newnum].highpt == 0)
				ver[ver[w-1].newnum].highpt = ver[v-1].newnum ;
				/* ݂Path(my_p)SĂPath̃Xg"path"ɉ
				   "my_p"͂ЂƂPath\A"path"͂̂ЂƂ
				      ƂPath̊Jn_ւ̃|C^S,XgƂ
				      Ď(=SĂPath) */
			path=listpath(path,my_p); 
			
			(*s_ref) = 0;
		}
		ad_list[v].vlst=ad_list[v].vlst->next;	
	}
	return;
}
/*---------------------------*/
/* Procedure5:OtG̃p[؂Path𐶐 */
void Procedure5(struct vertex *ver)
{
	int		i, m, s;

	s = 0;
	m = N;
	for(i=0; i<N; i++)
		ver[i].newnum = ver[i].highpt = 0;
	pathfinder(1, ver, &s, &m, NULL);
	return;
}
/*------------------------------------------------------------------*/
/* Procedure4Function:(v,w) vZ */
int compute(struct vertex *ver, int v, int w)
{
	if(A[v-1][w-1] == 2) 
		return (2*w + 1);
	else if(A[v-1][w-1] == 1){
		if(ver[w-1].lowpt2 < v) 
			return (2 * ver[w-1].lowpt1) ;
		else if(ver[w-1].lowpt2 >= v) 
			return (2 * ver[w-1].lowpt1 + 1) ;
		else 
			return -1;
	}
	else 
		return -1;
}
/*---------------------------*/
/* Procedure4Function:G̃GbW(v, w)̑gĂ(A[][]) */
int getedge(int *v_ref, int *w_ref, int *i_ref, int *j_ref)
{
	for( ; (*i_ref) < N; (*i_ref)++) {
		for( ; (*j_ref) < N ; (*j_ref)++) {
			if ( A[(*i_ref)][(*j_ref)] != 0 ) {
				(*v_ref) = (*i_ref) + 1;
				(*w_ref) = (*j_ref) + 1;
				(*j_ref)++;
				return 1 ;
			}
		}
		(*j_ref) = 0;
	}
	return 0;
}
/*---------------------------*/
/* Procedure4:tꂽאڃXg̍\z */
void Procedure4(struct vertex *ver)
{
	int		v, w, i_iter, j_iter;
	int		fai;
	int		ii,i,k;
	ELIST	bucket[2*MAXX+2];
	ELIST	head[2*MAXX+2];

	v = w = i_iter = j_iter = 0;
	fai = ii = 0;
	for(i=0; i<(2*N+2); i++) {
		head[i].elst=NULL;
		bucket[i].elst=NULL;
		head_a[i].vlst=NULL;
		ad_list[i].vlst=NULL;
	}

	/* G̃GbW(v, w)̑gĂČJԂDȂΔ */
	while(getedge(&v, &w, &i_iter, &j_iter)) {
		fai = compute(ver, v, w);
		/* V(v, w)ƂGbWCBUCKET[(v,w)]ɉ*/
		head[fai].elst=setout(fai,head,v,w);
	}

	for(ii=1; ii< (2*N +2); ii++) {
		if ( head[ii].elst!=NULL) { 
			bucket[ii].elst=head[ii].elst;
			while(bucket[ii].elst!=NULL) {
				v = bucket[ii].elst->source;
				w = bucket[ii].elst->sink;
				head_a[v].vlst = listad(v,head_a,w);
				bucket[ii].elst = bucket[ii].elst->next;
			}
		}
	}
	for(k=0; k<N+1; k++) {
		ad_list[k].vlst = head_a[k].vlst;
	}
}
/*---------------------------------------------------------*/
/* Procedure1Function: w𓾂 */
int get_w(int v, int *w_ref, int *iter_n_ref)
{
	for(; (*iter_n_ref) < N; (*iter_n_ref)++) {
		if(A[v-1][(*iter_n_ref)] != 0) {
			(*w_ref) = (*iter_n_ref) + 1;
			(*iter_n_ref)++;
			return 1; 
		}
	}
	return 0; 
}
/*---------------------------*/
/* Procedure1: OtGDFS */
void Procedure1(struct vertex *ver, int v, int u)
{
	int		w, iter_n;

	w = iter_n = 0;
	nn = ver[v-1].number = nn + 1;

	ver[v-1].lowpt1 = ver[v-1].lowpt2 = ver[v-1].number;
	ver[v-1].nd = 1;	
	
	/* get_wŗאڍs񂩂w𓾂D
	   ȂfalseԂĂă[v𔲂 */
	while(get_w(v, &w, &iter_n)) {
		if(ver[w-1].number == 0) {
			if(A[w-1][v-1] == 1) 
				A[w-1][v-1] = 0;
			Procedure1(ver, w, v);

			if(ver[w-1].lowpt1 < ver[v-1].lowpt1) {
				ver[v-1].lowpt2 = ver[v-1].lowpt1 < ver[w-1].lowpt2 ? ver[v-1].lowpt1 : ver[w-1].lowpt2 ;
				ver[v-1].lowpt1 = ver[w-1].lowpt1;
			}
			else if( ver[w-1].lowpt1 == ver[v-1].lowpt1 )
				ver[v-1].lowpt2 = ver[v-1].lowpt2 < ver[w-1].lowpt2 ? ver[v-1].lowpt2 : ver[w-1].lowpt2 ;
			else
				ver[v-1].lowpt2 = ver[v-1].lowpt2 < ver[w-1].lowpt1 ? ver[v-1].lowpt2 : ver[w-1].lowpt1 ;
			ver[v-1].nd += ver[w-1].nd ;
			ver[w-1].father = v;
		}
		else if(ver[w-1].number < ver[v-1].number && (w != u || ver[v-1].flag == 0 /*false*/) ) {
			/* A[v-1][w-1]͗tȂ̂2ɂC̋t̕ӂ͂Ȃ(0)Ƃ */
			if(A[v-1][w-1] == 1) 
				A[v-1][w-1] = 2;
			if(A[w-1][v-1] == 1) 
				A[w-1][v-1] = 0;

			if(ver[w-1].number < ver[v-1].lowpt1) {
				ver[v-1].lowpt2 = ver[v-1].lowpt1 ;
				ver[v-1].lowpt1 = ver[w-1].number ;
			}
			else if(ver[w-1].number > ver[v-1].lowpt1)
				ver[v-1].lowpt2 = ver[v-1].lowpt2 < ver[w-1].number ? ver[v-1].lowpt2 : ver[w-1].number ;
		}
		if (w == u) 
			ver[v-1].flag = 0; 
	}
	return;
}
/*------------------------------------------*/
/* path̔ԍVԍ(newnum)ɒB*/
void path_ch(struct vertex *ver)
{
	ADPLIST		*head_p;
	int			ex,ep;
	VLIST		*list_p,*tmp_iter;

	ep=0;
	head_p=path;
	
	while(path != NULL) {
		list_p=path->vlst;
		tmp_iter=NULL;
		
        while(list_p != NULL) {
			tmp_iter= list_p;
			ex=tmp_iter->vnum;
			ep=ver[ex-1].newnum;
			if(ver[ex-1].newnum != ex) {
				tmp_iter->vnum=ep;
			}
			list_p=list_p->next;
		}
		path=path->next;
	}
	path=head_p;
}
/*---------------------------*/
/*@אڃXgׂB*/
void change_a(struct vertex *ver)
{
   int		i,j,k;
   int		p,q,r;
   int		Ac[300][300];
   
   for(i=1;i<N+1;i++) {
		for(j=0;j<N;j++) {
			if(ver[j].number==i)
				for(k=0;k<N;k++)
					Ac[i-1][k]=A[j][k];
		}
	}
   for(p=1;p<N+1;p++) {
		for(q=0;q<N;q++) {
			if(ver[q].number==p)
				for(r=0;r<N;r++)
					A[r][p-1]=Ac[r][q];
		}
	}
	return;
}
/*---------------------------*/
/* ver ́@number,lowpt1,lowpt2,nd ύXB*/
void change3(struct vertex *ver)
{
	int		i,j;
	int		num;
    struct vertex ver1[MAXX];

	for(i=0;i<N;i++) {
	    num=ver[i].number;
		ver1[num-1].father=ver[ver[i].father-1].number;
		ver1[num-1].lowpt1=ver[i].lowpt1;
		ver1[num-1].lowpt2=ver[i].lowpt2;
		ver1[num-1].nd=ver[i].nd;
	}
	ver1[0].father=0;
	
	for(j=0;j<N;j++) {
		ver[j].father=ver1[j].father;
		ver[j].lowpt1=ver1[j].lowpt1;
		ver[j].lowpt2=ver1[j].lowpt2;
        ver[j].nd=ver1[j].nd;
	}
	return;
}
/*---------------------------*/
/* ver ́@number,lowpt1,lowpt2 ύXB*/
void lowpt_ch(struct vertex *ver)
{
	int		i,j;
	int		num;
    struct vertex ver1[MAXX];

	for(i=0;i<N;i++) {
		num=ver[i].number;
		ver1[num-1].father=ver[ver[i].father-1].number;
		ver1[num-1].lowpt1=ver[ver[i].lowpt1-1].number;
		ver1[num-1].lowpt2=ver[ver[i].lowpt2-1].number;
		ver1[num-1].nd=ver[i].nd;
	}
	ver1[0].father=0;

	for(j=0;j<N;j++) {
		ver[j].father=ver1[j].father;
		ver[j].lowpt1=ver1[j].lowpt1;
		ver[j].lowpt2=ver1[j].lowpt2;
        ver[j].nd=ver1[j].nd;
	}
	return;
}
/*-------------------------*/
/* VLIST ^̍\̂ԌɒǉB*/	
VLIST *addition(VLIST *head, int i)
{
	VLIST	*gbox,*list;

	if(head==NULL) {
		list=getmemory();
		list->next=NULL;
		list->vnum=i;
		head=list;
	}
	else { 
		list=head;	
		while(list->next!=NULL)
			list=list->next;
	
		gbox=getmemory();
		list->next=gbox;
		gbox->next=NULL;
		gbox->vnum=i;
	}

	return (head);
}
/*-----------------------------*/
/* \̂ԌɒǉB*/	
struct edge *setout(int a,ELIST *head,int v,int w)
{
	struct edge *gbox,*list;

	if(head[a].elst==NULL) {
		list=getmemory_e();
		list->next=NULL;
		list->source=v;
		list->sink=w;
		head[a].elst=list;
	}
	else { 
		list=head[a].elst;
		while(list->next!=NULL)
			list=list->next;
		gbox=getmemory_e();
		list->next=gbox;
		gbox->next=NULL;
		gbox->source=v;
		gbox->sink=w;
	}
	return (head[a].elst);
}
/*----------------------------------*/
/* \̂ԌɒǉB*/					
VLIST *listad(int a,ADPLIST *head_a,int v)
{
	VLIST *gbox,*list;

	if(head_a[a].vlst==NULL) {
		list=getmemory();
		list->next=NULL;
		list->vnum=v;
		head_a[a].vlst=list;
	}
	else { 
		list=head_a[a].vlst;
		while(list->next!=NULL)
			list=list->next;
		gbox=getmemory();
		list->next=gbox;
		gbox->next=NULL;
		gbox->vnum=v;
	}
	return (head_a[a].vlst);
}
/*------------------------------------*/
/* \̂ԌɒǉB*/	
ADPLIST *listpath(ADPLIST *head_path,VLIST *my_p)
{
	ADPLIST *gbox,*list;

	if(head_path==NULL) {
		list=getmemory_path();
		list->next=NULL;
		list->vlst=my_p;
		head_path=list;
	}
	else { 
		list=head_path;
		while(list->next!=NULL)
			list=list->next;
		gbox=getmemory_path();
		list->next=gbox;
		gbox->next=NULL;
		gbox->vlst=my_p;
	}
	return (head_path);
}
/*----------------------------------*/
/* \̂ԌɒǉB*/	
struct edge *sptype(struct edge *head_sp_type,int a,int b)
{
	struct edge *gbox,*list;

	if(head_sp_type==NULL) {
		list=getmemory_e();
		list->next=NULL;
		list->source=a;
		list->sink=b;
		head_sp_type=list;
	}
	else { 
		list=head_sp_type;
		while(list->next!=NULL)
			list=list->next;
		gbox=getmemory_e();
		list->next=gbox;
		gbox->next=NULL;
		gbox->source=a;
		gbox->sink=b;
	}
	return (head_sp_type);
}
/*---------------------------------------------*/
/*͂ꂽOt2Aǂ肷*/
int biconnected(struct vertex *ver)
{
	int			u,a,t,j,degree,pof;
	ADPLIST		desc[MAXX];
    ADPLIST		head_desc[MAXX];

	degree = pof = 0;
	head_bic_list = NULL;

	for(j=0; j<=N; j++) {
		head_desc[j].vlst = NULL;
		if(A[0][j]==1)
			degree++;
	}
	
	for(u=1; u<N; u++) {
		if(degree == 1 && ver[u].father == 1)
			;
		else {
			t = 0;
			pof = 1;
			get_des(desc,head_desc,u,u);               /*q߂*/
			while(head_desc[u].vlst != NULL) {
				a = head_desc[u].vlst->vnum;
				if(ver[a-1].lowpt1 < ver[u].father)
					t = 1;
				head_desc[u].vlst = head_desc[u].vlst->next;
			}
			if(t==0) {
				bic_list = head_bic_list;
				while(bic_list != NULL){
					if(bic_list->vnum == ver[u].father)
						pof = 0;
					bic_list = bic_list->next;
				}
				if(pof == 1) {
					/*sseparation pointbic_listɓ@*/
					head_bic_list = addition(head_bic_list,ver[u].father);
				}
			}
		}
	}

	if(head_bic_list==NULL)
		return 0;
	else
		return 1;
}

/*---------------------------------------------*/
/*separation pointo͂*/			
void print_spoint(struct vertex *ver)
{
	int		i;

	FILE *out = fopen("separation_point.txt", "w");
	while(head_bic_list!=NULL) {
		for(i=0; i<N; i++){
			if(ver[i].number == head_bic_list->vnum)
				fprintf(out, "( %d ), ", i+1);
		}
		head_bic_list = head_bic_list->next;
	}
	fprintf(out, "\n");
	fclose(out);
	return;
}
/*------------------------------------------------*/