//*****************************************//
// Ochiai Lab. Nara Women's University     //
// Programmed by Chihiro Taninaka          //
// All rights reserved. March 1999         //
//*****************************************//
#include "stdafx.h"

#include "CGraph.h"

// constructor
CGraph::CGraph()
{//
	nV = nE = G_EMPTY;	AdjList = NULL;
}

CGraph::CGraph(iMatrix &mtx, int Vnum) 
{//אڍsA_
	nV = Vnum;
	AdjList = GetAdjList(mtx);
	CountEdge();
}

CGraph::CGraph(CrList *list, int Vnum)
{//אڃXgA_
	nV = Vnum;
	AdjList = new CrList[nV];
	for(int i = 0; i < nV; i++)
		AdjList[i]  = list[i];
	CountEdge();
}

CGraph::CGraph(CGraph &g)
{//Ot
	nV = g.nV;	nE = g.nE;	//nF = g.nF;
	AdjList = new CrList[nV];
	for(int i = 0; i < nV; i++)
		AdjList[i] = g.AdjList[i];
}

CGraph::CGraph(iostream &st)
{//istremit@Cj̓
	const int max_size = 256;
	char str[max_size];
	//////////// _ǂݍ /////////////////
	st.getline(str,max_size);		//Psڂ̓ǂݍ

	nV = atoi(str);	//_̓ǂݍ
	nE = 0;

	if(nV <= 0){  //_0ȉ̓_
		nV = nE = G_EMPTY;	AdjList = NULL;
		return;
	}

	//////////// אڏǂݍ //////////////
	iMatrix AdjMat(nV, nV);		//אڍs̏ (nV,nV)̗s
	AdjList = new CrList[nV];	//אڃXg쐬

	char buf[256];

	int i = 0, j = 0, count = 0, num=1;
	int low=0, column=0;	//s̍sԍAԍA
	int max;

	while(1){
		st.getline(str,max_size);
		if((max = strlen(str))==0)	//ǂݍ񂾕̒
			break;
		while(i < max) {	//ǂݍ񂾂Ps̃f[^𒲂ׂ
			while(i < max &&  str[i] != ' ') { //؂
				buf[j++] = str[i++];
			}

			buf[j] = '\0';
			i++;	// '\0'' 'Ƃ΂B
			j=0;	// j͌ɖ߂

			column = atoi(buf)-1;	//ɒi-1Ă)

			if(column != low && column != -1) {	//-1(X0)͍s̏ILƂĈ
				if(column < 0 || column > nV) { //O菬Vnum傫΃G[
					nV=nE=G_EMPTY;
					AdjMat = iMatrix();
					delete[] AdjList;
					return;
				}
				AdjMat.equal(low, column, 1);	//(low,column)1ɂB
				AdjList[low].Push(column);
				nE++;
			}
		};
		low++;	//̍sɈڂ
		AdjList[low].Sort();
		i=0;
		str[0]='\0';
	};

	//////////// אڍs̃`FbN ////////////
	for(i = 0; i < nV; i++)
		for(j = i+1; j < nV; j++)
			if(AdjMat.youso(i,j) != AdjMat.youso(j,i)) {
				nV=nE=G_EMPTY;
				AdjMat = iMatrix();
				delete[] AdjList;
			}
	nE /= 2;
}


//////////////////operator///////////////
CGraph CGraph::operator =(const CGraph &g)
{// 
	nV = g.nV;	nE = g.nE;	//nF = g.nF;
	if(AdjList != NULL) delete[] AdjList;
	AdjList = new CrList[nV];
	for(int i = 0; i < nV; i++)
		AdjList[i] = g.AdjList[i];
	return *this;
}


/////////////o[̒lԂ֐////////////////
CrList *CGraph::GetAdjList()
{
	if(nV == G_EMPTY)	return NULL;
	CrList *list = new CrList[nV];
	for(int i = 0; i < nV; i++)
		list[i] = AdjList[i];
	return list;
}

////////////Otɂ悭߂֐/////////////
void CGraph::CountEdge()
{//ӂ̐𐔂
	nE = 0;
	for(int i=0;i<nV;i++)
		nE += AdjList[i].Num();
	nE /= 2;
}

int * CGraph::GetDegree()
{//߂̔zԂ
	if(nV == G_EMPTY) return NULL;
	int *deg = new int[nV];

	for(int i = 0; i < nV; i++)
		deg[i] = AdjList[i].Num();

	return deg;
}

CrList * CGraph::GetAdjList(iMatrix &AdjMat)
{//אڍsאڃXg߂Ẵ|C^Ԃ
	int Vmax;
	if((Vmax = AdjMat.mSize())==0) return NULL;

	CrList *adjlist = new CrList[Vmax];
	int i, j;

	for(i = 0; i < Vmax; i++)
		for(j = nV-1; j>=0; j--)
			if(AdjMat.youso(i,j))
				adjlist[i].Push(j);
	return adjlist;
}

bool CGraph::IsConnected()
{
	if(nV == G_EMPTY) return true;

	int *Number = new int[nV];	//DFS̃io[
	int i, no = -1;

	CrList *adjlist = GetAdjList(); //אڃXgRs[
	for(i = 0; i < nV; i++){ //
		adjlist[i].Sort(0);
		Number[i] = -1;
	}

	int max = _DFS_(Number, adjlist,no); //[DTs

	delete[] adjlist;
	delete[] Number;

	if(max == nV-1)	return true;
	else			return false;
}

 //[DTs_ԍzԂ
int CGraph::_DFS_(int *Number, CrList *adjlist, int &no, int v, int u)	
{//Default v=u=0
	int w;
	Number[v] = ++no;
	
	while(adjlist[v].Num()) { //list[v]̗vfOŖ
		w = adjlist[v].Pop();
		if(Number[w] == -1)	_DFS_(Number, adjlist, no, w, v);//ċA
	};
	return no;
}


int *CGraph::DFS()
{//DipthFirstSearch(DFS)sADFSɂ钸_ԍԂ
	if(nV == G_EMPTY) return NULL;

	int *Number = new int[nV];	//DFS̃io[
	int i, no = -1;

	CrList *adjlist = GetAdjList(); //אڃXgRs[
	for(i = 0; i < nV; i++){ //
		adjlist[i].Sort(0);
		Number[i] = -1;
	}
	_DFS_(Number, adjlist,no); //[DTs

	delete[] adjlist;
	return Number;
}

int *CGraph::GetReducedIncidenceMtx
	(iMatrix &At, iMatrix &Al, DirectedEdge **et, DirectedEdge **el)
{//At ؕ̊ڑsAAlt̊̕ڑs (AOtł邱!!)
	int *Number = DFS();		//DFSsA_ԍς
	int *ReNum = new int[nV];	//DFS̒_ԍ̒_ԍɕς Number̋t֐
	*et	= new DirectedEdge[nV-1];
	*el = new DirectedEdge[nE - (nV-1)];
	
	int i,j,k;	//JE^[

	for(i = 0; i < nV; i++)
		ReNum[Number[i]] = i;

	////؂̕ӂ̊ڑs𐶐////

	At = iMatrix(nV-1, nV-1);		//wTCỸ[s̍쐬
	iMatrix mtx=GetAdjMat();

	for(i = 0; i < nV; i++) {	
		for(j = i-1; j >= 0; j--) {
			if(mtx.youso(ReNum[i],ReNum[j])) {
				if(i < nV-1) At.equal(i,i-1,1);	//vf(i,i-1)1ɂB
				if(j < nV-1) At.equal(j,i-1,1);	//vf(j,i-1)1ɂB
				(*et)[i-1].Set(j,i); 
				mtx.equal(ReNum[i],ReNum[j],0);	//̃Xebv̂߂ɖ؂̕ӂאڍs񂩂폜B
				mtx.equal(ReNum[j],ReNum[i],0);	//					h
				break;
	}}}

	////t̕ӂ̊ڑs𐶐////
	k=0;
	Al = iMatrix(nV-1, nE-(nV-1));	//wTCỸ[s̍쐬

	for(i = 0; i < nV-1; i++) {
		for(j = i+1; j < nV; j++) {
			if(mtx.youso(ReNum[i],ReNum[j])) {
								Al.equal(i,k,1);
				if(j < nV-1)	Al.equal(j,k,1);	//vf(i,i-1),(j,i-1)1ɂB
				(*el)[k].Set(i,j);
				k++;
	}}}

	delete[] ReNum;
	return Number;
}

iMatrix CGraph::GetAdjMat()
{//אڍsԂ
	if(nV==G_EMPTY)
		return iMatrix();

	CrList *alist=new CrList[nV];
	for(int i=0; i < nV; i++)
		alist[i] = AdjList[i];

	iMatrix mtx(nV,nV);	//(nV,nV)s
	for(i = 0; i < nV; i++)
		while(alist[i].Num())
			mtx.equal(i,alist[i].Pop(),1);

	return mtx;
}

//////////////////Ot̃Tv////////////////////////

//Ot̃Tv C60
void CGraph::GraphC60()
{
	int imat[]={
0,1,0,0,0,1,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
1,0,1,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,1,0,1,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,1,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,1,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
1,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,1,0,0,0,0,0,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,1,0,0,0,0,0,0,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,1,0,0,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
1,0,0,0,0,0,0,0,1,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,1,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,1,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,1,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,1,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,1,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,1,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,1,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,1,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,1,0,1,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,1,0,0,0,0,0,1,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,0,0,1,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,0,0,1,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,0,0,0,0,0,0,0,0,0,0,1,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,0,0,1,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,0,0,0,0,0,0,0,0,0,0,1,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,1,1,0};

//	AdjMat = iMatrix(60, 60, imat);
	nV = 60;	nE = 90;	//nF = 31;
	AdjList = GetAdjList(iMatrix(nV, nV, imat));

}

//Ot̃Tv _ÛP
void CGraph::GraphV6_1()
{
	nV = 6;	nE = 9;	//nF = 4;
	
	iMatrix AdjMat(nV, nV);
	
	AdjMat.equal(0,1,1); AdjMat.equal(1,0,1);
	AdjMat.equal(1,2,1); AdjMat.equal(2,1,1);
	AdjMat.equal(2,0,1); AdjMat.equal(0,2,1);
	AdjMat.equal(0,5,1); AdjMat.equal(5,0,1);
	AdjMat.equal(1,3,1); AdjMat.equal(3,1,1);
	AdjMat.equal(2,4,1); AdjMat.equal(4,2,1);
	AdjMat.equal(3,4,1); AdjMat.equal(4,3,1);
	AdjMat.equal(4,5,1); AdjMat.equal(5,4,1);
	AdjMat.equal(5,3,1); AdjMat.equal(3,5,1);
	AdjList = GetAdjList(AdjMat);
}

//Ot̃Tv _101
void CGraph::GraphV10_1()
{
	int imat[] =  
	{0,1,0,0,0,0,0,0,1,1,
	 1,0,1,1,1,0,0,0,0,0,
	 0,1,0,1,0,0,1,1,1,0,
	 0,1,1,0,1,1,0,0,0,1,
	 0,1,0,1,0,0,0,0,0,0,
	 0,0,0,1,0,0,1,0,0,1,
	 0,0,1,0,0,1,0,1,1,0,
	 0,0,1,0,0,0,1,0,1,0,
	 1,0,1,0,0,0,1,1,0,1,
	 1,0,0,1,0,1,0,0,1,0};

	nV = 10;	nE = 19;
	AdjList = GetAdjList(iMatrix(nV, nV, imat));
}

//Ot̃Tv _102
void CGraph::GraphV10_2()
{
	int imat[] =  
	{0,1,0,0,0,0,0,0,1,1,
	 1,0,1,1,1,0,0,0,0,0,
	 0,1,0,1,0,0,1,1,1,0,
	 0,1,0,1,1,1,0,0,0,1,
	 0,1,0,1,0,0,0,0,0,0,
	 0,0,0,1,0,0,1,0,0,1,
	 0,0,1,0,0,1,0,1,1,0,
	 0,0,1,0,0,0,1,0,1,0,
	 1,0,1,0,0,0,1,1,0,1,
	 1,0,0,1,0,1,0,0,1,0};

	nV = 10;	nE = 19;
	AdjList = GetAdjList(iMatrix(nV, nV, imat));
}

//Ot̃Tv _103
void CGraph::GraphV10_3()
{
	int imat[] =  
	{0,1,1,0,0,0,1,0,0,0,
	 1,0,1,0,1,0,0,0,0,0,
	 1,1,0,1,0,1,1,0,0,0,
	 0,0,1,0,1,1,0,0,0,0,
	 0,1,0,1,0,0,0,0,0,0,
	 0,0,1,1,0,0,0,0,0,0,
	 1,0,1,0,0,0,0,1,1,1,
	 0,0,0,0,0,0,1,0,1,1,
	 0,0,0,0,0,0,1,1,0,0,
	 0,0,0,0,0,0,1,1,0,0};

	nV = 10;	nE = 15;
//	AdjMat = iMatrix(nV, nV, imat);
	AdjList = GetAdjList(iMatrix(nV, nV, imat));

}

CMessages CGraph::Output()
{
	CMessages ms;

	if(nV == G_EMPTY) {
		ms += "No Data !\n";
	} else {

		char buf[256];
		ms += "*********** Adjaceny List ***********\n";

		///_̐///
		ms += "Number of Vertices ";
		sprintf(buf, ": %d, ", nV);
		ms += buf;

		///ӂ̐///
		ms += "Number of Edges ";
		sprintf(buf, ": %d.", nE);
		ms += buf;
		ms += "\n";

		///אڃXg///
		for(int i = 0; i < nV; i++) {
			sprintf(buf, "%3d :", i+1);
			ms += buf;
			ms += AdjList[i].Output(1);	//1𑫂lo
			ms += "\n";
		}
	}
	return ms;
}

void CGraph::SaveData(ostream &s)
{
	s << Output();
}

#ifdef	_draw_  //draw.hŒ`
	////////////////Ot̕`/////////////////////////
	//ł́Aac搶̕`NXgpB
	//炪A`ꂽȂƂ́A`ȂB


void CGraph::DrawGraph(draw &d)
{//Pʉ~ɁA_Ԃɔzuĕ`B

	if(nV == G_EMPTY)
		return;

//	const double pi = 3.14159265358979323846;	//draw.hŒ`(#define)Ă
	CrList *list = GetAdjList();
	double base = 2*pi/nV;

	int i;
	double x,y;
	double r = d.Pixel()* 2;
	char buf[256];

	string str;
	for(i = 0; i < nV; i++) {
		x = cos(i*base+pi/2); y = sin(i*base+pi/2);
//		d.DrawCircle(x,y,r,0,rgb(0,0,1));
		d.PaintDisc(x,y,r,rgb(0,0,1));
		sprintf(buf, "%d", i+1);
		str = buf;
		d.DrawString(x*1.1, y*1.1, str, 0.1, "Times");
		while(list[i].Num()) {
			int j = list[i].Pop();
			if(i < j)
				d.DrawLine(x, y, cos(j*base+pi/2), sin(j*base+pi/2));
			else
				break;
		}
	}
}

#endif


///////////////////////////////////////////////////////////////////////////////////////////
