//*****************************************//
// Ochiai Lab. Nara Women's University     //
// Programmed by Chihiro Taninaka          //
// All rights reserved. March 1999         //
//*****************************************//

/*****************************************
 Ot̋KNX
******************************************/

#ifndef __CGraph_H__
#define __CGraph_H__

#include <iostream>
using namespace std;

#include "..\Tools\Matrix.h"
#include "..\Tools\CList.h"
#include "..\Wada\draw.h"

//#include "..\Tools\CMessages.h"	//ōNXgpƂ
typedef string CMessages;	//݂C++WCustringgp

//////////////////////////////////////////////////////////////////
// Ot̕

class Edge{	//Ot̕ӂNXBB
protected:
	int u, v;	//(u,v)

public:
	Edge(){u=v=-1;}	//Default constructer
	Edge(int a, int b){u=a; v=b;}	//(a,b)쐬

	int Vtx1(){return u;}
	int Vtx2(){return v;}
	void Set(int a, int b){u=a; v=b;}

	friend bool operator == (Edge &a, Edge &b)
	{//ӂǂ
		if(a.u == b.u && a.v == b.v ||a.u == b.v && a.v == b.u ) return true;
		else	return false;
	}
	friend bool operator != (Edge &a, Edge &b)
	{//Ⴄӂǂ
		if(a.u == b.u && a.v == b.v ||a.u == b.v && a.v == b.u ) return false;
		else	return true;
	}

	char *Output(int *num=NULL)
	{
		char *buf=new char[256];
		if(num == NULL)	sprintf(buf, "e=(%2d, %2d) ", u, v);			//vZ̕ӂ̒_
		else			sprintf(buf, "e=(%2d, %2d) ", num[u], num[v]);	//[U`̔ԍ
		return buf;
	}
};

class DirectedEdge : public Edge{	//t
public:
	DirectedEdge(){}
	DirectedEdge(int a, int b):Edge(a,b){}
	int Tail(){return u;}
	int Head(){return v;}
	bool IsBackEdge(){return (u>v)? true:false;}
	bool IsTreeEdge(){return (u<v)? true:false;}

	friend bool operator == (DirectedEdge &a, DirectedEdge &b)
	{//ӂǂ
		if(a.u == b.u && a.v == b.v) return true;
		else	return false;
	}
	friend bool operator != (DirectedEdge &a, DirectedEdge &b)
	{//Ⴄӂǂ
		if(a.u == b.u && a.v == b.v) return false;
		else	return true;
	}
};

/////////////////////////////////////////////////////////////
//Ot

class CGraph {

protected:
	int		nV, nE;		//_Aӂ̐
	CrList	*AdjList;	//אڃXg

public:
	enum graph_mode{G_EMPTY=-1};

public:
	/////// contructors and a destructor///////
	CGraph();					//default,B
	CGraph(iMatrix &, int);		//אڍsA_
	CGraph(CrList *, int);		//אڃXgA_
	CGraph(iostream &);			//iostreamit@Cj̓
	CGraph(CGraph &);			//Ot

	~CGraph(){};				//destructor

	/////////// operator ////////////
	CGraph	operator =(const CGraph &); //

	/////////////o[̒lԂ֐////////////////
	int NumV(){return nV;};	//_Ԃ
	int NumE(){return nE;};	//ӂ̐Ԃ
	CrList* GetAdjList();	//אڃXgԂ

	////////////Otɂ悭߂֐/////////////
	void CountEdge();		//אڃXgӂ̐𐔂
	int * GetDegree();		//߂Ĕzɓꂻ̃|C^Ԃ
	CrList * GetAdjList(iMatrix &);//אڍsאڃXg߂Ẵ|C^Ԃ
	int * DFS();			//DipthFirstSearch(DFS)sADFSɂ钸_ԍԂ
	int _DFS_(int *Number, CrList *AdjList, int &no, int v=0, int u=0);	//DFSŎgp
	int * GetReducedIncidenceMtx(iMatrix &, iMatrix &, DirectedEdge **, DirectedEdge **);
							//ڑs쐬BDFSɂ钸_ԍԂ
	iMatrix GetAdjMat();	//אڍsԂ
	bool IsConnected();		//AOtǂ

	/////////////////TvOt////////////////////
public:
	void GraphC60();	//TvOtC60
	void GraphV6_1();	//				_ŨOt
	void GraphV10_1();  //                    10
	void GraphV10_2();  //
	void GraphV10_3();  //

	////////// o͗p /////////
	void SaveData(ostream &);
	CMessages Output();

#ifdef	_draw_  //draw.hŒ`
	////////////////Ot̕`/////////////////////////
	//ł́Aac搶̕`NXgpB
	//炪A`ꂽȂƂ́A`ȂB
	void DrawGraph(draw &);
#endif

};

////////////////////////////////////////////////
// 悭gpNumberReNumɊւNX
//	NumberReNum
//  Number[ReNum[i]]=ReNum[Number[i]]=i
//@𖞂Qint^złƒ`B
//
//	gpFNumber[i]iDFSɂԍƂƁA
//			ReNum[i]DFSɂԍǐ̔ԍ\B
//
//	ɁA֐ȊOgpƂ́ÄmہA
//@ӂ邱ƁB

class CalNumber {
private:
	int number_size;

protected:
	int *Number, *ReNum;	//Number[ReNum[i]] = i; Ƃ֌W𖞂
						//Number[i]͒_iDFSɂԍ
	CalNumber(){ Number=ReNum=NULL; number_size=0;}
	~CalNumber()
	{
		if(Number != NULL)	delete[] Number;
		if(ReNum != NULL)	delete[] ReNum;
	}
	void InitNumber(int size, bool flg = false)
	{//̈mۂƏs
		number_size = size;
		int i;
		if(flg) {
			Number = new int[size];
			for(i=0; i<size; i++)
				Number[i]=-1;
		}
		ReNum  = new int[size];
			for(i=0; i<size; i++)
				ReNum[i]=-1;
	}
	void CalReNum()
	{//NumbervZĂAɑΉlReNum낦
		if(number_size>0) {
			for(int i=0; i < number_size; i++)
				if(Number[i] != -1)
					ReNum[Number[i]] = i;
		}
	}
	void DelNumber()
	{
		if(Number != NULL) {
			delete[] Number; Number = NULL;
		}
		if(ReNum != NULL) {
			delete[] ReNum; ReNum = NULL;
		}
	}
};

#endif