/******************************
 Class Vector3
   Created by Chihiro Taninaka
*******************************/

#ifndef  __Vector3_h__
#define  __Vecror3_h__

#include <stdio.h>

class Vector3 {

public:
	double x, y, z;

	Vector3()
	{	x = y = z = 0; }

	Vector3(double xx, double yy, double zz)
	{	x = xx; y = yy; z = zz; }

	Vector3(double vec[3])
	{	x = vec[0]; y = vec[1]; z = vec[2]; }

	Vector3(double p[3], double q[3])// make vector pq
	{x = q[0]-p[0];	y = q[1]-p[1];	z = q[2]-p[2]; }

	friend Vector3 operator +(const Vector3 &vec)
	{ return vec; }

	friend Vector3 operator -(const Vector3 &vec)
	{ 
		Vector3 ans;
		ans.x = -vec.x; ans.y = -vec.y; ans.z = -vec.z;
		return ans;
	}

	friend Vector3 operator +(const Vector3 &v1, const Vector3 &v2)  //Z
	{
		Vector3 ans;
		ans.x = v1.x + v2.x;	ans.y = v1.y + v2.y;	ans.z = v1.z + v2.z;
		return ans;
	}

	friend Vector3 operator -(const Vector3 &v1, const Vector3 &v2)  //Z
	{
		Vector3 ans;
		ans.x = v1.x - v2.x;	ans.y = v1.y - v2.y;	ans.z = v1.z - v2.z;
		return ans;
	}

	friend double  operator *(const Vector3 &v1, const Vector3 &v2)  //
	{
		double ans;
		ans = v1.x * v2.x + v1.y * v2.y + v1.z * v2.z;
		return ans;
	}

	friend Vector3 operator *(const double r,  const Vector3 &v1) //XJ[{
	{
		Vector3 ans;
		ans.x = r * v1.x;	ans.y = r * v1.y;	ans.z = r * v1.z;
		return ans;
	}

	friend Vector3 operator *(const Vector3 &v1, const double r)     //@@h
	{
		Vector3 ans;
		ans.x = r * v1.x;	ans.y = r * v1.y;		ans.z = r * v1.z;
		return ans;
	}

	friend Vector3 operator /(const double r,    const Vector3 &v1)  //@@h
	{
		Vector3 ans;
		ans.x = v1.x / r;	ans.y = v1.y / r;	ans.z = v1.z / r;
		return ans;
	}

	friend Vector3 operator ^(const Vector3 &v1, const Vector3 &v2)  //O
	{
		Vector3 ans;
		ans.x = v1.y*v2.z - v2.y*v1.z;
		ans.y = v1.z*v2.x - v2.z*v1.x;
		ans.z = v1.x*v2.y - v2.x*v1.y;
		return ans;
	}

	friend double  operator >>(const Vector3 &, const Vector3 &) //v1v2Ɏˉe
	{
		double xx;
		xx =  v1.x * v2.x + v1.y * v2.y + v1.z * v2.z;
		xx /= sqrt(v2.x*v2.x+v2.y*v2.y+v2.z*v2.z);
		return xx;
	}

	Vector3 operator +=(const Vector3 &vec)
	{	
		x += vec.x;	y += vec.y;	z += vec.z;
		return *this;
	}

	Vector3 operator -=(const Vector3 &vec)
	{
		x -= vec.x;	y -= vec.y;	z -= vec.z;
		return *this;
	}

	Vector3 operator *=(const double r)
	{
		x *= r;	y *= r;	z *= r;
		return *this;
	}

	Vector3 operator /=(const double r)
	{
		if(r == 0) {
			printf("vec / 0 !!\n");
			exit(0);
		}
		x /= r;	y /= r;	z /= r;
		return *this;
	}

	friend bool operator == (const Vector3 &v1, const Vector3 &v2)
	{
		if(v1.x == v2.x && v1.y == v2.y && v1.z == v2.z) return true;
		else	return false;
	}

	friend bool operator != (const Vector3 &v1, const Vector3 &v2)
	{
		if(v1.x != v2.x || v1.y != v2.y || v1.z != v2.z) return true;
		else	return false;
	}

	Vector3 unit()
	{
		Vector3 ans;
		double r = sqrt(x*x+y*y+z*z);
		if(r != 0) {
			ans.x = x/r; ans.y = y/r; ans.z = z/r;
		}
		return ans;
	}

	double norm()
	{	return sqrt(x*x+y*y+z*z); }

	void print()
	{	cout <<"(" << x <<"," << y << "," << z << ")" ; //(x,y,z) }

	void to_array(double vec[3])
	{	vec[0] = x; vec[1] = y; vec[2] = z;	}
};

#endif





