(************** Content-type: application/mathematica **************
                     CreatedBy='Mathematica 5.0'

                    Mathematica-Compatible Notebook

This notebook can be used with any Mathematica-compatible
application, such as Mathematica, MathReader or Publicon. The data
for the notebook starts with the line containing stars above.

To get the notebook into a Mathematica-compatible application, do
one of the following:

* Save the data starting with the line of stars above into a file
  with a name ending in .nb, then open the file inside the
  application;

* Copy the data starting with the line of stars above to the
  clipboard, then use the Paste menu command inside the application.

Data for notebooks contains only printable 7-bit ASCII and can be
sent directly in email or through ftp in text mode.  Newlines can be
CR, LF or CRLF (Unix, Macintosh or MS-DOS style).

NOTE: If you modify the data for this notebook not in a Mathematica-
compatible application, you must delete the line below containing
the word CacheID, otherwise Mathematica-compatible applications may
try to use invalid cache data.

For more information on notebooks and Mathematica-compatible 
applications, contact Wolfram Research:
  web: http://www.wolfram.com
  email: info@wolfram.com
  phone: +1-217-398-0700 (U.S.)

Notebook reader applications are available free of charge from 
Wolfram Research.
*******************************************************************)

(*CacheID: 232*)


(*NotebookFileLineBreakTest
NotebookFileLineBreakTest*)
(*NotebookOptionsPosition[   1318436,      23977]*)
(*NotebookOutlinePosition[   1319142,      24001]*)
(*  CellTagsIndexPosition[   1319098,      23997]*)
(*WindowFrame->Normal*)



Notebook[{
Cell[BoxData[
    StyleBox[
      \(\(\:ff11\:ff10\:ff0e\) \:ff13\ \ \ \ \ \ 
        \:5e73\:9762\:30b0\:30e9\:30d5\:306e\:63cf\:753b\),
      FontSize->14]], "Input"],

Cell[TextData[{
  "\:3000\:30b0\:30e9\:30d5\:ff27\:306f\:ff12\:6b21\:5143\:5e73\:9762\:4e0a\
\:306b\:ff12\:3064\:306e\:8fba\:306e\:5185\:90e8\:3067\:4ea4\:308f\:3089\:306a\
\:3044\:3088\:3046\:306b\:63cf\:3051\:308b\:3068\:304d\:306b\:3001\:5e73\:9762\
\:7684\:30b0\:30e9\:30d5(planar graph)\:3067\:3042\:308b\:3068\:8a00\:3044\
\:3001\:5e73\:9762\:4e0a\:306b\:63cf\:304b\:308c\:305f\:30b0\:30e9\:30d5\:3092\
\:ff08\:5143\:306e\:30b0\:30e9\:30d5\:306e\:ff09\:5e73\:9762\:30b0\:30e9\:30d5\
(plane graph)\:3068\:8a00\:3044\:3001 ",
  Cell[BoxData[
      \(TraditionalForm\`G\&_\)]],
  " \:3067\:8868\:3059\:3002\:5e73\:9762\:30b0\:30e9\:30d5\:306e\:3059\:3079\
\:3066\:306e\:8fba\:3092\:76f4\:7dda\:3067\:63cf\:753b\:3059\:308b\:65b9\:6cd5\
\:304c\:3042\:308b\:304c\:3001\:305d\:308c\:306b\:306b\:3064\:3044\:3066\:306f\
\:5f8c\:3067\:8ff0\:3079\:308b\:3002\n\:3000\:307e\:305a\:3001\:5e73\:9762\
\:7684\:30b0\:30e9\:30d5\:306b\:3064\:3044\:3066\:306e\:57fa\:672c\:7684\:6982\
\:5ff5\:306b\:3064\:3044\:3066\:8aac\:660e\:3059\:308b\:3002\n\:3000\:4efb\
\:610f\:306e\:5e73\:9762\:30b0\:30e9\:30d5",
  Cell[BoxData[
      \(TraditionalForm\`G\&_\)]],
  "\:306f\:3001\:5e73\:9762\:3092\:3044\:304f\:3064\:304b\:306e\:9818\:57df\
\:306b\:5206\:5272\:3059\:308b\:3002\:3053\:306e\:9818\:57df\:306e\:3053\:3068\
\:3092\:9762 (face)\:3068\:8a00\:3044\:3001\:9762\:5168\:4f53\:306e\:96c6\
\:5408\:3092 F(",
  Cell[BoxData[
      \(TraditionalForm\`G\&_\)]],
  ")\:3068\:8868\:3059\:3002 F(",
  Cell[BoxData[
      \(TraditionalForm\`G\&_\)]],
  ")\:306e\:552f\:4e00\:3064\:306e\:8981\:7d20\:306e\:307f\:304c\:3001\:7121\
\:9650\:9818\:57df\:3067\:3042\:308a\:3001\:3053\:308c\:3092\:5916\:9762 \
(outermost face)\:3068\:8a00\:3046\:3002\:5916\:9762\:306e\:5468\:4e0a\:306e\
\:8fba\:306e\:4f5c\:308b\:30b5\:30a4\:30af\:30eb\:3092\:3001\:5916\:5468\:8def\
 (outermost cycle)\:3068\:8a00\:3046\:3002\n\:3000\:5e73\:9762\:7684\:30b0\
\:30e9\:30d5\:ff27\:306e\:5e73\:9762\:30b0\:30e9\:30d5",
  Cell[BoxData[
      \(TraditionalForm\`G\&_\)]],
  "\:306b\:5bfe\:3057\:3066\:3001\:6b21\:306e\:3053\:3068\:304c\:6210\:308a\
\:7acb\:3064\:3002\n\n\:30aa\:30a4\:30e9\:30fc(Euler)\:306e\:5b9a\:7406\:3000\
\:ff5cV(G\:ff5c\:30fc\:ff5cE(G)\:ff5c\:ff0b\:ff5cF(",
  Cell[BoxData[
      \(TraditionalForm\`G\&_\)]],
  ")\:ff5c\:ff1d\:ff12\n\n\:3000\:3053\:306e\:5b9a\:7406\:306b\:3088\:308a\
\:3001\:5e73\:9762\:7684\:30b0\:30e9\:30d5\:ff27\:306b\:5bfe\:3057\:3066\:3001\
F(",
  Cell[BoxData[
      \(TraditionalForm\`G\&_\)]],
  ")\:306f\:4e00\:5b9a\:3067\:3042\:308b\:306e\:3067\:3001F(G) = F(",
  Cell[BoxData[
      \(TraditionalForm\`G\&_\)]],
  ")\:3068\:3059\:308b\:3002\:307e\:305f\:3001\:30aa\:30a4\:30e9\:30fc\:306e\
\:5b9a\:7406\:306f\:ff5cE(G)\:ff5c\:306b\:95a2\:3059\:308b\:5e30\:7d0d\:6cd5\
\:3067\:7c21\:5358\:306b\:8a3c\:660e\:51fa\:6765\:308b\:3002\:66f4\:306b\:3001\
\:6b21\:306e\:3053\:3068\:304c\:5c0e\:3051\:308b\:3002\:3000\n\t\:ff5cE(G)\
\:ff5c\[LessEqual] 3\:ff5cV(G\:ff5c\:30fc\:ff16\:3000\:305f\:3060\:3057\:3001\
\:ff5cV(G\:ff5c\[GreaterEqual] \:ff13\n\:3000\:3053\:306e\:4e0d\:7b49\:5f0f\
\:306b\:3088\:308a\:3001",
  Cell[BoxData[
      \(TraditionalForm\`K\_5\)]],
  "\:3082",
  Cell[BoxData[
      \(TraditionalForm\`K\_\(3, 3\)\)]],
  "\:3082\:5e73\:9762\:7684\:30b0\:30e9\:30d5\:3067\:306f\:306a\:3044\:304c\
\:793a\:305b\:308b\:3002\:66f4\:306b\:3001\:5e73\:9762\:7684\:30b0\:30e9\:30d5\
\:306e\:8fba\:306e\:500b\:6570\:306f\:3001\:9802\:70b9\:306e\:500b\:6570\:306e\
\:ff13\:500d\:3088\:308a\:5c11\:306a\:3044\:3053\:3068\:306b\:306a\:308b\:3002\
\n\:3000\:6b21\:306e\:5b9a\:7406\:306f\:3001\:5e73\:9762\:6027\:3092\:5224\
\:5b9a\:3059\:308b\:57fa\:790e\:3068\:306a\:308b\:3002\n\n\:30af\:30e9\:30c8\
\:30d5\:30b9\:30ad\:30fc(Kuratowski)\:306e\:5b9a\:7406\:3000\:30b0\:30e9\:30d5\
\:ff27\:304c\:5e73\:9762\:7684\:3067\:3042\:308b\:305f\:3081\:306e\:5fc5\:8981\
\:5341\:5206\:6761\:4ef6\:306f\:3001\:ff27\:304c",
  Cell[BoxData[
      \(TraditionalForm\`K\_5\)]],
  "\:3068",
  Cell[BoxData[
      \(TraditionalForm\`K\_\(3, 3\)\)]],
  "\:306b\:4f4d\:76f8\:540c\:76f8\:306a\:90e8\:5206\:30b0\:30e9\:30d5\:3092\
\:542b\:307e\:306a\:3044\:3053\:3068\:3067\:3042\:308b\:3002\n\n\:3000\:3053\
\:306e\:5b9a\:7406\:306b\:3064\:3044\:3066\:306f\:3001[BM]\:306e\:7b2c\:ff19\
\:7ae0\:306b\:8a73\:3057\:3044\:8a3c\:660e\:304c\:3042\:308b\:3002\n\:3000\
\:3053\:3053\:3067\:306f\:3001\:5e73\:9762\:7684\:30b0\:30e9\:30d5\:304c\:4e0e\
\:3048\:3089\:308c\:305f\:3068\:304d\:3001\:305d\:308c\:3092\:5e73\:9762\:30b0\
\:30e9\:30d5\:3068\:3057\:3066\:63cf\:753b\:3059\:308b\:65b9\:6cd5\:306b\:3064\
\:3044\:3066\:8003\:5bdf\:3059\:308b\:3002\n\:3000\:6b21\:306e\:3088\:3046\
\:306a\:96a3\:63a5\:884c\:5217 A(G)\:3067\:5b9a\:7fa9\:3055\:308c\:308b\:3001\
\:5e73\:9762\:7684\:30b0\:30e9\:30d5\:3092\:ff27\:3068\:3059\:308b\:3002"
}], "Text"],

Cell[BoxData[
    RowBox[{"  ", 
      RowBox[{\(A \((G)\)\), "=", 
        TagBox[
          RowBox[{"(", GridBox[{
                {"0", "1", "1", "1", "0", "0", "1"},
                {"1", "0", "1", "0", "1", "0", "1"},
                {"1", "1", "0", "0", "0", "1", "1"},
                {"1", "0", "0", "0", "1", "1", "0"},
                {"0", "1", "0", "1", "0", "1", "0"},
                {"0", "0", "1", "1", "1", "0", "0"},
                {"1", "1", "1", "0", "0", "0", "0"}
                }], ")"}],
          (MatrixForm[ #]&)]}]}]], "Input"],

Cell[TextData[{
  "\:3000\:3053\:306e\:3068\:304d\:3001\:9802\:70b9\:5217  C={1,2,3} \
({1,2,3,1}\:3068\:3057\:3066\:ff11\:3064\:306e\:30b5\:30a4\:30af\:30eb\:3068\
\:8003\:3048\:308b\:ff09",
  Cell[BoxData[
      \(TraditionalForm
      \`\(\:3092\:4e0e\:3048\:305f\:3068\:304d\:3001\) 
        \:6b21\:306e\:3088\:3046\:306a\:884c\:5217\ \ F\)]],
  "=",
  Cell[BoxData[
      TagBox[
        RowBox[{"(", GridBox[{
              {"E", "0"},
              {"B", "A"}
              }], ")"}],
        (MatrixForm[ #]&)]]],
  "\:3092\:4f5c\:308b\:3002"
}], "Text"],

Cell[CellGroupData[{

Cell[BoxData[
    RowBox[{"mm", "=", 
      TagBox[
        RowBox[{"(", GridBox[{
              {"0", "1", "1", "1", "0", "0", "1"},
              {"1", "0", "1", "0", "1", "0", "1"},
              {"1", "1", "0", "0", "0", "1", "1"},
              {"1", "0", "0", "0", "1", "1", "0"},
              {"0", "1", "0", "1", "0", "1", "0"},
              {"0", "0", "1", "1", "1", "0", "0"},
              {"1", "1", "1", "0", "0", "0", "0"}
              }], ")"}],
        (MatrixForm[ #]&)]}]], "Input"],

Cell[BoxData[
    \({{0, 1, 1, 1, 0, 0, 1}, {1, 0, 1, 0, 1, 0, 1}, {1, 1, 0, 0, 0, 1, 
        1}, {1, 0, 0, 0, 1, 1, 0}, {0, 1, 0, 1, 0, 1, 0}, {0, 0, 1, 1, 1, 0, 
        0}, {1, 1, 1, 0, 0, 0, 0}}\)], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    RowBox[{" ", 
      RowBox[{"F", "=", 
        TagBox[
          RowBox[{"(", GridBox[{
                {"1", "0", "0", "0", "0", "0", "0"},
                {"0", "1", "0", "0", "0", "0", "0"},
                {"0", "0", "1", "0", "0", "0", "0"},
                {\(1\/3\), "0", "0", "0", \(1\/3\), \(1\/3\), "0"},
                {"0", \(1\/3\), "0", \(1\/3\), "0", \(1\/3\), "0"},
                {"0", "0", \(1\/3\), \(1\/3\), \(1\/3\), "0", "0"},
                {\(1\/3\), \(1\/3\), \(1\/3\), "0", "0", "0", "0"}
                }], ")"}],
          (MatrixForm[ #]&)]}]}]], "Input"],

Cell[BoxData[
    \({{1, 0, 0, 0, 0, 0, 0}, {0, 1, 0, 0, 0, 0, 0}, {0, 0, 1, 0, 0, 0, 
        0}, {1\/3, 0, 0, 0, 1\/3, 1\/3, 0}, {0, 1\/3, 0, 1\/3, 0, 1\/3, 
        0}, {0, 0, 1\/3, 1\/3, 1\/3, 0, 0}, {1\/3, 1\/3, 1\/3, 0, 0, 0, 
        0}}\)], "Output"]
}, Open  ]],

Cell[TextData[{
  StyleBox[
  " \:3000F\:306e\:6700\:521d\:306e\:ff13\:884c\:3092\:9664\:304f\:5404\:884c\
\:306f\:3001\:305d\:306e\:884c\:306b\:3042\:308b\:ff11\:3092\:884c\:306b\:5bfe\
\:5fdc\:3059\:308b\:9802\:70b9\:306e\:6b21\:6570\:3067\:5272\:3063\:305f\:5024\
\:3067\:3042\:308b\:3002                                                      \
      \n  \:3053\:3053\:3067\:3001E \
\:306f\:30b5\:30a4\:30ba\:304c\:ff13\:ff08\:ff23\:306e\:9577\:3055\:ff5cC\
\:ff5c\:ff09\:306e\:5358\:4f4d\:884c\:5217\:3067\:3001\:ff10\:306f\:30b5\:30a4\
\:30ba\:ff14\:ff08"],
  "\:ff5cV(G\:ff5c",
  StyleBox[
  "\:2212\:ff5cC\:ff5c\:ff09\:306e\:96f6\:884c\:5217\:3067\:3001\:884c\:5217 \
A\:3001B\:306f\:6b21\:306e\:3088\:3046\:306a\:884c\:5217\:3067\:3042\:308b\
\:3002"]
}], "Text"],

Cell[CellGroupData[{

Cell[BoxData[
    RowBox[{"  ", 
      RowBox[{
        RowBox[{"B", "=", 
          RowBox[{
            TagBox[
              RowBox[{"(", GridBox[{
                    {\(1\/3\), "0", "0"},
                    {"0", \(1\/3\), "0"},
                    {"0", "0", \(1\/3\)},
                    {\(1\/3\), \(1\/3\), \(1\/3\)}
                    }], ")"}],
              (MatrixForm[ #]&)], "\:3000\:3000"}]}], ";", 
        RowBox[{"\:3000", 
          TagBox[
            RowBox[{"A", "=", 
              RowBox[{"(", GridBox[{
                    {"0", \(1\/3\), \(1\/3\), "0"},
                    {\(1\/3\), "0", \(1\/3\), "0"},
                    {\(1\/3\), \(1\/3\), "0", "0"},
                    {"0", "0", "0", "0"}
                    }], ")"}]}],
            (MatrixForm[ #]&)]}]}]}]], "Input"],

Cell[BoxData[
    \({{0, \:3000\/3, \:3000\/3, 0}, {\:3000\/3, 0, \:3000\/3, 
        0}, {\:3000\/3, \:3000\/3, 0, 0}, {0, 0, 0, 0}}\)], "Output"]
}, Open  ]],

Cell["\<\
 \:3000\:6b21\:306b\:ff17\:500b\:306e\:9802\:70b9\:306e xy \
\:5ea7\:6a19\:3092P0\:3067\:4e0e\:3048\:308b\:3002\:53f3\:5074\:306e\:5217\
\:306f x \:5ea7\:6a19\:3092\:3001\:5de6\:5074\:306e\:5217\:306f y \
\:5ea7\:6a19\:3092\:793a\:3059\:3002\
\>", "Text"],

Cell[CellGroupData[{

Cell[BoxData[
    RowBox[{"                  ", 
      RowBox[{"P0", "=", 
        TagBox[
          RowBox[{"(", GridBox[{
                {"0", "1"},
                {\(\@3\/2\), \(-\(1\/2\)\)},
                {\(-\(\@3\/2\)\), \(-\(1\/2\)\)},
                {"0", "0"},
                {"0", "0"},
                {"0", "0"},
                {"0", "0"}
                }], ")"}],
          (MatrixForm[ #]&)]}], "                   "}]], "Input"],

Cell[BoxData[
    \({{0, 1}, {\@3\/2, \(-\(1\/2\)\)}, {\(-\(\@3\/2\)\), \(-\(1\/2\)\)}, {0, 
        0}, {0, 0}, {0, 0}, {0, 0}}\)], "Output"]
}, Open  ]],

Cell[TextData[StyleBox[
"\:3000\:6700\:521d\:306e\:ff13\:3064\:306e\:5ea7\:6a19\:306f\:5358\:4f4d\
\:5186\:5468\:4e0a\:306e\:ff13\:7b49\:5206\:5272\:70b9\:306e\:5ea7\:6a19\:3067\
\:3042\:308a\:3001\:5f8c\:306e\:ff14\:3064\:306f\:539f\:70b9\:3092\:8868\:3059\
\:3002\:3053\:308c\:306f\:3001\:30b5\:30a4\:30af\:30ebC\:306b\:5bfe\:5fdc\
\:3059\:308b\:9802\:70b9\:ff11\:ff0c\:ff12\:ff0c\:ff13\:3092\:5186\:5468\:4e0a\
\:306e\:ff13\:7b49\:5206\:5272\:70b9\:306b\:7f6e\:304d\:3001\:4ed6\:306e\:ff14\
\:9802\:70b9\:306f\:539f\:70b9\:306b\:914d\:7f6e\:3059\:308b\:3053\:3068\:3092\
\:610f\:5473\:3059\:308b\:3002   \n\:3000\:3053\:306e\:3068\:304d\:3001Pk = F \
Pk-1\:ff08\:ff4b\:ff1d1, 2, ... ) \:3067\:ff30k \
\:3092\:5b9a\:3081\:308b\:3068\:3001\:ff4b\[Rule]\[Infinity]  \:306e\:3068\
\:304d\:3001\:ff30k\:306f\:3088\:308a\:96a3\:63a5\:95a2\:4fc2\:3092\:53cd\
\:6620\:3057\:305f\:5ea7\:6a19\:306b\:5909\:5316\:3057\:3066\:3044\:304f\:3002\
\n\:3000\:3053\:306e\:5909\:5316\:306e\:904e\:7a0b\:3092\:3001Mathematica \
\:3067\:89b3\:5bdf\:3057\:3066\:307f\:308b\:3002\:305d\:306e\:305f\:3081\:306b\
\:3001\:9802\:70b9\:306e\:914d\:7f6e\:5ea7\:6a19\:306b\:5f93\:3063\:3066\:96a3\
\:63a5\:95a2\:4fc2\:304b\:3089\:30b0\:30e9\:30d5\:3092\:63cf\:753b\:3059\:308b\
\:95a2\:6570\:3092\:6b21\:306e\:3088\:3046\:306b\:5b9a\:3081\:308b\:3002      \
                                                                              \
                                "]], "Text"],

Cell[CellGroupData[{

Cell[BoxData[{
    \(\ FindPlotRange[v_List]\  := \ \ \ \ \ \ \ \ \ \ \n\t
      Module[{xmin = Min[Map[First, v]], \ 
          xmax = Max[Map[First, v]], \n\t\t\tymin = Min[Map[Last, v]], \ 
          ymax = Max[Map[Last, v]]}, \n\t\t{\ {xmin\  - \ 
              0.05\ Max[1, xmax - xmin], \ 
            xmax\  + \ 0.05\ Max[1, xmax - xmin]}, \n\t\t\ \ {ymin\  - \ 
              0.05\ Max[1, ymax - ymin], \ 
            ymax\  + \ 0.05\ Max[1, ymax - ymin]}\ }\n\t]\ \ \ \), "\n", 
    \(showgraphics[vtx_, prs_] := \n\t\tShow[
        Graphics[\n\t\t\tJoin[{PointSize[0.02]}, Map[Point, Chop[vtx]], 
            Map[\n\t\t\t\((Line[Chop[vtx[\([#]\)]]])\) &, 
              prs]]\n\t\t\t], {AspectRatio -> 1, 
          PlotRange -> FindPlotRange[vtx]}]\), "\n", 
    \(draw[mtx_, xy_] := \n\t
      showgraphics[xy, 
        Position[mtx, \ _?\((Function[n, n\  != \ 0])\)\ ]]\)}], "Input"],

Cell[BoxData[
    \(General::"spell1" \(\(:\)\(\ \)\) 
      "Possible spelling error: new symbol name \"\!\(ymin\)\" is similar to \
existing symbol \"\!\(xmin\)\"."\)], "Message"],

Cell[BoxData[
    \(General::"spell1" \(\(:\)\(\ \)\) 
      "Possible spelling error: new symbol name \"\!\(ymax\)\" is similar to \
existing symbol \"\!\(xmax\)\"."\)], "Message"]
}, Open  ]],

Cell[TextData[
"\:4ee5\:4e0b\:306b\:304a\:3044\:3066\:3001mm \:306f \:96a3\:63a5\:884c\:5217 \
A(G)\:3067\:3042\:308b\:3002"], "Text"],

Cell[CellGroupData[{

Cell[BoxData[
    \(\(\(draw[mm, \ P0]\)\(\t\ \ \)\)\)], "Input"],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: 1 
MathPictureStart
/Mabs {
Mgmatrix idtransform
Mtmatrix dtransform
} bind def
/Mabsadd { Mabs
3 -1 roll add
3 1 roll add
exch } bind def
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
0.5 0.524864 0.348485 0.606061 [
[ 0 0 0 0 ]
[ 1 1 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 0 m
1 0 L
1 1 L
0 1 L
closepath
clip
newpath
0 g
.02 w
.5 .95455 Mdot
.95455 .04545 Mdot
.04545 .04545 Mdot
.5 .34848 Mdot
.5 .34848 Mdot
.5 .34848 Mdot
.5 .34848 Mdot
.5 Mabswid
[ ] 0 setdash
.5 .95455 m
.95455 .04545 L
s
.5 .95455 m
.04545 .04545 L
s
.5 .95455 m
.5 .34848 L
s
.5 .95455 m
.5 .34848 L
s
.95455 .04545 m
.5 .95455 L
s
.95455 .04545 m
.04545 .04545 L
s
.95455 .04545 m
.5 .34848 L
s
.95455 .04545 m
.5 .34848 L
s
.04545 .04545 m
.5 .95455 L
s
.04545 .04545 m
.95455 .04545 L
s
.04545 .04545 m
.5 .34848 L
s
.04545 .04545 m
.5 .34848 L
s
.5 .34848 m
.5 .95455 L
s
.5 .34848 m
.5 .34848 L
s
.5 .34848 m
.5 .34848 L
s
.5 .34848 m
.95455 .04545 L
s
.5 .34848 m
.5 .34848 L
s
.5 .34848 m
.5 .34848 L
s
.5 .34848 m
.04545 .04545 L
s
.5 .34848 m
.5 .34848 L
s
.5 .34848 m
.5 .34848 L
s
.5 .34848 m
.5 .95455 L
s
.5 .34848 m
.95455 .04545 L
s
.5 .34848 m
.04545 .04545 L
s
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  ImageSize->{288, 288},
  ImageMargins->{{43, 0}, {0, 0}},
  ImageRegion->{{0, 1}, {0, 1}},
  ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`40004P000182000`400?l00000o`00003oo`3ooolQ
0?ooo`00o`3ooolQ0?ooo`00o`3ooolQ0?ooo`00o`3ooolQ0?ooo`00o`3ooolQ0?ooo`00o`3ooolQ
0?ooo`00o`3ooolQ0?ooo`00o`3ooolQ0?ooo`00o`3ooolQ0?ooo`00o`3ooolQ0?ooo`00o`3ooolQ
0?ooo`00o`3ooolQ0?ooo`002`3oool300000?l0oooo0`3oool3000000d0oooo000:0?ooo`D00000
o`3oool10?ooo`D00000303oool000X0ooooo`00000;000000`0oooo000:0?ooo`H00000o`3oool5
000000`0oooo000;0?ooo`@0000000<0oooo0000003oool0o03oool00`000000oooo000000020000
00d0oooo000>0?ooo`030000003oool0oooo00800000n@3oool2000000030?ooo`000000oooo00l0
oooo000?0?ooo`050000003oool0oooo0?ooo`000000m`3oool01@000000oooo0?ooo`3oool00000
0100oooo000?0?ooo`030000003oool0oooo0080oooo0P00003c0?ooo`8000000`3oool00`000000
oooo0?ooo`0?0?ooo`00403oool00`000000oooo0?ooo`030?ooo`030000003oool0oooo0>l0oooo
00<000000?ooo`3oool00`3oool00`000000oooo0?ooo`0?0?ooo`00403oool00`000000oooo0?oo
o`040?ooo`800000k@3oool2000000D0oooo00<000000?ooo`3oool0403oool00140oooo00<00000
0?ooo`3oool01@3oool00`000000oooo0?ooo`3Y0?ooo`030000003oool0oooo00D0oooo00<00000
0?ooo`3oool0403oool00140oooo00<000000?ooo`3oool01P3oool200000>L0oooo0P0000070?oo
o`030000003oool0oooo0140oooo000B0?ooo`030000003oool0oooo00L0oooo00<000000?ooo`3o
ool0h`3oool00`000000oooo0?ooo`070?ooo`030000003oool0oooo0140oooo000B0?ooo`030000
003oool0oooo00P0oooo0P00003Q0?ooo`8000002@3oool00`000000oooo0?ooo`0B0?ooo`004`3o
ool00`000000oooo0?ooo`090?ooo`030000003oool0oooo0=d0oooo00<000000?ooo`3oool02@3o
ool00`000000oooo0?ooo`0B0?ooo`004`3oool00`000000oooo0?ooo`0:0?ooo`800000f`3oool2
000000/0oooo00<000000?ooo`3oool04`3oool001@0oooo00<000000?ooo`3oool02`3oool00`00
0000oooo0?ooo`3G0?ooo`030000003oool0oooo00/0oooo00<000000?ooo`3oool04`3oool001@0
oooo00<000000?ooo`3oool0303oool200000=D0oooo0P00000=0?ooo`030000003oool0oooo01@0
oooo000E0?ooo`030000003oool0oooo00d0oooo00<000000?ooo`3oool0d@3oool00`000000oooo
0?ooo`0=0?ooo`030000003oool0oooo01@0oooo000E0?ooo`030000003oool0oooo00h0oooo0P00
003?0?ooo`8000003`3oool00`000000oooo0?ooo`0E0?ooo`005P3oool00`000000oooo0?ooo`0?
0?ooo`030000003oool0oooo0</0oooo00<000000?ooo`3oool03`3oool00`000000oooo0?ooo`0E
0?ooo`005P3oool00`000000oooo0?ooo`0@0?ooo`800000b@3oool200000140oooo00<000000?oo
o`3oool05P3oool001L0oooo00<000000?ooo`3oool04@3oool00`000000oooo0?ooo`350?ooo`03
0000003oool0oooo0140oooo00<000000?ooo`3oool05P3oool001L0oooo00<000000?ooo`3oool0
4P3oool200000<<0oooo0P00000C0?ooo`030000003oool0oooo01L0oooo000H0?ooo`030000003o
ool0oooo01<0oooo00<000000?ooo`3oool0_`3oool00`000000oooo0?ooo`0C0?ooo`030000003o
ool0oooo01L0oooo000H0?ooo`030000003oool0oooo01@0oooo0P00002m0?ooo`8000005@3oool0
0`000000oooo0?ooo`0H0?ooo`006@3oool00`000000oooo0?ooo`0E0?ooo`030000003oool0oooo
0;T0oooo00<000000?ooo`3oool05@3oool00`000000oooo0?ooo`0H0?ooo`006@3oool00`000000
oooo0?ooo`0F0?ooo`800000]`3oool2000001L0oooo00<000000?ooo`3oool06@3oool001X0oooo
00<000000?ooo`3oool05`3oool00`000000oooo0?ooo`2c0?ooo`030000003oool0oooo01L0oooo
00<000000?ooo`3oool06@3oool001X0oooo00<000000?ooo`3oool0603oool200000;40oooo0P00
000I0?ooo`030000003oool0oooo01X0oooo000K0?ooo`030000003oool0oooo01T0oooo00<00000
0?ooo`3oool0[@3oool00`000000oooo0?ooo`0I0?ooo`030000003oool0oooo01X0oooo000K0?oo
o`030000003oool0oooo01X0oooo0P00002[0?ooo`8000006`3oool00`000000oooo0?ooo`0K0?oo
o`00703oool00`000000oooo0?ooo`0K0?ooo`030000003oool0oooo0:L0oooo00<000000?ooo`3o
ool06`3oool00`000000oooo0?ooo`0K0?ooo`00703oool00`000000oooo0?ooo`0L0?ooo`800000
Y@3oool2000001d0oooo00<000000?ooo`3oool0703oool001d0oooo00<000000?ooo`3oool07@3o
ool00`000000oooo0?ooo`2Q0?ooo`030000003oool0oooo01d0oooo00<000000?ooo`3oool0703o
ool001d0oooo00<000000?ooo`3oool07P3oool2000009l0oooo0P00000O0?ooo`030000003oool0
oooo01d0oooo000N0?ooo`030000003oool0oooo01l0oooo00<000000?ooo`3oool0V`3oool00`00
0000oooo0?ooo`0O0?ooo`030000003oool0oooo01d0oooo000N0?ooo`030000003oool0oooo0200
oooo0P00002I0?ooo`8000008@3oool00`000000oooo0?ooo`0N0?ooo`007`3oool00`000000oooo
0?ooo`0Q0?ooo`030000003oool0oooo09D0oooo00<000000?ooo`3oool08@3oool00`000000oooo
0?ooo`0N0?ooo`007`3oool00`000000oooo0?ooo`0R0?ooo`800000T`3oool2000002<0oooo00<0
00000?ooo`3oool07`3oool00200oooo00<000000?ooo`3oool08`3oool00`000000oooo0?ooo`2?
0?ooo`030000003oool0oooo02<0oooo00<000000?ooo`3oool07`3oool00200oooo00<000000?oo
o`3oool0903oool2000008d0oooo0P00000U0?ooo`030000003oool0oooo0200oooo000Q0?ooo`03
0000003oool0oooo02D0oooo00<000000?ooo`3oool0R@3oool00`000000oooo0?ooo`0U0?ooo`03
0000003oool0oooo0200oooo000Q0?ooo`030000003oool0oooo02H0oooo0P0000270?ooo`800000
9`3oool00`000000oooo0?ooo`0Q0?ooo`008P3oool00`000000oooo0?ooo`0W0?ooo`030000003o
ool0oooo08<0oooo00<000000?ooo`3oool09`3oool00`000000oooo0?ooo`0Q0?ooo`008P3oool0
0`000000oooo0?ooo`0X0?ooo`030000003oool0oooo0840oooo00<000000?ooo`3oool09`3oool0
0`000000oooo0?ooo`0R0?ooo`008`3oool00`000000oooo0?ooo`0X0?ooo`800000O`3oool20000
02X0oooo00<000000?ooo`3oool08P3oool002<0oooo00<000000?ooo`3oool0:P3oool00`000000
oooo0?ooo`1k0?ooo`030000003oool0oooo02T0oooo00<000000?ooo`3oool08`3oool002@0oooo
00<000000?ooo`3oool0:P3oool2000007T0oooo0P00000/0?ooo`030000003oool0oooo02<0oooo
000T0?ooo`030000003oool0oooo02`0oooo00<000000?ooo`3oool0M@3oool00`000000oooo0?oo
o`0[0?ooo`030000003oool0oooo02@0oooo000U0?ooo`030000003oool0oooo02`0oooo0P00001c
0?ooo`800000;P3oool00`000000oooo0?ooo`0T0?ooo`009@3oool00`000000oooo0?ooo`0^0?oo
o`030000003oool0oooo06l0oooo00<000000?ooo`3oool0;@3oool00`000000oooo0?ooo`0U0?oo
o`009P3oool00`000000oooo0?ooo`0^0?ooo`800000K@3oool200000300oooo00<000000?ooo`3o
ool09@3oool002H0oooo00<000000?ooo`3oool0<03oool00`000000oooo0?ooo`1Y0?ooo`030000
003oool0oooo02l0oooo00<000000?ooo`3oool09P3oool002L0oooo00<000000?ooo`3oool0<03o
ool2000006L0oooo0P00000b0?ooo`030000003oool0oooo02H0oooo000W0?ooo`030000003oool0
oooo0380oooo00<000000?ooo`3oool0H`3oool00`000000oooo0?ooo`0a0?ooo`030000003oool0
oooo02L0oooo000X0?ooo`030000003oool0oooo0380oooo0P00001Q0?ooo`800000=03oool00`00
0000oooo0?ooo`0W0?ooo`00:03oool00`000000oooo0?ooo`0d0?ooo`030000003oool0oooo05d0
oooo00<000000?ooo`3oool0<`3oool00`000000oooo0?ooo`0X0?ooo`00:@3oool00`000000oooo
0?ooo`0d0?ooo`800000F`3oool2000003H0oooo00<000000?ooo`3oool0:03oool002T0oooo00<0
00000?ooo`3oool0=P3oool00`000000oooo0?ooo`1G0?ooo`030000003oool0oooo03D0oooo00<0
00000?ooo`3oool0:@3oool002X0oooo00<000000?ooo`3oool0=P3oool2000005D0oooo0P00000h
0?ooo`030000003oool0oooo02T0oooo000Z0?ooo`030000003oool0oooo03P0oooo00<000000?oo
o`3oool0D@3oool00`000000oooo0?ooo`0g0?ooo`030000003oool0oooo02X0oooo000[0?ooo`03
0000003oool0oooo03P0oooo0P00001?0?ooo`800000>P3oool00`000000oooo0?ooo`0Z0?ooo`00
:`3oool00`000000oooo0?ooo`0j0?ooo`030000003oool0oooo04/0oooo00<000000?ooo`3oool0
>@3oool00`000000oooo0?ooo`0[0?ooo`00;03oool00`000000oooo0?ooo`0j0?ooo`800000B@3o
ool2000003`0oooo00<000000?ooo`3oool0:`3oool002`0oooo00<000000?ooo`3oool0?03oool0
0`000000oooo0?ooo`150?ooo`030000003oool0oooo03/0oooo00<000000?ooo`3oool0;03oool0
02d0oooo00<000000?ooo`3oool0?03oool2000004<0oooo0P00000n0?ooo`030000003oool0oooo
02`0oooo000]0?ooo`030000003oool0oooo03h0oooo00<000000?ooo`3oool0?`3oool00`000000
oooo0?ooo`0m0?ooo`030000003oool0oooo02d0oooo000^0?ooo`030000003oool0oooo03h0oooo
0P00000m0?ooo`800000@03oool00`000000oooo0?ooo`0]0?ooo`00;P3oool00`000000oooo0?oo
o`100?ooo`030000003oool0oooo03T0oooo00<000000?ooo`3oool0?`3oool00`000000oooo0?oo
o`0^0?ooo`00;`3oool00`000000oooo0?ooo`100?ooo`800000=`3oool200000480oooo00<00000
0?ooo`3oool0;P3oool002l0oooo00<000000?ooo`3oool0@P3oool00`000000oooo0?ooo`0c0?oo
o`030000003oool0oooo0440oooo00<000000?ooo`3oool0;`3oool00300oooo00<000000?ooo`3o
ool0@P3oool200000340oooo0P0000140?ooo`030000003oool0oooo02l0oooo000`0?ooo`030000
003oool0oooo04@0oooo00<000000?ooo`3oool0;@3oool00`000000oooo0?ooo`130?ooo`030000
003oool0oooo0300oooo000a0?ooo`030000003oool0oooo04@0oooo0P00000[0?ooo`800000AP3o
ool00`000000oooo0?ooo`0`0?ooo`00<@3oool00`000000oooo0?ooo`160?ooo`030000003oool0
oooo02L0oooo00<000000?ooo`3oool0A@3oool00`000000oooo0?ooo`0a0?ooo`00<P3oool00`00
0000oooo0?ooo`160?ooo`8000009@3oool2000004P0oooo00<000000?ooo`3oool0<@3oool00380
oooo00<000000?ooo`3oool0B03oool00`000000oooo0?ooo`0Q0?ooo`030000003oool0oooo04L0
oooo00<000000?ooo`3oool0<P3oool003<0oooo00<000000?ooo`3oool0B03oool2000001l0oooo
0P00001:0?ooo`030000003oool0oooo0380oooo000c0?ooo`030000003oool0oooo04X0oooo00<0
00000?ooo`3oool06`3oool00`000000oooo0?ooo`190?ooo`030000003oool0oooo03<0oooo000d
0?ooo`030000003oool0oooo04X0oooo0P00000I0?ooo`800000C03oool00`000000oooo0?ooo`0c
0?ooo`00=03oool00`000000oooo0?ooo`1<0?ooo`030000003oool0oooo01D0oooo00<000000?oo
o`3oool0B`3oool00`000000oooo0?ooo`0d0?ooo`00=@3oool00`000000oooo0?ooo`1<0?ooo`80
00004`3oool2000004h0oooo00<000000?ooo`3oool0=03oool003D0oooo00<000000?ooo`3oool0
CP3oool00`000000oooo0?ooo`0?0?ooo`030000003oool0oooo04d0oooo00<000000?ooo`3oool0
=@3oool003H0oooo00<000000?ooo`3oool0CP3oool2000000d0oooo0P00001@0?ooo`030000003o
ool0oooo03D0oooo000f0?ooo`030000003oool0oooo0500oooo00<000000?ooo`3oool02@3oool0
0`000000oooo0?ooo`1?0?ooo`030000003oool0oooo03H0oooo000g0?ooo`030000003oool0oooo
0500oooo0P0000070?ooo`800000DP3oool00`000000oooo0?ooo`0f0?ooo`00=`3oool00`000000
oooo0?ooo`1B0?ooo`030000003oool000000080000000<0oooo0000003oool0DP3oool00`000000
oooo0?ooo`0g0?ooo`00>03oool00`000000oooo0?ooo`1B0?ooo`D00000E03oool00`000000oooo
0?ooo`0g0?ooo`00>03oool00`000000oooo0?ooo`1B0?ooo`D00000D`3oool00`000000oooo0?oo
o`0h0?ooo`00>@3oool00`000000oooo0?ooo`1A0?ooo`D00000D`3oool00`000000oooo0?ooo`0h
0?ooo`00>@3oool00`000000oooo0?ooo`1B0?ooo`<00000D`3oool00`000000oooo0?ooo`0i0?oo
o`00>P3oool00`000000oooo0?ooo`1B0?ooo`030000003oool0oooo0580oooo00<000000?ooo`3o
ool0>@3oool003X0oooo00<000000?ooo`3oool0DP3oool00`000000oooo0?ooo`1A0?ooo`030000
003oool0oooo03X0oooo000k0?ooo`030000003oool0oooo0540oooo00<000000?ooo`3oool0D@3o
ool00`000000oooo0?ooo`0j0?ooo`00>`3oool00`000000oooo0?ooo`1A0?ooo`030000003oool0
oooo0500oooo00<000000?ooo`3oool0>`3oool003`0oooo00<000000?ooo`3oool0D03oool00`00
0000oooo0?ooo`1@0?ooo`030000003oool0oooo03/0oooo000l0?ooo`030000003oool0oooo0500
oooo00<000000?ooo`3oool0C`3oool00`000000oooo0?ooo`0l0?ooo`00?@3oool00`000000oooo
0?ooo`1?0?ooo`030000003oool0oooo04l0oooo00<000000?ooo`3oool0?03oool003d0oooo00<0
00000?ooo`3oool0C`3oool00`000000oooo0?ooo`1>0?ooo`030000003oool0oooo03d0oooo000n
0?ooo`030000003oool0oooo04h0oooo00<000000?ooo`3oool0CP3oool00`000000oooo0?ooo`0m
0?ooo`00?P3oool00`000000oooo0?ooo`1>0?ooo`030000003oool0oooo04d0oooo00<000000?oo
o`3oool0?P3oool003l0oooo00<000000?ooo`3oool0C@3oool00`000000oooo0?ooo`1=0?ooo`03
0000003oool0oooo03h0oooo000o0?ooo`030000003oool0oooo04d0oooo00<000000?ooo`3oool0
C03oool00`000000oooo0?ooo`0o0?ooo`00@03oool00`000000oooo0?ooo`1<0?ooo`030000003o
ool0oooo04`0oooo00<000000?ooo`3oool0?`3oool00400oooo00<000000?ooo`3oool0C03oool0
0`000000oooo0?ooo`1;0?ooo`030000003oool0oooo0400oooo00110?ooo`030000003oool0oooo
04/0oooo00<000000?ooo`3oool0B`3oool00`000000oooo0?ooo`100?ooo`00@@3oool00`000000
oooo0?ooo`1;0?ooo`030000003oool0oooo04X0oooo00<000000?ooo`3oool0@@3oool00480oooo
00<000000?ooo`3oool0BP3oool00`000000oooo0?ooo`1:0?ooo`030000003oool0oooo0440oooo
00120?ooo`030000003oool0oooo04X0oooo00<000000?ooo`3oool0B@3oool00`000000oooo0?oo
o`120?ooo`00@`3oool00`000000oooo0?ooo`190?ooo`030000003oool0oooo04T0oooo00<00000
0?ooo`3oool0@P3oool004<0oooo00<000000?ooo`3oool0B@3oool00`000000oooo0?ooo`180?oo
o`030000003oool0oooo04<0oooo00140?ooo`030000003oool0oooo04P0oooo00<000000?ooo`3o
ool0B03oool00`000000oooo0?ooo`130?ooo`00A03oool00`000000oooo0?ooo`180?ooo`030000
003oool0oooo04L0oooo00<000000?ooo`3oool0A03oool004D0oooo00<000000?ooo`3oool0A`3o
ool00`000000oooo0?ooo`170?ooo`030000003oool0oooo04@0oooo00150?ooo`030000003oool0
oooo04L0oooo00<000000?ooo`3oool0AP3oool00`000000oooo0?ooo`150?ooo`00AP3oool00`00
0000oooo0?ooo`160?ooo`030000003oool0oooo04H0oooo00<000000?ooo`3oool0A@3oool004H0
oooo00<000000?ooo`3oool0AP3oool00`000000oooo0?ooo`150?ooo`030000003oool0oooo04H0
oooo00170?ooo`030000003oool0oooo04D0oooo00<000000?ooo`3oool0A@3oool00`000000oooo
0?ooo`160?ooo`00A`3oool00`000000oooo0?ooo`150?ooo`030000003oool0oooo04@0oooo00<0
00000?ooo`3oool0A`3oool004P0oooo00<000000?ooo`3oool0A03oool00`000000oooo0?ooo`14
0?ooo`030000003oool0oooo04L0oooo00180?ooo`030000003oool0oooo04@0oooo00<000000?oo
o`3oool0@`3oool00`000000oooo0?ooo`180?ooo`00B@3oool00`000000oooo0?ooo`130?ooo`03
0000003oool0oooo04<0oooo00<000000?ooo`3oool0B03oool004T0oooo00<000000?ooo`3oool0
@`3oool00`000000oooo0?ooo`120?ooo`030000003oool0oooo04T0oooo001:0?ooo`030000003o
ool0oooo0480oooo00<000000?ooo`3oool0@P3oool00`000000oooo0?ooo`190?ooo`00BP3oool0
0`000000oooo0?ooo`120?ooo`030000003oool0oooo0440oooo00<000000?ooo`3oool0BP3oool0
04/0oooo00<000000?ooo`3oool0@@3oool00`000000oooo0?ooo`110?ooo`030000003oool0oooo
04X0oooo001;0?ooo`030000003oool0oooo0440oooo00<000000?ooo`3oool0@03oool00`000000
oooo0?ooo`1;0?ooo`00C03oool00`000000oooo0?ooo`100?ooo`030000003oool0oooo0400oooo
00<000000?ooo`3oool0B`3oool004`0oooo00<000000?ooo`3oool0@03oool00`000000oooo0?oo
o`0o0?ooo`030000003oool0oooo04`0oooo001=0?ooo`030000003oool0oooo03l0oooo00<00000
0?ooo`3oool0?`3oool00`000000oooo0?ooo`1<0?ooo`00C@3oool00`000000oooo0?ooo`0o0?oo
o`030000003oool0oooo03h0oooo00<000000?ooo`3oool0C@3oool004h0oooo00<000000?ooo`3o
ool0?P3oool00`000000oooo0?ooo`0n0?ooo`030000003oool0oooo04d0oooo001>0?ooo`030000
003oool0oooo03h0oooo00<000000?ooo`3oool0?@3oool00`000000oooo0?ooo`1>0?ooo`00C`3o
ool00`000000oooo0?ooo`0m0?ooo`030000003oool0oooo03d0oooo00<000000?ooo`3oool0CP3o
ool004l0oooo00<000000?ooo`3oool0?@3oool00`000000oooo0?ooo`0l0?ooo`030000003oool0
oooo04l0oooo001@0?ooo`030000003oool0oooo03`0oooo00<000000?ooo`3oool0?03oool00`00
0000oooo0?ooo`1?0?ooo`00D03oool00`000000oooo0?ooo`0l0?ooo`030000003oool0oooo03/0
oooo00<000000?ooo`3oool0D03oool00540oooo00<000000?ooo`3oool0>`3oool00`000000oooo
0?ooo`0k0?ooo`030000003oool0oooo0500oooo001A0?ooo`030000003oool0oooo03/0oooo00<0
00000?ooo`3oool0>P3oool00`000000oooo0?ooo`1A0?ooo`00DP3oool00`000000oooo0?ooo`0j
0?ooo`030000003oool0oooo03X0oooo00<000000?ooo`3oool0D@3oool00580oooo00<000000?oo
o`3oool0>P3oool00`000000oooo0?ooo`0i0?ooo`030000003oool0oooo0580oooo001C0?ooo`03
0000003oool0oooo03T0oooo00<000000?ooo`3oool0>@3oool00`000000oooo0?ooo`1B0?ooo`00
D`3oool00`000000oooo0?ooo`0i0?ooo`030000003oool0oooo03P0oooo00<000000?ooo`3oool0
D`3oool005@0oooo00<000000?ooo`3oool0>03oool00`000000oooo0?ooo`0h0?ooo`030000003o
ool0oooo05<0oooo001D0?ooo`030000003oool0oooo03P0oooo00<000000?ooo`3oool0=`3oool0
0`000000oooo0?ooo`1D0?ooo`00E@3oool00`000000oooo0?ooo`0g0?ooo`030000003oool0oooo
03L0oooo00<000000?ooo`3oool0E03oool005D0oooo00<000000?ooo`3oool0=`3oool00`000000
oooo0?ooo`0f0?ooo`030000003oool0oooo05D0oooo001F0?ooo`030000003oool0oooo03H0oooo
00<000000?ooo`3oool0=P3oool00`000000oooo0?ooo`1E0?ooo`00EP3oool00`000000oooo0?oo
o`0f0?ooo`030000003oool0oooo03D0oooo00<000000?ooo`3oool0EP3oool005L0oooo00<00000
0?ooo`3oool0=@3oool00`000000oooo0?ooo`0e0?ooo`030000003oool0oooo05H0oooo001G0?oo
o`030000003oool0oooo03D0oooo00<000000?ooo`3oool0=03oool00`000000oooo0?ooo`1G0?oo
o`00F03oool00`000000oooo0?ooo`0d0?ooo`030000003oool0oooo03@0oooo00<000000?ooo`3o
ool0E`3oool005P0oooo00<000000?ooo`3oool0=03oool00`000000oooo0?ooo`0c0?ooo`030000
003oool0oooo05P0oooo001I0?ooo`030000003oool0oooo03<0oooo00<000000?ooo`3oool0<`3o
ool00`000000oooo0?ooo`1H0?ooo`00F@3oool00`000000oooo0?ooo`0c0?ooo`030000003oool0
oooo0380oooo00<000000?ooo`3oool0F@3oool005X0oooo00<000000?ooo`3oool0<P3oool00`00
0000oooo0?ooo`0b0?ooo`030000003oool0oooo05T0oooo001J0?ooo`030000003oool0oooo0380
oooo00<000000?ooo`3oool0<@3oool00`000000oooo0?ooo`1J0?ooo`00F`3oool00`000000oooo
0?ooo`0a0?ooo`030000003oool0oooo0340oooo00<000000?ooo`3oool0FP3oool005/0oooo00<0
00000?ooo`3oool0<@3oool00`000000oooo0?ooo`0`0?ooo`030000003oool0oooo05/0oooo001L
0?ooo`030000003oool0oooo0300oooo00<000000?ooo`3oool0<03oool00`000000oooo0?ooo`1K
0?ooo`00G03oool00`000000oooo0?ooo`0`0?ooo`030000003oool0oooo02l0oooo00<000000?oo
o`3oool0G03oool005d0oooo00<000000?ooo`3oool0;`3oool00`000000oooo0?ooo`0_0?ooo`03
0000003oool0oooo05`0oooo001M0?ooo`030000003oool0oooo02l0oooo00<000000?ooo`3oool0
;P3oool00`000000oooo0?ooo`1M0?ooo`00GP3oool00`000000oooo0?ooo`0^0?ooo`030000003o
ool0oooo02h0oooo00<000000?ooo`3oool0G@3oool005h0oooo00<000000?ooo`3oool0;P3oool0
0`000000oooo0?ooo`0]0?ooo`030000003oool0oooo05h0oooo001O0?ooo`030000003oool0oooo
02d0oooo00<000000?ooo`3oool0;@3oool00`000000oooo0?ooo`1N0?ooo`00G`3oool00`000000
oooo0?ooo`0]0?ooo`030000003oool0oooo02`0oooo00<000000?ooo`3oool0G`3oool00600oooo
00<000000?ooo`3oool0;03oool00`000000oooo0?ooo`0/0?ooo`030000003oool0oooo05l0oooo
001P0?ooo`030000003oool0oooo02`0oooo00<000000?ooo`3oool0:`3oool00`000000oooo0?oo
o`1P0?ooo`00H@3oool00`000000oooo0?ooo`0[0?ooo`030000003oool0oooo02/0oooo00<00000
0?ooo`3oool0H03oool00640oooo00<000000?ooo`3oool0:`3oool00`000000oooo0?ooo`0Z0?oo
o`030000003oool0oooo0640oooo001R0?ooo`030000003oool0oooo02X0oooo00<000000?ooo`3o
ool0:P3oool00`000000oooo0?ooo`1Q0?ooo`00HP3oool00`000000oooo0?ooo`0Z0?ooo`030000
003oool0oooo02T0oooo00<000000?ooo`3oool0HP3oool006<0oooo00<000000?ooo`3oool0:@3o
ool00`000000oooo0?ooo`0Y0?ooo`030000003oool0oooo0680oooo001S0?ooo`030000003oool0
oooo02T0oooo00<000000?ooo`3oool0:03oool00`000000oooo0?ooo`1S0?ooo`00I03oool00`00
0000oooo0?ooo`0X0?ooo`030000003oool0oooo02P0oooo00<000000?ooo`3oool0H`3oool006@0
oooo00<000000?ooo`3oool0:03oool00`000000oooo0?ooo`0W0?ooo`030000003oool0oooo06@0
oooo001U0?ooo`030000003oool0oooo02L0oooo00<000000?ooo`3oool09`3oool00`000000oooo
0?ooo`1T0?ooo`00I@3oool00`000000oooo0?ooo`0W0?ooo`030000003oool0oooo02H0oooo00<0
00000?ooo`3oool0I@3oool006H0oooo00<000000?ooo`3oool09P3oool00`000000oooo0?ooo`0V
0?ooo`030000003oool0oooo06D0oooo001V0?ooo`030000003oool0oooo02H0oooo00<000000?oo
o`3oool09@3oool00`000000oooo0?ooo`1V0?ooo`00I`3oool00`000000oooo0?ooo`0U0?ooo`03
0000003oool0oooo02D0oooo00<000000?ooo`3oool0IP3oool006L0oooo00<000000?ooo`3oool0
9@3oool00`000000oooo0?ooo`0T0?ooo`030000003oool0oooo06L0oooo001X0?ooo`030000003o
ool0oooo02@0oooo00<000000?ooo`3oool0903oool00`000000oooo0?ooo`1W0?ooo`00J03oool0
0`000000oooo0?ooo`0T0?ooo`030000003oool0oooo02<0oooo00<000000?ooo`3oool0J03oool0
06T0oooo00<000000?ooo`3oool08`3oool00`000000oooo0?ooo`0S0?ooo`030000003oool0oooo
06P0oooo001Y0?ooo`030000003oool0oooo02<0oooo00<000000?ooo`3oool08P3oool00`000000
oooo0?ooo`1Y0?ooo`00JP3oool00`000000oooo0?ooo`0R0?ooo`030000003oool0oooo0280oooo
00<000000?ooo`3oool0J@3oool006X0oooo00<000000?ooo`3oool08P3oool00`000000oooo0?oo
o`0Q0?ooo`030000003oool0oooo06X0oooo001[0?ooo`030000003oool0oooo0240oooo00<00000
0?ooo`3oool08@3oool00`000000oooo0?ooo`1Z0?ooo`00J`3oool00`000000oooo0?ooo`0Q0?oo
o`030000003oool0oooo0200oooo00<000000?ooo`3oool0J`3oool006`0oooo00<000000?ooo`3o
ool0803oool00`000000oooo0?ooo`0P0?ooo`030000003oool0oooo06/0oooo001/0?ooo`030000
003oool0oooo0200oooo00<000000?ooo`3oool07`3oool00`000000oooo0?ooo`1/0?ooo`00K@3o
ool00`000000oooo0?ooo`0O0?ooo`030000003oool0oooo01l0oooo00<000000?ooo`3oool0K03o
ool006d0oooo00<000000?ooo`3oool07`3oool00`000000oooo0?ooo`0N0?ooo`030000003oool0
oooo06d0oooo001^0?ooo`030000003oool0oooo01h0oooo00<000000?ooo`3oool07P3oool00`00
0000oooo0?ooo`1]0?ooo`00KP3oool00`000000oooo0?ooo`0N0?ooo`030000003oool0oooo01d0
oooo00<000000?ooo`3oool0KP3oool006l0oooo00<000000?ooo`3oool07@3oool00`000000oooo
0?ooo`0M0?ooo`030000003oool0oooo06h0oooo001_0?ooo`030000003oool0oooo01d0oooo00<0
00000?ooo`3oool0703oool00`000000oooo0?ooo`1_0?ooo`00L03oool00`000000oooo0?ooo`0L
0?ooo`030000003oool0oooo01`0oooo00<000000?ooo`3oool0K`3oool00700oooo00<000000?oo
o`3oool0703oool00`000000oooo0?ooo`0K0?ooo`030000003oool0oooo0700oooo001a0?ooo`03
0000003oool0oooo01/0oooo00<000000?ooo`3oool06`3oool00`000000oooo0?ooo`1`0?ooo`00
L@3oool00`000000oooo0?ooo`0K0?ooo`030000003oool0oooo01X0oooo00<000000?ooo`3oool0
L@3oool00780oooo00<000000?ooo`3oool06P3oool00`000000oooo0?ooo`0J0?ooo`030000003o
ool0oooo0740oooo001b0?ooo`030000003oool0oooo01X0oooo00<000000?ooo`3oool06@3oool0
0`000000oooo0?ooo`1b0?ooo`00L`3oool00`000000oooo0?ooo`0I0?ooo`030000003oool0oooo
01T0oooo00<000000?ooo`3oool0LP3oool007<0oooo00<000000?ooo`3oool06@3oool00`000000
oooo0?ooo`0H0?ooo`030000003oool0oooo07<0oooo001d0?ooo`030000003oool0oooo01P0oooo
00<000000?ooo`3oool0603oool00`000000oooo0?ooo`1c0?ooo`00M03oool00`000000oooo0?oo
o`0H0?ooo`030000003oool0oooo01L0oooo00<000000?ooo`3oool0M03oool007D0oooo00<00000
0?ooo`3oool05`3oool00`000000oooo0?ooo`0G0?ooo`030000003oool0oooo07@0oooo001e0?oo
o`030000003oool0oooo01L0oooo00<000000?ooo`3oool05P3oool00`000000oooo0?ooo`1e0?oo
o`00MP3oool00`000000oooo0?ooo`0F0?ooo`030000003oool0oooo01H0oooo00<000000?ooo`3o
ool0M@3oool007H0oooo00<000000?ooo`3oool05P3oool00`000000oooo0?ooo`0E0?ooo`030000
003oool0oooo07H0oooo001g0?ooo`030000003oool0oooo01D0oooo00<000000?ooo`3oool05@3o
ool00`000000oooo0?ooo`1f0?ooo`00M`3oool00`000000oooo0?ooo`0E0?ooo`030000003oool0
oooo01@0oooo00<000000?ooo`3oool0M`3oool007P0oooo00<000000?ooo`3oool0503oool00`00
0000oooo0?ooo`0D0?ooo`030000003oool0oooo07L0oooo001h0?ooo`030000003oool0oooo01@0
oooo00<000000?ooo`3oool04`3oool00`000000oooo0?ooo`1h0?ooo`00N@3oool00`000000oooo
0?ooo`0C0?ooo`030000003oool0oooo01<0oooo00<000000?ooo`3oool0N03oool007T0oooo00<0
00000?ooo`3oool04`3oool00`000000oooo0?ooo`0B0?ooo`030000003oool0oooo07T0oooo001j
0?ooo`030000003oool0oooo0180oooo00<000000?ooo`3oool04P3oool00`000000oooo0?ooo`1i
0?ooo`00NP3oool00`000000oooo0?ooo`0B0?ooo`030000003oool0oooo0140oooo00<000000?oo
o`3oool0NP3oool007/0oooo00<000000?ooo`3oool04@3oool00`000000oooo0?ooo`0A0?ooo`03
0000003oool0oooo07X0oooo001k0?ooo`030000003oool0oooo0140oooo00<000000?ooo`3oool0
403oool00`000000oooo0?ooo`1k0?ooo`00O03oool00`000000oooo0?ooo`0@0?ooo`030000003o
ool0oooo0100oooo00<000000?ooo`3oool0N`3oool007`0oooo00<000000?ooo`3oool0403oool0
0`000000oooo0?ooo`0?0?ooo`030000003oool0oooo07`0oooo001m0?ooo`030000003oool0oooo
00l0oooo00<000000?ooo`3oool03`3oool00`000000oooo0?ooo`1l0?ooo`00O@3oool00`000000
oooo0?ooo`0?0?ooo`030000003oool0oooo00h0oooo00<000000?ooo`3oool0O@3oool007h0oooo
00<000000?ooo`3oool03P3oool00`000000oooo0?ooo`0>0?ooo`030000003oool0oooo07d0oooo
001n0?ooo`030000003oool0oooo00h0oooo00<000000?ooo`3oool03@3oool00`000000oooo0?oo
o`1n0?ooo`00O`3oool00`000000oooo0?ooo`0=0?ooo`030000003oool0oooo00d0oooo00<00000
0?ooo`3oool0OP3oool007l0oooo00<000000?ooo`3oool03@3oool00`000000oooo0?ooo`0<0?oo
o`030000003oool0oooo07l0oooo00200?ooo`030000003oool0oooo00`0oooo00<000000?ooo`3o
ool0303oool00`000000oooo0?ooo`1o0?ooo`00P03oool00`000000oooo0?ooo`0<0?ooo`030000
003oool0oooo00/0oooo00<000000?ooo`3oool0P03oool00840oooo00<000000?ooo`3oool02`3o
ool00`000000oooo0?ooo`0;0?ooo`030000003oool0oooo0800oooo00210?ooo`030000003oool0
oooo00/0oooo00<000000?ooo`3oool02P3oool00`000000oooo0?ooo`210?ooo`00PP3oool00`00
0000oooo0?ooo`0:0?ooo`030000003oool0oooo00X0oooo00<000000?ooo`3oool0P@3oool00880
oooo00<000000?ooo`3oool02P3oool00`000000oooo0?ooo`090?ooo`030000003oool0oooo0880
oooo00230?ooo`030000003oool0oooo00T0oooo00<000000?ooo`3oool02@3oool00`000000oooo
0?ooo`220?ooo`00P`3oool00`000000oooo0?ooo`090?ooo`030000003oool0oooo00P0oooo00<0
00000?ooo`3oool0P`3oool008@0oooo00<000000?ooo`3oool0203oool00`000000oooo0?ooo`08
0?ooo`030000003oool0oooo08<0oooo00240?ooo`030000003oool0oooo00P0oooo00<000000?oo
o`3oool01`3oool00`000000oooo0?ooo`240?ooo`00Q@3oool00`000000oooo0?ooo`070?ooo`03
0000003oool0oooo00L0oooo00<000000?ooo`3oool0Q03oool008D0oooo00<000000?ooo`3oool0
1`3oool00`000000oooo0?ooo`060?ooo`030000003oool0oooo08D0oooo00260?ooo`030000003o
ool0oooo00H0oooo00<000000?ooo`3oool01P3oool00`000000oooo0?ooo`250?ooo`00QP3oool0
0`000000oooo0?ooo`060?ooo`030000003oool0oooo00D0oooo00<000000?ooo`3oool0QP3oool0
08L0oooo00<000000?ooo`3oool01@3oool00`000000oooo0?ooo`050?ooo`030000003oool0oooo
08H0oooo00270?ooo`030000003oool0oooo00D0oooo00<000000?ooo`3oool0103oool00`000000
oooo0?ooo`270?ooo`00R03oool00`000000oooo0?ooo`040?ooo`030000003oool0oooo00@0oooo
00<000000?ooo`3oool0Q`3oool008P0oooo00<000000?ooo`3oool0103oool00`000000oooo0?oo
o`030?ooo`030000003oool0oooo08P0oooo00290?ooo`030000003oool0oooo00<0oooo00<00000
0?ooo`3oool00`3oool00`000000oooo0?ooo`280?ooo`00R@3oool00`000000oooo0?ooo`030?oo
o`030000003oool0oooo0080oooo00<000000?ooo`3oool0R@3oool008X0oooo00<000000?ooo`3o
ool00P3oool00`000000oooo0?ooo`020?ooo`030000003oool0oooo08T0oooo002:0?ooo`030000
003oool0oooo0080oooo00D000000?ooo`3oool0oooo0000002<0?ooo`00R`3oool01@000000oooo
0?ooo`3oool0000000<0oooo00<000000?ooo`3oool0RP3oool008/0oooo00D000000?ooo`3oool0
oooo000000020?ooo`030000003oool0oooo08/0oooo002<0?ooo`040000003oool0oooo00000080
oooo00<000000?ooo`3oool0R`3oool008`0oooo00H000000?ooo`3oool000000?ooo`00002>0?oo
o`00S@3oool01@000000oooo0000003oool0000008h0oooo002=0?ooo`040000003oool000000000
08l0oooo002>0?ooo`<00000S`3oool008h0oooo0`00002?0?ooo`00S@3oool5000008h0oooo002=
0?ooo`D00000SP3oool008d0oooo1@00002>0?ooo`00SP3oool3000008l0oooo003o0?ooob40oooo
003o0?ooob40oooo003o0?ooob40oooo003o0?ooob40oooo003o0?ooob40oooo003o0?ooob40oooo
003o0?ooob40oooo003o0?ooob40oooo003o0?ooob40oooo003o0?ooob40oooo0000\
\>"],
  ImageRangeCache->{{{0, 287}, {287, 0}} -> {-0.952637, -0.575008, \
0.00663859, 0.00574918}}],

Cell[BoxData[
    TagBox[\(\[SkeletonIndicator]  Graphics  \[SkeletonIndicator]\),
      False,
      Editable->False]], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    \(draw[mm, \ F\  . \ P0]\)], "Input"],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: 1 
MathPictureStart
/Mabs {
Mgmatrix idtransform
Mtmatrix dtransform
} bind def
/Mabsadd { Mabs
3 -1 roll add
3 1 roll add
exch } bind def
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
0.5 0.524864 0.348485 0.606061 [
[ 0 0 0 0 ]
[ 1 1 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 0 m
1 0 L
1 1 L
0 1 L
closepath
clip
newpath
0 g
.02 w
.5 .95455 Mdot
.95455 .04545 Mdot
.04545 .04545 Mdot
.5 .55051 Mdot
.65152 .24747 Mdot
.34848 .24747 Mdot
.5 .34848 Mdot
.5 Mabswid
[ ] 0 setdash
.5 .95455 m
.95455 .04545 L
s
.5 .95455 m
.04545 .04545 L
s
.5 .95455 m
.5 .55051 L
s
.5 .95455 m
.5 .34848 L
s
.95455 .04545 m
.5 .95455 L
s
.95455 .04545 m
.04545 .04545 L
s
.95455 .04545 m
.65152 .24747 L
s
.95455 .04545 m
.5 .34848 L
s
.04545 .04545 m
.5 .95455 L
s
.04545 .04545 m
.95455 .04545 L
s
.04545 .04545 m
.34848 .24747 L
s
.04545 .04545 m
.5 .34848 L
s
.5 .55051 m
.5 .95455 L
s
.5 .55051 m
.65152 .24747 L
s
.5 .55051 m
.34848 .24747 L
s
.65152 .24747 m
.95455 .04545 L
s
.65152 .24747 m
.5 .55051 L
s
.65152 .24747 m
.34848 .24747 L
s
.34848 .24747 m
.04545 .04545 L
s
.34848 .24747 m
.5 .55051 L
s
.34848 .24747 m
.65152 .24747 L
s
.5 .34848 m
.5 .95455 L
s
.5 .34848 m
.95455 .04545 L
s
.5 .34848 m
.04545 .04545 L
s
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  ImageSize->{288, 288},
  ImageMargins->{{43, 0}, {0, 0}},
  ImageRegion->{{0, 1}, {0, 1}},
  ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`40004P000182000`400?l00000o`00003oo`3ooolQ
0?ooo`00o`3ooolQ0?ooo`00o`3ooolQ0?ooo`00o`3ooolQ0?ooo`00o`3ooolQ0?ooo`00o`3ooolQ
0?ooo`00o`3ooolQ0?ooo`00o`3ooolQ0?ooo`00o`3ooolQ0?ooo`00o`3ooolQ0?ooo`00o`3ooolQ
0?ooo`00o`3ooolQ0?ooo`002`3oool300000?l0oooo0`3oool3000000d0oooo000:0?ooo`D00000
o`3oool10?ooo`D00000303oool000X0ooooo`00000;000000`0oooo000:0?ooo`H00000o`3oool5
000000`0oooo000;0?ooo`@0000000<0oooo0000003oool0o03oool00`000000oooo000000020000
00d0oooo000>0?ooo`030000003oool0oooo00800000n@3oool2000000030?ooo`000000oooo00l0
oooo000?0?ooo`050000003oool0oooo0?ooo`000000m`3oool01@000000oooo0?ooo`3oool00000
0100oooo000?0?ooo`030000003oool0oooo0080oooo0P00003c0?ooo`8000000`3oool00`000000
oooo0?ooo`0?0?ooo`00403oool00`000000oooo0?ooo`030?ooo`030000003oool0oooo0>l0oooo
00<000000?ooo`3oool00`3oool00`000000oooo0?ooo`0?0?ooo`00403oool00`000000oooo0?oo
o`040?ooo`800000k@3oool2000000D0oooo00<000000?ooo`3oool0403oool00140oooo00<00000
0?ooo`3oool01@3oool00`000000oooo0?ooo`3Y0?ooo`030000003oool0oooo00D0oooo00<00000
0?ooo`3oool0403oool00140oooo00<000000?ooo`3oool01P3oool200000>L0oooo0P0000070?oo
o`030000003oool0oooo0140oooo000B0?ooo`030000003oool0oooo00L0oooo00<000000?ooo`3o
ool0h`3oool00`000000oooo0?ooo`070?ooo`030000003oool0oooo0140oooo000B0?ooo`030000
003oool0oooo00P0oooo0P00003Q0?ooo`8000002@3oool00`000000oooo0?ooo`0B0?ooo`004`3o
ool00`000000oooo0?ooo`090?ooo`030000003oool0oooo0=d0oooo00<000000?ooo`3oool02@3o
ool00`000000oooo0?ooo`0B0?ooo`004`3oool00`000000oooo0?ooo`0:0?ooo`800000f`3oool2
000000/0oooo00<000000?ooo`3oool04`3oool001@0oooo00<000000?ooo`3oool02`3oool00`00
0000oooo0?ooo`3G0?ooo`030000003oool0oooo00/0oooo00<000000?ooo`3oool04`3oool001@0
oooo00<000000?ooo`3oool0303oool200000=D0oooo0P00000=0?ooo`030000003oool0oooo01@0
oooo000E0?ooo`030000003oool0oooo00d0oooo00<000000?ooo`3oool0d@3oool00`000000oooo
0?ooo`0=0?ooo`030000003oool0oooo01@0oooo000E0?ooo`030000003oool0oooo00h0oooo0P00
003?0?ooo`8000003`3oool00`000000oooo0?ooo`0E0?ooo`005P3oool00`000000oooo0?ooo`0?
0?ooo`030000003oool0oooo0</0oooo00<000000?ooo`3oool03`3oool00`000000oooo0?ooo`0E
0?ooo`005P3oool00`000000oooo0?ooo`0@0?ooo`800000b@3oool200000140oooo00<000000?oo
o`3oool05P3oool001L0oooo00<000000?ooo`3oool04@3oool00`000000oooo0?ooo`350?ooo`03
0000003oool0oooo0140oooo00<000000?ooo`3oool05P3oool001L0oooo00<000000?ooo`3oool0
4P3oool200000<<0oooo0P00000C0?ooo`030000003oool0oooo01L0oooo000H0?ooo`030000003o
ool0oooo01<0oooo00<000000?ooo`3oool0_`3oool00`000000oooo0?ooo`0C0?ooo`030000003o
ool0oooo01L0oooo000H0?ooo`030000003oool0oooo01@0oooo0P00002m0?ooo`8000005@3oool0
0`000000oooo0?ooo`0H0?ooo`006@3oool00`000000oooo0?ooo`0E0?ooo`030000003oool0oooo
0;T0oooo00<000000?ooo`3oool05@3oool00`000000oooo0?ooo`0H0?ooo`006@3oool00`000000
oooo0?ooo`0F0?ooo`800000]`3oool2000001L0oooo00<000000?ooo`3oool06@3oool001X0oooo
00<000000?ooo`3oool05`3oool00`000000oooo0?ooo`2c0?ooo`030000003oool0oooo01L0oooo
00<000000?ooo`3oool06@3oool001X0oooo00<000000?ooo`3oool0603oool200000;40oooo0P00
000I0?ooo`030000003oool0oooo01X0oooo000K0?ooo`030000003oool0oooo01T0oooo00<00000
0?ooo`3oool0[@3oool00`000000oooo0?ooo`0I0?ooo`030000003oool0oooo01X0oooo000K0?oo
o`030000003oool0oooo01X0oooo0P00002[0?ooo`8000006`3oool00`000000oooo0?ooo`0K0?oo
o`00703oool00`000000oooo0?ooo`0K0?ooo`030000003oool0oooo0:L0oooo00<000000?ooo`3o
ool06`3oool00`000000oooo0?ooo`0K0?ooo`00703oool00`000000oooo0?ooo`0L0?ooo`800000
Y@3oool2000001d0oooo00<000000?ooo`3oool0703oool001d0oooo00<000000?ooo`3oool07@3o
ool00`000000oooo0?ooo`2Q0?ooo`030000003oool0oooo01d0oooo00<000000?ooo`3oool0703o
ool001d0oooo00<000000?ooo`3oool07P3oool2000009l0oooo0P00000O0?ooo`030000003oool0
oooo01d0oooo000N0?ooo`030000003oool0oooo01l0oooo00<000000?ooo`3oool0V`3oool00`00
0000oooo0?ooo`0O0?ooo`030000003oool0oooo01d0oooo000N0?ooo`030000003oool0oooo0200
oooo0P00002I0?ooo`8000008@3oool00`000000oooo0?ooo`0N0?ooo`007`3oool00`000000oooo
0?ooo`0Q0?ooo`030000003oool0oooo09D0oooo00<000000?ooo`3oool08@3oool00`000000oooo
0?ooo`0N0?ooo`007`3oool00`000000oooo0?ooo`0R0?ooo`800000T`3oool2000002<0oooo00<0
00000?ooo`3oool07`3oool00200oooo00<000000?ooo`3oool08`3oool00`000000oooo0?ooo`2?
0?ooo`030000003oool0oooo02<0oooo00<000000?ooo`3oool07`3oool00200oooo00<000000?oo
o`3oool0903oool2000008d0oooo0P00000U0?ooo`030000003oool0oooo0200oooo000Q0?ooo`03
0000003oool0oooo02D0oooo00<000000?ooo`3oool0R@3oool00`000000oooo0?ooo`0U0?ooo`03
0000003oool0oooo0200oooo000Q0?ooo`030000003oool0oooo02H0oooo0P0000270?ooo`800000
9`3oool00`000000oooo0?ooo`0Q0?ooo`008P3oool00`000000oooo0?ooo`0W0?ooo`030000003o
ool0oooo08<0oooo00<000000?ooo`3oool09`3oool00`000000oooo0?ooo`0Q0?ooo`008P3oool0
0`000000oooo0?ooo`0X0?ooo`800000P@3oool2000002T0oooo00<000000?ooo`3oool08P3oool0
02<0oooo00<000000?ooo`3oool0:03oool2000007l0oooo0P00000Z0?ooo`030000003oool0oooo
0280oooo000S0?ooo`030000003oool0oooo02X0oooo0P00001k0?ooo`800000:`3oool00`000000
oooo0?ooo`0S0?ooo`00903oool00`000000oooo0?ooo`0Z0?ooo`800000N@3oool2000002`0oooo
00<000000?ooo`3oool08`3oool002@0oooo00<000000?ooo`3oool0;03oool2000007D0oooo0P00
000]0?ooo`030000003oool0oooo02@0oooo000U0?ooo`030000003oool0oooo02`0oooo0P00001c
0?ooo`800000;P3oool00`000000oooo0?ooo`0T0?ooo`009@3oool00`000000oooo0?ooo`0^0?oo
o`800000K`3oool2000002l0oooo00<000000?ooo`3oool09@3oool002H0oooo00<000000?ooo`3o
ool0;P3oool2000006d0oooo0P00000`0?ooo`030000003oool0oooo02D0oooo000V0?ooo`030000
003oool0oooo0300oooo0P00001Y0?ooo`800000<@3oool00`000000oooo0?ooo`0V0?ooo`009`3o
ool00`000000oooo0?ooo`0`0?ooo`800000I`3oool200000380oooo00<000000?ooo`3oool09P3o
ool002L0oooo00<000000?ooo`3oool0<P3oool2000006<0oooo0P00000c0?ooo`030000003oool0
oooo02L0oooo000X0?ooo`030000003oool0oooo0380oooo0P00001Q0?ooo`800000=03oool00`00
0000oooo0?ooo`0W0?ooo`00:03oool00`000000oooo0?ooo`0d0?ooo`800000G@3oool2000003D0
oooo00<000000?ooo`3oool0:03oool002T0oooo00<000000?ooo`3oool0=03oool5000005@0oooo
0`0000000`3oool000000000000f0?ooo`030000003oool0oooo02P0oooo000Y0?ooo`030000003o
ool0oooo03D0oooo1@00001B0?ooo`D00000=`3oool00`000000oooo0?ooo`0Y0?ooo`00:P3oool0
0`000000oooo0?ooo`0d0?oooe`00000=`3oool00`000000oooo0?ooo`0Y0?ooo`00:P3oool00`00
0000oooo0?ooo`0d0?ooo`D00000DP3oool5000003H0oooo00<000000?ooo`3oool0:P3oool002/0
oooo00<000000?ooo`3oool0=03oool6000004l0oooo1@00000g0?ooo`030000003oool0oooo02X0
oooo000[0?ooo`030000003oool0oooo03L0oooo00@000000?ooo`3oool00000C@3oool00`000000
oooo0000000i0?ooo`030000003oool0oooo02/0oooo000/0?ooo`030000003oool0oooo03L0oooo
00<000000?ooo`3oool00P0000190?ooo`8000000P3oool00`000000oooo0?ooo`0g0?ooo`030000
003oool0oooo02/0oooo000/0?ooo`030000003oool0oooo03L0oooo00<000000?ooo`3oool00P3o
ool00`000000oooo0?ooo`150?ooo`050000003oool0oooo0?ooo`000000>@3oool00`000000oooo
0?ooo`0/0?ooo`00;@3oool00`000000oooo0?ooo`0g0?ooo`030000003oool0oooo0080oooo0P00
00130?ooo`800000103oool00`000000oooo0?ooo`0g0?ooo`030000003oool0oooo02`0oooo000]
0?ooo`030000003oool0oooo03L0oooo00<000000?ooo`3oool0103oool00`000000oooo0?ooo`0o
0?ooo`030000003oool0oooo00<0oooo00<000000?ooo`3oool0=`3oool00`000000oooo0?ooo`0]
0?ooo`00;P3oool00`000000oooo0?ooo`0g0?ooo`030000003oool0oooo00@0oooo0P00000m0?oo
o`8000001P3oool00`000000oooo0?ooo`0g0?ooo`030000003oool0oooo02d0oooo000^0?ooo`03
0000003oool0oooo03L0oooo00<000000?ooo`3oool01P3oool00`000000oooo0?ooo`0i0?ooo`03
0000003oool0oooo00D0oooo00<000000?ooo`3oool0=`3oool00`000000oooo0?ooo`0^0?ooo`00
;`3oool00`000000oooo0?ooo`0g0?ooo`030000003oool0oooo00H0oooo0P00000g0?ooo`800000
203oool00`000000oooo0?ooo`0g0?ooo`030000003oool0oooo02h0oooo000_0?ooo`030000003o
ool0oooo03L0oooo00<000000?ooo`3oool0203oool00`000000oooo0?ooo`0c0?ooo`030000003o
ool0oooo00L0oooo00<000000?ooo`3oool0=`3oool00`000000oooo0?ooo`0_0?ooo`00<03oool0
0`000000oooo0?ooo`0g0?ooo`030000003oool0oooo00P0oooo0P00000a0?ooo`8000002P3oool0
0`000000oooo0?ooo`0g0?ooo`030000003oool0oooo02l0oooo000`0?ooo`030000003oool0oooo
03L0oooo00<000000?ooo`3oool02P3oool00`000000oooo0?ooo`0]0?ooo`030000003oool0oooo
00T0oooo00<000000?ooo`3oool0=`3oool00`000000oooo0?ooo`0`0?ooo`00<@3oool00`000000
oooo0?ooo`0g0?ooo`030000003oool0oooo00X0oooo0P00000[0?ooo`800000303oool00`000000
oooo0?ooo`0g0?ooo`030000003oool0oooo0300oooo000a0?ooo`030000003oool0oooo03L0oooo
00<000000?ooo`3oool0303oool00`000000oooo0?ooo`0W0?ooo`030000003oool0oooo00/0oooo
00<000000?ooo`3oool0=`3oool00`000000oooo0?ooo`0a0?ooo`00<P3oool00`000000oooo0?oo
o`0g0?ooo`030000003oool0oooo00`0oooo0P00000U0?ooo`8000003P3oool00`000000oooo0?oo
o`0g0?ooo`030000003oool0oooo0340oooo000b0?ooo`030000003oool0oooo03L0oooo00<00000
0?ooo`3oool03P3oool00`000000oooo0?ooo`0Q0?ooo`030000003oool0oooo00d0oooo00<00000
0?ooo`3oool0=`3oool00`000000oooo0?ooo`0b0?ooo`00<`3oool00`000000oooo0?ooo`0g0?oo
o`030000003oool0oooo00h0oooo0P00000O0?ooo`800000403oool00`000000oooo0?ooo`0g0?oo
o`030000003oool0oooo0380oooo000c0?ooo`030000003oool0oooo03L0oooo00<000000?ooo`3o
ool0403oool00`000000oooo0?ooo`0K0?ooo`030000003oool0oooo00l0oooo00<000000?ooo`3o
ool0=`3oool00`000000oooo0?ooo`0c0?ooo`00=03oool00`000000oooo0?ooo`0g0?ooo`030000
003oool0oooo0100oooo0P00000I0?ooo`8000004P3oool00`000000oooo0?ooo`0g0?ooo`030000
003oool0oooo03<0oooo000d0?ooo`030000003oool0oooo03L0oooo00<000000?ooo`3oool04P3o
ool00`000000oooo0?ooo`0E0?ooo`030000003oool0oooo0140oooo00<000000?ooo`3oool0=`3o
ool00`000000oooo0?ooo`0d0?ooo`00=@3oool00`000000oooo0?ooo`0g0?ooo`030000003oool0
oooo0180oooo0P00000C0?ooo`800000503oool00`000000oooo0?ooo`0g0?ooo`030000003oool0
oooo03@0oooo000e0?ooo`030000003oool0oooo03L0oooo00<000000?ooo`3oool0503oool00`00
0000oooo0?ooo`0?0?ooo`030000003oool0oooo01<0oooo00<000000?ooo`3oool0=`3oool00`00
0000oooo0?ooo`0e0?ooo`00=P3oool00`000000oooo0?ooo`0g0?ooo`030000003oool0oooo01@0
oooo0P00000=0?ooo`8000005P3oool00`000000oooo0?ooo`0g0?ooo`030000003oool0oooo03D0
oooo000f0?ooo`030000003oool0oooo03L0oooo00<000000?ooo`3oool05P3oool00`000000oooo
0?ooo`090?ooo`030000003oool0oooo01D0oooo00<000000?ooo`3oool0=`3oool00`000000oooo
0?ooo`0f0?ooo`00=`3oool00`000000oooo0?ooo`0g0?ooo`030000003oool0oooo01H0oooo0P00
00070?ooo`800000603oool00`000000oooo0?ooo`0g0?ooo`030000003oool0oooo03H0oooo000g
0?ooo`030000003oool0oooo03L0oooo00<000000?ooo`3oool0603oool00`000000oooo00000002
000000030?ooo`000000oooo01P0oooo00<000000?ooo`3oool0=`3oool00`000000oooo0?ooo`0g
0?ooo`00>03oool00`000000oooo0?ooo`0g0?ooo`030000003oool0oooo01P0oooo1@00000J0?oo
o`030000003oool0oooo03L0oooo00<000000?ooo`3oool0=`3oool003P0oooo00<000000?ooo`3o
ool0=`3oool00`000000oooo0?ooo`0H0?ooo`D000006@3oool00`000000oooo0?ooo`0g0?ooo`03
0000003oool0oooo03P0oooo000i0?ooo`030000003oool0oooo03L0oooo00<000000?ooo`3oool0
5`3oool5000001T0oooo00<000000?ooo`3oool0=`3oool00`000000oooo0?ooo`0h0?ooo`00>@3o
ool00`000000oooo0?ooo`0g0?ooo`030000003oool0oooo01P0oooo0`00000I0?ooo`030000003o
ool0oooo03L0oooo00<000000?ooo`3oool0>@3oool003X0oooo00<000000?ooo`3oool0=`3oool0
0`000000oooo0?ooo`0H0?ooo`030000003oool0oooo01P0oooo00<000000?ooo`3oool0=`3oool0
0`000000oooo0?ooo`0i0?ooo`00>P3oool00`000000oooo0?ooo`0g0?ooo`030000003oool0oooo
01P0oooo00<000000?ooo`3oool05`3oool00`000000oooo0?ooo`0g0?ooo`030000003oool0oooo
03X0oooo000k0?ooo`030000003oool0oooo03L0oooo00<000000?ooo`3oool05`3oool00`000000
oooo0?ooo`0G0?ooo`030000003oool0oooo03L0oooo00<000000?ooo`3oool0>P3oool003/0oooo
00<000000?ooo`3oool0=`3oool00`000000oooo0?ooo`0G0?ooo`030000003oool0oooo01H0oooo
00<000000?ooo`3oool0=`3oool00`000000oooo0?ooo`0k0?ooo`00?03oool00`000000oooo0?oo
o`0g0?ooo`030000003oool0oooo01H0oooo00<000000?ooo`3oool05P3oool00`000000oooo0?oo
o`0g0?ooo`030000003oool0oooo03/0oooo000l0?ooo`030000003oool0oooo03L0oooo00<00000
0?ooo`3oool05P3oool00`000000oooo0?ooo`0E0?ooo`030000003oool0oooo03L0oooo00<00000
0?ooo`3oool0?03oool003d0oooo00<000000?ooo`3oool0=`3oool00`000000oooo0?ooo`0E0?oo
o`030000003oool0oooo01D0oooo00<000000?ooo`3oool0=`3oool00`000000oooo0?ooo`0l0?oo
o`00?@3oool00`000000oooo0?ooo`0g0?ooo`030000003oool0oooo01D0oooo00<000000?ooo`3o
ool0503oool00`000000oooo0?ooo`0g0?ooo`030000003oool0oooo03d0oooo000n0?ooo`030000
003oool0oooo03L0oooo00<000000?ooo`3oool0503oool00`000000oooo0?ooo`0D0?ooo`030000
003oool0oooo03L0oooo00<000000?ooo`3oool0?@3oool003h0oooo00<000000?ooo`3oool0=`3o
ool00`000000oooo0?ooo`0D0?ooo`030000003oool0oooo01<0oooo00<000000?ooo`3oool0=`3o
ool00`000000oooo0?ooo`0n0?ooo`00?`3oool00`000000oooo0?ooo`0g0?ooo`030000003oool0
oooo01<0oooo00<000000?ooo`3oool04`3oool00`000000oooo0?ooo`0g0?ooo`030000003oool0
oooo03h0oooo000o0?ooo`030000003oool0oooo03L0oooo00<000000?ooo`3oool04`3oool00`00
0000oooo0?ooo`0B0?ooo`030000003oool0oooo03L0oooo00<000000?ooo`3oool0?`3oool00400
oooo00<000000?ooo`3oool0=`3oool00`000000oooo0?ooo`0B0?ooo`030000003oool0oooo0180
oooo00<000000?ooo`3oool0=`3oool00`000000oooo0?ooo`0o0?ooo`00@03oool00`000000oooo
0?ooo`0g0?ooo`030000003oool0oooo0180oooo00<000000?ooo`3oool04@3oool00`000000oooo
0?ooo`0g0?ooo`030000003oool0oooo0400oooo00110?ooo`030000003oool0oooo03L0oooo00<0
00000?ooo`3oool04@3oool00`000000oooo0?ooo`0A0?ooo`030000003oool0oooo03L0oooo00<0
00000?ooo`3oool0@03oool00440oooo00<000000?ooo`3oool0=`3oool00`000000oooo0?ooo`0A
0?ooo`030000003oool0oooo0100oooo00<000000?ooo`3oool0=`3oool00`000000oooo0?ooo`11
0?ooo`00@P3oool00`000000oooo0?ooo`0g0?ooo`030000003oool0oooo0100oooo00<000000?oo
o`3oool0403oool00`000000oooo0?ooo`0g0?ooo`030000003oool0oooo0440oooo00120?ooo`03
0000003oool0oooo03L0oooo00<000000?ooo`3oool0403oool00`000000oooo0?ooo`0?0?ooo`03
0000003oool0oooo03L0oooo00<000000?ooo`3oool0@P3oool004<0oooo00<000000?ooo`3oool0
=`3oool00`000000oooo0?ooo`0?0?ooo`030000003oool0oooo00l0oooo00<000000?ooo`3oool0
=`3oool00`000000oooo0?ooo`120?ooo`00@`3oool00`000000oooo0?ooo`0g0?ooo`030000003o
ool0oooo00l0oooo00<000000?ooo`3oool03P3oool00`000000oooo0?ooo`0g0?ooo`030000003o
ool0oooo04<0oooo00140?ooo`030000003oool0oooo03L0oooo00<000000?ooo`3oool03P3oool0
0`000000oooo0?ooo`0>0?ooo`030000003oool0oooo03L0oooo00<000000?ooo`3oool0@`3oool0
04@0oooo00<000000?ooo`3oool0=`3oool00`000000oooo0?ooo`0>0?ooo`030000003oool0oooo
00d0oooo00<000000?ooo`3oool0=`3oool00`000000oooo0?ooo`140?ooo`00A@3oool00`000000
oooo0?ooo`0g0?ooo`030000003oool0oooo00d0oooo00<000000?ooo`3oool03@3oool00`000000
oooo0?ooo`0g0?ooo`030000003oool0oooo04@0oooo00150?ooo`030000003oool0oooo03L0oooo
00<000000?ooo`3oool03@3oool00`000000oooo0?ooo`0<0?ooo`030000003oool0oooo03L0oooo
00<000000?ooo`3oool0A@3oool004H0oooo00<000000?ooo`3oool0=`3oool00`000000oooo0?oo
o`0<0?ooo`030000003oool0oooo00`0oooo00<000000?ooo`3oool0=`3oool00`000000oooo0?oo
o`150?ooo`00AP3oool00`000000oooo0?ooo`0g0?ooo`030000003oool0oooo00`0oooo00<00000
0?ooo`3oool02`3oool00`000000oooo0?ooo`0g0?ooo`030000003oool0oooo04H0oooo00170?oo
o`030000003oool0oooo03L0oooo00<000000?ooo`3oool02`3oool00`000000oooo0?ooo`0;0?oo
o`030000003oool0oooo03L0oooo00<000000?ooo`3oool0AP3oool004L0oooo00<000000?ooo`3o
ool0=`3oool00`000000oooo0?ooo`0;0?ooo`030000003oool0oooo00X0oooo00<000000?ooo`3o
ool0=`3oool00`000000oooo0?ooo`170?ooo`00B03oool00`000000oooo0?ooo`0g0?ooo`030000
003oool0oooo00X0oooo00<000000?ooo`3oool02P3oool00`000000oooo0?ooo`0g0?ooo`030000
003oool0oooo04L0oooo00180?ooo`030000003oool0oooo03L0oooo00<000000?ooo`3oool02P3o
ool00`000000oooo0?ooo`090?ooo`030000003oool0oooo03L0oooo00<000000?ooo`3oool0B03o
ool004T0oooo00<000000?ooo`3oool0=`3oool00`000000oooo0?ooo`090?ooo`030000003oool0
oooo00T0oooo00<000000?ooo`3oool0=`3oool00`000000oooo0?ooo`180?ooo`00B@3oool00`00
0000oooo0?ooo`0g0?ooo`030000003oool0oooo00T0oooo00<000000?ooo`3oool0203oool00`00
0000oooo0?ooo`0g0?ooo`030000003oool0oooo04T0oooo001:0?ooo`030000003oool0oooo03L0
oooo00<000000?ooo`3oool0203oool00`000000oooo0?ooo`080?ooo`030000003oool0oooo03L0
oooo00<000000?ooo`3oool0B@3oool004X0oooo00<000000?ooo`3oool0=`3oool00`000000oooo
0?ooo`080?ooo`030000003oool0oooo00L0oooo00<000000?ooo`3oool0=`3oool00`000000oooo
0?ooo`1:0?ooo`00B`3oool00`000000oooo0?ooo`0g0?ooo`030000003oool0oooo00L0oooo00<0
00000?ooo`3oool01`3oool00`000000oooo0?ooo`0g0?ooo`030000003oool0oooo04X0oooo001;
0?ooo`030000003oool0oooo03L0oooo00<000000?ooo`3oool01`3oool00`000000oooo0?ooo`06
0?ooo`030000003oool0oooo03L0oooo00<000000?ooo`3oool0B`3oool004`0oooo00<000000?oo
o`3oool0=`3oool00`000000oooo0?ooo`060?ooo`030000003oool0oooo00H0oooo00<000000?oo
o`3oool0=`3oool00`000000oooo0?ooo`1;0?ooo`00C03oool00`000000oooo0?ooo`0g0?ooo`03
0000003oool0oooo00H0oooo00<000000?ooo`3oool01@3oool00`000000oooo0?ooo`0g0?ooo`03
0000003oool0oooo04`0oooo001=0?ooo`030000003oool0oooo03L0oooo00<000000?ooo`3oool0
1@3oool00`000000oooo0?ooo`050?ooo`030000003oool0oooo03L0oooo00<000000?ooo`3oool0
C03oool004d0oooo00<000000?ooo`3oool0=`3oool00`000000oooo0?ooo`050?ooo`030000003o
ool0oooo00@0oooo00<000000?ooo`3oool0=`3oool00`000000oooo0?ooo`1=0?ooo`00CP3oool0
0`000000oooo0?ooo`0g0?ooo`030000003oool0oooo00@0oooo00<000000?ooo`3oool0103oool0
0`000000oooo0?ooo`0g0?ooo`030000003oool0oooo04d0oooo001>0?ooo`030000003oool0oooo
03L0oooo00<000000?ooo`3oool0103oool00`000000oooo0?ooo`030?ooo`030000003oool0oooo
03L0oooo00<000000?ooo`3oool0CP3oool004l0oooo00<000000?ooo`3oool0=`3oool00`000000
oooo0?ooo`030?ooo`030000003oool0oooo00<0oooo00<000000?ooo`3oool0=`3oool00`000000
oooo0?ooo`1>0?ooo`00C`3oool00`000000oooo0?ooo`0g0?ooo`030000003oool0oooo00<0oooo
00<000000?ooo`3oool00P3oool00`000000oooo0?ooo`0g0?ooo`030000003oool0oooo04l0oooo
001@0?ooo`030000003oool0oooo03L0oooo00<000000?ooo`3oool00P3oool00`000000oooo0?oo
o`020?ooo`030000003oool0oooo03L0oooo00<000000?ooo`3oool0C`3oool00500oooo00<00000
0?ooo`3oool0=`3oool00`000000oooo0?ooo`020?ooo`050000003oool0oooo0?ooo`000000>@3o
ool00`000000oooo0?ooo`1@0?ooo`00D@3oool00`000000oooo0?ooo`0g0?ooo`050000003oool0
oooo0?ooo`0000000`3oool00`000000oooo0?ooo`0g0?ooo`030000003oool0oooo0500oooo001A
0?ooo`030000003oool0oooo03L0oooo00D000000?ooo`3oool0oooo000000020?ooo`030000003o
ool0oooo03L0oooo00<000000?ooo`3oool0D@3oool00580oooo00<000000?ooo`3oool0=`3oool0
10000000oooo0?ooo`0000020?ooo`030000003oool0oooo03L0oooo00<000000?ooo`3oool0D@3o
ool00580oooo00<000000?ooo`3oool0=`3oool01P000000oooo0?ooo`000000oooo000003T0oooo
00<000000?ooo`3oool0DP3oool005<0oooo00<000000?ooo`3oool0=`3oool01@000000oooo0000
003oool0000003T0oooo00<000000?ooo`3oool0DP3oool005<0oooo00<000000?ooo`3oool0=`3o
ool010000000oooo00000000000i0?ooo`030000003oool0oooo05<0oooo001D0?ooo`030000003o
ool0oooo03L0oooo0`00000i0?ooo`030000003oool0oooo05<0oooo001D0?ooo`030000003oool0
oooo03L0oooo0`00000h0?ooo`030000003oool0oooo05@0oooo001E0?ooo`030000003oool0oooo
03D0oooo1@00000g0?ooo`030000003oool0oooo05@0oooo001E0?ooo`030000003oool0oooo03D0
oooo1@00000f0?ooo`030000003oool0oooo05D0oooo001F0?ooo`030000003oool0oooo03@0oooo
1@00000f0?ooo`030000003oool0oooo05D0oooo001F0?ooo`030000003oool0oooo03D0oooo0`00
000f0?ooo`030000003oool0oooo05H0oooo001G0?ooo`030000003oool0oooo03D0oooo00<00000
0?ooo`3oool0=@3oool00`000000oooo0?ooo`1F0?ooo`00E`3oool00`000000oooo0?ooo`0e0?oo
o`030000003oool0oooo03@0oooo00<000000?ooo`3oool0E`3oool005P0oooo00<000000?ooo`3o
ool0=03oool00`000000oooo0?ooo`0d0?ooo`030000003oool0oooo05L0oooo001H0?ooo`030000
003oool0oooo03@0oooo00<000000?ooo`3oool0<`3oool00`000000oooo0?ooo`1H0?ooo`00F@3o
ool00`000000oooo0?ooo`0c0?ooo`030000003oool0oooo03<0oooo00<000000?ooo`3oool0F03o
ool005T0oooo00<000000?ooo`3oool0<`3oool00`000000oooo0?ooo`0b0?ooo`030000003oool0
oooo05T0oooo001J0?ooo`030000003oool0oooo0380oooo00<000000?ooo`3oool0<P3oool00`00
0000oooo0?ooo`1I0?ooo`00FP3oool00`000000oooo0?ooo`0b0?ooo`030000003oool0oooo0340
oooo00<000000?ooo`3oool0FP3oool005/0oooo00<000000?ooo`3oool0<@3oool00`000000oooo
0?ooo`0a0?ooo`030000003oool0oooo05X0oooo001K0?ooo`030000003oool0oooo0340oooo00<0
00000?ooo`3oool0<03oool00`000000oooo0?ooo`1K0?ooo`00G03oool00`000000oooo0?ooo`0`
0?ooo`030000003oool0oooo0300oooo00<000000?ooo`3oool0F`3oool005`0oooo00<000000?oo
o`3oool0<03oool00`000000oooo0?ooo`0_0?ooo`030000003oool0oooo05`0oooo001M0?ooo`03
0000003oool0oooo02l0oooo00<000000?ooo`3oool0;`3oool00`000000oooo0?ooo`1L0?ooo`00
G@3oool00`000000oooo0?ooo`0_0?ooo`030000003oool0oooo02h0oooo00<000000?ooo`3oool0
G@3oool005h0oooo00<000000?ooo`3oool0;P3oool00`000000oooo0?ooo`0^0?ooo`030000003o
ool0oooo05d0oooo001N0?ooo`030000003oool0oooo02h0oooo00<000000?ooo`3oool0;@3oool0
0`000000oooo0?ooo`1N0?ooo`00G`3oool00`000000oooo0?ooo`0]0?ooo`030000003oool0oooo
02d0oooo00<000000?ooo`3oool0GP3oool005l0oooo00<000000?ooo`3oool0;@3oool00`000000
oooo0?ooo`0/0?ooo`030000003oool0oooo05l0oooo001P0?ooo`030000003oool0oooo02`0oooo
00<000000?ooo`3oool0;03oool00`000000oooo0?ooo`1O0?ooo`00H03oool00`000000oooo0?oo
o`0/0?ooo`030000003oool0oooo02/0oooo00<000000?ooo`3oool0H03oool00640oooo00<00000
0?ooo`3oool0:`3oool00`000000oooo0?ooo`0[0?ooo`030000003oool0oooo0600oooo001Q0?oo
o`030000003oool0oooo02/0oooo00<000000?ooo`3oool0:P3oool00`000000oooo0?ooo`1Q0?oo
o`00HP3oool00`000000oooo0?ooo`0Z0?ooo`030000003oool0oooo02X0oooo00<000000?ooo`3o
ool0H@3oool00680oooo00<000000?ooo`3oool0:P3oool00`000000oooo0?ooo`0Y0?ooo`030000
003oool0oooo0680oooo001S0?ooo`030000003oool0oooo02T0oooo00<000000?ooo`3oool0:@3o
ool00`000000oooo0?ooo`1R0?ooo`00H`3oool00`000000oooo0?ooo`0Y0?ooo`030000003oool0
oooo02P0oooo00<000000?ooo`3oool0H`3oool006@0oooo00<000000?ooo`3oool0:03oool00`00
0000oooo0?ooo`0X0?ooo`030000003oool0oooo06<0oooo001T0?ooo`030000003oool0oooo02P0
oooo00<000000?ooo`3oool09`3oool00`000000oooo0?ooo`1T0?ooo`00I@3oool00`000000oooo
0?ooo`0W0?ooo`030000003oool0oooo02L0oooo00<000000?ooo`3oool0I03oool006D0oooo00<0
00000?ooo`3oool09`3oool00`000000oooo0?ooo`0V0?ooo`030000003oool0oooo06D0oooo001V
0?ooo`030000003oool0oooo02H0oooo00<000000?ooo`3oool09P3oool00`000000oooo0?ooo`1U
0?ooo`00IP3oool00`000000oooo0?ooo`0V0?ooo`030000003oool0oooo02D0oooo00<000000?oo
o`3oool0IP3oool006L0oooo00<000000?ooo`3oool09@3oool00`000000oooo0?ooo`0U0?ooo`03
0000003oool0oooo06H0oooo001W0?ooo`030000003oool0oooo02D0oooo00<000000?ooo`3oool0
903oool00`000000oooo0?ooo`1W0?ooo`00J03oool00`000000oooo0?ooo`0T0?ooo`030000003o
ool0oooo02@0oooo00<000000?ooo`3oool0I`3oool006P0oooo00<000000?ooo`3oool0903oool0
0`000000oooo0?ooo`0S0?ooo`030000003oool0oooo06P0oooo001Y0?ooo`030000003oool0oooo
02<0oooo00<000000?ooo`3oool08`3oool00`000000oooo0?ooo`1X0?ooo`00J@3oool00`000000
oooo0?ooo`0S0?ooo`030000003oool0oooo0280oooo00<000000?ooo`3oool0J@3oool006X0oooo
00<000000?ooo`3oool08P3oool00`000000oooo0?ooo`0R0?ooo`030000003oool0oooo06T0oooo
001Z0?ooo`030000003oool0oooo0280oooo00<000000?ooo`3oool08@3oool00`000000oooo0?oo
o`1Z0?ooo`00J`3oool00`000000oooo0?ooo`0Q0?ooo`030000003oool0oooo0240oooo00<00000
0?ooo`3oool0JP3oool006/0oooo00<000000?ooo`3oool08@3oool00`000000oooo0?ooo`0P0?oo
o`030000003oool0oooo06/0oooo001/0?ooo`030000003oool0oooo0200oooo00<000000?ooo`3o
ool0803oool00`000000oooo0?ooo`1[0?ooo`00K03oool00`000000oooo0?ooo`0P0?ooo`030000
003oool0oooo01l0oooo00<000000?ooo`3oool0K03oool006d0oooo00<000000?ooo`3oool07`3o
ool00`000000oooo0?ooo`0O0?ooo`030000003oool0oooo06`0oooo001]0?ooo`030000003oool0
oooo01l0oooo00<000000?ooo`3oool07P3oool00`000000oooo0?ooo`1]0?ooo`00KP3oool00`00
0000oooo0?ooo`0N0?ooo`030000003oool0oooo01h0oooo00<000000?ooo`3oool0K@3oool006h0
oooo00<000000?ooo`3oool07P3oool00`000000oooo0?ooo`0M0?ooo`030000003oool0oooo06h0
oooo001_0?ooo`030000003oool0oooo01d0oooo00<000000?ooo`3oool07@3oool00`000000oooo
0?ooo`1^0?ooo`00K`3oool00`000000oooo0?ooo`0M0?ooo`030000003oool0oooo01`0oooo00<0
00000?ooo`3oool0K`3oool00700oooo00<000000?ooo`3oool0703oool00`000000oooo0?ooo`0L
0?ooo`030000003oool0oooo06l0oooo001`0?ooo`030000003oool0oooo01`0oooo00<000000?oo
o`3oool06`3oool00`000000oooo0?ooo`1`0?ooo`00L@3oool00`000000oooo0?ooo`0K0?ooo`03
0000003oool0oooo01/0oooo00<000000?ooo`3oool0L03oool00740oooo00<000000?ooo`3oool0
6`3oool00`000000oooo0?ooo`0J0?ooo`030000003oool0oooo0740oooo001b0?ooo`030000003o
ool0oooo01X0oooo00<000000?ooo`3oool06P3oool00`000000oooo0?ooo`1a0?ooo`00LP3oool0
0`000000oooo0?ooo`0J0?ooo`030000003oool0oooo01T0oooo00<000000?ooo`3oool0LP3oool0
07<0oooo00<000000?ooo`3oool06@3oool00`000000oooo0?ooo`0I0?ooo`030000003oool0oooo
0780oooo001c0?ooo`030000003oool0oooo01T0oooo00<000000?ooo`3oool0603oool00`000000
oooo0?ooo`1c0?ooo`00M03oool00`000000oooo0?ooo`0H0?ooo`030000003oool0oooo01P0oooo
00<000000?ooo`3oool0L`3oool007@0oooo00<000000?ooo`3oool0603oool00`000000oooo0?oo
o`0G0?ooo`030000003oool0oooo07@0oooo001e0?ooo`030000003oool0oooo01L0oooo00<00000
0?ooo`3oool05`3oool00`000000oooo0?ooo`1d0?ooo`00M@3oool00`000000oooo0?ooo`0G0?oo
o`030000003oool0oooo01H0oooo00<000000?ooo`3oool0M@3oool007H0oooo00<000000?ooo`3o
ool05P3oool00`000000oooo0?ooo`0F0?ooo`030000003oool0oooo07D0oooo001f0?ooo`030000
003oool0oooo01H0oooo00<000000?ooo`3oool05@3oool00`000000oooo0?ooo`1f0?ooo`00M`3o
ool00`000000oooo0?ooo`0E0?ooo`030000003oool0oooo01D0oooo00<000000?ooo`3oool0MP3o
ool007L0oooo00<000000?ooo`3oool05@3oool00`000000oooo0?ooo`0D0?ooo`030000003oool0
oooo07L0oooo001h0?ooo`030000003oool0oooo01@0oooo00<000000?ooo`3oool0503oool00`00
0000oooo0?ooo`1g0?ooo`00N03oool00`000000oooo0?ooo`0D0?ooo`030000003oool0oooo01<0
oooo00<000000?ooo`3oool0N03oool007T0oooo00<000000?ooo`3oool04`3oool00`000000oooo
0?ooo`0C0?ooo`030000003oool0oooo07P0oooo001i0?ooo`030000003oool0oooo01<0oooo00<0
00000?ooo`3oool04P3oool00`000000oooo0?ooo`1i0?ooo`00NP3oool00`000000oooo0?ooo`0B
0?ooo`030000003oool0oooo0180oooo00<000000?ooo`3oool0N@3oool007X0oooo00<000000?oo
o`3oool04P3oool00`000000oooo0?ooo`0A0?ooo`030000003oool0oooo07X0oooo001k0?ooo`03
0000003oool0oooo0140oooo00<000000?ooo`3oool04@3oool00`000000oooo0?ooo`1j0?ooo`00
N`3oool00`000000oooo0?ooo`0A0?ooo`030000003oool0oooo0100oooo00<000000?ooo`3oool0
N`3oool007`0oooo00<000000?ooo`3oool0403oool00`000000oooo0?ooo`0@0?ooo`030000003o
ool0oooo07/0oooo001l0?ooo`030000003oool0oooo0100oooo00<000000?ooo`3oool03`3oool0
0`000000oooo0?ooo`1l0?ooo`00O@3oool00`000000oooo0?ooo`0?0?ooo`030000003oool0oooo
00l0oooo00<000000?ooo`3oool0O03oool007d0oooo00<000000?ooo`3oool03`3oool00`000000
oooo0?ooo`0>0?ooo`030000003oool0oooo07d0oooo001n0?ooo`030000003oool0oooo00h0oooo
00<000000?ooo`3oool03P3oool00`000000oooo0?ooo`1m0?ooo`00OP3oool00`000000oooo0?oo
o`0>0?ooo`030000003oool0oooo00d0oooo00<000000?ooo`3oool0OP3oool007l0oooo00<00000
0?ooo`3oool03@3oool00`000000oooo0?ooo`0=0?ooo`030000003oool0oooo07h0oooo001o0?oo
o`030000003oool0oooo00d0oooo00<000000?ooo`3oool0303oool00`000000oooo0?ooo`1o0?oo
o`00P03oool00`000000oooo0?ooo`0<0?ooo`030000003oool0oooo00`0oooo00<000000?ooo`3o
ool0O`3oool00800oooo00<000000?ooo`3oool0303oool00`000000oooo0?ooo`0;0?ooo`030000
003oool0oooo0800oooo00210?ooo`030000003oool0oooo00/0oooo00<000000?ooo`3oool02`3o
ool00`000000oooo0?ooo`200?ooo`00P@3oool00`000000oooo0?ooo`0;0?ooo`030000003oool0
oooo00X0oooo00<000000?ooo`3oool0P@3oool00880oooo00<000000?ooo`3oool02P3oool00`00
0000oooo0?ooo`0:0?ooo`030000003oool0oooo0840oooo00220?ooo`030000003oool0oooo00X0
oooo00<000000?ooo`3oool02@3oool00`000000oooo0?ooo`220?ooo`00P`3oool00`000000oooo
0?ooo`090?ooo`030000003oool0oooo00T0oooo00<000000?ooo`3oool0PP3oool008<0oooo00<0
00000?ooo`3oool02@3oool00`000000oooo0?ooo`080?ooo`030000003oool0oooo08<0oooo0024
0?ooo`030000003oool0oooo00P0oooo00<000000?ooo`3oool0203oool00`000000oooo0?ooo`23
0?ooo`00Q03oool00`000000oooo0?ooo`080?ooo`030000003oool0oooo00L0oooo00<000000?oo
o`3oool0Q03oool008D0oooo00<000000?ooo`3oool01`3oool00`000000oooo0?ooo`070?ooo`03
0000003oool0oooo08@0oooo00250?ooo`030000003oool0oooo00L0oooo00<000000?ooo`3oool0
1P3oool00`000000oooo0?ooo`250?ooo`00QP3oool00`000000oooo0?ooo`060?ooo`030000003o
ool0oooo00H0oooo00<000000?ooo`3oool0Q@3oool008H0oooo00<000000?ooo`3oool01P3oool0
0`000000oooo0?ooo`050?ooo`030000003oool0oooo08H0oooo00270?ooo`030000003oool0oooo
00D0oooo00<000000?ooo`3oool01@3oool00`000000oooo0?ooo`260?ooo`00Q`3oool00`000000
oooo0?ooo`050?ooo`030000003oool0oooo00@0oooo00<000000?ooo`3oool0Q`3oool008P0oooo
00<000000?ooo`3oool0103oool00`000000oooo0?ooo`040?ooo`030000003oool0oooo08L0oooo
00280?ooo`030000003oool0oooo00@0oooo00<000000?ooo`3oool00`3oool00`000000oooo0?oo
o`280?ooo`00R@3oool00`000000oooo0?ooo`030?ooo`030000003oool0oooo00<0oooo00<00000
0?ooo`3oool0R03oool008T0oooo00<000000?ooo`3oool00`3oool00`000000oooo0?ooo`020?oo
o`030000003oool0oooo08T0oooo002:0?ooo`030000003oool0oooo0080oooo00<000000?ooo`3o
ool00P3oool00`000000oooo0?ooo`290?ooo`00RP3oool00`000000oooo0?ooo`020?ooo`050000
003oool0oooo0?ooo`000000S03oool008/0oooo00D000000?ooo`3oool0oooo000000030?ooo`03
0000003oool0oooo08X0oooo002;0?ooo`050000003oool0oooo0?ooo`0000000P3oool00`000000
oooo0?ooo`2;0?ooo`00S03oool010000000oooo0?ooo`0000020?ooo`030000003oool0oooo08/0
oooo002<0?ooo`060000003oool0oooo0000003oool00000SP3oool008d0oooo00D000000?ooo`00
0000oooo0000002>0?ooo`00S@3oool010000000oooo00000000002?0?ooo`00SP3oool3000008l0
oooo002>0?ooo`<00000S`3oool008d0oooo1@00002>0?ooo`00S@3oool5000008h0oooo002=0?oo
o`D00000SP3oool008h0oooo0`00002?0?ooo`00o`3ooolQ0?ooo`00o`3ooolQ0?ooo`00o`3ooolQ
0?ooo`00o`3ooolQ0?ooo`00o`3ooolQ0?ooo`00o`3ooolQ0?ooo`00o`3ooolQ0?ooo`00o`3ooolQ
0?ooo`00o`3ooolQ0?ooo`00o`3ooolQ0?ooo`00\
\>"],
  ImageRangeCache->{{{0, 287}, {287, 0}} -> {-0.952637, -0.575008, \
0.00663859, 0.00574918}}],

Cell[BoxData[
    TagBox[\(\[SkeletonIndicator]  Graphics  \[SkeletonIndicator]\),
      False,
      Editable->False]], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    \(\(draw[mm, \ F . \ \ F\  . \ \ P0]\ \)\)], "Input"],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: 1 
MathPictureStart
/Mabs {
Mgmatrix idtransform
Mtmatrix dtransform
} bind def
/Mabsadd { Mabs
3 -1 roll add
3 1 roll add
exch } bind def
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
0.5 0.524864 0.348485 0.606061 [
[ 0 0 0 0 ]
[ 1 1 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 0 m
1 0 L
1 1 L
0 1 L
closepath
clip
newpath
0 g
.02 w
.5 .95455 Mdot
.95455 .04545 Mdot
.04545 .04545 Mdot
.5 .48316 Mdot
.60101 .28114 Mdot
.39899 .28114 Mdot
.5 .34848 Mdot
.5 Mabswid
.5 .95455 m
.95455 .04545 L
s
.5 .95455 m
.04545 .04545 L
s
.5 .95455 m
.5 .48316 L
s
.5 .95455 m
.5 .34848 L
s
.95455 .04545 m
.5 .95455 L
s
.95455 .04545 m
.04545 .04545 L
s
.95455 .04545 m
.60101 .28114 L
s
.95455 .04545 m
.5 .34848 L
s
.04545 .04545 m
.5 .95455 L
s
.04545 .04545 m
.95455 .04545 L
s
.04545 .04545 m
.39899 .28114 L
s
.04545 .04545 m
.5 .34848 L
s
.5 .48316 m
.5 .95455 L
s
.5 .48316 m
.60101 .28114 L
s
.5 .48316 m
.39899 .28114 L
s
.60101 .28114 m
.95455 .04545 L
s
.60101 .28114 m
.5 .48316 L
s
.60101 .28114 m
.39899 .28114 L
s
.39899 .28114 m
.04545 .04545 L
s
.39899 .28114 m
.5 .48316 L
s
.39899 .28114 m
.60101 .28114 L
s
.5 .34848 m
.5 .95455 L
s
.5 .34848 m
.95455 .04545 L
s
.5 .34848 m
.04545 .04545 L
s
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  ImageSize->{288, 288},
  ImageMargins->{{43, 0}, {0, 0}},
  ImageRegion->{{0, 1}, {0, 1}},
  ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`40004P000180P10`40000100000800002008200000
P800P020P<30`<3L`:K:l00003<006H009T00<`00?l0000c03<c06Hc09Tc0<`c0?lc001V03=V06IV
09UV0<aV0?mV002I03>I06JI09VI0<bI0?nI003<03?<06K<09W<0<c<0?o<003o03?o06Ko09Wo0<co
0?oo0000<c<0<fH0<iT0<l`0<ol0<`0c<c<c<fHc<iTc<l`c<olc<`1V<c=V<fIV<iUV<laV<omV<`2I
<c>I<fJI<iVI<lbI<onI<`3<<c?<<fK<<iW<<lc<<oo<<`3o<c?o<fKo<iWo<lco<ooo<`00IS<0IVH0
IYT0I/`0I_l0IP0cIS<cIVHcIYTcI/`cI_lcIP1VIS=VIVIVIYUVI/aVI_mVIP2IIS>IIVJIIYVII/bI
I_nIIP3<IS?<IVK<IYW<I/c<I_o<IP3oIS?oIVKoIYWoI/coI_ooIP00VC<0VFH0VIT0VL`0VOl0V@0c
VC<cVFHcVITcVL`cVOlcV@1VVC=VVFIVVIUVVLaVVOmVV@2IVC>IVFJIVIVIVLbIVOnIV@3<VC?<VFK<
VIW<VLc<VOo<V@3oVC?oVFKoVIWoVLcoVOooV@00c3<0c6H0c9T0c<`0c?l0c00cc3<cc6Hcc9Tcc<`c
c?lcc01Vc3=Vc6IVc9UVc<aVc?mVc02Ic3>Ic6JIc9VIc<bIc?nIc03<c3?<c6K<c9W<c<c<c?o<c03o
c3?oc6Koc9Woc<coc?ooc000oc<0ofH0oiT0ol`0ool0o`0coc<cofHcoiTcol`coolco`1Voc=VofIV
oiUVolaVoomVo`2Ioc>IofJIoiVIolbIoonIo`3<oc?<ofK<oiW<olc<ooo<o`3ooc?oofKooiWoolco
ooooo`0000410@820P<30`@410D51@H61PL71`P820T92@X:2P/;2``<30h>3Pl?3a0@414A4A8B4Q<C
4a@D5?okl:2PY820P?l0003o0?oo0000ool0o`3ooooooooQ8N400?oQ8N400?oQ8N400?oQ8N400?oQ
8N400?oQ8N400?oQ8N400?oQ8N400?oQ8N400?oQ8N400?oQ8N400?oQ8N4000_Q0`3oh@?Q0`0=h@00
2^450?oQ0N4500cQ000:hOl02`0<h@002^460?oQ1@0<h@002n440003h@3Q0?cQ00<0h@000P0=h@00
3^400`3Qh@020?WQ0P000n40h@0?h@003n401@3QhN400?OQ00D0hN7Q000@h@003n400`3Qh@02h@80
ln4200?Q00<0hN403n40013Q00<0hN400n400`3Qh@3_h@030>7Q00?Q00<0hN403n40013Q00<0hN40
1>420>gQ0P05h@030>7Q013Q000Ah@030>7Q00GQ00<0hN40jN400`3Qh@05h@030>7Q013Q000Ah@03
0>7Q00KQ0P3Wh@801n400`3Qh@0Ah@004^400`3Qh@07h@030>7Q0>?Q00<0hN401n400`3Qh@0Ah@00
4^400`3Qh@08h@80hN4200WQ00<0hN404^4001?Q00<0hN402N400`3Qh@3Mh@030>7Q00WQ00<0hN40
4^4001?Q00<0hN402^420=_Q0P0;h@030>7Q01?Q000Dh@030>7Q00_Q00<0hN40en400`3Qh@0;h@03
0>7Q01?Q000Dh@030>7Q00cQ0P3Eh@803N400`3Qh@0Dh@005N400`3Qh@0=h@030>7Q0=7Q00<0hN40
3N400`3Qh@0Dh@005N400`3Qh@0>h@80cn4200oQ00<0hN405N4001KQ00<0hN403n400`3Qh@3;h@03
0>7Q00oQ00<0hN405N4001KQ00<0hN404>420<WQ0P0Ah@030>7Q01KQ000Gh@030>7Q017Q00<0hN40
aN400`3Qh@0Ah@030>7Q01KQ000Gh@030>7Q01;Q0P33h@804n400`3Qh@0Gh@006>400`3Qh@0Ch@03
0>7Q0;oQ00<0hN404n400`3Qh@0Gh@006>400`3Qh@0Dh@80_N4201GQ00<0hN406>4001WQ00<0hN40
5N400`3Qh@2ih@030>7Q01GQ00<0hN406>4001WQ00<0hN405^420;OQ0P0Gh@030>7Q01WQ000Jh@03
0>7Q01OQ00<0hN40/n400`3Qh@0Gh@030>7Q01WQ000Jh@030>7Q01SQ0P2ah@806N400`3Qh@0Jh@00
6n400`3Qh@0Ih@030>7Q0:gQ00<0hN406N400`3Qh@0Jh@006n400`3Qh@0Jh@80Zn4201_Q00<0hN40
6n4001cQ00<0hN406n400`3Qh@2Wh@030>7Q01_Q00<0hN406n4001cQ00<0hN407>420:GQ0P0Mh@03
0>7Q01cQ000Mh@030>7Q01gQ00<0hN40XN400`3Qh@0Mh@030>7Q01cQ000Mh@030>7Q01kQ0P2Oh@80
7n400`3Qh@0Mh@007^400`3Qh@0Oh@80Vn42027Q00<0hN407N4001kQ00<0hN408>4209WQ0P0Qh@03
0>7Q01kQ000Oh@030>7Q027Q0P2Eh@808n400`3Qh@0Nh@007n400`3Qh@0Rh@80Tn4202?Q00<0hN40
7n40023Q00<0hN408n4208oQ0P0Uh@030>7Q01oQ000Ph@030>7Q02CQ0P2=h@809N400`3Qh@0Ph@00
8N400`3Qh@0Uh@80RN4202OQ00<0hN408>40027Q00<0hN409^4208OQ0P0Wh@030>7Q027Q000Rh@03
0>7Q02OQ0P23h@80:N400`3Qh@0Qh@008^400`3Qh@0Xh@80PN4202WQ00<0hN408^4002?Q00<0hN40
:>4307gQ0`0Zh@030>7Q02;Q000Sh@030>7Q02[Q0P1kh@80:n400`3Qh@0Sh@009>400`3Qh@0Zh@<0
Mn4302cQ00<0hN408n4002CQ00<0hN40;>4207GQ0P0]h@030>7Q02CQ000Uh@030>7Q02cQ0`1ah@<0
;^400`3Qh@0Th@009N400`3Qh@0^h@80Kn4202oQ00<0hN409N4002KQ00<0hN40;^4306_Q0`0`h@03
0>7Q02GQ000Vh@030>7Q033Q0P1Yh@80<N400`3Qh@0Vh@009n400`3Qh@0`h@<0IN4303;Q00<0hN40
9^4002OQ00<0hN40<^4206?Q0P0ch@030>7Q02OQ000Xh@030>7Q03;Q0`1Oh@<0=>400`3Qh@0Wh@00
:>400`3Qh@0dh@80GN4203GQ00<0hN40:>4002WQ00<0hN40=>4305WQ0`0fh@030>7Q02SQ000Yh@03
0>7Q03KQ0P1Gh@80=n400`3Qh@0Yh@00:^400`3Qh@0fh@<0Dn4303SQ00<0hN40:N4002[Q00<0hN40
>>42057Q0P0ih@030>7Q02[Q000[h@030>7Q03SQ0`1=h@<0>^400`3Qh@0Zh@00:n400`3Qh@0jh@80
Bn4203_Q00<0hN40:n4002cQ00<0hN40>^4304OQ0`0lh@030>7Q02_Q000/h@030>7Q03cQ0P15h@80
?N400`3Qh@0/h@00;N400`3Qh@0lh@<0@N4303kQ00<0hN40;>4002gQ00<0hN40?^420004h@0003OQ
0`000n40000oh@030>7Q02gQ000^h@030>7Q03kQ1P0eh@H0@>400`3Qh@0]h@00;^400`3Qh@0ohCl0
@>400`3Qh@0^h@00;n400`3Qh@0nh@D0=N45043Q00<0hN40;^4002oQ00<0hN40?n4403GQ1010h@03
0>7Q02oQ000`h@030>7Q043Q00@0h@00<N4304?Q00<0hN40;n40033Q00<0hN40@N40103Qh@0_h@04
0>7Q04;Q00<0hN40<>40037Q00<0hN40@>40103QhN4202_Q0P02h@030>7Q047Q00<0hN40<>40037Q
00<0hN40@N400`3Qh@02h@030>7Q02OQ00<0hN400^400`3Qh@10h@030>7Q037Q000bh@030>7Q043Q
00<0hN400n4202GQ0P04h@030>7Q047Q00<0hN40<N4003;Q00<0hN40@N400`3Qh@04h@030>7Q027Q
00<0hN401>400`3Qh@10h@030>7Q03;Q000ch@030>7Q043Q00<0hN401N4201oQ0P06h@030>7Q047Q
00<0hN40<^4003?Q00<0hN40@N400`3Qh@06h@030>7Q01_Q00<0hN401^400`3Qh@10h@030>7Q03?Q
000dh@030>7Q043Q00<0hN401n4201WQ0P08h@030>7Q047Q00<0hN40<n4003CQ00<0hN40@N400`3Q
h@08h@030>7Q01GQ00<0hN402>400`3Qh@10h@030>7Q03CQ000eh@030>7Q043Q00<0hN402N4201?Q
0P0:h@030>7Q047Q00<0hN40=>4003GQ00<0hN40@N400`3Qh@0:h@030>7Q00oQ00<0hN402^400`3Q
h@10h@030>7Q03GQ000fh@030>7Q043Q00<0hN402n4200gQ0P0<h@030>7Q047Q00<0hN40=N4003KQ
00<0hN40@N400`3Qh@0<h@030>7Q00WQ00<0hN403>400`3Qh@10h@030>7Q03KQ000gh@030>7Q043Q
00<0hN403N4200OQ0P0>h@030>7Q047Q00<0hN40=^4003OQ00<0hN40@N400`3Qh@0>h@030>400080
00?Q0>403n400`3Qh@10h@030>7Q03OQ000hh@030>7Q043Q00<0hN403n45013Q00<0hN40@N400`3Q
h@0gh@00>>400`3Qh@11h@030>7Q00kQ1@0@h@030>7Q043Q00<0hN40>>4003WQ00<0hN40@>400`3Q
h@0>h@D03n400`3Qh@11h@030>7Q03SQ000ih@030>7Q047Q00<0hN403^43013Q00<0hN40@>400`3Q
h@0ih@00>^400`3Qh@10h@030>7Q00oQ00<0hN403^400`3Qh@11h@030>7Q03WQ000jh@030>7Q047Q
00<0hN403^400`3Qh@0>h@030>7Q043Q00<0hN40>^4003_Q00<0hN40@>400`3Qh@0>h@030>7Q00gQ
00<0hN40@N400`3Qh@0jh@00>n400`3Qh@11h@030>7Q00gQ00<0hN403N400`3Qh@10h@030>7Q03_Q
000lh@030>7Q043Q00<0hN403N400`3Qh@0<h@030>7Q047Q00<0hN40>n4003cQ00<0hN40@N400`3Q
h@0<h@030>7Q00cQ00<0hN40@>400`3Qh@0lh@00?N400`3Qh@10h@030>7Q00cQ00<0hN402n400`3Q
h@11h@030>7Q03cQ000mh@030>7Q047Q00<0hN402n400`3Qh@0;h@030>7Q043Q00<0hN40?N4003kQ
00<0hN40@>400`3Qh@0;h@030>7Q00[Q00<0hN40@N400`3Qh@0mh@00?^400`3Qh@11h@030>7Q00[Q
00<0hN402^400`3Qh@10h@030>7Q03kQ000oh@030>7Q043Q00<0hN402^400`3Qh@09h@030>7Q047Q
00<0hN40?^4003oQ00<0hN40@N400`3Qh@09h@030>7Q00WQ00<0hN40@>400`3Qh@0oh@00@>400`3Q
h@10h@030>7Q00WQ00<0hN402>400`3Qh@11h@030>7Q03oQ0010h@030>7Q047Q00<0hN402>400`3Q
h@08h@030>7Q043Q00<0hN40@>40047Q00<0hN40@>400`3Qh@08h@030>7Q00OQ00<0hN40@N400`3Q
h@10h@00@N400`3Qh@11h@030>7Q00OQ00<0hN401n400`3Qh@10h@030>7Q047Q0012h@030>7Q043Q
00<0hN401n400`3Qh@06h@030>7Q047Q00<0hN40@N4004;Q00<0hN40@N400`3Qh@06h@030>7Q00KQ
00<0hN40@>400`3Qh@12h@00@n400`3Qh@10h@030>7Q00KQ00<0hN401N400`3Qh@11h@030>7Q04;Q
0013h@030>7Q047Q00<0hN401N400`3Qh@05h@030>7Q043Q00<0hN40@n4004CQ00<0hN40@>400`3Q
h@05h@030>7Q00CQ00<0hN40@N400`3Qh@13h@00A>400`3Qh@11h@030>7Q00CQ00<0hN401>400`3Q
h@10h@030>7Q04CQ0015h@030>7Q043Q00<0hN401>400`3Qh@03h@030>7Q047Q00<0hN40A>4004GQ
00<0hN40@N400`3Qh@03h@030>7Q00?Q00<0hN40@>400`3Qh@15h@00A^400`3Qh@10h@030>7Q00?Q
00<0hN400^400`3Qh@11h@030>7Q04GQ0016h@030>7Q047Q00<0hN400^400`3Qh@02h@030>7Q043Q
00<0hN40A^4004OQ00<0hN40@>400`3Qh@02h@050>7Qh@00@n400`3Qh@16h@00An400`3Qh@11h@05
0>7Qh@000n400`3Qh@10h@030>7Q04OQ0018h@030>7Q043Q00D0hN7Q0002h@030>7Q047Q00<0hN40
An4004SQ00<0hN40@N40103Qh@02h@030>7Q043Q00<0hN40B>4004WQ00<0hN40@>401P3Qh@3Q04?Q
00<0hN40B>4004WQ00<0hN40@N401@3Q0>4004;Q00<0hN40BN4004[Q00<0hN40@>40103Q0013h@03
0>7Q04WQ001:h@030>7Q047Q0`12h@030>7Q04[Q001;h@030>7Q03oQ1@11h@030>7Q04[Q001;h@03
0>7Q03oQ1@10h@030>7Q04_Q001<h@030>7Q03kQ1@10h@030>7Q04_Q001<h@030>7Q03oQ0`10h@03
0>7Q04cQ001=h@030>7Q03oQ00<0hN40?n400`3Qh@1<h@00CN400`3Qh@0oh@030>7Q03kQ00<0hN40
CN4004kQ00<0hN40?^400`3Qh@0nh@030>7Q04gQ001>h@030>7Q03kQ00<0hN40?N400`3Qh@1>h@00
Cn400`3Qh@0mh@030>7Q03gQ00<0hN40C^4004oQ00<0hN40?N400`3Qh@0lh@030>7Q04oQ001@h@03
0>7Q03cQ00<0hN40?>400`3Qh@1?h@00D>400`3Qh@0lh@030>7Q03_Q00<0hN40D>40057Q00<0hN40
>n400`3Qh@0kh@030>7Q053Q001Ah@030>7Q03_Q00<0hN40>^400`3Qh@1Ah@00D^400`3Qh@0jh@03
0>7Q03[Q00<0hN40DN4005;Q00<0hN40>^400`3Qh@0ih@030>7Q05;Q001Ch@030>7Q03WQ00<0hN40
>N400`3Qh@1Bh@00Dn400`3Qh@0ih@030>7Q03SQ00<0hN40Dn4005CQ00<0hN40>>400`3Qh@0hh@03
0>7Q05?Q001Dh@030>7Q03SQ00<0hN40=n400`3Qh@1Dh@00EN400`3Qh@0gh@030>7Q03OQ00<0hN40
E>4005GQ00<0hN40=n400`3Qh@0fh@030>7Q05GQ001Fh@030>7Q03KQ00<0hN40=^400`3Qh@1Eh@00
E^400`3Qh@0fh@030>7Q03GQ00<0hN40E^4005OQ00<0hN40=N400`3Qh@0eh@030>7Q05KQ001Gh@03
0>7Q03GQ00<0hN40=>400`3Qh@1Gh@00F>400`3Qh@0dh@030>7Q03CQ00<0hN40En4005SQ00<0hN40
=>400`3Qh@0ch@030>7Q05SQ001Ih@030>7Q03?Q00<0hN40<n400`3Qh@1Hh@00FN400`3Qh@0ch@03
0>7Q03;Q00<0hN40FN4005[Q00<0hN40<^400`3Qh@0bh@030>7Q05WQ001Jh@030>7Q03;Q00<0hN40
<N400`3Qh@1Jh@00Fn400`3Qh@0ah@030>7Q037Q00<0hN40F^4005_Q00<0hN40<N400`3Qh@0`h@03
0>7Q05_Q001Lh@030>7Q033Q00<0hN40<>400`3Qh@1Kh@00G>400`3Qh@0`h@030>7Q02oQ00<0hN40
G>4005gQ00<0hN40;n400`3Qh@0_h@030>7Q05cQ001Mh@030>7Q02oQ00<0hN40;^400`3Qh@1Mh@00
G^400`3Qh@0^h@030>7Q02kQ00<0hN40GN4005kQ00<0hN40;^400`3Qh@0]h@030>7Q05kQ001Oh@03
0>7Q02gQ00<0hN40;N400`3Qh@1Nh@00Gn400`3Qh@0]h@030>7Q02cQ00<0hN40Gn40063Q00<0hN40
;>400`3Qh@0/h@030>7Q05oQ001Ph@030>7Q02cQ00<0hN40:n400`3Qh@1Ph@00HN400`3Qh@0[h@03
0>7Q02_Q00<0hN40H>40067Q00<0hN40:n400`3Qh@0Zh@030>7Q067Q001Rh@030>7Q02[Q00<0hN40
:^400`3Qh@1Qh@00H^400`3Qh@0Zh@030>7Q02WQ00<0hN40H^4006?Q00<0hN40:N400`3Qh@0Yh@03
0>7Q06;Q001Sh@030>7Q02WQ00<0hN40:>400`3Qh@1Sh@00I>400`3Qh@0Xh@030>7Q02SQ00<0hN40
Hn4006CQ00<0hN40:>400`3Qh@0Wh@030>7Q06CQ001Uh@030>7Q02OQ00<0hN409n400`3Qh@1Th@00
IN400`3Qh@0Wh@030>7Q02KQ00<0hN40IN4006KQ00<0hN409^400`3Qh@0Vh@030>7Q06GQ001Vh@03
0>7Q02KQ00<0hN409N400`3Qh@1Vh@00In400`3Qh@0Uh@030>7Q02GQ00<0hN40I^4006OQ00<0hN40
9N400`3Qh@0Th@030>7Q06OQ001Xh@030>7Q02CQ00<0hN409>400`3Qh@1Wh@00J>400`3Qh@0Th@03
0>7Q02?Q00<0hN40J>4006WQ00<0hN408n400`3Qh@0Sh@030>7Q06SQ001Yh@030>7Q02?Q00<0hN40
8^400`3Qh@1Yh@00J^400`3Qh@0Rh@030>7Q02;Q00<0hN40JN4006[Q00<0hN408^400`3Qh@0Qh@03
0>7Q06[Q001[h@030>7Q027Q00<0hN408N400`3Qh@1Zh@00Jn400`3Qh@0Qh@030>7Q023Q00<0hN40
Jn4006cQ00<0hN408>400`3Qh@0Ph@030>7Q06_Q001/h@030>7Q023Q00<0hN407n400`3Qh@1/h@00
KN400`3Qh@0Oh@030>7Q01oQ00<0hN40K>4006gQ00<0hN407n400`3Qh@0Nh@030>7Q06gQ001^h@03
0>7Q01kQ00<0hN407^400`3Qh@1]h@00K^400`3Qh@0Nh@030>7Q01gQ00<0hN40K^4006oQ00<0hN40
7N400`3Qh@0Mh@030>7Q06kQ001_h@030>7Q01gQ00<0hN407>400`3Qh@1_h@00L>400`3Qh@0Lh@03
0>7Q01cQ00<0hN40Kn40073Q00<0hN407>400`3Qh@0Kh@030>7Q073Q001ah@030>7Q01_Q00<0hN40
6n400`3Qh@1`h@00LN400`3Qh@0Kh@030>7Q01[Q00<0hN40LN4007;Q00<0hN406^400`3Qh@0Jh@03
0>7Q077Q001bh@030>7Q01[Q00<0hN406N400`3Qh@1bh@00Ln400`3Qh@0Ih@030>7Q01WQ00<0hN40
L^4007?Q00<0hN406N400`3Qh@0Hh@030>7Q07?Q001dh@030>7Q01SQ00<0hN406>400`3Qh@1ch@00
M>400`3Qh@0Hh@030>7Q01OQ00<0hN40M>4007GQ00<0hN405n400`3Qh@0Gh@030>7Q07CQ001eh@03
0>7Q01OQ00<0hN405^400`3Qh@1eh@00M^400`3Qh@0Fh@030>7Q01KQ00<0hN40MN4007KQ00<0hN40
5^400`3Qh@0Eh@030>7Q07KQ001gh@030>7Q01GQ00<0hN405N400`3Qh@1fh@00Mn400`3Qh@0Eh@03
0>7Q01CQ00<0hN40Mn4007SQ00<0hN405>400`3Qh@0Dh@030>7Q07OQ001hh@030>7Q01CQ00<0hN40
4n400`3Qh@1hh@00NN400`3Qh@0Ch@030>7Q01?Q00<0hN40N>4007WQ00<0hN404n400`3Qh@0Bh@03
0>7Q07WQ001jh@030>7Q01;Q00<0hN404^400`3Qh@1ih@00N^400`3Qh@0Bh@030>7Q017Q00<0hN40
N^4007_Q00<0hN404N400`3Qh@0Ah@030>7Q07[Q001kh@030>7Q017Q00<0hN404>400`3Qh@1kh@00
O>400`3Qh@0@h@030>7Q013Q00<0hN40Nn4007cQ00<0hN404>400`3Qh@0?h@030>7Q07cQ001mh@03
0>7Q00oQ00<0hN403n400`3Qh@1lh@00ON400`3Qh@0?h@030>7Q00kQ00<0hN40ON4007kQ00<0hN40
3^400`3Qh@0>h@030>7Q07gQ001nh@030>7Q00kQ00<0hN403N400`3Qh@1nh@00On400`3Qh@0=h@03
0>7Q00gQ00<0hN40O^4007oQ00<0hN403N400`3Qh@0<h@030>7Q07oQ0020h@030>7Q00cQ00<0hN40
3>400`3Qh@1oh@00P>400`3Qh@0<h@030>7Q00_Q00<0hN40P>40087Q00<0hN402n400`3Qh@0;h@03
0>7Q083Q0021h@030>7Q00_Q00<0hN402^400`3Qh@21h@00P^400`3Qh@0:h@030>7Q00[Q00<0hN40
PN4008;Q00<0hN402^400`3Qh@09h@030>7Q08;Q0023h@030>7Q00WQ00<0hN402N400`3Qh@22h@00
Pn400`3Qh@09h@030>7Q00SQ00<0hN40Pn4008CQ00<0hN402>400`3Qh@08h@030>7Q08?Q0024h@03
0>7Q00SQ00<0hN401n400`3Qh@24h@00QN400`3Qh@07h@030>7Q00OQ00<0hN40Q>4008GQ00<0hN40
1n400`3Qh@06h@030>7Q08GQ0026h@030>7Q00KQ00<0hN401^400`3Qh@25h@00Q^400`3Qh@06h@03
0>7Q00GQ00<0hN40Q^4008OQ00<0hN401N400`3Qh@05h@030>7Q08KQ0027h@030>7Q00GQ00<0hN40
1>400`3Qh@27h@00R>400`3Qh@04h@030>7Q00CQ00<0hN40Qn4008SQ00<0hN401>400`3Qh@03h@03
0>7Q08SQ0029h@030>7Q00?Q00<0hN400n400`3Qh@28h@00RN400`3Qh@03h@030>7Q00;Q00<0hN40
RN4008[Q00<0hN400^400`3Qh@02h@030>7Q08WQ002:h@030>7Q00;Q00D0hN7Q002<h@00Rn401@3Q
hN4000?Q00<0hN40R^4008_Q00D0hN7Q0002h@030>7Q08_Q002<h@040>7Q00;Q00<0hN40Rn4008cQ
00H0hN40h@2>h@00SN401@3Q0>4008kQ002=h@040>4008oQ002>h@<0Sn4008kQ0`2?h@00SN4508kQ
002=h@D0S^4008gQ1@2>h@00S^4308oQ003ohB7Q003ohB7Q003ohB7Q003ohB7Q003ohB7Q003ohB7Q
003ohB7Q003ohB7Q003ohB7Q003ohB7Q0000\
\>"],
  ImageRangeCache->{{{0, 287}, {287, 0}} -> {-0.952637, -0.575008, 
  0.00663859, 0.00574918}}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    \(mm = {{0, 1, 1, 1, 0, 0, 0, 0}, {1, 0, 1, 0, 1, 0, 0, 0}, {1, 1, 0, 0, 
          0, 1, 0, 0}, {1, 0, 0, 0, 1, 1, 0, 1}, {0, 1, 0, 1, 0, 1, 1, 
          0}, {0, 0, 1, 1, 1, 0, 1, 0}, {0, 0, 0, 0, 1, 1, 0, 1}, {0, 0, 0, 
          1, 0, 0, 1, 0}}\)], "Input"],

Cell[BoxData[
    \({{0, 1, 1, 1, 0, 0, 0, 0}, {1, 0, 1, 0, 1, 0, 0, 0}, {1, 1, 0, 0, 0, 1, 
        0, 0}, {1, 0, 0, 0, 1, 1, 0, 1}, {0, 1, 0, 1, 0, 1, 1, 0}, {0, 0, 1, 
        1, 1, 0, 1, 0}, {0, 0, 0, 0, 1, 1, 0, 1}, {0, 0, 0, 1, 0, 0, 1, 
        0}}\)], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    \(\(\(\ \)\(F = {{1, 0, 0, 0, 0, 0, 0, 0}, {0, 1, 0, 0, 0, 0, 0, 0}, {0, 
          0, 1, 0, 0, 0, 0, 0}, {1\/4, 0, 0, 0, 1\/4, 1\/4, 0, 1\/4}, {0, 
          1\/4, 0, 1\/4, 0, 1\/4, 1/4, 0}, {0, 0, 1\/4, 1\/4, 1\/4, 0, 1/4, 
          0}, {0, 0, 0, 0, 1/3, 1/3, 0, 1\/3}, {0, 0, 0, 1\/2, 0, 0, 1\/2, 
          0}}\)\)\)], "Input"],

Cell[BoxData[
    \({{1, 0, 0, 0, 0, 0, 0, 0}, {0, 1, 0, 0, 0, 0, 0, 0}, {0, 0, 1, 0, 0, 0, 
        0, 0}, {1\/4, 0, 0, 0, 1\/4, 1\/4, 0, 1\/4}, {0, 1\/4, 0, 1\/4, 0, 
        1\/4, 1\/4, 0}, {0, 0, 1\/4, 1\/4, 1\/4, 0, 1\/4, 0}, {0, 0, 0, 0, 
        1\/3, 1\/3, 0, 1\/3}, {0, 0, 0, 1\/2, 0, 0, 1\/2, 0}}\)], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    \(\(\(\ \ \ \ \)\(P0 = {{0, 
          1}, {\@3\/2, \(-\(1\/2\)\)}, {\(-\(\@3\/2\)\), \(-\(1\/2\)\)}, {0, 
          0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}}\)\)\)], "Input"],

Cell[BoxData[
    \({{0, 1}, {\@3\/2, \(-\(1\/2\)\)}, {\(-\(\@3\/2\)\), \(-\(1\/2\)\)}, {0, 
        0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}}\)], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    \(\(\(draw[mm, \ P0]\)\(\ \ \ \ \ \ \ \ \ \ \ \ \ \ \)\)\)], "Input"],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: 1 
MathPictureStart
/Mabs {
Mgmatrix idtransform
Mtmatrix dtransform
} bind def
/Mabsadd { Mabs
3 -1 roll add
3 1 roll add
exch } bind def
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
0.5 0.524864 0.348485 0.606061 [
[ 0 0 0 0 ]
[ 1 1 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 0 m
1 0 L
1 1 L
0 1 L
closepath
clip
newpath
0 g
.02 w
.5 .95455 Mdot
.95455 .04545 Mdot
.04545 .04545 Mdot
.5 .34848 Mdot
.5 .34848 Mdot
.5 .34848 Mdot
.5 .34848 Mdot
.5 .34848 Mdot
.5 Mabswid
[ ] 0 setdash
.5 .95455 m
.95455 .04545 L
s
.5 .95455 m
.04545 .04545 L
s
.5 .95455 m
.5 .34848 L
s
.95455 .04545 m
.5 .95455 L
s
.95455 .04545 m
.04545 .04545 L
s
.95455 .04545 m
.5 .34848 L
s
.04545 .04545 m
.5 .95455 L
s
.04545 .04545 m
.95455 .04545 L
s
.04545 .04545 m
.5 .34848 L
s
.5 .34848 m
.5 .95455 L
s
.5 .34848 m
.5 .34848 L
s
.5 .34848 m
.5 .34848 L
s
.5 .34848 m
.5 .34848 L
s
.5 .34848 m
.95455 .04545 L
s
.5 .34848 m
.5 .34848 L
s
.5 .34848 m
.5 .34848 L
s
.5 .34848 m
.5 .34848 L
s
.5 .34848 m
.04545 .04545 L
s
.5 .34848 m
.5 .34848 L
s
.5 .34848 m
.5 .34848 L
s
.5 .34848 m
.5 .34848 L
s
.5 .34848 m
.5 .34848 L
s
.5 .34848 m
.5 .34848 L
s
.5 .34848 m
.5 .34848 L
s
.5 .34848 m
.5 .34848 L
s
.5 .34848 m
.5 .34848 L
s
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  ImageSize->{288, 288},
  ImageMargins->{{43, 0}, {0, 0}},
  ImageRegion->{{0, 1}, {0, 1}},
  ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`40004P000182000`400?l00000o`00003oo`3ooolQ
0?ooo`00o`3ooolQ0?ooo`00o`3ooolQ0?ooo`00o`3ooolQ0?ooo`00o`3ooolQ0?ooo`00o`3ooolQ
0?ooo`00o`3ooolQ0?ooo`00o`3ooolQ0?ooo`00o`3ooolQ0?ooo`00o`3ooolQ0?ooo`00o`3ooolQ
0?ooo`00o`3ooolQ0?ooo`002`3oool300000?l0oooo0`3oool3000000d0oooo000:0?ooo`D00000
o`3oool10?ooo`D00000303oool000X0ooooo`00000;000000`0oooo000:0?ooo`H00000o`3oool5
000000`0oooo000;0?ooo`@0000000<0oooo0000003oool0o03oool00`000000oooo000000020000
00d0oooo000>0?ooo`030000003oool0oooo00800000n@3oool2000000030?ooo`000000oooo00l0
oooo000?0?ooo`050000003oool0oooo0?ooo`000000m`3oool01@000000oooo0?ooo`3oool00000
0100oooo000?0?ooo`030000003oool0oooo0080oooo0P00003c0?ooo`8000000`3oool00`000000
oooo0?ooo`0?0?ooo`00403oool00`000000oooo0?ooo`030?ooo`030000003oool0oooo0>l0oooo
00<000000?ooo`3oool00`3oool00`000000oooo0?ooo`0?0?ooo`00403oool00`000000oooo0?oo
o`040?ooo`800000k@3oool2000000D0oooo00<000000?ooo`3oool0403oool00140oooo00<00000
0?ooo`3oool01@3oool00`000000oooo0?ooo`3Y0?ooo`030000003oool0oooo00D0oooo00<00000
0?ooo`3oool0403oool00140oooo00<000000?ooo`3oool01P3oool200000>L0oooo0P0000070?oo
o`030000003oool0oooo0140oooo000B0?ooo`030000003oool0oooo00L0oooo00<000000?ooo`3o
ool0h`3oool00`000000oooo0?ooo`070?ooo`030000003oool0oooo0140oooo000B0?ooo`030000
003oool0oooo00P0oooo0P00003Q0?ooo`8000002@3oool00`000000oooo0?ooo`0B0?ooo`004`3o
ool00`000000oooo0?ooo`090?ooo`030000003oool0oooo0=d0oooo00<000000?ooo`3oool02@3o
ool00`000000oooo0?ooo`0B0?ooo`004`3oool00`000000oooo0?ooo`0:0?ooo`800000f`3oool2
000000/0oooo00<000000?ooo`3oool04`3oool001@0oooo00<000000?ooo`3oool02`3oool00`00
0000oooo0?ooo`3G0?ooo`030000003oool0oooo00/0oooo00<000000?ooo`3oool04`3oool001@0
oooo00<000000?ooo`3oool0303oool200000=D0oooo0P00000=0?ooo`030000003oool0oooo01@0
oooo000E0?ooo`030000003oool0oooo00d0oooo00<000000?ooo`3oool0d@3oool00`000000oooo
0?ooo`0=0?ooo`030000003oool0oooo01@0oooo000E0?ooo`030000003oool0oooo00h0oooo0P00
003?0?ooo`8000003`3oool00`000000oooo0?ooo`0E0?ooo`005P3oool00`000000oooo0?ooo`0?
0?ooo`030000003oool0oooo0</0oooo00<000000?ooo`3oool03`3oool00`000000oooo0?ooo`0E
0?ooo`005P3oool00`000000oooo0?ooo`0@0?ooo`800000b@3oool200000140oooo00<000000?oo
o`3oool05P3oool001L0oooo00<000000?ooo`3oool04@3oool00`000000oooo0?ooo`350?ooo`03
0000003oool0oooo0140oooo00<000000?ooo`3oool05P3oool001L0oooo00<000000?ooo`3oool0
4P3oool200000<<0oooo0P00000C0?ooo`030000003oool0oooo01L0oooo000H0?ooo`030000003o
ool0oooo01<0oooo00<000000?ooo`3oool0_`3oool00`000000oooo0?ooo`0C0?ooo`030000003o
ool0oooo01L0oooo000H0?ooo`030000003oool0oooo01@0oooo0P00002m0?ooo`8000005@3oool0
0`000000oooo0?ooo`0H0?ooo`006@3oool00`000000oooo0?ooo`0E0?ooo`030000003oool0oooo
0;T0oooo00<000000?ooo`3oool05@3oool00`000000oooo0?ooo`0H0?ooo`006@3oool00`000000
oooo0?ooo`0F0?ooo`800000]`3oool2000001L0oooo00<000000?ooo`3oool06@3oool001X0oooo
00<000000?ooo`3oool05`3oool00`000000oooo0?ooo`2c0?ooo`030000003oool0oooo01L0oooo
00<000000?ooo`3oool06@3oool001X0oooo00<000000?ooo`3oool0603oool200000;40oooo0P00
000I0?ooo`030000003oool0oooo01X0oooo000K0?ooo`030000003oool0oooo01T0oooo00<00000
0?ooo`3oool0[@3oool00`000000oooo0?ooo`0I0?ooo`030000003oool0oooo01X0oooo000K0?oo
o`030000003oool0oooo01X0oooo0P00002[0?ooo`8000006`3oool00`000000oooo0?ooo`0K0?oo
o`00703oool00`000000oooo0?ooo`0K0?ooo`030000003oool0oooo0:L0oooo00<000000?ooo`3o
ool06`3oool00`000000oooo0?ooo`0K0?ooo`00703oool00`000000oooo0?ooo`0L0?ooo`800000
Y@3oool2000001d0oooo00<000000?ooo`3oool0703oool001d0oooo00<000000?ooo`3oool07@3o
ool00`000000oooo0?ooo`2Q0?ooo`030000003oool0oooo01d0oooo00<000000?ooo`3oool0703o
ool001d0oooo00<000000?ooo`3oool07P3oool2000009l0oooo0P00000O0?ooo`030000003oool0
oooo01d0oooo000N0?ooo`030000003oool0oooo01l0oooo00<000000?ooo`3oool0V`3oool00`00
0000oooo0?ooo`0O0?ooo`030000003oool0oooo01d0oooo000N0?ooo`030000003oool0oooo0200
oooo0P00002I0?ooo`8000008@3oool00`000000oooo0?ooo`0N0?ooo`007`3oool00`000000oooo
0?ooo`0Q0?ooo`030000003oool0oooo09D0oooo00<000000?ooo`3oool08@3oool00`000000oooo
0?ooo`0N0?ooo`007`3oool00`000000oooo0?ooo`0R0?ooo`800000T`3oool2000002<0oooo00<0
00000?ooo`3oool07`3oool00200oooo00<000000?ooo`3oool08`3oool00`000000oooo0?ooo`2?
0?ooo`030000003oool0oooo02<0oooo00<000000?ooo`3oool07`3oool00200oooo00<000000?oo
o`3oool0903oool2000008d0oooo0P00000U0?ooo`030000003oool0oooo0200oooo000Q0?ooo`03
0000003oool0oooo02D0oooo00<000000?ooo`3oool0R@3oool00`000000oooo0?ooo`0U0?ooo`03
0000003oool0oooo0200oooo000Q0?ooo`030000003oool0oooo02H0oooo0P0000270?ooo`800000
9`3oool00`000000oooo0?ooo`0Q0?ooo`008P3oool00`000000oooo0?ooo`0W0?ooo`030000003o
ool0oooo08<0oooo00<000000?ooo`3oool09`3oool00`000000oooo0?ooo`0Q0?ooo`008P3oool0
0`000000oooo0?ooo`0X0?ooo`030000003oool0oooo0840oooo00<000000?ooo`3oool09`3oool0
0`000000oooo0?ooo`0R0?ooo`008`3oool00`000000oooo0?ooo`0X0?ooo`800000O`3oool20000
02X0oooo00<000000?ooo`3oool08P3oool002<0oooo00<000000?ooo`3oool0:P3oool00`000000
oooo0?ooo`1k0?ooo`030000003oool0oooo02T0oooo00<000000?ooo`3oool08`3oool002@0oooo
00<000000?ooo`3oool0:P3oool2000007T0oooo0P00000/0?ooo`030000003oool0oooo02<0oooo
000T0?ooo`030000003oool0oooo02`0oooo00<000000?ooo`3oool0M@3oool00`000000oooo0?oo
o`0[0?ooo`030000003oool0oooo02@0oooo000U0?ooo`030000003oool0oooo02`0oooo0P00001c
0?ooo`800000;P3oool00`000000oooo0?ooo`0T0?ooo`009@3oool00`000000oooo0?ooo`0^0?oo
o`030000003oool0oooo06l0oooo00<000000?ooo`3oool0;@3oool00`000000oooo0?ooo`0U0?oo
o`009P3oool00`000000oooo0?ooo`0^0?ooo`800000K@3oool200000300oooo00<000000?ooo`3o
ool09@3oool002H0oooo00<000000?ooo`3oool0<03oool00`000000oooo0?ooo`1Y0?ooo`030000
003oool0oooo02l0oooo00<000000?ooo`3oool09P3oool002L0oooo00<000000?ooo`3oool0<03o
ool2000006L0oooo0P00000b0?ooo`030000003oool0oooo02H0oooo000W0?ooo`030000003oool0
oooo0380oooo00<000000?ooo`3oool0H`3oool00`000000oooo0?ooo`0a0?ooo`030000003oool0
oooo02L0oooo000X0?ooo`030000003oool0oooo0380oooo0P00001Q0?ooo`800000=03oool00`00
0000oooo0?ooo`0W0?ooo`00:03oool00`000000oooo0?ooo`0d0?ooo`030000003oool0oooo05d0
oooo00<000000?ooo`3oool0<`3oool00`000000oooo0?ooo`0X0?ooo`00:@3oool00`000000oooo
0?ooo`0d0?ooo`800000F`3oool2000003H0oooo00<000000?ooo`3oool0:03oool002T0oooo00<0
00000?ooo`3oool0=P3oool00`000000oooo0?ooo`1G0?ooo`030000003oool0oooo03D0oooo00<0
00000?ooo`3oool0:@3oool002X0oooo00<000000?ooo`3oool0=P3oool2000005D0oooo0P00000h
0?ooo`030000003oool0oooo02T0oooo000Z0?ooo`030000003oool0oooo03P0oooo00<000000?oo
o`3oool0D@3oool00`000000oooo0?ooo`0g0?ooo`030000003oool0oooo02X0oooo000[0?ooo`03
0000003oool0oooo03P0oooo0P00001?0?ooo`800000>P3oool00`000000oooo0?ooo`0Z0?ooo`00
:`3oool00`000000oooo0?ooo`0j0?ooo`030000003oool0oooo04/0oooo00<000000?ooo`3oool0
>@3oool00`000000oooo0?ooo`0[0?ooo`00;03oool00`000000oooo0?ooo`0j0?ooo`800000B@3o
ool2000003`0oooo00<000000?ooo`3oool0:`3oool002`0oooo00<000000?ooo`3oool0?03oool0
0`000000oooo0?ooo`150?ooo`030000003oool0oooo03/0oooo00<000000?ooo`3oool0;03oool0
02d0oooo00<000000?ooo`3oool0?03oool2000004<0oooo0P00000n0?ooo`030000003oool0oooo
02`0oooo000]0?ooo`030000003oool0oooo03h0oooo00<000000?ooo`3oool0?`3oool00`000000
oooo0?ooo`0m0?ooo`030000003oool0oooo02d0oooo000^0?ooo`030000003oool0oooo03h0oooo
0P00000m0?ooo`800000@03oool00`000000oooo0?ooo`0]0?ooo`00;P3oool00`000000oooo0?oo
o`100?ooo`030000003oool0oooo03T0oooo00<000000?ooo`3oool0?`3oool00`000000oooo0?oo
o`0^0?ooo`00;`3oool00`000000oooo0?ooo`100?ooo`800000=`3oool200000480oooo00<00000
0?ooo`3oool0;P3oool002l0oooo00<000000?ooo`3oool0@P3oool00`000000oooo0?ooo`0c0?oo
o`030000003oool0oooo0440oooo00<000000?ooo`3oool0;`3oool00300oooo00<000000?ooo`3o
ool0@P3oool200000340oooo0P0000140?ooo`030000003oool0oooo02l0oooo000`0?ooo`030000
003oool0oooo04@0oooo00<000000?ooo`3oool0;@3oool00`000000oooo0?ooo`130?ooo`030000
003oool0oooo0300oooo000a0?ooo`030000003oool0oooo04@0oooo0P00000[0?ooo`800000AP3o
ool00`000000oooo0?ooo`0`0?ooo`00<@3oool00`000000oooo0?ooo`160?ooo`030000003oool0
oooo02L0oooo00<000000?ooo`3oool0A@3oool00`000000oooo0?ooo`0a0?ooo`00<P3oool00`00
0000oooo0?ooo`160?ooo`8000009@3oool2000004P0oooo00<000000?ooo`3oool0<@3oool00380
oooo00<000000?ooo`3oool0B03oool00`000000oooo0?ooo`0Q0?ooo`030000003oool0oooo04L0
oooo00<000000?ooo`3oool0<P3oool003<0oooo00<000000?ooo`3oool0B03oool2000001l0oooo
0P00001:0?ooo`030000003oool0oooo0380oooo000c0?ooo`030000003oool0oooo04X0oooo00<0
00000?ooo`3oool06`3oool00`000000oooo0?ooo`190?ooo`030000003oool0oooo03<0oooo000d
0?ooo`030000003oool0oooo04X0oooo0P00000I0?ooo`800000C03oool00`000000oooo0?ooo`0c
0?ooo`00=03oool00`000000oooo0?ooo`1<0?ooo`030000003oool0oooo01D0oooo00<000000?oo
o`3oool0B`3oool00`000000oooo0?ooo`0d0?ooo`00=@3oool00`000000oooo0?ooo`1<0?ooo`80
00004`3oool2000004h0oooo00<000000?ooo`3oool0=03oool003D0oooo00<000000?ooo`3oool0
CP3oool00`000000oooo0?ooo`0?0?ooo`030000003oool0oooo04d0oooo00<000000?ooo`3oool0
=@3oool003H0oooo00<000000?ooo`3oool0CP3oool2000000d0oooo0P00001@0?ooo`030000003o
ool0oooo03D0oooo000f0?ooo`030000003oool0oooo0500oooo00<000000?ooo`3oool02@3oool0
0`000000oooo0?ooo`1?0?ooo`030000003oool0oooo03H0oooo000g0?ooo`030000003oool0oooo
0500oooo0P0000070?ooo`800000DP3oool00`000000oooo0?ooo`0f0?ooo`00=`3oool00`000000
oooo0?ooo`1B0?ooo`030000003oool000000080000000<0oooo0000003oool0DP3oool00`000000
oooo0?ooo`0g0?ooo`00>03oool00`000000oooo0?ooo`1B0?ooo`D00000E03oool00`000000oooo
0?ooo`0g0?ooo`00>03oool00`000000oooo0?ooo`1B0?ooo`D00000D`3oool00`000000oooo0?oo
o`0h0?ooo`00>@3oool00`000000oooo0?ooo`1A0?ooo`D00000D`3oool00`000000oooo0?ooo`0h
0?ooo`00>@3oool00`000000oooo0?ooo`1B0?ooo`<00000D`3oool00`000000oooo0?ooo`0i0?oo
o`00>P3oool00`000000oooo0?ooo`1B0?ooo`030000003oool0oooo0580oooo00<000000?ooo`3o
ool0>@3oool003X0oooo00<000000?ooo`3oool0DP3oool00`000000oooo0?ooo`1A0?ooo`030000
003oool0oooo03X0oooo000k0?ooo`030000003oool0oooo0540oooo00<000000?ooo`3oool0D@3o
ool00`000000oooo0?ooo`0j0?ooo`00>`3oool00`000000oooo0?ooo`1A0?ooo`030000003oool0
oooo0500oooo00<000000?ooo`3oool0>`3oool003`0oooo00<000000?ooo`3oool0D03oool00`00
0000oooo0?ooo`1@0?ooo`030000003oool0oooo03/0oooo000l0?ooo`030000003oool0oooo0500
oooo00<000000?ooo`3oool0C`3oool00`000000oooo0?ooo`0l0?ooo`00?@3oool00`000000oooo
0?ooo`1?0?ooo`030000003oool0oooo04l0oooo00<000000?ooo`3oool0?03oool003d0oooo00<0
00000?ooo`3oool0C`3oool00`000000oooo0?ooo`1>0?ooo`030000003oool0oooo03d0oooo000n
0?ooo`030000003oool0oooo04h0oooo00<000000?ooo`3oool0CP3oool00`000000oooo0?ooo`0m
0?ooo`00?P3oool00`000000oooo0?ooo`1>0?ooo`030000003oool0oooo04d0oooo00<000000?oo
o`3oool0?P3oool003l0oooo00<000000?ooo`3oool0C@3oool00`000000oooo0?ooo`1=0?ooo`03
0000003oool0oooo03h0oooo000o0?ooo`030000003oool0oooo04d0oooo00<000000?ooo`3oool0
C03oool00`000000oooo0?ooo`0o0?ooo`00@03oool00`000000oooo0?ooo`1<0?ooo`030000003o
ool0oooo04`0oooo00<000000?ooo`3oool0?`3oool00400oooo00<000000?ooo`3oool0C03oool0
0`000000oooo0?ooo`1;0?ooo`030000003oool0oooo0400oooo00110?ooo`030000003oool0oooo
04/0oooo00<000000?ooo`3oool0B`3oool00`000000oooo0?ooo`100?ooo`00@@3oool00`000000
oooo0?ooo`1;0?ooo`030000003oool0oooo04X0oooo00<000000?ooo`3oool0@@3oool00480oooo
00<000000?ooo`3oool0BP3oool00`000000oooo0?ooo`1:0?ooo`030000003oool0oooo0440oooo
00120?ooo`030000003oool0oooo04X0oooo00<000000?ooo`3oool0B@3oool00`000000oooo0?oo
o`120?ooo`00@`3oool00`000000oooo0?ooo`190?ooo`030000003oool0oooo04T0oooo00<00000
0?ooo`3oool0@P3oool004<0oooo00<000000?ooo`3oool0B@3oool00`000000oooo0?ooo`180?oo
o`030000003oool0oooo04<0oooo00140?ooo`030000003oool0oooo04P0oooo00<000000?ooo`3o
ool0B03oool00`000000oooo0?ooo`130?ooo`00A03oool00`000000oooo0?ooo`180?ooo`030000
003oool0oooo04L0oooo00<000000?ooo`3oool0A03oool004D0oooo00<000000?ooo`3oool0A`3o
ool00`000000oooo0?ooo`170?ooo`030000003oool0oooo04@0oooo00150?ooo`030000003oool0
oooo04L0oooo00<000000?ooo`3oool0AP3oool00`000000oooo0?ooo`150?ooo`00AP3oool00`00
0000oooo0?ooo`160?ooo`030000003oool0oooo04H0oooo00<000000?ooo`3oool0A@3oool004H0
oooo00<000000?ooo`3oool0AP3oool00`000000oooo0?ooo`150?ooo`030000003oool0oooo04H0
oooo00170?ooo`030000003oool0oooo04D0oooo00<000000?ooo`3oool0A@3oool00`000000oooo
0?ooo`160?ooo`00A`3oool00`000000oooo0?ooo`150?ooo`030000003oool0oooo04@0oooo00<0
00000?ooo`3oool0A`3oool004P0oooo00<000000?ooo`3oool0A03oool00`000000oooo0?ooo`14
0?ooo`030000003oool0oooo04L0oooo00180?ooo`030000003oool0oooo04@0oooo00<000000?oo
o`3oool0@`3oool00`000000oooo0?ooo`180?ooo`00B@3oool00`000000oooo0?ooo`130?ooo`03
0000003oool0oooo04<0oooo00<000000?ooo`3oool0B03oool004T0oooo00<000000?ooo`3oool0
@`3oool00`000000oooo0?ooo`120?ooo`030000003oool0oooo04T0oooo001:0?ooo`030000003o
ool0oooo0480oooo00<000000?ooo`3oool0@P3oool00`000000oooo0?ooo`190?ooo`00BP3oool0
0`000000oooo0?ooo`120?ooo`030000003oool0oooo0440oooo00<000000?ooo`3oool0BP3oool0
04/0oooo00<000000?ooo`3oool0@@3oool00`000000oooo0?ooo`110?ooo`030000003oool0oooo
04X0oooo001;0?ooo`030000003oool0oooo0440oooo00<000000?ooo`3oool0@03oool00`000000
oooo0?ooo`1;0?ooo`00C03oool00`000000oooo0?ooo`100?ooo`030000003oool0oooo0400oooo
00<000000?ooo`3oool0B`3oool004`0oooo00<000000?ooo`3oool0@03oool00`000000oooo0?oo
o`0o0?ooo`030000003oool0oooo04`0oooo001=0?ooo`030000003oool0oooo03l0oooo00<00000
0?ooo`3oool0?`3oool00`000000oooo0?ooo`1<0?ooo`00C@3oool00`000000oooo0?ooo`0o0?oo
o`030000003oool0oooo03h0oooo00<000000?ooo`3oool0C@3oool004h0oooo00<000000?ooo`3o
ool0?P3oool00`000000oooo0?ooo`0n0?ooo`030000003oool0oooo04d0oooo001>0?ooo`030000
003oool0oooo03h0oooo00<000000?ooo`3oool0?@3oool00`000000oooo0?ooo`1>0?ooo`00C`3o
ool00`000000oooo0?ooo`0m0?ooo`030000003oool0oooo03d0oooo00<000000?ooo`3oool0CP3o
ool004l0oooo00<000000?ooo`3oool0?@3oool00`000000oooo0?ooo`0l0?ooo`030000003oool0
oooo04l0oooo001@0?ooo`030000003oool0oooo03`0oooo00<000000?ooo`3oool0?03oool00`00
0000oooo0?ooo`1?0?ooo`00D03oool00`000000oooo0?ooo`0l0?ooo`030000003oool0oooo03/0
oooo00<000000?ooo`3oool0D03oool00540oooo00<000000?ooo`3oool0>`3oool00`000000oooo
0?ooo`0k0?ooo`030000003oool0oooo0500oooo001A0?ooo`030000003oool0oooo03/0oooo00<0
00000?ooo`3oool0>P3oool00`000000oooo0?ooo`1A0?ooo`00DP3oool00`000000oooo0?ooo`0j
0?ooo`030000003oool0oooo03X0oooo00<000000?ooo`3oool0D@3oool00580oooo00<000000?oo
o`3oool0>P3oool00`000000oooo0?ooo`0i0?ooo`030000003oool0oooo0580oooo001C0?ooo`03
0000003oool0oooo03T0oooo00<000000?ooo`3oool0>@3oool00`000000oooo0?ooo`1B0?ooo`00
D`3oool00`000000oooo0?ooo`0i0?ooo`030000003oool0oooo03P0oooo00<000000?ooo`3oool0
D`3oool005@0oooo00<000000?ooo`3oool0>03oool00`000000oooo0?ooo`0h0?ooo`030000003o
ool0oooo05<0oooo001D0?ooo`030000003oool0oooo03P0oooo00<000000?ooo`3oool0=`3oool0
0`000000oooo0?ooo`1D0?ooo`00E@3oool00`000000oooo0?ooo`0g0?ooo`030000003oool0oooo
03L0oooo00<000000?ooo`3oool0E03oool005D0oooo00<000000?ooo`3oool0=`3oool00`000000
oooo0?ooo`0f0?ooo`030000003oool0oooo05D0oooo001F0?ooo`030000003oool0oooo03H0oooo
00<000000?ooo`3oool0=P3oool00`000000oooo0?ooo`1E0?ooo`00EP3oool00`000000oooo0?oo
o`0f0?ooo`030000003oool0oooo03D0oooo00<000000?ooo`3oool0EP3oool005L0oooo00<00000
0?ooo`3oool0=@3oool00`000000oooo0?ooo`0e0?ooo`030000003oool0oooo05H0oooo001G0?oo
o`030000003oool0oooo03D0oooo00<000000?ooo`3oool0=03oool00`000000oooo0?ooo`1G0?oo
o`00F03oool00`000000oooo0?ooo`0d0?ooo`030000003oool0oooo03@0oooo00<000000?ooo`3o
ool0E`3oool005P0oooo00<000000?ooo`3oool0=03oool00`000000oooo0?ooo`0c0?ooo`030000
003oool0oooo05P0oooo001I0?ooo`030000003oool0oooo03<0oooo00<000000?ooo`3oool0<`3o
ool00`000000oooo0?ooo`1H0?ooo`00F@3oool00`000000oooo0?ooo`0c0?ooo`030000003oool0
oooo0380oooo00<000000?ooo`3oool0F@3oool005X0oooo00<000000?ooo`3oool0<P3oool00`00
0000oooo0?ooo`0b0?ooo`030000003oool0oooo05T0oooo001J0?ooo`030000003oool0oooo0380
oooo00<000000?ooo`3oool0<@3oool00`000000oooo0?ooo`1J0?ooo`00F`3oool00`000000oooo
0?ooo`0a0?ooo`030000003oool0oooo0340oooo00<000000?ooo`3oool0FP3oool005/0oooo00<0
00000?ooo`3oool0<@3oool00`000000oooo0?ooo`0`0?ooo`030000003oool0oooo05/0oooo001L
0?ooo`030000003oool0oooo0300oooo00<000000?ooo`3oool0<03oool00`000000oooo0?ooo`1K
0?ooo`00G03oool00`000000oooo0?ooo`0`0?ooo`030000003oool0oooo02l0oooo00<000000?oo
o`3oool0G03oool005d0oooo00<000000?ooo`3oool0;`3oool00`000000oooo0?ooo`0_0?ooo`03
0000003oool0oooo05`0oooo001M0?ooo`030000003oool0oooo02l0oooo00<000000?ooo`3oool0
;P3oool00`000000oooo0?ooo`1M0?ooo`00GP3oool00`000000oooo0?ooo`0^0?ooo`030000003o
ool0oooo02h0oooo00<000000?ooo`3oool0G@3oool005h0oooo00<000000?ooo`3oool0;P3oool0
0`000000oooo0?ooo`0]0?ooo`030000003oool0oooo05h0oooo001O0?ooo`030000003oool0oooo
02d0oooo00<000000?ooo`3oool0;@3oool00`000000oooo0?ooo`1N0?ooo`00G`3oool00`000000
oooo0?ooo`0]0?ooo`030000003oool0oooo02`0oooo00<000000?ooo`3oool0G`3oool00600oooo
00<000000?ooo`3oool0;03oool00`000000oooo0?ooo`0/0?ooo`030000003oool0oooo05l0oooo
001P0?ooo`030000003oool0oooo02`0oooo00<000000?ooo`3oool0:`3oool00`000000oooo0?oo
o`1P0?ooo`00H@3oool00`000000oooo0?ooo`0[0?ooo`030000003oool0oooo02/0oooo00<00000
0?ooo`3oool0H03oool00640oooo00<000000?ooo`3oool0:`3oool00`000000oooo0?ooo`0Z0?oo
o`030000003oool0oooo0640oooo001R0?ooo`030000003oool0oooo02X0oooo00<000000?ooo`3o
ool0:P3oool00`000000oooo0?ooo`1Q0?ooo`00HP3oool00`000000oooo0?ooo`0Z0?ooo`030000
003oool0oooo02T0oooo00<000000?ooo`3oool0HP3oool006<0oooo00<000000?ooo`3oool0:@3o
ool00`000000oooo0?ooo`0Y0?ooo`030000003oool0oooo0680oooo001S0?ooo`030000003oool0
oooo02T0oooo00<000000?ooo`3oool0:03oool00`000000oooo0?ooo`1S0?ooo`00I03oool00`00
0000oooo0?ooo`0X0?ooo`030000003oool0oooo02P0oooo00<000000?ooo`3oool0H`3oool006@0
oooo00<000000?ooo`3oool0:03oool00`000000oooo0?ooo`0W0?ooo`030000003oool0oooo06@0
oooo001U0?ooo`030000003oool0oooo02L0oooo00<000000?ooo`3oool09`3oool00`000000oooo
0?ooo`1T0?ooo`00I@3oool00`000000oooo0?ooo`0W0?ooo`030000003oool0oooo02H0oooo00<0
00000?ooo`3oool0I@3oool006H0oooo00<000000?ooo`3oool09P3oool00`000000oooo0?ooo`0V
0?ooo`030000003oool0oooo06D0oooo001V0?ooo`030000003oool0oooo02H0oooo00<000000?oo
o`3oool09@3oool00`000000oooo0?ooo`1V0?ooo`00I`3oool00`000000oooo0?ooo`0U0?ooo`03
0000003oool0oooo02D0oooo00<000000?ooo`3oool0IP3oool006L0oooo00<000000?ooo`3oool0
9@3oool00`000000oooo0?ooo`0T0?ooo`030000003oool0oooo06L0oooo001X0?ooo`030000003o
ool0oooo02@0oooo00<000000?ooo`3oool0903oool00`000000oooo0?ooo`1W0?ooo`00J03oool0
0`000000oooo0?ooo`0T0?ooo`030000003oool0oooo02<0oooo00<000000?ooo`3oool0J03oool0
06T0oooo00<000000?ooo`3oool08`3oool00`000000oooo0?ooo`0S0?ooo`030000003oool0oooo
06P0oooo001Y0?ooo`030000003oool0oooo02<0oooo00<000000?ooo`3oool08P3oool00`000000
oooo0?ooo`1Y0?ooo`00JP3oool00`000000oooo0?ooo`0R0?ooo`030000003oool0oooo0280oooo
00<000000?ooo`3oool0J@3oool006X0oooo00<000000?ooo`3oool08P3oool00`000000oooo0?oo
o`0Q0?ooo`030000003oool0oooo06X0oooo001[0?ooo`030000003oool0oooo0240oooo00<00000
0?ooo`3oool08@3oool00`000000oooo0?ooo`1Z0?ooo`00J`3oool00`000000oooo0?ooo`0Q0?oo
o`030000003oool0oooo0200oooo00<000000?ooo`3oool0J`3oool006`0oooo00<000000?ooo`3o
ool0803oool00`000000oooo0?ooo`0P0?ooo`030000003oool0oooo06/0oooo001/0?ooo`030000
003oool0oooo0200oooo00<000000?ooo`3oool07`3oool00`000000oooo0?ooo`1/0?ooo`00K@3o
ool00`000000oooo0?ooo`0O0?ooo`030000003oool0oooo01l0oooo00<000000?ooo`3oool0K03o
ool006d0oooo00<000000?ooo`3oool07`3oool00`000000oooo0?ooo`0N0?ooo`030000003oool0
oooo06d0oooo001^0?ooo`030000003oool0oooo01h0oooo00<000000?ooo`3oool07P3oool00`00
0000oooo0?ooo`1]0?ooo`00KP3oool00`000000oooo0?ooo`0N0?ooo`030000003oool0oooo01d0
oooo00<000000?ooo`3oool0KP3oool006l0oooo00<000000?ooo`3oool07@3oool00`000000oooo
0?ooo`0M0?ooo`030000003oool0oooo06h0oooo001_0?ooo`030000003oool0oooo01d0oooo00<0
00000?ooo`3oool0703oool00`000000oooo0?ooo`1_0?ooo`00L03oool00`000000oooo0?ooo`0L
0?ooo`030000003oool0oooo01`0oooo00<000000?ooo`3oool0K`3oool00700oooo00<000000?oo
o`3oool0703oool00`000000oooo0?ooo`0K0?ooo`030000003oool0oooo0700oooo001a0?ooo`03
0000003oool0oooo01/0oooo00<000000?ooo`3oool06`3oool00`000000oooo0?ooo`1`0?ooo`00
L@3oool00`000000oooo0?ooo`0K0?ooo`030000003oool0oooo01X0oooo00<000000?ooo`3oool0
L@3oool00780oooo00<000000?ooo`3oool06P3oool00`000000oooo0?ooo`0J0?ooo`030000003o
ool0oooo0740oooo001b0?ooo`030000003oool0oooo01X0oooo00<000000?ooo`3oool06@3oool0
0`000000oooo0?ooo`1b0?ooo`00L`3oool00`000000oooo0?ooo`0I0?ooo`030000003oool0oooo
01T0oooo00<000000?ooo`3oool0LP3oool007<0oooo00<000000?ooo`3oool06@3oool00`000000
oooo0?ooo`0H0?ooo`030000003oool0oooo07<0oooo001d0?ooo`030000003oool0oooo01P0oooo
00<000000?ooo`3oool0603oool00`000000oooo0?ooo`1c0?ooo`00M03oool00`000000oooo0?oo
o`0H0?ooo`030000003oool0oooo01L0oooo00<000000?ooo`3oool0M03oool007D0oooo00<00000
0?ooo`3oool05`3oool00`000000oooo0?ooo`0G0?ooo`030000003oool0oooo07@0oooo001e0?oo
o`030000003oool0oooo01L0oooo00<000000?ooo`3oool05P3oool00`000000oooo0?ooo`1e0?oo
o`00MP3oool00`000000oooo0?ooo`0F0?ooo`030000003oool0oooo01H0oooo00<000000?ooo`3o
ool0M@3oool007H0oooo00<000000?ooo`3oool05P3oool00`000000oooo0?ooo`0E0?ooo`030000
003oool0oooo07H0oooo001g0?ooo`030000003oool0oooo01D0oooo00<000000?ooo`3oool05@3o
ool00`000000oooo0?ooo`1f0?ooo`00M`3oool00`000000oooo0?ooo`0E0?ooo`030000003oool0
oooo01@0oooo00<000000?ooo`3oool0M`3oool007P0oooo00<000000?ooo`3oool0503oool00`00
0000oooo0?ooo`0D0?ooo`030000003oool0oooo07L0oooo001h0?ooo`030000003oool0oooo01@0
oooo00<000000?ooo`3oool04`3oool00`000000oooo0?ooo`1h0?ooo`00N@3oool00`000000oooo
0?ooo`0C0?ooo`030000003oool0oooo01<0oooo00<000000?ooo`3oool0N03oool007T0oooo00<0
00000?ooo`3oool04`3oool00`000000oooo0?ooo`0B0?ooo`030000003oool0oooo07T0oooo001j
0?ooo`030000003oool0oooo0180oooo00<000000?ooo`3oool04P3oool00`000000oooo0?ooo`1i
0?ooo`00NP3oool00`000000oooo0?ooo`0B0?ooo`030000003oool0oooo0140oooo00<000000?oo
o`3oool0NP3oool007/0oooo00<000000?ooo`3oool04@3oool00`000000oooo0?ooo`0A0?ooo`03
0000003oool0oooo07X0oooo001k0?ooo`030000003oool0oooo0140oooo00<000000?ooo`3oool0
403oool00`000000oooo0?ooo`1k0?ooo`00O03oool00`000000oooo0?ooo`0@0?ooo`030000003o
ool0oooo0100oooo00<000000?ooo`3oool0N`3oool007`0oooo00<000000?ooo`3oool0403oool0
0`000000oooo0?ooo`0?0?ooo`030000003oool0oooo07`0oooo001m0?ooo`030000003oool0oooo
00l0oooo00<000000?ooo`3oool03`3oool00`000000oooo0?ooo`1l0?ooo`00O@3oool00`000000
oooo0?ooo`0?0?ooo`030000003oool0oooo00h0oooo00<000000?ooo`3oool0O@3oool007h0oooo
00<000000?ooo`3oool03P3oool00`000000oooo0?ooo`0>0?ooo`030000003oool0oooo07d0oooo
001n0?ooo`030000003oool0oooo00h0oooo00<000000?ooo`3oool03@3oool00`000000oooo0?oo
o`1n0?ooo`00O`3oool00`000000oooo0?ooo`0=0?ooo`030000003oool0oooo00d0oooo00<00000
0?ooo`3oool0OP3oool007l0oooo00<000000?ooo`3oool03@3oool00`000000oooo0?ooo`0<0?oo
o`030000003oool0oooo07l0oooo00200?ooo`030000003oool0oooo00`0oooo00<000000?ooo`3o
ool0303oool00`000000oooo0?ooo`1o0?ooo`00P03oool00`000000oooo0?ooo`0<0?ooo`030000
003oool0oooo00/0oooo00<000000?ooo`3oool0P03oool00840oooo00<000000?ooo`3oool02`3o
ool00`000000oooo0?ooo`0;0?ooo`030000003oool0oooo0800oooo00210?ooo`030000003oool0
oooo00/0oooo00<000000?ooo`3oool02P3oool00`000000oooo0?ooo`210?ooo`00PP3oool00`00
0000oooo0?ooo`0:0?ooo`030000003oool0oooo00X0oooo00<000000?ooo`3oool0P@3oool00880
oooo00<000000?ooo`3oool02P3oool00`000000oooo0?ooo`090?ooo`030000003oool0oooo0880
oooo00230?ooo`030000003oool0oooo00T0oooo00<000000?ooo`3oool02@3oool00`000000oooo
0?ooo`220?ooo`00P`3oool00`000000oooo0?ooo`090?ooo`030000003oool0oooo00P0oooo00<0
00000?ooo`3oool0P`3oool008@0oooo00<000000?ooo`3oool0203oool00`000000oooo0?ooo`08
0?ooo`030000003oool0oooo08<0oooo00240?ooo`030000003oool0oooo00P0oooo00<000000?oo
o`3oool01`3oool00`000000oooo0?ooo`240?ooo`00Q@3oool00`000000oooo0?ooo`070?ooo`03
0000003oool0oooo00L0oooo00<000000?ooo`3oool0Q03oool008D0oooo00<000000?ooo`3oool0
1`3oool00`000000oooo0?ooo`060?ooo`030000003oool0oooo08D0oooo00260?ooo`030000003o
ool0oooo00H0oooo00<000000?ooo`3oool01P3oool00`000000oooo0?ooo`250?ooo`00QP3oool0
0`000000oooo0?ooo`060?ooo`030000003oool0oooo00D0oooo00<000000?ooo`3oool0QP3oool0
08L0oooo00<000000?ooo`3oool01@3oool00`000000oooo0?ooo`050?ooo`030000003oool0oooo
08H0oooo00270?ooo`030000003oool0oooo00D0oooo00<000000?ooo`3oool0103oool00`000000
oooo0?ooo`270?ooo`00R03oool00`000000oooo0?ooo`040?ooo`030000003oool0oooo00@0oooo
00<000000?ooo`3oool0Q`3oool008P0oooo00<000000?ooo`3oool0103oool00`000000oooo0?oo
o`030?ooo`030000003oool0oooo08P0oooo00290?ooo`030000003oool0oooo00<0oooo00<00000
0?ooo`3oool00`3oool00`000000oooo0?ooo`280?ooo`00R@3oool00`000000oooo0?ooo`030?oo
o`030000003oool0oooo0080oooo00<000000?ooo`3oool0R@3oool008X0oooo00<000000?ooo`3o
ool00P3oool00`000000oooo0?ooo`020?ooo`030000003oool0oooo08T0oooo002:0?ooo`030000
003oool0oooo0080oooo00D000000?ooo`3oool0oooo0000002<0?ooo`00R`3oool01@000000oooo
0?ooo`3oool0000000<0oooo00<000000?ooo`3oool0RP3oool008/0oooo00D000000?ooo`3oool0
oooo000000020?ooo`030000003oool0oooo08/0oooo002<0?ooo`040000003oool0oooo00000080
oooo00<000000?ooo`3oool0R`3oool008`0oooo00H000000?ooo`3oool000000?ooo`00002>0?oo
o`00S@3oool01@000000oooo0000003oool0000008h0oooo002=0?ooo`040000003oool000000000
08l0oooo002>0?ooo`<00000S`3oool008h0oooo0`00002?0?ooo`00S@3oool5000008h0oooo002=
0?ooo`D00000SP3oool008d0oooo1@00002>0?ooo`00SP3oool3000008l0oooo003o0?ooob40oooo
003o0?ooob40oooo003o0?ooob40oooo003o0?ooob40oooo003o0?ooob40oooo003o0?ooob40oooo
003o0?ooob40oooo003o0?ooob40oooo003o0?ooob40oooo003o0?ooob40oooo0000\
\>"],
  ImageRangeCache->{{{0, 287}, {287, 0}} -> {-0.952637, -0.575008, \
0.00663859, 0.00574918}}],

Cell[BoxData[
    TagBox[\(\[SkeletonIndicator]  Graphics  \[SkeletonIndicator]\),
      False,
      Editable->False]], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    \(draw[mm, \ F\  . \ P0]\)], "Input"],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: 1 
MathPictureStart
/Mabs {
Mgmatrix idtransform
Mtmatrix dtransform
} bind def
/Mabsadd { Mabs
3 -1 roll add
3 1 roll add
exch } bind def
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
0.5 0.524864 0.348485 0.606061 [
[ 0 0 0 0 ]
[ 1 1 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 0 m
1 0 L
1 1 L
0 1 L
closepath
clip
newpath
0 g
.02 w
.5 .95455 Mdot
.95455 .04545 Mdot
.04545 .04545 Mdot
.5 .5 Mdot
.61364 .27273 Mdot
.38636 .27273 Mdot
.5 .34848 Mdot
.5 .34848 Mdot
.5 Mabswid
[ ] 0 setdash
.5 .95455 m
.95455 .04545 L
s
.5 .95455 m
.04545 .04545 L
s
.5 .95455 m
.5 .5 L
s
.95455 .04545 m
.5 .95455 L
s
.95455 .04545 m
.04545 .04545 L
s
.95455 .04545 m
.61364 .27273 L
s
.04545 .04545 m
.5 .95455 L
s
.04545 .04545 m
.95455 .04545 L
s
.04545 .04545 m
.38636 .27273 L
s
.5 .5 m
.5 .95455 L
s
.5 .5 m
.61364 .27273 L
s
.5 .5 m
.38636 .27273 L
s
.5 .5 m
.5 .34848 L
s
.61364 .27273 m
.95455 .04545 L
s
.61364 .27273 m
.5 .5 L
s
.61364 .27273 m
.38636 .27273 L
s
.61364 .27273 m
.5 .34848 L
s
.38636 .27273 m
.04545 .04545 L
s
.38636 .27273 m
.5 .5 L
s
.38636 .27273 m
.61364 .27273 L
s
.38636 .27273 m
.5 .34848 L
s
.5 .34848 m
.61364 .27273 L
s
.5 .34848 m
.38636 .27273 L
s
.5 .34848 m
.5 .34848 L
s
.5 .34848 m
.5 .5 L
s
.5 .34848 m
.5 .34848 L
s
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  ImageSize->{288, 288},
  ImageMargins->{{43, 0}, {0, 0}},
  ImageRegion->{{0, 1}, {0, 1}},
  ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`40004P000182000`400?l00000o`00003oo`3ooolQ
0?ooo`00o`3ooolQ0?ooo`00o`3ooolQ0?ooo`00o`3ooolQ0?ooo`00o`3ooolQ0?ooo`00o`3ooolQ
0?ooo`00o`3ooolQ0?ooo`00o`3ooolQ0?ooo`00o`3ooolQ0?ooo`00o`3ooolQ0?ooo`00o`3ooolQ
0?ooo`00o`3ooolQ0?ooo`002`3oool300000?l0oooo0`3oool3000000d0oooo000:0?ooo`D00000
o`3oool10?ooo`D00000303oool000X0ooooo`00000;000000`0oooo000:0?ooo`H00000o`3oool5
000000`0oooo000;0?ooo`@0000000<0oooo0000003oool0o03oool00`000000oooo000000020000
00d0oooo000>0?ooo`030000003oool0oooo00800000n@3oool2000000030?ooo`000000oooo00l0
oooo000?0?ooo`050000003oool0oooo0?ooo`000000m`3oool01@000000oooo0?ooo`3oool00000
0100oooo000?0?ooo`030000003oool0oooo0080oooo0P00003c0?ooo`8000000`3oool00`000000
oooo0?ooo`0?0?ooo`00403oool00`000000oooo0?ooo`030?ooo`030000003oool0oooo0>l0oooo
00<000000?ooo`3oool00`3oool00`000000oooo0?ooo`0?0?ooo`00403oool00`000000oooo0?oo
o`040?ooo`800000k@3oool2000000D0oooo00<000000?ooo`3oool0403oool00140oooo00<00000
0?ooo`3oool01@3oool00`000000oooo0?ooo`3Y0?ooo`030000003oool0oooo00D0oooo00<00000
0?ooo`3oool0403oool00140oooo00<000000?ooo`3oool01P3oool200000>L0oooo0P0000070?oo
o`030000003oool0oooo0140oooo000B0?ooo`030000003oool0oooo00L0oooo00<000000?ooo`3o
ool0h`3oool00`000000oooo0?ooo`070?ooo`030000003oool0oooo0140oooo000B0?ooo`030000
003oool0oooo00P0oooo0P00003Q0?ooo`8000002@3oool00`000000oooo0?ooo`0B0?ooo`004`3o
ool00`000000oooo0?ooo`090?ooo`030000003oool0oooo0=d0oooo00<000000?ooo`3oool02@3o
ool00`000000oooo0?ooo`0B0?ooo`004`3oool00`000000oooo0?ooo`0:0?ooo`800000f`3oool2
000000/0oooo00<000000?ooo`3oool04`3oool001@0oooo00<000000?ooo`3oool02`3oool00`00
0000oooo0?ooo`3G0?ooo`030000003oool0oooo00/0oooo00<000000?ooo`3oool04`3oool001@0
oooo00<000000?ooo`3oool0303oool200000=D0oooo0P00000=0?ooo`030000003oool0oooo01@0
oooo000E0?ooo`030000003oool0oooo00d0oooo00<000000?ooo`3oool0d@3oool00`000000oooo
0?ooo`0=0?ooo`030000003oool0oooo01@0oooo000E0?ooo`030000003oool0oooo00h0oooo0P00
003?0?ooo`8000003`3oool00`000000oooo0?ooo`0E0?ooo`005P3oool00`000000oooo0?ooo`0?
0?ooo`030000003oool0oooo0</0oooo00<000000?ooo`3oool03`3oool00`000000oooo0?ooo`0E
0?ooo`005P3oool00`000000oooo0?ooo`0@0?ooo`800000b@3oool200000140oooo00<000000?oo
o`3oool05P3oool001L0oooo00<000000?ooo`3oool04@3oool00`000000oooo0?ooo`350?ooo`03
0000003oool0oooo0140oooo00<000000?ooo`3oool05P3oool001L0oooo00<000000?ooo`3oool0
4P3oool200000<<0oooo0P00000C0?ooo`030000003oool0oooo01L0oooo000H0?ooo`030000003o
ool0oooo01<0oooo00<000000?ooo`3oool0_`3oool00`000000oooo0?ooo`0C0?ooo`030000003o
ool0oooo01L0oooo000H0?ooo`030000003oool0oooo01@0oooo0P00002m0?ooo`8000005@3oool0
0`000000oooo0?ooo`0H0?ooo`006@3oool00`000000oooo0?ooo`0E0?ooo`030000003oool0oooo
0;T0oooo00<000000?ooo`3oool05@3oool00`000000oooo0?ooo`0H0?ooo`006@3oool00`000000
oooo0?ooo`0F0?ooo`800000]`3oool2000001L0oooo00<000000?ooo`3oool06@3oool001X0oooo
00<000000?ooo`3oool05`3oool00`000000oooo0?ooo`2c0?ooo`030000003oool0oooo01L0oooo
00<000000?ooo`3oool06@3oool001X0oooo00<000000?ooo`3oool0603oool200000;40oooo0P00
000I0?ooo`030000003oool0oooo01X0oooo000K0?ooo`030000003oool0oooo01T0oooo00<00000
0?ooo`3oool0[@3oool00`000000oooo0?ooo`0I0?ooo`030000003oool0oooo01X0oooo000K0?oo
o`030000003oool0oooo01X0oooo0P00002[0?ooo`8000006`3oool00`000000oooo0?ooo`0K0?oo
o`00703oool00`000000oooo0?ooo`0K0?ooo`030000003oool0oooo0:L0oooo00<000000?ooo`3o
ool06`3oool00`000000oooo0?ooo`0K0?ooo`00703oool00`000000oooo0?ooo`0L0?ooo`800000
Y@3oool2000001d0oooo00<000000?ooo`3oool0703oool001d0oooo00<000000?ooo`3oool07@3o
ool00`000000oooo0?ooo`2Q0?ooo`030000003oool0oooo01d0oooo00<000000?ooo`3oool0703o
ool001d0oooo00<000000?ooo`3oool07P3oool00`000000oooo0?ooo`2O0?ooo`030000003oool0
oooo01d0oooo00<000000?ooo`3oool07@3oool001h0oooo00<000000?ooo`3oool07P3oool20000
09d0oooo0P00000P0?ooo`030000003oool0oooo01d0oooo000N0?ooo`030000003oool0oooo0200
oooo00<000000?ooo`3oool0V@3oool00`000000oooo0?ooo`0O0?ooo`030000003oool0oooo01h0
oooo000O0?ooo`030000003oool0oooo0200oooo0P00002G0?ooo`8000008P3oool00`000000oooo
0?ooo`0N0?ooo`007`3oool00`000000oooo0?ooo`0R0?ooo`030000003oool0oooo09<0oooo00<0
00000?ooo`3oool08@3oool00`000000oooo0?ooo`0O0?ooo`00803oool00`000000oooo0?ooo`0R
0?ooo`800000T@3oool2000002@0oooo00<000000?ooo`3oool07`3oool00200oooo00<000000?oo
o`3oool0903oool00`000000oooo0?ooo`2=0?ooo`030000003oool0oooo02<0oooo00<000000?oo
o`3oool0803oool00240oooo00<000000?ooo`3oool0903oool2000008/0oooo0P00000V0?ooo`03
0000003oool0oooo0200oooo000Q0?ooo`030000003oool0oooo02H0oooo00<000000?ooo`3oool0
Q`3oool00`000000oooo0?ooo`0U0?ooo`030000003oool0oooo0240oooo000R0?ooo`030000003o
ool0oooo02H0oooo0P0000250?ooo`800000:03oool00`000000oooo0?ooo`0Q0?ooo`008P3oool0
0`000000oooo0?ooo`0X0?ooo`030000003oool0oooo0840oooo00<000000?ooo`3oool09`3oool0
0`000000oooo0?ooo`0R0?ooo`008`3oool00`000000oooo0?ooo`0X0?ooo`800000O`3oool20000
02X0oooo00<000000?ooo`3oool08P3oool002<0oooo00<000000?ooo`3oool0:P3oool00`000000
oooo0?ooo`1k0?ooo`030000003oool0oooo02T0oooo00<000000?ooo`3oool08`3oool002@0oooo
00<000000?ooo`3oool0:P3oool2000007T0oooo0P00000/0?ooo`030000003oool0oooo02<0oooo
000T0?ooo`030000003oool0oooo02`0oooo00<000000?ooo`3oool0M@3oool00`000000oooo0?oo
o`0[0?ooo`030000003oool0oooo02@0oooo000U0?ooo`030000003oool0oooo02`0oooo0P00001c
0?ooo`800000;P3oool00`000000oooo0?ooo`0T0?ooo`009@3oool00`000000oooo0?ooo`0^0?oo
o`030000003oool0oooo06l0oooo00<000000?ooo`3oool0;@3oool00`000000oooo0?ooo`0U0?oo
o`009P3oool00`000000oooo0?ooo`0^0?ooo`800000K@3oool200000300oooo00<000000?ooo`3o
ool09@3oool002H0oooo00<000000?ooo`3oool0<03oool00`000000oooo0?ooo`1Y0?ooo`030000
003oool0oooo02l0oooo00<000000?ooo`3oool09P3oool002L0oooo00<000000?ooo`3oool0<03o
ool2000006L0oooo0P00000b0?ooo`030000003oool0oooo02H0oooo000W0?ooo`030000003oool0
oooo0380oooo00<000000?ooo`3oool0H`3oool00`000000oooo0?ooo`0a0?ooo`030000003oool0
oooo02L0oooo000X0?ooo`030000003oool0oooo0380oooo0P00001Q0?ooo`800000=03oool00`00
0000oooo0?ooo`0W0?ooo`00:03oool00`000000oooo0?ooo`0d0?ooo`030000003oool0oooo05d0
oooo00<000000?ooo`3oool0<`3oool00`000000oooo0?ooo`0X0?ooo`00:@3oool00`000000oooo
0?ooo`0d0?ooo`800000F`3oool2000003H0oooo00<000000?ooo`3oool0:03oool002T0oooo00<0
00000?ooo`3oool0=P3oool00`000000oooo0?ooo`1G0?ooo`030000003oool0oooo03D0oooo00<0
00000?ooo`3oool0:@3oool002X0oooo00<000000?ooo`3oool0=P3oool2000005D0oooo0P00000h
0?ooo`030000003oool0oooo02T0oooo000Z0?ooo`030000003oool0oooo03P0oooo00<000000?oo
o`3oool0D@3oool00`000000oooo0?ooo`0g0?ooo`030000003oool0oooo02X0oooo000[0?ooo`03
0000003oool0oooo03P0oooo0P00001?0?ooo`800000>P3oool00`000000oooo0?ooo`0Z0?ooo`00
:`3oool00`000000oooo0?ooo`0j0?ooo`030000003oool0oooo04/0oooo00<000000?ooo`3oool0
>@3oool00`000000oooo0?ooo`0[0?ooo`00;03oool00`000000oooo0?ooo`0j0?ooo`800000B@3o
ool2000003`0oooo00<000000?ooo`3oool0:`3oool002`0oooo00<000000?ooo`3oool0?03oool0
0`000000oooo00000002000003h0oooo0`0000020?ooo`030000003oool0oooo03/0oooo00<00000
0?ooo`3oool0;03oool002d0oooo00<000000?ooo`3oool0?03oool5000003`0oooo1P00000n0?oo
o`030000003oool0oooo02`0oooo000]0?ooo`030000003oool0oooo03`0ooooAP00000n0?ooo`03
0000003oool0oooo02d0oooo000^0?ooo`030000003oool0oooo03/0oooo1@00000l0?ooo`D00000
?P3oool00`000000oooo0?ooo`0]0?ooo`00;P3oool00`000000oooo0?ooo`0l0?ooo`<0000000<0
oooo0000003oool0>P3oool4000003h0oooo00<000000?ooo`3oool0;P3oool002l0oooo00<00000
0?ooo`3oool0?P3oool010000000oooo00000000000g0?ooo`80000000<0oooo0000003oool0?`3o
ool00`000000oooo0?ooo`0^0?ooo`00;`3oool00`000000oooo0?ooo`0n0?ooo`050000003oool0
oooo0?ooo`000000=@3oool01@000000oooo0?ooo`3oool0000003l0oooo00<000000?ooo`3oool0
;`3oool00300oooo00<000000?ooo`3oool0?P3oool010000000oooo0?ooo`3oool200000340oooo
0P0000030?ooo`030000003oool0oooo03h0oooo00<000000?ooo`3oool0;`3oool00300oooo00<0
00000?ooo`3oool0?P3oool00`000000oooo0?ooo`030?ooo`030000003oool0oooo02d0oooo00<0
00000?ooo`3oool00`3oool00`000000oooo0?ooo`0m0?ooo`030000003oool0oooo0300oooo000a
0?ooo`030000003oool0oooo03h0oooo00<000000?ooo`3oool00`3oool2000002/0oooo0P000005
0?ooo`030000003oool0oooo03h0oooo00<000000?ooo`3oool0<03oool00340oooo00<000000?oo
o`3oool0?P3oool00`000000oooo0?ooo`050?ooo`030000003oool0oooo02L0oooo00<000000?oo
o`3oool01@3oool00`000000oooo0?ooo`0m0?ooo`030000003oool0oooo0340oooo000b0?ooo`03
0000003oool0oooo03h0oooo00<000000?ooo`3oool01@3oool2000002D0oooo0P0000070?ooo`03
0000003oool0oooo03h0oooo00<000000?ooo`3oool0<@3oool00380oooo00<000000?ooo`3oool0
?P3oool00`000000oooo0?ooo`070?ooo`030000003oool0oooo0240oooo00<000000?ooo`3oool0
1`3oool00`000000oooo0?ooo`0m0?ooo`030000003oool0oooo0380oooo000c0?ooo`030000003o
ool0oooo03h0oooo00<000000?ooo`3oool01`3oool2000001l0oooo0P0000090?ooo`030000003o
ool0oooo03h0oooo00<000000?ooo`3oool0<P3oool003<0oooo00<000000?ooo`3oool0?P3oool0
0`000000oooo0?ooo`090?ooo`030000003oool0oooo01/0oooo00<000000?ooo`3oool02@3oool0
0`000000oooo0?ooo`0m0?ooo`030000003oool0oooo03<0oooo000d0?ooo`030000003oool0oooo
03h0oooo00<000000?ooo`3oool02@3oool2000001T0oooo0P00000;0?ooo`030000003oool0oooo
03h0oooo00<000000?ooo`3oool0<`3oool003@0oooo00<000000?ooo`3oool0?P3oool00`000000
oooo0?ooo`0;0?ooo`030000003oool0oooo01D0oooo00<000000?ooo`3oool02`3oool00`000000
oooo0?ooo`0m0?ooo`030000003oool0oooo03@0oooo000e0?ooo`030000003oool0oooo03h0oooo
00<000000?ooo`3oool02`3oool2000001<0oooo0P00000=0?ooo`030000003oool0oooo03h0oooo
00<000000?ooo`3oool0=03oool003D0oooo00<000000?ooo`3oool0?P3oool00`000000oooo0?oo
o`0=0?ooo`030000003oool0oooo00l0oooo00<000000?ooo`3oool03@3oool00`000000oooo0?oo
o`0m0?ooo`030000003oool0oooo03D0oooo000f0?ooo`030000003oool0oooo03h0oooo00<00000
0?ooo`3oool03@3oool2000000d0oooo0P00000?0?ooo`030000003oool0oooo03h0oooo00<00000
0?ooo`3oool0=@3oool003H0oooo00<000000?ooo`3oool0?P3oool00`000000oooo0?ooo`0?0?oo
o`030000003oool0oooo00T0oooo00<000000?ooo`3oool03`3oool00`000000oooo0?ooo`0m0?oo
o`030000003oool0oooo03H0oooo000g0?ooo`030000003oool0oooo03h0oooo00<000000?ooo`3o
ool03`3oool2000000L0oooo0P00000A0?ooo`030000003oool0oooo03h0oooo00<000000?ooo`3o
ool0=P3oool003L0oooo00<000000?ooo`3oool0?P3oool00`000000oooo0?ooo`0A0?ooo`030000
003oool000000080000000<0oooo0000003oool04P3oool00`000000oooo0?ooo`0m0?ooo`030000
003oool0oooo03L0oooo000h0?ooo`030000003oool0oooo03h0oooo00<000000?ooo`3oool04@3o
ool5000001<0oooo00<000000?ooo`3oool0?P3oool00`000000oooo0?ooo`0g0?ooo`00>03oool0
0`000000oooo0?ooo`0n0?ooo`030000003oool0oooo0140oooo1@00000C0?ooo`030000003oool0
oooo03d0oooo00<000000?ooo`3oool0>03oool003T0oooo00<000000?ooo`3oool0?P3oool00`00
0000oooo0?ooo`0@0?ooo`D000004P3oool00`000000oooo0?ooo`0n0?ooo`030000003oool0oooo
03P0oooo000i0?ooo`030000003oool0oooo03h0oooo00<000000?ooo`3oool04@3oool3000001<0
oooo00<000000?ooo`3oool0?@3oool00`000000oooo0?ooo`0i0?ooo`00>P3oool00`000000oooo
0?ooo`0n0?ooo`030000003oool0oooo0140oooo00<000000?ooo`3oool04@3oool00`000000oooo
0?ooo`0n0?ooo`030000003oool0oooo03T0oooo000j0?ooo`030000003oool0oooo03h0oooo00<0
00000?ooo`3oool04@3oool00`000000oooo0?ooo`0A0?ooo`030000003oool0oooo03d0oooo00<0
00000?ooo`3oool0>P3oool003/0oooo00<000000?ooo`3oool0?P3oool00`000000oooo0?ooo`0@
0?ooo`030000003oool0oooo0100oooo00<000000?ooo`3oool0?P3oool00`000000oooo0?ooo`0j
0?ooo`00>`3oool00`000000oooo0?ooo`0n0?ooo`030000003oool0oooo0100oooo00<000000?oo
o`3oool0403oool00`000000oooo0?ooo`0m0?ooo`030000003oool0oooo03/0oooo000l0?ooo`03
0000003oool0oooo03h0oooo00<000000?ooo`3oool03`3oool00`000000oooo0?ooo`0?0?ooo`03
0000003oool0oooo03h0oooo00<000000?ooo`3oool0>`3oool003`0oooo00<000000?ooo`3oool0
?P3oool00`000000oooo0?ooo`0?0?ooo`030000003oool0oooo00l0oooo00<000000?ooo`3oool0
?@3oool00`000000oooo0?ooo`0l0?ooo`00?@3oool00`000000oooo0?ooo`0n0?ooo`030000003o
ool0oooo00h0oooo00<000000?ooo`3oool03P3oool00`000000oooo0?ooo`0n0?ooo`030000003o
ool0oooo03`0oooo000m0?ooo`030000003oool0oooo03h0oooo00<000000?ooo`3oool03P3oool0
0`000000oooo0?ooo`0>0?ooo`030000003oool0oooo03d0oooo00<000000?ooo`3oool0?@3oool0
03h0oooo00<000000?ooo`3oool0?P3oool00`000000oooo0?ooo`0=0?ooo`030000003oool0oooo
00d0oooo00<000000?ooo`3oool0?P3oool00`000000oooo0?ooo`0m0?ooo`00?P3oool00`000000
oooo0?ooo`0n0?ooo`030000003oool0oooo00d0oooo00<000000?ooo`3oool03@3oool00`000000
oooo0?ooo`0m0?ooo`030000003oool0oooo03h0oooo000o0?ooo`030000003oool0oooo03h0oooo
00<000000?ooo`3oool0303oool00`000000oooo0?ooo`0<0?ooo`030000003oool0oooo03h0oooo
00<000000?ooo`3oool0?P3oool003l0oooo00<000000?ooo`3oool0?P3oool00`000000oooo0?oo
o`0<0?ooo`030000003oool0oooo00`0oooo00<000000?ooo`3oool0?@3oool00`000000oooo0?oo
o`0o0?ooo`00@03oool00`000000oooo0?ooo`0n0?ooo`030000003oool0oooo00/0oooo00<00000
0?ooo`3oool02`3oool00`000000oooo0?ooo`0n0?ooo`030000003oool0oooo03l0oooo00100?oo
o`030000003oool0oooo03h0oooo00<000000?ooo`3oool02`3oool00`000000oooo0?ooo`0;0?oo
o`030000003oool0oooo03d0oooo00<000000?ooo`3oool0@03oool00440oooo00<000000?ooo`3o
ool0?P3oool00`000000oooo0?ooo`0:0?ooo`030000003oool0oooo00X0oooo00<000000?ooo`3o
ool0?P3oool00`000000oooo0?ooo`100?ooo`00@@3oool00`000000oooo0?ooo`0n0?ooo`030000
003oool0oooo00X0oooo00<000000?ooo`3oool02P3oool00`000000oooo0?ooo`0m0?ooo`030000
003oool0oooo0440oooo00120?ooo`030000003oool0oooo03h0oooo00<000000?ooo`3oool02@3o
ool00`000000oooo0?ooo`090?ooo`030000003oool0oooo03h0oooo00<000000?ooo`3oool0@@3o
ool00480oooo00<000000?ooo`3oool0?P3oool00`000000oooo0?ooo`090?ooo`030000003oool0
oooo00T0oooo00<000000?ooo`3oool0?@3oool00`000000oooo0?ooo`120?ooo`00@`3oool00`00
0000oooo0?ooo`0n0?ooo`030000003oool0oooo00P0oooo00<000000?ooo`3oool0203oool00`00
0000oooo0?ooo`0n0?ooo`030000003oool0oooo0480oooo00130?ooo`030000003oool0oooo03h0
oooo00<000000?ooo`3oool0203oool00`000000oooo0?ooo`080?ooo`030000003oool0oooo03d0
oooo00<000000?ooo`3oool0@`3oool004@0oooo00<000000?ooo`3oool0?P3oool00`000000oooo
0?ooo`070?ooo`030000003oool0oooo00L0oooo00<000000?ooo`3oool0?P3oool00`000000oooo
0?ooo`130?ooo`00A03oool00`000000oooo0?ooo`0n0?ooo`030000003oool0oooo00L0oooo00<0
00000?ooo`3oool01`3oool00`000000oooo0?ooo`0m0?ooo`030000003oool0oooo04@0oooo0015
0?ooo`030000003oool0oooo03h0oooo00<000000?ooo`3oool01P3oool00`000000oooo0?ooo`06
0?ooo`030000003oool0oooo03h0oooo00<000000?ooo`3oool0A03oool004D0oooo00<000000?oo
o`3oool0?P3oool00`000000oooo0?ooo`060?ooo`030000003oool0oooo00H0oooo00<000000?oo
o`3oool0?@3oool00`000000oooo0?ooo`150?ooo`00AP3oool00`000000oooo0?ooo`0n0?ooo`03
0000003oool0oooo00D0oooo00<000000?ooo`3oool01@3oool00`000000oooo0?ooo`0n0?ooo`03
0000003oool0oooo04D0oooo00160?ooo`030000003oool0oooo03h0oooo00<000000?ooo`3oool0
1@3oool00`000000oooo0?ooo`050?ooo`030000003oool0oooo03d0oooo00<000000?ooo`3oool0
AP3oool004L0oooo00<000000?ooo`3oool0?P3oool00`000000oooo0?ooo`040?ooo`030000003o
ool0oooo00@0oooo00<000000?ooo`3oool0?P3oool00`000000oooo0?ooo`160?ooo`00A`3oool0
0`000000oooo0?ooo`0n0?ooo`030000003oool0oooo00@0oooo00<000000?ooo`3oool0103oool0
0`000000oooo0?ooo`0m0?ooo`030000003oool0oooo04L0oooo00180?ooo`030000003oool0oooo
03h0oooo00<000000?ooo`3oool00`3oool00`000000oooo0?ooo`030?ooo`030000003oool0oooo
03h0oooo00<000000?ooo`3oool0A`3oool004P0oooo00<000000?ooo`3oool0?P3oool00`000000
oooo0?ooo`030?ooo`030000003oool0oooo00<0oooo00<000000?ooo`3oool0?@3oool00`000000
oooo0?ooo`180?ooo`00B@3oool00`000000oooo0?ooo`0n0?ooo`030000003oool0oooo0080oooo
00<000000?ooo`3oool00P3oool00`000000oooo0?ooo`0n0?ooo`030000003oool0oooo04P0oooo
00190?ooo`030000003oool0oooo03h0oooo00<000000?ooo`3oool00P3oool00`000000oooo0?oo
o`020?ooo`030000003oool0oooo03d0oooo00<000000?ooo`3oool0B@3oool004X0oooo00<00000
0?ooo`3oool0?P3oool01@000000oooo0?ooo`3oool0000000<0oooo00<000000?ooo`3oool0?P3o
ool00`000000oooo0?ooo`190?ooo`00BP3oool00`000000oooo0?ooo`0n0?ooo`050000003oool0
oooo0?ooo`0000000`3oool00`000000oooo0?ooo`0m0?ooo`030000003oool0oooo04X0oooo001;
0?ooo`030000003oool0oooo03h0oooo00@000000?ooo`3oool000000P3oool00`000000oooo0?oo
o`0n0?ooo`030000003oool0oooo04X0oooo001;0?ooo`030000003oool0oooo03h0oooo00@00000
0?ooo`3oool000000P3oool00`000000oooo0?ooo`0m0?ooo`030000003oool0oooo04/0oooo001<
0?ooo`030000003oool0oooo03h0oooo00D000000?ooo`000000oooo000000100?ooo`030000003o
ool0oooo04/0oooo001<0?ooo`030000003oool0oooo03h0oooo00D000000?ooo`000000oooo0000
000o0?ooo`030000003oool0oooo04`0oooo001=0?ooo`030000003oool0oooo03h0oooo0`000010
0?ooo`030000003oool0oooo04`0oooo001=0?ooo`030000003oool0oooo03d0oooo1@00000n0?oo
o`030000003oool0oooo04d0oooo001>0?ooo`030000003oool0oooo03`0oooo1@00000n0?ooo`03
0000003oool0oooo04d0oooo001>0?ooo`030000003oool0oooo03`0oooo1@00000m0?ooo`030000
003oool0oooo04h0oooo001?0?ooo`030000003oool0oooo03`0oooo0`00000n0?ooo`030000003o
ool0oooo04h0oooo001?0?ooo`030000003oool0oooo03d0oooo00<000000?ooo`3oool0?03oool0
0`000000oooo0?ooo`1?0?ooo`00D03oool00`000000oooo0?ooo`0l0?ooo`030000003oool0oooo
03`0oooo00<000000?ooo`3oool0C`3oool00500oooo00<000000?ooo`3oool0?03oool00`000000
oooo0?ooo`0k0?ooo`030000003oool0oooo0500oooo001A0?ooo`030000003oool0oooo03/0oooo
00<000000?ooo`3oool0>`3oool00`000000oooo0?ooo`1@0?ooo`00D@3oool00`000000oooo0?oo
o`0k0?ooo`030000003oool0oooo03X0oooo00<000000?ooo`3oool0D@3oool00580oooo00<00000
0?ooo`3oool0>P3oool00`000000oooo0?ooo`0j0?ooo`030000003oool0oooo0540oooo001B0?oo
o`030000003oool0oooo03X0oooo00<000000?ooo`3oool0>@3oool00`000000oooo0?ooo`1B0?oo
o`00D`3oool00`000000oooo0?ooo`0i0?ooo`030000003oool0oooo03T0oooo00<000000?ooo`3o
ool0DP3oool005<0oooo00<000000?ooo`3oool0>@3oool00`000000oooo0?ooo`0h0?ooo`030000
003oool0oooo05<0oooo001D0?ooo`030000003oool0oooo03P0oooo00<000000?ooo`3oool0>03o
ool00`000000oooo0?ooo`1C0?ooo`00E03oool00`000000oooo0?ooo`0h0?ooo`030000003oool0
oooo03L0oooo00<000000?ooo`3oool0E03oool005D0oooo00<000000?ooo`3oool0=`3oool00`00
0000oooo0?ooo`0g0?ooo`030000003oool0oooo05@0oooo001E0?ooo`030000003oool0oooo03L0
oooo00<000000?ooo`3oool0=P3oool00`000000oooo0?ooo`1E0?ooo`00EP3oool00`000000oooo
0?ooo`0f0?ooo`030000003oool0oooo03H0oooo00<000000?ooo`3oool0E@3oool005H0oooo00<0
00000?ooo`3oool0=P3oool00`000000oooo0?ooo`0e0?ooo`030000003oool0oooo05H0oooo001G
0?ooo`030000003oool0oooo03D0oooo00<000000?ooo`3oool0=@3oool00`000000oooo0?ooo`1F
0?ooo`00E`3oool00`000000oooo0?ooo`0e0?ooo`030000003oool0oooo03@0oooo00<000000?oo
o`3oool0E`3oool005P0oooo00<000000?ooo`3oool0=03oool00`000000oooo0?ooo`0d0?ooo`03
0000003oool0oooo05L0oooo001H0?ooo`030000003oool0oooo03@0oooo00<000000?ooo`3oool0
<`3oool00`000000oooo0?ooo`1H0?ooo`00F@3oool00`000000oooo0?ooo`0c0?ooo`030000003o
ool0oooo03<0oooo00<000000?ooo`3oool0F03oool005T0oooo00<000000?ooo`3oool0<`3oool0
0`000000oooo0?ooo`0b0?ooo`030000003oool0oooo05T0oooo001J0?ooo`030000003oool0oooo
0380oooo00<000000?ooo`3oool0<P3oool00`000000oooo0?ooo`1I0?ooo`00FP3oool00`000000
oooo0?ooo`0b0?ooo`030000003oool0oooo0340oooo00<000000?ooo`3oool0FP3oool005/0oooo
00<000000?ooo`3oool0<@3oool00`000000oooo0?ooo`0a0?ooo`030000003oool0oooo05X0oooo
001K0?ooo`030000003oool0oooo0340oooo00<000000?ooo`3oool0<03oool00`000000oooo0?oo
o`1K0?ooo`00G03oool00`000000oooo0?ooo`0`0?ooo`030000003oool0oooo0300oooo00<00000
0?ooo`3oool0F`3oool005`0oooo00<000000?ooo`3oool0<03oool00`000000oooo0?ooo`0_0?oo
o`030000003oool0oooo05`0oooo001M0?ooo`030000003oool0oooo02l0oooo00<000000?ooo`3o
ool0;`3oool00`000000oooo0?ooo`1L0?ooo`00G@3oool00`000000oooo0?ooo`0_0?ooo`030000
003oool0oooo02h0oooo00<000000?ooo`3oool0G@3oool005h0oooo00<000000?ooo`3oool0;P3o
ool00`000000oooo0?ooo`0^0?ooo`030000003oool0oooo05d0oooo001N0?ooo`030000003oool0
oooo02h0oooo00<000000?ooo`3oool0;@3oool00`000000oooo0?ooo`1N0?ooo`00G`3oool00`00
0000oooo0?ooo`0]0?ooo`030000003oool0oooo02d0oooo00<000000?ooo`3oool0GP3oool005l0
oooo00<000000?ooo`3oool0;@3oool00`000000oooo0?ooo`0/0?ooo`030000003oool0oooo05l0
oooo001P0?ooo`030000003oool0oooo02`0oooo00<000000?ooo`3oool0;03oool00`000000oooo
0?ooo`1O0?ooo`00H03oool00`000000oooo0?ooo`0/0?ooo`030000003oool0oooo02/0oooo00<0
00000?ooo`3oool0H03oool00640oooo00<000000?ooo`3oool0:`3oool00`000000oooo0?ooo`0[
0?ooo`030000003oool0oooo0600oooo001Q0?ooo`030000003oool0oooo02/0oooo00<000000?oo
o`3oool0:P3oool00`000000oooo0?ooo`1Q0?ooo`00HP3oool00`000000oooo0?ooo`0Z0?ooo`03
0000003oool0oooo02X0oooo00<000000?ooo`3oool0H@3oool00680oooo00<000000?ooo`3oool0
:P3oool00`000000oooo0?ooo`0Y0?ooo`030000003oool0oooo0680oooo001S0?ooo`030000003o
ool0oooo02T0oooo00<000000?ooo`3oool0:@3oool00`000000oooo0?ooo`1R0?ooo`00H`3oool0
0`000000oooo0?ooo`0Y0?ooo`030000003oool0oooo02P0oooo00<000000?ooo`3oool0H`3oool0
06@0oooo00<000000?ooo`3oool0:03oool00`000000oooo0?ooo`0X0?ooo`030000003oool0oooo
06<0oooo001T0?ooo`030000003oool0oooo02P0oooo00<000000?ooo`3oool09`3oool00`000000
oooo0?ooo`1T0?ooo`00I@3oool00`000000oooo0?ooo`0W0?ooo`030000003oool0oooo02L0oooo
00<000000?ooo`3oool0I03oool006D0oooo00<000000?ooo`3oool09`3oool00`000000oooo0?oo
o`0V0?ooo`030000003oool0oooo06D0oooo001V0?ooo`030000003oool0oooo02H0oooo00<00000
0?ooo`3oool09P3oool00`000000oooo0?ooo`1U0?ooo`00IP3oool00`000000oooo0?ooo`0V0?oo
o`030000003oool0oooo02D0oooo00<000000?ooo`3oool0IP3oool006L0oooo00<000000?ooo`3o
ool09@3oool00`000000oooo0?ooo`0U0?ooo`030000003oool0oooo06H0oooo001W0?ooo`030000
003oool0oooo02D0oooo00<000000?ooo`3oool0903oool00`000000oooo0?ooo`1W0?ooo`00J03o
ool00`000000oooo0?ooo`0T0?ooo`030000003oool0oooo02@0oooo00<000000?ooo`3oool0I`3o
ool006P0oooo00<000000?ooo`3oool0903oool00`000000oooo0?ooo`0S0?ooo`030000003oool0
oooo06P0oooo001Y0?ooo`030000003oool0oooo02<0oooo00<000000?ooo`3oool08`3oool00`00
0000oooo0?ooo`1X0?ooo`00J@3oool00`000000oooo0?ooo`0S0?ooo`030000003oool0oooo0280
oooo00<000000?ooo`3oool0J@3oool006X0oooo00<000000?ooo`3oool08P3oool00`000000oooo
0?ooo`0R0?ooo`030000003oool0oooo06T0oooo001Z0?ooo`030000003oool0oooo0280oooo00<0
00000?ooo`3oool08@3oool00`000000oooo0?ooo`1Z0?ooo`00J`3oool00`000000oooo0?ooo`0Q
0?ooo`030000003oool0oooo0240oooo00<000000?ooo`3oool0JP3oool006/0oooo00<000000?oo
o`3oool08@3oool00`000000oooo0?ooo`0P0?ooo`030000003oool0oooo06/0oooo001/0?ooo`03
0000003oool0oooo0200oooo00<000000?ooo`3oool0803oool00`000000oooo0?ooo`1[0?ooo`00
K03oool00`000000oooo0?ooo`0P0?ooo`030000003oool0oooo01l0oooo00<000000?ooo`3oool0
K03oool006d0oooo00<000000?ooo`3oool07`3oool00`000000oooo0?ooo`0O0?ooo`030000003o
ool0oooo06`0oooo001]0?ooo`030000003oool0oooo01l0oooo00<000000?ooo`3oool07P3oool0
0`000000oooo0?ooo`1]0?ooo`00KP3oool00`000000oooo0?ooo`0N0?ooo`030000003oool0oooo
01h0oooo00<000000?ooo`3oool0K@3oool006h0oooo00<000000?ooo`3oool07P3oool00`000000
oooo0?ooo`0M0?ooo`030000003oool0oooo06h0oooo001_0?ooo`030000003oool0oooo01d0oooo
00<000000?ooo`3oool07@3oool00`000000oooo0?ooo`1^0?ooo`00K`3oool00`000000oooo0?oo
o`0M0?ooo`030000003oool0oooo01`0oooo00<000000?ooo`3oool0K`3oool00700oooo00<00000
0?ooo`3oool0703oool00`000000oooo0?ooo`0L0?ooo`030000003oool0oooo06l0oooo001`0?oo
o`030000003oool0oooo01`0oooo00<000000?ooo`3oool06`3oool00`000000oooo0?ooo`1`0?oo
o`00L@3oool00`000000oooo0?ooo`0K0?ooo`030000003oool0oooo01/0oooo00<000000?ooo`3o
ool0L03oool00740oooo00<000000?ooo`3oool06`3oool00`000000oooo0?ooo`0J0?ooo`030000
003oool0oooo0740oooo001b0?ooo`030000003oool0oooo01X0oooo00<000000?ooo`3oool06P3o
ool00`000000oooo0?ooo`1a0?ooo`00LP3oool00`000000oooo0?ooo`0J0?ooo`030000003oool0
oooo01T0oooo00<000000?ooo`3oool0LP3oool007<0oooo00<000000?ooo`3oool06@3oool00`00
0000oooo0?ooo`0I0?ooo`030000003oool0oooo0780oooo001c0?ooo`030000003oool0oooo01T0
oooo00<000000?ooo`3oool0603oool00`000000oooo0?ooo`1c0?ooo`00M03oool00`000000oooo
0?ooo`0H0?ooo`030000003oool0oooo01P0oooo00<000000?ooo`3oool0L`3oool007@0oooo00<0
00000?ooo`3oool0603oool00`000000oooo0?ooo`0G0?ooo`030000003oool0oooo07@0oooo001e
0?ooo`030000003oool0oooo01L0oooo00<000000?ooo`3oool05`3oool00`000000oooo0?ooo`1d
0?ooo`00M@3oool00`000000oooo0?ooo`0G0?ooo`030000003oool0oooo01H0oooo00<000000?oo
o`3oool0M@3oool007H0oooo00<000000?ooo`3oool05P3oool00`000000oooo0?ooo`0F0?ooo`03
0000003oool0oooo07D0oooo001f0?ooo`030000003oool0oooo01H0oooo00<000000?ooo`3oool0
5@3oool00`000000oooo0?ooo`1f0?ooo`00M`3oool00`000000oooo0?ooo`0E0?ooo`030000003o
ool0oooo01D0oooo00<000000?ooo`3oool0MP3oool007L0oooo00<000000?ooo`3oool05@3oool0
0`000000oooo0?ooo`0D0?ooo`030000003oool0oooo07L0oooo001h0?ooo`030000003oool0oooo
01@0oooo00<000000?ooo`3oool0503oool00`000000oooo0?ooo`1g0?ooo`00N03oool00`000000
oooo0?ooo`0D0?ooo`030000003oool0oooo01<0oooo00<000000?ooo`3oool0N03oool007T0oooo
00<000000?ooo`3oool04`3oool00`000000oooo0?ooo`0C0?ooo`030000003oool0oooo07P0oooo
001i0?ooo`030000003oool0oooo01<0oooo00<000000?ooo`3oool04P3oool00`000000oooo0?oo
o`1i0?ooo`00NP3oool00`000000oooo0?ooo`0B0?ooo`030000003oool0oooo0180oooo00<00000
0?ooo`3oool0N@3oool007X0oooo00<000000?ooo`3oool04P3oool00`000000oooo0?ooo`0A0?oo
o`030000003oool0oooo07X0oooo001k0?ooo`030000003oool0oooo0140oooo00<000000?ooo`3o
ool04@3oool00`000000oooo0?ooo`1j0?ooo`00N`3oool00`000000oooo0?ooo`0A0?ooo`030000
003oool0oooo0100oooo00<000000?ooo`3oool0N`3oool007`0oooo00<000000?ooo`3oool0403o
ool00`000000oooo0?ooo`0@0?ooo`030000003oool0oooo07/0oooo001l0?ooo`030000003oool0
oooo0100oooo00<000000?ooo`3oool03`3oool00`000000oooo0?ooo`1l0?ooo`00O@3oool00`00
0000oooo0?ooo`0?0?ooo`030000003oool0oooo00l0oooo00<000000?ooo`3oool0O03oool007d0
oooo00<000000?ooo`3oool03`3oool00`000000oooo0?ooo`0>0?ooo`030000003oool0oooo07d0
oooo001n0?ooo`030000003oool0oooo00h0oooo00<000000?ooo`3oool03P3oool00`000000oooo
0?ooo`1m0?ooo`00OP3oool00`000000oooo0?ooo`0>0?ooo`030000003oool0oooo00d0oooo00<0
00000?ooo`3oool0OP3oool007l0oooo00<000000?ooo`3oool03@3oool00`000000oooo0?ooo`0=
0?ooo`030000003oool0oooo07h0oooo001o0?ooo`030000003oool0oooo00d0oooo00<000000?oo
o`3oool0303oool00`000000oooo0?ooo`1o0?ooo`00P03oool00`000000oooo0?ooo`0<0?ooo`03
0000003oool0oooo00`0oooo00<000000?ooo`3oool0O`3oool00800oooo00<000000?ooo`3oool0
303oool00`000000oooo0?ooo`0;0?ooo`030000003oool0oooo0800oooo00210?ooo`030000003o
ool0oooo00/0oooo00<000000?ooo`3oool02`3oool00`000000oooo0?ooo`200?ooo`00P@3oool0
0`000000oooo0?ooo`0;0?ooo`030000003oool0oooo00X0oooo00<000000?ooo`3oool0P@3oool0
0880oooo00<000000?ooo`3oool02P3oool00`000000oooo0?ooo`0:0?ooo`030000003oool0oooo
0840oooo00220?ooo`030000003oool0oooo00X0oooo00<000000?ooo`3oool02@3oool00`000000
oooo0?ooo`220?ooo`00P`3oool00`000000oooo0?ooo`090?ooo`030000003oool0oooo00T0oooo
00<000000?ooo`3oool0PP3oool008<0oooo00<000000?ooo`3oool02@3oool00`000000oooo0?oo
o`080?ooo`030000003oool0oooo08<0oooo00240?ooo`030000003oool0oooo00P0oooo00<00000
0?ooo`3oool0203oool00`000000oooo0?ooo`230?ooo`00Q03oool00`000000oooo0?ooo`080?oo
o`030000003oool0oooo00L0oooo00<000000?ooo`3oool0Q03oool008D0oooo00<000000?ooo`3o
ool01`3oool00`000000oooo0?ooo`070?ooo`030000003oool0oooo08@0oooo00250?ooo`030000
003oool0oooo00L0oooo00<000000?ooo`3oool01P3oool00`000000oooo0?ooo`250?ooo`00QP3o
ool00`000000oooo0?ooo`060?ooo`030000003oool0oooo00H0oooo00<000000?ooo`3oool0Q@3o
ool008H0oooo00<000000?ooo`3oool01P3oool00`000000oooo0?ooo`050?ooo`030000003oool0
oooo08H0oooo00270?ooo`030000003oool0oooo00D0oooo00<000000?ooo`3oool01@3oool00`00
0000oooo0?ooo`260?ooo`00Q`3oool00`000000oooo0?ooo`050?ooo`030000003oool0oooo00@0
oooo00<000000?ooo`3oool0Q`3oool008P0oooo00<000000?ooo`3oool0103oool00`000000oooo
0?ooo`040?ooo`030000003oool0oooo08L0oooo00280?ooo`030000003oool0oooo00@0oooo00<0
00000?ooo`3oool00`3oool00`000000oooo0?ooo`280?ooo`00R@3oool00`000000oooo0?ooo`03
0?ooo`030000003oool0oooo00<0oooo00<000000?ooo`3oool0R03oool008T0oooo00<000000?oo
o`3oool00`3oool00`000000oooo0?ooo`020?ooo`030000003oool0oooo08T0oooo002:0?ooo`03
0000003oool0oooo0080oooo00<000000?ooo`3oool00P3oool00`000000oooo0?ooo`290?ooo`00
RP3oool00`000000oooo0?ooo`020?ooo`050000003oool0oooo0?ooo`000000S03oool008/0oooo
00D000000?ooo`3oool0oooo000000030?ooo`030000003oool0oooo08X0oooo002;0?ooo`050000
003oool0oooo0?ooo`0000000P3oool00`000000oooo0?ooo`2;0?ooo`00S03oool010000000oooo
0?ooo`0000020?ooo`030000003oool0oooo08/0oooo002<0?ooo`060000003oool0oooo0000003o
ool00000SP3oool008d0oooo00D000000?ooo`000000oooo0000002>0?ooo`00S@3oool010000000
oooo00000000002?0?ooo`00SP3oool3000008l0oooo002>0?ooo`<00000S`3oool008d0oooo1@00
002>0?ooo`00S@3oool5000008h0oooo002=0?ooo`D00000SP3oool008h0oooo0`00002?0?ooo`00
o`3ooolQ0?ooo`00o`3ooolQ0?ooo`00o`3ooolQ0?ooo`00o`3ooolQ0?ooo`00o`3ooolQ0?ooo`00
o`3ooolQ0?ooo`00o`3ooolQ0?ooo`00o`3ooolQ0?ooo`00o`3ooolQ0?ooo`00o`3ooolQ0?ooo`00
\
\>"],
  ImageRangeCache->{{{0, 287}, {287, 0}} -> {-0.952637, -0.575008, \
0.00663859, 0.00574918}}],

Cell[BoxData[
    TagBox[\(\[SkeletonIndicator]  Graphics  \[SkeletonIndicator]\),
      False,
      Editable->False]], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    \(draw[mm, \ F\  . \ F\  . \ P0]\)], "Input"],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: 1 
MathPictureStart
/Mabs {
Mgmatrix idtransform
Mtmatrix dtransform
} bind def
/Mabsadd { Mabs
3 -1 roll add
3 1 roll add
exch } bind def
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
0.5 0.524864 0.348485 0.606061 [
[ 0 0 0 0 ]
[ 1 1 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 0 m
1 0 L
1 1 L
0 1 L
closepath
clip
newpath
0 g
.02 w
.5 .95455 Mdot
.95455 .04545 Mdot
.04545 .04545 Mdot
.5 .46212 Mdot
.58523 .29167 Mdot
.41477 .29167 Mdot
.5 .29798 Mdot
.5 .42424 Mdot
.5 Mabswid
[ ] 0 setdash
.5 .95455 m
.95455 .04545 L
s
.5 .95455 m
.04545 .04545 L
s
.5 .95455 m
.5 .46212 L
s
.95455 .04545 m
.5 .95455 L
s
.95455 .04545 m
.04545 .04545 L
s
.95455 .04545 m
.58523 .29167 L
s
.04545 .04545 m
.5 .95455 L
s
.04545 .04545 m
.95455 .04545 L
s
.04545 .04545 m
.41477 .29167 L
s
.5 .46212 m
.5 .95455 L
s
.5 .46212 m
.58523 .29167 L
s
.5 .46212 m
.41477 .29167 L
s
.5 .46212 m
.5 .42424 L
s
.58523 .29167 m
.95455 .04545 L
s
.58523 .29167 m
.5 .46212 L
s
.58523 .29167 m
.41477 .29167 L
s
.58523 .29167 m
.5 .29798 L
s
.41477 .29167 m
.04545 .04545 L
s
.41477 .29167 m
.5 .46212 L
s
.41477 .29167 m
.58523 .29167 L
s
.41477 .29167 m
.5 .29798 L
s
.5 .29798 m
.58523 .29167 L
s
.5 .29798 m
.41477 .29167 L
s
.5 .29798 m
.5 .42424 L
s
.5 .42424 m
.5 .46212 L
s
.5 .42424 m
.5 .29798 L
s
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  ImageSize->{288, 288},
  ImageMargins->{{43, 0}, {0, 0}},
  ImageRegion->{{0, 1}, {0, 1}},
  ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`40004P000182000`400?l00000o`00003oo`3ooolQ
0?ooo`00o`3ooolQ0?ooo`00o`3ooolQ0?ooo`00o`3ooolQ0?ooo`00o`3ooolQ0?ooo`00o`3ooolQ
0?ooo`00o`3ooolQ0?ooo`00o`3ooolQ0?ooo`00o`3ooolQ0?ooo`00o`3ooolQ0?ooo`00o`3ooolQ
0?ooo`00o`3ooolQ0?ooo`002`3oool300000?l0oooo0`3oool3000000d0oooo000:0?ooo`D00000
o`3oool10?ooo`D00000303oool000X0ooooo`00000;000000`0oooo000:0?ooo`H00000o`3oool5
000000`0oooo000;0?ooo`@0000000<0oooo0000003oool0o03oool00`000000oooo000000020000
00d0oooo000>0?ooo`030000003oool0oooo00800000n@3oool2000000030?ooo`000000oooo00l0
oooo000?0?ooo`050000003oool0oooo0?ooo`000000m`3oool01@000000oooo0?ooo`3oool00000
0100oooo000?0?ooo`030000003oool0oooo0080oooo0P00003c0?ooo`8000000`3oool00`000000
oooo0?ooo`0?0?ooo`00403oool00`000000oooo0?ooo`030?ooo`030000003oool0oooo0>l0oooo
00<000000?ooo`3oool00`3oool00`000000oooo0?ooo`0?0?ooo`00403oool00`000000oooo0?oo
o`040?ooo`800000k@3oool2000000D0oooo00<000000?ooo`3oool0403oool00140oooo00<00000
0?ooo`3oool01@3oool00`000000oooo0?ooo`3Y0?ooo`030000003oool0oooo00D0oooo00<00000
0?ooo`3oool0403oool00140oooo00<000000?ooo`3oool01P3oool200000>L0oooo0P0000070?oo
o`030000003oool0oooo0140oooo000B0?ooo`030000003oool0oooo00L0oooo00<000000?ooo`3o
ool0h`3oool00`000000oooo0?ooo`070?ooo`030000003oool0oooo0140oooo000B0?ooo`030000
003oool0oooo00P0oooo0P00003Q0?ooo`8000002@3oool00`000000oooo0?ooo`0B0?ooo`004`3o
ool00`000000oooo0?ooo`090?ooo`030000003oool0oooo0=d0oooo00<000000?ooo`3oool02@3o
ool00`000000oooo0?ooo`0B0?ooo`004`3oool00`000000oooo0?ooo`0:0?ooo`800000f`3oool2
000000/0oooo00<000000?ooo`3oool04`3oool001@0oooo00<000000?ooo`3oool02`3oool00`00
0000oooo0?ooo`3G0?ooo`030000003oool0oooo00/0oooo00<000000?ooo`3oool04`3oool001@0
oooo00<000000?ooo`3oool0303oool200000=D0oooo0P00000=0?ooo`030000003oool0oooo01@0
oooo000E0?ooo`030000003oool0oooo00d0oooo00<000000?ooo`3oool0d@3oool00`000000oooo
0?ooo`0=0?ooo`030000003oool0oooo01@0oooo000E0?ooo`030000003oool0oooo00h0oooo0P00
003?0?ooo`8000003`3oool00`000000oooo0?ooo`0E0?ooo`005P3oool00`000000oooo0?ooo`0?
0?ooo`800000b`3oool200000140oooo00<000000?ooo`3oool05@3oool001H0oooo00<000000?oo
o`3oool04@3oool00`000000oooo0?ooo`370?ooo`030000003oool0oooo0100oooo00<000000?oo
o`3oool05P3oool001L0oooo00<000000?ooo`3oool04@3oool200000<D0oooo0P00000C0?ooo`03
0000003oool0oooo01H0oooo000G0?ooo`030000003oool0oooo01<0oooo00<000000?ooo`3oool0
`@3oool00`000000oooo0?ooo`0B0?ooo`030000003oool0oooo01L0oooo000H0?ooo`030000003o
ool0oooo01<0oooo0P00002o0?ooo`8000005@3oool00`000000oooo0?ooo`0G0?ooo`00603oool0
0`000000oooo0?ooo`0E0?ooo`030000003oool0oooo0;/0oooo00<000000?ooo`3oool0503oool0
0`000000oooo0?ooo`0H0?ooo`006@3oool00`000000oooo0?ooo`0E0?ooo`800000^@3oool20000
01L0oooo00<000000?ooo`3oool0603oool001T0oooo00<000000?ooo`3oool05`3oool00`000000
oooo0?ooo`2e0?ooo`030000003oool0oooo01H0oooo00<000000?ooo`3oool06@3oool001X0oooo
00<000000?ooo`3oool05`3oool200000;<0oooo0P00000I0?ooo`030000003oool0oooo01T0oooo
000J0?ooo`030000003oool0oooo01T0oooo00<000000?ooo`3oool0[`3oool00`000000oooo0?oo
o`0H0?ooo`030000003oool0oooo01X0oooo000K0?ooo`030000003oool0oooo01T0oooo0P00002]
0?ooo`8000006`3oool00`000000oooo0?ooo`0J0?ooo`006`3oool00`000000oooo0?ooo`0K0?oo
o`030000003oool0oooo0:T0oooo00<000000?ooo`3oool06P3oool00`000000oooo0?ooo`0K0?oo
o`00703oool00`000000oooo0?ooo`0K0?ooo`800000Y`3oool2000001d0oooo00<000000?ooo`3o
ool06`3oool001`0oooo00<000000?ooo`3oool07@3oool00`000000oooo0?ooo`2S0?ooo`030000
003oool0oooo01`0oooo00<000000?ooo`3oool0703oool001d0oooo00<000000?ooo`3oool07@3o
ool200000:40oooo0P00000O0?ooo`030000003oool0oooo01`0oooo000M0?ooo`030000003oool0
oooo01l0oooo00<000000?ooo`3oool0W@3oool00`000000oooo0?ooo`0N0?ooo`030000003oool0
oooo01d0oooo000N0?ooo`030000003oool0oooo01l0oooo0P00002K0?ooo`8000008@3oool00`00
0000oooo0?ooo`0M0?ooo`007P3oool00`000000oooo0?ooo`0Q0?ooo`030000003oool0oooo09L0
oooo00<000000?ooo`3oool0803oool00`000000oooo0?ooo`0N0?ooo`007`3oool00`000000oooo
0?ooo`0Q0?ooo`800000U@3oool2000002<0oooo00<000000?ooo`3oool07P3oool001l0oooo00<0
00000?ooo`3oool08`3oool00`000000oooo0?ooo`2A0?ooo`030000003oool0oooo0280oooo00<0
00000?ooo`3oool07`3oool00200oooo00<000000?ooo`3oool08`3oool2000008l0oooo0P00000U
0?ooo`030000003oool0oooo01l0oooo000P0?ooo`030000003oool0oooo02D0oooo00<000000?oo
o`3oool0R`3oool00`000000oooo0?ooo`0T0?ooo`030000003oool0oooo0200oooo000Q0?ooo`03
0000003oool0oooo02D0oooo0P0000290?ooo`8000009`3oool00`000000oooo0?ooo`0P0?ooo`00
8@3oool00`000000oooo0?ooo`0W0?ooo`030000003oool0oooo08D0oooo00<000000?ooo`3oool0
9P3oool00`000000oooo0?ooo`0Q0?ooo`008P3oool00`000000oooo0?ooo`0W0?ooo`800000P`3o
ool2000002T0oooo00<000000?ooo`3oool08@3oool00280oooo00<000000?ooo`3oool0:@3oool0
0`000000oooo0?ooo`1o0?ooo`030000003oool0oooo02P0oooo00<000000?ooo`3oool08P3oool0
02<0oooo00<000000?ooo`3oool0:@3oool2000007d0oooo0P00000[0?ooo`030000003oool0oooo
0280oooo000S0?ooo`030000003oool0oooo02/0oooo00<000000?ooo`3oool0N@3oool00`000000
oooo0?ooo`0Z0?ooo`030000003oool0oooo02<0oooo000T0?ooo`030000003oool0oooo02/0oooo
0P00001g0?ooo`800000;@3oool00`000000oooo0?ooo`0S0?ooo`00903oool00`000000oooo0?oo
o`0]0?ooo`030000003oool0oooo07<0oooo00<000000?ooo`3oool0;03oool00`000000oooo0?oo
o`0T0?ooo`009@3oool00`000000oooo0?ooo`0]0?ooo`800000L@3oool2000002l0oooo00<00000
0?ooo`3oool0903oool002D0oooo00<000000?ooo`3oool0;`3oool00`000000oooo0?ooo`1]0?oo
o`030000003oool0oooo02h0oooo00<000000?ooo`3oool09@3oool002H0oooo00<000000?ooo`3o
ool0;`3oool2000006/0oooo0P00000a0?ooo`030000003oool0oooo02D0oooo000V0?ooo`030000
003oool0oooo0340oooo00<000000?ooo`3oool0I`3oool00`000000oooo0?ooo`0`0?ooo`030000
003oool0oooo02H0oooo000W0?ooo`030000003oool0oooo0340oooo0P00001U0?ooo`800000<`3o
ool00`000000oooo0?ooo`0V0?ooo`009`3oool00`000000oooo0?ooo`0c0?ooo`800000H@3oool2
000003@0oooo00<000000?ooo`3oool09`3oool002P0oooo00<000000?ooo`3oool0=03oool00`00
0000oooo0?ooo`1M0?ooo`030000003oool0oooo03@0oooo00<000000?ooo`3oool09`3oool002P0
oooo00<000000?ooo`3oool0=@3oool2000005/0oooo0P00000f0?ooo`030000003oool0oooo02P0
oooo000Y0?ooo`030000003oool0oooo03H0oooo00<000000?ooo`3oool0E`3oool00`000000oooo
0?ooo`0f0?ooo`030000003oool0oooo02P0oooo000Y0?ooo`030000003oool0oooo03L0oooo0P00
001E0?ooo`800000>03oool00`000000oooo0?ooo`0Y0?ooo`00:P3oool00`000000oooo0?ooo`0h
0?ooo`030000003oool0oooo0540oooo00<000000?ooo`3oool0>03oool00`000000oooo0?ooo`0Y
0?ooo`00:P3oool00`000000oooo0?ooo`0i0?ooo`800000C`3oool2000003X0oooo00<000000?oo
o`3oool0:P3oool002/0oooo00<000000?ooo`3oool0>P3oool00`000000oooo0?ooo`1;0?ooo`03
0000003oool0oooo03X0oooo00<000000?ooo`3oool0:P3oool002/0oooo00<000000?ooo`3oool0
>`3oool2000004T0oooo0P00000l0?ooo`030000003oool0oooo02/0oooo000/0?ooo`030000003o
ool0oooo03`0oooo00<000000?ooo`3oool0A@3oool00`000000oooo0?ooo`0l0?ooo`030000003o
ool0oooo02/0oooo000/0?ooo`030000003oool0oooo03d0oooo0P0000130?ooo`800000?P3oool0
0`000000oooo0?ooo`0/0?ooo`00;@3oool00`000000oooo0?ooo`0n0?ooo`030000003oool0oooo
03l0oooo00<000000?ooo`3oool0?P3oool00`000000oooo0?ooo`0/0?ooo`00;@3oool00`000000
oooo0?ooo`0o0?ooo`800000?@3oool200000400oooo00<000000?ooo`3oool0;@3oool002h0oooo
00<000000?ooo`3oool0@03oool00`000000oooo0?ooo`0i0?ooo`030000003oool0oooo0400oooo
00<000000?ooo`3oool0;@3oool002h0oooo00<000000?ooo`3oool0@@3oool2000003L0oooo0P00
00120?ooo`030000003oool0oooo02h0oooo000_0?ooo`030000003oool0oooo0480oooo00<00000
0?ooo`3oool0<`3oool00`000000oooo0?ooo`120?ooo`030000003oool0oooo02h0oooo000_0?oo
o`030000003oool0oooo04<0oooo0`00000^0?ooo`@00000A03oool00`000000oooo0?ooo`0_0?oo
o`00<03oool00`000000oooo0?ooo`110?ooocH00000A03oool00`000000oooo0?ooo`0_0?ooo`00
<03oool00`000000oooo0?ooo`110?ooo`D00000103oool<000000@0oooo1@0000040?ooo``00000
0`3oool5000004<0oooo00<000000?ooo`3oool0<03oool00340oooo00<000000?ooo`3oool0@03o
ool500000100oooo3@00000?0?ooo`D00000@`3oool00`000000oooo0?ooo`0`0?ooo`00<@3oool0
0`000000oooo0?ooo`110?ooo`@00000503oool5000001@0oooo0`0000130?ooo`030000003oool0
oooo0340oooo000b0?ooo`030000003oool0oooo04@0oooo00<000000?ooo`3oool04P3oool30000
01@0oooo00<000000?ooo`3oool0A03oool00`000000oooo0?ooo`0a0?ooo`00<P3oool00`000000
oooo0?ooo`140?ooo`030000003oool0oooo01<0oooo00<000000?ooo`3oool04`3oool00`000000
oooo0?ooo`130?ooo`030000003oool0oooo0380oooo000c0?ooo`030000003oool0oooo04@0oooo
00<000000?ooo`3oool04P3oool00`000000oooo0?ooo`0B0?ooo`030000003oool0oooo04@0oooo
00<000000?ooo`3oool0<P3oool003<0oooo00<000000?ooo`3oool0A03oool00`000000oooo0?oo
o`0B0?ooo`030000003oool0oooo0180oooo00<000000?ooo`3oool0@`3oool00`000000oooo0?oo
o`0c0?ooo`00=03oool00`000000oooo0?ooo`140?ooo`030000003oool0oooo0140oooo00<00000
0?ooo`3oool04@3oool00`000000oooo0?ooo`140?ooo`030000003oool0oooo03<0oooo000d0?oo
o`030000003oool0oooo04@0oooo00<000000?ooo`3oool04@3oool00`000000oooo0?ooo`0A0?oo
o`030000003oool0oooo04<0oooo00<000000?ooo`3oool0=03oool003D0oooo00<000000?ooo`3o
ool0A03oool00`000000oooo0?ooo`0@0?ooo`030000003oool0oooo0100oooo00<000000?ooo`3o
ool0A03oool00`000000oooo0?ooo`0d0?ooo`00=@3oool00`000000oooo0?ooo`140?ooo`030000
003oool0oooo0100oooo00<000000?ooo`3oool0403oool00`000000oooo0?ooo`130?ooo`030000
003oool0oooo03D0oooo000f0?ooo`030000003oool0oooo04@0oooo00<000000?ooo`3oool03`3o
ool00`000000oooo0?ooo`0?0?ooo`030000003oool0oooo04@0oooo00<000000?ooo`3oool0=@3o
ool003H0oooo00<000000?ooo`3oool0A03oool00`000000oooo0?ooo`0?0?ooo`030000003oool0
oooo00l0oooo00<000000?ooo`3oool0@`3oool00`000000oooo0?ooo`0f0?ooo`00=`3oool00`00
0000oooo0?ooo`140?ooo`030000003oool0oooo00h0oooo00<000000?ooo`3oool03P3oool00`00
0000oooo0?ooo`140?ooo`030000003oool0oooo03H0oooo000g0?ooo`030000003oool0oooo04@0
oooo00<000000?ooo`3oool03P3oool00`000000oooo0?ooo`0>0?ooo`030000003oool0oooo04<0
oooo00<000000?ooo`3oool0=`3oool003P0oooo00<000000?ooo`3oool0A03oool00`000000oooo
0?ooo`0=0?ooo`030000003oool0oooo00d0oooo00<000000?ooo`3oool0A03oool00`000000oooo
0?ooo`0g0?ooo`00>03oool00`000000oooo0?ooo`140?ooo`030000003oool0oooo00d0oooo00<0
00000?ooo`3oool03@3oool00`000000oooo0?ooo`130?ooo`030000003oool0oooo03P0oooo000i
0?ooo`030000003oool0oooo04@0oooo00<000000?ooo`3oool0303oool00`000000oooo0?ooo`0<
0?ooo`030000003oool0oooo04@0oooo00<000000?ooo`3oool0>03oool003T0oooo00<000000?oo
o`3oool0A03oool00`000000oooo0?ooo`0<0?ooo`030000003oool0oooo00`0oooo00<000000?oo
o`3oool0@`3oool00`000000oooo0?ooo`0i0?ooo`00>P3oool00`000000oooo0?ooo`140?ooo`03
0000003oool0oooo00/0oooo00<000000?ooo`3oool02`3oool00`000000oooo0?ooo`140?ooo`03
0000003oool0oooo03T0oooo000j0?ooo`030000003oool0oooo04@0oooo00<000000?ooo`3oool0
2`3oool00`000000oooo0?ooo`0;0?ooo`030000003oool0oooo04<0oooo00<000000?ooo`3oool0
>P3oool003/0oooo00<000000?ooo`3oool0A03oool00`000000oooo0?ooo`0:0?ooo`030000003o
ool0oooo00X0oooo00<000000?ooo`3oool0A03oool00`000000oooo0?ooo`0j0?ooo`00>`3oool0
0`000000oooo0?ooo`140?ooo`030000003oool0oooo00X0oooo00<000000?ooo`3oool02P3oool0
0`000000oooo0?ooo`130?ooo`030000003oool0oooo03/0oooo000l0?ooo`030000003oool0oooo
04@0oooo00<000000?ooo`3oool02@3oool00`000000oooo0?ooo`090?ooo`030000003oool0oooo
04@0oooo00<000000?ooo`3oool0>`3oool003`0oooo00<000000?ooo`3oool0A03oool00`000000
oooo0?ooo`090?ooo`030000003oool0oooo00T0oooo00<000000?ooo`3oool0@`3oool00`000000
oooo0?ooo`0l0?ooo`00?@3oool00`000000oooo0?ooo`140?ooo`030000003oool0oooo00P0oooo
00<000000?ooo`3oool0203oool00`000000oooo0?ooo`140?ooo`030000003oool0oooo03`0oooo
000m0?ooo`030000003oool0oooo04@0oooo00<000000?ooo`3oool0203oool00`000000oooo0?oo
o`080?ooo`030000003oool0oooo04<0oooo00<000000?ooo`3oool0?@3oool003h0oooo00<00000
0?ooo`3oool0A03oool00`000000oooo0?ooo`070?ooo`030000003oool0oooo00L0oooo00<00000
0?ooo`3oool0A03oool00`000000oooo0?ooo`0m0?ooo`00?P3oool00`000000oooo0?ooo`140?oo
o`030000003oool0oooo00L0oooo00<000000?ooo`3oool01`3oool00`000000oooo0?ooo`130?oo
o`030000003oool0oooo03h0oooo000o0?ooo`030000003oool0oooo04@0oooo00<000000?ooo`3o
ool01P3oool00`000000oooo0?ooo`060?ooo`030000003oool0oooo04@0oooo00<000000?ooo`3o
ool0?P3oool003l0oooo00<000000?ooo`3oool0A03oool00`000000oooo0?ooo`060?ooo`030000
003oool0oooo00H0oooo00<000000?ooo`3oool0@`3oool00`000000oooo0?ooo`0o0?ooo`00@03o
ool00`000000oooo0?ooo`140?ooo`030000003oool0oooo00D0oooo00<000000?ooo`3oool01@3o
ool00`000000oooo0?ooo`140?ooo`030000003oool0oooo03l0oooo00100?ooo`030000003oool0
oooo04@0oooo00<000000?ooo`3oool01@3oool00`000000oooo0?ooo`050?ooo`030000003oool0
oooo04<0oooo00<000000?ooo`3oool0@03oool00440oooo00<000000?ooo`3oool0A03oool00`00
0000oooo0?ooo`040?ooo`030000003oool0oooo00@0oooo00<000000?ooo`3oool0A03oool00`00
0000oooo0?ooo`100?ooo`00@@3oool00`000000oooo0?ooo`140?ooo`030000003oool0oooo00@0
oooo00<000000?ooo`3oool0103oool00`000000oooo0?ooo`130?ooo`030000003oool0oooo0440
oooo00120?ooo`030000003oool0oooo04@0oooo00<000000?ooo`3oool00`3oool00`000000oooo
0?ooo`030?ooo`030000003oool0oooo04@0oooo00<000000?ooo`3oool0@@3oool00480oooo00<0
00000?ooo`3oool0A03oool00`000000oooo0?ooo`020?ooo`<00000103oool00`000000oooo0?oo
o`130?ooo`030000003oool0oooo0480oooo00130?ooo`030000003oool0oooo04@0oooo00<00000
0?ooo`3oool01@0000020?ooo`030000003oool0oooo04@0oooo00<000000?ooo`3oool0@P3oool0
04<0oooo00<000000?ooo`3oool0A03oool00`000000oooo0?ooo`0500000080oooo00<000000?oo
o`3oool0@`3oool00`000000oooo0?ooo`130?ooo`00A03oool00`000000oooo0?ooo`140?ooo`03
0000003oool0000000@0000000<0oooo0000003oool0A@3oool00`000000oooo0?ooo`130?ooo`00
A03oool00`000000oooo0?ooo`140?ooo`030000003oool0oooo00<000000P3oool00`000000oooo
0?ooo`130?ooo`030000003oool0oooo04@0oooo00150?ooo`030000003oool0oooo04@0oooo00@0
00000?ooo`3oool000000P3oool00`000000oooo0?ooo`140?ooo`030000003oool0oooo04@0oooo
00150?ooo`030000003oool0oooo04@0oooo00@000000?ooo`3oool000000P3oool00`000000oooo
0?ooo`130?ooo`030000003oool0oooo04D0oooo00160?ooo`030000003oool0oooo04@0oooo00D0
00000?ooo`000000oooo000000160?ooo`030000003oool0oooo04D0oooo00160?ooo`030000003o
ool0oooo04@0oooo00D000000?ooo`000000oooo000000150?ooo`030000003oool0oooo04H0oooo
00170?ooo`030000003oool0oooo04@0oooo0`0000160?ooo`030000003oool0oooo04H0oooo0017
0?ooo`030000003oool0oooo04@0oooo0`0000150?ooo`030000003oool0oooo04L0oooo00180?oo
o`030000003oool0oooo0480oooo1@0000140?ooo`030000003oool0oooo04L0oooo00180?ooo`03
0000003oool0oooo0480oooo1@0000130?ooo`030000003oool0oooo04P0oooo00190?ooo`030000
003oool0oooo0440oooo1@0000130?ooo`030000003oool0oooo04P0oooo00190?ooo`030000003o
ool0oooo0480oooo0`0000130?ooo`030000003oool0oooo04T0oooo001:0?ooo`030000003oool0
oooo0480oooo00<000000?ooo`3oool0@P3oool00`000000oooo0?ooo`190?ooo`00BP3oool00`00
0000oooo0?ooo`120?ooo`030000003oool0oooo0440oooo00<000000?ooo`3oool0BP3oool004/0
oooo00<000000?ooo`3oool0@@3oool00`000000oooo0?ooo`110?ooo`030000003oool0oooo04X0
oooo001;0?ooo`030000003oool0oooo0440oooo00<000000?ooo`3oool0@03oool00`000000oooo
0?ooo`1;0?ooo`00C03oool00`000000oooo0?ooo`100?ooo`030000003oool0oooo0400oooo00<0
00000?ooo`3oool0B`3oool004`0oooo00<000000?ooo`3oool0@03oool00`000000oooo0?ooo`0o
0?ooo`030000003oool0oooo04`0oooo001=0?ooo`030000003oool0oooo03l0oooo00<000000?oo
o`3oool0?`3oool00`000000oooo0?ooo`1<0?ooo`00C@3oool00`000000oooo0?ooo`0o0?ooo`03
0000003oool0oooo03h0oooo00<000000?ooo`3oool0C@3oool004h0oooo00<000000?ooo`3oool0
?P3oool00`000000oooo0?ooo`0n0?ooo`030000003oool0oooo04d0oooo001>0?ooo`030000003o
ool0oooo03h0oooo00<000000?ooo`3oool0?@3oool00`000000oooo0?ooo`1>0?ooo`00C`3oool0
0`000000oooo0?ooo`0m0?ooo`030000003oool0oooo03d0oooo00<000000?ooo`3oool0CP3oool0
04l0oooo00<000000?ooo`3oool0?@3oool00`000000oooo0?ooo`0l0?ooo`030000003oool0oooo
04l0oooo001@0?ooo`030000003oool0oooo03`0oooo00<000000?ooo`3oool0?03oool00`000000
oooo0?ooo`1?0?ooo`00D03oool00`000000oooo0?ooo`0l0?ooo`030000003oool0oooo03/0oooo
00<000000?ooo`3oool0D03oool00540oooo00<000000?ooo`3oool0>`3oool00`000000oooo0?oo
o`0k0?ooo`030000003oool0oooo0500oooo001A0?ooo`030000003oool0oooo03/0oooo00<00000
0?ooo`3oool0>P3oool00`000000oooo0?ooo`1A0?ooo`00DP3oool00`000000oooo0?ooo`0j0?oo
o`030000003oool0oooo03X0oooo00<000000?ooo`3oool0D@3oool00580oooo00<000000?ooo`3o
ool0>P3oool00`000000oooo0?ooo`0i0?ooo`030000003oool0oooo0580oooo001C0?ooo`030000
003oool0oooo03T0oooo00<000000?ooo`3oool0>@3oool00`000000oooo0?ooo`1B0?ooo`00D`3o
ool00`000000oooo0?ooo`0i0?ooo`030000003oool0oooo03P0oooo00<000000?ooo`3oool0D`3o
ool005@0oooo00<000000?ooo`3oool0>03oool00`000000oooo0?ooo`0h0?ooo`030000003oool0
oooo05<0oooo001D0?ooo`030000003oool0oooo03P0oooo00<000000?ooo`3oool0=`3oool00`00
0000oooo0?ooo`1D0?ooo`00E@3oool00`000000oooo0?ooo`0g0?ooo`030000003oool0oooo03L0
oooo00<000000?ooo`3oool0E03oool005D0oooo00<000000?ooo`3oool0=`3oool00`000000oooo
0?ooo`0f0?ooo`030000003oool0oooo05D0oooo001F0?ooo`030000003oool0oooo03H0oooo00<0
00000?ooo`3oool0=P3oool00`000000oooo0?ooo`1E0?ooo`00EP3oool00`000000oooo0?ooo`0f
0?ooo`030000003oool0oooo03D0oooo00<000000?ooo`3oool0EP3oool005L0oooo00<000000?oo
o`3oool0=@3oool00`000000oooo0?ooo`0e0?ooo`030000003oool0oooo05H0oooo001G0?ooo`03
0000003oool0oooo03D0oooo00<000000?ooo`3oool0=03oool00`000000oooo0?ooo`1G0?ooo`00
F03oool00`000000oooo0?ooo`0d0?ooo`030000003oool0oooo03@0oooo00<000000?ooo`3oool0
E`3oool005P0oooo00<000000?ooo`3oool0=03oool00`000000oooo0?ooo`0c0?ooo`030000003o
ool0oooo05P0oooo001I0?ooo`030000003oool0oooo03<0oooo00<000000?ooo`3oool0<`3oool0
0`000000oooo0?ooo`1H0?ooo`00F@3oool00`000000oooo0?ooo`0c0?ooo`030000003oool0oooo
0380oooo00<000000?ooo`3oool0F@3oool005X0oooo00<000000?ooo`3oool0<P3oool00`000000
oooo0?ooo`0b0?ooo`030000003oool0oooo05T0oooo001J0?ooo`030000003oool0oooo0380oooo
00<000000?ooo`3oool0<@3oool00`000000oooo0?ooo`1J0?ooo`00F`3oool00`000000oooo0?oo
o`0a0?ooo`030000003oool0oooo0340oooo00<000000?ooo`3oool0FP3oool005/0oooo00<00000
0?ooo`3oool0<@3oool00`000000oooo0?ooo`0`0?ooo`030000003oool0oooo05/0oooo001L0?oo
o`030000003oool0oooo0300oooo00<000000?ooo`3oool0<03oool00`000000oooo0?ooo`1K0?oo
o`00G03oool00`000000oooo0?ooo`0`0?ooo`030000003oool0oooo02l0oooo00<000000?ooo`3o
ool0G03oool005d0oooo00<000000?ooo`3oool0;`3oool00`000000oooo0?ooo`0_0?ooo`030000
003oool0oooo05`0oooo001M0?ooo`030000003oool0oooo02l0oooo00<000000?ooo`3oool0;P3o
ool00`000000oooo0?ooo`1M0?ooo`00GP3oool00`000000oooo0?ooo`0^0?ooo`030000003oool0
oooo02h0oooo00<000000?ooo`3oool0G@3oool005h0oooo00<000000?ooo`3oool0;P3oool00`00
0000oooo0?ooo`0]0?ooo`030000003oool0oooo05h0oooo001O0?ooo`030000003oool0oooo02d0
oooo00<000000?ooo`3oool0;@3oool00`000000oooo0?ooo`1N0?ooo`00G`3oool00`000000oooo
0?ooo`0]0?ooo`030000003oool0oooo02`0oooo00<000000?ooo`3oool0G`3oool00600oooo00<0
00000?ooo`3oool0;03oool00`000000oooo0?ooo`0/0?ooo`030000003oool0oooo05l0oooo001P
0?ooo`030000003oool0oooo02`0oooo00<000000?ooo`3oool0:`3oool00`000000oooo0?ooo`1P
0?ooo`00H@3oool00`000000oooo0?ooo`0[0?ooo`030000003oool0oooo02/0oooo00<000000?oo
o`3oool0H03oool00640oooo00<000000?ooo`3oool0:`3oool00`000000oooo0?ooo`0Z0?ooo`03
0000003oool0oooo0640oooo001R0?ooo`030000003oool0oooo02X0oooo00<000000?ooo`3oool0
:P3oool00`000000oooo0?ooo`1Q0?ooo`00HP3oool00`000000oooo0?ooo`0Z0?ooo`030000003o
ool0oooo02T0oooo00<000000?ooo`3oool0HP3oool006<0oooo00<000000?ooo`3oool0:@3oool0
0`000000oooo0?ooo`0Y0?ooo`030000003oool0oooo0680oooo001S0?ooo`030000003oool0oooo
02T0oooo00<000000?ooo`3oool0:03oool00`000000oooo0?ooo`1S0?ooo`00I03oool00`000000
oooo0?ooo`0X0?ooo`030000003oool0oooo02P0oooo00<000000?ooo`3oool0H`3oool006@0oooo
00<000000?ooo`3oool0:03oool00`000000oooo0?ooo`0W0?ooo`030000003oool0oooo06@0oooo
001U0?ooo`030000003oool0oooo02L0oooo00<000000?ooo`3oool09`3oool00`000000oooo0?oo
o`1T0?ooo`00I@3oool00`000000oooo0?ooo`0W0?ooo`030000003oool0oooo02H0oooo00<00000
0?ooo`3oool0I@3oool006H0oooo00<000000?ooo`3oool09P3oool00`000000oooo0?ooo`0V0?oo
o`030000003oool0oooo06D0oooo001V0?ooo`030000003oool0oooo02H0oooo00<000000?ooo`3o
ool09@3oool00`000000oooo0?ooo`1V0?ooo`00I`3oool00`000000oooo0?ooo`0U0?ooo`030000
003oool0oooo02D0oooo00<000000?ooo`3oool0IP3oool006L0oooo00<000000?ooo`3oool09@3o
ool00`000000oooo0?ooo`0T0?ooo`030000003oool0oooo06L0oooo001X0?ooo`030000003oool0
oooo02@0oooo00<000000?ooo`3oool0903oool00`000000oooo0?ooo`1W0?ooo`00J03oool00`00
0000oooo0?ooo`0T0?ooo`030000003oool0oooo02<0oooo00<000000?ooo`3oool0J03oool006T0
oooo00<000000?ooo`3oool08`3oool00`000000oooo0?ooo`0S0?ooo`030000003oool0oooo06P0
oooo001Y0?ooo`030000003oool0oooo02<0oooo00<000000?ooo`3oool08P3oool00`000000oooo
0?ooo`1Y0?ooo`00JP3oool00`000000oooo0?ooo`0R0?ooo`030000003oool0oooo0280oooo00<0
00000?ooo`3oool0J@3oool006X0oooo00<000000?ooo`3oool08P3oool00`000000oooo0?ooo`0Q
0?ooo`030000003oool0oooo06X0oooo001[0?ooo`030000003oool0oooo0240oooo00<000000?oo
o`3oool08@3oool00`000000oooo0?ooo`1Z0?ooo`00J`3oool00`000000oooo0?ooo`0Q0?ooo`03
0000003oool0oooo0200oooo00<000000?ooo`3oool0J`3oool006`0oooo00<000000?ooo`3oool0
803oool00`000000oooo0?ooo`0P0?ooo`030000003oool0oooo06/0oooo001/0?ooo`030000003o
ool0oooo0200oooo00<000000?ooo`3oool07`3oool00`000000oooo0?ooo`1/0?ooo`00K@3oool0
0`000000oooo0?ooo`0O0?ooo`030000003oool0oooo01l0oooo00<000000?ooo`3oool0K03oool0
06d0oooo00<000000?ooo`3oool07`3oool00`000000oooo0?ooo`0N0?ooo`030000003oool0oooo
06d0oooo001^0?ooo`030000003oool0oooo01h0oooo00<000000?ooo`3oool07P3oool00`000000
oooo0?ooo`1]0?ooo`00KP3oool00`000000oooo0?ooo`0N0?ooo`030000003oool0oooo01d0oooo
00<000000?ooo`3oool0KP3oool006l0oooo00<000000?ooo`3oool07@3oool00`000000oooo0?oo
o`0M0?ooo`030000003oool0oooo06h0oooo001_0?ooo`030000003oool0oooo01d0oooo00<00000
0?ooo`3oool0703oool00`000000oooo0?ooo`1_0?ooo`00L03oool00`000000oooo0?ooo`0L0?oo
o`030000003oool0oooo01`0oooo00<000000?ooo`3oool0K`3oool00700oooo00<000000?ooo`3o
ool0703oool00`000000oooo0?ooo`0K0?ooo`030000003oool0oooo0700oooo001a0?ooo`030000
003oool0oooo01/0oooo00<000000?ooo`3oool06`3oool00`000000oooo0?ooo`1`0?ooo`00L@3o
ool00`000000oooo0?ooo`0K0?ooo`030000003oool0oooo01X0oooo00<000000?ooo`3oool0L@3o
ool00780oooo00<000000?ooo`3oool06P3oool00`000000oooo0?ooo`0J0?ooo`030000003oool0
oooo0740oooo001b0?ooo`030000003oool0oooo01X0oooo00<000000?ooo`3oool06@3oool00`00
0000oooo0?ooo`1b0?ooo`00L`3oool00`000000oooo0?ooo`0I0?ooo`030000003oool0oooo01T0
oooo00<000000?ooo`3oool0LP3oool007<0oooo00<000000?ooo`3oool06@3oool00`000000oooo
0?ooo`0H0?ooo`030000003oool0oooo07<0oooo001d0?ooo`030000003oool0oooo01P0oooo00<0
00000?ooo`3oool0603oool00`000000oooo0?ooo`1c0?ooo`00M03oool00`000000oooo0?ooo`0H
0?ooo`030000003oool0oooo01L0oooo00<000000?ooo`3oool0M03oool007D0oooo00<000000?oo
o`3oool05`3oool00`000000oooo0?ooo`0G0?ooo`030000003oool0oooo07@0oooo001e0?ooo`03
0000003oool0oooo01L0oooo00<000000?ooo`3oool05P3oool00`000000oooo0?ooo`1e0?ooo`00
MP3oool00`000000oooo0?ooo`0F0?ooo`030000003oool0oooo01H0oooo00<000000?ooo`3oool0
M@3oool007H0oooo00<000000?ooo`3oool05P3oool00`000000oooo0?ooo`0E0?ooo`030000003o
ool0oooo07H0oooo001g0?ooo`030000003oool0oooo01D0oooo00<000000?ooo`3oool05@3oool0
0`000000oooo0?ooo`1f0?ooo`00M`3oool00`000000oooo0?ooo`0E0?ooo`030000003oool0oooo
01@0oooo00<000000?ooo`3oool0M`3oool007P0oooo00<000000?ooo`3oool0503oool00`000000
oooo0?ooo`0D0?ooo`030000003oool0oooo07L0oooo001h0?ooo`030000003oool0oooo01@0oooo
00<000000?ooo`3oool04`3oool00`000000oooo0?ooo`1h0?ooo`00N@3oool00`000000oooo0?oo
o`0C0?ooo`030000003oool0oooo01<0oooo00<000000?ooo`3oool0N03oool007T0oooo00<00000
0?ooo`3oool04`3oool00`000000oooo0?ooo`0B0?ooo`030000003oool0oooo07T0oooo001j0?oo
o`030000003oool0oooo0180oooo00<000000?ooo`3oool04P3oool00`000000oooo0?ooo`1i0?oo
o`00NP3oool00`000000oooo0?ooo`0B0?ooo`030000003oool0oooo0140oooo00<000000?ooo`3o
ool0NP3oool007/0oooo00<000000?ooo`3oool04@3oool00`000000oooo0?ooo`0A0?ooo`030000
003oool0oooo07X0oooo001k0?ooo`030000003oool0oooo0140oooo00<000000?ooo`3oool0403o
ool00`000000oooo0?ooo`1k0?ooo`00O03oool00`000000oooo0?ooo`0@0?ooo`030000003oool0
oooo0100oooo00<000000?ooo`3oool0N`3oool007`0oooo00<000000?ooo`3oool0403oool00`00
0000oooo0?ooo`0?0?ooo`030000003oool0oooo07`0oooo001m0?ooo`030000003oool0oooo00l0
oooo00<000000?ooo`3oool03`3oool00`000000oooo0?ooo`1l0?ooo`00O@3oool00`000000oooo
0?ooo`0?0?ooo`030000003oool0oooo00h0oooo00<000000?ooo`3oool0O@3oool007h0oooo00<0
00000?ooo`3oool03P3oool00`000000oooo0?ooo`0>0?ooo`030000003oool0oooo07d0oooo001n
0?ooo`030000003oool0oooo00h0oooo00<000000?ooo`3oool03@3oool00`000000oooo0?ooo`1n
0?ooo`00O`3oool00`000000oooo0?ooo`0=0?ooo`030000003oool0oooo00d0oooo00<000000?oo
o`3oool0OP3oool007l0oooo00<000000?ooo`3oool03@3oool00`000000oooo0?ooo`0<0?ooo`03
0000003oool0oooo07l0oooo00200?ooo`030000003oool0oooo00`0oooo00<000000?ooo`3oool0
303oool00`000000oooo0?ooo`1o0?ooo`00P03oool00`000000oooo0?ooo`0<0?ooo`030000003o
ool0oooo00/0oooo00<000000?ooo`3oool0P03oool00840oooo00<000000?ooo`3oool02`3oool0
0`000000oooo0?ooo`0;0?ooo`030000003oool0oooo0800oooo00210?ooo`030000003oool0oooo
00/0oooo00<000000?ooo`3oool02P3oool00`000000oooo0?ooo`210?ooo`00PP3oool00`000000
oooo0?ooo`0:0?ooo`030000003oool0oooo00X0oooo00<000000?ooo`3oool0P@3oool00880oooo
00<000000?ooo`3oool02P3oool00`000000oooo0?ooo`090?ooo`030000003oool0oooo0880oooo
00230?ooo`030000003oool0oooo00T0oooo00<000000?ooo`3oool02@3oool00`000000oooo0?oo
o`220?ooo`00P`3oool00`000000oooo0?ooo`090?ooo`030000003oool0oooo00P0oooo00<00000
0?ooo`3oool0P`3oool008@0oooo00<000000?ooo`3oool0203oool00`000000oooo0?ooo`080?oo
o`030000003oool0oooo08<0oooo00240?ooo`030000003oool0oooo00P0oooo00<000000?ooo`3o
ool01`3oool00`000000oooo0?ooo`240?ooo`00Q@3oool00`000000oooo0?ooo`070?ooo`030000
003oool0oooo00L0oooo00<000000?ooo`3oool0Q03oool008D0oooo00<000000?ooo`3oool01`3o
ool00`000000oooo0?ooo`060?ooo`030000003oool0oooo08D0oooo00260?ooo`030000003oool0
oooo00H0oooo00<000000?ooo`3oool01P3oool00`000000oooo0?ooo`250?ooo`00QP3oool00`00
0000oooo0?ooo`060?ooo`030000003oool0oooo00D0oooo00<000000?ooo`3oool0QP3oool008L0
oooo00<000000?ooo`3oool01@3oool00`000000oooo0?ooo`050?ooo`030000003oool0oooo08H0
oooo00270?ooo`030000003oool0oooo00D0oooo00<000000?ooo`3oool0103oool00`000000oooo
0?ooo`270?ooo`00R03oool00`000000oooo0?ooo`040?ooo`030000003oool0oooo00@0oooo00<0
00000?ooo`3oool0Q`3oool008P0oooo00<000000?ooo`3oool0103oool00`000000oooo0?ooo`03
0?ooo`030000003oool0oooo08P0oooo00290?ooo`030000003oool0oooo00<0oooo00<000000?oo
o`3oool00`3oool00`000000oooo0?ooo`280?ooo`00R@3oool00`000000oooo0?ooo`030?ooo`03
0000003oool0oooo0080oooo00<000000?ooo`3oool0R@3oool008X0oooo00<000000?ooo`3oool0
0P3oool00`000000oooo0?ooo`020?ooo`030000003oool0oooo08T0oooo002:0?ooo`030000003o
ool0oooo0080oooo00D000000?ooo`3oool0oooo0000002<0?ooo`00R`3oool01@000000oooo0?oo
o`3oool0000000<0oooo00<000000?ooo`3oool0RP3oool008/0oooo00D000000?ooo`3oool0oooo
000000020?ooo`030000003oool0oooo08/0oooo002<0?ooo`040000003oool0oooo00000080oooo
00<000000?ooo`3oool0R`3oool008`0oooo00H000000?ooo`3oool000000?ooo`00002>0?ooo`00
S@3oool01@000000oooo0000003oool0000008h0oooo002=0?ooo`040000003oool00000000008l0
oooo002>0?ooo`<00000S`3oool008h0oooo0`00002?0?ooo`00S@3oool5000008h0oooo002=0?oo
o`D00000SP3oool008d0oooo1@00002>0?ooo`00SP3oool3000008l0oooo003o0?ooob40oooo003o
0?ooob40oooo003o0?ooob40oooo003o0?ooob40oooo003o0?ooob40oooo003o0?ooob40oooo003o
0?ooob40oooo003o0?ooob40oooo003o0?ooob40oooo003o0?ooob40oooo0000\
\>"],
  ImageRangeCache->{{{0, 287}, {287, 0}} -> {-0.952637, -0.575008, \
0.00663859, 0.00574918}}],

Cell[BoxData[
    TagBox[\(\[SkeletonIndicator]  Graphics  \[SkeletonIndicator]\),
      False,
      Editable->False]], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    \(draw[mm, \ F\  . \ \ F\  . \ F\  . \ P0]\)], "Input"],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: 1 
MathPictureStart
/Mabs {
Mgmatrix idtransform
Mtmatrix dtransform
} bind def
/Mabsadd { Mabs
3 -1 roll add
3 1 roll add
exch } bind def
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
0.5 0.524864 0.348485 0.606061 [
[ 0 0 0 0 ]
[ 1 1 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 0 m
1 0 L
1 1 L
0 1 L
closepath
clip
newpath
0 g
.02 w
.5 .95455 Mdot
.95455 .04545 Mdot
.04545 .04545 Mdot
.5 .63258 Mdot
.68466 .20013 Mdot
.31534 .20013 Mdot
.5 .32323 Mdot
.5 .41162 Mdot
.5 Mabswid
[ ] 0 setdash
.5 .95455 m
.95455 .04545 L
s
.5 .95455 m
.04545 .04545 L
s
.5 .95455 m
.5 .63258 L
s
.95455 .04545 m
.5 .95455 L
s
.95455 .04545 m
.04545 .04545 L
s
.95455 .04545 m
.68466 .20013 L
s
.04545 .04545 m
.5 .95455 L
s
.04545 .04545 m
.95455 .04545 L
s
.04545 .04545 m
.31534 .20013 L
s
.5 .63258 m
.5 .95455 L
s
.5 .63258 m
.68466 .20013 L
s
.5 .63258 m
.31534 .20013 L
s
.5 .63258 m
.5 .41162 L
s
.68466 .20013 m
.95455 .04545 L
s
.68466 .20013 m
.5 .63258 L
s
.68466 .20013 m
.31534 .20013 L
s
.68466 .20013 m
.5 .32323 L
s
.31534 .20013 m
.04545 .04545 L
s
.31534 .20013 m
.5 .63258 L
s
.31534 .20013 m
.68466 .20013 L
s
.31534 .20013 m
.5 .32323 L
s
.5 .32323 m
.68466 .20013 L
s
.5 .32323 m
.31534 .20013 L
s
.5 .32323 m
.5 .41162 L
s
.5 .41162 m
.5 .63258 L
s
.5 .41162 m
.5 .32323 L
s
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  ImageSize->{288, 288},
  ImageMargins->{{43, 0}, {0, 0}},
  ImageRegion->{{0, 1}, {0, 1}},
  ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`40004P000182000`400?l00000o`00003oo`3ooolQ
0?ooo`00o`3ooolQ0?ooo`00o`3ooolQ0?ooo`00o`3ooolQ0?ooo`00o`3ooolQ0?ooo`00o`3ooolQ
0?ooo`00o`3ooolQ0?ooo`00o`3ooolQ0?ooo`00o`3ooolQ0?ooo`00o`3ooolQ0?ooo`00o`3ooolQ
0?ooo`00o`3ooolQ0?ooo`002`3oool300000?l0oooo0`3oool3000000d0oooo000:0?ooo`D00000
o`3oool10?ooo`D00000303oool000X0ooooo`00000;000000`0oooo000:0?ooo`H00000o`3oool5
000000`0oooo000;0?ooo`@0000000<0oooo000000000000n`3oool2000000040?ooo`0000000000
000000d0oooo000>0?ooo`040000003oool0oooo0?ooo`800000m`3oool200000080oooo00<00000
0?ooo`3oool03P3oool000l0oooo00<000000?ooo`3oool00P3oool00`000000oooo0?ooo`3c0?oo
o`030000003oool0oooo0080oooo00<000000?ooo`3oool03P3oool000l0oooo00<000000?ooo`3o
ool00`3oool200000?40oooo0P0000040?ooo`030000003oool0oooo00l0oooo000@0?ooo`030000
003oool0oooo00@0oooo0P00003]0?ooo`8000001P3oool00`000000oooo0?ooo`0?0?ooo`00403o
ool00`000000oooo0?ooo`060?ooo`800000j@3oool2000000L0oooo00<000000?ooo`3oool0403o
ool00140oooo00<000000?ooo`3oool01`3oool00`000000oooo0?ooo`3U0?ooo`030000003oool0
oooo00L0oooo00<000000?ooo`3oool0403oool00140oooo00<000000?ooo`3oool0203oool20000
0><0oooo0P0000090?ooo`030000003oool0oooo0140oooo000B0?ooo`030000003oool0oooo00T0
oooo0P00003O0?ooo`8000002`3oool00`000000oooo0?ooo`0A0?ooo`004P3oool00`000000oooo
0?ooo`0;0?ooo`800000f`3oool2000000`0oooo00<000000?ooo`3oool04P3oool001<0oooo00<0
00000?ooo`3oool0303oool00`000000oooo0?ooo`3G0?ooo`030000003oool0oooo00`0oooo00<0
00000?ooo`3oool04P3oool001<0oooo00<000000?ooo`3oool03@3oool200000=D0oooo0P00000>
0?ooo`030000003oool0oooo01<0oooo000D0?ooo`030000003oool0oooo00h0oooo0P00003A0?oo
o`800000403oool00`000000oooo0?ooo`0C0?ooo`00503oool00`000000oooo0?ooo`0@0?ooo`80
0000c@3oool200000140oooo00<000000?ooo`3oool0503oool001D0oooo00<000000?ooo`3oool0
4@3oool00`000000oooo0?ooo`390?ooo`030000003oool0oooo0140oooo00<000000?ooo`3oool0
503oool001D0oooo00<000000?ooo`3oool04P3oool200000<L0oooo0P00000C0?ooo`030000003o
ool0oooo01D0oooo000F0?ooo`030000003oool0oooo01<0oooo0P0000330?ooo`8000005@3oool0
0`000000oooo0?ooo`0E0?ooo`005P3oool00`000000oooo0?ooo`0E0?ooo`800000_`3oool20000
01H0oooo00<000000?ooo`3oool05P3oool001L0oooo00<000000?ooo`3oool05P3oool00`000000
oooo0?ooo`2k0?ooo`030000003oool0oooo01H0oooo00<000000?ooo`3oool05P3oool001L0oooo
00<000000?ooo`3oool05`3oool200000;T0oooo0P00000H0?ooo`030000003oool0oooo01L0oooo
000H0?ooo`030000003oool0oooo01P0oooo0P00002e0?ooo`8000006P3oool00`000000oooo0?oo
o`0G0?ooo`00603oool00`000000oooo0?ooo`0J0?ooo`800000/@3oool2000001/0oooo00<00000
0?ooo`3oool0603oool001T0oooo00<000000?ooo`3oool06`3oool00`000000oooo0?ooo`2]0?oo
o`030000003oool0oooo01/0oooo00<000000?ooo`3oool0603oool001T0oooo00<000000?ooo`3o
ool0703oool200000:/0oooo0P00000M0?ooo`030000003oool0oooo01T0oooo000J0?ooo`030000
003oool0oooo01d0oooo0P00002W0?ooo`8000007`3oool00`000000oooo0?ooo`0I0?ooo`006P3o
ool00`000000oooo0?ooo`0O0?ooo`800000X`3oool200000200oooo00<000000?ooo`3oool06P3o
ool001/0oooo00<000000?ooo`3oool0803oool00`000000oooo0?ooo`2O0?ooo`030000003oool0
oooo0200oooo00<000000?ooo`3oool06P3oool001/0oooo00<000000?ooo`3oool08@3oool20000
09d0oooo0P00000R0?ooo`030000003oool0oooo01/0oooo000L0?ooo`030000003oool0oooo0280
oooo0P00002I0?ooo`800000903oool00`000000oooo0?ooo`0K0?ooo`00703oool00`000000oooo
0?ooo`0T0?ooo`800000U@3oool2000002D0oooo00<000000?ooo`3oool0703oool001d0oooo00<0
00000?ooo`3oool09@3oool00`000000oooo0?ooo`2A0?ooo`030000003oool0oooo02D0oooo00<0
00000?ooo`3oool0703oool001d0oooo00<000000?ooo`3oool09P3oool2000008l0oooo0P00000W
0?ooo`030000003oool0oooo01d0oooo000N0?ooo`030000003oool0oooo02L0oooo0P00002;0?oo
o`800000:@3oool00`000000oooo0?ooo`0M0?ooo`007P3oool00`000000oooo0?ooo`0Y0?ooo`80
0000Q`3oool2000002X0oooo00<000000?ooo`3oool07P3oool001l0oooo00<000000?ooo`3oool0
:P3oool00`000000oooo0?ooo`230?ooo`030000003oool0oooo02X0oooo00<000000?ooo`3oool0
7P3oool001l0oooo00<000000?ooo`3oool0:`3oool200000840oooo0P00000/0?ooo`030000003o
ool0oooo01l0oooo000P0?ooo`030000003oool0oooo02`0oooo0P00001m0?ooo`800000;P3oool0
0`000000oooo0?ooo`0O0?ooo`00803oool00`000000oooo0?ooo`0^0?ooo`800000N@3oool20000
02l0oooo00<000000?ooo`3oool0803oool00240oooo00<000000?ooo`3oool0;`3oool00`000000
oooo0?ooo`1e0?ooo`030000003oool0oooo02l0oooo00<000000?ooo`3oool0803oool00240oooo
00<000000?ooo`3oool0<03oool2000007<0oooo0P00000a0?ooo`030000003oool0oooo0240oooo
000R0?ooo`030000003oool0oooo0340oooo0P000000103oool0000000000000001W0?ooo`<00000
00<0oooo000000000000<`3oool00`000000oooo0?ooo`0Q0?ooo`008P3oool00`000000oooo0?oo
o`0c0?ooo`D00000I@3oool5000003@0oooo00<000000?ooo`3oool08P3oool002<0oooo00<00000
0?ooo`3oool0<P3ooom_000003@0oooo00<000000?ooo`3oool08P3oool002<0oooo00<000000?oo
o`3oool0<P3oool5000006D0oooo1@00000c0?ooo`030000003oool0oooo02<0oooo000T0?ooo`03
0000003oool0oooo0380oooo0`0000000`3oool000000?ooo`1R0?ooo`030000003oool000000080
0000=03oool00`000000oooo0?ooo`0S0?ooo`00903oool00`000000oooo0?ooo`0d0?ooo`030000
003oool0oooo00800000G`3oool200000080oooo00<000000?ooo`3oool0<`3oool00`000000oooo
0?ooo`0T0?ooo`009@3oool00`000000oooo0?ooo`0d0?ooo`050000003oool0oooo0?ooo`000000
G@3oool01@000000oooo0?ooo`3oool0000003H0oooo00<000000?ooo`3oool0903oool002D0oooo
00<000000?ooo`3oool0=03oool00`000000oooo0?ooo`020?ooo`800000F@3oool2000000@0oooo
00<000000?ooo`3oool0<`3oool00`000000oooo0?ooo`0U0?ooo`009P3oool00`000000oooo0?oo
o`0d0?ooo`030000003oool0oooo00<0oooo00<000000?ooo`3oool0E@3oool00`000000oooo0?oo
o`030?ooo`030000003oool0oooo03@0oooo00<000000?ooo`3oool09@3oool002H0oooo00<00000
0?ooo`3oool0=03oool00`000000oooo0?ooo`040?ooo`800000D`3oool2000000H0oooo00<00000
0?ooo`3oool0<`3oool00`000000oooo0?ooo`0V0?ooo`009`3oool00`000000oooo0?ooo`0c0?oo
o`030000003oool0oooo00H0oooo00<000000?ooo`3oool0C`3oool00`000000oooo0?ooo`060?oo
o`030000003oool0oooo03<0oooo00<000000?ooo`3oool09P3oool002L0oooo00<000000?ooo`3o
ool0=03oool00`000000oooo0?ooo`060?ooo`800000C@3oool2000000P0oooo00<000000?ooo`3o
ool0<`3oool00`000000oooo0?ooo`0W0?ooo`00:03oool00`000000oooo0?ooo`0c0?ooo`030000
003oool0oooo00P0oooo00<000000?ooo`3oool0B@3oool00`000000oooo0?ooo`080?ooo`030000
003oool0oooo03<0oooo00<000000?ooo`3oool09`3oool002P0oooo00<000000?ooo`3oool0=03o
ool00`000000oooo0?ooo`080?ooo`800000A`3oool2000000X0oooo00<000000?ooo`3oool0<`3o
ool00`000000oooo0?ooo`0X0?ooo`00:@3oool00`000000oooo0?ooo`0c0?ooo`030000003oool0
oooo00X0oooo00<000000?ooo`3oool0@`3oool00`000000oooo0?ooo`0:0?ooo`030000003oool0
oooo03<0oooo00<000000?ooo`3oool0:03oool002T0oooo00<000000?ooo`3oool0=03oool00`00
0000oooo0?ooo`0:0?ooo`800000@@3oool2000000`0oooo00<000000?ooo`3oool0<`3oool00`00
0000oooo0?ooo`0Y0?ooo`00:P3oool00`000000oooo0?ooo`0c0?ooo`030000003oool0oooo00`0
oooo00<000000?ooo`3oool0?@3oool00`000000oooo0?ooo`0<0?ooo`030000003oool0oooo03<0
oooo00<000000?ooo`3oool0:@3oool002X0oooo00<000000?ooo`3oool0<`3oool00`000000oooo
0?ooo`0=0?ooo`800000>`3oool2000000l0oooo00<000000?ooo`3oool0<P3oool00`000000oooo
0?ooo`0Z0?ooo`00:`3oool00`000000oooo0?ooo`0c0?ooo`030000003oool0oooo00h0oooo00<0
00000?ooo`3oool0=`3oool00`000000oooo0?ooo`0>0?ooo`030000003oool0oooo03<0oooo00<0
00000?ooo`3oool0:P3oool002/0oooo00<000000?ooo`3oool0<`3oool00`000000oooo0?ooo`0?
0?ooo`800000=@3oool200000140oooo00<000000?ooo`3oool0<P3oool00`000000oooo0?ooo`0[
0?ooo`00;03oool00`000000oooo0?ooo`0c0?ooo`030000003oool0oooo0100oooo0P00000a0?oo
o`8000004P3oool00`000000oooo0?ooo`0c0?ooo`030000003oool0oooo02/0oooo000/0?ooo`03
0000003oool0oooo03<0oooo00<000000?ooo`3oool04P3oool00`000000oooo0?ooo`0]0?ooo`03
0000003oool0oooo0180oooo00<000000?ooo`3oool0<P3oool00`000000oooo0?ooo`0/0?ooo`00
;@3oool00`000000oooo0?ooo`0c0?ooo`030000003oool0oooo0180oooo0P00000[0?ooo`800000
503oool00`000000oooo0?ooo`0c0?ooo`030000003oool0oooo02`0oooo000]0?ooo`030000003o
ool0oooo03<0oooo00<000000?ooo`3oool0503oool00`000000oooo0?ooo`0W0?ooo`030000003o
ool0oooo01@0oooo00<000000?ooo`3oool0<P3oool00`000000oooo0?ooo`0]0?ooo`00;P3oool0
0`000000oooo0?ooo`0b0?ooo`030000003oool0oooo01D0oooo0P00000U0?ooo`8000005`3oool0
0`000000oooo0?ooo`0b0?ooo`030000003oool0oooo02d0oooo000^0?ooo`030000003oool0oooo
03<0oooo00<000000?ooo`3oool05P3oool00`000000oooo0?ooo`0Q0?ooo`030000003oool0oooo
01H0oooo00<000000?ooo`3oool0<P3oool00`000000oooo0?ooo`0^0?ooo`00;`3oool00`000000
oooo0?ooo`0b0?ooo`030000003oool0oooo01L0oooo0P00000O0?ooo`8000006@3oool00`000000
oooo0?ooo`0b0?ooo`030000003oool0oooo02h0oooo000_0?ooo`030000003oool0oooo03<0oooo
00<000000?ooo`3oool0603oool00`000000oooo0?ooo`0K0?ooo`030000003oool0oooo01P0oooo
00<000000?ooo`3oool0<P3oool00`000000oooo0?ooo`0_0?ooo`00<03oool00`000000oooo0?oo
o`0b0?ooo`030000003oool0oooo01T0oooo0P00000I0?ooo`8000006`3oool00`000000oooo0?oo
o`0b0?ooo`030000003oool0oooo02l0oooo000`0?ooo`030000003oool0oooo03<0oooo00<00000
0?ooo`3oool06P3oool00`000000oooo0?ooo`0E0?ooo`030000003oool0oooo01X0oooo00<00000
0?ooo`3oool0<P3oool00`000000oooo0?ooo`0`0?ooo`00<@3oool00`000000oooo0?ooo`0b0?oo
o`030000003oool0oooo01/0oooo0P00000C0?ooo`8000007@3oool00`000000oooo0?ooo`0b0?oo
o`030000003oool0oooo0300oooo000a0?ooo`030000003oool0oooo0380oooo00<000000?ooo`3o
ool07@3oool00`000000oooo0?ooo`0?0?ooo`030000003oool0oooo01d0oooo00<000000?ooo`3o
ool0<@3oool00`000000oooo0?ooo`0a0?ooo`00<P3oool00`000000oooo0?ooo`0b0?ooo`030000
003oool0oooo01d0oooo0P00000=0?ooo`8000007`3oool00`000000oooo0?ooo`0b0?ooo`030000
003oool0oooo0340oooo000b0?ooo`030000003oool0oooo0380oooo00<000000?ooo`3oool07`3o
ool00`000000oooo0?ooo`090?ooo`030000003oool0oooo01l0oooo00<000000?ooo`3oool0<@3o
ool00`000000oooo0?ooo`0b0?ooo`00<`3oool00`000000oooo0?ooo`0b0?ooo`030000003oool0
oooo01l0oooo0P0000070?ooo`8000008@3oool00`000000oooo0?ooo`0b0?ooo`030000003oool0
oooo0380oooo000c0?ooo`030000003oool0oooo0380oooo00<000000?ooo`3oool08@3oool00`00
0000oooo0?ooo`030?ooo`030000003oool0oooo0240oooo00<000000?ooo`3oool0<@3oool00`00
0000oooo0?ooo`0c0?ooo`00=03oool00`000000oooo0?ooo`0b0?ooo`030000003oool0oooo0240
oooo1@00000S0?ooo`030000003oool0oooo0380oooo00<000000?ooo`3oool0<`3oool003@0oooo
00<000000?ooo`3oool0<P3oool00`000000oooo0?ooo`0Q0?ooo`D000008`3oool00`000000oooo
0?ooo`0a0?ooo`030000003oool0oooo03@0oooo000e0?ooo`030000003oool0oooo0340oooo00<0
00000?ooo`3oool08@3oool5000002<0oooo00<000000?ooo`3oool0<@3oool00`000000oooo0?oo
o`0d0?ooo`00=@3oool00`000000oooo0?ooo`0b0?ooo`030000003oool0oooo0200oooo1@00000R
0?ooo`030000003oool0oooo0340oooo00<000000?ooo`3oool0=@3oool003H0oooo00<000000?oo
o`3oool0<@3oool00`000000oooo0?ooo`0Q0?ooo`<000008`3oool00`000000oooo0?ooo`0a0?oo
o`030000003oool0oooo03D0oooo000f0?ooo`030000003oool0oooo0380oooo00<000000?ooo`3o
ool08@3oool00`000000oooo0?ooo`0Q0?ooo`030000003oool0oooo0340oooo00<000000?ooo`3o
ool0=P3oool003L0oooo00<000000?ooo`3oool0<@3oool00`000000oooo0?ooo`0Q0?ooo`030000
003oool0oooo0240oooo00<000000?ooo`3oool0<@3oool00`000000oooo0?ooo`0f0?ooo`00=`3o
ool00`000000oooo0?ooo`0b0?ooo`030000003oool0oooo0200oooo00<000000?ooo`3oool0803o
ool00`000000oooo0?ooo`0a0?ooo`030000003oool0oooo03L0oooo000h0?ooo`030000003oool0
oooo0340oooo00<000000?ooo`3oool0803oool00`000000oooo0?ooo`0P0?ooo`030000003oool0
oooo0340oooo00<000000?ooo`3oool0=`3oool003P0oooo00<000000?ooo`3oool0<@3oool00`00
0000oooo0?ooo`0P0?ooo`030000003oool0oooo0200oooo00<000000?ooo`3oool0<03oool00`00
0000oooo0?ooo`0h0?ooo`00>@3oool00`000000oooo0?ooo`0a0?ooo`030000003oool0oooo01l0
oooo00<000000?ooo`3oool07`3oool00`000000oooo0?ooo`0a0?ooo`030000003oool0oooo03P0
oooo000i0?ooo`030000003oool0oooo0340oooo00<000000?ooo`3oool07`3oool00`000000oooo
0?ooo`0O0?ooo`030000003oool0oooo0300oooo00<000000?ooo`3oool0>@3oool003X0oooo00<0
00000?ooo`3oool0<@3oool00`000000oooo0?ooo`0N0?ooo`030000003oool0oooo01h0oooo00<0
00000?ooo`3oool0<@3oool00`000000oooo0?ooo`0i0?ooo`00>P3oool00`000000oooo0?ooo`0a
0?ooo`030000003oool0oooo01h0oooo00<000000?ooo`3oool07P3oool00`000000oooo0?ooo`0`
0?ooo`030000003oool0oooo03X0oooo000k0?ooo`030000003oool0oooo0340oooo00<000000?oo
o`3oool07@3oool00`000000oooo0?ooo`0M0?ooo`030000003oool0oooo0340oooo00<000000?oo
o`3oool0>P3oool003/0oooo00<000000?ooo`3oool0<@3oool00`000000oooo0?ooo`0M0?ooo`03
0000003oool0oooo01d0oooo00<000000?ooo`3oool0<03oool00`000000oooo0?ooo`0k0?ooo`00
?03oool00`000000oooo0?ooo`0`0?ooo`030000003oool0oooo01d0oooo00<000000?ooo`3oool0
7@3oool00`000000oooo0?ooo`0`0?ooo`030000003oool0oooo03/0oooo000l0?ooo`030000003o
ool0oooo0340oooo00<000000?ooo`3oool0703oool00`000000oooo0?ooo`0L0?ooo`030000003o
ool0oooo0300oooo00<000000?ooo`3oool0?03oool003d0oooo00<000000?ooo`3oool0<03oool0
0`000000oooo0?ooo`0L0?ooo`030000003oool0oooo01`0oooo00<000000?ooo`3oool0<03oool0
0`000000oooo0?ooo`0l0?ooo`00?@3oool00`000000oooo0?ooo`0a0?ooo`030000003oool0oooo
01/0oooo00<000000?ooo`3oool06`3oool00`000000oooo0?ooo`0`0?ooo`030000003oool0oooo
03d0oooo000n0?ooo`030000003oool0oooo0300oooo00<000000?ooo`3oool06`3oool00`000000
oooo0?ooo`0K0?ooo`030000003oool0oooo0300oooo00<000000?ooo`3oool0?@3oool003h0oooo
00<000000?ooo`3oool0<@3oool00`000000oooo0?ooo`0J0?ooo`030000003oool0oooo01X0oooo
00<000000?ooo`3oool0<03oool00`000000oooo0?ooo`0n0?ooo`00?`3oool00`000000oooo0?oo
o`0`0?ooo`030000003oool0oooo01X0oooo00<000000?ooo`3oool06P3oool00`000000oooo0?oo
o`0`0?ooo`030000003oool0oooo03h0oooo000o0?ooo`030000003oool0oooo0300oooo00<00000
0?ooo`3oool06P3oool00`000000oooo0?ooo`0J0?ooo`030000003oool0oooo02l0oooo00<00000
0?ooo`3oool0?`3oool00400oooo00<000000?ooo`3oool0<03oool00`000000oooo0?ooo`0I0?oo
o`030000003oool0oooo01T0oooo00<000000?ooo`3oool0<03oool00`000000oooo0?ooo`0o0?oo
o`00@03oool00`000000oooo0?ooo`0`0?ooo`030000003oool0oooo01P0oooo0`00000J0?ooo`03
0000003oool0oooo02l0oooo00<000000?ooo`3oool0@03oool00440oooo00<000000?ooo`3oool0
<03oool00`000000oooo0?ooo`0F0?ooo`D00000603oool00`000000oooo0?ooo`0`0?ooo`030000
003oool0oooo0400oooo00110?ooo`030000003oool0oooo0300oooo00<000000?ooo`3oool05P3o
ool5000001P0oooo00<000000?ooo`3oool0;`3oool00`000000oooo0?ooo`110?ooo`00@P3oool0
0`000000oooo0?ooo`0_0?ooo`030000003oool0oooo01H0oooo1@00000G0?ooo`030000003oool0
oooo0300oooo00<000000?ooo`3oool0@@3oool00480oooo00<000000?ooo`3oool0<03oool00`00
0000oooo0?ooo`0F0?ooo`<00000603oool00`000000oooo0?ooo`0_0?ooo`030000003oool0oooo
0480oooo00130?ooo`030000003oool0oooo02l0oooo00<000000?ooo`3oool05`3oool00`000000
oooo0?ooo`0G0?ooo`030000003oool0oooo02l0oooo00<000000?ooo`3oool0@P3oool004<0oooo
00<000000?ooo`3oool0<03oool00`000000oooo0?ooo`0F0?ooo`030000003oool0oooo01H0oooo
00<000000?ooo`3oool0;`3oool00`000000oooo0?ooo`130?ooo`00A03oool00`000000oooo0?oo
o`0_0?ooo`030000003oool0oooo01H0oooo00<000000?ooo`3oool05P3oool00`000000oooo0?oo
o`0_0?ooo`030000003oool0oooo04<0oooo00140?ooo`030000003oool0oooo0300oooo00<00000
0?ooo`3oool05@3oool00`000000oooo0?ooo`0E0?ooo`030000003oool0oooo02l0oooo00<00000
0?ooo`3oool0A03oool004D0oooo00<000000?ooo`3oool0;`3oool00`000000oooo0?ooo`0E0?oo
o`030000003oool0oooo01D0oooo00<000000?ooo`3oool0;`3oool00`000000oooo0?ooo`140?oo
o`00A@3oool00`000000oooo0?ooo`0_0?ooo`030000003oool0oooo01D0oooo00<000000?ooo`3o
ool05@3oool00`000000oooo0?ooo`0^0?ooo`030000003oool0oooo04D0oooo00160?ooo`030000
003oool0oooo02l0oooo00<000000?ooo`3oool0503oool00`000000oooo0?ooo`0D0?ooo`030000
003oool0oooo02l0oooo00<000000?ooo`3oool0A@3oool004H0oooo00<000000?ooo`3oool0;`3o
ool00`000000oooo0?ooo`0D0?ooo`030000003oool0oooo01@0oooo00<000000?ooo`3oool0;P3o
ool00`000000oooo0?ooo`160?ooo`00A`3oool00`000000oooo0?ooo`0_0?ooo`030000003oool0
oooo01<0oooo00<000000?ooo`3oool04`3oool00`000000oooo0?ooo`0_0?ooo`030000003oool0
oooo04H0oooo00170?ooo`030000003oool0oooo02l0oooo00<000000?ooo`3oool04`3oool00`00
0000oooo0?ooo`0C0?ooo`030000003oool0oooo02h0oooo00<000000?ooo`3oool0A`3oool004P0
oooo00<000000?ooo`3oool0;`3oool00`000000oooo0?ooo`0B0?ooo`030000003oool0oooo0180
oooo00<000000?ooo`3oool0;`3oool00`000000oooo0?ooo`170?ooo`00B03oool00`000000oooo
0?ooo`0_0?ooo`030000003oool0oooo0180oooo00<000000?ooo`3oool04P3oool00`000000oooo
0?ooo`0^0?ooo`030000003oool0oooo04P0oooo00190?ooo`030000003oool0oooo02h0oooo00<0
00000?ooo`3oool04P3oool00`000000oooo0?ooo`0B0?ooo`030000003oool0oooo02h0oooo00<0
00000?ooo`3oool0B03oool004T0oooo00<000000?ooo`3oool0;`3oool00`000000oooo0?ooo`0A
0?ooo`030000003oool0oooo0140oooo00<000000?ooo`3oool0;P3oool00`000000oooo0?ooo`19
0?ooo`00BP3oool00`000000oooo0?ooo`0^0?ooo`030000003oool0oooo0140oooo00<000000?oo
o`3oool04@3oool00`000000oooo0?ooo`0^0?ooo`030000003oool0oooo04T0oooo001:0?ooo`03
0000003oool0oooo02l0oooo00<000000?ooo`3oool0403oool00`000000oooo0?ooo`0@0?ooo`03
0000003oool0oooo02h0oooo00<000000?ooo`3oool0BP3oool004/0oooo00<000000?ooo`3oool0
;P3oool00`000000oooo0?ooo`0@0?ooo`030000003oool0oooo0100oooo00<000000?ooo`3oool0
;P3oool00`000000oooo0?ooo`1:0?ooo`00B`3oool00`000000oooo0?ooo`0_0?ooo`030000003o
ool0oooo00l0oooo00<000000?ooo`3oool03`3oool00`000000oooo0?ooo`0^0?ooo`030000003o
ool0oooo04/0oooo001<0?ooo`030000003oool0oooo02h0oooo00<000000?ooo`3oool03`3oool0
0`000000oooo0?ooo`0?0?ooo`030000003oool0oooo02h0oooo00<000000?ooo`3oool0B`3oool0
04`0oooo00<000000?ooo`3oool0;P3oool00`000000oooo0?ooo`0?0?ooo`030000003oool0oooo
00l0oooo00<000000?ooo`3oool0;@3oool00`000000oooo0?ooo`1<0?ooo`00C@3oool00`000000
oooo0?ooo`0^0?ooo`030000003oool0oooo00h0oooo00<000000?ooo`3oool03P3oool00`000000
oooo0?ooo`0^0?ooo`030000003oool0oooo04`0oooo001=0?ooo`030000003oool0oooo02h0oooo
00<000000?ooo`3oool03P3oool00`000000oooo0?ooo`0>0?ooo`030000003oool0oooo02d0oooo
00<000000?ooo`3oool0C@3oool004h0oooo00<000000?ooo`3oool0;P3oool00`000000oooo0?oo
o`0=0?ooo`030000003oool0oooo00d0oooo00<000000?ooo`3oool0;P3oool00`000000oooo0?oo
o`1=0?ooo`00CP3oool00`000000oooo0?ooo`0^0?ooo`030000003oool0oooo00d0oooo00<00000
0?ooo`3oool03@3oool00`000000oooo0?ooo`0]0?ooo`030000003oool0oooo04h0oooo001?0?oo
o`030000003oool0oooo02h0oooo00<000000?ooo`3oool0303oool00`000000oooo0?ooo`0<0?oo
o`030000003oool0oooo02h0oooo00<000000?ooo`3oool0CP3oool004l0oooo00<000000?ooo`3o
ool0;P3oool00`000000oooo0?ooo`0<0?ooo`030000003oool0oooo00`0oooo00<000000?ooo`3o
ool0;@3oool00`000000oooo0?ooo`1?0?ooo`00D03oool00`000000oooo0?ooo`0]0?ooo`030000
003oool0oooo00`0oooo00<000000?ooo`3oool0303oool00`000000oooo0?ooo`0]0?ooo`030000
003oool0oooo04l0oooo001@0?ooo`030000003oool0oooo02h0oooo00<000000?ooo`3oool02`3o
ool00`000000oooo0?ooo`0;0?ooo`030000003oool0oooo02d0oooo00<000000?ooo`3oool0D03o
ool00540oooo00<000000?ooo`3oool0;@3oool00`000000oooo0?ooo`0;0?ooo`030000003oool0
oooo00/0oooo00<000000?ooo`3oool0;@3oool00`000000oooo0?ooo`1@0?ooo`00D@3oool00`00
0000oooo0?ooo`0^0?ooo`030000003oool0oooo00X0oooo00<000000?ooo`3oool02P3oool00`00
0000oooo0?ooo`0]0?ooo`030000003oool0oooo0540oooo001B0?ooo`030000003oool0oooo02d0
oooo00<000000?ooo`3oool02P3oool00`000000oooo0?ooo`0:0?ooo`030000003oool0oooo02d0
oooo00<000000?ooo`3oool0D@3oool00580oooo00<000000?ooo`3oool0;P3oool00`000000oooo
0?ooo`090?ooo`030000003oool0oooo00T0oooo00<000000?ooo`3oool0;@3oool00`000000oooo
0?ooo`1B0?ooo`00D`3oool00`000000oooo0?ooo`0]0?ooo`030000003oool0oooo00T0oooo00<0
00000?ooo`3oool02@3oool00`000000oooo0?ooo`0]0?ooo`030000003oool0oooo0580oooo001C
0?ooo`030000003oool0oooo02d0oooo00<000000?ooo`3oool02@3oool00`000000oooo0?ooo`09
0?ooo`030000003oool0oooo02`0oooo00<000000?ooo`3oool0D`3oool005@0oooo00<000000?oo
o`3oool0;@3oool00`000000oooo0?ooo`080?ooo`030000003oool0oooo00P0oooo00<000000?oo
o`3oool0;@3oool00`000000oooo0?ooo`1C0?ooo`00E03oool00`000000oooo0?ooo`0]0?ooo`03
0000003oool0oooo00P0oooo00<000000?ooo`3oool0203oool00`000000oooo0?ooo`0/0?ooo`03
0000003oool0oooo05@0oooo001E0?ooo`030000003oool0oooo02d0oooo00<000000?ooo`3oool0
1`3oool00`000000oooo0?ooo`070?ooo`030000003oool0oooo02d0oooo00<000000?ooo`3oool0
E03oool005D0oooo00<000000?ooo`3oool0;@3oool00`000000oooo0?ooo`070?ooo`030000003o
ool0oooo00L0oooo00<000000?ooo`3oool0;03oool00`000000oooo0?ooo`1E0?ooo`00EP3oool0
0`000000oooo0?ooo`0]0?ooo`030000003oool0oooo00H0oooo00<000000?ooo`3oool01P3oool0
0`000000oooo0?ooo`0]0?ooo`030000003oool0oooo05D0oooo001F0?ooo`030000003oool0oooo
02d0oooo00<000000?ooo`3oool01P3oool00`000000oooo0?ooo`060?ooo`030000003oool0oooo
02`0oooo00<000000?ooo`3oool0EP3oool005L0oooo00<000000?ooo`3oool0;03oool00`000000
oooo0?ooo`060?ooo`030000003oool0oooo00H0oooo00<000000?ooo`3oool0;03oool00`000000
oooo0?ooo`1F0?ooo`00E`3oool00`000000oooo0?ooo`0]0?ooo`030000003oool0oooo00D0oooo
00<000000?ooo`3oool01@3oool00`000000oooo0?ooo`0/0?ooo`030000003oool0oooo05L0oooo
001H0?ooo`030000003oool0oooo02`0oooo00<000000?ooo`3oool01@3oool00`000000oooo0?oo
o`050?ooo`030000003oool0oooo02`0oooo00<000000?ooo`3oool0E`3oool005P0oooo00<00000
0?ooo`3oool0;@3oool00`000000oooo0?ooo`040?ooo`030000003oool0oooo00@0oooo00<00000
0?ooo`3oool0;03oool00`000000oooo0?ooo`1H0?ooo`00F@3oool00`000000oooo0?ooo`0/0?oo
o`030000003oool0oooo00@0oooo00<000000?ooo`3oool0103oool00`000000oooo0?ooo`0/0?oo
o`030000003oool0oooo05P0oooo001I0?ooo`030000003oool0oooo02d0oooo00<000000?ooo`3o
ool00`3oool00`000000oooo0?ooo`030?ooo`030000003oool0oooo02`0oooo00<000000?ooo`3o
ool0F@3oool005X0oooo00<000000?ooo`3oool0;03oool00`000000oooo0?ooo`030?ooo`030000
003oool0oooo00<0oooo00<000000?ooo`3oool0;03oool00`000000oooo0?ooo`1I0?ooo`00FP3o
ool00`000000oooo0?ooo`0/0?ooo`030000003oool0oooo00<0oooo00<000000?ooo`3oool00`3o
ool00`000000oooo0?ooo`0[0?ooo`030000003oool0oooo05X0oooo001K0?ooo`030000003oool0
oooo02`0oooo00<000000?ooo`3oool00P3oool00`000000oooo0?ooo`020?ooo`030000003oool0
oooo02`0oooo00<000000?ooo`3oool0FP3oool005/0oooo00<000000?ooo`3oool0;03oool00`00
0000oooo0?ooo`020?ooo`030000003oool0oooo0080oooo00<000000?ooo`3oool0:`3oool00`00
0000oooo0?ooo`1K0?ooo`00G03oool00`000000oooo0?ooo`0/0?ooo`050000003oool0oooo0?oo
o`0000000`3oool00`000000oooo0?ooo`0/0?ooo`030000003oool0oooo05/0oooo001L0?ooo`03
0000003oool0oooo02`0oooo00D000000?ooo`3oool0oooo000000030?ooo`030000003oool0oooo
02/0oooo00<000000?ooo`3oool0G03oool005d0oooo00<000000?ooo`3oool0;03oool010000000
oooo0?ooo`0000020?ooo`030000003oool0oooo02`0oooo00<000000?ooo`3oool0G03oool005d0
oooo00<000000?ooo`3oool0;03oool010000000oooo0?ooo`0000020?ooo`030000003oool0oooo
02/0oooo00<000000?ooo`3oool0G@3oool005h0oooo00<000000?ooo`3oool0:`3oool010000000
oooo0?ooo`0000020?ooo`030000003oool0oooo02/0oooo00<000000?ooo`3oool0G@3oool005h0
oooo00<000000?ooo`3oool0;03oool01@000000oooo0000003oool0000002d0oooo00<000000?oo
o`3oool0GP3oool005l0oooo00<000000?ooo`3oool0:`3oool01@000000oooo0000003oool00000
02d0oooo00<000000?ooo`3oool0GP3oool005l0oooo00<000000?ooo`3oool0;03oool3000002d0
oooo00<000000?ooo`3oool0G`3oool00600oooo00<000000?ooo`3oool0:`3oool3000002d0oooo
00<000000?ooo`3oool0G`3oool00600oooo00<000000?ooo`3oool0:P3oool5000002/0oooo00<0
00000?ooo`3oool0H03oool00640oooo00<000000?ooo`3oool0:@3oool5000002/0oooo00<00000
0?ooo`3oool0H03oool00640oooo00<000000?ooo`3oool0:@3oool5000002X0oooo00<000000?oo
o`3oool0H@3oool00680oooo00<000000?ooo`3oool0:@3oool3000002/0oooo00<000000?ooo`3o
ool0H@3oool00680oooo00<000000?ooo`3oool0:P3oool00`000000oooo0?ooo`0Y0?ooo`030000
003oool0oooo0680oooo001S0?ooo`030000003oool0oooo02T0oooo00<000000?ooo`3oool0:@3o
ool00`000000oooo0?ooo`1R0?ooo`00H`3oool00`000000oooo0?ooo`0Y0?ooo`030000003oool0
oooo02P0oooo00<000000?ooo`3oool0H`3oool006@0oooo00<000000?ooo`3oool0:03oool00`00
0000oooo0?ooo`0X0?ooo`030000003oool0oooo06<0oooo001T0?ooo`030000003oool0oooo02P0
oooo00<000000?ooo`3oool09`3oool00`000000oooo0?ooo`1T0?ooo`00I@3oool00`000000oooo
0?ooo`0W0?ooo`030000003oool0oooo02L0oooo00<000000?ooo`3oool0I03oool006D0oooo00<0
00000?ooo`3oool09`3oool00`000000oooo0?ooo`0V0?ooo`030000003oool0oooo06D0oooo001V
0?ooo`030000003oool0oooo02H0oooo00<000000?ooo`3oool09P3oool00`000000oooo0?ooo`1U
0?ooo`00IP3oool00`000000oooo0?ooo`0V0?ooo`030000003oool0oooo02D0oooo00<000000?oo
o`3oool0IP3oool006L0oooo00<000000?ooo`3oool09@3oool00`000000oooo0?ooo`0U0?ooo`03
0000003oool0oooo06H0oooo001W0?ooo`030000003oool0oooo02D0oooo00<000000?ooo`3oool0
903oool00`000000oooo0?ooo`1W0?ooo`00J03oool00`000000oooo0?ooo`0T0?ooo`030000003o
ool0oooo02@0oooo00<000000?ooo`3oool0I`3oool006P0oooo00<000000?ooo`3oool0903oool0
0`000000oooo0?ooo`0S0?ooo`030000003oool0oooo06P0oooo001Y0?ooo`030000003oool0oooo
02<0oooo00<000000?ooo`3oool08`3oool00`000000oooo0?ooo`1X0?ooo`00J@3oool00`000000
oooo0?ooo`0S0?ooo`030000003oool0oooo0280oooo00<000000?ooo`3oool0J@3oool006X0oooo
00<000000?ooo`3oool08P3oool00`000000oooo0?ooo`0R0?ooo`030000003oool0oooo06T0oooo
001Z0?ooo`030000003oool0oooo0280oooo00<000000?ooo`3oool08@3oool00`000000oooo0?oo
o`1Z0?ooo`00J`3oool00`000000oooo0?ooo`0Q0?ooo`030000003oool0oooo0240oooo00<00000
0?ooo`3oool0JP3oool006/0oooo00<000000?ooo`3oool08@3oool00`000000oooo0?ooo`0P0?oo
o`030000003oool0oooo06/0oooo001/0?ooo`030000003oool0oooo0200oooo00<000000?ooo`3o
ool0803oool00`000000oooo0?ooo`1[0?ooo`00K03oool00`000000oooo0?ooo`0P0?ooo`030000
003oool0oooo01l0oooo00<000000?ooo`3oool0K03oool006d0oooo00<000000?ooo`3oool07`3o
ool00`000000oooo0?ooo`0O0?ooo`030000003oool0oooo06`0oooo001]0?ooo`030000003oool0
oooo01l0oooo00<000000?ooo`3oool07P3oool00`000000oooo0?ooo`1]0?ooo`00KP3oool00`00
0000oooo0?ooo`0N0?ooo`030000003oool0oooo01h0oooo00<000000?ooo`3oool0K@3oool006h0
oooo00<000000?ooo`3oool07P3oool00`000000oooo0?ooo`0M0?ooo`030000003oool0oooo06h0
oooo001_0?ooo`030000003oool0oooo01d0oooo00<000000?ooo`3oool07@3oool00`000000oooo
0?ooo`1^0?ooo`00K`3oool00`000000oooo0?ooo`0M0?ooo`030000003oool0oooo01`0oooo00<0
00000?ooo`3oool0K`3oool00700oooo00<000000?ooo`3oool0703oool00`000000oooo0?ooo`0L
0?ooo`030000003oool0oooo06l0oooo001`0?ooo`030000003oool0oooo01`0oooo00<000000?oo
o`3oool06`3oool00`000000oooo0?ooo`1`0?ooo`00L@3oool00`000000oooo0?ooo`0K0?ooo`03
0000003oool0oooo01/0oooo00<000000?ooo`3oool0L03oool00740oooo00<000000?ooo`3oool0
6`3oool00`000000oooo0?ooo`0J0?ooo`030000003oool0oooo0740oooo001b0?ooo`030000003o
ool0oooo01X0oooo00<000000?ooo`3oool06P3oool00`000000oooo0?ooo`1a0?ooo`00LP3oool0
0`000000oooo0?ooo`0J0?ooo`030000003oool0oooo01T0oooo00<000000?ooo`3oool0LP3oool0
07<0oooo00<000000?ooo`3oool06@3oool00`000000oooo0?ooo`0I0?ooo`030000003oool0oooo
0780oooo001c0?ooo`030000003oool0oooo01T0oooo00<000000?ooo`3oool0603oool00`000000
oooo0?ooo`1c0?ooo`00M03oool00`000000oooo0?ooo`0H0?ooo`030000003oool0oooo01P0oooo
00<000000?ooo`3oool0L`3oool007@0oooo00<000000?ooo`3oool0603oool00`000000oooo0?oo
o`0G0?ooo`030000003oool0oooo07@0oooo001e0?ooo`030000003oool0oooo01L0oooo00<00000
0?ooo`3oool05`3oool00`000000oooo0?ooo`1d0?ooo`00M@3oool00`000000oooo0?ooo`0G0?oo
o`030000003oool0oooo01H0oooo00<000000?ooo`3oool0M@3oool007H0oooo00<000000?ooo`3o
ool05P3oool00`000000oooo0?ooo`0F0?ooo`030000003oool0oooo07D0oooo001f0?ooo`030000
003oool0oooo01H0oooo00<000000?ooo`3oool05@3oool00`000000oooo0?ooo`1f0?ooo`00M`3o
ool00`000000oooo0?ooo`0E0?ooo`030000003oool0oooo01D0oooo00<000000?ooo`3oool0MP3o
ool007L0oooo00<000000?ooo`3oool05@3oool00`000000oooo0?ooo`0D0?ooo`030000003oool0
oooo07L0oooo001h0?ooo`030000003oool0oooo01@0oooo00<000000?ooo`3oool0503oool00`00
0000oooo0?ooo`1g0?ooo`00N03oool00`000000oooo0?ooo`0D0?ooo`030000003oool0oooo01<0
oooo00<000000?ooo`3oool0N03oool007T0oooo00<000000?ooo`3oool04`3oool00`000000oooo
0?ooo`0C0?ooo`030000003oool0oooo07P0oooo001i0?ooo`030000003oool0oooo01<0oooo00<0
00000?ooo`3oool04P3oool00`000000oooo0?ooo`1i0?ooo`00NP3oool00`000000oooo0?ooo`0B
0?ooo`030000003oool0oooo0180oooo00<000000?ooo`3oool0N@3oool007X0oooo00<000000?oo
o`3oool04P3oool00`000000oooo0?ooo`0A0?ooo`030000003oool0oooo07X0oooo001k0?ooo`03
0000003oool0oooo0140oooo00<000000?ooo`3oool04@3oool00`000000oooo0?ooo`1j0?ooo`00
N`3oool00`000000oooo0?ooo`0A0?ooo`030000003oool0oooo0100oooo00<000000?ooo`3oool0
N`3oool007`0oooo00<000000?ooo`3oool0403oool00`000000oooo0?ooo`0@0?ooo`030000003o
ool0oooo07/0oooo001l0?ooo`030000003oool0oooo0100oooo00<000000?ooo`3oool03`3oool0
0`000000oooo0?ooo`1l0?ooo`00O@3oool00`000000oooo0?ooo`0?0?ooo`030000003oool0oooo
00l0oooo00<000000?ooo`3oool0O03oool007d0oooo00<000000?ooo`3oool03`3oool00`000000
oooo0?ooo`0>0?ooo`030000003oool0oooo07d0oooo001n0?ooo`030000003oool0oooo00h0oooo
00<000000?ooo`3oool03P3oool00`000000oooo0?ooo`1m0?ooo`00OP3oool00`000000oooo0?oo
o`0>0?ooo`030000003oool0oooo00d0oooo00<000000?ooo`3oool0OP3oool007l0oooo00<00000
0?ooo`3oool03@3oool00`000000oooo0?ooo`0=0?ooo`030000003oool0oooo07h0oooo001o0?oo
o`030000003oool0oooo00d0oooo00<000000?ooo`3oool0303oool00`000000oooo0?ooo`1o0?oo
o`00P03oool00`000000oooo0?ooo`0<0?ooo`030000003oool0oooo00`0oooo00<000000?ooo`3o
ool0O`3oool00800oooo00<000000?ooo`3oool0303oool00`000000oooo0?ooo`0;0?ooo`030000
003oool0oooo0800oooo00210?ooo`030000003oool0oooo00/0oooo00<000000?ooo`3oool02`3o
ool00`000000oooo0?ooo`200?ooo`00P@3oool00`000000oooo0?ooo`0;0?ooo`030000003oool0
oooo00X0oooo00<000000?ooo`3oool0P@3oool00880oooo00<000000?ooo`3oool02P3oool00`00
0000oooo0?ooo`0:0?ooo`030000003oool0oooo0840oooo00220?ooo`030000003oool0oooo00X0
oooo00<000000?ooo`3oool02@3oool00`000000oooo0?ooo`220?ooo`00P`3oool00`000000oooo
0?ooo`090?ooo`030000003oool0oooo00T0oooo00<000000?ooo`3oool0PP3oool008<0oooo00<0
00000?ooo`3oool02@3oool00`000000oooo0?ooo`080?ooo`030000003oool0oooo08<0oooo0024
0?ooo`030000003oool0oooo00P0oooo00<000000?ooo`3oool0203oool00`000000oooo0?ooo`23
0?ooo`00Q03oool00`000000oooo0?ooo`080?ooo`030000003oool0oooo00L0oooo00<000000?oo
o`3oool0Q03oool008D0oooo00<000000?ooo`3oool01`3oool00`000000oooo0?ooo`070?ooo`03
0000003oool0oooo08@0oooo00250?ooo`030000003oool0oooo00L0oooo00<000000?ooo`3oool0
1P3oool00`000000oooo0?ooo`250?ooo`00QP3oool00`000000oooo0?ooo`060?ooo`030000003o
ool0oooo00H0oooo00<000000?ooo`3oool0Q@3oool008H0oooo00<000000?ooo`3oool01P3oool0
0`000000oooo0?ooo`050?ooo`030000003oool0oooo08H0oooo00270?ooo`030000003oool0oooo
00D0oooo00<000000?ooo`3oool01@3oool00`000000oooo0?ooo`260?ooo`00Q`3oool00`000000
oooo0?ooo`050?ooo`030000003oool0oooo00@0oooo00<000000?ooo`3oool0Q`3oool008P0oooo
00<000000?ooo`3oool0103oool00`000000oooo0?ooo`040?ooo`030000003oool0oooo08L0oooo
00280?ooo`030000003oool0oooo00@0oooo00<000000?ooo`3oool00`3oool00`000000oooo0?oo
o`280?ooo`00R@3oool00`000000oooo0?ooo`030?ooo`030000003oool0oooo00<0oooo00<00000
0?ooo`3oool0R03oool008T0oooo00<000000?ooo`3oool00`3oool00`000000oooo0?ooo`020?oo
o`030000003oool0oooo08T0oooo002:0?ooo`030000003oool0oooo0080oooo00<000000?ooo`3o
ool00P3oool00`000000oooo0?ooo`290?ooo`00RP3oool00`000000oooo0?ooo`020?ooo`050000
003oool0oooo0?ooo`000000S03oool008/0oooo00D000000?ooo`3oool0oooo000000030?ooo`03
0000003oool0oooo08X0oooo002;0?ooo`050000003oool0oooo0?ooo`0000000P3oool00`000000
oooo0?ooo`2;0?ooo`00S03oool010000000oooo0?ooo`0000020?ooo`030000003oool0oooo08/0
oooo002<0?ooo`060000003oool0oooo0000003oool00000SP3oool008d0oooo00D000000?ooo`00
0000oooo0000002>0?ooo`00S@3oool010000000oooo00000000002?0?ooo`00SP3oool3000008l0
oooo002>0?ooo`<00000S`3oool008d0oooo1@00002>0?ooo`00S@3oool5000008h0oooo002=0?oo
o`D00000SP3oool008h0oooo0`00002?0?ooo`00o`3ooolQ0?ooo`00o`3ooolQ0?ooo`00o`3ooolQ
0?ooo`00o`3ooolQ0?ooo`00o`3ooolQ0?ooo`00o`3ooolQ0?ooo`00o`3ooolQ0?ooo`00o`3ooolQ
0?ooo`00o`3ooolQ0?ooo`00o`3ooolQ0?ooo`00\
\>"],
  ImageRangeCache->{{{0, 287}, {287, 0}} -> {-0.952637, -0.575008, \
0.00663859, 0.00574918}}],

Cell[BoxData[
    TagBox[\(\[SkeletonIndicator]  Graphics  \[SkeletonIndicator]\),
      False,
      Editable->False]], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    \(\(\(\ \)\(F = {{1, 0, 0, 0, 0, 0, 0, 0}, {0, 1, 0, 0, 0, 0, 0, 0}, {0, 
          0, 1, 0, 0, 0, 0, 0}, {1\/2, 0, 0, 0, 1\/4, 1\/4, 0, 1\/4}, {0, 
          1\/2, 0, 1\/4, 0, 1\/4, 1/4, 0}, {0, 0, 1\/2, 1\/4, 1\/4, 0, 1/4, 
          0}, {0, 0, 0, 0, 1/3, 1/3, 0, 1\/3}, {0, 0, 0, 1\/2, 0, 0, 1\/2, 
          0}}\)\)\)], "Input"],

Cell[BoxData[
    \({{1, 0, 0, 0, 0, 0, 0, 0}, {0, 1, 0, 0, 0, 0, 0, 0}, {0, 0, 1, 0, 0, 0, 
        0, 0}, {1\/2, 0, 0, 0, 1\/4, 1\/4, 0, 1\/4}, {0, 1\/2, 0, 1\/4, 0, 
        1\/4, 1\/4, 0}, {0, 0, 1\/2, 1\/4, 1\/4, 0, 1\/4, 0}, {0, 0, 0, 0, 
        1\/3, 1\/3, 0, 1\/3}, {0, 0, 0, 1\/2, 0, 0, 1\/2, 0}}\)], "Output"]
}, Open  ]],

Cell[TextData[
"\:3000\:3053\:306e\:4f8b\:306e\:5834\:5408\:306b\:306f\:3001\:ff301\:306e\
\:6bb5\:968e\:3067\:65e2\:306b\:96a3\:63a5\:95a2\:4fc2\:3092\:53cd\:6620\:3057\
\:305f\:5e73\:8861\:72b6\:614b\:306b\:53ce\:675f\:3057\:3066\:3044\:308b\:3002\
\n\:6b21\:306b\:3001mm \:3068P0 \:3092\:5909\:3048\:3066\:5b9f\:884c\:3057\
\:3066\:307f\:308b\:3002\:305f\:3060\:3057\:3001\:30b5\:30a4\:30af\:30ebC\
\:306f{1, 2, 3, 4, 5, 6} \:3068\:3059\:308b\:3002"], "Text"],

Cell[BoxData[
    RowBox[{"       ", 
      RowBox[{
        RowBox[{"P0", "=", 
          TagBox[
            RowBox[{"(", GridBox[{
                  {"0.500000000000000088`", "0.866025403784438552`"},
                  {\(-0.499999999999999822`\), "0.866025403784438729`"},
                  {\(-1.`\), "0"},
                  {\(-0.500000000000000444`\), \(-0.866025403784438374`\)},
                  {"0.499999999999999289`", \(-0.866025403784439085`\)},
                  {"1.`", "0"},
                  {"0", "0"},
                  {"0", "0"},
                  {"0", "0"},
                  {"0", "0"},
                  {"0", "0"},
                  {"0", "0"},
                  {"0", "0"},
                  {"0", "0"},
                  {"0", "0"}
                  }], ")"}],
            (MatrixForm[ #]&)]}], "  ", ";", "  ", 
        RowBox[{"mm", "=", 
          TagBox[
            RowBox[{"(", GridBox[{
                  {"0", "1", "0", "0", "0", "1", "1", "1", "1", "1", "0", "0",
                     "0", "0", "1"},
                  {"1", "0", "1", "0", "0", "0", "1", "0", "0", "0", "0", "0",
                     "0", "0", "0"},
                  {"0", "1", "0", "1", "0", "0", "1", "1", "1", "1", "1", "0",
                     "0", "0", "0"},
                  {"0", "0", "1", "0", "1", "0", "0", "0", "0", "0", "1", "0",
                     "0", "0", "0"},
                  {"0", "0", "0", "1", "0", "1", "0", "0", "0", "0", "1", "1",
                     "1", "1", "1"},
                  {"1", "0", "0", "0", "1", "0", "0", "0", "0", "0", "0", "0",
                     "0", "0", "1"},
                  {"1", "1", "1", "0", "0", "0", "0", "1", "0", "0", "0", "0",
                     "0", "0", "0"},
                  {"1", "0", "1", "0", "0", "0", "1", "0", "1", "0", "0", "0",
                     "0", "0", "0"},
                  {"1", "0", "1", "0", "0", "0", "0", "1", "0", "1", "0", "0",
                     "0", "0", "0"},
                  {"1", "0", "1", "0", "0", "0", "0", "0", "1", "0", "1", "1",
                     "1", "1", "1"},
                  {"0", "0", "1", "1", "1", "0", "0", "0", "0", "1", "0", "1",
                     "0", "0", "0"},
                  {"0", "0", "0", "0", "1", "0", "0", "0", "0", "1", "1", "0",
                     "1", "0", "0"},
                  {"0", "0", "0", "0", "1", "0", "0", "0", "0", "1", "0", "1",
                     "0", "1", "0"},
                  {"0", "0", "0", "0", "1", "0", "0", "0", "0", "1", "0", "0",
                     "1", "0", "1"},
                  {"1", "0", "0", "0", "1", "1", "0", "0", "0", "1", "0", "0",
                     "0", "1", "0"}
                  }], ")"}],
            (MatrixForm[ #]&)]}], "  ", ";"}]}]], "Input"],

Cell[BoxData[
    RowBox[{
      RowBox[{"F", "=", 
        TagBox[
          RowBox[{"(", GridBox[{
                {"1", "0", "0", "0", "0", "0", "0", "0", "0", "0", "0", "0", 
                  "0", "0", "0"},
                {"0", "1", "0", "0", "0", "0", "0", "0", "0", "0", "0", "0", 
                  "0", "0", "0"},
                {"0", "0", "1", "0", "0", "0", "0", "0", "0", "0", "0", "0", 
                  "0", "0", "0"},
                {"0", "0", "0", "1", "0", "0", "0", "0", "0", "0", "0", "0", 
                  "0", "0", "0"},
                {"0", "0", "0", "0", "1", "0", "0", "0", "0", "0", "0", "0", 
                  "0", "0", "0"},
                {"0", "0", "0", "0", "0", "1", "0", "0", "0", "0", "0", "0", 
                  "0", "0", "0"},
                {\(1\/4\), \(1\/4\), \(1\/4\), "0", "0", "0", "0", \(1\/4\), 
                  "0", "0", "0", "0", "0", "0", "0"},
                {\(1\/4\), "0", \(1\/4\), "0", "0", "0", \(1\/4\), 
                  "0", \(1\/4\), "0", "0", "0", "0", "0", "0"},
                {\(1\/4\), "0", \(1\/4\), "0", "0", "0", "0", \(1\/4\), 
                  "0", \(1\/4\), "0", "0", "0", "0", "0"},
                {\(1\/8\), "0", \(1\/8\), "0", "0", "0", "0", "0", \(1\/8\), 
                  "0", \(1\/8\), \(1\/8\), \(1\/8\), \(1\/8\), \(1\/8\)},
                {"0", "0", \(1\/5\), \(1\/5\), \(1\/5\), "0", "0", "0", 
                  "0", \(1\/5\), "0", \(1\/5\), "0", "0", "0"},
                {"0", "0", "0", "0", \(1\/4\), "0", "0", "0", 
                  "0", \(1\/4\), \(1\/4\), "0", \(1\/4\), "0", "0"},
                {"0", "0", "0", "0", \(1\/4\), "0", "0", "0", "0", \(1\/4\), 
                  "0", \(1\/4\), "0", \(1\/4\), "0"},
                {"0", "0", "0", "0", \(1\/4\), "0", "0", "0", "0", \(1\/4\), 
                  "0", "0", \(1\/4\), "0", \(1\/4\)},
                {\(1\/5\), "0", "0", "0", \(1\/5\), \(1\/5\), "0", "0", 
                  "0", \(1\/5\), "0", "0", "0", \(1\/5\), "0"}
                }], ")"}],
          (MatrixForm[ #]&)]}], ";"}]], "Input"],

Cell[CellGroupData[{

Cell[BoxData[
    \(\(\(draw[mm, \ P0]\)\(\ \ \ \ \ \ \ \ \ \ \ \ \ \ \)\)\)], "Input"],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: 1 
MathPictureStart
/Mabs {
Mgmatrix idtransform
Mtmatrix dtransform
} bind def
/Mabsadd { Mabs
3 -1 roll add
3 1 roll add
exch } bind def
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
0.5 0.454545 0.5 0.524864 [
[ 0 0 0 0 ]
[ 1 1 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 0 m
1 0 L
1 1 L
0 1 L
closepath
clip
newpath
0 g
.02 w
.72727 .95455 Mdot
.27273 .95455 Mdot
.04545 .5 Mdot
.27273 .04545 Mdot
.72727 .04545 Mdot
.95455 .5 Mdot
.5 .5 Mdot
.5 .5 Mdot
.5 .5 Mdot
.5 .5 Mdot
.5 .5 Mdot
.5 .5 Mdot
.5 .5 Mdot
.5 .5 Mdot
.5 .5 Mdot
.5 Mabswid
.72727 .95455 m
.27273 .95455 L
s
.72727 .95455 m
.95455 .5 L
s
.72727 .95455 m
.5 .5 L
s
.72727 .95455 m
.5 .5 L
s
.72727 .95455 m
.5 .5 L
s
.72727 .95455 m
.5 .5 L
s
.72727 .95455 m
.5 .5 L
s
.27273 .95455 m
.72727 .95455 L
s
.27273 .95455 m
.04545 .5 L
s
.27273 .95455 m
.5 .5 L
s
.04545 .5 m
.27273 .95455 L
s
.04545 .5 m
.27273 .04545 L
s
.04545 .5 m
.5 .5 L
s
.04545 .5 m
.5 .5 L
s
.04545 .5 m
.5 .5 L
s
.04545 .5 m
.5 .5 L
s
.04545 .5 m
.5 .5 L
s
.27273 .04545 m
.04545 .5 L
s
.27273 .04545 m
.72727 .04545 L
s
.27273 .04545 m
.5 .5 L
s
.72727 .04545 m
.27273 .04545 L
s
.72727 .04545 m
.95455 .5 L
s
.72727 .04545 m
.5 .5 L
s
.72727 .04545 m
.5 .5 L
s
.72727 .04545 m
.5 .5 L
s
.72727 .04545 m
.5 .5 L
s
.72727 .04545 m
.5 .5 L
s
.95455 .5 m
.72727 .95455 L
s
.95455 .5 m
.72727 .04545 L
s
.95455 .5 m
.5 .5 L
s
.5 .5 m
.72727 .95455 L
s
.5 .5 m
.27273 .95455 L
s
.5 .5 m
.04545 .5 L
s
.5 .5 m
.5 .5 L
s
.5 .5 m
.72727 .95455 L
s
.5 .5 m
.04545 .5 L
s
.5 .5 m
.5 .5 L
s
.5 .5 m
.5 .5 L
s
.5 .5 m
.72727 .95455 L
s
.5 .5 m
.04545 .5 L
s
.5 .5 m
.5 .5 L
s
.5 .5 m
.5 .5 L
s
.5 .5 m
.72727 .95455 L
s
.5 .5 m
.04545 .5 L
s
.5 .5 m
.5 .5 L
s
.5 .5 m
.5 .5 L
s
.5 .5 m
.5 .5 L
s
.5 .5 m
.5 .5 L
s
.5 .5 m
.5 .5 L
s
.5 .5 m
.5 .5 L
s
.5 .5 m
.04545 .5 L
s
.5 .5 m
.27273 .04545 L
s
.5 .5 m
.72727 .04545 L
s
.5 .5 m
.5 .5 L
s
.5 .5 m
.5 .5 L
s
.5 .5 m
.72727 .04545 L
s
.5 .5 m
.5 .5 L
s
.5 .5 m
.5 .5 L
s
.5 .5 m
.5 .5 L
s
.5 .5 m
.72727 .04545 L
s
.5 .5 m
.5 .5 L
s
.5 .5 m
.5 .5 L
s
.5 .5 m
.5 .5 L
s
.5 .5 m
.72727 .04545 L
s
.5 .5 m
.5 .5 L
s
.5 .5 m
.5 .5 L
s
.5 .5 m
.5 .5 L
s
.5 .5 m
.72727 .95455 L
s
.5 .5 m
.72727 .04545 L
s
.5 .5 m
.95455 .5 L
s
.5 .5 m
.5 .5 L
s
.5 .5 m
.5 .5 L
s
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  ImageSize->{288, 288},
  ImageMargins->{{43, 0}, {0, 0}},
  ImageRegion->{{0, 1}, {0, 1}},
  ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`40004P000180P10`40000100000800002008200000
P800P020P<30`<3L`:K:l00003<006H009T00<`00?l0000c03<c06Hc09Tc0<`c0?lc001V03=V06IV
09UV0<aV0?mV002I03>I06JI09VI0<bI0?nI003<03?<06K<09W<0<c<0?o<003o03?o06Ko09Wo0<co
0?oo0000<c<0<fH0<iT0<l`0<ol0<`0c<c<c<fHc<iTc<l`c<olc<`1V<c=V<fIV<iUV<laV<omV<`2I
<c>I<fJI<iVI<lbI<onI<`3<<c?<<fK<<iW<<lc<<oo<<`3o<c?o<fKo<iWo<lco<ooo<`00IS<0IVH0
IYT0I/`0I_l0IP0cIS<cIVHcIYTcI/`cI_lcIP1VIS=VIVIVIYUVI/aVI_mVIP2IIS>IIVJIIYVII/bI
I_nIIP3<IS?<IVK<IYW<I/c<I_o<IP3oIS?oIVKoIYWoI/coI_ooIP00VC<0VFH0VIT0VL`0VOl0V@0c
VC<cVFHcVITcVL`cVOlcV@1VVC=VVFIVVIUVVLaVVOmVV@2IVC>IVFJIVIVIVLbIVOnIV@3<VC?<VFK<
VIW<VLc<VOo<V@3oVC?oVFKoVIWoVLcoVOooV@00c3<0c6H0c9T0c<`0c?l0c00cc3<cc6Hcc9Tcc<`c
c?lcc01Vc3=Vc6IVc9UVc<aVc?mVc02Ic3>Ic6JIc9VIc<bIc?nIc03<c3?<c6K<c9W<c<c<c?o<c03o
c3?oc6Koc9Woc<coc?ooc000oc<0ofH0oiT0ol`0ool0o`0coc<cofHcoiTcol`coolco`1Voc=VofIV
oiUVolaVoomVo`2Ioc>IofJIoiVIolbIoonIo`3<oc?<ofK<oiW<olc<ooo<o`3ooc?oofKooiWoolco
ooooo`0000410@820P<30`@410D51@H61PL71`P820T92@X:2P/;2``<30h>3Pl?3a0@414A4A8B4Q<C
4a@D5?okl:2PY820P?l0003o0?oo0000ool0o`3ooooooooQ8N400?oQ8N400?oQ8N400?oQ8N400?oQ
8N400?oQ8N400?oQ8N400?oQ8N400?oQ8N400?oQ8N400?oQ8N400?oQ8N4004cQ0`20h@<0C^4004_Q
1@1nh@D0CN4004_QR01=h@00Bn4507kQ1@1=h@00C>4407oQ0`1>h@00C>40103Qh@1nh@040>7Q04kQ
001<h@050>7Qh@00ON401@3QhN4004gQ001;h@030>7Q00;Q00<0hN40N^400`3Qh@02h@030>7Q04_Q
001;h@030>7Q00?Q00<0hN40NN400`3Qh@03h@030>7Q04[Q001:h@030>7Q00CQ00<0hN40N>400`3Q
h@04h@030>7Q04[Q001:h@030>7Q00GQ00<0hN40Mn400`3Qh@05h@030>7Q04WQ0019h@030>7Q00KQ
00<0hN40M^400`3Qh@06h@030>7Q04WQ0019h@030>7Q00OQ00<0hN40MN400`3Qh@07h@030>7Q04SQ
0018h@030>7Q00SQ00<0hN40M>400`3Qh@08h@030>7Q04SQ0018h@030>7Q00WQ00<0hN40Ln400`3Q
h@09h@030>7Q04OQ0017h@030>7Q00[Q00<0hN40L^400`3Qh@0:h@030>7Q04OQ0017h@030>7Q00_Q
00<0hN40LN400`3Qh@0;h@030>7Q04KQ0016h@030>7Q00cQ00<0hN40L>400`3Qh@0<h@030>7Q04KQ
0016h@030>7Q00gQ00<0hN40Kn400`3Qh@0=h@030>7Q04GQ0015h@030>7Q00kQ00<0hN40K^400`3Q
h@0>h@030>7Q04GQ0015h@030>7Q00oQ00<0hN40KN400`3Qh@0?h@030>7Q04CQ0014h@030>7Q013Q
00<0hN40K>400`3Qh@0@h@030>7Q04CQ0014h@030>7Q017Q00<0hN40Jn400`3Qh@0Ah@030>7Q04?Q
0013h@030>7Q01;Q00<0hN40J^400`3Qh@0Bh@030>7Q04?Q0013h@030>7Q01?Q00<0hN40JN400`3Q
h@0Ch@030>7Q04;Q0012h@030>7Q01CQ00<0hN40J>400`3Qh@0Dh@030>7Q04;Q0012h@030>7Q01GQ
00<0hN40In400`3Qh@0Eh@030>7Q047Q0011h@030>7Q01KQ00<0hN40I^400`3Qh@0Fh@030>7Q047Q
0011h@030>7Q01OQ00<0hN40IN400`3Qh@0Gh@030>7Q043Q0010h@030>7Q01SQ00<0hN40I>400`3Q
h@0Hh@030>7Q043Q0010h@030>7Q01WQ00<0hN40Hn400`3Qh@0Ih@030>7Q03oQ000oh@030>7Q01[Q
00<0hN40H^400`3Qh@0Jh@030>7Q03oQ000oh@030>7Q01_Q00<0hN40HN400`3Qh@0Kh@030>7Q03kQ
000nh@030>7Q01cQ00<0hN40H>400`3Qh@0Lh@030>7Q03kQ000nh@030>7Q01gQ00<0hN40Gn400`3Q
h@0Mh@030>7Q03gQ000mh@030>7Q01kQ00<0hN40G^400`3Qh@0Nh@030>7Q03gQ000mh@030>7Q01oQ
00<0hN40GN400`3Qh@0Oh@030>7Q03cQ000lh@030>7Q023Q00<0hN40G>400`3Qh@0Ph@030>7Q03cQ
000lh@030>7Q027Q00<0hN40Fn400`3Qh@0Qh@030>7Q03_Q000kh@030>7Q02;Q00<0hN40F^400`3Q
h@0Rh@030>7Q03_Q000kh@030>7Q02?Q00<0hN40FN400`3Qh@0Sh@030>7Q03[Q000jh@030>7Q02CQ
00<0hN40F>400`3Qh@0Th@030>7Q03[Q000jh@030>7Q02GQ00<0hN40En400`3Qh@0Uh@030>7Q03WQ
000ih@030>7Q02KQ00<0hN40E^400`3Qh@0Vh@030>7Q03WQ000ih@030>7Q02OQ00<0hN40EN400`3Q
h@0Wh@030>7Q03SQ000hh@030>7Q02SQ00<0hN40E>400`3Qh@0Xh@030>7Q03SQ000hh@030>7Q02WQ
00<0hN40Dn400`3Qh@0Yh@030>7Q03OQ000gh@030>7Q02[Q00<0hN40D^400`3Qh@0Zh@030>7Q03OQ
000gh@030>7Q02_Q00<0hN40DN400`3Qh@0[h@030>7Q03KQ000fh@030>7Q02cQ00<0hN40D>400`3Q
h@0/h@030>7Q03KQ000fh@030>7Q02gQ00<0hN40Cn400`3Qh@0]h@030>7Q03GQ000eh@030>7Q02kQ
00<0hN40C^400`3Qh@0^h@030>7Q03GQ000eh@030>7Q02oQ00<0hN40CN400`3Qh@0_h@030>7Q03CQ
000dh@030>7Q033Q00<0hN40C>400`3Qh@0`h@030>7Q03CQ000dh@030>7Q037Q00<0hN40Bn400`3Q
h@0ah@030>7Q03?Q000ch@030>7Q03;Q00<0hN40B^400`3Qh@0bh@030>7Q03?Q000ch@030>7Q03?Q
00<0hN40BN400`3Qh@0ch@030>7Q03;Q000bh@030>7Q03CQ00<0hN40B>400`3Qh@0dh@030>7Q03;Q
000bh@030>7Q03GQ00<0hN40An400`3Qh@0eh@030>7Q037Q000ah@030>7Q03KQ00<0hN40A^400`3Q
h@0fh@030>7Q037Q000ah@030>7Q03OQ00<0hN40AN400`3Qh@0gh@030>7Q033Q000`h@030>7Q03SQ
00<0hN40A>400`3Qh@0hh@030>7Q033Q000`h@030>7Q03WQ00<0hN40@n400`3Qh@0ih@030>7Q02oQ
000_h@030>7Q03[Q00<0hN40@^400`3Qh@0jh@030>7Q02oQ000_h@030>7Q03_Q00<0hN40@N400`3Q
h@0kh@030>7Q02kQ000^h@030>7Q03cQ00<0hN40@>400`3Qh@0lh@030>7Q02kQ000^h@030>7Q03gQ
00<0hN40?n400`3Qh@0mh@030>7Q02gQ000]h@030>7Q03kQ00<0hN40?^400`3Qh@0nh@030>7Q02gQ
000]h@030>7Q03oQ00<0hN40?N400`3Qh@0oh@030>7Q02cQ000/h@030>7Q043Q00<0hN40?>400`3Q
h@10h@030>7Q02cQ000/h@030>7Q047Q00<0hN40>n400`3Qh@11h@030>7Q02_Q000[h@030>7Q04;Q
00<0hN40>^400`3Qh@12h@030>7Q02_Q000[h@030>7Q04?Q00<0hN40>N400`3Qh@13h@030>7Q02[Q
000Zh@030>7Q04CQ00<0hN40>>400`3Qh@14h@030>7Q02[Q000Zh@030>7Q04GQ00<0hN40=n400`3Q
h@15h@030>7Q02WQ000Yh@030>7Q04KQ00<0hN40=^400`3Qh@16h@030>7Q02WQ000Yh@030>7Q04OQ
00<0hN40=N400`3Qh@17h@030>7Q02SQ000Xh@030>7Q04SQ00<0hN40=>400`3Qh@18h@030>7Q02SQ
000Xh@030>7Q04WQ00<0hN40<n400`3Qh@19h@030>7Q02OQ000Wh@030>7Q04[Q00<0hN40<^400`3Q
h@1:h@030>7Q02OQ000Wh@030>7Q04_Q00<0hN40<N400`3Qh@1;h@030>7Q02KQ000Vh@030>7Q04cQ
00<0hN40<>400`3Qh@1<h@030>7Q02KQ000Vh@030>7Q04gQ00<0hN40;n400`3Qh@1=h@030>7Q02GQ
000Uh@030>7Q04kQ00<0hN40;^400`3Qh@1>h@030>7Q02GQ000Uh@030>7Q04oQ00<0hN40;N400`3Q
h@1?h@030>7Q02CQ000Th@030>7Q053Q00<0hN40;>400`3Qh@1@h@030>7Q02CQ000Th@030>7Q057Q
00<0hN40:n400`3Qh@1Ah@030>7Q02?Q000Sh@030>7Q05;Q00<0hN40:^400`3Qh@1Bh@030>7Q02?Q
000Sh@030>7Q05?Q00<0hN40:N400`3Qh@1Ch@030>7Q02;Q000Rh@030>7Q05CQ00<0hN40:>400`3Q
h@1Dh@030>7Q02;Q000Rh@030>7Q05GQ00<0hN409n400`3Qh@1Eh@030>7Q027Q000Qh@030>7Q05KQ
00<0hN409^400`3Qh@1Fh@030>7Q027Q000Qh@030>7Q05OQ00<0hN409N400`3Qh@1Gh@030>7Q023Q
000Ph@030>7Q05SQ00<0hN409>400`3Qh@1Hh@030>7Q023Q000Ph@030>7Q05WQ00<0hN408n400`3Q
h@1Ih@030>7Q01oQ000Oh@030>7Q05[Q00<0hN408^400`3Qh@1Jh@030>7Q01oQ000Oh@030>7Q05_Q
00<0hN408N400`3Qh@1Kh@030>7Q01kQ000Nh@030>7Q05cQ00<0hN408>400`3Qh@1Lh@030>7Q01kQ
000Nh@030>7Q05gQ00<0hN407n400`3Qh@1Mh@030>7Q01gQ000Mh@030>7Q05kQ00<0hN407^400`3Q
h@1Nh@030>7Q01gQ000Mh@030>7Q05oQ00<0hN407N400`3Qh@1Oh@030>7Q01cQ000Lh@030>7Q063Q
00<0hN407>400`3Qh@1Ph@030>7Q01cQ000Lh@030>7Q067Q00<0hN406n400`3Qh@1Qh@030>7Q01_Q
000Kh@030>7Q06;Q00<0hN406^400`3Qh@1Rh@030>7Q01_Q000Kh@030>7Q06?Q00<0hN406N400`3Q
h@1Sh@030>7Q01[Q000Jh@030>7Q06CQ00<0hN406>400`3Qh@1Th@030>7Q01[Q000Jh@030>7Q06GQ
00<0hN405n400`3Qh@1Uh@030>7Q01WQ000Ih@030>7Q06KQ00<0hN405^400`3Qh@1Vh@030>7Q01WQ
000Ih@030>7Q06OQ00<0hN405N400`3Qh@1Wh@030>7Q01SQ000Hh@030>7Q06SQ00<0hN405>400`3Q
h@1Xh@030>7Q01SQ000Hh@030>7Q06WQ00<0hN404n400`3Qh@1Yh@030>7Q01OQ000Gh@030>7Q06[Q
00<0hN404^400`3Qh@1Zh@030>7Q01OQ000Gh@030>7Q06_Q00<0hN404N400`3Qh@1[h@030>7Q01KQ
000Fh@030>7Q06cQ00<0hN404>400`3Qh@1/h@030>7Q01KQ000Fh@030>7Q06gQ00<0hN403n400`3Q
h@1]h@030>7Q01GQ000Eh@030>7Q06kQ00<0hN403^400`3Qh@1^h@030>7Q01GQ000Eh@030>7Q06oQ
00<0hN403N400`3Qh@1_h@030>7Q01CQ000Dh@030>7Q073Q00<0hN403>400`3Qh@1`h@030>7Q01CQ
000Dh@030>7Q077Q00<0hN402n400`3Qh@1ah@030>7Q01?Q000Ch@030>7Q07;Q00<0hN402^400`3Q
h@1bh@030>7Q01?Q000Ch@030>7Q07?Q00<0hN402N400`3Qh@1ch@030>7Q01;Q000Bh@030>7Q07CQ
00<0hN402>400`3Qh@1dh@030>7Q01;Q000Bh@030>7Q07GQ00<0hN401n400`3Qh@1eh@030>7Q017Q
000Ah@030>7Q07KQ00<0hN401^400`3Qh@1fh@030>7Q017Q000Ah@030>7Q07OQ00<0hN401N400`3Q
h@1gh@030>7Q013Q000@h@030>7Q07SQ00<0hN401>400`3Qh@1hh@030>7Q013Q000@h@030>7Q07WQ
00<0hN400n400`3Qh@1ih@030>7Q00oQ000?h@030>7Q07[Q00<0hN400^400`3Qh@1jh@030>7Q00oQ
000?h@030>7Q07_Q00D0hN7Q001mh@030>7Q00kQ000>h@030>7Q07cQ00@0hN40O^400`3Qh@0>h@00
2n4407oQ0`1oh@<03N4000[Q1@1nh@D0ON4500cQ000:hOl02`0<h@002^4507kQ1@1mh@D03>4000_Q
101oh@<0On4300gQ000>h@030>7Q07cQ00@0hN40O^400`3Qh@0>h@003n400`3Qh@1kh@050>7Qh@00
ON400`3Qh@0>h@003n400`3Qh@1jh@030>7Q00;Q00<0hN40N^400`3Qh@0?h@004>400`3Qh@1ih@03
0>7Q00?Q00<0hN40NN400`3Qh@0?h@004>400`3Qh@1hh@030>7Q00CQ00<0hN40N>400`3Qh@0@h@00
4N400`3Qh@1gh@030>7Q00GQ00<0hN40Mn400`3Qh@0@h@004N400`3Qh@1fh@030>7Q00KQ00<0hN40
M^400`3Qh@0Ah@004^400`3Qh@1eh@030>7Q00OQ00<0hN40MN400`3Qh@0Ah@004^400`3Qh@1dh@03
0>7Q00SQ00<0hN40M>400`3Qh@0Bh@004n400`3Qh@1ch@030>7Q00WQ00<0hN40Ln400`3Qh@0Bh@00
4n400`3Qh@1bh@030>7Q00[Q00<0hN40L^400`3Qh@0Ch@005>400`3Qh@1ah@030>7Q00_Q00<0hN40
LN400`3Qh@0Ch@005>400`3Qh@1`h@030>7Q00cQ00<0hN40L>400`3Qh@0Dh@005N400`3Qh@1_h@03
0>7Q00gQ00<0hN40Kn400`3Qh@0Dh@005N400`3Qh@1^h@030>7Q00kQ00<0hN40K^400`3Qh@0Eh@00
5^400`3Qh@1]h@030>7Q00oQ00<0hN40KN400`3Qh@0Eh@005^400`3Qh@1/h@030>7Q013Q00<0hN40
K>400`3Qh@0Fh@005n400`3Qh@1[h@030>7Q017Q00<0hN40Jn400`3Qh@0Fh@005n400`3Qh@1Zh@03
0>7Q01;Q00<0hN40J^400`3Qh@0Gh@006>400`3Qh@1Yh@030>7Q01?Q00<0hN40JN400`3Qh@0Gh@00
6>400`3Qh@1Xh@030>7Q01CQ00<0hN40J>400`3Qh@0Hh@006N400`3Qh@1Wh@030>7Q01GQ00<0hN40
In400`3Qh@0Hh@006N400`3Qh@1Vh@030>7Q01KQ00<0hN40I^400`3Qh@0Ih@006^400`3Qh@1Uh@03
0>7Q01OQ00<0hN40IN400`3Qh@0Ih@006^400`3Qh@1Th@030>7Q01SQ00<0hN40I>400`3Qh@0Jh@00
6n400`3Qh@1Sh@030>7Q01WQ00<0hN40Hn400`3Qh@0Jh@006n400`3Qh@1Rh@030>7Q01[Q00<0hN40
H^400`3Qh@0Kh@007>400`3Qh@1Qh@030>7Q01_Q00<0hN40HN400`3Qh@0Kh@007>400`3Qh@1Ph@03
0>7Q01cQ00<0hN40H>400`3Qh@0Lh@007N400`3Qh@1Oh@030>7Q01gQ00<0hN40Gn400`3Qh@0Lh@00
7N400`3Qh@1Nh@030>7Q01kQ00<0hN40G^400`3Qh@0Mh@007^400`3Qh@1Mh@030>7Q01oQ00<0hN40
GN400`3Qh@0Mh@007^400`3Qh@1Lh@030>7Q023Q00<0hN40G>400`3Qh@0Nh@007n400`3Qh@1Kh@03
0>7Q027Q00<0hN40Fn400`3Qh@0Nh@007n400`3Qh@1Jh@030>7Q02;Q00<0hN40F^400`3Qh@0Oh@00
8>400`3Qh@1Ih@030>7Q02?Q00<0hN40FN400`3Qh@0Oh@008>400`3Qh@1Hh@030>7Q02CQ00<0hN40
F>400`3Qh@0Ph@008N400`3Qh@1Gh@030>7Q02GQ00<0hN40En400`3Qh@0Ph@008N400`3Qh@1Fh@03
0>7Q02KQ00<0hN40E^400`3Qh@0Qh@008^400`3Qh@1Eh@030>7Q02OQ00<0hN40EN400`3Qh@0Qh@00
8^400`3Qh@1Dh@030>7Q02SQ00<0hN40E>400`3Qh@0Rh@008n400`3Qh@1Ch@030>7Q02WQ00<0hN40
Dn400`3Qh@0Rh@008n400`3Qh@1Bh@030>7Q02[Q00<0hN40D^400`3Qh@0Sh@009>400`3Qh@1Ah@03
0>7Q02_Q00<0hN40DN400`3Qh@0Sh@009>400`3Qh@1@h@030>7Q02cQ00<0hN40D>400`3Qh@0Th@00
9N400`3Qh@1?h@030>7Q02gQ00<0hN40Cn400`3Qh@0Th@009N400`3Qh@1>h@030>7Q02kQ00<0hN40
C^400`3Qh@0Uh@009^400`3Qh@1=h@030>7Q02oQ00<0hN40CN400`3Qh@0Uh@009^400`3Qh@1<h@03
0>7Q033Q00<0hN40C>400`3Qh@0Vh@009n400`3Qh@1;h@030>7Q037Q00<0hN40Bn400`3Qh@0Vh@00
9n400`3Qh@1:h@030>7Q03;Q00<0hN40B^400`3Qh@0Wh@00:>400`3Qh@19h@030>7Q03?Q00<0hN40
BN400`3Qh@0Wh@00:>400`3Qh@18h@030>7Q03CQ00<0hN40B>400`3Qh@0Xh@00:N400`3Qh@17h@03
0>7Q03GQ00<0hN40An400`3Qh@0Xh@00:N400`3Qh@16h@030>7Q03KQ00<0hN40A^400`3Qh@0Yh@00
:^400`3Qh@15h@030>7Q03OQ00<0hN40AN400`3Qh@0Yh@00:^400`3Qh@14h@030>7Q03SQ00<0hN40
A>400`3Qh@0Zh@00:n400`3Qh@13h@030>7Q03WQ00<0hN40@n400`3Qh@0Zh@00:n400`3Qh@12h@03
0>7Q03[Q00<0hN40@^400`3Qh@0[h@00;>400`3Qh@11h@030>7Q03_Q00<0hN40@N400`3Qh@0[h@00
;>400`3Qh@10h@030>7Q03cQ00<0hN40@>400`3Qh@0/h@00;N400`3Qh@0oh@030>7Q03gQ00<0hN40
?n400`3Qh@0/h@00;N400`3Qh@0nh@030>7Q03kQ00<0hN40?^400`3Qh@0]h@00;^400`3Qh@0mh@03
0>7Q03oQ00<0hN40?N400`3Qh@0]h@00;^400`3Qh@0lh@030>7Q043Q00<0hN40?>400`3Qh@0^h@00
;n400`3Qh@0kh@030>7Q047Q00<0hN40>n400`3Qh@0^h@00;n400`3Qh@0jh@030>7Q04;Q00<0hN40
>^400`3Qh@0_h@00<>400`3Qh@0ih@030>7Q04?Q00<0hN40>N400`3Qh@0_h@00<>400`3Qh@0hh@03
0>7Q04CQ00<0hN40>>400`3Qh@0`h@00<N400`3Qh@0gh@030>7Q04GQ00<0hN40=n400`3Qh@0`h@00
<N400`3Qh@0fh@030>7Q04KQ00<0hN40=^400`3Qh@0ah@00<^400`3Qh@0eh@030>7Q04OQ00<0hN40
=N400`3Qh@0ah@00<^400`3Qh@0dh@030>7Q04SQ00<0hN40=>400`3Qh@0bh@00<n400`3Qh@0ch@03
0>7Q04WQ00<0hN40<n400`3Qh@0bh@00<n400`3Qh@0bh@030>7Q04[Q00<0hN40<^400`3Qh@0ch@00
=>400`3Qh@0ah@030>7Q04_Q00<0hN40<N400`3Qh@0ch@00=>400`3Qh@0`h@030>7Q04cQ00<0hN40
<>400`3Qh@0dh@00=N400`3Qh@0_h@030>7Q04gQ00<0hN40;n400`3Qh@0dh@00=N400`3Qh@0^h@03
0>7Q04kQ00<0hN40;^400`3Qh@0eh@00=^400`3Qh@0]h@030>7Q04oQ00<0hN40;N400`3Qh@0eh@00
=^400`3Qh@0/h@030>7Q053Q00<0hN40;>400`3Qh@0fh@00=n400`3Qh@0[h@030>7Q057Q00<0hN40
:n400`3Qh@0fh@00=n400`3Qh@0Zh@030>7Q05;Q00<0hN40:^400`3Qh@0gh@00>>400`3Qh@0Yh@03
0>7Q05?Q00<0hN40:N400`3Qh@0gh@00>>400`3Qh@0Xh@030>7Q05CQ00<0hN40:>400`3Qh@0hh@00
>N400`3Qh@0Wh@030>7Q05GQ00<0hN409n400`3Qh@0hh@00>N400`3Qh@0Vh@030>7Q05KQ00<0hN40
9^400`3Qh@0ih@00>^400`3Qh@0Uh@030>7Q05OQ00<0hN409N400`3Qh@0ih@00>^400`3Qh@0Th@03
0>7Q05SQ00<0hN409>400`3Qh@0jh@00>n400`3Qh@0Sh@030>7Q05WQ00<0hN408n400`3Qh@0jh@00
>n400`3Qh@0Rh@030>7Q05[Q00<0hN408^400`3Qh@0kh@00?>400`3Qh@0Qh@030>7Q05_Q00<0hN40
8N400`3Qh@0kh@00?>400`3Qh@0Ph@030>7Q05cQ00<0hN408>400`3Qh@0lh@00?N400`3Qh@0Oh@03
0>7Q05gQ00<0hN407n400`3Qh@0lh@00?N400`3Qh@0Nh@030>7Q05kQ00<0hN407^400`3Qh@0mh@00
?^400`3Qh@0Mh@030>7Q05oQ00<0hN407N400`3Qh@0mh@00?^400`3Qh@0Lh@030>7Q063Q00<0hN40
7>400`3Qh@0nh@00?n400`3Qh@0Kh@030>7Q067Q00<0hN406n400`3Qh@0nh@00?n400`3Qh@0Jh@03
0>7Q06;Q00<0hN406^400`3Qh@0oh@00@>400`3Qh@0Ih@030>7Q06?Q00<0hN406N400`3Qh@0oh@00
@>400`3Qh@0Hh@030>7Q06CQ00<0hN406>400`3Qh@10h@00@N400`3Qh@0Gh@030>7Q06GQ00<0hN40
5n400`3Qh@10h@00@N400`3Qh@0Fh@030>7Q06KQ00<0hN405^400`3Qh@11h@00@^400`3Qh@0Eh@03
0>7Q06OQ00<0hN405N400`3Qh@11h@00@^400`3Qh@0Dh@030>7Q06SQ00<0hN405>400`3Qh@12h@00
@n400`3Qh@0Ch@030>7Q06WQ00<0hN404n400`3Qh@12h@00@n400`3Qh@0Bh@030>7Q06[Q00<0hN40
4^400`3Qh@13h@00A>400`3Qh@0Ah@030>7Q06_Q00<0hN404N400`3Qh@13h@00A>400`3Qh@0@h@03
0>7Q06cQ00<0hN404>400`3Qh@14h@00AN400`3Qh@0?h@030>7Q06gQ00<0hN403n400`3Qh@14h@00
AN400`3Qh@0>h@030>7Q06kQ00<0hN403^400`3Qh@15h@00A^400`3Qh@0=h@030>7Q06oQ00<0hN40
3N400`3Qh@15h@00A^400`3Qh@0<h@030>7Q073Q00<0hN403>400`3Qh@16h@00An400`3Qh@0;h@03
0>7Q077Q00<0hN402n400`3Qh@16h@00An400`3Qh@0:h@030>7Q07;Q00<0hN402^400`3Qh@17h@00
B>400`3Qh@09h@030>7Q07?Q00<0hN402N400`3Qh@17h@00B>400`3Qh@08h@030>7Q07CQ00<0hN40
2>400`3Qh@18h@00BN400`3Qh@07h@030>7Q07GQ00<0hN401n400`3Qh@18h@00BN400`3Qh@06h@03
0>7Q07KQ00<0hN401^400`3Qh@19h@00B^400`3Qh@05h@030>7Q07OQ00<0hN401N400`3Qh@19h@00
B^400`3Qh@04h@030>7Q07SQ00<0hN401>400`3Qh@1:h@00Bn400`3Qh@03h@030>7Q07WQ00<0hN40
0n400`3Qh@1:h@00Bn400`3Qh@02h@030>7Q07[Q00<0hN400^400`3Qh@1;h@00C>401@3QhN4007gQ
00D0hN7Q001=h@00C>40103Qh@1nh@040>7Q04kQ001=h@030>4007oQ00<0h@00C^4004cQ0`20h@<0
C^4004_QR01=h@00Bn4507kQ1@1=h@00Bn4507kQ1@1=h@00C>43083Q0`1>h@00on4Qh@00on4Qh@00
on4Qh@00on4Qh@00on4Qh@00on4Qh@00on4Qh@00on4Qh@00on4Qh@00on4Qh@00\
\>"],
  ImageRangeCache->{{{0, 287}, {287, 0}} -> {-1.10001, -0.952637, 0.00766559, 
  0.00663859}}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    \(draw[mm, \ F\  . \ P0]\)], "Input"],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: 1 
MathPictureStart
/Mabs {
Mgmatrix idtransform
Mtmatrix dtransform
} bind def
/Mabsadd { Mabs
3 -1 roll add
3 1 roll add
exch } bind def
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
0.5 0.454545 0.5 0.524864 [
[ 0 0 0 0 ]
[ 1 1 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 0 m
1 0 L
1 1 L
0 1 L
closepath
clip
newpath
0 g
.02 w
.72727 .95455 Mdot
.27273 .95455 Mdot
.04545 .5 Mdot
.27273 .04545 Mdot
.72727 .04545 Mdot
.95455 .5 Mdot
.38636 .72727 Mdot
.44318 .61364 Mdot
.44318 .61364 Mdot
.47159 .55682 Mdot
.40909 .31818 Mdot
.55682 .38636 Mdot
.55682 .38636 Mdot
.55682 .38636 Mdot
.68182 .5 Mdot
.5 Mabswid
.72727 .95455 m
.27273 .95455 L
s
.72727 .95455 m
.95455 .5 L
s
.72727 .95455 m
.38636 .72727 L
s
.72727 .95455 m
.44318 .61364 L
s
.72727 .95455 m
.44318 .61364 L
s
.72727 .95455 m
.47159 .55682 L
s
.72727 .95455 m
.68182 .5 L
s
.27273 .95455 m
.72727 .95455 L
s
.27273 .95455 m
.04545 .5 L
s
.27273 .95455 m
.38636 .72727 L
s
.04545 .5 m
.27273 .95455 L
s
.04545 .5 m
.27273 .04545 L
s
.04545 .5 m
.38636 .72727 L
s
.04545 .5 m
.44318 .61364 L
s
.04545 .5 m
.44318 .61364 L
s
.04545 .5 m
.47159 .55682 L
s
.04545 .5 m
.40909 .31818 L
s
.27273 .04545 m
.04545 .5 L
s
.27273 .04545 m
.72727 .04545 L
s
.27273 .04545 m
.40909 .31818 L
s
.72727 .04545 m
.27273 .04545 L
s
.72727 .04545 m
.95455 .5 L
s
.72727 .04545 m
.40909 .31818 L
s
.72727 .04545 m
.55682 .38636 L
s
.72727 .04545 m
.55682 .38636 L
s
.72727 .04545 m
.55682 .38636 L
s
.72727 .04545 m
.68182 .5 L
s
.95455 .5 m
.72727 .95455 L
s
.95455 .5 m
.72727 .04545 L
s
.95455 .5 m
.68182 .5 L
s
.38636 .72727 m
.72727 .95455 L
s
.38636 .72727 m
.27273 .95455 L
s
.38636 .72727 m
.04545 .5 L
s
.38636 .72727 m
.44318 .61364 L
s
.44318 .61364 m
.72727 .95455 L
s
.44318 .61364 m
.04545 .5 L
s
.44318 .61364 m
.38636 .72727 L
s
.44318 .61364 m
.44318 .61364 L
s
.44318 .61364 m
.72727 .95455 L
s
.44318 .61364 m
.04545 .5 L
s
.44318 .61364 m
.44318 .61364 L
s
.44318 .61364 m
.47159 .55682 L
s
.47159 .55682 m
.72727 .95455 L
s
.47159 .55682 m
.04545 .5 L
s
.47159 .55682 m
.44318 .61364 L
s
.47159 .55682 m
.40909 .31818 L
s
.47159 .55682 m
.55682 .38636 L
s
.47159 .55682 m
.55682 .38636 L
s
.47159 .55682 m
.55682 .38636 L
s
.47159 .55682 m
.68182 .5 L
s
.40909 .31818 m
.04545 .5 L
s
.40909 .31818 m
.27273 .04545 L
s
.40909 .31818 m
.72727 .04545 L
s
.40909 .31818 m
.47159 .55682 L
s
.40909 .31818 m
.55682 .38636 L
s
.55682 .38636 m
.72727 .04545 L
s
.55682 .38636 m
.47159 .55682 L
s
.55682 .38636 m
.40909 .31818 L
s
.55682 .38636 m
.55682 .38636 L
s
.55682 .38636 m
.72727 .04545 L
s
.55682 .38636 m
.47159 .55682 L
s
.55682 .38636 m
.55682 .38636 L
s
.55682 .38636 m
.55682 .38636 L
s
.55682 .38636 m
.72727 .04545 L
s
.55682 .38636 m
.47159 .55682 L
s
.55682 .38636 m
.55682 .38636 L
s
.55682 .38636 m
.68182 .5 L
s
.68182 .5 m
.72727 .95455 L
s
.68182 .5 m
.72727 .04545 L
s
.68182 .5 m
.95455 .5 L
s
.68182 .5 m
.47159 .55682 L
s
.68182 .5 m
.55682 .38636 L
s
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  ImageSize->{288, 288},
  ImageMargins->{{43, 0}, {0, 0}},
  ImageRegion->{{0, 1}, {0, 1}},
  ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`40004P000180P10`40000100000800002008200000
P800P020P<30`<3L`:K:l00003<006H009T00<`00?l0000c03<c06Hc09Tc0<`c0?lc001V03=V06IV
09UV0<aV0?mV002I03>I06JI09VI0<bI0?nI003<03?<06K<09W<0<c<0?o<003o03?o06Ko09Wo0<co
0?oo0000<c<0<fH0<iT0<l`0<ol0<`0c<c<c<fHc<iTc<l`c<olc<`1V<c=V<fIV<iUV<laV<omV<`2I
<c>I<fJI<iVI<lbI<onI<`3<<c?<<fK<<iW<<lc<<oo<<`3o<c?o<fKo<iWo<lco<ooo<`00IS<0IVH0
IYT0I/`0I_l0IP0cIS<cIVHcIYTcI/`cI_lcIP1VIS=VIVIVIYUVI/aVI_mVIP2IIS>IIVJIIYVII/bI
I_nIIP3<IS?<IVK<IYW<I/c<I_o<IP3oIS?oIVKoIYWoI/coI_ooIP00VC<0VFH0VIT0VL`0VOl0V@0c
VC<cVFHcVITcVL`cVOlcV@1VVC=VVFIVVIUVVLaVVOmVV@2IVC>IVFJIVIVIVLbIVOnIV@3<VC?<VFK<
VIW<VLc<VOo<V@3oVC?oVFKoVIWoVLcoVOooV@00c3<0c6H0c9T0c<`0c?l0c00cc3<cc6Hcc9Tcc<`c
c?lcc01Vc3=Vc6IVc9UVc<aVc?mVc02Ic3>Ic6JIc9VIc<bIc?nIc03<c3?<c6K<c9W<c<c<c?o<c03o
c3?oc6Koc9Woc<coc?ooc000oc<0ofH0oiT0ol`0ool0o`0coc<cofHcoiTcol`coolco`1Voc=VofIV
oiUVolaVoomVo`2Ioc>IofJIoiVIolbIoonIo`3<oc?<ofK<oiW<olc<ooo<o`3ooc?oofKooiWoolco
ooooo`0000410@820P<30`@410D51@H61PL71`P820T92@X:2P/;2``<30h>3Pl?3a0@414A4A8B4Q<C
4a@D5?okl:2PY820P?l0003o0?oo0000ool0o`3ooooooooQ8N400?oQ8N400?oQ8N400?oQ8N400?oQ
8N400?oQ8N400?oQ8N400?oQ8N400?oQ8N400?oQ8N400?oQ8N400?oQ8N4004cQ0`20h@<0C^4004_Q
1@1nh@D0CN4004_QR01=h@00Bn4507kQ1@1=h@00C>4407kQ101>h@00C>40103Qh@1lh@<000?Q0000
C^4004cQ00D0hN7Q001jh@080>7Q0>40h@1=h@00Bn400`3Qh@02h@030>7Q07OQ00H0hN40h@02h@03
0>7Q04_Q001;h@030>7Q00?Q00<0hN40MN401`3QhN40h@000n400`3Qh@1:h@00B^400`3Qh@04h@03
0>7Q07CQ00D0hN7Q0002h@050>7Qh@00C>4004[Q00<0hN401N400`3Qh@1bh@030>7Q00;Q00@0hN40
1>400`3Qh@19h@00BN400`3Qh@06h@030>7Q073Q0P04h@050>7Qh@001>400`3Qh@19h@00BN400`3Q
h@07h@030>7Q06kQ00<0hN401>401@3QhN4000GQ00<0hN40B>4004SQ00<0hN402>400`3Qh@1]h@03
0>7Q00CQ00<0hN400^400`3Qh@03h@030>7Q04SQ0018h@030>7Q00WQ00<0hN40Jn400`3Qh@05h@03
0>7Q00;Q00<0hN401>400`3Qh@17h@00An400`3Qh@0:h@030>7Q06[Q00<0hN401N400`3Qh@03h@03
0>7Q00CQ00<0hN40An4004OQ00<0hN402n400`3Qh@1Xh@030>7Q00KQ00<0hN400n400`3Qh@05h@03
0>7Q04KQ0016h@030>7Q00cQ00<0hN40I^4200SQ00<0hN400n400`3Qh@06h@030>7Q04KQ0016h@03
0>7Q00gQ00<0hN40I>400`3Qh@08h@030>7Q00?Q00<0hN401n400`3Qh@15h@00AN400`3Qh@0>h@03
0>7Q06?Q00<0hN402>400`3Qh@04h@030>7Q00OQ00<0hN40AN4004GQ00<0hN403n400`3Qh@1Qh@03
0>7Q00WQ00<0hN401>400`3Qh@08h@030>7Q04CQ0014h@030>7Q013Q00<0hN40H>400`3Qh@09h@03
0>7Q00GQ00<0hN402>400`3Qh@14h@00A>400`3Qh@0Ah@030>7Q05kQ00<0hN402^400`3Qh@05h@03
0>7Q00WQ00<0hN40@n4004?Q00<0hN404^400`3Qh@1Lh@803>400`3Qh@06h@030>7Q00WQ00<0hN40
@n4004?Q00<0hN404n400`3Qh@1Jh@030>7Q00cQ00<0hN401^400`3Qh@0:h@030>7Q04;Q0012h@03
0>7Q01CQ00<0hN40FN400`3Qh@0<h@030>7Q00OQ00<0hN402^400`3Qh@12h@00@^400`3Qh@0Eh@03
0>7Q05OQ00<0hN403N400`3Qh@07h@030>7Q00_Q00<0hN40@N40047Q00<0hN405^400`3Qh@1Fh@03
0>7Q00gQ00<0hN401n400`3Qh@0<h@030>7Q047Q0011h@030>7Q01OQ00<0hN40E>400`3Qh@0>h@03
0>7Q00OQ00<0hN403N400`3Qh@10h@00@>400`3Qh@0Hh@030>7Q05;Q0P0@h@030>7Q00SQ00<0hN40
3N400`3Qh@10h@00@>400`3Qh@0Ih@030>7Q053Q00<0hN404>400`3Qh@08h@030>7Q00kQ00<0hN40
?n4003oQ00<0hN406^400`3Qh@1?h@030>7Q013Q00<0hN402N400`3Qh@0>h@030>7Q03oQ000oh@03
0>7Q01_Q00<0hN40CN400`3Qh@0Ah@030>7Q00WQ00<0hN403n400`3Qh@0nh@00?^400`3Qh@0Lh@03
0>7Q04cQ00<0hN404N400`3Qh@0:h@030>7Q00oQ00<0hN40?^4003kQ00<0hN407N400`3Qh@1:h@03
0>7Q01;Q00<0hN402^400`3Qh@0@h@030>7Q03gQ000mh@030>7Q01kQ00<0hN40B>4201CQ00<0hN40
2n400`3Qh@0@h@030>7Q03gQ000mh@030>7Q01oQ00<0hN40A^400`3Qh@0Dh@030>7Q00_Q00<0hN40
4N400`3Qh@0lh@00?>400`3Qh@0Ph@030>7Q04GQ00<0hN405>400`3Qh@0;h@030>7Q01;Q00<0hN40
?>4003cQ00<0hN408N400`3Qh@13h@030>7Q01GQ00<0hN402n400`3Qh@0Ch@030>7Q03_Q000kh@03
0>7Q02;Q00<0hN40@^400`3Qh@0Eh@030>7Q00cQ00<0hN404n400`3Qh@0kh@00>n400`3Qh@0Sh@03
0>7Q043Q00<0hN405^400`3Qh@0<h@030>7Q01CQ00<0hN40>^4003[Q00<0hN409>400`3Qh@0nh@80
6>400`3Qh@0=h@030>7Q01CQ00<0hN40>^4003[Q00<0hN409N400`3Qh@0lh@030>7Q01SQ00<0hN40
3N400`3Qh@0Eh@030>7Q03WQ000ih@030>7Q02KQ00<0hN40>n400`3Qh@0Hh@030>7Q00kQ00<0hN40
5N400`3Qh@0ih@00>N400`3Qh@0Wh@030>7Q03WQ00<0hN406N400`3Qh@0>h@030>7Q01KQ00<0hN40
>>4003SQ00<0hN40:>400`3Qh@0hh@030>7Q01WQ00<0hN403n400`3Qh@0Fh@030>7Q03SQ000hh@03
0>7Q02WQ00<0hN40=^400`3Qh@0Jh@030>7Q00oQ00<0hN405n400`3Qh@0gh@00=n400`3Qh@0Zh@03
0>7Q03CQ0P0Lh@030>7Q00oQ00<0hN406>400`3Qh@0gh@00=n400`3Qh@0[h@030>7Q03;Q00<0hN40
7>400`3Qh@0?h@030>7Q01WQ00<0hN40=^4003KQ00<0hN40;>400`3Qh@0ah@030>7Q01cQ00<0hN40
4>400`3Qh@0Ih@030>7Q03KQ000fh@030>7Q02gQ00<0hN40;n400`3Qh@0Mh@030>7Q013Q00<0hN40
6^400`3Qh@0eh@00=N400`3Qh@0^h@030>7Q02kQ00<0hN407N400`3Qh@0Ah@030>7Q01[Q00<0hN40
=N4003GQ00<0hN40;n400`3Qh@0/h@030>7Q01kQ00<0hN404N400`3Qh@0Kh@030>7Q03CQ000dh@03
0>7Q033Q00<0hN40:^42023Q00<0hN404^400`3Qh@0Kh@030>7Q03CQ000dh@030>7Q037Q00<0hN40
:>400`3Qh@0Ph@030>7Q01;Q00<0hN407>400`3Qh@0ch@00<n400`3Qh@0bh@030>7Q02OQ00<0hN40
8>400`3Qh@0Ch@030>7Q01cQ00<0hN40<n4003?Q00<0hN40<n400`3Qh@0Uh@030>7Q027Q00<0hN40
4n400`3Qh@0Mh@030>7Q03;Q000bh@030>7Q03CQ00<0hN409>400`3Qh@0Qh@030>7Q01?Q00<0hN40
7^400`3Qh@0bh@00<^400`3Qh@0eh@030>7Q02;Q00<0hN408^400`3Qh@0Ch@030>7Q01oQ00<0hN40
<N40037Q00<0hN40=^400`3Qh@0Ph@809>400`3Qh@0Dh@030>7Q01oQ00<0hN40<N40037Q00<0hN40
=n400`3Qh@0Nh@030>7Q02CQ00<0hN405>400`3Qh@0Ph@030>7Q033Q000`h@030>7Q03SQ00<0hN40
7N400`3Qh@0Th@030>7Q01GQ00<0hN408>400`3Qh@0`h@00<>400`3Qh@0ih@030>7Q01_Q00<0hN40
9N400`3Qh@0Eh@030>7Q027Q00<0hN40;n4002oQ00<0hN40>^400`3Qh@0Jh@030>7Q02GQ00<0hN40
5^400`3Qh@0Qh@030>7Q02oQ000_h@030>7Q03_Q00<0hN406>400`3Qh@0Vh@030>7Q01KQ00<0hN40
8^400`3Qh@0^h@00;^400`3Qh@0lh@030>7Q01KQ0P0Xh@030>7Q01OQ00<0hN408^400`3Qh@0^h@00
;^400`3Qh@0mh@030>7Q01CQ00<0hN40:>400`3Qh@0Gh@030>7Q02?Q00<0hN40;N4002gQ00<0hN40
?^400`3Qh@0Ch@030>7Q02SQ00<0hN405n400`3Qh@0Th@030>7Q02gQ000]h@030>7Q03oQ00<0hN40
4N400`3Qh@0Yh@030>7Q01OQ00<0hN409N400`3Qh@0/h@00;>400`3Qh@10h@030>7Q013Q00<0hN40
:N400`3Qh@0Hh@030>7Q02GQ00<0hN40;>4002cQ00<0hN40@N400`3Qh@0>h@030>7Q02[Q00<0hN40
6>400`3Qh@0Vh@030>7Q02_Q000[h@030>7Q04;Q00<0hN403>4202cQ00<0hN406N400`3Qh@0Vh@03
0>7Q02_Q000[h@030>7Q04?Q00<0hN402^400`3Qh@0/h@030>7Q01WQ00<0hN409n400`3Qh@0Zh@00
:^400`3Qh@14h@030>7Q00WQ00<0hN40;>400`3Qh@0Jh@030>7Q02OQ00<0hN40:^4002[Q00<0hN40
AN400`3Qh@07h@030>7Q02gQ00<0hN406^400`3Qh@0Xh@030>7Q02WQ000Yh@030>7Q04KQ00<0hN40
1^400`3Qh@0]h@030>7Q01_Q00<0hN40:>400`3Qh@0Yh@00:N400`3Qh@17h@030>7Q00CQ00<0hN40
;^400`3Qh@0Kh@030>7Q02WQ00<0hN40:>4002SQ00<0hN40B>400`3Qh@02h@80<>400`3Qh@0Kh@03
0>7Q02[Q00<0hN40:>4002SQ00<0hN40BN4403;Q00<0hN406n400`3Qh@0[h@030>7Q02OQ000Wh@03
0>7Q04WQ1@0ah@030>7Q01cQ00<0hN40:n400`3Qh@0Wh@009n400`3Qh@19h@D0<N400`3Qh@0Lh@03
0>7Q02cQ00<0hN409^4002KQ00<0hN40B^4602oQ00<0hN407N400`3Qh@0/h@030>7Q02KQ000Vh@03
0>7Q04SQ0P001>400002h@80;N400`3Qh@0Mh@030>7Q02gQ00<0hN409N4002GQ00<0hN40An4200GQ
00<0hN400^4202[Q00<0hN407^400`3Qh@0]h@030>7Q02GQ000Uh@030>7Q04GQ0P07h@030>7Q00CQ
0P0Xh@030>7Q01kQ00<0hN40;^400`3Qh@0Th@009>400`3Qh@14h@802N400`3Qh@06h@<09>400`3Q
h@0Oh@030>7Q02kQ00<0hN409>4002CQ00<0hN40@^4200cQ00<0hN402>4202;Q00<0hN407n400`3Q
h@0_h@030>7Q02?Q000Sh@030>7Q047Q0P0>h@030>7Q00[Q0P0Oh@030>7Q01oQ00<0hN40<>400`3Q
h@0Sh@008n400`3Qh@0oh@804>400`3Qh@0<h@807N400`3Qh@0Oh@030>7Q037Q00<0hN408^4002;Q
00<0hN40?^4201;Q00<0hN403^4201[Q00<0hN408>400`3Qh@0ah@030>7Q02;Q000Rh@030>7Q03cQ
0P0Eh@030>7Q00oQ0`0Gh@030>7Q023Q00<0hN40<^400`3Qh@0Qh@008N400`3Qh@0kh@805n400`3Q
h@0Bh@805>400`3Qh@0Qh@030>7Q03;Q00<0hN408N40027Q00<0hN40>N4201WQ00<0hN405>4201;Q
00<0hN408N400`3Qh@0ch@030>7Q023Q000Ph@030>7Q03SQ0P0Kh@030>7Q01KQ0P0?h@030>7Q02;Q
00<0hN40<n400`3Qh@0Ph@008>400`3Qh@0fh@807^400`3Qh@0Gh@<03>400`3Qh@0Rh@030>7Q03CQ
00<0hN407n4001oQ00<0hN40=N42023Q00<0hN406^4200WQ00<0hN408n400`3Qh@0dh@030>7Q01oQ
000Oh@030>7Q03?Q0P0Rh@030>7Q01cQ0P07h@030>7Q02?Q00<0hN40=N400`3Qh@0Nh@007^400`3Q
h@0bh@809>400`3Qh@0Nh@801>400`3Qh@0Sh@030>7Q03KQ00<0hN407^4001kQ00<0hN40<>4202OQ
00<0hN407n4502GQ00<0hN40=n400`3Qh@0Mh@007N400`3Qh@0_h@80:N400`3Qh@0Ph@D09>400`3Q
h@0gh@030>7Q01gQ000Mh@030>7Q02gQ0P0[h@030>7Q023Q1@0Th@030>7Q03SQ00<0hN407>4001cQ
00<0hN40;>4202kQ00<0hN407n4502CQ00<0hN40>>400`3Qh@0Lh@007>400`3Qh@0Zh@80<>400`3Q
h@0Ph@<000?Q0>408^400`3Qh@0ih@030>7Q01_Q000Kh@030>7Q02WQ0P0bh@030>7Q01oQ00<0hN40
0n400`3Qh@0Ph@030>7Q03WQ00<0hN406n4001_Q00<0hN409n4203CQ00<0hN407n400`3Qh@04h@03
0>7Q01oQ00<0hN40>^400`3Qh@0Jh@006^400`3Qh@0Vh@80=n400`3Qh@0Mh@030>7Q00KQ0P0Oh@03
0>7Q03[Q00<0hN406^4001[Q00<0hN409>4203WQ00<0hN407N400`3Qh@08h@030>7Q01cQ00<0hN40
>n400`3Qh@0Ih@006N400`3Qh@0Sh@80>n400`3Qh@0Lh@030>7Q00[Q00<0hN406^400`3Qh@0lh@03
0>7Q01WQ000Ih@030>7Q027Q0P0mh@030>7Q01cQ00<0hN402n400`3Qh@0Ih@030>7Q03gQ00<0hN40
6>4001SQ00<0hN408>42043Q00<0hN406^400`3Qh@0=h@030>7Q01SQ00<0hN40?N400`3Qh@0Hh@00
6>400`3Qh@0Nh@80@^400`3Qh@0Jh@030>7Q00kQ00<0hN405n400`3Qh@0nh@030>7Q01OQ000Gh@03
0>7Q01gQ0P14h@030>7Q01WQ00<0hN404>400`3Qh@0Fh@030>7Q03kQ00<0hN405n4001OQ00<0hN40
6n4204KQ00<0hN406N400`3Qh@0Ah@030>7Q01GQ00<0hN40?n400`3Qh@0Fh@005^400`3Qh@0Jh@80
BN400`3Qh@0Gh@030>7Q01?Q00<0hN405>400`3Qh@0oh@030>7Q01KQ000Fh@030>7Q01SQ0P1;h@03
0>7Q01OQ00<0hN405>400`3Qh@0Ch@030>7Q043Q00<0hN405N4001GQ00<0hN405n4204gQ00<0hN40
5^400`3Qh@0Fh@030>7Q01;Q00<0hN40@>400`3Qh@0Eh@005N400`3Qh@0Eh@80D>400`3Qh@0Eh@03
0>7Q01OQ0P0Bh@030>7Q047Q00<0hN405>4001CQ00<0hN405>4205;Q00<0hN405>400`3Qh@0Jh@03
0>7Q00kQ00<0hN40@^400`3Qh@0Dh@005>400`3Qh@0Bh@80E>400`3Qh@0Dh@030>7Q01_Q00<0hN40
3N400`3Qh@13h@030>7Q01?Q000Ch@030>7Q017Q0P1Fh@030>7Q01?Q00<0hN407N400`3Qh@0<h@03
0>7Q04?Q00<0hN404n4001?Q00<0hN403n4205WQ00<0hN404^400`3Qh@0Nh@030>7Q00_Q00<0hN40
A>400`3Qh@0Bh@004^400`3Qh@0>h@80Fn400`3Qh@0Ah@030>7Q023Q00<0hN402^400`3Qh@14h@03
0>7Q01;Q000Bh@030>7Q00cQ0P1Mh@030>7Q017Q00<0hN408N400`3Qh@09h@030>7Q04GQ00<0hN40
4N40017Q00<0hN402n4205oQ00<0hN404>400`3Qh@0Sh@030>7Q00SQ00<0hN40AN400`3Qh@0Ah@00
4N400`3Qh@09h@80H^400`3Qh@0?h@030>7Q02CQ00<0hN401n400`3Qh@16h@030>7Q013Q000@h@03
0>7Q00SQ0P1Th@030>7Q00kQ00<0hN409^400`3Qh@06h@030>7Q04KQ00<0hN404>40013Q00<0hN40
1^4206KQ00<0hN403^400`3Qh@0Wh@030>7Q00GQ00<0hN40An400`3Qh@0?h@003n400`3Qh@05h@80
J>400`3Qh@0=h@030>7Q02WQ0P04h@030>7Q04SQ00<0hN403n4000oQ00<0hN400n4206_Q00<0hN40
3>400`3Qh@0[h@050>7Qh@00Bn400`3Qh@0>h@003^400`3Qh@02h@80KN400`3Qh@0;h@030>7Q02gQ
00@0hN40Bn400`3Qh@0>h@002n4400;Q0P1_h@030>7Q00_Q00<0hN40;^4404_Q0`0=h@002^47077Q
00<0hN402^400`3Qh@0_h@D0BN4500cQ000:h@L0L^400`3Qh@09h@030>7Q02oQD`0<h@002^4?06[Q
00<0hN402>400`3Qh@0]h@P0BN4500cQ000;h@@000CQ0>7Q0`03h@P0H^400`3Qh@08h@030>7Q02WQ
1004h@<0Bn4300gQ000>h@030>7Q00800n4400OQ1`1Lh@030>7Q00KQ00<0hN409^4400WQ00<0hN40
BN400`3Qh@0>h@003n401@3QhN4000KQ0`0;h@P0E>400`3Qh@06h@030>7Q02?Q0`0=h@030>7Q04WQ
00<0hN403^4000oQ00<0hN400^4200OQ0`0@h@L0CN400`3Qh@05h@030>7Q023Q100@h@030>7Q04SQ
00<0hN403n40013Q00<0hN400n400`3Qh@07h@@04n4804GQ00<0hN401N400`3Qh@0Lh@@05N400`3Q
h@17h@030>7Q00oQ000@h@030>7Q00CQ0P0;h@<06>4803kQ00<0hN400n400`3Qh@0Ih@@06N400`3Q
h@16h@030>7Q013Q000Ah@030>7Q00GQ00<0hN402n4401cQ1`0gh@030>7Q00?Q00<0hN405^4301gQ
00<0hN40A^400`3Qh@0@h@004N400`3Qh@06h@803n43023Q200_h@030>7Q00;Q00<0hN404n44023Q
00<0hN40AN400`3Qh@0Ah@004^400`3Qh@07h@030>7Q00oQ100Th@P09n400`3Qh@02h@030>7Q00oQ
100Th@030>7Q04GQ00<0hN404N4001;Q00<0hN402>4201?Q0`0Yh@L08N40103Qh@0>h@@0:>400`3Q
h@14h@030>7Q01;Q000Ch@030>7Q00WQ00<0hN404n4402cQ200Ih@040>7Q00_Q0`0/h@030>7Q04CQ
00<0hN404^4001?Q00<0hN402^4201OQ0`0ah@L04^400`3Q0008h@@0;n400`3Qh@13h@030>7Q01?Q
000Dh@030>7Q00_Q00<0hN405n4403CQ200:h@030>4000CQ100ch@030>7Q04?Q00<0hN404n4001CQ
00<0hN403>4201_Q0`0ih@P00^4703OQ00<0hN40@^400`3Qh@0Dh@005N400`3Qh@0=h@030>7Q01_Q
0`0nh@H0>n400`3Qh@11h@030>7Q01CQ000Eh@030>7Q00kQ0P0Nh@@0>n4503_Q00<0hN40@>400`3Q
h@0Eh@005^400`3Qh@0?h@030>7Q01oQ0`0hh@D0>n400`3Qh@10h@030>7Q01GQ000Fh@030>7Q013Q
0P0Rh@@0=N4403_Q00<0hN40?n400`3Qh@0Fh@005n400`3Qh@0Ah@030>7Q02?Q0`0ah@030>7Q00;Q
00<0hN40>>400`3Qh@0oh@030>7Q01KQ000Gh@030>7Q01;Q0P0Vh@@0;N400`3Qh@02h@030>7Q03SQ
00<0hN40?^400`3Qh@0Gh@006>400`3Qh@0Ch@030>7Q02OQ0`0Yh@030>7Q00CQ00<0hN40=n400`3Q
h@0nh@030>7Q01OQ000Hh@030>7Q01CQ0P0Zh@@09N400`3Qh@04h@030>7Q03OQ00<0hN40?N400`3Q
h@0Hh@006N400`3Qh@0Eh@030>7Q02_Q0`0Qh@030>7Q00KQ00<0hN40=^400`3Qh@0mh@030>7Q01SQ
000Ih@030>7Q01KQ0P0^h@@07N400`3Qh@07h@030>7Q03GQ00<0hN40?>400`3Qh@0Ih@006^400`3Q
h@0Gh@030>7Q02oQ0`0Ih@030>7Q00SQ00<0hN40=^400`3Qh@0kh@030>7Q01WQ000Jh@030>7Q01SQ
0P0bh@<05^400`3Qh@09h@030>7Q03GQ00<0hN40>^400`3Qh@0Jh@006n400`3Qh@0Ih@030>7Q03;Q
100Ah@030>7Q00_Q00<0hN40=>400`3Qh@0jh@030>7Q01[Q000Kh@030>7Q01[Q0P0fh@<03^400`3Q
h@0;h@030>7Q03CQ00<0hN40>N400`3Qh@0Kh@007>400`3Qh@0Kh@030>7Q03KQ1009h@030>7Q00gQ
00<0hN40<n400`3Qh@0ih@030>7Q01_Q000Lh@030>7Q01cQ0P0jh@<00n44013Q00<0hN40<^400`3Q
h@0hh@030>7Q01cQ000Mh@030>7Q01gQ00<0hN40>^47013Q00<0hN40<^400`3Qh@0hh@030>7Q01cQ
000Mh@030>7Q01kQ00<0hN40>n45017Q00<0hN40<N400`3Qh@0gh@030>7Q01gQ000Nh@030>7Q01kQ
0P0kh@D04^400`3Qh@0`h@030>7Q03OQ00<0hN407N4001kQ00<0hN408>400`3Qh@0ih@<000?Q0>40
4>400`3Qh@0`h@030>7Q03KQ00<0hN407^4001oQ00<0hN408>4203WQ00<0hN400^400`3Qh@0?h@03
0>7Q033Q00<0hN40=N400`3Qh@0Nh@007n400`3Qh@0Rh@030>7Q03KQ00<0hN400^400`3Qh@0?h@03
0>7Q033Q00<0hN40=>400`3Qh@0Oh@008>400`3Qh@0Rh@80=N400`3Qh@04h@030>7Q00oQ00<0hN40
;n400`3Qh@0dh@030>7Q01oQ000Ph@030>7Q02CQ00<0hN40<^400`3Qh@05h@030>7Q00oQ00<0hN40
;^400`3Qh@0ch@030>7Q023Q000Qh@030>7Q02CQ0P0ah@030>7Q00OQ00<0hN403^400`3Qh@0^h@03
0>7Q03?Q00<0hN408>40027Q00<0hN409^400`3Qh@0^h@030>7Q00SQ00<0hN403^400`3Qh@0]h@03
0>7Q03;Q00<0hN408N4002;Q00<0hN409^4202gQ00<0hN402^400`3Qh@0>h@030>7Q02cQ00<0hN40
<^400`3Qh@0Qh@008^400`3Qh@0Xh@030>7Q02[Q00<0hN402^400`3Qh@0>h@030>7Q02cQ00<0hN40
<N400`3Qh@0Rh@008n400`3Qh@0Xh@80:N400`3Qh@0<h@030>7Q00kQ00<0hN40:n400`3Qh@0ah@03
0>7Q02;Q000Sh@030>7Q02[Q00<0hN409^400`3Qh@0=h@030>7Q00kQ00<0hN40:^400`3Qh@0`h@03
0>7Q02?Q000Th@030>7Q02[Q0P0Uh@030>7Q00oQ00<0hN403N400`3Qh@0[h@030>7Q02oQ00<0hN40
8n4002CQ00<0hN40;>400`3Qh@0Rh@030>7Q013Q00<0hN403N400`3Qh@0Zh@030>7Q02kQ00<0hN40
9>4002GQ00<0hN40;>42027Q00<0hN404^400`3Qh@0<h@030>7Q02[Q00<0hN40;^400`3Qh@0Th@00
9N400`3Qh@0^h@030>7Q01gQ00<0hN404n400`3Qh@0=h@030>7Q02WQ00<0hN40;N400`3Qh@0Uh@00
9^400`3Qh@0^h@807N400`3Qh@0Dh@030>7Q00gQ00<0hN40:>400`3Qh@0]h@030>7Q02GQ000Vh@03
0>7Q033Q00<0hN406N400`3Qh@0Fh@030>7Q00cQ00<0hN40:>400`3Qh@0/h@030>7Q02KQ000Wh@03
0>7Q033Q0P0Ih@030>7Q01OQ00<0hN403>400`3Qh@0Wh@030>7Q02cQ00<0hN409^4002OQ00<0hN40
<^400`3Qh@0Eh@030>7Q01WQ00<0hN403>400`3Qh@0Vh@030>7Q02_Q00<0hN409n4002SQ00<0hN40
<^4201GQ00<0hN406^400`3Qh@0;h@030>7Q02KQ00<0hN40:n400`3Qh@0Wh@00:>400`3Qh@0dh@03
0>7Q017Q00<0hN406n400`3Qh@0<h@030>7Q02GQ00<0hN40:^400`3Qh@0Xh@00:N400`3Qh@0dh@80
4N400`3Qh@0Lh@030>7Q00cQ00<0hN409N400`3Qh@0Yh@030>7Q02SQ000Yh@030>7Q03KQ00<0hN40
3N400`3Qh@0Nh@030>7Q00_Q00<0hN409N400`3Qh@0Xh@030>7Q02WQ000Zh@030>7Q03KQ0P0=h@03
0>7Q01oQ00<0hN402n400`3Qh@0Th@030>7Q02SQ00<0hN40:N4002[Q00<0hN40>>400`3Qh@09h@03
0>7Q027Q00<0hN402n400`3Qh@0Sh@030>7Q02OQ00<0hN40:^4002_Q00<0hN40>>4200WQ00<0hN40
8^400`3Qh@0:h@030>7Q02?Q00<0hN409n400`3Qh@0Zh@00:n400`3Qh@0jh@030>7Q00GQ00<0hN40
8n400`3Qh@0;h@030>7Q02;Q00<0hN409^400`3Qh@0[h@00;>400`3Qh@0jh@801N400`3Qh@0Th@03
0>7Q00[Q00<0hN408^400`3Qh@0Vh@030>7Q02_Q000/h@030>7Q03cQ00D0hN7Q000Xh@030>7Q00[Q
00<0hN408N400`3Qh@0Uh@030>7Q02cQ000]h@030>7Q03cQ100Yh@030>7Q00[Q00<0hN408>400`3Q
h@0Uh@030>7Q02cQ000]h@030>7Q03cQ1@0Yh@030>7Q00WQ00<0hN408>400`3Qh@0Th@030>7Q02gQ
000^h@030>7Q03_Q1@0Zh@030>7Q00WQ00<0hN408>400`3Qh@0Sh@030>7Q02gQ000^h@030>7Q03_Q
1P0Yh@030>7Q00[Q00<0hN407n400`3Qh@0Rh@030>7Q02kQ000_h@030>7Q03_Q0`02h@80:>400`3Q
h@09h@030>7Q01oQ00<0hN408^400`3Qh@0^h@00;n400`3Qh@0jh@030>7Q00GQ00<0hN409^400`3Q
h@09h@030>7Q01kQ00<0hN408N400`3Qh@0_h@00<>400`3Qh@0ih@030>7Q00KQ0P0Wh@030>7Q00WQ
00<0hN407N400`3Qh@0Qh@030>7Q02oQ000`h@030>7Q03SQ00<0hN402N400`3Qh@0Uh@030>7Q00SQ
00<0hN407N400`3Qh@0Ph@030>7Q033Q000ah@030>7Q03OQ00<0hN402^4202KQ00<0hN402>400`3Q
h@0Lh@030>7Q023Q00<0hN40<>40037Q00<0hN40=^400`3Qh@0=h@030>7Q02?Q00<0hN402>400`3Q
h@0Lh@030>7Q01oQ00<0hN40<N4003;Q00<0hN40=N400`3Qh@0>h@809>400`3Qh@08h@030>7Q01_Q
00<0hN407n400`3Qh@0ah@00<^400`3Qh@0dh@030>7Q017Q00<0hN408^400`3Qh@08h@030>7Q01[Q
00<0hN407^400`3Qh@0bh@00<n400`3Qh@0ch@030>7Q01;Q0P0Sh@030>7Q00OQ00<0hN406n400`3Q
h@0Mh@030>7Q03;Q000ch@030>7Q03;Q00<0hN405N400`3Qh@0Qh@030>7Q00OQ00<0hN406^400`3Q
h@0Lh@030>7Q03?Q000dh@030>7Q037Q00<0hN405^4202;Q00<0hN401n400`3Qh@0Ih@030>7Q01cQ
00<0hN40<n4003CQ00<0hN40<>400`3Qh@0Ih@030>7Q01oQ00<0hN401n400`3Qh@0Ih@030>7Q01_Q
00<0hN40=>4003GQ00<0hN40;n400`3Qh@0Jh@808>400`3Qh@07h@030>7Q01SQ00<0hN406n400`3Q
h@0dh@00=N400`3Qh@0^h@030>7Q01gQ00<0hN407^400`3Qh@07h@030>7Q01OQ00<0hN406^400`3Q
h@0eh@00=^400`3Qh@0]h@030>7Q01kQ0P0Oh@030>7Q00KQ00<0hN405n400`3Qh@0Jh@030>7Q03GQ
000fh@030>7Q02cQ00<0hN408N400`3Qh@0Mh@030>7Q00KQ00<0hN405^400`3Qh@0Ih@030>7Q03KQ
000gh@030>7Q02_Q00<0hN408^4201kQ00<0hN401^400`3Qh@0Eh@030>7Q01WQ00<0hN40=^4003OQ
00<0hN40:^400`3Qh@0Uh@030>7Q01_Q00<0hN401^400`3Qh@0Eh@030>7Q01SQ00<0hN40=n4003SQ
00<0hN40:N400`3Qh@0Vh@807>400`3Qh@06h@030>7Q01GQ00<0hN405n400`3Qh@0gh@00>>400`3Q
h@0Xh@030>7Q02WQ00<0hN406^400`3Qh@05h@030>7Q01GQ00<0hN405^400`3Qh@0hh@00>N400`3Q
h@0Wh@030>7Q02[Q0P0Kh@030>7Q00GQ00<0hN405>400`3Qh@0Fh@030>7Q03SQ000ih@030>7Q02KQ
00<0hN40;N400`3Qh@0Ih@030>7Q00GQ00<0hN404n400`3Qh@0Eh@030>7Q03WQ000jh@030>7Q02GQ
00<0hN40;^4201[Q00<0hN401>400`3Qh@0Ch@030>7Q01GQ00<0hN40>N4003[Q00<0hN409>400`3Q
h@0ah@030>7Q01OQ00<0hN401N400`3Qh@0Bh@030>7Q01CQ00<0hN40>^4003_Q00<0hN408n400`3Q
h@0bh@806>400`3Qh@05h@030>7Q017Q00<0hN405>400`3Qh@0jh@00>n400`3Qh@0Rh@030>7Q03GQ
00<0hN405^400`3Qh@04h@030>7Q017Q00<0hN404n400`3Qh@0kh@00?>400`3Qh@0Qh@030>7Q03KQ
0P0Gh@030>7Q00CQ00<0hN404>400`3Qh@0Ch@030>7Q03_Q000lh@030>7Q023Q00<0hN40>N400`3Q
h@0Eh@030>7Q00CQ00<0hN403n400`3Qh@0Bh@030>7Q03cQ000mh@030>7Q01oQ00<0hN40>^4201KQ
00<0hN400n400`3Qh@0@h@030>7Q017Q00<0hN40?>4003gQ00<0hN407^400`3Qh@0mh@030>7Q01?Q
00<0hN401>400`3Qh@0?h@030>7Q013Q00<0hN40?N4003kQ00<0hN407N400`3Qh@0nh@805>400`3Q
h@04h@030>7Q00kQ00<0hN404>400`3Qh@0mh@00?^400`3Qh@0Lh@030>7Q047Q0P0Ch@030>7Q00?Q
00<0hN403^400`3Qh@0?h@030>7Q03kQ000oh@030>7Q01_Q00<0hN40@n400`3Qh@0Ah@030>7Q00?Q
00<0hN403N400`3Qh@0?h@030>7Q03kQ000oh@030>7Q01[Q00<0hN40AN4201;Q00<0hN400^400`3Q
h@0=h@030>7Q00kQ00<0hN40?n40043Q00<0hN406N400`3Qh@17h@030>7Q013Q00<0hN400^400`3Q
h@0<h@030>7Q00kQ00<0hN40?n40043Q00<0hN406>400`3Qh@19h@804>400`3Qh@03h@030>7Q00_Q
00<0hN403N400`3Qh@10h@00@N400`3Qh@0Gh@030>7Q04_Q00<0hN403^400`3Qh@02h@030>7Q00_Q
00<0hN403N400`3Qh@10h@00@N400`3Qh@0Fh@030>7Q04gQ0P0?h@030>7Q00;Q00<0hN402^400`3Q
h@0<h@030>7Q047Q0012h@030>7Q01GQ00<0hN40Cn400`3Qh@0=h@030>7Q00;Q00<0hN402^400`3Q
h@0;h@030>7Q047Q0012h@030>7Q01CQ00<0hN40DN4200kQ00D0hN7Q000<h@030>7Q00[Q00<0hN40
@^4004?Q00<0hN404n400`3Qh@1Ch@030>7Q00cQ00D0hN7Q000;h@030>7Q00[Q00<0hN40@^4004?Q
00<0hN404^400`3Qh@1Eh@803>400`3Qh@02h@030>7Q00SQ00<0hN402N400`3Qh@13h@00A>400`3Q
h@0Ah@030>7Q05OQ00<0hN402^401@3QhN4000[Q00<0hN402N400`3Qh@13h@00A>400`3Qh@0@h@03
0>7Q05WQ0P0;h@050>7Qh@002N400`3Qh@08h@030>7Q04CQ0015h@030>7Q00oQ00<0hN40Fn400`3Q
h@09h@040>7Q00WQ00<0hN402>400`3Qh@14h@00AN400`3Qh@0>h@030>7Q05gQ0P0:h@040>7Q00SQ
00<0hN401n400`3Qh@15h@00A^400`3Qh@0=h@030>7Q05oQ00<0hN402>40103Qh@07h@030>7Q00OQ
00<0hN40AN4004KQ00<0hN403>400`3Qh@1Qh@802>40103Qh@07h@030>7Q00KQ00<0hN40A^4004OQ
00<0hN402n400`3Qh@1Sh@030>7Q00KQ00@0hN401n400`3Qh@05h@030>7Q04KQ0017h@030>7Q00[Q
00<0hN40IN4200OQ00@0hN401^400`3Qh@04h@030>7Q04OQ0018h@030>7Q00WQ00<0hN40In400`3Q
h@05h@030>4000KQ00<0hN401>400`3Qh@17h@00B>400`3Qh@08h@030>7Q06WQ0P06h@030>4000GQ
00<0hN400n400`3Qh@18h@00BN400`3Qh@07h@030>7Q06_Q00<0hN401>400`3Q0004h@030>7Q00?Q
00<0hN40B>4004WQ00<0hN401^400`3Qh@1]h@801>400`3Q0004h@030>7Q00;Q00<0hN40BN4004[Q
00<0hN401N400`3Qh@1_h@030>7Q00;Q00<0h@000n400`3Qh@02h@030>7Q04WQ001:h@030>7Q00CQ
00<0hN40LN4200?Q00<0h@000^401@3QhN4004cQ001;h@030>7Q00?Q00<0hN40Ln40103QhN4200;Q
00D0hN7Q001<h@00Bn400`3Qh@02h@030>7Q07GQ0P02h@8000GQ0>7Q001=h@00C>401@3QhN4007WQ
00@0hN400^400`3Q001=h@00C>40103Qh@1kh@@000?Q0000C^4004gQ00<0h@00ON4504kQ001<h@<0
On4404kQ001;hHP0CN4004_Q1@1nh@D0CN4004_Q1@1nh@D0CN4004cQ0`20h@<0C^400?oQ8N400?oQ
8N400?oQ8N400?oQ8N400?oQ8N400?oQ8N400?oQ8N400?oQ8N400?oQ8N400?oQ8N400001\
\>"],
  ImageRangeCache->{{{0, 287}, {287, 0}} -> {-1.10001, -0.952637, 0.00766559, 
  0.00663859}}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    \(\(draw[mm, \ F\  . \ \ F\  . \ P0]
      \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \
\ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \
\ \)\)], "Input"],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: 1 
MathPictureStart
/Mabs {
Mgmatrix idtransform
Mtmatrix dtransform
} bind def
/Mabsadd { Mabs
3 -1 roll add
3 1 roll add
exch } bind def
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
0.5 0.454545 0.5 0.524864 [
[ 0 0 0 0 ]
[ 1 1 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 0 m
1 0 L
1 1 L
0 1 L
closepath
clip
newpath
0 g
.02 w
.72727 .95455 Mdot
.27273 .95455 Mdot
.04545 .5 Mdot
.27273 .04545 Mdot
.72727 .04545 Mdot
.95455 .5 Mdot
.37216 .75568 Mdot
.40057 .69886 Mdot
.42188 .65625 Mdot
.49716 .50568 Mdot
.41477 .30682 Mdot
.54119 .3267 Mdot
.57812 .34375 Mdot
.60937 .37216 Mdot
.6875 .48864 Mdot
.5 Mabswid
.72727 .95455 m
.27273 .95455 L
s
.72727 .95455 m
.95455 .5 L
s
.72727 .95455 m
.37216 .75568 L
s
.72727 .95455 m
.40057 .69886 L
s
.72727 .95455 m
.42188 .65625 L
s
.72727 .95455 m
.49716 .50568 L
s
.72727 .95455 m
.6875 .48864 L
s
.27273 .95455 m
.72727 .95455 L
s
.27273 .95455 m
.04545 .5 L
s
.27273 .95455 m
.37216 .75568 L
s
.04545 .5 m
.27273 .95455 L
s
.04545 .5 m
.27273 .04545 L
s
.04545 .5 m
.37216 .75568 L
s
.04545 .5 m
.40057 .69886 L
s
.04545 .5 m
.42188 .65625 L
s
.04545 .5 m
.49716 .50568 L
s
.04545 .5 m
.41477 .30682 L
s
.27273 .04545 m
.04545 .5 L
s
.27273 .04545 m
.72727 .04545 L
s
.27273 .04545 m
.41477 .30682 L
s
.72727 .04545 m
.27273 .04545 L
s
.72727 .04545 m
.95455 .5 L
s
.72727 .04545 m
.41477 .30682 L
s
.72727 .04545 m
.54119 .3267 L
s
.72727 .04545 m
.57812 .34375 L
s
.72727 .04545 m
.60937 .37216 L
s
.72727 .04545 m
.6875 .48864 L
s
.95455 .5 m
.72727 .95455 L
s
.95455 .5 m
.72727 .04545 L
s
.95455 .5 m
.6875 .48864 L
s
.37216 .75568 m
.72727 .95455 L
s
.37216 .75568 m
.27273 .95455 L
s
.37216 .75568 m
.04545 .5 L
s
.37216 .75568 m
.40057 .69886 L
s
.40057 .69886 m
.72727 .95455 L
s
.40057 .69886 m
.04545 .5 L
s
.40057 .69886 m
.37216 .75568 L
s
.40057 .69886 m
.42188 .65625 L
s
.42188 .65625 m
.72727 .95455 L
s
.42188 .65625 m
.04545 .5 L
s
.42188 .65625 m
.40057 .69886 L
s
.42188 .65625 m
.49716 .50568 L
s
.49716 .50568 m
.72727 .95455 L
s
.49716 .50568 m
.04545 .5 L
s
.49716 .50568 m
.42188 .65625 L
s
.49716 .50568 m
.41477 .30682 L
s
.49716 .50568 m
.54119 .3267 L
s
.49716 .50568 m
.57812 .34375 L
s
.49716 .50568 m
.60937 .37216 L
s
.49716 .50568 m
.6875 .48864 L
s
.41477 .30682 m
.04545 .5 L
s
.41477 .30682 m
.27273 .04545 L
s
.41477 .30682 m
.72727 .04545 L
s
.41477 .30682 m
.49716 .50568 L
s
.41477 .30682 m
.54119 .3267 L
s
.54119 .3267 m
.72727 .04545 L
s
.54119 .3267 m
.49716 .50568 L
s
.54119 .3267 m
.41477 .30682 L
s
.54119 .3267 m
.57812 .34375 L
s
.57812 .34375 m
.72727 .04545 L
s
.57812 .34375 m
.49716 .50568 L
s
.57812 .34375 m
.54119 .3267 L
s
.57812 .34375 m
.60937 .37216 L
s
.60937 .37216 m
.72727 .04545 L
s
.60937 .37216 m
.49716 .50568 L
s
.60937 .37216 m
.57812 .34375 L
s
.60937 .37216 m
.6875 .48864 L
s
.6875 .48864 m
.72727 .95455 L
s
.6875 .48864 m
.72727 .04545 L
s
.6875 .48864 m
.95455 .5 L
s
.6875 .48864 m
.49716 .50568 L
s
.6875 .48864 m
.60937 .37216 L
s
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  ImageSize->{288, 288},
  ImageMargins->{{43, 0}, {0, 0}},
  ImageRegion->{{0, 1}, {0, 1}},
  ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`40004P000180P10`40000100000800002008200000
P800P020P<30`<3L`:K:l00003<006H009T00<`00?l0000c03<c06Hc09Tc0<`c0?lc001V03=V06IV
09UV0<aV0?mV002I03>I06JI09VI0<bI0?nI003<03?<06K<09W<0<c<0?o<003o03?o06Ko09Wo0<co
0?oo0000<c<0<fH0<iT0<l`0<ol0<`0c<c<c<fHc<iTc<l`c<olc<`1V<c=V<fIV<iUV<laV<omV<`2I
<c>I<fJI<iVI<lbI<onI<`3<<c?<<fK<<iW<<lc<<oo<<`3o<c?o<fKo<iWo<lco<ooo<`00IS<0IVH0
IYT0I/`0I_l0IP0cIS<cIVHcIYTcI/`cI_lcIP1VIS=VIVIVIYUVI/aVI_mVIP2IIS>IIVJIIYVII/bI
I_nIIP3<IS?<IVK<IYW<I/c<I_o<IP3oIS?oIVKoIYWoI/coI_ooIP00VC<0VFH0VIT0VL`0VOl0V@0c
VC<cVFHcVITcVL`cVOlcV@1VVC=VVFIVVIUVVLaVVOmVV@2IVC>IVFJIVIVIVLbIVOnIV@3<VC?<VFK<
VIW<VLc<VOo<V@3oVC?oVFKoVIWoVLcoVOooV@00c3<0c6H0c9T0c<`0c?l0c00cc3<cc6Hcc9Tcc<`c
c?lcc01Vc3=Vc6IVc9UVc<aVc?mVc02Ic3>Ic6JIc9VIc<bIc?nIc03<c3?<c6K<c9W<c<c<c?o<c03o
c3?oc6Koc9Woc<coc?ooc000oc<0ofH0oiT0ol`0ool0o`0coc<cofHcoiTcol`coolco`1Voc=VofIV
oiUVolaVoomVo`2Ioc>IofJIoiVIolbIoonIo`3<oc?<ofK<oiW<olc<ooo<o`3ooc?oofKooiWoolco
ooooo`0000410@820P<30`@410D51@H61PL71`P820T92@X:2P/;2``<30h>3Pl?3a0@414A4A8B4Q<C
4a@D5?okl:2PY820P?l0003o0?oo0000ool0o`3ooooooooQ8N400?oQ8N400?oQ8N400?oQ8N400?oQ
8N400?oQ8N400?oQ8N400?oQ8N400?oQ8N400?oQ8N400?oQ8N400?oQ8N4004cQ0`20h@<0C^4004_Q
1@1nh@D0CN4004_QR01=h@00Bn4507kQ1@1=h@00C>4407kQ101>h@00C>401@3QhN4007_Q1P1>h@00
C>401@3QhN4007[Q00<0h@000`000n40h@1<h@00Bn400`3Qh@03h@030>7Q07KQ00<0hN400P001>40
h@1=h@00Bn400`3Qh@03h@030>7Q07GQ00<0hN401003h@030>7Q04[Q001:h@030>7Q00GQ00<0hN40
Ln400`3Qh@030003h@3Q00;Q00<0hN40B^4004[Q00<0hN401N400`3Qh@1ah@800n430003h@3Q00?Q
00<0hN40BN4004WQ00<0hN401n400`3Qh@1_h@030>7Q00;Q0P001>40h@04h@030>7Q04WQ0019h@03
0>7Q00OQ00<0hN40K^400`3Qh@02h@040>4000;Q00<0hN400n400`3Qh@18h@00B>400`3Qh@09h@03
0>7Q06cQ00<0hN400n420005h@3Qh@001N400`3Qh@18h@00B>400`3Qh@0:h@030>7Q06[Q00<0hN40
0n401@3Q0>4000;Q00<0hN401>400`3Qh@17h@00An400`3Qh@0;h@030>7Q06SQ0P05h@050>40h@00
0n400`3Qh@04h@030>7Q04OQ0017h@030>7Q00cQ00<0hN40I^400`3Qh@05h@050>40h@000n400`3Q
h@05h@030>7Q04KQ0016h@030>7Q00gQ00<0hN40IN400`3Qh@05h@030>4000;Q00D0hN7Q0007h@03
0>7Q04KQ0016h@030>7Q00kQ00<0hN40Hn400`3Qh@05h@060>7Q0>401>400`3Qh@06h@030>7Q04GQ
0015h@030>7Q00oQ00<0hN40H^400`3Qh@06h@030>4000;Q00<0hN400^400`3Qh@06h@030>7Q04GQ
0015h@030>7Q013Q00<0hN40H>400`3Qh@06h@060>7Q0>401>400`3Qh@08h@030>7Q04CQ0014h@03
0>7Q017Q00<0hN40G^4200SQ00@0hN400^400`3Qh@02h@030>7Q00SQ00<0hN40A>4004CQ00<0hN40
4^400`3Qh@1Lh@030>7Q00SQ00@0hN400^400`3Qh@02h@030>7Q00WQ00<0hN40@n4004?Q00<0hN40
4n400`3Qh@1Kh@030>7Q00SQ00@0hN400^400`3Qh@03h@030>7Q00WQ00<0hN40@n4004?Q00<0hN40
5>400`3Qh@1Ih@030>7Q00SQ00D0hN7Q0002h@030>7Q00?Q00<0hN402^400`3Qh@12h@00@^400`3Q
h@0Fh@030>7Q05OQ00<0hN402N40103Qh@03h@030>7Q00?Q00<0hN402^400`3Qh@12h@00@^400`3Q
h@0Fh@030>7Q05GQ0P0;h@050>7Qh@000^400`3Qh@04h@030>7Q00_Q00<0hN40@N40047Q00<0hN40
6>400`3Qh@1Ch@030>7Q00[Q00D0hN7Q0003h@030>7Q00CQ00<0hN402n400`3Qh@11h@00@N400`3Q
h@0Hh@030>7Q05;Q00<0hN402n401@3QhN4000;Q00<0hN401N400`3Qh@0<h@030>7Q043Q0010h@03
0>7Q01[Q00<0hN40D>400`3Qh@0;h@050>7Qh@000n400`3Qh@05h@030>7Q00cQ00<0hN40@>40043Q
00<0hN406^400`3Qh@1?h@030>7Q00_Q00<0hN400^401@3QhN4000OQ00<0hN403N400`3Qh@0oh@00
?n400`3Qh@0Lh@030>7Q04cQ0P0>h@050>7Qh@000n400`3Qh@05h@030>7Q00kQ00<0hN40?n4003oQ
00<0hN407>400`3Qh@1;h@030>7Q00gQ00<0hN400^401@3QhN4000OQ00<0hN403n400`3Qh@0nh@00
?^400`3Qh@0Nh@030>7Q04WQ00<0hN403N400`3Qh@02h@030>7Q00;Q00<0hN401N400`3Qh@0?h@03
0>7Q03kQ000nh@030>7Q01kQ00<0hN40B>400`3Qh@0>h@030>7Q00;Q00D0hN7Q0008h@030>7Q013Q
00<0hN40?N4003gQ00<0hN408>400`3Qh@16h@030>7Q00kQ00<0hN400^400`3Qh@02h@030>7Q00KQ
00<0hN404>400`3Qh@0mh@00?N400`3Qh@0Qh@030>7Q04CQ00<0hN403^400`3Qh@03h@030>7Q00;Q
00<0hN401^400`3Qh@0Ah@030>7Q03cQ000lh@030>7Q02;Q00<0hN40@^42017Q00<0hN400^400`3Q
h@02h@030>7Q00OQ00<0hN404N400`3Qh@0lh@00?>400`3Qh@0Sh@030>7Q043Q00<0hN404>400`3Q
h@03h@030>7Q00;Q00<0hN401n400`3Qh@0Bh@030>7Q03_Q000kh@030>7Q02CQ00<0hN40?n400`3Q
h@0@h@030>7Q00?Q00<0hN400^400`3Qh@08h@030>7Q01;Q00<0hN40>n4003_Q00<0hN409N400`3Q
h@0mh@030>7Q017Q00<0hN400n400`3Qh@02h@030>7Q00SQ00<0hN404n400`3Qh@0jh@00>^400`3Q
h@0Vh@030>7Q03cQ00<0hN404N400`3Qh@03h@030>7Q00?Q00<0hN402>400`3Qh@0Ch@030>7Q03[Q
000jh@030>7Q02OQ00<0hN40>N4201?Q00<0hN401>400`3Qh@02h@030>7Q00WQ00<0hN405>400`3Q
h@0ih@00>N400`3Qh@0Xh@030>7Q03SQ00<0hN404n400`3Qh@03h@030>7Q00?Q00<0hN402>400`3Q
h@0Eh@030>7Q03WQ000ih@030>7Q02WQ00<0hN40=^400`3Qh@0Ch@030>7Q00CQ00<0hN400n400`3Q
h@08h@030>7Q01KQ00<0hN40>>4003SQ00<0hN40:n400`3Qh@0dh@030>7Q01CQ00<0hN400n400`3Q
h@03h@030>7Q00WQ00<0hN405^400`3Qh@0hh@00>>400`3Qh@0[h@030>7Q03?Q00<0hN405>400`3Q
h@04h@030>7Q00?Q00<0hN402N400`3Qh@0Gh@030>7Q03OQ000gh@030>7Q02gQ00<0hN40<N400`3Q
h@0Dh@030>7Q00CQ00<0hN401>400`3Qh@09h@030>7Q01OQ00<0hN40=n4003OQ00<0hN40;N400`3Q
h@0_h@805n400`3Qh@04h@030>7Q00?Q00<0hN402^400`3Qh@0Hh@030>7Q03KQ000fh@030>7Q02oQ
00<0hN40;N400`3Qh@0Fh@030>7Q00CQ00<0hN401>400`3Qh@0:h@030>7Q01SQ00<0hN40=^4003KQ
00<0hN40;n400`3Qh@0/h@030>7Q01KQ00<0hN401N400`3Qh@03h@030>7Q00_Q00<0hN406N400`3Q
h@0eh@00=N400`3Qh@0ah@030>7Q02[Q00<0hN405n400`3Qh@04h@030>7Q00CQ00<0hN402n400`3Q
h@0Ih@030>7Q03GQ000eh@030>7Q037Q00<0hN40:N400`3Qh@0Gh@030>7Q00GQ00<0hN401>400`3Q
h@0;h@030>7Q01[Q00<0hN40=>4003CQ00<0hN40<n400`3Qh@0Vh@806N400`3Qh@05h@030>7Q00CQ
00<0hN403>400`3Qh@0Jh@030>7Q03CQ000dh@030>7Q03?Q00<0hN409N400`3Qh@0Ih@030>7Q00GQ
00<0hN401>400`3Qh@0;h@030>7Q01cQ00<0hN40<n4003?Q00<0hN40=N400`3Qh@0Sh@030>7Q01WQ
00<0hN401N400`3Qh@05h@030>7Q00_Q00<0hN407>400`3Qh@0ch@00<n400`3Qh@0fh@030>7Q027Q
00<0hN406N400`3Qh@06h@030>7Q00CQ00<0hN403>400`3Qh@0Mh@030>7Q03;Q000bh@030>7Q03OQ
00<0hN408>400`3Qh@0Jh@030>7Q00GQ00<0hN401N400`3Qh@0<h@030>7Q01gQ00<0hN40<^4003;Q
00<0hN40>>400`3Qh@0Mh@807>400`3Qh@06h@030>7Q00GQ00<0hN403>400`3Qh@0Nh@030>7Q037Q
000ah@030>7Q03WQ00<0hN407>400`3Qh@0Kh@030>7Q00KQ00<0hN401N400`3Qh@0=h@030>7Q01kQ
00<0hN40<N40037Q00<0hN40>^400`3Qh@0Jh@030>7Q01cQ00<0hN401^400`3Qh@05h@030>7Q00gQ
00<0hN407n400`3Qh@0`h@00<>400`3Qh@0kh@030>7Q01WQ00<0hN407>400`3Qh@06h@030>7Q00GQ
00<0hN403^400`3Qh@0Oh@030>7Q033Q000`h@030>7Q03cQ00<0hN405n400`3Qh@0Lh@030>7Q00OQ
00<0hN401N400`3Qh@0>h@030>7Q023Q00<0hN40;n4002oQ00<0hN40?N400`3Qh@0Fh@030>7Q01gQ
00<0hN401^400`3Qh@06h@030>7Q00kQ00<0hN408>400`3Qh@0_h@00;n400`3Qh@0nh@030>7Q01?Q
0P0Oh@030>7Q00OQ00<0hN401N400`3Qh@0?h@030>7Q027Q00<0hN40;^4002kQ00<0hN40?n400`3Q
h@0Bh@030>7Q01kQ00<0hN401n400`3Qh@06h@030>7Q00oQ00<0hN408N400`3Qh@0^h@00;^400`3Q
h@10h@030>7Q013Q00<0hN407n400`3Qh@07h@030>7Q00KQ00<0hN403^400`3Qh@0Sh@030>7Q02gQ
000]h@030>7Q04;Q00<0hN403^400`3Qh@0Oh@030>7Q00OQ00<0hN401^400`3Qh@0?h@030>7Q02?Q
00<0hN40;N4002gQ00<0hN40@^400`3Qh@0=h@030>7Q01oQ00<0hN402>400`3Qh@06h@030>7Q00oQ
00<0hN409>400`3Qh@0/h@00;>400`3Qh@14h@030>7Q00[Q0P0Rh@030>7Q00OQ00<0hN401n400`3Q
h@0?h@030>7Q02CQ00<0hN40;>4002cQ00<0hN40A>400`3Qh@09h@030>7Q027Q00<0hN402>400`3Q
h@06h@030>7Q013Q00<0hN409N400`3Qh@0[h@00:n400`3Qh@16h@030>7Q00OQ00<0hN408N400`3Q
h@08h@030>7Q00OQ00<0hN404>400`3Qh@0Uh@030>7Q02_Q000[h@030>7Q04KQ00<0hN401^400`3Q
h@0Rh@030>7Q00SQ00<0hN401^400`3Qh@0Ah@030>7Q02KQ00<0hN40:^4002[Q00<0hN40B>400`3Q
h@04h@030>7Q02;Q00<0hN402>400`3Qh@07h@030>7Q017Q00<0hN409^400`3Qh@0Zh@00:^400`3Q
h@18h@030>7Q00;Q0P0Th@030>7Q00WQ00<0hN401n400`3Qh@0Ah@030>7Q02OQ00<0hN40:N4002WQ
00<0hN40BN430003h@3Q02GQ00<0hN402>400`3Qh@07h@030>7Q01;Q00<0hN409n400`3Qh@0Yh@00
:N400`3Qh@18h@D09^400`3Qh@09h@030>7Q00OQ00<0hN404^400`3Qh@0Xh@030>7Q02SQ000Xh@03
0>7Q04WQ1`0Sh@030>7Q00WQ00<0hN402>400`3Qh@0Bh@030>7Q02SQ00<0hN40:>4002SQ00<0hN40
BN4500;Q1`0Lh@030>7Q00WQ00<0hN401n400`3Qh@0Bh@030>7Q02[Q00<0hN409n4002OQ00<0hN40
BN4600WQ1`0Dh@030>7Q00WQ00<0hN402>400`3Qh@0Bh@030>7Q02[Q00<0hN409n4002OQ00<0hN40
An4200GQ00<0hN403^4800_Q00<0hN402^400`3Qh@07h@030>7Q01?Q00<0hN40:n400`3Qh@0Vh@00
9^400`3Qh@16h@802>400`3Qh@0Eh@L00^4300_Q00<0hN402>400`3Qh@0Ch@030>7Q02_Q00<0hN40
9^4002KQ00<0hN40A>4200[Q00<0hN407>4600[Q00<0hN402>400`3Qh@0Ch@030>7Q02cQ00<0hN40
9N4002GQ00<0hN40@n4200cQ00<0hN407N4500WQ00<0hN402>400`3Qh@0Dh@030>7Q02cQ00<0hN40
9N4002GQ00<0hN40@N4200oQ00<0hN407>4700OQ00<0hN402>400`3Qh@0Dh@030>7Q02gQ00<0hN40
9>4002CQ00<0hN40@>42017Q00<0hN407N4300?Q0P02h@<02n400`3Qh@0Dh@030>7Q02gQ00<0hN40
9>4002CQ00<0hN40?^4201CQ00<0hN407>400`3Qh@05h@H02N400`3Qh@0Eh@030>7Q02kQ00<0hN40
8n4002?Q00<0hN40?N4201KQ00<0hN407>400`3Qh@06h@D02N400`3Qh@0Eh@030>7Q02kQ00<0hN40
8n4002?Q00<0hN40>n4201SQ00<0hN406n400`3Qh@07h@D02N400`3Qh@0Eh@030>7Q02oQ00<0hN40
8^4002;Q00<0hN40>^4201_Q00<0hN406^400`3Qh@08h@@02>400`3Qh@0Eh@030>7Q033Q00<0hN40
8^4002;Q00<0hN40>>4201gQ00<0hN406^400`3Qh@08h@050>7Qh@001n400`3Qh@0Eh@030>7Q037Q
00<0hN408N40027Q00<0hN40>>400`3Qh@0Nh@030>7Q01WQ00<0hN401n400`3Qh@03h@801>400`3Q
h@0Fh@030>7Q037Q00<0hN408N40027Q00<0hN40=^42027Q00<0hN406>400`3Qh@08h@030>7Q00GQ
00D0hN7Q000Hh@030>7Q03;Q00<0hN408>40023Q00<0hN40=N4202?Q00<0hN406>400`3Qh@07h@03
0>7Q00OQ00@0hN406>400`3Qh@0bh@030>7Q023Q000Ph@030>7Q03?Q0P0Vh@030>7Q01OQ00<0hN40
1n400`3Qh@08h@<06>400`3Qh@0ch@030>7Q01oQ000Oh@030>7Q03;Q0P0Xh@030>7Q01OQ00<0hN40
1^400`3Qh@08h@D05n400`3Qh@0ch@030>7Q01oQ000Oh@030>7Q033Q0P0[h@030>7Q01GQ00<0hN40
1n400`3Qh@08h@D05n400`3Qh@0dh@030>7Q01kQ000Nh@030>7Q02oQ0P0]h@030>7Q01GQ00<0hN40
1^400`3Qh@09h@D05n400`3Qh@0dh@030>7Q01kQ000Nh@030>7Q02gQ0P0_h@030>7Q01GQ00<0hN40
1^400`3Qh@09h@D05n400`3Qh@0eh@030>7Q01gQ000Mh@030>7Q02cQ0P0bh@030>7Q01CQ00<0hN40
1N400`3Qh@09h@030>7Q00?Q00<0hN405>400`3Qh@0eh@030>7Q01gQ000Mh@030>7Q02[Q0P0dh@03
0>7Q01?Q00<0hN401^400`3Qh@08h@030>7Q00CQ00<0hN405>400`3Qh@0fh@030>7Q01cQ000Lh@03
0>7Q02WQ0P0gh@030>7Q01;Q00<0hN401N400`3Qh@08h@030>7Q00KQ00<0hN404^400`3Qh@0gh@03
0>7Q01cQ000Lh@030>7Q02OQ0P0ih@030>7Q01;Q00<0hN401N400`3Qh@07h@030>7Q00SQ00<0hN40
4N400`3Qh@0hh@030>7Q01_Q000Kh@030>7Q02KQ0P0kh@030>7Q01;Q00<0hN401>400`3Qh@07h@03
0>7Q00WQ00<0hN404N400`3Qh@0hh@030>7Q01_Q000Kh@030>7Q02GQ00<0hN40?>400`3Qh@0@h@03
0>7Q00GQ00<0hN401n400`3Qh@0:h@030>7Q013Q00<0hN40>N400`3Qh@0Jh@006^400`3Qh@0Th@80
?n400`3Qh@0@h@030>7Q00CQ00<0hN401n400`3Qh@0<h@030>7Q00oQ00<0hN40>N400`3Qh@0Jh@00
6^400`3Qh@0Rh@80@^400`3Qh@0?h@030>7Q00CQ00<0hN401^400`3Qh@0=h@030>7Q00oQ00<0hN40
>^400`3Qh@0Ih@006N400`3Qh@0Qh@80A>400`3Qh@0?h@030>7Q00?Q00<0hN401^400`3Qh@0?h@03
0>7Q00kQ00<0hN40>^400`3Qh@0Ih@006N400`3Qh@0Oh@80An400`3Qh@0=h@030>7Q00CQ00<0hN40
1N400`3Qh@0Ah@030>7Q00gQ00<0hN40>n400`3Qh@0Hh@006>400`3Qh@0Nh@80BN400`3Qh@0=h@03
0>7Q00?Q00<0hN401^400`3Qh@0Ah@030>7Q00gQ00<0hN40>n400`3Qh@0Hh@006>400`3Qh@0Lh@80
Bn400`3Qh@0=h@030>7Q00?Q00<0hN401N400`3Qh@0Ch@030>7Q00cQ00<0hN40?>400`3Qh@0Gh@00
5n400`3Qh@0Kh@80C^400`3Qh@0<h@030>7Q00;Q00<0hN401N400`3Qh@0Eh@030>7Q00_Q00<0hN40
?>400`3Qh@0Gh@005n400`3Qh@0Ih@80D>400`3Qh@0;h@030>7Q00?Q00<0hN401>400`3Qh@0Fh@03
0>7Q00[Q00<0hN40?^400`3Qh@0Fh@005^400`3Qh@0Hh@80Dn400`3Qh@0:h@030>7Q00;Q00<0hN40
1>400`3Qh@0Hh@030>7Q00WQ00<0hN40?^400`3Qh@0Fh@005^400`3Qh@0Fh@80EN400`3Qh@0:h@03
0>7Q00;Q00<0hN400n400`3Qh@0Jh@030>7Q00SQ00<0hN40?n400`3Qh@0Eh@005N400`3Qh@0Eh@80
En400`3Qh@0:h@050>7Qh@001^400`3Qh@0Kh@030>7Q00OQ00<0hN40?n400`3Qh@0Eh@005N400`3Q
h@0Ch@80F^400`3Qh@08h@030>7Q00;Q00<0hN400n400`3Qh@0Lh@030>7Q00OQ00<0hN40@>400`3Q
h@0Dh@005>400`3Qh@0Bh@80G>400`3Qh@08h@050>7Qh@001N400`3Qh@0Nh@030>7Q00KQ00<0hN40
@>400`3Qh@0Dh@005>400`3Qh@0Ah@030>7Q05gQ00<0hN401n401@3QhN4000CQ00<0hN408>400`3Q
h@05h@030>7Q047Q00<0hN404n4001?Q00<0hN404>42063Q00<0hN401n40103Qh@04h@030>7Q027Q
00<0hN401N400`3Qh@11h@030>7Q01?Q000Ch@030>7Q00kQ0P1Rh@030>7Q00KQ00D0hN7Q0003h@03
0>7Q02?Q00<0hN401>400`3Qh@12h@030>7Q01;Q000Bh@030>7Q00gQ0P1Uh@030>7Q00GQ00@0hN40
1>400`3Qh@0Th@030>7Q00?Q00<0hN40@^400`3Qh@0Bh@004^400`3Qh@0;h@80In400`3Qh@05h@04
0>7Q00?Q00<0hN409N400`3Qh@03h@030>7Q04?Q00<0hN404N40017Q00<0hN402^4206[Q00<0hN40
1>400`3Q0003h@030>7Q02OQ00<0hN400^400`3Qh@13h@030>7Q017Q000Ah@030>7Q00SQ0P1/h@03
0>7Q00?Q00@0hN400^400`3Qh@0Yh@040>7Q04OQ00<0hN404>40013Q00<0hN401n4206kQ00<0hN40
0n400`3Q0002h@030>7Q02[Q00@0hN40An400`3Qh@0@h@004>400`3Qh@05h@80LN400`3Qh@02h@03
0>4000;Q00<0hN40:n400`3Q0018h@030>7Q00oQ000?h@030>7Q00CQ0P1ch@030>7Q00;Q0P02h@03
0>7Q02gQ0`17h@030>7Q00oQ000?h@030>7Q00;Q0P1fh@080>7Q0>40h@0_h@D0An400`3Qh@0>h@00
3^40103QhN4207SQ00<0hN400P000n40h@0/hA80?N400`3Qh@0>h@002n440003h@0007[Q00<0hN40
0`0Sh@/00n4500[Q6@0Uh@<03N4000[Q1P1mh@040>4001WQ2`0?h@<09>4J00[Q1@0<h@002^4T05oQ
100>h@/06n400`3Qh@0mh@l03>4000[Q1`0MhD007^4500?Q2`0Vh@030>7Q04OQ1@0<h@002n4805_Q
9P0ah@030>7Q04SQ0`0=h@003^400`3Qh@0507KQ1@0dh@030>7Q04OQ00<0hN403^4000oQ00L0hN40
h@3Q0080MN4303KQ00<0hN40A^400`3Qh@0>h@003n40103QhN440004h@0007;Q00@0hN40=N400`3Q
h@15h@030>7Q00oQ000@h@030>7Q00;Q00@0h@000^4206oQ00D0hN7Q000eh@030>7Q04GQ00<0hN40
3n40013Q00<0hN400n400`3Qh@0200;Q0P1]h@030>7Q00;Q00<0hN40<^400`3Qh@14h@030>7Q013Q
000Ah@030>7Q00?Q00@0hN7Q0P02h@<0JN400`3Qh@03h@030>7Q03;Q00<0hN40A>400`3Qh@0@h@00
4N400`3Qh@04h@800n400`3Qh@02h@80In400`3Qh@04h@030>7Q037Q00<0hN40@n400`3Qh@0Ah@00
4^400`3Qh@05h@040>7Qh@801>4306?Q00<0hN401N400`3Qh@0ah@030>7Q04?Q00<0hN404N4001;Q
00<0hN401^400`3Qh@02h@801N42067Q00<0hN401^400`3Qh@0`h@030>7Q04;Q00<0hN404^4001?Q
00<0hN401^400`3Qh@03h@801N4205kQ00<0hN401n400`3Qh@0`h@030>7Q04;Q00<0hN404^4001?Q
00<0hN401n4200GQ00<0hN401>4305_Q00<0hN402>400`3Qh@0_h@030>7Q047Q00<0hN404n4001CQ
00<0hN402>400`3Qh@03h@801n4205SQ00<0hN402N400`3Qh@0_h@030>7Q047Q00<0hN404n4001CQ
00<0hN402N400`3Qh@04h@801n4305GQ00<0hN402^400`3Qh@0^h@030>7Q043Q00<0hN405>4001GQ
00<0hN402N4200KQ0P08h@80D^400`3Qh@0;h@030>7Q02oQ00<0hN40?n400`3Qh@0Dh@005N400`3Q
h@0;h@030>7Q00GQ0P08h@80D>400`3Qh@0<h@030>7Q02kQ00<0hN40?^400`3Qh@0Eh@005^400`3Q
h@0;h@030>7Q00KQ00<0hN401n4304cQ00<0hN403N400`3Qh@0^h@030>7Q03kQ00<0hN405N4001KQ
00<0hN403>400`3Qh@06h@802^4204[Q00<0hN403^400`3Qh@0]h@030>7Q03gQ00<0hN405^4001OQ
00<0hN403>4200SQ0P0:h@<0A^400`3Qh@0?h@030>7Q02gQ00<0hN40?N400`3Qh@0Fh@005n400`3Q
h@0>h@030>7Q00OQ0P0;h@80A>400`3Qh@0@h@030>7Q02cQ00<0hN40?>400`3Qh@0Gh@006>400`3Q
h@0>h@030>7Q00SQ00<0hN402^42047Q00<0hN404N400`3Qh@0/h@030>7Q03cQ00<0hN405n4001SQ
00<0hN403n400`3Qh@08h@803>4303kQ00<0hN404^400`3Qh@0[h@030>7Q03_Q00<0hN406>4001WQ
00<0hN403n4200[Q0P0=h@80>n400`3Qh@0Ch@030>7Q02_Q00<0hN40>n400`3Qh@0Hh@006N400`3Q
h@0Ah@030>7Q00WQ0P0=h@<0>>400`3Qh@0Dh@030>7Q02[Q00<0hN40>^400`3Qh@0Ih@006^400`3Q
h@0Ah@030>7Q00[Q00<0hN403N4203GQ00<0hN405N400`3Qh@0Zh@030>7Q03[Q00<0hN406N4001[Q
00<0hN404^4200_Q0P0?h@80<n400`3Qh@0Fh@030>7Q02WQ00<0hN40>N400`3Qh@0Jh@006n400`3Q
h@0Ch@030>7Q00[Q0P0?h@<0;n400`3Qh@0Gh@030>7Q02[Q00<0hN40>>400`3Qh@0Jh@006n400`3Q
h@0Dh@030>7Q00_Q0P0@h@80;N400`3Qh@0Hh@030>7Q02WQ00<0hN40=n400`3Qh@0Kh@007>400`3Q
h@0Dh@030>7Q00cQ0P0@h@<0:N400`3Qh@0Ih@030>7Q02WQ00<0hN40=n400`3Qh@0Kh@007>400`3Q
h@0Eh@803^400`3Qh@0@h@809n400`3Qh@0Jh@030>7Q02SQ00<0hN40=^400`3Qh@0Lh@007N400`3Q
h@0Fh@030>7Q00cQ0P0Bh@809>400`3Qh@0Kh@030>7Q02SQ00<0hN40=^400`3Qh@0Lh@007N400`3Q
h@0Gh@030>7Q00gQ0P0Bh@<08N400`3Qh@0Lh@030>7Q02OQ00<0hN40=N400`3Qh@0Mh@007^400`3Q
h@0Gh@030>7Q00kQ0P0Ch@807^400`3Qh@0Mh@030>7Q02OQ00<0hN40=N400`3Qh@0Mh@007^400`3Q
h@0Hh@804>400`3Qh@0Bh@<06n400`3Qh@0Nh@030>7Q02KQ00<0hN40=>400`3Qh@0Nh@007n400`3Q
h@0Ih@030>7Q00kQ0P0Eh@806>400`3Qh@0Ph@030>7Q02GQ00<0hN40=>400`3Qh@0Nh@007n400`3Q
h@0Jh@030>7Q00oQ0P0Eh@805^400`3Qh@0Ph@030>7Q02GQ00<0hN40<n400`3Qh@0Oh@008>400`3Q
h@0Jh@804N4201GQ0`0Bh@030>7Q02;Q00<0hN409>400`3Qh@0ch@030>7Q01oQ000Ph@030>7Q01cQ
00<0hN404>400`3Qh@0Eh@804>400`3Qh@0Rh@030>7Q02CQ00<0hN40<^400`3Qh@0Ph@008N400`3Q
h@0Lh@030>7Q013Q0P0Gh@<03>400`3Qh@0Th@030>7Q02CQ00<0hN40<N400`3Qh@0Ph@008N400`3Q
h@0Mh@030>7Q017Q0P0Hh@802^400`3Qh@0Th@030>7Q02CQ00<0hN40<>400`3Qh@0Qh@008^400`3Q
h@0Mh@804n4201SQ0P07h@030>7Q02KQ00<0hN408n400`3Qh@0`h@030>7Q027Q000Rh@030>7Q01oQ
00<0hN404^4201SQ0`000n40000202SQ00<0hN408n400`3Qh@0_h@030>7Q02;Q000Sh@030>7Q01oQ
00<0hN404n400`3Qh@0Hh@D0:N400`3Qh@0Rh@030>7Q02oQ00<0hN408^4002?Q00<0hN408>400`3Q
h@0Ch@806>4502WQ00<0hN408^400`3Qh@0^h@030>7Q02?Q000Th@030>7Q023Q0P0Eh@805^4502[Q
00<0hN408N400`3Qh@0^h@030>7Q02?Q000Th@030>7Q02;Q00<0hN405>4201GQ0`000n40h@0Xh@03
0>7Q027Q00<0hN40;N400`3Qh@0Th@009N400`3Qh@0Rh@030>7Q01GQ00<0hN404^400`3Qh@02h@03
0>7Q02OQ00<0hN408>400`3Qh@0]h@030>7Q02CQ000Uh@030>7Q02?Q0P0Fh@804^400`3Qh@03h@03
0>7Q02KQ00<0hN408>400`3Qh@0/h@030>7Q02GQ000Vh@030>7Q02CQ00<0hN405N4200oQ00<0hN40
1N400`3Qh@0Vh@030>7Q01oQ00<0hN40;>400`3Qh@0Uh@009^400`3Qh@0Uh@030>7Q01KQ0P0<h@03
0>7Q00OQ00<0hN409N400`3Qh@0Oh@030>7Q02_Q00<0hN409^4002OQ00<0hN409N400`3Qh@0Gh@80
2^400`3Qh@08h@030>7Q02GQ00<0hN407n400`3Qh@0Zh@030>7Q02KQ000Wh@030>7Q02KQ0P0Ih@03
0>7Q00KQ00<0hN402^400`3Qh@0Th@030>7Q01oQ00<0hN40:N400`3Qh@0Wh@00:>400`3Qh@0Wh@03
0>7Q01OQ0P06h@030>7Q00_Q00<0hN409>400`3Qh@0Nh@030>7Q02WQ00<0hN409n4002SQ00<0hN40
:>400`3Qh@0Hh@8000CQ00003n400`3Qh@0Sh@030>7Q01kQ00<0hN40:>400`3Qh@0Xh@00:N400`3Q
h@0Xh@030>7Q01WQ1@0?h@030>7Q02?Q00<0hN407N400`3Qh@0Xh@030>7Q02SQ000Yh@030>7Q02WQ
0P0Ih@D04>400`3Qh@0Rh@030>7Q01gQ00<0hN409n400`3Qh@0Yh@00:^400`3Qh@0Zh@030>7Q01KQ
1@0Ah@030>7Q02;Q00<0hN407>400`3Qh@0Wh@030>7Q02WQ000Zh@030>7Q02_Q00<0hN405^45017Q
00<0hN408N400`3Qh@0Lh@030>7Q02KQ00<0hN40:^4002_Q00<0hN40:n4201GQ00<0hN400n400`3Q
h@0?h@030>7Q027Q00<0hN406n400`3Qh@0Vh@030>7Q02[Q000[h@030>7Q02gQ00<0hN404^400`3Q
h@04h@030>7Q00oQ00<0hN408>400`3Qh@0Kh@030>7Q02GQ00<0hN40:n4002cQ00<0hN40;N400`3Q
h@0@h@030>7Q00KQ0P0@h@030>7Q023Q00<0hN406^400`3Qh@0Uh@030>7Q02_Q000/h@030>7Q02kQ
00<0hN403n400`3Qh@08h@030>7Q00kQ00<0hN407n400`3Qh@0Jh@030>7Q02CQ00<0hN40;>4002gQ
00<0hN40;^4200kQ00<0hN402^400`3Qh@0>h@030>7Q01oQ00<0hN406^400`3Qh@0Sh@030>7Q02cQ
000]h@030>7Q033Q00<0hN402n400`3Qh@0;h@030>7Q00kQ00<0hN407^400`3Qh@0Jh@030>7Q02;Q
00<0hN40;N4002kQ00<0hN40<>400`3Qh@09h@030>7Q00gQ0P0?h@807n400`3Qh@0Ih@030>7Q02;Q
00<0hN40;N4002kQ00<0hN40<N400`3Qh@08h@030>7Q00oQ00<0hN403^400`3Qh@0Mh@030>7Q01SQ
00<0hN408N400`3Qh@0^h@00;n400`3Qh@0ah@801n400`3Qh@0Ah@030>7Q00kQ00<0hN407>400`3Q
h@0Hh@030>7Q027Q00<0hN40;^4002oQ00<0hN40<n400`3Qh@04h@030>7Q01;Q0P0?h@030>7Q01cQ
00<0hN405n400`3Qh@0Ph@030>7Q02oQ000`h@030>7Q03?Q00<0hN400^400`3Qh@0Eh@030>7Q00gQ
00<0hN406n400`3Qh@0Gh@030>7Q023Q00<0hN40;n40033Q00<0hN40=>4200;Q00<0hN405^400`3Q
h@0=h@030>7Q01_Q00<0hN405^400`3Qh@0Oh@030>7Q033Q000ah@030>7Q03GQ0`0Ih@030>7Q00gQ
00<0hN406^400`3Qh@0Fh@030>7Q01oQ00<0hN40<>40037Q00<0hN40=>4501WQ0P0>h@030>7Q01[Q
00<0hN405N400`3Qh@0Nh@030>7Q037Q000bh@030>7Q03?Q1@0Kh@030>7Q00cQ00<0hN406N400`3Q
h@0Eh@030>7Q01kQ00<0hN40<N4003;Q00<0hN40<n4701[Q00<0hN403>400`3Qh@0Ih@030>7Q01CQ
00<0hN407N400`3Qh@0bh@00<n400`3Qh@0ch@<00n4201WQ0P0=h@030>7Q01SQ00<0hN405N400`3Q
h@0Lh@030>7Q03;Q000ch@030>7Q03;Q00<0hN401^4201WQ00<0hN402n400`3Qh@0Hh@030>7Q01CQ
00<0hN406n400`3Qh@0ch@00=>400`3Qh@0ah@030>7Q00SQ00<0hN405n400`3Qh@0;h@030>7Q01OQ
00<0hN405>400`3Qh@0Kh@030>7Q03?Q000dh@030>7Q033Q00<0hN402^4201SQ00<0hN402n400`3Q
h@0Gh@030>7Q01?Q00<0hN406^400`3Qh@0dh@00=N400`3Qh@0_h@030>7Q00cQ0P0Gh@803>400`3Q
h@0Fh@030>7Q01?Q00<0hN406^400`3Qh@0dh@00=N400`3Qh@0^h@030>7Q00oQ0P0Gh@030>7Q00[Q
00<0hN405^400`3Qh@0Bh@030>7Q01WQ00<0hN40=N4003KQ00<0hN40;N400`3Qh@0Ah@030>7Q01GQ
00<0hN402^400`3Qh@0Eh@030>7Q01;Q00<0hN406N400`3Qh@0eh@00=^400`3Qh@0/h@030>7Q01?Q
0P0Fh@802n400`3Qh@0Eh@030>7Q017Q00<0hN406>400`3Qh@0fh@00=n400`3Qh@0[h@030>7Q01GQ
0P0Fh@030>7Q00WQ00<0hN405>400`3Qh@0Ah@030>7Q01SQ00<0hN40=^4003OQ00<0hN40:^400`3Q
h@0Hh@805N400`3Qh@09h@030>7Q01CQ00<0hN404>400`3Qh@0Gh@030>7Q03OQ000hh@030>7Q02WQ
00<0hN406^4201CQ00<0hN402N400`3Qh@0Ch@030>7Q013Q00<0hN405n400`3Qh@0gh@00>>400`3Q
h@0Xh@030>7Q01gQ00<0hN404^4200[Q00<0hN404n400`3Qh@0?h@030>7Q01KQ00<0hN40>>4003WQ
00<0hN409n400`3Qh@0Nh@805>400`3Qh@08h@030>7Q01;Q00<0hN404>400`3Qh@0Eh@030>7Q03SQ
000ih@030>7Q02KQ00<0hN408N4201?Q00<0hN402>400`3Qh@0Bh@030>7Q00oQ00<0hN405>400`3Q
h@0ih@00>^400`3Qh@0Uh@030>7Q02?Q0P0Bh@802N400`3Qh@0Ah@030>7Q00oQ00<0hN405>400`3Q
h@0ih@00>^400`3Qh@0Th@030>7Q02KQ0P0Bh@030>7Q00OQ00<0hN404N400`3Qh@0>h@030>7Q01?Q
00<0hN40>^4003_Q00<0hN408n400`3Qh@0Xh@030>7Q013Q00<0hN401n400`3Qh@0@h@030>7Q00kQ
00<0hN404n400`3Qh@0jh@00>n400`3Qh@0Rh@030>7Q02[Q0P0Ah@030>7Q00OQ00<0hN404>400`3Q
h@0=h@030>7Q01;Q00<0hN40>n4003cQ00<0hN408N400`3Qh@0/h@804>4200SQ00<0hN403n400`3Q
h@0=h@030>7Q01;Q00<0hN40>n4003cQ00<0hN408>400`3Qh@0_h@804>400`3Qh@06h@030>7Q00oQ
00<0hN403>400`3Qh@0Ah@030>7Q03cQ000mh@030>7Q01oQ00<0hN40<N4200oQ00<0hN401^400`3Q
h@0>h@030>7Q00cQ00<0hN404N400`3Qh@0lh@00?N400`3Qh@0Nh@030>7Q03CQ00<0hN403N4200OQ
00<0hN403^400`3Qh@0;h@030>7Q013Q00<0hN40?N4003kQ00<0hN407N400`3Qh@0eh@803n400`3Q
h@05h@030>7Q00gQ00<0hN402n400`3Qh@0@h@030>7Q03gQ000nh@030>7Q01cQ00<0hN40>>4200kQ
00<0hN401N400`3Qh@0=h@030>7Q00[Q00<0hN403n400`3Qh@0nh@00?n400`3Qh@0Kh@030>7Q03[Q
0P0=h@801^400`3Qh@0=h@030>7Q00[Q00<0hN403^400`3Qh@0nh@00?n400`3Qh@0Jh@030>7Q03gQ
00<0hN403>400`3Qh@04h@030>7Q00cQ00<0hN402^400`3Qh@0=h@030>7Q03oQ0010h@030>7Q01WQ
00<0hN40?^4200gQ00<0hN401>400`3Qh@0<h@030>7Q00WQ00<0hN403N400`3Qh@0oh@00@>400`3Q
h@0Hh@030>7Q047Q0P0<h@030>7Q00CQ00<0hN402n400`3Qh@09h@030>7Q00cQ00<0hN40@>40047Q
00<0hN405n400`3Qh@13h@802n4200GQ00<0hN402n400`3Qh@08h@030>7Q00cQ00<0hN40@>40047Q
00<0hN405^400`3Qh@16h@802n400`3Qh@03h@030>7Q00[Q00<0hN402>400`3Qh@0;h@030>7Q047Q
0012h@030>7Q01GQ00<0hN40B>400`3Qh@09h@030>7Q00?Q00<0hN402^400`3Qh@07h@030>7Q00_Q
00<0hN40@N4004;Q00<0hN405>400`3Qh@1:h@802^4200CQ00<0hN402N400`3Qh@07h@030>7Q00[Q
00<0hN40@^4004?Q00<0hN404n400`3Qh@1<h@802^400`3Qh@02h@030>7Q00WQ00<0hN401^400`3Q
h@0:h@030>7Q04;Q0013h@030>7Q01;Q00<0hN40Cn4200WQ00<0hN400^4200WQ00<0hN401^400`3Q
h@09h@030>7Q04?Q0014h@030>7Q017Q00<0hN40DN4200SQ00<0hN400n400`3Qh@07h@030>7Q00GQ
00<0hN402N400`3Qh@13h@00A>400`3Qh@0@h@030>7Q05CQ00<0hN401^4200CQ00<0hN401^400`3Q
h@05h@030>7Q00SQ00<0hN40A>4004GQ00<0hN403n400`3Qh@1Eh@802>400`3Qh@02h@030>7Q00KQ
00<0hN401N400`3Qh@07h@030>7Q04CQ0015h@030>7Q00kQ00<0hN40F>4200OQ00<0hN400^400`3Q
h@05h@030>7Q00GQ00<0hN401^400`3Qh@15h@00A^400`3Qh@0=h@030>7Q05[Q0P06h@800n400`3Q
h@05h@030>7Q00CQ00<0hN401^400`3Qh@15h@00A^400`3Qh@0<h@030>7Q05gQ0P06h@050>7Qh@00
1^400`3Qh@04h@030>7Q00GQ00<0hN40A^4004OQ00<0hN402n400`3Qh@1Oh@030>7Q00CQ00D0hN7Q
0006h@030>7Q00?Q00<0hN401N400`3Qh@16h@00An400`3Qh@0:h@030>7Q067Q0P05h@050>7Qh@00
1N400`3Qh@03h@030>7Q00CQ00<0hN40An4004SQ00<0hN402N400`3Qh@1Sh@801>4200;Q00<0hN40
0n400`3Qh@02h@030>7Q00CQ00<0hN40An4004SQ00<0hN402>400`3Qh@1Vh@801>40103Qh@04h@03
0>7Q00;Q00<0hN400n400`3Qh@18h@00BN400`3Qh@07h@030>7Q06SQ00<0hN400^40103Qh@04h@05
0>7Qh@001N400`3Qh@18h@00BN400`3Qh@06h@030>7Q06[Q0P03h@8000?Q0>400^401@3QhN4000CQ
00<0hN40BN4004[Q00<0hN401N400`3Qh@1/h@800n400`3Q0003h@040>7Q00CQ00<0hN40BN4004[Q
00<0hN401>400`3Qh@1_h@800^400`3Q0002h@040>7Q00?Q00<0hN40B^4004_Q00<0hN400n400`3Q
h@1ah@8000CQ0>400^40103Qh@02h@030>7Q04[Q001;h@030>7Q00;Q00<0hN40M>400`3Q00020007
h@3Qh@3Q001=h@00C>401@3QhN4007OQ0P002N400>40h@3Q001=h@00C>40103Qh@1jh@D000?Q0000
C^4004gQ00<0h@00O>4604kQ001<h@<0On4404kQ001;hHP0CN4004_Q1@1nh@D0CN4004_Q1@1nh@D0
CN4004cQ0`20h@<0C^400?oQ8N400?oQ8N400?oQ8N400?oQ8N400?oQ8N400?oQ8N400?oQ8N400?oQ
8N400?oQ8N400?oQ8N400001\
\>"],
  ImageRangeCache->{{{0, 287}, {287, 0}} -> {-1.10001, -0.952637, 0.00766559, 
  0.00663859}}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    \(draw[mm, \ F\  . \ \ F\  . \ \ F\ \  . \ P0]\)], "Input"],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: 1 
MathPictureStart
/Mabs {
Mgmatrix idtransform
Mtmatrix dtransform
} bind def
/Mabsadd { Mabs
3 -1 roll add
3 1 roll add
exch } bind def
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
0.5 0.454545 0.5 0.524864 [
[ 0 0 0 0 ]
[ 1 1 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 0 m
1 0 L
1 1 L
0 1 L
closepath
clip
newpath
0 g
.02 w
.72727 .95455 Mdot
.27273 .95455 Mdot
.04545 .5 Mdot
.27273 .04545 Mdot
.72727 .04545 Mdot
.95455 .5 Mdot
.36151 .77699 Mdot
.39169 .71662 Mdot
.41761 .66477 Mdot
.5032 .49361 Mdot
.41676 .28466 Mdot
.55433 .30043 Mdot
.59375 .3125 Mdot
.62251 .34588 Mdot
.70312 .47557 Mdot
.5 Mabswid
.72727 .95455 m
.27273 .95455 L
s
.72727 .95455 m
.95455 .5 L
s
.72727 .95455 m
.36151 .77699 L
s
.72727 .95455 m
.39169 .71662 L
s
.72727 .95455 m
.41761 .66477 L
s
.72727 .95455 m
.5032 .49361 L
s
.72727 .95455 m
.70312 .47557 L
s
.27273 .95455 m
.72727 .95455 L
s
.27273 .95455 m
.04545 .5 L
s
.27273 .95455 m
.36151 .77699 L
s
.04545 .5 m
.27273 .95455 L
s
.04545 .5 m
.27273 .04545 L
s
.04545 .5 m
.36151 .77699 L
s
.04545 .5 m
.39169 .71662 L
s
.04545 .5 m
.41761 .66477 L
s
.04545 .5 m
.5032 .49361 L
s
.04545 .5 m
.41676 .28466 L
s
.27273 .04545 m
.04545 .5 L
s
.27273 .04545 m
.72727 .04545 L
s
.27273 .04545 m
.41676 .28466 L
s
.72727 .04545 m
.27273 .04545 L
s
.72727 .04545 m
.95455 .5 L
s
.72727 .04545 m
.41676 .28466 L
s
.72727 .04545 m
.55433 .30043 L
s
.72727 .04545 m
.59375 .3125 L
s
.72727 .04545 m
.62251 .34588 L
s
.72727 .04545 m
.70312 .47557 L
s
.95455 .5 m
.72727 .95455 L
s
.95455 .5 m
.72727 .04545 L
s
.95455 .5 m
.70312 .47557 L
s
.36151 .77699 m
.72727 .95455 L
s
.36151 .77699 m
.27273 .95455 L
s
.36151 .77699 m
.04545 .5 L
s
.36151 .77699 m
.39169 .71662 L
s
.39169 .71662 m
.72727 .95455 L
s
.39169 .71662 m
.04545 .5 L
s
.39169 .71662 m
.36151 .77699 L
s
.39169 .71662 m
.41761 .66477 L
s
.41761 .66477 m
.72727 .95455 L
s
.41761 .66477 m
.04545 .5 L
s
.41761 .66477 m
.39169 .71662 L
s
.41761 .66477 m
.5032 .49361 L
s
.5032 .49361 m
.72727 .95455 L
s
.5032 .49361 m
.04545 .5 L
s
.5032 .49361 m
.41761 .66477 L
s
.5032 .49361 m
.41676 .28466 L
s
.5032 .49361 m
.55433 .30043 L
s
.5032 .49361 m
.59375 .3125 L
s
.5032 .49361 m
.62251 .34588 L
s
.5032 .49361 m
.70312 .47557 L
s
.41676 .28466 m
.04545 .5 L
s
.41676 .28466 m
.27273 .04545 L
s
.41676 .28466 m
.72727 .04545 L
s
.41676 .28466 m
.5032 .49361 L
s
.41676 .28466 m
.55433 .30043 L
s
.55433 .30043 m
.72727 .04545 L
s
.55433 .30043 m
.5032 .49361 L
s
.55433 .30043 m
.41676 .28466 L
s
.55433 .30043 m
.59375 .3125 L
s
.59375 .3125 m
.72727 .04545 L
s
.59375 .3125 m
.5032 .49361 L
s
.59375 .3125 m
.55433 .30043 L
s
.59375 .3125 m
.62251 .34588 L
s
.62251 .34588 m
.72727 .04545 L
s
.62251 .34588 m
.5032 .49361 L
s
.62251 .34588 m
.59375 .3125 L
s
.62251 .34588 m
.70312 .47557 L
s
.70312 .47557 m
.72727 .95455 L
s
.70312 .47557 m
.72727 .04545 L
s
.70312 .47557 m
.95455 .5 L
s
.70312 .47557 m
.5032 .49361 L
s
.70312 .47557 m
.62251 .34588 L
s
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  ImageSize->{288, 288},
  ImageMargins->{{43, 0}, {0, 0}},
  ImageRegion->{{0, 1}, {0, 1}},
  ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`40004P000180P10`40000100000800002008200000
P800P020P<30`<3L`:K:l00003<006H009T00<`00?l0000c03<c06Hc09Tc0<`c0?lc001V03=V06IV
09UV0<aV0?mV002I03>I06JI09VI0<bI0?nI003<03?<06K<09W<0<c<0?o<003o03?o06Ko09Wo0<co
0?oo0000<c<0<fH0<iT0<l`0<ol0<`0c<c<c<fHc<iTc<l`c<olc<`1V<c=V<fIV<iUV<laV<omV<`2I
<c>I<fJI<iVI<lbI<onI<`3<<c?<<fK<<iW<<lc<<oo<<`3o<c?o<fKo<iWo<lco<ooo<`00IS<0IVH0
IYT0I/`0I_l0IP0cIS<cIVHcIYTcI/`cI_lcIP1VIS=VIVIVIYUVI/aVI_mVIP2IIS>IIVJIIYVII/bI
I_nIIP3<IS?<IVK<IYW<I/c<I_o<IP3oIS?oIVKoIYWoI/coI_ooIP00VC<0VFH0VIT0VL`0VOl0V@0c
VC<cVFHcVITcVL`cVOlcV@1VVC=VVFIVVIUVVLaVVOmVV@2IVC>IVFJIVIVIVLbIVOnIV@3<VC?<VFK<
VIW<VLc<VOo<V@3oVC?oVFKoVIWoVLcoVOooV@00c3<0c6H0c9T0c<`0c?l0c00cc3<cc6Hcc9Tcc<`c
c?lcc01Vc3=Vc6IVc9UVc<aVc?mVc02Ic3>Ic6JIc9VIc<bIc?nIc03<c3?<c6K<c9W<c<c<c?o<c03o
c3?oc6Koc9Woc<coc?ooc000oc<0ofH0oiT0ol`0ool0o`0coc<cofHcoiTcol`coolco`1Voc=VofIV
oiUVolaVoomVo`2Ioc>IofJIoiVIolbIoonIo`3<oc?<ofK<oiW<olc<ooo<o`3ooc?oofKooiWoolco
ooooo`0000410@820P<30`@410D51@H61PL71`P820T92@X:2P/;2``<30h>3Pl?3a0@414A4A8B4Q<C
4a@D5?okl:2PY820P?l0003o0?oo0000ool0o`3ooooooooQ8N400?oQ8N400?oQ8N400?oQ8N400?oQ
8N400?oQ8N400?oQ8N400?oQ8N400?oQ8N400?oQ8N400?oQ8N400?oQ8N4004cQ0`20h@<0C^4004_Q
1@1nh@D0CN4004_QR01=h@00Bn4507kQ1@1=h@00C>4407gQ1@1>h@00C>401@3QhN4007_Q00<0h@00
0`1>h@00C>401@3QhN4007[Q00<0h@000`000n40h@1<h@00Bn400`3Qh@03h@030>7Q07GQ0P02h@80
00CQ0>40CN4004_Q00<0hN401>400`3Qh@1ch@040>7Qh@<000GQ0>7Q001<h@00B^400`3Qh@05h@03
0>7Q07;Q00@0hN7Q0P001>40h@02h@030>7Q04[Q001:h@030>7Q00KQ00<0hN40Kn4200CQ0`02h@05
0>7Qh@00Bn4004WQ00<0hN401n400`3Qh@1^h@030>7Q00?Q0P001>40h@04h@030>7Q04WQ0019h@03
0>7Q00SQ00<0hN40K>400`3Qh@03h@070>40h@3Q0005h@030>7Q04SQ0018h@030>7Q00[Q00<0hN40
JN4200KQ0P001N40hN4000GQ00<0hN40B>4004SQ00<0hN402^400`3Qh@1Xh@030>7Q00GQ00D0h@3Q
0002h@030>7Q00CQ00<0hN40An4004OQ00<0hN403>400`3Qh@1Vh@030>7Q00GQ00D0h@3Q0003h@03
0>7Q00CQ00<0hN40An4004OQ00<0hN403>400`3Qh@1Uh@030>7Q00KQ00D0h@3Q0003h@030>7Q00GQ
00<0hN40A^4004KQ00<0hN403^400`3Qh@1Rh@802>400`3Q0002h@050>7Qh@001n400`3Qh@16h@00
A^400`3Qh@0?h@030>7Q063Q00<0hN401n401P3Qh@3Q00CQ00<0hN401^400`3Qh@15h@00AN400`3Q
h@0@h@030>7Q05oQ00<0hN402>400`3Q0002h@030>7Q00;Q00<0hN401^400`3Qh@15h@00AN400`3Q
h@0Ah@030>7Q05cQ0P0:h@040>7Q00;Q00<0hN400^400`3Qh@07h@030>7Q04CQ0014h@030>7Q01;Q
00<0hN40Fn400`3Qh@09h@040>7Q00;Q00<0hN400n400`3Qh@07h@030>7Q04CQ0014h@030>7Q01?Q
00<0hN40FN400`3Qh@0:h@040>7Q00;Q00<0hN400n400`3Qh@08h@030>7Q04?Q0013h@030>7Q01GQ
00<0hN40E^4200cQ00@0hN400n400`3Qh@03h@030>7Q00SQ00<0hN40@n4004?Q00<0hN405N400`3Q
h@1Eh@030>7Q00_Q00D0hN7Q0002h@030>7Q00CQ00<0hN402N400`3Qh@12h@00@^400`3Qh@0Gh@03
0>7Q05?Q00<0hN403>40103Qh@03h@030>7Q00CQ00<0hN402N400`3Qh@12h@00@^400`3Qh@0Gh@03
0>7Q057Q0P0>h@050>7Qh@000n400`3Qh@04h@030>7Q00[Q00<0hN40@N40047Q00<0hN406N400`3Q
h@1?h@030>7Q00gQ00D0hN7Q0003h@030>7Q00GQ00<0hN402^400`3Qh@11h@00@N400`3Qh@0Jh@03
0>7Q04gQ00<0hN403^401@3QhN4000?Q00<0hN401N400`3Qh@0;h@030>7Q043Q0010h@030>7Q01_Q
00<0hN40C>400`3Qh@0>h@050>7Qh@001>400`3Qh@04h@030>7Q00cQ00<0hN40@>40043Q00<0hN40
7>400`3Qh@19h@804>400`3Qh@02h@050>7Qh@001n400`3Qh@0=h@030>7Q03oQ000oh@030>7Q01gQ
00<0hN40B>400`3Qh@0@h@050>7Qh@001>400`3Qh@05h@030>7Q00gQ00<0hN40?n4003oQ00<0hN40
7^400`3Qh@16h@030>7Q013Q00<0hN400^400`3Qh@02h@030>7Q00GQ00<0hN403^400`3Qh@0nh@00
?^400`3Qh@0Ph@030>7Q04?Q0P0Bh@030>7Q00;Q00<0hN400^400`3Qh@06h@030>7Q00kQ00<0hN40
?^4003kQ00<0hN408>400`3Qh@12h@030>7Q01;Q00<0hN400^400`3Qh@02h@030>7Q00KQ00<0hN40
3n400`3Qh@0mh@00?N400`3Qh@0Rh@030>7Q043Q00<0hN404^400`3Qh@02h@030>7Q00;Q00<0hN40
1n400`3Qh@0?h@030>7Q03gQ000mh@030>7Q02;Q00<0hN40?^4201CQ00<0hN400n400`3Qh@02h@03
0>7Q00OQ00<0hN404>400`3Qh@0lh@00?>400`3Qh@0Th@030>7Q03cQ00<0hN405>400`3Qh@02h@03
0>7Q00?Q00<0hN401n400`3Qh@0@h@030>7Q03cQ000lh@030>7Q02GQ00<0hN40>^400`3Qh@0Dh@03
0>7Q00?Q00<0hN400^400`3Qh@08h@030>7Q017Q00<0hN40>n4003_Q00<0hN409^400`3Qh@0hh@80
5^400`3Qh@03h@030>7Q00?Q00<0hN402>400`3Qh@0Ah@030>7Q03_Q000kh@030>7Q02OQ00<0hN40
=^400`3Qh@0Eh@030>7Q00CQ00<0hN400n400`3Qh@08h@030>7Q01;Q00<0hN40>^4003[Q00<0hN40
:N400`3Qh@0dh@030>7Q01KQ00<0hN400n400`3Qh@03h@030>7Q00WQ00<0hN404^400`3Qh@0jh@00
>^400`3Qh@0Yh@030>7Q03;Q0P0Hh@030>7Q00CQ00<0hN400n400`3Qh@09h@030>7Q01?Q00<0hN40
>N4003WQ00<0hN40:n400`3Qh@0`h@030>7Q01OQ00<0hN401>400`3Qh@04h@030>7Q00WQ00<0hN40
4n400`3Qh@0ih@00>N400`3Qh@0[h@030>7Q02oQ00<0hN406>400`3Qh@04h@030>7Q00?Q00<0hN40
2^400`3Qh@0Dh@030>7Q03SQ000hh@030>7Q02gQ00<0hN40;N400`3Qh@0Hh@030>7Q00CQ00<0hN40
1>400`3Qh@0:h@030>7Q01CQ00<0hN40>>4003SQ00<0hN40;^400`3Qh@0Zh@806^400`3Qh@05h@03
0>7Q00CQ00<0hN402N400`3Qh@0Fh@030>7Q03OQ000gh@030>7Q02oQ00<0hN40:N400`3Qh@0Jh@03
0>7Q00CQ00<0hN401>400`3Qh@0:h@030>7Q01KQ00<0hN40=n4003OQ00<0hN40<>400`3Qh@0Wh@03
0>7Q01[Q00<0hN401N400`3Qh@04h@030>7Q00[Q00<0hN405n400`3Qh@0fh@00=^400`3Qh@0ah@03
0>7Q02GQ0P0Lh@030>7Q00GQ00<0hN401N400`3Qh@0:h@030>7Q01OQ00<0hN40=^4003KQ00<0hN40
<^400`3Qh@0Sh@030>7Q01cQ00<0hN401N400`3Qh@04h@030>7Q00_Q00<0hN406>400`3Qh@0eh@00
=N400`3Qh@0dh@030>7Q027Q00<0hN407>400`3Qh@05h@030>7Q00GQ00<0hN402n400`3Qh@0Hh@03
0>7Q03GQ000eh@030>7Q03CQ00<0hN407n4201kQ00<0hN401^400`3Qh@05h@030>7Q00_Q00<0hN40
6N400`3Qh@0dh@00=>400`3Qh@0fh@030>7Q01gQ00<0hN407^400`3Qh@05h@030>7Q00GQ00<0hN40
3>400`3Qh@0Ih@030>7Q03CQ000dh@030>7Q03KQ00<0hN407>400`3Qh@0Nh@030>7Q00KQ00<0hN40
1N400`3Qh@0<h@030>7Q01[Q00<0hN40<n4003?Q00<0hN40>>400`3Qh@0Ih@808>400`3Qh@06h@03
0>7Q00KQ00<0hN403>400`3Qh@0Jh@030>7Q03?Q000ch@030>7Q03WQ00<0hN405n400`3Qh@0Ph@03
0>7Q00KQ00<0hN401N400`3Qh@0=h@030>7Q01_Q00<0hN40<^4003;Q00<0hN40>^400`3Qh@0Fh@03
0>7Q023Q00<0hN401^400`3Qh@06h@030>7Q00gQ00<0hN406n400`3Qh@0bh@00<^400`3Qh@0kh@03
0>7Q01CQ00<0hN408>400`3Qh@07h@030>7Q00GQ00<0hN403^400`3Qh@0Lh@030>7Q037Q000ah@03
0>7Q03cQ00<0hN404^4202?Q00<0hN401^400`3Qh@06h@030>7Q00kQ00<0hN407>400`3Qh@0ah@00
<N400`3Qh@0mh@030>7Q013Q00<0hN408^400`3Qh@07h@030>7Q00KQ00<0hN403^400`3Qh@0Mh@03
0>7Q033Q000`h@030>7Q03oQ00<0hN403^400`3Qh@0Rh@030>7Q00OQ00<0hN401^400`3Qh@0?h@03
0>7Q01gQ00<0hN40<>40033Q00<0hN40?n400`3Qh@0<h@809N400`3Qh@07h@030>7Q00KQ00<0hN40
3n400`3Qh@0Nh@030>7Q02oQ000_h@030>7Q047Q00<0hN402^400`3Qh@0Th@030>7Q00OQ00<0hN40
1n400`3Qh@0?h@030>7Q01kQ00<0hN40;n4002oQ00<0hN40@N400`3Qh@09h@030>7Q02CQ00<0hN40
2>400`3Qh@06h@030>7Q00oQ00<0hN408>400`3Qh@0^h@00;^400`3Qh@13h@030>7Q00KQ0P0Wh@03
0>7Q00OQ00<0hN401n400`3Qh@0?h@030>7Q023Q00<0hN40;^4002kQ00<0hN40A>400`3Qh@04h@03
0>7Q02KQ00<0hN402>400`3Qh@07h@030>7Q00oQ00<0hN408N400`3Qh@0]h@00;N400`3Qh@15h@03
0>7Q00?Q00<0hN409^400`3Qh@08h@030>7Q00OQ00<0hN404>400`3Qh@0Qh@030>7Q02gQ000]h@03
0>7Q04KQ00<0hN400P0Yh@030>7Q00SQ00<0hN401n400`3Qh@0@h@030>7Q02;Q00<0hN40;>4002cQ
00<0hN40An4302[Q00<0hN402>400`3Qh@08h@030>7Q013Q00<0hN408^400`3Qh@0/h@00;>400`3Q
h@16h@H09n400`3Qh@09h@030>7Q00OQ00<0hN404N400`3Qh@0Sh@030>7Q02_Q000[h@030>7Q04OQ
1@000n40000601oQ00<0hN402>400`3Qh@08h@030>7Q017Q00<0hN408n400`3Qh@0[h@00:n400`3Q
h@15h@L02N4801KQ00<0hN402N400`3Qh@08h@030>7Q017Q00<0hN409>400`3Qh@0Zh@00:^400`3Q
h@15h@040>7Qh@<04^4800[Q100;h@030>7Q00SQ00<0hN404^400`3Qh@0Th@030>7Q02[Q000Zh@03
0>7Q04?Q0P07h@030>7Q01OQ20000n40000300_Q00<0hN402>400`3Qh@0Bh@030>7Q02GQ00<0hN40
:N4002WQ00<0hN40@^4200WQ00<0hN407n4600[Q00<0hN402N400`3Qh@0Bh@030>7Q02GQ00<0hN40
:N4002WQ00<0hN40@>4200_Q00<0hN408>4900CQ0`0:h@030>7Q01?Q00<0hN409^400`3Qh@0Xh@00
:>400`3Qh@10h@030>7Q00cQ00<0hN408>4300GQ2009h@030>7Q01?Q00<0hN409^400`3Qh@0Xh@00
:>400`3Qh@0nh@803n400`3Qh@0Qh@030>7Q00OQ1@08h@030>7Q01CQ00<0hN409n400`3Qh@0Wh@00
9n400`3Qh@0mh@804^400`3Qh@0Ph@030>7Q00OQ1@08h@030>7Q01CQ00<0hN409n400`3Qh@0Wh@00
9n400`3Qh@0lh@030>7Q01;Q00<0hN408>400`3Qh@08h@@02>400`3Qh@0Dh@030>7Q02SQ00<0hN40
9^4002KQ00<0hN40>n4201KQ00<0hN407^400`3Qh@08h@050>7Qh@001n400`3Qh@0Eh@030>7Q02SQ
00<0hN409^4002KQ00<0hN40>N4201SQ00<0hN407^400`3Qh@08h@030>7Q00;Q00<0hN401>400`3Q
h@0Dh@030>7Q02[Q00<0hN409N4002GQ00<0hN40>>4201[Q00<0hN407^400`3Qh@07h@030>7Q00CQ
00<0hN400n400`3Qh@0Dh@030>7Q02[Q00<0hN409N4002GQ00<0hN40=n400`3Qh@0Kh@030>7Q01gQ
00<0hN401n400`3Qh@05h@050>7Qh@005n400`3Qh@0[h@030>7Q02CQ000Th@030>7Q03KQ0P0Nh@03
0>7Q01cQ00<0hN401n400`3Qh@07h@040>7Q01OQ00<0hN40:n400`3Qh@0Th@009>400`3Qh@0dh@80
8N400`3Qh@0Kh@030>7Q00OQ00<0hN401n4401OQ00<0hN40;>400`3Qh@0Sh@008n400`3Qh@0dh@03
0>7Q027Q00<0hN406n400`3Qh@06h@030>7Q00SQ1@0Fh@030>7Q02cQ00<0hN408n4002?Q00<0hN40
<^4202CQ00<0hN406^400`3Qh@07h@030>7Q00SQ1@0Fh@030>7Q02gQ00<0hN408^4002;Q00<0hN40
<N4202OQ00<0hN406N400`3Qh@06h@030>7Q00WQ1@0Fh@030>7Q02gQ00<0hN408^4002;Q00<0hN40
;n4202WQ00<0hN406N400`3Qh@06h@030>7Q00WQ100Gh@030>7Q02kQ00<0hN408N40027Q00<0hN40
;n400`3Qh@0Zh@030>7Q01SQ00<0hN401N400`3Qh@0:h@050>7Qh@005^400`3Qh@0^h@030>7Q027Q
000Qh@030>7Q02gQ0P0]h@030>7Q01OQ00<0hN401^400`3Qh@09h@030>7Q00;Q00<0hN405>400`3Q
h@0_h@030>7Q023Q000Ph@030>7Q02cQ0P0`h@030>7Q01KQ00<0hN401N400`3Qh@09h@030>7Q00CQ
00<0hN404n400`3Qh@0_h@030>7Q023Q000Ph@030>7Q02_Q00<0hN40<>400`3Qh@0Fh@030>7Q00GQ
00<0hN402>400`3Qh@06h@030>7Q01;Q00<0hN40<>400`3Qh@0Oh@007n400`3Qh@0Zh@80<n400`3Q
h@0Fh@030>7Q00CQ00<0hN402>400`3Qh@07h@030>7Q01;Q00<0hN40<>400`3Qh@0Oh@007n400`3Q
h@0Xh@80=^400`3Qh@0Dh@030>7Q00GQ00<0hN402>400`3Qh@08h@030>7Q017Q00<0hN40<N400`3Q
h@0Nh@007^400`3Qh@0Wh@80>>400`3Qh@0Dh@030>7Q00CQ00<0hN402>400`3Qh@0:h@030>7Q013Q
00<0hN40<N400`3Qh@0Nh@007^400`3Qh@0Vh@030>7Q03WQ00<0hN404n400`3Qh@04h@030>7Q00OQ
00<0hN402n400`3Qh@0@h@030>7Q03;Q00<0hN407N4001gQ00<0hN409N4203cQ00<0hN404^400`3Q
h@04h@030>7Q00OQ00<0hN403N400`3Qh@0>h@030>7Q03?Q00<0hN407N4001gQ00<0hN408n4203kQ
00<0hN404^400`3Qh@04h@030>7Q00KQ00<0hN403^400`3Qh@0>h@030>7Q03CQ00<0hN407>4001cQ
00<0hN408n400`3Qh@0oh@030>7Q017Q00<0hN400n400`3Qh@06h@030>7Q013Q00<0hN403N400`3Q
h@0dh@030>7Q01cQ000Lh@030>7Q027Q0P12h@030>7Q017Q00<0hN400n400`3Qh@06h@030>7Q017Q
00<0hN403>400`3Qh@0eh@030>7Q01_Q000Kh@030>7Q023Q0P15h@030>7Q00oQ00<0hN400n400`3Q
h@06h@030>7Q01;Q00<0hN403>400`3Qh@0eh@030>7Q01_Q000Kh@030>7Q01oQ00<0hN40AN400`3Q
h@0?h@030>7Q00?Q00<0hN401N400`3Qh@0Dh@030>7Q00_Q00<0hN40=^400`3Qh@0Jh@006^400`3Q
h@0Nh@80BN400`3Qh@0>h@030>7Q00;Q00<0hN401N400`3Qh@0Fh@030>7Q00[Q00<0hN40=^400`3Q
h@0Jh@006^400`3Qh@0Lh@80Bn400`3Qh@0>h@030>7Q00;Q00<0hN401>400`3Qh@0Gh@030>7Q00[Q
00<0hN40=n400`3Qh@0Ih@006N400`3Qh@0Kh@80CN400`3Qh@0=h@030>7Q00;Q00<0hN401N400`3Q
h@0Hh@030>7Q00WQ00<0hN40=n400`3Qh@0Ih@006N400`3Qh@0Jh@030>7Q04kQ00<0hN403>400`3Q
h@02h@030>7Q00CQ00<0hN406N400`3Qh@09h@030>7Q03SQ00<0hN406>4001SQ00<0hN406N42057Q
00<0hN403>401@3QhN4000KQ00<0hN406n400`3Qh@08h@030>7Q03SQ00<0hN406>4001SQ00<0hN40
5n4205CQ00<0hN402^400`3Qh@02h@030>7Q00?Q00<0hN407N400`3Qh@07h@030>7Q03WQ00<0hN40
5n4001OQ00<0hN405n400`3Qh@1Dh@030>7Q00[Q00D0hN7Q0005h@030>7Q01kQ00<0hN401n400`3Q
h@0ih@030>7Q01OQ000Gh@030>7Q01GQ0P1Gh@030>7Q00[Q00D0hN7Q0005h@030>7Q01oQ00<0hN40
1^400`3Qh@0jh@030>7Q01KQ000Fh@030>7Q01CQ0P1Jh@030>7Q00WQ00@0hN401N400`3Qh@0Qh@03
0>7Q00GQ00<0hN40>^400`3Qh@0Fh@005^400`3Qh@0Bh@80G>400`3Qh@08h@050>7Qh@001>400`3Q
h@0Rh@030>7Q00GQ00<0hN40>n400`3Qh@0Eh@005N400`3Qh@0Bh@030>7Q05gQ00<0hN401n40103Q
h@04h@030>7Q02CQ00<0hN401>400`3Qh@0kh@030>7Q01GQ000Eh@030>7Q013Q0P1Ph@030>7Q00OQ
00@0hN400n400`3Qh@0Uh@030>7Q00CQ00<0hN40?>400`3Qh@0Dh@005>400`3Qh@0?h@80Hn400`3Q
h@06h@030>4000CQ00<0hN409^400`3Qh@02h@030>7Q03gQ00<0hN405>4001CQ00<0hN403^400`3Q
h@1Sh@030>7Q00GQ00@0hN400n400`3Qh@0Xh@050>7Qh@00@>400`3Qh@0Ch@004n400`3Qh@0=h@80
I^400`3Qh@05h@030>4000?Q00<0hN40:N401@3QhN40043Q00<0hN404n4001?Q00<0hN402n4206WQ
00<0hN401>400`3Q0002h@030>7Q02_Q00@0hN40@N400`3Qh@0Bh@004^400`3Qh@0:h@80Jn400`3Q
h@03h@030>4000;Q00<0hN40;N400`3Q0011h@030>7Q01;Q000Bh@030>7Q00WQ00<0hN40K>400`3Q
h@02h@050>40h@00<>400`3Q0012h@030>7Q017Q000Ah@030>7Q00SQ0P1_h@030>7Q00;Q0P02h@03
0>7Q02oQ0`11h@030>7Q017Q000Ah@030>7Q00KQ0P1ah@030>7Q00;Q0P000n40h@0`h@D0@N400`3Q
h@0@h@004>400`3Qh@06h@030>7Q07;Q00<0hN400P000n40h@0^h@/0?^400`3Qh@0@h@004>400`3Q
h@04h@80MN400`3Qh@0302CQ3003h@D00n4:03GQ00<0hN403n4000oQ00<0hN400n4207SQ00@0h@00
6^4;013Q0`0>h@X0:n400`3Qh@0?h@003n40103QhN4207[Q100?h@/07>400`3Qh@0Gh@X08^400`3Q
h@0>h@003^401@3QhN4007_Q1@03h@`09n400`3Qh@0Qh@/05n400`3Qh@0>h@002n440003h@0005kQ
9P0ch@030>7Q02cQ2P0>h@<03N4000[Q1P0NhD807^4503KQ00<0hN40=^4:00?Q1@0<h@002^4T067Q
0`0gh@030>7Q043Q200<h@002^4707gQ00@0hN40=n400`3Qh@13h@D03>4000_Q201kh@050>7Qh@00
=^400`3Qh@14h@<03N4000kQ00<0h@00101hh@030>7Q00;Q00<0hN40=N400`3Qh@12h@030>7Q00kQ
000?h@030>4000H0MN400`3Qh@03h@030>7Q03CQ00<0hN40@^400`3Qh@0>h@003n401`3QhN40h@00
0^4207;Q00<0hN401>400`3Qh@0dh@030>7Q047Q00<0hN403n40013Q00H0hN7Q0>4200;Q0P1`h@03
0>7Q00GQ00<0hN40<n400`3Qh@11h@030>7Q00oQ000@h@030>7Q00;Q00@0hN400n4206gQ00<0hN40
1^400`3Qh@0ch@030>7Q043Q00<0hN404>40017Q00<0hN400^400`3Qh@0200?Q0`1Zh@030>7Q00OQ
00<0hN40<^400`3Qh@10h@030>7Q013Q000Ah@030>7Q00?Q00@0hN7Q0P04h@80In400`3Qh@08h@03
0>7Q03;Q00<0hN40?n400`3Qh@0Ah@004^400`3Qh@03h@030>7Q00;Q00<0hN400n4206GQ00<0hN40
2N400`3Qh@0ah@030>7Q03oQ00<0hN404N4001;Q00<0hN401>4200?Q0P05h@80H^400`3Qh@0:h@03
0>7Q037Q00<0hN40?^400`3Qh@0Bh@004n400`3Qh@05h@030>7Q00;Q00<0hN401>4305oQ00<0hN40
2n400`3Qh@0`h@030>7Q03kQ00<0hN404^4001?Q00<0hN401^400`3Qh@02h@801n4205cQ00<0hN40
3>400`3Qh@0`h@030>7Q03gQ00<0hN404n4001CQ00<0hN401^400`3Qh@03h@801n4205[Q00<0hN40
3N400`3Qh@0_h@030>7Q03gQ00<0hN404n4001CQ00<0hN401n400`3Qh@04h@030>7Q00KQ0P1Gh@03
0>7Q00kQ00<0hN40;n400`3Qh@0lh@030>7Q01CQ000Eh@030>7Q00OQ00<0hN401>4200SQ0`1Dh@03
0>7Q00oQ00<0hN40;^400`3Qh@0lh@030>7Q01CQ000Eh@030>7Q00SQ00<0hN401N400`3Qh@08h@80
DN400`3Qh@0@h@030>7Q02kQ00<0hN40>n400`3Qh@0Eh@005^400`3Qh@08h@801^4200[Q0P1?h@03
0>7Q017Q00<0hN40;N400`3Qh@0kh@030>7Q01GQ000Fh@030>7Q00[Q00<0hN401N4200[Q0P1<h@03
0>7Q01;Q00<0hN40;N400`3Qh@0jh@030>7Q01KQ000Gh@030>7Q00[Q00<0hN401^400`3Qh@09h@<0
BN400`3Qh@0Ch@030>7Q02cQ00<0hN40>^400`3Qh@0Fh@005n400`3Qh@0;h@030>7Q00KQ0P0<h@80
A^400`3Qh@0Dh@030>7Q02cQ00<0hN40>N400`3Qh@0Gh@006>400`3Qh@0;h@030>7Q00OQ00<0hN40
2n4204CQ00<0hN405N400`3Qh@0[h@030>7Q03WQ00<0hN405n4001SQ00<0hN403>400`3Qh@07h@80
3N42047Q00<0hN405^400`3Qh@0/h@030>7Q03OQ00<0hN406>4001WQ00<0hN403>400`3Qh@08h@80
3N4303kQ00<0hN405n400`3Qh@0[h@030>7Q03OQ00<0hN406>4001WQ00<0hN403N4200[Q00<0hN40
3N4203_Q00<0hN406>400`3Qh@0[h@030>7Q03KQ00<0hN406N4001[Q00<0hN403^400`3Qh@08h@80
3n4203WQ00<0hN406N400`3Qh@0Zh@030>7Q03KQ00<0hN406N4001[Q00<0hN403n400`3Qh@09h@03
0>7Q00kQ0`0eh@030>7Q01[Q00<0hN40:^400`3Qh@0eh@030>7Q01[Q000Kh@030>7Q00oQ00<0hN40
2N42017Q0P0ch@030>7Q01_Q00<0hN40:N400`3Qh@0eh@030>7Q01[Q000Kh@030>7Q013Q00<0hN40
2^42017Q0P0`h@030>7Q01cQ00<0hN40:N400`3Qh@0dh@030>7Q01_Q000Lh@030>7Q013Q00<0hN40
2n400`3Qh@0@h@80;^400`3Qh@0Mh@030>7Q02SQ00<0hN40=>400`3Qh@0Kh@007>400`3Qh@0Ah@03
0>7Q00_Q0P0Bh@<0:^400`3Qh@0Nh@030>7Q02SQ00<0hN40<n400`3Qh@0Lh@007N400`3Qh@0Ah@80
3N400`3Qh@0Bh@80:>400`3Qh@0Nh@030>7Q02SQ00<0hN40<n400`3Qh@0Lh@007N400`3Qh@0Ch@03
0>7Q00_Q0P0Dh@809N400`3Qh@0Ph@030>7Q02OQ00<0hN40<^400`3Qh@0Mh@007^400`3Qh@0Ch@03
0>7Q00cQ0P0Dh@808n400`3Qh@0Ph@030>7Q02OQ00<0hN40<^400`3Qh@0Mh@007^400`3Qh@0Dh@03
0>7Q00gQ00<0hN404n4301oQ00<0hN408^400`3Qh@0Vh@030>7Q037Q00<0hN407^4001oQ00<0hN40
5>400`3Qh@0=h@805^4201gQ00<0hN408^400`3Qh@0Vh@030>7Q037Q00<0hN407^4001oQ00<0hN40
5N400`3Qh@0>h@030>7Q01GQ0P0Jh@030>7Q02CQ00<0hN409N400`3Qh@0`h@030>7Q01oQ000Ph@03
0>7Q01GQ00<0hN403^4201OQ0P0Hh@030>7Q02CQ00<0hN409N400`3Qh@0`h@030>7Q01oQ000Ph@03
0>7Q01KQ00<0hN403n4201OQ0`0Dh@030>7Q02KQ00<0hN409>400`3Qh@0_h@030>7Q023Q000Qh@03
0>7Q01KQ0P0Ah@030>7Q01OQ0P0Bh@030>7Q02KQ00<0hN409>400`3Qh@0_h@030>7Q023Q000Qh@03
0>7Q01SQ00<0hN403n4201WQ0P0?h@030>7Q02SQ00<0hN408n400`3Qh@0^h@030>7Q027Q000Rh@03
0>7Q01SQ00<0hN404>400`3Qh@0Hh@803N400`3Qh@0Xh@030>7Q02CQ00<0hN40;N400`3Qh@0Qh@00
8^400`3Qh@0Ih@030>7Q013Q0P0Jh@<02N400`3Qh@0Zh@030>7Q02?Q00<0hN40;>400`3Qh@0Rh@00
8n400`3Qh@0Ih@030>7Q017Q0P0Kh@801n400`3Qh@0Zh@030>7Q02?Q00<0hN40;>400`3Qh@0Rh@00
8n400`3Qh@0Jh@030>7Q01;Q00<0hN406^4200CQ00<0hN40;>400`3Qh@0Rh@030>7Q02_Q00<0hN40
8n4002CQ00<0hN406^400`3Qh@0Bh@807>4502kQ00<0hN408^400`3Qh@0[h@030>7Q02?Q000Th@03
0>7Q01_Q0P0Dh@030>7Q01[Q1@0^h@030>7Q027Q00<0hN40:^400`3Qh@0Th@009N400`3Qh@0Lh@03
0>7Q01;Q0P0Jh@D0;^400`3Qh@0Qh@030>7Q02[Q00<0hN409>4002GQ00<0hN407N400`3Qh@0Ch@80
6>4502oQ00<0hN408>400`3Qh@0Yh@030>7Q02GQ000Vh@030>7Q01gQ00<0hN405>400`3Qh@0Fh@<0
00?Q0>40;N400`3Qh@0Ph@030>7Q02WQ00<0hN409N4002KQ00<0hN407^400`3Qh@0Dh@805N400`3Q
h@03h@030>7Q02cQ00<0hN407n400`3Qh@0Xh@030>7Q02KQ000Wh@030>7Q01kQ00<0hN405N400`3Q
h@0Bh@030>7Q00CQ00<0hN40:n400`3Qh@0Oh@030>7Q02SQ00<0hN409^4002OQ00<0hN407n400`3Q
h@0Eh@804N400`3Qh@06h@030>7Q02_Q00<0hN407^400`3Qh@0Wh@030>7Q02OQ000Xh@030>7Q01oQ
0P0Gh@803n400`3Qh@07h@80:n400`3Qh@0Nh@030>7Q02OQ00<0hN409n4002SQ00<0hN408N400`3Q
h@0Fh@030>7Q00_Q00<0hN402^400`3Qh@0Yh@030>7Q01gQ00<0hN409^400`3Qh@0Xh@00:N400`3Q
h@0Qh@030>7Q01KQ0P0;h@030>7Q00_Q00<0hN40:>400`3Qh@0Mh@030>7Q02KQ00<0hN40:>4002WQ
00<0hN408^400`3Qh@0Gh@030>7Q00OQ00<0hN403N400`3Qh@0Xh@030>7Q01cQ00<0hN409N400`3Q
h@0Yh@00:^400`3Qh@0Rh@030>7Q01OQ0P07h@030>7Q00kQ00<0hN409n400`3Qh@0Lh@030>7Q02GQ
00<0hN40:N4002[Q00<0hN408n400`3Qh@0Hh@801>400`3Qh@0@h@030>7Q02OQ00<0hN406n400`3Q
h@0Th@030>7Q02[Q000[h@030>7Q02?Q00<0hN406N400`3Q000201?Q00<0hN409^400`3Qh@0Kh@03
0>7Q02CQ00<0hN40:^4002_Q00<0hN409>4201[Q1@0Ch@030>7Q02KQ00<0hN406^400`3Qh@0Sh@03
0>7Q02_Q000/h@030>7Q02GQ00<0hN405n4501CQ00<0hN409N400`3Qh@0Kh@030>7Q02;Q00<0hN40
:n4002cQ00<0hN409^400`3Qh@0Fh@D05N400`3Qh@0Uh@030>7Q01[Q00<0hN408N400`3Qh@0/h@00
;N400`3Qh@0Vh@030>7Q01KQ0`000n40h@0Dh@030>7Q02CQ00<0hN406^400`3Qh@0Qh@030>7Q02cQ
000]h@030>7Q02OQ00<0hN405>400`3Qh@03h@030>7Q01?Q00<0hN408n400`3Qh@0Jh@030>7Q023Q
00<0hN40;N4002kQ00<0hN409n400`3Qh@0Ch@030>7Q00CQ0P0Dh@030>7Q02?Q00<0hN406N400`3Q
h@0Ph@030>7Q02gQ000^h@030>7Q02SQ00<0hN404N400`3Qh@07h@030>7Q01;Q00<0hN408^400`3Q
h@0Ih@030>7Q01oQ00<0hN40;^4002oQ00<0hN40:>42017Q00<0hN402>4201?Q0P0Sh@030>7Q01SQ
00<0hN407n400`3Qh@0^h@00;n400`3Qh@0Zh@030>7Q00gQ00<0hN402n400`3Qh@0Bh@030>7Q023Q
00<0hN406>400`3Qh@0Nh@030>7Q02oQ000`h@030>7Q02[Q00<0hN403>400`3Qh@0<h@030>7Q01;Q
00<0hN408>400`3Qh@0Gh@030>7Q01kQ00<0hN40;n40033Q00<0hN40:n400`3Qh@0:h@030>7Q00kQ
0P0Ch@030>7Q01oQ00<0hN405n400`3Qh@0Mh@030>7Q033Q000ah@030>7Q02_Q00<0hN402N400`3Q
h@0@h@030>7Q017Q00<0hN407n400`3Qh@0Fh@030>7Q01gQ00<0hN40<>40037Q00<0hN40;>400`3Q
h@07h@030>7Q01;Q0P0Bh@030>7Q01kQ00<0hN405^400`3Qh@0Lh@030>7Q037Q000bh@030>7Q02cQ
00<0hN401^400`3Qh@0Dh@030>7Q013Q00<0hN407^400`3Qh@0Eh@030>7Q01cQ00<0hN40<N4003;Q
00<0hN40;N4200GQ00<0hN405^42017Q00<0hN407N400`3Qh@0Eh@030>7Q01_Q00<0hN40<^4003?Q
00<0hN40;^400`3Qh@02h@030>7Q01SQ00<0hN403n400`3Qh@0Mh@030>7Q01CQ00<0hN406n400`3Q
h@0bh@00<n400`3Qh@0_h@040>7Q01cQ00<0hN403n400`3Qh@0Lh@030>7Q01CQ00<0hN406^400`3Q
h@0ch@00=>400`3Qh@0_h@<07N42013Q00<0hN407>400`3Qh@0Ch@030>7Q01[Q00<0hN40<n4003CQ
00<0hN40;^4501kQ00<0hN403^400`3Qh@0Kh@030>7Q01?Q00<0hN406N400`3Qh@0dh@00=N400`3Q
h@0]h@H07^4200oQ00<0hN406n400`3Qh@0Bh@030>7Q01WQ00<0hN40=>4003GQ00<0hN40;N450003
h@0001kQ00<0hN403N400`3Qh@0Jh@030>7Q01;Q00<0hN406>400`3Qh@0eh@00=^400`3Qh@0]h@<0
1>4201gQ00<0hN403N4201_Q00<0hN404^400`3Qh@0Gh@030>7Q03GQ000fh@030>7Q02cQ00<0hN40
1n4201cQ0P0?h@030>7Q01SQ00<0hN404^400`3Qh@0Fh@030>7Q03KQ000gh@030>7Q02_Q00<0hN40
2N4201cQ00<0hN403N400`3Qh@0Hh@030>7Q017Q00<0hN405^400`3Qh@0fh@00=n400`3Qh@0Zh@03
0>7Q00cQ0P0Kh@803^400`3Qh@0Gh@030>7Q017Q00<0hN405N400`3Qh@0gh@00>>400`3Qh@0Yh@03
0>7Q00kQ0P0Kh@030>7Q00cQ00<0hN405n400`3Qh@0@h@030>7Q01GQ00<0hN40=n4003SQ00<0hN40
:>400`3Qh@0Ah@806^400`3Qh@0<h@030>7Q01KQ00<0hN404>400`3Qh@0Dh@030>7Q03SQ000ih@03
0>7Q02OQ00<0hN404n4201WQ0P0=h@030>7Q01KQ00<0hN403n400`3Qh@0Dh@030>7Q03SQ000ih@03
0>7Q02KQ00<0hN405^4201WQ00<0hN402n400`3Qh@0Eh@030>7Q00oQ00<0hN404n400`3Qh@0ih@00
>^400`3Qh@0Uh@030>7Q01SQ0P0Hh@803>400`3Qh@0Eh@030>7Q00kQ00<0hN404n400`3Qh@0ih@00
>^400`3Qh@0Th@030>7Q01_Q0P0Hh@030>7Q00[Q00<0hN405>400`3Qh@0>h@030>7Q01;Q00<0hN40
>^4003_Q00<0hN408n400`3Qh@0Mh@805n4200_Q00<0hN405>400`3Qh@0=h@030>7Q01;Q00<0hN40
>^4003_Q00<0hN408^400`3Qh@0Ph@805n400`3Qh@09h@030>7Q01?Q00<0hN403N400`3Qh@0Ah@03
0>7Q03_Q000lh@030>7Q027Q00<0hN408^4201KQ00<0hN402N400`3Qh@0Ch@030>7Q00cQ00<0hN40
4N400`3Qh@0kh@00?>400`3Qh@0Ph@030>7Q02GQ0P0Eh@802^4201?Q00<0hN403>400`3Qh@0@h@03
0>7Q03cQ000mh@030>7Q01oQ00<0hN409n4301CQ00<0hN402N400`3Qh@0Ah@030>7Q00_Q00<0hN40
4>400`3Qh@0lh@00?N400`3Qh@0Nh@030>7Q02_Q0P0Ch@802^400`3Qh@0@h@030>7Q00_Q00<0hN40
3n400`3Qh@0mh@00?^400`3Qh@0Mh@030>7Q02gQ0P0Ch@030>7Q00SQ00<0hN403n400`3Qh@0;h@03
0>7Q00oQ00<0hN40?N4003kQ00<0hN407>400`3Qh@0`h@804^400`3Qh@08h@030>7Q00oQ00<0hN40
2^400`3Qh@0>h@030>7Q03kQ000oh@030>7Q01_Q00<0hN40<^42017Q0P09h@030>7Q00kQ00<0hN40
2^400`3Qh@0>h@030>7Q03kQ000oh@030>7Q01[Q00<0hN40=N42017Q00<0hN401n400`3Qh@0>h@03
0>7Q00[Q00<0hN403>400`3Qh@0oh@00@>400`3Qh@0Ih@030>7Q03OQ0P0@h@802>400`3Qh@0=h@03
0>7Q00[Q00<0hN403>400`3Qh@0oh@00@>400`3Qh@0Hh@030>7Q03[Q0P0@h@030>7Q00KQ00<0hN40
3N400`3Qh@09h@030>7Q00_Q00<0hN40@>40047Q00<0hN405n400`3Qh@0lh@803n400`3Qh@06h@03
0>7Q00cQ00<0hN402N400`3Qh@0;h@030>7Q043Q0011h@030>7Q01KQ00<0hN40?n4200kQ0P07h@03
0>7Q00cQ00<0hN402>400`3Qh@0:h@030>7Q047Q0012h@030>7Q01GQ00<0hN40@N4200kQ00<0hN40
1N400`3Qh@0;h@030>7Q00SQ00<0hN402^400`3Qh@11h@00@^400`3Qh@0Dh@030>7Q04CQ0P0=h@80
1^400`3Qh@0;h@030>7Q00OQ00<0hN402N400`3Qh@12h@00@n400`3Qh@0Ch@030>7Q04KQ0P0=h@03
0>7Q00CQ00<0hN402^400`3Qh@07h@030>7Q00WQ00<0hN40@^4004?Q00<0hN404^400`3Qh@19h@80
3>4200GQ0P0;h@030>7Q00KQ00<0hN402>400`3Qh@13h@00A>400`3Qh@0Ah@030>7Q04_Q0P0<h@03
0>7Q00CQ00<0hN402>400`3Qh@06h@030>7Q00SQ00<0hN40@n4004CQ00<0hN404>400`3Qh@1>h@80
2n400`3Qh@04h@030>7Q00SQ00<0hN401N400`3Qh@07h@030>7Q04CQ0015h@030>7Q00oQ00<0hN40
D>4200[Q0P05h@030>7Q00OQ00<0hN401N400`3Qh@07h@030>7Q04CQ0015h@030>7Q00kQ00<0hN40
Dn4300WQ00<0hN400n400`3Qh@07h@030>7Q00CQ00<0hN401^400`3Qh@15h@00A^400`3Qh@0=h@03
0>7Q05KQ0P08h@801>400`3Qh@06h@030>7Q00CQ00<0hN401^400`3Qh@15h@00A^400`3Qh@0<h@03
0>7Q05WQ0P08h@030>7Q00;Q00<0hN401^400`3Qh@03h@030>7Q00GQ00<0hN40A^4004OQ00<0hN40
2n400`3Qh@1Kh@801n400`3Qh@02h@030>7Q00GQ00<0hN400n400`3Qh@05h@030>7Q04KQ0017h@03
0>7Q00[Q00<0hN40G^4200KQ0P03h@030>7Q00GQ00<0hN400^400`3Qh@04h@030>7Q04OQ0018h@03
0>7Q00WQ00<0hN40H>4200KQ00D0hN7Q0006h@030>7Q00;Q00<0hN401>400`3Qh@17h@00B>400`3Q
h@08h@030>7Q06?Q0P05h@800^400`3Qh@04h@050>7Qh@001N400`3Qh@18h@00BN400`3Qh@07h@03
0>7Q06GQ0P05h@040>7Q00GQ00D0hN7Q0005h@030>7Q04SQ0019h@030>7Q00KQ00<0hN40J>4200CQ
00@0hN401N401@3QhN4000?Q00<0hN40BN4004[Q00<0hN401N400`3Qh@1Zh@800n420003h@3Q00?Q
00D0hN7Q0003h@030>7Q04WQ001:h@030>7Q00CQ00<0hN40KN4200?Q00@0h@000n40103Qh@02h@03
0>7Q04[Q001;h@030>7Q00?Q00<0hN40Kn4200;Q0P001N40hN4000;Q00@0hN40C>4004_Q00<0hN40
0^400`3Qh@1bh@800^400`3Q0002h@050>40h@00CN4004cQ00D0hN7Q001fh@8000[Q0000h@3Q0>40
CN4004cQ00@0hN40NN420004h@00h@<0C^4004gQ00<0h@00Nn4704kQ001<h@<0O^4504kQ001;hHP0
CN4004_Q1@1nh@D0CN4004_Q1@1nh@D0CN4004cQ0`20h@<0C^400?oQ8N400?oQ8N400?oQ8N400?oQ
8N400?oQ8N400?oQ8N400?oQ8N400?oQ8N400?oQ8N400?oQ8N400001\
\>"],
  ImageRangeCache->{{{0, 287}, {287, 0}} -> {-1.10001, -0.952637, 0.00766559, 
  0.00663859}}]
}, Open  ]],

Cell["\<\
\:3000\:3053\:306e\:4f8b\:3067\:306f\:3001P1\:3067\:306f\:672a\:3060\:4e0d\
\:5b8c\:5168\:306a\:56f3\:5f62\:3067\:3042\:308a\:3001P2\:3067\:59cb\:3081\
\:3066\:5e73\:8861\:72b6\:614b\:306e\:56f3\:5f62\:304c\:73fe\:308c\:308b\:3002\

\:3000\:4e0a\:306b\:8ff0\:3079\:305f\:65b9\:6cd5\:3067\:306f\:3001\:5909\:63db\
\:884c\:5217\:3068\:304b\:914d\:7f6e\:306e\:305f\:3081\:306e\:521d\:671f\:5ea7\
\:6a19\:3092\:4f5c\:3063\:3066\:304b\:3089\:3001\:63cf\:753b\:3057\:3066\:3044\
\:308b\:3002\:6b21\:306b\:96a3\:63a5\:884c\:5217\:3068\:30b5\:30a4\:30af\:30eb\
\:304b\:3089\:3001\:5909\:63db\:884c\:5217\:3092\:4f5c\:308a\:3001\:63cf\:753b\
\:3059\:308b\:30d7\:30ed\:30b0\:30e9\:30e0\:4f5c\:308b\:3002\:3053\:306e\:305f\
\:3081\:306e\:30d7\:30ed\:30b0\:30e9\:30e0\:306f\:6b21\:306e\:3088\:3046\:306b\
\:66f8\:3051\:308b\:3002
\:3000\:95a2\:6570 maketransformationmatrix \:306f\:3001\:5909\:63db\:884c\
\:5217\:3092\:5024\:3068\:3057\:3066\:8fd4\:3059\:304c\:3001\:3053\:306e\:95a2\
\:6570\:3092\:547c\:3073\:51fa\:3059\:306b\:306f\:3001\:95a2\:6570 rearrange \
\:306e\:8fd4\:3059\:5024\:3092\:5b9f\:5f15\:6570\:306b\:4e0e\:3048\:308b\:5fc5\
\:8981\:304c\:3042\:308b\:3002\:307e\:305f\:3001\:95a2\:6570 \
drawbytransformationmatrix \:306f\:3001Combinatorica.m \:3067\:5b9a\:7fa9\
\:3055\:308c\:3066\:3044\:308b\:95a2\:6570ChangeVertices\:3001ChangeEdges\
\:3001EmptyGraph\:3001ShowLabeledGraph\:3092\:5229\:7528\:3057\:3066\:3044\
\:308b\:306e\:3067\:6ce8\:610f\:3059\:308b\:3053\:3068\:3002\
\>", "Text"],

Cell[BoxData[{
    \(maketransformationmatrix[mtx_, cyl_] := 
      Block[{i, j, d, len1, len2, fmt}, \n\tlen1 = Length[mtx]; \n\t
        len2 = Length[cyl]; \n\tfmt = Table[0, {i, len1}, {j, len1}]; \n\t
        i = 1; \n\t
        While[i <= len2, \n\t\t
          For[j = 1, j <= len1, \(j++\), \n\t\t\t
            If[j == i, fmt[\([i, j]\)] = 1]]; \n\t\t\(i++\)]; \t\t\n\t
        i = len2 + 1; \n\t
        While[i <= len1, \n\t\td = Sum[mtx[\([i, j]\)], {j, len1}]; \n\t\t
          For[j = 1, j <= len1, \(j++\), \n\t\ \ \ \ \ \ 
            If[mtx[\([i, j]\)] == 1, fmt[\([i, j]\)] = 1/d]]; \n\t\t\(i++\)]; 
        \n\tReturn[fmt]\n]\), 
    \(circluarvertices[n_] := 
      Block[{i, s = Pi/2 - 2\ Pi\ /\ n, x = N[2\ Pi\ /\ n]}, \n\t\ \ 
        Return[Chop[
            N[Map[\(({{Cos[s], \(-Sin[s]\)}, {Sin[s], Cos[s]}}\  . \ #)\)&, 
                Table[{\((Cos[x\ \ i])\), \((Sin[x\ \ i])\)}, {i, n}]]]]]\n\t]
        \), 
    \(drawbytransformationmatrix[mtx_, cyl_, pwr_] := \n\t
      Block[{mt, f, len1, len2, g0, g1, vtx, gph}, \n\t\tlen1 = Length[mtx]; 
        \n\t\tlen2 = Length[cyl]; \n\t\tmt = rearrange[mtx, cyl]; \n\t\t
        f = MatrixPower[maketransformationmatrix[mt, cyl], pwr]; \n\t\t
        g0 = circluarvertices[len2]; \n\t\t
        g1 = Table[0, {i, len1 - len2}, {j, 2}]; \n\t\t
        vtx = f\  . \ Join[g0, g1]; \n\t\t
        gph = ChangeVertices[EmptyGraph[len1], vtx]; \n\t\t
        ghp = ChangeEdges[gph, mt]; \n\t\tShowLabeledGraph[gph]; \n\t\t
        Return[gph]\n]\)}], "Input"],

Cell[TextData[{
  StyleBox[
  "\:554f\:ff13\:ff0edrawbytransformationmatrix[mm,{1,2,3,8},k] \:3092\:ff11\
\:4ee5\:4e0a\:306e\:ff4b\:306b\:5bfe\:3057\:3066\:5b9f\:884c\:3057\:3066\:3001\
\:63cf\:753b\:3055\:308c\:308b\:56f3\:5f62\:306e\:5909\:5316\:3092\:8abf\:3079\
\:3088\:3002\n\n\:3000\:4e0a\:306e\:4f8b\:304c\:793a\:3059\:3088\:3046\:306b\
\:3001\:30b0\:30e9\:30d5\:304c\:8907\:96d1\:306b\:306a\:308b\:3068\:5909\:63db\
\:884c\:5217\:306e\:7a4d\:3092\:4f55\:5ea6\:3082\:8a08\:7b97\:3059\:308b\:5fc5\
\:8981\:304c\:3042\:308b\:3002\:3057\:304b\:3057\:3001\:6b21\:306e\:3088\:3046\
\:306b\:3059\:308c\:3070\:3001\:5e73\:8861\:72b6\:614b\:306e\:5ea7\:6a19\:3092\
\:ff11\:56de\:306e\:8a08\:7b97\:3067\:5f97\:308b\:3053\:3068\:304c\:3067\:304d\
\:308b\:3002\n\:3000"],
  StyleBox[Cell[BoxData[
      FormBox[
        RowBox[{
          RowBox[{
            RowBox[{
              RowBox[{"\:307e\:305a\:884c\:5217", " ", 
                FormBox[\(\((E - A)\)\^\(-1\)\),
                  "TraditionalForm"], "B\:3092\:8a08\:7b97\:3057"}], 
              "\:3001"}], 
            "\:6b21\:306b\:6700\:521d\:539f\:70b9\:306b\:3042"}], "\:3063"}], 
        TextForm]]]],
  StyleBox[
  "\:305f\:9802\:70b9\:306e\:5e73\:8861\:72b6\:614b\:3067\:306e\:5ea7\:6a19HP\
\:3092 HP="],
  StyleBox[Cell[BoxData[
      FormBox[
        RowBox[{
          RowBox[{
            FormBox[\(\((E - A)\)\^\(-1\)\),
              "TraditionalForm"], "B", " ", "HP0", "  ", 
            "\:3067\:6c42\:3081\:308b"}], "\:3002"}], TextForm]]]],
  StyleBox[
  "\n\:305f\:3060\:3057\:3001HP0\:306f\:5358\:4f4d\:5186\:5468\:4e0a\:306e\
\:9802\:70b9\:306e\:5ea7\:6a19\:306e\:4f5c\:308b\:884c\:5217\:3067\:3001\:4e0a\
\:306e\:4f8b\:306e\:5834\:5408\:306b\:306f\:3001\:6b21\:306e\:3088\:3046\:306b\
\:306a\:308b\:3002"]
}], "Text"],

Cell[BoxData[
    RowBox[{"HP0", "=", 
      TagBox[
        RowBox[{"(", GridBox[{
              {"0.500000000000000088`", "0.866025403784438552`"},
              {\(-0.499999999999999822`\), "0.866025403784438729`"},
              {\(-1.`\), "0"},
              {\(-0.500000000000000444`\), \(-0.866025403784438374`\)},
              {"0.499999999999999289`", \(-0.866025403784439085`\)},
              {"1.`", "0"}
              }], ")"}],
        (MatrixForm[ #]&)]}]], "Input"],

Cell[BoxData[
    FormBox[
      RowBox[{
        RowBox[{
        \(\(\:307e\:305f\:3001\) \:884c\:5217\ A\), ",", " ", "B", ",", " ", 
          RowBox[{
            FormBox[\(\((E - A)\)\^\(-1\)\),
              "TraditionalForm"], "B", " ", 
            "\:306f\:6b21\:306e\:3088\:3046\:306b\:306a\:308b"}]}], 
        "\:3002"}], TextForm]], "Text"],

Cell[BoxData[
    RowBox[{" ", 
      RowBox[{"B", "=", 
        TagBox[
          RowBox[{"(", GridBox[{
                {\(1\/4\), \(1\/4\), \(1\/4\), "0", "0", "0"},
                {\(1\/4\), "0", \(1\/4\), "0", "0", "0"},
                {\(1\/4\), "0", \(1\/4\), "0", "0", "0"},
                {\(1\/8\), "0", \(1\/8\), "0", "0", "0"},
                {"0", "0", \(1\/5\), \(1\/5\), \(1\/5\), "0"},
                {"0", "0", "0", "0", \(1\/4\), "0"},
                {"0", "0", "0", "0", \(1\/4\), "0"},
                {"0", "0", "0", "0", \(1\/4\), "0"},
                {\(1\/5\), "0", "0", "0", \(1\/5\), \(1\/5\)}
                }], ")"}],
          (MatrixForm[ #]&)]}]}]], "Input"],

Cell[BoxData[
    RowBox[{"      ", 
      RowBox[{"A", "=", 
        TagBox[
          RowBox[{"(", GridBox[{
                {"0", \(1\/4\), "0", "0", "0", "0", "0", "0", "0"},
                {\(1\/4\), "0", \(1\/4\), "0", "0", "0", "0", "0", "0"},
                {"0", \(1\/4\), "0", \(1\/4\), "0", "0", "0", "0", "0"},
                {"0", "0", \(1\/8\), "0", \(1\/8\), \(1\/8\), \(1\/8\), 
                  \(1\/8\), \(1\/8\)},
                {"0", "0", "0", \(1\/5\), "0", \(1\/5\), "0", "0", "0"},
                {"0", "0", "0", \(1\/4\), \(1\/4\), "0", \(1\/4\), "0", "0"},
                {"0", "0", "0", \(1\/4\), "0", \(1\/4\), "0", \(1\/4\), "0"},
                {"0", "0", "0", \(1\/4\), "0", "0", \(1\/4\), "0", \(1\/4\)},
                {"0", "0", "0", \(1\/5\), "0", "0", "0", \(1\/5\), "0"}
                }], ")"}],
          (MatrixForm[ #]&)]}]}]], "Input"],

Cell[BoxData[
    RowBox[{
      RowBox[{
        FormBox[\(\((E - A)\)\^\(-1\)\),
          "TraditionalForm"], "B"}], "=", 
      TagBox[
        RowBox[{"(", GridBox[{
              {\(7775\/21466\), \(5751\/21466\), \(7775\/21466\), 
                \(19\/21466\), \(127\/21466\), \(19\/21466\)},
              {\(4817\/10733\), \(769\/10733\), \(4817\/10733\), 
                \(38\/10733\), \(254\/10733\), \(38\/10733\)},
              {\(9295\/21466\), \(401\/21466\), \(9295\/21466\), 
                \(285\/21466\), \(1905\/21466\), \(285\/21466\)},
              {\(3040\/10733\), \(33\/10733\), \(3040\/10733\), 
                \(532\/10733\), \(3556\/10733\), \(532\/10733\)},
              {\(33581\/407854\), \(19\/21466\), \(119445\/407854\), 
                \(92009\/407854\), \(8227\/21466\), \(6145\/407854\)},
              {\(52385\/407854\), \(29\/21466\), \(73851\/407854\), 
                \(31975\/407854\), \(12557\/21466\), \(10509\/407854\)},
              {\(3181\/21466\), \(31\/21466\), \(3181\/21466\), 
                \(825\/21466\), \(13423\/21466\), \(825\/21466\)},
              {\(73851\/407854\), \(29\/21466\), \(52385\/407854\), 
                \(10509\/407854\), \(12557\/21466\), \(31975\/407854\)},
              {\(119445\/407854\), \(19\/21466\), \(33581\/407854\), 
                \(6145\/407854\), \(8227\/21466\), \(92009\/407854\)}
              }], ")"}],
        (MatrixForm[ #]&)]}]], "Input"],

Cell[BoxData[
    FormBox[
      RowBox[{
        RowBox[{
          RowBox[{
            RowBox[{
            \(\(\(\:5f93\:3063\) \:3066\:3001\) HP\ 
                  \:306f\:6b21\:306e\:3088\:3046\:306b\:306a\:308b\:3002\), 
              "\n", "                ", 
              StyleBox[
                RowBox[{"HP", "=", 
                  TagBox[
                    RowBox[{"(", GridBox[{
                          {\(-0.311655641479548961`\), 
                            "0.539803405508049394`"},
                          {\(-0.246622565918196112`\), 
                            "0.427162814463320383`"},
                          {\(-0.174834622193235844`\), 
                            "0.302822448560793544`"},
                          {"0.0472840771452527075`", 
                            \(-0.0818984240045845801`\)},
                          {\(-0.158237996930274427`\), 
                            \(-0.455208300184154168`\)},
                          {"0.161525938203376213`", 
                            \(-0.462092269347308537`\)},
                          {"0.257057672598527453`", 
                            \(-0.445236949416056493`\)},
                          {"0.319420675045481505`", 
                            \(-0.370931700527893992`\)},
                          {"0.473340950438146723`", 
                            \(-0.0905660249064958122`\)}
                          }], ")"}],
                    (MatrixForm[ #]&)]}]], 
              StyleBox[
                RowBox[{
                  StyleBox["         ",
                    "Input"], 
                  "                                                  "}]], 
              "\n", "\:6700\:5f8c\:306b"}], "\:3001"}], 
          "\:5e73\:8861\:72b6\:614b\:306e\:56f3\:5f62\:3092\:66f8\:304f\:3068\
\:6b21\:306e\:3088\:3046\:306b\:306a\:308b"}], "\:3002"}], TextForm]], "Text"],

Cell[CellGroupData[{

Cell[BoxData[
    \(draw[mm, \ Join[HP0, HP]]\)], "Input"],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: 1 
MathPictureStart
/Mabs {
Mgmatrix idtransform
Mtmatrix dtransform
} bind def
/Mabsadd { Mabs
3 -1 roll add
3 1 roll add
exch } bind def
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
0.5 0.454545 0.5 0.524864 [
[ 0 0 0 0 ]
[ 1 1 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 0 m
1 0 L
1 1 L
0 1 L
closepath
clip
newpath
0 g
.02 w
.72727 .95455 Mdot
.27273 .95455 Mdot
.04545 .5 Mdot
.27273 .04545 Mdot
.72727 .04545 Mdot
.95455 .5 Mdot
.35834 .78332 Mdot
.3879 .7242 Mdot
.42053 .65894 Mdot
.52149 .45701 Mdot
.42807 .26108 Mdot
.57342 .25746 Mdot
.61684 .26631 Mdot
.64519 .30531 Mdot
.71515 .45247 Mdot
.5 Mabswid
.72727 .95455 m
.27273 .95455 L
s
.72727 .95455 m
.95455 .5 L
s
.72727 .95455 m
.35834 .78332 L
s
.72727 .95455 m
.3879 .7242 L
s
.72727 .95455 m
.42053 .65894 L
s
.72727 .95455 m
.52149 .45701 L
s
.72727 .95455 m
.71515 .45247 L
s
.27273 .95455 m
.72727 .95455 L
s
.27273 .95455 m
.04545 .5 L
s
.27273 .95455 m
.35834 .78332 L
s
.04545 .5 m
.27273 .95455 L
s
.04545 .5 m
.27273 .04545 L
s
.04545 .5 m
.35834 .78332 L
s
.04545 .5 m
.3879 .7242 L
s
.04545 .5 m
.42053 .65894 L
s
.04545 .5 m
.52149 .45701 L
s
.04545 .5 m
.42807 .26108 L
s
.27273 .04545 m
.04545 .5 L
s
.27273 .04545 m
.72727 .04545 L
s
.27273 .04545 m
.42807 .26108 L
s
.72727 .04545 m
.27273 .04545 L
s
.72727 .04545 m
.95455 .5 L
s
.72727 .04545 m
.42807 .26108 L
s
.72727 .04545 m
.57342 .25746 L
s
.72727 .04545 m
.61684 .26631 L
s
.72727 .04545 m
.64519 .30531 L
s
.72727 .04545 m
.71515 .45247 L
s
.95455 .5 m
.72727 .95455 L
s
.95455 .5 m
.72727 .04545 L
s
.95455 .5 m
.71515 .45247 L
s
.35834 .78332 m
.72727 .95455 L
s
.35834 .78332 m
.27273 .95455 L
s
.35834 .78332 m
.04545 .5 L
s
.35834 .78332 m
.3879 .7242 L
s
.3879 .7242 m
.72727 .95455 L
s
.3879 .7242 m
.04545 .5 L
s
.3879 .7242 m
.35834 .78332 L
s
.3879 .7242 m
.42053 .65894 L
s
.42053 .65894 m
.72727 .95455 L
s
.42053 .65894 m
.04545 .5 L
s
.42053 .65894 m
.3879 .7242 L
s
.42053 .65894 m
.52149 .45701 L
s
.52149 .45701 m
.72727 .95455 L
s
.52149 .45701 m
.04545 .5 L
s
.52149 .45701 m
.42053 .65894 L
s
.52149 .45701 m
.42807 .26108 L
s
.52149 .45701 m
.57342 .25746 L
s
.52149 .45701 m
.61684 .26631 L
s
.52149 .45701 m
.64519 .30531 L
s
.52149 .45701 m
.71515 .45247 L
s
.42807 .26108 m
.04545 .5 L
s
.42807 .26108 m
.27273 .04545 L
s
.42807 .26108 m
.72727 .04545 L
s
.42807 .26108 m
.52149 .45701 L
s
.42807 .26108 m
.57342 .25746 L
s
.57342 .25746 m
.72727 .04545 L
s
.57342 .25746 m
.52149 .45701 L
s
.57342 .25746 m
.42807 .26108 L
s
.57342 .25746 m
.61684 .26631 L
s
.61684 .26631 m
.72727 .04545 L
s
.61684 .26631 m
.52149 .45701 L
s
.61684 .26631 m
.57342 .25746 L
s
.61684 .26631 m
.64519 .30531 L
s
.64519 .30531 m
.72727 .04545 L
s
.64519 .30531 m
.52149 .45701 L
s
.64519 .30531 m
.61684 .26631 L
s
.64519 .30531 m
.71515 .45247 L
s
.71515 .45247 m
.72727 .95455 L
s
.71515 .45247 m
.72727 .04545 L
s
.71515 .45247 m
.95455 .5 L
s
.71515 .45247 m
.52149 .45701 L
s
.71515 .45247 m
.64519 .30531 L
s
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  ImageSize->{288, 288},
  ImageMargins->{{43, 0}, {0, 0}},
  ImageRegion->{{0, 1}, {0, 1}},
  ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`40004P000180P10`40000100000800002008200000
P800P020P<30`<3L`:K:l00003<006H009T00<`00?l0000c03<c06Hc09Tc0<`c0?lc001V03=V06IV
09UV0<aV0?mV002I03>I06JI09VI0<bI0?nI003<03?<06K<09W<0<c<0?o<003o03?o06Ko09Wo0<co
0?oo0000<c<0<fH0<iT0<l`0<ol0<`0c<c<c<fHc<iTc<l`c<olc<`1V<c=V<fIV<iUV<laV<omV<`2I
<c>I<fJI<iVI<lbI<onI<`3<<c?<<fK<<iW<<lc<<oo<<`3o<c?o<fKo<iWo<lco<ooo<`00IS<0IVH0
IYT0I/`0I_l0IP0cIS<cIVHcIYTcI/`cI_lcIP1VIS=VIVIVIYUVI/aVI_mVIP2IIS>IIVJIIYVII/bI
I_nIIP3<IS?<IVK<IYW<I/c<I_o<IP3oIS?oIVKoIYWoI/coI_ooIP00VC<0VFH0VIT0VL`0VOl0V@0c
VC<cVFHcVITcVL`cVOlcV@1VVC=VVFIVVIUVVLaVVOmVV@2IVC>IVFJIVIVIVLbIVOnIV@3<VC?<VFK<
VIW<VLc<VOo<V@3oVC?oVFKoVIWoVLcoVOooV@00c3<0c6H0c9T0c<`0c?l0c00cc3<cc6Hcc9Tcc<`c
c?lcc01Vc3=Vc6IVc9UVc<aVc?mVc02Ic3>Ic6JIc9VIc<bIc?nIc03<c3?<c6K<c9W<c<c<c?o<c03o
c3?oc6Koc9Woc<coc?ooc000oc<0ofH0oiT0ol`0ool0o`0coc<cofHcoiTcol`coolco`1Voc=VofIV
oiUVolaVoomVo`2Ioc>IofJIoiVIolbIoonIo`3<oc?<ofK<oiW<olc<ooo<o`3ooc?oofKooiWoolco
ooooo`0000410@820P<30`@410D51@H61PL71`P820T92@X:2P/;2``<30h>3Pl?3a0@414A4A8B4Q<C
4a@D5?okl:2PY820P?l0003o0?oo0000ool0o`3ooooooooQ8N400?oQ8N400?oQ8N400?oQ8N400?oQ
8N400?oQ8N400?oQ8N400?oQ8N400?oQ8N400?oQ8N400?oQ8N400?oQ8N4004cQ0`20h@<0C^4004_Q
1@1nh@D0CN4004_QR01=h@00Bn4507kQ1@1=h@00C>4407gQ00<0h@000P1>h@00C>401@3QhN4007_Q
00<0h@000`1>h@00C>400`3Qh@02h@030>7Q07KQ0P000n4000020003h@3Q04cQ001;h@030>7Q00CQ
00<0hN40M>402P3Qh@3Q0>40h@1=h@00Bn400`3Qh@04h@030>7Q07;Q0P03h@<000GQ0>7Q001<h@00
B^400`3Qh@06h@030>7Q073Q00<0hN400^401P3Q003Q00;Q00<0hN40B^4004[Q00<0hN401n400`3Q
h@1^h@030>7Q00;Q00L0h@3Q0>4000?Q00<0hN40BN4004WQ00<0hN402>400`3Qh@1/h@801>400`3Q
h@0200;Q00D0hN7Q001;h@00BN400`3Qh@09h@030>7Q06[Q00<0hN401>401@3Q0>4000;Q00<0hN40
0^400`3Qh@18h@00B>400`3Qh@0;h@030>7Q06OQ0P06h@060>7Q0>400^400`3Qh@02h@030>7Q04SQ
0018h@030>7Q00cQ00<0hN40IN400`3Qh@05h@060>7Q0>400n400`3Qh@03h@030>7Q04OQ0017h@03
0>7Q00gQ00<0hN40Hn4200OQ00L0hN7Q0>4000?Q00<0hN400n400`3Qh@17h@00An400`3Qh@0>h@03
0>7Q067Q00<0hN401n40103Qh@02h@050>7Qh@001^400`3Qh@16h@00A^400`3Qh@0@h@030>7Q05oQ
00<0hN401n401`3QhN40h@001>400`3Qh@04h@030>7Q04KQ0016h@030>7Q017Q00<0hN40G>4200WQ
00D0hN7Q0002h@030>7Q00;Q00<0hN401N400`3Qh@15h@00AN400`3Qh@0Bh@030>7Q05_Q00<0hN40
2N401@3QhN4000;Q00<0hN400^400`3Qh@05h@030>7Q04GQ0015h@030>7Q01?Q00<0hN40F>4200_Q
00D0hN7Q0002h@030>7Q00?Q00<0hN401^400`3Qh@14h@00A>400`3Qh@0Eh@030>7Q05KQ00<0hN40
2^400`3Qh@02h@040>7Q00GQ00<0hN401^400`3Qh@14h@00A>400`3Qh@0Eh@030>7Q05GQ00<0hN40
2^400`3Qh@02h@050>7Qh@001>400`3Qh@08h@030>7Q04?Q0013h@030>7Q01OQ00<0hN40D^4200gQ
00<0hN400^40103Qh@05h@030>7Q00SQ00<0hN40@n4004?Q00<0hN406>400`3Qh@1@h@030>7Q00cQ
00<0hN400^401@3QhN4000GQ00<0hN402N400`3Qh@12h@00@^400`3Qh@0Jh@030>7Q04gQ0P0>h@03
0>7Q00?Q00D0hN7Q0005h@030>7Q00WQ00<0hN40@^4004;Q00<0hN406^400`3Qh@1<h@030>7Q00gQ
00<0hN400n400`3Qh@02h@030>7Q00?Q00<0hN402^400`3Qh@11h@00@N400`3Qh@0Lh@030>7Q04[Q
00<0hN403^400`3Qh@03h@050>7Qh@001^400`3Qh@0:h@030>7Q047Q0011h@030>7Q01gQ00<0hN40
An42013Q00<0hN400n400`3Qh@02h@030>7Q00CQ00<0hN402n400`3Qh@10h@00@>400`3Qh@0Nh@03
0>7Q04KQ00<0hN403n400`3Qh@04h@030>7Q00;Q00<0hN401>400`3Qh@0;h@030>7Q043Q0010h@03
0>7Q01oQ00<0hN40@n42017Q00<0hN401>400`3Qh@02h@030>7Q00GQ00<0hN403>400`3Qh@0oh@00
?n400`3Qh@0Qh@030>7Q047Q00<0hN404N400`3Qh@04h@030>7Q00;Q00<0hN401N400`3Qh@0<h@03
0>7Q03oQ000oh@030>7Q02;Q00<0hN40?n400`3Qh@0Ah@030>7Q00CQ00<0hN400n400`3Qh@05h@03
0>7Q00gQ00<0hN40?^4003kQ00<0hN408n400`3Qh@0mh@804n400`3Qh@05h@030>7Q00;Q00<0hN40
1^400`3Qh@0=h@030>7Q03kQ000nh@030>7Q02CQ00<0hN40>n400`3Qh@0Ch@030>7Q00CQ00<0hN40
0n400`3Qh@06h@030>7Q00kQ00<0hN40?N4003gQ00<0hN409^400`3Qh@0hh@805N400`3Qh@05h@03
0>7Q00?Q00<0hN401^400`3Qh@0>h@030>7Q03gQ000mh@030>7Q02OQ00<0hN40=^400`3Qh@0Dh@03
0>7Q00GQ00<0hN400n400`3Qh@07h@030>7Q00oQ00<0hN40?>4003cQ00<0hN40:>400`3Qh@0dh@80
5^400`3Qh@06h@030>7Q00?Q00<0hN401n400`3Qh@0?h@030>7Q03cQ000lh@030>7Q02WQ00<0hN40
<^400`3Qh@0Fh@030>7Q00GQ00<0hN401>400`3Qh@07h@030>7Q013Q00<0hN40>n4003_Q00<0hN40
:n400`3Qh@0`h@030>7Q01KQ00<0hN401^400`3Qh@03h@030>7Q00SQ00<0hN404>400`3Qh@0kh@00
>n400`3Qh@0[h@030>7Q02kQ0P0Hh@030>7Q00KQ00<0hN401>400`3Qh@08h@030>7Q017Q00<0hN40
>^4003[Q00<0hN40;N400`3Qh@0/h@030>7Q01OQ00<0hN401n400`3Qh@04h@030>7Q00SQ00<0hN40
4N400`3Qh@0jh@00>^400`3Qh@0^h@030>7Q02WQ0P0Jh@030>7Q00KQ00<0hN401N400`3Qh@08h@03
0>7Q01;Q00<0hN40>N4003WQ00<0hN40<>400`3Qh@0Wh@030>7Q01WQ00<0hN401n400`3Qh@04h@03
0>7Q00WQ00<0hN404^400`3Qh@0ih@00>N400`3Qh@0`h@030>7Q02KQ00<0hN406N400`3Qh@07h@03
0>7Q00GQ00<0hN402N400`3Qh@0Ch@030>7Q03SQ000hh@030>7Q03;Q00<0hN408n4201_Q00<0hN40
2>400`3Qh@05h@030>7Q00WQ00<0hN404n400`3Qh@0hh@00>>400`3Qh@0ch@030>7Q027Q00<0hN40
6n400`3Qh@07h@030>7Q00GQ00<0hN402^400`3Qh@0Dh@030>7Q03OQ000gh@030>7Q03CQ00<0hN40
7n4201gQ00<0hN402>400`3Qh@05h@030>7Q00[Q00<0hN405>400`3Qh@0gh@00=n400`3Qh@0eh@03
0>7Q01gQ00<0hN407>400`3Qh@08h@030>7Q00KQ00<0hN402^400`3Qh@0Eh@030>7Q03KQ000fh@03
0>7Q03OQ00<0hN406n400`3Qh@0Mh@030>7Q00SQ00<0hN401N400`3Qh@0;h@030>7Q01GQ00<0hN40
=^4003KQ00<0hN40>>400`3Qh@0Hh@807n400`3Qh@08h@030>7Q00KQ00<0hN402n400`3Qh@0Fh@03
0>7Q03GQ000eh@030>7Q03WQ00<0hN405n400`3Qh@0Nh@030>7Q00WQ00<0hN401^400`3Qh@0;h@03
0>7Q01KQ00<0hN40=N4003GQ00<0hN40>^400`3Qh@0Dh@808>400`3Qh@09h@030>7Q00KQ00<0hN40
3>400`3Qh@0Gh@030>7Q03CQ000dh@030>7Q03cQ00<0hN404^400`3Qh@0Ph@030>7Q00WQ00<0hN40
1^400`3Qh@0<h@030>7Q01OQ00<0hN40=>4003CQ00<0hN40?N400`3Qh@0?h@808^400`3Qh@09h@03
0>7Q00OQ00<0hN403>400`3Qh@0Hh@030>7Q03?Q000ch@030>7Q03kQ00<0hN403^400`3Qh@0Qh@03
0>7Q00[Q00<0hN401n400`3Qh@0<h@030>7Q01SQ00<0hN40<n4003?Q00<0hN40?n400`3Qh@0<h@03
0>7Q027Q00<0hN402^400`3Qh@07h@030>7Q00gQ00<0hN406N400`3Qh@0bh@00<^400`3Qh@11h@03
0>7Q00WQ0P0Th@030>7Q00[Q00<0hN401n400`3Qh@0=h@030>7Q01WQ00<0hN40<^4003;Q00<0hN40
@N400`3Qh@08h@030>7Q02?Q00<0hN402^400`3Qh@08h@030>7Q00gQ00<0hN406^400`3Qh@0ah@00
<N400`3Qh@13h@030>7Q00GQ0P0Uh@030>7Q00_Q00<0hN401n400`3Qh@0>h@030>7Q01[Q00<0hN40
<N40037Q00<0hN40A>400`3Qh@03h@030>7Q02CQ00<0hN402n400`3Qh@08h@030>7Q00gQ00<0hN40
7>400`3Qh@0`h@00<>400`3Qh@16h@050>7Qh@009N4300gQ00<0hN402>400`3Qh@0=h@030>7Q01cQ
00<0hN40<>40033Q00<0hN40A^4401?Q5`0;h@030>7Q00SQ00<0hN403^400`3Qh@0Mh@030>7Q02oQ
000_h@030>7Q04KQ600Bh@T01>4400[Q00<0hN403^400`3Qh@0Mh@030>7Q02oQ000_h@030>7Q04KQ
1@0Uh@D01>4800[Q00<0hN403^400`3Qh@0Nh@030>7Q02kQ000^h@030>7Q04KQ1P0Vh@<02>4500WQ
00<0hN403n400`3Qh@0Nh@030>7Q02kQ000^h@030>7Q04CQ0P02h@<09n400`3Qh@08h@D02N400`3Q
h@0?h@030>7Q01oQ00<0hN40;N4002gQ00<0hN40@n4200OQ00<0hN409>400`3Qh@09h@@02N400`3Q
h@0?h@030>7Q01oQ00<0hN40;N4002gQ00<0hN40@^400`3Qh@07h@030>7Q02?Q00<0hN402^401@3Q
hN4000OQ00<0hN404>400`3Qh@0Ph@030>7Q02cQ000/h@030>7Q047Q0P0;h@030>7Q02;Q00<0hN40
2^400`3Qh@02h@030>7Q00CQ00<0hN404>400`3Qh@0Ph@030>7Q02cQ000/h@030>7Q043Q00<0hN40
2n400`3Qh@0Rh@030>7Q00WQ00<0hN401>400`3Qh@03h@030>7Q013Q00<0hN408N400`3Qh@0[h@00
:n400`3Qh@0oh@803n400`3Qh@0Qh@030>7Q00WQ00<0hN401>400`3Qh@03h@030>7Q013Q00<0hN40
8N400`3Qh@0[h@00:n400`3Qh@0mh@804N400`3Qh@0Ph@030>7Q00WQ00<0hN401^401@3QhN4001?Q
00<0hN408^400`3Qh@0Zh@00:^400`3Qh@0mh@030>7Q01;Q00<0hN407n400`3Qh@09h@030>7Q00OQ
00@0hN404n400`3Qh@0Rh@030>7Q02[Q000Zh@030>7Q03_Q0P0Eh@030>7Q01oQ00<0hN402>400`3Q
h@08h@@04n400`3Qh@0Sh@030>7Q02WQ000Yh@030>7Q03_Q00<0hN405^400`3Qh@0Nh@030>7Q00SQ
00<0hN401n4501?Q00<0hN408n400`3Qh@0Yh@00:N400`3Qh@0ih@806N400`3Qh@0Mh@030>7Q00SQ
00<0hN402>4501?Q00<0hN409>400`3Qh@0Xh@00:>400`3Qh@0ih@030>7Q01[Q00<0hN407>400`3Q
h@08h@030>7Q00SQ1@0Ch@030>7Q02CQ00<0hN40:>4002SQ00<0hN40=n4201gQ00<0hN407>400`3Q
h@07h@030>7Q00[Q100Ch@030>7Q02GQ00<0hN409n4002OQ00<0hN40=^42023Q00<0hN406n400`3Q
h@07h@030>7Q00[Q00@0hN404n400`3Qh@0Uh@030>7Q02OQ000Wh@030>7Q03GQ00<0hN408>400`3Q
h@0Jh@030>7Q00OQ00<0hN402^400`3Qh@02h@030>7Q013Q00<0hN409^400`3Qh@0Vh@009^400`3Q
h@0dh@809>400`3Qh@0Ih@030>7Q00OQ00<0hN402N400`3Qh@03h@030>7Q013Q00<0hN409^400`3Q
h@0Vh@009^400`3Qh@0ch@030>7Q02CQ00<0hN406N400`3Qh@06h@030>7Q00WQ00<0hN401N400`3Q
h@0?h@030>7Q02OQ00<0hN409N4002GQ00<0hN40<^4202OQ00<0hN406N400`3Qh@06h@030>7Q00SQ
00<0hN401^400`3Qh@0?h@030>7Q02OQ00<0hN409N4002GQ00<0hN40<N400`3Qh@0Xh@030>7Q01OQ
00<0hN401^400`3Qh@08h@030>7Q00SQ00<0hN403^400`3Qh@0Xh@030>7Q02CQ000Th@030>7Q033Q
0P0[h@030>7Q01OQ00<0hN401^400`3Qh@08h@030>7Q00SQ00<0hN403^400`3Qh@0Xh@030>7Q02CQ
000Th@030>7Q02kQ0P0^h@030>7Q01KQ00<0hN401N400`3Qh@08h@030>7Q00[Q00<0hN403N400`3Q
h@0Yh@030>7Q02?Q000Sh@030>7Q02kQ00<0hN40;^400`3Qh@0Fh@030>7Q00GQ00<0hN401n400`3Q
h@0;h@030>7Q00gQ00<0hN40:N400`3Qh@0Sh@008n400`3Qh@0/h@80<^400`3Qh@0Dh@030>7Q00GQ
00<0hN401n400`3Qh@0=h@030>7Q00cQ00<0hN40:^400`3Qh@0Rh@008^400`3Qh@0/h@030>7Q03;Q
00<0hN405>400`3Qh@05h@030>7Q00KQ00<0hN403^400`3Qh@0<h@030>7Q02[Q00<0hN408^4002;Q
00<0hN40:^4203KQ00<0hN404n400`3Qh@04h@030>7Q00OQ00<0hN403n400`3Qh@0;h@030>7Q02_Q
00<0hN408N40027Q00<0hN40:N4203SQ00<0hN404^400`3Qh@05h@030>7Q00KQ00<0hN404>400`3Q
h@0;h@030>7Q02_Q00<0hN408N40027Q00<0hN40:>400`3Qh@0ih@030>7Q017Q00<0hN401>400`3Q
h@06h@030>7Q01;Q00<0hN402^400`3Qh@0/h@030>7Q023Q000Ph@030>7Q02OQ0P0lh@030>7Q017Q
00<0hN401>400`3Qh@05h@030>7Q01?Q00<0hN402^400`3Qh@0/h@030>7Q023Q000Ph@030>7Q02KQ
00<0hN40?N400`3Qh@0@h@030>7Q00?Q00<0hN401N400`3Qh@0Eh@030>7Q00WQ00<0hN40;N400`3Q
h@0Oh@007n400`3Qh@0Uh@80@>400`3Qh@0?h@030>7Q00CQ00<0hN401>400`3Qh@0Fh@030>7Q00WQ
00<0hN40;N400`3Qh@0Oh@007n400`3Qh@0Th@030>7Q047Q00<0hN403^400`3Qh@03h@030>7Q00GQ
00<0hN405n400`3Qh@08h@030>7Q02kQ00<0hN407^4001kQ00<0hN408n4204CQ00<0hN403^400`3Q
h@03h@030>7Q00CQ00<0hN406>400`3Qh@08h@030>7Q02kQ00<0hN407^4001kQ00<0hN408N4204OQ
00<0hN403N400`3Qh@02h@030>7Q00CQ00<0hN406N400`3Qh@08h@030>7Q02oQ00<0hN407N4001gQ
00<0hN408N400`3Qh@17h@030>7Q00cQ00<0hN400n400`3Qh@03h@030>7Q01_Q00<0hN401^400`3Q
h@0`h@030>7Q01gQ000Mh@030>7Q01oQ0P1;h@030>7Q00_Q00<0hN400^400`3Qh@03h@030>7Q01cQ
00<0hN401^400`3Qh@0ah@030>7Q01cQ000Lh@030>7Q01oQ00<0hN40Bn400`3Qh@0;h@030>7Q00;Q
00<0hN400n400`3Qh@0Mh@030>7Q00GQ00<0hN40<N400`3Qh@0Lh@007>400`3Qh@0Mh@80C^400`3Q
h@0;h@050>7Qh@001N400`3Qh@0Nh@030>7Q00GQ00<0hN40<^400`3Qh@0Kh@006n400`3Qh@0Mh@03
0>7Q04oQ00<0hN402N400`3Qh@02h@030>7Q00;Q00<0hN408>400`3Qh@04h@030>7Q03;Q00<0hN40
6n4001_Q00<0hN406n4205;Q00<0hN402N401@3QhN4000CQ00<0hN408N400`3Qh@04h@030>7Q03?Q
00<0hN406^4001[Q00<0hN406^4205GQ00<0hN402>401@3QhN4000?Q00<0hN408n400`3Qh@03h@03
0>7Q03?Q00<0hN406^4001[Q00<0hN406N400`3Qh@1Eh@030>7Q00SQ00@0hN400n400`3Qh@0Th@03
0>7Q00?Q00<0hN40=>400`3Qh@0Ih@006N400`3Qh@0Hh@80FN400`3Qh@06h@050>7Qh@000n400`3Q
h@0Uh@030>7Q00;Q00<0hN40=>400`3Qh@0Ih@006N400`3Qh@0Gh@030>7Q05WQ00<0hN401^40103Q
h@03h@030>7Q02KQ00<0hN400^400`3Qh@0eh@030>7Q01SQ000Hh@030>7Q01KQ0P1Mh@030>7Q00GQ
00@0hN400^400`3Qh@0Xh@050>7Qh@00=n400`3Qh@0Hh@006>400`3Qh@0Dh@80Gn400`3Qh@05h@03
0>4000;Q00<0hN40:N401@3QhN4003SQ00<0hN405n4001OQ00<0hN405>400`3Qh@1Ph@030>7Q00?Q
00H0hN40h@0]h@040>7Q03SQ00<0hN405n4001OQ00<0hN404^4206?Q00<0hN400n400`3Q0002h@03
0>7Q02_Q00@0hN40>N400`3Qh@0Fh@005^400`3Qh@0Bh@030>7Q06CQ00<0hN400^401@3Q0>4002oQ
00<0h@00>N400`3Qh@0Fh@005^400`3Qh@0@h@80In400`3Qh@02h@8000?Q0>40;n400`3Q000jh@03
0>7Q01GQ000Eh@030>7Q013Q00<0hN40J>401@3Qh@3Q0080<^4203[Q00<0hN405N4001GQ00<0hN40
3^4206_Q00<0hN400`0ch@80>n400`3Qh@0Dh@005>400`3Qh@0=h@80K^40103Q000ch@<0>n400`3Q
h@0Dh@005>400`3Qh@0<h@030>7Q06kQ100XhA00>^400`3Qh@0Ch@004n400`3Qh@0;h@80L>4500cQ
700:h@D000?Q00000`0eh@030>7Q01?Q000Ch@030>7Q00[Q00<0hN40KN4D02KQ1@06h@D0<N400`3Q
h@0Bh@004^400`3Qh@09h@80IN4;00?Q1@0ch@<03>4402gQ00<0hN404^4001;Q00<0hN402>400`3Q
h@1Ih@`03n4303KQ00<0hN403^4502WQ00<0hN404N40017Q00<0hN401n42057Q2`0Jh@040>7Q03KQ
00<0hN404n4502CQ00<0hN404N40017Q00<0hN401N4204SQ2`0Uh@050>7Qh@00=N400`3Qh@0Hh@D0
8>400`3Qh@0@h@004>400`3Qh@05h@030>7Q03cQ300_h@030>7Q00;Q00<0hN40<n400`3Qh@0Mh@D0
6n400`3Qh@0@h@004>400`3Qh@03h@80=>4;03_Q00<0hN400^400`3Qh@0ch@030>7Q02;Q1@0Gh@03
0>7Q00oQ000?h@030>7Q00?Q00<0hN40:N4;04GQ00<0hN401>400`3Qh@0bh@030>7Q02OQ1@0Bh@03
0>7Q00oQ000?h@040>7Qh@808>4<053Q00<0hN401>400`3Qh@0bh@030>7Q02cQ100?h@030>7Q00kQ
000>h@030>7Q00805n4;05_Q00<0hN401^400`3Qh@0ah@030>7Q033Q1@0:h@030>7Q00kQ000;h@@0
00?Q0>403N4;06KQ00<0hN401^400`3Qh@0ah@030>7Q03GQ1@06h@<03N4000[Q1P03h@`0L>400`3Q
h@08h@030>7Q033Q00<0hN40>^4:00cQ000:h@T0O>400`3Qh@08h@030>7Q033Q00<0hN40?n4500cQ
000:h@L0ON400`3Qh@09h@030>7Q033Q00<0hN40?n4500cQ000;h@P0Nn400`3Qh@0:h@030>7Q02oQ
00<0hN40@>4300gQ000>h@030>4000D0Mn400`3Qh@0;h@030>7Q02oQ00<0hN40?n400`3Qh@0>h@00
3n401@3Q0>4000;Q0P1eh@030>7Q00cQ00<0hN40;^400`3Qh@0oh@030>7Q00kQ000?h@030>7Q00@0
0^4207;Q00<0hN403N400`3Qh@0^h@030>7Q03kQ00<0hN403n40013Q00L0hN7Q0>4000?Q0`1_h@03
0>7Q00gQ00<0hN40;^400`3Qh@0nh@030>7Q00oQ000@h@030>7Q00;Q00@0h@001>4206cQ00<0hN40
3n400`3Qh@0]h@030>7Q03gQ00<0hN404>40017Q00<0hN400^400`3Qh@0200CQ0P1Zh@030>7Q00oQ
00<0hN40;N400`3Qh@0mh@030>7Q013Q000Ah@030>7Q00?Q00D0hN7Q0005h@<0I^400`3Qh@0Ah@03
0>7Q02cQ00<0hN40?>400`3Qh@0Ah@004^400`3Qh@03h@040>7Qh@801^4206CQ00<0hN404N400`3Q
h@0/h@030>7Q03cQ00<0hN404N4001;Q00<0hN401>400`3Qh@02h@030>7Q00GQ0P1Qh@030>7Q01?Q
00<0hN40;>400`3Qh@0jh@030>7Q01;Q000Ch@030>7Q00CQ00<0hN400^4200OQ0`1Nh@030>7Q01?Q
00<0hN40;>400`3Qh@0jh@030>7Q01;Q000Ch@030>7Q00GQ00<0hN400n400`3Qh@07h@80Fn400`3Q
h@0Dh@030>7Q02cQ00<0hN40>N400`3Qh@0Ch@005>400`3Qh@05h@030>7Q00?Q0P09h@80FN400`3Q
h@0Eh@030>7Q02_Q00<0hN40>N400`3Qh@0Ch@005>400`3Qh@06h@801N400`3Qh@08h@<0EN400`3Q
h@0Fh@030>7Q02_Q00<0hN40>>400`3Qh@0Dh@005N400`3Qh@07h@030>7Q00?Q0P0;h@80Dn400`3Q
h@0Gh@030>7Q02[Q00<0hN40>>400`3Qh@0Dh@005N400`3Qh@08h@030>7Q00CQ00<0hN402^42053Q
00<0hN406>400`3Qh@0Zh@030>7Q03OQ00<0hN405N4001KQ00<0hN402>400`3Qh@04h@803>4304gQ
00<0hN406>400`3Qh@0Zh@030>7Q03OQ00<0hN405N4001KQ00<0hN402N400`3Qh@05h@030>7Q00cQ
0P1:h@030>7Q01[Q00<0hN40:N400`3Qh@0fh@030>7Q01KQ000Gh@030>7Q00WQ00<0hN401N4200kQ
0P18h@030>7Q01[Q00<0hN40:N400`3Qh@0fh@030>7Q01KQ000Gh@030>7Q00[Q00<0hN401^400`3Q
h@0=h@<0A>400`3Qh@0Lh@030>7Q02SQ00<0hN40=N400`3Qh@0Gh@006>400`3Qh@0:h@030>7Q00KQ
0P0@h@80@^400`3Qh@0Lh@030>7Q02SQ00<0hN40=N400`3Qh@0Gh@006>400`3Qh@0;h@030>7Q00OQ
00<0hN403n4203oQ00<0hN407^400`3Qh@0Wh@030>7Q03CQ00<0hN406>4001WQ00<0hN402n400`3Q
h@07h@804N4203gQ00<0hN407^400`3Qh@0Wh@030>7Q03CQ00<0hN406>4001WQ00<0hN403>4200WQ
0P0Ah@<0>N400`3Qh@0Oh@030>7Q02OQ00<0hN40<n400`3Qh@0Ih@006^400`3Qh@0=h@030>7Q00SQ
00<0hN404N4203OQ00<0hN408>400`3Qh@0Vh@030>7Q03?Q00<0hN406N4001[Q00<0hN403^400`3Q
h@08h@804n4203CQ00<0hN408N400`3Qh@0Vh@030>7Q03;Q00<0hN406^4001_Q00<0hN403^400`3Q
h@09h@030>7Q01;Q0`0ah@030>7Q02;Q00<0hN409N400`3Qh@0bh@030>7Q01[Q000Kh@030>7Q00oQ
00<0hN402N4201GQ0P0^h@030>7Q02?Q00<0hN409N400`3Qh@0ah@030>7Q01_Q000Lh@030>7Q00oQ
00<0hN402^400`3Qh@0Dh@80;>400`3Qh@0Sh@030>7Q02GQ00<0hN40<N400`3Qh@0Kh@007>400`3Q
h@0@h@030>7Q00[Q0P0Fh@<0:>400`3Qh@0Uh@030>7Q02CQ00<0hN40<>400`3Qh@0Lh@007N400`3Q
h@0@h@030>7Q00_Q00<0hN405^4202KQ00<0hN409N400`3Qh@0Th@030>7Q033Q00<0hN407>4001gQ
00<0hN404N400`3Qh@0;h@806>4202?Q00<0hN409n400`3Qh@0Sh@030>7Q02oQ00<0hN407N4001kQ
00<0hN404N400`3Qh@0<h@030>7Q01OQ0`0Ph@030>7Q02OQ00<0hN408n400`3Qh@0_h@030>7Q01gQ
000Nh@030>7Q01;Q0P0=h@806^4201gQ00<0hN40:N400`3Qh@0Rh@030>7Q02kQ00<0hN407^4001oQ
00<0hN404n400`3Qh@0<h@030>7Q01WQ0P0Kh@030>7Q02WQ00<0hN408^400`3Qh@0^h@030>7Q01kQ
000Oh@030>7Q01CQ00<0hN403>4201_Q0`0Gh@030>7Q02[Q00<0hN408^400`3Qh@0]h@030>7Q01oQ
000Ph@030>7Q01CQ00<0hN403N400`3Qh@0Kh@805N400`3Qh@0[h@030>7Q027Q00<0hN40;N400`3Q
h@0Oh@008>400`3Qh@0Eh@030>7Q00gQ0P0Mh@804^400`3Qh@0/h@030>7Q027Q00<0hN40;>400`3Q
h@0Ph@008N400`3Qh@0Eh@030>7Q00kQ0P0Mh@<03n400`3Qh@0]h@030>7Q023Q00<0hN40;>400`3Q
h@0Ph@008N400`3Qh@0Fh@030>7Q00oQ00<0hN407N4200cQ00<0hN40;^400`3Qh@0Ph@030>7Q02_Q
00<0hN408N4002;Q00<0hN405^400`3Qh@0?h@807n4200[Q00<0hN40;^400`3Qh@0Ph@030>7Q02_Q
00<0hN408N4002;Q00<0hN405n400`3Qh@0@h@030>7Q01kQ0`06h@030>7Q033Q00<0hN407n400`3Q
h@0Zh@030>7Q02;Q000Sh@030>7Q01OQ00<0hN404>42027Q0P02h@<0<^400`3Qh@0Oh@030>7Q02[Q
00<0hN408^4002?Q00<0hN406>400`3Qh@0Ah@030>7Q023Q1P0bh@030>7Q01kQ00<0hN40:N400`3Q
h@0Sh@009>400`3Qh@0Hh@804^42027Q1@0bh@030>7Q01kQ00<0hN40:N400`3Qh@0Sh@009>400`3Q
h@0Jh@030>7Q017Q00<0hN407^4503?Q00<0hN407N400`3Qh@0Xh@030>7Q02CQ000Uh@030>7Q01[Q
00<0hN404N4201oQ100ch@030>7Q01gQ00<0hN40:>400`3Qh@0Th@009N400`3Qh@0Kh@030>7Q01;Q
00<0hN406n400`3Qh@02h@030>7Q033Q00<0hN407N400`3Qh@0Wh@030>7Q02GQ000Vh@030>7Q01_Q
00<0hN404^4201_Q00<0hN400n400`3Qh@0`h@030>7Q01cQ00<0hN409n400`3Qh@0Uh@009^400`3Q
h@0Lh@030>7Q01?Q00<0hN405n400`3Qh@05h@030>7Q02oQ00<0hN407>400`3Qh@0Vh@030>7Q02KQ
000Wh@030>7Q01cQ00<0hN404n4201OQ00<0hN401^400`3Qh@0_h@030>7Q01_Q00<0hN409^400`3Q
h@0Vh@009n400`3Qh@0Mh@030>7Q01CQ00<0hN404n400`3Qh@08h@030>7Q02kQ00<0hN406n400`3Q
h@0Uh@030>7Q02OQ000Xh@030>7Q01gQ00<0hN405>4201?Q00<0hN402N400`3Qh@0]h@030>7Q01_Q
00<0hN409N400`3Qh@0Wh@00:>400`3Qh@0Nh@030>7Q01GQ00<0hN403n400`3Qh@0;h@030>7Q02gQ
00<0hN406^400`3Qh@0Th@030>7Q02SQ000Yh@030>7Q01kQ0P0Fh@803n400`3Qh@0<h@030>7Q02cQ
00<0hN406^400`3Qh@0Th@030>7Q02SQ000Yh@030>7Q023Q00<0hN405N4200cQ00<0hN403^4202gQ
00<0hN406N400`3Qh@0Sh@030>7Q02WQ000Zh@030>7Q023Q00<0hN405^400`3Qh@09h@030>7Q013Q
00<0hN40:^400`3Qh@0Ih@030>7Q02?Q00<0hN40:N4002[Q00<0hN408N400`3Qh@0Fh@802>400`3Q
h@0Bh@030>7Q02WQ00<0hN406^400`3Qh@0Qh@030>7Q02[Q000[h@030>7Q027Q00<0hN405n400`3Q
h@05h@030>7Q01?Q00<0hN40:N400`3Qh@0Ih@030>7Q027Q00<0hN40:^4002_Q00<0hN408^400`3Q
h@0Gh@801>400`3Qh@0Eh@030>7Q02SQ00<0hN406N400`3Qh@0Ph@030>7Q02_Q000/h@030>7Q02;Q
00<0hN406>401@3QhN4001SQ00<0hN40:>400`3Qh@0Hh@030>7Q023Q00<0hN40:n4002cQ00<0hN40
8n400`3Qh@0Hh@@06N400`3Qh@0Wh@030>7Q01SQ00<0hN407n400`3Qh@0/h@00;N400`3Qh@0Sh@03
0>7Q01OQ1@0Ih@030>7Q02OQ00<0hN405n400`3Qh@0Oh@030>7Q02cQ000]h@030>7Q02CQ00<0hN40
5^4501[Q00<0hN409^400`3Qh@0Gh@030>7Q01kQ00<0hN40;N4002kQ00<0hN409>4201KQ1P0Jh@03
0>7Q02GQ00<0hN405n400`3Qh@0Nh@030>7Q02gQ000^h@030>7Q02KQ00<0hN404n4400;Q0P0Ih@03
0>7Q02GQ00<0hN405^400`3Qh@0Mh@030>7Q02kQ000_h@030>7Q02KQ00<0hN404^400`3Qh@05h@03
0>7Q01OQ00<0hN409>400`3Qh@0Fh@030>7Q01gQ00<0hN40;^4002oQ00<0hN409n400`3Qh@0@h@03
0>7Q00OQ0P0Hh@030>7Q02CQ00<0hN405N400`3Qh@0Lh@030>7Q02oQ000`h@030>7Q02OQ00<0hN40
3n400`3Qh@09h@030>7Q01KQ00<0hN408n400`3Qh@0Eh@030>7Q01cQ00<0hN40;n40033Q00<0hN40
:>400`3Qh@0=h@030>7Q00_Q0P0Gh@030>7Q02;Q00<0hN405N400`3Qh@0Kh@030>7Q033Q000ah@03
0>7Q02SQ00<0hN403>400`3Qh@0=h@030>7Q01GQ00<0hN408^400`3Qh@0Dh@030>7Q01_Q00<0hN40
<>40037Q00<0hN40:N400`3Qh@0:h@030>7Q00oQ00<0hN405N400`3Qh@0Qh@030>7Q01CQ00<0hN40
6^400`3Qh@0ah@00<^400`3Qh@0Yh@030>7Q00WQ00<0hN404>4201KQ00<0hN408N400`3Qh@0Ch@03
0>7Q01[Q00<0hN40<N4003;Q00<0hN40:^400`3Qh@07h@030>7Q01?Q00<0hN405>400`3Qh@0Ph@03
0>7Q01?Q00<0hN406N400`3Qh@0bh@00<n400`3Qh@0Zh@801n400`3Qh@0Dh@805N400`3Qh@0Ph@03
0>7Q01;Q00<0hN406N400`3Qh@0bh@00<n400`3Qh@0/h@030>7Q00?Q00<0hN405n400`3Qh@0Ch@03
0>7Q01oQ00<0hN404^400`3Qh@0Hh@030>7Q03?Q000dh@030>7Q02cQ00<0hN400^400`3Qh@0Hh@80
5>4201oQ00<0hN404^400`3Qh@0Hh@030>7Q03?Q000dh@030>7Q02gQ00@0hN407N400`3Qh@0Ch@03
0>7Q01gQ00<0hN404N400`3Qh@0Gh@030>7Q03CQ000eh@030>7Q02gQ0`0Nh@805>400`3Qh@0Lh@03
0>7Q017Q00<0hN405n400`3Qh@0dh@00=N400`3Qh@0/h@D07n400`3Qh@0Bh@030>7Q01cQ00<0hN40
4>400`3Qh@0Fh@030>7Q03GQ000fh@030>7Q02_Q1P0Oh@804n400`3Qh@0Kh@030>7Q013Q00<0hN40
5^400`3Qh@0eh@00=^400`3Qh@0[h@D000?Q00007n400`3Qh@0Ah@030>7Q01[Q00<0hN404>400`3Q
h@0Eh@030>7Q03KQ000gh@030>7Q02_Q0`04h@807^4201;Q00<0hN406^400`3Qh@0?h@030>7Q01GQ
00<0hN40=^4003OQ00<0hN40:^400`3Qh@07h@807^400`3Qh@0@h@030>7Q01WQ00<0hN403n400`3Q
h@0Dh@030>7Q03OQ000hh@030>7Q02WQ00<0hN402N4201gQ0P0Ah@030>7Q01WQ00<0hN403^400`3Q
h@0Dh@030>7Q03OQ000hh@030>7Q02SQ00<0hN403>4301cQ00<0hN403n400`3Qh@0Hh@030>7Q00kQ
00<0hN404n400`3Qh@0hh@00>N400`3Qh@0Wh@030>7Q00oQ0P0Kh@804>400`3Qh@0Hh@030>7Q00gQ
00<0hN404n400`3Qh@0hh@00>N400`3Qh@0Vh@030>7Q01;Q0P0Kh@030>7Q00kQ00<0hN405n400`3Q
h@0=h@030>7Q01;Q00<0hN40>N4003[Q00<0hN409N400`3Qh@0Dh@806^400`3Qh@0>h@030>7Q01KQ
00<0hN403N400`3Qh@0Bh@030>7Q03WQ000jh@030>7Q02CQ00<0hN405n4201WQ0P0?h@030>7Q01KQ
00<0hN403>400`3Qh@0Ah@030>7Q03[Q000kh@030>7Q02?Q00<0hN406N4201WQ00<0hN403N400`3Q
h@0Eh@030>7Q00cQ00<0hN404N400`3Qh@0jh@00>n400`3Qh@0Rh@030>7Q01cQ0`0Gh@803^400`3Q
h@0Eh@030>7Q00_Q00<0hN404>400`3Qh@0kh@00?>400`3Qh@0Qh@030>7Q01oQ0P0Gh@030>7Q00cQ
00<0hN405>400`3Qh@0;h@030>7Q013Q00<0hN40>n4003cQ00<0hN408>400`3Qh@0Rh@805^4200gQ
00<0hN404n400`3Qh@0;h@030>7Q00oQ00<0hN40?>4003gQ00<0hN407n400`3Qh@0Th@805^400`3Q
h@0;h@030>7Q01?Q00<0hN402^400`3Qh@0?h@030>7Q03cQ000mh@030>7Q01kQ00<0hN409n4201GQ
0P0<h@030>7Q01;Q00<0hN402^400`3Qh@0>h@030>7Q03gQ000nh@030>7Q01gQ00<0hN40:N4201GQ
00<0hN402^400`3Qh@0Bh@030>7Q00WQ00<0hN403^400`3Qh@0mh@00?^400`3Qh@0Lh@030>7Q02cQ
0`0Ch@802n4201;Q00<0hN402N400`3Qh@0=h@030>7Q03kQ000oh@030>7Q01_Q00<0hN40;n4201?Q
00<0hN402^400`3Qh@0@h@030>7Q00SQ00<0hN403N400`3Qh@0nh@00?n400`3Qh@0Jh@030>7Q03;Q
0P0Bh@802n400`3Qh@0?h@030>7Q00SQ00<0hN403>400`3Qh@0oh@00@>400`3Qh@0Ih@030>7Q03CQ
0P0Bh@030>7Q00WQ00<0hN403^400`3Qh@08h@030>7Q00cQ00<0hN40?n40043Q00<0hN406>400`3Q
h@0gh@804N4200[Q00<0hN403^400`3Qh@07h@030>7Q00_Q00<0hN40@>40047Q00<0hN405n400`3Q
h@0ih@804N400`3Qh@08h@030>7Q00gQ00<0hN401n400`3Qh@0;h@030>7Q043Q0011h@030>7Q01KQ
00<0hN40?>42013Q00<0hN402>400`3Qh@0=h@030>7Q00KQ00<0hN402^400`3Qh@11h@00@^400`3Q
h@0Eh@030>7Q03kQ0`0>h@802N400`3Qh@0<h@030>7Q00KQ00<0hN402^400`3Qh@11h@00@^400`3Q
h@0Dh@030>7Q04;Q0P0>h@030>7Q00OQ00<0hN402n400`3Qh@07h@030>7Q00SQ00<0hN40@^4004?Q
00<0hN404n400`3Qh@14h@803N4200SQ00<0hN402n400`3Qh@06h@030>7Q00SQ00<0hN40@^4004?Q
00<0hN404^400`3Qh@17h@803N400`3Qh@06h@030>7Q00[Q00<0hN401^400`3Qh@07h@030>7Q04?Q
0014h@030>7Q017Q00<0hN40BN4200cQ0P07h@030>7Q00[Q00<0hN401N400`3Qh@07h@030>7Q04?Q
0014h@030>7Q013Q00<0hN40C>4200cQ00<0hN401N400`3Qh@09h@030>7Q00GQ00<0hN401^400`3Q
h@14h@00AN400`3Qh@0?h@030>7Q04kQ0`0:h@801^400`3Qh@09h@030>7Q00CQ00<0hN401^400`3Q
h@14h@00AN400`3Qh@0>h@030>7Q05;Q0P0:h@030>7Q00CQ00<0hN402>400`3Qh@04h@030>7Q00GQ
00<0hN40AN4004KQ00<0hN403N400`3Qh@1Dh@802N4200GQ00<0hN401n400`3Qh@04h@030>7Q00GQ
00<0hN40AN4004KQ00<0hN403>400`3Qh@1Gh@802N400`3Qh@03h@030>7Q00OQ00<0hN400n400`3Q
h@04h@030>7Q04KQ0017h@030>7Q00_Q00<0hN40FN4200SQ0P04h@030>7Q00KQ00<0hN400n400`3Q
h@04h@030>7Q04KQ0017h@030>7Q00[Q00<0hN40G>4200SQ00<0hN400^400`3Qh@06h@030>7Q00;Q
00<0hN400n400`3Qh@17h@00B>400`3Qh@09h@030>7Q05kQ0`06h@800n400`3Qh@05h@030>7Q00;Q
00<0hN400n400`3Qh@17h@00B>400`3Qh@08h@030>7Q06;Q0P06h@050>7Qh@001^400`3Qh@02h@03
0>7Q00;Q00<0hN40B>4004WQ00<0hN401n400`3Qh@1Th@801N4200;Q0P05h@050>7Qh@001>400`3Q
h@18h@00BN400`3Qh@06h@030>7Q06OQ0P05h@050>7Qh@001>401@3QhN4000?Q00<0hN40BN4004[Q
00<0hN401N400`3Qh@1Yh@801>401@3QhN4000CQ00@0hN400n400`3Qh@19h@00B^400`3Qh@04h@03
0>7Q06cQ0P03h@800^401@3QhN4000;Q00@0hN40C>4004_Q00<0hN400n400`3Qh@1^h@<00^40103Q
h@03h@030>4000;Q00<0hN40B^4004_Q00<0hN400^400`3Qh@1bh@8000GQ003Q0002h@050>40h@00
CN4004cQ00D0hN7Q001fh@8000[Q0>40h@3Q0>40CN4004cQ00@0hN40NN450004h@0004kQ001=h@03
0>4007_Q1`1>h@00C>4307kQ1@1>h@00Bn6804gQ001;h@D0O^4504gQ001;h@D0O^4504gQ001<h@<0
P>4304kQ003ohB7Q003ohB7Q003ohB7Q003ohB7Q003ohB7Q003ohB7Q003ohB7Q003ohB7Q003ohB7Q
003ohB7Q0000\
\>"],
  ImageRangeCache->{{{0, 287}, {287, 0}} -> {-1.10001, -0.952637, 0.00766559, 
  0.00663859}}]
}, Open  ]],

Cell[TextData[StyleBox[
"\:3000\:3053\:306e\:3088\:3046\:306b\:3057\:3066\:5f97\:3089\:308c\:305f\
\:56f3\:5f62\:306f\:3001  draw[mm, F .  F .  F  . P0] \
\:306b\:3088\:308b\:3082\:306e\:3068\:307b\:3068\:3093\:3069\:540c\:3058\:3067\
\:3042\:308b\:3002\n\:3000\:6b21\:306b\:3001\:5e73\:9762\:7684\:30b0\:30e9\
\:30d5\:306e\:96a3\:63a5\:884c\:5217\:3068\:5916\:5468\:8def\:3092\:4e0e\:3048\
\:305f\:3068\:304d\:3001\:884c\:5217"],
StyleBox[Cell[BoxData[
    FormBox[
      RowBox[{
        RowBox[{"A", ",", " ", "B", ",", " ", 
          RowBox[{
            FormBox[\(\((E - A)\)\^\(-1\)\),
              "TraditionalForm"], "B"}]}], " "}], TextForm]]]],
StyleBox["\:3092\:7528\:3044\:3066\:3001\:5e73\:9762\:30b0\:30e9\:30d5\:3092\
\:63cf\:753b\:3059\:308b\:30d7\:30ed\:30b0\:30e9\:30e0\:3092\:4f5c\:308b\:3068\
\:3001\:6b21\:306e\:3088\:3046\:306b\:66f8\:3051\:308b\:3002\:305f\:3060\:3057\
\:3001\:5916\:5468\:8def\:306f\:3069\:306e\:9806\:756a\:306e\:30b5\:30a4\:30af\
\:30eb\:3067\:3082\:3088\:3044\:3082\:306e\:3068\:3059\:308b\:3002"]], "Text"],

Cell[BoxData[{
    \(makematrix[mtx_, \ len_] := 
      Block[{i, j, k, d, len1, amt, bmt}, \n\tlen1 = Length[mtx]; \n\t
        amt = Table[0, {i, len1 - len}, {j, len1 - len}]; \n\t
        bmt = Table[0, {i, len1 - len}, {j, len}]; \n\ti = len + 1; k = 1; \n
        \tWhile[i <= len1, \n\t\td = Sum[mtx[\([i, j]\)], {j, len1}]; \n\t\t
          For[j = 1, j <= len1, \(j++\), \n\t\t\t
            If[mtx[\([i, j]\)] == 1, \n\t\t\t\t
              If[j <= len, bmt[\([k, j]\)] = 1/d, 
                amt[\([k, j - len]\)] = 1/d]]]; \n\t\t\(k++\); \n\t\t
          \(i++\)]; \n\t
        Return[Inverse[IdentityMatrix[len1 - len] - amt]\  . \ bmt]\n]\), 
    \(rearrange[mtx_, cyl_] := 
      Block[{i, j, len1, len2, cset, tmm1, tmm2}, \n\tlen1 = Length[mtx]; 
        len2 = Length[cyl]; \n\tcset = Complement[Table[i, {i, len1}], cyl]; 
        \n\ttmm1 = mtx; \n\ttmm2 = Table[0, {i, len1}, {j, len1}]; \n\t
        For[j = 0, j < 2, \(j++\), \n\t\t
          For[i = 1, i <= len2, \(i++\), 
            tmm2[\([i]\)] = tmm1[\([cyl[\([i]\)]]\)]]; \n\t\t
          For[i = len2 + 1, i <= len1, \(i++\), 
            tmm2[\([i]\)] = tmm1[\([cset[\([i - len2]\)]]\)]]; \n\t\t
          tmm1 = Transpose[tmm2]; \n\t]; \n\tReturn[tmm1]\n]\), 
    \(\tdrawgraph[mtx_, \ cyl_] := 
      Block[{len1, len2, xy0, \ xy, pairs, mx}, \n\tlen1 = Length[mtx]; 
        len2 = Length[cyl]; \n\t
        If[len1 == len2, xy = circluarvertices[len1]; mx = mtx, \n\t\t\t
          mx = rearrange[mtx, cyl]; \n\t\t\txy0 = circluarvertices[len2]; \n
          \t\t\txy = Join[xy0, makematrix[mx, len2]\  . \ xy0]]; \t\t\t\n\t
        pairs = Position[\ mx, \ _?\((Function[n, n\  != \ 0])\)\ ]; \n\t
        showgraphics[xy, pairs]; \n]\t\)}], "Input"],

Cell[TextData[
"\:3053\:306e\:30d7\:30ed\:30b0\:30e9\:30e0\:3092\:4e0a\:306e\:4f8b\:3067\
\:5b9f\:884c\:3059\:308b\:3002"], "Text"],

Cell[CellGroupData[{

Cell[BoxData[
    \(drawgraph[mm, {1, 2, 3, 4, 5, 6}]\)], "Input"],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: 1 
MathPictureStart
/Mabs {
Mgmatrix idtransform
Mtmatrix dtransform
} bind def
/Mabsadd { Mabs
3 -1 roll add
3 1 roll add
exch } bind def
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
0.5 0.524864 0.5 0.454545 [
[ 0 0 0 0 ]
[ 1 1 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 0 m
1 0 L
1 1 L
0 1 L
closepath
clip
newpath
0 g
.02 w
.5 .95455 Mdot
.04545 .72727 Mdot
.04545 .27273 Mdot
.5 .04545 Mdot
.95455 .27273 Mdot
.95455 .72727 Mdot
.21668 .64166 Mdot
.2758 .6121 Mdot
.34106 .57947 Mdot
.54299 .47851 Mdot
.54753 .28485 Mdot
.69469 .35481 Mdot
.73369 .38316 Mdot
.74254 .42658 Mdot
.73892 .57193 Mdot
.5 Mabswid
.5 .95455 m
.04545 .72727 L
s
.5 .95455 m
.95455 .72727 L
s
.5 .95455 m
.21668 .64166 L
s
.5 .95455 m
.2758 .6121 L
s
.5 .95455 m
.34106 .57947 L
s
.5 .95455 m
.54299 .47851 L
s
.5 .95455 m
.73892 .57193 L
s
.04545 .72727 m
.5 .95455 L
s
.04545 .72727 m
.04545 .27273 L
s
.04545 .72727 m
.21668 .64166 L
s
.04545 .27273 m
.04545 .72727 L
s
.04545 .27273 m
.5 .04545 L
s
.04545 .27273 m
.21668 .64166 L
s
.04545 .27273 m
.2758 .6121 L
s
.04545 .27273 m
.34106 .57947 L
s
.04545 .27273 m
.54299 .47851 L
s
.04545 .27273 m
.54753 .28485 L
s
.5 .04545 m
.04545 .27273 L
s
.5 .04545 m
.95455 .27273 L
s
.5 .04545 m
.54753 .28485 L
s
.95455 .27273 m
.5 .04545 L
s
.95455 .27273 m
.95455 .72727 L
s
.95455 .27273 m
.54753 .28485 L
s
.95455 .27273 m
.69469 .35481 L
s
.95455 .27273 m
.73369 .38316 L
s
.95455 .27273 m
.74254 .42658 L
s
.95455 .27273 m
.73892 .57193 L
s
.95455 .72727 m
.5 .95455 L
s
.95455 .72727 m
.95455 .27273 L
s
.95455 .72727 m
.73892 .57193 L
s
.21668 .64166 m
.5 .95455 L
s
.21668 .64166 m
.04545 .72727 L
s
.21668 .64166 m
.04545 .27273 L
s
.21668 .64166 m
.2758 .6121 L
s
.2758 .6121 m
.5 .95455 L
s
.2758 .6121 m
.04545 .27273 L
s
.2758 .6121 m
.21668 .64166 L
s
.2758 .6121 m
.34106 .57947 L
s
.34106 .57947 m
.5 .95455 L
s
.34106 .57947 m
.04545 .27273 L
s
.34106 .57947 m
.2758 .6121 L
s
.34106 .57947 m
.54299 .47851 L
s
.54299 .47851 m
.5 .95455 L
s
.54299 .47851 m
.04545 .27273 L
s
.54299 .47851 m
.34106 .57947 L
s
.54299 .47851 m
.54753 .28485 L
s
.54299 .47851 m
.69469 .35481 L
s
.54299 .47851 m
.73369 .38316 L
s
.54299 .47851 m
.74254 .42658 L
s
.54299 .47851 m
.73892 .57193 L
s
.54753 .28485 m
.04545 .27273 L
s
.54753 .28485 m
.5 .04545 L
s
.54753 .28485 m
.95455 .27273 L
s
.54753 .28485 m
.54299 .47851 L
s
.54753 .28485 m
.69469 .35481 L
s
.69469 .35481 m
.95455 .27273 L
s
.69469 .35481 m
.54299 .47851 L
s
.69469 .35481 m
.54753 .28485 L
s
.69469 .35481 m
.73369 .38316 L
s
.73369 .38316 m
.95455 .27273 L
s
.73369 .38316 m
.54299 .47851 L
s
.73369 .38316 m
.69469 .35481 L
s
.73369 .38316 m
.74254 .42658 L
s
.74254 .42658 m
.95455 .27273 L
s
.74254 .42658 m
.54299 .47851 L
s
.74254 .42658 m
.73369 .38316 L
s
.74254 .42658 m
.73892 .57193 L
s
.73892 .57193 m
.5 .95455 L
s
.73892 .57193 m
.95455 .27273 L
s
.73892 .57193 m
.95455 .72727 L
s
.73892 .57193 m
.54299 .47851 L
s
.73892 .57193 m
.74254 .42658 L
s
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  ImageSize->{288, 288},
  ImageMargins->{{43, 0}, {0, 0}},
  ImageRegion->{{0, 1}, {0, 1}},
  ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`40004P000180P10`40000100000800002008200000
P800P020P<30`<3L`:K:l00003<006H009T00<`00?l0000c03<c06Hc09Tc0<`c0?lc001V03=V06IV
09UV0<aV0?mV002I03>I06JI09VI0<bI0?nI003<03?<06K<09W<0<c<0?o<003o03?o06Ko09Wo0<co
0?oo0000<c<0<fH0<iT0<l`0<ol0<`0c<c<c<fHc<iTc<l`c<olc<`1V<c=V<fIV<iUV<laV<omV<`2I
<c>I<fJI<iVI<lbI<onI<`3<<c?<<fK<<iW<<lc<<oo<<`3o<c?o<fKo<iWo<lco<ooo<`00IS<0IVH0
IYT0I/`0I_l0IP0cIS<cIVHcIYTcI/`cI_lcIP1VIS=VIVIVIYUVI/aVI_mVIP2IIS>IIVJIIYVII/bI
I_nIIP3<IS?<IVK<IYW<I/c<I_o<IP3oIS?oIVKoIYWoI/coI_ooIP00VC<0VFH0VIT0VL`0VOl0V@0c
VC<cVFHcVITcVL`cVOlcV@1VVC=VVFIVVIUVVLaVVOmVV@2IVC>IVFJIVIVIVLbIVOnIV@3<VC?<VFK<
VIW<VLc<VOo<V@3oVC?oVFKoVIWoVLcoVOooV@00c3<0c6H0c9T0c<`0c?l0c00cc3<cc6Hcc9Tcc<`c
c?lcc01Vc3=Vc6IVc9UVc<aVc?mVc02Ic3>Ic6JIc9VIc<bIc?nIc03<c3?<c6K<c9W<c<c<c?o<c03o
c3?oc6Koc9Woc<coc?ooc000oc<0ofH0oiT0ol`0ool0o`0coc<cofHcoiTcol`coolco`1Voc=VofIV
oiUVolaVoomVo`2Ioc>IofJIoiVIolbIoonIo`3<oc?<ofK<oiW<olc<ooo<o`3ooc?oofKooiWoolco
ooooo`0000410@820P<30`@410D51@H61PL71`P820T92@X:2P/;2``<30h>3Pl?3a0@414A4A8B4Q<C
4a@D5?okl:2PY820P?l0003o0?oo0000ool0o`3ooooooooQ8N400?oQ8N400?oQ8N400?oQ8N400?oQ
8N400?oQ8N400?oQ8N400?oQ8N400?oQ8N400?oQ8N400?oQ8N400?oQ8N4008kQ0`2?h@00SN4508kQ
002=h@D0S^4008gQ1@2>h@00Rn420005h@000>400P2<h@00RN4200GQ00@0hN7Q0P2:h@00Qn4200OQ
00<0hN400n4208SQ0025h@802N400`3Qh@05h@80Q^4008?Q0P0;h@030>7Q00OQ0P24h@00PN4200gQ
00<0hN402N4208;Q001oh@804>400`3Qh@0:h@80P>4007gQ0P0Bh@030>7Q00cQ0P1nh@00Nn4201CQ
00<0hN403^4207cQ001ih@805^400`3Qh@0@h@80N^4007OQ0P0Hh@030>7Q01;Q0P1hh@00MN4201_Q
00<0hN404n4207KQ001ch@807N400`3Qh@0Eh@80M>40077Q0P0Oh@030>7Q01OQ0P1bh@00Kn42027Q
00<0hN406N42073Q001]h@808n400`3Qh@0Kh@80K^4006_Q0P0Vh@030>7Q01cQ0P1/h@00JN4202SQ
00<0hN407^4206[Q001Wh@80:^400`3Qh@0Ph@80J>4006GQ0P0/h@030>7Q02;Q0P1Vh@00Hn4202oQ
00<0hN408n4206CQ001Qh@80<N400`3Qh@0Uh@80H^4005oQ0P0ch@030>7Q02OQ0P1Ph@00GN4203GQ
00<0hN40:N4205kQ001Kh@80=n400`3Qh@0[h@80G>4005WQ0P0jh@030>7Q02cQ0P1Jh@00En4203cQ
00<0hN40;^4205SQ001Eh@80?^400`3Qh@0`h@80E^4005?Q0P10h@030>7Q03;Q0P1Dh@00DN4204;Q
00<0hN40=>4205;Q001?h@80AN400`3Qh@0eh@80D>4004gQ0P17h@030>7Q03OQ0P1>h@00Bn4204WQ
00<0hN40>N4204cQ0019h@80Bn400`3Qh@0kh@80B^4004OQ0P1=h@030>7Q03gQ0P18h@00AN42053Q
00<0hN40?^4204KQ0013h@80D^400`3Qh@10h@80A>40047Q0P1Dh@030>7Q04;Q0P12h@00?n4205KQ
00<0hN40A>42043Q000mh@80F>400`3Qh@16h@80?^4003_Q0P1Kh@030>7Q04OQ0P0lh@00>N4205gQ
00<0hN40BN4203[Q000gh@80Gn400`3Qh@1;h@80>>4003GQ0P1Qh@030>7Q04gQ0P0fh@00<n4206?Q
00<0hN40Cn4203CQ000ah@80I^400`3Qh@1@h@80<^4002oQ0P1Xh@030>7Q05;Q0P0`h@00;N4206[Q
00<0hN40E>4202kQ000[h@80K>400`3Qh@1Fh@80;>4002WQ0P1^h@030>7Q05SQ0P0Zh@009n42077Q
00<0hN40FN4202SQ000Uh@80Ln400`3Qh@1Kh@809^4002?Q0P1eh@030>7Q05gQ0P0Th@008N4207OQ
00<0hN40Gn4202;Q000Oh@80N^400`3Qh@1Ph@808>4001gQ0P1lh@030>7Q06;Q0P0Nh@006n4207kQ
00<0hN40I>4201cQ000Ih@80P>400`3Qh@1Vh@806^4001OQ0P22h@030>7Q06SQ0P0Hh@005N4208GQ
00<0hN40JN4201KQ000Ch@80Qn400`3Qh@1[h@805>4000_Q0`03h@80RN400`3Qh@1]h@800^4300gQ
000:h@L0Rn400`3Qh@1_h@H03>4000[Q6`1gh@030>7Q05oQ5P0<h@002^4701CQ<018h@030>7Q03SQ
9P0?h@L03>4000_Q1@001>400011hC005^4301?Q9`0ah@H000CQ00003N4000gQ1003h@80Kn4/05GQ
0`002N400>40h@3Q000>h@003N400`3Q000200CQ0P22h@L0H^4300;Q0P001N400>4000;Q00<0hN40
3>4000gQ00H0h@00h@05h@<0On4500;Q0P1Mh@<00n4200;Q00@0hN400n400`3Qh@0<h@003N400`3Q
h@020003h@3Q00KQ0P1nh@<01N4205SQ0`04h@800n401@3QhN4000?Q00<0hN403>4000gQ00P0hN40
h@3Q00SQ0`1mh@030>7Q00GQ0P1Bh@@01N4200?Q0P03h@030>7Q00;Q00<0hN403>4000gQ00@0hN7Q
0P02h@030>7Q00SQ0P1kh@030>7Q00OQ0P1=h@<01n4200CQ00<0hN400^400`3Qh@03h@030>7Q00cQ
000=h@070>7Qh@3Q0002h@030>7Q00WQ0P1ih@030>7Q00WQ0P18h@<02>4200GQ00<0hN400n400`3Q
h@03h@030>7Q00cQ000=h@030>7Q00;Q00<0h@000^400`3Qh@0:h@<0M^400`3Qh@0;h@80@n4300WQ
0P05h@801N400`3Qh@04h@030>7Q00cQ000=h@030>7Q00;Q00<0h@000^400`3Qh@0=h@80M>400`3Q
h@0=h@80?^4300[Q0P06h@030>7Q00CQ00<0hN401N400`3Qh@0<h@003N400`3Qh@03h@030>4000;Q
00<0hN403^43077Q00<0hN403n4203SQ100;h@801^4200KQ00<0hN401^400`3Qh@0<h@003N400`3Q
h@03h@040>7Q00;Q00<0hN404>4206oQ00<0hN404N4303;Q0`0=h@801n400`3Qh@06h@030>7Q00KQ
00<0hN403>4000gQ00<0hN400n401@3QhN4000;Q00<0hN404N4206gQ00<0hN405>4202gQ0`0>h@80
2>400`3Qh@06h@030>7Q00OQ00<0hN403>4000gQ00<0hN401>40103Qh@03h@030>7Q01;Q0`1Zh@03
0>7Q01KQ0P0Xh@<03n4200SQ0P08h@030>7Q00SQ00<0hN403>4000gQ00<0hN401>401@3QhN4000?Q
00<0hN405>4206SQ00<0hN406>4202;Q100@h@802N400`3Qh@08h@030>7Q00SQ00<0hN403>4000gQ
00<0hN401N401@3QhN4000?Q00<0hN405N4306CQ00<0hN406n4201gQ0`0Bh@802^400`3Qh@08h@03
0>7Q00WQ00<0hN403>4000gQ00<0hN401N401@3QhN4000CQ00<0hN405n4206;Q00<0hN407N4201SQ
0`0Ch@802^4200[Q00<0hN402^400`3Qh@0<h@003N400`3Qh@06h@050>7Qh@001>400`3Qh@0Hh@80
H>400`3Qh@0Oh@804n4301CQ0P0;h@030>7Q00[Q00<0hN402^400`3Qh@0<h@003N400`3Qh@06h@03
0>7Q00;Q00<0hN400^400`3Qh@0Ih@<0GN400`3Qh@0Qh@803^4301GQ0P0<h@030>7Q00[Q00<0hN40
2n400`3Qh@0<h@003N400`3Qh@07h@050>7Qh@001N400`3Qh@0Kh@80Fn400`3Qh@0Sh@802>4401KQ
0P0<h@803>400`3Qh@0<h@030>7Q00cQ000=h@030>7Q00OQ00<0hN400^400`3Qh@03h@030>7Q01cQ
0`1Hh@030>7Q02GQ200Hh@803N400`3Qh@0;h@030>7Q00gQ00<0hN403>4000gQ00<0hN402>400`3Q
h@02h@030>7Q00?Q00<0hN407^4205KQ00<0hN409^4501SQ0P0=h@803^400`3Qh@0=h@030>7Q00cQ
000=h@030>7Q00SQ00<0hN400^400`3Qh@04h@030>7Q01oQ0P1Dh@030>7Q02KQ1@0Fh@803^400`3Q
h@0=h@030>7Q00kQ00<0hN403>4000gQ00<0hN402N400`3Qh@02h@030>7Q00CQ00<0hN408>43057Q
00<0hN409N4701?Q0P0?h@030>7Q00gQ00<0hN403n400`3Qh@0<h@003N400`3Qh@09h@030>7Q00?Q
00<0hN401>400`3Qh@0Rh@80Cn400`3Qh@0Th@030>7Q00<00^400`3Qh@0>h@803n42013Q00<0hN40
3n400`3Qh@0<h@003N400`3Qh@09h@030>7Q00?Q00<0hN401N400`3Qh@0Sh@<0C>400`3Qh@0Sh@03
0>7Q00OQ0P0<h@804>400`3Qh@0?h@030>7Q013Q00<0hN403>4000gQ00<0hN402^400`3Qh@03h@03
0>7Q00GQ00<0hN409N4204[Q00<0hN408^400`3Qh@0:h@030>7Q00OQ0P0Ah@030>7Q00oQ00<0hN40
4N400`3Qh@0<h@003N400`3Qh@0:h@030>7Q00CQ00<0hN401N400`3Qh@0Vh@80B>400`3Qh@0Qh@03
0>7Q00cQ00<0hN401>42017Q0P0Ah@030>7Q01;Q00<0hN403>4000gQ00<0hN402n400`3Qh@03h@03
0>7Q00KQ00<0hN409n4304GQ00<0hN407n42013Q1P0Bh@030>7Q017Q00<0hN404^400`3Qh@0<h@00
3N400`3Qh@0;h@030>7Q00CQ00<0hN401^400`3Qh@0Yh@80@n400`3Qh@0Nh@030>7Q013Q1@0Bh@03
0>7Q017Q00<0hN404n400`3Qh@0<h@003N400`3Qh@0<h@030>7Q00CQ00<0hN401^400`3Qh@0Zh@<0
@>400`3Qh@0Mh@030>7Q017Q1@0@h@804n400`3Qh@0Dh@030>7Q00cQ000=h@030>7Q00cQ00<0hN40
1>400`3Qh@06h@030>7Q02gQ0P0nh@030>7Q01cQ00<0hN404>4700oQ00<0hN404n400`3Qh@0Dh@03
0>7Q00cQ000=h@030>7Q00gQ00<0hN401>400`3Qh@06h@030>7Q02kQ0`0kh@030>7Q01[Q0P0Ah@80
0n4300kQ0P0Eh@030>7Q01GQ00<0hN403>4000gQ00<0hN403N400`3Qh@05h@030>7Q00KQ00<0hN40
<>4203WQ00<0hN406N400`3Qh@0?h@801n400`3Qh@0;h@030>7Q01CQ00<0hN405^400`3Qh@0<h@00
3N400`3Qh@0>h@030>7Q00CQ00<0hN401n400`3Qh@0ah@80=n400`3Qh@0Hh@030>7Q00kQ0P09h@03
0>7Q00[Q00<0hN405>400`3Qh@0Gh@030>7Q00cQ000=h@030>7Q00kQ00<0hN401N400`3Qh@07h@03
0>7Q03;Q0`0dh@030>7Q01OQ00<0hN403N4200_Q00<0hN402>4201OQ00<0hN405n400`3Qh@0<h@00
3N400`3Qh@0?h@030>7Q00GQ00<0hN401n400`3Qh@0dh@80<^400`3Qh@0Fh@030>7Q00cQ0P0>h@03
0>7Q00KQ00<0hN405^400`3Qh@0Hh@030>7Q00cQ000=h@030>7Q00oQ00<0hN401^400`3Qh@07h@03
0>7Q03GQ0`0_h@030>7Q01CQ0P0=h@804>400`3Qh@05h@030>7Q01KQ00<0hN406N400`3Qh@0<h@00
3N400`3Qh@0?h@030>7Q00KQ00<0hN402>400`3Qh@0gh@80;N400`3Qh@0Ch@030>7Q00_Q0P0Bh@03
0>7Q00?Q0P0Ih@030>7Q01WQ00<0hN403>4000gQ00<0hN404>400`3Qh@06h@030>7Q00SQ00<0hN40
>>4202_Q00<0hN404^400`3Qh@0:h@805>400`3Qh@02h@030>7Q01SQ00<0hN406^400`3Qh@0<h@00
3N400`3Qh@0@h@030>7Q00OQ00<0hN402>400`3Qh@0ih@<0:>400`3Qh@0Ah@030>7Q00WQ0P0Eh@<0
0^400`3Qh@0Hh@030>7Q01_Q00<0hN403>4000gQ00<0hN404N400`3Qh@06h@030>7Q00WQ00<0hN40
>n4202KQ00<0hN403n4200[Q0P0Fh@H06^400`3Qh@0Lh@030>7Q00cQ000=h@030>7Q017Q00<0hN40
1n400`3Qh@09h@030>7Q03cQ0`0Sh@030>7Q00kQ00<0hN402>4201SQ1@0Kh@030>7Q01cQ00<0hN40
3>4000gQ00<0hN404^400`3Qh@07h@030>7Q00WQ00<0hN40?^42023Q00<0hN403^400`3Qh@07h@80
6>4701[Q00<0hN407N400`3Qh@0<h@003N400`3Qh@0Bh@030>7Q00OQ00<0hN402^400`3Qh@0oh@80
7^400`3Qh@0=h@030>7Q00KQ0P0Fh@@00n4301[Q00<0hN407^400`3Qh@0<h@003N400`3Qh@0Ch@03
0>7Q00OQ00<0hN402^400`3Qh@10h@<06n400`3Qh@0<h@030>7Q00GQ0P0Dh@@02N400`3Qh@0Hh@03
0>7Q01kQ00<0hN403>4000gQ00<0hN404n400`3Qh@08h@030>7Q00[Q00<0hN40@^4201WQ00<0hN40
2^4200KQ0P0Bh@@03N400`3Qh@0Gh@030>7Q01oQ00<0hN403>4000gQ00<0hN405>400`3Qh@07h@03
0>7Q00_Q00<0hN40@n4301KQ00<0hN402N400`3Qh@04h@804>44017Q00<0hN405^400`3Qh@0Ph@03
0>7Q00cQ000=h@030>7Q01CQ00<0hN402>400`3Qh@0;h@030>7Q04GQ0P0Dh@030>7Q00SQ00<0hN40
0n4200kQ100Eh@030>7Q01KQ00<0hN408>400`3Qh@0<h@003N400`3Qh@0Eh@030>7Q00SQ00<0hN40
2n400`3Qh@16h@804^400`3Qh@07h@030>7Q00;Q0P0=h@<06N400`3Qh@0Eh@030>7Q027Q00<0hN40
3>4000gQ00<0hN405N400`3Qh@08h@030>7Q00cQ00<0hN40An4300oQ00<0hN401N4200?Q0P0;h@@0
7>400`3Qh@0Dh@030>7Q02;Q00<0hN403>4000gQ00<0hN405N400`3Qh@09h@030>7Q00cQ00<0hN40
BN4200gQ00<0hN401>40103QhN4200WQ100Ph@030>7Q01?Q00<0hN408n400`3Qh@0<h@003N400`3Q
h@0Fh@030>7Q00WQ00<0hN403>400`3Qh@1:h@<02^400`3Qh@03h@030>7Q00801n4402CQ00<0hN40
4n400`3Qh@0Sh@030>7Q00cQ000=h@030>7Q01KQ00<0hN402N400`3Qh@0<h@030>7Q04gQ0P08h@03
0>7Q00;Q00@0h@001N4402SQ00<0hN404^400`3Qh@0Th@030>7Q00cQ000=h@030>7Q01OQ00<0hN40
2N400`3Qh@0<h@030>7Q04kQ0P06h@040>7Qh@<00n4402cQ00<0hN404N400`3Qh@0Uh@030>7Q00cQ
000=h@030>7Q01OQ00<0hN402^400`3Qh@0<h@030>7Q04oQ0`02h@H000?Q00000P0`h@030>7Q017Q
00<0hN409N400`3Qh@0<h@003N400`3Qh@0Hh@030>7Q00WQ00<0hN403N400`3Qh@1Ah@T0=>400`3Q
h@0@h@030>7Q02KQ00<0hN403>4000gQ00<0hN406>400`3Qh@0:h@030>7Q00gQ00<0hN40DN4503OQ
00<0hN403n400`3Qh@0Wh@030>7Q00cQ000=h@030>7Q01WQ00<0hN402^400`3Qh@0=h@030>7Q053Q
1P0fh@030>7Q00kQ00<0hN40:>400`3Qh@0<h@003N400`3Qh@0Ih@030>7Q00_Q00<0hN403N400`3Q
h@1=h@8000CQ00000^4203CQ00<0hN403^400`3Qh@0Xh@030>7Q00cQ000=h@030>7Q01[Q00<0hN40
2^400`3Qh@0>h@030>7Q04[Q0P04h@030>7Q00?Q0P0bh@030>7Q00gQ00<0hN40:N400`3Qh@0<h@00
3N400`3Qh@0Jh@030>7Q00_Q00<0hN403^400`3Qh@17h@801^400`3Qh@05h@80<>400`3Qh@0<h@03
0>7Q02[Q00<0hN403>4000gQ00<0hN406n400`3Qh@0;h@030>7Q00kQ00<0hN40A>4200SQ00<0hN40
1n4202kQ00<0hN403>400`3Qh@0Zh@030>7Q00cQ000=h@030>7Q01_Q00<0hN402n400`3Qh@0?h@03
0>7Q047Q0P09h@030>7Q00[Q0P0[h@030>7Q00cQ00<0hN40:n400`3Qh@0<h@003N400`3Qh@0Lh@03
0>7Q00_Q00<0hN403n400`3Qh@0nh@802n400`3Qh@0<h@80:N400`3Qh@0;h@030>7Q02cQ00<0hN40
3>4000gQ00<0hN407>400`3Qh@0<h@030>7Q00oQ00<0hN40>n4200gQ00<0hN403^4202OQ00<0hN40
2^400`3Qh@0]h@030>7Q00cQ000=h@030>7Q01cQ00<0hN403>400`3Qh@0@h@030>7Q03SQ0P0?h@03
0>7Q013Q0`0Th@030>7Q00[Q00<0hN40;N400`3Qh@0<h@003N400`3Qh@0Mh@030>7Q00cQ00<0hN40
4>400`3Qh@0eh@804N400`3Qh@0Ch@808^400`3Qh@09h@030>7Q02kQ00<0hN403>4000gQ00<0hN40
7N400`3Qh@0=h@030>7Q013Q00<0hN40<^4201?Q00<0hN405N42023Q00<0hN402>400`3Qh@0_h@03
0>7Q00cQ000=h@030>7Q01kQ00<0hN403>400`3Qh@0Ah@030>7Q02oQ0P0Eh@030>7Q01OQ0P0Nh@03
0>7Q00SQ00<0hN40;n400`3Qh@0<h@003N400`3Qh@0Nh@030>7Q00gQ00<0hN404N400`3Qh@0/h@80
5n400`3Qh@0Ih@807>400`3Qh@07h@030>7Q033Q00<0hN403>4000gQ00<0hN407n400`3Qh@0=h@03
0>7Q017Q00<0hN40:N4201WQ00<0hN406n4201[Q00<0hN401^400`3Qh@0ah@030>7Q00cQ000=h@03
0>7Q01oQ00<0hN403N400`3Qh@0Bh@030>7Q02KQ0P0Kh@030>7Q01gQ0P0Hh@030>7Q00KQ00<0hN40
<N400`3Qh@0<h@003N400`3Qh@0Ph@030>7Q00gQ00<0hN404^400`3Qh@0Sh@807N400`3Qh@0Oh@80
5^400`3Qh@05h@030>7Q03;Q00<0hN403>4000gQ00<0hN408>400`3Qh@0>h@030>7Q01;Q00<0hN40
8>4201kQ00<0hN408^4201CQ00<0hN401>400`3Qh@0ch@030>7Q00cQ000=h@030>7Q027Q00<0hN40
3N400`3Qh@0Bh@030>7Q01kQ0P0Ph@030>7Q02CQ0`0Ah@030>7Q00?Q00<0hN40=>400`3Qh@0<h@00
3N400`3Qh@0Qh@030>7Q00kQ00<0hN404^400`3Qh@0Kh@808^400`3Qh@0Wh@803n400`3Qh@03h@03
0>7Q03CQ00<0hN403>4000gQ00<0hN408^400`3Qh@0>h@030>7Q01;Q00<0hN406>4202CQ00<0hN40
:N4200gQ00<0hN400^400`3Qh@0eh@030>7Q00cQ000=h@030>7Q02;Q00<0hN403^400`3Qh@0Ch@03
0>7Q01GQ0P0Vh@030>7Q02_Q0P0;h@050>7Qh@00>>400`3Qh@0<h@003N400`3Qh@0Rh@030>7Q00oQ
00<0hN404n400`3Qh@0Bh@80:>400`3Qh@0]h@802N401@3QhN4003SQ00<0hN403>4000gQ00<0hN40
8n400`3Qh@0?h@030>7Q01?Q00<0hN403n4202[Q00<0hN40;n4200OQ00@0hN40>N400`3Qh@0<h@00
3N400`3Qh@0Sh@030>7Q00oQ00<0hN405>400`3Qh@0<h@80;>400`3Qh@0ah@801N400`3Q000jh@03
0>7Q00cQ000=h@030>7Q02CQ00<0hN403n400`3Qh@0Dh@030>7Q00WQ0P0^h@030>7Q03?Q0P000n40
000203_Q00<0hN403>4000gQ00<0hN409>400`3Qh@0@h@030>7Q01CQ00<0hN401^42033Q00<0hN40
=N4503_Q00<0hN403>4000gQ00<0hN409N400`3Qh@0@h@030>7Q01CQ1002h@80<^400`3Qh@0eh@D0
>n400`3Qh@0<h@003N400`3Qh@0Uh@030>7Q013Q00<0hN405>4603CQ00<0hN40=N4603[Q00<0hN40
3>4000gQ00<0hN409^400`3Qh@0@h@030>7Q01?Q1@0dh@030>7Q03OQ0`02h@030>7Q03OQ00<0hN40
3>4000gQ00<0hN409^400`3Qh@0Ah@030>7Q01;Q1@0dh@030>7Q03OQ00<0hN400n400`3Qh@0fh@03
0>7Q00cQ000=h@030>7Q02OQ00<0hN404>400`3Qh@0@h@8000CQ0000=N400`3Qh@0fh@030>7Q00GQ
0P0fh@030>7Q00cQ000=h@030>7Q02OQ00<0hN404N400`3Qh@0=h@801N400`3Qh@0ch@030>7Q03KQ
00<0hN401n400`3Qh@0ch@030>7Q00cQ000=h@030>7Q02SQ00<0hN404N400`3Qh@0:h@802>400`3Q
h@0bh@030>7Q03GQ00<0hN402N4203?Q00<0hN403>4000gQ00<0hN40:>400`3Qh@0Ah@030>7Q00SQ
0P0:h@030>7Q03;Q00<0hN40=N400`3Qh@0;h@030>7Q033Q00<0hN403>4000gQ00<0hN40:>400`3Q
h@0Bh@030>7Q00GQ0P0=h@030>7Q037Q00<0hN40=>400`3Qh@0=h@030>7Q02oQ00<0hN403>4000gQ
00<0hN40:N400`3Qh@0Ah@<00n4200oQ00<0hN40<N400`3Qh@0ch@030>7Q00oQ0P0_h@030>7Q00cQ
000=h@030>7Q02WQ00<0hN404>47017Q00<0hN40<N400`3Qh@0ch@030>7Q017Q00<0hN40;>400`3Q
h@0<h@003N400`3Qh@0Zh@030>7Q00oQ1@0Dh@030>7Q033Q00<0hN40<^400`3Qh@0Ch@030>7Q02_Q
00<0hN403>4000gQ00<0hN40:^400`3Qh@0?h@D05>400`3Qh@0`h@030>7Q037Q00<0hN405N4202_Q
00<0hN403>4000gQ00<0hN40:n400`3Qh@0=h@H05N400`3Qh@0^h@030>7Q03;Q00<0hN405n400`3Q
h@0Xh@030>7Q00cQ000=h@030>7Q02_Q00<0hN402n4200KQ00<0hN404^400`3Qh@0^h@030>7Q037Q
00<0hN406N4202SQ00<0hN403>4000gQ00<0hN40;>400`3Qh@08h@802N400`3Qh@0Bh@030>7Q02gQ
00<0hN40<N400`3Qh@0Kh@030>7Q02GQ00<0hN403>4000gQ00<0hN40;>400`3Qh@06h@802n400`3Q
h@0Bh@030>7Q02gQ00<0hN40<>400`3Qh@0Mh@030>7Q02CQ00<0hN403>4000gQ00<0hN40;N400`3Q
h@03h@803^400`3Qh@0Ah@030>7Q02gQ00<0hN40;n400`3Qh@0Oh@809>400`3Qh@0<h@003N400`3Q
h@0/h@<00^42017Q00<0hN404N400`3Qh@0/h@030>7Q02oQ00<0hN408N400`3Qh@0Qh@030>7Q00cQ
000=h@030>7Q02_Q1P0Ch@030>7Q017Q00<0hN40;>400`3Qh@0^h@030>7Q02?Q0P0Qh@030>7Q00cQ
000=h@030>7Q02_Q1@0Eh@030>7Q017Q00<0hN40:n400`3Qh@0]h@030>7Q02KQ00<0hN407^400`3Q
h@0<h@003N400`3Qh@0[h@D05^400`3Qh@0@h@030>7Q02_Q00<0hN40;N400`3Qh@0Wh@030>7Q01gQ
00<0hN403>4000gQ00<0hN40:N420006h@000>405N400`3Qh@0Ah@030>7Q02[Q00<0hN40;>400`3Q
h@0Yh@807N400`3Qh@0<h@003N400`3Qh@0Wh@802>400`3Qh@0Ch@030>7Q013Q00<0hN40:^400`3Q
h@0[h@030>7Q02cQ00<0hN406^400`3Qh@0<h@003N400`3Qh@0Uh@802n400`3Qh@0Bh@030>7Q013Q
00<0hN40:N400`3Qh@0/h@030>7Q02gQ00<0hN406N400`3Qh@0<h@003N400`3Qh@0Sh@803^400`3Q
h@0Bh@030>7Q013Q00<0hN40:>400`3Qh@0[h@030>7Q02oQ0P0Ih@030>7Q00cQ000=h@030>7Q027Q
0P0@h@030>7Q01?Q00<0hN403n400`3Qh@0Xh@030>7Q02_Q00<0hN40<N400`3Qh@0Fh@030>7Q00cQ
000=h@030>7Q01oQ0P0Ch@030>7Q01;Q00<0hN404>400`3Qh@0Wh@030>7Q02[Q00<0hN40<n4201KQ
00<0hN403>4000gQ00<0hN407N4201KQ00<0hN404^400`3Qh@0?h@030>7Q02OQ00<0hN40:N400`3Q
h@0fh@030>7Q01?Q00<0hN403>4000gQ00<0hN406n4201WQ00<0hN404^400`3Qh@0?h@030>7Q02KQ
00<0hN40:N400`3Qh@0gh@030>7Q01;Q00<0hN403>4000gQ00<0hN406N4201cQ00<0hN404N400`3Q
h@0?h@030>7Q02KQ00<0hN40:>400`3Qh@0ih@804^400`3Qh@0<h@003N400`3Qh@0Gh@807n400`3Q
h@0Ah@030>7Q00kQ00<0hN409^400`3Qh@0Wh@030>7Q03cQ00<0hN403n400`3Qh@0<h@003N400`3Q
h@0Eh@808^400`3Qh@0Ah@030>7Q00kQ00<0hN409N400`3Qh@0Wh@030>7Q03gQ0P0?h@030>7Q00cQ
000=h@030>7Q01?Q0P0Uh@030>7Q013Q00<0hN403^400`3Qh@0Uh@030>7Q02KQ00<0hN40@>400`3Q
h@0<h@030>7Q00cQ000=h@030>7Q017Q0P0Xh@030>7Q013Q00<0hN403^400`3Qh@0Th@030>7Q02GQ
00<0hN40@^400`3Qh@0;h@030>7Q00cQ000=h@030>7Q00oQ0P0[h@030>7Q013Q00<0hN403N400`3Q
h@0Th@030>7Q02GQ00<0hN40@n4200_Q00<0hN403>4000gQ00<0hN403N4202kQ00<0hN403n400`3Q
h@0>h@030>7Q02;Q00<0hN409N400`3Qh@16h@030>7Q00SQ00<0hN403>4000gQ00<0hN402n42033Q
00<0hN404>400`3Qh@0=h@030>7Q02;Q00<0hN409N400`3Qh@17h@030>7Q00OQ00<0hN403>4000gQ
00<0hN402N4203?Q00<0hN404>400`3Qh@0<h@030>7Q02;Q00<0hN409>400`3Qh@19h@801n400`3Q
h@0<h@003N400`3Qh@07h@80=^400`3Qh@0?h@030>7Q00gQ00<0hN408N400`3Qh@0Sh@030>7Q04cQ
00<0hN401>400`3Qh@0<h@003N400`3Qh@05h@80>N400`3Qh@0?h@030>7Q00cQ00<0hN408N400`3Q
h@0Sh@030>7Q04gQ0P04h@030>7Q00cQ000=h@030>7Q00?Q0P0lh@030>7Q00oQ00<0hN403>400`3Q
h@0Ph@030>7Q02;Q00<0hN40D>401@3QhN4000kQ000=h@040>7Qh@80?n400`3Qh@0>h@030>7Q00cQ
00<0hN408>400`3Qh@0Qh@030>7Q05;Q00@0hN403^4000_Q0`000n400012h@030>7Q00kQ00<0hN40
3>400`3Qh@0Oh@030>7Q027Q00<0hN40Dn4400gQ000:h@D0AN400`3Qh@0>h@030>7Q00_Q00<0hN40
7n400`3Qh@0Ph@030>7Q05CQ1@0<h@002^4604GQ00<0hN403N400`3Qh@0;h@030>7Q01oQ00<0hN40
8>400`3Qh@1Dh@D03>4000[Q1@000n400014h@030>7Q00gQ00<0hN402n400`3Qh@0Nh@030>7Q01oQ
00<0hN40Dn4700cQ000;h@<01>4204?Q00<0hN403N400`3Qh@0:h@030>7Q01gQ00<0hN407n400`3Q
h@1Bh@800n4300gQ000Dh@80@N400`3Qh@0=h@030>7Q00_Q00<0hN407>400`3Qh@0Oh@030>7Q053Q
0P0Eh@005^42043Q00<0hN403N400`3Qh@0:h@030>7Q01cQ00<0hN407^400`3Qh@1?h@805n4001SQ
0P0oh@030>7Q00cQ00<0hN402n400`3Qh@0Kh@030>7Q01gQ00<0hN40C^4201WQ000Jh@80?^400`3Q
h@0<h@030>7Q00[Q00<0hN406n400`3Qh@0Mh@030>7Q04cQ0P0Kh@007>4203gQ00<0hN403>400`3Q
h@09h@030>7Q01_Q00<0hN407>400`3Qh@1;h@807N4001kQ0P0lh@030>7Q00_Q00<0hN402^400`3Q
h@0Jh@030>7Q01_Q00<0hN40B^4201oQ000Ph@80>n400`3Qh@0;h@030>7Q00WQ00<0hN406^400`3Q
h@0Kh@030>7Q04SQ0P0Qh@008^4203[Q00<0hN402n400`3Qh@09h@030>7Q01WQ00<0hN406^400`3Q
h@17h@808n4002CQ0P0ih@030>7Q00[Q00<0hN402N400`3Qh@0Ih@030>7Q01[Q00<0hN40AN4202GQ
000Vh@80>>400`3Qh@0:h@030>7Q00WQ00<0hN406>400`3Qh@0Ih@030>7Q04CQ0P0Wh@00:>4203OQ
00<0hN402^400`3Qh@08h@030>7Q01OQ00<0hN406N400`3Qh@13h@80:N4002[Q0P0eh@030>7Q00[Q
00<0hN402N400`3Qh@0Fh@030>7Q01WQ00<0hN40@N4202_Q000/h@80=>400`3Qh@0:h@030>7Q00SQ
00<0hN405^400`3Qh@0Hh@030>7Q043Q0P0]h@00;^4203?Q00<0hN402^400`3Qh@07h@030>7Q01KQ
00<0hN405n400`3Qh@0oh@80;n40033Q0P0bh@030>7Q00WQ00<0hN402>400`3Qh@0Eh@030>7Q01OQ
00<0hN40?N42037Q000bh@80<N400`3Qh@09h@030>7Q00OQ00<0hN405N400`3Qh@0Fh@030>7Q03cQ
0P0ch@00=>42033Q00<0hN402N400`3Qh@07h@030>7Q01CQ00<0hN405N400`3Qh@0kh@80=N4003KQ
0P0_h@030>7Q00SQ00<0hN401n400`3Qh@0Dh@030>7Q01GQ00<0hN40>N4203OQ000hh@80;^400`3Q
h@08h@030>7Q00OQ00<0hN404n400`3Qh@0Dh@030>7Q03SQ0P0ih@00>^4202gQ00<0hN402>400`3Q
h@06h@030>7Q01?Q00<0hN405>400`3Qh@0fh@80>n4003cQ0P0/h@030>7Q00OQ00<0hN401^400`3Q
h@0Ch@030>7Q01?Q00<0hN40=N4203gQ000nh@80:n400`3Qh@07h@030>7Q00KQ00<0hN404^400`3Q
h@0Bh@030>7Q03CQ0P0oh@00@>4202[Q00<0hN401n400`3Qh@05h@030>7Q017Q00<0hN404n400`3Q
h@0bh@80@N4004;Q0P0Xh@030>7Q00OQ00<0hN401^400`3Qh@0@h@030>7Q01;Q00<0hN40<N4204?Q
0014h@809n400`3Qh@07h@030>7Q00GQ00<0hN404>400`3Qh@0Ah@030>7Q033Q0P15h@00A^4202KQ
00<0hN401^400`3Qh@06h@030>7Q00oQ00<0hN404N400`3Qh@0^h@80An4004SQ0P0Uh@030>7Q00KQ
00<0hN401N400`3Qh@0?h@030>7Q013Q00<0hN40;N4204WQ001:h@809>400`3Qh@06h@030>7Q00CQ
00<0hN403n400`3Qh@0@h@030>7Q02_Q0P1;h@00C>4202?Q00<0hN401N400`3Qh@05h@030>7Q00kQ
00<0hN403n400`3Qh@0Zh@80CN4004kQ0P0Rh@030>7Q00GQ00<0hN401>400`3Qh@0>h@030>7Q00kQ
00<0hN40:N4204oQ001@h@808N400`3Qh@05h@030>7Q00CQ00<0hN403N400`3Qh@0>h@030>7Q02OQ
0P1Ah@00D^42023Q00<0hN401>400`3Qh@04h@030>7Q00gQ00<0hN403N400`3Qh@0Vh@80Dn4005CQ
0P0Oh@030>7Q00CQ00<0hN401>400`3Qh@0<h@030>7Q00cQ00<0hN409N4205GQ001Fh@807^400`3Q
h@04h@030>7Q00?Q00<0hN402n400`3Qh@0=h@030>7Q02?Q0P1Gh@00F>4201cQ00<0hN401>400`3Q
h@03h@030>7Q00_Q00<0hN403>400`3Qh@0Rh@80FN4005[Q0P0Kh@030>7Q00CQ00<0hN400n400`3Q
h@0:h@030>7Q00_Q00<0hN408N4205_Q001Lh@806^400`3Qh@04h@030>7Q00;Q00<0hN402^400`3Q
h@0;h@030>7Q01oQ0P1Mh@00G^4201WQ00<0hN400n400`3Qh@03h@030>7Q00WQ00<0hN402^400`3Q
h@0Nh@80Gn40063Q0P0Hh@030>7Q00?Q00<0hN400^400`3Qh@09h@030>7Q00[Q00<0hN407>42067Q
001Rh@805n400`3Qh@03h@030>7Q00;Q00<0hN402>400`3Qh@09h@030>7Q01_Q0P1Sh@00I>4201KQ
00<0hN400^400`3Qh@02h@030>7Q00SQ00<0hN402>400`3Qh@0Jh@80IN4006KQ0P0Eh@030>7Q00;Q
00D0hN7Q000:h@030>7Q00SQ00<0hN406>4206OQ001Xh@805>400`3Qh@02h@050>7Qh@002N400`3Q
h@07h@030>7Q01OQ0P1Yh@00J^4201?Q00D0hN7Q0003h@030>7Q00OQ00<0hN401^400`3Qh@0Fh@80
Jn4006cQ0P0Bh@050>7Qh@000n400`3Qh@05h@030>7Q00OQ00<0hN405>4206gQ001^h@804>400`3Q
h@02h@040>7Q00OQ00<0hN401^400`3Qh@0Ch@80Kn40073Q0P0?h@050>7Qh@000n400`3Qh@04h@03
0>7Q00GQ00<0hN404^42077Q001bh@803^401@3QhN4000;Q00<0hN401>400`3Qh@05h@030>7Q013Q
0P1ch@00M>4200gQ00L0hN7Q0>4000KQ00<0hN401>400`3Qh@0?h@80MN4007KQ0P0<h@040>7Q00;Q
00<0hN400n400`3Qh@04h@030>7Q00gQ0P1gh@00N>4200_Q00H0hN40h@05h@030>7Q00?Q00<0hN40
3>4207WQ001jh@802^400`3Q0002h@030>7Q00;Q00<0hN400^400`3Qh@0;h@80Nn4007cQ0P09h@05
0>40h@001>400`3Qh@02h@030>7Q00WQ0P1mh@00O^4200SQ00D0h@3Q0003h@050>7Qh@002^4207oQ
0020h@801n420003h@3Q00;Q00@0hN402N42087Q0022h@801^4300?Q00@0hN401n4208?Q0024h@80
1>401P3Q003Q00;Q00<0hN401>4208GQ0026h@800n430005h@3Qh@001>4208OQ0028h@800^440003
h@3Q00;Q0P29h@00R^420003h@0000800^4208_Q002<h@L0SN4008gQ1@2>h@00SN4508kQ002=h@D0
S^4008kQ0`2?h@00on4Qh@00on4Qh@00on4Qh@00on4Qh@00on4Qh@00on4Qh@00on4Qh@00on4Qh@00
on4Qh@00on4Qh@00\
\>"],
  ImageRangeCache->{{{0, 287}, {287, 0}} -> {-0.952637, -1.10001, 0.00663859, 
  0.00766559}}]
}, Open  ]],

Cell[TextData[StyleBox[
"\:5f97\:3089\:308c\:305f\:51fa\:529b\:306f\:3001draw[mm, Join[HP0, HP]] \
\:3068\:540c\:3058\:3067\:3042\:308b\:3002\n\:6b21\:306b\:3001\:5916\:5468\
\:8def\:3092{1,2,3,4,5}\:3068\:3057\:3066\:5b9f\:884c\:3059\:308b\:3002"]], 
  "Text"],

Cell[CellGroupData[{

Cell[BoxData[
    \(drawgraph[mm, {1, 2, 3, 4, 5}]\)], "Input"],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: 1 
MathPictureStart
/Mabs {
Mgmatrix idtransform
Mtmatrix dtransform
} bind def
/Mabsadd { Mabs
3 -1 roll add
3 1 roll add
exch } bind def
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
0.5 0.477937 0.452012 0.502533 [
[ 0 0 0 0 ]
[ 1 1 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 0 m
1 0 L
1 1 L
0 1 L
closepath
clip
newpath
0 g
.02 w
.5 .95455 Mdot
.04545 .6073 Mdot
.21908 .04545 Mdot
.78092 .04545 Mdot
.95455 .6073 Mdot
.71967 .74939 Mdot
.2796 .5292 Mdot
.35388 .5095 Mdot
.41685 .5088 Mdot
.59444 .52571 Mdot
.65822 .34674 Mdot
.7421 .50978 Mdot
.76119 .55937 Mdot
.75366 .59468 Mdot
.70446 .68633 Mdot
.5 Mabswid
.5 .95455 m
.04545 .6073 L
s
.5 .95455 m
.71967 .74939 L
s
.5 .95455 m
.2796 .5292 L
s
.5 .95455 m
.35388 .5095 L
s
.5 .95455 m
.41685 .5088 L
s
.5 .95455 m
.59444 .52571 L
s
.5 .95455 m
.70446 .68633 L
s
.04545 .6073 m
.5 .95455 L
s
.04545 .6073 m
.21908 .04545 L
s
.04545 .6073 m
.2796 .5292 L
s
.21908 .04545 m
.04545 .6073 L
s
.21908 .04545 m
.78092 .04545 L
s
.21908 .04545 m
.2796 .5292 L
s
.21908 .04545 m
.35388 .5095 L
s
.21908 .04545 m
.41685 .5088 L
s
.21908 .04545 m
.59444 .52571 L
s
.21908 .04545 m
.65822 .34674 L
s
.78092 .04545 m
.21908 .04545 L
s
.78092 .04545 m
.95455 .6073 L
s
.78092 .04545 m
.65822 .34674 L
s
.95455 .6073 m
.78092 .04545 L
s
.95455 .6073 m
.71967 .74939 L
s
.95455 .6073 m
.65822 .34674 L
s
.95455 .6073 m
.7421 .50978 L
s
.95455 .6073 m
.76119 .55937 L
s
.95455 .6073 m
.75366 .59468 L
s
.95455 .6073 m
.70446 .68633 L
s
.71967 .74939 m
.5 .95455 L
s
.71967 .74939 m
.95455 .6073 L
s
.71967 .74939 m
.70446 .68633 L
s
.2796 .5292 m
.5 .95455 L
s
.2796 .5292 m
.04545 .6073 L
s
.2796 .5292 m
.21908 .04545 L
s
.2796 .5292 m
.35388 .5095 L
s
.35388 .5095 m
.5 .95455 L
s
.35388 .5095 m
.21908 .04545 L
s
.35388 .5095 m
.2796 .5292 L
s
.35388 .5095 m
.41685 .5088 L
s
.41685 .5088 m
.5 .95455 L
s
.41685 .5088 m
.21908 .04545 L
s
.41685 .5088 m
.35388 .5095 L
s
.41685 .5088 m
.59444 .52571 L
s
.59444 .52571 m
.5 .95455 L
s
.59444 .52571 m
.21908 .04545 L
s
.59444 .52571 m
.41685 .5088 L
s
.59444 .52571 m
.65822 .34674 L
s
.59444 .52571 m
.7421 .50978 L
s
.59444 .52571 m
.76119 .55937 L
s
.59444 .52571 m
.75366 .59468 L
s
.59444 .52571 m
.70446 .68633 L
s
.65822 .34674 m
.21908 .04545 L
s
.65822 .34674 m
.78092 .04545 L
s
.65822 .34674 m
.95455 .6073 L
s
.65822 .34674 m
.59444 .52571 L
s
.65822 .34674 m
.7421 .50978 L
s
.7421 .50978 m
.95455 .6073 L
s
.7421 .50978 m
.59444 .52571 L
s
.7421 .50978 m
.65822 .34674 L
s
.7421 .50978 m
.76119 .55937 L
s
.76119 .55937 m
.95455 .6073 L
s
.76119 .55937 m
.59444 .52571 L
s
.76119 .55937 m
.7421 .50978 L
s
.76119 .55937 m
.75366 .59468 L
s
.75366 .59468 m
.95455 .6073 L
s
.75366 .59468 m
.59444 .52571 L
s
.75366 .59468 m
.76119 .55937 L
s
.75366 .59468 m
.70446 .68633 L
s
.70446 .68633 m
.5 .95455 L
s
.70446 .68633 m
.95455 .6073 L
s
.70446 .68633 m
.71967 .74939 L
s
.70446 .68633 m
.59444 .52571 L
s
.70446 .68633 m
.75366 .59468 L
s
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  ImageSize->{288, 288},
  ImageMargins->{{43, 0}, {0, 0}},
  ImageRegion->{{0, 1}, {0, 1}},
  ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`40004P000180P10`40000100000800002008200000
P800P020P<30`<3L`:K:l00003<006H009T00<`00?l0000c03<c06Hc09Tc0<`c0?lc001V03=V06IV
09UV0<aV0?mV002I03>I06JI09VI0<bI0?nI003<03?<06K<09W<0<c<0?o<003o03?o06Ko09Wo0<co
0?oo0000<c<0<fH0<iT0<l`0<ol0<`0c<c<c<fHc<iTc<l`c<olc<`1V<c=V<fIV<iUV<laV<omV<`2I
<c>I<fJI<iVI<lbI<onI<`3<<c?<<fK<<iW<<lc<<oo<<`3o<c?o<fKo<iWo<lco<ooo<`00IS<0IVH0
IYT0I/`0I_l0IP0cIS<cIVHcIYTcI/`cI_lcIP1VIS=VIVIVIYUVI/aVI_mVIP2IIS>IIVJIIYVII/bI
I_nIIP3<IS?<IVK<IYW<I/c<I_o<IP3oIS?oIVKoIYWoI/coI_ooIP00VC<0VFH0VIT0VL`0VOl0V@0c
VC<cVFHcVITcVL`cVOlcV@1VVC=VVFIVVIUVVLaVVOmVV@2IVC>IVFJIVIVIVLbIVOnIV@3<VC?<VFK<
VIW<VLc<VOo<V@3oVC?oVFKoVIWoVLcoVOooV@00c3<0c6H0c9T0c<`0c?l0c00cc3<cc6Hcc9Tcc<`c
c?lcc01Vc3=Vc6IVc9UVc<aVc?mVc02Ic3>Ic6JIc9VIc<bIc?nIc03<c3?<c6K<c9W<c<c<c?o<c03o
c3?oc6Koc9Woc<coc?ooc000oc<0ofH0oiT0ol`0ool0o`0coc<cofHcoiTcol`coolco`1Voc=VofIV
oiUVolaVoomVo`2Ioc>IofJIoiVIolbIoonIo`3<oc?<ofK<oiW<olc<ooo<o`3ooc?oofKooiWoolco
ooooo`0000410@820P<30`@410D51@H61PL71`P820T92@X:2P/;2``<30h>3Pl?3a0@414A4A8B4Q<C
4a@D5?okl:2PY820P?l0003o0?oo0000ool0o`3ooooooooQ8N400?oQ8N400?oQ8N400?oQ8N400?oQ
8N400?oQ8N400?oQ8N400?oQ8N400?oQ8N400?oQ8N400?oQ8N400?oQ8N4003gQ0`2Nh@<0?n4003cQ
1@2Lh@D0?^4003cQYP0nh@00?>4509cQ1@0nh@00?N4509cQ100nh@00?N440003h@0009_Q00<0h@00
?^4003gQ00<0h@000P02h@030>7Q09OQ00@0hN40?^4003cQ00<0hN400P001>40hN4209OQ00D0hN7Q
000mh@00?>400`3Qh@030003h@3Q00;Q00<0hN40Tn400`3Qh@02h@030>7Q03_Q000lh@030>7Q00<0
0^401@3QhN4009CQ00<0hN400^400`3Qh@0kh@00?>400`3Qh@0300;Q00<0hN400^4209;Q00<0hN40
0^400`3Qh@0kh@00>n401P3QhN40h@800^400`3Qh@03h@030>7Q08kQ00<0hN401>400`3Qh@0jh@00
>n401P3QhN40h@800n400`3Qh@03h@80S^400`3Qh@04h@030>7Q03[Q000kh@090>7Qh@3Q0>4000?Q
00<0hN401>400`3Qh@2:h@030>7Q00GQ00<0hN40>^4003[Q00<0hN400n40103Q0003h@030>7Q00GQ
0P2:h@030>7Q00KQ00<0hN40>N4003[Q00<0hN400n401@3Q0>4000?Q00<0hN401^400`3Qh@27h@03
0>7Q00KQ00<0hN40>N4003[Q00<0hN400n401@3Q0>4000CQ00<0hN401^4208KQ00<0hN401n400`3Q
h@0ih@00>N400`3Qh@04h@050>40h@001N400`3Qh@07h@030>7Q08?Q00<0hN402>400`3Qh@0hh@00
>N400`3Qh@04h@060>7Q0>401N400`3Qh@07h@80P^400`3Qh@09h@030>7Q03SQ000ih@030>7Q00CQ
00H0hN40h@05h@030>7Q00WQ00<0hN40On400`3Qh@09h@030>7Q03SQ000ih@030>7Q00CQ00@0hN40
0^400`3Qh@03h@030>7Q00WQ0P1nh@030>7Q00[Q00<0hN40>>4003SQ00<0hN401N401`3QhN40h@00
1^400`3Qh@0:h@030>7Q07_Q00<0hN402n400`3Qh@0gh@00>>400`3Qh@06h@040>7Q00;Q00<0hN40
1>400`3Qh@0:h@80Nn400`3Qh@0;h@030>7Q03OQ000hh@030>7Q00KQ00@0hN400^400`3Qh@05h@03
0>7Q00_Q00<0hN40Mn400`3Qh@0<h@030>7Q03OQ000gh@030>7Q00OQ00@0hN400^400`3Qh@05h@03
0>7Q00cQ00<0hN40M^400`3Qh@0=h@030>7Q03KQ000gh@030>7Q00OQ00D0hN7Q0002h@030>7Q00GQ
00<0hN403>4207GQ00<0hN403^400`3Qh@0fh@00=n400`3Qh@07h@050>7Qh@000^400`3Qh@06h@03
0>7Q00gQ00<0hN40L^400`3Qh@0>h@030>7Q03KQ000fh@030>7Q00SQ00D0hN7Q0003h@030>7Q00KQ
00<0hN403N4207;Q00<0hN403n400`3Qh@0eh@00=^400`3Qh@08h@030>7Q00;Q00@0hN402>400`3Q
h@0?h@030>7Q06kQ00<0hN404>400`3Qh@0eh@00=^400`3Qh@09h@050>7Qh@000n400`3Qh@06h@03
0>7Q00oQ0P1^h@030>7Q013Q00<0hN40=N4003GQ00<0hN402^401@3QhN4000?Q00<0hN401n400`3Q
h@0@h@030>7Q06[Q00<0hN404^400`3Qh@0dh@00=N400`3Qh@0:h@030>7Q00;Q00@0hN402^400`3Q
h@0@h@80J^400`3Qh@0Bh@030>7Q03CQ000eh@030>7Q00[Q00<0hN400^401@3QhN4000[Q00<0hN40
4N400`3Qh@1Vh@030>7Q01?Q00<0hN40=>4003GQ00<0hN402^400`3Qh@02h@050>7Qh@002^400`3Q
h@0Bh@80I^400`3Qh@0Ch@030>7Q03CQ000dh@030>7Q00_Q00<0hN400^400`3Qh@02h@030>7Q00SQ
00<0hN404n400`3Qh@1Sh@030>7Q01CQ00<0hN40<n4003CQ00<0hN402n400`3Qh@03h@050>7Qh@00
2n400`3Qh@0Ch@80H^400`3Qh@0Eh@030>7Q03?Q000dh@030>7Q00_Q00<0hN400n400`3Qh@02h@03
0>7Q00WQ00<0hN405>400`3Qh@1Oh@030>7Q01GQ00<0hN40<n4003?Q00<0hN403N400`3Qh@02h@03
0>7Q00;Q00<0hN402^400`3Qh@0Dh@80G^400`3Qh@0Gh@030>7Q03;Q000ch@030>7Q00gQ00<0hN40
0n401@3QhN4000cQ00<0hN405^400`3Qh@1Kh@030>7Q01OQ00<0hN40<^4003?Q00<0hN403N400`3Q
h@03h@030>7Q00;Q00<0hN402^400`3Qh@0Fh@030>7Q05[Q00<0hN405n400`3Qh@0bh@00<^400`3Q
h@0>h@030>7Q00?Q00<0hN400^400`3Qh@0;h@030>7Q01KQ0P1Ih@030>7Q01WQ00<0hN40<N4003;Q
00<0hN403^400`3Qh@03h@030>7Q00?Q00<0hN402n400`3Qh@0Gh@030>7Q05KQ00<0hN406N400`3Q
h@0ah@00<^400`3Qh@0>h@030>7Q00CQ00<0hN400^400`3Qh@0<h@030>7Q01OQ0P1Eh@030>7Q01[Q
00<0hN40<N4003;Q00<0hN403^400`3Qh@04h@030>7Q00?Q00<0hN402n400`3Qh@0Ih@030>7Q05;Q
00<0hN406^400`3Qh@0ah@00<N400`3Qh@0?h@030>7Q00CQ00<0hN400n400`3Qh@0<h@030>7Q01WQ
0P1Ah@030>7Q01cQ00<0hN40<>40037Q00<0hN404>400`3Qh@04h@030>7Q00;Q00<0hN403N400`3Q
h@0Jh@030>7Q04kQ00<0hN407>400`3Qh@0`h@00<N400`3Qh@0@h@030>7Q00CQ00<0hN400n400`3Q
h@0=h@030>7Q01[Q0P1>h@030>7Q01cQ00<0hN40<>40033Q00<0hN404N400`3Qh@04h@030>7Q00?Q
00<0hN403N400`3Qh@0Lh@030>7Q04[Q00<0hN407^400`3Qh@0_h@00<>400`3Qh@0Ah@030>7Q00CQ
00<0hN401>400`3Qh@0=h@030>7Q01cQ0P1:h@030>7Q01kQ00<0hN40;n40033Q00<0hN404N400`3Q
h@05h@030>7Q00?Q00<0hN403^400`3Qh@0Mh@030>7Q04KQ00<0hN407n400`3Qh@0_h@00;n400`3Q
h@0Bh@030>7Q00GQ00<0hN401>400`3Qh@0>h@030>7Q01gQ0P16h@030>7Q023Q00<0hN40;^4002oQ
00<0hN404^400`3Qh@05h@030>7Q00CQ00<0hN403n400`3Qh@0Nh@030>7Q04;Q00<0hN408N400`3Q
h@0^h@00;n400`3Qh@0Ch@030>7Q00GQ00<0hN400n400`3Qh@0?h@030>7Q01oQ00<0hN40@N400`3Q
h@0Qh@030>7Q02kQ000^h@030>7Q01CQ00<0hN401N400`3Qh@04h@030>7Q00oQ00<0hN407n42047Q
00<0hN408^400`3Qh@0]h@00;^400`3Qh@0Dh@030>7Q00GQ00<0hN401>400`3Qh@0@h@030>7Q023Q
00<0hN40?N400`3Qh@0Sh@030>7Q02gQ000^h@030>7Q01CQ00<0hN401^400`3Qh@04h@030>7Q013Q
00<0hN408>4203gQ00<0hN408n400`3Qh@0]h@00;^400`3Qh@0Dh@030>7Q00KQ00<0hN401>400`3Q
h@0Ah@030>7Q027Q00<0hN40>N400`3Qh@0Th@030>7Q02gQ000]h@030>7Q01GQ00<0hN401^400`3Q
h@05h@030>7Q013Q00<0hN408^4203WQ00<0hN409N400`3Qh@0/h@00;N400`3Qh@0Eh@030>7Q00KQ
00<0hN401N400`3Qh@0Ah@030>7Q02?Q00<0hN40=^400`3Qh@0Uh@030>7Q02cQ000]h@030>7Q01GQ
00<0hN401n400`3Qh@04h@030>7Q01;Q00<0hN408n4203GQ00<0hN409^400`3Qh@0/h@00;>400`3Q
h@0Gh@030>7Q00KQ00<0hN401N400`3Qh@0Bh@030>7Q02CQ00<0hN40<^400`3Qh@0Wh@030>7Q02_Q
000/h@030>7Q01OQ00<0hN401^400`3Qh@05h@030>7Q01?Q00<0hN409>42037Q00<0hN40:>400`3Q
h@0[h@00;>400`3Qh@0Gh@030>7Q00OQ00<0hN401N400`3Qh@0Bh@030>7Q02KQ00<0hN40;^400`3Q
h@0Xh@030>7Q02_Q000[h@030>7Q01SQ00<0hN401n400`3Qh@05h@030>7Q01?Q00<0hN409^4202gQ
00<0hN40:^400`3Qh@0Zh@00:n400`3Qh@0Hh@030>7Q00OQ00<0hN401^400`3Qh@0Ch@030>7Q02OQ
00<0hN40:^400`3Qh@0Zh@030>7Q02[Q000[h@030>7Q01SQ00<0hN401n400`3Qh@06h@030>7Q01CQ
00<0hN409n4202[Q00<0hN40:^400`3Qh@0Zh@00:n400`3Qh@0Hh@030>7Q00SQ00<0hN401N400`3Q
h@0Dh@030>7Q02WQ00<0hN409^400`3Qh@0[h@030>7Q02[Q000Zh@030>7Q01WQ00<0hN402>400`3Q
h@06h@030>7Q01CQ00<0hN40:N400`3Qh@0Uh@030>7Q02cQ00<0hN40:N4002[Q00<0hN406^400`3Q
h@07h@030>7Q00KQ00<0hN405N400`3Qh@0Yh@809>400`3Qh@0]h@030>7Q02WQ000Zh@030>7Q01[Q
00<0hN402>400`3Qh@06h@030>7Q01GQ00<0hN40:^400`3Qh@0Qh@030>7Q02gQ00<0hN40:N4002WQ
00<0hN406n400`3Qh@08h@030>7Q00KQ00<0hN405^400`3Qh@0Zh@808N400`3Qh@0^h@030>7Q02SQ
000Yh@030>7Q01_Q00<0hN402>400`3Qh@07h@030>7Q01GQ00<0hN40;>400`3Qh@0Mh@030>7Q02oQ
00<0hN40:>4002WQ00<0hN406n400`3Qh@09h@030>7Q00KQ00<0hN405^400`3Qh@0/h@807N400`3Q
h@0_h@030>7Q02SQ000Xh@030>7Q01cQ00<0hN402N400`3Qh@06h@030>7Q01OQ00<0hN40;N400`3Q
h@0Ih@030>7Q037Q00<0hN409n4002SQ00<0hN407>400`3Qh@09h@030>7Q00OQ00<0hN405n400`3Q
h@0]h@806N400`3Qh@0ah@030>7Q02OQ000Xh@030>7Q01gQ00<0hN402>400`3Qh@07h@030>7Q01SQ
00<0hN40;^400`3Qh@0Eh@030>7Q03;Q00<0hN409n4002OQ00<0hN407^400`3Qh@09h@030>7Q00OQ
00<0hN405n400`3Qh@0_h@805N400`3Qh@0ch@030>7Q02KQ000Wh@030>7Q01kQ00<0hN402N400`3Q
h@07h@030>7Q01SQ00<0hN40<>400`3Qh@0Bh@030>7Q03?Q00<0hN409^4002OQ00<0hN407^400`3Q
h@09h@030>7Q00SQ00<0hN406>400`3Qh@0`h@804N400`3Qh@0dh@030>7Q02KQ000Wh@030>7Q01kQ
00<0hN402^400`3Qh@07h@030>7Q01WQ00<0hN40<N400`3Qh@0>h@030>7Q03CQ00<0hN409^4002KQ
00<0hN407n400`3Qh@0:h@030>7Q00OQ00<0hN406N400`3Qh@0bh@803N400`3Qh@0fh@030>7Q02GQ
000Vh@030>7Q01oQ00<0hN402^400`3Qh@08h@030>7Q01WQ00<0hN40<n400`3Qh@0:h@030>7Q03KQ
00<0hN409N4002KQ00<0hN407n400`3Qh@0:h@030>7Q00SQ00<0hN406^400`3Qh@0ch@030>7Q00WQ
00<0hN40=^400`3Qh@0Uh@009N400`3Qh@0Qh@030>7Q00[Q00<0hN402>400`3Qh@0Jh@030>7Q03?Q
0P08h@030>7Q03SQ00<0hN409>4002GQ00<0hN408N400`3Qh@0:h@030>7Q00SQ00<0hN406n400`3Q
h@0dh@030>7Q00GQ00<0hN40>>400`3Qh@0Th@009N400`3Qh@0Qh@030>7Q00[Q00<0hN402N400`3Q
h@0Jh@030>7Q03GQ0P04h@030>7Q03WQ00<0hN409>4002CQ00<0hN408^400`3Qh@0;h@030>7Q00SQ
00<0hN406n400`3Qh@0fh@030>400080?>400`3Qh@0Sh@009>400`3Qh@0Rh@030>7Q00_Q00<0hN40
2>400`3Qh@0Lh@030>7Q03KQ1@0kh@030>7Q02?Q000Th@030>7Q02;Q00<0hN402n400`3Qh@09h@03
0>7Q01cQ00<0hN40=N4503_Q00<0hN408n4002CQ00<0hN408^400`3Qh@0<h@030>7Q00SQ00<0hN40
7N400`3Qh@0dh@D0>n400`3Qh@0Sh@008n400`3Qh@0Sh@030>7Q00cQ00<0hN402N400`3Qh@0Lh@03
0>7Q03GQ100lh@030>7Q02;Q000Sh@030>7Q02CQ00<0hN402n400`3Qh@09h@030>7Q01gQ00<0hN40
=>400`3Qh@0203_Q00<0hN408^4002?Q00<0hN409>400`3Qh@0;h@030>7Q00[Q00<0hN407N400`3Q
h@0ch@050>7Q0>400P0ih@030>7Q02;Q000Rh@030>7Q02GQ00<0hN403>400`3Qh@09h@030>7Q01kQ
00<0hN40<N400`3Qh@02h@040>7Q03WQ00<0hN408N4002;Q00<0hN409N400`3Qh@0<h@030>7Q00WQ
00<0hN407n400`3Qh@0`h@030>7Q00;Q00D0hN7Q000hh@030>7Q027Q000Rh@030>7Q02GQ00<0hN40
3>400`3Qh@0:h@030>7Q01kQ00<0hN40<>400`3Qh@03h@050>7Qh@00=n400`3Qh@0Qh@008N400`3Q
h@0Vh@030>7Q00gQ00<0hN402N400`3Qh@0Oh@030>7Q02kQ00<0hN401>400`3Qh@02h@030>7Q03GQ
00<0hN408>40027Q00<0hN409^400`3Qh@0=h@030>7Q00[Q00<0hN407n400`3Qh@0]h@030>7Q00GQ
00<0hN400^400`3Qh@0dh@030>7Q023Q000Qh@030>7Q02OQ00<0hN403>400`3Qh@0:h@030>7Q023Q
00<0hN40:n400`3Qh@06h@030>7Q00?Q00<0hN40<n400`3Qh@0Ph@008>400`3Qh@0Xh@030>7Q00cQ
00<0hN402n400`3Qh@0Oh@030>7Q02_Q00<0hN401n400`3Qh@03h@80=>400`3Qh@0Oh@008>400`3Q
h@0Xh@030>7Q00gQ00<0hN402^400`3Qh@0Ph@030>7Q02[Q00<0hN401n400`3Qh@05h@030>7Q037Q
00<0hN407n40023Q00<0hN40:>400`3Qh@0=h@030>7Q00[Q00<0hN408N400`3Qh@0Xh@030>7Q00WQ
00<0hN401N400`3Qh@0`h@030>7Q01oQ000Ph@030>7Q02SQ00<0hN403N400`3Qh@0;h@030>7Q027Q
00<0hN409n400`3Qh@09h@030>7Q00KQ00<0hN40;n400`3Qh@0Oh@007n400`3Qh@0Yh@030>7Q00kQ
00<0hN402^400`3Qh@0Rh@030>7Q02KQ00<0hN402^400`3Qh@06h@030>7Q02oQ00<0hN407^4001oQ
00<0hN40:N400`3Qh@0>h@030>7Q00_Q00<0hN408N400`3Qh@0Uh@030>7Q00_Q00<0hN401n400`3Q
h@0^h@030>7Q01kQ000Oh@030>7Q02WQ00<0hN403^400`3Qh@0;h@030>7Q02;Q00<0hN409>400`3Q
h@0<h@030>7Q00OQ00<0hN40;N400`3Qh@0Nh@007^400`3Qh@0[h@030>7Q00gQ00<0hN403>400`3Q
h@0Rh@030>7Q02?Q00<0hN403>400`3Qh@08h@030>7Q02gQ00<0hN407N4001kQ00<0hN40:n400`3Q
h@0>h@030>7Q00_Q00<0hN408n400`3Qh@0Qh@030>7Q00kQ00<0hN402>4202gQ00<0hN407N4001kQ
00<0hN40:n400`3Qh@0>h@030>7Q00_Q00<0hN409>400`3Qh@0Ph@030>7Q00kQ00<0hN402^400`3Q
h@0Zh@030>7Q01gQ000Mh@030>7Q02cQ00<0hN403^400`3Qh@0<h@030>7Q02?Q00<0hN408>400`3Q
h@0?h@030>7Q00[Q00<0hN40:^400`3Qh@0Lh@007N400`3Qh@0/h@030>7Q00oQ00<0hN402n400`3Q
h@0Th@030>7Q01kQ00<0hN404>400`3Qh@0;h@030>7Q02WQ00<0hN407>4001gQ00<0hN40;>400`3Q
h@0?h@030>7Q00cQ00<0hN409>400`3Qh@0Mh@030>7Q017Q00<0hN402n400`3Qh@0Xh@030>7Q01cQ
000Mh@030>7Q02cQ00<0hN403n400`3Qh@0<h@030>7Q02GQ00<0hN407>400`3Qh@0Ah@030>7Q00cQ
00<0hN409n400`3Qh@0Lh@007>400`3Qh@0]h@030>7Q013Q00<0hN403>400`3Qh@0Uh@030>7Q01[Q
00<0hN404n400`3Qh@0<h@030>7Q02OQ00<0hN406n4001cQ00<0hN40;^400`3Qh@0?h@030>7Q00cQ
00<0hN409N400`3Qh@0Jh@030>7Q01?Q00<0hN403N4202OQ00<0hN406n4001cQ00<0hN40;^400`3Q
h@0?h@030>7Q00cQ00<0hN409^400`3Qh@0Hh@030>7Q01GQ00<0hN403^400`3Qh@0Th@030>7Q01_Q
000Kh@030>7Q02oQ00<0hN403n400`3Qh@0=h@030>7Q02KQ00<0hN405n400`3Qh@0Eh@030>7Q00oQ
00<0hN409>400`3Qh@0Jh@006n400`3Qh@0_h@030>7Q013Q00<0hN403>400`3Qh@0Wh@030>7Q01KQ
00<0hN405^400`3Qh@0?h@030>7Q02?Q00<0hN406^4001_Q00<0hN40;n400`3Qh@0@h@030>7Q00gQ
00<0hN409^400`3Qh@0Eh@030>7Q01OQ00<0hN404>400`3Qh@0Rh@030>7Q01[Q000Jh@030>7Q033Q
00<0hN404>400`3Qh@0=h@030>7Q02OQ00<0hN405>400`3Qh@0Hh@030>7Q013Q00<0hN408^400`3Q
h@0Ih@006^400`3Qh@0`h@030>7Q017Q00<0hN403N400`3Qh@0Wh@030>7Q01?Q00<0hN406>400`3Q
h@0Ah@030>7Q027Q00<0hN406N4001[Q00<0hN40<N400`3Qh@0@h@030>7Q00gQ00<0hN40:>400`3Q
h@0Ah@030>7Q01[Q00<0hN404N400`3Qh@0Ph@030>7Q01WQ000Ih@030>7Q03;Q00<0hN404>400`3Q
h@0=h@030>7Q02WQ00<0hN404>400`3Qh@0Jh@030>7Q01;Q0P0Qh@030>7Q01SQ000Ih@030>7Q03;Q
00<0hN404>400`3Qh@0>h@030>7Q02SQ00<0hN404>400`3Qh@0Kh@030>7Q01?Q00<0hN407^400`3Q
h@0Hh@006N400`3Qh@0bh@030>7Q017Q00<0hN403N400`3Qh@0Yh@030>7Q00kQ00<0hN407>400`3Q
h@0Dh@030>7Q01gQ00<0hN406>4001WQ00<0hN40<^400`3Qh@0Ah@030>7Q00kQ00<0hN40:N400`3Q
h@0=h@030>7Q01gQ00<0hN405>400`3Qh@0Lh@030>7Q01SQ000Hh@030>7Q03?Q00<0hN404N400`3Q
h@0>h@030>7Q02[Q00<0hN403>400`3Qh@0Mh@030>7Q01GQ00<0hN407>400`3Qh@0Gh@006>400`3Q
h@0ch@030>7Q01;Q00<0hN403^400`3Qh@0Zh@030>7Q00[Q00<0hN407n400`3Qh@0Eh@030>7Q01_Q
00<0hN405n4001SQ00<0hN40<n400`3Qh@0Bh@030>7Q00kQ00<0hN40:^400`3Qh@0:h@030>7Q01oQ
00<0hN405^400`3Qh@0Jh@030>7Q01OQ000Gh@030>7Q03GQ00<0hN404N400`3Qh@0>h@030>7Q02_Q
00<0hN402N400`3Qh@0Ph@030>7Q01KQ0P0Kh@030>7Q01KQ000Gh@030>7Q03GQ00<0hN404^400`3Q
h@0>h@030>7Q02_Q00<0hN401n400`3Qh@0Qh@030>7Q01SQ00<0hN406>400`3Qh@0Fh@005n400`3Q
h@0eh@030>7Q01;Q00<0hN403^400`3Qh@0/h@030>7Q00KQ00<0hN408^400`3Qh@0Hh@030>7Q01OQ
00<0hN405^4001KQ00<0hN40=^400`3Qh@0Bh@030>7Q00oQ00<0hN40:n400`3Qh@05h@030>7Q02?Q
00<0hN406N400`3Qh@0Gh@030>7Q01GQ000Fh@030>7Q03KQ00<0hN404^4300oQ0`0/h@030>7Q00CQ
00<0hN409>4301WQ00<0hN405^400`3Qh@0Eh@005^400`3Qh@0fh@030>7Q017Q1@0=h@D0;>400`3Q
h@03h@030>7Q02?Q1@0Ih@030>7Q01GQ00<0hN405N4001KQ00<0hN40=^400`3Qh@0AhA/0:N401@3Q
hN4002?Q200Jh@030>7Q01CQ00<0hN405N4001GQ00<0hN40=n400`3Qh@0=h@T03N4500CQ3@0Mh@04
0>7Q01WQ2P03h@H06^400`3Qh@0Dh@030>7Q01CQ000Eh@030>7Q03SQ00<0hN402>4400GQ0`0?h@<0
4^4<017Q00@0hN403^4;00kQ0`02h@806N4201CQ00<0hN405>4001GQ00<0hN40>>400`3Qh@04h@@0
2n400`3Qh@0?h@030>7Q01cQ3@05h@<01>4:01_Q00<0hN400^4201WQ00<0hN404N400`3Qh@0Dh@00
5>400`3Qh@0gh@<00^4400oQ00<0hN403n400`3Qh@0Yh@`09^400`3Qh@03h@806>400`3Qh@0Ah@03
0>7Q01?Q000Dh@030>7Q03KQ1P0Dh@030>7Q00kQ00<0hN40;N4:02CQ00<0hN401N4201OQ00<0hN40
4>400`3Qh@0Ch@005>400`3Qh@0eh@H05N400`3Qh@0>h@030>7Q02gQ1@000n400002h@@08N400`3Q
h@06h@<05N400`3Qh@0?h@030>7Q01?Q000Ch@030>7Q03?Q0`000n40000301GQ00<0hN403^400`3Q
h@0^h@@00n4300?Q1@0Lh@030>7Q00WQ0P0Dh@030>7Q00oQ00<0hN404^4001?Q00<0hN40<>4300GQ
0`000n40h@0Dh@030>7Q00kQ00<0hN40;N401@3QhN4000GQ0P06h@D05n400`3Qh@0;h@804n400`3Q
h@0>h@030>7Q01;Q000Ch@030>7Q02gQ0`0<h@030>7Q01?Q00<0hN403^400`3Qh@0]h@050>7Qh@00
1n4200WQ1@0Ch@030>7Q00cQ0P0Bh@803^400`3Qh@0Bh@004^400`3Qh@0[h@<04>400`3Qh@0Bh@03
0>7Q00kQ00<0hN40;N400`3Qh@02h@030>7Q00KQ0P0<h@D03^400`3Qh@0>h@804^400`3Qh@0<h@03
0>7Q017Q000Bh@030>7Q02WQ0P0Ch@030>7Q01?Q00<0hN403N400`3Qh@0/h@030>7Q00CQ00<0hN40
1n4300kQ100;h@030>7Q00oQ0`0@h@030>7Q00_Q00<0hN404N4001;Q00<0hN409^4301KQ00<0hN40
4^400`3Qh@0=h@030>7Q02cQ00<0hN401N400`3Qh@09h@804>4500KQ0`0Bh@803n400`3Qh@0:h@03
0>7Q017Q000Bh@030>7Q02?Q0`0Ih@030>7Q01;Q00<0hN403N400`3Qh@0/h@030>7Q00GQ00<0hN40
2n4201?Q2P0Ch@803^400`3Qh@09h@030>7Q017Q000Ah@030>7Q027Q0`0Mh@030>7Q01;Q00<0hN40
3N400`3Qh@0[h@030>7Q00KQ00<0hN403>4301GQ1@0Eh@803N400`3Qh@09h@030>7Q013Q000Ah@03
0>7Q01kQ0`0Ph@030>7Q01;Q00<0hN403N400`3Qh@0[h@030>7Q00OQ00<0hN403^4201?Q200Dh@80
3>400`3Qh@08h@030>7Q013Q000Ah@030>7Q01_Q0`0Th@030>7Q017Q00<0hN403N400`3Qh@0Zh@03
0>7Q00SQ00<0hN404>4201;Q0`04h@@04^4200_Q00<0hN401n400`3Qh@0@h@004>400`3Qh@0Ih@<0
9n400`3Qh@0Bh@030>7Q00cQ00<0hN40:^400`3Qh@09h@030>7Q017Q0`0?h@030>7Q00SQ100@h@<0
2N4200SQ00<0hN403n40013Q00<0hN405^4302_Q00<0hN404N400`3Qh@0<h@030>7Q02[Q00<0hN40
2^400`3Qh@0Ch@803N400`3Qh@0<h@@03n4200WQ00<0hN401N400`3Qh@0?h@004>400`3Qh@0Ch@<0
;^400`3Qh@0Ah@030>7Q00gQ00<0hN40:N400`3Qh@0:h@030>7Q01GQ0P0;h@030>7Q013Q100=h@80
2>400`3Qh@04h@030>7Q00oQ000?h@030>7Q017Q0`0bh@030>7Q017Q00<0hN403>400`3Qh@0Xh@03
0>7Q00cQ00<0hN405^4200WQ00<0hN405>4400_Q0P07h@030>7Q00CQ00<0hN403^4000oQ00<0hN40
3^4303GQ00<0hN404N400`3Qh@0<h@030>7Q02SQ00<0hN403N400`3Qh@0Gh@<01^400`3Qh@0Hh@@0
2N4200KQ00<0hN400n400`3Qh@0>h@003n400`3Qh@0<h@80>N400`3Qh@0@h@030>7Q00cQ00<0hN40
:>400`3Qh@0>h@030>7Q01WQ0P001>40000Oh@@01n4300CQ00<0hN400^400`3Qh@0>h@003n400`3Q
h@09h@<0>n400`3Qh@0Ah@030>7Q00_Q00<0hN40:>400`3Qh@0>h@030>7Q01_Q1@0Rh@@01^4200?Q
00D0hN7Q000@h@003^400`3Qh@07h@<0?n400`3Qh@0@h@030>7Q00cQ00<0hN409n400`3Qh@0?h@03
0>7Q01[Q2`0Ph@@01>4200;Q0P02h@030>7Q00gQ000>h@030>7Q00CQ0`12h@030>7Q013Q00<0hN40
3>400`3Qh@0Vh@030>7Q017Q00<0hN406N4500KQ3P0Fh@@00^4200;Q00<0h@003n4000_Q1003h@<0
A^400`3Qh@0@h@030>7Q00_Q00<0hN409^400`3Qh@0Ah@030>7Q01[Q0`0Eh@h03>460003h@000080
3N4000[Q2019h@030>7Q013Q00<0hN402n400`3Qh@0Vh@030>7Q01;Q00<0hN406N400`3Qh@0Sh@h0
0^4800cQ000:h@D0CN400`3Qh@0?h@030>7Q00_Q00<0hN409^400`3Qh@0Ch@030>7Q01SQ00<0hN40
<N4:00cQ000:h@D0CN400`3Qh@0@h@030>7Q00[Q00<0hN409^400`3Qh@0Ch@030>7Q01OQ00<0hN40
=N4700cQ000;h@<000?Q0000C>400`3Qh@0?h@030>7Q00_Q00<0hN409>400`3Qh@0Eh@030>7Q01KQ
00<0hN40<N460004h@0000gQ000Ah@030>7Q04WQ00<0hN403n400`3Qh@0;h@030>7Q02CQ00<0hN40
5^400`3Qh@0Dh@030>7Q02oQ0`03h@030>7Q017Q000Bh@030>7Q04WQ00<0hN403n400`3Qh@0:h@03
0>7Q02CQ00<0hN405^400`3Qh@0Dh@030>7Q02cQ0`04h@805>4001?Q0P19h@030>7Q00oQ00<0hN40
2^400`3Qh@0Th@030>7Q01OQ00<0hN404^400`3Qh@0Zh@<01^400`3Qh@0Dh@005N400`3Qh@17h@03
0>7Q00kQ00<0hN402^400`3Qh@0Sh@030>7Q01WQ00<0hN404N400`3Qh@0Wh@<01n4201OQ000Fh@03
0>7Q04KQ00<0hN403n400`3Qh@0:h@030>7Q02;Q00<0hN406^400`3Qh@0?h@030>7Q02CQ1008h@80
6N4001OQ0P17h@030>7Q00kQ00<0hN402^400`3Qh@0Rh@030>7Q01[Q00<0hN403n400`3Qh@0Qh@<0
2n400`3Qh@0Ih@006N400`3Qh@15h@030>7Q00gQ00<0hN402^400`3Qh@0Rh@030>7Q01_Q00<0hN40
3N400`3Qh@0Oh@<03>4201cQ000Jh@030>7Q04CQ00<0hN403^400`3Qh@09h@030>7Q02;Q00<0hN40
7>400`3Qh@0;h@030>7Q01gQ0`0=h@807^4001_Q0P15h@030>7Q00gQ00<0hN402N400`3Qh@0Qh@03
0>7Q01gQ00<0hN402n400`3Qh@0Ih@@03n400`3Qh@0Nh@007N400`3Qh@12h@030>7Q00gQ00<0hN40
2^400`3Qh@0Ph@030>7Q01kQ00<0hN402N400`3Qh@0Gh@<04N42027Q000Nh@030>7Q04;Q00<0hN40
3N400`3Qh@09h@030>7Q023Q00<0hN407n400`3Qh@08h@030>7Q01CQ0`0Bh@808n4001oQ0P12h@03
0>7Q00gQ00<0hN402N400`3Qh@0Ph@030>7Q01oQ00<0hN401n400`3Qh@0Bh@<05>400`3Qh@0Sh@00
8N400`3Qh@10h@030>7Q00cQ00<0hN402N400`3Qh@0Oh@030>7Q027Q00<0hN401^400`3Qh@0>h@@0
5N4202KQ000Rh@030>7Q03oQ00<0hN403N400`3Qh@08h@030>7Q01oQ00<0hN408^400`3Qh@04h@03
0>7Q00cQ0`0Hh@030>7Q02KQ000Sh@030>7Q03oQ00<0hN403>400`3Qh@09h@030>7Q01kQ00<0hN40
8n400`3Qh@03h@030>7Q00WQ0`0Ih@80:N4002CQ0P0oh@030>7Q00cQ00<0hN402N400`3Qh@0Nh@03
0>7Q02?Q00<0hN400^400`3Qh@07h@<06^4202_Q000Vh@030>7Q03gQ00<0hN403>400`3Qh@08h@03
0>7Q01kQ00<0hN409>401@3QhN4000KQ0`0Lh@030>7Q02_Q000Wh@030>7Q03cQ00<0hN403>400`3Q
h@08h@030>7Q01gQ00<0hN409^400`3Q0003h@@07N4202kQ000Xh@80?N400`3Qh@0;h@030>7Q00SQ
00<0hN407N400`3Qh@0Uh@L07n42033Q000Zh@030>7Q03[Q00<0hN403>400`3Qh@07h@030>7Q01gQ
00<0hN409>45027Q00<0hN40<>4002_Q00<0hN40>^400`3Qh@0;h@030>7Q00SQ00<0hN407>400`3Q
h@0Th@D07n4203?Q000/h@80>^400`3Qh@0;h@030>7Q00SQ00<0hN406n400`3Qh@0Uh@D07N4203GQ
000^h@030>7Q03SQ00<0hN402n400`3Qh@07h@030>7Q01_Q00<0hN409^4401cQ00<0hN40=N4002oQ
00<0hN40=n400`3Qh@0;h@030>7Q00OQ00<0hN406n400`3Qh@0Uh@050>7Qh@006^4203SQ000`h@80
>>400`3Qh@0:h@030>7Q00OQ00<0hN406n400`3Qh@0Th@030>7Q00;Q00<0hN405n400`3Qh@0hh@00
<^400`3Qh@0eh@030>7Q00_Q00<0hN401n400`3Qh@0Jh@030>7Q02?Q00<0hN400n400`3Qh@0Eh@80
>n4003?Q00<0hN40=N400`3Qh@0:h@030>7Q00OQ00<0hN406N400`3Qh@0Th@030>7Q00?Q00<0hN40
4n4203gQ000dh@80=N400`3Qh@0:h@030>7Q00OQ00<0hN406N400`3Qh@0Sh@030>7Q00GQ00<0hN40
4N400`3Qh@0mh@00=^400`3Qh@0ch@030>7Q00[Q00<0hN401^400`3Qh@0Ih@030>7Q02;Q00<0hN40
1^400`3Qh@0?h@80@>4003OQ00<0hN40<^400`3Qh@0:h@030>7Q00KQ00<0hN406N400`3Qh@0Qh@03
0>7Q00OQ00<0hN403N4204;Q000hh@030>7Q03;Q00<0hN402N400`3Qh@07h@030>7Q01OQ00<0hN40
8^400`3Qh@07h@030>7Q00cQ00<0hN40@^4003WQ0P0bh@030>7Q00[Q00<0hN401^400`3Qh@0Gh@03
0>7Q027Q00<0hN402N400`3Qh@09h@80AN4003_Q00<0hN40<>400`3Qh@09h@030>7Q00KQ00<0hN40
5n400`3Qh@0Ph@030>7Q00[Q00<0hN401n4204OQ000lh@030>7Q02oQ00<0hN402N400`3Qh@06h@03
0>7Q01OQ00<0hN407n400`3Qh@0;h@030>7Q00KQ00<0hN40An4003gQ0P0`h@030>7Q00SQ00<0hN40
1^400`3Qh@0Gh@030>7Q01oQ00<0hN402n400`3Qh@04h@80B^4003oQ00<0hN40;N400`3Qh@09h@03
0>7Q00GQ00<0hN405^400`3Qh@0Oh@030>7Q00cQ00<0hN400n400`3Qh@1:h@00@>400`3Qh@0]h@03
0>7Q00SQ00<0hN401^400`3Qh@0Eh@030>7Q01kQ00<0hN403N430003h@0004gQ0011h@80;^400`3Q
h@07h@030>7Q00KQ00<0hN405N400`3Qh@0Mh@030>7Q00gQ1@1?h@00@n400`3Qh@0[h@030>7Q00SQ
00<0hN401N400`3Qh@0Eh@030>7Q01cQ00<0hN403^4504oQ0014h@030>7Q02_Q00<0hN401n400`3Q
h@05h@030>7Q01GQ00<0hN407>400`3Qh@0>h@D0Cn4004GQ0P0[h@030>7Q00OQ00<0hN401N400`3Q
h@0Dh@030>7Q01cQ00<0hN403n44053Q0017h@030>7Q02WQ00<0hN401n400`3Qh@05h@030>7Q01?Q
00<0hN406n400`3Qh@0?h@030>7Q05;Q0018h@030>7Q02SQ00<0hN401n400`3Qh@05h@030>7Q01?Q
00<0hN406^400`3Qh@0?h@030>7Q05?Q0019h@80:N400`3Qh@06h@030>7Q00GQ00<0hN404n400`3Q
h@0Jh@030>7Q00kQ00<0hN40E>4004_Q00<0hN409^400`3Qh@07h@030>7Q00CQ00<0hN404^400`3Q
h@0Jh@030>7Q00gQ0P1Gh@00C>400`3Qh@0Vh@030>7Q00KQ00<0hN401>400`3Qh@0Bh@030>7Q01WQ
00<0hN403N400`3Qh@1Gh@00CN400`3Qh@0Uh@030>7Q00KQ00<0hN401N400`3Qh@0Ah@030>7Q01SQ
00<0hN403N400`3Qh@1Hh@00C^4202KQ00<0hN401^400`3Qh@04h@030>7Q017Q00<0hN406>400`3Q
h@0<h@030>7Q05WQ001@h@030>7Q02?Q00<0hN401^400`3Qh@04h@030>7Q017Q00<0hN405n400`3Q
h@0<h@030>7Q05[Q001Ah@030>7Q02?Q00<0hN401N400`3Qh@04h@030>7Q013Q00<0hN405n400`3Q
h@0<h@030>7Q05_Q001Bh@808n400`3Qh@06h@030>7Q00?Q00<0hN404>400`3Qh@0Fh@030>7Q00cQ
00<0hN40G>4005CQ00<0hN408N400`3Qh@05h@030>7Q00?Q00<0hN404>400`3Qh@0Eh@030>7Q00cQ
00<0hN40GN4005GQ00<0hN408>400`3Qh@05h@030>7Q00CQ00<0hN403n400`3Qh@0Eh@030>7Q00_Q
00<0hN40G^4005KQ0P0Qh@030>7Q00GQ00<0hN400n400`3Qh@0>h@030>7Q01GQ00<0hN402n400`3Q
h@1Oh@00F>400`3Qh@0Nh@030>7Q00GQ00<0hN400n400`3Qh@0>h@030>7Q01CQ00<0hN402n400`3Q
h@1Ph@00FN400`3Qh@0Nh@030>7Q00CQ00<0hN400n400`3Qh@0>h@030>7Q01?Q00<0hN402^4206?Q
001Jh@807^400`3Qh@05h@030>7Q00;Q00<0hN403^400`3Qh@0Ch@030>7Q00WQ00<0hN40Hn4005cQ
00<0hN407>400`3Qh@04h@030>7Q00?Q00<0hN403N400`3Qh@0Bh@030>7Q00WQ00<0hN40I>4005gQ
00<0hN406n400`3Qh@04h@030>7Q00?Q00<0hN403>400`3Qh@0Bh@030>7Q00WQ00<0hN40IN4005kQ
0P0Lh@030>7Q00CQ00<0hN400^400`3Qh@0<h@030>7Q017Q00<0hN402N400`3Qh@1Vh@00H>400`3Q
h@0Ih@030>7Q00CQ00<0hN400^400`3Qh@0<h@030>7Q017Q00<0hN402>400`3Qh@1Wh@00HN400`3Q
h@0Ih@030>7Q00?Q00<0hN400^400`3Qh@0<h@030>7Q013Q00<0hN402>400`3Qh@1Xh@00H^4201WQ
00<0hN401>400`3Qh@02h@030>7Q00[Q00<0hN404>400`3Qh@08h@030>7Q06WQ001Th@030>7Q01OQ
00<0hN400n400`3Qh@02h@030>7Q00[Q00<0hN403n400`3Qh@08h@030>7Q06[Q001Uh@030>7Q01KQ
00<0hN400n400`3Qh@02h@030>7Q00[Q00<0hN403n400`3Qh@07h@030>7Q06_Q001Vh@030>7Q01KQ
00<0hN400n401@3QhN4000cQ00<0hN403^400`3Qh@07h@030>7Q06cQ001Wh@805n400`3Qh@02h@05
0>7Qh@003>400`3Qh@0=h@030>7Q00OQ00<0hN40KN4006WQ00<0hN405>400`3Qh@02h@030>7Q00;Q
00<0hN402>400`3Qh@0=h@030>7Q00KQ0P1`h@00J^400`3Qh@0Dh@030>7Q00;Q00D0hN7Q000:h@03
0>7Q00cQ00<0hN401^400`3Qh@1`h@00Jn4201CQ00<0hN400^401@3QhN4000[Q00<0hN403>400`3Q
h@05h@030>7Q077Q001]h@030>7Q01;Q00D0hN7Q0003h@030>7Q00SQ00<0hN402n400`3Qh@05h@03
0>7Q07;Q001^h@030>7Q017Q00<0hN400^40103Qh@09h@030>7Q00_Q00<0hN401N400`3Qh@1ch@00
Kn4201;Q00D0hN7Q0002h@030>7Q00OQ00<0hN402^400`3Qh@05h@030>7Q07CQ001ah@030>7Q00oQ
00D0hN7Q0003h@030>7Q00KQ00<0hN402^400`3Qh@04h@030>7Q07GQ001bh@030>7Q00oQ00D0hN7Q
0002h@030>7Q00KQ00<0hN402N400`3Qh@04h@030>7Q07KQ001ch@803n401@3QhN4000;Q00<0hN40
1^400`3Qh@08h@030>7Q00CQ00<0hN40Mn4007GQ00<0hN403N40103Qh@02h@030>7Q00GQ00<0hN40
2>400`3Qh@04h@030>7Q07SQ001fh@030>7Q00cQ00L0hN7Q0>4000OQ00<0hN402>400`3Qh@03h@03
0>7Q07WQ001gh@803N40103Qh@02h@030>7Q00CQ00<0hN401n400`3Qh@03h@030>7Q07[Q001ih@03
0>7Q00[Q00@0hN400^400`3Qh@04h@030>7Q00KQ00<0hN400^4207gQ001jh@030>7Q00[Q00H0hN40
h@06h@030>7Q00GQ00<0hN400^400`3Qh@1mh@00Nn400`3Qh@09h@060>7Q0>401N400`3Qh@05h@03
0>7Q00;Q00<0hN40O^4007cQ0P0:h@050>40h@001N400`3Qh@05h@050>7Qh@00PN4007kQ00<0hN40
1n401P3Qh@3Q00CQ00<0hN401>401@3QhN4008;Q001oh@030>7Q00OQ00D0h@3Q0004h@030>7Q00?Q
00D0hN7Q0023h@00P>4200OQ00D0h@3Q0003h@030>7Q00?Q00D0hN7Q0024h@00P^400`3Qh@05h@04
0>4000?Q00<0hN400n40103Qh@25h@00Pn400`3Qh@04h@040>4000?Q00<0hN400^40103Qh@26h@00
Q>4200GQ0`03h@050>7Qh@000^400`3Qh@25h@00Q^400`3Qh@02h@040>4000;Q00@0hN400^400`3Q
h@26h@00Qn400`3Qh@02h@<000?Q0>400^4308WQ0028h@800^430004h@3Qh@80Rn4008[Q00<0hN40
0P000n40h@0208cQ002;h@050>400>400`2=h@00S>440003h@3Q08gQ002>h@<0Sn4008gQ1@2>h@00
SN4508kQ002=h@D0S^4008kQ0`2?h@00on4Qh@00on4Qh@00on4Qh@00on4Qh@00on4Qh@00on4Qh@00
on4Qh@00on4Qh@00on4Qh@00on4Qh@00\
\>"],
  ImageRangeCache->{{{0, 287}, {287, 0}} -> {-1.04617, -0.899477, 0.00729041, 
  0.00693358}}]
}, Open  ]],

Cell[TextData[StyleBox[
"\:3000\:3053\:308c\:307e\:3067\:306f\:3001\:5916\:5468\:8def\:306b\:306f\
\:90fd\:5408\:306e\:3088\:3044\:30b5\:30a4\:30af\:30eb\:3092\:9078\:3093\:3067\
\:304d\:305f\:3002\:4eca\:5ea6\:306f\:9069\:5207\:3067\:306a\:3044\:3082\:306e\
\:3092\:6307\:5b9a\:3057\:3066\:307f\:308b\:3002\n\:3053\:3053\:3067\:306f\
\:3001Combinatorica.m \:3067\:5b9a\:7fa9\:3055\:308c\:305f\:30b0\:30e9\:30d5\
\:3092\:63cf\:753b\:3059\:308b\:95a2\:6570 ShowGraph\:3092\:5229\:7528\:3059\
\:308b\:3053\:3068\:3092\:8003\:3048\:308b\:3002\:3053\:306e\:95a2\:6570\:3092\
\:5229\:7528\:3059\:308b\:306b\:306f\:3001\:30b0\:30e9\:30d5\:3092\:30b0\:30e9\
\:30d5\:8868\:73fe\n\tGraph[\:96a3\:63a5\:884c\:5217\:3001\:9802\:70b9\:306e\
\:5ea7\:6a19\:306e\:30ea\:30b9\:30c8]\n\:3068\:3057\:3066\:3001\:8868\:3059\
\:3053\:3068\:304c\:5fc5\:8981\:3067\:3042\:308b\:3002\:305d\:3053\:3067\:3001\
\:307e\:305a\:6b21\:306e\:95a2\:6570\:3092\:7528\:610f\:3059\:308b\:3002"]], 
  "Text"],

Cell[BoxData[
    \(\(getvertices[mtx_, \ cyl_] := 
      Block[{xy0, xy1, len2}, \n\t\ \ len2 = Length[cyl]; \n\t\t
        xy0 = circluarvertices[len2]; \n\t\t
        xy1 = makematrix[rearrange[mtx, cyl], len2]\  . \ xy0; \n\ \ \ \t
        Return[Join[xy0, xy1]]\n]\t\)\)], "Input"],

Cell[TextData[
"\:3000\:3053\:306e\:95a2\:6570\:306f\:3001\:96a3\:63a5\:884c\:5217\:3068\
\:5916\:5468\:8def\:3092\:4e0e\:3048\:305f\:3068\:304d\:306b\:3001\:30b0\:30e9\
\:30d5\:5168\:4f53\:306e\:5ea7\:6a19\:3092\:8fd4\:3059\:3082\:306e\:3067\:3001\
\:30b0\:30e9\:30d5\:304c\:5e73\:9762\:7684\:3067\:3001\:304b\:3064\:5916\:5468\
\:8def\:304c\:9069\:5207\:3067\:3042\:308c\:3070\:3001\:5e73\:9762\:30b0\:30e9\
\:30d5\:306e\:5ea7\:6a19\:3092\:8fd4\:3059\:3002"], "Text"],

Cell[CellGroupData[{

Cell[BoxData[
    \(vtx = getvertices[mm, {1, 2, 3, 4}]; \ng0 = EmptyGraph[15]; 
    \t\t\t\t\t\t\t\t\t\t (*\ 
      15  \:9802\:70b9\:306e\:30c0\:30df\:30fc\:306e\:30b0\:30e9\:30d5\ \ *) 
      \ng1 = ChangeVertices[g0, \ vtx]; 
    \t (*\ \:30b0\:30e9\:30d5g0\:306e\:9802\:70b9\:306e\:5ea7\:6a19\:3092vtx\
\:3068\:5165\:308c\:66ff\:3048\:308b\ *) \ng2 = ChangeEdges[g1, \ mm]; 
    \ \t\t\t\t (*\ \ 
      \:30b0\:30e9\:30d5g1\:306e\:96a3\:63a5\:884c\:5217\:3092mm\:3068\:5165\
\:308c\:66ff\:3048\:308b\ *) \nShowGraph[g2]\)], "Input"],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: 1 
MathPictureStart
/Mabs {
Mgmatrix idtransform
Mtmatrix dtransform
} bind def
/Mabsadd { Mabs
3 -1 roll add
3 1 roll add
exch } bind def
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
0.0454545 0.909091 0.0454545 0.909091 [
[ 0 0 0 0 ]
[ 1 1 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 0 m
1 0 L
1 1 L
0 1 L
closepath
clip
newpath
0 g
.025 w
.5 .95455 Mdot
.04545 .5 Mdot
.5 .04545 Mdot
.95455 .5 Mdot
.66787 .57318 Mdot
.58602 .73481 Mdot
.37969 .50064 Mdot
.47332 .50256 Mdot
.51358 .50961 Mdot
.58101 .53589 Mdot
.66777 .43589 Mdot
.63544 .52494 Mdot
.62509 .55479 Mdot
.61604 .58514 Mdot
.59019 .67671 Mdot
.5 Mabswid
.5 .95455 m
.04545 .5 L
s
.5 .95455 m
.58602 .73481 L
s
.5 .95455 m
.37969 .50064 L
s
.5 .95455 m
.47332 .50256 L
s
.5 .95455 m
.51358 .50961 L
s
.5 .95455 m
.58101 .53589 L
s
.5 .95455 m
.59019 .67671 L
s
.04545 .5 m
.5 .95455 L
s
.04545 .5 m
.5 .04545 L
s
.04545 .5 m
.37969 .50064 L
s
.5 .04545 m
.04545 .5 L
s
.5 .04545 m
.95455 .5 L
s
.5 .04545 m
.37969 .50064 L
s
.5 .04545 m
.47332 .50256 L
s
.5 .04545 m
.51358 .50961 L
s
.5 .04545 m
.58101 .53589 L
s
.5 .04545 m
.66777 .43589 L
s
.95455 .5 m
.5 .04545 L
s
.95455 .5 m
.66787 .57318 L
s
.95455 .5 m
.66777 .43589 L
s
.66787 .57318 m
.95455 .5 L
s
.66787 .57318 m
.58602 .73481 L
s
.66787 .57318 m
.66777 .43589 L
s
.66787 .57318 m
.63544 .52494 L
s
.66787 .57318 m
.62509 .55479 L
s
.66787 .57318 m
.61604 .58514 L
s
.66787 .57318 m
.59019 .67671 L
s
.58602 .73481 m
.5 .95455 L
s
.58602 .73481 m
.66787 .57318 L
s
.58602 .73481 m
.59019 .67671 L
s
.37969 .50064 m
.5 .95455 L
s
.37969 .50064 m
.04545 .5 L
s
.37969 .50064 m
.5 .04545 L
s
.37969 .50064 m
.47332 .50256 L
s
.47332 .50256 m
.5 .95455 L
s
.47332 .50256 m
.5 .04545 L
s
.47332 .50256 m
.37969 .50064 L
s
.47332 .50256 m
.51358 .50961 L
s
.51358 .50961 m
.5 .95455 L
s
.51358 .50961 m
.5 .04545 L
s
.51358 .50961 m
.47332 .50256 L
s
.51358 .50961 m
.58101 .53589 L
s
.58101 .53589 m
.5 .95455 L
s
.58101 .53589 m
.5 .04545 L
s
.58101 .53589 m
.51358 .50961 L
s
.58101 .53589 m
.66777 .43589 L
s
.58101 .53589 m
.63544 .52494 L
s
.58101 .53589 m
.62509 .55479 L
s
.58101 .53589 m
.61604 .58514 L
s
.58101 .53589 m
.59019 .67671 L
s
.66777 .43589 m
.5 .04545 L
s
.66777 .43589 m
.95455 .5 L
s
.66777 .43589 m
.66787 .57318 L
s
.66777 .43589 m
.58101 .53589 L
s
.66777 .43589 m
.63544 .52494 L
s
.63544 .52494 m
.66787 .57318 L
s
.63544 .52494 m
.58101 .53589 L
s
.63544 .52494 m
.66777 .43589 L
s
.63544 .52494 m
.62509 .55479 L
s
.62509 .55479 m
.66787 .57318 L
s
.62509 .55479 m
.58101 .53589 L
s
.62509 .55479 m
.63544 .52494 L
s
.62509 .55479 m
.61604 .58514 L
s
.61604 .58514 m
.66787 .57318 L
s
.61604 .58514 m
.58101 .53589 L
s
.61604 .58514 m
.62509 .55479 L
s
.61604 .58514 m
.59019 .67671 L
s
.59019 .67671 m
.5 .95455 L
s
.59019 .67671 m
.66787 .57318 L
s
.59019 .67671 m
.58602 .73481 L
s
.59019 .67671 m
.58101 .53589 L
s
.59019 .67671 m
.61604 .58514 L
s
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  ImageSize->{288, 288},
  ImageMargins->{{43, 0}, {0, 0}},
  ImageRegion->{{0, 1}, {0, 1}},
  ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`40004P000180P10`40000100000800002008200000
P800P020P<30`<3L`:K:l00003<006H009T00<`00?l0000c03<c06Hc09Tc0<`c0?lc001V03=V06IV
09UV0<aV0?mV002I03>I06JI09VI0<bI0?nI003<03?<06K<09W<0<c<0?o<003o03?o06Ko09Wo0<co
0?oo0000<c<0<fH0<iT0<l`0<ol0<`0c<c<c<fHc<iTc<l`c<olc<`1V<c=V<fIV<iUV<laV<omV<`2I
<c>I<fJI<iVI<lbI<onI<`3<<c?<<fK<<iW<<lc<<oo<<`3o<c?o<fKo<iWo<lco<ooo<`00IS<0IVH0
IYT0I/`0I_l0IP0cIS<cIVHcIYTcI/`cI_lcIP1VIS=VIVIVIYUVI/aVI_mVIP2IIS>IIVJIIYVII/bI
I_nIIP3<IS?<IVK<IYW<I/c<I_o<IP3oIS?oIVKoIYWoI/coI_ooIP00VC<0VFH0VIT0VL`0VOl0V@0c
VC<cVFHcVITcVL`cVOlcV@1VVC=VVFIVVIUVVLaVVOmVV@2IVC>IVFJIVIVIVLbIVOnIV@3<VC?<VFK<
VIW<VLc<VOo<V@3oVC?oVFKoVIWoVLcoVOooV@00c3<0c6H0c9T0c<`0c?l0c00cc3<cc6Hcc9Tcc<`c
c?lcc01Vc3=Vc6IVc9UVc<aVc?mVc02Ic3>Ic6JIc9VIc<bIc?nIc03<c3?<c6K<c9W<c<c<c?o<c03o
c3?oc6Koc9Woc<coc?ooc000oc<0ofH0oiT0ol`0ool0o`0coc<cofHcoiTcol`coolco`1Voc=VofIV
oiUVolaVoomVo`2Ioc>IofJIoiVIolbIoonIo`3<oc?<ofK<oiW<olc<ooo<o`3ooc?oofKooiWoolco
ooooo`0000410@820P<30`@410D51@H61PL71`P820T92@X:2P/;2``<30h>3Pl?3a0@414A4A8B4Q<C
4a@D5?okl:2PY820P?l0003o0?oo0000ool0o`3ooooooooQ8N400?oQ8N400?oQ8N400?oQ8N400?oQ
8N400?oQ8N400?oQ8N400?oQ8N400?oQ8N400?oQ8N400?oQ8N4008kQ0`2?h@00SN4508kQ002<h@L0
SN4008cQ1`2=h@00S>4708gQ002=h@D0S^4008cQ00<0h@000P000n40h@2<h@00Rn400`3Qh@040003
h@3Q08_Q002:h@040>7Qh@@00^400`3Qh@29h@00RN401P3QhN40h@8000GQ0>7Q002:h@00R>400`3Q
h@02h@060>400>400n400`3Qh@27h@00Qn400`3Qh@03h@060>400>401>400`3Qh@26h@00Q^400`3Q
h@04h@@00^400`3Qh@02h@030>7Q08GQ0025h@030>7Q00CQ00P0h@00h@3Q00GQ00<0hN40Q>4008CQ
00<0hN401N401P3Q003Q00;Q00<0hN400n400`3Qh@23h@00Pn400`3Qh@06h@060>400>400^400`3Q
h@04h@030>7Q08;Q0022h@030>7Q00KQ00<0hN400P000n40h@02h@030>7Q00CQ00<0hN40PN40087Q
00<0hN401n400`3Qh@020003h@3Q00;Q00<0hN401N400`3Qh@20h@00P>400`3Qh@08h@030>7Q0080
00?Q0>400^400`3Qh@06h@030>7Q07oQ001oh@030>7Q00WQ00<0hN400P02h@050>7Qh@002>400`3Q
h@1nh@00O^400`3Qh@09h@090>7Qh@3Q0>4000?Q00<0hN401n400`3Qh@1mh@00ON400`3Qh@0:h@09
0>7Qh@3Q0>4000CQ00<0hN401n400`3Qh@1lh@00O>400`3Qh@0;h@090>7Qh@3Q0>4000CQ00<0hN40
2>400`3Qh@1kh@00Nn400`3Qh@0<h@090>7Qh@3Q0>4000GQ00<0hN402>400`3Qh@1jh@00N^400`3Q
h@0<h@030>7Q00;Q00D0h@3Q0005h@030>7Q00WQ00<0hN40NN4007WQ00<0hN403N400`3Qh@02h@03
0>4000;Q00<0hN400^400`3Qh@0:h@030>7Q07SQ001hh@030>7Q00kQ00<0hN400^400`3Q0002h@03
0>7Q00?Q00<0hN402^400`3Qh@1gh@00Mn400`3Qh@0?h@030>7Q00;Q00<0h@000^400`3Qh@03h@03
0>7Q00_Q00<0hN40M^4007KQ00<0hN403n400`3Qh@02h@040>7Q00;Q00<0hN401>400`3Qh@0;h@03
0>7Q07GQ001eh@030>7Q013Q00<0hN400^40103Qh@02h@030>7Q00CQ00<0hN403>400`3Qh@1dh@00
M>400`3Qh@0Ah@030>7Q00;Q00@0hN400^400`3Qh@05h@030>7Q00cQ00<0hN40Ln4007?Q00<0hN40
4N400`3Qh@03h@040>7Q00?Q00<0hN401>400`3Qh@0=h@030>7Q07;Q001bh@030>7Q01;Q00<0hN40
0n40103Qh@03h@030>7Q00CQ00<0hN403^400`3Qh@1ah@00LN400`3Qh@0Ch@030>7Q00?Q00@0hN40
0n400`3Qh@05h@030>7Q00kQ00<0hN40L>40073Q00<0hN405>400`3Qh@03h@040>7Q00?Q00<0hN40
1N400`3Qh@0?h@030>7Q06oQ001_h@030>7Q01CQ00<0hN401>40103Qh@03h@030>7Q00KQ00<0hN40
3n400`3Qh@1^h@00K^400`3Qh@0Eh@030>7Q00CQ00@0hN400n400`3Qh@06h@030>7Q013Q00<0hN40
KN4006gQ00<0hN405^400`3Qh@04h@040>7Q00CQ00<0hN401^400`3Qh@0@h@030>7Q06cQ001/h@03
0>7Q01OQ00<0hN401>40103Qh@04h@030>7Q00KQ00<0hN404N400`3Qh@1[h@00Jn400`3Qh@0Gh@03
0>7Q00GQ00@0hN401>400`3Qh@06h@030>7Q01;Q00<0hN40J^4006[Q00<0hN406>400`3Qh@05h@04
0>7Q00CQ00<0hN401n400`3Qh@0Bh@030>7Q06WQ001Yh@030>7Q01WQ00<0hN401N40103Qh@04h@03
0>7Q00OQ00<0hN404n400`3Qh@1Xh@00J>400`3Qh@0Ih@030>7Q00KQ00@0hN401>400`3Qh@08h@03
0>7Q01?Q00<0hN40In4006OQ00<0hN406^400`3Qh@06h@040>7Q00GQ00<0hN401n400`3Qh@0Dh@03
0>7Q06KQ001Vh@030>7Q01_Q00<0hN401N401@3QhN4000GQ00<0hN402>400`3Qh@0Dh@030>7Q06GQ
001Uh@030>7Q01cQ00<0hN401N401@3QhN4000GQ00<0hN402>400`3Qh@0Eh@030>7Q06CQ001Th@03
0>7Q01cQ00<0hN401^401@3QhN4000GQ00<0hN402>400`3Qh@0Fh@030>7Q06?Q001Sh@030>7Q01gQ
00<0hN401^401@3QhN4000GQ00<0hN402N400`3Qh@0Fh@030>7Q06;Q001Rh@030>7Q01kQ00<0hN40
1^401@3QhN4000GQ00<0hN402N400`3Qh@0Gh@030>7Q067Q001Qh@030>7Q01oQ00<0hN401^401@3Q
hN4000KQ00<0hN402N400`3Qh@0Gh@030>7Q063Q001Ph@030>7Q01oQ00<0hN401n401@3QhN4000KQ
00<0hN402N400`3Qh@0Hh@030>7Q05oQ001Oh@030>7Q023Q00<0hN401n401@3QhN4000KQ00<0hN40
2^400`3Qh@0Hh@030>7Q05kQ001Nh@030>7Q027Q00<0hN401n401@3QhN4000KQ00<0hN402^400`3Q
h@0Ih@030>7Q05gQ001Mh@030>7Q02;Q00<0hN401n400`3Qh@02h@030>7Q00?Q00<0hN402^400`3Q
h@0Jh@030>7Q05cQ001Lh@030>7Q02;Q00<0hN402>400`3Qh@02h@030>7Q00?Q00<0hN402n400`3Q
h@0Jh@030>7Q05_Q001Kh@030>7Q02?Q00<0hN402>400`3Qh@02h@030>7Q00CQ00<0hN402^400`3Q
h@0Kh@030>7Q05[Q001Jh@030>7Q02CQ00<0hN402>400`3Qh@02h@030>7Q00CQ00<0hN402n400`3Q
h@0Kh@030>7Q05WQ001Ih@030>7Q02CQ00<0hN402N400`3Qh@02h@030>7Q00CQ00<0hN402n400`3Q
h@0Lh@030>7Q05SQ001Hh@030>7Q02GQ00<0hN402N400`3Qh@02h@030>7Q00CQ00<0hN403>400`3Q
h@0Lh@030>7Q05OQ001Gh@030>7Q02KQ00<0hN402N400`3Qh@02h@030>7Q00CQ00<0hN403>400`3Q
h@0Mh@030>7Q05KQ001Fh@030>7Q02OQ00<0hN402N400`3Qh@02h@030>7Q00CQ00<0hN403>400`3Q
h@0Nh@030>7Q05GQ001Eh@030>7Q02OQ00<0hN402N400`3Qh@03h@030>7Q00GQ00<0hN403>400`3Q
h@0Nh@030>7Q05CQ001Dh@030>7Q02SQ00<0hN402N400`3Qh@03h@030>7Q00GQ00<0hN403>400`3Q
h@0Oh@030>7Q05?Q001Ch@030>7Q02WQ00<0hN402N400`3Qh@03h@030>7Q00GQ00<0hN403N400`3Q
h@0Oh@030>7Q05;Q001Bh@030>7Q02[Q00<0hN402N400`3Qh@03h@030>7Q00GQ00<0hN403N400`3Q
h@0Ph@030>7Q057Q001Ah@030>7Q02[Q00<0hN402^400`3Qh@03h@030>7Q00GQ00<0hN403^400`3Q
h@0Ph@030>7Q053Q001@h@030>7Q02_Q00<0hN402^400`3Qh@03h@030>7Q00GQ00<0hN403^400`3Q
h@0Qh@030>7Q04oQ001?h@030>7Q02cQ00<0hN402^400`3Qh@03h@030>7Q00KQ00<0hN403N400`3Q
h@0Rh@030>7Q04kQ001>h@030>7Q02cQ00<0hN402n400`3Qh@03h@030>7Q00KQ00<0hN403^400`3Q
h@0Rh@030>7Q04gQ001=h@030>7Q02gQ00<0hN402n400`3Qh@03h@030>7Q00KQ00<0hN403^400`3Q
h@0Sh@030>7Q04cQ001<h@030>7Q02kQ00<0hN402n400`3Qh@03h@030>7Q00KQ00<0hN403n400`3Q
h@0Sh@030>7Q04_Q001;h@030>7Q02oQ00<0hN402n400`3Qh@03h@030>7Q00KQ00<0hN403n400`3Q
h@0Th@030>7Q04[Q001:h@030>7Q02oQ00<0hN403>400`3Qh@03h@030>7Q00KQ00<0hN404>400`3Q
h@0Th@030>7Q04WQ0019h@030>7Q033Q00<0hN403>400`3Qh@03h@030>7Q00KQ00<0hN404>400`3Q
h@0Uh@030>7Q04SQ0018h@030>7Q037Q00<0hN403>400`3Qh@03h@030>7Q00OQ00<0hN403n400`3Q
h@0Vh@030>7Q04OQ0017h@030>7Q03;Q00<0hN403>400`3Qh@03h@030>7Q00OQ00<0hN404>400`3Q
h@0Vh@030>7Q04KQ0016h@030>7Q03;Q00<0hN403N400`3Qh@03h@030>7Q00OQ00<0hN404>400`3Q
h@0Wh@030>7Q04GQ0015h@030>7Q03?Q00<0hN403>400`3Qh@04h@030>7Q00OQ00<0hN404N400`3Q
h@0Wh@030>7Q04CQ0014h@030>7Q03CQ00<0hN403>400`3Qh@04h@030>7Q00OQ00<0hN404N400`3Q
h@0Xh@030>7Q04?Q0013h@030>7Q03GQ00<0hN403>400`3Qh@04h@030>7Q00OQ00<0hN404^400`3Q
h@0Xh@030>7Q04;Q0012h@030>7Q03GQ00<0hN403N400`3Qh@04h@030>7Q00SQ00<0hN404N400`3Q
h@0Yh@030>7Q047Q0011h@030>7Q03KQ00<0hN403N400`3Qh@04h@030>7Q00SQ00<0hN404N400`3Q
h@0Zh@030>7Q043Q0010h@030>7Q03OQ00<0hN403N400`3Qh@04h@030>7Q00SQ00<0hN404^400`3Q
h@0Zh@030>7Q03oQ000oh@030>7Q03OQ00<0hN403^400`3Qh@04h@030>7Q00SQ00<0hN404^400`3Q
h@0[h@030>7Q03kQ000nh@030>7Q03SQ00<0hN403^400`3Qh@04h@030>7Q00SQ00<0hN404n400`3Q
h@0[h@030>7Q03gQ000mh@030>7Q03WQ00<0hN403^400`3Qh@04h@030>7Q00SQ00<0hN404n400`3Q
h@0/h@030>7Q03cQ000lh@030>7Q03[Q00<0hN403^400`3Qh@04h@030>7Q00WQ00<0hN404n400`3Q
h@0/h@030>7Q03_Q000kh@030>7Q03[Q00<0hN403n400`3Qh@05h@030>7Q00SQ00<0hN404n400`3Q
h@0]h@030>7Q03[Q000jh@030>7Q03_Q00<0hN403n400`3Qh@05h@030>7Q00SQ00<0hN404n400`3Q
h@0^h@030>7Q03WQ000ih@030>7Q03cQ00<0hN403n400`3Qh@05h@030>7Q00SQ00<0hN405>400`3Q
h@0^h@030>7Q03SQ000hh@030>7Q03gQ00<0hN403n400`3Qh@05h@030>7Q00SQ00<0hN405>400`3Q
h@0_h@030>7Q03OQ000gh@030>7Q03gQ00<0hN404>400`3Qh@05h@030>7Q00SQ00<0hN405N400`3Q
h@0_h@030>7Q03KQ000fh@030>7Q03kQ00<0hN404>400`3Qh@05h@030>7Q00WQ00<0hN405>400`3Q
h@0`h@030>7Q03GQ000eh@030>7Q03oQ00<0hN404>400`3Qh@05h@030>7Q00WQ00<0hN405N400`3Q
h@0`h@030>7Q03CQ000dh@030>7Q03oQ00<0hN404>400`3Qh@06h@030>7Q00WQ00<0hN405N400`3Q
h@0ah@030>7Q03?Q000ch@030>7Q043Q00<0hN404>400`3Qh@06h@030>7Q00WQ00<0hN405N400`3Q
h@0bh@030>7Q03;Q000bh@030>7Q047Q00<0hN404>400`3Qh@06h@030>7Q00WQ00<0hN405^400`3Q
h@0bh@030>7Q037Q000ah@030>7Q04;Q00<0hN404>400`3Qh@06h@030>7Q00WQ00<0hN405^400`3Q
h@0ch@030>7Q033Q000`h@030>7Q04;Q00<0hN404N400`3Qh@06h@030>7Q00[Q00<0hN405^400`3Q
h@0ch@030>7Q02oQ000_h@030>7Q04?Q00<0hN404N400`3Qh@06h@030>7Q00[Q00<0hN405^400`3Q
h@0dh@030>7Q02kQ000^h@030>7Q04CQ00<0hN404N400`3Qh@06h@030>7Q00[Q00<0hN405n400`3Q
h@0dh@030>7Q02gQ000]h@030>7Q04GQ00<0hN404N400`3Qh@06h@030>7Q00[Q00<0hN405n400`3Q
h@0eh@030>7Q02cQ000/h@030>7Q04GQ00<0hN404^400`3Qh@06h@030>7Q00[Q00<0hN405n400`3Q
h@0fh@030>7Q02_Q000[h@030>7Q04KQ00<0hN404^400`3Qh@06h@030>7Q00[Q00<0hN406>400`3Q
h@0fh@030>7Q02[Q000Zh@030>7Q04OQ00<0hN404^400`3Qh@06h@030>7Q00_Q00<0hN405n400`3Q
h@0gh@030>7Q02WQ000Yh@030>7Q04SQ00<0hN404^400`3Qh@06h@030>7Q00_Q00<0hN406>400`3Q
h@0gh@030>7Q02SQ000Xh@030>7Q04SQ00<0hN404n400`3Qh@06h@030>7Q00_Q00<0hN406>400`3Q
h@0hh@030>7Q02OQ000Wh@030>7Q04WQ00<0hN404n400`3Qh@06h@030>7Q00_Q00<0hN406N400`3Q
h@0hh@030>7Q02KQ000Vh@030>7Q04[Q00<0hN404n400`3Qh@06h@030>7Q00_Q00<0hN406N400`3Q
h@0ih@030>7Q02GQ000Uh@030>7Q04[Q00<0hN405>400`3Qh@06h@030>7Q00_Q00<0hN406N400`3Q
h@0jh@030>7Q02CQ000Th@030>7Q04_Q00<0hN404n400`3Qh@07h@030>7Q00cQ00<0hN406N400`3Q
h@0jh@030>7Q02?Q000Sh@030>7Q04cQ00<0hN404n400`3Qh@07h@030>7Q00cQ00<0hN406N400`3Q
h@0kh@030>7Q02;Q000Rh@030>7Q04gQ00<0hN404n400`3Qh@07h@030>7Q00cQ00<0hN406^4303_Q
00<0hN408N40027Q00<0hN40CN400`3Qh@0Dh@030>7Q00OQ00<0hN403>400`3Qh@0Ih@D0>n400`3Q
h@0Ph@008>400`3Qh@1>h@030>7Q01CQ00<0hN401n400`3Qh@0<h@030>7Q01SQ1`0kh@030>7Q01oQ
000Oh@030>7Q04oQ00<0hN405>400`3Qh@07h@030>7Q00cQ00<0hN406>4703cQ00<0hN407^4001kQ
00<0hN40D>400`3Qh@0Dh@030>7Q00OQ00<0hN403N400`3Qh@0Gh@X0>^400`3Qh@0Mh@007N400`3Q
h@1@h@030>7Q01GQ00<0hN401n400`3Qh@0=h@030>7Q01SQ1@04h@D0=^400`3Qh@0Lh@007>400`3Q
h@1Ah@030>7Q01GQ00<0hN401n400`3Qh@0=h@030>7Q01OQ00<0h@000P0:h@@0<n400`3Qh@0Kh@00
6n400`3Qh@1Bh@030>7Q01GQ00<0hN401n400`3Qh@0=h@030>7Q01KQ00<0hN400P0?h@D0;n400`3Q
h@0Jh@006^400`3Qh@1Bh@030>7Q01KQ00<0hN402>400`3Qh@0<h@030>7Q01KQ00D0h@3Q000Dh@D0
:n400`3Qh@0Ih@006N400`3Qh@1Ch@030>7Q01KQ00<0hN402>400`3Qh@0<h@030>7Q01GQ00H0hN40
h@0Ih@@0:>400`3Qh@0Hh@006>400`3Qh@1Dh@030>7Q01KQ00<0hN402>400`3Qh@0=h@030>7Q01?Q
00@0hN400^400`3Qh@0Kh@D09>400`3Qh@0Gh@005n400`3Qh@1Eh@030>7Q01KQ00<0hN402>400`3Q
h@0=h@030>7Q01;Q00D0hN7Q0002h@030>7Q023Q100Qh@030>7Q01KQ000Fh@030>7Q05GQ00<0hN40
5n400`3Qh@08h@030>7Q00gQ00<0hN404N400`3Qh@02h@040>7Q02KQ1@0Mh@030>7Q01GQ000Eh@03
0>7Q05KQ00<0hN405n400`3Qh@08h@030>7Q00gQ00<0hN404>400`3Qh@02h@050>7Qh@00:n4401[Q
00<0hN405>4001CQ00<0hN40En400`3Qh@0Fh@030>7Q00WQ00<0hN403N400`3Qh@0?h@030>7Q00?Q
00D0hN7Q000_h@D05^400`3Qh@0Ch@004n400`3Qh@1Hh@030>7Q01KQ00<0hN402N400`3Qh@0=h@03
0>7Q00kQ00<0hN401>401@3QhN4003CQ100Ch@030>7Q01;Q000Bh@030>7Q05SQ00<0hN405n400`3Q
h@09h@030>7Q00kQ00<0hN403>400`3Qh@04h@030>7Q00;Q00<0hN40=^4500oQ00<0hN404N40017Q
00<0hN40FN400`3Qh@0Gh@030>7Q00WQ00<0hN403^400`3Qh@0;h@030>7Q00GQ00<0hN400^400`3Q
h@0kh@D02n400`3Qh@0@h@002n4300;Q00<0hN40F>4301WQ00<0hN402N400`3Qh@0>h@030>7Q00_Q
00<0hN401N400`3Qh@02h@030>7Q043Q1008h@030>4000803N4000[Q1P1Jh@D05n4300[Q00<0hN40
3^400`3Qh@0:h@030>7Q00GQ00<0hN400n400`3Qh@14h@D01>4500cQ0009h@L0FN4701GQ1@09h@03
0>7Q00kQ00<0hN402N400`3Qh@06h@030>7Q00?Q00<0hN40BN4:00_Q0009hG402^4700OQ0`0?h@03
0>7Q00SQ00<0hN401n400`3Qh@03h@030>7Q04cQ1`0;h@002N4705WQ1`0:hA401^4500oQ00<0hN40
1^400`3Qh@07h@030>7Q00CQ00<0hN40B^4900_Q000:h@H0F^4501GQ4`0>h@030>7Q00GQ00<0hN40
2>400`3Qh@04h@030>7Q04KQ1003h@D03>4000_Q0`02h@030>7Q05SQ0`0Gh@D01^4700kQ00<0hN40
1>400`3Qh@08h@030>7Q00GQ00<0hN40@^4400SQ0`0=h@004N400`3Qh@1Ih@030>7Q01KQ0`07h@P0
3N400`3Qh@03h@030>7Q00OQ0`07h@030>7Q03kQ100Lh@004^400`3Qh@1Hh@030>7Q01OQ00<0hN40
1n4500;Q0P0;h@030>7Q00;Q00<0hN401n4500KQ00<0hN40>^44023Q000Ch@030>7Q05SQ00<0hN40
5^400`3Qh@08h@<01N4300SQ00<0hN400^400`3Qh@06h@L01N400`3Qh@0fh@@09>4001CQ00<0hN40
En400`3Qh@0Fh@030>7Q00WQ00<0hN401n4300GQ0`000n40h@08h@L01N400`3Qh@0bh@@0:>4001GQ
00<0hN40E^400`3Qh@0Fh@030>7Q00WQ00<0hN402^4200;Q1@06h@/01N400`3Qh@0^h@@0;>4001KQ
00<0hN40EN400`3Qh@0Fh@030>7Q00WQ00<0hN403>4=00GQ1@06h@030>7Q02[Q100`h@005n400`3Q
h@1Eh@030>7Q01KQ00<0hN402>400`3Qh@0=h@L02n4400KQ00<0hN409n4303CQ000Hh@030>7Q05CQ
00<0hN405^400`3Qh@08h@030>7Q00gQ1`0;h@050>7Qh@001N400`3Qh@0Sh@@0=n4001WQ00<0hN40
Dn400`3Qh@0Fh@030>7Q00SQ00<0hN403^450003h@0000SQ00<0hN400^400`3Qh@03h@030>7Q01oQ
100kh@006^400`3Qh@1Bh@030>7Q01KQ00<0hN402>400`3Qh@0?h@@00n4200CQ0`05h@030>7Q00;Q
00<0hN406n4403oQ000Kh@030>7Q05;Q00<0hN405N400`3Qh@08h@030>7Q00oQ0P02h@030>7Q00;Q
0P000n40000300CQ00<0hN400^400`3Qh@0Gh@@0@n4001cQ00<0hN40DN400`3Qh@0Eh@030>7Q00SQ
00<0hN403n4200?Q00<0hN400n4700CQ00D0hN7Q000Eh@@0An4001gQ00<0hN40D>400`3Qh@0Eh@03
0>7Q00SQ00<0hN403n4200?Q00<0hN400n4700GQ00@0hN404N4404_Q000Nh@030>7Q053Q00<0hN40
5>400`3Qh@08h@030>7Q00oQ00<0h@000n400`3Qh@02h@L01N40103Qh@0=h@@0Cn4001oQ00<0hN40
Cn400`3Qh@0Dh@030>7Q00SQ00<0hN403^40103Qh@04h@030>7Q00;Q1@000n400004h@@02>4405?Q
000Ph@030>7Q04kQ00<0hN405>400`3Qh@07h@030>7Q00oQ00@0hN401>400`3Qh@03h@<01>430003
h@0000<00n4405OQ000Qh@030>7Q04gQ00<0hN405>400`3Qh@07h@030>7Q00oQ00@0hN401N401@3Q
hN4000[Q2@1Kh@008^400`3Qh@1=h@030>7Q01?Q00<0hN401n400`3Qh@0?h@040>7Q00KQ100:h@L0
GN4002?Q00<0hN40C>400`3Qh@0Ch@030>7Q00OQ00<0hN403n40103Qh@06h@D01N4;05gQ000Th@03
0>7Q04_Q00<0hN404n400`3Qh@07h@030>7Q00oQ00@0hN401N4;00GQ1@1Nh@009N400`3Qh@1:h@03
0>7Q01?Q00<0hN401n400`3Qh@0>h@050>7Qh@001N4700WQ101Oh@009^400`3Qh@1:h@030>7Q01;Q
00<0hN401n400`3Qh@0>h@050>7Qh@001N4700SQ0P1Rh@009n400`3Qh@19h@030>7Q01?Q00<0hN40
1^400`3Qh@0>h@050>7Qh@001^4500SQ0P1Sh@00:>400`3Qh@18h@030>7Q01?Q00<0hN401^400`3Q
h@0>h@050>7Qh@001n4300WQ0P1Sh@00:N400`3Qh@18h@030>7Q01;Q00<0hN401^400`3Qh@0>h@05
0>7Qh@001n400`3Qh@08h@80I>4002[Q00<0hN40An400`3Qh@0Bh@030>7Q00KQ00<0hN403N400`3Q
h@02h@030>7Q00GQ00<0hN401n400`3Q001Th@00:n400`3Qh@16h@030>7Q01;Q00<0hN401^400`3Q
h@0=h@030>7Q00;Q00<0hN401>400`3Qh@07h@030>4006GQ000/h@030>7Q04GQ00<0hN404^400`3Q
h@06h@030>7Q00gQ00<0hN400n400`3Qh@03h@030>7Q00OQ00<0h@00IN4002gQ00<0hN40AN400`3Q
h@0Ah@030>7Q00KQ00<0hN403N400`3Qh@03h@030>7Q00?Q00<0hN401^400`3Q001Vh@00;^400`3Q
h@14h@030>7Q017Q00<0hN401^400`3Qh@0=h@030>7Q00?Q00<0hN400n400`3Qh@05h@040>7Q06KQ
000_h@030>7Q04?Q00<0hN404N400`3Qh@06h@030>7Q00cQ00<0hN401>400`3Qh@02h@030>7Q00GQ
00@0hN40In40033Q00<0hN40@^400`3Qh@0Ah@030>7Q00KQ00<0hN403>400`3Qh@04h@030>7Q00;Q
00<0hN401N40103Qh@1Wh@00<N400`3Qh@12h@030>7Q013Q00<0hN401^400`3Qh@0<h@030>7Q00CQ
00<0hN400^400`3Qh@04h@040>7Q06SQ000bh@030>7Q047Q00<0hN404>400`3Qh@06h@030>7Q00cQ
00<0hN401>400`3Qh@02h@030>7Q00?Q00D0hN7Q001Xh@00<n400`3Qh@10h@030>7Q013Q00<0hN40
1^400`3Qh@0<h@030>7Q00CQ00D0hN7Q0006h@040>7Q06WQ000dh@030>7Q03oQ00<0hN404>400`3Q
h@06h@030>7Q00_Q00<0hN401N401@3QhN4000GQ00D0hN7Q001Yh@00=N400`3Qh@0oh@030>7Q00oQ
00<0hN401^400`3Qh@0;h@030>7Q00GQ00D0hN7Q0004h@050>7Qh@00J^4003KQ00<0hN40?^400`3Q
h@0?h@030>7Q00KQ00<0hN402n400`3Qh@05h@050>7Qh@000n400`3Qh@02h@030>7Q06SQ000gh@03
0>7Q03gQ00<0hN404>400`3Qh@05h@030>7Q00_Q00<0hN401N40103Qh@04h@050>7Qh@00Jn4003SQ
00<0hN40?N400`3Qh@0?h@030>7Q00GQ00<0hN402n400`3Qh@05h@040>7Q00?Q00<0hN400^400`3Q
h@1Yh@00>N400`3Qh@0lh@030>7Q00oQ00<0hN401N400`3Qh@0:h@030>7Q00KQ00@0hN400^400`3Q
h@02h@030>7Q06[Q000jh@030>7Q03_Q00<0hN403n400`3Qh@05h@030>7Q00[Q00<0hN401n401@3Q
0>4000GQ00<0hN40J^4003_Q00<0hN40>^400`3Qh@0?h@030>7Q00GQ00<0hN402^400`3Qh@07h@80
0^400`3Qh@02h@030>7Q06_Q000lh@030>7Q03[Q00<0hN403^400`3Qh@05h@030>7Q00[Q00<0hN40
1n420003h@3Q00CQ00<0hN40Jn4003gQ00<0hN40>N400`3Qh@0>h@030>7Q00GQ00<0hN402^400`3Q
h@06h@@01N400`3Qh@1/h@00?^400`3Qh@0hh@030>7Q00kQ00<0hN401N400`3Qh@0:h@030>7Q00GQ
1@05h@030>7Q06cQ000oh@030>7Q03OQ00<0hN403^400`3Qh@05h@030>7Q00WQ00<0hN401N4700?Q
00<0hN40KN40043Q00<0hN40=n400`3Qh@0=h@030>7Q00CQ00<0hN402^400`3Qh@05h@L00n400`3Q
h@1]h@00@N400`3Qh@0fh@030>7Q00gQ00<0hN401>400`3Qh@0:h@030>7Q00GQ1`02h@030>7Q06kQ
0012h@030>7Q03GQ00<0hN403N400`3Qh@04h@030>7Q00[Q00<0hN401^4500?Q00<0hN40K^4004?Q
00<0hN40=N400`3Qh@0<h@030>7Q00CQ00<0hN402^400`3Qh@07h@<00n400`3Qh@1_h@00A>400`3Q
h@0dh@030>7Q00cQ00<0hN401>400`3Qh@09h@030>7Q00SQ0P04h@030>7Q06oQ0015h@030>7Q03?Q
00<0hN403>400`3Qh@04h@030>7Q00WQ00<0hN401n400`3Q0003h@030>7Q073Q0016h@030>7Q03;Q
00<0hN403>400`3Qh@04h@030>7Q00WQ00<0hN401n400`3Q0003h@030>7Q073Q0017h@030>7Q03;Q
00<0hN403>400`3Qh@03h@030>7Q00WQ00<0hN401n400`3Q0002h@030>7Q077Q0018h@030>7Q037Q
00<0hN403>400`3Qh@03h@030>7Q00WQ00<0hN401^400`3Q0003h@030>7Q077Q0019h@030>7Q033Q
00<0hN403>400`3Qh@03h@030>7Q00SQ00<0hN401n400`3Q0002h@030>7Q07;Q001:h@030>7Q02oQ
00<0hN403>400`3Qh@03h@030>7Q00SQ00<0hN401n400`3Q0002h@030>7Q07;Q001;h@030>7Q02oQ
00<0hN402n400`3Qh@03h@030>7Q00SQ00<0hN401^401P3Qh@3Q07GQ001<h@030>7Q02kQ00<0hN40
2n400`3Qh@03h@030>7Q00SQ00<0hN401^401P3Qh@3Q07GQ001=h@030>7Q02gQ00<0hN402n400`3Q
h@03h@030>7Q00SQ00<0hN401^400`3Q000207KQ001>h@030>7Q02cQ00<0hN402n400`3Qh@03h@03
0>7Q00OQ00<0hN401^400`3Q000407GQ001?h@030>7Q02cQ00<0hN402^400`3Qh@03h@030>7Q00OQ
00<0hN401^4807CQ001@h@030>7Q02_Q00<0hN402^400`3Qh@03h@030>7Q00OQ00<0hN401^4807CQ
001Ah@030>7Q02[Q00<0hN402^400`3Qh@03h@030>7Q00OQ00<0hN401N400`3Q000607CQ001Bh@03
0>7Q02[Q00<0hN402N400`3Qh@03h@030>7Q00OQ00<0hN401N400`3Qh@0507GQ001Ch@030>7Q02WQ
00<0hN402N400`3Qh@03h@030>7Q00KQ00<0hN401^40103QhN4307KQ001Dh@030>7Q02SQ00<0hN40
2N400`3Qh@03h@030>7Q00KQ00<0hN401N401@3QhN4007WQ001Eh@030>7Q02OQ00<0hN402N400`3Q
h@03h@030>7Q00KQ00<0hN401N401@3QhN4007WQ001Fh@030>7Q02OQ00<0hN402>400`3Qh@03h@03
0>7Q00KQ00<0hN401N401@3QhN4007WQ001Gh@030>7Q02KQ00<0hN402N400`3Qh@02h@030>7Q00KQ
00<0hN401>401@3QhN4007[Q001Hh@030>7Q02GQ00<0hN402N400`3Qh@02h@030>7Q00KQ00<0hN40
1>401@3QhN4007[Q001Ih@030>7Q02CQ00<0hN402N400`3Qh@02h@030>7Q00GQ00<0hN401N40103Q
h@1kh@00F^400`3Qh@0Th@030>7Q00SQ00<0hN400^400`3Qh@05h@030>7Q00CQ00D0hN7Q001kh@00
Fn400`3Qh@0Sh@030>7Q00SQ00<0hN400^400`3Qh@05h@030>7Q00CQ00D0hN7Q001kh@00G>400`3Q
h@0Rh@030>7Q00SQ00<0hN400^400`3Qh@05h@030>7Q00CQ00@0hN40O>4005gQ00<0hN408^400`3Q
h@07h@030>7Q00;Q00<0hN401N400`3Qh@03h@050>7Qh@00O>4005kQ00<0hN408N400`3Qh@07h@03
0>7Q00;Q00<0hN401>400`3Qh@04h@040>7Q07gQ001Oh@030>7Q023Q00<0hN401n400`3Qh@02h@03
0>7Q00CQ00<0hN401>40103Qh@1mh@00H>400`3Qh@0Oh@030>7Q00OQ00D0hN7Q0007h@030>7Q00?Q
00D0hN7Q001mh@00HN400`3Qh@0Oh@030>7Q00KQ00D0hN7Q0007h@030>7Q00?Q00@0hN40O^4006;Q
00<0hN407^400`3Qh@06h@050>7Qh@001n400`3Qh@03h@040>7Q07kQ001Sh@030>7Q01gQ00<0hN40
1^401@3QhN4000KQ00<0hN400n40103Qh@1oh@00I>400`3Qh@0Lh@030>7Q00KQ00D0hN7Q0006h@03
0>7Q00?Q00@0hN40On4006GQ00<0hN407>400`3Qh@05h@050>7Qh@001^400`3Qh@03h@040>7Q07oQ
001Vh@030>7Q01_Q00<0hN401N401@3QhN4000KQ00<0hN400^40103Qh@20h@00In400`3Qh@0Jh@03
0>7Q00KQ00@0hN401^400`3Qh@02h@040>7Q083Q001Xh@030>7Q01WQ00<0hN401^40103Qh@05h@03
0>7Q00?Q00<0h@00PN4006WQ00<0hN406N400`3Qh@05h@040>7Q00GQ00<0hN400n400`3Q0021h@00
J^400`3Qh@0Hh@030>7Q00GQ00@0hN401N400`3Qh@02h@040>7Q087Q001[h@030>7Q01OQ00<0hN40
1N40103Qh@05h@030>7Q00;Q00<0h@00P^4006cQ00<0hN405n400`3Qh@04h@040>7Q00GQ00<0hN40
0^400`3Q0022h@00KN400`3Qh@0Fh@030>7Q00CQ00@0hN401N401`3QhN40h@00Pn4006kQ00<0hN40
5N400`3Qh@04h@040>7Q00CQ00<0hN400^400`3Q0023h@00Kn400`3Qh@0Dh@030>7Q00CQ00@0hN40
1>400`3Qh@02h@030>4008?Q001`h@030>7Q01CQ00<0hN400n40103Qh@04h@070>7Qh@3Q0024h@00
LN400`3Qh@0Ch@030>7Q00?Q00@0hN401>401`3QhN40h@00Q>4007;Q00<0hN404^400`3Qh@03h@04
0>7Q00CQ00L0hN7Q0>4008CQ001ch@030>7Q017Q00<0hN400n40103Qh@03h@070>7Qh@3Q0025h@00
M>400`3Qh@0Ah@030>7Q00;Q00@0hN400n401`3QhN40h@00QN4007GQ00<0hN404>400`3Qh@02h@04
0>7Q00?Q00@0hN7Q0P26h@00M^400`3Qh@0?h@030>7Q00;Q00@0hN400n401P3Qh@3Q08KQ001gh@03
0>7Q00oQ00<0hN400^400`3Q0003h@060>7Q0>40Q^4007SQ00<0hN403^400`3Qh@02h@030>4000;Q
00@0hN7Q0P27h@00NN400`3Qh@0=h@030>7Q00;Q00<0h@000^401P3Qh@3Q08OQ001jh@030>7Q00cQ
00<0hN400^400`3Q0002h@030>7Q0080R>4007_Q00<0hN403>401`3QhN40h@000^400`3Qh@0208SQ
001lh@030>7Q00_Q00L0hN7Q0>4000;Q00D0h@3Q0028h@00ON400`3Qh@0:h@090>7Qh@3Q0>4000;Q
0P29h@00O^400`3Qh@09h@090>7Qh@3Q0>4000;Q0P29h@00On400`3Qh@09h@090>7Q0>40h@3Q0080
R^40083Q00<0hN402>400`3Qh@0200;Q00@0h@00R^40087Q00<0hN401n400`3Qh@0200;Q00@0h@00
R^4008;Q00<0hN401^400`3Qh@020003h@3Q0080Rn4008?Q00<0hN401^401`3Q003Q0>400P2;h@00
Q>400`3Qh@05h@080>400>40h@2<h@00QN400`3Qh@04h@050>400>400`2<h@00Q^400`3Qh@04h@<0
00CQ0000S>4008OQ00<0hN400n40103Q0>4208gQ0028h@030>7Q00;Q00<0h@000`2=h@00RN401P3Q
hN40h@<0S^4008[Q00@0hN7Q102>h@00Rn400`3Qh@0408kQ002<h@030>400080Sn4008gQ102?h@00
SN4508kQ002<h@L0SN4008cQ1`2=h@00S>4708gQ002=h@D0S^4008kQ0`2?h@00on4Qh@00on4Qh@00
on4Qh@00on4Qh@00on4Qh@00on4Qh@00on4Qh@00on4Qh@00on4Qh@00\
\>"],
  ImageRangeCache->{{{0, 287}, {287, 0}} -> {-0.0500054, -0.0500054, 
  0.00383279, 0.00383279}}]
}, Open  ]],

Cell[TextData[{
  "    \:3053\:308c\:307e\:3067\:306f\:3001\:9069\:5207\:306a\:5916\:5468\
\:8def\:3092\:6307\:5b9a\:3057\:305f\:306e\:3067\:6b63\:3057\:3044\:5e73\:9762\
\:30b0\:30e9\:30d5\:306e\:8868\:793a\:304c\:5f97\:3089\:308c\:305f\:3002\:6b21\
\:306b\:4e0d\:9069\:5207\:306a\:3082\:306e\:3092\:6307\:5b9a\:3057\:3066\:307f\
\:3088\:3046\:3002\:4f8b\:3048\:3070\:3001\:5916\:5468\:8def\:3068\:3057\:3066\
 {5,7,2,1,9,11}\:3092\:6307\:5b9a\:3059\:308b\:3002\n\
vtx=getvertices[mm,{5,7,2,1,9,11}];\ng0=EmptyGraph[15];\t\t\t(* \
15\:9802\:70b9\:306e\:30c0\:30df\:30fc\:306e\:30b0\:30e9\:30d5  *)\n\
g1=ChangeVertices[g0, vtx];\t\t(* \
\:30b0\:30e9\:30d5g0\:306e\:9802\:70b9\:306e\:5ea7\:6a19\:3092vtx\:3068\:5165\
\:308c\:66ff\:3048\:308b *)\ng2=ChangeEdges[g1, mm]; \t\t(*  \:30b0\:30e9\
\:30d5g1\:306e\:96a3\:63a5\:884c\:5217\:3092mm\:3068\:5165\:308c\:66ff\:3048\
\:308b *)\nShowLabeledGraph[g2]\t\t(*  \:30b0\:30e9\:30d5\:306b\:9802\:70b9\
\:306e\:756a\:53f7\:3092\:4ed8\:3051\:3066\:8868\:793a\:3000\:3000  *)\:3000\n\
\n",
  Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: 1 
MathPictureStart
/Mabs {
Mgmatrix idtransform
Mtmatrix dtransform
} bind def
/Mabsadd { Mabs
3 -1 roll add
3 1 roll add
exch } bind def
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
-0.0175847 1.03517 0.0454545 0.909091 [
[ 0 0 0 0 ]
[ 1 1 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 0 m
1 0 L
1 1 L
0 1 L
closepath
clip
newpath
0 g
.025 w
.5 .95455 Mdot
.05176 .72727 Mdot
.05176 .27273 Mdot
.5 .04545 Mdot
.94824 .27273 Mdot
.94824 .72727 Mdot
.55013 .52305 Mdot
.66612 .73495 Mdot
.51832 .51613 Mdot
.51253 .39213 Mdot
.67227 .53425 Mdot
.68257 .73631 Mdot
.60978 .72917 Mdot
.58425 .69159 Mdot
.55497 .54839 Mdot
.5 Mabswid
.5 .95455 m
.05176 .72727 L
s
.5 .95455 m
.94824 .72727 L
s
.5 .95455 m
.55013 .52305 L
s
.5 .95455 m
.66612 .73495 L
s
.5 .95455 m
.51832 .51613 L
s
.5 .95455 m
.51253 .39213 L
s
.5 .95455 m
.55497 .54839 L
s
.05176 .72727 m
.5 .95455 L
s
.05176 .72727 m
.05176 .27273 L
s
.05176 .72727 m
.55013 .52305 L
s
.05176 .27273 m
.05176 .72727 L
s
.05176 .27273 m
.5 .04545 L
s
.05176 .27273 m
.55013 .52305 L
s
.05176 .27273 m
.66612 .73495 L
s
.05176 .27273 m
.51832 .51613 L
s
.05176 .27273 m
.51253 .39213 L
s
.05176 .27273 m
.67227 .53425 L
s
.5 .04545 m
.05176 .27273 L
s
.5 .04545 m
.94824 .27273 L
s
.5 .04545 m
.67227 .53425 L
s
.94824 .27273 m
.5 .04545 L
s
.94824 .27273 m
.94824 .72727 L
s
.94824 .27273 m
.67227 .53425 L
s
.94824 .27273 m
.68257 .73631 L
s
.94824 .27273 m
.60978 .72917 L
s
.94824 .27273 m
.58425 .69159 L
s
.94824 .27273 m
.55497 .54839 L
s
.94824 .72727 m
.5 .95455 L
s
.94824 .72727 m
.94824 .27273 L
s
.94824 .72727 m
.55497 .54839 L
s
.55013 .52305 m
.5 .95455 L
s
.55013 .52305 m
.05176 .72727 L
s
.55013 .52305 m
.05176 .27273 L
s
.55013 .52305 m
.66612 .73495 L
s
.66612 .73495 m
.5 .95455 L
s
.66612 .73495 m
.05176 .27273 L
s
.66612 .73495 m
.55013 .52305 L
s
.66612 .73495 m
.51832 .51613 L
s
.51832 .51613 m
.5 .95455 L
s
.51832 .51613 m
.05176 .27273 L
s
.51832 .51613 m
.66612 .73495 L
s
.51832 .51613 m
.51253 .39213 L
s
.51253 .39213 m
.5 .95455 L
s
.51253 .39213 m
.05176 .27273 L
s
.51253 .39213 m
.51832 .51613 L
s
.51253 .39213 m
.67227 .53425 L
s
.51253 .39213 m
.68257 .73631 L
s
.51253 .39213 m
.60978 .72917 L
s
.51253 .39213 m
.58425 .69159 L
s
.51253 .39213 m
.55497 .54839 L
s
.67227 .53425 m
.05176 .27273 L
s
.67227 .53425 m
.5 .04545 L
s
.67227 .53425 m
.94824 .27273 L
s
.67227 .53425 m
.51253 .39213 L
s
.67227 .53425 m
.68257 .73631 L
s
.68257 .73631 m
.94824 .27273 L
s
.68257 .73631 m
.51253 .39213 L
s
.68257 .73631 m
.67227 .53425 L
s
.68257 .73631 m
.60978 .72917 L
s
.60978 .72917 m
.94824 .27273 L
s
.60978 .72917 m
.51253 .39213 L
s
.60978 .72917 m
.68257 .73631 L
s
.60978 .72917 m
.58425 .69159 L
s
.58425 .69159 m
.94824 .27273 L
s
.58425 .69159 m
.51253 .39213 L
s
.58425 .69159 m
.60978 .72917 L
s
.58425 .69159 m
.55497 .54839 L
s
.55497 .54839 m
.5 .95455 L
s
.55497 .54839 m
.94824 .27273 L
s
.55497 .54839 m
.94824 .72727 L
s
.55497 .54839 m
.51253 .39213 L
s
.55497 .54839 m
.58425 .69159 L
s
.5 .95455 m
.05176 .72727 L
s
.5 .95455 m
.94824 .72727 L
s
.5 .95455 m
.55013 .52305 L
s
.5 .95455 m
.66612 .73495 L
s
.5 .95455 m
.51832 .51613 L
s
.5 .95455 m
.51253 .39213 L
s
.5 .95455 m
.55497 .54839 L
s
.05176 .72727 m
.5 .95455 L
s
.05176 .72727 m
.05176 .27273 L
s
.05176 .72727 m
.55013 .52305 L
s
.05176 .27273 m
.05176 .72727 L
s
.05176 .27273 m
.5 .04545 L
s
.05176 .27273 m
.55013 .52305 L
s
.05176 .27273 m
.66612 .73495 L
s
.05176 .27273 m
.51832 .51613 L
s
.05176 .27273 m
.51253 .39213 L
s
.05176 .27273 m
.67227 .53425 L
s
.5 .04545 m
.05176 .27273 L
s
.5 .04545 m
.94824 .27273 L
s
.5 .04545 m
.67227 .53425 L
s
.94824 .27273 m
.5 .04545 L
s
.94824 .27273 m
.94824 .72727 L
s
.94824 .27273 m
.67227 .53425 L
s
.94824 .27273 m
.68257 .73631 L
s
.94824 .27273 m
.60978 .72917 L
s
.94824 .27273 m
.58425 .69159 L
s
.94824 .27273 m
.55497 .54839 L
s
.94824 .72727 m
.5 .95455 L
s
.94824 .72727 m
.94824 .27273 L
s
.94824 .72727 m
.55497 .54839 L
s
.55013 .52305 m
.5 .95455 L
s
.55013 .52305 m
.05176 .72727 L
s
.55013 .52305 m
.05176 .27273 L
s
.55013 .52305 m
.66612 .73495 L
s
.66612 .73495 m
.5 .95455 L
s
.66612 .73495 m
.05176 .27273 L
s
.66612 .73495 m
.55013 .52305 L
s
.66612 .73495 m
.51832 .51613 L
s
.51832 .51613 m
.5 .95455 L
s
.51832 .51613 m
.05176 .27273 L
s
.51832 .51613 m
.66612 .73495 L
s
.51832 .51613 m
.51253 .39213 L
s
.51253 .39213 m
.5 .95455 L
s
.51253 .39213 m
.05176 .27273 L
s
.51253 .39213 m
.51832 .51613 L
s
.51253 .39213 m
.67227 .53425 L
s
.51253 .39213 m
.68257 .73631 L
s
.51253 .39213 m
.60978 .72917 L
s
.51253 .39213 m
.58425 .69159 L
s
.51253 .39213 m
.55497 .54839 L
s
.67227 .53425 m
.05176 .27273 L
s
.67227 .53425 m
.5 .04545 L
s
.67227 .53425 m
.94824 .27273 L
s
.67227 .53425 m
.51253 .39213 L
s
.67227 .53425 m
.68257 .73631 L
s
.68257 .73631 m
.94824 .27273 L
s
.68257 .73631 m
.51253 .39213 L
s
.68257 .73631 m
.67227 .53425 L
s
.68257 .73631 m
.60978 .72917 L
s
.60978 .72917 m
.94824 .27273 L
s
.60978 .72917 m
.51253 .39213 L
s
.60978 .72917 m
.68257 .73631 L
s
.60978 .72917 m
.58425 .69159 L
s
.58425 .69159 m
.94824 .27273 L
s
.58425 .69159 m
.51253 .39213 L
s
.58425 .69159 m
.60978 .72917 L
s
.58425 .69159 m
.55497 .54839 L
s
.55497 .54839 m
.5 .95455 L
s
.55497 .54839 m
.94824 .27273 L
s
.55497 .54839 m
.94824 .72727 L
s
.55497 .54839 m
.51253 .39213 L
s
.55497 .54839 m
.58425 .69159 L
s
[(1)] .46894 .92727 0 1 Mshowa
[(2)] .0207 .7 0 1 Mshowa
[(3)] .0207 .24545 0 1 Mshowa
[(4)] .46894 .01818 0 1 Mshowa
[(5)] .91719 .24545 0 1 Mshowa
[(6)] .91719 .7 0 1 Mshowa
[(7)] .51908 .49577 0 1 Mshowa
[(8)] .63507 .70768 0 1 Mshowa
[(9)] .48727 .48886 0 1 Mshowa
[(10)] .48148 .36485 0 1 Mshowa
[(11)] .64122 .50697 0 1 Mshowa
[(12)] .65152 .70904 0 1 Mshowa
[(13)] .57872 .7019 0 1 Mshowa
[(14)] .5532 .66432 0 1 Mshowa
[(15)] .52392 .52112 0 1 Mshowa
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
    ImageSize->{288, 288},
    ImageMargins->{{43, 0}, {0, 0}},
    ImageRegion->{{0, 1}, {0, 1}},
    ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`40004P000180P10`40000100000800002008200000
P800P020P<30`<3L`:K:l00000000000000000000000000000000000000000000000000000000000
00000000000000000000000000000000000000000000000000000000000000000000000000000000
00000000000000000000000000000000000000000000000000000000000000000000000000000000
00000000000000000000000000000000000000000000000000000000000000000000000000000000
00000000000000000000000000000000000000000000000000000000000000000000000000000000
00000000000000000000000000000000000000000000000000000000000000000000000000000000
00000000000000000000000000000000000000000000000000000000000000000000000000000000
00000000000000000000000000000000000000000000000000000000000000000000000000000000
00000000000000000000000000000000000000000000000000000000000000000000000000000000
00000000000000000000000000000000000000000000000000000000000000000000000000000000
00000000000000000000000000000000000000000000000000000000000000000000000000000000
00000000000000000000000000000000000000000000000000000000000000000000000000000000
00000?okl:2PY820P?l0003o0?oo0000ool0o`3oooooohGo102Go`00QOl00`3o002Ho`00Q_l209So
0027o`030?oo09Ko003oob7o003oob7o003oob7o003oob7o003oob7o003oob7o003oob7o002>o`<0
Sol008go1@2>o`00S?l708go002<o`L0SOl008co1`2=o`00Rol908co0029o`800ol300?o0P2:o`00
Qol200Oo00<0ool00ol208So0025o`802_l00`3oo`04o`80Q_l008?o0P0<o`030?oo00Ko0P24o`00
POl200ko00<0ool02?l208;o001oo`804Ol00`3oo`09o`80P?l007go0P0Co`030?oo00_o0P1no`00
Nol201Go00<0ool03Ol207co001io`806?l00`3oo`0>o`80N_l007Oo0P0Jo`030?oo013o0P1ho`00
MOl201go00<0ool04Ol207Ko001co`807ol00`3oo`0Co`80M?l0077o0P0Qo`030?oo01Go0P1bo`00
Kol202Co00<0ool05_l2073o001]o`809_l00`3oo`0Ho`80K_l006_o0P0Xo`030?oo01[o0P1/o`00
JOl202_o00<0ool06ol206[o001Wo`80;Ol00`3oo`0Mo`80J?l006Go0P0_o`030?oo01oo0P1Vo`00
Hol203;o00<0ool08?l206Co001Qo`80=?l00`3oo`0Ro`80H_l005oo0P0fo`030?oo02Co0P1Po`00
GOl203Wo00<0ool09Ol205ko001Ko`80>ol00`3oo`0Wo`80G?l005Wo0P0mo`030?oo02Wo0P1Jo`00
Eol2043o00<0ool0:_l205So001Eo`80@_l00`3oo`0/o`80E_l005?o0P14o`030?oo02ko0P1Do`00
DOl204Oo00<0ool0;ol205;o001?o`80BOl00`3oo`0ao`80D?l004go0P1<o`030?oo03;o0P1>o`00
Bol204ko00<0ool0=?l204co0019o`80D?l00`3oo`0fo`80B_l004Oo0P1Co`030?oo03Oo0P18o`00
AOl205Go00<0ool0>Ol204Ko0013o`80Eol00`3oo`0ko`80A?l0047o0P1Jo`030?oo03co0P12o`00
?ol205co00<0ool0?_l2043o000mo`80G_l00`3oo`10o`80?_l003_o0P1Qo`030?oo047o0P0lo`00
>Ol206?o00<0ool0@ol203[o000go`80IOl00`3oo`15o`80>?l003Go0P1Xo`030?oo04Ko0P0fo`00
<ol206[o00<0ool0B?l203Co000ao`80K?l00`3oo`1:o`80<_l002oo0P1_o`030?oo04_o0P0`o`00
1?l202Oo0P1ao`030?oo04go0P0Do`030?oo01Oo0006o`030?oo02;o0P1co`030?oo04oo0P0Ao`03
0?l001So0005o`030?oo027o0P1fo`030?oo053o0P0Ao`030?oo01Ko0006o`030?oo01ko0P1ho`03
0?oo05;o0P0=o`806Ol000Co00<0o`007_l207_o00<0ool0Dol200_o00<0ool06?l000Go00<0ool0
6ol207go00<0ool0EOl200Wo0`0Ho`008Ol207oo00<0ool0Eol202;o000Oo`80P_l00`3oo`1Ho`80
8?l001go0P24o`030?oo05[o0P0No`006ol208Ko00<0ool0G?l201co000Io`80ROl00`3oo`1Mo`80
6_l001Oo0P2;o`030?oo05oo0P0Ho`005Ol208go00<0ool0HOl201Ko000=o`<00ol2093o00<0ool0
H_l200?o0`0>o`003?l709;o00<0ool0I?l700go000;o`L0Tol00`3oo`1Uo`L03?l000_o1`2Do`03
0?oo06Co1`0<o`002ol909;o00<0ool0I?l700co000<o``0S_l00`3oo`1To`H03Ol000go0`02o`D0
00?o00000P2;o`030?oo067o1`0>o`003_l00`3oo`02o`H00ol408Oo00<0ool0H?l00`3o00020003
o`3o00ko000>o`030?oo00Co00<0o`001004o`@0Pol00`3oo`1Oo`030?l000800_l00`3oo`0=o`00
3_l00`3oo`05o`030?oo008000?o00001_l4083o00<0ool0G?l20003o`0000800_l00`3oo`0=o`00
3_l00`3oo`06o`800_l20003o`0000So101lo`030?oo05_o00<0ool01003o`030?oo00go000>o`03
0?oo00So00@0oooo0P001?l00009o`@0NOl00`3oo`1Ho`8000?o00000`04o`030?oo00go000>o`03
0?oo00Wo00<0ool00_l200;o0P0;o`@0MOl00`3oo`1Go`050?oo0?l00P000ol0o`03o`030?oo00go
000>o`030?oo00[o0P04o`800_l200go101ao`030?oo05Go0P02o`040?l0o`801Ol00`3oo`0=o`00
3_l00`3oo`0<o`030?oo00?o0P02o`<03_l306oo00<0ool0Dol02`3oool0o`3o0?l000Go00<0ool0
3Ol000ko00<0ool03Ol00`3oo`04o`800ol200oo101[o`030?oo05;o00/0oooo0?l0o`3o0006o`03
0?oo00go000>o`030?oo00ko0P05o`<00ol3013o101Wo`030?oo053o0P03o`030?oo008000?o0?l0
1_l00`3oo`0=o`003_l00`3oo`0@o`030?oo00Co0`04o`804_l406Co00<0ool0C_l00`3oo`02o`08
0?oo0?l0o`07o`030?oo00go000>o`030?oo017o00<0ool01Ol300Co0P0Do`@0H?l00`3oo`1<o`80
1?l0203oo`3o0?l02?l00`3oo`0=o`003_l00`3oo`0Bo`801ol300Co0`0Eo`@0G?l00`3oo`1;o`03
0?oo00?o00H0ool0o`02o`030?oo00Ko00<0ool03Ol000ko00<0ool05?l00`3oo`06o`<01Ol201Oo
101Io`030?oo04So0P05o`060?oo0?l00_l00`3oo`07o`030?oo00go000>o`030?oo01Go00<0ool0
1ol300Go0P0Io`@0;_l500;o00<0ool07Ol00`3oo`17o`030?oo00Co00@0ool00_l0103oo`09o`03
0?oo00go000>o`030?oo01Ko0P09o`<01Ol301[o100/o`070?ooo`3o000No`030?oo04Ko00<0ool0
1?l0103oo`02o`040?oo00[o00<0ool03Ol000ko00<0ool06?l00`3oo`08o`<01_l201co100Xo`07
0?ooo`3o000Oo`030?oo04?o0P06o`040?oo00;o00@0ool02ol00`3oo`0=o`003_l00`3oo`0Io`03
0?oo00Wo0`06o`<07Ol402Co00L0oooo0?l001oo00<0ool0@_l00`3oo`05o`070?ooo`3o0003o`03
0?oo00Wo00<0ool03Ol000ko00<0ool06_l200_o0`07o`807ol4023o00L0oooo0?l001oo00<0ool0
@?l200Oo00D0oooo0002o`040?oo00co00<0ool03Ol000ko00<0ool07?l00`3oo`0:o`<01ol2027o
0`0Lo`801?l00`3oo`0Oo`030?oo03ko00<0ool01Ol200?o00@0ool00ol00`3oo`0:o`030?oo00go
000>o`030?oo01go00<0ool02_l400Oo0`0Qo`@0@?l00`3oo`0lo`801ol00`3oo`02o`040?oo00?o
00<0ool02ol00`3oo`0=o`003_l00`3oo`0No`803?l400So0P0So`@0??l00`3oo`0ko`030?oo00Ko
00<0ool00_l0103oo`04o`030?oo00_o00<0ool03Ol000ko00<0ool08?l00`3oo`0;o`@02?l202Go
100io`030?oo03Wo00<0ool01_l00`3oo`02o`050?ooo`000ol00`3oo`0<o`030?oo00go000>o`03
0?oo027o00<0ool03?l400So0`0Vo`@0=Ol00`3oo`0go`802?l00`3oo`02o`050?ooo`000ol00`3o
o`0=o`030?oo00go000>o`030?oo02;o0P0>o`@02Ol202So100bo`030?oo03Go00<0ool01ol00`3o
o`02o`050?ooo`001?l00`3oo`0=o`030?oo00go000>o`030?oo02Co00<0ool03Ol400Wo0`0Yo`@0
;_l00`3oo`0co`802Ol00`3oo`03o`050?ooo`000ol00`3oo`0>o`030?oo00go000>o`030?oo02Go
00<0ool03_l400[o0P0[o`@0:_l00`3oo`0bo`030?oo00So00<0ool00ol01@3oool000Co00<0ool0
3_l00`3oo`0=o`003_l00`3oo`0Vo`804?l400[o0P0]o`@02?l301co00<0ool0;ol200[o00<0ool0
0ol01@3oool000Co00<0ool03ol00`3oo`0=o`003_l00`3oo`0Xo`030?oo00oo100:o`<0;_l400?o
1@0Ko`030?oo02ko00<0ool02Ol00`3oo`03o`050?ooo`001?l00`3oo`0@o`030?oo00go000>o`03
0?oo02Wo00<0ool04?l400_o0P0`o`T06_l00`3oo`0]o`030?oo00Wo00<0ool00ol00`3oo`02o`03
0?oo00;o00<0ool04?l00`3oo`0=o`003_l00`3oo`0Zo`804_l400_o0P0`o`L06ol00`3oo`0Zo`80
2ol00`3oo`03o`030?oo00;o00<0ool00_l00`3oo`0Ao`030?oo00go000>o`030?oo02co00<0ool0
4Ol0103o000;o`<0;Ol701_o00<0ool0:Ol00`3oo`0:o`030?oo00?o00<0ool00_l00`3oo`03o`03
0?oo017o00<0ool03Ol000ko00<0ool0;Ol00`3oo`0Ao`8000?o00003?l202co1@0Lo`030?oo02Oo
0P0<o`030?oo00?o00<0ool00_l00`3oo`03o`030?oo01;o00<0ool03Ol000ko00<0ool0;_l201?o
0P000ol0000<o`80:ol30003o`3o01_o00<0ool09Ol00`3oo`0;o`030?oo00Co00<0ool00_l00`3o
o`03o`030?oo01;o00<0ool03Ol000ko00<0ool0<?l00`3oo`0Bo`8000?o00003?l302Wo0`000ol0
o`0Jo`030?oo02?o0P0<o`801_l00`3oo`02o`030?oo00?o00<0ool04ol00`3oo`0=o`003_l00`3o
o`0ao`030?oo01?o0P000ol0000=o`809ol300;o0P0Io`030?oo02;o00<0ool02ol00`3oo`05o`03
0?oo00;o00<0ool00ol00`3oo`0Do`030?oo00go000>o`030?oo03;o0P0Eo`8000?o00003Ol302Co
1003o`030?oo01Oo00<0ool08?l00`3oo`0;o`030?oo00Go00<0ool00_l00`3oo`04o`030?oo01Co
00<0ool03Ol000ko00<0ool0=?l00`3oo`0Do`8000?o00003_l202;o00@0o`001?l00`3oo`0Fo`03
0?oo01ko0P0=o`030?oo00Go00<0ool00ol00`3oo`03o`030?oo01Go00<0ool03Ol000ko00<0ool0
=Ol00`3oo`0Eo`8000?o00003_l2023o00D0o`3o0004o`030?oo01Go00<0ool07Ol00`3oo`0<o`03
0?oo00Go00<0ool00ol00`3oo`04o`030?oo01Go00<0ool03Ol000ko00<0ool0=_l201Oo0P000ol0
000>o`<07Ol00`3o000200Go00<0ool05Ol00`3oo`0Jo`803_l00`3oo`05o`030?oo00?o00<0ool0
1?l00`3oo`0Fo`030?oo00go000>o`030?oo03So00<0ool05_l20003o`0000oo0P0Ko`060?l00?l0
1Ol00`3oo`0Do`030?oo01Wo00<0ool03Ol00`3oo`05o`030?oo00?o00<0ool01Ol00`3oo`0Fo`03
0?oo00go000>o`030?oo03Wo0P0Ho`8000?o00003ol201Wo00H0ool0o`06o`030?oo01?o00<0ool0
5ol200oo00<0ool01_l00`3oo`03o`030?oo00Co00<0ool05ol00`3oo`0=o`003_l00`3oo`0ko`03
0?oo01Oo0P000ol0000?o`<05_l0103oo`02o`030?oo00Co00<0ool04ol00`3oo`0Eo`030?oo00ko
00<0ool01_l00`3oo`03o`030?oo00Co00<0ool06?l00`3oo`0=o`003_l00`3oo`0lo`030?oo01So
00<0ool00P0@o`805?l00`3oo`020003o`3o00Ko00<0ool04_l00`3oo`0Do`030?oo00ko00<0ool0
1_l00`3oo`03o`030?oo00Go00<0ool06?l00`3oo`0=o`003_l00`3oo`0mo`806Ol200;o0P0@o`<0
4Ol00`3oo`0200;o00<0ool01Ol00`3oo`0Bo`030?oo017o0P0@o`030?oo00Ko00<0ool00ol00`3o
o`05o`030?oo01Wo00<0ool03Ol000ko00<0ool0?ol00`3oo`0Ho`800_l2017o0P0?o`030?oo0080
0_l00`3oo`06o`804_l00`3oo`0@o`030?oo00oo00<0ool01_l00`3oo`04o`030?oo00Go00<0ool0
6Ol00`3oo`0=o`003_l00`3oo`10o`030?oo01Wo0P02o`804Ol200go00@0oooo0P02o`030?oo00Oo
00<0ool03ol00`3oo`0>o`804Ol00`3oo`06o`030?oo00Co00<0ool01Ol00`3oo`0Jo`030?oo00go
000>o`030?oo047o0P0Ko`800_l2017o0`0:o`040?ooo`800_l00`3oo`08o`030?oo00oo00<0ool0
3?l00`3oo`0@o`030?oo00Ko00<0ool01?l00`3oo`05o`030?oo01_o00<0ool03Ol000ko00<0ool0
@ol00`3oo`0Jo`800_l201;o0P08o`040?ooo`800ol00`3oo`08o`030?oo00ko00<0ool02_l201;o
00<0ool01_l00`3oo`04o`030?oo00Ko00<0ool06ol00`3oo`0=o`003_l00`3oo`14o`030?oo01_o
0P02o`804_l200Ko0P02o`800ol00`3oo`09o`030?oo00go00<0ool02Ol00`3oo`0@o`802Ol00`3o
o`04o`030?oo00Go00<0ool07?l00`3oo`0=o`003_l00`3oo`15o`807Ol200;o0P0?o`8000Co0000
0ol200?o0P03o`030?oo00Wo00<0ool03Ol00`3oo`07o`030?oo013o00<0ool02?l00`3oo`04o`03
0?oo00Ko00<0ool07?l00`3oo`0=o`003_l00`3oo`17o`030?oo01co0P02o`803ol0103oool30003
o`3o00;o0P03o`030?oo00[o00<0ool03?l00`3oo`05o`804_l00`3oo`08o`030?oo00Co00<0ool0
1_l00`3oo`0Mo`030?oo00go000>o`030?oo04So00<0ool07Ol200;o0P0<o`801Ol300?o0P04o`03
0?oo00[o00<0ool02ol00`3oo`04o`030?oo017o00<0ool02?l00`3oo`05o`030?oo00Ko00<0ool0
7Ol00`3oo`0=o`003_l00`3oo`19o`807ol200;o0P09o`030?l000Go00<0o`000P001?l00003o`03
0?oo00_o00<0ool02ol0103oool201?o00<0ool02?l00`3oo`05o`030?oo00Ko00<0ool07_l00`3o
o`0=o`003_l00`3oo`1;o`030?oo01ko00@0oooo0P07o`030?l000Go00<0o`000_l400Co00<0ool0
2ol00`3oo`0:o`040?oo01Co00<0ool02?l00`3oo`05o`030?oo00Ko00<0ool07ol00`3oo`0=o`00
3_l00`3oo`1<o`030?oo01ko0P03o`801_l200Go00@0o`000ol300?o00<0ool03?l00`3oo`02o`X0
5?l00`3oo`08o`030?oo00Go00<0ool01ol00`3oo`0Oo`030?oo00go000>o`030?oo04go0P0Po`80
0ol200_o1003o`D00_l00`3oo`0<o`801?l00`3oo`02o`805?l00`3oo`08o`030?oo00Ko00<0ool0
1_l00`3oo`0Po`030?oo00go000>o`030?oo04oo00<0ool07ol200?o0P09o`@00ol300;o0`0@o`05
0?ooo`000ol301?o00<0ool02Ol00`3oo`05o`030?oo00Oo00<0ool08?l00`3oo`0=o`003_l00`3o
o`1@o`030?oo023o0P03o`801ol00`3o0005o`801?l300oo00D0ool0o`020003o`0001;o00<0ool0
2Ol00`3oo`05o`030?oo00Oo00<0ool08Ol00`3oo`0=o`003_l00`3oo`1Ao`808_l200?o0P04o`D0
0_l0103o0005o`040?l000ko00@0o`000ol00`3o000@o`030?oo00Wo00<0ool01Ol00`3oo`08o`03
0?oo027o00<0ool03Ol000ko00<0ool0Dol00`3oo`0Qo`800ol200?o0`02o`030?l000<01Ol00`3o
o`0300co0P03o`8000?o0?l03_l00`3oo`09o`030?oo00Ko00<0ool01ol00`3oo`0Ro`030?oo00go
000>o`030?oo05Co00<0ool08_l200?o0P001?l00004o`@01Ol00`3oo`03o`802Ol00`3o0006o`03
0?oo00co00<0ool02Ol00`3oo`06o`030?oo00Oo00<0ool08ol00`3oo`0=o`003_l00`3oo`1Eo`80
9?l200?o1002o`8000Co0?l01_l00`3oo`04o`801Ol200?o00<0ool01?l00`3oo`0:o`030?oo00Wo
00<0ool01_l00`3oo`08o`030?oo02?o00<0ool03Ol000ko00<0ool0Eol00`3oo`0So`800_l40003
o`3o00;o0`05o`030?oo00Ko0`000ol0o`05o`030?oo00?o00<0ool02Ol00`3oo`09o`030?oo00Ko
00<0ool02?l00`3oo`0To`030?oo00go000>o`030?oo05So00<0ool09?l:0004o`0000Go00<0ool0
2Ol200Oo00<0ool00ol00`3oo`06o`802ol00`3oo`07o`030?oo00So00<0ool09?l00`3oo`0=o`00
3_l00`3oo`1Io`809Ol800;o1005o`030?oo00Ko0P02o`801_l00`3oo`02o`030?oo00Go00<0ool0
2ol00`3oo`06o`030?oo00So00<0ool09Ol00`3oo`0=o`003_l00`3oo`1Ko`030?oo02;o1`000ol0
000500Co00<0ool01Ol00`3oo`04o`<01?l200;o00<0ool01?l00`3oo`0;o`030?oo00Ko00<0ool0
2?l00`3oo`0Vo`030?oo00go000>o`030?oo05co00<0ool08Ol700;o1`04o`030?oo00;o0P0:o`80
1?l0103oo`04o`030?oo00_o00<0ool01_l00`3oo`09o`030?oo02Ko00<0ool03Ol000ko00<0ool0
GOl202;o1@03o`L01?l01@3oool000ko0`02o`030?l0008000?o0?l03?l00`3oo`07o`030?oo00So
00<0ool09ol00`3oo`0=o`003_l00`3oo`1Oo`030?oo01oo1@03o`L01Ol301;o0P000ol0000300go
00<0ool01ol00`3oo`09o`030?oo02Oo00<0ool03Ol000ko00<0ool0H?l00`3oo`0No`030?l000;o
0`000ol0000300Ko00<0ool05?l700_o00<0ool01ol00`3oo`09o`030?oo02So00<0ool03Ol000ko
00<0ool0HOl201ko00<0o`000`04o`@01Ol00`3o000Eo`L02_l00`3oo`07o`030?oo00[o00<0ool0
:?l00`3oo`0=o`003_l00`3oo`1So`030?oo01_o0`03o`030?oo00;o1002o`800_l00`3oo`0Co`L0
2Ol00`3oo`08o`030?oo00Wo00<0ool0:Ol00`3oo`0=o`003_l00`3oo`1To`030?oo01So0`000ol0
o`03o`030?oo00L01Ol00`3oo`0Co`D02_l00`3oo`07o`030?oo00Wo00<0ool0:_l00`3oo`0=o`00
3_l00`3oo`1Uo`805Ol300;o00<0o`001Ol00`3o000600Go00<0ool05?l300[o00<0ool01ol00`3o
o`0:o`030?oo02[o00<0ool03Ol000ko00<0ool0Iol00`3oo`0@o`801Ol00`3o0005o`030?l000H0
1_l00`3oo`0Do`030?oo00So00<0ool02?l00`3oo`09o`030?oo02_o00<0ool03Ol000ko00<0ool0
J?l00`3oo`0=o`801ol00`3o0006o`P01_l00`3oo`0Do`030?oo00Oo00<0ool02?l00`3oo`0:o`03
0?oo02_o00<0ool03Ol000ko00<0ool0JOl200[o0`09o`030?l000Oo2@05o`030?oo01?o00<0ool0
1_l00`3oo`08o`030?oo00[o00<0ool0;?l00`3oo`0=o`003_l00`3oo`1[o`030?oo00Go0P0<o`03
0?l000Oo00<0o`000`000ol0o`0200?o00<0ool04ol00`3oo`05o`030?oo00So00<0ool02ol00`3o
o`0/o`030?oo00go000>o`030?oo06co00@0oooo0`0>o`802?l30005o`00o`000ol200;o00<0ool0
4_l00`3oo`04o`030?oo00Wo00<0ool02_l00`3oo`0]o`030?oo00go000>o`030?oo06go0`0Ao`80
2?l00`3o000300;o00<0ool00_l301Co00<0ool00ol00`3oo`09o`030?oo00[o00<0ool0;_l00`3o
o`0=o`003_l00`3oo`1[o`<000?o0?l04?l200So00<0o`000P001?l0o`07o`804ol00`3oo`02o`03
0?oo00So00<0ool02ol00`3oo`0^o`030?oo00go000>o`030?oo06Wo0P05o`030?oo00ko0P07o`03
0?oo00<000Go0?oo0006o`040?l0017o00D0oooo000:o`030?oo00_o00<0ool0;ol00`3oo`0=o`00
3_l00`3oo`1Vo`<02?l200ko0P07o`030?oo00D00_l00`3oo`05o`030?oo00803ol0103oo`0;o`03
0?oo00_o00<0ool0;ol00`3oo`0=o`003_l00`3oo`1To`803Ol00`3oo`0;o`801ol01@3oo`3o0080
00Go0?oo0006o`030?oo00;o0`0<o`030?l000_o00<0ool02ol00`3oo`0`o`030?oo00go000>o`03
0?oo067o0`0@o`802ol200Oo00D0ool0o`020003o`3o00;o00<0ool01?l00`3oo`04o`802_l200_o
00<0ool02ol00`3oo`0ao`030?oo00go000>o`030?oo05oo0P0Eo`030?oo00So0P07o`030?l000;o
1003o`030?oo00Co00<0ool01_l200So00<0ool02Ol00`3oo`0<o`030?oo037o00<0ool03Ol000ko
00<0ool0G?l301So00<0ool01ol200Oo00<0o`000_l20003o`3o00?o00<0ool01?l00`3oo`07o`80
1Ol200_o00<0ool02ol00`3oo`0bo`030?oo00go000>o`030?oo05[o0P0Lo`801ol200Oo00<0o`00
0_l00`3o000200?o00<0ool01?l00`3oo`09o`800_l00`3o000:o`030?oo00co00<0ool0<_l00`3o
o`0=o`003_l00`3oo`1Go`<08?l00`3oo`04o`801ol00`3o0003o`8000?o0?l00ol00`3oo`04o`03
0?oo00[o0`000ol0o`08o`030?oo00co00<0ool0<ol00`3oo`0=o`003_l00`3oo`1Eo`809?l00`3o
o`03o`801_l0103oo`03o`8000?o00000ol00`3oo`04o`030?oo00_o00@0o`002?l00`3oo`0=o`03
0?oo03?o00<0ool03Ol000ko00<0ool0Dol202Oo0P02o`030?l000Ko00@0ool00ol200;o00<0ool0
0_l00`3oo`04o`030?oo00Wo00@0oooo0`06o`030?oo00co00<0ool0=?l00`3oo`0=o`003_l00`3o
o`1@o`<0:ol01@3o0?l000Ko00@0ool00ol200;o0P04o`030?oo00?o00<0ool02?l00`3oo`02o`03
0?oo00800ol00`3oo`0<o`030?oo03Go00<0ool03Ol000ko00<0ool0C_l202oo0P000ol0o`05o`04
0?oo00Co0P001?l0o`03o`030?oo00Co00<0ool01_l00`3oo`03o`030?oo00;o0`0?o`030?oo03Go
00<0ool03Ol000ko00<0ool0Bol303;o0`06o`030?l000Go0P001?l0o`04o`030?oo00?o00<0ool0
1Ol00`3oo`04o`030?oo00?o100<o`030?oo03Ko00<0ool03Ol000ko00<0ool0BOl203Go00<0o`00
1_l00`3o0005o`800_l00`3o0003o`030?oo00Co00<0ool00ol00`3oo`05o`030?oo00?o00@0oooo
0P0:o`030?oo03Ko00<0ool03Ol000ko00<0ool0A_l303Oo00@0o`001Ol00`3o0005o`800_l0103o
o`03o`030?oo00?o00<0ool00_l00`3oo`06o`030?oo00;o00<0ool01?l200Oo00<0ool0=ol00`3o
o`0=o`003_l00`3oo`14o`80>_l0103o0?l200?o00<0o`001_l0103oo`02o`050?ooo`001Ol00`3o
o`02o`030?oo00Ko00D0oooo0009o`801Ol00`3oo`0go`030?oo00go000>o`030?oo047o0`0lo`03
0?l000?o00H0ool0o`06o`050?ooo`000_l01@3oool000Go00@0ool02Ol0103oo`0<o`<000?o0?l0
>Ol00`3oo`0=o`003_l00`3oo`0oo`80?ol00`3o0004o`800_l00`3oo`04o`800_l01@3oool000?o
00<0ool00_l00`3o000:o`040?oo00oo0P0jo`030?oo00go000>o`030?oo03co0`11o`030?l000Go
1@02o`D00_l00`3oo`02o`040?oo00Go00<0ool02Ol00`3o000@o`040?l003So00<0ool03Ol000ko
00<0ool0>_l204Co00<0o`001Ol00`3o0005o`040?oo00;o00<0ool00_l01@3oool000?o0P0<o`03
0?oo00ko00<0ool00_l203Ko00<0ool03Ol000ko00<0ool0=ol304Ko00<0o`001Ol0103o0002o`@0
00?o0?l00_l00`3oo`02o`040?oo00;o00@0ool02ol00`3oo`0>o`030?oo00Co0P0do`030?oo00go
000>o`030?oo03Go0P19o`030?l000Go00@0o`3o0`001Ol0ool000?o00<0ool00ol00`3oo`0200?o
00<0ool02?l200oo00<0ool01ol3037o00<0ool03Ol000ko00<0ool0<ol204_o0P06o`030?l000?o
0`02o`800_l00`3oo`03o`040?oo00Go00<0ool01_l00`3o000>o`030?oo00_o0P0_o`030?oo00go
000>o`030?oo033o0`1=o`801_l300Co0P02o`800ol00`3oo`03o`040?l000Co00<0ool01Ol0103o
o`0>o`030?oo00go0P0]o`030?oo00go000>o`030?oo02ko0P1@o`801_l00`3o0005o`800_l01@3o
ool000Ko00@0ool01?l00`3oo`04o`040?oo00go00<0ool04?l202_o00<0ool03Ol000ko00<0ool0
:ol305;o0P06o`030?l000Oo00<0o`000ol00`3oo`03o`800_l00`3oo`02o`030?oo00?o00D0oooo
000=o`030?oo01;o0`0Xo`030?oo00go000>o`030?oo02Wo0P1Eo`801Ol00`3o0009o`801?l01@3o
ool000;o00@0ool01?l01@3oool000Co00<0ool02_l00`3oo`0Fo`809_l00`3oo`0=o`003_l00`3o
o`0Vo`<0Eol200Go00<0o`002_l200?o00@0ool01?l00`3o0004o`040?oo00Go00<0ool02_l00`3o
o`0Ho`809?l00`3oo`0=o`001?l300Oo00<0ool09?l205[o0P05o`030?l000_o0P02o`030?l000Ko
00<0o`001?l00`3o0005o`030?oo00Wo00<0ool06ol201Oo0P09o`030?oo00go0004o`030?oo00Oo
00<0ool08Ol305co0P05o`030?l000Ko20000ol00007o`030?l000Co0P06o`030?oo00So00<0ool0
7_l201Go00<0o`002?l00`3oo`0=o`001Ol00`3oo`06o`030?oo01oo0P1Oo`801Ol00`3o0008o`04
0?oo00;o0`08o`030?l000?o0P06o`030?oo00So00<0ool08?l301;o00<0o`002?l00`3oo`0=o`00
1Ol00`3oo`06o`030?oo01co0`1Qo`801Ol00`3o0008o`030?oo00<000?o00002Ol50004o`0000Co
00<0ool01ol00`3oo`0To`804?l200Wo00<0ool03Ol000Co00<0o`001ol00`3oo`0Jo`80I?l200Go
00<0o`002?l00`3o00040003o`0000Oo10000ol0o`0200Go00<0ool01ol00`3oo`0Vo`803_l00`3o
o`08o`030?oo00go0005o`030?oo00Ko00<0ool05ol306Ko0P05o`802Ol80004o`0000Go00<0o`00
0P03o`030?oo00?o00<0ool01_l00`3oo`0Yo`803Ol200So00<0ool03Ol000ko00<0ool05Ol206Wo
0P05o`802?l90005o`3oo`001Ol0103o0003o`801?l00`3oo`06o`030?oo02_o0P0Eo`030?oo00go
000>o`030?oo01;o0`1[o`801?l00`3o000:o`L000?o0?l00_l01P3oool0o`8000Ko0?l0o`04o`03
0?oo00Go00<0ool0;_l301;o00<0ool03Ol000ko00<0ool04?l206ko0P04o`030?l000_o1@02o`03
0?oo00;o0P02o`D00_l00`3o0003o`030?oo00Co00<0ool0<_l2013o00<0ool03Ol000ko00<0ool0
3_l2073o0P04o`030?l000co1003o`030?oo00?o00<0o`000ol200?o00D0oooo0006o`030?oo03Co
0P0>o`030?oo00go000>o`030?oo00_o0`1bo`801?l00`3o000@o`040?oo00Ko00<0ool00_l200Co
00D0oooo0004o`030?oo03Oo0P0<o`030?oo00go000>o`030?oo00Wo0P1eo`801?l00`3o000Ao`03
0?l000Go00@0o`000ol200?o00D0oooo0004o`030?oo03Wo0`09o`030?oo00go000>o`030?oo00Ko
0`1go`801?l00`3o000Ao`040?oo00Co00D0oooo0003o`800ol0103oo`03o`030?oo03go0P07o`03
0?oo00go000=o`<01Ol207[o0P04o`804ol00`3o0003o`030?oo00?o00D0oooo0003o`040?oo00;o
00<0ool0@?l200Co0`0>o`003?l50004o`0007co0P04o`805?l30003o`3o00Ko0P000ol00003o`03
0?l000;o00<0ool0@_l20003o`0000<03Ol000_o1`1oo`801?l201?o1@0:o`030?l000@000Co0?l0
Aol700co000;o`L0Ool200?o00<0o`004_l700[o2P17o`L03?l000_o1`1oo`800ol00`3o000Bo`T0
2?l:04Oo1`0<o`003?l707ko0P03o`030?l001;o1`02oa<0AOl700go000=o`<00ol207co00<0ool0
0_l00`3o000Co`D02ol;04?o0P03o`<03_l001Go0P1jo`030?oo00;o0P0Eo`<03Ol:047o0P0Fo`00
5ol207Oo0P04o`809Ol9043o0P0Ho`006Ol207Go0P04o`809?l00`3oo`03o`<0?ol201[o000Ko`80
Lol200Co0P0So`030?oo04Co0P0Lo`007Ol2077o0P03o`030?l002;o00<0ool0@ol201ko000Oo`80
Kol200?o00<0o`008_l00`3oo`11o`808?l0027o0P1]o`800ol00`3o000Qo`030?oo043o0P0Ro`00
8ol206_o0P03o`808Ol00`3oo`0oo`809?l002Go0P1Yo`800ol2023o00<0ool0?_l202Ko000Wo`80
Iol200?o0P0Po`030?oo03co0P0Xo`00:Ol206Go0P03o`807ol00`3oo`0ko`80:_l002_o0P1So`80
0ol201ko00<0ool0>_l202co000]o`80HOl200?o0P0Mo`030?oo03Wo0P0^o`00;ol205oo0P02o`03
0?l001go00<0ool0=ol2033o000ao`80GOl200;o0P0Mo`030?oo03Ko0P0bo`00<ol205_o0P02o`80
7?l00`3oo`0eo`80=?l003Go0P1Io`800_l201_o00<0ool0=?l203Ko000go`80Eol200;o0P0Ko`03
0?oo03;o0P0ho`00>Ol205Go0P02o`806_l00`3oo`0ao`80>_l003_o0P1Co`800_l201Wo00<0ool0
<?l203co000mo`80DOl200;o0P0Ho`030?oo02oo0P0no`00?ol204oo0P02o`805ol00`3oo`0^o`80
@?l0047o0P1=o`8000?o00006?l00`3oo`0/o`80@_l004?o0P1;o`8000?o00005ol00`3oo`0[o`80
A?l004Go0P19o`030?oo00805_l00`3oo`0Zo`80A_l004Oo0P17o`030?oo00805Ol00`3oo`0Yo`80
B?l004Wo0P15o`030?oo00805Ol00`3oo`0Wo`80B_l004_o0P13o`030?oo00805?l00`3oo`0Vo`80
C?l004go0P11o`030?oo00804ol00`3oo`0Uo`80C_l004oo0P0oo`040?oo01?o00<0ool09?l2053o
001Ao`80?Ol0103oo`0Co`030?oo02;o0P1Bo`00Dol203_o00@0o`004_l00`3oo`0Qo`80E?l005Go
0P0io`040?l0017o00<0ool08?l205Ko001Go`80=ol0103o000@o`030?oo01oo0P1Ho`00FOl203Go
00@0o`004?l00`3oo`0Mo`80F_l005_o0P0co`040?l000oo00<0ool07?l205co001Mo`80<Ol00`3o
000?o`030?oo01_o0P1No`00Gol202oo00<0o`003_l00`3oo`0Jo`80H?l0067o0P0]o`030?l000ko
00<0ool06?l206;o001So`80:ol00`3o000=o`030?oo01Oo0P1To`00IOl202Wo0`0<o`030?oo01Ko
0P1Vo`00Iol202Ko100;o`030?oo01Go0P1Xo`00JOl202Co100:o`030?oo01Co0P1Zo`00Jol202;o
0`0;o`030?oo01;o0P1/o`00KOl2023o0`0:o`030?oo017o0P1^o`00Kol201ko0`09o`030?oo013o
0P1`o`00LOl2017o1@06o`<02?l00`3oo`0?o`80L_l007?o0P0Ao`030?oo00Ko0`08o`030?oo00go
0P1do`00MOl200oo00<0ool01_l300Oo00<0ool03?l207Ko001go`803Ol00`3oo`06o`<01_l00`3o
o`0;o`80N?l007Wo0P0;o`030?oo00Ko0`05o`030?oo00[o0P1jo`00Nol200So0P08o`801_l00`3o
o`08o`80O?l007go0P0@o`801Ol00`3oo`07o`80O_l007oo0P0>o`801?l00`3oo`06o`80P?l0087o
0P0<o`800ol00`3oo`05o`80P_l008?o0P0:o`800ol00`3oo`03o`80Q?l008Go0P08o`800_l00`3o
o`02o`80Q_l008Oo0P06o`8000?o0?l00_l208So0029o`801?l00`3o0002o`80R_l008_o0P000ol0
000408co002=o`D0S_l008co1`2=o`00S?l708go002<o`L0SOl008go1@2>o`00S_l308oo003oob7o
003oob7o003oob7o003oob7o003oob7o003oob7o003oob7o003oob7o003oob7o0000\
\>"],
    ImageRangeCache->{{{0, 287}, {287, 0}} -> {0, 0, 0, 0}}],
  "\n\:3000\:4e0a\:306b\:8868\:793a\:3055\:308c\:56f3\:3067\:306f\:3001\:8fba\
\:3068\:8fba\:304c\:9802\:70b9\:4ee5\:5916\:3067\:4ea4\:5dee\:3057\:3066\:3044\
\:308b\:306e\:3067\:6b63\:3057\:3044\:5e73\:9762\:30b0\:30e9\:30d5\:306e\:8868\
\:793a\:3067\:306f\:306a\:3044\:3002\n\:3000\:3057\:304b\:3057\:3001\:3053\
\:306e\:63cf\:753b\:306e\:65b9\:6cd5\:306f\:3001\:5e73\:9762\:7684\:30b0\:30e9\
\:30d5\:306e\:5916\:5468\:8def\:304c\:3042\:3089\:304b\:3058\:3081\:89e3\:3063\
\:3066\:3044\:306a\:3044\:3068\:304d\:306b\:3001\:5e73\:9762\:7684\:30b0\:30e9\
\:30d5\:3092\:5e73\:9762\:4e0a\:306b\:63cf\:753b\:3067\:304d\:308b\:5229\:70b9\
\:304c\:3042\:308b\:3002\:305d\:3053\:3067\:3001\:ff11\:3064\:306e\:95a2\:6570\
\:3068\:3057\:3066\:307e\:3068\:3081\:308b\:3068\:3001\:6b21\:306e\:3088\:3046\
\:306b\:66f8\:3051\:308b\:3002\n\
pseudoplanegraph[mm_,cyl_]:=Block[{g,vtx,len},\n\t\tlen=Length[mm];\n\t\t\
If[len==Length[cyl],\n\t\t\t\
vtx=circluarvertices[len],vtx=getvertices[mm,cyl]];\n\t\t\
g=ChangeVertices[EmptyGraph[len], vtx];\n\t\tReturn[ChangeEdges[g,mm]]\n]\n\
ShowLabeledGraph[pseudoplanegraph[mm,{1,2,3}]]\n",
  Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: 1 
MathPictureStart
/Mabs {
Mgmatrix idtransform
Mtmatrix dtransform
} bind def
/Mabsadd { Mabs
3 -1 roll add
3 1 roll add
exch } bind def
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
0.0486285 0.97257 -0.1617 1.10638 [
[ 0 0 0 0 ]
[ 1 1 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 0 m
1 0 L
1 1 L
0 1 L
closepath
clip
newpath
0 g
.025 w
.5 .94468 Mdot
.04863 .05532 Mdot
.95137 .05532 Mdot
.82265 .30639 Mdot
.72418 .49901 Mdot
.62677 .69234 Mdot
.54428 .38086 Mdot
.67713 .46811 Mdot
.71288 .49159 Mdot
.72301 .49824 Mdot
.79241 .36483 Mdot
.74082 .46519 Mdot
.72369 .49869 Mdot
.70675 .53231 Mdot
.65614 .63332 Mdot
.5 Mabswid
.5 .94468 m
.04863 .05532 L
s
.5 .94468 m
.62677 .69234 L
s
.5 .94468 m
.54428 .38086 L
s
.5 .94468 m
.67713 .46811 L
s
.5 .94468 m
.71288 .49159 L
s
.5 .94468 m
.72301 .49824 L
s
.5 .94468 m
.65614 .63332 L
s
.04863 .05532 m
.5 .94468 L
s
.04863 .05532 m
.95137 .05532 L
s
.04863 .05532 m
.54428 .38086 L
s
.95137 .05532 m
.04863 .05532 L
s
.95137 .05532 m
.82265 .30639 L
s
.95137 .05532 m
.54428 .38086 L
s
.95137 .05532 m
.67713 .46811 L
s
.95137 .05532 m
.71288 .49159 L
s
.95137 .05532 m
.72301 .49824 L
s
.95137 .05532 m
.79241 .36483 L
s
.82265 .30639 m
.95137 .05532 L
s
.82265 .30639 m
.72418 .49901 L
s
.82265 .30639 m
.79241 .36483 L
s
.72418 .49901 m
.82265 .30639 L
s
.72418 .49901 m
.62677 .69234 L
s
.72418 .49901 m
.79241 .36483 L
s
.72418 .49901 m
.74082 .46519 L
s
.72418 .49901 m
.72369 .49869 L
s
.72418 .49901 m
.70675 .53231 L
s
.72418 .49901 m
.65614 .63332 L
s
.62677 .69234 m
.5 .94468 L
s
.62677 .69234 m
.72418 .49901 L
s
.62677 .69234 m
.65614 .63332 L
s
.54428 .38086 m
.5 .94468 L
s
.54428 .38086 m
.04863 .05532 L
s
.54428 .38086 m
.95137 .05532 L
s
.54428 .38086 m
.67713 .46811 L
s
.67713 .46811 m
.5 .94468 L
s
.67713 .46811 m
.95137 .05532 L
s
.67713 .46811 m
.54428 .38086 L
s
.67713 .46811 m
.71288 .49159 L
s
.71288 .49159 m
.5 .94468 L
s
.71288 .49159 m
.95137 .05532 L
s
.71288 .49159 m
.67713 .46811 L
s
.71288 .49159 m
.72301 .49824 L
s
.72301 .49824 m
.5 .94468 L
s
.72301 .49824 m
.95137 .05532 L
s
.72301 .49824 m
.71288 .49159 L
s
.72301 .49824 m
.79241 .36483 L
s
.72301 .49824 m
.74082 .46519 L
s
.72301 .49824 m
.72369 .49869 L
s
.72301 .49824 m
.70675 .53231 L
s
.72301 .49824 m
.65614 .63332 L
s
.79241 .36483 m
.95137 .05532 L
s
.79241 .36483 m
.82265 .30639 L
s
.79241 .36483 m
.72418 .49901 L
s
.79241 .36483 m
.72301 .49824 L
s
.79241 .36483 m
.74082 .46519 L
s
.74082 .46519 m
.72418 .49901 L
s
.74082 .46519 m
.72301 .49824 L
s
.74082 .46519 m
.79241 .36483 L
s
.74082 .46519 m
.72369 .49869 L
s
.72369 .49869 m
.72418 .49901 L
s
.72369 .49869 m
.72301 .49824 L
s
.72369 .49869 m
.74082 .46519 L
s
.72369 .49869 m
.70675 .53231 L
s
.70675 .53231 m
.72418 .49901 L
s
.70675 .53231 m
.72301 .49824 L
s
.70675 .53231 m
.72369 .49869 L
s
.70675 .53231 m
.65614 .63332 L
s
.65614 .63332 m
.5 .94468 L
s
.65614 .63332 m
.72418 .49901 L
s
.65614 .63332 m
.62677 .69234 L
s
.65614 .63332 m
.72301 .49824 L
s
.65614 .63332 m
.70675 .53231 L
s
.5 .94468 m
.04863 .05532 L
s
.5 .94468 m
.62677 .69234 L
s
.5 .94468 m
.54428 .38086 L
s
.5 .94468 m
.67713 .46811 L
s
.5 .94468 m
.71288 .49159 L
s
.5 .94468 m
.72301 .49824 L
s
.5 .94468 m
.65614 .63332 L
s
.04863 .05532 m
.5 .94468 L
s
.04863 .05532 m
.95137 .05532 L
s
.04863 .05532 m
.54428 .38086 L
s
.95137 .05532 m
.04863 .05532 L
s
.95137 .05532 m
.82265 .30639 L
s
.95137 .05532 m
.54428 .38086 L
s
.95137 .05532 m
.67713 .46811 L
s
.95137 .05532 m
.71288 .49159 L
s
.95137 .05532 m
.72301 .49824 L
s
.95137 .05532 m
.79241 .36483 L
s
.82265 .30639 m
.95137 .05532 L
s
.82265 .30639 m
.72418 .49901 L
s
.82265 .30639 m
.79241 .36483 L
s
.72418 .49901 m
.82265 .30639 L
s
.72418 .49901 m
.62677 .69234 L
s
.72418 .49901 m
.79241 .36483 L
s
.72418 .49901 m
.74082 .46519 L
s
.72418 .49901 m
.72369 .49869 L
s
.72418 .49901 m
.70675 .53231 L
s
.72418 .49901 m
.65614 .63332 L
s
.62677 .69234 m
.5 .94468 L
s
.62677 .69234 m
.72418 .49901 L
s
.62677 .69234 m
.65614 .63332 L
s
.54428 .38086 m
.5 .94468 L
s
.54428 .38086 m
.04863 .05532 L
s
.54428 .38086 m
.95137 .05532 L
s
.54428 .38086 m
.67713 .46811 L
s
.67713 .46811 m
.5 .94468 L
s
.67713 .46811 m
.95137 .05532 L
s
.67713 .46811 m
.54428 .38086 L
s
.67713 .46811 m
.71288 .49159 L
s
.71288 .49159 m
.5 .94468 L
s
.71288 .49159 m
.95137 .05532 L
s
.71288 .49159 m
.67713 .46811 L
s
.71288 .49159 m
.72301 .49824 L
s
.72301 .49824 m
.5 .94468 L
s
.72301 .49824 m
.95137 .05532 L
s
.72301 .49824 m
.71288 .49159 L
s
.72301 .49824 m
.79241 .36483 L
s
.72301 .49824 m
.74082 .46519 L
s
.72301 .49824 m
.72369 .49869 L
s
.72301 .49824 m
.70675 .53231 L
s
.72301 .49824 m
.65614 .63332 L
s
.79241 .36483 m
.95137 .05532 L
s
.79241 .36483 m
.82265 .30639 L
s
.79241 .36483 m
.72418 .49901 L
s
.79241 .36483 m
.72301 .49824 L
s
.79241 .36483 m
.74082 .46519 L
s
.74082 .46519 m
.72418 .49901 L
s
.74082 .46519 m
.72301 .49824 L
s
.74082 .46519 m
.79241 .36483 L
s
.74082 .46519 m
.72369 .49869 L
s
.72369 .49869 m
.72418 .49901 L
s
.72369 .49869 m
.72301 .49824 L
s
.72369 .49869 m
.74082 .46519 L
s
.72369 .49869 m
.70675 .53231 L
s
.70675 .53231 m
.72418 .49901 L
s
.70675 .53231 m
.72301 .49824 L
s
.70675 .53231 m
.72369 .49869 L
s
.70675 .53231 m
.65614 .63332 L
s
.65614 .63332 m
.5 .94468 L
s
.65614 .63332 m
.72418 .49901 L
s
.65614 .63332 m
.62677 .69234 L
s
.65614 .63332 m
.72301 .49824 L
s
.65614 .63332 m
.70675 .53231 L
s
[(1)] .47082 .91149 0 1 Mshowa
[(2)] .01945 .02213 0 1 Mshowa
[(3)] .92219 .02213 0 1 Mshowa
[(4)] .79347 .27319 0 1 Mshowa
[(5)] .695 .46582 0 1 Mshowa
[(6)] .5976 .65914 0 1 Mshowa
[(7)] .51511 .34767 0 1 Mshowa
[(8)] .64796 .43492 0 1 Mshowa
[(9)] .6837 .4584 0 1 Mshowa
[(10)] .69383 .46505 0 1 Mshowa
[(11)] .76323 .33164 0 1 Mshowa
[(12)] .71164 .432 0 1 Mshowa
[(13)] .69451 .4655 0 1 Mshowa
[(14)] .67758 .49912 0 1 Mshowa
[(15)] .62696 .60012 0 1 Mshowa
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
    ImageSize->{288, 288},
    ImageMargins->{{43, 0}, {0, 2}},
    ImageRegion->{{0, 1}, {0, 1}},
    ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`40004P000180P10`40000100000800002008200000
P800P020P<30`<3L`:K:l:C8l3<006H009T00<`0000c03<c06Hc09Tc0<`c0?lc001V03=V06IV09UV
0<aV0?mV002I03>I06JI09VI0<bI0?nI003<03?<06K<09W<0<c<0?o<03?o06Ko09Wo0<co0000<c<0
<fH0<iT0<l`0<ol0<`0c<c<c<fHc<iTc<l`c<olc<`1V<c=V<fIV<iUV<laV<omV<`2I<c>I<fJI<iVI
<lbI<onI<`3<<c?<<fK<<iW<<lc<<oo<<`3o<c?o<fKo<iWo<lco<ooo<`00IS<0IVH0IYT0I/`0I_l0
IP0cIS<cIVHcIYTcI/`cI_lcIP1VIS=VIVIVIYUVI/aVI_mVIP2IIS>IIVJIIYVII/bII_nIIP3<IS?<
IVK<IYW<I/c<I_o<IP3oIS?oIVKoIYWoI/coI_ooIP00VC<0VFH0VIT0VL`0VOl0V@0cVC<cVFHcVITc
VL`cVOlcV@1VVC=VVFIVVIUVVLaVVOmVV@2IVC>IVFJIVIVIVLbIVOnIV@3<VC?<VFK<VIW<VLc<VOo<
V@3oVC?oVFKoVIWoVLcoVOooV@00c3<0c6H0c9T0c<`0c?l0c00cc3<cc6Hcc9Tcc<`cc?lcc01Vc3=V
c6IVc9UVc<aVc?mVc02Ic3>Ic6JIc9VIc<bIc?nIc03<c3?<c6K<c9W<c<c<c?o<c03oc3?oc6Koc9Wo
c<coc?ooc3<0ofH0oiT0ol`0o`0coc<cofHcoiTcol`coolco`1Voc=VofIVoiUVolaVoomVo`2Ioc>I
ofJIoiVIolbIoonIo`3<oc?<ofK<oiW<olc<ooo<oc?oofKooiWoolcoo`410@820P<30`@410D51@H6
1PL71`P820T92@X:2P/;2``<30h>3Pl?3a0@414A4A8B4Q<C4a@D5000000000000000000000000000
00000?okl:2PY820P?l0003o0?oo0000ool0o`3oooooo`Co00<0ool0ool3o`030?oo01Co0005o`03
0?oo0?oo0Ol00`3oo`0Eo`001Ol00`3oo`3oo`;o00<0ool05?l000Co00<0o`00ool1o`030?l001Ko
0005o`030?oo0?oo0Ol00`3oo`0Eo`00oolQo`00oolQo`00oolQo`00oolQo`00oolQo`00oolQo`00
oolQo`00oolQo`003?l30?oo0Ol300ko000;o`D0o_l500go000:o`L0o?l700co000:ool02`0<o`00
2_l70?co1`0<o`002ol60?go1@0=o`003?l40003o`000?[o00<0o`000P0>o`003ol01@3oool00?So
00@0o`004?l0013o00@0oooo0P3eo`040?oo017o000@o`030?oo00?o00<0ool0l?l200;o0P0Ao`00
4Ol00`3oo`03o`80kol0103oool201;o000Ao`030?oo00Go00<0ool0jol00`3oo`02o`804_l001;o
00<0ool01Ol20>[o00<0ool00_l201?o000Bo`030?oo00Oo00<0ool0iOl200Co00<0o`004ol001?o
00<0ool01ol20>Co00<0ool01?l201Co000Co`030?oo00Wo0P3Qo`030?oo00Co0`0Do`005?l00`3o
o`0:o`030?oo0=go00<0ool01?l00`3o000Eo`005?l00`3oo`0;o`80fol200Oo0`0Eo`005Ol00`3o
o`0<o`030?oo0=Oo00<0ool01_l00`3o000Fo`005Ol00`3oo`0=o`80e_l00`3oo`06o`040?l001Ko
000Fo`030?oo00ko00<0ool0d_l00`3oo`07o`030?l001Oo000Fo`030?oo00oo0P3@o`802Ol0103o
000Go`005ol00`3oo`0@o`030?oo0<co00<0ool02?l0103oo`0Ho`005ol00`3oo`0Ao`80bol00`3o
o`09o`040?l001So000Ho`030?oo01;o00<0ool0aol00`3oo`09o`040?l001Wo000Ho`030?oo01?o
0P35o`802ol00`3oo`0201Wo000Io`030?oo01Co00<0ool0`Ol00`3oo`0;o`040?l001[o000Io`03
0?oo01Go0P30o`030?oo00_o00<0ool00P0Jo`006_l00`3oo`0Fo`030?oo0;co00<0ool02ol00`3o
o`0201_o000Jo`030?oo01Oo0P2ko`030?oo00co00<0ool00P0Ko`006ol00`3oo`0Ho`030?oo0;Ko
0P0>o`030?oo00807?l001_o00<0ool06Ol20;Go00<0ool03Ol0103oool201co000Lo`030?oo01[o
00<0ool0/Ol00`3oo`0>o`030?oo00807Ol001co00<0ool06ol20;3o00<0ool03_l0103oool201go
000Mo`030?oo01co00<0ool0Zol2013o00@0oooo0P0No`007Ol00`3oo`0Mo`80Z_l00`3oo`0@o`03
0?oo00<07_l001ko00<0ool07_l00`3oo`2Vo`030?oo013o00@0oooo0P0Oo`007_l00`3oo`0Oo`80
YOl00`3oo`0@o`040?ooo`<07ol001oo00<0ool08?l20:7o0P0Co`040?ooo`808?l001oo00<0ool0
8_l00`3oo`2Mo`030?oo01;o00@0oooo0P0Qo`008?l00`3oo`0Ro`80W?l00`3oo`0Bo`030?oo00;o
0P0Qo`008?l00`3oo`0To`030?oo09So00<0ool04ol0103oool202;o000Qo`030?oo02Co0P2Fo`80
5Ol00`3oo`02o`808_l0027o00<0ool09_l00`3oo`2Bo`030?oo01Co00<0ool00_l202?o000Ro`03
0?oo02Ko0P2Ao`030?oo01Go00<0ool00_l202?o000Ro`030?oo02So00<0ool0SOl00`3oo`0Eo`03
0?oo00;o0P0To`008ol00`3oo`0Xo`80Rol201Oo00<0ool00_l00`3o000To`008ol00`3oo`0Zo`03
0?oo08Oo00<0ool05ol00`3oo`02o`809Ol002Co00<0ool0:_l208Ko00<0ool05ol00`3oo`02o`03
0?l002Go000To`030?oo02co00<0ool0P_l00`3oo`0Go`030?oo00?o0P0Vo`009Ol00`3oo`0/o`80
P?l201[o00<0ool00_l00`3o000Vo`009Ol00`3oo`0^o`030?oo07co00<0ool06Ol00`3oo`03o`80
9ol002Ko00<0ool0;_l207_o00<0ool06Ol00`3oo`03o`030?l002Oo000Vo`030?oo033o00<0ool0
Mol00`3oo`0Jo`030?oo00?o0P0Xo`009ol00`3oo`0`o`80MOl201co00<0ool00ol302So000Wo`03
0?oo03;o00<0ool0LOl00`3oo`0Ko`030?oo00Co0P0Yo`00:?l00`3oo`0bo`80L?l00`3oo`0Lo`03
0?oo00?o0`0Yo`00:?l00`3oo`0do`030?oo06co00<0ool07?l00`3oo`03o`030?l002[o000Yo`03
0?oo03Co0P1Zo`805Ol300Ko00<0ool01?l302[o000Yo`030?oo03Ko00<0ool0I_l00`3oo`0Fo`03
0?oo00Go00<0ool00ol00`3o000[o`00:_l00`3oo`0fo`80IOl00`3oo`0Eo`@01Ol00`3oo`04o`<0
:ol002[o00<0ool0>?l00`3oo`1Qo`030?oo01Ko00<0o`001Ol00`3oo`04o`030?l002co000[o`03
0?oo03So0P1Oo`806_l200Go00<0ool01?l302co000[o`030?oo03[o0P1Lo`030?oo01_o00<0ool0
0_l00`3oo`04o`030?l002go000/o`030?oo03_o00<0ool0F?l00`3oo`0Qo`030?oo00Co0`0]o`00
;?l00`3oo`0lo`80Eol00`3oo`0Qo`030?oo00Co00<0o`00;_l002go00<0ool0?Ol00`3oo`1Bo`80
8ol00`3oo`04o`040?l002ko000]o`030?oo03ko0P1Ao`030?oo02?o00<0ool01?l00`3o000_o`00
;_l00`3oo`0oo`030?oo04go00<0ool08ol00`3oo`04o`040?l002oo000_o`030?oo03oo0P1<o`03
0?oo02?o00<0ool01Ol00`3o000`o`00;ol00`3oo`11o`030?oo04Oo0P0Vo`030?oo00Co00@0o`00
<?l0033o00<0ool0@Ol204Ko00<0ool09Ol00`3oo`05o`030?l0037o000`o`030?oo04?o00<0ool0
@_l00`3oo`0Uo`030?oo00Go100ao`00<Ol00`3oo`13o`80@Ol00`3oo`0Vo`030?oo00Co1@0ao`00
<Ol00`3oo`15o`030?oo03go00<0ool09_l00`3oo`04o`L0<?l003;o00<0ool0AOl203_o0P0Mo`X0
00?o0?l01_l7033o000bo`030?oo04Oo00<0ool0=ol00`3oo`0Oo`030?oo00;o00D0oooo0007o`L0
<?l003?o00<0ool0Aol203Ko00<0ool08?l00`3oo`02o`040?oo00Oo00<0o`00100ao`00<ol00`3o
o`19o`030?oo03;o00<0ool08Ol00`3oo`02o`030?l000So00<0o`000`0bo`00=?l00`3oo`19o`80
4Ol00`3oo`0Lo`809?l00`3oo`02o`030?l000Oo00@0ool0=Ol003Co00<0ool0Bol00`3oo`0>o`03
0?oo01_o00<0ool08ol200?o0`08o`030?l003Ko000eo`030?oo04_o0P0>o`030?oo01[o00<0ool0
:_l00`3oo`06o`040?l003Ko000eo`030?oo04go00<0ool03?l00`3oo`0Ho`030?oo02_o00<0ool0
1_l00`3o000go`00=_l00`3oo`1=o`802_l00`3o000Ho`80;Ol00`3oo`06o`040?l003Oo000fo`03
0?oo04oo00<0ool01ol301Oo00<0ool0;?l00`3oo`07o`030?l003So000go`030?oo04oo0P0Po`03
0?oo02go00<0ool01_l0103o000ho`00=ol00`3oo`1Ao`807Ol00`3oo`0]o`030?oo00Oo00<0o`00
>Ol003So00<0ool0D_l00`3oo`0Ho`80;ol00`3oo`07o`040?l003Wo000ho`030?oo05?o0P0Go`03
0?oo02oo00<0ool01_l0103oo`0jo`00>Ol00`3oo`1Do`030?oo01?o00<0ool0;ol00`3oo`07o`@0
>_l003Wo00<0ool0EOl201;o00<0ool0;ol00`3oo`07o`D0>_l003[o00<0ool0E_l00`3oo`0=o`80
<_l00`3oo`06o`L0>Ol003[o00<0ool0Eol200co00<0ool0<Ol00`3oo`07o`L0>Ol003_o00<0ool0
F?l00`3oo`08o`030?oo037o00<0ool02?l703Wo000ko`030?oo05Wo0P02o`<00_l00`3oo`0bo`03
0?oo00Oo00<0o`00100jo`00??l00`3oo`1Jo`L0=?l00`3oo`08o`030?l000<0>ol003co00<0ool0
F_l703?o00<0ool02?l0103oo`0no`00?Ol00`3oo`1Io`L0<ol00`3oo`08o`040?l003ko000mo`03
0?oo05Wo1`0bo`030?oo00So00@0ool0?ol003ko00<0ool0FOl6037o00<0ool02?l00`3oo`0203oo
000no`030?oo05[o0`02o`80;ol00`3oo`08o`040?oo043o000oo`030?oo05[o00<0ool00ol00`3o
o`0[o`030?oo00So00<0ool00P10o`00?ol00`3oo`1Jo`030?oo00Co0P0Zo`030?oo00Wo00@0ool0
@Ol0043o00<0ool0FOl00`3oo`06o`030?oo01oo1@001?l0000:o`040?oo04;o0010o`030?oo05So
00<0ool02?l2017o00<0ool03Ol0103oool200_o00@0ool0@_l0047o00<0ool0Eol00`3oo`0:o`03
0?oo00go00<0o`003_l0103oool200[o00@0ool0@ol0047o00<0ool0Eol00`3oo`0;o`803Ol00`3o
000>o`040?ooo`802_l0103o0013o`00@_l00`3oo`1Fo`030?oo00go00<0ool02ol00`3oo`0=o`03
0?oo008000?o0?l01ol0103oo`14o`00@_l00`3oo`1Fo`030?oo00ko0P0:o`030?l000go0P001Ol0
ool000So00<0ool00P14o`00@ol00`3oo`1Eo`030?oo013o00<0ool02?l00`3oo`0?o`030?oo00Wo
00@0ool0AOl004?o00<0ool0EOl00`3oo`0Ao`806Ol00`3oo`09o`030?oo0080AOl004Co00<0ool0
E?l00`3oo`0Co`803ol200Go00<0ool02_l0103oo`16o`00A?l00`3oo`1Do`030?oo01Go00<0ool0
3_l00`3oo`02o`030?oo00Wo00<0ool00P16o`00AOl00`3oo`1Co`030?oo01Ko0P0<o`D000?o0000
2ol0103oo`17o`00AOl00`3oo`1Co`030?oo01So00<0ool02Ol01@3o003o008000?o0?l02?l00`3o
o`0204Oo0016o`030?oo05;o00<0ool06Ol200Wo00<0o`000_l400Wo00@0ool0B?l004Ko00<0ool0
DOl00`3oo`0Lo`030?oo00Oo10001?l0o`08o`030?oo0080B?l004Oo00<0ool0D?l00`3oo`0Mo`80
2?l200;o00<0o`002?l0103oo`19o`00Aol00`3oo`1@o`030?oo01oo00<0ool01?l50003o`3o00Oo
1@19o`00B?l00`3oo`1?o`030?oo023o0P02o`@03?l604Wo0018o`030?oo04oo00<0ool08_l600co
1`18o`00BOl00`3oo`1>o`030?oo02;o1`0:o`P0B?l004Wo00<0ool0C_l00`3oo`0Ro`L02_l804So
001:o`030?oo04go00<0ool08?l:00So00<0ool01@19o`00B_l00`3oo`1=o`030?oo02;o1`09o`03
0?oo00@0B_l004_o00<0ool0C?l00`3oo`0Ro`030?l000D01ol01@3oool004go001;o`030?oo04co
00<0ool08_l0203o0?l0o`3o0P02o`@00_l204go001<o`030?oo04_o00<0ool08_l200?o0P03o`H0
0_l00`3oo`1<o`00C?l00`3oo`1;o`030?oo027o0`04o`040?ooo`T0C_l004go00<0ool0BOl00`3o
o`0So`030?oo00Oo2@1>o`00COl00`3oo`19o`030?oo02?o00<0ool01ol:04go001>o`030?oo04So
00<0ool08ol00`3oo`08o`T0COl004oo00<0ool0Aol00`3oo`0Ro`030?oo00[o201=o`00Col00`3o
o`17o`030?oo02;o00<0ool02Ol00`3oo`0504ko001@o`030?oo04Ko00<0ool08_l00`3oo`09o`03
0?oo00@0Col0053o00<0ool0A_l00`3oo`0Qo`030?oo00Wo00<0ool00P1Bo`00DOl00`3oo`15o`03
0?oo027o00<0ool02Ol0103oo`1Co`00DOl00`3oo`15o`030?oo023o00<0ool02Ol505?o001Bo`03
0?oo04Co00<0ool08?l00`3oo`09o`D0Dol005;o00<0ool0A?l00`3oo`0Po`030?oo00So1`1Bo`00
Dol00`3oo`13o`030?oo01oo00<0ool02Ol705;o001Co`030?oo04;o00<0ool08?l00`3oo`08o`P0
D_l005Co00<0ool0@Ol00`3oo`0Po`030?oo00So00<0o`00101Co`00E?l00`3oo`11o`030?oo01oo
00<0ool02?l0103oool305Co001Eo`030?oo043o00<0ool07ol00`3oo`08o`040?oo05Oo001Eo`03
0?oo043o00<0ool07_l00`3oo`08o`050?ooo`00Eol005Ko00<0ool0?ol00`3oo`0No`030?oo00So
00@0ool0F?l005Ko00<0ool0?ol00`3oo`0No`030?oo00So00@0ool0F?l005Oo00<0ool0?_l00`3o
o`0Mo`030?oo00So00@0ool0FOl005Oo00<0ool0?_l00`3oo`0Mo`030?oo00So00@0ool0FOl005So
00<0ool0?Ol00`3oo`0Mo`030?oo00Oo00@0ool0F_l005So00<0ool0?Ol00`3oo`0Lo`030?oo00So
00@0ool0F_l005Wo00<0ool0??l00`3oo`0Co`D00_l00`3o0009o`040?oo05_o001Io`030?oo03co
00<0ool05Ol01`3oool0o`002_l0103oo`1Ko`00F_l00`3oo`0jo`030?oo01Ko00<0ool00ol00`3o
o`07o`040?oo05co001Jo`030?oo03[o00<0ool05_l0103oool300Wo00@0ool0G?l005_o00<0ool0
>Ol00`3oo`0Fo`040?ooo`802Ol0103oo`1Mo`00Fol00`3oo`0io`030?oo01Go0P03o`<02?l0103o
o`1Mo`00G?l00`3oo`0ho`030?oo01_o00<0ool01_l0103oo`1No`00G?l00`3oo`0ho`030?oo01[o
00<0ool01ol0103oo`1No`00GOl00`3oo`0go`030?oo01[o00<0ool01_l0103oo`1Oo`00GOl00`3o
o`0go`030?oo01Wo00<0ool01ol0103oo`1Oo`00G_l00`3oo`0fo`030?oo01Wo00<0ool01ol00`3o
001Po`00G_l00`3oo`0fo`030?oo01Wo00<0ool01_l0103oo`1Po`00Gol00`3oo`0eo`030?oo01So
00<0ool01ol00`3o001Qo`00Gol00`3oo`0eo`030?oo01So00<0ool01_l0103oo`1Qo`00H?l00`3o
o`0co`030?oo01Wo00<0ool01_l306;o001Po`030?oo03?o00<0ool06?l00`3oo`06o`D0HOl0067o
00<0ool0<_l00`3oo`0Ho`030?oo00Go1`1Po`00HOl00`3oo`0bo`030?oo017o0P05o`030?oo00Go
1`1Po`00H_l00`3oo`0ao`030?oo017o00<0o`000ol00`3oo`06o`L0H?l006;o00<0ool0<Ol00`3o
o`0Ao`030?l000?o00<0ool01Ol00`3o0004067o001So`030?oo033o00<0ool04Ol200?o00<0ool0
1_l00`3o000306;o001So`030?oo033o00<0ool04Ol00`3oo`02o`030?oo00Go00@0ool0IOl006Co
00<0ool0;ol00`3oo`0Bo`800_l00`3oo`05o`030?l006Ko001To`030?oo02oo00<0ool05Ol00`3o
o`05o`040?oo06Ko001Uo`030?oo02ko00<0ool05Ol00`3oo`05o`030?l006Oo001Uo`030?oo02ko
00<0ool05Ol00`3oo`04o`040?oo06Oo001Vo`030?oo02co00<0ool05Ol00`3oo`05o`030?l006So
001Vo`030?oo02co00<0ool05Ol00`3oo`05o`030?l006So001Wo`030?oo02_o00<0ool05?l00`3o
o`05o`030?l006Wo001Wo`030?oo02_o00<0ool05?l00`3oo`05o`030?l006Wo001Xo`030?oo02[o
00<0ool05?l00`3oo`04o`030?l006[o001Xo`030?oo02[o00<0ool04ol00`3oo`04o`@0J_l006Wo
00<0ool0:Ol00`3oo`0Co`030?oo00?o1@1Zo`00JOl00`3oo`0Yo`030?oo01?o00<0ool00_l706Wo
001Zo`030?oo02So00<0ool04_l00`3oo`03o`L0JOl006[o00<0ool0:?l00`3oo`0Bo`030?oo00?o
1`1Yo`00Jol00`3oo`0Wo`030?oo017o00<0ool01?l606[o001[o`030?oo02Oo00<0ool04Ol00`3o
o`04o`030?l00080Jol006co00<0ool09_l00`3oo`0Ao`030?oo00?o00<0o`00K_l006co00<0ool0
9Ol00`3oo`0Ao`030?oo00Co00<0o`00K_l006go00<0ool09?l00`3oo`0Ao`030?oo00?o00<0o`00
Kol006go00<0ool09?l00`3oo`0Ao`030?oo00?o00<0o`00Kol006ko00<0ool08ol00`3oo`0@o`03
0?oo00?o00<0o`00L?l006ko00<0ool08ol00`3oo`0@o`030?oo00?o00<0o`00L?l006oo00<0ool0
8_l00`3oo`0?o`030?oo00Co0P1ao`00L?l00`3oo`0Qo`030?oo00oo00<0ool00ol00`3o001ao`00
L?l00`3oo`0Qo`030?oo00oo00<0ool00ol207;o001ao`030?oo023o00<0ool03_l00`3oo`03o`03
0?l007;o001ao`030?oo023o00<0ool03_l00`3oo`03o`80Lol007;o00<0ool07ol00`3oo`0>o`03
0?oo00;o00<0o`00Lol007;o00<0ool07ol00`3oo`0=o`030?oo00?o0P1do`00Lol00`3oo`0Mo`03
0?oo00ko00<0ool00_l00`3o001do`00Lol00`3oo`0Mo`030?oo00go00<0ool00ol207Go001do`03
0?oo01co00<0ool03Ol00`3oo`02o`030?l007Go001do`030?oo01co00<0ool03Ol00`3oo`02o`80
M_l007Go00<0ool06ol00`3oo`0<o`030?oo00;o00<0o`00M_l007Go00<0ool06ol00`3oo`0<o`03
0?oo00;o0P1go`00M_l00`3oo`0Jo`030?oo00co00L0oooo0?l007Oo001fo`030?oo01[o00<0ool0
2ol00`3oo`02o`80N?l007Oo00<0ool06Ol00`3oo`0;o`030?oo00;o0P1ho`00Mol00`3oo`0Io`03
0?oo00[o00<0ool00_l207Wo001ho`030?oo01So00<0ool02_l00`3oo`02o`80NOl007So00<0ool0
6?l00`3oo`0:o`040?ooo`80N_l007Wo00<0ool05ol00`3oo`09o`030?oo00;o0P1jo`00NOl00`3o
o`0Fo`030?oo00[o00@0oooo0P1ko`00N_l00`3oo`0Eo`030?oo00[o00@0oooo0P1ko`00N_l00`3o
o`0Eo`030?oo00Wo00@0oooo0P1lo`00Nol00`3oo`0Do`030?oo00Wo00@0oooo0P1lo`00Nol00`3o
o`0Do`030?oo00Wo00<0ool00P1mo`00O?l00`3oo`0Co`030?oo00So00@0oooo0P1mo`00O?l00`3o
o`0Co`030?oo00So00<0ool00P1no`00OOl00`3oo`0Bo`030?oo00Oo00@0oooo0P1no`00OOl00`3o
o`0Bo`030?oo00Oo00<0ool00P1oo`00O_l00`3oo`0Ao`030?oo00Oo00<0ool00P1oo`00O_l00`3o
o`0Ao`030?oo00Ko00<0ool00P20o`00Ool00`3oo`0@o`030?oo00Ko00<0ool00P20o`00Ool00`3o
o`0?o`030?oo00Oo00@0ool0POl0083o00<0ool03_l00`3oo`06o`030?oo0080POl0083o00<0ool0
3_l00`3oo`06o`040?oo08;o0021o`030?oo00go00<0ool01Ol00`3oo`0208;o0021o`030?oo00go
00<0ool01Ol0103oo`23o`00P_l00`3oo`0<o`030?oo00Go00@0o`00Pol008;o00<0ool03?l00`3o
o`04o`040?oo08Co0023o`030?oo00_o00<0ool01?l0103o0024o`00Pol00`3oo`0;o`030?oo00Co
00<0o`00QOl008Co00<0ool02_l00`3oo`03o`040?l008Go0024o`030?oo00[o00<0ool00ol00`3o
0026o`00QOl00`3oo`09o`030?oo00;o00@0o`00Q_l008Go00<0ool02Ol00`3oo`02o`030?l008Oo
0024o`D01ol00`3oo`03o`<0Qol008Ko00<0ool01ol00`3oo`02o`030?l008So0026o`802?l00`3o
o`02o`030?l008So0026o`802?l00`3oo`02o`80ROl008Ko00<0o`001ol01`3oool0o`00ROl008Go
0P000ol0o`06o`040?ooo`80R_l008Wo00<0ool01?l01P3oo`3o08[o0029o`030?oo00Co00<0ool0
0P2;o`00R_l00`3oo`03o`030?oo0080Rol008[o00<0ool00ol0103o002<o`00Rol00`3oo`02o`04
0?l008co002;o`030?oo00;o00<0o`00SOl008co00D0ool0o`0208go002<o`060?oo0?l0S_l008go
00<0o`000P2>o`00SOl408oo002=o`D0S_l008co1`2=o`00S?l708go002<o`L0SOl008go1@2>o`00
S_l308oo003oob7o003oob7o003oob7o003oob7o003oob7o003oob7o003oob7o003oob7o003oob7o
003oob7o003oob7o003oob7o0000\
\>"],
    ImageRangeCache->{{{0, 287}, {287, 0}} -> {0, 0, 0, 0}}],
  "\n\:3000\:3053\:306e\:5834\:5408\:306b\:306f\:3001\:63cf\:753b\:306e\:30d0\
\:30e9\:30f3\:30b9\:306f\:60aa\:3044\:304c\:5e73\:9762\:30b0\:30e9\:30d5\:306e\
\:6b63\:3057\:3044\:8868\:793a\:3068\:306a\:3063\:3066\:3044\:308b\:3002\:5e73\
\:9762\:30b0\:30e9\:30d5\:3092\:6b63\:3057\:304f\[CloseCurlyDoubleQuote]\:30d0\
\:30e9\:30f3\:30b9\:3088\:304f\[CloseCurlyDoubleQuote]\:63cf\:753b\:3059\:308b\
\:306b\:306f\:3001\[CloseCurlyDoubleQuote]\:96a3\:63a5\:5ea6\
\[CloseCurlyDoubleQuote]\:3092\:3046\:307e\:304f\:8abf\:7bc0\:3059\:308b\:4e8b\
\:306b\:3088\:308a\:3001\:6539\:5584\:3059\:308b\:4e8b\:304c\:53ef\:80fd\:3067\
\:3042\:308b\:3002\:4f8b\:3048\:3070\:3001\:4e0a\:306e\:4f8b\:306b\:5bfe\:3057\
\:3066\:306f\:3001\:9802\:70b92\:306e\:65b9\:5411\:306b\:ff13\:89d2\:5f62\
\:306e\:5185\:90e8\:306e\:9802\:70b9\:3092\:5f15\:3063\:5f35\:308c\:3070\:3001\
\:3088\:308a\:30d0\:30e9\:30f3\:30b9\:306e\:3088\:3044\:56f3\:304c\:63cf\:3051\
\:308b\:3002\n     \:96a3\:63a5\:884c\:5217 mm \
\:3068\:30b5\:30a4\:30af\:30ebC\:3092\:4e0e\:3048\:305f\:3068\:304d\:3001\
\:5909\:63db\:884c\:5217 F = {",
  Cell[BoxData[
      \(TraditionalForm\`f\_ij\)]],
  "} \:3092\:3001\:6b21\:306e\:3088\:3046\:306b\:5b9a\:3081\:305f\:3002\n     \
                ",
  Cell[BoxData[
      \(TraditionalForm\`f\_ij\)]],
  " \:ff1d ",
  Cell[BoxData[
      FormBox[
        RowBox[{"(", GridBox[{
              {GridBox[{
                    {\(\[Delta]\_ij\), 
                      \((i = 1,  ... , \(| C | \), \ \ 
                        \(j \[LessEqual] \) | C | )\)},
                    {"0", 
                      \((i = | C | \(+1\),  ... , \(| mm | \), \ 
                        \(j \[LessEqual] \) | C | )\)}
                    }]},
              {GridBox[{
                    {\(a\_ij\/\(d(v\_i)\)\), 
                      \(\((i = 1,  ... , \(| mm | \), \ | C | \( < j\))\)\ 
                      \)}
                    }]}
              }]}], TraditionalForm]]],
  "\n \:3053\:308c\:3092\:3001\:ff4b\:756a\:76ee\:306e\:9802\:70b9\:306e\:96a3\
\:63a5\:5ea6 ",
  Cell[BoxData[
      \(TraditionalForm\`f\_ik\)]],
  "\:3092\:5b9f\:6570\:ff54\:3067\:3001\:6b21\:306e\:3088\:3046\:306b\:8abf\
\:6574\:3059\:308b\:3002\n                      ",
  Cell[BoxData[
      \(TraditionalForm\`f\_ij\)]],
  " \:ff1d ",
  Cell[BoxData[
      FormBox[
        RowBox[{"(", GridBox[{
              {GridBox[{
                    {\(\[Delta]\_ij\), 
                      \((i = 1,  ... , \(| C | \), \ \ 
                        \(j \[LessEqual] \) | C | )\)},
                    {"0", 
                      \((i = | C | \(+1\),  ... , \(| mm | \), \ 
                        \(j \[LessEqual] \) | C | )\)}
                    }]},
              {GridBox[{
                    {\(a\_ij\/\((td(v\_i) - 1)\)\), 
                      \((i = 1,  ... , \(| mm | \), \ | C | \( < j\), \ 
                        j \[NotEqual] k, \ a\_ij = 1)\)},
                    {\(\(\(d(v\_i)\) \((t - 1)\)\)\/\((td(v\_i) - 1)\)\), 
                      \((i = 1,  ... , \(| mm | \), \ | C | \( < j\), j = k)
                        \)}
                    }]}
              }]}], TraditionalForm]]],
  "\n\:554f\:ff14\:ff0e \
\:4e0a\:306e\:63cf\:753b\:3092\:3001\:9802\:70b9\:ff12\:306e\:96a3\:63a5\:5ea6\
\:3092\:4e0a\:3052\:3066\:5b9f\:884c\:305b\:3088\:3002                        \
                                        \n\:3000\:3057\:304b\:3057\:3001\:6700\
\:9069\:306b\:63cf\:753b\:3092\:884c\:3046\:3053\:3068\:306f\:3001\:4f55\:304c\
\:6700\:9069\:3067\:3042\:308b\:304b\:3092\:542b\:3081\:3066\:3001\:6975\:3081\
\:3066\:96e3\:3057\:3044\:3002\n\:554f\:ff15\:ff0e\:5909\:63db\:884c\:5217\
\:306e\:5b9a\:7fa9\:3092\:5c11\:3057\:4fee\:6b63\:3059\:308b\:3053\:3068\:306b\
\:3088\:308a\:3001\:4e0a\:306e\:63cf\:753b\:3092\:3088\:308a\:30d0\:30e9\:30f3\
\:30b9\:306e\:3088\:3044\:3082\:306e\:306b\:6539\:826f\:305b\:3088\:3002\n\
\:554f\:ff16\:ff0e\:6b21\:306e\:884c\:5217\:3092\:96a3\:63a5\:884c\:5217\:306b\
\:6301\:3064\:30b0\:30e9\:30d5\:3092\:3001\:30d4\:30fc\:30bf\:30bd\:30f3\:30fb\
\:30b0\:30e9\:30d5(Petersen graph)\:3068\:8a00\:3046\:3002\:3053\:306e\:30b0\
\:30e9\:30d5\:3092\:95a2\:6570planegraph\:3092\:7528\:3044\:3066\:63cf\:3051\
\:3002\:305f\:3060\:3057\:3001\:5916\:5468\:8def\:306f{1,2,3,4,5}\:3068\:305b\
\:3088\:3002\n     Petersen={{0,1,0,0,1,1,0,0,0,0},{1,0,1,0,0,0,1,0,0,0},\n\t \
          \t{0,1,0,1,0,0,0,1,0,0},{0,0,1,0,1,0,0,0,1,0},\n\t\t\
{1,0,0,1,0,0,0,0,0,1},{1,0,0,0,0,0,0,1,1,0},\n\t\t\
{0,1,0,0,0,0,0,0,1,1},{0,0,1,0,0,1,0,0,0,1},\n\t\t\
{0,0,0,1,0,1,1,0,0,0},{0,0,0,0,1,0,1,1,0,0}}\n\:554f\:ff17\:ff0e\:554f\:ff11\
\:306e\:30b0\:30e9\:30d5\:3092\:5e73\:9762\:30b0\:30e9\:30d5\:3068\:3057\:3066\
\:6b63\:3057\:304f\:63cf\:753b\:305b\:3088\:3002\n\:554f\:ff18\:ff0e\:6b21\
\:306e\:30b0\:30e9\:30d5\:306f\:3001\:6b6320\:9762\:4f53 (icosahedron graph)\
\:30b0\:30e9\:30d5\:3068\:547c\:3070\:308c\:308b\:3002\:3053\:306e\:30b0\:30e9\
\:30d5\:3092\:95a2\:6570drawgraph[ico, {1,2,3}]\:3092\:7528\:3044\:3066\:63cf\
\:753b\:305b\:3088\:3002\:305f\:3060\:3057\:3001ico\:306f\:4e0b\:56f3\:306b\
\:57fa\:3065\:304f\:3001\:96a3\:63a5\:884c\:5217\:3067\:3042\:308b\:3002\n",
  Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: 1 
MathPictureStart
/Mabs {
Mgmatrix idtransform
Mtmatrix dtransform
} bind def
/Mabsadd { Mabs
3 -1 roll add
3 1 roll add
exch } bind def
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
-0.1617 1.10638 0.0486285 0.97257 [
[ 0 0 0 0 ]
[ 1 1 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 0 m
1 0 L
1 1 L
0 1 L
closepath
clip
newpath
0 g
.025 w
.05532 .95137 Mdot
.05532 .04863 Mdot
.94468 .5 Mdot
.27092 .6231 Mdot
.19007 .5 Mdot
.27092 .3769 Mdot
.43262 .3769 Mdot
.51348 .5 Mdot
.43262 .6231 Mdot
.29787 .5 Mdot
.37872 .45897 Mdot
.37872 .54103 Mdot
.5 Mabswid
.05532 .95137 m
.05532 .04863 L
s
.05532 .95137 m
.94468 .5 L
s
.05532 .95137 m
.27092 .6231 L
s
.05532 .95137 m
.19007 .5 L
s
.05532 .95137 m
.43262 .6231 L
s
.05532 .04863 m
.05532 .95137 L
s
.05532 .04863 m
.94468 .5 L
s
.05532 .04863 m
.19007 .5 L
s
.05532 .04863 m
.27092 .3769 L
s
.05532 .04863 m
.43262 .3769 L
s
.94468 .5 m
.05532 .95137 L
s
.94468 .5 m
.05532 .04863 L
s
.94468 .5 m
.43262 .3769 L
s
.94468 .5 m
.51348 .5 L
s
.94468 .5 m
.43262 .6231 L
s
.27092 .6231 m
.05532 .95137 L
s
.27092 .6231 m
.19007 .5 L
s
.27092 .6231 m
.43262 .6231 L
s
.27092 .6231 m
.29787 .5 L
s
.27092 .6231 m
.37872 .54103 L
s
.19007 .5 m
.05532 .95137 L
s
.19007 .5 m
.05532 .04863 L
s
.19007 .5 m
.27092 .6231 L
s
.19007 .5 m
.27092 .3769 L
s
.19007 .5 m
.29787 .5 L
s
.27092 .3769 m
.05532 .04863 L
s
.27092 .3769 m
.19007 .5 L
s
.27092 .3769 m
.43262 .3769 L
s
.27092 .3769 m
.29787 .5 L
s
.27092 .3769 m
.37872 .45897 L
s
.43262 .3769 m
.05532 .04863 L
s
.43262 .3769 m
.94468 .5 L
s
.43262 .3769 m
.27092 .3769 L
s
.43262 .3769 m
.51348 .5 L
s
.43262 .3769 m
.37872 .45897 L
s
.51348 .5 m
.94468 .5 L
s
.51348 .5 m
.43262 .3769 L
s
.51348 .5 m
.43262 .6231 L
s
.51348 .5 m
.37872 .45897 L
s
.51348 .5 m
.37872 .54103 L
s
.43262 .6231 m
.05532 .95137 L
s
.43262 .6231 m
.94468 .5 L
s
.43262 .6231 m
.27092 .6231 L
s
.43262 .6231 m
.51348 .5 L
s
.43262 .6231 m
.37872 .54103 L
s
.29787 .5 m
.27092 .6231 L
s
.29787 .5 m
.19007 .5 L
s
.29787 .5 m
.27092 .3769 L
s
.29787 .5 m
.37872 .45897 L
s
.29787 .5 m
.37872 .54103 L
s
.37872 .45897 m
.27092 .3769 L
s
.37872 .45897 m
.43262 .3769 L
s
.37872 .45897 m
.51348 .5 L
s
.37872 .45897 m
.29787 .5 L
s
.37872 .45897 m
.37872 .54103 L
s
.37872 .54103 m
.27092 .6231 L
s
.37872 .54103 m
.51348 .5 L
s
.37872 .54103 m
.43262 .6231 L
s
.37872 .54103 m
.29787 .5 L
s
.37872 .54103 m
.37872 .45897 L
s
.05532 .95137 m
.05532 .04863 L
s
.05532 .95137 m
.94468 .5 L
s
.05532 .95137 m
.27092 .6231 L
s
.05532 .95137 m
.19007 .5 L
s
.05532 .95137 m
.43262 .6231 L
s
.05532 .04863 m
.05532 .95137 L
s
.05532 .04863 m
.94468 .5 L
s
.05532 .04863 m
.19007 .5 L
s
.05532 .04863 m
.27092 .3769 L
s
.05532 .04863 m
.43262 .3769 L
s
.94468 .5 m
.05532 .95137 L
s
.94468 .5 m
.05532 .04863 L
s
.94468 .5 m
.43262 .3769 L
s
.94468 .5 m
.51348 .5 L
s
.94468 .5 m
.43262 .6231 L
s
.27092 .6231 m
.05532 .95137 L
s
.27092 .6231 m
.19007 .5 L
s
.27092 .6231 m
.43262 .6231 L
s
.27092 .6231 m
.29787 .5 L
s
.27092 .6231 m
.37872 .54103 L
s
.19007 .5 m
.05532 .95137 L
s
.19007 .5 m
.05532 .04863 L
s
.19007 .5 m
.27092 .6231 L
s
.19007 .5 m
.27092 .3769 L
s
.19007 .5 m
.29787 .5 L
s
.27092 .3769 m
.05532 .04863 L
s
.27092 .3769 m
.19007 .5 L
s
.27092 .3769 m
.43262 .3769 L
s
.27092 .3769 m
.29787 .5 L
s
.27092 .3769 m
.37872 .45897 L
s
.43262 .3769 m
.05532 .04863 L
s
.43262 .3769 m
.94468 .5 L
s
.43262 .3769 m
.27092 .3769 L
s
.43262 .3769 m
.51348 .5 L
s
.43262 .3769 m
.37872 .45897 L
s
.51348 .5 m
.94468 .5 L
s
.51348 .5 m
.43262 .3769 L
s
.51348 .5 m
.43262 .6231 L
s
.51348 .5 m
.37872 .45897 L
s
.51348 .5 m
.37872 .54103 L
s
.43262 .6231 m
.05532 .95137 L
s
.43262 .6231 m
.94468 .5 L
s
.43262 .6231 m
.27092 .6231 L
s
.43262 .6231 m
.51348 .5 L
s
.43262 .6231 m
.37872 .54103 L
s
.29787 .5 m
.27092 .6231 L
s
.29787 .5 m
.19007 .5 L
s
.29787 .5 m
.27092 .3769 L
s
.29787 .5 m
.37872 .45897 L
s
.29787 .5 m
.37872 .54103 L
s
.37872 .45897 m
.27092 .3769 L
s
.37872 .45897 m
.43262 .3769 L
s
.37872 .45897 m
.51348 .5 L
s
.37872 .45897 m
.29787 .5 L
s
.37872 .45897 m
.37872 .54103 L
s
.37872 .54103 m
.27092 .6231 L
s
.37872 .54103 m
.51348 .5 L
s
.37872 .54103 m
.43262 .6231 L
s
.37872 .54103 m
.29787 .5 L
s
.37872 .54103 m
.37872 .45897 L
s
[(1)] .02213 .92219 0 1 Mshowa
[(2)] .02213 .01945 0 1 Mshowa
[(3)] .91149 .47082 0 1 Mshowa
[(4)] .23773 .59392 0 1 Mshowa
[(5)] .15688 .47082 0 1 Mshowa
[(6)] .23773 .34772 0 1 Mshowa
[(7)] .39943 .34772 0 1 Mshowa
[(8)] .48028 .47082 0 1 Mshowa
[(9)] .39943 .59392 0 1 Mshowa
[(10)] .26468 .47082 0 1 Mshowa
[(11)] .34553 .42979 0 1 Mshowa
[(12)] .34553 .51186 0 1 Mshowa
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
    ImageSize->{288, 288},
    ImageMargins->{{44, 0}, {0, 0}},
    ImageRegion->{{0, 1}, {0, 1}},
    ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`40004P000180P10`40000100000800002008200000
P800P020P<30`<3L`:K:l00000000000000000000000000000000000000000000000000000000000
00000000000000000000000000000000000000000000000000000000000000000000000000000000
00000000000000000000000000000000000000000000000000000000000000000000000000000000
00000000000000000000000000000000000000000000000000000000000000000000000000000000
00000000000000000000000000000000000000000000000000000000000000000000000000000000
00000000000000000000000000000000000000000000000000000000000000000000000000000000
00000000000000000000000000000000000000000000000000000000000000000000000000000000
00000000000000000000000000000000000000000000000000000000000000000000000000000000
00000000000000000000000000000000000000000000000000000000000000000000000000000000
00000000000000000000000000000000000000000000000000000000000000000000000000000000
00000000000000000000000000000000000000000000000000000000000000000000000000000000
00000000000000000000000000000000000000000000000000000000000000000000000000000000
00000?okl:2PY820P?l0003o0?oo0000ool0o`3oooooo`Go00<0ool0oolIo`001Ol00`3oo`3ooaWo
0004o`030?l00?oo6_l000Go00<0ool0oolIo`00oolQo`00oolQo`00oolQo`00oolQo`00oolQo`00
oolQo`00oolQo`00oolQo`003_l30?oo4?l000go1@3oo`oo000<o`L0ool>o`003?l70?oo3_l000co
203oo`go000=o`T0ool;o`003_l30005o`3o0?l00P3oo`Wo000?o`040?l000;o00<0ool00P3oo`Oo
000?o`050?l0o`000_l0103oool20?oo1Ol000oo00<0o`000_l0103oo`04o`80ool3o`003ol00`3o
0002o`050?ooo`001Ol20?oo0Ol000oo00@0ool00_l01@3oool000Ko0P3no`003ol0103oo`03o`04
0?ooo`801_l20?co000?o`040?oo00?o00<0ool00ol00`3oo`05o`80n_l000oo00D0oooo0003o`03
0?oo00?o00<0ool01_l20?So000?o`050?ooo`000ol00`3oo`04o`030?oo00Oo0P3fo`003ol01@3o
ool000Co00<0ool01?l00`3oo`08o`80m?l000oo00<0ool00_l00`3oo`02o`030?oo00Co00<0ool0
2Ol20?;o000?o`030?oo00;o00<0ool00_l00`3oo`05o`030?oo00[o0P3`o`003ol00`3oo`02o`03
0?oo00?o00<0ool01Ol200co0P3^o`003ol00`3oo`02o`030?oo00Co00<0ool01_l00`3oo`0;o`80
k?l000oo00<0ool00ol00`3oo`03o`030?oo00Oo00<0ool03?l20>[o000?o`030?oo00?o00<0ool0
1?l00`3oo`07o`030?oo00go0P3Xo`003ol00`3oo`03o`030?oo00Go00<0ool01ol00`3oo`0>o`80
i_l000oo00<0ool01?l00`3oo`04o`030?oo00So00<0ool03ol20>Co000?o`030?oo00Co00<0ool0
1Ol00`3oo`08o`030?oo013o0P3Ro`003ol00`3oo`04o`030?oo00Ko00<0ool02?l201;o0P3Po`00
3ol00`3oo`05o`030?oo00Go00<0ool02_l00`3oo`0Ao`80g_l000oo00<0ool01Ol00`3oo`06o`03
0?oo00[o00<0ool04_l20=co000?o`030?oo00Go00<0ool01ol00`3oo`0:o`030?oo01?o0P3Jo`00
3ol00`3oo`05o`030?oo00Oo00<0ool02ol00`3oo`0Do`80f?l000oo00<0ool01_l00`3oo`07o`03
0?oo00_o00<0ool05Ol20=Ko000?o`030?oo00Ko00<0ool02?l00`3oo`0;o`030?oo01Ko0P3Do`00
3ol00`3oo`06o`030?oo00So00<0ool03?l201So0P3Bo`003ol00`3oo`07o`030?oo00So00<0ool0
3Ol00`3oo`0Go`030?oo0<oo000?o`030?oo00Oo00<0ool02Ol00`3oo`0=o`030?oo01Oo0P3?o`00
3ol00`3oo`07o`030?oo00Wo00<0ool03_l00`3oo`0Ho`80cOl000oo00<0ool02?l00`3oo`09o`03
0?oo00ko00<0ool06Ol20<_o000?o`030?oo00So00<0ool02Ol00`3oo`0?o`030?oo01[o0P39o`00
3ol00`3oo`08o`030?oo00[o00<0ool03ol201co0P37o`003ol00`3oo`08o`030?oo00_o00<0ool0
4?l00`3oo`0Ko`80aOl000oo00<0ool02Ol00`3oo`0:o`030?oo017o00<0ool07?l20<?o000?o`03
0?oo00Wo00<0ool02ol00`3oo`0Ao`030?oo01go0P31o`003ol00`3oo`09o`030?oo00co00<0ool0
4Ol00`3oo`0No`80_ol000oo00<0ool02_l00`3oo`0;o`030?oo01;o00<0ool07ol20;go000?o`03
0?oo00[o00<0ool03?l00`3oo`0Bo`030?oo023o0P2ko`003ol00`3oo`0:o`030?oo00go00<0ool0
4_l202;o0P2io`003ol00`3oo`0;o`030?oo00co00<0ool05?l00`3oo`0Qo`80]ol000oo00<0ool0
2ol00`3oo`0=o`030?oo01Co00<0ool08_l20;Go000?o`030?oo00_o00<0ool03_l00`3oo`0Do`03
0?oo02?o0P2co`003ol00`3oo`0;o`030?oo00ko00<0ool05Ol00`3oo`0To`80/Ol000oo00<0ool0
3?l00`3oo`0>o`030?oo01Go00<0ool09Ol20:oo000?o`030?oo00co00<0ool03ol00`3oo`0Eo`03
0?oo02Ko0P2]o`003ol00`3oo`0<o`030?oo00oo00<0ool05_l202So0P2[o`003ol00`3oo`0=o`03
0?oo00oo00<0ool05ol00`3oo`0Wo`80ZOl000oo00<0ool03Ol00`3oo`0@o`030?oo01Oo00<0ool0
:?l20:Oo000?o`030?oo00go00<0ool04?l00`3oo`0Ho`030?oo02Wo0P2Uo`003ol00`3oo`0>o`03
0?oo013o00<0ool06?l00`3oo`0Zo`80Xol000oo00<0ool03_l00`3oo`0Ao`030?oo01So00<0ool0
:ol20:7o000?o`030?oo00ko00<0ool04Ol00`3oo`0Io`030?oo02co0P2Oo`003ol00`3oo`0>o`03
0?oo01;o00<0ool06Ol202ko0P2Mo`003ol00`3oo`0?o`030?oo01;o00<0ool06_l00`3oo`0]o`80
Vol000oo00<0ool03ol00`3oo`0Bo`030?oo01_o00<0ool0;_l209Wo000?o`030?oo00oo00<0ool0
4ol00`3oo`0Ko`030?oo02oo0P2Go`003ol00`3oo`0@o`030?oo01;o00<0ool07?l00`3oo`0`o`80
UOl000oo00<0ool04?l00`3oo`0Co`030?oo01co00<0ool0<Ol209?o000?o`030?oo013o00<0ool0
5?l00`3oo`0Lo`80<ol2097o000?o`030?oo017o00<0ool04ol00`3oo`0No`030?oo03;o00<0ool0
S_l000oo00<0ool04Ol00`3oo`0Do`030?oo01ko00<0ool0<_l208ko000?o`030?oo017o00<0ool0
5Ol00`3oo`0No`030?oo03?o0P2<o`003ol00`3oo`0Ao`030?oo01Go00<0ool07ol00`3oo`0do`80
R_l000oo00<0ool04_l00`3oo`0Eo`030?oo01oo00<0ool0=Ol208So000?o`030?oo01;o00<0ool0
5_l00`3oo`0Oo`030?oo03Ko0P26o`003ol00`3oo`0Bo`030?oo01Ko00<0ool08?l203So0P24o`00
3ol00`3oo`0Co`030?oo01Ko00<0ool08Ol00`3oo`0go`80P_l000oo00<0ool04ol00`3oo`0Go`03
0?oo027o00<0ool0>?l2083o000?o`030?oo01?o00<0ool05ol00`3oo`0Ro`030?oo03Wo0P1no`00
3ol00`3oo`0Do`030?oo01Oo00<0ool08_l00`3oo`0jo`80O?l000oo00<0ool05?l00`3oo`0Ho`03
0?oo02;o00<0ool0>ol207[o000?o`030?oo01Co00<0ool06?l00`3oo`0So`030?oo03co0P1ho`00
3ol00`3oo`0Do`030?oo01Wo0P0To`802?l00`3oo`0co`80M_l000oo00<0ool05Ol00`3oo`0Ho`<0
9Ol00`3oo`05o`030?oo03Go0P1do`003ol00`3oo`0Eo`030?oo01So0`0Vo`030?oo00Co00<0ool0
=ol207;o000?o`030?oo01Go00<0ool06?l302Oo00<0ool01?l00`3oo`0ho`80L?l000oo00<0ool0
5_l00`3oo`0Go`040?oo02Oo00L0oooo0?l003co0P1^o`003ol00`3oo`0Fo`030?oo01So0`0Xo`03
0?oo00<0?_l206co000?o`030?oo01Ko00<0ool06ol00`3oo`0Vo`030?oo04;o0P1Zo`003ol00`3o
o`0Go`030?oo01[o00<0ool09ol204Co0P1Xo`003ol00`3oo`0Go`030?oo01_o00<0ool0:?l00`3o
o`13o`80I_l000oo00<0ool05ol00`3oo`0Lo`030?oo02So00<0ool0A?l206Co000?o`030?oo01Oo
00<0ool07?l00`3oo`0Yo`030?oo04Go0P1Ro`003ol00`3oo`0Ho`030?oo01co00<0ool0:Ol00`3o
o`16o`80H?l000oo00<0ool06?l00`3oo`0Mo`030?oo02Wo00<0ool0Aol205ko000?o`030?oo01So
00<0ool07Ol00`3oo`0Zo`030?oo04So0P1Lo`003ol00`3oo`0Io`030?oo01go100Yo`8000Co0000
A_l205[o000?o`030?oo01Wo00<0ool07Ol502[o1@17o`80F?l000oo00<0ool06Ol00`3oo`0Lo`L0
:?l704So0P1Fo`003ol00`3oo`0Jo`030?oo01_o=P1:o`80E?l000oo00<0ool06_l00`3oo`0Ko`L0
:?l:04Wo0P1Bo`003ol00`3oo`0Jo`030?oo01co1P0Yo`D01?l404Oo00<0ool0Col000oo00<0ool0
6_l00`3oo`0Lo`@00_l00`3oo`0Vo`D02?l404Co0P1?o`003ol00`3oo`0Ko`030?oo01[o00D0oooo
0003o`809Ol00`3oo`03o`030?oo00Wo1012o`80COl000oo00<0ool06ol00`3oo`0Jo`050?ooo`00
1Ol00`3oo`0Ro`030?oo00?o00<0ool03Ol503oo0P1;o`003ol00`3oo`0Ko`030?oo01Wo00<0ool0
0_l00`3oo`04o`030?oo023o00<0ool01Ol00`3oo`0Ao`@0?Ol204Wo000?o`030?oo01co00<0ool0
5ol00`3oo`04o`030?oo00Co0P06o`X03ol00`3oo`07o`030?oo01Co100ko`80Aol000oo00<0ool0
7?l00`3oo`0Go`030?oo00Co00<0ool01_l00`3oo`05o`030?oo00;o00<0ool03_l00`3oo`08o`03
0?oo01So100io`80AOl000oo00<0ool07?l00`3oo`0Fo`030?oo00Go00<0ool01ol00`3oo`04o`03
0?oo00;o00<0ool03_l00`3oo`09o`030?oo01_o100go`80@ol000oo00<0ool07Ol00`3oo`0Do`03
0?oo00Ko00<0ool02?l200Co00<0ool00_l00`3oo`0=o`030?oo00_o00<0ool07_l503Co0P11o`00
3ol00`3oo`0Mo`030?oo01Co00<0ool01ol00`3oo`09o`050?ooo`001?l00`3oo`0<o`030?oo00co
00<0ool08ol403;o0P0oo`003ol00`3oo`0Mo`030?oo01?o00<0ool02?l00`3oo`0:o`040?l000?o
0P0>o`030?oo00go00<0ool09_l4033o0P0mo`003ol00`3oo`0Mo`030?oo01;o00<0ool02Ol00`3o
o`0;o`804ol00`3oo`0?o`030?oo02Wo100^o`80>ol000oo00<0ool07_l00`3oo`0Ao`030?oo00Wo
00<0ool03Ol00`3oo`0?o`030?oo013o00<0ool0;Ol402co0P0io`003ol00`3oo`0No`030?oo013o
00<0ool02_l00`3oo`0>o`030?oo00ko00<0ool04Ol00`3oo`0`o`D0:Ol203Oo000?o`030?oo01ko
00<0ool03ol00`3oo`0<o`030?oo00ko0P0=o`030?oo01?o00<0ool0=?l402Oo0P0eo`003ol00`3o
o`0Oo`030?oo00ko00<0ool03?l00`3oo`0@o`030?oo00Wo00<0ool05?l00`3oo`0ho`@09Ol203?o
000?o`030?oo01oo00<0ool03Ol00`3oo`0=o`030?oo017o00<0ool01ol00`3oo`0Fo`030?oo03_o
100So`80<Ol000oo00<0ool06_l00`3oo`02o`030?oo00go00<0ool00_l500;o00D0oooo000Do`80
1ol00`3oo`0Fo`80@?l4027o0P0Co`806_l000oo00<0ool06Ol00`3o0004o`030?oo00_o00<0ool0
1Ol01`3oool0o`000ol00`3oo`0Co`030?oo00@06Ol304?o1@0No`804ol00`3oo`0Go`003ol00`3o
o`0Ko`030?oo00;o00<0ool02_l00`3oo`06o`070?ooo`3o0003o`030?oo01Co1P0Io`030?l004So
100Lo`804?l00`3oo`0Ho`003ol00`3oo`0Io`801Ol00`3oo`0:o`030?oo00Ko00L0oooo0?l000?o
00<0ool05?l701Wo0P1<o`@06_l200oo00<0ool05ol000oo00<0ool06Ol00`3oo`04o`030?oo00Wo
00<0ool01ol01`3oool0o`000ol00`3oo`0Do`L06?l0103o001?o`@06?l200_o00<0o`006Ol000oo
00<0ool06Ol300Go00<0ool01ol00`3oo`07o`801?l00`3oo`02o`030?oo01Co200Ho`040?oo05;o
100Fo`802_l00`3oo`0Ho`003ol00`3oo`0Qo`030?oo00Oo00<0ool04ol00`3oo`0Bo`L00_l401Oo
00<0ool0E?l501?o0P0So`003ol00`3oo`0Qo`030?oo00Ko00<0ool05?l00`3oo`0@o`800ol300Oo
0`0Eo`030?oo05So100Ao`808Ol000oo00<0ool08_l00`3oo`04o`030?oo01Go00<0ool03_l200Ko
00<0ool02Ol301?o00<0ool0Fol400oo0P0Oo`003ol00`3oo`0Ro`030?oo00Co00<0ool05Ol00`3o
o`0<o`802?l00`3oo`0<o`<04?l00`3oo`1Oo`@03Ol201go000?o`030?oo02;o00<0ool00ol00`3o
o`0Go`030?oo00Wo0P0:o`030?oo00oo100=o`030?oo06;o100;o`806ol000oo00<0ool08ol01@3o
ool001[o00<0ool01ol50004o`0000Go00<0ool04ol300_o00<0ool0IOl500So0P0Io`003ol00`3o
o`0So`050?ooo`006_l00`3oo`05o`800_l01@3oool000Oo00<0ool05_l300So00<0ool0J_l400Ko
0P0Go`003ol00`3oo`0So`@06ol300?o0P04o`030?oo00;o00<0ool01?l00`3oo`0Io`<01_l406co
1004o`800ol300oo000?o`030?oo02;o1@0Jo`L01_l00`3oo`02o`030?oo00Co00<0ool07?l400;o
1@1_o`@00_l700ko000?o`030?oo027o1`0Ho`L01ol01`3oool0o`001Ol00`3oo`0Po`P0L_l:00go
000?o`030?oo027o9P06o`801?l00`3oo`04o`030?oo027oP`0=o`003ol00`3oo`0Qo`L06?l701?o
00<0ool08?l807;o2P0=o`003ol00`3oo`0Ro`D06_l701;o00<0ool07?l400;o1@1_o`@00_l700ko
000?o`030?oo02?o100Ko`<00ol2013o00<0ool06Ol300Ko101/o`@01?l200?o0`0?o`003ol00`3o
o`0So`050?ooo`006_l00`3oo`05o`803_l00`3oo`0Fo`<02?l00`3oo`1Zo`@01_l201Oo000?o`03
0?oo02;o00<0ool00_l00`3oo`0Ho`030?oo00Oo0P0<o`030?oo01?o0`0;o`030?oo06Go1@08o`80
6Ol000oo00<0ool08_l00`3oo`03o`030?oo01Oo00<0ool02Ol200[o00<0ool03ol400go00<0ool0
H_l400_o0P0Ko`003ol00`3oo`0Ro`030?oo00Co00<0ool05Ol00`3oo`0<o`802?l00`3oo`0<o`<0
4?l00`3oo`1Oo`@03Ol201go000?o`030?oo02;o00<0ool01?l00`3oo`0Eo`030?oo00ko0P06o`03
0?oo00Wo0`0Co`030?oo05_o100?o`807ol000oo00<0ool08Ol00`3oo`06o`030?oo01Co00<0ool0
4?l200?o0`07o`<05Ol00`3oo`1Ho`@04Ol2027o000?o`030?oo027o00<0ool01ol00`3oo`0Co`03
0?oo01;o1`02o`@05ol00`3oo`1Do`D04ol202?o000?o`030?oo027o00<0ool01ol00`3oo`0Bo`03
0?oo01Co200Ko`030?oo053o100Fo`809Ol000oo00<0ool08?l00`3oo`09o`030?oo017o00<0ool0
5?l701_o00<0ool0COl401So0P0Wo`003ol00`3oo`0Po`030?oo00[o00<0ool04?l00`3oo`0Do`L0
6_l00`3oo`1:o`@06_l202Wo000?o`030?oo023o00<0ool02_l00`3oo`0@o`030?oo01Co1P0Ko`03
0?oo04Ko100Lo`80:ol000oo00<0ool07ol00`3oo`0<o`030?oo00oo00<0ool04ol00`3oo`0401[o
00<0ool0@_l501ko0P0]o`003ol00`3oo`0Oo`030?oo00go00<0ool03Ol00`3oo`0Bo`801ol00`3o
o`0Fo`030?oo03oo100Qo`80;ol000oo00<0ool07ol00`3oo`0=o`030?oo00go00<0ool04Ol00`3o
o`07o`030?oo01Ko00<0ool0>ol402?o0P0ao`003ol00`3oo`0Oo`030?oo00ko00<0ool03?l00`3o
o`0@o`030?oo00Wo00<0ool05?l00`3oo`0ho`@09Ol203?o000?o`030?oo01ko00<0ool03ol400_o
00<0ool03_l200go0P0Do`030?oo03Co100Wo`80=Ol000oo00<0ool07_l00`3oo`0@o`802ol00`3o
o`0>o`030?oo00ko0P0Bo`030?oo033o1@0Yo`80=ol000oo00<0ool07_l00`3oo`0?o`@02_l00`3o
o`0=o`030?oo00oo0P0Ao`030?oo02go100/o`80>Ol000oo00<0ool07Ol00`3oo`0@o`030?l000_o
00<0ool02ol2017o00<0o`004Ol00`3oo`0Yo`@0;_l203_o000?o`030?oo01go00<0ool04Ol300[o
00<0ool02_l00`3oo`0Ao`040?l000oo00<0ool09_l4033o0P0mo`003ol00`3oo`0Mo`030?oo01;o
00<0o`002Ol00`3oo`09o`030?oo01?o0`0>o`030?oo02?o100bo`80?ol000oo00<0ool07?l00`3o
o`0Eo`030?oo00Ko00<0ool02?l201Wo00<0ool02ol00`3oo`0No`D0=?l2047o000?o`030?oo01co
00<0ool05_l00`3oo`05o`030?oo00Oo00<0ool06_l00`3oo`09o`030?oo01_o100go`80@ol000oo
00<0ool07?l00`3oo`0Go`030?oo00Co00<0ool01_l00`3oo`0Ko`030?oo00So00<0ool06?l403Wo
0P15o`003ol00`3oo`0Lo`030?oo01Oo00<0ool01?l00`3oo`04o`807ol00`3oo`07o`030?oo01Co
100ko`80Aol000oo00<0ool06ol00`3oo`0Io`030?oo00;o00<0ool01?l00`3oo`0Po`030?oo00Go
00<0ool04Ol403go0P19o`003ol00`3oo`0Ko`030?oo01[o00D0oooo0005o`030?oo02;o00<0ool0
0ol00`3oo`0=o`D0?ol204_o000?o`030?oo01_o00<0ool06_l01@3oool000?o0P0Uo`030?oo00?o
00<0ool02Ol404;o0P1=o`003ol00`3oo`0Jo`030?oo01co1002o`030?oo02Ko1@08o`@0AOl00`3o
o`1=o`003ol00`3oo`0Jo`030?oo01co1P0Yo`D01?l404Oo0P1@o`003ol00`3oo`0Jo`030?oo01_o
1`0Xo`X0BOl205;o000?o`030?oo01Wo00<0ool07?lf04[o0P1Do`003ol00`3oo`0Io`030?oo01co
1`0Xo`L0B?l205Ko000?o`030?oo01Wo00<0ool07Ol502[o1@17o`80F?l000oo00<0ool06Ol00`3o
o`0Mo`@0:Ol20004o`0004Ko0P1Jo`003ol00`3oo`0Ho`030?oo01go00<0ool0:_l00`3oo`18o`80
G?l000oo00<0ool06?l00`3oo`0Mo`030?oo02Wo00<0ool0Aol205ko000?o`030?oo01So00<0ool0
7?l00`3oo`0Yo`030?oo04Ko0P1Po`003ol00`3oo`0Go`030?oo01co00<0ool0:Ol00`3oo`15o`80
H_l000oo00<0ool05ol00`3oo`0Lo`030?oo02So00<0ool0A?l206Co000?o`030?oo01Oo00<0ool0
6ol00`3oo`0Xo`030?oo04?o0P1Vo`003ol00`3oo`0Fo`030?oo01_o00<0ool09ol204Co0P1Xo`00
3ol00`3oo`0Fo`030?oo01_o00<0ool09_l00`3oo`12o`80J_l000oo00<0ool05_l00`3oo`0Jo`03
0?oo02Ko00<0ool0@Ol206co000?o`030?oo01Ko00<0ool06_l00`3oo`0Uo`030?oo043o0P1^o`00
3ol00`3oo`0Eo`030?oo01[o00<0ool09Ol00`3oo`0oo`80L?l000oo00<0ool05Ol00`3oo`0Io`03
0?oo02Go00<0ool0?_l207;o000?o`030?oo01Go00<0ool06Ol00`3oo`0To`030?oo03go0P1do`00
3ol00`3oo`0Do`030?oo01Wo00<0ool08ol203ko0P1fo`003ol00`3oo`0Do`030?oo01So00<0ool0
8ol00`3oo`0lo`80N?l000oo00<0ool05?l00`3oo`0Ho`030?oo02;o00<0ool0>ol207[o000?o`03
0?oo01?o00<0ool06?l00`3oo`0Ro`030?oo03[o0P1lo`003ol00`3oo`0Co`030?oo01Oo00<0ool0
8_l00`3oo`0io`80O_l000oo00<0ool04ol00`3oo`0Go`030?oo027o00<0ool0>?l2083o000?o`03
0?oo01?o00<0ool05_l00`3oo`0Qo`030?oo03Oo0P22o`003ol00`3oo`0Bo`030?oo01Ko00<0ool0
8?l203So0P24o`003ol00`3oo`0Bo`030?oo01Ko00<0ool07ol00`3oo`0fo`80Q_l000oo00<0ool0
4_l00`3oo`0Eo`030?oo01oo00<0ool0=Ol208So000?o`030?oo017o00<0ool05Ol00`3oo`0Oo`03
0?oo03Co0P2:o`003ol00`3oo`0Ao`030?oo01Go00<0ool07_l00`3oo`0co`80S?l000oo00<0ool0
4Ol00`3oo`0Do`030?oo01ko00<0ool0<_l208ko000?o`030?oo013o00<0ool05?l00`3oo`0No`03
0?oo03;o00<0ool0S_l000oo00<0ool04?l00`3oo`0Do`030?oo01co0P0co`80TOl000oo00<0ool0
4?l00`3oo`0Co`030?oo01co00<0ool0<Ol209?o000?o`030?oo013o00<0ool04_l00`3oo`0Lo`03
0?oo033o0P2Eo`003ol00`3oo`0?o`030?oo01?o00<0ool06ol00`3oo`0_o`80Uol000oo00<0ool0
3ol00`3oo`0Bo`030?oo01_o00<0ool0;_l209Wo000?o`030?oo00oo00<0ool04_l00`3oo`0Jo`03
0?oo02go0P2Ko`003ol00`3oo`0>o`030?oo01;o00<0ool06Ol202ko0P2Mo`003ol00`3oo`0>o`03
0?oo017o00<0ool06Ol00`3oo`0/o`80Wol000oo00<0ool03_l00`3oo`0Ao`030?oo01So00<0ool0
:ol20:7o000?o`030?oo00go00<0ool04Ol00`3oo`0Ho`030?oo02[o0P2So`003ol00`3oo`0=o`03
0?oo013o00<0ool06?l00`3oo`0Yo`80YOl000oo00<0ool03Ol00`3oo`0@o`030?oo01Oo00<0ool0
:?l20:Oo000?o`030?oo00go00<0ool03ol00`3oo`0Go`030?oo02Oo0P2Yo`003ol00`3oo`0<o`03
0?oo00oo00<0ool05_l202So0P2[o`003ol00`3oo`0<o`030?oo00oo00<0ool05Ol00`3oo`0Vo`80
[Ol000oo00<0ool03?l00`3oo`0>o`030?oo01Go00<0ool09Ol20:oo000?o`030?oo00_o00<0ool0
3_l00`3oo`0Eo`030?oo02Co0P2ao`003ol00`3oo`0;o`030?oo00ko00<0ool05?l00`3oo`0So`80
/ol000oo00<0ool02ol00`3oo`0=o`030?oo01Co00<0ool08_l20;Go000?o`030?oo00[o00<0ool0
3Ol00`3oo`0Do`030?oo027o0P2go`003ol00`3oo`0:o`030?oo00go00<0ool04_l202;o0P2io`00
3ol00`3oo`0:o`030?oo00co00<0ool04_l00`3oo`0Po`80^ol000oo00<0ool02_l00`3oo`0;o`03
0?oo01;o00<0ool07ol20;go000?o`030?oo00Wo00<0ool03?l00`3oo`0Ao`030?oo01ko0P2oo`00
3ol00`3oo`09o`030?oo00_o00<0ool04Ol00`3oo`0Mo`80`Ol000oo00<0ool02Ol00`3oo`0:o`03
0?oo017o00<0ool07?l20<?o000?o`030?oo00So00<0ool02ol00`3oo`0@o`030?oo01_o0P35o`00
3ol00`3oo`08o`030?oo00[o00<0ool03ol201co0P37o`003ol00`3oo`08o`030?oo00Wo00<0ool0
3ol00`3oo`0Jo`80bOl000oo00<0ool01ol00`3oo`0:o`030?oo00ko00<0ool06Ol20<_o000?o`03
0?oo00Oo00<0ool02Ol00`3oo`0>o`030?oo01So0P3=o`003ol00`3oo`07o`030?oo00Wo00<0ool0
3Ol00`3oo`0Ho`030?oo0<go000?o`030?oo00Oo00<0ool02?l00`3oo`0=o`030?oo01Oo0P3@o`00
3ol00`3oo`06o`030?oo00So00<0ool03?l201So0P3Bo`003ol00`3oo`06o`030?oo00So00<0ool0
2ol00`3oo`0Fo`80e?l000oo00<0ool01_l00`3oo`07o`030?oo00_o00<0ool05Ol20=Ko000?o`03
0?oo00Go00<0ool01ol00`3oo`0;o`030?oo01Co0P3Ho`003ol00`3oo`05o`030?oo00Oo00<0ool0
2_l00`3oo`0Co`80f_l000oo00<0ool01Ol00`3oo`06o`030?oo00[o00<0ool04_l20=co000?o`03
0?oo00Co00<0ool01_l00`3oo`0:o`030?oo017o0P3No`003ol00`3oo`04o`030?oo00Ko00<0ool0
2?l201;o0P3Po`003ol00`3oo`04o`030?oo00Go00<0ool02?l00`3oo`0@o`80h_l000oo00<0ool0
1?l00`3oo`04o`030?oo00So00<0ool03ol20>Co000?o`030?oo00?o00<0ool01Ol00`3oo`07o`03
0?oo00ko0P3Vo`003ol00`3oo`03o`030?oo00Co00<0ool01ol00`3oo`0=o`80j?l000oo00<0ool0
0ol00`3oo`03o`030?oo00Oo00<0ool03?l20>[o000?o`030?oo00;o00<0ool01?l00`3oo`06o`03
0?oo00_o0P3/o`000ol500Oo00<0ool00_l00`3oo`03o`030?oo00Go0P0<o`80k_l000Go00<0ool0
1ol00`3oo`02o`030?oo00;o00<0ool01Ol00`3oo`0:o`80l?l000Go00<0ool01ol01@3oool000Go
00<0ool01?l00`3oo`09o`80l_l000Go00<0ool01ol01@3oool000Co00<0ool01?l00`3oo`08o`80
m?l000Go00<0ool01ol01@3oool000?o00<0ool01?l00`3oo`07o`80m_l000Co0P09o`050?ooo`00
0ol00`3oo`03o`030?oo00Ko0P3ho`003ol0103oo`03o`030?oo00?o00<0ool01Ol20?[o000?o`04
0?oo00?o00@0oooo0P06o`80o?l000oo00@0ool00_l01@3oool000Ko0P3no`003ol00`3o0002o`05
0?ooo`001Ol20?oo0Ol000oo00<0o`000_l0103oo`04o`80ool3o`003ol01@3o0?l000;o00@0oooo
0P3oo`Go000?o`8000Go0?oo0002o`80ool7o`003ol20005o`3o0?l00P3oo`Wo000>o`P0ool;o`00
3Ol70?oo3Ol000co1`3oo`ko000<o`L0ool>o`003?l70?oo3_l000go1@3oo`oo000>o`<0ool@o`00
oolQo`00oolQo`00oolQo`00oolQo`00oolQo`00oolQo`00oolQo`00oolQo`00oolQo`00oolQo`00
\
\>"],
    ImageRangeCache->{{{0, 287}, {287, 0}} -> {0, 0, 0, 0}}],
  "\n\:554f\:ff19\:ff0e\:6b21\:306e\:30b0\:30e9\:30d5\:306f\:6b6312\:9762\
\:4f53\:30b0\:30e9\:30d5 (dodecahedron)\:3068\:547c\:3070\:308c\:308b\:3002\
\:3053\:306e\:30b0\:30e9\:30d5\:3092\:63cf\:753b\:305b\:3088\:3002\n",
  Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: 1 
MathPictureStart
/Mabs {
Mgmatrix idtransform
Mtmatrix dtransform
} bind def
/Mabsadd { Mabs
3 -1 roll add
3 1 roll add
exch } bind def
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
0.0465153 0.930307 -0.0221976 0.973522 [
[ 0 0 0 0 ]
[ 1 1 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 0 m
1 0 L
1 1 L
0 1 L
closepath
clip
newpath
0 g
.025 w
.5 .95132 Mdot
.04652 .60654 Mdot
.21973 .04868 Mdot
.78027 .04868 Mdot
.95348 .60654 Mdot
.5 .70368 Mdot
.27158 .53002 Mdot
.35883 .24902 Mdot
.64117 .24902 Mdot
.72842 .53002 Mdot
.41147 .57986 Mdot
.58853 .57986 Mdot
.64324 .40365 Mdot
.5 .29474 Mdot
.35676 .40365 Mdot
.46283 .50588 Mdot
.53717 .50588 Mdot
.56014 .43191 Mdot
.5 .38618 Mdot
.43986 .43191 Mdot
.5 Mabswid
.5 .95132 m
.04652 .60654 L
s
.5 .95132 m
.95348 .60654 L
s
.5 .95132 m
.5 .70368 L
s
.04652 .60654 m
.5 .95132 L
s
.04652 .60654 m
.21973 .04868 L
s
.04652 .60654 m
.27158 .53002 L
s
.21973 .04868 m
.04652 .60654 L
s
.21973 .04868 m
.78027 .04868 L
s
.21973 .04868 m
.35883 .24902 L
s
.78027 .04868 m
.21973 .04868 L
s
.78027 .04868 m
.95348 .60654 L
s
.78027 .04868 m
.64117 .24902 L
s
.95348 .60654 m
.5 .95132 L
s
.95348 .60654 m
.78027 .04868 L
s
.95348 .60654 m
.72842 .53002 L
s
.5 .70368 m
.5 .95132 L
s
.5 .70368 m
.41147 .57986 L
s
.5 .70368 m
.58853 .57986 L
s
.27158 .53002 m
.04652 .60654 L
s
.27158 .53002 m
.41147 .57986 L
s
.27158 .53002 m
.35676 .40365 L
s
.35883 .24902 m
.21973 .04868 L
s
.35883 .24902 m
.5 .29474 L
s
.35883 .24902 m
.35676 .40365 L
s
.64117 .24902 m
.78027 .04868 L
s
.64117 .24902 m
.64324 .40365 L
s
.64117 .24902 m
.5 .29474 L
s
.72842 .53002 m
.95348 .60654 L
s
.72842 .53002 m
.58853 .57986 L
s
.72842 .53002 m
.64324 .40365 L
s
.41147 .57986 m
.5 .70368 L
s
.41147 .57986 m
.27158 .53002 L
s
.41147 .57986 m
.46283 .50588 L
s
.58853 .57986 m
.5 .70368 L
s
.58853 .57986 m
.72842 .53002 L
s
.58853 .57986 m
.53717 .50588 L
s
.64324 .40365 m
.64117 .24902 L
s
.64324 .40365 m
.72842 .53002 L
s
.64324 .40365 m
.56014 .43191 L
s
.5 .29474 m
.35883 .24902 L
s
.5 .29474 m
.64117 .24902 L
s
.5 .29474 m
.5 .38618 L
s
.35676 .40365 m
.27158 .53002 L
s
.35676 .40365 m
.35883 .24902 L
s
.35676 .40365 m
.43986 .43191 L
s
.46283 .50588 m
.41147 .57986 L
s
.46283 .50588 m
.53717 .50588 L
s
.46283 .50588 m
.43986 .43191 L
s
.53717 .50588 m
.58853 .57986 L
s
.53717 .50588 m
.46283 .50588 L
s
.53717 .50588 m
.56014 .43191 L
s
.56014 .43191 m
.64324 .40365 L
s
.56014 .43191 m
.53717 .50588 L
s
.56014 .43191 m
.5 .38618 L
s
.5 .38618 m
.5 .29474 L
s
.5 .38618 m
.56014 .43191 L
s
.5 .38618 m
.43986 .43191 L
s
.43986 .43191 m
.35676 .40365 L
s
.43986 .43191 m
.46283 .50588 L
s
.43986 .43191 m
.5 .38618 L
s
.5 .95132 m
.04652 .60654 L
s
.5 .95132 m
.95348 .60654 L
s
.5 .95132 m
.5 .70368 L
s
.04652 .60654 m
.5 .95132 L
s
.04652 .60654 m
.21973 .04868 L
s
.04652 .60654 m
.27158 .53002 L
s
.21973 .04868 m
.04652 .60654 L
s
.21973 .04868 m
.78027 .04868 L
s
.21973 .04868 m
.35883 .24902 L
s
.78027 .04868 m
.21973 .04868 L
s
.78027 .04868 m
.95348 .60654 L
s
.78027 .04868 m
.64117 .24902 L
s
.95348 .60654 m
.5 .95132 L
s
.95348 .60654 m
.78027 .04868 L
s
.95348 .60654 m
.72842 .53002 L
s
.5 .70368 m
.5 .95132 L
s
.5 .70368 m
.41147 .57986 L
s
.5 .70368 m
.58853 .57986 L
s
.27158 .53002 m
.04652 .60654 L
s
.27158 .53002 m
.41147 .57986 L
s
.27158 .53002 m
.35676 .40365 L
s
.35883 .24902 m
.21973 .04868 L
s
.35883 .24902 m
.5 .29474 L
s
.35883 .24902 m
.35676 .40365 L
s
.64117 .24902 m
.78027 .04868 L
s
.64117 .24902 m
.64324 .40365 L
s
.64117 .24902 m
.5 .29474 L
s
.72842 .53002 m
.95348 .60654 L
s
.72842 .53002 m
.58853 .57986 L
s
.72842 .53002 m
.64324 .40365 L
s
.41147 .57986 m
.5 .70368 L
s
.41147 .57986 m
.27158 .53002 L
s
.41147 .57986 m
.46283 .50588 L
s
.58853 .57986 m
.5 .70368 L
s
.58853 .57986 m
.72842 .53002 L
s
.58853 .57986 m
.53717 .50588 L
s
.64324 .40365 m
.64117 .24902 L
s
.64324 .40365 m
.72842 .53002 L
s
.64324 .40365 m
.56014 .43191 L
s
.5 .29474 m
.35883 .24902 L
s
.5 .29474 m
.64117 .24902 L
s
.5 .29474 m
.5 .38618 L
s
.35676 .40365 m
.27158 .53002 L
s
.35676 .40365 m
.35883 .24902 L
s
.35676 .40365 m
.43986 .43191 L
s
.46283 .50588 m
.41147 .57986 L
s
.46283 .50588 m
.53717 .50588 L
s
.46283 .50588 m
.43986 .43191 L
s
.53717 .50588 m
.58853 .57986 L
s
.53717 .50588 m
.46283 .50588 L
s
.53717 .50588 m
.56014 .43191 L
s
.56014 .43191 m
.64324 .40365 L
s
.56014 .43191 m
.53717 .50588 L
s
.56014 .43191 m
.5 .38618 L
s
.5 .38618 m
.5 .29474 L
s
.5 .38618 m
.56014 .43191 L
s
.5 .38618 m
.43986 .43191 L
s
.43986 .43191 m
.35676 .40365 L
s
.43986 .43191 m
.46283 .50588 L
s
.43986 .43191 m
.5 .38618 L
s
[(1)] .47209 .92212 0 1 Mshowa
[(2)] .01861 .57734 0 1 Mshowa
[(3)] .19182 .01947 0 1 Mshowa
[(4)] .75236 .01947 0 1 Mshowa
[(5)] .92558 .57734 0 1 Mshowa
[(6)] .47209 .67448 0 1 Mshowa
[(7)] .24367 .50081 0 1 Mshowa
[(8)] .33092 .21982 0 1 Mshowa
[(9)] .61326 .21982 0 1 Mshowa
[(10)] .70051 .50081 0 1 Mshowa
[(11)] .38356 .55066 0 1 Mshowa
[(12)] .56062 .55066 0 1 Mshowa
[(13)] .61533 .37444 0 1 Mshowa
[(14)] .47209 .26554 0 1 Mshowa
[(15)] .32885 .37444 0 1 Mshowa
[(16)] .43492 .47668 0 1 Mshowa
[(17)] .50926 .47668 0 1 Mshowa
[(18)] .53223 .4027 0 1 Mshowa
[(19)] .47209 .35698 0 1 Mshowa
[(20)] .41196 .4027 0 1 Mshowa
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
    ImageSize->{288, 288},
    ImageMargins->{{43, 0}, {0, 0}},
    ImageRegion->{{0, 1}, {0, 1}},
    ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`40004P000180P10`40000100000800002008200000
P800P020P<30`<3L`:K:l3<006H009T00<`0000c03<c06Hc09Tc0<`c0?lc001V03=V06IV09UV0<aV
0?mV002I03>I06JI09VI0<bI0?nI003<03?<06K<09W<0<c<0?o<03?o06Ko09Wo0<co0000<c<0<fH0
<iT0<l`0<ol0<`0c<c<c<fHc<iTc<l`c<olc<`1V<c=V<fIV<iUV<laV<omV<`2I<c>I<fJI<iVI<lbI
<onI<`3<<c?<<fK<<iW<<lc<<oo<<`3o<c?o<fKo<iWo<lco<ooo<`00IS<0IVH0IYT0I/`0I_l0IP0c
IS<cIVHcIYTcI/`cI_lcIP1VIS=VIVIVIYUVI/aVI_mVIP2IIS>IIVJIIYVII/bII_nIIP3<IS?<IVK<
IYW<I/c<I_o<IP3oIS?oIVKoIYWoI/coI_ooIP00VC<0VFH0VIT0VL`0VOl0V@0cVC<cVFHcVITcVL`c
VOlcV@1VVC=VVFIVVIUVVLaVVOmVV@2IVC>IVFJIVIVIVLbIVOnIV@3<VC?<VFK<VIW<VLc<VOo<V@3o
VC?oVFKoVIWoVLcoVOooV@00c3<0c6H0c9T0c<`0c?l0c00cc3<cc6Hcc9Tcc<`cc?lcc01Vc3=Vc6IV
c9UVc<aVc?mVc02Ic3>Ic6JIc9VIc<bIc?nIc03<c3?<c6K<c9W<c<c<c?o<c03oc3?oc6Koc9Woc<co
c?ooc3<0ofH0oiT0ol`0o`0coc<cofHcoiTcol`coolco`1Voc=VofIVoiUVolaVoomVo`2Ioc>IofJI
oiVIolbIoonIo`3<oc?<ofK<oiW<olc<ooo<oc?oofKooiWoolcoo`410@820P<30`@410D51@H61PL7
1`P820T92@X:2P/;2``<30h>3Pl?3a0@414A4A8B4Q<C4a@D50000000000000000000000000000000
00000?okl:2PY820P?l0003o0?oo0000ool0o`3oooooocKo00<0ool0WOl404Ko000go`030?oo09co
00<0o`00Aol003Go00<0o`00Wol204Oo000fo`030?oo09oo00<0ool0AOl00?oo8Ol00?oo8Ol00?oo
8Ol00?oo8Ol00?oo8Ol00?oo8Ol00?oo8Ol00?oo8Ol003ko0`2Mo`<0?ol003go1@2Ko`D0?_l003co
Y`0mo`00??l709Wo1`0mo`00??l709Wo1`0mo`00?Ol509_o1@0no`00?_l30003o`3o09So00<0o`00
0P0oo`00?Ol00`3oo`02o`030?oo09Oo00<0ool00_l00`3oo`0lo`00?Ol00`3oo`03o`030?oo09Go
00<0ool00ol00`3oo`0lo`00?Ol00`3oo`04o`030?oo09?o00<0ool01?l00`3oo`0lo`00?Ol00`3o
o`04o`030?oo09?o00<0ool01?l00`3oo`0lo`00??l00`3oo`06o`030?oo097o00<0ool01_l00`3o
o`0ko`00??l00`3oo`07o`030?oo08oo00<0ool01ol00`3oo`0ko`00??l00`3oo`07o`030?oo08oo
00<0ool01ol00`3oo`0ko`00>ol00`3oo`09o`030?oo08go00<0ool02Ol00`3oo`0jo`00>ol00`3o
o`0:o`030?oo08_o00<0ool02_l00`3oo`0jo`00>ol00`3oo`0:o`030?oo08_o00<0ool02_l00`3o
o`0jo`00>_l00`3oo`0<o`030?oo08Wo00<0ool03?l00`3oo`0io`00>_l00`3oo`0=o`030?oo08Oo
00<0ool03Ol00`3oo`0io`00>_l00`3oo`0=o`030?oo08Oo00<0ool03Ol00`3oo`0io`00>Ol00`3o
o`0?o`030?oo08Go00<0ool03ol00`3oo`0ho`00>Ol00`3oo`0@o`030?oo08?o00<0ool04?l00`3o
o`0ho`00>Ol00`3oo`0@o`030?oo08?o00<0ool04?l00`3oo`0ho`00>?l00`3oo`0Bo`030?oo087o
00<0ool04_l00`3oo`0go`00>?l00`3oo`0Co`030?oo07oo00<0ool04ol00`3oo`0go`00>?l00`3o
o`0Co`030?oo07oo00<0ool04ol00`3oo`0go`00>?l00`3oo`0Do`030?oo07go00<0ool05?l00`3o
o`0go`00=ol00`3oo`0Fo`030?oo07_o00<0ool05_l00`3oo`0fo`00=ol00`3oo`0Fo`030?oo07_o
00<0ool05_l00`3oo`0fo`00=ol00`3oo`0Go`030?oo07Wo00<0ool05ol00`3oo`0fo`00=_l00`3o
o`0Io`030?oo07Oo00<0ool06Ol00`3oo`0eo`00=_l00`3oo`0Io`030?oo07Ko00<0ool06_l00`3o
o`0eo`00=_l00`3oo`0Jo`030?oo07Go00<0ool06_l00`3oo`0eo`00=Ol00`3oo`0Lo`030?oo07?o
00<0ool07?l00`3oo`0do`00=Ol00`3oo`0Mo`030?oo077o00<0ool07Ol00`3oo`0do`00=Ol00`3o
o`0Mo`030?oo077o00<0ool07Ol00`3oo`0do`00=?l00`3oo`0Oo`030?oo06oo00<0ool07ol00`3o
o`0co`00=?l00`3oo`0Po`030?oo06go00<0ool08?l00`3oo`0co`00=?l00`3oo`0Po`030?oo06go
00<0ool08?l00`3oo`0co`00=?l00`3oo`0Qo`030?oo06_o00<0ool08Ol00`3oo`0co`00<ol00`3o
o`0So`030?oo06Wo00<0ool08ol00`3oo`0bo`00<ol00`3oo`0So`030?oo06Wo00<0ool08ol00`3o
o`0bo`00<ol00`3oo`0To`030?oo06Oo00<0ool09?l00`3oo`0bo`00<_l00`3oo`0Vo`030?oo06Go
00<0ool09_l00`3oo`0ao`00<_l00`3oo`0Vo`040?oo04oo0P0Co`030?oo02Ko00<0ool0<Ol003;o
00<0ool09ol20003o`3o04oo00<0ool03ol00`3oo`0Wo`030?oo037o000ao`030?oo02Wo00<0o`00
Col2013o00<0ool0:Ol00`3oo`0`o`00<Ol00`3oo`0Yo`80Col00`3o000@o`030?oo02Wo00<0ool0
<?l0037o00<0ool0:Ol304ko00<0o`003ol00`3oo`0Zo`030?oo033o000`o`030?oo02_o0P1?o`80
3_l00`3oo`0/o`030?oo02oo000`o`030?oo02co00<0ool0GOl00`3oo`0/o`030?oo02oo000`o`03
0?oo02go00<0ool0Fol00`3oo`0]o`030?oo02oo000_o`030?oo02oo00<0ool0FOl00`3oo`0_o`03
0?oo02ko000_o`030?oo02oo00<0ool0FOl00`3oo`0_o`030?oo02ko000_o`030?oo033o00<0ool0
Eol00`3oo`0`o`030?oo02ko000_o`030?oo037o00<0ool0EOl00`3oo`0ao`030?oo02ko000^o`03
0?oo03;o00<0ool0EOl00`3oo`0bo`030?oo02go000^o`030?oo03?o100Jo`D00_l302[o0`000ol0
o`0do`030?oo02go000^o`030?oo03?o1@0Ko`030?oo00?o00<0ool0:?l503Ko00<0ool0;Ol002go
00<0ool0<ol701[o00@0oooo100Xo`L0=_l00`3oo`0/o`00;Ol00`3oo`0co`L06_l01`3oool0o`00
:Ol703Ko00<0ool0;?l002go00<0ool0<ol801Wo00<0ool00_l202Wo1`0fo`030?oo02co000/o`03
0?oo03Go1@02o`<05Ol200Go00<0ool09?l30003o`0000<0>?l00`3oo`0[o`00;?l00`3oo`0fo`<0
1_l403_o1005o`<0>Ol00`3oo`0[o`00;?l00`3oo`0go`030?oo00Wo0`0eo`<02ol00`3oo`0go`03
0?oo02_o000[o`030?oo03So00<0ool03?l302oo0`0>o`030?oo03So00<0ool0:_l002_o00<0ool0
>?l00`3oo`0?o`<0:Ol3017o00<0ool0>?l00`3oo`0Zo`00:ol00`3oo`0ho`030?oo01;o0`0So`<0
5?l00`3oo`0ho`030?oo02[o000[o`030?oo03So00<0ool05Ol301go0`0Go`030?oo03So00<0ool0
:_l002[o00<0ool0>Ol00`3oo`0Ho`<05ol301[o00<0ool0>Ol00`3oo`0Yo`00:_l00`3oo`0io`03
0?oo01_o1006o`<01_l401go00<0ool0>Ol00`3oo`0Yo`00:_l00`3oo`0io`030?oo01oo0`02o`D0
0_l3027o00<0ool0>Ol00`3oo`0Yo`00:Ol00`3oo`0jo`030?oo02;o2@0To`030?oo03[o00<0ool0
:?l002Wo00<0ool0>_l00`3oo`0So`L09Ol00`3oo`0jo`030?oo02So000Yo`030?oo03[o00<0ool0
8ol702Go00<0ool0>_l00`3oo`0Xo`00:?l00`3oo`0ko`030?oo02Co1@0Vo`030?oo03_o00<0ool0
9ol002So00<0ool0>ol00`3oo`0Uo`<09ol00`3oo`0ko`030?oo02Oo000Xo`030?oo03_o00<0ool0
9_l00`3oo`0Vo`030?oo03_o00<0ool09ol002Oo00<0ool0??l00`3oo`0Vo`030?oo02Ko00<0ool0
??l00`3oo`0Vo`009ol00`3oo`0lo`030?oo02Ko00<0ool09_l00`3oo`0lo`030?oo02Ko000Wo`03
0?oo03co00<0ool09_l00`3oo`0Vo`030?oo03co00<0ool09_l002Ko00<0ool0?Ol00`3oo`0Vo`03
0?oo02Ko00<0ool0?Ol00`3oo`0Uo`009_l00`3oo`0mo`030?oo02Ko00<0ool09_l00`3oo`0mo`03
0?oo02Go000Vo`030?oo03go00<0ool06Ol50003o`0000Go00<0ool09_l00`3oo`0mo`030?oo02Go
000Vo`030?oo03go00<0ool06ol00`3oo`03o`030?oo00;o00<0ool09_l00`3oo`0mo`030?oo02Go
000Uo`030?oo03ko00<0ool06ol00`3oo`02o`801?l00`3oo`0Vo`030?oo03ko00<0ool09?l002Go
00<0ool0?_l00`3oo`0Ko`070?ooo`3o0004o`030?oo02Ko00<0ool0?_l00`3oo`0To`009Ol00`3o
o`0no`030?oo01_o00L0oooo0?l000Co00<0ool09_l00`3oo`0no`030?oo02Co000To`030?oo03;o
1@02o`030?oo00?o00<0ool06_l200Co0P04o`030?oo01Wo1@000ol00005o`030?oo03oo00<0ool0
8ol002Co00<0ool0=?l01`3oool0o`001?l00`3oo`0Vo`030?oo01_o00<0ool00ol00`3oo`02o`03
0?oo03oo00<0ool08ol002Co00<0ool0=?l00`3oo`03o`030?oo00;o00<0ool09_l00`3oo`0Ko`03
0?oo00;o00<0ool00ol00`3oo`0oo`030?oo02?o000So`030?oo03Go00@0oooo0P05o`030?oo02Ko
00<0ool06ol00`3oo`03o`030?oo00;o00<0ool0@?l00`3oo`0Ro`008ol00`3oo`0eo`050?ooo`00
1_l00`3oo`0Vo`030?oo01_o00L0oooo0?l000Co00<0ool0@?l00`3oo`0Ro`008ol00`3oo`0do`80
0ol300Co00<0ool09_l00`3oo`0Jo`801?l00`3oo`03o`030?oo043o00<0ool08_l002;o00<0ool0
@Ol00`3oo`0Vo`030?oo02Ko00<0ool0@Ol00`3oo`0Qo`008_l00`3oo`11o`030?oo02Ko00<0ool0
9_l00`3oo`11o`030?oo027o000Ro`030?oo047o00<0ool02Ol300?o00<0ool04ol300;o1@02o`03
0?oo01_o00<0ool0@Ol00`3oo`0Qo`008Ol00`3oo`12o`030?oo00Wo00<0ool00_l00`3o000Co`D0
0ol01`3oool0o`007?l00`3oo`12o`030?oo023o000Qo`030?oo04;o00<0ool02_l01`3oool0o`00
4_l700;o00L0oooo0?l001co00<0ool0@_l00`3oo`0Po`008Ol00`3oo`12o`030?oo00[o00L0oooo
0?l001;o1`02o`030?oo00;o00<0ool06ol00`3oo`12o`030?oo023o000Qo`030?oo04;o00<0ool0
2Ol00`3o0002o`030?l001;o1`02o`070?ooo`3o000Lo`030?oo04;o00<0ool08?l0023o00<0ool0
@_l300_o00<0ool00_l00`3oo`0Ao`L000?o00001?l00`3oo`0Jo`<0A?l00`3oo`0Oo`008?l00`3o
o`11o`D08_l00`3oo`0300;o00<0ool08?l504?o00<0ool07ol0023o00<0ool0@?l7023o00<0ool0
1ol00`3oo`0No`L0@_l00`3oo`0Oo`007ol00`3oo`11o`L07_l200_o0P0No`L0@ol00`3oo`0No`00
7ol00`3oo`11o`P07?l00`3oo`0=o`030?oo01[o2013o`030?oo01ko000Oo`030?oo04;o1@02o`<0
6?l00`3oo`0?o`030?oo01Ko0`02o`D0A?l00`3oo`0No`007_l00`3oo`13o`@01_l301?o0P0Co`80
4ol300Ko1015o`030?oo01go000No`030?oo04;o00<0ool02ol300oo00<0ool05Ol00`3oo`0=o`<0
3Ol00`3oo`12o`030?oo01go000No`030?oo04;o00<0ool03_l300_o00<0ool05ol00`3oo`09o`<0
4?l00`3oo`12o`030?oo01go000Mo`030?oo04;o00<0ool04_l300?o1@0Ko`D00ol301Co00<0ool0
@_l00`3oo`0Lo`007Ol00`3oo`11o`030?oo01Ko1`0Mo`L06?l00`3oo`11o`030?oo01co000Mo`03
0?oo047o00<0ool05ol701_o1`0Io`030?oo047o00<0ool07?l001go00<0ool0@?l00`3oo`0Ho`L0
6ol701[o00<0ool0@?l00`3oo`0Lo`007?l00`3oo`10o`030?oo01Wo1`0Ko`L06ol00`3oo`10o`03
0?oo01_o000Lo`030?oo043o00<0ool06_l501go1@0Lo`030?oo043o00<0ool06ol001co00<0ool0
?ol00`3oo`0Lo`<07ol301ko00<0ool0?ol00`3oo`0Ko`006ol00`3oo`0oo`030?oo01Oo1@001?l0
000=o`D00_l00`3oo`08o`030?oo01oo00<0ool0?ol00`3oo`0Jo`006ol00`3oo`0oo`030?oo01Wo
00H0oooo0?l200ko00<0ool00_l00`3oo`07o`030?oo023o00<0ool0?ol00`3oo`0Jo`006ol00`3o
o`0no`030?oo01[o00H0oooo0?l200ko00<0ool00_l00`3oo`07o`030?oo027o00<0ool0?_l00`3o
o`0Jo`006_l00`3oo`0no`030?oo01_o00@0oooo0P000ol0o`0=o`030?oo00?o00<0ool01_l00`3o
o`0Ro`030?oo03ko00<0ool06Ol001[o00<0ool0?_l00`3oo`0Ko`050?ooo`000_l00`3oo`0<o`07
0?ooo`3o0008o`030?oo02;o00<0ool0?_l00`3oo`0Io`006_l00`3oo`0mo`030?oo01_o0P04o`80
00?o0?l02ol200?o0`07o`030?oo02Co00<0ool0?Ol00`3oo`0Io`006Ol00`3oo`0mo`030?oo02Go
00<0ool06Ol00`3oo`0Uo`030?oo03go00<0ool06?l001Wo00<0ool0:Ol00`3oo`0@o`030?oo02Ko
00<0ool06Ol00`3oo`0To`D00_l00`3oo`0go`030?oo01So000Io`030?oo02Wo00<0ool04?l00`3o
o`0Wo`030?oo01Oo00<0ool09ol01`3oool0o`00>?l00`3oo`0Ho`006?l00`3oo`0Zo`030?oo00oo
00<0ool0:?l00`3oo`0Go`030?oo02Oo0P02o`030?l003Wo00<0ool05ol001So00<0ool0:ol00`3o
o`0=o`030?oo02Wo00<0ool05ol00`3oo`0Wo`070?l0o`3o000io`030?oo01Oo000Ho`030?oo02Wo
00<0o`003ol00`3oo`0Yo`030?oo01Oo00<0ool09ol01`3o0?l0o`00>Ol00`3oo`0Go`006?l00`3o
o`0Yo`<03_l00`3oo`0[o`030?oo01Go00<0ool09ol200;o00<0o`00>_l00`3oo`0Go`005ol00`3o
o`0jo`030?oo02co00<0ool05Ol00`3oo`0/o`030?oo03[o00<0ool05_l001Oo00<0ool0>_l00`3o
o`0/o`<04ol302ko00<0ool0>_l00`3oo`0Fo`005ol00`3oo`0io`030?oo02co1@0Ao`D0;_l00`3o
o`0io`030?oo01Ko000Fo`030?oo03Wo00<0ool0;?l700oo1`0^o`030?oo03Wo00<0ool05Ol001Ko
00<0ool0>Ol00`3oo`0/oad0;_l00`3oo`0io`030?oo01Go000Fo`030?oo03So00<0ool0;Ol700oo
1`0_o`030?oo03So00<0ool05Ol001Go00<0ool0>?l00`3oo`0_o`D04Ol5037o00<0ool0>?l00`3o
o`0Do`005Ol00`3oo`0ho`030?oo02oo100Co`@0<Ol00`3oo`0ho`030?oo01Co000Eo`030?oo03Co
100ao`030?oo01Wo00<0ool0;ol303Oo00<0ool05?l001Co00<0ool0=?l501Wo2P0>o`030?oo01Oo
1@001?l0000Zo`D0=ol00`3oo`0Co`005?l00`3oo`0co`L06_l00`3oo`02o`030?oo00go00<0ool0
6_l200;o00<0ool0:Ol703Ko00<0ool04ol001Co00<0ool0<ol701[o00<0ool00_l00`3oo`0<o`03
0?oo01_o00<0o`000_l00`3oo`0Xo`L0=_l00`3oo`0Co`005?l00`3oo`0bo`T06Ol00`3oo`02o`03
0?oo00co00<0ool06ol00`3o0002o`030?oo02So2@0do`030?oo01?o000Co`030?oo033o0`02o`D0
0_l301Ko00<0ool00_l00`3oo`0;o`030?oo01co00<0ool00P000ol0o`0Uo`<000?o00000`03o`<0
<_l00`3oo`0Bo`004ol00`3oo`0]o`<01_l300Ko0`0Bo`800ol200co00<0ool07?l200?o0P0To`<0
1Ol300Oo0`0_o`030?oo01;o000Co`030?oo02[o0`0Eo`<08_l00`3oo`0Qo`030?oo023o0`0Eo`<0
;?l00`3oo`0Bo`000ol300co00<0ool0:Ol201_o0`0No`030?oo02?o00<0ool07?l301_o0P0Xo`04
0?oo01?o0003o`030?oo00co00<0ool09_l3023o0`0Jo`030?oo02Go00<0ool06?l3023o0`0To`05
0?l0o`004ol000Co00<0ool02ol00`3oo`0So`<09_l201So00<0ool09Ol00`3oo`0Fo`809_l302?o
00<0o`004ol000Co00<0ool02_l00`3oo`0Qo`<0:ol301Co00<0ool09ol00`3oo`0Bo`<0:ol301ko
0P03o`030?oo013o0003o`030?l000_o00<0ool07_l3037o0`0@o`030?oo02Wo00<0ool03_l3037o
0`0Ko`030?oo00;o00<0ool04?l000Co00<0ool02_l00`3oo`0Ko`<0=ol300go00<0ool0:Ol00`3o
o`0;o`<0=ol301So0`02o`030?oo013o000@o`030?oo01Wo0`0mo`<01_l402go1006o`<0?Ol301_o
00<0ool03ol0013o00<0ool05_l304?o0`02o`D0;Ol500;o0`13o`<06?l00`3oo`0?o`004?l00`3o
o`0Co`<0BOl802_o2019o`<05Ol00`3oo`0?o`003ol00`3oo`0Ao`<0COl702_o1`1=o`<04ol00`3o
o`0>o`003ol00`3oo`0>o`<0D?l702_o1`1@o`<04?l00`3oo`0>o`003ol00`3oo`0<o`80E?l502go
1@1Do`803_l00`3oo`0>o`003ol00`3oo`09o`<0Eol402go101Go`<02ol00`3oo`0>o`003_l00`3o
o`07o`<0G_l00`3oo`0Yo`030?oo05co0`09o`030?oo00go000<o`<01_l306;o00<0ool09ol00`3o
o`1Po`<01_l300go000;o`D00_l306Go00<0ool09ol00`3oo`1So`<00_l500co000:o`P0JOl00`3o
o`0Uo`030?oo06Oo200;o`002_l706_o00<0ool08ol00`3oo`1Yo`L02ol000[o1`1[o`030?oo02?o
00<0ool0JOl700_o000;o`H0K?l00`3oo`0Qo`030?oo06[o1P0<o`003?l300;o00<0ool0J_l00`3o
o`0Oo`030?oo06[o00<0ool00`0=o`004_l00`3oo`1Zo`030?oo01go00<0ool0J_l00`3oo`0Ao`00
4ol206[o00<0ool07Ol00`3oo`1Xo`805?l001Go00<0ool0J?l00`3oo`0Ko`030?oo06So00<0ool0
5?l001Ko00<0ool0J?l00`3oo`0Io`030?oo06So00<0ool05Ol001Oo0P1Xo`030?oo01Wo00<0ool0
I_l201So000Io`030?oo06Ko00<0ool05ol00`3oo`1Vo`030?oo01So000Jo`030?oo06Ko00<0ool0
5Ol00`3oo`1Vo`030?oo01Wo000Ko`80Iol301?o00<0ool0IOl201co000Mo`030?oo06Co0P000ol0
o`0Ao`030?oo06Co00<0ool07?l001ko00<0ool0I?l00`3o000Ao`030?oo06Co00<0ool07Ol001oo
0P1To`804Ol00`3oo`1So`808?l0027o00<0ool0HOl2017o00<0ool0H_l00`3oo`0Po`008_l00`3o
o`1Qo`803ol00`3oo`1Ro`030?oo027o000So`030?oo06;o00<0ool02ol00`3oo`1Ro`030?oo02;o
000To`80Hol00`3oo`09o`030?oo067o0P0Uo`009_l00`3oo`1Po`030?oo00Wo00<0ool0H?l00`3o
o`0Uo`009ol00`3oo`1Po`030?oo00Oo00<0ool0H?l00`3oo`0Vo`00:?l2067o00<0ool01Ol00`3o
o`1Oo`80:Ol002[o00<0ool0G_l00`3oo`05o`030?oo05ko00<0ool0:Ol002_o00<0ool0G_l00`3o
o`03o`030?oo05ko00<0ool0:_l002co0P1Oo`050?ooo`00Gol202go000^o`030?oo05go0`1Oo`03
0?oo02go000_o`030?oo05_o1@1Mo`030?oo02ko000`o`80F_l705[o0P0ao`00<_l00`3oo`1Go`L0
FOl00`3oo`0ao`00<ol00`3oo`1Fo`L0F?l00`3oo`0bo`00=?l205Oo1@1Go`80=Ol003Ko00<0ool0
EOl305Oo00<0ool0=Ol003Oo00<0ool0EOl00`3oo`1Eo`030?oo03Ko000ho`030?oo05Co00<0ool0
E?l00`3oo`0go`00>Ol205Co00<0ool0D_l203[o000ko`030?oo057o00<0ool0DOl00`3oo`0jo`00
??l00`3oo`1@o`030?oo053o00<0ool0>ol003go0P1@o`030?oo04ko0P0no`00?ol00`3oo`1=o`03
0?oo04go00<0ool0?_l0043o00<0ool0C?l00`3oo`1<o`030?oo03oo0011o`80C?l00`3oo`1:o`80
@_l004?o00<0ool0BOl00`3oo`19o`030?oo04;o0014o`030?oo04So00<0ool0B?l00`3oo`13o`00
AOl204So00<0ool0A_l204Ko0017o`030?oo04Go00<0ool0AOl00`3oo`16o`00B?l00`3oo`14o`03
0?oo04Co00<0ool0Aol004Wo0P14o`030?oo04;o0P1:o`00Bol00`3oo`11o`030?oo047o00<0ool0
B_l004co00<0ool0@?l00`3oo`10o`030?oo04_o001=o`030?oo03oo00<0ool0?ol00`3oo`1<o`00
C_l203oo00<0ool0?Ol204oo001@o`030?oo03co00<0ool0??l00`3oo`1?o`00DOl00`3oo`0ko`03
0?oo03_o00<0ool0D?l005;o0P0ko`030?oo03Wo0P1Co`00E?l00`3oo`0ho`030?oo03So00<0ool0
Dol005Go00<0ool0=ol00`3oo`0go`030?oo05Co001Fo`80=ol00`3oo`0eo`80Eol005So00<0ool0
=?l00`3oo`0do`030?oo05Oo001Io`030?oo03?o00<0ool0<ol00`3oo`1Ho`00F_l203?o00<0ool0
<Ol205_o001Lo`030?oo033o00<0ool0<?l00`3oo`1Ko`00GOl00`3oo`0_o`030?oo02oo00<0ool0
G?l005ko0P0_o`030?oo02go0P1Oo`00H?l00`3oo`0/o`030?oo02co00<0ool0Gol0067o00<0ool0
:ol00`3oo`0[o`030?oo063o001Ro`80:ol00`3oo`0Yo`80Hol006Co00<0ool0:?l00`3oo`0Xo`03
0?oo06?o001Uo`030?oo02Oo00<0ool09ol00`3oo`1To`00I_l00`3oo`0Vo`030?oo02Ko00<0ool0
IOl006Oo0P0Vo`030?oo02Co0P1Xo`00JOl00`3oo`0So`030?oo02?o00<0ool0J?l006[o00<0ool0
8_l00`3oo`0Ro`030?oo06Wo001[o`808_l00`3oo`0Po`80K?l006go00<0ool07ol00`3oo`0Oo`03
0?oo06co001^o`030?oo01ko00<0ool07_l00`3oo`1]o`00Kol201ko00<0ool07?l2073o001ao`03
0?oo01_o00<0ool06ol00`3oo`1`o`00L_l00`3oo`0Jo`030?oo01[o00<0ool0LOl007?o0P0Jo`03
0?oo01So0P1do`00MOl00`3oo`0Go`030?oo01Oo00<0ool0M?l007Ko00<0ool05_l00`3oo`0Fo`03
0?oo07Go001go`805_l00`3oo`0Do`80N?l007Wo00<0ool02?l500Ko00<0ool04ol00`3oo`1ho`00
N_l00`3oo`09o`030?oo00Ko00<0ool04_l00`3oo`1io`00Nol00`3oo`08o`030?oo00Ko00<0ool0
4Ol00`3oo`1jo`00O?l200So00<0ool01_l00`3oo`0?o`80OOl007ko00<0ool01Ol00`3oo`06o`03
0?oo00ko00<0ool0OOl007oo00<0ool00ol200So00<0ool03Ol00`3oo`1no`00P?l200go00<0ool0
2ol2087o0022o`030?oo00[o00<0ool02_l00`3oo`21o`00Pol00`3oo`09o`030?oo00Wo00<0ool0
P_l008Co0P09o`030?oo00Oo0P25o`00Q_l00`3oo`06o`030?oo00Ko00<0ool0QOl008Oo00<0ool0
1Ol00`3oo`05o`030?oo08Ko0028o`801Ol00`3oo`03o`80ROl008[o00<0ool00_l00`3oo`02o`03
0?oo08Wo002;o`030?oo00<00_l00`3oo`2:o`00S?l708go002<o`L0SOl008co1`2=o`00S?l708go
002=o`D0S_l008ko0`2?o`00oolQo`00oolQo`00oolQo`00oolQo`00oolQo`00oolQo`00oolQo`00
oolQo`00oolQo`00oolQo`00\
\>"],
    ImageRangeCache->{{{0, 287}, {287, 0}} -> {0, 0, 0, 0}}]
}], "Text"],

Cell[BoxData[
    \(\(mm = {{0, 1, 0, 0, 0, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 
            0, 0}, {1, 0, 1, 0, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, 0, 0, 0, 0, 
            0, 0, 0, 0}, {0, 1, 0, 1, 0, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, 0, 
            0, 0, 0, 0, 0, 0}, {0, 0, 1, 0, 1, 0, 0, 0, 0, 0, 0, 0, 1, 0, 0, 
            0, 0, 0, 0, 0, 0, 0, 0}, {0, 0, 0, 1, 0, 1, 0, 0, 0, 0, 0, 0, 0, 
            0, 0, 1, 0, 0, 0, 0, 0, 0, 0}, {1, 0, 0, 0, 1, 0, 1, 0, 0, 0, 0, 
            0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 1, 0, 1, 0, 
            0, 0, 0, 0, 0, 1, 1, 0, 1, 1, 1, 0, 0, 1}, {0, 0, 0, 0, 0, 0, 1, 
            0, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 1, 0, 0, 0}, {0, 0, 0, 0, 0, 
            0, 0, 1, 0, 1, 0, 0, 0, 1, 1, 0, 0, 0, 1, 1, 1, 0, 1}, {0, 0, 0, 
            0, 0, 0, 0, 0, 1, 0, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 0, 1}, {0, 
            1, 0, 0, 0, 0, 0, 0, 0, 1, 0, 1, 0, 0, 0, 0, 1, 1, 0, 0, 1, 1, 
            1}, {0, 0, 1, 0, 0, 0, 0, 0, 0, 0, 1, 0, 1, 0, 0, 0, 0, 0, 0, 0, 
            0, 1, 0}, {0, 0, 0, 1, 0, 0, 0, 0, 0, 0, 0, 1, 0, 1, 0, 1, 1, 0, 
            0, 1, 1, 1, 0}, {0, 0, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 1, 0, 0, 0, 
            0, 0, 0, 1, 1, 0, 0}, {0, 0, 0, 0, 0, 0, 1, 0, 1, 0, 0, 0, 0, 0, 
            0, 0, 0, 0, 1, 0, 0, 0, 1}, {0, 0, 0, 0, 1, 0, 1, 0, 0, 0, 0, 0, 
            1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0}, {0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 
            1, 0, 1, 0, 0, 0, 0, 0, 0, 0, 1, 1, 0}, {1, 0, 0, 0, 0, 0, 1, 0, 
            0, 0, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1}, {0, 0, 0, 0, 0, 0, 
            1, 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 
            0, 0, 1, 1, 1, 0, 0, 0, 1, 1, 0, 1, 0, 0, 0, 0, 0, 0, 0}, {0, 0, 
            0, 0, 0, 0, 0, 0, 1, 1, 1, 0, 1, 1, 0, 0, 1, 0, 0, 0, 0, 0, 
            0}, {0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 1, 1, 0, 0, 0, 1, 0, 0, 0, 
            0, 0, 0}, {0, 0, 0, 0, 0, 0, 1, 0, 1, 1, 1, 0, 0, 0, 1, 0, 0, 1, 
            0, 0, 0, 0, 0}};\)\)], "Input"],

Cell[CellGroupData[{

Cell[BoxData[
    \(mm - Transpose[mm]\)], "Input"],

Cell[BoxData[
    \({{0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 
        0}, {0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 
        0, 0}, {0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 
        0, 0, 0}, {0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 
        0, 0, 0, 0}, {0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 
        0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 
        0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 
        0, 0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 
        0, 0, 0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 
        0, 0, 0, 0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0, 0, 0, 0, 
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0, 0, 0, 
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0, 0, 
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0, 
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, {0, 0, 0, 
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, {0, 0, 
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, {0, 
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 
        0}, {0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 
        0, 0}}\)], "Output"]
}, Open  ]],

Cell[BoxData[
    \(\(F = {{1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 
            0, 0}, {0, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 
            0, 0, 0, 0}, {0, 0, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 
            0, 0, 0, 0, 0, 0}, {0, 0, 0, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 
            0, 0, 0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 1, 0, 0, 0, 0, 0, 0, 0, 0, 
            0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 1, 0, 0, 0, 0, 0, 
            0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 1/8, 0, 1/8, 
            0, 0, 0, 0, 0, 0, 1/8, 1/8, 0, 1/8, 1/8, 1/8, 0, 0, 1/8}, {0, 0, 
            0, 0, 0, 0, 1/4, 0, 1/4, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1/4, 1/4, 0, 
            0, 0}, {0, 0, 0, 0, 0, 0, 0, 1/8, 0, 1/8, 0, 0, 0, 1/8, 1/8, 0, 
            0, 0, 1/8, 1/8, 1/8, 0, 1/8}, {0, 0, 0, 0, 0, 0, 0, 0, 1/4, 0, 
            1/4, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1/4, 0, 1/4}, {0, 1/2, 0, 0, 0, 
            0, 0, 0, 0, 1/8, 0, 1/8, 0, 0, 0, 0, 1/8, 1/8, 0, 0, 1/8, 1/8, 
            1/8}, {0, 0, 1/4, 0, 0, 0, 0, 0, 0, 0, 1/4, 0, 1/4, 0, 0, 0, 0, 
            0, 0, 0, 0, 1/4, 0}, {0, 0, 0, 1/8, 0, 0, 0, 0, 0, 0, 0, 1/8, 0, 
            1/8, 0, 1/8, 1/8, 0, 0, 1/8, 1/8, 1/8, 0}, {0, 0, 0, 0, 0, 0, 0, 
            0, 1/4, 0, 0, 0, 1/4, 0, 0, 0, 0, 0, 0, 1/4, 1/4, 0, 0}, {0, 0, 
            0, 0, 0, 0, 1/4, 0, 1/4, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1/4, 0, 0, 0, 
            1/4}, {0, 0, 0, 0, 1/4, 0, 1/4, 0, 0, 0, 0, 0, 1/4, 0, 0, 0, 0, 
            0, 0, 1/4, 0, 0, 0}, {0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1/4, 0, 1/4, 
            0, 0, 0, 0, 0, 0, 0, 1/4, 1/4, 0}, {1/4, 0, 0, 0, 0, 0, 1/4, 0, 
            0, 0, 1/4, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1/4}, {0, 0, 0, 0, 0, 
            0, 1/4, 1/4, 1/4, 0, 0, 0, 0, 0, 1/4, 0, 0, 0, 0, 0, 0, 0, 
            0}, {0, 0, 0, 0, 0, 0, 1/6, 1/6, 1/6, 0, 0, 0, 1/6, 1/6, 0, 1/6, 
            0, 0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0, 0, 0, 1/6, 1/6, 1/6, 0, 
            1/6, 1/6, 0, 0, 1/6, 0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0, 0, 0, 
            0, 0, 1/4, 1/4, 1/4, 0, 0, 0, 1/4, 0, 0, 0, 0, 0, 0}, {0, 0, 0, 
            0, 0, 0, 1/6, 0, 1/6, 1/6, 1/6, 0, 0, 0, 1/6, 0, 0, 1/6, 0, 0, 0, 
            0, 0}};\)\)], "Input"],

Cell[CellGroupData[{

Cell[BoxData[
    \(F = {{1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 
            0}, {0, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 
            0, 0, 0}, {0, 0, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 
            0, 0, 0, 0, 0}, {0, 0, 0, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 
            0, 0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 
            0, 0, 0, 0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 1, 0, 0, 0, 0, 0, 0, 
            0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 1/2, 0, 1/8, 0, 
            0, 0, 0, 0, 0, 1/8, 1/8, 0, 1/8, 1/8, 1/8, 0, 0, 1/8}, {0, 0, 0, 
            0, 0, 0, 1/4, 0, 1/4, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1/4, 1/4, 0, 0, 
            0}, {0, 0, 0, 0, 0, 0, 0, 1/8, 0, 1/8, 0, 0, 0, 1/8, 1/8, 0, 0, 
            0, 1/8, 1/8, 1/8, 0, 1/8}, {0, 0, 0, 0, 0, 0, 0, 0, 1/4, 0, 1/4, 
            0, 0, 0, 0, 0, 0, 0, 0, 0, 1/4, 0, 1/4}, {0, 1/2, 0, 0, 0, 0, 0, 
            0, 0, 1/8, 0, 1/8, 0, 0, 0, 0, 1/8, 1/8, 0, 0, 1/8, 1/8, 
            1/8}, {0, 0, 1/2, 0, 0, 0, 0, 0, 0, 0, 1/4, 0, 1/4, 0, 0, 0, 0, 
            0, 0, 0, 0, 1/4, 0}, {0, 0, 0, 1/2, 0, 0, 0, 0, 0, 0, 0, 1/8, 0, 
            1/8, 0, 1/8, 1/8, 0, 0, 1/8, 1/8, 1/8, 0}, {0, 0, 0, 0, 0, 0, 0, 
            0, 1/4, 0, 0, 0, 1/4, 0, 0, 0, 0, 0, 0, 1/4, 1/4, 0, 0}, {0, 0, 
            0, 0, 0, 0, 1/4, 0, 1/4, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1/4, 0, 0, 0, 
            1/4}, {0, 0, 0, 0, 1/2, 0, 1/4, 0, 0, 0, 0, 0, 1/4, 0, 0, 0, 0, 
            0, 0, 1/4, 0, 0, 0}, {0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1/4, 0, 1/4, 
            0, 0, 0, 0, 0, 0, 0, 1/4, 1/4, 0}, {1/2, 0, 0, 0, 0, 0, 1/4, 0, 
            0, 0, 1/4, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1/4}, {0, 0, 0, 0, 0, 
            0, 1/4, 1/4, 1/4, 0, 0, 0, 0, 0, 1/4, 0, 0, 0, 0, 0, 0, 0, 
            0}, {0, 0, 0, 0, 0, 0, 1/6, 1/6, 1/6, 0, 0, 0, 1/6, 1/6, 0, 1/6, 
            0, 0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0, 0, 0, 1/6, 1/6, 1/6, 0, 
            1/6, 1/6, 0, 0, 1/6, 0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0, 0, 0, 
            0, 0, 1/4, 1/4, 1/4, 0, 0, 0, 1/4, 0, 0, 0, 0, 0, 0}, {0, 0, 0, 
            0, 0, 0, 1/6, 0, 1/6, 1/6, 1/6, 0, 0, 0, 1/6, 0, 0, 1/6, 0, 0, 0, 
            0, 0}} // MatrixForm\)], "Input"],

Cell[BoxData[
    TagBox[
      RowBox[{"(", "\[NoBreak]", GridBox[{
            {"1", "0", "0", "0", "0", "0", "0", "0", "0", "0", "0", "0", "0", 
              "0", "0", "0", "0", "0", "0", "0", "0", "0", "0"},
            {"0", "1", "0", "0", "0", "0", "0", "0", "0", "0", "0", "0", "0", 
              "0", "0", "0", "0", "0", "0", "0", "0", "0", "0"},
            {"0", "0", "1", "0", "0", "0", "0", "0", "0", "0", "0", "0", "0", 
              "0", "0", "0", "0", "0", "0", "0", "0", "0", "0"},
            {"0", "0", "0", "1", "0", "0", "0", "0", "0", "0", "0", "0", "0", 
              "0", "0", "0", "0", "0", "0", "0", "0", "0", "0"},
            {"0", "0", "0", "0", "1", "0", "0", "0", "0", "0", "0", "0", "0", 
              "0", "0", "0", "0", "0", "0", "0", "0", "0", "0"},
            {"0", "0", "0", "0", "0", "1", "0", "0", "0", "0", "0", "0", "0", 
              "0", "0", "0", "0", "0", "0", "0", "0", "0", "0"},
            {"0", "0", "0", "0", "0", \(1\/2\), "0", \(1\/8\), "0", "0", "0", 
              "0", "0", "0", \(1\/8\), \(1\/8\), 
              "0", \(1\/8\), \(1\/8\), \(1\/8\), "0", "0", \(1\/8\)},
            {"0", "0", "0", "0", "0", "0", \(1\/4\), "0", \(1\/4\), "0", "0", 
              "0", "0", "0", "0", "0", "0", "0", \(1\/4\), \(1\/4\), "0", "0",
               "0"},
            {"0", "0", "0", "0", "0", "0", "0", \(1\/8\), "0", \(1\/8\), "0", 
              "0", "0", \(1\/8\), \(1\/8\), "0", "0", 
              "0", \(1\/8\), \(1\/8\), \(1\/8\), "0", \(1\/8\)},
            {"0", "0", "0", "0", "0", "0", "0", "0", \(1\/4\), "0", \(1\/4\), 
              "0", "0", "0", "0", "0", "0", "0", "0", "0", \(1\/4\), 
              "0", \(1\/4\)},
            {"0", \(1\/2\), "0", "0", "0", "0", "0", "0", "0", \(1\/8\), 
              "0", \(1\/8\), "0", "0", "0", "0", \(1\/8\), \(1\/8\), "0", 
              "0", \(1\/8\), \(1\/8\), \(1\/8\)},
            {"0", "0", \(1\/2\), "0", "0", "0", "0", "0", "0", "0", \(1\/4\), 
              "0", \(1\/4\), "0", "0", "0", "0", "0", "0", "0", "0", \(1\/4\),
               "0"},
            {"0", "0", "0", \(1\/2\), "0", "0", "0", "0", "0", "0", 
              "0", \(1\/8\), "0", \(1\/8\), "0", \(1\/8\), \(1\/8\), "0", 
              "0", \(1\/8\), \(1\/8\), \(1\/8\), "0"},
            {"0", "0", "0", "0", "0", "0", "0", "0", \(1\/4\), "0", "0", 
              "0", \(1\/4\), "0", "0", "0", "0", "0", "0", \(1\/4\), \(1\/4\),
               "0", "0"},
            {"0", "0", "0", "0", "0", "0", \(1\/4\), "0", \(1\/4\), "0", "0", 
              "0", "0", "0", "0", "0", "0", "0", \(1\/4\), "0", "0", 
              "0", \(1\/4\)},
            {"0", "0", "0", "0", \(1\/2\), "0", \(1\/4\), "0", "0", "0", "0", 
              "0", \(1\/4\), "0", "0", "0", "0", "0", "0", \(1\/4\), "0", "0",
               "0"},
            {"0", "0", "0", "0", "0", "0", "0", "0", "0", "0", \(1\/4\), 
              "0", \(1\/4\), "0", "0", "0", "0", "0", "0", 
              "0", \(1\/4\), \(1\/4\), "0"},
            {\(1\/2\), "0", "0", "0", "0", "0", \(1\/4\), "0", "0", 
              "0", \(1\/4\), "0", "0", "0", "0", "0", "0", "0", "0", "0", "0",
               "0", \(1\/4\)},
            {"0", "0", "0", "0", "0", "0", \(1\/4\), \(1\/4\), \(1\/4\), "0", 
              "0", "0", "0", "0", \(1\/4\), "0", "0", "0", "0", "0", "0", "0",
               "0"},
            {"0", "0", "0", "0", "0", "0", \(1\/6\), \(1\/6\), \(1\/6\), "0", 
              "0", "0", \(1\/6\), \(1\/6\), "0", \(1\/6\), "0", "0", "0", "0",
               "0", "0", "0"},
            {"0", "0", "0", "0", "0", "0", "0", 
              "0", \(1\/6\), \(1\/6\), \(1\/6\), "0", \(1\/6\), \(1\/6\), "0",
               "0", \(1\/6\), "0", "0", "0", "0", "0", "0"},
            {"0", "0", "0", "0", "0", "0", "0", "0", "0", 
              "0", \(1\/4\), \(1\/4\), \(1\/4\), "0", "0", "0", \(1\/4\), "0",
               "0", "0", "0", "0", "0"},
            {"0", "0", "0", "0", "0", "0", \(1\/6\), 
              "0", \(1\/6\), \(1\/6\), \(1\/6\), "0", "0", "0", \(1\/6\), "0",
               "0", \(1\/6\), "0", "0", "0", "0", "0"}
            }], "\[NoBreak]", ")"}],
      (MatrixForm[ #]&)]], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    \(TexForm[%]\)], "Input"],

Cell[BoxData[
    \(General::"spell" \(\(:\)\(\ \)\) 
      "Possible spelling error: new symbol name \"\!\(TexForm\)\" is similar \
to existing symbols \!\({TeXForm, TextForm}\)."\)], "Message"],

Cell[BoxData[
    \(TexForm[{{1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 
          0, 0, 0}, {0, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 
          0, 0, 0, 0}, {0, 0, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 
          0, 0, 0, 0, 0}, {0, 0, 0, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 
          0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 
          0, 0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 
          0, 0, 0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 1\/2, 0, 1\/8, 0, 0, 0, 0, 
          0, 0, 1\/8, 1\/8, 0, 1\/8, 1\/8, 1\/8, 0, 0, 1\/8}, {0, 0, 0, 0, 0, 
          0, 1\/4, 0, 1\/4, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1\/4, 1\/4, 0, 0, 
          0}, {0, 0, 0, 0, 0, 0, 0, 1\/8, 0, 1\/8, 0, 0, 0, 1\/8, 1\/8, 0, 0, 
          0, 1\/8, 1\/8, 1\/8, 0, 1\/8}, {0, 0, 0, 0, 0, 0, 0, 0, 1\/4, 0, 
          1\/4, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1\/4, 0, 1\/4}, {0, 1\/2, 0, 0, 0, 
          0, 0, 0, 0, 1\/8, 0, 1\/8, 0, 0, 0, 0, 1\/8, 1\/8, 0, 0, 1\/8, 
          1\/8, 1\/8}, {0, 0, 1\/2, 0, 0, 0, 0, 0, 0, 0, 1\/4, 0, 1\/4, 0, 0, 
          0, 0, 0, 0, 0, 0, 1\/4, 0}, {0, 0, 0, 1\/2, 0, 0, 0, 0, 0, 0, 0, 
          1\/8, 0, 1\/8, 0, 1\/8, 1\/8, 0, 0, 1\/8, 1\/8, 1\/8, 0}, {0, 0, 0, 
          0, 0, 0, 0, 0, 1\/4, 0, 0, 0, 1\/4, 0, 0, 0, 0, 0, 0, 1\/4, 1\/4, 
          0, 0}, {0, 0, 0, 0, 0, 0, 1\/4, 0, 1\/4, 0, 0, 0, 0, 0, 0, 0, 0, 0, 
          1\/4, 0, 0, 0, 1\/4}, {0, 0, 0, 0, 1\/2, 0, 1\/4, 0, 0, 0, 0, 0, 
          1\/4, 0, 0, 0, 0, 0, 0, 1\/4, 0, 0, 0}, {0, 0, 0, 0, 0, 0, 0, 0, 0, 
          0, 1\/4, 0, 1\/4, 0, 0, 0, 0, 0, 0, 0, 1\/4, 1\/4, 0}, {1\/2, 0, 0, 
          0, 0, 0, 1\/4, 0, 0, 0, 1\/4, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 
          1\/4}, {0, 0, 0, 0, 0, 0, 1\/4, 1\/4, 1\/4, 0, 0, 0, 0, 0, 1\/4, 0, 
          0, 0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0, 1\/6, 1\/6, 1\/6, 0, 0, 0, 
          1\/6, 1\/6, 0, 1\/6, 0, 0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0, 0, 0, 
          1\/6, 1\/6, 1\/6, 0, 1\/6, 1\/6, 0, 0, 1\/6, 0, 0, 0, 0, 0, 0}, {0, 
          0, 0, 0, 0, 0, 0, 0, 0, 0, 1\/4, 1\/4, 1\/4, 0, 0, 0, 1\/4, 0, 0, 
          0, 0, 0, 0}, {0, 0, 0, 0, 0, 0, 1\/6, 0, 1\/6, 1\/6, 1\/6, 0, 0, 0, 
          1\/6, 0, 0, 1\/6, 0, 0, 0, 0, 0}}]\)], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    \(TeXForm[{{1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 
          0, 0, 0}, {0, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 
          0, 0, 0, 0}, {0, 0, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 
          0, 0, 0, 0, 0}, {0, 0, 0, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 
          0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 
          0, 0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 
          0, 0, 0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 1\/2, 0, 1\/8, 0, 0, 0, 0, 
          0, 0, 1\/8, 1\/8, 0, 1\/8, 1\/8, 1\/8, 0, 0, 1\/8}, {0, 0, 0, 0, 0, 
          0, 1\/4, 0, 1\/4, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1\/4, 1\/4, 0, 0, 
          0}, {0, 0, 0, 0, 0, 0, 0, 1\/8, 0, 1\/8, 0, 0, 0, 1\/8, 1\/8, 0, 0, 
          0, 1\/8, 1\/8, 1\/8, 0, 1\/8}, {0, 0, 0, 0, 0, 0, 0, 0, 1\/4, 0, 
          1\/4, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1\/4, 0, 1\/4}, {0, 1\/2, 0, 0, 0, 
          0, 0, 0, 0, 1\/8, 0, 1\/8, 0, 0, 0, 0, 1\/8, 1\/8, 0, 0, 1\/8, 
          1\/8, 1\/8}, {0, 0, 1\/2, 0, 0, 0, 0, 0, 0, 0, 1\/4, 0, 1\/4, 0, 0, 
          0, 0, 0, 0, 0, 0, 1\/4, 0}, {0, 0, 0, 1\/2, 0, 0, 0, 0, 0, 0, 0, 
          1\/8, 0, 1\/8, 0, 1\/8, 1\/8, 0, 0, 1\/8, 1\/8, 1\/8, 0}, {0, 0, 0, 
          0, 0, 0, 0, 0, 1\/4, 0, 0, 0, 1\/4, 0, 0, 0, 0, 0, 0, 1\/4, 1\/4, 
          0, 0}, {0, 0, 0, 0, 0, 0, 1\/4, 0, 1\/4, 0, 0, 0, 0, 0, 0, 0, 0, 0, 
          1\/4, 0, 0, 0, 1\/4}, {0, 0, 0, 0, 1\/2, 0, 1\/4, 0, 0, 0, 0, 0, 
          1\/4, 0, 0, 0, 0, 0, 0, 1\/4, 0, 0, 0}, {0, 0, 0, 0, 0, 0, 0, 0, 0, 
          0, 1\/4, 0, 1\/4, 0, 0, 0, 0, 0, 0, 0, 1\/4, 1\/4, 0}, {1\/2, 0, 0, 
          0, 0, 0, 1\/4, 0, 0, 0, 1\/4, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 
          1\/4}, {0, 0, 0, 0, 0, 0, 1\/4, 1\/4, 1\/4, 0, 0, 0, 0, 0, 1\/4, 0, 
          0, 0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0, 1\/6, 1\/6, 1\/6, 0, 0, 0, 
          1\/6, 1\/6, 0, 1\/6, 0, 0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0, 0, 0, 
          1\/6, 1\/6, 1\/6, 0, 1\/6, 1\/6, 0, 0, 1\/6, 0, 0, 0, 0, 0, 0}, {0, 
          0, 0, 0, 0, 0, 0, 0, 0, 0, 1\/4, 1\/4, 1\/4, 0, 0, 0, 1\/4, 0, 0, 
          0, 0, 0, 0}, {0, 0, 0, 0, 0, 0, 1\/6, 0, 1\/6, 1\/6, 1\/6, 0, 0, 0, 
          1\/6, 0, 0, 1\/6, 0, 0, 0, 0, 0}}]\)], "Input"],

Cell["\<\
\\{ \\{ 1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0\\} ,\\{ \
0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0\\} ,
  \\{ 0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0\\} ,\\{ \
0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0\\} ,
  \\{ 0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0\\} ,\\{ \
0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0\\} ,
  \\{ 0,0,0,0,0,\\frac{1}{2},0,\\frac{1}{8},0,0,0,0,0,0,\\frac{1}{8},\\frac{1}\
{8},0,\\frac{1}{8},\\frac{1}{8},\\frac{1}{8},
   0,0,\\frac{1}{8}\\} ,\\{ \
0,0,0,0,0,0,\\frac{1}{4},0,\\frac{1}{4},0,0,0,0,0,0,0,0,0,\\frac{1}{4},\\frac{\
1}{4},0,0,0\\} ,
  \\{ 0,0,0,0,0,0,0,\\frac{1}{8},0,\\frac{1}{8},0,0,0,\\frac{1}{8},\\frac{1}{\
8},0,0,0,\\frac{1}{8},\\frac{1}{8},
   \\frac{1}{8},0,\\frac{1}{8}\\} ,\\{ \
0,0,0,0,0,0,0,0,\\frac{1}{4},0,\\frac{1}{4},0,0,0,0,0,0,0,0,0,\\frac{1}{4},0,
   \\frac{1}{4}\\} ,\\{ \
0,\\frac{1}{2},0,0,0,0,0,0,0,\\frac{1}{8},0,\\frac{1}{8},0,0,0,0,\\frac{1}{8},\
\\frac{1}{8},0,0,
   \\frac{1}{8},\\frac{1}{8},\\frac{1}{8}\\} ,\\{ \
0,0,\\frac{1}{2},0,0,0,0,0,0,0,\\frac{1}{4},0,\\frac{1}{4},0,0,0,0,0,0,0,
   0,\\frac{1}{4},0\\} ,\\{ \
0,0,0,\\frac{1}{2},0,0,0,0,0,0,0,\\frac{1}{8},0,\\frac{1}{8},0,\\frac{1}{8},\\\
frac{1}{8},0,0,
   \\frac{1}{8},\\frac{1}{8},\\frac{1}{8},0\\} ,\\{ \
0,0,0,0,0,0,0,0,\\frac{1}{4},0,0,0,\\frac{1}{4},0,0,0,0,0,0,
   \\frac{1}{4},\\frac{1}{4},0,0\\} ,\\{ \
0,0,0,0,0,0,\\frac{1}{4},0,\\frac{1}{4},0,0,0,0,0,0,0,0,0,\\frac{1}{4},0,0,0,
   \\frac{1}{4}\\} ,\\{ \
0,0,0,0,\\frac{1}{2},0,\\frac{1}{4},0,0,0,0,0,\\frac{1}{4},0,0,0,0,0,0,\\frac{\
1}{4},0,0,0\\} ,
  \\{ 0,0,0,0,0,0,0,0,0,0,\\frac{1}{4},0,\\frac{1}{4},0,0,0,0,0,0,0,\\frac{1}{\
4},\\frac{1}{4},0\\} ,
  \\{ \\frac{1}{2},0,0,0,0,0,\\frac{1}{4},0,0,0,\\frac{1}{4},0,0,0,0,0,0,0,0,\
0,0,0,\\frac{1}{4}\\} ,
  \\{ 0,0,0,0,0,0,\\frac{1}{4},\\frac{1}{4},\\frac{1}{4},0,0,0,0,0,\\frac{1}{\
4},0,0,0,0,0,0,0,0\\} ,
  \\{ 0,0,0,0,0,0,\\frac{1}{6},\\frac{1}{6},\\frac{1}{6},0,0,0,\\frac{1}{6},\\\
frac{1}{6},0,\\frac{1}{6},0,0,0,0,0,0,0\\} ,
  \\{ 0,0,0,0,0,0,0,0,\\frac{1}{6},\\frac{1}{6},\\frac{1}{6},0,\\frac{1}{6},\\\
frac{1}{6},0,0,\\frac{1}{6},0,0,0,0,0,0\\} ,
  \\{ 0,0,0,0,0,0,0,0,0,0,\\frac{1}{4},\\frac{1}{4},\\frac{1}{4},0,0,0,\\frac{\
1}{4},0,0,0,0,0,0\\} ,
  \\{ 0,0,0,0,0,0,\\frac{1}{6},0,\\frac{1}{6},\\frac{1}{6},\\frac{1}{6},0,0,0,\
\\frac{1}{6},0,0,\\frac{1}{6},0,0,0,0,0\\} \\}\
\>", "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    \(CompleteGraph[6]\)], "Input"],

Cell[BoxData[
    \(Graph[{{0, 1, 1, 1, 1, 1}, {1, 0, 1, 1, 1, 1}, {1, 1, 0, 1, 1, 1}, {1, 
          1, 1, 0, 1, 1}, {1, 1, 1, 1, 0, 1}, {1, 1, 1, 1, 1, 
          0}}, {{0.5000000000000001`, 
          0.8660254037844386`}, {\(-0.4999999999999998`\), 
          0.8660254037844387`}, {\(-1.`\), 
          0}, {\(-0.5000000000000004`\), \(-0.8660254037844384`\)}, \
{0.49999999999999933`, \(-0.866025403784439`\)}, {1.`, 0}}]\)], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    \(P = {{0.5000000000000001`, 
            0.8660254037844386`}, {\(-0.4999999999999998`\), 
            0.8660254037844387`}, {\(-1.`\), 
            0}, {\(-0.5000000000000004`\), \(-0.8660254037844384`\)}, \
{0.49999999999999933`, \(-0.866025403784439`\)}, {1.`, 
            0}, \[IndentingNewLine]{0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 
            0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 
            0}, \[IndentingNewLine]{0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 
            0}, {0, 0}, {0, 0}} // MatrixForm\)], "Input"],

Cell[BoxData[
    TagBox[
      RowBox[{"(", "\[NoBreak]", GridBox[{
            {"0.5000000000000001`", "0.8660254037844386`"},
            {\(-0.4999999999999998`\), "0.8660254037844387`"},
            {\(-1.`\), "0"},
            {\(-0.5000000000000004`\), \(-0.8660254037844384`\)},
            {"0.49999999999999933`", \(-0.866025403784439`\)},
            {"1.`", "0"},
            {"0", "0"},
            {"0", "0"},
            {"0", "0"},
            {"0", "0"},
            {"0", "0"},
            {"0", "0"},
            {"0", "0"},
            {"0", "0"},
            {"0", "0"},
            {"0", "0"},
            {"0", "0"},
            {"0", "0"},
            {"0", "0"},
            {"0", "0"},
            {"0", "0"},
            {"0", "0"},
            {"0", "0"}
            }], "\[NoBreak]", ")"}],
      (MatrixForm[ #]&)]], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    \(TeXForm[%]\)], "Input"],

Cell["\<\
\\{ \\{ 0.5,0.866025\\} ,\\{ -0.5,0.866025\\} ,\\{ -1.,0\\} ,\\{ \
-0.5,-0.866025\\} ,\\{ 0.5,-0.866025\\} ,\\{ 1.,0\\} ,\\{ 0,0\\} ,
  \\{ 0,0\\} ,\\{ 0,0\\} ,\\{ 0,0\\} ,\\{ 0,0\\} ,\\{ 0,0\\} ,\\{ 0,0\\} ,\\{ \
0,0\\} ,\\{ 0,0\\} ,\\{ 0,0\\} ,\\{ 0,0\\} ,\\{ 0,0\\} ,
  \\{ 0,0\\} ,\\{ 0,0\\} ,\\{ 0,0\\} ,\\{ 0,0\\} ,\\{ 0,0\\} \\}\
\>", "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    \(\(\(draw[mm, \ P]\)\(\ \ \ \ \ \ \ \ \ \ \ \ \ \ \)\)\)], "Input"],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: 1 
MathPictureStart
/Mabs {
Mgmatrix idtransform
Mtmatrix dtransform
} bind def
/Mabsadd { Mabs
3 -1 roll add
3 1 roll add
exch } bind def
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
0.5 0.454545 0.5 0.524864 [
[ 0 0 0 0 ]
[ 1 1 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 0 m
1 0 L
1 1 L
0 1 L
closepath
clip
newpath
0 g
.02 w
.72727 .95455 Mdot
.27273 .95455 Mdot
.04545 .5 Mdot
.27273 .04545 Mdot
.72727 .04545 Mdot
.95455 .5 Mdot
.5 .5 Mdot
.5 .5 Mdot
.5 .5 Mdot
.5 .5 Mdot
.5 .5 Mdot
.5 .5 Mdot
.5 .5 Mdot
.5 .5 Mdot
.5 .5 Mdot
.5 .5 Mdot
.5 .5 Mdot
.5 .5 Mdot
.5 .5 Mdot
.5 .5 Mdot
.5 .5 Mdot
.5 .5 Mdot
.5 .5 Mdot
.5 Mabswid
[ ] 0 setdash
.72727 .95455 m
.27273 .95455 L
s
.72727 .95455 m
.95455 .5 L
s
.72727 .95455 m
.5 .5 L
s
.27273 .95455 m
.72727 .95455 L
s
.27273 .95455 m
.04545 .5 L
s
.27273 .95455 m
.5 .5 L
s
.04545 .5 m
.27273 .95455 L
s
.04545 .5 m
.27273 .04545 L
s
.04545 .5 m
.5 .5 L
s
.27273 .04545 m
.04545 .5 L
s
.27273 .04545 m
.72727 .04545 L
s
.27273 .04545 m
.5 .5 L
s
.72727 .04545 m
.27273 .04545 L
s
.72727 .04545 m
.95455 .5 L
s
.72727 .04545 m
.5 .5 L
s
.95455 .5 m
.72727 .95455 L
s
.95455 .5 m
.72727 .04545 L
s
.95455 .5 m
.5 .5 L
s
.5 .5 m
.95455 .5 L
s
.5 .5 m
.5 .5 L
s
.5 .5 m
.5 .5 L
s
.5 .5 m
.5 .5 L
s
.5 .5 m
.5 .5 L
s
.5 .5 m
.5 .5 L
s
.5 .5 m
.5 .5 L
s
.5 .5 m
.5 .5 L
s
.5 .5 m
.5 .5 L
s
.5 .5 m
.5 .5 L
s
.5 .5 m
.5 .5 L
s
.5 .5 m
.5 .5 L
s
.5 .5 m
.5 .5 L
s
.5 .5 m
.5 .5 L
s
.5 .5 m
.5 .5 L
s
.5 .5 m
.5 .5 L
s
.5 .5 m
.5 .5 L
s
.5 .5 m
.5 .5 L
s
.5 .5 m
.5 .5 L
s
.5 .5 m
.5 .5 L
s
.5 .5 m
.5 .5 L
s
.5 .5 m
.5 .5 L
s
.5 .5 m
.5 .5 L
s
.5 .5 m
.5 .5 L
s
.5 .5 m
.5 .5 L
s
.5 .5 m
.5 .5 L
s
.5 .5 m
.5 .5 L
s
.5 .5 m
.5 .5 L
s
.5 .5 m
.5 .5 L
s
.5 .5 m
.5 .5 L
s
.5 .5 m
.5 .5 L
s
.5 .5 m
.04545 .5 L
s
.5 .5 m
.5 .5 L
s
.5 .5 m
.5 .5 L
s
.5 .5 m
.5 .5 L
s
.5 .5 m
.27273 .04545 L
s
.5 .5 m
.5 .5 L
s
.5 .5 m
.5 .5 L
s
.5 .5 m
.5 .5 L
s
.5 .5 m
.5 .5 L
s
.5 .5 m
.5 .5 L
s
.5 .5 m
.5 .5 L
s
.5 .5 m
.5 .5 L
s
.5 .5 m
.5 .5 L
s
.5 .5 m
.5 .5 L
s
.5 .5 m
.5 .5 L
s
.5 .5 m
.5 .5 L
s
.5 .5 m
.5 .5 L
s
.5 .5 m
.5 .5 L
s
.5 .5 m
.5 .5 L
s
.5 .5 m
.5 .5 L
s
.5 .5 m
.72727 .04545 L
s
.5 .5 m
.5 .5 L
s
.5 .5 m
.5 .5 L
s
.5 .5 m
.5 .5 L
s
.5 .5 m
.5 .5 L
s
.5 .5 m
.5 .5 L
s
.5 .5 m
.5 .5 L
s
.5 .5 m
.5 .5 L
s
.5 .5 m
.72727 .95455 L
s
.5 .5 m
.5 .5 L
s
.5 .5 m
.5 .5 L
s
.5 .5 m
.5 .5 L
s
.5 .5 m
.5 .5 L
s
.5 .5 m
.5 .5 L
s
.5 .5 m
.5 .5 L
s
.5 .5 m
.5 .5 L
s
.5 .5 m
.5 .5 L
s
.5 .5 m
.5 .5 L
s
.5 .5 m
.5 .5 L
s
.5 .5 m
.5 .5 L
s
.5 .5 m
.5 .5 L
s
.5 .5 m
.5 .5 L
s
.5 .5 m
.5 .5 L
s
.5 .5 m
.5 .5 L
s
.5 .5 m
.5 .5 L
s
.5 .5 m
.5 .5 L
s
.5 .5 m
.5 .5 L
s
.5 .5 m
.5 .5 L
s
.5 .5 m
.5 .5 L
s
.5 .5 m
.5 .5 L
s
.5 .5 m
.5 .5 L
s
.5 .5 m
.5 .5 L
s
.5 .5 m
.5 .5 L
s
.5 .5 m
.5 .5 L
s
.5 .5 m
.5 .5 L
s
.5 .5 m
.5 .5 L
s
.5 .5 m
.5 .5 L
s
.5 .5 m
.5 .5 L
s
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  ImageSize->{288, 288},
  ImageMargins->{{43, 0}, {0, 0}},
  ImageRegion->{{0, 1}, {0, 1}},
  ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`40004P000182000`400?l00000o`00003oo`3ooolQ
0?ooo`00o`3ooolQ0?ooo`00o`3ooolQ0?ooo`00o`3ooolQ0?ooo`00o`3ooolQ0?ooo`00o`3ooolQ
0?ooo`00o`3ooolQ0?ooo`00o`3ooolQ0?ooo`00o`3ooolQ0?ooo`00o`3ooolQ0?ooo`00o`3ooolQ
0?ooo`00o`3ooolQ0?ooo`00C03oool300000800oooo0`00001>0?ooo`00B`3oool5000007h0oooo
1@00001=0?ooo`00B`3ooon8000004d0oooo001;0?ooo`D00000OP3oool5000004d0oooo001<0?oo
o`@00000O`3oool3000004h0oooo001<0?ooo`040000003oool0oooo000007h0oooo00@000000?oo
o`3oool00000CP3oool004`0oooo00D000000?ooo`3oool0oooo0000001m0?ooo`050000003oool0
oooo0?ooo`000000C@3oool004/0oooo00<000000?ooo`3oool00P3oool00`000000oooo0?ooo`1j
0?ooo`030000003oool0oooo0080oooo00<000000?ooo`3oool0B`3oool004/0oooo00<000000?oo
o`3oool00`3oool00`000000oooo0?ooo`1i0?ooo`030000003oool0oooo00<0oooo00<000000?oo
o`3oool0BP3oool004X0oooo00<000000?ooo`3oool0103oool00`000000oooo0?ooo`1h0?ooo`03
0000003oool0oooo00@0oooo00<000000?ooo`3oool0BP3oool004X0oooo00<000000?ooo`3oool0
1@3oool00`000000oooo0?ooo`1g0?ooo`030000003oool0oooo00D0oooo00<000000?ooo`3oool0
B@3oool004T0oooo00<000000?ooo`3oool01P3oool00`000000oooo0?ooo`1f0?ooo`030000003o
ool0oooo00H0oooo00<000000?ooo`3oool0B@3oool004T0oooo00<000000?ooo`3oool01`3oool0
0`000000oooo0?ooo`1e0?ooo`030000003oool0oooo00L0oooo00<000000?ooo`3oool0B03oool0
04P0oooo00<000000?ooo`3oool0203oool00`000000oooo0?ooo`1d0?ooo`030000003oool0oooo
00P0oooo00<000000?ooo`3oool0B03oool004P0oooo00<000000?ooo`3oool02@3oool00`000000
oooo0?ooo`1c0?ooo`030000003oool0oooo00T0oooo00<000000?ooo`3oool0A`3oool004L0oooo
00<000000?ooo`3oool02P3oool00`000000oooo0?ooo`1b0?ooo`030000003oool0oooo00X0oooo
00<000000?ooo`3oool0A`3oool004L0oooo00<000000?ooo`3oool02`3oool00`000000oooo0?oo
o`1a0?ooo`030000003oool0oooo00/0oooo00<000000?ooo`3oool0AP3oool004H0oooo00<00000
0?ooo`3oool0303oool00`000000oooo0?ooo`1`0?ooo`030000003oool0oooo00`0oooo00<00000
0?ooo`3oool0AP3oool004H0oooo00<000000?ooo`3oool03@3oool00`000000oooo0?ooo`1_0?oo
o`030000003oool0oooo00d0oooo00<000000?ooo`3oool0A@3oool004D0oooo00<000000?ooo`3o
ool03P3oool00`000000oooo0?ooo`1^0?ooo`030000003oool0oooo00h0oooo00<000000?ooo`3o
ool0A@3oool004D0oooo00<000000?ooo`3oool03`3oool00`000000oooo0?ooo`1]0?ooo`030000
003oool0oooo00l0oooo00<000000?ooo`3oool0A03oool004@0oooo00<000000?ooo`3oool0403o
ool00`000000oooo0?ooo`1/0?ooo`030000003oool0oooo0100oooo00<000000?ooo`3oool0A03o
ool004@0oooo00<000000?ooo`3oool04@3oool00`000000oooo0?ooo`1[0?ooo`030000003oool0
oooo0140oooo00<000000?ooo`3oool0@`3oool004<0oooo00<000000?ooo`3oool04P3oool00`00
0000oooo0?ooo`1Z0?ooo`030000003oool0oooo0180oooo00<000000?ooo`3oool0@`3oool004<0
oooo00<000000?ooo`3oool04`3oool00`000000oooo0?ooo`1Y0?ooo`030000003oool0oooo01<0
oooo00<000000?ooo`3oool0@P3oool00480oooo00<000000?ooo`3oool0503oool00`000000oooo
0?ooo`1X0?ooo`030000003oool0oooo01@0oooo00<000000?ooo`3oool0@P3oool00480oooo00<0
00000?ooo`3oool05@3oool00`000000oooo0?ooo`1W0?ooo`030000003oool0oooo01D0oooo00<0
00000?ooo`3oool0@@3oool00440oooo00<000000?ooo`3oool05P3oool00`000000oooo0?ooo`1V
0?ooo`030000003oool0oooo01H0oooo00<000000?ooo`3oool0@@3oool00440oooo00<000000?oo
o`3oool05`3oool00`000000oooo0?ooo`1U0?ooo`030000003oool0oooo01L0oooo00<000000?oo
o`3oool0@03oool00400oooo00<000000?ooo`3oool0603oool00`000000oooo0?ooo`1T0?ooo`03
0000003oool0oooo01P0oooo00<000000?ooo`3oool0@03oool00400oooo00<000000?ooo`3oool0
6@3oool00`000000oooo0?ooo`1S0?ooo`030000003oool0oooo01T0oooo00<000000?ooo`3oool0
?`3oool003l0oooo00<000000?ooo`3oool06P3oool00`000000oooo0?ooo`1R0?ooo`030000003o
ool0oooo01X0oooo00<000000?ooo`3oool0?`3oool003l0oooo00<000000?ooo`3oool06`3oool0
0`000000oooo0?ooo`1Q0?ooo`030000003oool0oooo01/0oooo00<000000?ooo`3oool0?P3oool0
03h0oooo00<000000?ooo`3oool0703oool00`000000oooo0?ooo`1P0?ooo`030000003oool0oooo
01`0oooo00<000000?ooo`3oool0?P3oool003h0oooo00<000000?ooo`3oool07@3oool00`000000
oooo0?ooo`1O0?ooo`030000003oool0oooo01d0oooo00<000000?ooo`3oool0?@3oool003d0oooo
00<000000?ooo`3oool07P3oool00`000000oooo0?ooo`1N0?ooo`030000003oool0oooo01h0oooo
00<000000?ooo`3oool0?@3oool003d0oooo00<000000?ooo`3oool07`3oool00`000000oooo0?oo
o`1M0?ooo`030000003oool0oooo01l0oooo00<000000?ooo`3oool0?03oool003`0oooo00<00000
0?ooo`3oool0803oool00`000000oooo0?ooo`1L0?ooo`030000003oool0oooo0200oooo00<00000
0?ooo`3oool0?03oool003`0oooo00<000000?ooo`3oool08@3oool00`000000oooo0?ooo`1K0?oo
o`030000003oool0oooo0240oooo00<000000?ooo`3oool0>`3oool003/0oooo00<000000?ooo`3o
ool08P3oool00`000000oooo0?ooo`1J0?ooo`030000003oool0oooo0280oooo00<000000?ooo`3o
ool0>`3oool003/0oooo00<000000?ooo`3oool08`3oool00`000000oooo0?ooo`1I0?ooo`030000
003oool0oooo02<0oooo00<000000?ooo`3oool0>P3oool003X0oooo00<000000?ooo`3oool0903o
ool00`000000oooo0?ooo`1H0?ooo`030000003oool0oooo02@0oooo00<000000?ooo`3oool0>P3o
ool003X0oooo00<000000?ooo`3oool09@3oool00`000000oooo0?ooo`1G0?ooo`030000003oool0
oooo02D0oooo00<000000?ooo`3oool0>@3oool003T0oooo00<000000?ooo`3oool09P3oool00`00
0000oooo0?ooo`1F0?ooo`030000003oool0oooo02H0oooo00<000000?ooo`3oool0>@3oool003T0
oooo00<000000?ooo`3oool09`3oool00`000000oooo0?ooo`1E0?ooo`030000003oool0oooo02L0
oooo00<000000?ooo`3oool0>03oool003P0oooo00<000000?ooo`3oool0:03oool00`000000oooo
0?ooo`1D0?ooo`030000003oool0oooo02P0oooo00<000000?ooo`3oool0>03oool003P0oooo00<0
00000?ooo`3oool0:@3oool00`000000oooo0?ooo`1C0?ooo`030000003oool0oooo02T0oooo00<0
00000?ooo`3oool0=`3oool003L0oooo00<000000?ooo`3oool0:P3oool00`000000oooo0?ooo`1B
0?ooo`030000003oool0oooo02X0oooo00<000000?ooo`3oool0=`3oool003L0oooo00<000000?oo
o`3oool0:`3oool00`000000oooo0?ooo`1A0?ooo`030000003oool0oooo02/0oooo00<000000?oo
o`3oool0=P3oool003H0oooo00<000000?ooo`3oool0;03oool00`000000oooo0?ooo`1@0?ooo`03
0000003oool0oooo02`0oooo00<000000?ooo`3oool0=P3oool003H0oooo00<000000?ooo`3oool0
;@3oool00`000000oooo0?ooo`1?0?ooo`030000003oool0oooo02d0oooo00<000000?ooo`3oool0
=@3oool003D0oooo00<000000?ooo`3oool0;P3oool00`000000oooo0?ooo`1>0?ooo`030000003o
ool0oooo02h0oooo00<000000?ooo`3oool0=@3oool003D0oooo00<000000?ooo`3oool0;`3oool0
0`000000oooo0?ooo`1=0?ooo`030000003oool0oooo02l0oooo00<000000?ooo`3oool0=03oool0
03@0oooo00<000000?ooo`3oool0<03oool00`000000oooo0?ooo`1<0?ooo`030000003oool0oooo
0300oooo00<000000?ooo`3oool0=03oool003@0oooo00<000000?ooo`3oool0<@3oool00`000000
oooo0?ooo`1;0?ooo`030000003oool0oooo0340oooo00<000000?ooo`3oool0<`3oool003<0oooo
00<000000?ooo`3oool0<P3oool00`000000oooo0?ooo`1:0?ooo`030000003oool0oooo0380oooo
00<000000?ooo`3oool0<`3oool003<0oooo00<000000?ooo`3oool0<`3oool00`000000oooo0?oo
o`190?ooo`030000003oool0oooo03<0oooo00<000000?ooo`3oool0<P3oool00380oooo00<00000
0?ooo`3oool0=03oool00`000000oooo0?ooo`180?ooo`030000003oool0oooo03@0oooo00<00000
0?ooo`3oool0<P3oool00380oooo00<000000?ooo`3oool0=@3oool00`000000oooo0?ooo`170?oo
o`030000003oool0oooo03D0oooo00<000000?ooo`3oool0<@3oool00340oooo00<000000?ooo`3o
ool0=P3oool00`000000oooo0?ooo`160?ooo`030000003oool0oooo03H0oooo00<000000?ooo`3o
ool0<@3oool00340oooo00<000000?ooo`3oool0=`3oool00`000000oooo0?ooo`150?ooo`030000
003oool0oooo03L0oooo00<000000?ooo`3oool0<03oool00300oooo00<000000?ooo`3oool0>03o
ool00`000000oooo0?ooo`140?ooo`030000003oool0oooo03P0oooo00<000000?ooo`3oool0<03o
ool00300oooo00<000000?ooo`3oool0>@3oool00`000000oooo0?ooo`130?ooo`030000003oool0
oooo03T0oooo00<000000?ooo`3oool0;`3oool002l0oooo00<000000?ooo`3oool0>P3oool00`00
0000oooo0?ooo`120?ooo`030000003oool0oooo03X0oooo00<000000?ooo`3oool0;`3oool002l0
oooo00<000000?ooo`3oool0>`3oool00`000000oooo0?ooo`110?ooo`030000003oool0oooo03/0
oooo00<000000?ooo`3oool0;P3oool002h0oooo00<000000?ooo`3oool0?03oool00`000000oooo
0?ooo`100?ooo`030000003oool0oooo03`0oooo00<000000?ooo`3oool0;P3oool002h0oooo00<0
00000?ooo`3oool0?@3oool00`000000oooo0?ooo`0o0?ooo`030000003oool0oooo03d0oooo00<0
00000?ooo`3oool0;@3oool002d0oooo00<000000?ooo`3oool0?P3oool00`000000oooo0?ooo`0n
0?ooo`030000003oool0oooo03h0oooo00<000000?ooo`3oool0;@3oool002d0oooo00<000000?oo
o`3oool0?`3oool00`000000oooo0?ooo`0m0?ooo`030000003oool0oooo03l0oooo00<000000?oo
o`3oool0;03oool002`0oooo00<000000?ooo`3oool0@03oool00`000000oooo0?ooo`0l0?ooo`03
0000003oool0oooo0400oooo00<000000?ooo`3oool0;03oool002`0oooo00<000000?ooo`3oool0
@@3oool00`000000oooo0?ooo`0k0?ooo`030000003oool0oooo0440oooo00<000000?ooo`3oool0
:`3oool002/0oooo00<000000?ooo`3oool0@P3oool00`000000oooo0?ooo`0j0?ooo`030000003o
ool0oooo0480oooo00<000000?ooo`3oool0:`3oool002/0oooo00<000000?ooo`3oool0@`3oool0
0`000000oooo0?ooo`0i0?ooo`030000003oool0oooo04<0oooo00<000000?ooo`3oool0:P3oool0
02X0oooo00<000000?ooo`3oool0A03oool00`000000oooo0?ooo`0h0?ooo`030000003oool0oooo
04@0oooo00<000000?ooo`3oool0:P3oool002X0oooo00<000000?ooo`3oool0A@3oool00`000000
oooo0?ooo`0g0?ooo`030000003oool0oooo04D0oooo00<000000?ooo`3oool0:@3oool002T0oooo
00<000000?ooo`3oool0AP3oool00`000000oooo0?ooo`0f0?ooo`030000003oool0oooo04H0oooo
00<000000?ooo`3oool0:@3oool002T0oooo00<000000?ooo`3oool0A`3oool00`000000oooo0?oo
o`0e0?ooo`030000003oool0oooo04L0oooo00<000000?ooo`3oool0:03oool002P0oooo00<00000
0?ooo`3oool0B03oool00`000000oooo0?ooo`0d0?ooo`030000003oool0oooo04P0oooo00<00000
0?ooo`3oool0:03oool002P0oooo00<000000?ooo`3oool0B@3oool00`000000oooo0?ooo`0c0?oo
o`030000003oool0oooo04T0oooo00<000000?ooo`3oool09`3oool002L0oooo00<000000?ooo`3o
ool0BP3oool00`000000oooo0?ooo`0b0?ooo`030000003oool0oooo04X0oooo00<000000?ooo`3o
ool09`3oool002L0oooo00<000000?ooo`3oool0B`3oool00`000000oooo0?ooo`0a0?ooo`030000
003oool0oooo04/0oooo00<000000?ooo`3oool09P3oool002H0oooo00<000000?ooo`3oool0C03o
ool00`000000oooo0?ooo`0`0?ooo`030000003oool0oooo04`0oooo00<000000?ooo`3oool09P3o
ool002H0oooo00<000000?ooo`3oool0C@3oool00`000000oooo0?ooo`0_0?ooo`030000003oool0
oooo04d0oooo00<000000?ooo`3oool09@3oool002D0oooo00<000000?ooo`3oool0CP3oool00`00
0000oooo0?ooo`0^0?ooo`030000003oool0oooo04h0oooo00<000000?ooo`3oool09@3oool002D0
oooo00<000000?ooo`3oool0C`3oool00`000000oooo0?ooo`0]0?ooo`030000003oool0oooo04l0
oooo00<000000?ooo`3oool0903oool002@0oooo00<000000?ooo`3oool0D03oool00`000000oooo
0?ooo`0/0?ooo`030000003oool0oooo0500oooo00<000000?ooo`3oool0903oool002@0oooo00<0
00000?ooo`3oool0D@3oool00`000000oooo0?ooo`0[0?ooo`030000003oool0oooo0540oooo00<0
00000?ooo`3oool08`3oool002<0oooo00<000000?ooo`3oool0DP3oool00`000000oooo0?ooo`0Z
0?ooo`030000003oool0oooo0580oooo00<000000?ooo`3oool08`3oool002<0oooo00<000000?oo
o`3oool0D`3oool00`000000oooo0?ooo`0Y0?ooo`030000003oool0oooo05<0oooo00<000000?oo
o`3oool08P3oool00280oooo00<000000?ooo`3oool0E03oool00`000000oooo0?ooo`0X0?ooo`03
0000003oool0oooo05@0oooo00<000000?ooo`3oool08P3oool00280oooo00<000000?ooo`3oool0
E@3oool00`000000oooo0?ooo`0W0?ooo`030000003oool0oooo05D0oooo00<000000?ooo`3oool0
8@3oool00240oooo00<000000?ooo`3oool0EP3oool00`000000oooo0?ooo`0V0?ooo`030000003o
ool0oooo05H0oooo00<000000?ooo`3oool08@3oool00240oooo00<000000?ooo`3oool0E`3oool0
0`000000oooo0?ooo`0U0?ooo`030000003oool0oooo05L0oooo00<000000?ooo`3oool0803oool0
0200oooo00<000000?ooo`3oool0F03oool00`000000oooo0?ooo`0T0?ooo`030000003oool0oooo
05P0oooo00<000000?ooo`3oool0803oool00200oooo00<000000?ooo`3oool0F@3oool00`000000
oooo0?ooo`0S0?ooo`030000003oool0oooo05T0oooo00<000000?ooo`3oool07`3oool001l0oooo
00<000000?ooo`3oool0FP3oool00`000000oooo0?ooo`0R0?ooo`030000003oool0oooo05X0oooo
00<000000?ooo`3oool07`3oool001l0oooo00<000000?ooo`3oool0F`3oool00`000000oooo0?oo
o`0Q0?ooo`030000003oool0oooo05/0oooo00<000000?ooo`3oool07P3oool001h0oooo00<00000
0?ooo`3oool0G03oool00`000000oooo0?ooo`0P0?ooo`030000003oool0oooo05`0oooo00<00000
0?ooo`3oool07P3oool001h0oooo00<000000?ooo`3oool0G@3oool00`000000oooo0?ooo`0O0?oo
o`030000003oool0oooo05d0oooo00<000000?ooo`3oool07@3oool001d0oooo00<000000?ooo`3o
ool0GP3oool00`000000oooo0?ooo`0N0?ooo`030000003oool0oooo05h0oooo00<000000?ooo`3o
ool07@3oool001d0oooo00<000000?ooo`3oool0G`3oool00`000000oooo0?ooo`0M0?ooo`030000
003oool0oooo05l0oooo00<000000?ooo`3oool0703oool001`0oooo00<000000?ooo`3oool0H03o
ool00`000000oooo0?ooo`0L0?ooo`030000003oool0oooo0600oooo00<000000?ooo`3oool0703o
ool001`0oooo00<000000?ooo`3oool0H@3oool00`000000oooo0?ooo`0K0?ooo`030000003oool0
oooo0640oooo00<000000?ooo`3oool06`3oool001/0oooo00<000000?ooo`3oool0HP3oool00`00
0000oooo0?ooo`0J0?ooo`030000003oool0oooo0680oooo00<000000?ooo`3oool06`3oool001/0
oooo00<000000?ooo`3oool0H`3oool00`000000oooo0?ooo`0I0?ooo`030000003oool0oooo06<0
oooo00<000000?ooo`3oool06P3oool001X0oooo00<000000?ooo`3oool0I03oool00`000000oooo
0?ooo`0H0?ooo`030000003oool0oooo06@0oooo00<000000?ooo`3oool06P3oool001X0oooo00<0
00000?ooo`3oool0I@3oool00`000000oooo0?ooo`0G0?ooo`030000003oool0oooo06D0oooo00<0
00000?ooo`3oool06@3oool001T0oooo00<000000?ooo`3oool0IP3oool00`000000oooo0?ooo`0F
0?ooo`030000003oool0oooo06H0oooo00<000000?ooo`3oool06@3oool001T0oooo00<000000?oo
o`3oool0I`3oool00`000000oooo0?ooo`0E0?ooo`030000003oool0oooo06L0oooo00<000000?oo
o`3oool0603oool001P0oooo00<000000?ooo`3oool0J03oool00`000000oooo0?ooo`0D0?ooo`03
0000003oool0oooo06P0oooo00<000000?ooo`3oool0603oool001P0oooo00<000000?ooo`3oool0
J@3oool00`000000oooo0?ooo`0C0?ooo`030000003oool0oooo06T0oooo00<000000?ooo`3oool0
5`3oool001L0oooo00<000000?ooo`3oool0JP3oool00`000000oooo0?ooo`0B0?ooo`030000003o
ool0oooo06X0oooo00<000000?ooo`3oool05`3oool001L0oooo00<000000?ooo`3oool0J`3oool0
0`000000oooo0?ooo`0A0?ooo`030000003oool0oooo06/0oooo00<000000?ooo`3oool05P3oool0
01H0oooo00<000000?ooo`3oool0K03oool00`000000oooo0?ooo`0@0?ooo`030000003oool0oooo
06`0oooo00<000000?ooo`3oool05P3oool001H0oooo00<000000?ooo`3oool0K@3oool00`000000
oooo0?ooo`0?0?ooo`030000003oool0oooo06d0oooo00<000000?ooo`3oool05@3oool001D0oooo
00<000000?ooo`3oool0KP3oool00`000000oooo0?ooo`0>0?ooo`030000003oool0oooo06h0oooo
00<000000?ooo`3oool05@3oool001D0oooo00<000000?ooo`3oool0K`3oool00`000000oooo0?oo
o`0=0?ooo`030000003oool0oooo06l0oooo00<000000?ooo`3oool0503oool001@0oooo00<00000
0?ooo`3oool0L03oool00`000000oooo0?ooo`0<0?ooo`030000003oool0oooo0700oooo00<00000
0?ooo`3oool0503oool001@0oooo00<000000?ooo`3oool0L@3oool00`000000oooo0?ooo`0;0?oo
o`030000003oool0oooo0740oooo00<000000?ooo`3oool04`3oool001<0oooo00<000000?ooo`3o
ool0LP3oool00`000000oooo0?ooo`0:0?ooo`030000003oool0oooo0780oooo00<000000?ooo`3o
ool04`3oool001<0oooo00<000000?ooo`3oool0L`3oool00`000000oooo0?ooo`090?ooo`030000
003oool0oooo07<0oooo00<000000?ooo`3oool04P3oool00180oooo00<000000?ooo`3oool0M03o
ool00`000000oooo0?ooo`080?ooo`030000003oool0oooo07@0oooo00<000000?ooo`3oool04P3o
ool00180oooo00<000000?ooo`3oool0M@3oool00`000000oooo0?ooo`070?ooo`030000003oool0
oooo07D0oooo00<000000?ooo`3oool04@3oool00140oooo00<000000?ooo`3oool0MP3oool00`00
0000oooo0?ooo`060?ooo`030000003oool0oooo07H0oooo00<000000?ooo`3oool04@3oool00140
oooo00<000000?ooo`3oool0M`3oool00`000000oooo0?ooo`050?ooo`030000003oool0oooo07L0
oooo00<000000?ooo`3oool0403oool00100oooo00<000000?ooo`3oool0N03oool00`000000oooo
0?ooo`040?ooo`030000003oool0oooo07P0oooo00<000000?ooo`3oool0403oool00100oooo00<0
00000?ooo`3oool0N@3oool00`000000oooo0?ooo`030?ooo`030000003oool0oooo07T0oooo00<0
00000?ooo`3oool03`3oool000l0oooo00<000000?ooo`3oool0NP3oool00`000000oooo0?ooo`02
0?ooo`030000003oool0oooo07X0oooo00<000000?ooo`3oool03`3oool000l0oooo00<000000?oo
o`3oool0N`3oool01@000000oooo0?ooo`3oool0000007d0oooo00<000000?ooo`3oool03P3oool0
00h0oooo00<000000?ooo`3oool0O03oool010000000oooo0?ooo`00001n0?ooo`030000003oool0
oooo00h0oooo000;0?ooo`@00000O`3oool3000007l0oooo0`00000=0?ooo`002P3oool5000007h0
oooo1@00001m0?ooo`D00000303oool000X0ooooo`00000;000000`0oooo000:0?ooo`D00000OP3o
ool5000007d0oooo1@00000<0?ooo`002`3oool4000007l0oooo0`00001o0?ooo`<000003@3oool0
00h0oooo00<000000?ooo`3oool0O03oool010000000oooo0?ooo`00001n0?ooo`030000003oool0
oooo00h0oooo000?0?ooo`030000003oool0oooo07/0oooo00D000000?ooo`3oool0oooo0000001m
0?ooo`030000003oool0oooo00h0oooo000?0?ooo`030000003oool0oooo07X0oooo00<000000?oo
o`3oool00P3oool00`000000oooo0?ooo`1j0?ooo`030000003oool0oooo00l0oooo000@0?ooo`03
0000003oool0oooo07T0oooo00<000000?ooo`3oool00`3oool00`000000oooo0?ooo`1i0?ooo`03
0000003oool0oooo00l0oooo000@0?ooo`030000003oool0oooo07P0oooo00<000000?ooo`3oool0
103oool00`000000oooo0?ooo`1h0?ooo`030000003oool0oooo0100oooo000A0?ooo`030000003o
ool0oooo07L0oooo00<000000?ooo`3oool01@3oool00`000000oooo0?ooo`1g0?ooo`030000003o
ool0oooo0100oooo000A0?ooo`030000003oool0oooo07H0oooo00<000000?ooo`3oool01P3oool0
0`000000oooo0?ooo`1f0?ooo`030000003oool0oooo0140oooo000B0?ooo`030000003oool0oooo
07D0oooo00<000000?ooo`3oool01`3oool00`000000oooo0?ooo`1e0?ooo`030000003oool0oooo
0140oooo000B0?ooo`030000003oool0oooo07@0oooo00<000000?ooo`3oool0203oool00`000000
oooo0?ooo`1d0?ooo`030000003oool0oooo0180oooo000C0?ooo`030000003oool0oooo07<0oooo
00<000000?ooo`3oool02@3oool00`000000oooo0?ooo`1c0?ooo`030000003oool0oooo0180oooo
000C0?ooo`030000003oool0oooo0780oooo00<000000?ooo`3oool02P3oool00`000000oooo0?oo
o`1b0?ooo`030000003oool0oooo01<0oooo000D0?ooo`030000003oool0oooo0740oooo00<00000
0?ooo`3oool02`3oool00`000000oooo0?ooo`1a0?ooo`030000003oool0oooo01<0oooo000D0?oo
o`030000003oool0oooo0700oooo00<000000?ooo`3oool0303oool00`000000oooo0?ooo`1`0?oo
o`030000003oool0oooo01@0oooo000E0?ooo`030000003oool0oooo06l0oooo00<000000?ooo`3o
ool03@3oool00`000000oooo0?ooo`1_0?ooo`030000003oool0oooo01@0oooo000E0?ooo`030000
003oool0oooo06h0oooo00<000000?ooo`3oool03P3oool00`000000oooo0?ooo`1^0?ooo`030000
003oool0oooo01D0oooo000F0?ooo`030000003oool0oooo06d0oooo00<000000?ooo`3oool03`3o
ool00`000000oooo0?ooo`1]0?ooo`030000003oool0oooo01D0oooo000F0?ooo`030000003oool0
oooo06`0oooo00<000000?ooo`3oool0403oool00`000000oooo0?ooo`1/0?ooo`030000003oool0
oooo01H0oooo000G0?ooo`030000003oool0oooo06/0oooo00<000000?ooo`3oool04@3oool00`00
0000oooo0?ooo`1[0?ooo`030000003oool0oooo01H0oooo000G0?ooo`030000003oool0oooo06X0
oooo00<000000?ooo`3oool04P3oool00`000000oooo0?ooo`1Z0?ooo`030000003oool0oooo01L0
oooo000H0?ooo`030000003oool0oooo06T0oooo00<000000?ooo`3oool04`3oool00`000000oooo
0?ooo`1Y0?ooo`030000003oool0oooo01L0oooo000H0?ooo`030000003oool0oooo06P0oooo00<0
00000?ooo`3oool0503oool00`000000oooo0?ooo`1X0?ooo`030000003oool0oooo01P0oooo000I
0?ooo`030000003oool0oooo06L0oooo00<000000?ooo`3oool05@3oool00`000000oooo0?ooo`1W
0?ooo`030000003oool0oooo01P0oooo000I0?ooo`030000003oool0oooo06H0oooo00<000000?oo
o`3oool05P3oool00`000000oooo0?ooo`1V0?ooo`030000003oool0oooo01T0oooo000J0?ooo`03
0000003oool0oooo06D0oooo00<000000?ooo`3oool05`3oool00`000000oooo0?ooo`1U0?ooo`03
0000003oool0oooo01T0oooo000J0?ooo`030000003oool0oooo06@0oooo00<000000?ooo`3oool0
603oool00`000000oooo0?ooo`1T0?ooo`030000003oool0oooo01X0oooo000K0?ooo`030000003o
ool0oooo06<0oooo00<000000?ooo`3oool06@3oool00`000000oooo0?ooo`1S0?ooo`030000003o
ool0oooo01X0oooo000K0?ooo`030000003oool0oooo0680oooo00<000000?ooo`3oool06P3oool0
0`000000oooo0?ooo`1R0?ooo`030000003oool0oooo01/0oooo000L0?ooo`030000003oool0oooo
0640oooo00<000000?ooo`3oool06`3oool00`000000oooo0?ooo`1Q0?ooo`030000003oool0oooo
01/0oooo000L0?ooo`030000003oool0oooo0600oooo00<000000?ooo`3oool0703oool00`000000
oooo0?ooo`1P0?ooo`030000003oool0oooo01`0oooo000M0?ooo`030000003oool0oooo05l0oooo
00<000000?ooo`3oool07@3oool00`000000oooo0?ooo`1O0?ooo`030000003oool0oooo01`0oooo
000M0?ooo`030000003oool0oooo05h0oooo00<000000?ooo`3oool07P3oool00`000000oooo0?oo
o`1N0?ooo`030000003oool0oooo01d0oooo000N0?ooo`030000003oool0oooo05d0oooo00<00000
0?ooo`3oool07`3oool00`000000oooo0?ooo`1M0?ooo`030000003oool0oooo01d0oooo000N0?oo
o`030000003oool0oooo05`0oooo00<000000?ooo`3oool0803oool00`000000oooo0?ooo`1L0?oo
o`030000003oool0oooo01h0oooo000O0?ooo`030000003oool0oooo05/0oooo00<000000?ooo`3o
ool08@3oool00`000000oooo0?ooo`1K0?ooo`030000003oool0oooo01h0oooo000O0?ooo`030000
003oool0oooo05X0oooo00<000000?ooo`3oool08P3oool00`000000oooo0?ooo`1J0?ooo`030000
003oool0oooo01l0oooo000P0?ooo`030000003oool0oooo05T0oooo00<000000?ooo`3oool08`3o
ool00`000000oooo0?ooo`1I0?ooo`030000003oool0oooo01l0oooo000P0?ooo`030000003oool0
oooo05P0oooo00<000000?ooo`3oool0903oool00`000000oooo0?ooo`1H0?ooo`030000003oool0
oooo0200oooo000Q0?ooo`030000003oool0oooo05L0oooo00<000000?ooo`3oool09@3oool00`00
0000oooo0?ooo`1G0?ooo`030000003oool0oooo0200oooo000Q0?ooo`030000003oool0oooo05H0
oooo00<000000?ooo`3oool09P3oool00`000000oooo0?ooo`1F0?ooo`030000003oool0oooo0240
oooo000R0?ooo`030000003oool0oooo05D0oooo00<000000?ooo`3oool09`3oool00`000000oooo
0?ooo`1E0?ooo`030000003oool0oooo0240oooo000R0?ooo`030000003oool0oooo05@0oooo00<0
00000?ooo`3oool0:03oool00`000000oooo0?ooo`1D0?ooo`030000003oool0oooo0280oooo000S
0?ooo`030000003oool0oooo05<0oooo00<000000?ooo`3oool0:@3oool00`000000oooo0?ooo`1C
0?ooo`030000003oool0oooo0280oooo000S0?ooo`030000003oool0oooo0580oooo00<000000?oo
o`3oool0:P3oool00`000000oooo0?ooo`1B0?ooo`030000003oool0oooo02<0oooo000T0?ooo`03
0000003oool0oooo0540oooo00<000000?ooo`3oool0:`3oool00`000000oooo0?ooo`1A0?ooo`03
0000003oool0oooo02<0oooo000T0?ooo`030000003oool0oooo0500oooo00<000000?ooo`3oool0
;03oool00`000000oooo0?ooo`1@0?ooo`030000003oool0oooo02@0oooo000U0?ooo`030000003o
ool0oooo04l0oooo00<000000?ooo`3oool0;@3oool00`000000oooo0?ooo`1?0?ooo`030000003o
ool0oooo02@0oooo000U0?ooo`030000003oool0oooo04h0oooo00<000000?ooo`3oool0;P3oool0
0`000000oooo0?ooo`1>0?ooo`030000003oool0oooo02D0oooo000V0?ooo`030000003oool0oooo
04d0oooo00<000000?ooo`3oool0;`3oool00`000000oooo0?ooo`1=0?ooo`030000003oool0oooo
02D0oooo000V0?ooo`030000003oool0oooo04`0oooo00<000000?ooo`3oool0<03oool00`000000
oooo0?ooo`1<0?ooo`030000003oool0oooo02H0oooo000W0?ooo`030000003oool0oooo04/0oooo
00<000000?ooo`3oool0<@3oool00`000000oooo0?ooo`1;0?ooo`030000003oool0oooo02H0oooo
000W0?ooo`030000003oool0oooo04X0oooo00<000000?ooo`3oool0<P3oool00`000000oooo0?oo
o`1:0?ooo`030000003oool0oooo02L0oooo000X0?ooo`030000003oool0oooo04T0oooo00<00000
0?ooo`3oool0<`3oool00`000000oooo0?ooo`190?ooo`030000003oool0oooo02L0oooo000X0?oo
o`030000003oool0oooo04P0oooo00<000000?ooo`3oool0=03oool00`000000oooo0?ooo`180?oo
o`030000003oool0oooo02P0oooo000Y0?ooo`030000003oool0oooo04L0oooo00<000000?ooo`3o
ool0=@3oool00`000000oooo0?ooo`170?ooo`030000003oool0oooo02P0oooo000Y0?ooo`030000
003oool0oooo04H0oooo00<000000?ooo`3oool0=P3oool00`000000oooo0?ooo`160?ooo`030000
003oool0oooo02T0oooo000Z0?ooo`030000003oool0oooo04D0oooo00<000000?ooo`3oool0=`3o
ool00`000000oooo0?ooo`150?ooo`030000003oool0oooo02T0oooo000Z0?ooo`030000003oool0
oooo04@0oooo00<000000?ooo`3oool0>03oool00`000000oooo0?ooo`140?ooo`030000003oool0
oooo02X0oooo000[0?ooo`030000003oool0oooo04<0oooo00<000000?ooo`3oool0>@3oool00`00
0000oooo0?ooo`130?ooo`030000003oool0oooo02X0oooo000[0?ooo`030000003oool0oooo0480
oooo00<000000?ooo`3oool0>P3oool00`000000oooo0?ooo`120?ooo`030000003oool0oooo02/0
oooo000/0?ooo`030000003oool0oooo0440oooo00<000000?ooo`3oool0>`3oool00`000000oooo
0?ooo`110?ooo`030000003oool0oooo02/0oooo000/0?ooo`030000003oool0oooo0400oooo00<0
00000?ooo`3oool0?03oool00`000000oooo0?ooo`100?ooo`030000003oool0oooo02`0oooo000]
0?ooo`030000003oool0oooo03l0oooo00<000000?ooo`3oool0?@3oool00`000000oooo0?ooo`0o
0?ooo`030000003oool0oooo02`0oooo000]0?ooo`030000003oool0oooo03h0oooo00<000000?oo
o`3oool0?P3oool00`000000oooo0?ooo`0n0?ooo`030000003oool0oooo02d0oooo000^0?ooo`03
0000003oool0oooo03d0oooo00<000000?ooo`3oool0?`3oool00`000000oooo0?ooo`0m0?ooo`03
0000003oool0oooo02d0oooo000^0?ooo`030000003oool0oooo03`0oooo00<000000?ooo`3oool0
@03oool00`000000oooo0?ooo`0l0?ooo`030000003oool0oooo02h0oooo000_0?ooo`030000003o
ool0oooo03/0oooo00<000000?ooo`3oool0@@3oool00`000000oooo0?ooo`0k0?ooo`030000003o
ool0oooo02h0oooo000_0?ooo`030000003oool0oooo03X0oooo00<000000?ooo`3oool0@P3oool0
0`000000oooo0?ooo`0j0?ooo`030000003oool0oooo02l0oooo000`0?ooo`030000003oool0oooo
03T0oooo00<000000?ooo`3oool0@`3oool00`000000oooo0?ooo`0i0?ooo`030000003oool0oooo
02l0oooo000`0?ooo`030000003oool0oooo03P0oooo00<000000?ooo`3oool0A03oool00`000000
oooo0?ooo`0h0?ooo`030000003oool0oooo0300oooo000a0?ooo`030000003oool0oooo03L0oooo
00<000000?ooo`3oool0A@3oool00`000000oooo0?ooo`0g0?ooo`030000003oool0oooo0300oooo
000a0?ooo`030000003oool0oooo03H0oooo00<000000?ooo`3oool0AP3oool00`000000oooo0?oo
o`0f0?ooo`030000003oool0oooo0340oooo000b0?ooo`030000003oool0oooo03D0oooo00<00000
0?ooo`3oool0A`3oool00`000000oooo0?ooo`0e0?ooo`030000003oool0oooo0340oooo000b0?oo
o`030000003oool0oooo03@0oooo00<000000?ooo`3oool0B03oool00`000000oooo0?ooo`0d0?oo
o`030000003oool0oooo0380oooo000c0?ooo`030000003oool0oooo03<0oooo00<000000?ooo`3o
ool0B@3oool00`000000oooo0?ooo`0c0?ooo`030000003oool0oooo0380oooo000c0?ooo`030000
003oool0oooo0380oooo00<000000?ooo`3oool0BP3oool00`000000oooo0?ooo`0b0?ooo`030000
003oool0oooo03<0oooo000d0?ooo`030000003oool0oooo0340oooo00<000000?ooo`3oool0B`3o
ool00`000000oooo0?ooo`0a0?ooo`030000003oool0oooo03<0oooo000d0?ooo`030000003oool0
oooo0300oooo00<000000?ooo`3oool0C03oool00`000000oooo0?ooo`0`0?ooo`030000003oool0
oooo03@0oooo000e0?ooo`030000003oool0oooo02l0oooo00<000000?ooo`3oool0C@3oool00`00
0000oooo0?ooo`0_0?ooo`030000003oool0oooo03@0oooo000e0?ooo`030000003oool0oooo02h0
oooo00<000000?ooo`3oool0CP3oool00`000000oooo0?ooo`0^0?ooo`030000003oool0oooo03D0
oooo000f0?ooo`030000003oool0oooo02d0oooo00<000000?ooo`3oool0C`3oool00`000000oooo
0?ooo`0]0?ooo`030000003oool0oooo03D0oooo000f0?ooo`030000003oool0oooo02`0oooo00<0
00000?ooo`3oool0D03oool00`000000oooo0?ooo`0/0?ooo`030000003oool0oooo03H0oooo000g
0?ooo`030000003oool0oooo02/0oooo00<000000?ooo`3oool0D@3oool00`000000oooo0?ooo`0[
0?ooo`030000003oool0oooo03H0oooo000g0?ooo`030000003oool0oooo02X0oooo00<000000?oo
o`3oool0DP3oool00`000000oooo0?ooo`0Z0?ooo`030000003oool0oooo03L0oooo000h0?ooo`03
0000003oool0oooo02T0oooo00<000000?ooo`3oool0D`3oool00`000000oooo0?ooo`0Y0?ooo`03
0000003oool0oooo03L0oooo000h0?ooo`030000003oool0oooo02P0oooo00<000000?ooo`3oool0
E03oool00`000000oooo0?ooo`0X0?ooo`030000003oool0oooo03P0oooo000i0?ooo`030000003o
ool0oooo02L0oooo00<000000?ooo`3oool0E@3oool00`000000oooo0?ooo`0W0?ooo`030000003o
ool0oooo03P0oooo000i0?ooo`030000003oool0oooo02H0oooo00<000000?ooo`3oool0EP3oool0
0`000000oooo0?ooo`0V0?ooo`030000003oool0oooo03T0oooo000j0?ooo`030000003oool0oooo
02D0oooo00<000000?ooo`3oool0E`3oool00`000000oooo0?ooo`0U0?ooo`030000003oool0oooo
03T0oooo000j0?ooo`030000003oool0oooo02@0oooo00<000000?ooo`3oool0F03oool00`000000
oooo0?ooo`0T0?ooo`030000003oool0oooo03X0oooo000k0?ooo`030000003oool0oooo02<0oooo
00<000000?ooo`3oool0F@3oool00`000000oooo0?ooo`0S0?ooo`030000003oool0oooo03X0oooo
000k0?ooo`030000003oool0oooo0280oooo00<000000?ooo`3oool0FP3oool00`000000oooo0?oo
o`0R0?ooo`030000003oool0oooo03/0oooo000l0?ooo`030000003oool0oooo0240oooo00<00000
0?ooo`3oool0F`3oool00`000000oooo0?ooo`0Q0?ooo`030000003oool0oooo03/0oooo000l0?oo
o`030000003oool0oooo0200oooo00<000000?ooo`3oool0G03oool00`000000oooo0?ooo`0P0?oo
o`030000003oool0oooo03`0oooo000m0?ooo`030000003oool0oooo01l0oooo00<000000?ooo`3o
ool0G@3oool00`000000oooo0?ooo`0O0?ooo`030000003oool0oooo03`0oooo000m0?ooo`030000
003oool0oooo01h0oooo00<000000?ooo`3oool0GP3oool00`000000oooo0?ooo`0N0?ooo`030000
003oool0oooo03d0oooo000n0?ooo`030000003oool0oooo01d0oooo00<000000?ooo`3oool0G`3o
ool00`000000oooo0?ooo`0M0?ooo`030000003oool0oooo03d0oooo000n0?ooo`030000003oool0
oooo01`0oooo00<000000?ooo`3oool0H03oool00`000000oooo0?ooo`0L0?ooo`030000003oool0
oooo03h0oooo000o0?ooo`030000003oool0oooo01/0oooo00<000000?ooo`3oool0H@3oool00`00
0000oooo0?ooo`0K0?ooo`030000003oool0oooo03h0oooo000o0?ooo`030000003oool0oooo01X0
oooo00<000000?ooo`3oool0HP3oool00`000000oooo0?ooo`0J0?ooo`030000003oool0oooo03l0
oooo00100?ooo`030000003oool0oooo01T0oooo00<000000?ooo`3oool0H`3oool00`000000oooo
0?ooo`0I0?ooo`030000003oool0oooo03l0oooo00100?ooo`030000003oool0oooo01P0oooo00<0
00000?ooo`3oool0I03oool00`000000oooo0?ooo`0H0?ooo`030000003oool0oooo0400oooo0011
0?ooo`030000003oool0oooo01L0oooo00<000000?ooo`3oool0I@3oool00`000000oooo0?ooo`0G
0?ooo`030000003oool0oooo0400oooo00110?ooo`030000003oool0oooo01H0oooo00<000000?oo
o`3oool0IP3oool00`000000oooo0?ooo`0F0?ooo`030000003oool0oooo0440oooo00120?ooo`03
0000003oool0oooo01D0oooo00<000000?ooo`3oool0I`3oool00`000000oooo0?ooo`0E0?ooo`03
0000003oool0oooo0440oooo00120?ooo`030000003oool0oooo01@0oooo00<000000?ooo`3oool0
J03oool00`000000oooo0?ooo`0D0?ooo`030000003oool0oooo0480oooo00130?ooo`030000003o
ool0oooo01<0oooo00<000000?ooo`3oool0J@3oool00`000000oooo0?ooo`0C0?ooo`030000003o
ool0oooo0480oooo00130?ooo`030000003oool0oooo0180oooo00<000000?ooo`3oool0JP3oool0
0`000000oooo0?ooo`0B0?ooo`030000003oool0oooo04<0oooo00140?ooo`030000003oool0oooo
0140oooo00<000000?ooo`3oool0J`3oool00`000000oooo0?ooo`0A0?ooo`030000003oool0oooo
04<0oooo00140?ooo`030000003oool0oooo0100oooo00<000000?ooo`3oool0K03oool00`000000
oooo0?ooo`0@0?ooo`030000003oool0oooo04@0oooo00150?ooo`030000003oool0oooo00l0oooo
00<000000?ooo`3oool0K@3oool00`000000oooo0?ooo`0?0?ooo`030000003oool0oooo04@0oooo
00150?ooo`030000003oool0oooo00h0oooo00<000000?ooo`3oool0KP3oool00`000000oooo0?oo
o`0>0?ooo`030000003oool0oooo04D0oooo00160?ooo`030000003oool0oooo00d0oooo00<00000
0?ooo`3oool0K`3oool00`000000oooo0?ooo`0=0?ooo`030000003oool0oooo04D0oooo00160?oo
o`030000003oool0oooo00`0oooo00<000000?ooo`3oool0L03oool00`000000oooo0?ooo`0<0?oo
o`030000003oool0oooo04H0oooo00170?ooo`030000003oool0oooo00/0oooo00<000000?ooo`3o
ool0L@3oool00`000000oooo0?ooo`0;0?ooo`030000003oool0oooo04H0oooo00170?ooo`030000
003oool0oooo00X0oooo00<000000?ooo`3oool0LP3oool00`000000oooo0?ooo`0:0?ooo`030000
003oool0oooo04L0oooo00180?ooo`030000003oool0oooo00T0oooo00<000000?ooo`3oool0L`3o
ool00`000000oooo0?ooo`090?ooo`030000003oool0oooo04L0oooo00180?ooo`030000003oool0
oooo00P0oooo00<000000?ooo`3oool0M03oool00`000000oooo0?ooo`080?ooo`030000003oool0
oooo04P0oooo00190?ooo`030000003oool0oooo00L0oooo00<000000?ooo`3oool0M@3oool00`00
0000oooo0?ooo`070?ooo`030000003oool0oooo04P0oooo00190?ooo`030000003oool0oooo00H0
oooo00<000000?ooo`3oool0MP3oool00`000000oooo0?ooo`060?ooo`030000003oool0oooo04T0
oooo001:0?ooo`030000003oool0oooo00D0oooo00<000000?ooo`3oool0M`3oool00`000000oooo
0?ooo`050?ooo`030000003oool0oooo04T0oooo001:0?ooo`030000003oool0oooo00@0oooo00<0
00000?ooo`3oool0N03oool00`000000oooo0?ooo`040?ooo`030000003oool0oooo04X0oooo001;
0?ooo`030000003oool0oooo00<0oooo00<000000?ooo`3oool0N@3oool00`000000oooo0?ooo`03
0?ooo`030000003oool0oooo04X0oooo001;0?ooo`030000003oool0oooo0080oooo00<000000?oo
o`3oool0NP3oool00`000000oooo0?ooo`020?ooo`030000003oool0oooo04/0oooo001<0?ooo`05
0000003oool0oooo0?ooo`000000O@3oool01@000000oooo0?ooo`3oool0000004d0oooo001<0?oo
o`040000003oool0oooo000007h0oooo00@000000?ooo`3oool00000CP3oool004d0oooo00<00000
0?ooo`000000O`3oool00`000000oooo0000001>0?ooo`00C03oool300000800oooo0`00001>0?oo
o`00B`3ooon8000004d0oooo001;0?ooo`D00000OP3oool5000004d0oooo001;0?ooo`D00000OP3o
ool5000004d0oooo001<0?ooo`<00000P03oool3000004h0oooo003o0?ooob40oooo003o0?ooob40
oooo003o0?ooob40oooo003o0?ooob40oooo003o0?ooob40oooo003o0?ooob40oooo003o0?ooob40
oooo003o0?ooob40oooo003o0?ooob40oooo003o0?ooob40oooo0000\
\>"],
  ImageRangeCache->{{{0, 287}, {287, 0}} -> {-1.10001, -0.952637, 0.00766559, \
0.00663859}}],

Cell[BoxData[
    TagBox[\(\[SkeletonIndicator]  Graphics  \[SkeletonIndicator]\),
      False,
      Editable->False]], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    \(\(\(draw[mm, \ 
      F\  . \ P]\)\(\ \ \ \ \ \ \ \ \ \ \ \ \ \ \)\)\)], "Input"],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: 1 
MathPictureStart
/Mabs {
Mgmatrix idtransform
Mtmatrix dtransform
} bind def
/Mabsadd { Mabs
3 -1 roll add
3 1 roll add
exch } bind def
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
0.5 0.454545 0.5 0.524864 [
[ 0 0 0 0 ]
[ 1 1 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 0 m
1 0 L
1 1 L
0 1 L
closepath
clip
newpath
0 g
.02 w
.72727 .95455 Mdot
.27273 .95455 Mdot
.04545 .5 Mdot
.27273 .04545 Mdot
.72727 .04545 Mdot
.95455 .5 Mdot
.72727 .5 Mdot
.5 .5 Mdot
.5 .5 Mdot
.5 .5 Mdot
.5 .5 Mdot
.27273 .5 Mdot
.38636 .27273 Mdot
.5 .5 Mdot
.5 .5 Mdot
.61364 .27273 Mdot
.5 .5 Mdot
.61364 .72727 Mdot
.5 .5 Mdot
.5 .5 Mdot
.5 .5 Mdot
.5 .5 Mdot
.5 .5 Mdot
.5 Mabswid
[ ] 0 setdash
.72727 .95455 m
.27273 .95455 L
s
.72727 .95455 m
.95455 .5 L
s
.72727 .95455 m
.61364 .72727 L
s
.27273 .95455 m
.72727 .95455 L
s
.27273 .95455 m
.04545 .5 L
s
.27273 .95455 m
.5 .5 L
s
.04545 .5 m
.27273 .95455 L
s
.04545 .5 m
.27273 .04545 L
s
.04545 .5 m
.27273 .5 L
s
.27273 .04545 m
.04545 .5 L
s
.27273 .04545 m
.72727 .04545 L
s
.27273 .04545 m
.38636 .27273 L
s
.72727 .04545 m
.27273 .04545 L
s
.72727 .04545 m
.95455 .5 L
s
.72727 .04545 m
.61364 .27273 L
s
.95455 .5 m
.72727 .95455 L
s
.95455 .5 m
.72727 .04545 L
s
.95455 .5 m
.72727 .5 L
s
.72727 .5 m
.95455 .5 L
s
.72727 .5 m
.5 .5 L
s
.72727 .5 m
.5 .5 L
s
.72727 .5 m
.61364 .27273 L
s
.72727 .5 m
.61364 .72727 L
s
.72727 .5 m
.5 .5 L
s
.72727 .5 m
.5 .5 L
s
.72727 .5 m
.5 .5 L
s
.5 .5 m
.72727 .5 L
s
.5 .5 m
.5 .5 L
s
.5 .5 m
.5 .5 L
s
.5 .5 m
.5 .5 L
s
.5 .5 m
.5 .5 L
s
.5 .5 m
.5 .5 L
s
.5 .5 m
.5 .5 L
s
.5 .5 m
.5 .5 L
s
.5 .5 m
.5 .5 L
s
.5 .5 m
.5 .5 L
s
.5 .5 m
.5 .5 L
s
.5 .5 m
.5 .5 L
s
.5 .5 m
.5 .5 L
s
.5 .5 m
.5 .5 L
s
.5 .5 m
.5 .5 L
s
.5 .5 m
.5 .5 L
s
.5 .5 m
.27273 .95455 L
s
.5 .5 m
.5 .5 L
s
.5 .5 m
.27273 .5 L
s
.5 .5 m
.5 .5 L
s
.5 .5 m
.61364 .72727 L
s
.5 .5 m
.5 .5 L
s
.5 .5 m
.5 .5 L
s
.5 .5 m
.5 .5 L
s
.27273 .5 m
.04545 .5 L
s
.27273 .5 m
.5 .5 L
s
.27273 .5 m
.38636 .27273 L
s
.27273 .5 m
.5 .5 L
s
.38636 .27273 m
.27273 .04545 L
s
.38636 .27273 m
.27273 .5 L
s
.38636 .27273 m
.5 .5 L
s
.38636 .27273 m
.61364 .27273 L
s
.38636 .27273 m
.5 .5 L
s
.38636 .27273 m
.5 .5 L
s
.38636 .27273 m
.5 .5 L
s
.38636 .27273 m
.5 .5 L
s
.5 .5 m
.5 .5 L
s
.5 .5 m
.38636 .27273 L
s
.5 .5 m
.5 .5 L
s
.5 .5 m
.5 .5 L
s
.5 .5 m
.72727 .5 L
s
.5 .5 m
.5 .5 L
s
.5 .5 m
.5 .5 L
s
.5 .5 m
.5 .5 L
s
.61364 .27273 m
.72727 .04545 L
s
.61364 .27273 m
.72727 .5 L
s
.61364 .27273 m
.38636 .27273 L
s
.61364 .27273 m
.5 .5 L
s
.5 .5 m
.5 .5 L
s
.5 .5 m
.38636 .27273 L
s
.5 .5 m
.5 .5 L
s
.5 .5 m
.5 .5 L
s
.61364 .72727 m
.72727 .95455 L
s
.61364 .72727 m
.72727 .5 L
s
.61364 .72727 m
.5 .5 L
s
.61364 .72727 m
.5 .5 L
s
.5 .5 m
.72727 .5 L
s
.5 .5 m
.5 .5 L
s
.5 .5 m
.5 .5 L
s
.5 .5 m
.5 .5 L
s
.5 .5 m
.72727 .5 L
s
.5 .5 m
.5 .5 L
s
.5 .5 m
.5 .5 L
s
.5 .5 m
.38636 .27273 L
s
.5 .5 m
.5 .5 L
s
.5 .5 m
.61364 .27273 L
s
.5 .5 m
.5 .5 L
s
.5 .5 m
.5 .5 L
s
.5 .5 m
.5 .5 L
s
.5 .5 m
.38636 .27273 L
s
.5 .5 m
.5 .5 L
s
.5 .5 m
.5 .5 L
s
.5 .5 m
.5 .5 L
s
.5 .5 m
.27273 .5 L
s
.5 .5 m
.38636 .27273 L
s
.5 .5 m
.5 .5 L
s
.5 .5 m
.72727 .5 L
s
.5 .5 m
.5 .5 L
s
.5 .5 m
.5 .5 L
s
.5 .5 m
.5 .5 L
s
.5 .5 m
.5 .5 L
s
.5 .5 m
.61364 .72727 L
s
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  ImageSize->{288, 288},
  ImageMargins->{{43, 0}, {0, 0}},
  ImageRegion->{{0, 1}, {0, 1}},
  ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`40004P000182000`400?l00000o`00003oo`3ooolQ
0?ooo`00o`3ooolQ0?ooo`00o`3ooolQ0?ooo`00o`3ooolQ0?ooo`00o`3ooolQ0?ooo`00o`3ooolQ
0?ooo`00o`3ooolQ0?ooo`00o`3ooolQ0?ooo`00o`3ooolQ0?ooo`00o`3ooolQ0?ooo`00o`3ooolQ
0?ooo`00o`3ooolQ0?ooo`00C03oool300000800oooo0`00001>0?ooo`00B`3oool5000007h0oooo
1@00001=0?ooo`00B`3ooon8000004d0oooo001;0?ooo`D00000OP3oool5000004d0oooo001<0?oo
o`@00000O`3oool3000004h0oooo001<0?ooo`040000003oool0oooo000007l0oooo00<000000?oo
o`000000CP3oool004`0oooo00D000000?ooo`3oool0oooo0000001m0?ooo`050000003oool0oooo
0?ooo`000000C@3oool004/0oooo00<000000?ooo`3oool00P3oool00`000000oooo0?ooo`1k0?oo
o`050000003oool0oooo0?ooo`000000C@3oool004/0oooo00<000000?ooo`3oool00`3oool00`00
0000oooo0?ooo`1i0?ooo`030000003oool0oooo00<0oooo00<000000?ooo`3oool0BP3oool004X0
oooo00<000000?ooo`3oool0103oool00`000000oooo0?ooo`1i0?ooo`030000003oool0oooo00<0
oooo00<000000?ooo`3oool0BP3oool004X0oooo00<000000?ooo`3oool01@3oool00`000000oooo
0?ooo`1g0?ooo`030000003oool0oooo00D0oooo00<000000?ooo`3oool0B@3oool004T0oooo00<0
00000?ooo`3oool01P3oool00`000000oooo0?ooo`1g0?ooo`030000003oool0oooo00D0oooo00<0
00000?ooo`3oool0B@3oool004T0oooo00<000000?ooo`3oool01`3oool00`000000oooo0?ooo`1e
0?ooo`030000003oool0oooo00L0oooo00<000000?ooo`3oool0B03oool004P0oooo00<000000?oo
o`3oool0203oool00`000000oooo0?ooo`1e0?ooo`030000003oool0oooo00L0oooo00<000000?oo
o`3oool0B03oool004P0oooo00<000000?ooo`3oool02@3oool00`000000oooo0?ooo`1c0?ooo`03
0000003oool0oooo00T0oooo00<000000?ooo`3oool0A`3oool004L0oooo00<000000?ooo`3oool0
2P3oool00`000000oooo0?ooo`1c0?ooo`030000003oool0oooo00T0oooo00<000000?ooo`3oool0
A`3oool004L0oooo00<000000?ooo`3oool02`3oool00`000000oooo0?ooo`1a0?ooo`030000003o
ool0oooo00/0oooo00<000000?ooo`3oool0AP3oool004H0oooo00<000000?ooo`3oool0303oool0
0`000000oooo0?ooo`1a0?ooo`030000003oool0oooo00/0oooo00<000000?ooo`3oool0AP3oool0
04H0oooo00<000000?ooo`3oool03@3oool00`000000oooo0?ooo`1_0?ooo`030000003oool0oooo
00d0oooo00<000000?ooo`3oool0A@3oool004D0oooo00<000000?ooo`3oool03P3oool00`000000
oooo0?ooo`1_0?ooo`030000003oool0oooo00d0oooo00<000000?ooo`3oool0A@3oool004D0oooo
00<000000?ooo`3oool03`3oool00`000000oooo0?ooo`1]0?ooo`030000003oool0oooo00l0oooo
00<000000?ooo`3oool0A03oool004@0oooo00<000000?ooo`3oool0403oool00`000000oooo0?oo
o`1]0?ooo`030000003oool0oooo00l0oooo00<000000?ooo`3oool0A03oool004@0oooo00<00000
0?ooo`3oool04@3oool00`000000oooo0?ooo`1[0?ooo`030000003oool0oooo0140oooo00<00000
0?ooo`3oool0@`3oool004<0oooo00<000000?ooo`3oool04P3oool00`000000oooo0?ooo`1[0?oo
o`030000003oool0oooo0140oooo00<000000?ooo`3oool0@`3oool004<0oooo00<000000?ooo`3o
ool04`3oool00`000000oooo0?ooo`1Y0?ooo`030000003oool0oooo01<0oooo00<000000?ooo`3o
ool0@P3oool00480oooo00<000000?ooo`3oool0503oool00`000000oooo0?ooo`1Y0?ooo`030000
003oool0oooo01<0oooo00<000000?ooo`3oool0@P3oool00480oooo00<000000?ooo`3oool05@3o
ool00`000000oooo0?ooo`1W0?ooo`030000003oool0oooo01D0oooo00<000000?ooo`3oool0@@3o
ool00440oooo00<000000?ooo`3oool05P3oool00`000000oooo0?ooo`1W0?ooo`030000003oool0
oooo01D0oooo00<000000?ooo`3oool0@@3oool00440oooo00<000000?ooo`3oool05`3oool00`00
0000oooo0?ooo`1U0?ooo`030000003oool0oooo01L0oooo00<000000?ooo`3oool0@03oool00400
oooo00<000000?ooo`3oool0603oool00`000000oooo0?ooo`1U0?ooo`030000003oool0oooo01L0
oooo00<000000?ooo`3oool0@03oool00400oooo00<000000?ooo`3oool06@3oool00`000000oooo
0?ooo`1S0?ooo`030000003oool0oooo01T0oooo00<000000?ooo`3oool0?`3oool003l0oooo00<0
00000?ooo`3oool06P3oool00`000000oooo0?ooo`1S0?ooo`030000003oool0oooo01T0oooo00<0
00000?ooo`3oool0?`3oool003l0oooo00<000000?ooo`3oool06`3oool00`000000oooo0?ooo`1Q
0?ooo`030000003oool0oooo01/0oooo00<000000?ooo`3oool0?P3oool003h0oooo00<000000?oo
o`3oool0703oool00`000000oooo0?ooo`1Q0?ooo`030000003oool0oooo01/0oooo00<000000?oo
o`3oool0?P3oool003h0oooo00<000000?ooo`3oool07@3oool00`000000oooo0?ooo`1O0?ooo`03
0000003oool0oooo01d0oooo00<000000?ooo`3oool0?@3oool003d0oooo00<000000?ooo`3oool0
7P3oool00`000000oooo0?ooo`1O0?ooo`030000003oool0oooo01d0oooo00<000000?ooo`3oool0
?@3oool003d0oooo00<000000?ooo`3oool07`3oool00`000000oooo0?ooo`1M0?ooo`030000003o
ool0oooo01l0oooo00<000000?ooo`3oool0?03oool003`0oooo00<000000?ooo`3oool0803oool0
0`000000oooo0?ooo`1M0?ooo`030000003oool0oooo01l0oooo00<000000?ooo`3oool0?03oool0
03`0oooo00<000000?ooo`3oool08@3oool00`000000oooo0?ooo`1K0?ooo`030000003oool0oooo
0240oooo00<000000?ooo`3oool0>`3oool003/0oooo00<000000?ooo`3oool08P3oool00`000000
oooo0?ooo`1K0?ooo`030000003oool0oooo0240oooo00<000000?ooo`3oool0>`3oool003/0oooo
00<000000?ooo`3oool08`3oool00`000000oooo0?ooo`1I0?ooo`030000003oool0oooo02<0oooo
00<000000?ooo`3oool0>P3oool003X0oooo00<000000?ooo`3oool0903oool00`000000oooo0?oo
o`1I0?ooo`030000003oool0oooo02<0oooo00<000000?ooo`3oool0>P3oool003X0oooo00<00000
0?ooo`3oool09@3oool00`000000oooo0?ooo`1G0?ooo`030000003oool0oooo02D0oooo00<00000
0?ooo`3oool0>@3oool003T0oooo00<000000?ooo`3oool09P3oool00`000000oooo0?ooo`1G0?oo
o`030000003oool0oooo02D0oooo00<000000?ooo`3oool0>@3oool003T0oooo00<000000?ooo`3o
ool09`3oool00`000000oooo0?ooo`1E0?ooo`030000003oool0oooo02L0oooo00<000000?ooo`3o
ool0>03oool003P0oooo00<000000?ooo`3oool0:03oool00`000000oooo0?ooo`1E0?ooo`030000
003oool0oooo02L0oooo00<000000?ooo`3oool0>03oool003P0oooo00<000000?ooo`3oool0:@3o
ool00`000000oooo0?ooo`1C0?ooo`030000003oool0oooo02T0oooo00<000000?ooo`3oool0=`3o
ool003L0oooo00<000000?ooo`3oool0:P3oool00`000000oooo0?ooo`1C0?ooo`030000003oool0
oooo02T0oooo00<000000?ooo`3oool0=`3oool003L0oooo00<000000?ooo`3oool0:`3oool00`00
0000oooo0?ooo`1A0?ooo`030000003oool0oooo02/0oooo00<000000?ooo`3oool0=P3oool003H0
oooo00<000000?ooo`3oool0;03oool00`000000oooo0?ooo`1A0?ooo`030000003oool0oooo02/0
oooo00<000000?ooo`3oool0=P3oool003H0oooo00<000000?ooo`3oool0;@3oool00`000000oooo
0?ooo`1?0?ooo`030000003oool0oooo02d0oooo00<000000?ooo`3oool0=@3oool003D0oooo00<0
00000?ooo`3oool0;P3oool00`000000oooo0?ooo`1?0?ooo`030000003oool0oooo02d0oooo00<0
00000?ooo`3oool0=@3oool003D0oooo00<000000?ooo`3oool0;`3oool00`000000oooo0?ooo`1=
0?ooo`030000003oool0oooo02l0oooo00<000000?ooo`3oool0=03oool003@0oooo00<000000?oo
o`3oool0<03oool00`000000oooo0?ooo`1=0?ooo`030000003oool0oooo02l0oooo00<000000?oo
o`3oool0=03oool003@0oooo00<000000?ooo`3oool0<@3oool00`000000oooo0?ooo`1;0?ooo`03
0000003oool0oooo0340oooo00<000000?ooo`3oool0<`3oool003<0oooo00<000000?ooo`3oool0
<P3oool00`000000oooo0?ooo`1;0?ooo`030000003oool0oooo0340oooo00<000000?ooo`3oool0
<`3oool003<0oooo00<000000?ooo`3oool0<`3oool00`000000oooo0?ooo`190?ooo`030000003o
ool0oooo03<0oooo00<000000?ooo`3oool0<P3oool00380oooo00<000000?ooo`3oool0=03oool0
0`000000oooo0?ooo`190?ooo`030000003oool0oooo03<0oooo00<000000?ooo`3oool0<P3oool0
0380oooo00<000000?ooo`3oool0=@3oool00`000000oooo0?ooo`170?ooo`030000003oool0oooo
03D0oooo00<000000?ooo`3oool0<@3oool00340oooo00<000000?ooo`3oool0=P3oool00`000000
oooo0?ooo`170?ooo`030000003oool0oooo03D0oooo00<000000?ooo`3oool0<@3oool00340oooo
00<000000?ooo`3oool0=`3oool00`000000oooo0?ooo`150?ooo`030000003oool0oooo03L0oooo
00<000000?ooo`3oool0<03oool00300oooo00<000000?ooo`3oool0>03oool00`000000oooo0?oo
o`150?ooo`030000003oool0oooo03L0oooo00<000000?ooo`3oool0<03oool00300oooo00<00000
0?ooo`3oool0>@3oool00`000000oooo0?ooo`130?ooo`030000003oool0oooo03T0oooo00<00000
0?ooo`3oool0;`3oool002l0oooo00<000000?ooo`3oool0>P3oool00`000000oooo0?ooo`130?oo
o`030000003oool0oooo03T0oooo00<000000?ooo`3oool0;`3oool002l0oooo00<000000?ooo`3o
ool0>`3oool00`000000oooo0?ooo`110?ooo`030000003oool0oooo03/0oooo00<000000?ooo`3o
ool0;P3oool002h0oooo00<000000?ooo`3oool0?03oool3000003h0oooo1000000m0?ooo`030000
003oool0oooo02h0oooo000^0?ooo`030000003oool0oooo03/0oooo1@00000l0?ooo`D00000?P3o
ool00`000000oooo0?ooo`0]0?ooo`00;@3oool00`000000oooo0?ooo`0l0?ooodH00000?P3oool0
0`000000oooo0?ooo`0]0?ooo`00;@3oool00`000000oooo0?ooo`0l0?ooo`D00000?03oool50000
03l0oooo00<000000?ooo`3oool0;03oool002`0oooo00<000000?ooo`3oool0?P3oool3000003h0
oooo1000000o0?ooo`030000003oool0oooo02`0oooo000/0?ooo`030000003oool0oooo03h0oooo
00@000000?ooo`3oool00000?@3oool010000000oooo0?ooo`0000100?ooo`030000003oool0oooo
02/0oooo000[0?ooo`030000003oool0oooo03h0oooo00D000000?ooo`3oool0oooo0000000m0?oo
o`050000003oool0oooo0?ooo`000000?`3oool00`000000oooo0?ooo`0[0?ooo`00:`3oool00`00
0000oooo0?ooo`0n0?ooo`030000003oool0oooo0080oooo00<000000?ooo`3oool0>@3oool00`00
0000oooo0?ooo`020?ooo`030000003oool0oooo03h0oooo00<000000?ooo`3oool0:P3oool002X0
oooo00<000000?ooo`3oool0?P3oool00`000000oooo0?ooo`030?ooo`030000003oool0oooo03T0
oooo00<000000?ooo`3oool00`3oool00`000000oooo0?ooo`0m0?ooo`030000003oool0oooo02X0
oooo000Z0?ooo`030000003oool0oooo03h0oooo00<000000?ooo`3oool0103oool00`000000oooo
0?ooo`0g0?ooo`030000003oool0oooo00@0oooo00<000000?ooo`3oool0?P3oool00`000000oooo
0?ooo`0Y0?ooo`00:@3oool00`000000oooo0?ooo`0n0?ooo`030000003oool0oooo00D0oooo00<0
00000?ooo`3oool0=`3oool00`000000oooo0?ooo`050?ooo`030000003oool0oooo03d0oooo00<0
00000?ooo`3oool0:@3oool002T0oooo00<000000?ooo`3oool0?P3oool00`000000oooo0?ooo`06
0?ooo`030000003oool0oooo03D0oooo00<000000?ooo`3oool01P3oool00`000000oooo0?ooo`0n
0?ooo`030000003oool0oooo02P0oooo000X0?ooo`030000003oool0oooo03h0oooo00<000000?oo
o`3oool01`3oool00`000000oooo0?ooo`0e0?ooo`030000003oool0oooo00L0oooo00<000000?oo
o`3oool0?@3oool00`000000oooo0?ooo`0X0?ooo`00:03oool00`000000oooo0?ooo`0n0?ooo`03
0000003oool0oooo00P0oooo00<000000?ooo`3oool0<`3oool00`000000oooo0?ooo`080?ooo`03
0000003oool0oooo03h0oooo00<000000?ooo`3oool09`3oool002L0oooo00<000000?ooo`3oool0
?P3oool00`000000oooo0?ooo`090?ooo`030000003oool0oooo03<0oooo00<000000?ooo`3oool0
2@3oool00`000000oooo0?ooo`0m0?ooo`030000003oool0oooo02L0oooo000W0?ooo`030000003o
ool0oooo03h0oooo00<000000?ooo`3oool02P3oool00`000000oooo0?ooo`0a0?ooo`030000003o
ool0oooo00X0oooo00<000000?ooo`3oool0?P3oool00`000000oooo0?ooo`0V0?ooo`009P3oool0
0`000000oooo0?ooo`0n0?ooo`030000003oool0oooo00/0oooo00<000000?ooo`3oool0<@3oool0
0`000000oooo0?ooo`0;0?ooo`030000003oool0oooo03d0oooo00<000000?ooo`3oool09P3oool0
02H0oooo00<000000?ooo`3oool0?P3oool00`000000oooo0?ooo`0<0?ooo`030000003oool0oooo
02l0oooo00<000000?ooo`3oool0303oool00`000000oooo0?ooo`0n0?ooo`030000003oool0oooo
02D0oooo000U0?ooo`030000003oool0oooo03h0oooo00<000000?ooo`3oool03@3oool00`000000
oooo0?ooo`0_0?ooo`030000003oool0oooo00d0oooo00<000000?ooo`3oool0?@3oool00`000000
oooo0?ooo`0U0?ooo`009@3oool00`000000oooo0?ooo`0n0?ooo`030000003oool0oooo00h0oooo
00<000000?ooo`3oool0;@3oool00`000000oooo0?ooo`0>0?ooo`030000003oool0oooo03h0oooo
00<000000?ooo`3oool0903oool002@0oooo00<000000?ooo`3oool0?P3oool00`000000oooo0?oo
o`0?0?ooo`030000003oool0oooo02d0oooo00<000000?ooo`3oool03`3oool00`000000oooo0?oo
o`0m0?ooo`030000003oool0oooo02@0oooo000T0?ooo`030000003oool0oooo03h0oooo00<00000
0?ooo`3oool0403oool00`000000oooo0?ooo`0[0?ooo`030000003oool0oooo0100oooo00<00000
0?ooo`3oool0?P3oool00`000000oooo0?ooo`0S0?ooo`008`3oool00`000000oooo0?ooo`0n0?oo
o`030000003oool0oooo0140oooo00<000000?ooo`3oool0:`3oool00`000000oooo0?ooo`0A0?oo
o`030000003oool0oooo03d0oooo00<000000?ooo`3oool08`3oool002<0oooo00<000000?ooo`3o
ool0?P3oool00`000000oooo0?ooo`0B0?ooo`030000003oool0oooo02T0oooo00<000000?ooo`3o
ool04P3oool00`000000oooo0?ooo`0n0?ooo`030000003oool0oooo0280oooo000R0?ooo`030000
003oool0oooo03h0oooo00<000000?ooo`3oool04`3oool00`000000oooo0?ooo`0Y0?ooo`030000
003oool0oooo01<0oooo00<000000?ooo`3oool0?@3oool00`000000oooo0?ooo`0R0?ooo`008P3o
ool00`000000oooo0?ooo`0n0?ooo`030000003oool0oooo01@0oooo00<000000?ooo`3oool09`3o
ool00`000000oooo0?ooo`0D0?ooo`030000003oool0oooo03h0oooo00<000000?ooo`3oool08@3o
ool00240oooo00<000000?ooo`3oool0?P3oool00`000000oooo0?ooo`0E0?ooo`030000003oool0
oooo02L0oooo00<000000?ooo`3oool05@3oool00`000000oooo0?ooo`0m0?ooo`030000003oool0
oooo0240oooo000Q0?ooo`030000003oool0oooo03h0oooo00<000000?ooo`3oool05P3oool00`00
0000oooo0?ooo`0U0?ooo`030000003oool0oooo01H0oooo00<000000?ooo`3oool0?P3oool00`00
0000oooo0?ooo`0P0?ooo`00803oool00`000000oooo0?ooo`0n0?ooo`030000003oool0oooo01L0
oooo00<000000?ooo`3oool09@3oool00`000000oooo0?ooo`0G0?ooo`030000003oool0oooo03d0
oooo00<000000?ooo`3oool0803oool00200oooo00<000000?ooo`3oool0?P3oool00`000000oooo
0?ooo`0H0?ooo`030000003oool0oooo02<0oooo00<000000?ooo`3oool0603oool00`000000oooo
0?ooo`0n0?ooo`030000003oool0oooo01l0oooo000O0?ooo`030000003oool0oooo03h0oooo00<0
00000?ooo`3oool06@3oool00`000000oooo0?ooo`0S0?ooo`030000003oool0oooo01T0oooo00<0
00000?ooo`3oool0?@3oool00`000000oooo0?ooo`0O0?ooo`007`3oool00`000000oooo0?ooo`0n
0?ooo`030000003oool0oooo01X0oooo00<000000?ooo`3oool08@3oool00`000000oooo0?ooo`0J
0?ooo`030000003oool0oooo03h0oooo00<000000?ooo`3oool07P3oool001h0oooo00<000000?oo
o`3oool0?P3oool00`000000oooo0?ooo`0K0?ooo`030000003oool0oooo0240oooo00<000000?oo
o`3oool06`3oool00`000000oooo0?ooo`0m0?ooo`030000003oool0oooo01h0oooo000N0?ooo`03
0000003oool0oooo03h0oooo00<000000?ooo`3oool0703oool00`000000oooo0?ooo`0O0?ooo`03
0000003oool0oooo01`0oooo00<000000?ooo`3oool0?P3oool00`000000oooo0?ooo`0M0?ooo`00
7@3oool00`000000oooo0?ooo`0n0?ooo`030000003oool0oooo01d0oooo00<000000?ooo`3oool0
7`3oool00`000000oooo0?ooo`0M0?ooo`030000003oool0oooo03d0oooo00<000000?ooo`3oool0
7@3oool001d0oooo00<000000?ooo`3oool0?P3oool00`000000oooo0?ooo`0N0?ooo`030000003o
ool0oooo01d0oooo00<000000?ooo`3oool07P3oool00`000000oooo0?ooo`0n0?ooo`030000003o
ool0oooo01`0oooo000L0?ooo`030000003oool0oooo03h0oooo00<000000?ooo`3oool07`3oool0
0`000000oooo0?ooo`0M0?ooo`030000003oool0oooo01l0oooo00<000000?ooo`3oool0?@3oool0
0`000000oooo0?ooo`0L0?ooo`00703oool00`000000oooo0?ooo`0n0?ooo`030000003oool0oooo
0200oooo00<000000?ooo`3oool06`3oool00`000000oooo0?ooo`0P0?ooo`030000003oool0oooo
03h0oooo00<000000?ooo`3oool06`3oool001/0oooo00<000000?ooo`3oool0?P3oool00`000000
oooo0?ooo`0Q0?ooo`030000003oool0oooo01/0oooo00<000000?ooo`3oool08@3oool00`000000
oooo0?ooo`0m0?ooo`030000003oool0oooo01/0oooo000K0?ooo`030000003oool0oooo03h0oooo
00<000000?ooo`3oool08P3oool00`000000oooo0?ooo`0I0?ooo`030000003oool0oooo0280oooo
00<000000?ooo`3oool0?P3oool00`000000oooo0?ooo`0J0?ooo`006P3oool00`000000oooo0?oo
o`0n0?ooo`030000003oool0oooo02<0oooo00<000000?ooo`3oool06@3oool00`000000oooo0?oo
o`0S0?ooo`030000003oool0oooo03d0oooo00<000000?ooo`3oool06P3oool001X0oooo00<00000
0?ooo`3oool0?P3oool00`000000oooo0?ooo`0T0?ooo`030000003oool0oooo01L0oooo00<00000
0?ooo`3oool0903oool00`000000oooo0?ooo`0n0?ooo`030000003oool0oooo01T0oooo000I0?oo
o`030000003oool0oooo03h0oooo00<000000?ooo`3oool09@3oool00`000000oooo0?ooo`0G0?oo
o`030000003oool0oooo02D0oooo00<000000?ooo`3oool0?@3oool00`000000oooo0?ooo`0I0?oo
o`006@3oool00`000000oooo0?ooo`0n0?ooo`030000003oool0oooo02H0oooo00<000000?ooo`3o
ool05@3oool00`000000oooo0?ooo`0V0?ooo`030000003oool0oooo03h0oooo00<000000?ooo`3o
ool0603oool001P0oooo00<000000?ooo`3oool0?P3oool00`000000oooo0?ooo`0W0?ooo`030000
003oool0oooo01D0oooo00<000000?ooo`3oool09`3oool00`000000oooo0?ooo`0m0?ooo`030000
003oool0oooo01P0oooo000H0?ooo`030000003oool0oooo03h0oooo00<000000?ooo`3oool0:03o
ool00`000000oooo0?ooo`0C0?ooo`030000003oool0oooo02P0oooo00<000000?ooo`3oool0?P3o
ool00`000000oooo0?ooo`0G0?ooo`005`3oool00`000000oooo0?ooo`0n0?ooo`030000003oool0
oooo02T0oooo00<000000?ooo`3oool04`3oool00`000000oooo0?ooo`0Y0?ooo`030000003oool0
oooo03d0oooo00<000000?ooo`3oool05`3oool001L0oooo00<000000?ooo`3oool0?P3oool00`00
0000oooo0?ooo`0Z0?ooo`030000003oool0oooo0140oooo00<000000?ooo`3oool0:P3oool00`00
0000oooo0?ooo`0n0?ooo`030000003oool0oooo01H0oooo000F0?ooo`030000003oool0oooo03h0
oooo00<000000?ooo`3oool0:`3oool00`000000oooo0?ooo`0A0?ooo`030000003oool0oooo02/0
oooo00<000000?ooo`3oool0?@3oool00`000000oooo0?ooo`0F0?ooo`005P3oool00`000000oooo
0?ooo`0n0?ooo`030000003oool0oooo02`0oooo00<000000?ooo`3oool03`3oool00`000000oooo
0?ooo`0/0?ooo`030000003oool0oooo03h0oooo00<000000?ooo`3oool05@3oool001D0oooo00<0
00000?ooo`3oool0?P3oool00`000000oooo0?ooo`0]0?ooo`030000003oool0oooo00l0oooo00<0
00000?ooo`3oool0;@3oool00`000000oooo0?ooo`0m0?ooo`030000003oool0oooo01D0oooo000E
0?ooo`030000003oool0oooo03h0oooo00<000000?ooo`3oool0;P3oool00`000000oooo0?ooo`0=
0?ooo`030000003oool0oooo02h0oooo00<000000?ooo`3oool0?P3oool00`000000oooo0?ooo`0D
0?ooo`00503oool00`000000oooo0?ooo`0n0?ooo`030000003oool0oooo02l0oooo00<000000?oo
o`3oool03@3oool00`000000oooo0?ooo`0_0?ooo`030000003oool0oooo03d0oooo00<000000?oo
o`3oool0503oool001@0oooo00<000000?ooo`3oool0?P3oool00`000000oooo0?ooo`0`0?ooo`03
0000003oool0oooo00/0oooo00<000000?ooo`3oool0<03oool00`000000oooo0?ooo`0n0?ooo`03
0000003oool0oooo01<0oooo000C0?ooo`030000003oool0oooo03h0oooo00<000000?ooo`3oool0
<@3oool00`000000oooo0?ooo`0;0?ooo`030000003oool0oooo0340oooo00<000000?ooo`3oool0
?@3oool00`000000oooo0?ooo`0C0?ooo`004`3oool00`000000oooo0?ooo`0n0?ooo`030000003o
ool0oooo0380oooo00<000000?ooo`3oool02@3oool00`000000oooo0?ooo`0b0?ooo`030000003o
ool0oooo03h0oooo00<000000?ooo`3oool04P3oool00180oooo00<000000?ooo`3oool0?P3oool0
0`000000oooo0?ooo`0c0?ooo`030000003oool0oooo00T0oooo00<000000?ooo`3oool0<`3oool0
0`000000oooo0?ooo`0m0?ooo`030000003oool0oooo0180oooo000B0?ooo`030000003oool0oooo
03h0oooo00<000000?ooo`3oool0=03oool00`000000oooo0?ooo`070?ooo`030000003oool0oooo
03@0oooo00<000000?ooo`3oool0?P3oool00`000000oooo0?ooo`0A0?ooo`004@3oool00`000000
oooo0?ooo`0n0?ooo`030000003oool0oooo03D0oooo00<000000?ooo`3oool01`3oool00`000000
oooo0?ooo`0e0?ooo`030000003oool0oooo03d0oooo00<000000?ooo`3oool04@3oool00140oooo
00<000000?ooo`3oool0?P3oool00`000000oooo0?ooo`0f0?ooo`030000003oool0oooo00D0oooo
00<000000?ooo`3oool0=P3oool00`000000oooo0?ooo`0n0?ooo`030000003oool0oooo0100oooo
000@0?ooo`030000003oool0oooo03h0oooo00<000000?ooo`3oool0=`3oool00`000000oooo0?oo
o`050?ooo`030000003oool0oooo03L0oooo00<000000?ooo`3oool0?@3oool00`000000oooo0?oo
o`0@0?ooo`00403oool00`000000oooo0?ooo`0n0?ooo`030000003oool0oooo03P0oooo00<00000
0?ooo`3oool00`3oool00`000000oooo0?ooo`0h0?ooo`030000003oool0oooo03h0oooo00<00000
0?ooo`3oool03`3oool000l0oooo00<000000?ooo`3oool0?P3oool00`000000oooo0?ooo`0i0?oo
o`030000003oool0oooo00<0oooo00<000000?ooo`3oool0>@3oool00`000000oooo0?ooo`0m0?oo
o`030000003oool0oooo00l0oooo000?0?ooo`030000003oool0oooo03h0oooo00<000000?ooo`3o
ool0>P3oool01@000000oooo0?ooo`3oool0000003`0oooo00<000000?ooo`3oool0?P3oool00`00
0000oooo0?ooo`0>0?ooo`003P3oool00`000000oooo0?ooo`0n0?ooo`030000003oool0oooo03/0
oooo00D000000?ooo`3oool0oooo0000000m0?ooo`030000003oool0oooo03d0oooo00<000000?oo
o`3oool03P3oool000/0oooo1000000m0?ooo`@00000?P3oool3000003h0oooo0`00000n0?ooo`<0
00003@3oool000X0oooo1@00000l0?ooo`D00000?@3oool5000003`0oooo1@00000l0?ooo`D00000
303oool000X0ooooo`00000;000000`0oooo000:0?ooo`D00000?03oool5000003d0oooo1@00000l
0?ooo`D00000?03oool5000000`0oooo000;0?ooo`@00000?@3oool3000003l0oooo0`00000n0?oo
o`<00000?P3oool3000000d0oooo000>0?ooo`030000003oool0oooo07`0oooo00D000000?ooo`3o
ool0oooo0000000m0?ooo`030000003oool0oooo03d0oooo00<000000?ooo`3oool03P3oool000l0
oooo00<000000?ooo`3oool0N`3oool01@000000oooo0?ooo`3oool0000003`0oooo00<000000?oo
o`3oool0?P3oool00`000000oooo0?ooo`0>0?ooo`003`3oool00`000000oooo0?ooo`1j0?ooo`03
0000003oool0oooo00<0oooo00<000000?ooo`3oool0>@3oool00`000000oooo0?ooo`0m0?ooo`03
0000003oool0oooo00l0oooo000@0?ooo`030000003oool0oooo07T0oooo00<000000?ooo`3oool0
0`3oool00`000000oooo0?ooo`0h0?ooo`030000003oool0oooo03h0oooo00<000000?ooo`3oool0
3`3oool00100oooo00<000000?ooo`3oool0N03oool00`000000oooo0?ooo`050?ooo`030000003o
ool0oooo03L0oooo00<000000?ooo`3oool0?@3oool00`000000oooo0?ooo`0@0?ooo`004@3oool0
0`000000oooo0?ooo`1g0?ooo`030000003oool0oooo00D0oooo00<000000?ooo`3oool0=P3oool0
0`000000oooo0?ooo`0n0?ooo`030000003oool0oooo0100oooo000A0?ooo`030000003oool0oooo
07H0oooo00<000000?ooo`3oool01`3oool00`000000oooo0?ooo`0e0?ooo`030000003oool0oooo
03d0oooo00<000000?ooo`3oool04@3oool00180oooo00<000000?ooo`3oool0M@3oool00`000000
oooo0?ooo`070?ooo`030000003oool0oooo03@0oooo00<000000?ooo`3oool0?P3oool00`000000
oooo0?ooo`0A0?ooo`004P3oool00`000000oooo0?ooo`1d0?ooo`030000003oool0oooo00T0oooo
00<000000?ooo`3oool0<`3oool00`000000oooo0?ooo`0m0?ooo`030000003oool0oooo0180oooo
000C0?ooo`030000003oool0oooo07<0oooo00<000000?ooo`3oool02@3oool00`000000oooo0?oo
o`0b0?ooo`030000003oool0oooo03h0oooo00<000000?ooo`3oool04P3oool001<0oooo00<00000
0?ooo`3oool0LP3oool00`000000oooo0?ooo`0;0?ooo`030000003oool0oooo0340oooo00<00000
0?ooo`3oool0?@3oool00`000000oooo0?ooo`0C0?ooo`00503oool00`000000oooo0?ooo`1a0?oo
o`030000003oool0oooo00/0oooo00<000000?ooo`3oool0<03oool00`000000oooo0?ooo`0n0?oo
o`030000003oool0oooo01<0oooo000D0?ooo`030000003oool0oooo0700oooo00<000000?ooo`3o
ool03@3oool00`000000oooo0?ooo`0_0?ooo`030000003oool0oooo03d0oooo00<000000?ooo`3o
ool0503oool001D0oooo00<000000?ooo`3oool0K`3oool00`000000oooo0?ooo`0=0?ooo`030000
003oool0oooo02h0oooo00<000000?ooo`3oool0?P3oool00`000000oooo0?ooo`0D0?ooo`005@3o
ool00`000000oooo0?ooo`1^0?ooo`030000003oool0oooo00l0oooo00<000000?ooo`3oool0;@3o
ool00`000000oooo0?ooo`0m0?ooo`030000003oool0oooo01D0oooo000F0?ooo`030000003oool0
oooo06d0oooo00<000000?ooo`3oool03`3oool00`000000oooo0?ooo`0/0?ooo`030000003oool0
oooo03h0oooo00<000000?ooo`3oool05@3oool001H0oooo00<000000?ooo`3oool0K03oool00`00
0000oooo0?ooo`0A0?ooo`030000003oool0oooo02/0oooo00<000000?ooo`3oool0?@3oool00`00
0000oooo0?ooo`0F0?ooo`005`3oool00`000000oooo0?ooo`1[0?ooo`030000003oool0oooo0140
oooo00<000000?ooo`3oool0:P3oool00`000000oooo0?ooo`0n0?ooo`030000003oool0oooo01H0
oooo000G0?ooo`030000003oool0oooo06X0oooo00<000000?ooo`3oool04`3oool00`000000oooo
0?ooo`0Y0?ooo`030000003oool0oooo03d0oooo00<000000?ooo`3oool05`3oool001P0oooo00<0
00000?ooo`3oool0J@3oool00`000000oooo0?ooo`0C0?ooo`030000003oool0oooo02P0oooo00<0
00000?ooo`3oool0?P3oool00`000000oooo0?ooo`0G0?ooo`00603oool00`000000oooo0?ooo`1X
0?ooo`030000003oool0oooo01D0oooo00<000000?ooo`3oool09`3oool00`000000oooo0?ooo`0m
0?ooo`030000003oool0oooo01P0oooo000I0?ooo`030000003oool0oooo06L0oooo00<000000?oo
o`3oool05@3oool00`000000oooo0?ooo`0V0?ooo`030000003oool0oooo03h0oooo00<000000?oo
o`3oool0603oool001T0oooo00<000000?ooo`3oool0IP3oool00`000000oooo0?ooo`0G0?ooo`03
0000003oool0oooo02D0oooo00<000000?ooo`3oool0?@3oool00`000000oooo0?ooo`0I0?ooo`00
6P3oool00`000000oooo0?ooo`1U0?ooo`030000003oool0oooo01L0oooo00<000000?ooo`3oool0
903oool00`000000oooo0?ooo`0n0?ooo`030000003oool0oooo01T0oooo000J0?ooo`030000003o
ool0oooo06@0oooo00<000000?ooo`3oool06@3oool00`000000oooo0?ooo`0S0?ooo`030000003o
ool0oooo03d0oooo00<000000?ooo`3oool06P3oool001/0oooo00<000000?ooo`3oool0H`3oool0
0`000000oooo0?ooo`0I0?ooo`030000003oool0oooo0280oooo00<000000?ooo`3oool0?P3oool0
0`000000oooo0?ooo`0J0?ooo`006`3oool00`000000oooo0?ooo`1R0?ooo`030000003oool0oooo
01/0oooo00<000000?ooo`3oool08@3oool00`000000oooo0?ooo`0m0?ooo`030000003oool0oooo
01/0oooo000L0?ooo`030000003oool0oooo0640oooo00<000000?ooo`3oool06`3oool00`000000
oooo0?ooo`0P0?ooo`030000003oool0oooo03h0oooo00<000000?ooo`3oool06`3oool001`0oooo
00<000000?ooo`3oool0H03oool00`000000oooo0?ooo`0M0?ooo`030000003oool0oooo01l0oooo
00<000000?ooo`3oool0?@3oool00`000000oooo0?ooo`0L0?ooo`007@3oool00`000000oooo0?oo
o`1O0?ooo`030000003oool0oooo01d0oooo00<000000?ooo`3oool07P3oool00`000000oooo0?oo
o`0n0?ooo`030000003oool0oooo01`0oooo000M0?ooo`030000003oool0oooo05h0oooo00<00000
0?ooo`3oool07`3oool00`000000oooo0?ooo`0M0?ooo`030000003oool0oooo03d0oooo00<00000
0?ooo`3oool07@3oool001h0oooo00<000000?ooo`3oool0G@3oool00`000000oooo0?ooo`0O0?oo
o`030000003oool0oooo01`0oooo00<000000?ooo`3oool0?P3oool00`000000oooo0?ooo`0M0?oo
o`007P3oool00`000000oooo0?ooo`1L0?ooo`030000003oool0oooo0240oooo00<000000?ooo`3o
ool06`3oool00`000000oooo0?ooo`0m0?ooo`030000003oool0oooo01h0oooo000O0?ooo`030000
003oool0oooo05/0oooo00<000000?ooo`3oool08@3oool00`000000oooo0?ooo`0J0?ooo`030000
003oool0oooo03h0oooo00<000000?ooo`3oool07P3oool001l0oooo00<000000?ooo`3oool0FP3o
ool00`000000oooo0?ooo`0S0?ooo`030000003oool0oooo01T0oooo00<000000?ooo`3oool0?@3o
ool00`000000oooo0?ooo`0O0?ooo`00803oool00`000000oooo0?ooo`1I0?ooo`030000003oool0
oooo02<0oooo00<000000?ooo`3oool0603oool00`000000oooo0?ooo`0n0?ooo`030000003oool0
oooo01l0oooo000P0?ooo`030000003oool0oooo05P0oooo00<000000?ooo`3oool09@3oool00`00
0000oooo0?ooo`0G0?ooo`030000003oool0oooo03d0oooo00<000000?ooo`3oool0803oool00240
oooo00<000000?ooo`3oool0E`3oool00`000000oooo0?ooo`0U0?ooo`030000003oool0oooo01H0
oooo00<000000?ooo`3oool0?P3oool00`000000oooo0?ooo`0P0?ooo`008@3oool00`000000oooo
0?ooo`1F0?ooo`030000003oool0oooo02L0oooo00<000000?ooo`3oool05@3oool00`000000oooo
0?ooo`0m0?ooo`030000003oool0oooo0240oooo000R0?ooo`030000003oool0oooo05D0oooo00<0
00000?ooo`3oool09`3oool00`000000oooo0?ooo`0D0?ooo`030000003oool0oooo03h0oooo00<0
00000?ooo`3oool08@3oool00280oooo00<000000?ooo`3oool0E03oool00`000000oooo0?ooo`0Y
0?ooo`030000003oool0oooo01<0oooo00<000000?ooo`3oool0?@3oool00`000000oooo0?ooo`0R
0?ooo`008`3oool00`000000oooo0?ooo`1C0?ooo`030000003oool0oooo02T0oooo00<000000?oo
o`3oool04P3oool00`000000oooo0?ooo`0n0?ooo`030000003oool0oooo0280oooo000S0?ooo`03
0000003oool0oooo0580oooo00<000000?ooo`3oool0:`3oool00`000000oooo0?ooo`0A0?ooo`03
0000003oool0oooo03d0oooo00<000000?ooo`3oool08`3oool002@0oooo00<000000?ooo`3oool0
D@3oool00`000000oooo0?ooo`0[0?ooo`030000003oool0oooo0100oooo00<000000?ooo`3oool0
?P3oool00`000000oooo0?ooo`0S0?ooo`00903oool00`000000oooo0?ooo`1@0?ooo`030000003o
ool0oooo02d0oooo00<000000?ooo`3oool03`3oool00`000000oooo0?ooo`0m0?ooo`030000003o
ool0oooo02@0oooo000U0?ooo`030000003oool0oooo04l0oooo00<000000?ooo`3oool0;@3oool0
0`000000oooo0?ooo`0>0?ooo`030000003oool0oooo03h0oooo00<000000?ooo`3oool0903oool0
02D0oooo00<000000?ooo`3oool0CP3oool00`000000oooo0?ooo`0_0?ooo`030000003oool0oooo
00d0oooo00<000000?ooo`3oool0?@3oool00`000000oooo0?ooo`0U0?ooo`009P3oool00`000000
oooo0?ooo`1=0?ooo`030000003oool0oooo02l0oooo00<000000?ooo`3oool0303oool00`000000
oooo0?ooo`0n0?ooo`030000003oool0oooo02D0oooo000V0?ooo`030000003oool0oooo04`0oooo
00<000000?ooo`3oool0<@3oool00`000000oooo0?ooo`0;0?ooo`030000003oool0oooo03d0oooo
00<000000?ooo`3oool09P3oool002L0oooo00<000000?ooo`3oool0B`3oool00`000000oooo0?oo
o`0a0?ooo`030000003oool0oooo00X0oooo00<000000?ooo`3oool0?P3oool00`000000oooo0?oo
o`0V0?ooo`009`3oool00`000000oooo0?ooo`1:0?ooo`030000003oool0oooo03<0oooo00<00000
0?ooo`3oool02@3oool00`000000oooo0?ooo`0m0?ooo`030000003oool0oooo02L0oooo000X0?oo
o`030000003oool0oooo04T0oooo00<000000?ooo`3oool0<`3oool00`000000oooo0?ooo`080?oo
o`030000003oool0oooo03h0oooo00<000000?ooo`3oool09`3oool002P0oooo00<000000?ooo`3o
ool0B03oool00`000000oooo0?ooo`0e0?ooo`030000003oool0oooo00L0oooo00<000000?ooo`3o
ool0?@3oool00`000000oooo0?ooo`0X0?ooo`00:@3oool00`000000oooo0?ooo`170?ooo`030000
003oool0oooo03D0oooo00<000000?ooo`3oool01P3oool00`000000oooo0?ooo`0n0?ooo`030000
003oool0oooo02P0oooo000Y0?ooo`030000003oool0oooo04H0oooo00<000000?ooo`3oool0=`3o
ool00`000000oooo0?ooo`050?ooo`030000003oool0oooo03d0oooo00<000000?ooo`3oool0:@3o
ool002X0oooo00<000000?ooo`3oool0A@3oool00`000000oooo0?ooo`0g0?ooo`030000003oool0
oooo00@0oooo00<000000?ooo`3oool0?P3oool00`000000oooo0?ooo`0Y0?ooo`00:P3oool00`00
0000oooo0?ooo`140?ooo`030000003oool0oooo03T0oooo00<000000?ooo`3oool00`3oool00`00
0000oooo0?ooo`0m0?ooo`030000003oool0oooo02X0oooo000[0?ooo`030000003oool0oooo04<0
oooo00<000000?ooo`3oool0>@3oool00`000000oooo0?ooo`020?ooo`030000003oool0oooo03h0
oooo00<000000?ooo`3oool0:P3oool002/0oooo00<000000?ooo`3oool0@P3oool00`000000oooo
0?ooo`0k0?ooo`050000003oool0oooo0?ooo`000000?`3oool00`000000oooo0?ooo`0[0?ooo`00
;03oool00`000000oooo0?ooo`110?ooo`030000003oool0oooo03/0oooo00@000000?ooo`3oool0
0000@03oool00`000000oooo0?ooo`0[0?ooo`00;03oool00`000000oooo0?ooo`100?ooo`030000
003oool0oooo03d0oooo00<000000?ooo`000000?`3oool00`000000oooo0?ooo`0/0?ooo`00;@3o
ool00`000000oooo0?ooo`0o0?ooo`030000003oool0oooo03`0oooo0`0000100?ooo`030000003o
ool0oooo02`0oooo000]0?ooo`030000003oool0oooo03h0oooo00<000000?ooo`3oool0?03oool5
000003h0oooo00<000000?ooo`3oool0;@3oool002h0oooo00<000000?ooo`3oool0?@3oool00`00
0000oooo0?ooo`0l0?ooo`D00000?P3oool00`000000oooo0?ooo`0]0?ooo`00;P3oool00`000000
oooo0?ooo`0l0?ooo`030000003oool0oooo03d0oooo1@00000m0?ooo`030000003oool0oooo02h0
oooo000_0?ooo`030000003oool0oooo03/0oooo00<000000?ooo`3oool0?P3oool4000003d0oooo
00<000000?ooo`3oool0;P3oool002l0oooo00<000000?ooo`3oool0>P3oool00`000000oooo0?oo
o`130?ooo`030000003oool0oooo03T0oooo00<000000?ooo`3oool0;`3oool00300oooo00<00000
0?ooo`3oool0>@3oool00`000000oooo0?ooo`130?ooo`030000003oool0oooo03T0oooo00<00000
0?ooo`3oool0;`3oool00300oooo00<000000?ooo`3oool0>03oool00`000000oooo0?ooo`150?oo
o`030000003oool0oooo03L0oooo00<000000?ooo`3oool0<03oool00340oooo00<000000?ooo`3o
ool0=`3oool00`000000oooo0?ooo`150?ooo`030000003oool0oooo03L0oooo00<000000?ooo`3o
ool0<03oool00340oooo00<000000?ooo`3oool0=P3oool00`000000oooo0?ooo`170?ooo`030000
003oool0oooo03D0oooo00<000000?ooo`3oool0<@3oool00380oooo00<000000?ooo`3oool0=@3o
ool00`000000oooo0?ooo`170?ooo`030000003oool0oooo03D0oooo00<000000?ooo`3oool0<@3o
ool00380oooo00<000000?ooo`3oool0=03oool00`000000oooo0?ooo`190?ooo`030000003oool0
oooo03<0oooo00<000000?ooo`3oool0<P3oool003<0oooo00<000000?ooo`3oool0<`3oool00`00
0000oooo0?ooo`190?ooo`030000003oool0oooo03<0oooo00<000000?ooo`3oool0<P3oool003<0
oooo00<000000?ooo`3oool0<P3oool00`000000oooo0?ooo`1;0?ooo`030000003oool0oooo0340
oooo00<000000?ooo`3oool0<`3oool003@0oooo00<000000?ooo`3oool0<@3oool00`000000oooo
0?ooo`1;0?ooo`030000003oool0oooo0340oooo00<000000?ooo`3oool0<`3oool003@0oooo00<0
00000?ooo`3oool0<03oool00`000000oooo0?ooo`1=0?ooo`030000003oool0oooo02l0oooo00<0
00000?ooo`3oool0=03oool003D0oooo00<000000?ooo`3oool0;`3oool00`000000oooo0?ooo`1=
0?ooo`030000003oool0oooo02l0oooo00<000000?ooo`3oool0=03oool003D0oooo00<000000?oo
o`3oool0;P3oool00`000000oooo0?ooo`1?0?ooo`030000003oool0oooo02d0oooo00<000000?oo
o`3oool0=@3oool003H0oooo00<000000?ooo`3oool0;@3oool00`000000oooo0?ooo`1?0?ooo`03
0000003oool0oooo02d0oooo00<000000?ooo`3oool0=@3oool003H0oooo00<000000?ooo`3oool0
;03oool00`000000oooo0?ooo`1A0?ooo`030000003oool0oooo02/0oooo00<000000?ooo`3oool0
=P3oool003L0oooo00<000000?ooo`3oool0:`3oool00`000000oooo0?ooo`1A0?ooo`030000003o
ool0oooo02/0oooo00<000000?ooo`3oool0=P3oool003L0oooo00<000000?ooo`3oool0:P3oool0
0`000000oooo0?ooo`1C0?ooo`030000003oool0oooo02T0oooo00<000000?ooo`3oool0=`3oool0
03P0oooo00<000000?ooo`3oool0:@3oool00`000000oooo0?ooo`1C0?ooo`030000003oool0oooo
02T0oooo00<000000?ooo`3oool0=`3oool003P0oooo00<000000?ooo`3oool0:03oool00`000000
oooo0?ooo`1E0?ooo`030000003oool0oooo02L0oooo00<000000?ooo`3oool0>03oool003T0oooo
00<000000?ooo`3oool09`3oool00`000000oooo0?ooo`1E0?ooo`030000003oool0oooo02L0oooo
00<000000?ooo`3oool0>03oool003T0oooo00<000000?ooo`3oool09P3oool00`000000oooo0?oo
o`1G0?ooo`030000003oool0oooo02D0oooo00<000000?ooo`3oool0>@3oool003X0oooo00<00000
0?ooo`3oool09@3oool00`000000oooo0?ooo`1G0?ooo`030000003oool0oooo02D0oooo00<00000
0?ooo`3oool0>@3oool003X0oooo00<000000?ooo`3oool0903oool00`000000oooo0?ooo`1I0?oo
o`030000003oool0oooo02<0oooo00<000000?ooo`3oool0>P3oool003/0oooo00<000000?ooo`3o
ool08`3oool00`000000oooo0?ooo`1I0?ooo`030000003oool0oooo02<0oooo00<000000?ooo`3o
ool0>P3oool003/0oooo00<000000?ooo`3oool08P3oool00`000000oooo0?ooo`1K0?ooo`030000
003oool0oooo0240oooo00<000000?ooo`3oool0>`3oool003`0oooo00<000000?ooo`3oool08@3o
ool00`000000oooo0?ooo`1K0?ooo`030000003oool0oooo0240oooo00<000000?ooo`3oool0>`3o
ool003`0oooo00<000000?ooo`3oool0803oool00`000000oooo0?ooo`1M0?ooo`030000003oool0
oooo01l0oooo00<000000?ooo`3oool0?03oool003d0oooo00<000000?ooo`3oool07`3oool00`00
0000oooo0?ooo`1M0?ooo`030000003oool0oooo01l0oooo00<000000?ooo`3oool0?03oool003d0
oooo00<000000?ooo`3oool07P3oool00`000000oooo0?ooo`1O0?ooo`030000003oool0oooo01d0
oooo00<000000?ooo`3oool0?@3oool003h0oooo00<000000?ooo`3oool07@3oool00`000000oooo
0?ooo`1O0?ooo`030000003oool0oooo01d0oooo00<000000?ooo`3oool0?@3oool003h0oooo00<0
00000?ooo`3oool0703oool00`000000oooo0?ooo`1Q0?ooo`030000003oool0oooo01/0oooo00<0
00000?ooo`3oool0?P3oool003l0oooo00<000000?ooo`3oool06`3oool00`000000oooo0?ooo`1Q
0?ooo`030000003oool0oooo01/0oooo00<000000?ooo`3oool0?P3oool003l0oooo00<000000?oo
o`3oool06P3oool00`000000oooo0?ooo`1S0?ooo`030000003oool0oooo01T0oooo00<000000?oo
o`3oool0?`3oool00400oooo00<000000?ooo`3oool06@3oool00`000000oooo0?ooo`1S0?ooo`03
0000003oool0oooo01T0oooo00<000000?ooo`3oool0?`3oool00400oooo00<000000?ooo`3oool0
603oool00`000000oooo0?ooo`1U0?ooo`030000003oool0oooo01L0oooo00<000000?ooo`3oool0
@03oool00440oooo00<000000?ooo`3oool05`3oool00`000000oooo0?ooo`1U0?ooo`030000003o
ool0oooo01L0oooo00<000000?ooo`3oool0@03oool00440oooo00<000000?ooo`3oool05P3oool0
0`000000oooo0?ooo`1W0?ooo`030000003oool0oooo01D0oooo00<000000?ooo`3oool0@@3oool0
0480oooo00<000000?ooo`3oool05@3oool00`000000oooo0?ooo`1W0?ooo`030000003oool0oooo
01D0oooo00<000000?ooo`3oool0@@3oool00480oooo00<000000?ooo`3oool0503oool00`000000
oooo0?ooo`1Y0?ooo`030000003oool0oooo01<0oooo00<000000?ooo`3oool0@P3oool004<0oooo
00<000000?ooo`3oool04`3oool00`000000oooo0?ooo`1Y0?ooo`030000003oool0oooo01<0oooo
00<000000?ooo`3oool0@P3oool004<0oooo00<000000?ooo`3oool04P3oool00`000000oooo0?oo
o`1[0?ooo`030000003oool0oooo0140oooo00<000000?ooo`3oool0@`3oool004@0oooo00<00000
0?ooo`3oool04@3oool00`000000oooo0?ooo`1[0?ooo`030000003oool0oooo0140oooo00<00000
0?ooo`3oool0@`3oool004@0oooo00<000000?ooo`3oool0403oool00`000000oooo0?ooo`1]0?oo
o`030000003oool0oooo00l0oooo00<000000?ooo`3oool0A03oool004D0oooo00<000000?ooo`3o
ool03`3oool00`000000oooo0?ooo`1]0?ooo`030000003oool0oooo00l0oooo00<000000?ooo`3o
ool0A03oool004D0oooo00<000000?ooo`3oool03P3oool00`000000oooo0?ooo`1_0?ooo`030000
003oool0oooo00d0oooo00<000000?ooo`3oool0A@3oool004H0oooo00<000000?ooo`3oool03@3o
ool00`000000oooo0?ooo`1_0?ooo`030000003oool0oooo00d0oooo00<000000?ooo`3oool0A@3o
ool004H0oooo00<000000?ooo`3oool0303oool00`000000oooo0?ooo`1a0?ooo`030000003oool0
oooo00/0oooo00<000000?ooo`3oool0AP3oool004L0oooo00<000000?ooo`3oool02`3oool00`00
0000oooo0?ooo`1a0?ooo`030000003oool0oooo00/0oooo00<000000?ooo`3oool0AP3oool004L0
oooo00<000000?ooo`3oool02P3oool00`000000oooo0?ooo`1c0?ooo`030000003oool0oooo00T0
oooo00<000000?ooo`3oool0A`3oool004P0oooo00<000000?ooo`3oool02@3oool00`000000oooo
0?ooo`1c0?ooo`030000003oool0oooo00T0oooo00<000000?ooo`3oool0A`3oool004P0oooo00<0
00000?ooo`3oool0203oool00`000000oooo0?ooo`1e0?ooo`030000003oool0oooo00L0oooo00<0
00000?ooo`3oool0B03oool004T0oooo00<000000?ooo`3oool01`3oool00`000000oooo0?ooo`1e
0?ooo`030000003oool0oooo00L0oooo00<000000?ooo`3oool0B03oool004T0oooo00<000000?oo
o`3oool01P3oool00`000000oooo0?ooo`1g0?ooo`030000003oool0oooo00D0oooo00<000000?oo
o`3oool0B@3oool004X0oooo00<000000?ooo`3oool01@3oool00`000000oooo0?ooo`1g0?ooo`03
0000003oool0oooo00D0oooo00<000000?ooo`3oool0B@3oool004X0oooo00<000000?ooo`3oool0
103oool00`000000oooo0?ooo`1i0?ooo`030000003oool0oooo00<0oooo00<000000?ooo`3oool0
BP3oool004/0oooo00<000000?ooo`3oool00`3oool00`000000oooo0?ooo`1i0?ooo`030000003o
ool0oooo00<0oooo00<000000?ooo`3oool0BP3oool004/0oooo00<000000?ooo`3oool00P3oool0
0`000000oooo0?ooo`1k0?ooo`050000003oool0oooo0?ooo`000000C@3oool004`0oooo00D00000
0?ooo`3oool0oooo0000001m0?ooo`050000003oool0oooo0?ooo`000000C@3oool004`0oooo00@0
00000?ooo`3oool00000O`3oool00`000000oooo0000001>0?ooo`00C@3oool00`000000oooo0000
001o0?ooo`030000003oool0000004h0oooo001<0?ooo`<00000P03oool3000004h0oooo001;0?oo
ohP00000C@3oool004/0oooo1@00001n0?ooo`D00000C@3oool004/0oooo1@00001n0?ooo`D00000
C@3oool004`0oooo0`0000200?ooo`<00000CP3oool00?l0oooo8@3oool00?l0oooo8@3oool00?l0
oooo8@3oool00?l0oooo8@3oool00?l0oooo8@3oool00?l0oooo8@3oool00?l0oooo8@3oool00?l0
oooo8@3oool00?l0oooo8@3oool00?l0oooo8@3oool00001\
\>"],
  ImageRangeCache->{{{0, 287}, {287, 0}} -> {-1.10001, -0.952637, 0.00766559, \
0.00663859}}],

Cell[BoxData[
    TagBox[\(\[SkeletonIndicator]  Graphics  \[SkeletonIndicator]\),
      False,
      Editable->False]], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    \(\(\(draw[mm, \ 
      F\ \  . \ F\  . \ P]\)\(\ \ \ \ \ \ \ \ \ \ \ \ \ \ \)\)\)], "Input"],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: 1 
MathPictureStart
/Mabs {
Mgmatrix idtransform
Mtmatrix dtransform
} bind def
/Mabsadd { Mabs
3 -1 roll add
3 1 roll add
exch } bind def
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
0.5 0.454545 0.5 0.524864 [
[ 0 0 0 0 ]
[ 1 1 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 0 m
1 0 L
1 1 L
0 1 L
closepath
clip
newpath
0 g
.02 w
.72727 .95455 Mdot
.27273 .95455 Mdot
.04545 .5 Mdot
.27273 .04545 Mdot
.72727 .04545 Mdot
.95455 .5 Mdot
.75568 .5 Mdot
.55682 .5 Mdot
.5 .5 Mdot
.47159 .55682 Mdot
.37216 .75568 Mdot
.21591 .5 Mdot
.37216 .24432 Mdot
.47159 .44318 Mdot
.55682 .5 Mdot
.64205 .21591 Mdot
.44318 .5 Mdot
.64205 .78409 Mdot
.55682 .5 Mdot
.53788 .42424 Mdot
.46212 .5 Mdot
.38636 .5 Mdot
.53788 .57576 Mdot
.5 Mabswid
[ ] 0 setdash
.72727 .95455 m
.27273 .95455 L
s
.72727 .95455 m
.95455 .5 L
s
.72727 .95455 m
.64205 .78409 L
s
.27273 .95455 m
.72727 .95455 L
s
.27273 .95455 m
.04545 .5 L
s
.27273 .95455 m
.37216 .75568 L
s
.04545 .5 m
.27273 .95455 L
s
.04545 .5 m
.27273 .04545 L
s
.04545 .5 m
.21591 .5 L
s
.27273 .04545 m
.04545 .5 L
s
.27273 .04545 m
.72727 .04545 L
s
.27273 .04545 m
.37216 .24432 L
s
.72727 .04545 m
.27273 .04545 L
s
.72727 .04545 m
.95455 .5 L
s
.72727 .04545 m
.64205 .21591 L
s
.95455 .5 m
.72727 .95455 L
s
.95455 .5 m
.72727 .04545 L
s
.95455 .5 m
.75568 .5 L
s
.75568 .5 m
.95455 .5 L
s
.75568 .5 m
.55682 .5 L
s
.75568 .5 m
.55682 .5 L
s
.75568 .5 m
.64205 .21591 L
s
.75568 .5 m
.64205 .78409 L
s
.75568 .5 m
.55682 .5 L
s
.75568 .5 m
.53788 .42424 L
s
.75568 .5 m
.53788 .57576 L
s
.55682 .5 m
.75568 .5 L
s
.55682 .5 m
.5 .5 L
s
.55682 .5 m
.55682 .5 L
s
.55682 .5 m
.53788 .42424 L
s
.5 .5 m
.55682 .5 L
s
.5 .5 m
.47159 .55682 L
s
.5 .5 m
.47159 .44318 L
s
.5 .5 m
.55682 .5 L
s
.5 .5 m
.55682 .5 L
s
.5 .5 m
.53788 .42424 L
s
.5 .5 m
.46212 .5 L
s
.5 .5 m
.53788 .57576 L
s
.47159 .55682 m
.5 .5 L
s
.47159 .55682 m
.37216 .75568 L
s
.47159 .55682 m
.46212 .5 L
s
.47159 .55682 m
.53788 .57576 L
s
.37216 .75568 m
.27273 .95455 L
s
.37216 .75568 m
.47159 .55682 L
s
.37216 .75568 m
.21591 .5 L
s
.37216 .75568 m
.44318 .5 L
s
.37216 .75568 m
.64205 .78409 L
s
.37216 .75568 m
.46212 .5 L
s
.37216 .75568 m
.38636 .5 L
s
.37216 .75568 m
.53788 .57576 L
s
.21591 .5 m
.04545 .5 L
s
.21591 .5 m
.37216 .75568 L
s
.21591 .5 m
.37216 .24432 L
s
.21591 .5 m
.38636 .5 L
s
.37216 .24432 m
.27273 .04545 L
s
.37216 .24432 m
.21591 .5 L
s
.37216 .24432 m
.47159 .44318 L
s
.37216 .24432 m
.64205 .21591 L
s
.37216 .24432 m
.44318 .5 L
s
.37216 .24432 m
.53788 .42424 L
s
.37216 .24432 m
.46212 .5 L
s
.37216 .24432 m
.38636 .5 L
s
.47159 .44318 m
.5 .5 L
s
.47159 .44318 m
.37216 .24432 L
s
.47159 .44318 m
.53788 .42424 L
s
.47159 .44318 m
.46212 .5 L
s
.55682 .5 m
.75568 .5 L
s
.55682 .5 m
.5 .5 L
s
.55682 .5 m
.55682 .5 L
s
.55682 .5 m
.53788 .57576 L
s
.64205 .21591 m
.72727 .04545 L
s
.64205 .21591 m
.75568 .5 L
s
.64205 .21591 m
.37216 .24432 L
s
.64205 .21591 m
.53788 .42424 L
s
.44318 .5 m
.37216 .75568 L
s
.44318 .5 m
.37216 .24432 L
s
.44318 .5 m
.46212 .5 L
s
.44318 .5 m
.38636 .5 L
s
.64205 .78409 m
.72727 .95455 L
s
.64205 .78409 m
.75568 .5 L
s
.64205 .78409 m
.37216 .75568 L
s
.64205 .78409 m
.53788 .57576 L
s
.55682 .5 m
.75568 .5 L
s
.55682 .5 m
.55682 .5 L
s
.55682 .5 m
.5 .5 L
s
.55682 .5 m
.55682 .5 L
s
.53788 .42424 m
.75568 .5 L
s
.53788 .42424 m
.55682 .5 L
s
.53788 .42424 m
.5 .5 L
s
.53788 .42424 m
.37216 .24432 L
s
.53788 .42424 m
.47159 .44318 L
s
.53788 .42424 m
.64205 .21591 L
s
.46212 .5 m
.5 .5 L
s
.46212 .5 m
.47159 .55682 L
s
.46212 .5 m
.37216 .75568 L
s
.46212 .5 m
.37216 .24432 L
s
.46212 .5 m
.47159 .44318 L
s
.46212 .5 m
.44318 .5 L
s
.38636 .5 m
.37216 .75568 L
s
.38636 .5 m
.21591 .5 L
s
.38636 .5 m
.37216 .24432 L
s
.38636 .5 m
.44318 .5 L
s
.53788 .57576 m
.75568 .5 L
s
.53788 .57576 m
.5 .5 L
s
.53788 .57576 m
.47159 .55682 L
s
.53788 .57576 m
.37216 .75568 L
s
.53788 .57576 m
.55682 .5 L
s
.53788 .57576 m
.64205 .78409 L
s
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  ImageSize->{288, 288},
  ImageMargins->{{43, 0}, {0, 0}},
  ImageRegion->{{0, 1}, {0, 1}},
  ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`40004P000182000`400?l00000o`00003oo`3ooolQ
0?ooo`00o`3ooolQ0?ooo`00o`3ooolQ0?ooo`00o`3ooolQ0?ooo`00o`3ooolQ0?ooo`00o`3ooolQ
0?ooo`00o`3ooolQ0?ooo`00o`3ooolQ0?ooo`00o`3ooolQ0?ooo`00o`3ooolQ0?ooo`00o`3ooolQ
0?ooo`00o`3ooolQ0?ooo`00C03oool300000800oooo0`00001>0?ooo`00B`3oool5000007h0oooo
1@00001=0?ooo`00B`3ooon8000004d0oooo001;0?ooo`D00000OP3oool5000004d0oooo001<0?oo
o`@00000O`3oool3000004h0oooo001<0?ooo`040000003oool0oooo000007h0oooo00@000000?oo
o`3oool00000CP3oool004`0oooo00D000000?ooo`3oool0oooo0000001m0?ooo`050000003oool0
oooo0?ooo`000000C@3oool004/0oooo00<000000?ooo`3oool00P3oool00`000000oooo0?ooo`1j
0?ooo`030000003oool0oooo0080oooo00<000000?ooo`3oool0B`3oool004/0oooo00<000000?oo
o`3oool00`3oool00`000000oooo0?ooo`1i0?ooo`030000003oool0oooo00<0oooo00<000000?oo
o`3oool0BP3oool004X0oooo00<000000?ooo`3oool0103oool00`000000oooo0?ooo`1h0?ooo`03
0000003oool0oooo00@0oooo00<000000?ooo`3oool0BP3oool004X0oooo00<000000?ooo`3oool0
1@3oool00`000000oooo0?ooo`1g0?ooo`030000003oool0oooo00D0oooo00<000000?ooo`3oool0
B@3oool004T0oooo00<000000?ooo`3oool01P3oool00`000000oooo0?ooo`1f0?ooo`030000003o
ool0oooo00H0oooo00<000000?ooo`3oool0B@3oool004T0oooo00<000000?ooo`3oool01`3oool0
0`000000oooo0?ooo`1e0?ooo`030000003oool0oooo00L0oooo00<000000?ooo`3oool0B03oool0
04P0oooo00<000000?ooo`3oool0203oool00`000000oooo0?ooo`1d0?ooo`030000003oool0oooo
00P0oooo00<000000?ooo`3oool0B03oool004P0oooo00<000000?ooo`3oool02@3oool00`000000
oooo0?ooo`1c0?ooo`030000003oool0oooo00T0oooo00<000000?ooo`3oool0A`3oool004L0oooo
00<000000?ooo`3oool02P3oool00`000000oooo0?ooo`1b0?ooo`030000003oool0oooo00X0oooo
00<000000?ooo`3oool0A`3oool004L0oooo00<000000?ooo`3oool02`3oool00`000000oooo0?oo
o`1a0?ooo`030000003oool0oooo00/0oooo00<000000?ooo`3oool0AP3oool004H0oooo00<00000
0?ooo`3oool0303oool00`000000oooo0?ooo`1`0?ooo`030000003oool0oooo00`0oooo00<00000
0?ooo`3oool0AP3oool004H0oooo00<000000?ooo`3oool03@3oool00`000000oooo0?ooo`1_0?oo
o`030000003oool0oooo00d0oooo00<000000?ooo`3oool0A@3oool004D0oooo00<000000?ooo`3o
ool03P3oool00`000000oooo0?ooo`1^0?ooo`030000003oool0oooo00h0oooo00<000000?ooo`3o
ool0A@3oool004D0oooo00<000000?ooo`3oool03`3oool00`000000oooo0?ooo`1]0?ooo`030000
003oool0oooo00l0oooo00<000000?ooo`3oool0A03oool004@0oooo00<000000?ooo`3oool0403o
ool00`000000oooo0?ooo`1/0?ooo`030000003oool0oooo0100oooo00<000000?ooo`3oool0A03o
ool004@0oooo00<000000?ooo`3oool04@3oool00`000000oooo0?ooo`1[0?ooo`030000003oool0
oooo0140oooo00<000000?ooo`3oool0@`3oool004<0oooo00<000000?ooo`3oool04P3oool00`00
0000oooo0?ooo`1Z0?ooo`030000003oool0oooo0180oooo00<000000?ooo`3oool0@`3oool004<0
oooo00<000000?ooo`3oool04`3oool00`000000oooo0?ooo`1Y0?ooo`030000003oool0oooo01<0
oooo00<000000?ooo`3oool0@P3oool00480oooo00<000000?ooo`3oool0503oool00`000000oooo
0?ooo`1X0?ooo`030000003oool0oooo01@0oooo00<000000?ooo`3oool0@P3oool00480oooo00<0
00000?ooo`3oool05@3oool00`000000oooo0?ooo`1W0?ooo`030000003oool0oooo01D0oooo00<0
00000?ooo`3oool0@@3oool00440oooo00<000000?ooo`3oool05P3oool00`000000oooo0?ooo`1V
0?ooo`030000003oool0oooo01H0oooo00<000000?ooo`3oool0@@3oool00440oooo00<000000?oo
o`3oool05`3oool00`000000oooo0?ooo`1U0?ooo`030000003oool0oooo01L0oooo00<000000?oo
o`3oool0@03oool00400oooo00<000000?ooo`3oool0603oool00`000000oooo0?ooo`1T0?ooo`03
0000003oool0oooo01P0oooo00<000000?ooo`3oool0@03oool00400oooo00<000000?ooo`3oool0
6@3oool00`000000oooo0?ooo`1S0?ooo`030000003oool0oooo01T0oooo00<000000?ooo`3oool0
?`3oool003l0oooo00<000000?ooo`3oool06P3oool00`000000oooo0?ooo`1R0?ooo`030000003o
ool0oooo01X0oooo00<000000?ooo`3oool0?`3oool003l0oooo00<000000?ooo`3oool06`3oool0
0`000000oooo0?ooo`1Q0?ooo`030000003oool0oooo01/0oooo00<000000?ooo`3oool0?P3oool0
03h0oooo00<000000?ooo`3oool0703oool00`000000oooo0?ooo`1P0?ooo`030000003oool0oooo
01`0oooo00<000000?ooo`3oool0?P3oool003h0oooo00<000000?ooo`3oool07@3oool00`000000
oooo0?ooo`1O0?ooo`030000003oool0oooo01d0oooo00<000000?ooo`3oool0?@3oool003d0oooo
00<000000?ooo`3oool07P3oool00`000000oooo0?ooo`1N0?ooo`030000003oool0oooo01h0oooo
00<000000?ooo`3oool0?@3oool003d0oooo00<000000?ooo`3oool07`3oool00`000000oooo0?oo
o`1M0?ooo`030000003oool0oooo01l0oooo00<000000?ooo`3oool0?03oool003`0oooo00<00000
0?ooo`3oool0803oool00`000000oooo0?ooo`1L0?ooo`030000003oool0oooo0200oooo00<00000
0?ooo`3oool0?03oool003`0oooo00<000000?ooo`3oool08@3oool00`000000oooo0?ooo`1K0?oo
o`030000003oool0oooo0240oooo00<000000?ooo`3oool0>`3oool003/0oooo00<000000?ooo`3o
ool08P3oool00`000000oooo0?ooo`1J0?ooo`030000003oool0oooo0280oooo00<000000?ooo`3o
ool0>`3oool003/0oooo00<000000?ooo`3oool08`3oool00`000000oooo0?ooo`1I0?ooo`030000
003oool0oooo02<0oooo00<000000?ooo`3oool0>P3oool003X0oooo00<000000?ooo`3oool0903o
ool00`000000oooo0?ooo`1H0?ooo`030000003oool0oooo02@0oooo00<000000?ooo`3oool0>P3o
ool003X0oooo00<000000?ooo`3oool09@3oool00`000000oooo0?ooo`1G0?ooo`030000003oool0
oooo02D0oooo00<000000?ooo`3oool0>@3oool003T0oooo00<000000?ooo`3oool09P3oool00`00
0000oooo0?ooo`1F0?ooo`030000003oool0oooo02H0oooo00<000000?ooo`3oool0>@3oool003T0
oooo00<000000?ooo`3oool09`3oool00`000000oooo0?ooo`1E0?ooo`030000003oool0oooo02L0
oooo00<000000?ooo`3oool0>03oool003P0oooo00<000000?ooo`3oool0:03oool00`000000oooo
0?ooo`1D0?ooo`030000003oool0oooo02P0oooo00<000000?ooo`3oool0>03oool003P0oooo00<0
00000?ooo`3oool0:@3oool00`000000oooo0?ooo`1C0?ooo`030000003oool0oooo02T0oooo00<0
00000?ooo`3oool0=`3oool003L0oooo00<000000?ooo`3oool0:P3oool00`000000oooo0?ooo`1B
0?ooo`030000003oool0oooo02X0oooo00<000000?ooo`3oool0=`3oool003L0oooo00<000000?oo
o`3oool0:`3oool00`000000oooo0?ooo`1A0?ooo`030000003oool0oooo02/0oooo00<000000?oo
o`3oool0=P3oool003H0oooo00<000000?ooo`3oool0;03oool00`000000oooo0?ooo`1>0?ooo`<0
0000;P3oool00`000000oooo0?ooo`0f0?ooo`00=P3oool00`000000oooo0?ooo`0]0?ooo`030000
003oool0oooo04/0oooo1P00000^0?ooo`030000003oool0oooo03D0oooo000e0?ooo`030000003o
ool0oooo02h0oooo00<000000?ooo`3oool0@`3oool8000000030?ooo`000000000000<00000;P3o
ool00`000000oooo0?ooo`0e0?ooo`00=@3oool00`000000oooo0?ooo`0_0?ooo`030000003oool0
oooo03T0oooo2@0000090?ooo`D00000;`3oool00`000000oooo0?ooo`0d0?ooo`00=03oool00`00
0000oooo0?ooo`0`0?ooo`030000003oool0oooo0300oooo2@00000C0?ooo`@00000;`3oool00`00
0000oooo0?ooo`0d0?ooo`00=03oool00`000000oooo0?ooo`0a0?ooo`030000003oool0oooo02L0
oooo2000000L0?ooo`050000003oool0oooo0?ooo`000000;`3oool00`000000oooo0?ooo`0c0?oo
o`00<`3oool00`000000oooo0?ooo`0b0?ooo`030000003oool0oooo01h0oooo2@00000S0?ooo`03
0000003oool0oooo0080oooo00<000000?ooo`3oool0;@3oool00`000000oooo0?ooo`0c0?ooo`00
<`3oool00`000000oooo0?ooo`0c0?ooo`030000003oool0oooo01@0oooo2@00000/0?ooo`030000
003oool0oooo0080oooo00<000000?ooo`3oool0;P3oool00`000000oooo0?ooo`0b0?ooo`00<P3o
ool00`000000oooo0?ooo`0d0?ooo`<00000303oool8000003@0oooo00<000000?ooo`3oool0103o
ool00`000000oooo0?ooo`0]0?ooo`030000003oool0oooo0380oooo000b0?ooo`030000003oool0
oooo03<0oooo1@0000020?ooo`T00000?03oool00`000000oooo0?ooo`040?ooo`030000003oool0
oooo02h0oooo00<000000?ooo`3oool0<@3oool00340oooo00<000000?ooo`3oool0=03oool70000
04@0oooo00<000000?ooo`3oool01P3oool00`000000oooo0?ooo`0]0?ooo`030000003oool0oooo
0340oooo000a0?ooo`030000003oool0oooo03@0oooo1@0000160?ooo`030000003oool0oooo00H0
oooo00<000000?ooo`3oool0;P3oool00`000000oooo0?ooo`0`0?ooo`00<03oool00`000000oooo
0?ooo`0f0?ooo`@00000A@3oool00`000000oooo0?ooo`070?ooo`030000003oool0oooo02h0oooo
00<000000?ooo`3oool0<03oool00300oooo00<000000?ooo`3oool0=@3oool00`000000oooo0000
0003000004@0oooo00<000000?ooo`3oool0203oool00`000000oooo0?ooo`0^0?ooo`030000003o
ool0oooo02l0oooo000_0?ooo`030000003oool0oooo03H0oooo00<000000?ooo`0000000P000000
0`3oool000000?ooo`110?ooo`030000003oool0oooo00T0oooo00<000000?ooo`3oool0;P3oool0
0`000000oooo0?ooo`0_0?ooo`00;`3oool00`000000oooo0?ooo`0e0?ooo`030000003oool0oooo
00@0000000<0oooo0000003oool0@03oool00`000000oooo0?ooo`090?ooo`030000003oool0oooo
02l0oooo00<000000?ooo`3oool0;P3oool002h0oooo00<000000?ooo`3oool0=@3oool01P000000
oooo0?ooo`3oool000000?ooo`8000000P3oool00`000000oooo0?ooo`0m0?ooo`030000003oool0
oooo00/0oooo00<000000?ooo`3oool0;P3oool00`000000oooo0?ooo`0^0?ooo`00;P3oool00`00
0000oooo0?ooo`0e0?ooo`090000003oool0oooo0?ooo`000000oooo0000003oool000000080oooo
00<000000?ooo`3oool0?03oool00`000000oooo0?ooo`0;0?ooo`030000003oool0oooo02l0oooo
00<000000?ooo`3oool0;@3oool002d0oooo00<000000?ooo`3oool0=@3oool00`000000oooo0?oo
o`020?ooo`030000003oool00000008000000`3oool00`000000oooo0?ooo`0j0?ooo`030000003o
ool0oooo00d0oooo00<000000?ooo`3oool0;P3oool00`000000oooo0?ooo`0]0?ooo`00;@3oool0
0`000000oooo0?ooo`0d0?ooo`030000003oool0oooo00<0oooo00H000000?ooo`3oool000000?oo
o`0000020?ooo`030000003oool0oooo03X0oooo00<000000?ooo`3oool03@3oool00`000000oooo
0?ooo`0_0?ooo`030000003oool0oooo02`0oooo000/0?ooo`030000003oool0oooo03D0oooo00<0
00000?ooo`3oool0103oool00`000000oooo00000002000000<0oooo00<000000?ooo`3oool0>03o
ool00`000000oooo0?ooo`0>0?ooo`030000003oool0oooo02l0oooo00<000000?ooo`3oool0;03o
ool002`0oooo00<000000?ooo`3oool0=03oool00`000000oooo0?ooo`050?ooo`060000003oool0
00000000003oool000000`3oool00`000000oooo0?ooo`0g0?ooo`030000003oool0oooo00l0oooo
00<000000?ooo`3oool0;`3oool00`000000oooo0?ooo`0[0?ooo`00:`3oool00`000000oooo0?oo
o`0e0?ooo`030000003oool0oooo00D0oooo00H000000?ooo`00000000000?ooo`0000040?ooo`03
0000003oool0oooo03D0oooo00<000000?ooo`3oool0403oool00`000000oooo0?ooo`0_0?ooo`03
0000003oool0oooo02/0oooo000[0?ooo`030000003oool0oooo03@0oooo00<000000?ooo`3oool0
1P3oool00`000000oooo0?ooo`02000000030?ooo`000000oooo00<0oooo00<000000?ooo`3oool0
=03oool00`000000oooo0?ooo`0A0?ooo`030000003oool0oooo02l0oooo00<000000?ooo`3oool0
:P3oool002X0oooo00<000000?ooo`3oool0=03oool00`000000oooo0?ooo`070?ooo`030000003o
ool0oooo0080000000<0oooo0000003oool0103oool00`000000oooo0?ooo`0b0?ooo`030000003o
ool0oooo0180oooo00<000000?ooo`3oool0;`3oool00`000000oooo0?ooo`0Z0?ooo`00:P3oool0
0`000000oooo0?ooo`0d0?ooo`030000003oool0oooo00L0oooo00<000000?ooo`3oool00P000002
0?ooo`030000003oool0oooo00<0oooo00<000000?ooo`3oool0<@3oool00`000000oooo0?ooo`0B
0?ooo`030000003oool0oooo0300oooo00<000000?ooo`3oool0:@3oool002T0oooo00<000000?oo
o`3oool0=03oool00`000000oooo0?ooo`080?ooo`040000003oool0oooo0?ooo`80000000<0oooo
0000003oool01@3oool00`000000oooo0?ooo`0_0?ooo`030000003oool0oooo01@0oooo00<00000
0?ooo`3oool0;`3oool00`000000oooo0?ooo`0Y0?ooo`00:@3oool00`000000oooo0?ooo`0d0?oo
o`030000003oool0oooo00P0oooo00@000000?ooo`3oool0oooo0P0000020?ooo`030000003oool0
oooo00@0oooo00<000000?ooo`3oool0;P3oool00`000000oooo0?ooo`0D0?ooo`030000003oool0
oooo0300oooo00<000000?ooo`3oool0:03oool002P0oooo00<000000?ooo`3oool0=03oool00`00
0000oooo0?ooo`090?ooo`040000003oool0oooo0?ooo`8000000P3oool00`000000oooo0?ooo`05
0?ooo`030000003oool0oooo02`0oooo00<000000?ooo`3oool05P3oool00`000000oooo0?ooo`0_
0?ooo`030000003oool0oooo02P0oooo000X0?ooo`030000003oool0oooo03<0oooo00<000000?oo
o`3oool02P3oool01`000000oooo0?ooo`3oool000000?ooo`0000000P3oool00`000000oooo0?oo
o`050?ooo`030000003oool0oooo02/0oooo00<000000?ooo`3oool05P3oool00`000000oooo0?oo
o`0`0?ooo`030000003oool0oooo02L0oooo000W0?ooo`030000003oool0oooo03@0oooo00<00000
0?ooo`3oool02P3oool00`000000oooo0?ooo`020?ooo`8000000P3oool00`000000oooo0?ooo`06
0?ooo`030000003oool0oooo02T0oooo00<000000?ooo`3oool05`3oool00`000000oooo0?ooo`0`
0?ooo`030000003oool0oooo02L0oooo000W0?ooo`030000003oool0oooo03<0oooo00<000000?oo
o`3oool02`3oool00`000000oooo0?ooo`020?ooo`8000000`3oool00`000000oooo0?ooo`060?oo
o`030000003oool0oooo02P0oooo00<000000?ooo`3oool0603oool00`000000oooo0?ooo`0`0?oo
o`030000003oool0oooo02H0oooo000V0?ooo`030000003oool0oooo03<0oooo00<000000?ooo`3o
ool0303oool00`000000oooo0?ooo`020?ooo`030000003oool000000080oooo00<000000?ooo`3o
ool01`3oool00`000000oooo0?ooo`0V0?ooo`030000003oool0oooo01T0oooo00<000000?ooo`3o
ool0<03oool00`000000oooo0?ooo`0V0?ooo`009P3oool00`000000oooo0?ooo`0c0?ooo`030000
003oool0oooo00`0oooo00<000000?ooo`3oool00`3oool2000000<0oooo00<000000?ooo`3oool0
1`3oool00`000000oooo0?ooo`0U0?ooo`030000003oool0oooo01T0oooo00<000000?ooo`3oool0
<@3oool00`000000oooo0?ooo`0U0?ooo`009@3oool00`000000oooo0?ooo`0c0?ooo`030000003o
ool0oooo00d0oooo00<000000?ooo`3oool00`3oool00`000000oooo000000020?ooo`030000003o
ool0oooo00P0oooo00<000000?ooo`3oool08`3oool00`000000oooo0?ooo`0K0?ooo`030000003o
ool0oooo0300oooo00<000000?ooo`3oool09@3oool002D0oooo00<000000?ooo`3oool0<`3oool0
0`000000oooo0?ooo`0=0?ooo`030000003oool0oooo00<0oooo00<000000?ooo`0000000`3oool0
0`000000oooo0?ooo`080?ooo`030000003oool0oooo0280oooo00<000000?ooo`3oool06`3oool0
0`000000oooo0?ooo`0a0?ooo`030000003oool0oooo02@0oooo000T0?ooo`030000003oool0oooo
03<0oooo00<000000?ooo`3oool03P3oool00`000000oooo0?ooo`030?ooo`030000003oool00000
00<0oooo00<000000?ooo`3oool0203oool00`000000oooo0?ooo`0Q0?ooo`030000003oool0oooo
01d0oooo00<000000?ooo`3oool0<03oool00`000000oooo0?ooo`0T0?ooo`00903oool00`000000
oooo0?ooo`0b0?ooo`030000003oool0oooo00l0oooo00<000000?ooo`3oool0103oool00`000000
oooo000000030?ooo`030000003oool0oooo00P0oooo00<000000?ooo`3oool0803oool00`000000
oooo0?ooo`0M0?ooo`030000003oool0oooo0340oooo00<000000?ooo`3oool08`3oool002<0oooo
00<000000?ooo`3oool0<`3oool00`000000oooo0?ooo`0@0?ooo`030000003oool0oooo00<0oooo
00<000000?ooo`0000000`3oool00`000000oooo0?ooo`090?ooo`030000003oool0oooo01h0oooo
00<000000?ooo`3oool07P3oool00`000000oooo0?ooo`0a0?ooo`030000003oool0oooo02<0oooo
000S0?ooo`030000003oool0oooo0380oooo00<000000?ooo`3oool04@3oool00`000000oooo0?oo
o`030?ooo`030000003oool0000000@0oooo00<000000?ooo`3oool02@3oool00`000000oooo0?oo
o`0M0?ooo`030000003oool0oooo01l0oooo00<000000?ooo`3oool0<@3oool00`000000oooo0?oo
o`0R0?ooo`008P3oool00`000000oooo0?ooo`0c0?ooo`030000003oool0oooo0140oooo00<00000
0?ooo`3oool0103oool00`000000oooo000000030?ooo`030000003oool0oooo00X0oooo00<00000
0?ooo`3oool06`3oool00`000000oooo0?ooo`0P0?ooo`030000003oool0oooo0340oooo00<00000
0?ooo`3oool08P3oool00280oooo00<000000?ooo`3oool0<P3oool00`000000oooo0?ooo`0B0?oo
o`030000003oool0oooo00@0oooo00<000000?ooo`000000103oool00`000000oooo0?ooo`0:0?oo
o`030000003oool0oooo01X0oooo00<000000?ooo`3oool08@3oool00`000000oooo0?ooo`0a0?oo
o`030000003oool0oooo0240oooo000Q0?ooo`030000003oool0oooo0380oooo00<000000?ooo`3o
ool04`3oool00`000000oooo0?ooo`040?ooo`030000003oool0000000@0oooo00<000000?ooo`3o
ool02`3oool00`000000oooo0?ooo`0H0?ooo`030000003oool0oooo0280oooo00<000000?ooo`3o
ool0<@3oool00`000000oooo0?ooo`0Q0?ooo`008@3oool00`000000oooo0?ooo`0b0?ooo`030000
003oool0oooo01<0oooo00<000000?ooo`3oool0103oool010000000oooo0?ooo`0000040?ooo`03
0000003oool0oooo00/0oooo00<000000?ooo`3oool05`3oool00`000000oooo0?ooo`0R0?ooo`03
0000003oool0oooo0380oooo00<000000?ooo`3oool0803oool00200oooo00<000000?ooo`3oool0
<P3oool00`000000oooo0?ooo`0D0?ooo`030000003oool0oooo00D0oooo00<000000?ooo`000000
103oool00`000000oooo0?ooo`0<0?ooo`030000003oool0oooo01D0oooo00<000000?ooo`3oool0
903oool00`000000oooo0?ooo`0a0?ooo`030000003oool0oooo0200oooo000P0?ooo`030000003o
ool0oooo0340oooo00<000000?ooo`3oool05@3oool00`000000oooo0?ooo`050?ooo`030000003o
ool0000000D0oooo00<000000?ooo`3oool0303oool00`000000oooo0?ooo`0D0?ooo`030000003o
ool0oooo02@0oooo00<000000?ooo`3oool0<P3oool00`000000oooo0?ooo`0O0?ooo`007`3oool0
0`000000oooo0?ooo`0b0?ooo`030000003oool0oooo01D0oooo00<000000?ooo`3oool01@3oool0
10000000oooo0?ooo`0000040?ooo`030000003oool0oooo00d0oooo00<000000?ooo`3oool04P3o
ool00`000000oooo0?ooo`0V0?ooo`030000003oool0oooo0340oooo00<000000?ooo`3oool07`3o
ool001l0oooo00<000000?ooo`3oool0<@3oool00`000000oooo0?ooo`0F0?ooo`030000003oool0
oooo00H0oooo00<000000?ooo`0000001@3oool00`000000oooo0?ooo`0=0?ooo`030000003oool0
oooo0140oooo00<000000?ooo`3oool09P3oool00`000000oooo0?ooo`0b0?ooo`030000003oool0
oooo01h0oooo000N0?ooo`030000003oool0oooo0380oooo00<000000?ooo`3oool05P3oool00`00
0000oooo0?ooo`060?ooo`040000003oool0oooo000000@0oooo00<000000?ooo`3oool03P3oool0
0`000000oooo0?ooo`0?0?ooo`030000003oool0oooo02L0oooo00<000000?ooo`3oool0<P3oool0
0`000000oooo0?ooo`0N0?ooo`007P3oool00`000000oooo0?ooo`0a0?ooo`030000003oool0oooo
01L0oooo00<000000?ooo`3oool01P3oool010000000oooo0?ooo`0000050?ooo`030000003oool0
oooo00h0oooo00<000000?ooo`3oool03P3oool00`000000oooo0?ooo`0X0?ooo`030000003oool0
oooo0380oooo00<000000?ooo`3oool07@3oool001d0oooo00<000000?ooo`3oool0<@3oool00`00
0000oooo0?ooo`0H0?ooo`030000003oool0oooo00L0oooo00<000000?ooo`0000001@3oool00`00
0000oooo0?ooo`0?0?ooo`030000003oool0oooo00`0oooo00<000000?ooo`3oool0:@3oool00`00
0000oooo0?ooo`0b0?ooo`030000003oool0oooo01d0oooo000M0?ooo`030000003oool0oooo0340
oooo00<000000?ooo`3oool0603oool00`000000oooo0?ooo`070?ooo`040000003oool0oooo0000
00D0oooo00<000000?ooo`3oool03`3oool00`000000oooo0?ooo`0;0?ooo`030000003oool0oooo
02X0oooo00<000000?ooo`3oool0<P3oool00`000000oooo0?ooo`0L0?ooo`00703oool00`000000
oooo0?ooo`0a0?ooo`030000003oool0oooo01T0oooo00<000000?ooo`3oool01`3oool010000000
oooo0?ooo`0000050?ooo`030000003oool0oooo0100oooo00<000000?ooo`3oool02@3oool00`00
0000oooo0?ooo`0[0?ooo`030000003oool0oooo0380oooo00<000000?ooo`3oool0703oool001`0
oooo00<000000?ooo`3oool0<03oool00`000000oooo0?ooo`0J0?ooo`030000003oool0oooo00L0
oooo00@000000?ooo`3oool000001P3oool00`000000oooo0?ooo`0?0?ooo`030000003oool0oooo
00T0oooo00<000000?ooo`3oool0:`3oool00`000000oooo0?ooo`0c0?ooo`030000003oool0oooo
01/0oooo000K0?ooo`030000003oool0oooo0340oooo00<000000?ooo`3oool06P3oool00`000000
oooo0?ooo`080?ooo`040000003oool0oooo000000D0oooo00<000000?ooo`3oool0403oool00`00
0000oooo0?ooo`070?ooo`030000003oool0oooo02d0oooo00<000000?ooo`3oool0<P3oool00`00
0000oooo0?ooo`0K0?ooo`006`3oool00`000000oooo0?ooo`0`0?ooo`030000003oool0oooo01/0
oooo00<000000?ooo`3oool0203oool010000000oooo0?ooo`0000060?ooo`030000003oool0oooo
0100oooo00<000000?ooo`3oool01P3oool00`000000oooo0?ooo`0]0?ooo`030000003oool0oooo
03<0oooo00<000000?ooo`3oool06P3oool001X0oooo00<000000?ooo`3oool0<@3oool00`000000
oooo0?ooo`0L0?ooo`030000003oool0oooo00L0oooo00@000000?ooo`3oool000001P3oool00`00
0000oooo0?ooo`0A0?ooo`030000003oool0oooo00@0oooo00<000000?ooo`3oool0;P3oool00`00
0000oooo0?ooo`0c0?ooo`030000003oool0oooo01X0oooo000J0?ooo`030000003oool0oooo0300
oooo00<000000?ooo`3oool07@3oool00`000000oooo0?ooo`080?ooo`040000003oool0oooo0000
00H0oooo00<000000?ooo`3oool04@3oool00`000000oooo0?ooo`030?ooo`030000003oool0oooo
02l0oooo00<000000?ooo`3oool0<`3oool00`000000oooo0?ooo`0I0?ooo`006@3oool00`000000
oooo0?ooo`0`0?ooo`030000003oool0oooo01h0oooo00<000000?ooo`3oool0203oool010000000
oooo0?ooo`0000060?ooo`030000003oool0oooo0180oooo00D000000?ooo`3oool0oooo0000000b
0?ooo`030000003oool0oooo03<0oooo00<000000?ooo`3oool06@3oool001T0oooo00<000000?oo
o`3oool0<03oool00`000000oooo0?ooo`0N0?ooo`030000003oool0oooo00P0oooo00@000000?oo
o`3oool000001`3oool00`000000oooo0?ooo`0B0?ooo`040000003oool0oooo000003<0oooo00<0
00000?ooo`3oool0<`3oool00`000000oooo0?ooo`0H0?ooo`00603oool00`000000oooo0?ooo`0`
0?ooo`030000003oool0oooo01l0oooo00<000000?ooo`3oool0203oool01@000000oooo0?ooo`3o
ool0000000H0oooo00<000000?ooo`3oool04`3oool3000003<0oooo00<000000?ooo`3oool0<`3o
ool00`000000oooo0?ooo`0H0?ooo`00603oool00`000000oooo0?ooo`0`0?ooo`030000003oool0
oooo01l0oooo00<000000?ooo`3oool02@3oool010000000oooo0?ooo`0000070?ooo`030000003o
ool0oooo0140oooo1@00000b0?ooo`030000003oool0oooo03@0oooo00<000000?ooo`3oool05`3o
ool001L0oooo00<000000?ooo`3oool0<03oool00`000000oooo0?ooo`0P0?ooo`030000003oool0
oooo00T0oooo00D000000?ooo`3oool0oooo000000060?ooo`030000003oool0oooo00l0oooo2@00
000a0?ooo`030000003oool0oooo03<0oooo00<000000?ooo`3oool05`3oool001L0oooo00<00000
0?ooo`3oool0;`3oool00`000000oooo0?ooo`0Q0?ooo`030000003oool0oooo00T0oooo00D00000
0?ooo`3oool0oooo000000070?ooo`030000003oool0oooo00/0oooo0`0000020?ooo`D000000P3o
ool3000002h0oooo00<000000?ooo`3oool0=03oool00`000000oooo0?ooo`0F0?ooo`005P3oool0
0`000000oooo0?ooo`0`0?ooo`030000003oool0oooo0240oooo00<000000?ooo`3oool02P3oool0
10000000oooo0?ooo`0000070?ooo`030000003oool0oooo00L0oooo100000050?ooo`@000001P3o
ool2000002d0oooo00<000000?ooo`3oool0<`3oool00`000000oooo0?ooo`0F0?ooo`005P3oool0
0`000000oooo0?ooo`0_0?ooo`030000003oool0oooo0280oooo00<000000?ooo`3oool02P3oool0
1@000000oooo0?ooo`3oool0000000L0oooo0`0000030?ooo`<000002@3oool010000000oooo0?oo
o`0000080?ooo`<00000:P3oool00`000000oooo0?ooo`0d0?ooo`030000003oool0oooo01D0oooo
000E0?ooo`030000003oool0oooo02l0oooo00<000000?ooo`3oool08`3oool00`000000oooo0?oo
o`0:0?ooo`050000003oool0oooo0?ooo`0000001P3oool7000000/0oooo00D000000?ooo`3oool0
oooo0000000;0?ooo`<000009`3oool00`000000oooo0?ooo`0d0?ooo`030000003oool0oooo01D0
oooo000E0?ooo`030000003oool0oooo02l0oooo00<000000?ooo`3oool08`3oool00`000000oooo
0?ooo`0:0?ooo`050000003oool0oooo0?ooo`0000001P3oool5000000d0oooo00D000000?ooo`3o
ool0oooo0000000>0?ooo`<000009@3oool00`000000oooo0?ooo`0d0?ooo`030000003oool0oooo
01@0oooo000D0?ooo`030000003oool0oooo02l0oooo00<000000?ooo`3oool0903oool00`000000
oooo0?ooo`0;0?ooo`050000003oool0oooo0?ooo`0000001@3oool5000000`0oooo00<000000?oo
o`3oool00`3oool00`000000oooo0?ooo`0>0?ooo`<000008P3oool00`000000oooo0?ooo`0d0?oo
o`030000003oool0oooo01@0oooo000D0?ooo`030000003oool0oooo02l0oooo00<000000?ooo`3o
ool0903oool00`000000oooo0?ooo`0;0?ooo`050000003oool0oooo0?ooo`0000001P3oool30000
00d0oooo00<000000?ooo`3oool00`3oool00`000000oooo0?ooo`0A0?ooo`8000008@3oool00`00
0000oooo0?ooo`0d0?ooo`030000003oool0oooo01<0oooo000C0?ooo`030000003oool0oooo02l0
oooo00<000000?ooo`3oool09@3oool00`000000oooo0?ooo`0;0?ooo`050000003oool0oooo0?oo
o`0000001P3oool00`000000oooo0000000<0?ooo`030000003oool0oooo00@0oooo00<000000?oo
o`3oool04`3oool3000001h0oooo00<000000?ooo`3oool0=03oool00`000000oooo0?ooo`0C0?oo
o`004`3oool00`000000oooo0?ooo`0^0?ooo`030000003oool0oooo02H0oooo00<000000?ooo`3o
ool0303oool01@000000oooo0?ooo`3oool0000000D0oooo00@000000?ooo`3oool000002`3oool0
0`000000oooo0?ooo`040?ooo`030000003oool0oooo01H0oooo0`00000K0?ooo`030000003oool0
oooo03D0oooo00<000000?ooo`3oool04P3oool00180oooo00<000000?ooo`3oool0;`3oool00`00
0000oooo0?ooo`0V0?ooo`030000003oool0oooo00`0oooo00D000000?ooo`3oool0oooo00000005
0?ooo`040000003oool0oooo000000X0oooo00<000000?ooo`3oool01@3oool00`000000oooo0?oo
o`0I0?ooo`<000006@3oool00`000000oooo0?ooo`0d0?ooo`030000003oool0oooo0180oooo000B
0?ooo`030000003oool0oooo02h0oooo00<000000?ooo`3oool09`3oool00`000000oooo0?ooo`0<
0?ooo`050000003oool0oooo0?ooo`0000001@3oool01@000000oooo0?ooo`3oool0000000T0oooo
00<000000?ooo`3oool01P3oool00`000000oooo0?ooo`0K0?ooo`<000005P3oool00`000000oooo
0?ooo`0e0?ooo`030000003oool0oooo0140oooo000A0?ooo`030000003oool0oooo02l0oooo00<0
00000?ooo`3oool0:03oool00`000000oooo0?ooo`0;0?ooo`030000003oool0oooo0080oooo00<0
00000?ooo`3oool00P3oool01@000000oooo0?ooo`3oool0000000P0oooo00<000000?ooo`3oool0
1`3oool00`000000oooo0?ooo`0N0?ooo`<000004`3oool00`000000oooo0?ooo`0e0?ooo`030000
003oool0oooo0140oooo000A0?ooo`030000003oool0oooo02h0oooo00<000000?ooo`3oool0:@3o
ool00`000000oooo0?ooo`0<0?ooo`050000003oool0oooo0?ooo`0000000`3oool00`000000oooo
0?ooo`030?ooo`030000003oool0oooo00D0oooo00<000000?ooo`3oool01`3oool00`000000oooo
0?ooo`0Q0?ooo`8000004P3oool00`000000oooo0?ooo`0e0?ooo`030000003oool0oooo0100oooo
000@0?ooo`030000003oool0oooo02h0oooo00<000000?ooo`3oool0:P3oool00`000000oooo0?oo
o`0<0?ooo`030000003oool0oooo0080oooo00@000000?ooo`3oool000001@3oool00`000000oooo
0?ooo`040?ooo`030000003oool0oooo00P0oooo00<000000?ooo`3oool08`3oool3000000l0oooo
00<000000?ooo`3oool0=@3oool00`000000oooo0?ooo`0@0?ooo`00403oool00`000000oooo0?oo
o`0^0?ooo`030000003oool0oooo02X0oooo00<000000?ooo`3oool0303oool00`000000oooo0?oo
o`020?ooo`040000003oool0oooo000000H0oooo00<000000?ooo`3oool00`3oool00`000000oooo
0?ooo`090?ooo`030000003oool0oooo02D0oooo0`00000=0?ooo`030000003oool0oooo03D0oooo
00<000000?ooo`3oool03`3oool000l0oooo00<000000?ooo`3oool0;P3oool00`000000oooo0?oo
o`0[0?ooo`030000003oool0oooo00d0oooo00D000000?ooo`3oool0oooo000000020?ooo`030000
003oool0oooo00@0oooo00<000000?ooo`3oool00P3oool00`000000oooo0?ooo`0:0?ooo`030000
003oool0oooo02P0oooo0`00000:0?ooo`030000003oool0oooo03D0oooo00<000000?ooo`3oool0
3`3oool000l0oooo00<000000?ooo`3oool0;@3oool00`000000oooo0?ooo`0/0?ooo`030000003o
ool0oooo00d0oooo00<000000?ooo`3oool00P3oool00`000000oooo000000070?ooo`050000003o
ool0oooo0?ooo`000000303oool00`000000oooo0?ooo`0[0?ooo`<000001`3oool00`000000oooo
0?ooo`0f0?ooo`030000003oool0oooo00h0oooo000>0?ooo`030000003oool0oooo02h0oooo00<0
00000?ooo`3oool0;03oool00`000000oooo0?ooo`0=0?ooo`030000003oool0oooo0080oooo00<0
00000?ooo`0000001`3oool010000000oooo0?ooo`00000=0?ooo`030000003oool0oooo02h0oooo
0P0000060?ooo`030000003oool0oooo03D0oooo00<000000?ooo`3oool03P3oool000/0oooo1000
000]0?ooo`<00000;P3oool3000000d0oooo0`0000030?ooo`<00000203oool3000000d0oooo0`00
000`0?ooo`<000000`3oool3000003H0oooo0`00000=0?ooo`002P3oool5000002`0oooo1@00000/
0?ooo`D000002`3oool5000000030?ooo`000000000000<000001P3oool5000000/0oooo1@00000b
0?ooo`L00000=03oool5000000`0oooo000:0?ooool000002`00000<0?ooo`002P3oool5000002`0
oooo1@00000/0?ooo`D000002`3oool5000000030?ooo`000000000000<000001P3oool5000000/0
oooo1@00000b0?ooo`L00000=03oool5000000`0oooo000;0?ooo`@00000;@3oool3000002h0oooo
0`00000=0?ooo`<000000`3oool3000000P0oooo0`00000=0?ooo`<00000<03oool3000000<0oooo
0`00000f0?ooo`<000003@3oool000h0oooo00<000000?ooo`3oool0;P3oool00`000000oooo0?oo
o`0/0?ooo`030000003oool0oooo00d0oooo00<000000?ooo`3oool00P3oool00`000000oooo0000
00070?ooo`040000003oool0oooo000000d0oooo00<000000?ooo`3oool0;P3oool2000000H0oooo
00<000000?ooo`3oool0=@3oool00`000000oooo0?ooo`0>0?ooo`003`3oool00`000000oooo0?oo
o`0]0?ooo`030000003oool0oooo02`0oooo00<000000?ooo`3oool03@3oool00`000000oooo0?oo
o`020?ooo`030000003oool0000000L0oooo00D000000?ooo`3oool0oooo0000000<0?ooo`030000
003oool0oooo02/0oooo0`0000070?ooo`030000003oool0oooo03H0oooo00<000000?ooo`3oool0
3P3oool000l0oooo00<000000?ooo`3oool0;P3oool00`000000oooo0?ooo`0[0?ooo`030000003o
ool0oooo00d0oooo00D000000?ooo`3oool0oooo000000020?ooo`030000003oool0oooo00@0oooo
00<000000?ooo`3oool00P3oool00`000000oooo0?ooo`0:0?ooo`030000003oool0oooo02P0oooo
0`00000:0?ooo`030000003oool0oooo03D0oooo00<000000?ooo`3oool03`3oool00100oooo00<0
00000?ooo`3oool0;P3oool00`000000oooo0?ooo`0Z0?ooo`030000003oool0oooo00`0oooo00<0
00000?ooo`3oool00P3oool010000000oooo0?ooo`0000060?ooo`030000003oool0oooo00<0oooo
00<000000?ooo`3oool02@3oool00`000000oooo0?ooo`0U0?ooo`<000003@3oool00`000000oooo
0?ooo`0e0?ooo`030000003oool0oooo00l0oooo000@0?ooo`030000003oool0oooo02h0oooo00<0
00000?ooo`3oool0:P3oool00`000000oooo0?ooo`0<0?ooo`030000003oool0oooo0080oooo00@0
00000?ooo`3oool000001@3oool00`000000oooo0?ooo`040?ooo`030000003oool0oooo00P0oooo
00<000000?ooo`3oool08`3oool3000000l0oooo00<000000?ooo`3oool0=@3oool00`000000oooo
0?ooo`0@0?ooo`004@3oool00`000000oooo0?ooo`0^0?ooo`030000003oool0oooo02T0oooo00<0
00000?ooo`3oool0303oool01@000000oooo0?ooo`3oool0000000<0oooo00<000000?ooo`3oool0
0`3oool00`000000oooo0?ooo`050?ooo`030000003oool0oooo00L0oooo00<000000?ooo`3oool0
8@3oool200000180oooo00<000000?ooo`3oool0=@3oool00`000000oooo0?ooo`0@0?ooo`004@3o
ool00`000000oooo0?ooo`0_0?ooo`030000003oool0oooo02P0oooo00<000000?ooo`3oool02`3o
ool00`000000oooo0?ooo`020?ooo`030000003oool0oooo0080oooo00D000000?ooo`3oool0oooo
000000080?ooo`030000003oool0oooo00L0oooo00<000000?ooo`3oool07P3oool3000001<0oooo
00<000000?ooo`3oool0=@3oool00`000000oooo0?ooo`0A0?ooo`004P3oool00`000000oooo0?oo
o`0^0?ooo`030000003oool0oooo02L0oooo00<000000?ooo`3oool0303oool01@000000oooo0?oo
o`3oool0000000D0oooo00D000000?ooo`3oool0oooo000000090?ooo`030000003oool0oooo00H0
oooo00<000000?ooo`3oool06`3oool3000001H0oooo00<000000?ooo`3oool0=@3oool00`000000
oooo0?ooo`0A0?ooo`004P3oool00`000000oooo0?ooo`0_0?ooo`030000003oool0oooo02H0oooo
00<000000?ooo`3oool0303oool01@000000oooo0?ooo`3oool0000000D0oooo00@000000?ooo`3o
ool000002P3oool00`000000oooo0?ooo`050?ooo`030000003oool0oooo01T0oooo0`00000I0?oo
o`030000003oool0oooo03@0oooo00<000000?ooo`3oool04P3oool001<0oooo00<000000?ooo`3o
ool0;P3oool00`000000oooo0?ooo`0V0?ooo`030000003oool0oooo00`0oooo00D000000?ooo`3o
ool0oooo000000050?ooo`040000003oool0oooo000000/0oooo00<000000?ooo`3oool0103oool0
0`000000oooo0?ooo`0F0?ooo`<000006`3oool00`000000oooo0?ooo`0e0?ooo`030000003oool0
oooo0180oooo000C0?ooo`030000003oool0oooo02l0oooo00<000000?ooo`3oool09@3oool00`00
0000oooo0?ooo`0;0?ooo`050000003oool0oooo0?ooo`0000001P3oool00`000000oooo0000000<
0?ooo`030000003oool0oooo00@0oooo00<000000?ooo`3oool04`3oool3000001h0oooo00<00000
0?ooo`3oool0=03oool00`000000oooo0?ooo`0C0?ooo`00503oool00`000000oooo0?ooo`0_0?oo
o`030000003oool0oooo02@0oooo00<000000?ooo`3oool02`3oool01@000000oooo0?ooo`3oool0
000000L0oooo0P00000=0?ooo`030000003oool0oooo00<0oooo00<000000?ooo`3oool04@3oool2
00000240oooo00<000000?ooo`3oool0=03oool00`000000oooo0?ooo`0C0?ooo`00503oool00`00
0000oooo0?ooo`0_0?ooo`030000003oool0oooo02@0oooo00<000000?ooo`3oool02`3oool01@00
0000oooo0?ooo`3oool0000000H0oooo0`00000=0?ooo`030000003oool0oooo00<0oooo00<00000
0?ooo`3oool03P3oool300000280oooo00<000000?ooo`3oool0=03oool00`000000oooo0?ooo`0D
0?ooo`005@3oool00`000000oooo0?ooo`0_0?ooo`030000003oool0oooo02<0oooo00<000000?oo
o`3oool02P3oool01@000000oooo0?ooo`3oool0000000H0oooo1@00000=0?ooo`050000003oool0
oooo0?ooo`0000003P3oool3000002D0oooo00<000000?ooo`3oool0=03oool00`000000oooo0?oo
o`0D0?ooo`005@3oool00`000000oooo0?ooo`0_0?ooo`030000003oool0oooo02<0oooo00<00000
0?ooo`3oool02P3oool01@000000oooo0?ooo`3oool0000000H0oooo1`00000;0?ooo`050000003o
ool0oooo0?ooo`0000002`3oool3000002L0oooo00<000000?ooo`3oool0=03oool00`000000oooo
0?ooo`0E0?ooo`005P3oool00`000000oooo0?ooo`0_0?ooo`030000003oool0oooo0280oooo00<0
00000?ooo`3oool02P3oool01@000000oooo0?ooo`3oool0000000H0oooo1@0000020?ooo`<00000
2@3oool010000000oooo0?ooo`0000080?ooo`<00000:P3oool00`000000oooo0?ooo`0d0?ooo`03
0000003oool0oooo01D0oooo000F0?ooo`030000003oool0oooo0300oooo00<000000?ooo`3oool0
8@3oool00`000000oooo0?ooo`0:0?ooo`040000003oool0oooo000000L0oooo100000060?ooo`@0
00001@3oool010000000oooo0?ooo`0000060?ooo`800000;@3oool00`000000oooo0?ooo`0c0?oo
o`030000003oool0oooo01H0oooo000G0?ooo`030000003oool0oooo02l0oooo00<000000?ooo`3o
ool08@3oool00`000000oooo0?ooo`090?ooo`050000003oool0oooo0?ooo`0000001`3oool00`00
0000oooo0?ooo`0;0?ooo`<000000`3oool3000000<0oooo0`00000^0?ooo`030000003oool0oooo
03@0oooo00<000000?ooo`3oool05P3oool001L0oooo00<000000?ooo`3oool0<03oool00`000000
oooo0?ooo`0P0?ooo`030000003oool0oooo00T0oooo00D000000?ooo`3oool0oooo000000060?oo
o`030000003oool0oooo00l0oooo2@00000a0?ooo`030000003oool0oooo03<0oooo00<000000?oo
o`3oool05`3oool001P0oooo00<000000?ooo`3oool0<03oool00`000000oooo0?ooo`0O0?ooo`03
0000003oool0oooo00T0oooo00@000000?ooo`3oool000001`3oool00`000000oooo0?ooo`0A0?oo
o`D00000<P3oool00`000000oooo0?ooo`0d0?ooo`030000003oool0oooo01L0oooo000H0?ooo`03
0000003oool0oooo0300oooo00<000000?ooo`3oool07`3oool00`000000oooo0?ooo`080?ooo`05
0000003oool0oooo0?ooo`0000001P3oool00`000000oooo0?ooo`0B0?ooo`D00000<P3oool00`00
0000oooo0?ooo`0c0?ooo`030000003oool0oooo01P0oooo000I0?ooo`030000003oool0oooo0300
oooo00<000000?ooo`3oool07P3oool00`000000oooo0?ooo`080?ooo`040000003oool0oooo0000
00L0oooo00<000000?ooo`3oool04P3oool4000003<0oooo00<000000?ooo`3oool0<`3oool00`00
0000oooo0?ooo`0H0?ooo`006@3oool00`000000oooo0?ooo`0`0?ooo`030000003oool0oooo01h0
oooo00<000000?ooo`3oool0203oool010000000oooo0?ooo`0000060?ooo`030000003oool0oooo
0180oooo00D000000?ooo`3oool0oooo0000000b0?ooo`030000003oool0oooo03<0oooo00<00000
0?ooo`3oool06@3oool001X0oooo00<000000?ooo`3oool0<03oool00`000000oooo0?ooo`0M0?oo
o`030000003oool0oooo00P0oooo00@000000?ooo`3oool000001P3oool00`000000oooo0?ooo`0A
0?ooo`030000003oool0oooo00<0oooo00<000000?ooo`3oool0;`3oool00`000000oooo0?ooo`0c
0?ooo`030000003oool0oooo01T0oooo000J0?ooo`030000003oool0oooo0340oooo00<000000?oo
o`3oool0703oool00`000000oooo0?ooo`070?ooo`040000003oool0oooo000000H0oooo00<00000
0?ooo`3oool04@3oool00`000000oooo0?ooo`040?ooo`030000003oool0oooo02h0oooo00<00000
0?ooo`3oool0<`3oool00`000000oooo0?ooo`0J0?ooo`006`3oool00`000000oooo0?ooo`0`0?oo
o`030000003oool0oooo01/0oooo00<000000?ooo`3oool0203oool010000000oooo0?ooo`000006
0?ooo`030000003oool0oooo0100oooo00<000000?ooo`3oool01P3oool00`000000oooo0?ooo`0]
0?ooo`030000003oool0oooo03<0oooo00<000000?ooo`3oool06P3oool001/0oooo00<000000?oo
o`3oool0<@3oool00`000000oooo0?ooo`0J0?ooo`030000003oool0oooo00P0oooo00@000000?oo
o`3oool000001@3oool00`000000oooo0?ooo`0@0?ooo`030000003oool0oooo00L0oooo00<00000
0?ooo`3oool0;@3oool00`000000oooo0?ooo`0b0?ooo`030000003oool0oooo01/0oooo000L0?oo
o`030000003oool0oooo0300oooo00<000000?ooo`3oool06P3oool00`000000oooo0?ooo`070?oo
o`040000003oool0oooo000000H0oooo00<000000?ooo`3oool03`3oool00`000000oooo0?ooo`09
0?ooo`030000003oool0oooo02/0oooo00<000000?ooo`3oool0<`3oool00`000000oooo0?ooo`0K
0?ooo`00703oool00`000000oooo0?ooo`0a0?ooo`030000003oool0oooo01T0oooo00<000000?oo
o`3oool01`3oool010000000oooo0?ooo`0000050?ooo`030000003oool0oooo0100oooo00<00000
0?ooo`3oool02@3oool00`000000oooo0?ooo`0[0?ooo`030000003oool0oooo0380oooo00<00000
0?ooo`3oool0703oool001d0oooo00<000000?ooo`3oool0<@3oool00`000000oooo0?ooo`0H0?oo
o`030000003oool0oooo00L0oooo00@000000?ooo`3oool000001@3oool00`000000oooo0?ooo`0?
0?ooo`030000003oool0oooo00/0oooo00<000000?ooo`3oool0:P3oool00`000000oooo0?ooo`0b
0?ooo`030000003oool0oooo01`0oooo000M0?ooo`030000003oool0oooo0340oooo00<000000?oo
o`3oool0603oool00`000000oooo0?ooo`070?ooo`030000003oool0000000D0oooo00<000000?oo
o`3oool03`3oool00`000000oooo0?ooo`0<0?ooo`030000003oool0oooo02T0oooo00<000000?oo
o`3oool0<P3oool00`000000oooo0?ooo`0M0?ooo`007P3oool00`000000oooo0?ooo`0a0?ooo`03
0000003oool0oooo01L0oooo00<000000?ooo`3oool01P3oool010000000oooo0?ooo`0000050?oo
o`030000003oool0oooo00h0oooo00<000000?ooo`3oool03P3oool00`000000oooo0?ooo`0X0?oo
o`030000003oool0oooo0380oooo00<000000?ooo`3oool07@3oool001h0oooo00<000000?ooo`3o
ool0<P3oool00`000000oooo0?ooo`0F0?ooo`030000003oool0oooo00H0oooo00@000000?ooo`3o
ool00000103oool00`000000oooo0?ooo`0>0?ooo`030000003oool0oooo00l0oooo00<000000?oo
o`3oool09`3oool00`000000oooo0?ooo`0b0?ooo`030000003oool0oooo01h0oooo000O0?ooo`03
0000003oool0oooo0340oooo00<000000?ooo`3oool05P3oool00`000000oooo0?ooo`060?ooo`03
0000003oool0000000D0oooo00<000000?ooo`3oool03@3oool00`000000oooo0?ooo`0A0?ooo`03
0000003oool0oooo02H0oooo00<000000?ooo`3oool0<P3oool00`000000oooo0?ooo`0N0?ooo`00
7`3oool00`000000oooo0?ooo`0b0?ooo`030000003oool0oooo01D0oooo00<000000?ooo`3oool0
1@3oool010000000oooo0?ooo`0000040?ooo`030000003oool0oooo00d0oooo00<000000?ooo`3o
ool04P3oool00`000000oooo0?ooo`0V0?ooo`030000003oool0oooo0340oooo00<000000?ooo`3o
ool07`3oool00200oooo00<000000?ooo`3oool0<@3oool00`000000oooo0?ooo`0E0?ooo`030000
003oool0oooo00D0oooo00<000000?ooo`0000001@3oool00`000000oooo0?ooo`0<0?ooo`030000
003oool0oooo01@0oooo00<000000?ooo`3oool0903oool00`000000oooo0?ooo`0b0?ooo`030000
003oool0oooo01l0oooo000P0?ooo`030000003oool0oooo0380oooo00<000000?ooo`3oool0503o
ool00`000000oooo0?ooo`050?ooo`030000003oool0000000@0oooo00<000000?ooo`3oool0303o
ool00`000000oooo0?ooo`0E0?ooo`030000003oool0oooo02@0oooo00<000000?ooo`3oool0<@3o
ool00`000000oooo0?ooo`0P0?ooo`008@3oool00`000000oooo0?ooo`0b0?ooo`030000003oool0
oooo01<0oooo00<000000?ooo`3oool0103oool010000000oooo0?ooo`0000040?ooo`030000003o
ool0oooo00/0oooo00<000000?ooo`3oool05`3oool00`000000oooo0?ooo`0R0?ooo`030000003o
ool0oooo0380oooo00<000000?ooo`3oool0803oool00240oooo00<000000?ooo`3oool0<P3oool0
0`000000oooo0?ooo`0C0?ooo`030000003oool0oooo00@0oooo00<000000?ooo`000000103oool0
0`000000oooo0?ooo`0;0?ooo`030000003oool0oooo01P0oooo00<000000?ooo`3oool08P3oool0
0`000000oooo0?ooo`0a0?ooo`030000003oool0oooo0240oooo000R0?ooo`030000003oool0oooo
0380oooo00<000000?ooo`3oool04P3oool00`000000oooo0?ooo`040?ooo`030000003oool00000
00@0oooo00<000000?ooo`3oool02P3oool00`000000oooo0?ooo`0J0?ooo`030000003oool0oooo
0240oooo00<000000?ooo`3oool0<@3oool00`000000oooo0?ooo`0Q0?ooo`008P3oool00`000000
oooo0?ooo`0c0?ooo`030000003oool0oooo0140oooo00<000000?ooo`3oool0103oool00`000000
oooo000000030?ooo`030000003oool0oooo00X0oooo00<000000?ooo`3oool06`3oool00`000000
oooo0?ooo`0P0?ooo`030000003oool0oooo0340oooo00<000000?ooo`3oool08P3oool002<0oooo
00<000000?ooo`3oool0<P3oool00`000000oooo0?ooo`0A0?ooo`030000003oool0oooo00<0oooo
00<000000?ooo`000000103oool00`000000oooo0?ooo`090?ooo`030000003oool0oooo01d0oooo
00<000000?ooo`3oool07`3oool00`000000oooo0?ooo`0a0?ooo`030000003oool0oooo0280oooo
000S0?ooo`030000003oool0oooo03<0oooo00<000000?ooo`3oool0403oool00`000000oooo0?oo
o`030?ooo`030000003oool0000000<0oooo00<000000?ooo`3oool02@3oool00`000000oooo0?oo
o`0N0?ooo`030000003oool0oooo01h0oooo00<000000?ooo`3oool0<@3oool00`000000oooo0?oo
o`0S0?ooo`00903oool00`000000oooo0?ooo`0b0?ooo`030000003oool0oooo00l0oooo00<00000
0?ooo`3oool0103oool00`000000oooo000000030?ooo`030000003oool0oooo00P0oooo00<00000
0?ooo`3oool0803oool00`000000oooo0?ooo`0M0?ooo`030000003oool0oooo0340oooo00<00000
0?ooo`3oool08`3oool002@0oooo00<000000?ooo`3oool0<`3oool00`000000oooo0?ooo`0>0?oo
o`030000003oool0oooo00<0oooo00<000000?ooo`0000000`3oool00`000000oooo0?ooo`080?oo
o`030000003oool0oooo0240oooo00<000000?ooo`3oool07@3oool00`000000oooo0?ooo`0`0?oo
o`030000003oool0oooo02@0oooo000U0?ooo`030000003oool0oooo03<0oooo00<000000?ooo`3o
ool03@3oool00`000000oooo0?ooo`030?ooo`030000003oool0000000<0oooo00<000000?ooo`3o
ool0203oool00`000000oooo0?ooo`0R0?ooo`030000003oool0oooo01/0oooo00<000000?ooo`3o
ool0<@3oool00`000000oooo0?ooo`0T0?ooo`009@3oool00`000000oooo0?ooo`0c0?ooo`030000
003oool0oooo00d0oooo00<000000?ooo`3oool00`3oool00`000000oooo000000020?ooo`030000
003oool0oooo00P0oooo00<000000?ooo`3oool08`3oool00`000000oooo0?ooo`0K0?ooo`030000
003oool0oooo0300oooo00<000000?ooo`3oool09@3oool002H0oooo00<000000?ooo`3oool0<`3o
ool00`000000oooo0?ooo`0<0?ooo`030000003oool0oooo00<0oooo0P0000030?ooo`030000003o
ool0oooo00L0oooo00<000000?ooo`3oool09@3oool00`000000oooo0?ooo`0I0?ooo`030000003o
ool0oooo0340oooo00<000000?ooo`3oool09@3oool002H0oooo00<000000?ooo`3oool0<`3oool0
0`000000oooo0?ooo`0<0?ooo`030000003oool0oooo0080oooo00<000000?ooo`0000000P3oool0
0`000000oooo0?ooo`070?ooo`030000003oool0oooo02H0oooo00<000000?ooo`3oool06@3oool0
0`000000oooo0?ooo`0`0?ooo`030000003oool0oooo02H0oooo000W0?ooo`030000003oool0oooo
03<0oooo00<000000?ooo`3oool02`3oool00`000000oooo0?ooo`020?ooo`8000000`3oool00`00
0000oooo0?ooo`060?ooo`030000003oool0oooo02P0oooo00<000000?ooo`3oool0603oool00`00
0000oooo0?ooo`0`0?ooo`030000003oool0oooo02H0oooo000W0?ooo`030000003oool0oooo03@0
oooo00<000000?ooo`3oool02P3oool00`000000oooo0?ooo`020?ooo`8000000P3oool00`000000
oooo0?ooo`060?ooo`030000003oool0oooo02T0oooo00<000000?ooo`3oool05`3oool00`000000
oooo0?ooo`0`0?ooo`030000003oool0oooo02L0oooo000X0?ooo`030000003oool0oooo03<0oooo
00<000000?ooo`3oool02P3oool01`000000oooo0?ooo`3oool000000?ooo`0000000P3oool00`00
0000oooo0?ooo`050?ooo`030000003oool0oooo02/0oooo00<000000?ooo`3oool05P3oool00`00
0000oooo0?ooo`0`0?ooo`030000003oool0oooo02L0oooo000X0?ooo`030000003oool0oooo03@0
oooo00<000000?ooo`3oool02@3oool010000000oooo0?ooo`3oool200000080oooo00<000000?oo
o`3oool01@3oool00`000000oooo0?ooo`0/0?ooo`030000003oool0oooo01H0oooo00<000000?oo
o`3oool0;`3oool00`000000oooo0?ooo`0X0?ooo`00:@3oool00`000000oooo0?ooo`0d0?ooo`03
0000003oool0oooo00P0oooo00@000000?ooo`3oool0oooo0P0000020?ooo`030000003oool0oooo
00@0oooo00<000000?ooo`3oool0;P3oool00`000000oooo0?ooo`0D0?ooo`030000003oool0oooo
0300oooo00<000000?ooo`3oool0:03oool002T0oooo00<000000?ooo`3oool0=03oool00`000000
oooo0?ooo`080?ooo`040000003oool0oooo0?ooo`80000000<0oooo0000003oool01@3oool00`00
0000oooo0?ooo`0_0?ooo`030000003oool0oooo01@0oooo00<000000?ooo`3oool0;`3oool00`00
0000oooo0?ooo`0Y0?ooo`00:P3oool00`000000oooo0?ooo`0d0?ooo`030000003oool0oooo00L0
oooo00<000000?ooo`3oool00P0000020?ooo`030000003oool0oooo00<0oooo00<000000?ooo`3o
ool0<@3oool00`000000oooo0?ooo`0B0?ooo`030000003oool0oooo0300oooo00<000000?ooo`3o
ool0:@3oool002X0oooo00<000000?ooo`3oool0=03oool00`000000oooo0?ooo`070?ooo`030000
003oool0oooo0080000000<0oooo0000003oool0103oool00`000000oooo0?ooo`0b0?ooo`030000
003oool0oooo0180oooo00<000000?ooo`3oool0;`3oool00`000000oooo0?ooo`0Z0?ooo`00:`3o
ool00`000000oooo0?ooo`0d0?ooo`030000003oool0oooo00H0oooo00<000000?ooo`3oool00P00
00000`3oool000000?ooo`030?ooo`030000003oool0oooo03@0oooo00<000000?ooo`3oool04@3o
ool00`000000oooo0?ooo`0_0?ooo`030000003oool0oooo02X0oooo000[0?ooo`030000003oool0
oooo03D0oooo00<000000?ooo`3oool01@3oool01P000000oooo000000000000oooo000000@0oooo
00<000000?ooo`3oool0=@3oool00`000000oooo0?ooo`0@0?ooo`030000003oool0oooo02l0oooo
00<000000?ooo`3oool0:`3oool002`0oooo00<000000?ooo`3oool0=03oool00`000000oooo0?oo
o`050?ooo`060000003oool000000000003oool000000`3oool00`000000oooo0?ooo`0g0?ooo`03
0000003oool0oooo00l0oooo00<000000?ooo`3oool0;`3oool00`000000oooo0?ooo`0[0?ooo`00
;03oool00`000000oooo0?ooo`0e0?ooo`030000003oool0oooo00@0oooo00<000000?ooo`000000
0P0000030?ooo`030000003oool0oooo03P0oooo00<000000?ooo`3oool03P3oool00`000000oooo
0?ooo`0_0?ooo`030000003oool0oooo02`0oooo000]0?ooo`030000003oool0oooo03@0oooo00<0
00000?ooo`3oool00`3oool01P000000oooo0?ooo`000000oooo00000080oooo00<000000?ooo`3o
ool0>P3oool00`000000oooo0?ooo`0=0?ooo`030000003oool0oooo02l0oooo00<000000?ooo`3o
ool0;03oool002d0oooo00<000000?ooo`3oool0=@3oool00`000000oooo0?ooo`020?ooo`030000
003oool00000008000000`3oool00`000000oooo0?ooo`0j0?ooo`030000003oool0oooo00d0oooo
00<000000?ooo`3oool0;P3oool00`000000oooo0?ooo`0]0?ooo`00;P3oool00`000000oooo0?oo
o`0e0?ooo`090000003oool0oooo0?ooo`000000oooo0000003oool000000080oooo00<000000?oo
o`3oool0?03oool00`000000oooo0?ooo`0;0?ooo`030000003oool0oooo02l0oooo00<000000?oo
o`3oool0;@3oool002h0oooo00<000000?ooo`3oool0=@3oool01P000000oooo0?ooo`3oool00000
0?ooo`8000000P3oool00`000000oooo0?ooo`0m0?ooo`030000003oool0oooo00/0oooo00<00000
0?ooo`3oool0;P3oool00`000000oooo0?ooo`0^0?ooo`00;`3oool00`000000oooo0?ooo`0e0?oo
o`030000003oool0oooo00@0000000<0oooo0000003oool0@03oool00`000000oooo0?ooo`090?oo
o`030000003oool0oooo02l0oooo00<000000?ooo`3oool0;P3oool002l0oooo00<000000?ooo`3o
ool0=P3oool00`000000oooo00000002000000030?ooo`000000oooo0440oooo00<000000?ooo`3o
ool02@3oool00`000000oooo0?ooo`0^0?ooo`030000003oool0oooo02l0oooo000`0?ooo`030000
003oool0oooo03D0oooo00<000000?ooo`0000000`0000140?ooo`030000003oool0oooo00P0oooo
00<000000?ooo`3oool0;P3oool00`000000oooo0?ooo`0_0?ooo`00<03oool00`000000oooo0?oo
o`0f0?ooo`@00000A@3oool00`000000oooo0?ooo`070?ooo`030000003oool0oooo02h0oooo00<0
00000?ooo`3oool0<03oool00340oooo00<000000?ooo`3oool0=@3oool3000004L0oooo00<00000
0?ooo`3oool01P3oool00`000000oooo0?ooo`0^0?ooo`030000003oool0oooo0300oooo000a0?oo
o`030000003oool0oooo03@0oooo1`0000140?ooo`030000003oool0oooo00H0oooo00<000000?oo
o`3oool0;@3oool00`000000oooo0?ooo`0a0?ooo`00<P3oool00`000000oooo0?ooo`0c0?ooo`D0
00000P3oool8000003d0oooo00<000000?ooo`3oool0103oool00`000000oooo0?ooo`0^0?ooo`03
0000003oool0oooo0340oooo000b0?ooo`030000003oool0oooo03<0oooo1@00000:0?ooo`T00000
=03oool00`000000oooo0?ooo`040?ooo`030000003oool0oooo02d0oooo00<000000?ooo`3oool0
<P3oool003<0oooo00<000000?ooo`3oool0<`3oool3000001@0oooo2@00000/0?ooo`030000003o
ool0oooo0080oooo00<000000?ooo`3oool0;P3oool00`000000oooo0?ooo`0b0?ooo`00<`3oool0
0`000000oooo0?ooo`0b0?ooo`030000003oool0oooo01h0oooo2000000T0?ooo`030000003oool0
oooo0080oooo00<000000?ooo`3oool0;@3oool00`000000oooo0?ooo`0c0?ooo`00=03oool00`00
0000oooo0?ooo`0a0?ooo`030000003oool0oooo02H0oooo2@00000L0?ooo`050000003oool0oooo
0?ooo`000000;`3oool00`000000oooo0?ooo`0c0?ooo`00=03oool00`000000oooo0?ooo`0`0?oo
o`030000003oool0oooo0300oooo2@00000C0?ooo`040000003oool0oooo000002l0oooo00<00000
0?ooo`3oool0=03oool003D0oooo00<000000?ooo`3oool0;`3oool00`000000oooo0?ooo`0i0?oo
o`P000002`3oool4000002l0oooo00<000000?ooo`3oool0=03oool003D0oooo00<000000?ooo`3o
ool0;P3oool00`000000oooo0?ooo`120?ooo`T0000000<0oooo0000000000000`00000^0?ooo`03
0000003oool0oooo03D0oooo000f0?ooo`030000003oool0oooo02d0oooo00<000000?ooo`3oool0
B`3oool6000002h0oooo00<000000?ooo`3oool0=@3oool003H0oooo00<000000?ooo`3oool0;03o
ool00`000000oooo0?ooo`1=0?ooo`D00000;@3oool00`000000oooo0?ooo`0f0?ooo`00=`3oool0
0`000000oooo0?ooo`0[0?ooo`030000003oool0oooo04h0oooo1000000]0?ooo`030000003oool0
oooo03H0oooo000g0?ooo`030000003oool0oooo02X0oooo00<000000?ooo`3oool0DP3oool00`00
0000oooo0?ooo`0Z0?ooo`030000003oool0oooo03L0oooo000h0?ooo`030000003oool0oooo02T0
oooo00<000000?ooo`3oool0D`3oool00`000000oooo0?ooo`0Y0?ooo`030000003oool0oooo03L0
oooo000h0?ooo`030000003oool0oooo02P0oooo00<000000?ooo`3oool0E03oool00`000000oooo
0?ooo`0X0?ooo`030000003oool0oooo03P0oooo000i0?ooo`030000003oool0oooo02L0oooo00<0
00000?ooo`3oool0E@3oool00`000000oooo0?ooo`0W0?ooo`030000003oool0oooo03P0oooo000i
0?ooo`030000003oool0oooo02H0oooo00<000000?ooo`3oool0EP3oool00`000000oooo0?ooo`0V
0?ooo`030000003oool0oooo03T0oooo000j0?ooo`030000003oool0oooo02D0oooo00<000000?oo
o`3oool0E`3oool00`000000oooo0?ooo`0U0?ooo`030000003oool0oooo03T0oooo000j0?ooo`03
0000003oool0oooo02@0oooo00<000000?ooo`3oool0F03oool00`000000oooo0?ooo`0T0?ooo`03
0000003oool0oooo03X0oooo000k0?ooo`030000003oool0oooo02<0oooo00<000000?ooo`3oool0
F@3oool00`000000oooo0?ooo`0S0?ooo`030000003oool0oooo03X0oooo000k0?ooo`030000003o
ool0oooo0280oooo00<000000?ooo`3oool0FP3oool00`000000oooo0?ooo`0R0?ooo`030000003o
ool0oooo03/0oooo000l0?ooo`030000003oool0oooo0240oooo00<000000?ooo`3oool0F`3oool0
0`000000oooo0?ooo`0Q0?ooo`030000003oool0oooo03/0oooo000l0?ooo`030000003oool0oooo
0200oooo00<000000?ooo`3oool0G03oool00`000000oooo0?ooo`0P0?ooo`030000003oool0oooo
03`0oooo000m0?ooo`030000003oool0oooo01l0oooo00<000000?ooo`3oool0G@3oool00`000000
oooo0?ooo`0O0?ooo`030000003oool0oooo03`0oooo000m0?ooo`030000003oool0oooo01h0oooo
00<000000?ooo`3oool0GP3oool00`000000oooo0?ooo`0N0?ooo`030000003oool0oooo03d0oooo
000n0?ooo`030000003oool0oooo01d0oooo00<000000?ooo`3oool0G`3oool00`000000oooo0?oo
o`0M0?ooo`030000003oool0oooo03d0oooo000n0?ooo`030000003oool0oooo01`0oooo00<00000
0?ooo`3oool0H03oool00`000000oooo0?ooo`0L0?ooo`030000003oool0oooo03h0oooo000o0?oo
o`030000003oool0oooo01/0oooo00<000000?ooo`3oool0H@3oool00`000000oooo0?ooo`0K0?oo
o`030000003oool0oooo03h0oooo000o0?ooo`030000003oool0oooo01X0oooo00<000000?ooo`3o
ool0HP3oool00`000000oooo0?ooo`0J0?ooo`030000003oool0oooo03l0oooo00100?ooo`030000
003oool0oooo01T0oooo00<000000?ooo`3oool0H`3oool00`000000oooo0?ooo`0I0?ooo`030000
003oool0oooo03l0oooo00100?ooo`030000003oool0oooo01P0oooo00<000000?ooo`3oool0I03o
ool00`000000oooo0?ooo`0H0?ooo`030000003oool0oooo0400oooo00110?ooo`030000003oool0
oooo01L0oooo00<000000?ooo`3oool0I@3oool00`000000oooo0?ooo`0G0?ooo`030000003oool0
oooo0400oooo00110?ooo`030000003oool0oooo01H0oooo00<000000?ooo`3oool0IP3oool00`00
0000oooo0?ooo`0F0?ooo`030000003oool0oooo0440oooo00120?ooo`030000003oool0oooo01D0
oooo00<000000?ooo`3oool0I`3oool00`000000oooo0?ooo`0E0?ooo`030000003oool0oooo0440
oooo00120?ooo`030000003oool0oooo01@0oooo00<000000?ooo`3oool0J03oool00`000000oooo
0?ooo`0D0?ooo`030000003oool0oooo0480oooo00130?ooo`030000003oool0oooo01<0oooo00<0
00000?ooo`3oool0J@3oool00`000000oooo0?ooo`0C0?ooo`030000003oool0oooo0480oooo0013
0?ooo`030000003oool0oooo0180oooo00<000000?ooo`3oool0JP3oool00`000000oooo0?ooo`0B
0?ooo`030000003oool0oooo04<0oooo00140?ooo`030000003oool0oooo0140oooo00<000000?oo
o`3oool0J`3oool00`000000oooo0?ooo`0A0?ooo`030000003oool0oooo04<0oooo00140?ooo`03
0000003oool0oooo0100oooo00<000000?ooo`3oool0K03oool00`000000oooo0?ooo`0@0?ooo`03
0000003oool0oooo04@0oooo00150?ooo`030000003oool0oooo00l0oooo00<000000?ooo`3oool0
K@3oool00`000000oooo0?ooo`0?0?ooo`030000003oool0oooo04@0oooo00150?ooo`030000003o
ool0oooo00h0oooo00<000000?ooo`3oool0KP3oool00`000000oooo0?ooo`0>0?ooo`030000003o
ool0oooo04D0oooo00160?ooo`030000003oool0oooo00d0oooo00<000000?ooo`3oool0K`3oool0
0`000000oooo0?ooo`0=0?ooo`030000003oool0oooo04D0oooo00160?ooo`030000003oool0oooo
00`0oooo00<000000?ooo`3oool0L03oool00`000000oooo0?ooo`0<0?ooo`030000003oool0oooo
04H0oooo00170?ooo`030000003oool0oooo00/0oooo00<000000?ooo`3oool0L@3oool00`000000
oooo0?ooo`0;0?ooo`030000003oool0oooo04H0oooo00170?ooo`030000003oool0oooo00X0oooo
00<000000?ooo`3oool0LP3oool00`000000oooo0?ooo`0:0?ooo`030000003oool0oooo04L0oooo
00180?ooo`030000003oool0oooo00T0oooo00<000000?ooo`3oool0L`3oool00`000000oooo0?oo
o`090?ooo`030000003oool0oooo04L0oooo00180?ooo`030000003oool0oooo00P0oooo00<00000
0?ooo`3oool0M03oool00`000000oooo0?ooo`080?ooo`030000003oool0oooo04P0oooo00190?oo
o`030000003oool0oooo00L0oooo00<000000?ooo`3oool0M@3oool00`000000oooo0?ooo`070?oo
o`030000003oool0oooo04P0oooo00190?ooo`030000003oool0oooo00H0oooo00<000000?ooo`3o
ool0MP3oool00`000000oooo0?ooo`060?ooo`030000003oool0oooo04T0oooo001:0?ooo`030000
003oool0oooo00D0oooo00<000000?ooo`3oool0M`3oool00`000000oooo0?ooo`050?ooo`030000
003oool0oooo04T0oooo001:0?ooo`030000003oool0oooo00@0oooo00<000000?ooo`3oool0N03o
ool00`000000oooo0?ooo`040?ooo`030000003oool0oooo04X0oooo001;0?ooo`030000003oool0
oooo00<0oooo00<000000?ooo`3oool0N@3oool00`000000oooo0?ooo`030?ooo`030000003oool0
oooo04X0oooo001;0?ooo`030000003oool0oooo0080oooo00<000000?ooo`3oool0NP3oool00`00
0000oooo0?ooo`020?ooo`030000003oool0oooo04/0oooo001<0?ooo`050000003oool0oooo0?oo
o`000000O@3oool01@000000oooo0?ooo`3oool0000004d0oooo001<0?ooo`040000003oool0oooo
000007h0oooo00@000000?ooo`3oool00000CP3oool004d0oooo00<000000?ooo`000000O`3oool0
0`000000oooo0000001>0?ooo`00C03oool300000800oooo0`00001>0?ooo`00B`3ooon8000004d0
oooo001;0?ooo`D00000OP3oool5000004d0oooo001;0?ooo`D00000OP3oool5000004d0oooo001<
0?ooo`<00000P03oool3000004h0oooo003o0?ooob40oooo003o0?ooob40oooo003o0?ooob40oooo
003o0?ooob40oooo003o0?ooob40oooo003o0?ooob40oooo003o0?ooob40oooo003o0?ooob40oooo
003o0?ooob40oooo003o0?ooob40oooo0000\
\>"],
  ImageRangeCache->{{{0, 287}, {287, 0}} -> {-1.10001, -0.952637, 0.00766559, \
0.00663859}}],

Cell[BoxData[
    TagBox[\(\[SkeletonIndicator]  Graphics  \[SkeletonIndicator]\),
      False,
      Editable->False]], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    \(\(\(draw[mm, 
      F\  . \ F\  . \ F\  . \ F\  . \ F\  . \ F\  . \ F\  . \ F\  . \ F\  . \ 
        F\  . \ F\  . \ \ F\  . \ F\  . \ F\ \  . \ F\  . \ 
        P]\)\(\ \ \ \)\)\)], "Input"],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: 1 
MathPictureStart
/Mabs {
Mgmatrix idtransform
Mtmatrix dtransform
} bind def
/Mabsadd { Mabs
3 -1 roll add
3 1 roll add
exch } bind def
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
0.5 0.454545 0.5 0.524864 [
[ 0 0 0 0 ]
[ 1 1 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 0 m
1 0 L
1 1 L
0 1 L
closepath
clip
newpath
0 g
.02 w
.72727 .95455 Mdot
.27273 .95455 Mdot
.04545 .5 Mdot
.27273 .04545 Mdot
.72727 .04545 Mdot
.95455 .5 Mdot
.86282 .5 Mdot
.67918 .46786 Mdot
.57036 .5 Mdot
.46546 .60674 Mdot
.30085 .79844 Mdot
.11207 .5 Mdot
.30085 .20156 Mdot
.46546 .39326 Mdot
.67918 .53214 Mdot
.67683 .16598 Mdot
.31475 .5 Mdot
.67683 .83402 Mdot
.69664 .5 Mdot
.59165 .37145 Mdot
.40227 .5 Mdot
.25679 .5 Mdot
.59165 .62855 Mdot
.5 Mabswid
[ ] 0 setdash
.72727 .95455 m
.27273 .95455 L
s
.72727 .95455 m
.95455 .5 L
s
.72727 .95455 m
.67683 .83402 L
s
.27273 .95455 m
.72727 .95455 L
s
.27273 .95455 m
.04545 .5 L
s
.27273 .95455 m
.30085 .79844 L
s
.04545 .5 m
.27273 .95455 L
s
.04545 .5 m
.27273 .04545 L
s
.04545 .5 m
.11207 .5 L
s
.27273 .04545 m
.04545 .5 L
s
.27273 .04545 m
.72727 .04545 L
s
.27273 .04545 m
.30085 .20156 L
s
.72727 .04545 m
.27273 .04545 L
s
.72727 .04545 m
.95455 .5 L
s
.72727 .04545 m
.67683 .16598 L
s
.95455 .5 m
.72727 .95455 L
s
.95455 .5 m
.72727 .04545 L
s
.95455 .5 m
.86282 .5 L
s
.86282 .5 m
.95455 .5 L
s
.86282 .5 m
.67918 .46786 L
s
.86282 .5 m
.67918 .53214 L
s
.86282 .5 m
.67683 .16598 L
s
.86282 .5 m
.67683 .83402 L
s
.86282 .5 m
.69664 .5 L
s
.86282 .5 m
.59165 .37145 L
s
.86282 .5 m
.59165 .62855 L
s
.67918 .46786 m
.86282 .5 L
s
.67918 .46786 m
.57036 .5 L
s
.67918 .46786 m
.69664 .5 L
s
.67918 .46786 m
.59165 .37145 L
s
.57036 .5 m
.67918 .46786 L
s
.57036 .5 m
.46546 .60674 L
s
.57036 .5 m
.46546 .39326 L
s
.57036 .5 m
.67918 .53214 L
s
.57036 .5 m
.69664 .5 L
s
.57036 .5 m
.59165 .37145 L
s
.57036 .5 m
.40227 .5 L
s
.57036 .5 m
.59165 .62855 L
s
.46546 .60674 m
.57036 .5 L
s
.46546 .60674 m
.30085 .79844 L
s
.46546 .60674 m
.40227 .5 L
s
.46546 .60674 m
.59165 .62855 L
s
.30085 .79844 m
.27273 .95455 L
s
.30085 .79844 m
.46546 .60674 L
s
.30085 .79844 m
.11207 .5 L
s
.30085 .79844 m
.31475 .5 L
s
.30085 .79844 m
.67683 .83402 L
s
.30085 .79844 m
.40227 .5 L
s
.30085 .79844 m
.25679 .5 L
s
.30085 .79844 m
.59165 .62855 L
s
.11207 .5 m
.04545 .5 L
s
.11207 .5 m
.30085 .79844 L
s
.11207 .5 m
.30085 .20156 L
s
.11207 .5 m
.25679 .5 L
s
.30085 .20156 m
.27273 .04545 L
s
.30085 .20156 m
.11207 .5 L
s
.30085 .20156 m
.46546 .39326 L
s
.30085 .20156 m
.67683 .16598 L
s
.30085 .20156 m
.31475 .5 L
s
.30085 .20156 m
.59165 .37145 L
s
.30085 .20156 m
.40227 .5 L
s
.30085 .20156 m
.25679 .5 L
s
.46546 .39326 m
.57036 .5 L
s
.46546 .39326 m
.30085 .20156 L
s
.46546 .39326 m
.59165 .37145 L
s
.46546 .39326 m
.40227 .5 L
s
.67918 .53214 m
.86282 .5 L
s
.67918 .53214 m
.57036 .5 L
s
.67918 .53214 m
.69664 .5 L
s
.67918 .53214 m
.59165 .62855 L
s
.67683 .16598 m
.72727 .04545 L
s
.67683 .16598 m
.86282 .5 L
s
.67683 .16598 m
.30085 .20156 L
s
.67683 .16598 m
.59165 .37145 L
s
.31475 .5 m
.30085 .79844 L
s
.31475 .5 m
.30085 .20156 L
s
.31475 .5 m
.40227 .5 L
s
.31475 .5 m
.25679 .5 L
s
.67683 .83402 m
.72727 .95455 L
s
.67683 .83402 m
.86282 .5 L
s
.67683 .83402 m
.30085 .79844 L
s
.67683 .83402 m
.59165 .62855 L
s
.69664 .5 m
.86282 .5 L
s
.69664 .5 m
.67918 .46786 L
s
.69664 .5 m
.57036 .5 L
s
.69664 .5 m
.67918 .53214 L
s
.59165 .37145 m
.86282 .5 L
s
.59165 .37145 m
.67918 .46786 L
s
.59165 .37145 m
.57036 .5 L
s
.59165 .37145 m
.30085 .20156 L
s
.59165 .37145 m
.46546 .39326 L
s
.59165 .37145 m
.67683 .16598 L
s
.40227 .5 m
.57036 .5 L
s
.40227 .5 m
.46546 .60674 L
s
.40227 .5 m
.30085 .79844 L
s
.40227 .5 m
.30085 .20156 L
s
.40227 .5 m
.46546 .39326 L
s
.40227 .5 m
.31475 .5 L
s
.25679 .5 m
.30085 .79844 L
s
.25679 .5 m
.11207 .5 L
s
.25679 .5 m
.30085 .20156 L
s
.25679 .5 m
.31475 .5 L
s
.59165 .62855 m
.86282 .5 L
s
.59165 .62855 m
.57036 .5 L
s
.59165 .62855 m
.46546 .60674 L
s
.59165 .62855 m
.30085 .79844 L
s
.59165 .62855 m
.67918 .53214 L
s
.59165 .62855 m
.67683 .83402 L
s
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  ImageSize->{617, 617},
  ImageMargins->{{44, 0}, {0, 0}},
  ImageRegion->{{0, 1}, {0, 1}},
  ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`40009Y0002JB000`400?l00000o`00003oo`3ooooo
0?ooof/0oooo003o0?ooool0ooooJ`3oool00?l0ooooo`3ooom[0?ooo`00o`3ooooo0?ooof/0oooo
003o0?ooool0ooooJ`3oool00?l0ooooo`3ooom[0?ooo`00o`3ooooo0?ooof/0oooo003o0?ooool0
ooooJ`3oool00?l0ooooo`3ooom[0?ooo`00o`3ooooo0?ooof/0oooo003o0?ooool0ooooJ`3oool0
0?l0ooooo`3ooom[0?ooo`00o`3ooooo0?ooof/0oooo003o0?ooool0ooooJ`3oool00?l0ooooo`3o
oom[0?ooo`00o`3ooooo0?ooof/0oooo003o0?ooool0ooooJ`3oool00?l0ooooo`3ooom[0?ooo`00
o`3ooooo0?ooof/0oooo003o0?ooool0ooooJ`3oool00?l0ooooo`3ooom[0?ooo`00o`3ooooo0?oo
of/0oooo003o0?ooool0ooooJ`3oool00:L0oooo0P00003o0?oooaL0oooo0P00002X0?ooo`00Y03o
ool800000?l0oooo4@3oool800000:D0oooo002S0?ooo`X00000o`3oool?0?ooo`X00000Y03oool0
0:<0oooo2P00003o0?ooo`l0oooo2P00002T0?ooo`00X`3oool:00000?l0oooo3`3oool:00000:@0
oooo002R0?ooool000009@00002S0?ooo`00XP3oool<00000?l0oooo3@3oool<00000:<0oooo002S
0?ooo`X00000o`3oool?0?ooo`X00000Y03oool00:<0oooo2P00003o0?ooo`l0oooo2P00002T0?oo
o`00X`3oool:00000?l0oooo3`3oool:00000:@0oooo002T0?ooo`P00000o`3ooolA0?ooo`P00000
Y@3oool00:D0oooo00<000000?ooo`0000000P00003o0?oooa@0oooo00H000000?ooo`0000000000
0?ooo`00002V0?ooo`00Y03oool00`000000oooo0?ooo`020?ooo`030000003oool0oooo0?l0oooo
4@3oool00`000000oooo0?ooo`040?ooo`030000003oool0oooo0:<0oooo002T0?ooo`030000003o
ool0oooo0080oooo00<000000?ooo`3oool0o`3ooolA0?ooo`030000003oool0oooo00@0oooo00<0
00000?ooo`3oool0X`3oool00:<0oooo00<000000?ooo`3oool0103oool00`000000oooo0?ooo`3o
0?ooo`l0oooo00<000000?ooo`3oool01P3oool00`000000oooo0?ooo`2R0?ooo`00X`3oool00`00
0000oooo0?ooo`040?ooo`030000003oool0oooo0?l0oooo3`3oool00`000000oooo0?ooo`060?oo
o`030000003oool0oooo0:80oooo002R0?ooo`030000003oool0oooo00D0oooo00<000000?ooo`3o
ool0o`3oool>0?ooo`030000003oool0oooo00P0oooo00<000000?ooo`3oool0X@3oool00:80oooo
00<000000?ooo`3oool01@3oool00`000000oooo0?ooo`3o0?ooo`h0oooo00<000000?ooo`3oool0
203oool00`000000oooo0?ooo`2Q0?ooo`00X@3oool00`000000oooo0?ooo`060?ooo`030000003o
ool0oooo0?l0oooo3P3oool00`000000oooo0?ooo`090?ooo`030000003oool0oooo0:00oooo002Q
0?ooo`030000003oool0oooo00H0oooo00<000000?ooo`3oool0o`3oool=0?ooo`030000003oool0
oooo00X0oooo00<000000?ooo`3oool0X03oool00:00oooo00<000000?ooo`3oool0203oool00`00
0000oooo0?ooo`3o0?ooo``0oooo00<000000?ooo`3oool02`3oool00`000000oooo0?ooo`2O0?oo
o`00X03oool00`000000oooo0?ooo`080?ooo`030000003oool0oooo0?l0oooo2`3oool00`000000
oooo0?ooo`0<0?ooo`030000003oool0oooo09l0oooo002O0?ooo`030000003oool0oooo00T0oooo
00<000000?ooo`3oool0o`3oool;0?ooo`030000003oool0oooo00d0oooo00<000000?ooo`3oool0
WP3oool009l0oooo00<000000?ooo`3oool02@3oool00`000000oooo0?ooo`3o0?ooo`/0oooo00<0
00000?ooo`3oool03@3oool00`000000oooo0?ooo`2N0?ooo`00WP3oool00`000000oooo0?ooo`0:
0?ooo`030000003oool0oooo0?l0oooo2P3oool00`000000oooo0?ooo`0?0?ooo`030000003oool0
oooo09d0oooo002N0?ooo`030000003oool0oooo00/0oooo00<000000?ooo`3oool0o`3oool90?oo
o`030000003oool0oooo00l0oooo00<000000?ooo`3oool0W@3oool009d0oooo00<000000?ooo`3o
ool0303oool00`000000oooo0?ooo`3o0?ooo`P0oooo00<000000?ooo`3oool04@3oool00`000000
oooo0?ooo`2L0?ooo`00W@3oool00`000000oooo0?ooo`0<0?ooo`030000003oool0oooo0?l0oooo
203oool00`000000oooo0?ooo`0A0?ooo`030000003oool0oooo09`0oooo002L0?ooo`030000003o
ool0oooo00d0oooo00<000000?ooo`3oool0o`3oool70?ooo`030000003oool0oooo01<0oooo00<0
00000?ooo`3oool0V`3oool009`0oooo00<000000?ooo`3oool03@3oool00`000000oooo0?ooo`3o
0?ooo`L0oooo00<000000?ooo`3oool04`3oool00`000000oooo0?ooo`2K0?ooo`00V`3oool00`00
0000oooo0?ooo`0>0?ooo`030000003oool0oooo0?l0oooo1`3oool00`000000oooo0?ooo`0D0?oo
o`030000003oool0oooo09X0oooo002K0?ooo`030000003oool0oooo00l0oooo00<000000?ooo`3o
ool0o`3oool50?ooo`030000003oool0oooo01D0oooo00<000000?ooo`3oool0VP3oool009X0oooo
00<000000?ooo`3oool0403oool00`000000oooo0?ooo`3o0?ooo`D0oooo00<000000?ooo`3oool0
5P3oool00`000000oooo0?ooo`2I0?ooo`00VP3oool00`000000oooo0?ooo`0@0?ooo`030000003o
ool0oooo0?l0oooo103oool00`000000oooo0?ooo`0G0?ooo`030000003oool0oooo09T0oooo002I
0?ooo`030000003oool0oooo0140oooo00<000000?ooo`3oool0o`3oool40?ooo`030000003oool0
oooo01P0oooo00<000000?ooo`3oool0V03oool009T0oooo00<000000?ooo`3oool04@3oool00`00
0000oooo0?ooo`3o0?ooo`@0oooo00<000000?ooo`3oool0603oool00`000000oooo0?ooo`2H0?oo
o`00V03oool00`000000oooo0?ooo`0B0?ooo`030000003oool0oooo0?l0oooo0`3oool00`000000
oooo0?ooo`0J0?ooo`030000003oool0oooo09L0oooo002H0?ooo`030000003oool0oooo01<0oooo
00<000000?ooo`3oool0o`3oool20?ooo`030000003oool0oooo01X0oooo00<000000?ooo`3oool0
U`3oool009L0oooo00<000000?ooo`3oool0503oool00`000000oooo0?ooo`3o0?ooo`40oooo00<0
00000?ooo`3oool0703oool00`000000oooo0?ooo`2F0?ooo`00U`3oool00`000000oooo0?ooo`0D
0?ooo`030000003oool0oooo0?l0oooo0@3oool00`000000oooo0?ooo`0L0?ooo`030000003oool0
oooo09H0oooo002F0?ooo`030000003oool0oooo01D0oooo00<000000?ooo`3oool0o`3oool10?oo
o`030000003oool0oooo01d0oooo00<000000?ooo`3oool0U@3oool009H0oooo00<000000?ooo`3o
ool05@3oool00`000000oooo0?ooo`3o0?ooo`030000003oool0oooo01h0oooo00<000000?ooo`3o
ool0U@3oool009D0oooo00<000000?ooo`3oool05P3oool00`000000oooo0?ooo`3o0?ooo`030000
003oool0oooo01l0oooo00<000000?ooo`3oool0U03oool009D0oooo00<000000?ooo`3oool05`3o
ool00`000000oooo0?ooo`3m0?ooo`030000003oool0oooo0200oooo00<000000?ooo`3oool0U03o
ool009@0oooo00<000000?ooo`3oool0603oool00`000000oooo0?ooo`3m0?ooo`030000003oool0
oooo0240oooo00<000000?ooo`3oool0T`3oool009@0oooo00<000000?ooo`3oool0603oool00`00
0000oooo0?ooo`3l0?ooo`030000003oool0oooo0280oooo00<000000?ooo`3oool0T`3oool009<0
oooo00<000000?ooo`3oool06@3oool00`000000oooo0?ooo`3l0?ooo`030000003oool0oooo02<0
oooo00<000000?ooo`3oool0TP3oool009<0oooo00<000000?ooo`3oool06@3oool00`000000oooo
0?ooo`3l0?ooo`030000003oool0oooo02<0oooo00<000000?ooo`3oool0TP3oool00980oooo00<0
00000?ooo`3oool06`3oool00`000000oooo0?ooo`3j0?ooo`030000003oool0oooo02D0oooo00<0
00000?ooo`3oool0T@3oool00980oooo00<000000?ooo`3oool06`3oool00`000000oooo0?ooo`3j
0?ooo`030000003oool0oooo02D0oooo00<000000?ooo`3oool0T@3oool00940oooo00<000000?oo
o`3oool0703oool00`000000oooo0?ooo`3i0?ooo`030000003oool0oooo02L0oooo00<000000?oo
o`3oool0T03oool00940oooo00<000000?ooo`3oool0703oool00`000000oooo0?ooo`3i0?ooo`03
0000003oool0oooo02L0oooo00<000000?ooo`3oool0T03oool00900oooo00<000000?ooo`3oool0
7@3oool00`000000oooo0?ooo`3i0?ooo`030000003oool0oooo02P0oooo00<000000?ooo`3oool0
S`3oool00900oooo00<000000?ooo`3oool07@3oool00`000000oooo0?ooo`3h0?ooo`030000003o
ool0oooo02T0oooo00<000000?ooo`3oool0S`3oool008l0oooo00<000000?ooo`3oool07`3oool0
0`000000oooo0?ooo`3g0?ooo`030000003oool0oooo02X0oooo00<000000?ooo`3oool0SP3oool0
08l0oooo00<000000?ooo`3oool07`3oool00`000000oooo0?ooo`3f0?ooo`030000003oool0oooo
02/0oooo00<000000?ooo`3oool0SP3oool008h0oooo00<000000?ooo`3oool0803oool00`000000
oooo0?ooo`3f0?ooo`030000003oool0oooo02`0oooo00<000000?ooo`3oool0S@3oool008h0oooo
00<000000?ooo`3oool0803oool00`000000oooo0?ooo`3f0?ooo`030000003oool0oooo02`0oooo
00<000000?ooo`3oool0S@3oool008d0oooo00<000000?ooo`3oool08@3oool00`000000oooo0?oo
o`3e0?ooo`030000003oool0oooo02h0oooo00<000000?ooo`3oool0S03oool008d0oooo00<00000
0?ooo`3oool08@3oool00`000000oooo0?ooo`3e0?ooo`030000003oool0oooo02h0oooo00<00000
0?ooo`3oool0S03oool008`0oooo00<000000?ooo`3oool08`3oool00`000000oooo0?ooo`3c0?oo
o`030000003oool0oooo0300oooo00<000000?ooo`3oool0R`3oool008`0oooo00<000000?ooo`3o
ool08`3oool00`000000oooo0?ooo`3c0?ooo`030000003oool0oooo0300oooo00<000000?ooo`3o
ool0R`3oool008/0oooo00<000000?ooo`3oool0903oool00`000000oooo0?ooo`3b0?ooo`030000
003oool0oooo0380oooo00<000000?ooo`3oool0RP3oool008/0oooo00<000000?ooo`3oool0903o
ool00`000000oooo0?ooo`3b0?ooo`030000003oool0oooo0380oooo00<000000?ooo`3oool0RP3o
ool008X0oooo00<000000?ooo`3oool09@3oool00`000000oooo0?ooo`3b0?ooo`030000003oool0
oooo03<0oooo00<000000?ooo`3oool0R@3oool008X0oooo00<000000?ooo`3oool09P3oool00`00
0000oooo0?ooo`3`0?ooo`030000003oool0oooo03@0oooo00<000000?ooo`3oool0R@3oool008T0
oooo00<000000?ooo`3oool09`3oool00`000000oooo0?ooo`3`0?ooo`030000003oool0oooo03D0
oooo00<000000?ooo`3oool0R03oool008T0oooo00<000000?ooo`3oool09`3oool00`000000oooo
0?ooo`3_0?ooo`030000003oool0oooo03H0oooo00<000000?ooo`3oool0R03oool008P0oooo00<0
00000?ooo`3oool0:03oool00`000000oooo0?ooo`3_0?ooo`030000003oool0oooo03L0oooo00<0
00000?ooo`3oool0Q`3oool008P0oooo00<000000?ooo`3oool0:03oool00`000000oooo0?ooo`3_
0?ooo`030000003oool0oooo03L0oooo00<000000?ooo`3oool0Q`3oool008L0oooo00<000000?oo
o`3oool0:@3oool00`000000oooo0?ooo`3^0?ooo`030000003oool0oooo03T0oooo00<000000?oo
o`3oool0QP3oool008L0oooo00<000000?ooo`3oool0:P3oool00`000000oooo0?ooo`3]0?ooo`03
0000003oool0oooo03T0oooo00<000000?ooo`3oool0QP3oool008H0oooo00<000000?ooo`3oool0
:`3oool00`000000oooo0?ooo`3/0?ooo`030000003oool0oooo03/0oooo00<000000?ooo`3oool0
Q@3oool008H0oooo00<000000?ooo`3oool0:`3oool00`000000oooo0?ooo`3/0?ooo`030000003o
ool0oooo03/0oooo00<000000?ooo`3oool0Q@3oool008D0oooo00<000000?ooo`3oool0;03oool0
0`000000oooo0?ooo`3Y0?ooo`<00000?`3oool00`000000oooo0?ooo`240?ooo`00Q@3oool00`00
0000oooo0?ooo`0/0?ooo`030000003oool0oooo0>H0oooo2000000m0?ooo`030000003oool0oooo
08@0oooo00240?ooo`030000003oool0oooo02d0oooo00<000000?ooo`3oool0i@3oool:000003d0
oooo00<000000?ooo`3oool0P`3oool008@0oooo00<000000?ooo`3oool0;P3oool00`000000oooo
0?ooo`3T0?ooo`X00000?@3oool00`000000oooo0?ooo`230?ooo`00P`3oool00`000000oooo0?oo
o`0_0?ooo`030000003oool0oooo0>@0oooo2P00000n0?ooo`030000003oool0oooo0880oooo0023
0?ooo`030000003oool0oooo02l0oooo00<000000?ooo`3oool0h`3oool<000003d0oooo00<00000
0?ooo`3oool0PP3oool00880oooo00<000000?ooo`3oool0<03oool00`000000oooo0?ooo`3S0?oo
o``00000?P3oool00`000000oooo0?ooo`210?ooo`00PP3oool00`000000oooo0?ooo`0`0?ooo`03
0000003oool0oooo0=T0oooo2P0000000`3oool0000000000008000003l0oooo00<000000?ooo`3o
ool0P@3oool00840oooo00<000000?ooo`3oool0<@3oool00`000000oooo0?ooo`3>0?ooo`/00000
2`3oool:00000400oooo00<000000?ooo`3oool0P03oool00840oooo00<000000?ooo`3oool0<P3o
ool00`000000oooo0?ooo`330?ooo`X000005P3oool:00000400oooo00<000000?ooo`3oool0P03o
ool00800oooo00<000000?ooo`3oool0<`3oool00`000000oooo0?ooo`2h0?ooo`/000008@3oool8
00000480oooo00<000000?ooo`3oool0O`3oool00800oooo00<000000?ooo`3oool0<`3oool00`00
0000oooo0?ooo`2^0?ooo`X00000;@3oool01P000000oooo000000000000oooo000004<0oooo00<0
00000?ooo`3oool0O`3oool007l0oooo00<000000?ooo`3oool0=03oool00`000000oooo0?ooo`2S
0?ooo`/00000=`3oool00`000000oooo0?ooo`020?ooo`030000003oool0oooo0480oooo00<00000
0?ooo`3oool0OP3oool007l0oooo00<000000?ooo`3oool0=03oool00`000000oooo0?ooo`2I0?oo
o`X00000@@3oool00`000000oooo0?ooo`040?ooo`030000003oool0oooo0440oooo00<000000?oo
o`3oool0OP3oool007h0oooo00<000000?ooo`3oool0=P3oool00`000000oooo0?ooo`2=0?ooo`/0
0000B`3oool00`000000oooo0?ooo`040?ooo`030000003oool0oooo0480oooo00<000000?ooo`3o
ool0O@3oool007h0oooo00<000000?ooo`3oool0=P3oool00`000000oooo0?ooo`230?ooo`X00000
E@3oool00`000000oooo0?ooo`060?ooo`030000003oool0oooo0440oooo00<000000?ooo`3oool0
O@3oool007d0oooo00<000000?ooo`3oool0=`3oool00`000000oooo0?ooo`1h0?ooo`/00000G`3o
ool00`000000oooo0?ooo`070?ooo`030000003oool0oooo0440oooo00<000000?ooo`3oool0O03o
ool007d0oooo00<000000?ooo`3oool0=`3oool00`000000oooo0?ooo`1^0?ooo`X00000J@3oool0
0`000000oooo0?ooo`080?ooo`030000003oool0oooo0440oooo00<000000?ooo`3oool0O03oool0
07`0oooo00<000000?ooo`3oool0>03oool00`000000oooo0?ooo`1S0?ooo`/00000L`3oool00`00
0000oooo0?ooo`090?ooo`030000003oool0oooo0440oooo00<000000?ooo`3oool0N`3oool007`0
oooo00<000000?ooo`3oool0>03oool00`000000oooo0?ooo`1I0?ooo`X00000OP3oool00`000000
oooo0?ooo`090?ooo`030000003oool0oooo0440oooo00<000000?ooo`3oool0N`3oool007/0oooo
00<000000?ooo`3oool0>P3oool00`000000oooo0?ooo`1=0?ooo`/00000Q`3oool00`000000oooo
0?ooo`0;0?ooo`030000003oool0oooo0440oooo00<000000?ooo`3oool0NP3oool007/0oooo00<0
00000?ooo`3oool0>P3oool00`000000oooo0?ooo`130?ooo`X00000TP3oool00`000000oooo0?oo
o`0;0?ooo`030000003oool0oooo0440oooo00<000000?ooo`3oool0NP3oool007X0oooo00<00000
0?ooo`3oool0>`3oool2000003T0oooo2`00002K0?ooo`030000003oool0oooo00d0oooo00<00000
0?ooo`3oool0@@3oool00`000000oooo0?ooo`1i0?ooo`00NP3oool00`000000oooo0?ooo`0h0?oo
o`P00000;03oool:00000:H0oooo00<000000?ooo`3oool03P3oool00`000000oooo0?ooo`100?oo
o`030000003oool0oooo07T0oooo001i0?ooo`030000003oool0oooo03P0oooo2P00000P0?ooo`/0
0000/03oool00`000000oooo0?ooo`0>0?ooo`030000003oool0oooo0440oooo00<000000?ooo`3o
ool0N03oool007T0oooo00<000000?ooo`3oool0>03oool:000001H0oooo2P00002j0?ooo`030000
003oool0oooo0100oooo00<000000?ooo`3oool0@03oool00`000000oooo0?ooo`1h0?ooo`00N03o
ool00`000000oooo0?ooo`0i0?ooo`X000002`3oool;00000<@0oooo00<000000?ooo`3oool0403o
ool00`000000oooo0?ooo`110?ooo`030000003oool0oooo07L0oooo001h0?ooo`030000003oool0
oooo03P0oooo5P00003>0?ooo`030000003oool0oooo0180oooo00<000000?ooo`3oool0@03oool0
0`000000oooo0?ooo`1g0?ooo`00M`3oool00`000000oooo0?ooo`0i0?ooo``00000f03oool00`00
0000oooo0?ooo`0B0?ooo`030000003oool0oooo0440oooo00<000000?ooo`3oool0MP3oool007L0
oooo00<000000?ooo`3oool0>P3oool:00000=T0oooo00<000000?ooo`3oool04`3oool00`000000
oooo0?ooo`100?ooo`030000003oool0oooo07H0oooo001f0?ooo`030000003oool0oooo03/0oooo
2P00003H0?ooo`030000003oool0oooo01@0oooo00<000000?ooo`3oool0@@3oool00`000000oooo
0?ooo`1e0?ooo`00MP3oool00`000000oooo0?ooo`0k0?ooo``00000eP3oool00`000000oooo0?oo
o`0E0?ooo`030000003oool0oooo0400oooo00<000000?ooo`3oool0M@3oool007D0oooo00<00000
0?ooo`3oool0?@3oool8000000<0oooo00<000000?ooo`3oool0dP3oool00`000000oooo0?ooo`0G
0?ooo`030000003oool0oooo0400oooo00<000000?ooo`3oool0M03oool007D0oooo00<000000?oo
o`3oool0?P3oool020000000oooo000000000000oooo0000003oool000000`3oool200000=80oooo
00<000000?ooo`3oool05`3oool00`000000oooo0?ooo`100?ooo`030000003oool0oooo07@0oooo
001d0?ooo`030000003oool0oooo03h0oooo00<000000?ooo`3oool00P0000001@3oool000000?oo
o`3oool0000000@0oooo0P00003?0?ooo`030000003oool0oooo01T0oooo00<000000?ooo`3oool0
@03oool00`000000oooo0?ooo`1c0?ooo`00M03oool00`000000oooo0?ooo`0n0?ooo`030000003o
ool0oooo0080000000<0oooo0000003oool00P3oool00`000000oooo0?ooo`030?ooo`030000003o
ool0oooo0<`0oooo00<000000?ooo`3oool06@3oool00`000000oooo0?ooo`100?ooo`030000003o
ool0oooo07<0oooo001c0?ooo`030000003oool0oooo03h0oooo00@000000?ooo`3oool0oooo0P00
00020?ooo`050000003oool0oooo0?ooo`0000001@3oool200000<`0oooo00<000000?ooo`3oool0
6P3oool00`000000oooo0?ooo`100?ooo`030000003oool0oooo0780oooo001c0?ooo`030000003o
ool0oooo03d0oooo00<000000?ooo`3oool00P3oool200000080oooo00<000000?ooo`3oool00P3o
ool00`000000oooo0?ooo`040?ooo`800000b@3oool00`000000oooo0?ooo`0K0?ooo`030000003o
ool0oooo0400oooo00<000000?ooo`3oool0LP3oool00780oooo00<000000?ooo`3oool0?P3oool0
0`000000oooo0?ooo`020?ooo`8000000P3oool00`000000oooo0?ooo`030?ooo`030000003oool0
oooo00D0oooo0P0000370?ooo`030000003oool0oooo01`0oooo00<000000?ooo`3oool0@03oool0
0`000000oooo0?ooo`1a0?ooo`00LP3oool00`000000oooo0?ooo`0m0?ooo`030000003oool0oooo
0080oooo00<000000?ooo`0000000`3oool00`000000oooo0?ooo`020?ooo`030000003oool0oooo
00L0oooo00<000000?ooo`3oool0``3oool00`000000oooo0?ooo`0N0?ooo`030000003oool0oooo
03l0oooo00<000000?ooo`3oool0L@3oool00740oooo00<000000?ooo`3oool0?@3oool00`000000
oooo0?ooo`030?ooo`040000003oool0oooo00000080oooo00<000000?ooo`3oool00`3oool00`00
0000oooo0?ooo`070?ooo`800000``3oool00`000000oooo0?ooo`0N0?ooo`030000003oool0oooo
0400oooo00<000000?ooo`3oool0L03oool00740oooo00<000000?ooo`3oool0?@3oool00`000000
oooo0?ooo`030?ooo`040000003oool0oooo00000080oooo00<000000?ooo`3oool0103oool00`00
0000oooo0?ooo`080?ooo`800000`@3oool00`000000oooo0?ooo`0O0?ooo`030000003oool0oooo
03l0oooo00<000000?ooo`3oool0L03oool00700oooo00<000000?ooo`3oool0?@3oool00`000000
oooo0?ooo`040?ooo`040000003oool0oooo000000<0oooo00<000000?ooo`3oool0103oool00`00
0000oooo0?ooo`090?ooo`030000003oool0oooo0;d0oooo00<000000?ooo`3oool0803oool00`00
0000oooo0?ooo`100?ooo`030000003oool0oooo06l0oooo001`0?ooo`030000003oool0oooo03`0
oooo00<000000?ooo`3oool01@3oool010000000oooo0?ooo`0000030?ooo`030000003oool0oooo
00D0oooo00<000000?ooo`3oool02@3oool200000;d0oooo00<000000?ooo`3oool08@3oool00`00
0000oooo0?ooo`0o0?ooo`030000003oool0oooo06l0oooo001_0?ooo`030000003oool0oooo03d0
oooo00<000000?ooo`3oool01@3oool010000000oooo0?ooo`0000030?ooo`030000003oool0oooo
00H0oooo00<000000?ooo`3oool02P3oool200000;X0oooo00<000000?ooo`3oool08P3oool00`00
0000oooo0?ooo`100?ooo`030000003oool0oooo06h0oooo001_0?ooo`030000003oool0oooo03`0
oooo00<000000?ooo`3oool01@3oool01@000000oooo0?ooo`3oool0000000@0oooo00<000000?oo
o`3oool01P3oool00`000000oooo0?ooo`0;0?ooo`800000^03oool00`000000oooo0?ooo`0S0?oo
o`030000003oool0oooo03l0oooo00<000000?ooo`3oool0KP3oool006h0oooo00<000000?ooo`3o
ool0?@3oool00`000000oooo0?ooo`050?ooo`050000003oool0oooo0?ooo`000000103oool00`00
0000oooo0?ooo`060?ooo`030000003oool0oooo00d0oooo00<000000?ooo`3oool0]03oool00`00
0000oooo0?ooo`0T0?ooo`030000003oool0oooo0400oooo00<000000?ooo`3oool0K@3oool006h0
oooo00<000000?ooo`3oool0?03oool00`000000oooo0?ooo`060?ooo`050000003oool0oooo0?oo
o`000000103oool00`000000oooo0?ooo`070?ooo`030000003oool0oooo00d0oooo0P00002d0?oo
o`030000003oool0oooo02D0oooo00<000000?ooo`3oool0?`3oool00`000000oooo0?ooo`1]0?oo
o`00K@3oool00`000000oooo0?ooo`0l0?ooo`030000003oool0oooo00L0oooo00D000000?ooo`3o
ool0oooo000000050?ooo`030000003oool0oooo00L0oooo00<000000?ooo`3oool03P3oool20000
0;80oooo00<000000?ooo`3oool09P3oool00`000000oooo0?ooo`0o0?ooo`030000003oool0oooo
06`0oooo001]0?ooo`030000003oool0oooo03`0oooo00<000000?ooo`3oool01`3oool01@000000
oooo0?ooo`3oool0000000D0oooo00<000000?ooo`3oool0203oool00`000000oooo0?ooo`0?0?oo
o`800000[`3oool00`000000oooo0?ooo`0W0?ooo`030000003oool0oooo03l0oooo00<000000?oo
o`3oool0K03oool006`0oooo00<000000?ooo`3oool0?03oool00`000000oooo0?ooo`080?ooo`05
0000003oool0oooo0?ooo`0000001@3oool00`000000oooo0?ooo`090?ooo`030000003oool0oooo
0100oooo00<000000?ooo`3oool0[03oool00`000000oooo0?ooo`0X0?ooo`030000003oool0oooo
03l0oooo00<000000?ooo`3oool0J`3oool006`0oooo00<000000?ooo`3oool0>`3oool00`000000
oooo0?ooo`090?ooo`050000003oool0oooo0?ooo`0000001P3oool00`000000oooo0?ooo`090?oo
o`030000003oool0oooo0100oooo0P00002[0?ooo`030000003oool0oooo02T0oooo00<000000?oo
o`3oool0?`3oool00`000000oooo0?ooo`1[0?ooo`00J`3oool00`000000oooo0?ooo`0l0?ooo`03
0000003oool0oooo00P0oooo00<000000?ooo`3oool00P3oool00`000000oooo0?ooo`040?ooo`03
0000003oool0oooo00X0oooo00<000000?ooo`3oool04@3oool200000:T0oooo00<000000?ooo`3o
ool0:P3oool00`000000oooo0?ooo`0o0?ooo`030000003oool0oooo06X0oooo001[0?ooo`030000
003oool0oooo03/0oooo00<000000?ooo`3oool02@3oool00`000000oooo0?ooo`020?ooo`030000
003oool0oooo00@0oooo00<000000?ooo`3oool02P3oool00`000000oooo0?ooo`0C0?ooo`030000
003oool0oooo0:H0oooo00<000000?ooo`3oool0:P3oool00`000000oooo0?ooo`0o0?ooo`030000
003oool0oooo06X0oooo001Z0?ooo`030000003oool0oooo03`0oooo00<000000?ooo`3oool02@3o
ool00`000000oooo0?ooo`020?ooo`030000003oool0oooo00D0oooo00<000000?ooo`3oool02P3o
ool00`000000oooo0?ooo`0C0?ooo`800000Y@3oool00`000000oooo0?ooo`0/0?ooo`030000003o
ool0oooo03l0oooo00<000000?ooo`3oool0J@3oool006X0oooo00<000000?ooo`3oool0>`3oool0
0`000000oooo0?ooo`0:0?ooo`030000003oool0oooo0080oooo00<000000?ooo`3oool01@3oool0
0`000000oooo0?ooo`0;0?ooo`030000003oool0oooo01@0oooo0P00002S0?ooo`030000003oool0
oooo02`0oooo00<000000?ooo`3oool0?`3oool00`000000oooo0?ooo`1Y0?ooo`00J@3oool00`00
0000oooo0?ooo`0k0?ooo`030000003oool0oooo00/0oooo00<000000?ooo`3oool00P3oool00`00
0000oooo0?ooo`050?ooo`030000003oool0oooo00`0oooo00<000000?ooo`3oool05@3oool20000
0:00oooo00<000000?ooo`3oool0;P3oool00`000000oooo0?ooo`0o0?ooo`030000003oool0oooo
06P0oooo001Y0?ooo`030000003oool0oooo03/0oooo00<000000?ooo`3oool02`3oool00`000000
oooo0?ooo`020?ooo`030000003oool0oooo00H0oooo00<000000?ooo`3oool0303oool00`000000
oooo0?ooo`0F0?ooo`030000003oool0oooo09d0oooo00<000000?ooo`3oool0;`3oool00`000000
oooo0?ooo`0n0?ooo`030000003oool0oooo06P0oooo001X0?ooo`030000003oool0oooo03/0oooo
00<000000?ooo`3oool0303oool00`000000oooo0?ooo`020?ooo`030000003oool0oooo00H0oooo
00<000000?ooo`3oool03@3oool00`000000oooo0?ooo`0F0?ooo`800000W@3oool00`000000oooo
0?ooo`0_0?ooo`030000003oool0oooo03l0oooo00<000000?ooo`3oool0I`3oool006P0oooo00<0
00000?ooo`3oool0>P3oool00`000000oooo0?ooo`0<0?ooo`030000003oool0oooo00<0oooo00<0
00000?ooo`3oool01`3oool00`000000oooo0?ooo`0=0?ooo`030000003oool0oooo01L0oooo0P00
002J0?ooo`030000003oool0oooo0340oooo00<000000?ooo`3oool0?P3oool00`000000oooo0?oo
o`1W0?ooo`00I`3oool00`000000oooo0?ooo`0k0?ooo`030000003oool0oooo00`0oooo00<00000
0?ooo`3oool00`3oool00`000000oooo0?ooo`070?ooo`030000003oool0oooo00d0oooo00<00000
0?ooo`3oool06@3oool00`000000oooo0?ooo`2G0?ooo`030000003oool0oooo0340oooo00<00000
0?ooo`3oool0?`3oool00`000000oooo0?ooo`1V0?ooo`00I`3oool00`000000oooo0?ooo`0j0?oo
o`030000003oool0oooo00d0oooo00<000000?ooo`3oool00`3oool00`000000oooo0?ooo`070?oo
o`030000003oool0oooo00h0oooo00<000000?ooo`3oool06@3oool2000009H0oooo00<000000?oo
o`3oool0<`3oool00`000000oooo0?ooo`0n0?ooo`030000003oool0oooo06H0oooo001V0?ooo`03
0000003oool0oooo03X0oooo00<000000?ooo`3oool03P3oool00`000000oooo0?ooo`030?ooo`03
0000003oool0oooo00P0oooo00<000000?ooo`3oool03P3oool00`000000oooo0?ooo`0J0?ooo`80
0000U03oool00`000000oooo0?ooo`0c0?ooo`030000003oool0oooo03l0oooo00<000000?ooo`3o
ool0I@3oool006H0oooo00<000000?ooo`3oool0>P3oool00`000000oooo0?ooo`0>0?ooo`030000
003oool0oooo00@0oooo00<000000?ooo`3oool01`3oool00`000000oooo0?ooo`0?0?ooo`030000
003oool0oooo01/0oooo0P00002A0?ooo`030000003oool0oooo03D0oooo00<000000?ooo`3oool0
?P3oool00`000000oooo0?ooo`1U0?ooo`00I@3oool00`000000oooo0?ooo`0j0?ooo`030000003o
ool0oooo00l0oooo00<000000?ooo`3oool0103oool00`000000oooo0?ooo`070?ooo`030000003o
ool0oooo0100oooo00<000000?ooo`3oool0703oool00`000000oooo0?ooo`2>0?ooo`030000003o
ool0oooo03H0oooo00<000000?ooo`3oool0?P3oool00`000000oooo0?ooo`1T0?ooo`00I@3oool0
0`000000oooo0?ooo`0j0?ooo`030000003oool0oooo00l0oooo00<000000?ooo`3oool0103oool0
0`000000oooo0?ooo`080?ooo`030000003oool0oooo0100oooo00<000000?ooo`3oool0703oool2
000008h0oooo00<000000?ooo`3oool0=P3oool00`000000oooo0?ooo`0n0?ooo`030000003oool0
oooo06@0oooo001T0?ooo`030000003oool0oooo03X0oooo00<000000?ooo`3oool03`3oool00`00
0000oooo0?ooo`050?ooo`030000003oool0oooo00P0oooo00<000000?ooo`3oool04@3oool00`00
0000oooo0?ooo`0M0?ooo`800000R`3oool00`000000oooo0?ooo`0h0?ooo`030000003oool0oooo
03h0oooo00<000000?ooo`3oool0H`3oool006@0oooo00<000000?ooo`3oool0>@3oool00`000000
oooo0?ooo`0@0?ooo`030000003oool0oooo00D0oooo00<000000?ooo`3oool0203oool00`000000
oooo0?ooo`0A0?ooo`030000003oool0oooo01l0oooo00<000000?ooo`3oool0R03oool00`000000
oooo0?ooo`0h0?ooo`030000003oool0oooo03h0oooo00<000000?ooo`3oool0H`3oool006<0oooo
00<000000?ooo`3oool0>P3oool00`000000oooo0?ooo`0@0?ooo`030000003oool0oooo00D0oooo
00<000000?ooo`3oool02@3oool00`000000oooo0?ooo`0A0?ooo`030000003oool0oooo01l0oooo
0P0000270?ooo`030000003oool0oooo03X0oooo00<000000?ooo`3oool0?P3oool00`000000oooo
0?ooo`1R0?ooo`00H`3oool00`000000oooo0?ooo`0i0?ooo`030000003oool0oooo0140oooo00<0
00000?ooo`3oool01@3oool00`000000oooo0?ooo`090?ooo`030000003oool0oooo0180oooo00<0
00000?ooo`3oool0803oool2000008D0oooo00<000000?ooo`3oool0>P3oool00`000000oooo0?oo
o`0n0?ooo`030000003oool0oooo0680oooo001R0?ooo`030000003oool0oooo03T0oooo00<00000
0?ooo`3oool04P3oool00`000000oooo0?ooo`050?ooo`030000003oool0oooo00T0oooo00<00000
0?ooo`3oool04`3oool00`000000oooo0?ooo`0Q0?ooo`800000P`3oool00`000000oooo0?ooo`0k
0?ooo`030000003oool0oooo03h0oooo00<000000?ooo`3oool0H@3oool00680oooo00<000000?oo
o`3oool0>@3oool00`000000oooo0?ooo`0B0?ooo`030000003oool0oooo00D0oooo00<000000?oo
o`3oool02P3oool00`000000oooo0?ooo`0C0?ooo`030000003oool0oooo0280oooo00<000000?oo
o`3oool0O`3oool00`000000oooo0?ooo`0l0?ooo`030000003oool0oooo03h0oooo00<000000?oo
o`3oool0H@3oool00640oooo00<000000?ooo`3oool0>@3oool00`000000oooo0?ooo`0C0?ooo`03
0000003oool0oooo00D0oooo00<000000?ooo`3oool02P3oool00`000000oooo0?ooo`0D0?ooo`03
0000003oool0oooo0280oooo0P00001o0?ooo`030000003oool0oooo03d0oooo00<000000?ooo`3o
ool0?P3oool00`000000oooo0?ooo`1P0?ooo`00H@3oool00`000000oooo0?ooo`0h0?ooo`030000
003oool0oooo01<0oooo00<000000?ooo`3oool01P3oool00`000000oooo0?ooo`0:0?ooo`030000
003oool0oooo01D0oooo00<000000?ooo`3oool08`3oool2000007`0oooo00<000000?ooo`3oool0
?`3oool00`000000oooo0?ooo`0n0?ooo`030000003oool0oooo05l0oooo001P0?ooo`030000003o
ool0oooo03T0oooo00<000000?ooo`3oool04`3oool00`000000oooo0?ooo`060?ooo`030000003o
ool0oooo00/0oooo00<000000?ooo`3oool0503oool00`000000oooo0?ooo`0U0?ooo`800000NP3o
ool00`000000oooo0?ooo`0o0?ooo`030000003oool0oooo03h0oooo00<000000?ooo`3oool0G`3o
ool00600oooo00<000000?ooo`3oool0>03oool00`000000oooo0?ooo`0D0?ooo`030000003oool0
oooo00H0oooo00<000000?ooo`3oool02`3oool00`000000oooo0?ooo`0E0?ooo`030000003oool0
oooo02H0oooo00<000000?ooo`3oool0M`3oool00`000000oooo0?ooo`100?ooo`030000003oool0
oooo03h0oooo00<000000?ooo`3oool0GP3oool005l0oooo00<000000?ooo`3oool0>@3oool00`00
0000oooo0?ooo`0D0?ooo`030000003oool0oooo00H0oooo00<000000?ooo`3oool02`3oool00`00
0000oooo0?ooo`0F0?ooo`030000003oool0oooo02H0oooo0P00001f0?ooo`030000003oool0oooo
0440oooo00<000000?ooo`3oool0?P3oool00`000000oooo0?ooo`1N0?ooo`00G`3oool00`000000
oooo0?ooo`0h0?ooo`030000003oool0oooo01D0oooo00<000000?ooo`3oool01P3oool00`000000
oooo0?ooo`0<0?ooo`030000003oool0oooo01H0oooo00<000000?ooo`3oool09`3oool2000007@0
oooo00<000000?ooo`3oool0@P3oool00`000000oooo0?ooo`0n0?ooo`030000003oool0oooo05d0
oooo001N0?ooo`030000003oool0oooo03P0oooo00<000000?ooo`3oool05P3oool00`000000oooo
0?ooo`060?ooo`030000003oool0oooo00`0oooo00<000000?ooo`3oool05`3oool00`000000oooo
0?ooo`0X0?ooo`030000003oool0oooo0700oooo00<000000?ooo`3oool0@`3oool00`000000oooo
0?ooo`0n0?ooo`030000003oool0oooo05d0oooo001N0?ooo`030000003oool0oooo03P0oooo00<0
00000?ooo`3oool05@3oool00`000000oooo0?ooo`070?ooo`030000003oool0oooo00`0oooo00<0
00000?ooo`3oool0603oool00`000000oooo0?ooo`0X0?ooo`800000L03oool00`000000oooo0?oo
o`140?ooo`030000003oool0oooo03h0oooo00<000000?ooo`3oool0G03oool005d0oooo00<00000
0?ooo`3oool0>03oool00`000000oooo0?ooo`0F0?ooo`030000003oool0oooo00L0oooo00<00000
0?ooo`3oool03@3oool00`000000oooo0?ooo`0H0?ooo`030000003oool0oooo02T0oooo0P00001]
0?ooo`030000003oool0oooo04H0oooo00<000000?ooo`3oool0?@3oool00`000000oooo0?ooo`1L
0?ooo`00G@3oool00`000000oooo0?ooo`0g0?ooo`030000003oool0oooo01L0oooo00<000000?oo
o`3oool01`3oool00`000000oooo0?ooo`0=0?ooo`030000003oool0oooo01P0oooo00<000000?oo
o`3oool0:`3oool2000006/0oooo00<000000?ooo`3oool0AP3oool00`000000oooo0?ooo`0n0?oo
o`030000003oool0oooo05/0oooo001L0?ooo`030000003oool0oooo03P0oooo00<000000?ooo`3o
ool05`3oool00`000000oooo0?ooo`070?ooo`030000003oool0oooo00d0oooo00<000000?ooo`3o
ool06@3oool00`000000oooo0?ooo`0/0?ooo`030000003oool0oooo06P0oooo00<000000?ooo`3o
ool0A`3oool00`000000oooo0?ooo`0m0?ooo`030000003oool0oooo05/0oooo001L0?ooo`030000
003oool0oooo03L0oooo00<000000?ooo`3oool0603oool00`000000oooo0?ooo`070?ooo`030000
003oool0oooo00h0oooo00<000000?ooo`3oool06@3oool00`000000oooo0?ooo`0/0?ooo`800000
I`3oool00`000000oooo0?ooo`180?ooo`030000003oool0oooo03h0oooo00<000000?ooo`3oool0
FP3oool005/0oooo00<000000?ooo`3oool0>03oool00`000000oooo0?ooo`0H0?ooo`030000003o
ool0oooo00L0oooo00<000000?ooo`3oool03P3oool00`000000oooo0?ooo`0J0?ooo`030000003o
ool0oooo02d0oooo0P00001U0?ooo`030000003oool0oooo04T0oooo00<000000?ooo`3oool0?@3o
ool00`000000oooo0?ooo`1J0?ooo`00F`3oool00`000000oooo0?ooo`0g0?ooo`030000003oool0
oooo01T0oooo00<000000?ooo`3oool01`3oool00`000000oooo0?ooo`0>0?ooo`030000003oool0
oooo01/0oooo00<000000?ooo`3oool0;P3oool00`000000oooo0?ooo`1Q0?ooo`030000003oool0
oooo04X0oooo00<000000?ooo`3oool0?P3oool00`000000oooo0?ooo`1I0?ooo`00FP3oool00`00
0000oooo0?ooo`0g0?ooo`030000003oool0oooo01T0oooo00<000000?ooo`3oool02@3oool00`00
0000oooo0?ooo`0>0?ooo`030000003oool0oooo01/0oooo00<000000?ooo`3oool0;P3oool20000
0640oooo00<000000?ooo`3oool0B`3oool00`000000oooo0?ooo`0m0?ooo`030000003oool0oooo
05T0oooo001J0?ooo`030000003oool0oooo03L0oooo00<000000?ooo`3oool06@3oool00`000000
oooo0?ooo`090?ooo`030000003oool0oooo00h0oooo00<000000?ooo`3oool06`3oool00`000000
oooo0?ooo`0`0?ooo`800000G`3oool00`000000oooo0?ooo`1;0?ooo`030000003oool0oooo03h0
oooo00<000000?ooo`3oool0F03oool005T0oooo00<000000?ooo`3oool0=`3oool00`000000oooo
0?ooo`0J0?ooo`030000003oool0oooo00T0oooo00<000000?ooo`3oool03P3oool00`000000oooo
0?ooo`0L0?ooo`030000003oool0oooo0340oooo0P00001L0?ooo`030000003oool0oooo04d0oooo
00<000000?ooo`3oool0?@3oool00`000000oooo0?ooo`1H0?ooo`00F@3oool00`000000oooo0?oo
o`0f0?ooo`030000003oool0oooo01/0oooo00<000000?ooo`3oool02@3oool00`000000oooo0?oo
o`0?0?ooo`030000003oool0oooo01`0oooo00<000000?ooo`3oool0<P3oool00`000000oooo0?oo
o`1I0?ooo`030000003oool0oooo04h0oooo00<000000?ooo`3oool0?@3oool00`000000oooo0?oo
o`1G0?ooo`00F03oool00`000000oooo0?ooo`0g0?ooo`030000003oool0oooo01/0oooo00<00000
0?ooo`3oool02@3oool00`000000oooo0?ooo`0?0?ooo`030000003oool0oooo01d0oooo00<00000
0?ooo`3oool0<P3oool2000005P0oooo00<000000?ooo`3oool0C`3oool00`000000oooo0?ooo`0m
0?ooo`030000003oool0oooo05L0oooo001H0?ooo`030000003oool0oooo03H0oooo00<000000?oo
o`3oool0703oool00`000000oooo0?ooo`090?ooo`030000003oool0oooo00l0oooo00<000000?oo
o`3oool07P3oool00`000000oooo0?ooo`0c0?ooo`800000EP3oool00`000000oooo0?ooo`1@0?oo
o`030000003oool0oooo03d0oooo00<000000?ooo`3oool0EP3oool005L0oooo00<000000?ooo`3o
ool0=P3oool00`000000oooo0?ooo`0M0?ooo`030000003oool0oooo00T0oooo00<000000?ooo`3o
ool0403oool00`000000oooo0?ooo`0N0?ooo`030000003oool0oooo03@0oooo0P00001D0?ooo`03
0000003oool0oooo0500oooo00<000000?ooo`3oool0?@3oool00`000000oooo0?ooo`1F0?ooo`00
E`3oool00`000000oooo0?ooo`0f0?ooo`030000003oool0oooo01`0oooo00<000000?ooo`3oool0
2P3oool00`000000oooo0?ooo`0@0?ooo`030000003oool0oooo01l0oooo00<000000?ooo`3oool0
=@3oool00`000000oooo0?ooo`1@0?ooo`030000003oool0oooo0580oooo00<000000?ooo`3oool0
?@3oool00`000000oooo0?ooo`1E0?ooo`00EP3oool00`000000oooo0?ooo`0f0?ooo`030000003o
ool0oooo01d0oooo00<000000?ooo`3oool02P3oool00`000000oooo0?ooo`0@0?ooo`030000003o
ool0oooo01l0oooo00<000000?ooo`3oool0=P3oool200000500oooo00<000000?ooo`3oool0DP3o
ool00`000000oooo0?ooo`0m0?ooo`030000003oool0oooo05D0oooo001F0?ooo`030000003oool0
oooo03H0oooo00<000000?ooo`3oool07@3oool00`000000oooo0?ooo`0:0?ooo`030000003oool0
oooo0140oooo00<000000?ooo`3oool07`3oool00`000000oooo0?ooo`0g0?ooo`800000C@3oool0
0`000000oooo0?ooo`1D0?ooo`030000003oool0oooo03d0oooo00<000000?ooo`3oool0E03oool0
05D0oooo00<000000?ooo`3oool0=P3oool00`000000oooo0?ooo`0N0?ooo`030000003oool0oooo
00X0oooo00<000000?ooo`3oool04@3oool00`000000oooo0?ooo`0P0?ooo`030000003oool0oooo
03P0oooo00<000000?ooo`3oool0BP3oool00`000000oooo0?ooo`1D0?ooo`030000003oool0oooo
03d0oooo00<000000?ooo`3oool0E03oool005D0oooo00<000000?ooo`3oool0=@3oool00`000000
oooo0?ooo`0O0?ooo`030000003oool0oooo00X0oooo00<000000?ooo`3oool04@3oool00`000000
oooo0?ooo`0Q0?ooo`030000003oool0oooo03P0oooo0P0000190?ooo`030000003oool0oooo05H0
oooo00<000000?ooo`3oool0?@3oool00`000000oooo0?ooo`1C0?ooo`00E03oool00`000000oooo
0?ooo`0f0?ooo`030000003oool0oooo01l0oooo00<000000?ooo`3oool02P3oool00`000000oooo
0?ooo`0B0?ooo`030000003oool0oooo0240oooo00<000000?ooo`3oool0>@3oool2000004L0oooo
00<000000?ooo`3oool0E`3oool00`000000oooo0?ooo`0l0?ooo`030000003oool0oooo05<0oooo
001D0?ooo`030000003oool0oooo03D0oooo00<000000?ooo`3oool0803oool00`000000oooo0?oo
o`0:0?ooo`030000003oool0oooo0180oooo00<000000?ooo`3oool08P3oool00`000000oooo0?oo
o`0j0?ooo`800000A@3oool00`000000oooo0?ooo`1G0?ooo`030000003oool0oooo03d0oooo00<0
00000?ooo`3oool0DP3oool005<0oooo00<000000?ooo`3oool0=@3oool00`000000oooo0?ooo`0P
0?ooo`030000003oool0oooo00/0oooo00<000000?ooo`3oool04P3oool00`000000oooo0?ooo`0S
0?ooo`030000003oool0oooo03/0oooo00<000000?ooo`3oool0@@3oool00`000000oooo0?ooo`1I
0?ooo`030000003oool0oooo03`0oooo00<000000?ooo`3oool0DP3oool005<0oooo00<000000?oo
o`3oool0=@3oool00`000000oooo0?ooo`0P0?ooo`030000003oool0oooo00/0oooo00<000000?oo
o`3oool04`3oool00`000000oooo0?ooo`0R0?ooo`030000003oool0oooo03`0oooo0P0000110?oo
o`030000003oool0oooo05T0oooo00<000000?ooo`3oool0?@3oool00`000000oooo0?ooo`1A0?oo
o`00DP3oool00`000000oooo0?ooo`0e0?ooo`030000003oool0oooo0240oooo00<000000?ooo`3o
ool02`3oool00`000000oooo0?ooo`0C0?ooo`030000003oool0oooo02<0oooo00<000000?ooo`3o
ool0?@3oool2000003h0oooo00<000000?ooo`3oool0F`3oool00`000000oooo0?ooo`0l0?ooo`03
0000003oool0oooo0540oooo001B0?ooo`030000003oool0oooo03@0oooo00<000000?ooo`3oool0
8P3oool00`000000oooo0?ooo`0;0?ooo`030000003oool0oooo01<0oooo00<000000?ooo`3oool0
903oool00`000000oooo0?ooo`0n0?ooo`030000003oool0oooo03/0oooo00<000000?ooo`3oool0
F`3oool00`000000oooo0?ooo`0m0?ooo`030000003oool0oooo0500oooo001A0?ooo`030000003o
ool0oooo03D0oooo00<000000?ooo`3oool08P3oool00`000000oooo0?ooo`0;0?ooo`030000003o
ool0oooo01@0oooo00<000000?ooo`3oool0903oool00`000000oooo0?ooo`0n0?ooo`800000>`3o
ool00`000000oooo0?ooo`1L0?ooo`030000003oool0oooo03`0oooo00<000000?ooo`3oool0D03o
ool00540oooo00<000000?ooo`3oool0=03oool00`000000oooo0?ooo`0S0?ooo`030000003oool0
oooo00/0oooo00<000000?ooo`3oool0503oool00`000000oooo0?ooo`0U0?ooo`030000003oool0
oooo03l0oooo0P00000h0?ooo`030000003oool0oooo05h0oooo00<000000?ooo`3oool0?03oool0
0`000000oooo0?ooo`1?0?ooo`00D03oool00`000000oooo0?ooo`0e0?ooo`030000003oool0oooo
0280oooo00<000000?ooo`3oool0303oool00`000000oooo0?ooo`0D0?ooo`030000003oool0oooo
02H0oooo00<000000?ooo`3oool0@03oool2000003H0oooo00<000000?ooo`3oool0GP3oool00`00
0000oooo0?ooo`0l0?ooo`030000003oool0oooo04l0oooo001@0?ooo`030000003oool0oooo03@0
oooo00<000000?ooo`3oool08`3oool00`000000oooo0?ooo`0<0?ooo`030000003oool0oooo01D0
oooo00<000000?ooo`3oool09P3oool00`000000oooo0?ooo`110?ooo`030000003oool0oooo0380
oooo00<000000?ooo`3oool0H03oool00`000000oooo0?ooo`0l0?ooo`030000003oool0oooo04h0
oooo001?0?ooo`030000003oool0oooo03@0oooo00<000000?ooo`3oool0903oool00`000000oooo
0?ooo`0<0?ooo`030000003oool0oooo01D0oooo00<000000?ooo`3oool09P3oool00`000000oooo
0?ooo`120?ooo`800000<P3oool00`000000oooo0?ooo`1P0?ooo`030000003oool0oooo03`0oooo
00<000000?ooo`3oool0CP3oool004l0oooo00<000000?ooo`3oool0=03oool00`000000oooo0?oo
o`0T0?ooo`030000003oool0oooo00d0oooo00<000000?ooo`3oool0503oool00`000000oooo0?oo
o`0W0?ooo`030000003oool0oooo04<0oooo0P00000_0?ooo`030000003oool0oooo0680oooo00<0
00000?ooo`3oool0?03oool00`000000oooo0?ooo`1=0?ooo`00CP3oool00`000000oooo0?ooo`0d
0?ooo`030000003oool0oooo02D0oooo00<000000?ooo`3oool03@3oool00`000000oooo0?ooo`0E
0?ooo`030000003oool0oooo02L0oooo00<000000?ooo`3oool0A03oool00`000000oooo0?ooo`0/
0?ooo`030000003oool0oooo0680oooo00<000000?ooo`3oool0?03oool00`000000oooo0?ooo`1=
0?ooo`00CP3oool00`000000oooo0?ooo`0c0?ooo`030000003oool0oooo02H0oooo00<000000?oo
o`3oool03@3oool00`000000oooo0?ooo`0E0?ooo`030000003oool0oooo02P0oooo00<000000?oo
o`3oool0A03oool2000002`0oooo00<000000?ooo`3oool0H`3oool00`000000oooo0?ooo`0l0?oo
o`030000003oool0oooo04`0oooo001=0?ooo`030000003oool0oooo03@0oooo00<000000?ooo`3o
ool09P3oool00`000000oooo0?ooo`0=0?ooo`030000003oool0oooo01D0oooo00<000000?ooo`3o
ool0:@3oool00`000000oooo0?ooo`150?ooo`800000:@3oool00`000000oooo0?ooo`1T0?ooo`03
0000003oool0oooo03`0oooo00<000000?ooo`3oool0C03oool004d0oooo00<000000?ooo`3oool0
<`3oool00`000000oooo0?ooo`0V0?ooo`030000003oool0oooo00h0oooo00<000000?ooo`3oool0
5P3oool00`000000oooo0?ooo`0Y0?ooo`030000003oool0oooo04H0oooo0P00000W0?ooo`030000
003oool0oooo06D0oooo00<000000?ooo`3oool0?03oool00`000000oooo0?ooo`1;0?ooo`00C03o
ool00`000000oooo0?ooo`0c0?ooo`030000003oool0oooo02L0oooo00<000000?ooo`3oool03P3o
ool00`000000oooo0?ooo`0F0?ooo`030000003oool0oooo02X0oooo00<000000?ooo`3oool0A`3o
ool00`000000oooo0?ooo`0S0?ooo`030000003oool0oooo06L0oooo00<000000?ooo`3oool0>`3o
ool00`000000oooo0?ooo`1;0?ooo`00C03oool00`000000oooo0?ooo`0c0?ooo`030000003oool0
oooo02L0oooo00<000000?ooo`3oool03P3oool00`000000oooo0?ooo`0F0?ooo`030000003oool0
oooo02X0oooo00<000000?ooo`3oool0B03oool2000002<0oooo00<000000?ooo`3oool0I`3oool0
0`000000oooo0?ooo`0l0?ooo`030000003oool0oooo04X0oooo001;0?ooo`030000003oool0oooo
03<0oooo00<000000?ooo`3oool0:03oool00`000000oooo0?ooo`0>0?ooo`030000003oool0oooo
01L0oooo00<000000?ooo`3oool0:P3oool00`000000oooo0?ooo`190?ooo`8000008@3oool00`00
0000oooo0?ooo`1X0?ooo`030000003oool0oooo03/0oooo00<000000?ooo`3oool0BP3oool004/0
oooo00<000000?ooo`3oool0<`3oool00`000000oooo0?ooo`0X0?ooo`030000003oool0oooo00h0
oooo00<000000?ooo`3oool05`3oool00`000000oooo0?ooo`0[0?ooo`030000003oool0oooo04X0
oooo0P00000N0?ooo`030000003oool0oooo06T0oooo00<000000?ooo`3oool0?03oool00`000000
oooo0?ooo`190?ooo`00BP3oool00`000000oooo0?ooo`0c0?ooo`030000003oool0oooo02T0oooo
00<000000?ooo`3oool03P3oool00`000000oooo0?ooo`0G0?ooo`030000003oool0oooo02`0oooo
00<000000?ooo`3oool0B`3oool00`000000oooo0?ooo`0K0?ooo`030000003oool0oooo06X0oooo
00<000000?ooo`3oool0>`3oool00`000000oooo0?ooo`190?ooo`00BP3oool00`000000oooo0?oo
o`0b0?ooo`030000003oool0oooo02X0oooo00<000000?ooo`3oool03P3oool00`000000oooo0?oo
o`0H0?ooo`030000003oool0oooo02`0oooo00<000000?ooo`3oool0B`3oool2000001X0oooo00<0
00000?ooo`3oool0J`3oool00`000000oooo0?ooo`0l0?ooo`030000003oool0oooo04P0oooo0019
0?ooo`030000003oool0oooo03<0oooo00<000000?ooo`3oool0:@3oool00`000000oooo0?ooo`0?
0?ooo`030000003oool0oooo01P0oooo00<000000?ooo`3oool0;@3oool00`000000oooo0?ooo`1<
0?ooo`800000603oool00`000000oooo0?ooo`1/0?ooo`030000003oool0oooo03/0oooo00<00000
0?ooo`3oool0B03oool004T0oooo00<000000?ooo`3oool0<P3oool00`000000oooo0?ooo`0Z0?oo
o`030000003oool0oooo00l0oooo00<000000?ooo`3oool06@3oool00`000000oooo0?ooo`0]0?oo
o`030000003oool0oooo04d0oooo00<000000?ooo`3oool05@3oool00`000000oooo0?ooo`1]0?oo
o`030000003oool0oooo03/0oooo00<000000?ooo`3oool0A`3oool004P0oooo00<000000?ooo`3o
ool0<P3oool00`000000oooo0?ooo`0[0?ooo`030000003oool0oooo00l0oooo00<000000?ooo`3o
ool06@3oool00`000000oooo0?ooo`0]0?ooo`030000003oool0oooo04h0oooo0P00000D0?ooo`03
0000003oool0oooo06h0oooo00<000000?ooo`3oool0>`3oool00`000000oooo0?ooo`170?ooo`00
B03oool00`000000oooo0?ooo`0b0?ooo`030000003oool0oooo02/0oooo00<000000?ooo`3oool0
3`3oool00`000000oooo0?ooo`0I0?ooo`030000003oool0oooo02h0oooo00<000000?ooo`3oool0
C`3oool200000180oooo00<000000?ooo`3oool0K`3oool00`000000oooo0?ooo`0k0?ooo`030000
003oool0oooo04H0oooo00170?ooo`030000003oool0oooo0380oooo00<000000?ooo`3oool0;03o
ool00`000000oooo0?ooo`0?0?ooo`030000003oool0oooo01X0oooo00<000000?ooo`3oool0;P3o
ool00`000000oooo0?ooo`1@0?ooo`8000003`3oool00`000000oooo0?ooo`1`0?ooo`030000003o
ool0oooo03/0oooo00<000000?ooo`3oool0AP3oool004L0oooo00<000000?ooo`3oool0<P3oool0
0`000000oooo0?ooo`0/0?ooo`030000003oool0oooo00l0oooo00<000000?ooo`3oool06P3oool0
0`000000oooo0?ooo`0_0?ooo`030000003oool0oooo0540oooo00<000000?ooo`3oool0303oool0
0`000000oooo0?ooo`1a0?ooo`030000003oool0oooo03/0oooo00<000000?ooo`3oool0A@3oool0
04H0oooo00<000000?ooo`3oool0<P3oool00`000000oooo0?ooo`0]0?ooo`030000003oool0oooo
00l0oooo00<000000?ooo`3oool06P3oool00`000000oooo0?ooo`0`0?ooo`030000003oool0oooo
0540oooo0P00000;0?ooo`030000003oool0oooo0780oooo00<000000?ooo`3oool0>`3oool00`00
0000oooo0?ooo`150?ooo`00AP3oool00`000000oooo0?ooo`0a0?ooo`030000003oool0oooo02d0
oooo00<000000?ooo`3oool0403oool00`000000oooo0?ooo`0K0?ooo`030000003oool0oooo0300
oooo00<000000?ooo`3oool0DP3oool2000000H0oooo0P0000000`3oool000000?ooo`1d0?ooo`03
0000003oool0oooo03/0oooo00<000000?ooo`3oool0A03oool004D0oooo00<000000?ooo`3oool0
<P3oool00`000000oooo0?ooo`0]0?ooo`030000003oool0oooo0100oooo00<000000?ooo`3oool0
6`3oool00`000000oooo0?ooo`0a0?ooo`030000003oool0oooo05<0oooo00<000000?ooo`3oool0
2000001d0?ooo`030000003oool0oooo03/0oooo00<000000?ooo`3oool0A03oool004D0oooo00<0
00000?ooo`3oool0<@3oool00`000000oooo0?ooo`0^0?ooo`030000003oool0oooo0100oooo00<0
00000?ooo`3oool06`3oool00`000000oooo0?ooo`0a0?ooo`030000003oool0oooo05@0oooo2`00
001d0?ooo`030000003oool0oooo03/0oooo00<000000?ooo`3oool0@`3oool004@0oooo00<00000
0?ooo`3oool0<@3oool00`000000oooo0?ooo`0_0?ooo`030000003oool0oooo0100oooo00<00000
0?ooo`3oool0703oool00`000000oooo0?ooo`0a0?ooo`030000003oool0oooo05@0oooo2P00001e
0?ooo`030000003oool0oooo03X0oooo00<000000?ooo`3oool0@`3oool004@0oooo00<000000?oo
o`3oool0<@3oool00`000000oooo0?ooo`0_0?ooo`030000003oool0oooo0140oooo00<000000?oo
o`3oool06`3oool00`000000oooo0?ooo`0b0?ooo`030000003oool0oooo05<0oooo2P00001e0?oo
o`030000003oool0oooo03/0oooo00<000000?ooo`3oool0@P3oool004<0oooo00<000000?ooo`3o
ool0<@3oool00`000000oooo0?ooo`0`0?ooo`030000003oool0oooo0140oooo00<000000?ooo`3o
ool06`3oool00`000000oooo0?ooo`0c0?ooo`030000003oool0oooo0540oooo3000001e0?ooo`03
0000003oool0oooo03X0oooo00<000000?ooo`3oool0@P3oool004<0oooo00<000000?ooo`3oool0
<03oool00`000000oooo0?ooo`0a0?ooo`030000003oool0oooo0140oooo00<000000?ooo`3oool0
703oool00`000000oooo0?ooo`0c0?ooo`030000003oool0oooo04h0oooo3P00001e0?ooo`030000
003oool0oooo03/0oooo00<000000?ooo`3oool0@@3oool00480oooo00<000000?ooo`3oool0<@3o
ool00`000000oooo0?ooo`0`0?ooo`030000003oool0oooo0180oooo00<000000?ooo`3oool0703o
ool00`000000oooo0?ooo`0d0?ooo`030000003oool0oooo04P0oooo1@0000030?ooo`/00000MP3o
ool00`000000oooo0?ooo`0j0?ooo`030000003oool0oooo0440oooo00120?ooo`030000003oool0
oooo0300oooo00<000000?ooo`3oool0<@3oool00`000000oooo0?ooo`0B0?ooo`030000003oool0
oooo01`0oooo00<000000?ooo`3oool0=@3oool00`000000oooo0?ooo`110?ooo`H00000203oool:
000000030?ooo`000000000007@0oooo00<000000?ooo`3oool0>`3oool00`000000oooo0?ooo`10
0?ooo`00@@3oool00`000000oooo0?ooo`0a0?ooo`030000003oool0oooo0340oooo00<000000?oo
o`3oool04P3oool00`000000oooo0?ooo`0M0?ooo`030000003oool0oooo03@0oooo00<000000?oo
o`3oool0>`3oool6000000h0oooo2P0000030?ooo`800000L`3oool00`000000oooo0?ooo`0j0?oo
o`030000003oool0oooo0400oooo00110?ooo`030000003oool0oooo0300oooo00<000000?ooo`3o
ool0<P3oool00`000000oooo0?ooo`0B0?ooo`030000003oool0oooo01d0oooo00<000000?ooo`3o
ool0=@3oool00`000000oooo0?ooo`0e0?ooo`D000005@3oool9000000D0oooo0P00001a0?ooo`03
0000003oool0oooo03/0oooo00<000000?ooo`3oool0?`3oool00400oooo00<000000?ooo`3oool0
<03oool00`000000oooo0?ooo`0c0?ooo`030000003oool0oooo0180oooo00<000000?ooo`3oool0
7@3oool00`000000oooo0?ooo`0f0?ooo`030000003oool0oooo02h0oooo1P00000M0?ooo`800000
103oool00`000000oooo0?ooo`040?ooo`800000L03oool00`000000oooo0?ooo`0j0?ooo`030000
003oool0oooo03l0oooo00100?ooo`030000003oool0oooo0300oooo00<000000?ooo`3oool0<`3o
ool00`000000oooo0?ooo`0B0?ooo`030000003oool0oooo01h0oooo00<000000?ooo`3oool0=P3o
ool00`000000oooo0?ooo`0X0?ooo`D000008`3oool00`000000oooo0?ooo`040?ooo`030000003o
ool0oooo00D0oooo0P00001_0?ooo`030000003oool0oooo03X0oooo00<000000?ooo`3oool0?P3o
ool003l0oooo00<000000?ooo`3oool0<03oool00`000000oooo0?ooo`0c0?ooo`030000003oool0
oooo01<0oooo00<000000?ooo`3oool07P3oool00`000000oooo0?ooo`0g0?ooo`030000003oool0
oooo0080oooo0P00000M0?ooo`H00000:03oool00`000000oooo0?ooo`050?ooo`030000003oool0
oooo00H0oooo0P00001]0?ooo`030000003oool0oooo03X0oooo00<000000?ooo`3oool0?P3oool0
03l0oooo00<000000?ooo`3oool0;`3oool00`000000oooo0?ooo`0d0?ooo`030000003oool0oooo
01<0oooo00<000000?ooo`3oool07P3oool00`000000oooo0?ooo`0h0?ooo`T000005@3oool50000
02h0oooo00<000000?ooo`3oool01P3oool00`000000oooo0?ooo`070?ooo`<00000J`3oool00`00
0000oooo0?ooo`0j0?ooo`030000003oool0oooo03d0oooo000n0?ooo`030000003oool0oooo0300
oooo00<000000?ooo`3oool0=03oool00`000000oooo0?ooo`0C0?ooo`030000003oool0oooo01l0
oooo00<000000?ooo`3oool0=`3oool:000000h0oooo1P00000b0?ooo`030000003oool0oooo00P0
oooo00<000000?ooo`3oool02@3oool2000006T0oooo00<000000?ooo`3oool0>P3oool00`000000
oooo0?ooo`0m0?ooo`00?P3oool00`000000oooo0?ooo`0_0?ooo`030000003oool0oooo03D0oooo
00<000000?ooo`3oool04`3oool00`000000oooo0?ooo`0O0?ooo`030000003oool0oooo03L0oooo
2P0000080?ooo`H00000>03oool00`000000oooo0?ooo`090?ooo`030000003oool0oooo00X0oooo
0P00001X0?ooo`030000003oool0oooo03X0oooo00<000000?ooo`3oool0?03oool003d0oooo00<0
00000?ooo`3oool0;`3oool00`000000oooo0?ooo`0f0?ooo`030000003oool0oooo01<0oooo00<0
00000?ooo`3oool07`3oool00`000000oooo0?ooo`0g0?ooo`X000000`3oool5000003h0oooo00<0
00000?ooo`3oool02P3oool00`000000oooo0?ooo`0;0?ooo`800000IP3oool00`000000oooo0?oo
o`0j0?ooo`030000003oool0oooo03`0oooo000m0?ooo`030000003oool0oooo02l0oooo00<00000
0?ooo`3oool0=P3oool00`000000oooo0?ooo`0C0?ooo`030000003oool0oooo0200oooo00<00000
0?ooo`3oool0=@3oool>000004<0oooo00<000000?ooo`3oool02`3oool00`000000oooo0?ooo`0<
0?ooo`800000I@3oool00`000000oooo0?ooo`0j0?ooo`030000003oool0oooo03/0oooo000l0?oo
o`030000003oool0oooo02l0oooo00<000000?ooo`3oool0=`3oool00`000000oooo0?ooo`0C0?oo
o`030000003oool0oooo0200oooo00<000000?ooo`3oool0=@3oool<000004D0oooo00<000000?oo
o`3oool0303oool00`000000oooo0?ooo`0=0?ooo`800000I03oool00`000000oooo0?ooo`0i0?oo
o`030000003oool0oooo03/0oooo000l0?ooo`030000003oool0oooo02l0oooo00<000000?ooo`3o
ool0=P3oool00`000000oooo0?ooo`0D0?ooo`030000003oool0oooo0200oooo00<000000?ooo`3o
ool0=P3oool:000004H0oooo00<000000?ooo`3oool0303oool00`000000oooo0?ooo`0?0?ooo`80
0000HP3oool00`000000oooo0?ooo`0j0?ooo`030000003oool0oooo03X0oooo000k0?ooo`030000
003oool0oooo02l0oooo00<000000?ooo`3oool0=`3oool00`000000oooo0?ooo`0D0?ooo`030000
003oool0oooo0240oooo00<000000?ooo`3oool0=@3oool:000004D0oooo00<000000?ooo`3oool0
3P3oool00`000000oooo0?ooo`0@0?ooo`800000H@3oool00`000000oooo0?ooo`0i0?ooo`030000
003oool0oooo03X0oooo000k0?ooo`030000003oool0oooo02h0oooo00<000000?ooo`3oool0>03o
ool00`000000oooo0?ooo`0D0?ooo`030000003oool0oooo0240oooo00<000000?ooo`3oool0=@3o
ool:000004D0oooo00<000000?ooo`3oool03`3oool00`000000oooo0?ooo`0A0?ooo`800000G`3o
ool00`000000oooo0?ooo`0j0?ooo`030000003oool0oooo03T0oooo000j0?ooo`030000003oool0
oooo02l0oooo00<000000?ooo`3oool0>03oool00`000000oooo0?ooo`0D0?ooo`030000003oool0
oooo0240oooo00<000000?ooo`3oool0=P3oool8000004H0oooo00<000000?ooo`3oool0403oool0
0`000000oooo0?ooo`0B0?ooo`<00000G@3oool00`000000oooo0?ooo`0i0?ooo`030000003oool0
oooo03T0oooo000j0?ooo`030000003oool0oooo02h0oooo00<000000?ooo`3oool0>@3oool00`00
0000oooo0?ooo`0D0?ooo`030000003oool0oooo0280oooo00<000000?ooo`3oool0=@3oool00`00
0000oooo0?ooo`02000000<0oooo00<000000?ooo`3oool0@`3oool00`000000oooo0?ooo`0A0?oo
o`030000003oool0oooo01@0oooo0P00001K0?ooo`030000003oool0oooo03X0oooo00<000000?oo
o`3oool0>03oool003T0oooo00<000000?ooo`3oool0;P3oool00`000000oooo0?ooo`0j0?ooo`03
0000003oool0oooo01@0oooo00<000000?ooo`3oool08P3oool00`000000oooo0?ooo`0d0?ooo`03
0000003oool0oooo00L0oooo00<000000?ooo`3oool0@P3oool00`000000oooo0?ooo`0B0?ooo`03
0000003oool0oooo01D0oooo0P00001J0?ooo`030000003oool0oooo03T0oooo00<000000?ooo`3o
ool0>03oool003T0oooo00<000000?ooo`3oool0;P3oool00`000000oooo0?ooo`0j0?ooo`030000
003oool0oooo01@0oooo00<000000?ooo`3oool08P3oool00`000000oooo0?ooo`0d0?ooo`030000
003oool0oooo00P0oooo00<000000?ooo`3oool0@@3oool00`000000oooo0?ooo`0C0?ooo`030000
003oool0oooo01H0oooo0P00001H0?ooo`030000003oool0oooo03X0oooo00<000000?ooo`3oool0
=`3oool003P0oooo00<000000?ooo`3oool0;P3oool00`000000oooo0?ooo`0j0?ooo`030000003o
ool0oooo01H0oooo00<000000?ooo`3oool08P3oool00`000000oooo0?ooo`0b0?ooo`030000003o
ool0oooo00X0oooo00<000000?ooo`3oool0?`3oool00`000000oooo0?ooo`0E0?ooo`030000003o
ool0oooo01L0oooo0P00001G0?ooo`030000003oool0oooo03T0oooo00<000000?ooo`3oool0=`3o
ool003P0oooo00<000000?ooo`3oool0;@3oool00`000000oooo0?ooo`0k0?ooo`030000003oool0
oooo01H0oooo00<000000?ooo`3oool08P3oool00`000000oooo0?ooo`0b0?ooo`030000003oool0
oooo00/0oooo00<000000?ooo`3oool0?P3oool00`000000oooo0?ooo`0F0?ooo`030000003oool0
oooo01P0oooo0P00001F0?ooo`030000003oool0oooo03T0oooo00<000000?ooo`3oool0=P3oool0
03L0oooo00<000000?ooo`3oool0;P3oool00`000000oooo0?ooo`0k0?ooo`030000003oool0oooo
01H0oooo00<000000?ooo`3oool08P3oool00`000000oooo0?ooo`0a0?ooo`030000003oool0oooo
00d0oooo00<000000?ooo`3oool0?@3oool00`000000oooo0?ooo`0G0?ooo`030000003oool0oooo
01T0oooo0P00001D0?ooo`030000003oool0oooo03T0oooo00<000000?ooo`3oool0=P3oool003L0
oooo00<000000?ooo`3oool0;@3oool00`000000oooo0?ooo`0l0?ooo`030000003oool0oooo01H0
oooo00<000000?ooo`3oool08`3oool00`000000oooo0?ooo`0_0?ooo`030000003oool0oooo00l0
oooo00<000000?ooo`3oool0?03oool00`000000oooo0?ooo`0G0?ooo`030000003oool0oooo01/0
oooo0P00001C0?ooo`030000003oool0oooo03T0oooo00<000000?ooo`3oool0=@3oool003H0oooo
00<000000?ooo`3oool0;P3oool00`000000oooo0?ooo`0l0?ooo`030000003oool0oooo01H0oooo
00<000000?ooo`3oool08`3oool00`000000oooo0?ooo`0_0?ooo`030000003oool0oooo0100oooo
00<000000?ooo`3oool0>`3oool00`000000oooo0?ooo`0H0?ooo`030000003oool0oooo01`0oooo
0`00001@0?ooo`030000003oool0oooo03T0oooo00<000000?ooo`3oool0=@3oool003H0oooo00<0
00000?ooo`3oool0;@3oool00`000000oooo0?ooo`0m0?ooo`030000003oool0oooo01H0oooo00<0
00000?ooo`3oool08`3oool00`000000oooo0?ooo`0^0?ooo`030000003oool0oooo0180oooo00<0
00000?ooo`3oool0>P3oool00`000000oooo0?ooo`0I0?ooo`030000003oool0oooo01h0oooo0P00
001?0?ooo`030000003oool0oooo03T0oooo00<000000?ooo`3oool0=03oool003D0oooo00<00000
0?ooo`3oool0;@3oool00`000000oooo0?ooo`0n0?ooo`030000003oool0oooo01H0oooo00<00000
0?ooo`3oool0903oool00`000000oooo0?ooo`0]0?ooo`030000003oool0oooo01<0oooo00<00000
0?ooo`3oool0>03oool00`000000oooo0?ooo`0K0?ooo`030000003oool0oooo01l0oooo0P00001=
0?ooo`030000003oool0oooo03T0oooo00<000000?ooo`3oool0=03oool003D0oooo00<000000?oo
o`3oool0;@3oool00`000000oooo0?ooo`0m0?ooo`030000003oool0oooo01L0oooo00<000000?oo
o`3oool0903oool00`000000oooo0?ooo`0/0?ooo`030000003oool0oooo01D0oooo00<000000?oo
o`3oool0=`3oool00`000000oooo0?ooo`0L0?ooo`030000003oool0oooo0200oooo0P00001<0?oo
o`030000003oool0oooo03T0oooo00<000000?ooo`3oool0<`3oool003@0oooo00<000000?ooo`3o
ool0;@3oool00`000000oooo0?ooo`0n0?ooo`030000003oool0oooo01L0oooo00<000000?ooo`3o
ool0903oool00`000000oooo0?ooo`0[0?ooo`030000003oool0oooo01L0oooo00<000000?ooo`3o
ool0=P3oool00`000000oooo0?ooo`0M0?ooo`030000003oool0oooo0240oooo0P00001;0?ooo`03
0000003oool0oooo03P0oooo00<000000?ooo`3oool0<`3oool003@0oooo00<000000?ooo`3oool0
;03oool00`000000oooo0?ooo`0o0?ooo`030000003oool0oooo01L0oooo00<000000?ooo`3oool0
9@3oool00`000000oooo0?ooo`0Z0?ooo`030000003oool0oooo01P0oooo00<000000?ooo`3oool0
=@3oool00`000000oooo0?ooo`0N0?ooo`030000003oool0oooo0280oooo0P0000190?ooo`030000
003oool0oooo03T0oooo00<000000?ooo`3oool0<P3oool003<0oooo00<000000?ooo`3oool0;@3o
ool00`000000oooo0?ooo`0o0?ooo`030000003oool0oooo01L0oooo00<000000?ooo`3oool09@3o
ool00`000000oooo0?ooo`0Y0?ooo`030000003oool0oooo01X0oooo00<000000?ooo`3oool0=03o
ool00`000000oooo0?ooo`0O0?ooo`030000003oool0oooo02<0oooo0P0000180?ooo`030000003o
ool0oooo03P0oooo00<000000?ooo`3oool0<P3oool003<0oooo00<000000?ooo`3oool0;03oool0
0`000000oooo0?ooo`100?ooo`030000003oool0oooo01L0oooo00<000000?ooo`3oool09@3oool0
0`000000oooo0?ooo`0Y0?ooo`030000003oool0oooo01/0oooo00<000000?ooo`3oool0<`3oool0
0`000000oooo0?ooo`0P0?ooo`030000003oool0oooo02@0oooo0P0000160?ooo`030000003oool0
oooo03T0oooo00<000000?ooo`3oool0<@3oool00380oooo00<000000?ooo`3oool0;@3oool00`00
0000oooo0?ooo`100?ooo`030000003oool0oooo01L0oooo00<000000?ooo`3oool09P3oool00`00
0000oooo0?ooo`0W0?ooo`030000003oool0oooo01d0oooo00<000000?ooo`3oool0<@3oool00`00
0000oooo0?ooo`0R0?ooo`030000003oool0oooo02D0oooo0P0000150?ooo`030000003oool0oooo
03P0oooo00<000000?ooo`3oool0<@3oool00380oooo00<000000?ooo`3oool0;03oool00`000000
oooo0?ooo`100?ooo`030000003oool0oooo01P0oooo00<000000?ooo`3oool09P3oool00`000000
oooo0?ooo`0V0?ooo`030000003oool0oooo01l0oooo00<000000?ooo`3oool0<03oool00`000000
oooo0?ooo`0R0?ooo`030000003oool0oooo02L0oooo0`0000120?ooo`030000003oool0oooo03T0
oooo00<000000?ooo`3oool0<03oool00340oooo00<000000?ooo`3oool0;03oool00`000000oooo
0?ooo`110?ooo`030000003oool0oooo01P0oooo00<000000?ooo`3oool09P3oool00`000000oooo
0?ooo`0V0?ooo`030000003oool0oooo0200oooo00<000000?ooo`3oool0;`3oool00`000000oooo
0?ooo`0S0?ooo`030000003oool0oooo02T0oooo0P0000110?ooo`030000003oool0oooo03P0oooo
00<000000?ooo`3oool0<03oool00340oooo00<000000?ooo`3oool0;03oool00`000000oooo0?oo
o`110?ooo`030000003oool0oooo01P0oooo00<000000?ooo`3oool09`3oool00`000000oooo0?oo
o`0T0?ooo`030000003oool0oooo0280oooo00<000000?ooo`3oool0;P3oool00`000000oooo0?oo
o`0T0?ooo`030000003oool0oooo02X0oooo0P00000o0?ooo`030000003oool0oooo03T0oooo00<0
00000?ooo`3oool0;`3oool00300oooo00<000000?ooo`3oool0;03oool00`000000oooo0?ooo`12
0?ooo`030000003oool0oooo01P0oooo00<000000?ooo`3oool09`3oool00`000000oooo0?ooo`0T
0?ooo`030000003oool0oooo02<0oooo00<000000?ooo`3oool0;@3oool00`000000oooo0?ooo`0U
0?ooo`030000003oool0oooo02/0oooo0P00000n0?ooo`030000003oool0oooo03P0oooo00<00000
0?ooo`3oool0;`3oool00300oooo00<000000?ooo`3oool0:`3oool00`000000oooo0?ooo`130?oo
o`030000003oool0oooo01P0oooo00<000000?ooo`3oool09`3oool00`000000oooo0?ooo`0S0?oo
o`030000003oool0oooo02D0oooo00<000000?ooo`3oool0;03oool00`000000oooo0?ooo`0V0?oo
o`030000003oool0oooo02`0oooo0P00000m0?ooo`030000003oool0oooo03P0oooo00<000000?oo
o`3oool0;P3oool002l0oooo00<000000?ooo`3oool0;03oool00`000000oooo0?ooo`130?ooo`03
0000003oool0oooo01P0oooo00<000000?ooo`3oool0:03oool00`000000oooo0?ooo`0Q0?ooo`03
0000003oool0oooo02L0oooo00<000000?ooo`3oool0:P3oool00`000000oooo0?ooo`0X0?ooo`03
0000003oool0oooo02d0oooo0P00000k0?ooo`030000003oool0oooo03P0oooo00<000000?ooo`3o
ool0;P3oool002l0oooo00<000000?ooo`3oool0:`3oool00`000000oooo0?ooo`140?ooo`030000
003oool0oooo01P0oooo00<000000?ooo`3oool0:03oool00`000000oooo0?ooo`0Q0?ooo`030000
003oool0oooo02P0oooo00<000000?ooo`3oool0:@3oool00`000000oooo0?ooo`0Y0?ooo`030000
003oool0oooo02h0oooo0P00000j0?ooo`030000003oool0oooo03P0oooo00<000000?ooo`3oool0
;@3oool002h0oooo00<000000?ooo`3oool0:`3oool00`000000oooo0?ooo`140?ooo`030000003o
ool0oooo01T0oooo00<000000?ooo`3oool0:03oool00`000000oooo0?ooo`0P0?ooo`030000003o
ool0oooo02X0oooo00<000000?ooo`3oool0:03oool00`000000oooo0?ooo`0Z0?ooo`030000003o
ool0oooo02l0oooo0P00000h0?ooo`030000003oool0oooo03P0oooo00<000000?ooo`3oool0;@3o
ool002h0oooo00<000000?ooo`3oool0:`3oool00`000000oooo0?ooo`140?ooo`030000003oool0
oooo01T0oooo00<000000?ooo`3oool0:@3oool00`000000oooo0?ooo`0O0?ooo`030000003oool0
oooo02/0oooo00<000000?ooo`3oool09`3oool00`000000oooo0?ooo`0[0?ooo`030000003oool0
oooo0300oooo0P00000g0?ooo`030000003oool0oooo03P0oooo00<000000?ooo`3oool0;03oool0
02d0oooo00<000000?ooo`3oool0:`3oool00`000000oooo0?ooo`150?ooo`030000003oool0oooo
01T0oooo00<000000?ooo`3oool0:@3oool00`000000oooo0?ooo`0N0?ooo`030000003oool0oooo
02d0oooo00<000000?ooo`3oool09P3oool00`000000oooo0?ooo`0/0?ooo`030000003oool0oooo
0340oooo0`00000d0?ooo`030000003oool0oooo03P0oooo00<000000?ooo`3oool0;03oool002d0
oooo00<000000?ooo`3oool0:`3oool00`000000oooo0?ooo`150?ooo`030000003oool0oooo01X0
oooo00<000000?ooo`3oool0:03oool00`000000oooo0?ooo`0M0?ooo`030000003oool0oooo02l0
oooo00<000000?ooo`3oool09@3oool00`000000oooo0?ooo`0/0?ooo`030000003oool0oooo03@0
oooo0P00000c0?ooo`030000003oool0oooo03P0oooo00<000000?ooo`3oool0:`3oool002`0oooo
00<000000?ooo`3oool0:`3oool00`000000oooo0?ooo`160?ooo`030000003oool0oooo01X0oooo
00<000000?ooo`3oool0:@3oool00`000000oooo0?ooo`0L0?ooo`030000003oool0oooo0300oooo
00<000000?ooo`3oool08`3oool00`000000oooo0?ooo`0^0?ooo`030000003oool0oooo03D0oooo
0P00000a0?ooo`030000003oool0oooo03P0oooo00<000000?ooo`3oool0:`3oool002`0oooo00<0
00000?ooo`3oool0:P3oool00`000000oooo0?ooo`170?ooo`030000003oool0oooo01X0oooo00<0
00000?ooo`3oool0:@3oool00`000000oooo0?ooo`0K0?ooo`030000003oool0oooo0380oooo00<0
00000?ooo`3oool08P3oool00`000000oooo0?ooo`0_0?ooo`030000003oool0oooo03H0oooo0P00
000`0?ooo`030000003oool0oooo03P0oooo00<000000?ooo`3oool0:P3oool002/0oooo00<00000
0?ooo`3oool0:`3oool00`000000oooo0?ooo`170?ooo`030000003oool0oooo01X0oooo00<00000
0?ooo`3oool0:@3oool00`000000oooo0?ooo`0K0?ooo`030000003oool0oooo03<0oooo00<00000
0?ooo`3oool08@3oool00`000000oooo0?ooo`0`0?ooo`030000003oool0oooo03L0oooo0P00000_
0?ooo`030000003oool0oooo03L0oooo00<000000?ooo`3oool0:P3oool002/0oooo00<000000?oo
o`3oool0:P3oool00`000000oooo0?ooo`170?ooo`030000003oool0oooo01/0oooo00<000000?oo
o`3oool0:P3oool00`000000oooo0?ooo`0I0?ooo`030000003oool0oooo03D0oooo00<000000?oo
o`3oool0803oool00`000000oooo0?ooo`0a0?ooo`030000003oool0oooo03P0oooo0P00000]0?oo
o`030000003oool0oooo03P0oooo00<000000?ooo`3oool0:@3oool002X0oooo00<000000?ooo`3o
ool0:P3oool00`000000oooo0?ooo`180?ooo`030000003oool0oooo01/0oooo00<000000?ooo`3o
ool0:P3oool00`000000oooo0?ooo`0H0?ooo`030000003oool0oooo03L0oooo00<000000?ooo`3o
ool07`3oool00`000000oooo0?ooo`0b0?ooo`030000003oool0oooo03T0oooo0P00000/0?ooo`03
0000003oool0oooo03L0oooo00<000000?ooo`3oool0:@3oool002X0oooo00<000000?ooo`3oool0
:P3oool00`000000oooo0?ooo`180?ooo`030000003oool0oooo01/0oooo00<000000?ooo`3oool0
:`3oool00`000000oooo0?ooo`0G0?ooo`030000003oool0oooo03P0oooo00<000000?ooo`3oool0
7P3oool00`000000oooo0?ooo`0c0?ooo`030000003oool0oooo03X0oooo0P00000Z0?ooo`030000
003oool0oooo03P0oooo00<000000?ooo`3oool0:03oool002T0oooo00<000000?ooo`3oool0:P3o
ool00`000000oooo0?ooo`190?ooo`030000003oool0oooo01/0oooo00<000000?ooo`3oool0:`3o
ool00`000000oooo0?ooo`0F0?ooo`030000003oool0oooo03X0oooo00<000000?ooo`3oool0703o
ool00`000000oooo0?ooo`0e0?ooo`030000003oool0oooo03/0oooo0P00000Y0?ooo`030000003o
ool0oooo03L0oooo00<000000?ooo`3oool0:03oool002T0oooo00<000000?ooo`3oool0:@3oool0
0`000000oooo0?ooo`1:0?ooo`030000003oool0oooo01/0oooo00<000000?ooo`3oool0:`3oool0
0`000000oooo0?ooo`0F0?ooo`030000003oool0oooo03/0oooo00<000000?ooo`3oool06`3oool0
0`000000oooo0?ooo`0f0?ooo`030000003oool0oooo03`0oooo0`00000V0?ooo`030000003oool0
oooo03P0oooo00<000000?ooo`3oool09`3oool002P0oooo00<000000?ooo`3oool0:P3oool00`00
0000oooo0?ooo`1:0?ooo`030000003oool0oooo01/0oooo00<000000?ooo`3oool0;03oool00`00
0000oooo0?ooo`0D0?ooo`030000003oool0oooo03d0oooo00<000000?ooo`3oool06P3oool00`00
0000oooo0?ooo`0g0?ooo`040000003oool0oooo0?ooo`800000>`3oool2000002D0oooo00<00000
0?ooo`3oool0=`3oool00`000000oooo0?ooo`0W0?ooo`00:03oool00`000000oooo0?ooo`0Y0?oo
o`030000003oool0oooo04/0oooo00<000000?ooo`3oool06`3oool00`000000oooo0?ooo`0/0?oo
o`030000003oool0oooo01<0oooo00<000000?ooo`3oool0?`3oool00`000000oooo0?ooo`0I0?oo
o`030000003oool0oooo03L0oooo2@00000j0?ooo`800000903oool00`000000oooo0?ooo`0g0?oo
o`030000003oool0oooo02H0oooo000W0?ooo`030000003oool0oooo02X0oooo00<000000?ooo`3o
ool0BP3oool00`000000oooo0?ooo`0L0?ooo`030000003oool0oooo02`0oooo00<000000?ooo`3o
ool04`3oool00`000000oooo0?ooo`100?ooo`030000003oool0oooo01P0oooo00<000000?ooo`3o
ool0=`3oool:000003/0oooo0P00000R0?ooo`030000003oool0oooo03L0oooo00<000000?ooo`3o
ool09P3oool002L0oooo00<000000?ooo`3oool0:@3oool00`000000oooo0?ooo`1;0?ooo`030000
003oool0oooo01`0oooo00<000000?ooo`3oool0;@3oool00`000000oooo0?ooo`0A0?ooo`030000
003oool0oooo0480oooo00<000000?ooo`3oool05`3oool00`000000oooo0?ooo`0g0?ooo`X00000
?@3oool200000240oooo00<000000?ooo`3oool0=`3oool00`000000oooo0?ooo`0U0?ooo`009P3o
ool00`000000oooo0?ooo`0Y0?ooo`030000003oool0oooo04`0oooo00<000000?ooo`3oool0703o
ool00`000000oooo0?ooo`0]0?ooo`030000003oool0oooo0140oooo00<000000?ooo`3oool0@`3o
ool00`000000oooo0?ooo`0E0?ooo`030000003oool0oooo03P0oooo2P00000o0?ooo`8000007`3o
ool00`000000oooo0?ooo`0g0?ooo`030000003oool0oooo02D0oooo000V0?ooo`030000003oool0
oooo02T0oooo00<000000?ooo`3oool0C03oool00`000000oooo0?ooo`0L0?ooo`030000003oool0
oooo02d0oooo00<000000?ooo`3oool0403oool00`000000oooo0?ooo`150?ooo`030000003oool0
oooo01@0oooo00<000000?ooo`3oool0=`3oool<00000400oooo0P00000N0?ooo`030000003oool0
oooo03L0oooo00<000000?ooo`3oool0903oool002D0oooo00<000000?ooo`3oool0:@3oool00`00
0000oooo0?ooo`1=0?ooo`030000003oool0oooo01`0oooo00<000000?ooo`3oool0;P3oool00`00
0000oooo0?ooo`0>0?ooo`030000003oool0oooo04L0oooo00<000000?ooo`3oool04`3oool00`00
0000oooo0?ooo`0g0?ooo``00000@P3oool2000001`0oooo00<000000?ooo`3oool0=`3oool00`00
0000oooo0?ooo`0T0?ooo`009@3oool00`000000oooo0?ooo`0X0?ooo`030000003oool0oooo04h0
oooo00<000000?ooo`3oool0703oool00`000000oooo0?ooo`0^0?ooo`030000003oool0oooo00h0
oooo00<000000?ooo`3oool0B03oool00`000000oooo0?ooo`0B0?ooo`030000003oool0oooo03P0
oooo3P0000110?ooo`<000006P3oool00`000000oooo0?ooo`0g0?ooo`030000003oool0oooo02<0
oooo000T0?ooo`030000003oool0oooo02T0oooo00<000000?ooo`3oool0CP3oool00`000000oooo
0?ooo`0L0?ooo`030000003oool0oooo02h0oooo00<000000?ooo`3oool03@3oool00`000000oooo
0?ooo`1:0?ooo`030000003oool0oooo0140oooo00<000000?ooo`3oool0=@3oool=000000@0oooo
1P00000n0?ooo`800000603oool00`000000oooo0?ooo`0g0?ooo`030000003oool0oooo02<0oooo
000T0?ooo`030000003oool0oooo02P0oooo00<000000?ooo`3oool0CP3oool00`000000oooo0?oo
o`0M0?ooo`030000003oool0oooo02l0oooo00<000000?ooo`3oool0303oool00`000000oooo0?oo
o`1;0?ooo`030000003oool0oooo0100oooo00<000000?ooo`3oool0<@3oool4000000<0oooo2P00
000:0?ooo`H00000>P3oool2000001L0oooo00<000000?ooo`3oool0=`3oool00`000000oooo0?oo
o`0R0?ooo`008`3oool00`000000oooo0?ooo`0Y0?ooo`030000003oool0oooo04h0oooo00<00000
0?ooo`3oool07@3oool00`000000oooo0?ooo`0_0?ooo`030000003oool0oooo00/0oooo00<00000
0?ooo`3oool0C@3oool00`000000oooo0?ooo`0>0?ooo`030000003oool0oooo02l0oooo0`000008
0?ooo`P000004@3oool6000003H0oooo0P00000F0?ooo`030000003oool0oooo03H0oooo00<00000
0?ooo`3oool08P3oool002<0oooo00<000000?ooo`3oool0:03oool00`000000oooo0?ooo`1?0?oo
o`030000003oool0oooo01d0oooo00<000000?ooo`3oool0;`3oool00`000000oooo0?ooo`0:0?oo
o`030000003oool0oooo04l0oooo00<000000?ooo`3oool03@3oool00`000000oooo0?ooo`0[0?oo
o`@000003P3oool200000080oooo00<000000?ooo`3oool05@3oool600000380oooo0P00000D0?oo
o`030000003oool0oooo03L0oooo00<000000?ooo`3oool08@3oool00280oooo00<000000?ooo`3o
ool0:03oool00`000000oooo0?ooo`1@0?ooo`030000003oool0oooo01d0oooo00<000000?ooo`3o
ool0<03oool00`000000oooo0?ooo`090?ooo`030000003oool0oooo0500oooo00<000000?ooo`3o
ool0303oool00`000000oooo0?ooo`0X0?ooo`<000005P3oool00`000000oooo0?ooo`0K0?ooo`H0
0000;P3oool2000001<0oooo00<000000?ooo`3oool0=P3oool00`000000oooo0?ooo`0Q0?ooo`00
8P3oool00`000000oooo0?ooo`0X0?ooo`030000003oool0oooo0500oooo00<000000?ooo`3oool0
7@3oool00`000000oooo0?ooo`0`0?ooo`030000003oool0oooo00P0oooo00<000000?ooo`3oool0
DP3oool00`000000oooo0?ooo`0;0?ooo`030000003oool0oooo02@0oooo1000000J0?ooo`030000
003oool0oooo0200oooo1P00000Z0?ooo`8000004@3oool00`000000oooo0?ooo`0g0?ooo`030000
003oool0oooo0200oooo000Q0?ooo`030000003oool0oooo02P0oooo00<000000?ooo`3oool0D@3o
ool00`000000oooo0?ooo`0N0?ooo`030000003oool0oooo02l0oooo00<000000?ooo`3oool0203o
ool00`000000oooo0?ooo`1C0?ooo`030000003oool0oooo00X0oooo00<000000?ooo`3oool08@3o
ool3000001l0oooo00<000000?ooo`3oool09@3oool6000002H0oooo0P00000@0?ooo`030000003o
ool0oooo03H0oooo00<000000?ooo`3oool0803oool00240oooo00<000000?ooo`3oool09`3oool0
0`000000oooo0?ooo`1A0?ooo`030000003oool0oooo01l0oooo00<000000?ooo`3oool0<03oool0
0`000000oooo0?ooo`060?ooo`030000003oool0oooo05D0oooo00<000000?ooo`3oool02@3oool0
0`000000oooo0?ooo`0M0?ooo`@000008P3oool00`000000oooo0?ooo`0[0?ooo`H000008P3oool2
000000h0oooo00<000000?ooo`3oool0=`3oool00`000000oooo0?ooo`0O0?ooo`00803oool00`00
0000oooo0?ooo`0X0?ooo`030000003oool0oooo0540oooo00<000000?ooo`3oool07`3oool00`00
0000oooo0?ooo`0`0?ooo`030000003oool0oooo00D0oooo00<000000?ooo`3oool0E`3oool00`00
0000oooo0?ooo`070?ooo`030000003oool0oooo01X0oooo1000000W0?ooo`030000003oool0oooo
0300oooo1P00000N0?ooo`<00000303oool00`000000oooo0?ooo`0f0?ooo`030000003oool0oooo
01l0oooo000P0?ooo`030000003oool0oooo02L0oooo00<000000?ooo`3oool0DP3oool00`000000
oooo0?ooo`0O0?ooo`030000003oool0oooo0300oooo00<000000?ooo`3oool01@3oool00`000000
oooo0?ooo`1H0?ooo`030000003oool0oooo00H0oooo00<000000?ooo`3oool05`3oool3000002/0
oooo00<000000?ooo`3oool0=P3oool6000001/0oooo0P00000;0?ooo`030000003oool0oooo03H0
oooo00<000000?ooo`3oool07P3oool001l0oooo00<000000?ooo`3oool09`3oool00`000000oooo
0?ooo`1C0?ooo`030000003oool0oooo01l0oooo00<000000?ooo`3oool0<@3oool00`000000oooo
0?ooo`030?ooo`030000003oool0oooo05X0oooo00<000000?ooo`3oool01@3oool00`000000oooo
0?ooo`0C0?ooo`@00000;`3oool00`000000oooo0?ooo`0k0?ooo`H000005`3oool2000000T0oooo
00<000000?ooo`3oool0=P3oool00`000000oooo0?ooo`0N0?ooo`007`3oool00`000000oooo0?oo
o`0W0?ooo`030000003oool0oooo05<0oooo00<000000?ooo`3oool07`3oool00`000000oooo0?oo
o`0a0?ooo`030000003oool0oooo00<0oooo00<000000?ooo`3oool0F`3oool00`000000oooo0?oo
o`040?ooo`030000003oool0oooo0100oooo0`00000d0?ooo`030000003oool0oooo0400oooo1P00
000C0?ooo`800000203oool00`000000oooo0?ooo`0f0?ooo`030000003oool0oooo01d0oooo000K
0?ooo`80000000<0oooo0000003oool0903oool200000080oooo00<000000?ooo`3oool0DP3oool3
00000240oooo0P00000b0?ooo`060000003oool000000000003oool00000G`3oool010000000oooo
0?ooo`3oool3000000h0oooo1000000g0?ooo`040000003oool00000000004D0oooo1P00000?0?oo
o`8000001P3oool010000000oooo00000000000e0?ooo`040000003oool00000000001`0oooo000H
0?ooo`P000008@3oool800000540oooo2000000L0?ooo`P00000;P3oool8000005l0oooo20000009
0?ooo`<00000>P3oool8000004P0oooo1P00000;0?ooo`8000000`3oool800000340oooo2000000I
0?ooo`005`3oool:000001l0oooo2P00001?0?ooo`X000006P3oool:000002`0oooo2P00001M0?oo
o`X00000103oool4000003`0oooo2P00001=0?ooo`H000001`3oool<000002l0oooo2P00000H0?oo
o`005`3oool:000001l0oooo2P00001?0?ooo`X000006P3oool:000002`0oooo2P00001M0?ooo`X0
000000@0oooo0000000000000000@03oool:000005<0oooo1P0000030?ooo`X00000;`3oool:0000
01P0oooo000G0?ooo`X000007`3oool:000004l0oooo2P00000J0?ooo`X00000;03oool:000005d0
oooo2`0000130?ooo`X00000F@3oool=000002l0oooo2P00000H0?ooo`005P3ooooo00000?l00000
?P00000G0?ooo`005P3oool<000001d0oooo3000001=0?ooo``00000603oool<000002X0oooo3000
001K0?ooo``00000@P3oool<000005P0oooo3P00000]0?ooo``000005`3oool001L0oooo2P00000O
0?ooo`X00000C`3oool:000001X0oooo2P00000/0?ooo`X00000G@3oool:000000040?ooo`000000
000000000400oooo2P00001C0?ooo`H000000`3oool:000002l0oooo2P00000H0?ooo`005`3oool:
000001l0oooo2P00001?0?ooo`X000006P3oool:000002`0oooo2P00001M0?ooo`X00000103oool3
000003d0oooo2P00001>0?ooo`D000001`3oool<000002l0oooo2P00000H0?ooo`005`3oool:0000
01l0oooo2P00001?0?ooo`X000006P3oool:000002`0oooo2P00001M0?ooo`X000001`3oool40000
03T0oooo2P0000180?ooo`H000002P3oool200000080oooo2P00000_0?ooo`X00000603oool001P0
oooo2000000Q0?ooo`P00000D@3oool8000001`0oooo2000000^0?ooo`P00000GP3oool9000000`0
oooo0`00000g0?ooo`P00000@`3oool6000000h0oooo0P0000050?ooo`P00000<@3oool8000001T0
oooo000K0?ooo`8000000P3oool00`000000oooo0?ooo`0R0?ooo`8000000`3oool00`000000oooo
0?ooo`1A0?ooo`<000008@3oool200000380oooo00@000000?ooo`00000000000P3oool00`000000
oooo0?ooo`1K0?ooo`030000003oool0oooo0080oooo0`00000A0?ooo`<00000=@3oool010000000
oooo0000000000110?ooo`D000004P3oool2000000P0oooo00@000000?ooo`0000000000=@3oool0
10000000oooo00000000000L0?ooo`007`3oool00`000000oooo0?ooo`0W0?ooo`030000003oool0
oooo05<0oooo00<000000?ooo`3oool07`3oool00`000000oooo0?ooo`0a0?ooo`030000003oool0
oooo00<0oooo00<000000?ooo`3oool0FP3oool00`000000oooo0?ooo`050?ooo`030000003oool0
oooo0180oooo1000000`0?ooo`030000003oool0oooo03d0oooo1P00000E0?ooo`8000002@3oool0
0`000000oooo0?ooo`0f0?ooo`030000003oool0oooo01h0oooo000P0?ooo`030000003oool0oooo
02L0oooo00<000000?ooo`3oool0DP3oool00`000000oooo0?ooo`0O0?ooo`030000003oool0oooo
0300oooo00<000000?ooo`3oool01@3oool00`000000oooo0?ooo`1H0?ooo`030000003oool0oooo
00H0oooo00<000000?ooo`3oool05P3oool3000002d0oooo00<000000?ooo`3oool0=`3oool60000
01T0oooo0P00000;0?ooo`030000003oool0oooo03H0oooo00<000000?ooo`3oool07P3oool00200
oooo00<000000?ooo`3oool0:03oool00`000000oooo0?ooo`1A0?ooo`030000003oool0oooo01l0
oooo00<000000?ooo`3oool0<03oool00`000000oooo0?ooo`050?ooo`030000003oool0oooo05L0
oooo00<000000?ooo`3oool01`3oool00`000000oooo0?ooo`0I0?ooo`<00000:@3oool00`000000
oooo0?ooo`0c0?ooo`D000007@3oool2000000`0oooo00<000000?ooo`3oool0=P3oool00`000000
oooo0?ooo`0O0?ooo`008@3oool00`000000oooo0?ooo`0W0?ooo`030000003oool0oooo0540oooo
00<000000?ooo`3oool07`3oool00`000000oooo0?ooo`0`0?ooo`030000003oool0oooo00H0oooo
00<000000?ooo`3oool0E@3oool00`000000oooo0?ooo`090?ooo`030000003oool0oooo01/0oooo
1000000T0?ooo`030000003oool0oooo02h0oooo1P00000P0?ooo`8000003@3oool00`000000oooo
0?ooo`0g0?ooo`030000003oool0oooo01l0oooo000Q0?ooo`030000003oool0oooo02P0oooo00<0
00000?ooo`3oool0D@3oool00`000000oooo0?ooo`0N0?ooo`030000003oool0oooo02l0oooo00<0
00000?ooo`3oool01`3oool00`000000oooo0?ooo`1D0?ooo`030000003oool0oooo00X0oooo00<0
00000?ooo`3oool07`3oool300000240oooo00<000000?ooo`3oool0:@3oool5000002<0oooo0`00
000?0?ooo`030000003oool0oooo03H0oooo00<000000?ooo`3oool0803oool00280oooo00<00000
0?ooo`3oool0:03oool00`000000oooo0?ooo`1@0?ooo`030000003oool0oooo01d0oooo00<00000
0?ooo`3oool0<03oool00`000000oooo0?ooo`080?ooo`030000003oool0oooo0580oooo00<00000
0?ooo`3oool02`3oool00`000000oooo0?ooo`0R0?ooo`<000007@3oool00`000000oooo0?ooo`0T
0?ooo`H000009P3oool200000140oooo00<000000?ooo`3oool0=`3oool00`000000oooo0?ooo`0P
0?ooo`008P3oool00`000000oooo0?ooo`0X0?ooo`030000003oool0oooo0500oooo00<000000?oo
o`3oool07@3oool00`000000oooo0?ooo`0`0?ooo`030000003oool0oooo00T0oooo00<000000?oo
o`3oool0D03oool00`000000oooo0?ooo`0<0?ooo`030000003oool0oooo02D0oooo1000000I0?oo
o`030000003oool0oooo01h0oooo1P00000Z0?ooo`8000004`3oool00`000000oooo0?ooo`0f0?oo
o`030000003oool0oooo0240oooo000S0?ooo`030000003oool0oooo02P0oooo00<000000?ooo`3o
ool0C`3oool00`000000oooo0?ooo`0M0?ooo`030000003oool0oooo02l0oooo00<000000?ooo`3o
ool02P3oool00`000000oooo0?ooo`1?0?ooo`030000003oool0oooo00d0oooo00<000000?ooo`3o
ool0:@3oool3000001D0oooo00<000000?ooo`3oool06P3oool5000002h0oooo0P00000D0?ooo`03
0000003oool0oooo03L0oooo00<000000?ooo`3oool08@3oool002<0oooo00<000000?ooo`3oool0
:03oool00`000000oooo0?ooo`1?0?ooo`030000003oool0oooo01d0oooo00<000000?ooo`3oool0
;`3oool00`000000oooo0?ooo`0;0?ooo`030000003oool0oooo04d0oooo00<000000?ooo`3oool0
3P3oool00`000000oooo0?ooo`0/0?ooo`<000003P3oool200000080oooo00<000000?ooo`3oool0
503oool600000340oooo0P00000F0?ooo`030000003oool0oooo03H0oooo00<000000?ooo`3oool0
8P3oool002@0oooo00<000000?ooo`3oool0:03oool00`000000oooo0?ooo`1>0?ooo`030000003o
ool0oooo01d0oooo00<000000?ooo`3oool0;`3oool00`000000oooo0?ooo`0;0?ooo`030000003o
ool0oooo04`0oooo00<000000?ooo`3oool0403oool00`000000oooo0?ooo`0^0?ooo`@000001`3o
ool800000100oooo1P00000e0?ooo`8000005`3oool00`000000oooo0?ooo`0g0?ooo`030000003o
ool0oooo0280oooo000T0?ooo`030000003oool0oooo02T0oooo00<000000?ooo`3oool0C@3oool0
0`000000oooo0?ooo`0M0?ooo`030000003oool0oooo02h0oooo00<000000?ooo`3oool03@3oool0
0`000000oooo0?ooo`1:0?ooo`030000003oool0oooo0140oooo00<000000?ooo`3oool0<P3oool3
000000<0oooo2P00000:0?ooo`D00000>@3oool2000001T0oooo00<000000?ooo`3oool0=P3oool0
0`000000oooo0?ooo`0S0?ooo`009@3oool00`000000oooo0?ooo`0X0?ooo`030000003oool0oooo
04h0oooo00<000000?ooo`3oool0703oool00`000000oooo0?ooo`0^0?ooo`030000003oool0oooo
00h0oooo00<000000?ooo`3oool0B03oool00`000000oooo0?ooo`0B0?ooo`030000003oool0oooo
03D0oooo3@0000040?ooo`H00000?03oool2000001X0oooo00<000000?ooo`3oool0=`3oool00`00
0000oooo0?ooo`0S0?ooo`009@3oool00`000000oooo0?ooo`0Y0?ooo`030000003oool0oooo04d0
oooo00<000000?ooo`3oool0703oool00`000000oooo0?ooo`0^0?ooo`030000003oool0oooo00h0
oooo00<000000?ooo`3oool0A`3oool00`000000oooo0?ooo`0C0?ooo`030000003oool0oooo03P0
oooo3P0000100?ooo`8000006`3oool00`000000oooo0?ooo`0g0?ooo`030000003oool0oooo02@0
oooo000V0?ooo`030000003oool0oooo02T0oooo00<000000?ooo`3oool0C03oool00`000000oooo
0?ooo`0L0?ooo`030000003oool0oooo02d0oooo00<000000?ooo`3oool0403oool00`000000oooo
0?ooo`150?ooo`030000003oool0oooo01@0oooo00<000000?ooo`3oool0=`3oool<00000440oooo
0P00000M0?ooo`030000003oool0oooo03L0oooo00<000000?ooo`3oool0903oool002H0oooo00<0
00000?ooo`3oool0:@3oool00`000000oooo0?ooo`1<0?ooo`030000003oool0oooo01`0oooo00<0
00000?ooo`3oool0;@3oool00`000000oooo0?ooo`0@0?ooo`030000003oool0oooo04@0oooo00<0
00000?ooo`3oool05@3oool00`000000oooo0?ooo`0g0?ooo``00000?`3oool2000001h0oooo00<0
00000?ooo`3oool0=`3oool00`000000oooo0?ooo`0U0?ooo`009`3oool00`000000oooo0?ooo`0Y
0?ooo`030000003oool0oooo04/0oooo00<000000?ooo`3oool0703oool00`000000oooo0?ooo`0]
0?ooo`030000003oool0oooo0140oooo00<000000?ooo`3oool0@P3oool00`000000oooo0?ooo`0G
0?ooo`030000003oool0oooo03L0oooo2P00000n0?ooo`800000803oool00`000000oooo0?ooo`0g
0?ooo`030000003oool0oooo02D0oooo000W0?ooo`030000003oool0oooo02T0oooo00<000000?oo
o`3oool0B`3oool00`000000oooo0?ooo`0L0?ooo`030000003oool0oooo02`0oooo00<000000?oo
o`3oool04`3oool00`000000oooo0?ooo`100?ooo`030000003oool0oooo01P0oooo00<000000?oo
o`3oool0=`3oool:000003/0oooo0`00000Q0?ooo`030000003oool0oooo03L0oooo00<000000?oo
o`3oool09P3oool002P0oooo00<000000?ooo`3oool0:@3oool00`000000oooo0?ooo`1;0?ooo`03
0000003oool0oooo01/0oooo00<000000?ooo`3oool0;03oool00`000000oooo0?ooo`0C0?ooo`03
0000003oool0oooo03l0oooo00<000000?ooo`3oool06@3oool00`000000oooo0?ooo`0g0?ooo`X0
0000>@3oool2000002@0oooo00<000000?ooo`3oool0=`3oool00`000000oooo0?ooo`0V0?ooo`00
:03oool00`000000oooo0?ooo`0Z0?ooo`030000003oool0oooo04X0oooo00<000000?ooo`3oool0
6`3oool00`000000oooo0?ooo`0/0?ooo`030000003oool0oooo01@0oooo00<000000?ooo`3oool0
?@3oool00`000000oooo0?ooo`0J0?ooo`030000003oool0oooo03L0oooo2@00000h0?ooo`800000
9@3oool00`000000oooo0?ooo`0g0?ooo`030000003oool0oooo02L0oooo000Y0?ooo`030000003o
ool0oooo02T0oooo00<000000?ooo`3oool0BP3oool00`000000oooo0?ooo`0K0?ooo`030000003o
ool0oooo02/0oooo00<000000?ooo`3oool05@3oool00`000000oooo0?ooo`0l0?ooo`030000003o
ool0oooo01/0oooo00<000000?ooo`3oool0=`3oool010000000oooo0?ooo`3oool2000003T0oooo
0P00000V0?ooo`030000003oool0oooo03P0oooo00<000000?ooo`3oool09`3oool002T0oooo00<0
00000?ooo`3oool0:P3oool00`000000oooo0?ooo`190?ooo`030000003oool0oooo01/0oooo00<0
00000?ooo`3oool0:`3oool00`000000oooo0?ooo`0F0?ooo`030000003oool0oooo03X0oooo00<0
00000?ooo`3oool0703oool00`000000oooo0?ooo`0f0?ooo`030000003oool0oooo03/0oooo0P00
000X0?ooo`030000003oool0oooo03L0oooo00<000000?ooo`3oool0:03oool002X0oooo00<00000
0?ooo`3oool0:P3oool00`000000oooo0?ooo`180?ooo`030000003oool0oooo01/0oooo00<00000
0?ooo`3oool0:`3oool00`000000oooo0?ooo`0G0?ooo`030000003oool0oooo03P0oooo00<00000
0?ooo`3oool07P3oool00`000000oooo0?ooo`0d0?ooo`030000003oool0oooo03X0oooo0P00000Y
0?ooo`030000003oool0oooo03P0oooo00<000000?ooo`3oool0:03oool002X0oooo00<000000?oo
o`3oool0:P3oool00`000000oooo0?ooo`180?ooo`030000003oool0oooo01/0oooo00<000000?oo
o`3oool0:P3oool00`000000oooo0?ooo`0H0?ooo`030000003oool0oooo03L0oooo00<000000?oo
o`3oool07`3oool00`000000oooo0?ooo`0c0?ooo`030000003oool0oooo03T0oooo0P00000[0?oo
o`030000003oool0oooo03L0oooo00<000000?ooo`3oool0:@3oool002/0oooo00<000000?ooo`3o
ool0:P3oool00`000000oooo0?ooo`170?ooo`030000003oool0oooo01/0oooo00<000000?ooo`3o
ool0:P3oool00`000000oooo0?ooo`0I0?ooo`030000003oool0oooo03D0oooo00<000000?ooo`3o
ool0803oool00`000000oooo0?ooo`0b0?ooo`030000003oool0oooo03P0oooo0P00000/0?ooo`03
0000003oool0oooo03P0oooo00<000000?ooo`3oool0:@3oool002/0oooo00<000000?ooo`3oool0
:`3oool00`000000oooo0?ooo`170?ooo`030000003oool0oooo01X0oooo00<000000?ooo`3oool0
:P3oool00`000000oooo0?ooo`0I0?ooo`030000003oool0oooo03@0oooo00<000000?ooo`3oool0
8@3oool00`000000oooo0?ooo`0a0?ooo`030000003oool0oooo03L0oooo0P00000^0?ooo`030000
003oool0oooo03L0oooo00<000000?ooo`3oool0:P3oool002`0oooo00<000000?ooo`3oool0:P3o
ool00`000000oooo0?ooo`170?ooo`030000003oool0oooo01X0oooo00<000000?ooo`3oool0:@3o
ool00`000000oooo0?ooo`0K0?ooo`030000003oool0oooo0380oooo00<000000?ooo`3oool08P3o
ool00`000000oooo0?ooo`0`0?ooo`030000003oool0oooo03H0oooo0P00000_0?ooo`030000003o
ool0oooo03P0oooo00<000000?ooo`3oool0:P3oool002`0oooo00<000000?ooo`3oool0:`3oool0
0`000000oooo0?ooo`160?ooo`030000003oool0oooo01X0oooo00<000000?ooo`3oool0:@3oool0
0`000000oooo0?ooo`0K0?ooo`030000003oool0oooo0340oooo00<000000?ooo`3oool08`3oool0
0`000000oooo0?ooo`0_0?ooo`030000003oool0oooo03D0oooo0P00000a0?ooo`030000003oool0
oooo03L0oooo00<000000?ooo`3oool0:`3oool002d0oooo00<000000?ooo`3oool0:P3oool00`00
0000oooo0?ooo`160?ooo`030000003oool0oooo01X0oooo00<000000?ooo`3oool0:@3oool00`00
0000oooo0?ooo`0L0?ooo`030000003oool0oooo0300oooo00<000000?ooo`3oool0903oool00`00
0000oooo0?ooo`0]0?ooo`030000003oool0oooo03<0oooo0`00000b0?ooo`030000003oool0oooo
03P0oooo00<000000?ooo`3oool0:`3oool002d0oooo00<000000?ooo`3oool0:`3oool00`000000
oooo0?ooo`150?ooo`030000003oool0oooo01T0oooo00<000000?ooo`3oool0:@3oool00`000000
oooo0?ooo`0N0?ooo`030000003oool0oooo02h0oooo00<000000?ooo`3oool09@3oool00`000000
oooo0?ooo`0/0?ooo`030000003oool0oooo0380oooo0P00000d0?ooo`030000003oool0oooo03P0
oooo00<000000?ooo`3oool0;03oool002h0oooo00<000000?ooo`3oool0:`3oool00`000000oooo
0?ooo`140?ooo`030000003oool0oooo01T0oooo00<000000?ooo`3oool0:@3oool00`000000oooo
0?ooo`0N0?ooo`030000003oool0oooo02d0oooo00<000000?ooo`3oool09P3oool00`000000oooo
0?ooo`0/0?ooo`030000003oool0oooo0300oooo0P00000f0?ooo`030000003oool0oooo03P0oooo
00<000000?ooo`3oool0;03oool002h0oooo00<000000?ooo`3oool0:`3oool00`000000oooo0?oo
o`140?ooo`030000003oool0oooo01T0oooo00<000000?ooo`3oool0:@3oool00`000000oooo0?oo
o`0O0?ooo`030000003oool0oooo02/0oooo00<000000?ooo`3oool09`3oool00`000000oooo0?oo
o`0[0?ooo`030000003oool0oooo02l0oooo0P00000g0?ooo`030000003oool0oooo03P0oooo00<0
00000?ooo`3oool0;@3oool002l0oooo00<000000?ooo`3oool0:`3oool00`000000oooo0?ooo`14
0?ooo`030000003oool0oooo01P0oooo00<000000?ooo`3oool0:03oool00`000000oooo0?ooo`0P
0?ooo`030000003oool0oooo02X0oooo00<000000?ooo`3oool0:03oool00`000000oooo0?ooo`0Z
0?ooo`030000003oool0oooo02h0oooo0P00000i0?ooo`030000003oool0oooo03P0oooo00<00000
0?ooo`3oool0;@3oool002l0oooo00<000000?ooo`3oool0;03oool00`000000oooo0?ooo`130?oo
o`030000003oool0oooo01P0oooo00<000000?ooo`3oool0:03oool00`000000oooo0?ooo`0Q0?oo
o`030000003oool0oooo02P0oooo00<000000?ooo`3oool0:@3oool00`000000oooo0?ooo`0Y0?oo
o`030000003oool0oooo02d0oooo0P00000j0?ooo`030000003oool0oooo03P0oooo00<000000?oo
o`3oool0;P3oool00300oooo00<000000?ooo`3oool0:`3oool00`000000oooo0?ooo`130?ooo`03
0000003oool0oooo01P0oooo00<000000?ooo`3oool0:03oool00`000000oooo0?ooo`0R0?ooo`03
0000003oool0oooo02H0oooo00<000000?ooo`3oool0:P3oool00`000000oooo0?ooo`0X0?ooo`03
0000003oool0oooo02`0oooo0P00000l0?ooo`030000003oool0oooo03P0oooo00<000000?ooo`3o
ool0;P3oool00300oooo00<000000?ooo`3oool0;03oool00`000000oooo0?ooo`120?ooo`030000
003oool0oooo01P0oooo00<000000?ooo`3oool09`3oool00`000000oooo0?ooo`0S0?ooo`030000
003oool0oooo02D0oooo00<000000?ooo`3oool0;03oool00`000000oooo0?ooo`0V0?ooo`030000
003oool0oooo02/0oooo0P00000m0?ooo`030000003oool0oooo03P0oooo00<000000?ooo`3oool0
;`3oool00340oooo00<000000?ooo`3oool0:`3oool00`000000oooo0?ooo`120?ooo`030000003o
ool0oooo01P0oooo00<000000?ooo`3oool09`3oool00`000000oooo0?ooo`0T0?ooo`030000003o
ool0oooo02<0oooo00<000000?ooo`3oool0;@3oool00`000000oooo0?ooo`0U0?ooo`030000003o
ool0oooo02X0oooo0P00000o0?ooo`030000003oool0oooo03P0oooo00<000000?ooo`3oool0;`3o
ool00340oooo00<000000?ooo`3oool0;03oool00`000000oooo0?ooo`110?ooo`030000003oool0
oooo01P0oooo00<000000?ooo`3oool09`3oool00`000000oooo0?ooo`0T0?ooo`030000003oool0
oooo0280oooo00<000000?ooo`3oool0;P3oool00`000000oooo0?ooo`0T0?ooo`030000003oool0
oooo02T0oooo0P0000100?ooo`030000003oool0oooo03P0oooo00<000000?ooo`3oool0<03oool0
0380oooo00<000000?ooo`3oool0;03oool00`000000oooo0?ooo`100?ooo`030000003oool0oooo
01P0oooo00<000000?ooo`3oool09P3oool00`000000oooo0?ooo`0V0?ooo`030000003oool0oooo
0200oooo00<000000?ooo`3oool0;`3oool00`000000oooo0?ooo`0S0?ooo`030000003oool0oooo
02P0oooo0P0000110?ooo`030000003oool0oooo03T0oooo00<000000?ooo`3oool0<03oool00380
oooo00<000000?ooo`3oool0;03oool00`000000oooo0?ooo`110?ooo`030000003oool0oooo01L0
oooo00<000000?ooo`3oool09P3oool00`000000oooo0?ooo`0W0?ooo`030000003oool0oooo01h0
oooo00<000000?ooo`3oool0<03oool00`000000oooo0?ooo`0R0?ooo`030000003oool0oooo02L0
oooo0P0000130?ooo`030000003oool0oooo03P0oooo00<000000?ooo`3oool0<@3oool003<0oooo
00<000000?ooo`3oool0;03oool00`000000oooo0?ooo`100?ooo`030000003oool0oooo01L0oooo
00<000000?ooo`3oool09@3oool00`000000oooo0?ooo`0X0?ooo`030000003oool0oooo01d0oooo
00<000000?ooo`3oool0<@3oool00`000000oooo0?ooo`0R0?ooo`030000003oool0oooo02@0oooo
0`0000140?ooo`030000003oool0oooo03T0oooo00<000000?ooo`3oool0<@3oool003<0oooo00<0
00000?ooo`3oool0;@3oool00`000000oooo0?ooo`0o0?ooo`030000003oool0oooo01L0oooo00<0
00000?ooo`3oool09@3oool00`000000oooo0?ooo`0Y0?ooo`030000003oool0oooo01/0oooo00<0
00000?ooo`3oool0<`3oool00`000000oooo0?ooo`0P0?ooo`030000003oool0oooo02<0oooo0P00
00170?ooo`030000003oool0oooo03P0oooo00<000000?ooo`3oool0<P3oool003@0oooo00<00000
0?ooo`3oool0;03oool00`000000oooo0?ooo`0o0?ooo`030000003oool0oooo01L0oooo00<00000
0?ooo`3oool09@3oool00`000000oooo0?ooo`0Y0?ooo`030000003oool0oooo01X0oooo00<00000
0?ooo`3oool0=03oool00`000000oooo0?ooo`0O0?ooo`030000003oool0oooo0280oooo0P000018
0?ooo`030000003oool0oooo03T0oooo00<000000?ooo`3oool0<P3oool003@0oooo00<000000?oo
o`3oool0;@3oool00`000000oooo0?ooo`0n0?ooo`030000003oool0oooo01L0oooo00<000000?oo
o`3oool0903oool00`000000oooo0?ooo`0[0?ooo`030000003oool0oooo01P0oooo00<000000?oo
o`3oool0=@3oool00`000000oooo0?ooo`0N0?ooo`030000003oool0oooo0240oooo0P00001:0?oo
o`030000003oool0oooo03P0oooo00<000000?ooo`3oool0<`3oool003D0oooo00<000000?ooo`3o
ool0;@3oool00`000000oooo0?ooo`0m0?ooo`030000003oool0oooo01L0oooo00<000000?ooo`3o
ool0903oool00`000000oooo0?ooo`0/0?ooo`030000003oool0oooo01H0oooo00<000000?ooo`3o
ool0=P3oool00`000000oooo0?ooo`0M0?ooo`030000003oool0oooo0200oooo0P00001;0?ooo`03
0000003oool0oooo03T0oooo00<000000?ooo`3oool0<`3oool003D0oooo00<000000?ooo`3oool0
;@3oool00`000000oooo0?ooo`0m0?ooo`030000003oool0oooo01L0oooo00<000000?ooo`3oool0
903oool00`000000oooo0?ooo`0/0?ooo`030000003oool0oooo01D0oooo00<000000?ooo`3oool0
=`3oool00`000000oooo0?ooo`0L0?ooo`030000003oool0oooo01l0oooo0P00001=0?ooo`030000
003oool0oooo03P0oooo00<000000?ooo`3oool0=03oool003H0oooo00<000000?ooo`3oool0;@3o
ool00`000000oooo0?ooo`0m0?ooo`030000003oool0oooo01H0oooo00<000000?ooo`3oool08`3o
ool00`000000oooo0?ooo`0^0?ooo`030000003oool0oooo01<0oooo00<000000?ooo`3oool0>03o
ool00`000000oooo0?ooo`0K0?ooo`030000003oool0oooo01h0oooo0P00001>0?ooo`030000003o
ool0oooo03T0oooo00<000000?ooo`3oool0=03oool003H0oooo00<000000?ooo`3oool0;@3oool0
0`000000oooo0?ooo`0m0?ooo`030000003oool0oooo01H0oooo00<000000?ooo`3oool08`3oool0
0`000000oooo0?ooo`0^0?ooo`030000003oool0oooo0180oooo00<000000?ooo`3oool0>P3oool0
0`000000oooo0?ooo`0I0?ooo`030000003oool0oooo01d0oooo0P00001?0?ooo`030000003oool0
oooo03T0oooo00<000000?ooo`3oool0=@3oool003L0oooo00<000000?ooo`3oool0;@3oool00`00
0000oooo0?ooo`0l0?ooo`030000003oool0oooo01H0oooo00<000000?ooo`3oool08`3oool00`00
0000oooo0?ooo`0_0?ooo`030000003oool0oooo0100oooo00<000000?ooo`3oool0>`3oool00`00
0000oooo0?ooo`0H0?ooo`030000003oool0oooo01`0oooo0P00001A0?ooo`030000003oool0oooo
03T0oooo00<000000?ooo`3oool0=@3oool003L0oooo00<000000?ooo`3oool0;P3oool00`000000
oooo0?ooo`0k0?ooo`030000003oool0oooo01H0oooo00<000000?ooo`3oool08P3oool00`000000
oooo0?ooo`0`0?ooo`030000003oool0oooo00l0oooo00<000000?ooo`3oool0?03oool00`000000
oooo0?ooo`0G0?ooo`030000003oool0oooo01/0oooo0P00001B0?ooo`030000003oool0oooo03T0
oooo00<000000?ooo`3oool0=P3oool003P0oooo00<000000?ooo`3oool0;@3oool00`000000oooo
0?ooo`0k0?ooo`030000003oool0oooo01H0oooo00<000000?ooo`3oool08P3oool00`000000oooo
0?ooo`0a0?ooo`030000003oool0oooo00d0oooo00<000000?ooo`3oool0?@3oool00`000000oooo
0?ooo`0G0?ooo`030000003oool0oooo01T0oooo0P00001D0?ooo`030000003oool0oooo03T0oooo
00<000000?ooo`3oool0=P3oool003P0oooo00<000000?ooo`3oool0;P3oool00`000000oooo0?oo
o`0j0?ooo`030000003oool0oooo01H0oooo00<000000?ooo`3oool08P3oool00`000000oooo0?oo
o`0b0?ooo`030000003oool0oooo00/0oooo00<000000?ooo`3oool0?P3oool00`000000oooo0?oo
o`0F0?ooo`030000003oool0oooo01L0oooo0`00001E0?ooo`030000003oool0oooo03T0oooo00<0
00000?ooo`3oool0=`3oool003T0oooo00<000000?ooo`3oool0;P3oool00`000000oooo0?ooo`0j
0?ooo`030000003oool0oooo01@0oooo00<000000?ooo`3oool08P3oool00`000000oooo0?ooo`0c
0?ooo`030000003oool0oooo00X0oooo00<000000?ooo`3oool0?`3oool00`000000oooo0?ooo`0E
0?ooo`030000003oool0oooo01H0oooo0P00001H0?ooo`030000003oool0oooo03T0oooo00<00000
0?ooo`3oool0=`3oool003T0oooo00<000000?ooo`3oool0;P3oool00`000000oooo0?ooo`0j0?oo
o`030000003oool0oooo01@0oooo00<000000?ooo`3oool08P3oool00`000000oooo0?ooo`0d0?oo
o`030000003oool0oooo00P0oooo00<000000?ooo`3oool0@@3oool00`000000oooo0?ooo`0C0?oo
o`030000003oool0oooo01D0oooo0P00001I0?ooo`030000003oool0oooo03T0oooo00<000000?oo
o`3oool0>03oool003X0oooo00<000000?ooo`3oool0;P3oool00`000000oooo0?ooo`0i0?ooo`03
0000003oool0oooo01@0oooo00<000000?ooo`3oool08P3oool00`000000oooo0?ooo`0d0?ooo`03
0000003oool0oooo00L0oooo00<000000?ooo`3oool0@P3oool00`000000oooo0?ooo`0B0?ooo`03
0000003oool0oooo01@0oooo0P00001K0?ooo`030000003oool0oooo03T0oooo00<000000?ooo`3o
ool0>03oool003X0oooo00<000000?ooo`3oool0;P3oool00`000000oooo0?ooo`0i0?ooo`030000
003oool0oooo01@0oooo00<000000?ooo`3oool08@3oool00`000000oooo0?ooo`0f0?ooo`030000
003oool0oooo008000000`3oool00`000000oooo0?ooo`130?ooo`030000003oool0oooo0140oooo
00<000000?ooo`3oool04`3oool2000005`0oooo00<000000?ooo`3oool0>@3oool00`000000oooo
0?ooo`0i0?ooo`00>`3oool00`000000oooo0?ooo`0^0?ooo`030000003oool0oooo03P0oooo00<0
00000?ooo`3oool0503oool00`000000oooo0?ooo`0Q0?ooo`030000003oool0oooo03H0oooo2000
00160?ooo`030000003oool0oooo0100oooo00<000000?ooo`3oool04P3oool2000005d0oooo00<0
00000?ooo`3oool0>P3oool00`000000oooo0?ooo`0i0?ooo`00>`3oool00`000000oooo0?ooo`0_
0?ooo`030000003oool0oooo03L0oooo00<000000?ooo`3oool0503oool00`000000oooo0?ooo`0Q
0?ooo`030000003oool0oooo03D0oooo2P0000150?ooo`030000003oool0oooo00l0oooo00<00000
0?ooo`3oool04@3oool2000005l0oooo00<000000?ooo`3oool0>@3oool00`000000oooo0?ooo`0j
0?ooo`00?03oool00`000000oooo0?ooo`0^0?ooo`030000003oool0oooo03L0oooo00<000000?oo
o`3oool0503oool00`000000oooo0?ooo`0P0?ooo`030000003oool0oooo03H0oooo2P0000150?oo
o`030000003oool0oooo00h0oooo00<000000?ooo`3oool0403oool200000600oooo00<000000?oo
o`3oool0>P3oool00`000000oooo0?ooo`0j0?ooo`00?03oool00`000000oooo0?ooo`0_0?ooo`03
0000003oool0oooo03L0oooo00<000000?ooo`3oool04`3oool00`000000oooo0?ooo`0P0?ooo`03
0000003oool0oooo03H0oooo2P0000160?ooo`030000003oool0oooo00`0oooo00<000000?ooo`3o
ool03`3oool200000680oooo00<000000?ooo`3oool0>@3oool00`000000oooo0?ooo`0k0?ooo`00
?@3oool00`000000oooo0?ooo`0_0?ooo`030000003oool0oooo03H0oooo00<000000?ooo`3oool0
4`3oool00`000000oooo0?ooo`0P0?ooo`030000003oool0oooo03D0oooo300000150?ooo`030000
003oool0oooo00`0oooo00<000000?ooo`3oool03@3oool2000006<0oooo00<000000?ooo`3oool0
>P3oool00`000000oooo0?ooo`0k0?ooo`00?@3oool00`000000oooo0?ooo`0_0?ooo`030000003o
ool0oooo03H0oooo00<000000?ooo`3oool04`3oool00`000000oooo0?ooo`0O0?ooo`030000003o
ool0oooo03H0oooo3P0000130?ooo`030000003oool0oooo00/0oooo00<000000?ooo`3oool0303o
ool2000006D0oooo00<000000?ooo`3oool0>@3oool00`000000oooo0?ooo`0l0?ooo`00?P3oool0
0`000000oooo0?ooo`0_0?ooo`030000003oool0oooo03D0oooo00<000000?ooo`3oool04`3oool0
0`000000oooo0?ooo`0O0?ooo`030000003oool0oooo03L0oooo2P0000030?ooo`D00000?P3oool0
0`000000oooo0?ooo`0:0?ooo`030000003oool0oooo00/0oooo0P00001V0?ooo`030000003oool0
oooo03X0oooo00<000000?ooo`3oool0?03oool003h0oooo00<000000?ooo`3oool0;`3oool00`00
0000oooo0?ooo`0e0?ooo`030000003oool0oooo01<0oooo00<000000?ooo`3oool07`3oool00`00
0000oooo0?ooo`0g0?ooo`X00000203oool6000003P0oooo00<000000?ooo`3oool02@3oool00`00
0000oooo0?ooo`090?ooo`<00000I`3oool00`000000oooo0?ooo`0j0?ooo`030000003oool0oooo
03d0oooo000o0?ooo`030000003oool0oooo02l0oooo00<000000?ooo`3oool0=03oool00`000000
oooo0?ooo`0C0?ooo`030000003oool0oooo01h0oooo00<000000?ooo`3oool0>03oool:000000h0
oooo1P00000b0?ooo`030000003oool0oooo00P0oooo00<000000?ooo`3oool0203oool2000006X0
oooo00<000000?ooo`3oool0>P3oool00`000000oooo0?ooo`0m0?ooo`00?`3oool00`000000oooo
0?ooo`0`0?ooo`030000003oool0oooo03<0oooo00<000000?ooo`3oool04`3oool00`000000oooo
0?ooo`0N0?ooo`030000003oool0oooo03P0oooo2@00000E0?ooo`D00000;P3oool00`000000oooo
0?ooo`060?ooo`030000003oool0oooo00L0oooo0P00001[0?ooo`030000003oool0oooo03X0oooo
00<000000?ooo`3oool0?P3oool00400oooo00<000000?ooo`3oool0;`3oool00`000000oooo0?oo
o`0d0?ooo`030000003oool0oooo0180oooo00<000000?ooo`3oool07P3oool00`000000oooo0?oo
o`0g0?ooo`030000003oool0oooo0080oooo0P00000M0?ooo`H00000:03oool00`000000oooo0?oo
o`050?ooo`030000003oool0oooo00H0oooo0P00001]0?ooo`030000003oool0oooo03X0oooo00<0
00000?ooo`3oool0?P3oool00400oooo00<000000?ooo`3oool0<03oool00`000000oooo0?ooo`0c
0?ooo`030000003oool0oooo0180oooo00<000000?ooo`3oool07@3oool00`000000oooo0?ooo`0g
0?ooo`030000003oool0oooo02P0oooo1@00000S0?ooo`030000003oool0oooo00@0oooo00<00000
0?ooo`3oool01@3oool2000006h0oooo00<000000?ooo`3oool0>P3oool00`000000oooo0?ooo`0o
0?ooo`00@@3oool00`000000oooo0?ooo`0`0?ooo`030000003oool0oooo0380oooo00<000000?oo
o`3oool04P3oool00`000000oooo0?ooo`0M0?ooo`030000003oool0oooo03H0oooo00<000000?oo
o`3oool0;P3oool6000001d0oooo0P0000040?ooo`030000003oool0oooo00@0oooo0P00001`0?oo
o`030000003oool0oooo03X0oooo00<000000?ooo`3oool0?`3oool00440oooo00<000000?ooo`3o
ool0<03oool00`000000oooo0?ooo`0b0?ooo`030000003oool0oooo0180oooo00<000000?ooo`3o
ool07@3oool00`000000oooo0?ooo`0e0?ooo`030000003oool0oooo03D0oooo1@00000E0?ooo`T0
00001@3oool200000740oooo00<000000?ooo`3oool0>P3oool00`000000oooo0?ooo`100?ooo`00
@P3oool00`000000oooo0?ooo`0`0?ooo`030000003oool0oooo0340oooo00<000000?ooo`3oool0
4P3oool00`000000oooo0?ooo`0L0?ooo`030000003oool0oooo03D0oooo00<000000?ooo`3oool0
>`3oool6000000h0oooo2P0000030?ooo`800000L`3oool00`000000oooo0?ooo`0j0?ooo`030000
003oool0oooo0400oooo00120?ooo`030000003oool0oooo0340oooo00<000000?ooo`3oool0<03o
ool00`000000oooo0?ooo`0B0?ooo`030000003oool0oooo01`0oooo00<000000?ooo`3oool0=@3o
ool00`000000oooo0?ooo`110?ooo`H00000203oool:000000030?ooo`000000000007@0oooo00<0
00000?ooo`3oool0>P3oool00`000000oooo0?ooo`110?ooo`00@`3oool00`000000oooo0?ooo`0`
0?ooo`030000003oool0oooo0300oooo00<000000?ooo`3oool04P3oool00`000000oooo0?ooo`0L
0?ooo`030000003oool0oooo03@0oooo00<000000?ooo`3oool0B03oool5000000<0oooo2`00001e
0?ooo`030000003oool0oooo03/0oooo00<000000?ooo`3oool0@@3oool004<0oooo00<000000?oo
o`3oool0<@3oool00`000000oooo0?ooo`0`0?ooo`030000003oool0oooo0140oooo00<000000?oo
o`3oool06`3oool00`000000oooo0?ooo`0d0?ooo`030000003oool0oooo04h0oooo3P00001e0?oo
o`030000003oool0oooo03X0oooo00<000000?ooo`3oool0@P3oool004@0oooo00<000000?ooo`3o
ool0<03oool00`000000oooo0?ooo`0`0?ooo`030000003oool0oooo0140oooo00<000000?ooo`3o
ool06`3oool00`000000oooo0?ooo`0c0?ooo`030000003oool0oooo0540oooo3000001d0?ooo`03
0000003oool0oooo03/0oooo00<000000?ooo`3oool0@P3oool004@0oooo00<000000?ooo`3oool0
<@3oool00`000000oooo0?ooo`0_0?ooo`030000003oool0oooo0100oooo00<000000?ooo`3oool0
703oool00`000000oooo0?ooo`0b0?ooo`030000003oool0oooo05<0oooo2P00001e0?ooo`030000
003oool0oooo03X0oooo00<000000?ooo`3oool0@`3oool004D0oooo00<000000?ooo`3oool0<@3o
ool00`000000oooo0?ooo`0^0?ooo`030000003oool0oooo0100oooo00<000000?ooo`3oool06`3o
ool00`000000oooo0?ooo`0b0?ooo`030000003oool0oooo05@0oooo2P00001d0?ooo`030000003o
ool0oooo03/0oooo00<000000?ooo`3oool0@`3oool004D0oooo00<000000?ooo`3oool0<@3oool0
0`000000oooo0?ooo`0^0?ooo`030000003oool0oooo0100oooo00<000000?ooo`3oool06`3oool0
0`000000oooo0?ooo`0a0?ooo`030000003oool0oooo05@0oooo2`00001d0?ooo`030000003oool0
oooo03X0oooo00<000000?ooo`3oool0A03oool004H0oooo00<000000?ooo`3oool0<@3oool00`00
0000oooo0?ooo`0]0?ooo`030000003oool0oooo0100oooo00<000000?ooo`3oool06`3oool00`00
0000oooo0?ooo`0a0?ooo`030000003oool0oooo05<0oooo00<000000?ooo`3oool02000001d0?oo
o`030000003oool0oooo03/0oooo00<000000?ooo`3oool0A03oool004H0oooo00<000000?ooo`3o
ool0<P3oool00`000000oooo0?ooo`0/0?ooo`030000003oool0oooo0100oooo00<000000?ooo`3o
ool06P3oool00`000000oooo0?ooo`0a0?ooo`030000003oool0oooo0580oooo0P0000060?ooo`80
000000<0oooo0000003oool0M03oool00`000000oooo0?ooo`0j0?ooo`030000003oool0oooo04D0
oooo00170?ooo`030000003oool0oooo0340oooo00<000000?ooo`3oool0;@3oool00`000000oooo
0?ooo`0?0?ooo`030000003oool0oooo01X0oooo00<000000?ooo`3oool0<03oool00`000000oooo
0?ooo`1A0?ooo`8000002`3oool00`000000oooo0?ooo`1b0?ooo`030000003oool0oooo03/0oooo
00<000000?ooo`3oool0A@3oool004L0oooo00<000000?ooo`3oool0<P3oool00`000000oooo0?oo
o`0/0?ooo`030000003oool0oooo00l0oooo00<000000?ooo`3oool06P3oool00`000000oooo0?oo
o`0_0?ooo`030000003oool0oooo0540oooo00<000000?ooo`3oool0303oool00`000000oooo0?oo
o`1`0?ooo`030000003oool0oooo03/0oooo00<000000?ooo`3oool0AP3oool004P0oooo00<00000
0?ooo`3oool0<@3oool00`000000oooo0?ooo`0/0?ooo`030000003oool0oooo00l0oooo00<00000
0?ooo`3oool06@3oool00`000000oooo0?ooo`0_0?ooo`030000003oool0oooo0500oooo0P00000?
0?ooo`030000003oool0oooo0700oooo00<000000?ooo`3oool0>`3oool00`000000oooo0?ooo`16
0?ooo`00B03oool00`000000oooo0?ooo`0b0?ooo`030000003oool0oooo02/0oooo00<000000?oo
o`3oool03`3oool00`000000oooo0?ooo`0I0?ooo`030000003oool0oooo02h0oooo00<000000?oo
o`3oool0C`3oool200000180oooo00<000000?ooo`3oool0KP3oool00`000000oooo0?ooo`0k0?oo
o`030000003oool0oooo04L0oooo00190?ooo`030000003oool0oooo0380oooo00<000000?ooo`3o
ool0:P3oool00`000000oooo0?ooo`0?0?ooo`030000003oool0oooo01T0oooo00<000000?ooo`3o
ool0;@3oool00`000000oooo0?ooo`1>0?ooo`800000503oool00`000000oooo0?ooo`1^0?ooo`03
0000003oool0oooo03/0oooo00<000000?ooo`3oool0A`3oool004T0oooo00<000000?ooo`3oool0
<P3oool00`000000oooo0?ooo`0Z0?ooo`030000003oool0oooo00l0oooo00<000000?ooo`3oool0
603oool00`000000oooo0?ooo`0^0?ooo`030000003oool0oooo04d0oooo00<000000?ooo`3oool0
5@3oool00`000000oooo0?ooo`1/0?ooo`030000003oool0oooo03/0oooo00<000000?ooo`3oool0
B03oool004X0oooo00<000000?ooo`3oool0<P3oool00`000000oooo0?ooo`0Y0?ooo`030000003o
ool0oooo00l0oooo00<000000?ooo`3oool0603oool00`000000oooo0?ooo`0]0?ooo`030000003o
ool0oooo04`0oooo0P00000H0?ooo`030000003oool0oooo06`0oooo00<000000?ooo`3oool0>`3o
ool00`000000oooo0?ooo`180?ooo`00BP3oool00`000000oooo0?ooo`0c0?ooo`030000003oool0
oooo02T0oooo00<000000?ooo`3oool03P3oool00`000000oooo0?ooo`0H0?ooo`030000003oool0
oooo02`0oooo00<000000?ooo`3oool0B`3oool2000001X0oooo00<000000?ooo`3oool0J`3oool0
0`000000oooo0?ooo`0k0?ooo`030000003oool0oooo04T0oooo001;0?ooo`030000003oool0oooo
0380oooo00<000000?ooo`3oool0:@3oool00`000000oooo0?ooo`0>0?ooo`030000003oool0oooo
01L0oooo00<000000?ooo`3oool0;03oool00`000000oooo0?ooo`1;0?ooo`030000003oool0oooo
01/0oooo00<000000?ooo`3oool0JP3oool00`000000oooo0?ooo`0k0?ooo`030000003oool0oooo
04T0oooo001;0?ooo`030000003oool0oooo03<0oooo00<000000?ooo`3oool0:03oool00`000000
oooo0?ooo`0>0?ooo`030000003oool0oooo01L0oooo00<000000?ooo`3oool0:`3oool00`000000
oooo0?ooo`1:0?ooo`8000007P3oool00`000000oooo0?ooo`1Y0?ooo`030000003oool0oooo03/0
oooo00<000000?ooo`3oool0BP3oool004`0oooo00<000000?ooo`3oool0<`3oool00`000000oooo
0?ooo`0W0?ooo`030000003oool0oooo00h0oooo00<000000?ooo`3oool05`3oool00`000000oooo
0?ooo`0Z0?ooo`030000003oool0oooo04T0oooo0P00000Q0?ooo`030000003oool0oooo06L0oooo
00<000000?ooo`3oool0?03oool00`000000oooo0?ooo`1:0?ooo`00C03oool00`000000oooo0?oo
o`0c0?ooo`030000003oool0oooo02L0oooo00<000000?ooo`3oool03P3oool00`000000oooo0?oo
o`0F0?ooo`030000003oool0oooo02X0oooo00<000000?ooo`3oool0B03oool2000002<0oooo00<0
00000?ooo`3oool0I`3oool00`000000oooo0?ooo`0k0?ooo`030000003oool0oooo04/0oooo001=
0?ooo`030000003oool0oooo03<0oooo00<000000?ooo`3oool09P3oool00`000000oooo0?ooo`0>
0?ooo`030000003oool0oooo01H0oooo00<000000?ooo`3oool0:P3oool00`000000oooo0?ooo`17
0?ooo`030000003oool0oooo02<0oooo00<000000?ooo`3oool0IP3oool00`000000oooo0?ooo`0l
0?ooo`030000003oool0oooo04/0oooo001=0?ooo`030000003oool0oooo03<0oooo00<000000?oo
o`3oool09`3oool00`000000oooo0?ooo`0=0?ooo`030000003oool0oooo01H0oooo00<000000?oo
o`3oool0:@3oool00`000000oooo0?ooo`160?ooo`8000009`3oool00`000000oooo0?ooo`1U0?oo
o`030000003oool0oooo03/0oooo00<000000?ooo`3oool0C03oool004h0oooo00<000000?ooo`3o
ool0<`3oool00`000000oooo0?ooo`0V0?ooo`030000003oool0oooo00d0oooo00<000000?ooo`3o
ool05@3oool00`000000oooo0?ooo`0Y0?ooo`030000003oool0oooo04D0oooo0P00000Y0?ooo`03
0000003oool0oooo06@0oooo00<000000?ooo`3oool0?03oool00`000000oooo0?ooo`1<0?ooo`00
CP3oool00`000000oooo0?ooo`0d0?ooo`030000003oool0oooo02D0oooo00<000000?ooo`3oool0
3@3oool00`000000oooo0?ooo`0E0?ooo`030000003oool0oooo02P0oooo00<000000?ooo`3oool0
A03oool2000002`0oooo00<000000?ooo`3oool0H`3oool00`000000oooo0?ooo`0k0?ooo`030000
003oool0oooo04d0oooo001?0?ooo`030000003oool0oooo03<0oooo00<000000?ooo`3oool09@3o
ool00`000000oooo0?ooo`0=0?ooo`030000003oool0oooo01D0oooo00<000000?ooo`3oool09`3o
ool00`000000oooo0?ooo`140?ooo`030000003oool0oooo02`0oooo00<000000?ooo`3oool0HP3o
ool00`000000oooo0?ooo`0l0?ooo`030000003oool0oooo04d0oooo001?0?ooo`030000003oool0
oooo03@0oooo00<000000?ooo`3oool0903oool00`000000oooo0?ooo`0=0?ooo`030000003oool0
oooo01@0oooo00<000000?ooo`3oool09`3oool00`000000oooo0?ooo`130?ooo`800000;`3oool0
0`000000oooo0?ooo`1Q0?ooo`030000003oool0oooo03`0oooo00<000000?ooo`3oool0CP3oool0
0500oooo00<000000?ooo`3oool0=03oool00`000000oooo0?ooo`0S0?ooo`030000003oool0oooo
00`0oooo00<000000?ooo`3oool05@3oool00`000000oooo0?ooo`0V0?ooo`030000003oool0oooo
0480oooo0P00000b0?ooo`030000003oool0oooo0600oooo00<000000?ooo`3oool0?03oool00`00
0000oooo0?ooo`1>0?ooo`00D03oool00`000000oooo0?ooo`0d0?ooo`030000003oool0oooo02<0
oooo00<000000?ooo`3oool0303oool00`000000oooo0?ooo`0E0?ooo`030000003oool0oooo02H0
oooo00<000000?ooo`3oool0@@3oool00`000000oooo0?ooo`0b0?ooo`030000003oool0oooo05l0
oooo00<000000?ooo`3oool0?03oool00`000000oooo0?ooo`1?0?ooo`00D@3oool00`000000oooo
0?ooo`0d0?ooo`030000003oool0oooo02<0oooo00<000000?ooo`3oool02`3oool00`000000oooo
0?ooo`0D0?ooo`030000003oool0oooo02H0oooo00<000000?ooo`3oool0@03oool2000003H0oooo
00<000000?ooo`3oool0GP3oool00`000000oooo0?ooo`0l0?ooo`030000003oool0oooo04l0oooo
001A0?ooo`030000003oool0oooo03@0oooo00<000000?ooo`3oool08`3oool00`000000oooo0?oo
o`0;0?ooo`030000003oool0oooo01@0oooo00<000000?ooo`3oool09@3oool00`000000oooo0?oo
o`0o0?ooo`800000>03oool00`000000oooo0?ooo`1M0?ooo`030000003oool0oooo03`0oooo00<0
00000?ooo`3oool0D03oool00580oooo00<000000?ooo`3oool0=03oool00`000000oooo0?ooo`0R
0?ooo`030000003oool0oooo00/0oooo00<000000?ooo`3oool0503oool00`000000oooo0?ooo`0T
0?ooo`030000003oool0oooo03h0oooo0P00000k0?ooo`030000003oool0oooo05`0oooo00<00000
0?ooo`3oool0?03oool00`000000oooo0?ooo`1@0?ooo`00DP3oool00`000000oooo0?ooo`0e0?oo
o`030000003oool0oooo0240oooo00<000000?ooo`3oool02`3oool00`000000oooo0?ooo`0C0?oo
o`030000003oool0oooo02@0oooo00<000000?ooo`3oool0?P3oool00`000000oooo0?ooo`0k0?oo
o`030000003oool0oooo05/0oooo00<000000?ooo`3oool0?03oool00`000000oooo0?ooo`1A0?oo
o`00D`3oool00`000000oooo0?ooo`0d0?ooo`030000003oool0oooo0240oooo00<000000?ooo`3o
ool02`3oool00`000000oooo0?ooo`0C0?ooo`030000003oool0oooo02<0oooo00<000000?ooo`3o
ool0?@3oool2000003h0oooo00<000000?ooo`3oool0F`3oool00`000000oooo0?ooo`0l0?ooo`03
0000003oool0oooo0540oooo001C0?ooo`030000003oool0oooo03D0oooo00<000000?ooo`3oool0
803oool00`000000oooo0?ooo`0;0?ooo`030000003oool0oooo01<0oooo00<000000?ooo`3oool0
8P3oool00`000000oooo0?ooo`0l0?ooo`800000@@3oool00`000000oooo0?ooo`1I0?ooo`030000
003oool0oooo03`0oooo00<000000?ooo`3oool0DP3oool005@0oooo00<000000?ooo`3oool0=@3o
ool00`000000oooo0?ooo`0O0?ooo`030000003oool0oooo00/0oooo00<000000?ooo`3oool04P3o
ool00`000000oooo0?ooo`0S0?ooo`030000003oool0oooo03/0oooo00<000000?ooo`3oool0@@3o
ool00`000000oooo0?ooo`1H0?ooo`030000003oool0oooo03d0oooo00<000000?ooo`3oool0DP3o
ool005@0oooo00<000000?ooo`3oool0=@3oool00`000000oooo0?ooo`0P0?ooo`030000003oool0
oooo00X0oooo00<000000?ooo`3oool04P3oool00`000000oooo0?ooo`0R0?ooo`030000003oool0
oooo03X0oooo0P0000150?ooo`030000003oool0oooo05L0oooo00<000000?ooo`3oool0?03oool0
0`000000oooo0?ooo`1C0?ooo`00E@3oool00`000000oooo0?ooo`0e0?ooo`030000003oool0oooo
01l0oooo00<000000?ooo`3oool02P3oool00`000000oooo0?ooo`0B0?ooo`030000003oool0oooo
0240oooo00<000000?ooo`3oool0>@3oool2000004L0oooo00<000000?ooo`3oool0EP3oool00`00
0000oooo0?ooo`0m0?ooo`030000003oool0oooo05<0oooo001E0?ooo`030000003oool0oooo03D0
oooo00<000000?ooo`3oool07`3oool00`000000oooo0?ooo`0:0?ooo`030000003oool0oooo0140
oooo00<000000?ooo`3oool08@3oool00`000000oooo0?ooo`0h0?ooo`800000B@3oool00`000000
oooo0?ooo`1F0?ooo`030000003oool0oooo03`0oooo00<000000?ooo`3oool0E03oool005H0oooo
00<000000?ooo`3oool0=@3oool00`000000oooo0?ooo`0N0?ooo`030000003oool0oooo00X0oooo
00<000000?ooo`3oool04@3oool00`000000oooo0?ooo`0P0?ooo`030000003oool0oooo03P0oooo
00<000000?ooo`3oool0BP3oool00`000000oooo0?ooo`1D0?ooo`030000003oool0oooo03d0oooo
00<000000?ooo`3oool0E03oool005H0oooo00<000000?ooo`3oool0=P3oool00`000000oooo0?oo
o`0M0?ooo`030000003oool0oooo00X0oooo00<000000?ooo`3oool04@3oool00`000000oooo0?oo
o`0O0?ooo`030000003oool0oooo03L0oooo0P00001=0?ooo`030000003oool0oooo05@0oooo00<0
00000?ooo`3oool0?03oool00`000000oooo0?ooo`1E0?ooo`00E`3oool00`000000oooo0?ooo`0e
0?ooo`030000003oool0oooo01d0oooo00<000000?ooo`3oool02P3oool00`000000oooo0?ooo`0@
0?ooo`030000003oool0oooo01l0oooo00<000000?ooo`3oool0=P3oool200000500oooo00<00000
0?ooo`3oool0DP3oool00`000000oooo0?ooo`0m0?ooo`030000003oool0oooo05D0oooo001G0?oo
o`030000003oool0oooo03H0oooo00<000000?ooo`3oool0703oool00`000000oooo0?ooo`0:0?oo
o`030000003oool0oooo0100oooo00<000000?ooo`3oool07`3oool00`000000oooo0?ooo`0e0?oo
o`030000003oool0oooo0500oooo00<000000?ooo`3oool0DP3oool00`000000oooo0?ooo`0l0?oo
o`030000003oool0oooo05H0oooo001H0?ooo`030000003oool0oooo03H0oooo00<000000?ooo`3o
ool0703oool00`000000oooo0?ooo`090?ooo`030000003oool0oooo0100oooo00<000000?ooo`3o
ool07P3oool00`000000oooo0?ooo`0d0?ooo`800000E03oool00`000000oooo0?ooo`1@0?ooo`03
0000003oool0oooo03d0oooo00<000000?ooo`3oool0EP3oool005P0oooo00<000000?ooo`3oool0
=P3oool00`000000oooo0?ooo`0L0?ooo`030000003oool0oooo00T0oooo00<000000?ooo`3oool0
3`3oool00`000000oooo0?ooo`0N0?ooo`030000003oool0oooo03<0oooo0P00001F0?ooo`030000
003oool0oooo04l0oooo00<000000?ooo`3oool0?@3oool00`000000oooo0?ooo`1G0?ooo`00F@3o
ool00`000000oooo0?ooo`0f0?ooo`030000003oool0oooo01/0oooo00<000000?ooo`3oool02@3o
ool00`000000oooo0?ooo`0?0?ooo`030000003oool0oooo01d0oooo00<000000?ooo`3oool0<P3o
ool2000005P0oooo00<000000?ooo`3oool0C`3oool00`000000oooo0?ooo`0m0?ooo`030000003o
ool0oooo05L0oooo001I0?ooo`030000003oool0oooo03L0oooo00<000000?ooo`3oool06P3oool0
0`000000oooo0?ooo`090?ooo`030000003oool0oooo00l0oooo00<000000?ooo`3oool0703oool0
0`000000oooo0?ooo`0b0?ooo`030000003oool0oooo05T0oooo00<000000?ooo`3oool0C@3oool0
0`000000oooo0?ooo`0m0?ooo`030000003oool0oooo05P0oooo001J0?ooo`030000003oool0oooo
03H0oooo00<000000?ooo`3oool06P3oool00`000000oooo0?ooo`090?ooo`030000003oool0oooo
00h0oooo00<000000?ooo`3oool0703oool00`000000oooo0?ooo`0a0?ooo`800000G03oool00`00
0000oooo0?ooo`1=0?ooo`030000003oool0oooo03d0oooo00<000000?ooo`3oool0F03oool005X0
oooo00<000000?ooo`3oool0=`3oool00`000000oooo0?ooo`0I0?ooo`030000003oool0oooo00T0
oooo00<000000?ooo`3oool03P3oool00`000000oooo0?ooo`0K0?ooo`030000003oool0oooo0300
oooo0P00001O0?ooo`030000003oool0oooo04/0oooo00<000000?ooo`3oool0?@3oool00`000000
oooo0?ooo`1I0?ooo`00F`3oool00`000000oooo0?ooo`0f0?ooo`030000003oool0oooo01T0oooo
00<000000?ooo`3oool02@3oool00`000000oooo0?ooo`0>0?ooo`030000003oool0oooo01/0oooo
00<000000?ooo`3oool0;P3oool200000640oooo00<000000?ooo`3oool0B`3oool00`000000oooo
0?ooo`0m0?ooo`030000003oool0oooo05T0oooo001K0?ooo`030000003oool0oooo03L0oooo00<0
00000?ooo`3oool06@3oool00`000000oooo0?ooo`070?ooo`030000003oool0oooo00h0oooo00<0
00000?ooo`3oool06`3oool00`000000oooo0?ooo`0^0?ooo`030000003oool0oooo0640oooo00<0
00000?ooo`3oool0BP3oool00`000000oooo0?ooo`0m0?ooo`030000003oool0oooo05X0oooo001L
0?ooo`030000003oool0oooo03L0oooo00<000000?ooo`3oool0603oool00`000000oooo0?ooo`07
0?ooo`030000003oool0oooo00h0oooo00<000000?ooo`3oool06P3oool00`000000oooo0?ooo`0]
0?ooo`800000I@3oool00`000000oooo0?ooo`190?ooo`030000003oool0oooo03d0oooo00<00000
0?ooo`3oool0FP3oool005`0oooo00<000000?ooo`3oool0=`3oool00`000000oooo0?ooo`0H0?oo
o`030000003oool0oooo00L0oooo00<000000?ooo`3oool03P3oool00`000000oooo0?ooo`0I0?oo
o`030000003oool0oooo02`0oooo0P00001W0?ooo`030000003oool0oooo04P0oooo00<000000?oo
o`3oool0?@3oool00`000000oooo0?ooo`1K0?ooo`00G@3oool00`000000oooo0?ooo`0g0?ooo`03
0000003oool0oooo01L0oooo00<000000?ooo`3oool01`3oool00`000000oooo0?ooo`0=0?ooo`03
0000003oool0oooo01T0oooo00<000000?ooo`3oool0;03oool00`000000oooo0?ooo`1X0?ooo`03
0000003oool0oooo04H0oooo00<000000?ooo`3oool0?P3oool00`000000oooo0?ooo`1K0?ooo`00
G@3oool00`000000oooo0?ooo`0h0?ooo`030000003oool0oooo01H0oooo00<000000?ooo`3oool0
1`3oool00`000000oooo0?ooo`0=0?ooo`030000003oool0oooo01P0oooo00<000000?ooo`3oool0
:`3oool2000006/0oooo00<000000?ooo`3oool0AP3oool00`000000oooo0?ooo`0m0?ooo`030000
003oool0oooo05`0oooo001N0?ooo`030000003oool0oooo03L0oooo00<000000?ooo`3oool05P3o
ool00`000000oooo0?ooo`070?ooo`030000003oool0oooo00d0oooo00<000000?ooo`3oool0603o
ool00`000000oooo0?ooo`0Y0?ooo`800000K@3oool00`000000oooo0?ooo`150?ooo`030000003o
ool0oooo03h0oooo00<000000?ooo`3oool0G03oool005h0oooo00<000000?ooo`3oool0>03oool0
0`000000oooo0?ooo`0F0?ooo`030000003oool0oooo00H0oooo00<000000?ooo`3oool0303oool0
0`000000oooo0?ooo`0H0?ooo`030000003oool0oooo02P0oooo0P00001`0?ooo`030000003oool0
oooo04@0oooo00<000000?ooo`3oool0?@3oool00`000000oooo0?ooo`1M0?ooo`00G`3oool00`00
0000oooo0?ooo`0g0?ooo`030000003oool0oooo01H0oooo00<000000?ooo`3oool01P3oool00`00
0000oooo0?ooo`0<0?ooo`030000003oool0oooo01L0oooo00<000000?ooo`3oool0:03oool00`00
0000oooo0?ooo`1`0?ooo`030000003oool0oooo04<0oooo00<000000?ooo`3oool0?P3oool00`00
0000oooo0?ooo`1M0?ooo`00G`3oool00`000000oooo0?ooo`0h0?ooo`030000003oool0oooo01D0
oooo00<000000?ooo`3oool01P3oool00`000000oooo0?ooo`0<0?ooo`030000003oool0oooo01H0
oooo00<000000?ooo`3oool09`3oool2000007@0oooo00<000000?ooo`3oool0@P3oool00`000000
oooo0?ooo`0m0?ooo`030000003oool0oooo05h0oooo001P0?ooo`030000003oool0oooo03P0oooo
00<000000?ooo`3oool0503oool00`000000oooo0?ooo`060?ooo`030000003oool0oooo00/0oooo
00<000000?ooo`3oool05P3oool00`000000oooo0?ooo`0V0?ooo`800000MP3oool00`000000oooo
0?ooo`110?ooo`030000003oool0oooo03h0oooo00<000000?ooo`3oool0GP3oool00600oooo00<0
00000?ooo`3oool0>03oool00`000000oooo0?ooo`0D0?ooo`030000003oool0oooo00H0oooo00<0
00000?ooo`3oool02`3oool00`000000oooo0?ooo`0E0?ooo`030000003oool0oooo02H0oooo00<0
00000?ooo`3oool0M`3oool00`000000oooo0?ooo`100?ooo`030000003oool0oooo03d0oooo00<0
00000?ooo`3oool0G`3oool00640oooo00<000000?ooo`3oool0>03oool00`000000oooo0?ooo`0C
0?ooo`030000003oool0oooo00H0oooo00<000000?ooo`3oool02P3oool00`000000oooo0?ooo`0E
0?ooo`030000003oool0oooo02D0oooo0P00001j0?ooo`030000003oool0oooo03l0oooo00<00000
0?ooo`3oool0?P3oool00`000000oooo0?ooo`1O0?ooo`00H@3oool00`000000oooo0?ooo`0i0?oo
o`030000003oool0oooo0180oooo00<000000?ooo`3oool01P3oool00`000000oooo0?ooo`0:0?oo
o`030000003oool0oooo01D0oooo00<000000?ooo`3oool08`3oool2000007`0oooo00<000000?oo
o`3oool0?P3oool00`000000oooo0?ooo`0n0?ooo`030000003oool0oooo0600oooo001R0?ooo`03
0000003oool0oooo03P0oooo00<000000?ooo`3oool04`3oool00`000000oooo0?ooo`050?ooo`03
0000003oool0oooo00X0oooo00<000000?ooo`3oool0503oool00`000000oooo0?ooo`0R0?ooo`80
0000O`3oool00`000000oooo0?ooo`0m0?ooo`030000003oool0oooo03d0oooo00<000000?ooo`3o
ool0H@3oool00680oooo00<000000?ooo`3oool0>@3oool00`000000oooo0?ooo`0B0?ooo`030000
003oool0oooo00D0oooo00<000000?ooo`3oool02@3oool00`000000oooo0?ooo`0D0?ooo`030000
003oool0oooo0280oooo00<000000?ooo`3oool0O`3oool00`000000oooo0?ooo`0l0?ooo`030000
003oool0oooo03h0oooo00<000000?ooo`3oool0H@3oool006<0oooo00<000000?ooo`3oool0>@3o
ool00`000000oooo0?ooo`0A0?ooo`030000003oool0oooo00D0oooo00<000000?ooo`3oool02@3o
ool00`000000oooo0?ooo`0C0?ooo`030000003oool0oooo0240oooo0P0000230?ooo`030000003o
ool0oooo03/0oooo00<000000?ooo`3oool0?@3oool00`000000oooo0?ooo`1R0?ooo`00H`3oool0
0`000000oooo0?ooo`0i0?ooo`030000003oool0oooo0140oooo00<000000?ooo`3oool01@3oool0
0`000000oooo0?ooo`090?ooo`030000003oool0oooo0180oooo00<000000?ooo`3oool0803oool2
000008D0oooo00<000000?ooo`3oool0>P3oool00`000000oooo0?ooo`0n0?ooo`030000003oool0
oooo0680oooo001T0?ooo`030000003oool0oooo03T0oooo00<000000?ooo`3oool0403oool00`00
0000oooo0?ooo`050?ooo`030000003oool0oooo00P0oooo00<000000?ooo`3oool04P3oool00`00
0000oooo0?ooo`0O0?ooo`800000Q`3oool00`000000oooo0?ooo`0j0?ooo`030000003oool0oooo
03d0oooo00<000000?ooo`3oool0H`3oool006@0oooo00<000000?ooo`3oool0>@3oool00`000000
oooo0?ooo`0@0?ooo`030000003oool0oooo00D0oooo00<000000?ooo`3oool0203oool00`000000
oooo0?ooo`0A0?ooo`030000003oool0oooo01l0oooo00<000000?ooo`3oool0R03oool00`000000
oooo0?ooo`0h0?ooo`030000003oool0oooo03h0oooo00<000000?ooo`3oool0H`3oool006D0oooo
00<000000?ooo`3oool0>@3oool00`000000oooo0?ooo`0?0?ooo`030000003oool0oooo00D0oooo
00<000000?ooo`3oool0203oool00`000000oooo0?ooo`0A0?ooo`030000003oool0oooo01d0oooo
0P00002;0?ooo`030000003oool0oooo03L0oooo00<000000?ooo`3oool0?P3oool00`000000oooo
0?ooo`1T0?ooo`00I@3oool00`000000oooo0?ooo`0j0?ooo`030000003oool0oooo00l0oooo00<0
00000?ooo`3oool0103oool00`000000oooo0?ooo`070?ooo`030000003oool0oooo0140oooo00<0
00000?ooo`3oool0703oool2000008h0oooo00<000000?ooo`3oool0=P3oool00`000000oooo0?oo
o`0n0?ooo`030000003oool0oooo06@0oooo001V0?ooo`030000003oool0oooo03T0oooo00<00000
0?ooo`3oool03`3oool00`000000oooo0?ooo`040?ooo`030000003oool0oooo00L0oooo00<00000
0?ooo`3oool0403oool00`000000oooo0?ooo`0L0?ooo`030000003oool0oooo08h0oooo00<00000
0?ooo`3oool0=@3oool00`000000oooo0?ooo`0n0?ooo`030000003oool0oooo06D0oooo001V0?oo
o`030000003oool0oooo03X0oooo00<000000?ooo`3oool03P3oool00`000000oooo0?ooo`040?oo
o`030000003oool0oooo00L0oooo00<000000?ooo`3oool03`3oool00`000000oooo0?ooo`0K0?oo
o`800000T@3oool00`000000oooo0?ooo`0e0?ooo`030000003oool0oooo03h0oooo00<000000?oo
o`3oool0I@3oool006L0oooo00<000000?ooo`3oool0>P3oool00`000000oooo0?ooo`0=0?ooo`03
0000003oool0oooo00<0oooo00<000000?ooo`3oool01`3oool00`000000oooo0?ooo`0?0?ooo`03
0000003oool0oooo01X0oooo0P00002D0?ooo`030000003oool0oooo03<0oooo00<000000?ooo`3o
ool0?P3oool00`000000oooo0?ooo`1V0?ooo`00I`3oool00`000000oooo0?ooo`0j0?ooo`030000
003oool0oooo00d0oooo00<000000?ooo`3oool00`3oool00`000000oooo0?ooo`070?ooo`030000
003oool0oooo00h0oooo00<000000?ooo`3oool06@3oool2000009H0oooo00<000000?ooo`3oool0
<`3oool00`000000oooo0?ooo`0n0?ooo`030000003oool0oooo06H0oooo001X0?ooo`030000003o
ool0oooo03X0oooo00<000000?ooo`3oool0303oool00`000000oooo0?ooo`030?ooo`030000003o
ool0oooo00L0oooo00<000000?ooo`3oool03@3oool00`000000oooo0?ooo`0I0?ooo`030000003o
ool0oooo09L0oooo00<000000?ooo`3oool0<@3oool00`000000oooo0?ooo`0n0?ooo`030000003o
ool0oooo06L0oooo001X0?ooo`030000003oool0oooo03X0oooo00<000000?ooo`3oool0303oool0
0`000000oooo0?ooo`030?ooo`030000003oool0oooo00H0oooo00<000000?ooo`3oool03P3oool0
0`000000oooo0?ooo`0G0?ooo`800000VP3oool00`000000oooo0?ooo`0a0?ooo`030000003oool0
oooo03h0oooo00<000000?ooo`3oool0I`3oool006T0oooo00<000000?ooo`3oool0>P3oool00`00
0000oooo0?ooo`0<0?ooo`030000003oool0oooo0080oooo00<000000?ooo`3oool01P3oool00`00
0000oooo0?ooo`0=0?ooo`030000003oool0oooo01H0oooo0P00002M0?ooo`030000003oool0oooo
02l0oooo00<000000?ooo`3oool0?P3oool00`000000oooo0?ooo`1X0?ooo`00J@3oool00`000000
oooo0?ooo`0k0?ooo`030000003oool0oooo00/0oooo00<000000?ooo`3oool00P3oool00`000000
oooo0?ooo`060?ooo`030000003oool0oooo00`0oooo00<000000?ooo`3oool05P3oool00`000000
oooo0?ooo`2M0?ooo`030000003oool0oooo02h0oooo00<000000?ooo`3oool0?`3oool00`000000
oooo0?ooo`1X0?ooo`00JP3oool00`000000oooo0?ooo`0j0?ooo`030000003oool0oooo00/0oooo
00<000000?ooo`3oool00P3oool00`000000oooo0?ooo`050?ooo`030000003oool0oooo00`0oooo
00<000000?ooo`3oool05@3oool200000:00oooo00<000000?ooo`3oool0;P3oool00`000000oooo
0?ooo`0n0?ooo`030000003oool0oooo06T0oooo001Z0?ooo`030000003oool0oooo03/0oooo00<0
00000?ooo`3oool02P3oool00`000000oooo0?ooo`020?ooo`030000003oool0oooo00D0oooo00<0
00000?ooo`3oool02`3oool00`000000oooo0?ooo`0D0?ooo`800000X`3oool00`000000oooo0?oo
o`0/0?ooo`030000003oool0oooo03l0oooo00<000000?ooo`3oool0J@3oool006/0oooo00<00000
0?ooo`3oool0>`3oool00`000000oooo0?ooo`090?ooo`030000003oool0oooo0080oooo00<00000
0?ooo`3oool01@3oool00`000000oooo0?ooo`0:0?ooo`030000003oool0oooo01<0oooo0P00002U
0?ooo`030000003oool0oooo02`0oooo00<000000?ooo`3oool0?P3oool00`000000oooo0?ooo`1Z
0?ooo`00J`3oool00`000000oooo0?ooo`0k0?ooo`030000003oool0oooo00T0oooo00<000000?oo
o`3oool00P3oool00`000000oooo0?ooo`040?ooo`030000003oool0oooo00X0oooo00<000000?oo
o`3oool04`3oool00`000000oooo0?ooo`2V0?ooo`030000003oool0oooo02X0oooo00<000000?oo
o`3oool0?`3oool00`000000oooo0?ooo`1Z0?ooo`00K03oool00`000000oooo0?ooo`0k0?ooo`03
0000003oool0oooo00P0oooo00<000000?ooo`3oool00P3oool00`000000oooo0?ooo`040?ooo`03
0000003oool0oooo00X0oooo00<000000?ooo`3oool04@3oool200000:T0oooo00<000000?ooo`3o
ool0:P3oool00`000000oooo0?ooo`0n0?ooo`030000003oool0oooo06/0oooo001/0?ooo`030000
003oool0oooo03/0oooo00<000000?ooo`3oool02@3oool01@000000oooo0?ooo`3oool0000000H0
oooo00<000000?ooo`3oool02@3oool00`000000oooo0?ooo`0@0?ooo`800000Z`3oool00`000000
oooo0?ooo`0Y0?ooo`030000003oool0oooo03l0oooo00<000000?ooo`3oool0J`3oool006d0oooo
00<000000?ooo`3oool0>`3oool00`000000oooo0?ooo`080?ooo`050000003oool0oooo0?ooo`00
00001@3oool00`000000oooo0?ooo`090?ooo`030000003oool0oooo0100oooo00<000000?ooo`3o
ool0[03oool00`000000oooo0?ooo`0X0?ooo`030000003oool0oooo03h0oooo00<000000?ooo`3o
ool0K03oool006d0oooo00<000000?ooo`3oool0?03oool00`000000oooo0?ooo`070?ooo`050000
003oool0oooo0?ooo`0000001@3oool00`000000oooo0?ooo`080?ooo`030000003oool0oooo00l0
oooo0P00002_0?ooo`030000003oool0oooo02L0oooo00<000000?ooo`3oool0?`3oool00`000000
oooo0?ooo`1/0?ooo`00KP3oool00`000000oooo0?ooo`0k0?ooo`030000003oool0oooo00L0oooo
00D000000?ooo`3oool0oooo000000050?ooo`030000003oool0oooo00L0oooo00<000000?ooo`3o
ool03P3oool200000;80oooo00<000000?ooo`3oool09@3oool00`000000oooo0?ooo`0o0?ooo`03
0000003oool0oooo06d0oooo001^0?ooo`030000003oool0oooo03`0oooo00<000000?ooo`3oool0
1P3oool01@000000oooo0?ooo`3oool0000000@0oooo00<000000?ooo`3oool01`3oool00`000000
oooo0?ooo`0=0?ooo`800000]03oool00`000000oooo0?ooo`0U0?ooo`030000003oool0oooo03l0
oooo00<000000?ooo`3oool0K@3oool006l0oooo00<000000?ooo`3oool0?03oool00`000000oooo
0?ooo`050?ooo`050000003oool0oooo0?ooo`000000103oool00`000000oooo0?ooo`060?ooo`03
0000003oool0oooo00d0oooo00<000000?ooo`3oool0]03oool00`000000oooo0?ooo`0T0?ooo`03
0000003oool0oooo03l0oooo00<000000?ooo`3oool0KP3oool006l0oooo00<000000?ooo`3oool0
?03oool00`000000oooo0?ooo`060?ooo`040000003oool0oooo000000@0oooo00<000000?ooo`3o
ool01P3oool00`000000oooo0?ooo`0;0?ooo`800000^03oool00`000000oooo0?ooo`0S0?ooo`03
0000003oool0oooo03l0oooo00<000000?ooo`3oool0KP3oool00700oooo00<000000?ooo`3oool0
?03oool00`000000oooo0?ooo`050?ooo`040000003oool0oooo000000<0oooo00<000000?ooo`3o
ool01P3oool00`000000oooo0?ooo`0:0?ooo`800000^P3oool00`000000oooo0?ooo`0R0?ooo`03
0000003oool0oooo03l0oooo00<000000?ooo`3oool0K`3oool00700oooo00<000000?ooo`3oool0
?@3oool00`000000oooo0?ooo`040?ooo`040000003oool0oooo000000<0oooo00<000000?ooo`3o
ool01@3oool00`000000oooo0?ooo`090?ooo`800000_@3oool00`000000oooo0?ooo`0Q0?ooo`03
0000003oool0oooo03l0oooo00<000000?ooo`3oool0K`3oool00740oooo00<000000?ooo`3oool0
?03oool00`000000oooo0?ooo`040?ooo`040000003oool0oooo000000<0oooo00<000000?ooo`3o
ool0103oool00`000000oooo0?ooo`090?ooo`030000003oool0oooo0;d0oooo00<000000?ooo`3o
ool0803oool00`000000oooo0?ooo`0o0?ooo`030000003oool0oooo0700oooo001a0?ooo`030000
003oool0oooo03d0oooo00<000000?ooo`3oool00`3oool010000000oooo0?ooo`0000020?ooo`03
0000003oool0oooo00@0oooo00<000000?ooo`3oool0203oool200000<40oooo00<000000?ooo`3o
ool07`3oool00`000000oooo0?ooo`0o0?ooo`030000003oool0oooo0700oooo001b0?ooo`030000
003oool0oooo03`0oooo00<000000?ooo`3oool00`3oool010000000oooo0?ooo`0000020?ooo`03
0000003oool0oooo00<0oooo00<000000?ooo`3oool01`3oool200000<<0oooo00<000000?ooo`3o
ool07P3oool00`000000oooo0?ooo`0o0?ooo`030000003oool0oooo0740oooo001b0?ooo`030000
003oool0oooo03d0oooo00<000000?ooo`3oool00P3oool00`000000oooo000000030?ooo`030000
003oool0oooo0080oooo00<000000?ooo`3oool01`3oool00`000000oooo0?ooo`330?ooo`030000
003oool0oooo01d0oooo00<000000?ooo`3oool0@03oool00`000000oooo0?ooo`1a0?ooo`00L`3o
ool00`000000oooo0?ooo`0m0?ooo`030000003oool0oooo0080oooo0P0000020?ooo`030000003o
ool0oooo00<0oooo00<000000?ooo`3oool01@3oool200000<L0oooo00<000000?ooo`3oool0703o
ool00`000000oooo0?ooo`0o0?ooo`030000003oool0oooo0780oooo001c0?ooo`030000003oool0
oooo03d0oooo00<000000?ooo`3oool00P3oool200000080oooo00<000000?ooo`3oool00P3oool0
0`000000oooo0?ooo`040?ooo`800000b@3oool00`000000oooo0?ooo`0K0?ooo`030000003oool0
oooo0400oooo00<000000?ooo`3oool0LP3oool007@0oooo00<000000?ooo`3oool0?@3oool01000
0000oooo0?ooo`3oool200000080oooo00D000000?ooo`3oool0oooo000000050?ooo`800000c03o
ool00`000000oooo0?ooo`0J0?ooo`030000003oool0oooo03l0oooo00<000000?ooo`3oool0L`3o
ool007@0oooo00<000000?ooo`3oool0?P3oool00`000000oooo0?ooo`02000000030?ooo`000000
oooo0080oooo00<000000?ooo`3oool00`3oool00`000000oooo0?ooo`3<0?ooo`030000003oool0
oooo01T0oooo00<000000?ooo`3oool0@03oool00`000000oooo0?ooo`1c0?ooo`00M@3oool00`00
0000oooo0?ooo`0m0?ooo`030000003oool0oooo0080000000D0oooo0000003oool0oooo00000004
0?ooo`800000c`3oool00`000000oooo0?ooo`0I0?ooo`030000003oool0oooo03l0oooo00<00000
0?ooo`3oool0M03oool007D0oooo00<000000?ooo`3oool0?P3oool020000000oooo000000000000
oooo0000003oool000000`3oool200000=80oooo00<000000?ooo`3oool05`3oool00`000000oooo
0?ooo`100?ooo`030000003oool0oooo07@0oooo001f0?ooo`030000003oool0oooo03`0oooo2000
00030?ooo`030000003oool0oooo0=80oooo00<000000?ooo`3oool05`3oool00`000000oooo0?oo
o`0o0?ooo`030000003oool0oooo07D0oooo001f0?ooo`030000003oool0oooo03/0oooo3000003F
0?ooo`030000003oool0oooo01D0oooo00<000000?ooo`3oool0@03oool00`000000oooo0?ooo`1e
0?ooo`00M`3oool00`000000oooo0?ooo`0j0?ooo`X00000f03oool00`000000oooo0?ooo`0D0?oo
o`030000003oool0oooo0400oooo00<000000?ooo`3oool0MP3oool007L0oooo00<000000?ooo`3o
ool0>P3oool:00000=T0oooo00<000000?ooo`3oool04`3oool00`000000oooo0?ooo`100?ooo`03
0000003oool0oooo07H0oooo001h0?ooo`030000003oool0oooo03P0oooo3000003H0?ooo`030000
003oool0oooo0180oooo00<000000?ooo`3oool0@03oool00`000000oooo0?ooo`1g0?ooo`00N03o
ool00`000000oooo0?ooo`0h0?oooaH00000cP3oool00`000000oooo0?ooo`0B0?ooo`030000003o
ool0oooo0400oooo00<000000?ooo`3oool0M`3oool007T0oooo00<000000?ooo`3oool0>03oool:
000000/0oooo2`0000340?ooo`030000003oool0oooo0100oooo00<000000?ooo`3oool0@03oool0
0`000000oooo0?ooo`1h0?ooo`00N@3oool00`000000oooo0?ooo`0h0?ooo`X000005P3oool:0000
0;X0oooo00<000000?ooo`3oool0403oool00`000000oooo0?ooo`100?ooo`030000003oool0oooo
07P0oooo001j0?ooo`030000003oool0oooo03L0oooo2P00000P0?ooo`/00000/03oool00`000000
oooo0?ooo`0>0?ooo`030000003oool0oooo0400oooo00<000000?ooo`3oool0N@3oool007X0oooo
00<000000?ooo`3oool0>03oool8000002`0oooo2P00002V0?ooo`030000003oool0oooo00d0oooo
00<000000?ooo`3oool0@@3oool00`000000oooo0?ooo`1i0?ooo`00N`3oool00`000000oooo0?oo
o`0j0?ooo`800000>@3oool;000009/0oooo00<000000?ooo`3oool03@3oool00`000000oooo0?oo
o`100?ooo`030000003oool0oooo07X0oooo001k0?ooo`030000003oool0oooo03X0oooo00<00000
0?ooo`3oool0@`3oool:00000980oooo00<000000?ooo`3oool02`3oool00`000000oooo0?ooo`11
0?ooo`030000003oool0oooo07X0oooo001l0?ooo`030000003oool0oooo03T0oooo00<000000?oo
o`3oool0C@3oool;000008L0oooo00<000000?ooo`3oool02`3oool00`000000oooo0?ooo`100?oo
o`030000003oool0oooo07/0oooo001l0?ooo`030000003oool0oooo03P0oooo00<000000?ooo`3o
ool0F@3oool:000007h0oooo00<000000?ooo`3oool02@3oool00`000000oooo0?ooo`110?ooo`03
0000003oool0oooo07/0oooo001m0?ooo`030000003oool0oooo03L0oooo00<000000?ooo`3oool0
H`3oool;000007<0oooo00<000000?ooo`3oool02@3oool00`000000oooo0?ooo`100?ooo`030000
003oool0oooo07`0oooo001m0?ooo`030000003oool0oooo03L0oooo00<000000?ooo`3oool0KP3o
ool:000006T0oooo00<000000?ooo`3oool0203oool00`000000oooo0?ooo`110?ooo`030000003o
ool0oooo07`0oooo001n0?ooo`030000003oool0oooo03H0oooo00<000000?ooo`3oool0N03oool;
000005l0oooo00<000000?ooo`3oool01`3oool00`000000oooo0?ooo`100?ooo`030000003oool0
oooo07d0oooo001n0?ooo`030000003oool0oooo03H0oooo00<000000?ooo`3oool0P`3oool:0000
05D0oooo00<000000?ooo`3oool01P3oool00`000000oooo0?ooo`110?ooo`030000003oool0oooo
07d0oooo001o0?ooo`030000003oool0oooo03D0oooo00<000000?ooo`3oool0S@3oool;000004/0
oooo00<000000?ooo`3oool0103oool00`000000oooo0?ooo`110?ooo`030000003oool0oooo07h0
oooo001o0?ooo`030000003oool0oooo03@0oooo00<000000?ooo`3oool0V@3oool:00000440oooo
00<000000?ooo`3oool0103oool00`000000oooo0?ooo`110?ooo`030000003oool0oooo07h0oooo
00200?ooo`030000003oool0oooo03<0oooo00<000000?ooo`3oool0X`3oool;000003L0oooo00<0
00000?ooo`3oool00P3oool00`000000oooo0?ooo`110?ooo`030000003oool0oooo07l0oooo0020
0?ooo`030000003oool0oooo03<0oooo00<000000?ooo`3oool0[P3oool:000002d0oooo00H00000
0?ooo`00000000000?ooo`0000130?ooo`030000003oool0oooo07l0oooo00210?ooo`030000003o
ool0oooo0380oooo00<000000?ooo`3oool0^03oool;00000240oooo200000110?ooo`030000003o
ool0oooo0800oooo00210?ooo`030000003oool0oooo0380oooo00<000000?ooo`3oool0``3oool:
000001H0oooo2P0000100?ooo`030000003oool0oooo0800oooo00220?ooo`030000003oool0oooo
0300oooo00<000000?ooo`3oool0cP3oool;000000/0oooo2P00000o0?ooo`030000003oool0oooo
0840oooo00220?ooo`030000003oool0oooo0300oooo00<000000?ooo`3oool0f@3oool:00000003
0?ooo`000000000000P00000?`3oool00`000000oooo0?ooo`210?ooo`00P`3oool00`000000oooo
0?ooo`0_0?ooo`030000003oool0oooo0><0oooo3000000m0?ooo`030000003oool0oooo0880oooo
00230?ooo`030000003oool0oooo02l0oooo00<000000?ooo`3oool0h`3oool<000003d0oooo00<0
00000?ooo`3oool0PP3oool008@0oooo00<000000?ooo`3oool0;P3oool00`000000oooo0?ooo`3T
0?ooo`X00000?@3oool00`000000oooo0?ooo`230?ooo`00Q03oool00`000000oooo0?ooo`0^0?oo
o`030000003oool0oooo0>@0oooo2P00000m0?ooo`030000003oool0oooo08<0oooo00250?ooo`03
0000003oool0oooo02`0oooo00<000000?ooo`3oool0i@3oool:000003`0oooo00<000000?ooo`3o
ool0Q03oool008D0oooo00<000000?ooo`3oool0;03oool00`000000oooo0?ooo`3V0?ooo`P00000
?@3oool00`000000oooo0?ooo`240?ooo`00QP3oool00`000000oooo0?ooo`0[0?ooo`030000003o
ool0oooo0>T0oooo0P0000000`3oool000000?ooo`0l0?ooo`030000003oool0oooo08D0oooo0026
0?ooo`030000003oool0oooo02/0oooo00<000000?ooo`3oool0k03oool00`000000oooo0?ooo`0k
0?ooo`030000003oool0oooo08D0oooo00270?ooo`030000003oool0oooo02X0oooo00<000000?oo
o`3oool0k03oool00`000000oooo0?ooo`0j0?ooo`030000003oool0oooo08H0oooo00270?ooo`03
0000003oool0oooo02X0oooo00<000000?ooo`3oool0k@3oool00`000000oooo0?ooo`0i0?ooo`03
0000003oool0oooo08H0oooo00280?ooo`030000003oool0oooo02P0oooo00<000000?ooo`3oool0
kP3oool00`000000oooo0?ooo`0h0?ooo`030000003oool0oooo08L0oooo00280?ooo`030000003o
ool0oooo02P0oooo00<000000?ooo`3oool0k`3oool00`000000oooo0?ooo`0g0?ooo`030000003o
ool0oooo08L0oooo00290?ooo`030000003oool0oooo02L0oooo00<000000?ooo`3oool0k`3oool0
0`000000oooo0?ooo`0f0?ooo`030000003oool0oooo08P0oooo00290?ooo`030000003oool0oooo
02L0oooo00<000000?ooo`3oool0k`3oool00`000000oooo0?ooo`0f0?ooo`030000003oool0oooo
08P0oooo002:0?ooo`030000003oool0oooo02H0oooo00<000000?ooo`3oool0l03oool00`000000
oooo0?ooo`0d0?ooo`030000003oool0oooo08T0oooo002:0?ooo`030000003oool0oooo02D0oooo
00<000000?ooo`3oool0l@3oool00`000000oooo0?ooo`0d0?ooo`030000003oool0oooo08T0oooo
002;0?ooo`030000003oool0oooo02@0oooo00<000000?ooo`3oool0lP3oool00`000000oooo0?oo
o`0b0?ooo`030000003oool0oooo08X0oooo002;0?ooo`030000003oool0oooo02@0oooo00<00000
0?ooo`3oool0lP3oool00`000000oooo0?ooo`0b0?ooo`030000003oool0oooo08X0oooo002<0?oo
o`030000003oool0oooo02<0oooo00<000000?ooo`3oool0l`3oool00`000000oooo0?ooo`0`0?oo
o`030000003oool0oooo08/0oooo002<0?ooo`030000003oool0oooo02<0oooo00<000000?ooo`3o
ool0l`3oool00`000000oooo0?ooo`0`0?ooo`030000003oool0oooo08/0oooo002=0?ooo`030000
003oool0oooo0280oooo00<000000?ooo`3oool0l`3oool00`000000oooo0?ooo`0_0?ooo`030000
003oool0oooo08`0oooo002=0?ooo`030000003oool0oooo0240oooo00<000000?ooo`3oool0m@3o
ool00`000000oooo0?ooo`0^0?ooo`030000003oool0oooo08`0oooo002>0?ooo`030000003oool0
oooo0200oooo00<000000?ooo`3oool0m@3oool00`000000oooo0?ooo`0]0?ooo`030000003oool0
oooo08d0oooo002>0?ooo`030000003oool0oooo0200oooo00<000000?ooo`3oool0mP3oool00`00
0000oooo0?ooo`0/0?ooo`030000003oool0oooo08d0oooo002?0?ooo`030000003oool0oooo01l0
oooo00<000000?ooo`3oool0mP3oool00`000000oooo0?ooo`0[0?ooo`030000003oool0oooo08h0
oooo002?0?ooo`030000003oool0oooo01l0oooo00<000000?ooo`3oool0mP3oool00`000000oooo
0?ooo`0[0?ooo`030000003oool0oooo08h0oooo002@0?ooo`030000003oool0oooo01d0oooo00<0
00000?ooo`3oool0n03oool00`000000oooo0?ooo`0Y0?ooo`030000003oool0oooo08l0oooo002@
0?ooo`030000003oool0oooo01d0oooo00<000000?ooo`3oool0n03oool00`000000oooo0?ooo`0Y
0?ooo`030000003oool0oooo08l0oooo002A0?ooo`030000003oool0oooo01`0oooo00<000000?oo
o`3oool0n@3oool00`000000oooo0?ooo`0W0?ooo`030000003oool0oooo0900oooo002A0?ooo`03
0000003oool0oooo01`0oooo00<000000?ooo`3oool0n@3oool00`000000oooo0?ooo`0W0?ooo`03
0000003oool0oooo0900oooo002B0?ooo`030000003oool0oooo01/0oooo00<000000?ooo`3oool0
nP3oool00`000000oooo0?ooo`0U0?ooo`030000003oool0oooo0940oooo002B0?ooo`030000003o
ool0oooo01/0oooo00<000000?ooo`3oool0nP3oool00`000000oooo0?ooo`0U0?ooo`030000003o
ool0oooo0940oooo002C0?ooo`030000003oool0oooo01T0oooo00<000000?ooo`3oool0n`3oool0
0`000000oooo0?ooo`0T0?ooo`030000003oool0oooo0980oooo002C0?ooo`030000003oool0oooo
01T0oooo00<000000?ooo`3oool0o03oool00`000000oooo0?ooo`0S0?ooo`030000003oool0oooo
0980oooo002D0?ooo`030000003oool0oooo01P0oooo00<000000?ooo`3oool0o03oool00`000000
oooo0?ooo`0R0?ooo`030000003oool0oooo09<0oooo002D0?ooo`030000003oool0oooo01P0oooo
00<000000?ooo`3oool0o@3oool00`000000oooo0?ooo`0Q0?ooo`030000003oool0oooo09<0oooo
002E0?ooo`030000003oool0oooo01L0oooo00<000000?ooo`3oool0o@3oool00`000000oooo0?oo
o`0P0?ooo`030000003oool0oooo09@0oooo002E0?ooo`030000003oool0oooo01L0oooo00<00000
0?ooo`3oool0o@3oool00`000000oooo0?ooo`0P0?ooo`030000003oool0oooo09@0oooo002F0?oo
o`030000003oool0oooo01D0oooo00<000000?ooo`3oool0o`3oool00`000000oooo0?ooo`0N0?oo
o`030000003oool0oooo09D0oooo002F0?ooo`030000003oool0oooo01D0oooo00<000000?ooo`3o
ool0o`3oool00`000000oooo0?ooo`0N0?ooo`030000003oool0oooo09D0oooo002G0?ooo`030000
003oool0oooo01@0oooo00<000000?ooo`3oool0o`3oool10?ooo`030000003oool0oooo01`0oooo
00<000000?ooo`3oool0UP3oool009L0oooo00<000000?ooo`3oool0503oool00`000000oooo0?oo
o`3o0?ooo`40oooo00<000000?ooo`3oool0703oool00`000000oooo0?ooo`2F0?ooo`00V03oool0
0`000000oooo0?ooo`0C0?ooo`030000003oool0oooo0?l0oooo0P3oool00`000000oooo0?ooo`0J
0?ooo`030000003oool0oooo09L0oooo002H0?ooo`030000003oool0oooo0180oooo00<000000?oo
o`3oool0o`3oool30?ooo`030000003oool0oooo01X0oooo00<000000?ooo`3oool0U`3oool009T0
oooo00<000000?ooo`3oool04@3oool00`000000oooo0?ooo`3o0?ooo`<0oooo00<000000?ooo`3o
ool06@3oool00`000000oooo0?ooo`2H0?ooo`00V@3oool00`000000oooo0?ooo`0A0?ooo`030000
003oool0oooo0?l0oooo103oool00`000000oooo0?ooo`0H0?ooo`030000003oool0oooo09P0oooo
002J0?ooo`030000003oool0oooo0100oooo00<000000?ooo`3oool0o`3oool40?ooo`030000003o
ool0oooo01L0oooo00<000000?ooo`3oool0V@3oool009X0oooo00<000000?ooo`3oool0403oool0
0`000000oooo0?ooo`3o0?ooo`D0oooo00<000000?ooo`3oool05P3oool00`000000oooo0?ooo`2I
0?ooo`00V`3oool00`000000oooo0?ooo`0?0?ooo`030000003oool0oooo0?l0oooo1@3oool00`00
0000oooo0?ooo`0E0?ooo`030000003oool0oooo09X0oooo002K0?ooo`030000003oool0oooo00h0
oooo00<000000?ooo`3oool0o`3oool70?ooo`030000003oool0oooo01@0oooo00<000000?ooo`3o
ool0VP3oool009`0oooo00<000000?ooo`3oool03@3oool00`000000oooo0?ooo`3o0?ooo`L0oooo
00<000000?ooo`3oool04`3oool00`000000oooo0?ooo`2K0?ooo`00W03oool00`000000oooo0?oo
o`0=0?ooo`030000003oool0oooo0?l0oooo1`3oool00`000000oooo0?ooo`0C0?ooo`030000003o
ool0oooo09/0oooo002M0?ooo`030000003oool0oooo00`0oooo00<000000?ooo`3oool0o`3oool8
0?ooo`030000003oool0oooo0140oooo00<000000?ooo`3oool0W03oool009d0oooo00<000000?oo
o`3oool0303oool00`000000oooo0?ooo`3o0?ooo`P0oooo00<000000?ooo`3oool04@3oool00`00
0000oooo0?ooo`2L0?ooo`00WP3oool00`000000oooo0?ooo`0;0?ooo`030000003oool0oooo0?l0
oooo2@3oool00`000000oooo0?ooo`0?0?ooo`030000003oool0oooo09d0oooo002N0?ooo`030000
003oool0oooo00X0oooo00<000000?ooo`3oool0o`3oool:0?ooo`030000003oool0oooo00l0oooo
00<000000?ooo`3oool0W@3oool009l0oooo00<000000?ooo`3oool02@3oool00`000000oooo0?oo
o`3o0?ooo`X0oooo00<000000?ooo`3oool03P3oool00`000000oooo0?ooo`2N0?ooo`00W`3oool0
0`000000oooo0?ooo`090?ooo`030000003oool0oooo0?l0oooo2`3oool00`000000oooo0?ooo`0=
0?ooo`030000003oool0oooo09h0oooo002P0?ooo`030000003oool0oooo00P0oooo00<000000?oo
o`3oool0o`3oool;0?ooo`030000003oool0oooo00`0oooo00<000000?ooo`3oool0W`3oool00:00
oooo00<000000?ooo`3oool0203oool00`000000oooo0?ooo`3o0?ooo``0oooo00<000000?ooo`3o
ool02`3oool00`000000oooo0?ooo`2O0?ooo`00X@3oool00`000000oooo0?ooo`060?ooo`030000
003oool0oooo0?l0oooo3@3oool00`000000oooo0?ooo`0:0?ooo`030000003oool0oooo0:00oooo
002Q0?ooo`030000003oool0oooo00H0oooo00<000000?ooo`3oool0o`3oool>0?ooo`030000003o
ool0oooo00T0oooo00<000000?ooo`3oool0X03oool00:80oooo00<000000?ooo`3oool01@3oool0
0`000000oooo0?ooo`3o0?ooo`h0oooo00<000000?ooo`3oool0203oool00`000000oooo0?ooo`2Q
0?ooo`00XP3oool00`000000oooo0?ooo`050?ooo`030000003oool0oooo0?l0oooo3P3oool00`00
0000oooo0?ooo`080?ooo`030000003oool0oooo0:40oooo002S0?ooo`030000003oool0oooo00@0
oooo00<000000?ooo`3oool0o`3oool?0?ooo`030000003oool0oooo00H0oooo00<000000?ooo`3o
ool0XP3oool00:<0oooo00<000000?ooo`3oool0103oool00`000000oooo0?ooo`3o0?ooo`l0oooo
00<000000?ooo`3oool01P3oool00`000000oooo0?ooo`2R0?ooo`00Y03oool00`000000oooo0?oo
o`020?ooo`030000003oool0oooo0?l0oooo4@3oool00`000000oooo0?ooo`040?ooo`030000003o
ool0oooo0:<0oooo002T0?ooo`030000003oool0oooo0080oooo00<000000?ooo`3oool0o`3ooolA
0?ooo`030000003oool0oooo00@0oooo00<000000?ooo`3oool0X`3oool00:D0oooo00D000000?oo
o`3oool0oooo0000003o0?oooa<0oooo00<000000?ooo`3oool00`3oool00`000000oooo0?ooo`2T
0?ooo`00Y@3oool00`000000oooo0000000200000?l0oooo503oool01P000000oooo000000000000
oooo00000:H0oooo002T0?ooo`P00000o`3ooolA0?ooo`P00000Y@3oool00:<0oooo2P00003o0?oo
o`l0oooo2P00002T0?ooo`00X`3oool:00000?l0oooo3`3oool:00000:@0oooo002S0?ooo`X00000
o`3oool?0?ooo`X00000Y03oool00:80ooooo`00000U00000:<0oooo002R0?ooo``00000o`3oool=
0?ooo``00000X`3oool00:<0oooo2P00003o0?ooo`l0oooo2P00002T0?ooo`00X`3oool:00000?l0
oooo3`3oool:00000:@0oooo002S0?ooo`X00000o`3oool?0?ooo`X00000Y03oool00:@0oooo2000
003o0?oooa40oooo2000002U0?ooo`00Y`3oool200000?l0oooo5`3oool200000:P0oooo003o0?oo
ool0ooooJ`3oool00?l0ooooo`3ooom[0?ooo`00o`3ooooo0?ooof/0oooo003o0?ooool0ooooJ`3o
ool00?l0ooooo`3ooom[0?ooo`00o`3ooooo0?ooof/0oooo003o0?ooool0ooooJ`3oool00?l0oooo
o`3ooom[0?ooo`00o`3ooooo0?ooof/0oooo003o0?ooool0ooooJ`3oool00?l0ooooo`3ooom[0?oo
o`00o`3ooooo0?ooof/0oooo003o0?ooool0ooooJ`3oool00?l0ooooo`3ooom[0?ooo`00o`3ooooo
0?ooof/0oooo003o0?ooool0ooooJ`3oool00?l0ooooo`3ooom[0?ooo`00o`3ooooo0?ooof/0oooo
003o0?ooool0ooooJ`3oool00?l0ooooo`3ooom[0?ooo`00o`3ooooo0?ooof/0oooo003o0?ooool0
ooooJ`3oool00001\
\>"],
  ImageRangeCache->{{{0, 616}, {616, 0}} -> {-1.10001, -0.952637, 0.00357147, \
0.00309298}}],

Cell[BoxData[
    TagBox[\(\[SkeletonIndicator]  Graphics  \[SkeletonIndicator]\),
      False,
      Editable->False]], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    \(showconvex3dpolygon[mm]\)], "Input"],

Cell[CellGroupData[{

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: 1 
MathPictureStart
/Mabs {
Mgmatrix idtransform
Mtmatrix dtransform
} bind def
/Mabsadd { Mabs
3 -1 roll add
3 1 roll add
exch } bind def
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
-0.0175847 1.03517 0.0454545 0.909091 [
[ 0 0 0 0 ]
[ 1 1 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 0 m
1 0 L
1 1 L
0 1 L
closepath
clip
newpath
0 g
.025 w
.5 .95455 Mdot
.05176 .72727 Mdot
.05176 .27273 Mdot
.5 .04545 Mdot
.94824 .27273 Mdot
.94824 .72727 Mdot
.60725 .55438 Mdot
.56428 .52111 Mdot
.52802 .5142 Mdot
.48097 .52307 Mdot
.40507 .53681 Mdot
.34164 .41971 Mdot
.48883 .4094 Mdot
.51323 .474 Mdot
.55296 .53833 Mdot
.65076 .43009 Mdot
.44804 .47365 Mdot
.50644 .64962 Mdot
.56313 .53201 Mdot
.55873 .48386 Mdot
.47736 .48852 Mdot
.4209 .45989 Mdot
.51345 .55273 Mdot
.5 Mabswid
[ ] 0 setdash
.5 .95455 m
.05176 .72727 L
s
.5 .95455 m
.94824 .72727 L
s
.5 .95455 m
.50644 .64962 L
s
.05176 .72727 m
.5 .95455 L
s
.05176 .72727 m
.05176 .27273 L
s
.05176 .72727 m
.40507 .53681 L
s
.05176 .27273 m
.05176 .72727 L
s
.05176 .27273 m
.5 .04545 L
s
.05176 .27273 m
.34164 .41971 L
s
.5 .04545 m
.05176 .27273 L
s
.5 .04545 m
.94824 .27273 L
s
.5 .04545 m
.48883 .4094 L
s
.94824 .27273 m
.5 .04545 L
s
.94824 .27273 m
.94824 .72727 L
s
.94824 .27273 m
.65076 .43009 L
s
.94824 .72727 m
.5 .95455 L
s
.94824 .72727 m
.94824 .27273 L
s
.94824 .72727 m
.60725 .55438 L
s
.60725 .55438 m
.94824 .72727 L
s
.60725 .55438 m
.56428 .52111 L
s
.60725 .55438 m
.55296 .53833 L
s
.60725 .55438 m
.65076 .43009 L
s
.60725 .55438 m
.50644 .64962 L
s
.60725 .55438 m
.56313 .53201 L
s
.60725 .55438 m
.55873 .48386 L
s
.60725 .55438 m
.51345 .55273 L
s
.56428 .52111 m
.60725 .55438 L
s
.56428 .52111 m
.52802 .5142 L
s
.56428 .52111 m
.56313 .53201 L
s
.56428 .52111 m
.55873 .48386 L
s
.52802 .5142 m
.56428 .52111 L
s
.52802 .5142 m
.48097 .52307 L
s
.52802 .5142 m
.51323 .474 L
s
.52802 .5142 m
.55296 .53833 L
s
.52802 .5142 m
.56313 .53201 L
s
.52802 .5142 m
.55873 .48386 L
s
.52802 .5142 m
.47736 .48852 L
s
.52802 .5142 m
.51345 .55273 L
s
.48097 .52307 m
.52802 .5142 L
s
.48097 .52307 m
.40507 .53681 L
s
.48097 .52307 m
.47736 .48852 L
s
.48097 .52307 m
.51345 .55273 L
s
.40507 .53681 m
.05176 .72727 L
s
.40507 .53681 m
.48097 .52307 L
s
.40507 .53681 m
.34164 .41971 L
s
.40507 .53681 m
.44804 .47365 L
s
.40507 .53681 m
.50644 .64962 L
s
.40507 .53681 m
.47736 .48852 L
s
.40507 .53681 m
.4209 .45989 L
s
.40507 .53681 m
.51345 .55273 L
s
.34164 .41971 m
.05176 .27273 L
s
.34164 .41971 m
.40507 .53681 L
s
.34164 .41971 m
.48883 .4094 L
s
.34164 .41971 m
.4209 .45989 L
s
.48883 .4094 m
.5 .04545 L
s
.48883 .4094 m
.34164 .41971 L
s
.48883 .4094 m
.51323 .474 L
s
.48883 .4094 m
.65076 .43009 L
s
.48883 .4094 m
.44804 .47365 L
s
.48883 .4094 m
.55873 .48386 L
s
.48883 .4094 m
.47736 .48852 L
s
.48883 .4094 m
.4209 .45989 L
s
.51323 .474 m
.52802 .5142 L
s
.51323 .474 m
.48883 .4094 L
s
.51323 .474 m
.55873 .48386 L
s
.51323 .474 m
.47736 .48852 L
s
.55296 .53833 m
.60725 .55438 L
s
.55296 .53833 m
.52802 .5142 L
s
.55296 .53833 m
.56313 .53201 L
s
.55296 .53833 m
.51345 .55273 L
s
.65076 .43009 m
.94824 .27273 L
s
.65076 .43009 m
.60725 .55438 L
s
.65076 .43009 m
.48883 .4094 L
s
.65076 .43009 m
.55873 .48386 L
s
.44804 .47365 m
.40507 .53681 L
s
.44804 .47365 m
.48883 .4094 L
s
.44804 .47365 m
.47736 .48852 L
s
.44804 .47365 m
.4209 .45989 L
s
.50644 .64962 m
.5 .95455 L
s
.50644 .64962 m
.60725 .55438 L
s
.50644 .64962 m
.40507 .53681 L
s
.50644 .64962 m
.51345 .55273 L
s
.56313 .53201 m
.60725 .55438 L
s
.56313 .53201 m
.56428 .52111 L
s
.56313 .53201 m
.52802 .5142 L
s
.56313 .53201 m
.55296 .53833 L
s
.55873 .48386 m
.60725 .55438 L
s
.55873 .48386 m
.56428 .52111 L
s
.55873 .48386 m
.52802 .5142 L
s
.55873 .48386 m
.48883 .4094 L
s
.55873 .48386 m
.51323 .474 L
s
.55873 .48386 m
.65076 .43009 L
s
.47736 .48852 m
.52802 .5142 L
s
.47736 .48852 m
.48097 .52307 L
s
.47736 .48852 m
.40507 .53681 L
s
.47736 .48852 m
.48883 .4094 L
s
.47736 .48852 m
.51323 .474 L
s
.47736 .48852 m
.44804 .47365 L
s
.4209 .45989 m
.40507 .53681 L
s
.4209 .45989 m
.34164 .41971 L
s
.4209 .45989 m
.48883 .4094 L
s
.4209 .45989 m
.44804 .47365 L
s
.51345 .55273 m
.60725 .55438 L
s
.51345 .55273 m
.52802 .5142 L
s
.51345 .55273 m
.48097 .52307 L
s
.51345 .55273 m
.40507 .53681 L
s
.51345 .55273 m
.55296 .53833 L
s
.51345 .55273 m
.50644 .64962 L
s
.5 .95455 m
.05176 .72727 L
s
.5 .95455 m
.94824 .72727 L
s
.5 .95455 m
.50644 .64962 L
s
.05176 .72727 m
.5 .95455 L
s
.05176 .72727 m
.05176 .27273 L
s
.05176 .72727 m
.40507 .53681 L
s
.05176 .27273 m
.05176 .72727 L
s
.05176 .27273 m
.5 .04545 L
s
.05176 .27273 m
.34164 .41971 L
s
.5 .04545 m
.05176 .27273 L
s
.5 .04545 m
.94824 .27273 L
s
.5 .04545 m
.48883 .4094 L
s
.94824 .27273 m
.5 .04545 L
s
.94824 .27273 m
.94824 .72727 L
s
.94824 .27273 m
.65076 .43009 L
s
.94824 .72727 m
.5 .95455 L
s
.94824 .72727 m
.94824 .27273 L
s
.94824 .72727 m
.60725 .55438 L
s
.60725 .55438 m
.94824 .72727 L
s
.60725 .55438 m
.56428 .52111 L
s
.60725 .55438 m
.55296 .53833 L
s
.60725 .55438 m
.65076 .43009 L
s
.60725 .55438 m
.50644 .64962 L
s
.60725 .55438 m
.56313 .53201 L
s
.60725 .55438 m
.55873 .48386 L
s
.60725 .55438 m
.51345 .55273 L
s
.56428 .52111 m
.60725 .55438 L
s
.56428 .52111 m
.52802 .5142 L
s
.56428 .52111 m
.56313 .53201 L
s
.56428 .52111 m
.55873 .48386 L
s
.52802 .5142 m
.56428 .52111 L
s
.52802 .5142 m
.48097 .52307 L
s
.52802 .5142 m
.51323 .474 L
s
.52802 .5142 m
.55296 .53833 L
s
.52802 .5142 m
.56313 .53201 L
s
.52802 .5142 m
.55873 .48386 L
s
.52802 .5142 m
.47736 .48852 L
s
.52802 .5142 m
.51345 .55273 L
s
.48097 .52307 m
.52802 .5142 L
s
.48097 .52307 m
.40507 .53681 L
s
.48097 .52307 m
.47736 .48852 L
s
.48097 .52307 m
.51345 .55273 L
s
.40507 .53681 m
.05176 .72727 L
s
.40507 .53681 m
.48097 .52307 L
s
.40507 .53681 m
.34164 .41971 L
s
.40507 .53681 m
.44804 .47365 L
s
.40507 .53681 m
.50644 .64962 L
s
.40507 .53681 m
.47736 .48852 L
s
.40507 .53681 m
.4209 .45989 L
s
.40507 .53681 m
.51345 .55273 L
s
.34164 .41971 m
.05176 .27273 L
s
.34164 .41971 m
.40507 .53681 L
s
.34164 .41971 m
.48883 .4094 L
s
.34164 .41971 m
.4209 .45989 L
s
.48883 .4094 m
.5 .04545 L
s
.48883 .4094 m
.34164 .41971 L
s
.48883 .4094 m
.51323 .474 L
s
.48883 .4094 m
.65076 .43009 L
s
.48883 .4094 m
.44804 .47365 L
s
.48883 .4094 m
.55873 .48386 L
s
.48883 .4094 m
.47736 .48852 L
s
.48883 .4094 m
.4209 .45989 L
s
.51323 .474 m
.52802 .5142 L
s
.51323 .474 m
.48883 .4094 L
s
.51323 .474 m
.55873 .48386 L
s
.51323 .474 m
.47736 .48852 L
s
.55296 .53833 m
.60725 .55438 L
s
.55296 .53833 m
.52802 .5142 L
s
.55296 .53833 m
.56313 .53201 L
s
.55296 .53833 m
.51345 .55273 L
s
.65076 .43009 m
.94824 .27273 L
s
.65076 .43009 m
.60725 .55438 L
s
.65076 .43009 m
.48883 .4094 L
s
.65076 .43009 m
.55873 .48386 L
s
.44804 .47365 m
.40507 .53681 L
s
.44804 .47365 m
.48883 .4094 L
s
.44804 .47365 m
.47736 .48852 L
s
.44804 .47365 m
.4209 .45989 L
s
.50644 .64962 m
.5 .95455 L
s
.50644 .64962 m
.60725 .55438 L
s
.50644 .64962 m
.40507 .53681 L
s
.50644 .64962 m
.51345 .55273 L
s
.56313 .53201 m
.60725 .55438 L
s
.56313 .53201 m
.56428 .52111 L
s
.56313 .53201 m
.52802 .5142 L
s
.56313 .53201 m
.55296 .53833 L
s
.55873 .48386 m
.60725 .55438 L
s
.55873 .48386 m
.56428 .52111 L
s
.55873 .48386 m
.52802 .5142 L
s
.55873 .48386 m
.48883 .4094 L
s
.55873 .48386 m
.51323 .474 L
s
.55873 .48386 m
.65076 .43009 L
s
.47736 .48852 m
.52802 .5142 L
s
.47736 .48852 m
.48097 .52307 L
s
.47736 .48852 m
.40507 .53681 L
s
.47736 .48852 m
.48883 .4094 L
s
.47736 .48852 m
.51323 .474 L
s
.47736 .48852 m
.44804 .47365 L
s
.4209 .45989 m
.40507 .53681 L
s
.4209 .45989 m
.34164 .41971 L
s
.4209 .45989 m
.48883 .4094 L
s
.4209 .45989 m
.44804 .47365 L
s
.51345 .55273 m
.60725 .55438 L
s
.51345 .55273 m
.52802 .5142 L
s
.51345 .55273 m
.48097 .52307 L
s
.51345 .55273 m
.40507 .53681 L
s
.51345 .55273 m
.55296 .53833 L
s
.51345 .55273 m
.50644 .64962 L
s
[(1)] .46894 .92727 0 1 Mshowa
[(2)] .0207 .7 0 1 Mshowa
[(3)] .0207 .24545 0 1 Mshowa
[(4)] .46894 .01818 0 1 Mshowa
[(5)] .91719 .24545 0 1 Mshowa
[(6)] .91719 .7 0 1 Mshowa
[(7)] .57619 .52711 0 1 Mshowa
[(8)] .53323 .49384 0 1 Mshowa
[(9)] .49696 .48693 0 1 Mshowa
[(10)] .44992 .49579 0 1 Mshowa
[(11)] .37402 .50954 0 1 Mshowa
[(12)] .31058 .39243 0 1 Mshowa
[(13)] .45778 .38213 0 1 Mshowa
[(14)] .48218 .44672 0 1 Mshowa
[(15)] .52191 .51106 0 1 Mshowa
[(16)] .61971 .40282 0 1 Mshowa
[(17)] .41699 .44638 0 1 Mshowa
[(18)] .47539 .62234 0 1 Mshowa
[(19)] .53207 .50473 0 1 Mshowa
[(20)] .52767 .45659 0 1 Mshowa
[(21)] .44631 .46125 0 1 Mshowa
[(22)] .38984 .43262 0 1 Mshowa
[(23)] .4824 .52546 0 1 Mshowa
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  ImageSize->{721, 721},
  ImageMargins->{{41, 0}, {0, 52}},
  ImageRegion->{{0, 1}, {0, 1}},
  ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`4000;A0002dB000`400?l00000o`00003oo`3ooooo
0?ooom<0oooo003o0?ooool0ooood`3oool00?l0ooooo`3ooooC0?ooo`00o`3ooooo0?ooom<0oooo
003o0?ooool0ooood`3oool00?l0ooooo`3ooooC0?ooo`00o`3ooomB0?ooo`<00000o`3ooomn0?oo
o`00o`3ooomC0?ooo`030000003oool0oooo0?l0ooooO@3oool00?l0ooooD03oool500000?l0oooo
OP3oool00?l0ooooD03oool010000000oooo0?ooo`00003o0?ooogl0oooo003o0?oooe40oooo00<0
00000?ooo`000000o`3ooomo0?ooo`00o`3ooomB0?ooo`800000o`3ooomo0?ooo`00o`3ooooo0?oo
om<0oooo003o0?ooool0ooood`3oool00?l0ooooo`3ooooC0?ooo`00o`3ooooo0?ooom<0oooo003o
0?ooool0ooood`3oool00?l0ooooo`3ooooC0?ooo`00o`3ooooo0?ooom<0oooo003o0?ooool0oooo
d`3oool00?l0ooooo`3ooooC0?ooo`00o`3ooooo0?ooom<0oooo003o0?ooool0ooood`3oool00?l0
ooooo`3ooooC0?ooo`00o`3ooooo0?ooom<0oooo003o0?ooofL0oooo1000003o0?ooofP0oooo003o
0?ooof@0oooo2P00003o0?ooofD0oooo003o0?ooof<0oooo3000003o0?ooof@0oooo003o0?ooof80
oooo3P00003o0?ooof<0oooo003o0?ooof40oooo4000003o0?ooof80oooo003o0?ooof40oooo4000
003o0?ooof80oooo003o0?ooof40oooo4000003o0?ooof80oooo003o0?ooof00oooo4P00003o0?oo
of40oooo003o0?ooof00oooo4P00003o0?ooof40oooo003o0?ooof00oooo4P00003o0?ooof40oooo
003o0?ooof00oooo4P00003o0?ooof40oooo003o0?ooof40oooo4000003o0?ooof80oooo003o0?oo
of40oooo4@00003o0?ooof40oooo003o0?oooel0oooo4P0000000`3oool000000000003o0?oooel0
oooo003o0?oooed0oooo0P0000030?ooo`h00000103oool200000?l0ooooG@3oool00?l0ooooF`3o
ool2000000H0oooo300000070?ooo`800000o`3ooomK0?ooo`00o`3ooomI0?ooo`8000002@3oool:
000000X0oooo0P00003o0?oooeT0oooo003o0?oooeL0oooo0P00000>0?ooo`@000003`3oool20000
0?l0ooooE`3oool00?l0ooooE@3oool200000180oooo00<000000?ooo`3oool0403oool200000?l0
ooooE@3oool00?l0ooooD`3oool2000001@0oooo00<000000?ooo`3oool04P3oool200000?l0oooo
D`3oool00?l0ooooD@3oool2000001H0oooo00<000000?ooo`3oool0503oool200000?l0ooooD@3o
ool00?l0ooooC`3oool2000001P0oooo00<000000?ooo`3oool05P3oool200000?l0ooooC`3oool0
0?l0ooooC@3oool2000001X0oooo00<000000?ooo`3oool0603oool200000?l0ooooC@3oool00?l0
ooooB`3oool2000001/0oooo00<000000?ooo`3oool06`3oool200000?l0ooooB`3oool00?l0oooo
B@3oool2000001d0oooo00<000000?ooo`3oool07@3oool200000?l0ooooB@3oool00?l0ooooA`3o
ool2000001l0oooo00<000000?ooo`3oool07`3oool200000?l0ooooA`3oool00?l0ooooA@3oool2
00000240oooo00<000000?ooo`3oool08@3oool200000?l0ooooA@3oool00?l0oooo@`3oool20000
02<0oooo00<000000?ooo`3oool08`3oool200000?l0oooo@`3oool00?l0oooo@@3oool2000002D0
oooo00<000000?ooo`3oool09@3oool200000?l0oooo@@3oool00?l0oooo?`3oool2000002L0oooo
00<000000?ooo`3oool09`3oool200000?l0oooo?`3oool00?l0oooo?@3oool2000002T0oooo00<0
00000?ooo`3oool0:@3oool200000?l0oooo?@3oool00?l0oooo>`3oool2000002/0oooo00<00000
0?ooo`3oool0:`3oool200000?l0oooo>`3oool00?l0oooo>@3oool2000002d0oooo00<000000?oo
o`3oool0;@3oool200000?l0oooo>@3oool00?l0oooo=`3oool2000002l0oooo00<000000?ooo`3o
ool0;`3oool200000?l0oooo=`3oool00?l0oooo=@3oool200000340oooo00<000000?ooo`3oool0
<@3oool200000?l0oooo=@3oool00?l0oooo<`3oool2000003<0oooo00<000000?ooo`3oool0<`3o
ool00`000000oooo0?ooo`3o0?oooc80oooo003o0?oooc40oooo0P00000e0?ooo`030000003oool0
oooo03@0oooo0P00003o0?oooc80oooo003o0?ooobl0oooo0P00000g0?ooo`030000003oool0oooo
03H0oooo0P00003o0?oooc00oooo003o0?ooobd0oooo0P00000i0?ooo`030000003oool0oooo03P0
oooo0P00003o0?ooobh0oooo003o0?ooob/0oooo0P00000k0?ooo`030000003oool0oooo03X0oooo
0P00003o0?ooob`0oooo003o0?ooobT0oooo0P00000m0?ooo`030000003oool0oooo03`0oooo0P00
003o0?ooobX0oooo003o0?ooobP0oooo00<000000?ooo`3oool0?@3oool00`000000oooo0?ooo`0n
0?ooo`800000o`3ooolX0?ooo`00o`3ooolV0?ooo`800000@03oool00`000000oooo0?ooo`100?oo
o`800000o`3ooolV0?ooo`00o`3ooolT0?ooo`800000@P3oool00`000000oooo0?ooo`120?ooo`80
0000o`3ooolT0?ooo`00o`3ooolR0?ooo`800000A03oool00`000000oooo0?ooo`140?ooo`800000
o`3ooolR0?ooo`00o`3ooolP0?ooo`800000AP3oool00`000000oooo0?ooo`160?ooo`800000o`3o
oolP0?ooo`00o`3ooolN0?ooo`800000B03oool00`000000oooo0?ooo`180?ooo`800000o`3ooolN
0?ooo`00o`3ooolL0?ooo`800000BP3oool00`000000oooo0?ooo`1:0?ooo`800000o`3ooolL0?oo
o`00o`3ooolJ0?ooo`800000C03oool00`000000oooo0?ooo`1<0?ooo`800000o`3ooolJ0?ooo`00
o`3ooolH0?ooo`800000CP3oool00`000000oooo0?ooo`1>0?ooo`800000o`3ooolH0?ooo`00o`3o
oolF0?ooo`800000D03oool00`000000oooo0?ooo`1@0?ooo`800000o`3ooolF0?ooo`00o`3ooolD
0?ooo`800000DP3oool00`000000oooo0?ooo`1B0?ooo`800000o`3ooolD0?ooo`00o`3ooolB0?oo
o`800000D`3oool00`000000oooo0?ooo`1E0?ooo`800000o`3ooolB0?ooo`00o`3oool@0?ooo`80
0000E@3oool00`000000oooo0?ooo`1G0?ooo`800000o`3oool@0?ooo`00o`3oool>0?ooo`800000
E`3oool00`000000oooo0?ooo`1I0?ooo`800000o`3oool>0?ooo`00o`3oool<0?ooo`800000F@3o
ool00`000000oooo0?ooo`1K0?ooo`800000o`3oool<0?ooo`00o`3oool:0?ooo`800000F`3oool0
0`000000oooo0?ooo`1M0?ooo`800000o`3oool:0?ooo`00o`3oool80?ooo`800000G@3oool00`00
0000oooo0?ooo`1O0?ooo`800000o`3oool80?ooo`00o`3oool60?ooo`800000G`3oool00`000000
oooo0?ooo`1Q0?ooo`800000o`3oool60?ooo`00o`3oool40?ooo`800000H@3oool00`000000oooo
0?ooo`1S0?ooo`800000o`3oool40?ooo`00o`3oool20?ooo`800000H`3oool00`000000oooo0?oo
o`1U0?ooo`800000o`3oool20?ooo`00o`3oool2000006D0oooo00<000000?ooo`3oool0I`3oool2
00000?l0oooo003m0?ooo`800000I`3oool00`000000oooo0?ooo`1Y0?ooo`800000o@3oool00?/0
oooo0P00001Y0?ooo`030000003oool0oooo06/0oooo00<000000?ooo`3oool0nP3oool00?T0oooo
0P00001[0?ooo`030000003oool0oooo06`0oooo0P00003j0?ooo`00m`3oool2000006d0oooo00<0
00000?ooo`3oool0KP3oool200000?P0oooo003e0?ooo`800000K`3oool00`000000oooo0?ooo`1`
0?ooo`800000mP3oool00?<0oooo0P00001a0?ooo`030000003oool0oooo0780oooo0P00003d0?oo
o`00l@3oool2000007<0oooo00<000000?ooo`3oool0M03oool200000?80oooo003_0?ooo`800000
M@3oool00`000000oooo0?ooo`1f0?ooo`800000l03oool00>d0oooo0P00001g0?ooo`030000003o
ool0oooo07P0oooo0P00003^0?ooo`00j`3oool2000007T0oooo00<000000?ooo`3oool0NP3oool2
00000>`0oooo003Y0?ooo`800000N`3oool00`000000oooo0?ooo`1l0?ooo`800000jP3oool00>L0
oooo0P00001m0?ooo`030000003oool0oooo07h0oooo0P00003X0?ooo`00iP3oool00`000000oooo
0?ooo`1m0?ooo`030000003oool0oooo0800oooo0P00003V0?ooo`00i03oool200000800oooo00<0
00000?ooo`3oool0PP3oool200000>@0oooo003R0?ooo`800000PP3oool00`000000oooo0?ooo`24
0?ooo`800000hP3oool00>00oooo0P0000240?ooo`030000003oool0oooo08H0oooo0P00003P0?oo
o`00gP3oool2000008H0oooo00<000000?ooo`3oool0R03oool200000=h0oooo003L0?ooo`800000
R03oool00`000000oooo0?ooo`2:0?ooo`800000g03oool00=X0oooo0P00002:0?ooo`030000003o
ool0oooo08`0oooo0P00003J0?ooo`00f03oool2000008/0oooo00<000000?ooo`3oool0S`3oool2
00000=P0oooo003F0?ooo`800000S@3oool00`000000oooo0?ooo`2A0?ooo`800000eP3oool00=@0
oooo0P00002?0?ooo`030000003oool0oooo09<0oooo0P00003D0?ooo`00dP3oool200000940oooo
00<000000?ooo`3oool0U@3oool200000=80oooo003@0?ooo`800000T`3oool00`000000oooo0?oo
o`2G0?ooo`800000d03oool00<h0oooo0P00002E0?ooo`030000003oool0oooo09T0oooo0P00003>
0?ooo`00c03oool2000009L0oooo00<000000?ooo`3oool0V`3oool200000<`0oooo003:0?ooo`80
0000V@3oool00`000000oooo0?ooo`2M0?ooo`800000bP3oool00<P0oooo0P00002K0?ooo`030000
003oool0oooo09l0oooo0P0000380?ooo`00aP3oool2000009d0oooo00<000000?ooo`3oool0X@3o
ool00`000000oooo0?ooo`350?ooo`00a03oool2000009l0oooo00<000000?ooo`3oool0XP3oool2
00000<D0oooo00320?ooo`800000X@3oool00`000000oooo0?ooo`2T0?ooo`800000``3oool00<00
oooo0P00002S0?ooo`030000003oool0oooo0:H0oooo0P0000310?ooo`00_P3oool200000:D0oooo
00<000000?ooo`3oool0Z03oool200000;l0oooo002l0?ooo`800000Y`3oool00`000000oooo0?oo
o`2Z0?ooo`800000_@3oool00;X0oooo0P00002Y0?ooo`030000003oool0oooo0:`0oooo0P00002k
0?ooo`00^03oool200000:/0oooo00<000000?ooo`3oool0[P3oool200000;T0oooo002f0?ooo`80
0000[@3oool00`000000oooo0?ooo`2`0?ooo`800000]`3oool00;@0oooo0P00002_0?ooo`030000
003oool0oooo0;80oooo0P00002e0?ooo`00/P3oool200000;40oooo00<000000?ooo`3oool0]03o
ool200000;<0oooo002`0?ooo`800000/`3oool00`000000oooo0?ooo`2f0?ooo`800000/@3oool0
0:h0oooo0P00002e0?ooo`030000003oool0oooo0;P0oooo0P00002_0?ooo`00[03oool200000;L0
oooo00<000000?ooo`3oool0^P3oool200000:d0oooo002Z0?ooo`800000^@3oool00`000000oooo
0?ooo`2l0?ooo`800000Z`3oool00:P0oooo0P00002k0?ooo`030000003oool0oooo0;h0oooo0P00
002Y0?ooo`00Y`3oool00`000000oooo0?ooo`2k0?ooo`030000003oool0oooo0<00oooo0P00002W
0?ooo`00Y@3oool200000;h0oooo00<000000?ooo`3oool0`P3oool200000:D0oooo002S0?ooo`80
0000`03oool00`000000oooo0?ooo`340?ooo`800000X`3oool00:40oooo0P0000320?ooo`030000
003oool0oooo0<H0oooo0P00002Q0?ooo`00W`3oool200000<<0oooo00<000000?ooo`3oool0b@3o
ool2000009l0oooo002M0?ooo`800000a@3oool00`000000oooo0?ooo`3;0?ooo`800000W@3oool0
09/0oooo0P0000370?ooo`030000003oool0oooo0<d0oooo0P00002K0?ooo`00V@3oool200000<T0
oooo00<000000?ooo`3oool0c`3oool2000009T0oooo002G0?ooo`800000b`3oool00`000000oooo
0?ooo`3A0?ooo`800000U`3oool009D0oooo0P00003=0?ooo`030000003oool0oooo0=<0oooo0P00
002E0?ooo`00T`3oool200000<l0oooo00<000000?ooo`3oool0e@3oool2000009<0oooo002A0?oo
o`800000d@3oool00`000000oooo0?ooo`3G0?ooo`030000003oool0oooo0900oooo002?0?ooo`80
0000d`3oool00`000000oooo0?ooo`3H0?ooo`800000T03oool008d0oooo0P00003E0?ooo`030000
003oool0oooo0=X0oooo0P00002>0?ooo`00R`3oool200000=L0oooo00<000000?ooo`3oool0g03o
ool2000008`0oooo00290?ooo`800000f@3oool00`000000oooo0?ooo`3N0?ooo`800000RP3oool0
08L0oooo0P00003K0?ooo`030000003oool0oooo0>00oooo0P0000280?ooo`00Q@3oool200000=d0
oooo00<000000?ooo`3oool0hP3oool2000008H0oooo00230?ooo`800000g`3oool00`000000oooo
0?ooo`3T0?ooo`800000Q03oool00840oooo0P00003Q0?ooo`030000003oool0oooo0>H0oooo0P00
00220?ooo`00O`3oool200000><0oooo00<000000?ooo`3oool0j03oool200000800oooo001m0?oo
o`800000i@3oool00`000000oooo0?ooo`3Z0?ooo`800000OP3oool007/0oooo0P00003W0?ooo`03
0000003oool0oooo0>`0oooo0P00001l0?ooo`00N@3oool200000>T0oooo00<000000?ooo`3oool0
kP3oool2000007X0oooo001g0?ooo`800000j`3oool00`000000oooo0?ooo`3`0?ooo`800000N03o
ool007D0oooo0P00003]0?ooo`030000003oool0oooo0?80oooo0P00001f0?ooo`00L`3oool20000
0>l0oooo00<000000?ooo`3oool0m03oool2000007@0oooo001a0?ooo`800000l@3oool00`000000
oooo0?ooo`3f0?ooo`800000LP3oool006l0oooo0P00003c0?ooo`030000003oool0oooo0?P0oooo
0P00001`0?ooo`00K@3oool200000?D0oooo00<000000?ooo`3oool0nP3oool2000006h0oooo001[
0?ooo`800000m`3oool00`000000oooo0?ooo`3l0?ooo`800000K03oool006T0oooo0P00003i0?oo
o`030000003oool0oooo0?h0oooo0P00001Z0?ooo`00I`3oool200000?/0oooo00<000000?ooo`3o
ool0o`3oool10?ooo`800000J03oool006H0oooo00<000000?ooo`3oool0nP3oool00`000000oooo
0?ooo`3o0?ooo`@0oooo0P00001V0?ooo`00I03oool200000?d0oooo00<000000?ooo`3oool0o`3o
ool60?ooo`800000I03oool00680oooo0P00003o0?ooo`030000003oool0oooo0?l0oooo203oool2
00000680oooo001P0?ooo`800000o`3oool20?ooo`030000003oool0oooo0?l0oooo2P3oool20000
0600oooo001N0?ooo`800000o`3oool40?ooo`030000003oool0oooo0?l0oooo303oool2000005h0
oooo000=0?ooo`800000C@3oool200000?l0oooo1P3oool00`000000oooo0?ooo`3o0?ooo`h0oooo
0P00000N0?ooo`800000?03oool000`0oooo00@000000?ooo`3oool00000BP3oool200000?l0oooo
203oool00`000000oooo0?ooo`3o0?oooa00oooo00<000000?ooo`3oool06P3oool010000000oooo
0?ooo`00000k0?ooo`003P3oool00`000000oooo0?ooo`170?ooo`800000o`3oool:0?ooo`030000
003oool0oooo0?l0oooo4@3oool2000001d0oooo00<000000?ooo`3oool0>@3oool000l0oooo00<0
00000?ooo`3oool0A03oool200000?l0oooo303oool00`000000oooo0?ooo`3o0?oooa<0oooo0P00
000I0?ooo`800000?03oool000`0oooo00@000000?ooo`3oool00000A03oool200000?l0oooo3P3o
ool00`000000oooo0?ooo`3o0?oooaD0oooo0P00000G0?ooo`030000003oool0oooo03/0oooo000=
0?ooo`800000@`3oool200000?l0oooo403oool00`000000oooo0?ooo`3o0?oooaL0oooo0P00000E
0?ooo`<00000>`3oool00500oooo0P00003o0?oooa80oooo00<000000?ooo`3oool0o`3ooolI0?oo
o`800000D@3oool004h0oooo0P00003o0?oooa@0oooo00<000000?ooo`3oool0o`3ooolK0?ooo`80
0000C`3oool004`0oooo0P00003o0?oooaH0oooo00<000000?ooo`3oool0o`3ooolM0?ooo`800000
C@3oool004X0oooo0P00003o0?oooaP0oooo00<000000?ooo`3oool0o`3ooolO0?ooo`800000B`3o
ool004P0oooo0P00003o0?oooaX0oooo00<000000?ooo`3oool0o`3ooolQ0?ooo`800000B@3oool0
04H0oooo0P00003o0?oooa`0oooo00<000000?ooo`3oool0o`3ooolS0?ooo`800000A`3oool004@0
oooo0P00003o0?oooah0oooo00<000000?ooo`3oool0o`3ooolU0?ooo`800000A@3oool00480oooo
0P00003o0?ooob00oooo00<000000?ooo`3oool0o`3ooolW0?ooo`800000@`3oool00400oooo0P00
003o0?ooob80oooo00<000000?ooo`3oool0o`3ooolY0?ooo`800000@@3oool003h0oooo0P00003o
0?ooob@0oooo00<000000?ooo`3oool0o`3oool[0?ooo`800000?`3oool003`0oooo0P00003o0?oo
obH0oooo00<000000?ooo`3oool0o`3oool]0?ooo`800000?@3oool003X0oooo0P00003o0?ooobP0
oooo00<000000?ooo`3oool0o`3oool_0?ooo`800000>`3oool003P0oooo0P00003o0?ooobX0oooo
00<000000?ooo`3oool0o`3ooola0?ooo`800000>@3oool002<0oooo1000000?0?ooo`800000o`3o
ool/0?ooo`030000003oool0oooo0?l0oooo<`3oool2000000l0oooo1000000T0?ooo`00803oool:
000000X0oooo0P00003o0?ooobh0oooo00<000000?ooo`3oool0o`3ooole0?ooo`8000002P3oool:
00000240oooo000O0?ooo``000001`3oool200000?l0oooo<03oool00`000000oooo0?ooo`3o0?oo
ocL0oooo0P0000070?ooo``00000803oool001h0oooo3P0000040?ooo`800000o`3ooolb0?ooo`03
0000003oool0oooo0?l0oooo>@3oool2000000@0oooo3P00000O0?ooo`007@3oool@000000030?oo
o`00000000000?l0oooo=03oool00`000000oooo0?ooo`3o0?oooc/0oooo0P0000000`3oool00000
0000000>000001h0oooo000M0?oooa400000o`3ooolf0?ooo`030000003oool0oooo0?l0oooo?@3o
oolA000001h0oooo000M0?oooa000000o`3ooolf0?ooo`030000003oool0oooo0?l0oooo?`3oool@
000001h0oooo000L0?oooa800000o`3ooole0?ooo`030000003oool0oooo0?l0oooo?P3ooolB0000
01d0oooo000L0?oooa800000o`3ooole0?ooo`030000003oool0oooo0?l0oooo?P3ooolB000001d0
oooo000L0?oooa800000o`3ooole0?ooo`030000003oool0oooo0?l0oooo?P3ooolB000001d0oooo
000L0?oooa800000o`3ooole0?ooo`030000003oool0oooo0?l0oooo?P3ooolB000001d0oooo000M
0?oooa000000o`3ooolf0?ooo`030000003oool0oooo0?l0oooo?`3oool@000001h0oooo000M0?oo
oa000000o`3ooolf0?ooo`030000003oool0oooo0?l0oooo?`3oool@000001h0oooo000M0?oooa40
0000o`3ooole0?ooo`030000003oool0oooo0?l0oooo?P3ooolA000001h0oooo000N0?ooo`h00000
0P3oool200000?l0oooo<`3oool00`000000oooo0?ooo`3o0?oooc`0oooo0P0000020?ooo`h00000
7`3oool001l0oooo300000050?ooo`800000o`3ooola0?ooo`030000003oool0oooo0?l0oooo>P3o
ool2000000D0oooo3000000P0?ooo`00803oool:000000P0oooo0P00003o0?ooobl0oooo00<00000
0?ooo`3oool0o`3ooolh0?ooo`800000203oool:00000240oooo000S0?ooo`@000003@3oool20000
0?l0oooo;@3oool00`000000oooo0?ooo`3o0?ooocH0oooo0P00000=0?ooo`@00000903oool002D0
oooo00<000000?ooo`3oool03P3oool200000?l0oooo:`3oool00`000000oooo0?ooo`3o0?ooocD0
oooo00<000000?ooo`3oool03P3oool00`000000oooo0?ooo`0T0?ooo`009@3oool00`000000oooo
0?ooo`0@0?ooo`800000o`3ooolY0?ooo`030000003oool0oooo0?l0oooo<`3oool200000140oooo
00<000000?ooo`3oool0903oool002D0oooo00<000000?ooo`3oool04P3oool200000?l0oooo9`3o
ool00`000000oooo0?ooo`3o0?oooc40oooo0P00000C0?ooo`030000003oool0oooo02@0oooo000U
0?ooo`030000003oool0oooo01@0oooo0P00003o0?ooobD0oooo00<000000?ooo`3oool0o`3oool_
0?ooo`8000005@3oool00`000000oooo0?ooo`0T0?ooo`009@3oool00`000000oooo0?ooo`0F0?oo
o`800000o`3ooolS0?ooo`030000003oool0oooo0?l0oooo;@3oool2000001L0oooo00<000000?oo
o`3oool0903oool002D0oooo00<000000?ooo`3oool0603oool200000?l0oooo8@3oool00`000000
oooo0?ooo`3o0?ooob/0oooo0P00000I0?ooo`030000003oool0oooo02@0oooo000U0?ooo`030000
003oool0oooo01X0oooo0P00003o0?oooal0oooo00<000000?ooo`3oool0o`3ooolY0?ooo`800000
6`3oool00`000000oooo0?ooo`0T0?ooo`009@3oool00`000000oooo0?ooo`0L0?ooo`800000o`3o
oolM0?ooo`030000003oool0oooo0?l0oooo9`3oool2000001d0oooo00<000000?ooo`3oool0903o
ool002D0oooo00<000000?ooo`3oool07P3oool200000?l0oooo6`3oool00`000000oooo0?ooo`3o
0?ooobD0oooo0P00000O0?ooo`030000003oool0oooo02@0oooo000U0?ooo`030000003oool0oooo
0200oooo0P00003o0?oooaT0oooo00<000000?ooo`3oool0o`3ooolS0?ooo`8000008@3oool00`00
0000oooo0?ooo`0T0?ooo`009@3oool00`000000oooo0?ooo`0R0?ooo`800000o`3ooolG0?ooo`03
0000003oool0oooo0?l0oooo8P3oool00`000000oooo0?ooo`0Q0?ooo`030000003oool0oooo02@0
oooo000U0?ooo`030000003oool0oooo02@0oooo0P00003o0?oooaD0oooo00<000000?ooo`3oool0
o`3ooolP0?ooo`800000903oool00`000000oooo0?ooo`0T0?ooo`009@3oool00`000000oooo0?oo
o`0V0?ooo`800000o`3ooolC0?ooo`030000003oool0oooo0?l0oooo7P3oool2000002H0oooo00<0
00000?ooo`3oool0903oool002D0oooo00<000000?ooo`3oool0:03oool200000?l0oooo4@3oool0
0`000000oooo0?ooo`3o0?oooa`0oooo0P00000X0?ooo`030000003oool0oooo02@0oooo000U0?oo
o`030000003oool0oooo02X0oooo0P00003o0?ooo`l0oooo00<000000?ooo`3oool0o`3ooolJ0?oo
o`800000:P3oool00`000000oooo0?ooo`0T0?ooo`009@3oool00`000000oooo0?ooo`0/0?ooo`80
0000o`3oool=0?ooo`030000003oool0oooo0?l0oooo603oool2000002`0oooo00<000000?ooo`3o
ool0903oool002D0oooo00<000000?ooo`3oool0;P3oool200000?l0oooo2`3oool00`000000oooo
0?ooo`3o0?oooaH0oooo0P00000^0?ooo`030000003oool0oooo02@0oooo000U0?ooo`030000003o
ool0oooo0300oooo00<000000?ooo`3oool0o`3oool70?ooo`030000003oool0oooo0?l0oooo5@3o
ool200000300oooo00<000000?ooo`3oool0903oool002D0oooo00<000000?ooo`3oool0<@3oool2
00000?l0oooo1`3oool00`000000oooo0?ooo`3o0?oooa<0oooo0P00000b0?ooo`030000003oool0
oooo02@0oooo000U0?ooo`030000003oool0oooo03<0oooo0P00003o0?ooo`D0oooo00<000000?oo
o`3oool0o`3ooolB0?ooo`030000003oool0oooo0380oooo00<000000?ooo`3oool0903oool002D0
oooo00<000000?ooo`3oool0=@3oool200000?l0oooo0`3oool00`000000oooo0?ooo`3o0?oooa00
oooo0P00000e0?ooo`030000003oool0oooo02@0oooo000U0?ooo`030000003oool0oooo03L0oooo
0P00003o0?ooo`40oooo00<000000?ooo`3oool0o`3oool>0?ooo`800000=`3oool00`000000oooo
0?ooo`0T0?ooo`009@3oool00`000000oooo0?ooo`0i0?ooo`800000oP3oool00`000000oooo0?oo
o`3o0?ooo``0oooo0P00000i0?ooo`030000003oool0oooo02@0oooo000U0?ooo`030000003oool0
oooo03/0oooo0P00003l0?ooo`030000003oool0oooo0?l0oooo2P3oool2000003/0oooo00<00000
0?ooo`3oool0903oool002D0oooo00<000000?ooo`3oool0?@3oool200000?X0oooo00<000000?oo
o`3oool0o`3oool80?ooo`800000?@3oool00`000000oooo0?ooo`0T0?ooo`009@3oool00`000000
oooo0?ooo`0o0?ooo`800000n03oool00`000000oooo0?ooo`3o0?ooo`H0oooo0P00000o0?ooo`03
0000003oool0oooo02@0oooo000U0?ooo`030000003oool0oooo0440oooo0P00003f0?ooo`030000
003oool0oooo0?l0oooo103oool200000440oooo00<000000?ooo`3oool0903oool002D0oooo00<0
00000?ooo`3oool0@`3oool200000?@0oooo00<000000?ooo`3oool0o`3oool20?ooo`800000@`3o
ool00`000000oooo0?ooo`0T0?ooo`009@3oool00`000000oooo0?ooo`150?ooo`800000lP3oool0
0`000000oooo0?ooo`3o0?ooo`800000A@3oool00`000000oooo0?ooo`0T0?ooo`009@3oool00`00
0000oooo0?ooo`170?ooo`800000l03oool00`000000oooo0?ooo`3n0?ooo`030000003oool0oooo
04D0oooo00<000000?ooo`3oool0903oool002D0oooo00<000000?ooo`3oool0B@3oool200000>h0
oooo00<000000?ooo`3oool0o03oool2000004P0oooo00<000000?ooo`3oool0903oool002D0oooo
00<000000?ooo`3oool0B`3oool200000>`0oooo00<000000?ooo`3oool0nP3oool2000004X0oooo
00<000000?ooo`3oool0903oool002D0oooo00<000000?ooo`3oool0C@3oool200000>X0oooo00<0
00000?ooo`3oool0n03oool2000004`0oooo00<000000?ooo`3oool0903oool002D0oooo00<00000
0?ooo`3oool0C`3oool200000>P0oooo00<000000?ooo`3oool0mP3oool2000004h0oooo00<00000
0?ooo`3oool0903oool002D0oooo00<000000?ooo`3oool0D@3oool200000>H0oooo00<000000?oo
o`3oool0m03oool200000500oooo00<000000?ooo`3oool0903oool002D0oooo00<000000?ooo`3o
ool0D`3oool200000>@0oooo00<000000?ooo`3oool0lP3oool200000580oooo00<000000?ooo`3o
ool0903oool002D0oooo00<000000?ooo`3oool0E@3oool200000>80oooo00<000000?ooo`3oool0
l03oool2000005@0oooo00<000000?ooo`3oool0903oool002D0oooo00<000000?ooo`3oool0E`3o
ool200000>00oooo00<000000?ooo`3oool0kP3oool2000005H0oooo00<000000?ooo`3oool0903o
ool002D0oooo00<000000?ooo`3oool0F@3oool200000=h0oooo00<000000?ooo`3oool0k@3oool0
0`000000oooo0?ooo`1F0?ooo`030000003oool0oooo02@0oooo000U0?ooo`030000003oool0oooo
05/0oooo0P00003L0?ooo`030000003oool0oooo0>/0oooo0P00001I0?ooo`030000003oool0oooo
02@0oooo000U0?ooo`030000003oool0oooo05d0oooo0P00003J0?ooo`030000003oool0oooo0>T0
oooo0P00001K0?ooo`030000003oool0oooo02@0oooo000U0?ooo`030000003oool0oooo05l0oooo
0P00003H0?ooo`030000003oool0oooo0>L0oooo0P00001M0?ooo`030000003oool0oooo02@0oooo
000U0?ooo`030000003oool0oooo0640oooo0P00003F0?ooo`030000003oool0oooo0>D0oooo0P00
001O0?ooo`030000003oool0oooo02@0oooo000U0?ooo`030000003oool0oooo06<0oooo0P00003D
0?ooo`030000003oool0oooo0><0oooo0P00001Q0?ooo`030000003oool0oooo02@0oooo000U0?oo
o`030000003oool0oooo06D0oooo00<000000?ooo`3oool0d@3oool00`000000oooo0?ooo`3Q0?oo
o`800000H`3oool00`000000oooo0?ooo`0T0?ooo`009@3oool00`000000oooo0?ooo`1V0?ooo`80
0000d@3oool00`000000oooo0?ooo`3O0?ooo`800000I@3oool00`000000oooo0?ooo`0T0?ooo`00
9@3oool00`000000oooo0?ooo`1X0?ooo`800000cP3oool00`000000oooo0?ooo`3N0?ooo`800000
I`3oool00`000000oooo0?ooo`0T0?ooo`009@3oool00`000000oooo0?ooo`1Z0?ooo`800000c03o
ool00`000000oooo0?ooo`3M0?ooo`030000003oool0oooo06L0oooo00<000000?ooo`3oool0903o
ool002D0oooo00<000000?ooo`3oool0K03oool200000<X0oooo00<000000?ooo`3oool0f`3oool2
000006X0oooo00<000000?ooo`3oool0903oool002D0oooo00<000000?ooo`3oool0KP3oool20000
0<P0oooo00<000000?ooo`3oool0f@3oool2000006`0oooo00<000000?ooo`3oool0903oool002D0
oooo00<000000?ooo`3oool0L03oool200000<H0oooo00<000000?ooo`3oool0e`3oool2000006h0
oooo00<000000?ooo`3oool0903oool002D0oooo00<000000?ooo`3oool0LP3oool200000<@0oooo
00<000000?ooo`3oool0e@3oool200000700oooo00<000000?ooo`3oool0903oool002D0oooo00<0
00000?ooo`3oool0M03oool200000<80oooo00<000000?ooo`3oool0d`3oool200000780oooo00<0
00000?ooo`3oool0903oool002D0oooo00<000000?ooo`3oool0MP3oool200000<00oooo00<00000
0?ooo`3oool0d@3oool2000007@0oooo00<000000?ooo`3oool0903oool002D0oooo00<000000?oo
o`3oool0N03oool200000;h0oooo00<000000?ooo`3oool0c`3oool2000007H0oooo00<000000?oo
o`3oool0903oool002D0oooo00<000000?ooo`3oool0NP3oool200000;`0oooo00<000000?ooo`3o
ool0c@3oool2000007P0oooo00<000000?ooo`3oool0903oool002D0oooo00<000000?ooo`3oool0
O03oool200000;X0oooo00<000000?ooo`3oool0b`3oool2000007X0oooo00<000000?ooo`3oool0
903oool002D0oooo00<000000?ooo`3oool0OP3oool200000;P0oooo00<000000?ooo`3oool0bP3o
ool00`000000oooo0?ooo`1j0?ooo`030000003oool0oooo02@0oooo000U0?ooo`030000003oool0
oooo0800oooo0P00002f0?ooo`030000003oool0oooo0<P0oooo0P00001m0?ooo`030000003oool0
oooo02@0oooo000U0?ooo`030000003oool0oooo0880oooo0P00002d0?ooo`030000003oool0oooo
0<H0oooo0P00001o0?ooo`030000003oool0oooo02@0oooo000U0?ooo`030000003oool0oooo08@0
oooo0P00002b0?ooo`030000003oool0oooo0<@0oooo0P0000210?ooo`030000003oool0oooo02@0
oooo000U0?ooo`030000003oool0oooo08H0oooo0P00002`0?ooo`030000003oool0oooo0<80oooo
0P0000230?ooo`030000003oool0oooo02@0oooo000U0?ooo`030000003oool0oooo08P0oooo0P00
002B0?ooo`D000000P3oool2000001<0oooo00<000000?ooo`3oool0`03oool2000008D0oooo00<0
00000?ooo`3oool0903oool002D0oooo00<000000?ooo`3oool0RP3oool200000980oooo00D00000
0?ooo`3oool0oooo000000020?ooo`030000003oool0oooo0100oooo00<000000?ooo`3oool0_P3o
ool2000008L0oooo00<000000?ooo`3oool0903oool002D0oooo00<000000?ooo`3oool0S03oool2
00000900oooo00<000000?ooo`3oool00`3oool00`000000oooo0?ooo`0A0?ooo`030000003oool0
oooo0;`0oooo0P0000290?ooo`030000003oool0oooo02@0oooo000U0?ooo`030000003oool0oooo
08h0oooo0P00002>0?ooo`030000003oool0oooo00@0oooo00<000000?ooo`3oool0403oool00`00
0000oooo0?ooo`2j0?ooo`800000R`3oool00`000000oooo0?ooo`0T0?ooo`009@3oool00`000000
oooo0?ooo`2@0?ooo`800000S03oool01@000000oooo0?ooo`3oool000000080oooo00<000000?oo
o`3oool0403oool00`000000oooo0?ooo`2i0?ooo`030000003oool0oooo08/0oooo00<000000?oo
o`3oool0903oool002D0oooo00<000000?ooo`3oool0TP3oool2000008T0oooo0P0000040?ooo`80
00004`3oool00`000000oooo0?ooo`2g0?ooo`800000SP3oool00`000000oooo0?ooo`0T0?ooo`00
9@3oool00`000000oooo0?ooo`2D0?ooo`800000XP3oool00`000000oooo0?ooo`2e0?ooo`800000
T03oool00`000000oooo0?ooo`0T0?ooo`009@3oool00`000000oooo0?ooo`2F0?ooo`8000006P3o
ool5000000030?ooo`000000000000800000O03oool00`000000oooo0?ooo`2c0?ooo`800000TP3o
ool00`000000oooo0?ooo`0T0?ooo`009@3oool00`000000oooo0?ooo`2H0?ooo`030000003oool0
oooo01T0oooo00D000000?ooo`3oool0oooo0000001o0?ooo`030000003oool0oooo0;40oooo0P00
002D0?ooo`030000003oool0oooo02@0oooo000U0?ooo`030000003oool0oooo09T0oooo0P00000I
0?ooo`030000003oool0oooo0080oooo00<000000?ooo`3oool0O03oool00`000000oooo0?ooo`2_
0?ooo`800000UP3oool00`000000oooo0?ooo`0T0?ooo`009@3oool00`000000oooo0?ooo`2K0?oo
o`8000005`3oool00`000000oooo0?ooo`030?ooo`030000003oool0oooo07/0oooo00<000000?oo
o`3oool0[@3oool2000009P0oooo00<000000?ooo`3oool0903oool002D0oooo00<000000?ooo`3o
ool0W@3oool2000001D0oooo00D000000?ooo`3oool0oooo000000020?ooo`030000003oool0oooo
07X0oooo00<000000?ooo`3oool0Z`3oool2000009X0oooo00<000000?ooo`3oool0903oool002D0
oooo00<000000?ooo`3oool0W`3oool200000180oooo0P0000040?ooo`800000O@3oool00`000000
oooo0?ooo`2Y0?ooo`800000W03oool00`000000oooo0?ooo`0T0?ooo`009@3oool00`000000oooo
0?ooo`2Q0?ooo`800000U03oool00`000000oooo0?ooo`2X0?ooo`800000WP3oool00`000000oooo
0?ooo`0T0?ooo`009@3oool00`000000oooo0?ooo`2S0?ooo`800000TP3oool00`000000oooo0?oo
o`2W0?ooo`030000003oool0oooo09h0oooo00<000000?ooo`3oool0903oool002D0oooo00<00000
0?ooo`3oool0Y@3oool200000900oooo00<000000?ooo`3oool0E`3oool5000000040?ooo`000000
0000000004D0oooo0P00002Q0?ooo`030000003oool0oooo02@0oooo000U0?ooo`030000003oool0
oooo0:L0oooo0P00002>0?ooo`030000003oool0oooo05T0oooo00D000000?ooo`3oool0oooo0000
00020?ooo`030000003oool0oooo0400oooo0P00002S0?ooo`030000003oool0oooo02@0oooo000U
0?ooo`030000003oool0oooo0:T0oooo0P00002<0?ooo`030000003oool0oooo05T0oooo00D00000
0?ooo`3oool0oooo000000020?ooo`030000003oool0oooo03h0oooo0P00002U0?ooo`030000003o
ool0oooo02@0oooo000U0?ooo`030000003oool0oooo0:/0oooo0P00002:0?ooo`030000003oool0
oooo05T0oooo00@000000?ooo`3oool0oooo0`00000o0?ooo`800000Y`3oool00`000000oooo0?oo
o`0T0?ooo`009@3oool00`000000oooo0?ooo`2]0?ooo`800000Q`3oool4000005T0oooo00<00000
0?ooo`3oool00P3oool00`000000oooo0?ooo`0l0?ooo`800000Z@3oool00`000000oooo0?ooo`0T
0?ooo`009@3oool00`000000oooo0?ooo`2_0?ooo`800000PP3oool:000005D0oooo0P0000040?oo
o`<00000>P3oool200000:/0oooo00<000000?ooo`3oool0903oool002D0oooo00<000000?ooo`3o
ool0/@3oool2000007l0oooo3000002E0?ooo`800000[@3oool00`000000oooo0?ooo`0T0?ooo`00
9@3oool00`000000oooo0?ooo`2c0?ooo`800000O03oool>00000980oooo0P00002_0?ooo`030000
003oool0oooo02@0oooo000U0?ooo`030000003oool0oooo0;D0oooo0P00001i0?oooa000000T03o
ool00`000000oooo0?ooo`2_0?ooo`030000003oool0oooo02@0oooo000U0?ooo`030000003oool0
oooo0;L0oooo0P00001g0?oooa000000SP3oool200000;80oooo00<000000?ooo`3oool0903oool0
02D0oooo00<000000?ooo`3oool0^@3oool2000007D0oooo4000002<0?ooo`800000]03oool00`00
0000oooo0?ooo`0T0?ooo`009@3oool00`000000oooo0?ooo`2k0?ooo`8000003`3oool4000005l0
oooo4P0000290?ooo`800000]P3oool00`000000oooo0?ooo`0T0?ooo`009@3oool00`000000oooo
0?ooo`2m0?ooo`8000002P3oool:000005`0oooo4P0000270?ooo`800000^03oool00`000000oooo
0?ooo`0T0?ooo`009@3oool00`000000oooo0?ooo`2o0?ooo`8000001`3oool<00000500oooo7`00
00230?ooo`800000^P3oool00`000000oooo0?ooo`0T0?ooo`009@3oool00`000000oooo0?ooo`31
0?ooo`800000103oool>00000440oooo3P00000;0?oooa8000000P3oool8000007T0oooo0P00002l
0?ooo`030000003oool0oooo02@0oooo000U0?ooo`030000003oool0oooo0<<0oooo0P0000000`3o
ool000000000000>000003<0oooo3@00000J0?oooa0000002`3oool8000006l0oooo0P00002n0?oo
o`030000003oool0oooo02@0oooo000U0?ooo`030000003oool0oooo0<D0oooo4@00000V0?ooo`d0
00009`3oool@000001<0oooo2000001U0?ooo`800000`03oool00`000000oooo0?ooo`0T0?ooo`00
9@3oool00`000000oooo0?ooo`360?oooa0000006@3oool=000003@0oooo4000000K0?ooo`L00000
G03oool200000<80oooo00<000000?ooo`3oool0903oool002D0oooo00<000000?ooo`3oool0a@3o
oolB000000X0oooo3P0000100?ooo`030000003oool0000000d000008`3oool8000005<0oooo00<0
00000?ooo`3oool0`P3oool00`000000oooo0?ooo`0T0?ooo`009@3oool00`000000oooo0?ooo`35
0?oooa`00000C@3oool010000000oooo0?ooo`3oool=000002/0oooo2000000i0?ooo`@00000303o
ool200000<D0oooo00<000000?ooo`3oool0903oool002D0oooo00<000000?ooo`3oool0a@3ooolB
000005D0oooo0P0000040?ooo`/000000P3oool00`000000oooo0?ooo`0`0?ooo`P00000;P3oool:
000000L0oooo0P0000370?ooo`030000003oool0oooo02@0oooo000U0?ooo`030000003oool0oooo
0<D0oooo4P00000D0?ooo`@000000P3oool4000003H0oooo00<000000?ooo`3oool00`3oool00`00
0000oooo0?ooo`020?ooo`D00000103oool00`000000oooo0?ooo`0h0?ooo`P000009@3oool<0000
00@0oooo0P0000390?ooo`030000003oool0oooo02@0oooo000U0?ooo`030000003oool0oooo0<H0
oooo4000000E0?ooo`030000003oool0oooo00<0oooo00<000000?ooo`3oool0=P3oool00`000000
oooo0?ooo`040?ooo`030000003oool0oooo0080oooo00<000000?ooo`3oool00P3oool00`000000
oooo0?ooo`020?ooo`030000003oool0oooo03l0oooo1`00000M0?ooo`h0000000<0oooo00000000
0000b`3oool00`000000oooo0?ooo`0T0?ooo`009@3oool00`000000oooo0?ooo`360?oooa000000
5P3oool00`000000oooo0?ooo`030?ooo`030000003oool0oooo03@0oooo00<000000?ooo`3oool0
103oool00`000000oooo0?ooo`020?ooo`030000003oool0oooo00<0oooo00<000000?ooo`3oool0
0`3oool00`000000oooo0?ooo`150?ooo`P00000503oool@00000<d0oooo00<000000?ooo`3oool0
903oool002D0oooo00<000000?ooo`3oool0aP3oool@000001L0oooo00<000000?ooo`3oool00`3o
ool00`000000oooo0?ooo`0a0?ooo`8000001`3oool00`000000oooo0?ooo`020?ooo`030000003o
ool0oooo00@0oooo00<000000?ooo`3oool00`3oool00`000000oooo0?ooo`1<0?ooo`P00000303o
ool@00000<d0oooo00<000000?ooo`3oool0903oool002D0oooo00<000000?ooo`3oool0a`3oool>
000000030?ooo`000000000001<0oooo00@000000?ooo`3oool000000P3oool010000000oooo0?oo
o`00000a0?ooo`030000003oool0oooo00H0oooo00<000000?ooo`3oool00`3oool00`000000oooo
0?ooo`040?ooo`030000003oool0oooo00@0oooo00<000000?ooo`3oool0D`3oool8000000@0oooo
4000003=0?ooo`030000003oool0oooo02@0oooo000U0?ooo`030000003oool0oooo0<P0oooo3000
00040?ooo`8000004P3oool2000000@0oooo0P00000a0?ooo`030000003oool0oooo00H0oooo00<0
00000?ooo`3oool0103oool00`000000oooo0?ooo`040?ooo`030000003oool0oooo00D0oooo00<0
00000?ooo`3oool0FP3ooolE00000<`0oooo00<000000?ooo`3oool0903oool002D0oooo00<00000
0?ooo`3oool0b@3oool:000000L0oooo0P0000170?ooo`8000002@3oool00`000000oooo0?ooo`04
0?ooo`030000003oool0oooo00D0oooo00<000000?ooo`3oool01@3oool00`000000oooo0?ooo`1L
0?oooa800000c03oool00`000000oooo0?ooo`0T0?ooo`009@3oool00`000000oooo0?ooo`3<0?oo
o`@0000000<0oooo0000003oool02@3oool2000004@0oooo00<000000?ooo`3oool0203oool00`00
0000oooo0?ooo`050?ooo`030000003oool0oooo00D0oooo00<000000?ooo`3oool01P3oool00`00
0000oooo0?ooo`1K0?oooa800000c03oool00`000000oooo0?ooo`0T0?ooo`009@3oool00`000000
oooo0?ooo`3B0?ooo`030000003oool0oooo00T0oooo0P0000110?ooo`030000003oool0oooo00T0
oooo00<000000?ooo`3oool01@3oool00`000000oooo0?ooo`060?ooo`030000003oool0oooo00H0
oooo00<000000?ooo`3oool0FP3ooolB00000<`0oooo00<000000?ooo`3oool0903oool002D0oooo
00<000000?ooo`3oool0dP3oool00`000000oooo0?ooo`0;0?ooo`800000?P3oool00`000000oooo
0?ooo`090?ooo`030000003oool0oooo00D0oooo00<000000?ooo`3oool01`3oool00`000000oooo
0?ooo`070?ooo`030000003oool0oooo05X0oooo4000003=0?ooo`030000003oool0oooo02@0oooo
000U0?ooo`030000003oool0oooo0=<0oooo00<000000?ooo`3oool0303oool2000001/0oooo1@00
00030?ooo`030000003oool0oooo01@0oooo0P00000;0?ooo`030000003oool0oooo00D0000000<0
oooo0000003oool00`0000050?ooo`030000003oool0oooo00P0oooo00<000000?ooo`3oool0F@3o
ool@00000<d0oooo00<000000?ooo`3oool0903oool002D0oooo00<000000?ooo`3oool0e03oool0
0`000000oooo0?ooo`0=0?ooo`8000006`3oool00`000000oooo0?ooo`030?ooo`030000003oool0
oooo01<0oooo00<000000?ooo`3oool02`3oool00`000000oooo0?ooo`020?ooo`050000003oool0
oooo0?ooo`0000000P3oool00`000000oooo0?ooo`050?ooo`030000003oool0oooo00P0oooo00<0
00000?ooo`3oool0EP3ooolB00000<d0oooo00<000000?ooo`3oool0903oool002D0oooo00<00000
0?ooo`3oool0e03oool00`000000oooo0?ooo`0?0?ooo`8000006@3oool00`000000oooo0?ooo`03
0?ooo`030000003oool0oooo0180oooo00<000000?ooo`3oool02`3oool00`000000oooo0?ooo`03
0?ooo`040000003oool0oooo0?ooo`D000001P3oool00`000000oooo0?ooo`090?ooo`030000003o
ool0oooo05@0oooo00@000000?ooo`3oool0oooo3P00003>0?ooo`030000003oool0oooo02@0oooo
000U0?ooo`030000003oool0oooo0=D0oooo00<000000?ooo`3oool0403oool2000001L0oooo00<0
00000?ooo`3oool0103oool00`000000oooo0?ooo`0?0?ooo`8000003@3oool00`000000oooo0?oo
o`040?ooo`050000003oool0oooo0?ooo`0000000P3oool00`000000oooo0?ooo`050?ooo`030000
003oool0oooo00X0oooo00<000000?ooo`3oool0D@3oool2000000D0oooo3000003?0?ooo`030000
003oool0oooo02@0oooo000U0?ooo`030000003oool0oooo0=D0oooo00<000000?ooo`3oool04P3o
ool2000001D0oooo00D000000?ooo`3oool0oooo000000020?ooo`030000003oool0oooo00h0oooo
00<000000?ooo`3oool03@3oool00`000000oooo0?ooo`040?ooo`040000003oool0oooo0?ooo`80
000000<0oooo0000003oool01`3oool00`000000oooo0?ooo`0:0?ooo`030000003oool0oooo04h0
oooo0P0000080?ooo`X00000d03oool00`000000oooo0?ooo`0T0?ooo`009@3oool00`000000oooo
0?ooo`3F0?ooo`030000003oool0oooo01<0oooo0P00000B0?ooo`8000000`3oool4000000l0oooo
00<000000?ooo`3oool03@3oool00`000000oooo0?ooo`040?ooo`8000000`3oool010000000oooo
0000000000080?ooo`030000003oool0oooo00/0oooo00<000000?ooo`3oool0B`3oool2000000/0
oooo00<000000?ooo`0000000`00003C0?ooo`030000003oool0oooo02@0oooo000U0?ooo`030000
003oool0oooo0=H0oooo00<000000?ooo`3oool05@3oool2000002H0oooo0P00000@0?ooo`030000
003oool0oooo00P0oooo00<000000?ooo`3oool02`3oool00`000000oooo0?ooo`0;0?ooo`030000
003oool0oooo04T0oooo00<000000?ooo`3oool02`3oool00`000000oooo0?ooo`3F0?ooo`030000
003oool0oooo02@0oooo000U0?ooo`030000003oool0oooo0=L0oooo00<000000?ooo`3oool05P3o
ool2000002<0oooo00<000000?ooo`3oool03`3oool00`000000oooo0?ooo`090?ooo`030000003o
ool0oooo00/0oooo00<000000?ooo`3oool02P3oool4000000<0oooo0P0000120?ooo`8000003@3o
ool00`000000oooo0?ooo`3G0?ooo`030000003oool0oooo02@0oooo000U0?ooo`030000003oool0
oooo0=L0oooo00<000000?ooo`3oool0603oool200000200oooo00<000000?ooo`3oool03`3oool0
0`000000oooo0?ooo`0:0?ooo`030000003oool0oooo00/0oooo00<000000?ooo`3oool02P3oool0
0`000000oooo000000030?ooo`040000003oool0oooo000003l0oooo0P00000?0?ooo`030000003o
ool0oooo0=L0oooo00<000000?ooo`3oool0903oool002D0oooo00<000000?ooo`3oool0f03oool0
0`000000oooo0?ooo`0I0?ooo`8000003`3oool4000000X0oooo00<000000?ooo`3oool0403oool0
0`000000oooo0?ooo`0:0?ooo`030000003oool0oooo00`0oooo00<000000?ooo`3oool02P3oool0
0`000000oooo000000020?ooo`040000003oool0oooo000003h0oooo00<000000?ooo`3oool03`3o
ool00`000000oooo0?ooo`3G0?ooo`030000003oool0oooo02@0oooo000U0?ooo`030000003oool0
oooo0=P0oooo00<000000?ooo`3oool06`3oool2000000X0oooo2P0000050?ooo`8000004P3oool0
0`000000oooo0?ooo`0;0?ooo`030000003oool0oooo00`0oooo00<000000?ooo`3oool02`3oool0
1@000000oooo0000003oool000000080oooo00<000000?ooo`3oool0>P3oool200000140oooo00<0
00000?ooo`3oool0f03oool00`000000oooo0?ooo`0T0?ooo`009@3oool00`000000oooo0?ooo`3I
0?ooo`030000003oool0oooo01`0oooo0P0000070?ooo``000000`3oool010000000oooo0?ooo`3o
ool400000080oooo1@0000050?ooo`030000003oool0oooo00`0oooo00<000000?ooo`3oool0303o
ool00`000000oooo0?ooo`090?ooo`050000003oool0oooo0000003oool00P0000020?ooo`030000
003oool0oooo03P0oooo0P00000C0?ooo`030000003oool0oooo0=P0oooo00<000000?ooo`3oool0
903oool002D0oooo00<000000?ooo`3oool0fP3oool00`000000oooo0?ooo`0M0?ooo`800000103o
ool>000000030?ooo`000000oooo00<0oooo00<000000?ooo`3oool01@3oool00`000000oooo0?oo
o`050?ooo`030000003oool0oooo00`0oooo00<000000?ooo`3oool03@3oool00`000000oooo0?oo
o`090?ooo`8000000`3oool3000003X0oooo00<000000?ooo`3oool04P3oool00`000000oooo0?oo
o`3I0?ooo`030000003oool0oooo02@0oooo000U0?ooo`030000003oool0oooo0=X0oooo00<00000
0?ooo`3oool07`3oool2000000030?ooo`000000000000h000001P3oool00`000000oooo0?ooo`04
0?ooo`030000003oool0oooo00@0oooo00<000000?ooo`3oool03@3oool00`000000oooo0?ooo`0=
0?ooo`030000003oool0oooo00l0oooo00<000000?ooo`3oool0=`3oool2000001D0oooo00<00000
0?ooo`3oool0f@3oool00`000000oooo0?ooo`0T0?ooo`009@3oool00`000000oooo0?ooo`3K0?oo
o`030000003oool0oooo0200oooo4@0000070?ooo`030000003oool0oooo00<0oooo00<000000?oo
o`3oool0103oool00`000000oooo0?ooo`0<0?ooo`030000003oool0oooo00l0oooo00<000000?oo
o`3oool03`3oool00`000000oooo0?ooo`0d0?ooo`8000005`3oool00`000000oooo0?ooo`3I0?oo
o`030000003oool0oooo02@0oooo000U0?ooo`030000003oool0oooo0=/0oooo00<000000?ooo`3o
ool08@3oool@000000D0oooo00@000000?ooo`3oool00000103oool00`000000oooo0?ooo`030?oo
o`030000003oool0oooo00d0oooo00<000000?ooo`3oool03`3oool00`000000oooo0?ooo`0@0?oo
o`030000003oool0oooo0380oooo00<000000?ooo`3oool05P3oool00`000000oooo0?ooo`3J0?oo
o`030000003oool0oooo02@0oooo000U0?ooo`030000003oool0oooo0=`0oooo00<000000?ooo`3o
ool07`3ooolB000000D0oooo0P0000040?ooo`800000103oool00`000000oooo0?ooo`0>0?ooo`03
0000003oool0oooo00l0oooo00<000000?ooo`3oool04@3oool00`000000oooo0?ooo`0_0?ooo`80
00006@3oool00`000000oooo0?ooo`3J0?ooo`030000003oool0oooo02@0oooo000U0?ooo`030000
003oool0oooo0=`0oooo00<000000?ooo`3oool07`3ooolB00000140oooo00<000000?ooo`3oool0
3P3oool00`000000oooo0?ooo`0@0?ooo`030000003oool0oooo0140oooo00<000000?ooo`3oool0
;03oool2000001/0oooo00<000000?ooo`3oool0fP3oool00`000000oooo0?ooo`0T0?ooo`009@3o
ool00`000000oooo0?ooo`3M0?ooo`030000003oool0oooo01h0oooo4P00000@0?ooo`030000003o
ool0oooo00l0oooo00<000000?ooo`3oool0403oool00`000000oooo0?ooo`0B0?ooo`030000003o
ool0oooo02T0oooo0P00000L0?ooo`030000003oool0oooo0=/0oooo00<000000?ooo`3oool0903o
ool002D0oooo00<000000?ooo`3oool0g@3oool00`000000oooo0?ooo`0N0?oooa8000002@3oool4
000000<0oooo00<000000?ooo`3oool03`3oool00`000000oooo0?ooo`0A0?ooo`030000003oool0
000000<000003`3oool00`000000oooo0?ooo`0W0?ooo`030000003oool0oooo01`0oooo00<00000
0?ooo`3oool0f`3oool00`000000oooo0?ooo`0T0?ooo`009@3oool00`000000oooo0?ooo`3N0?oo
o`030000003oool0oooo01h0oooo400000070?ooo`X000004P3oool00`000000oooo0?ooo`0@0?oo
o`X000003@3oool00`000000oooo0?ooo`0T0?ooo`8000007`3oool00`000000oooo0?ooo`3K0?oo
o`030000003oool0oooo02@0oooo000U0?ooo`030000003oool0oooo0=l0oooo00<000000?ooo`3o
ool07@3oool@000000H0oooo3000000@0?ooo`030000003oool0oooo0100oooo3000000=0?ooo`03
0000003oool0oooo0240oooo0P00000P0?ooo`030000003oool0oooo0=`0oooo00<000000?ooo`3o
ool0903oool002D0oooo00<000000?ooo`3oool0g`3oool00`000000oooo0?ooo`0M0?oooa400000
103oool>000000l0oooo00<000000?ooo`3oool03`3oool>000000d0oooo00<000000?ooo`3oool0
7`3oool00`000000oooo0?ooo`0P0?ooo`030000003oool0oooo0=`0oooo00<000000?ooo`3oool0
903oool002D0oooo00<000000?ooo`3oool0h03oool00`000000oooo0?ooo`0M0?ooo`h000000P3o
ool2000000030?ooo`000000000000h000003P3oool00`000000oooo0?ooo`0>0?oooa0000003@3o
ool00`000000oooo0?ooo`0L0?ooo`8000008`3oool00`000000oooo0?ooo`3L0?ooo`030000003o
ool0oooo02@0oooo000U0?ooo`030000003oool0oooo0>00oooo00<000000?ooo`3oool07P3oool<
000000D0oooo4@00000>0?ooo`030000003oool0oooo00h0oooo4000000>0?ooo`030000003oool0
oooo01T0oooo0P00000T0?ooo`030000003oool0oooo0=d0oooo00<000000?ooo`3oool0903oool0
02D0oooo00<000000?ooo`3oool0h@3oool00`000000oooo0?ooo`0N0?ooo`X000001`3oool@0000
00h0oooo00<000000?ooo`3oool03P3oool@000000l0oooo00<000000?ooo`3oool05`3oool00`00
0000oooo0?ooo`0T0?ooo`030000003oool0oooo0=d0oooo00<000000?ooo`3oool0903oool002D0
oooo00<000000?ooo`3oool0h@3oool00`000000oooo0?ooo`0Q0?ooo`@000002@3ooolB000000d0
oooo00<000000?ooo`3oool03@3ooolB000000h0oooo00<000000?ooo`3oool0103oool4000000d0
oooo0P00000W0?ooo`030000003oool0oooo0=d0oooo00<000000?ooo`3oool0903oool002D0oooo
00<000000?ooo`3oool0hP3oool00`000000oooo0?ooo`0P0?ooo`030000003oool0oooo00X0oooo
4P00000=0?ooo`030000003oool0oooo00d0oooo4P00000?0?ooo`030000003oool0oooo00X00000
203oool2000002P0oooo00<000000?ooo`3oool0gP3oool00`000000oooo0?ooo`0T0?ooo`009@3o
ool00`000000oooo0?ooo`3R0?ooo`030000003oool0oooo0200oooo00<000000?ooo`3oool02P3o
oolB000000`0oooo00<000000?ooo`3oool03P3ooolB00000100oooo3@0000060?ooo`030000003o
ool0oooo02P0oooo00<000000?ooo`3oool0gP3oool00`000000oooo0?ooo`0T0?ooo`009@3oool0
0`000000oooo0?ooo`3S0?ooo`030000003oool0oooo01l0oooo00<000000?ooo`3oool02P3ooolB
000000`0oooo00<000000?ooo`3oool0203oool3000000<0oooo4P00000@0?ooo`h000000`3oool2
000002/0oooo00<000000?ooo`3oool0gP3oool00`000000oooo0?ooo`0T0?ooo`009@3oool00`00
0000oooo0?ooo`3S0?ooo`030000003oool0oooo01h0oooo00<000000?ooo`3oool0303oool@0000
00/0oooo1000000;0?ooo`030000003oool0oooo0080oooo4`00000=0?oooa800000;03oool00`00
0000oooo0?ooo`3O0?ooo`030000003oool0oooo02@0oooo000U0?ooo`030000003oool0oooo0>@0
oooo00<000000?ooo`3oool07@3oool00`000000oooo0?ooo`0<0?oooa000000203oool:000000L0
oooo0`0000000`3oool000000000000@000000<0oooo1@0000080?oooa000000;P3oool00`000000
oooo0?ooo`3O0?ooo`030000003oool0oooo02@0oooo000U0?ooo`030000003oool0oooo0>D0oooo
00<000000?ooo`3oool0703oool00`000000oooo0?ooo`0<0?oooa4000001P3oool<000000D0oooo
00<000000?ooo`3oool00P0000020?oooa000000203oool5000000<0oooo4000000^0?ooo`030000
003oool0oooo0=l0oooo00<000000?ooo`3oool0903oool002D0oooo00<000000?ooo`3oool0i@3o
ool00`000000oooo0?ooo`0L0?ooo`030000003oool0oooo00d0oooo3P0000020?ooo`8000000`3o
ool>000000@0oooo100000040?ooo`h000003P3ooolD000002`0oooo00<000000?ooo`3oool0h03o
ool00`000000oooo0?ooo`0T0?ooo`009@3oool00`000000oooo0?ooo`3V0?ooo`030000003oool0
oooo01/0oooo00<000000?ooo`3oool03P3oool<000000D0oooo4P000000103oool000000000003o
ool3000000D0oooo300000060?ooo`8000002@3ooolB000002`0oooo00<000000?ooo`3oool0h03o
ool00`000000oooo0?ooo`0T0?ooo`009@3oool00`000000oooo0?ooo`3V0?ooo`030000003oool0
oooo01X0oooo00<000000?ooo`3oool03`3oool;000000P0oooo4@00000<0?ooo`X000001P3oool0
10000000oooo0?ooo`0000080?oooa800000;03oool00`000000oooo0?ooo`3P0?ooo`030000003o
ool0oooo02@0oooo000U0?ooo`030000003oool0oooo0>L0oooo00<000000?ooo`3oool06@3oool0
0`000000oooo0?ooo`0>0?ooo`040000003oool0oooo0?ooo`D000000P3oool00`000000oooo0?oo
o`060?oooa000000403oool5000000P0oooo00@000000?ooo`3oool00000203ooolB000002/0oooo
00<000000?ooo`3oool0h@3oool00`000000oooo0?ooo`0T0?ooo`009@3oool00`000000oooo0?oo
o`3W0?ooo`030000003oool0oooo01T0oooo00<000000?ooo`3oool03P3oool01@000000oooo0?oo
o`3oool0000000<0oooo00@000000?ooo`3oool000001`3ooolB000001<0oooo00<000000?ooo`3o
ool01`3oool2000000X0oooo4000000/0?ooo`030000003oool0oooo0>40oooo00<000000?ooo`3o
ool0903oool002D0oooo00<000000?ooo`3oool0j03oool00`000000oooo0?ooo`0H0?ooo`030000
003oool0oooo00d0oooo00<000000?ooo`3oool00P3oool01@000000oooo0?ooo`3oool000000080
oooo00<000000?ooo`3oool01@3ooolB000001@0oooo00<000000?ooo`3oool01@3oool010000000
oooo0?ooo`0000090?oooa000000;03oool00`000000oooo0?ooo`3Q0?ooo`030000003oool0oooo
02@0oooo000U0?ooo`030000003oool0oooo0>P0oooo00<000000?ooo`3oool05`3oool00`000000
oooo0?ooo`0=0?ooo`030000003oool0oooo00<0oooo00D000000?ooo`3oool0oooo000000020?oo
o`030000003oool0oooo00D0oooo4P00000D0?ooo`030000003oool0oooo00H0oooo0P00000:0?oo
oa000000:`3oool00`000000oooo0?ooo`3R0?ooo`030000003oool0oooo02@0oooo000U0?ooo`03
0000003oool0oooo0>T0oooo00<000000?ooo`3oool05P3oool00`000000oooo0?ooo`0=0?ooo`03
0000003oool0oooo0080oooo0P0000040?ooo`800000203ooolB000001D0oooo00<000000?ooo`3o
ool04P3oool>000002`0oooo00<000000?ooo`3oool0hP3oool00`000000oooo0?ooo`0T0?ooo`00
9@3oool00`000000oooo0?ooo`3Y0?ooo`030000003oool0oooo01H0oooo00<000000?ooo`3oool0
303oool00`000000oooo0?ooo`0D0?oooa0000005P3oool00`000000oooo0?ooo`0C0?ooo``00000
;03oool00`000000oooo0?ooo`3S0?ooo`030000003oool0oooo02@0oooo000U0?ooo`030000003o
ool0oooo0>X0oooo00<000000?ooo`3oool05@3oool00`000000oooo0?ooo`0;0?ooo`030000003o
ool0oooo01D0oooo4000000F0?ooo`040000003oool0oooo0?ooo`D0000000@0oooo000000000000
0000203oool00`000000oooo0000000:000002`0oooo00<000000?ooo`3oool0h`3oool00`000000
oooo0?ooo`0T0?ooo`009@3oool00`000000oooo0?ooo`3[0?ooo`030000003oool0oooo01@0oooo
00<000000?ooo`3oool02`3oool00`000000oooo0?ooo`0D0?oooa<000005@3oool00`000000oooo
0?ooo`020?ooo`030000003oool0oooo00<0oooo00<000000?ooo`3oool01@3oool00`000000oooo
0?ooo`030?ooo`@000000`3oool00`000000oooo0?ooo`0Z0?ooo`030000003oool0oooo0><0oooo
00<000000?ooo`3oool0903oool002D0oooo00<000000?ooo`3oool0j`3oool00`000000oooo0?oo
o`0C0?ooo`030000003oool0oooo00/0oooo00<000000?ooo`3oool0503oool00`000000oooo0?oo
o`0>000000<0oooo0P00000C0?ooo`030000003oool0oooo0080oooo00<000000?ooo`3oool00P3o
ool3000000D0oooo00<000000?ooo`3oool01`3oool00`000000oooo0?ooo`020?ooo`030000003o
ool0oooo02P0oooo00<000000?ooo`3oool0i03oool00`000000oooo0?ooo`0T0?ooo`009@3oool0
0`000000oooo0?ooo`3P0?ooo`D0000000<0oooo0000000000000`0000000`3oool000000?ooo`0C
0?ooo`030000003oool0oooo00X0oooo00<000000?ooo`3oool04`3oool2000000@0oooo30000006
0?ooo`8000004@3oool00`000000oooo0?ooo`020?ooo`050000003oool0oooo0?ooo`0000000P3o
ool00`000000oooo0?ooo`020?ooo`030000003oool0oooo00P0oooo00<000000?ooo`3oool00`3o
ool00`000000oooo0?ooo`0W0?ooo`030000003oool0oooo0>@0oooo00<000000?ooo`3oool0903o
ool002D0oooo00<000000?ooo`3oool0hP3oool00`000000oooo0?ooo`030?ooo`050000003oool0
oooo0?ooo`000000503oool00`000000oooo0?ooo`0:0?ooo`030000003oool0oooo0180oooo00<0
00000?ooo`3oool01@3oool:000000T0oooo0P00000:0?ooo`D0000000H0oooo0000000000000000
0?ooo`0000030?ooo`040000003oool0oooo000000<0oooo00<000000?ooo`3oool02P3oool00`00
0000oooo0?ooo`030?ooo`030000003oool0oooo02H0oooo00<000000?ooo`3oool0i03oool00`00
0000oooo0?ooo`0T0?ooo`009@3oool00`000000oooo0?ooo`3R0?ooo`030000003oool0oooo00<0
oooo00<000000?ooo`3oool00P3oool00`000000oooo0?ooo`0A0?ooo`030000003oool0oooo00T0
oooo00<000000?ooo`3oool04@3oool2000000/0oooo1000000>0?ooo`8000002P3oool01@000000
oooo0?ooo`3oool000000080oooo0P0000040?ooo`<000000P3oool00`000000oooo0?ooo`0;0?oo
o`030000003oool0oooo00<0oooo00<000000?ooo`3oool09@3oool00`000000oooo0?ooo`3U0?oo
o`030000003oool0oooo02@0oooo000U0?ooo`030000003oool0oooo0>80oooo00<000000?ooo`3o
ool00`3oool00`000000oooo0?ooo`020?ooo`030000003oool0oooo0100oooo00<000000?ooo`3o
ool02@3oool00`000000oooo0?ooo`0A0?ooo`030000003oool0oooo00d0oooo00<000000?ooo`3o
ool03`3oool2000000P0oooo00<000000?ooo`3oool00P3oool5000000L0oooo00<000000?ooo`3o
ool0303oool00`000000oooo0?ooo`040?ooo`030000003oool0oooo02@0oooo00<000000?ooo`3o
ool0i@3oool00`000000oooo0?ooo`0T0?ooo`009@3oool00`000000oooo0?ooo`3R0?ooo`030000
003oool0oooo00<0oooo00<000000?ooo`3oool00`3oool00`000000oooo0?ooo`0?0?ooo`030000
003oool0oooo00T0oooo00<000000?ooo`3oool03`3oool200000100oooo00<000000?ooo`3oool0
4@3oool2000000H0oooo00<000000?ooo`3oool02P0000030?ooo`030000003oool0oooo00d0oooo
00<000000?ooo`3oool01@3oool00`000000oooo0?ooo`0S0?ooo`030000003oool0oooo0>D0oooo
00<000000?ooo`3oool0903oool002D0oooo00<000000?ooo`3oool0h@3oool2000000@0oooo0P00
00050?ooo`030000003oool0oooo00l0oooo00<000000?ooo`3oool0203oool00`000000oooo0?oo
o`0?0?ooo`030000003oool0oooo0100oooo00<000000?ooo`3oool04`3oool2000000@0oooo00<0
00000?ooo`0000002`0000000`3oool000000?ooo`0?0?ooo`030000003oool0oooo00D0oooo00<0
00000?ooo`3oool08P3oool00`000000oooo0?ooo`3V0?ooo`030000003oool0oooo02@0oooo000U
0?ooo`030000003oool0oooo0>l0oooo00<000000?ooo`3oool03P3oool00`000000oooo0?ooo`07
0?ooo`030000003oool0oooo00h0oooo0P00000D0?ooo`030000003oool0oooo01@0oooo0P000000
0`3oool000000000000>00000140oooo00<000000?ooo`3oool01P3oool00`000000oooo0?ooo`0Q
0?ooo`030000003oool0oooo0>H0oooo00<000000?ooo`3oool0903oool002D0oooo00<000000?oo
o`3oool0k`3oool00`000000oooo0?ooo`0>0?ooo`030000003oool0oooo00H0oooo00<000000?oo
o`3oool03P3oool00`000000oooo0?ooo`0D0?ooo`030000003oool0oooo01H0oooo4P00000A0?oo
o`030000003oool0oooo00H0oooo00<000000?ooo`3oool0803oool00`000000oooo0?ooo`3V0?oo
o`030000003oool0oooo02@0oooo000U0?ooo`030000003oool0oooo0?00oooo00<000000?ooo`3o
ool0303oool00`000000oooo0?ooo`070?ooo`030000003oool0oooo00`0oooo0P00000G0?ooo`03
0000003oool0oooo01P0oooo4000000@0?ooo`@000001P3oool00`000000oooo0?ooo`0O0?ooo`03
0000003oool0oooo0>L0oooo00<000000?ooo`3oool0903oool002D0oooo00<000000?ooo`3oool0
l@3oool00`000000oooo0?ooo`0;0?ooo`030000003oool0oooo00H0oooo00<000000?ooo`3oool0
303oool00`000000oooo0?ooo`0G0?ooo`030000003oool0oooo01P0oooo4000000=0?ooo`X00000
103oool00`000000oooo0?ooo`0N0?ooo`030000003oool0oooo0>L0oooo00<000000?ooo`3oool0
903oool002D0oooo00<000000?ooo`3oool0l@3oool00`000000oooo0?ooo`0;0?ooo`030000003o
ool0oooo00D0oooo00<000000?ooo`3oool0303oool00`000000oooo0?ooo`0G0?ooo`@000005`3o
oolB000000/0oooo300000040?ooo`030000003oool0oooo01d0oooo00<000000?ooo`3oool0i`3o
ool00`000000oooo0?ooo`0T0?ooo`009@3oool00`000000oooo0?ooo`3b0?ooo`030000003oool0
oooo00X0oooo00<000000?ooo`3oool01@3oool00`000000oooo0?ooo`0:0?ooo`8000005`3oool:
000001@0oooo4P00000:0?ooo`h000000`3oool00`000000oooo0?ooo`0L0?ooo`030000003oool0
oooo0>P0oooo00<000000?ooo`3oool0903oool002D0oooo00<000000?ooo`3oool0lP3oool00`00
0000oooo0?ooo`090?ooo`030000003oool0oooo00D0oooo00<000000?ooo`3oool02P3oool00`00
0000oooo0?ooo`0F0?ooo``000004`3ooolB000000T0oooo400000030?ooo`030000003oool0oooo
01/0oooo00<000000?ooo`3oool0j03oool00`000000oooo0?ooo`0T0?ooo`009@3oool00`000000
oooo0?ooo`3c0?ooo`030000003oool0oooo00P0oooo00<000000?ooo`3oool0103oool00`000000
oooo0?ooo`090?ooo`800000603oool>00000180oooo4P0000090?oooa4000000`3oool00`000000
oooo0?ooo`0J0?ooo`030000003oool0oooo0>P0oooo00<000000?ooo`3oool0903oool002D0oooo
00<000000?ooo`3oool0l`3oool00`000000oooo0?ooo`080?ooo`030000003oool0oooo00@0oooo
00<000000?ooo`3oool0203oool00`000000oooo0?ooo`0G0?oooa000000303ooolK000000D0oooo
4@0000030?ooo`030000003oool0oooo01T0oooo00<000000?ooo`3oool0j@3oool00`000000oooo
0?ooo`0T0?ooo`009@3oool00`000000oooo0?ooo`3d0?ooo`030000003oool0oooo00L0oooo00<0
00000?ooo`3oool00`3oool00`000000oooo0?ooo`070?ooo`8000006P3oool@000000L0oooo1@00
00060?oooa0000001@3ooolF000000@0oooo00<000000?ooo`3oool0603oool00`000000oooo0?oo
o`3Y0?ooo`030000003oool0oooo02@0oooo000U0?ooo`030000003oool0oooo0?@0oooo00<00000
0?ooo`3oool01`3oool00`000000oooo0?ooo`020?ooo`030000003oool0oooo00L0oooo00<00000
0?ooo`3oool06P3oool@000000030?ooo`000000000000@000002`3ooolA000000P0oooo4`000004
0?ooo`030000003oool0oooo01L0oooo00<000000?ooo`3oool0j@3oool00`000000oooo0?ooo`0T
0?ooo`009@3oool00`000000oooo0?ooo`3e0?ooo`030000003oool0oooo00D0oooo00<000000?oo
o`3oool00`3oool00`000000oooo0?ooo`050?ooo`800000703ooolB00000180oooo3P0000020?oo
o`8000001P3ooolC000000D0oooo00<000000?ooo`3oool05@3oool00`000000oooo0?ooo`3Z0?oo
o`030000003oool0oooo02@0oooo000U0?ooo`030000003oool0oooo0?H0oooo00<000000?ooo`3o
ool0103oool00`000000oooo0?ooo`020?ooo`030000003oool0oooo00D0oooo00<000000?ooo`3o
ool0703ooolB000001<0oooo3@0000040?ooo`800000103ooolC000000D0oooo00<000000?ooo`3o
ool05@3oool00`000000oooo0?ooo`3Z0?ooo`030000003oool0oooo02@0oooo000U0?ooo`030000
003oool0oooo0?H0oooo00<000000?ooo`3oool0103oool01@000000oooo0?ooo`3oool0000000H0
oooo0P00000O0?oooa800000503oool:00000080oooo00<000000?ooo`3oool00`3oool2000000<0
oooo400000080?ooo`030000003oool0oooo01@0oooo00<000000?ooo`3oool0jP3oool00`000000
oooo0?ooo`0T0?ooo`009@3oool00`000000oooo0?ooo`3g0?ooo`030000003oool0oooo00@00000
0`3oool00`000000oooo0?ooo`030?ooo`030000003oool0oooo01/0oooo5P00000F0?ooo`D00000
1P3oool00`000000oooo0?ooo`040?oooa<000002@3oool00`000000oooo0?ooo`0B0?ooo`030000
003oool0oooo0>/0oooo00<000000?ooo`3oool0903oool002D0oooo00<000000?ooo`3oool0m`3o
ool:000000@0oooo0P00000H0?ooo`H000001@3oool@000001H0oooo00<000000?ooo`3oool02P3o
ool2000000D0oooo4P0000090?ooo`030000003oool0oooo0180oooo00<000000?ooo`3oool0j`3o
ool00`000000oooo0?ooo`0T0?ooo`009@3oool00`000000oooo0?ooo`3f0?ooo``000000P3oool0
0`000000oooo0?ooo`0C0?ooo`D000002`3oool@000001H0oooo00<000000?ooo`3oool0303oool0
0`000000oooo0000000D000000X0oooo00<000000?ooo`3oool04@3oool00`000000oooo0?ooo`3[
0?ooo`030000003oool0oooo02@0oooo000U0?ooo`030000003oool0oooo0?D0oooo3`00000@0?oo
o`H00000403oool@000001H0oooo00<000000?ooo`3oool03@3ooolG000000X0oooo00<000000?oo
o`3oool03`3oool00`000000oooo0?ooo`3/0?ooo`030000003oool0oooo02@0oooo000U0?ooo`03
0000003oool0oooo0?@0oooo4000000;0?ooo`D000005`3oool?000001D0oooo00<000000?ooo`3o
ool03@3ooolG000000030?ooo`000000oooo00P0oooo00<000000?ooo`3oool03`3oool00`000000
oooo0?ooo`3/0?ooo`030000003oool0oooo02@0oooo000U0?ooo`030000003oool0oooo0?@0oooo
400000050?ooo`H000007@3oool<00000080oooo00<000000?ooo`3oool04P3oool00`000000oooo
0?ooo`0<0?oooaP000000P3oool00`000000oooo0?ooo`070?ooo`030000003oool0oooo00h0oooo
00<000000?ooo`3oool0k03oool00`000000oooo0?ooo`0T0?ooo`009@3oool00`000000oooo0?oo
o`3d0?oooaD00000903oool:000000@0oooo00<000000?ooo`3oool0403oool00`000000oooo0?oo
o`0=0?oooaP000000`3oool2000000P0oooo00<000000?ooo`3oool0303oool00`000000oooo0?oo
o`3]0?ooo`030000003oool0oooo02@0oooo000U0?ooo`030000003oool0oooo0?<0oooo4P00000[
0?ooo`@00000203oool00`000000oooo0?ooo`0?0?ooo`030000003oool0oooo00d0oooo5`000006
0?ooo`030000003oool0oooo00D0oooo00<000000?ooo`3oool0303oool00`000000oooo0?ooo`3]
0?ooo`030000003oool0oooo02@0oooo000U0?ooo`030000003oool0oooo0?<0oooo4P00000h0?oo
o`030000003oool0oooo00d0oooo00<000000?ooo`3oool03@3ooolH000000L0oooo00<000000?oo
o`3oool01@3oool00`000000oooo0?ooo`0:0?ooo`030000003oool0oooo0>h0oooo00<000000?oo
o`3oool0903oool002D0oooo00<000000?ooo`3oool0l`3ooolC000003P0oooo00<000000?ooo`3o
ool0303oool00`000000oooo0?ooo`0=0?oooaT000001`3oool2000000H0oooo00<000000?ooo`3o
ool02@3oool00`000000oooo0?ooo`3^0?ooo`030000003oool0oooo02@0oooo000U0?ooo`030000
003oool0oooo0?<0oooo4P0000000`3oool000000000000500000380oooo00<000000?ooo`3oool0
2`3oool00`000000oooo0?ooo`0=0?oooaL000000P3oool2000000L0oooo00<000000?ooo`3oool0
0`3oool00`000000oooo0?ooo`090?ooo`030000003oool0oooo0>h0oooo00<000000?ooo`3oool0
903oool002D0oooo00<000000?ooo`3oool0m03oool@000000T0oooo1`00000/0?ooo`030000003o
ool0oooo00D0oooo1@00000@0?oooaH000001@3oool2000000H0oooo00<000000?ooo`3oool00`3o
ool00`000000oooo0?ooo`070?ooo`030000003oool0oooo0>l0oooo00<000000?ooo`3oool0903o
ool002D0oooo00<000000?ooo`3oool0l`3ooolA00000100oooo1`00000V0?ooo`040000003oool0
oooo0?ooo`X000003@3ooolF000000P0oooo0P0000050?ooo`800000103oool010000000oooo0?oo
o`3oool4000000030?ooo`000000oooo0?00oooo00<000000?ooo`3oool0903oool002D0oooo00<0
00000?ooo`3oool0l@3oool2000000030?ooo`000000000000h000005`3oool700000200oooo00<0
00000?ooo`0000002`0000090?ooo`<000000P3ooolA000000<0oooo0`0000070?ooo`8000001@3o
ool00`000000oooo0?ooo`020?ooo`X00000l03oool00`000000oooo0?ooo`0T0?ooo`009@3oool0
0`000000oooo0?ooo`3_0?ooo`800000103oool>000001l0oooo2000000I0?ooo`h000001P3oool2
000000D0oooo400000070?ooo`<000001P3oool2000000@0oooo00<000000?ooo`3oool03000003_
0?ooo`030000003oool0oooo02@0oooo000U0?ooo`030000003oool0oooo0>h0oooo00<000000?oo
o`3oool01@3oool<000002P0oooo1`00000A0?oooa0000000P3oool3000000P0oooo3P00000;0?oo
o`@00000103oool2000000<0oooo3`00003^0?ooo`030000003oool0oooo02@0oooo000U0?ooo`03
0000003oool0oooo0>`0oooo0P0000090?ooo`X0000000<0oooo0000003oool0;@3oool7000000X0
oooo4P00000<0?ooo``00000403oool3000000<0oooo0P0000000`3oool000000000000>00000>d0
oooo00<000000?ooo`3oool0903oool002D0oooo00<000000?ooo`3oool0jP3oool2000000h0oooo
100000050?ooo`030000003oool0oooo0380oooo1`0000030?oooa0000003`3oool:000001@0oooo
0`0000020?oooa400000k@3oool00`000000oooo0?ooo`0T0?ooo`009@3oool00`000000oooo0?oo
o`3X0?ooo`8000006P3oool00`000000oooo0?ooo`0h0?oooa@000004@3oool4000001X0oooo4`00
003]0?ooo`030000003oool0oooo02@0oooo000U0?ooo`030000003oool0oooo0>H0oooo0P00000M
0?ooo`030000003oool0oooo03T0oooo6@00000Z0?oooa800000k03oool00`000000oooo0?ooo`0T
0?ooo`009@3oool00`000000oooo0?ooo`3T0?ooo`800000803oool00`000000oooo0?ooo`0h0?oo
oa8000001`3ooolR000000P0oooo4P00003/0?ooo`030000003oool0oooo02@0oooo000U0?ooo`03
0000003oool0oooo0>80oooo0P00000S0?ooo`030000003oool0oooo03L0oooo4P00000Y0?oooaX0
0000k03oool00`000000oooo0?ooo`0T0?ooo`009@3oool00`000000oooo0?ooo`3Q0?ooo`030000
003oool0oooo02@0oooo00<000000?ooo`3oool0=`3oool@00000380oooo4P00003/0?ooo`030000
003oool0oooo02@0oooo000U0?ooo`030000003oool0oooo0=l0oooo0P00000X0?ooo`030000003o
ool0oooo03H0oooo4000000c0?oooa000000k@3oool00`000000oooo0?ooo`0T0?ooo`009@3oool0
0`000000oooo0?ooo`3M0?ooo`800000:P3oool00`000000oooo0?ooo`0f0?oooa000000<`3oool@
00000>d0oooo00<000000?ooo`3oool0903oool002D0oooo00<000000?ooo`3oool0f`3oool20000
02d0oooo00<000000?ooo`3oool0=P3oool>000003@0oooo4@00003/0?ooo`030000003oool0oooo
02@0oooo000U0?ooo`030000003oool0oooo0=T0oooo0P00000`0?ooo`030000003oool0oooo03H0
oooo3000000f0?ooo`h000000P3oool200000>X0oooo00<000000?ooo`3oool0903oool002D0oooo
00<000000?ooo`3oool0e`3oool2000003<0oooo00<000000?ooo`3oool0=P3oool:000003P0oooo
300000050?ooo`800000j03oool00`000000oooo0?ooo`0T0?ooo`009@3oool00`000000oooo0?oo
o`3E0?ooo`800000=P3oool00`000000oooo0?ooo`0h0?ooo`@00000>@3oool2000000030?ooo`00
0000000000P00000203oool200000>H0oooo00<000000?ooo`3oool0903oool002D0oooo00<00000
0?ooo`3oool0e03oool00`000000oooo0?ooo`0g0?ooo`030000003oool0oooo03L0oooo00<00000
0?ooo`3oool0>@3oool00`000000oooo0?ooo`040?ooo`@000003@3oool200000>@0oooo00<00000
0?ooo`3oool0903oool002D0oooo00<000000?ooo`3oool0dP3oool2000003/0oooo00<000000?oo
o`3oool0=P3oool00`000000oooo0?ooo`0h0?ooo`030000003oool0oooo01P0oooo0P00003R0?oo
o`030000003oool0oooo02@0oooo000U0?ooo`030000003oool0oooo0=00oooo0P00000n0?ooo`03
0000003oool0oooo03D0oooo00<000000?ooo`3oool0=`3oool00`000000oooo0?ooo`0K0?ooo`80
0000h03oool00`000000oooo0?ooo`0T0?ooo`009@3oool00`000000oooo0?ooo`3>0?ooo`800000
@@3oool00`000000oooo0?ooo`0d0?ooo`030000003oool0oooo03H0oooo00<000000?ooo`3oool0
7P3oool200000=h0oooo00<000000?ooo`3oool0903oool002D0oooo00<000000?ooo`3oool0c03o
ool2000004@0oooo00<000000?ooo`3oool0<`3oool00`000000oooo0?ooo`0e0?ooo`030000003o
ool0oooo0240oooo0P00003L0?ooo`030000003oool0oooo02@0oooo000U0?ooo`030000003oool0
oooo0<X0oooo0P0000160?ooo`030000003oool0oooo03<0oooo00<000000?ooo`3oool0=03oool0
0`000000oooo0?ooo`0T0?ooo`800000fP3oool00`000000oooo0?ooo`0T0?ooo`009@3oool00`00
0000oooo0?ooo`390?ooo`030000003oool0oooo04L0oooo00<000000?ooo`3oool0<P3oool00`00
0000oooo0?ooo`0c0?ooo`030000003oool0oooo02L0oooo0P00003H0?ooo`030000003oool0oooo
02@0oooo000U0?ooo`030000003oool0oooo0<L0oooo0P00001;0?ooo`030000003oool0oooo0340
oooo00<000000?ooo`3oool0<P3oool00`000000oooo0?ooo`0Z0?ooo`800000eP3oool00`000000
oooo0?ooo`0T0?ooo`009@3oool00`000000oooo0?ooo`350?ooo`800000CP3oool00`000000oooo
0?ooo`0`0?ooo`030000003oool0oooo0340oooo00<000000?ooo`3oool0;@3oool200000=@0oooo
00<000000?ooo`3oool0903oool002D0oooo00<000000?ooo`3oool0``3oool200000540oooo00<0
00000?ooo`3oool0;`3oool00`000000oooo0?ooo`0`0?ooo`030000003oool0oooo0300oooo0P00
003B0?ooo`030000003oool0oooo02@0oooo000U0?ooo`030000003oool0oooo0<40oooo0P00001D
0?ooo`030000003oool0oooo02h0oooo00<000000?ooo`3oool0;`3oool00`000000oooo0?ooo`0c
0?ooo`800000d03oool00`000000oooo0?ooo`0T0?ooo`009@3oool00`000000oooo0?ooo`2o0?oo
o`800000E`3oool00`000000oooo0?ooo`0/0?ooo`030000003oool0oooo02l0oooo00<000000?oo
o`3oool0=P3oool200000<h0oooo00<000000?ooo`3oool0903oool002D0oooo00<000000?ooo`3o
ool0_@3oool2000005X0oooo00<000000?ooo`3oool0:`3oool00`000000oooo0?ooo`0]0?ooo`80
0000>`3oool200000<`0oooo00<000000?ooo`3oool0903oool002D0oooo00<000000?ooo`3oool0
_03oool00`000000oooo0?ooo`1K0?ooo`030000003oool0oooo02X0oooo00<000000?ooo`3oool0
;03oool00`000000oooo0?ooo`0m0?ooo`800000bP3oool00`000000oooo0?ooo`0T0?ooo`009@3o
ool00`000000oooo0?ooo`2j0?ooo`800000G`3oool00`000000oooo0?ooo`0Y0?ooo`030000003o
ool0oooo02/0oooo00<000000?ooo`3oool0@03oool200000<P0oooo00<000000?ooo`3oool0903o
ool002D0oooo00<000000?ooo`3oool0^03oool200000640oooo00<000000?ooo`3oool0:@3oool0
0`000000oooo0?ooo`0Z0?ooo`030000003oool0oooo04<0oooo0P0000360?ooo`030000003oool0
oooo02@0oooo000U0?ooo`030000003oool0oooo0;H0oooo0P00001T0?ooo`030000003oool0oooo
02P0oooo00<000000?ooo`3oool0:@3oool00`000000oooo0?ooo`160?ooo`800000a03oool00`00
0000oooo0?ooo`0T0?ooo`009@3oool00`000000oooo0?ooo`2d0?ooo`800000I`3oool00`000000
oooo0?ooo`0W0?ooo`030000003oool0oooo02P0oooo00<000000?ooo`3oool0B@3oool200000<80
oooo00<000000?ooo`3oool0903oool002D0oooo00<000000?ooo`3oool0/P3oool2000006X0oooo
00<000000?ooo`3oool09P3oool00`000000oooo0?ooo`0W0?ooo`030000003oool0oooo04`0oooo
0P0000300?ooo`030000003oool0oooo02@0oooo000U0?ooo`030000003oool0oooo0;00oooo0P00
001]0?ooo`030000003oool0oooo02D0oooo00<000000?ooo`3oool09P3oool00`000000oooo0?oo
o`1?0?ooo`800000_P3oool00`000000oooo0?ooo`0T0?ooo`009@3oool00`000000oooo0?ooo`2_
0?ooo`030000003oool0oooo06h0oooo00<000000?ooo`3oool0903oool00`000000oooo0?ooo`0U
0?ooo`030000003oool0oooo0580oooo0P00002l0?ooo`030000003oool0oooo02@0oooo000U0?oo
o`030000003oool0oooo0:d0oooo0P00001b0?ooo`030000003oool0oooo02<0oooo00<000000?oo
o`3oool0903oool00`000000oooo0?ooo`1E0?ooo`800000^P3oool00`000000oooo0?ooo`0T0?oo
o`009@3oool00`000000oooo0?ooo`2[0?ooo`800000M@3oool00`000000oooo0?ooo`0R0?ooo`03
0000003oool0oooo02<0oooo00<000000?ooo`3oool0F03oool200000;P0oooo00<000000?ooo`3o
ool0903oool002D0oooo00<000000?ooo`3oool0Z@3oool2000007P0oooo00<000000?ooo`3oool0
8@3oool00`000000oooo0?ooo`0R0?ooo`030000003oool0oooo05/0oooo0P00002f0?ooo`030000
003oool0oooo02@0oooo000U0?ooo`030000003oool0oooo0:L0oooo0P00001k0?ooo`030000003o
ool0oooo0200oooo00<000000?ooo`3oool08@3oool00`000000oooo0?ooo`1N0?ooo`800000]03o
ool00`000000oooo0?ooo`0T0?ooo`009@3oool00`000000oooo0?ooo`2U0?ooo`800000O@3oool0
0`000000oooo0?ooo`0O0?ooo`030000003oool0oooo0240oooo00<000000?ooo`3oool0H@3oool2
00000;80oooo00<000000?ooo`3oool0903oool002D0oooo00<000000?ooo`3oool0X`3oool20000
0800oooo00<000000?ooo`3oool07P3oool00`000000oooo0?ooo`0O0?ooo`800000IP3oool20000
0;00oooo00<000000?ooo`3oool0903oool002D0oooo00<000000?ooo`3oool0XP3oool00`000000
oooo0?ooo`210?ooo`030000003oool0oooo01d0oooo00<000000?ooo`3oool07P3oool00`000000
oooo0?ooo`1X0?ooo`800000[P3oool00`000000oooo0?ooo`0T0?ooo`009@3oool00`000000oooo
0?ooo`2P0?ooo`800000Q@3oool00`000000oooo0?ooo`0L0?ooo`030000003oool0oooo01d0oooo
00<000000?ooo`3oool0J`3oool200000:`0oooo00<000000?ooo`3oool0903oool002D0oooo00<0
00000?ooo`3oool0WP3oool2000008P0oooo00<000000?ooo`3oool06`3oool00`000000oooo0?oo
o`0L0?ooo`030000003oool0oooo06h0oooo0P00002Z0?ooo`030000003oool0oooo02@0oooo000U
0?ooo`030000003oool0oooo09`0oooo0P00002;0?ooo`030000003oool0oooo01X0oooo00<00000
0?ooo`3oool06`3oool00`000000oooo0?ooo`1a0?ooo`800000Z03oool00`000000oooo0?ooo`0T
0?ooo`009@3oool00`000000oooo0?ooo`2J0?ooo`800000SP3oool00`000000oooo0?ooo`0I0?oo
o`030000003oool0oooo01X0oooo00<000000?ooo`3oool0M03oool200000:H0oooo00<000000?oo
o`3oool0903oool002D0oooo00<000000?ooo`3oool0V03oool200000940oooo00<000000?ooo`3o
ool0603oool00`000000oooo0?ooo`0I0?ooo`030000003oool0oooo07L0oooo0P00002T0?ooo`03
0000003oool0oooo02@0oooo000U0?ooo`030000003oool0oooo09H0oooo0P00002A0?ooo`D00000
0P3oool2000001@0oooo00<000000?ooo`3oool0603oool00`000000oooo0?ooo`1j0?ooo`030000
003oool0oooo0:40oooo00<000000?ooo`3oool0903oool002D0oooo00<000000?ooo`3oool0U@3o
ool00`000000oooo0?ooo`2C0?ooo`050000003oool000000?ooo`0000000P3oool00`000000oooo
0?ooo`0A0?ooo`030000003oool0oooo01L0oooo00<000000?ooo`3oool0O03oool200000:40oooo
00<000000?ooo`3oool0903oool002D0oooo00<000000?ooo`3oool0T`3oool2000009H0oooo00D0
00000?ooo`000000oooo000000020?ooo`030000003oool0oooo0140oooo00<000000?ooo`3oool0
5P3oool00`000000oooo0?ooo`1o0?ooo`800000W`3oool00`000000oooo0?ooo`0T0?ooo`009@3o
ool00`000000oooo0?ooo`2A0?ooo`800000V03oool01@000000oooo0?ooo`000000oooo00800000
503oool00`000000oooo0?ooo`0E0?ooo`030000003oool0oooo0880oooo0P00002M0?ooo`030000
003oool0oooo02@0oooo000U0?ooo`030000003oool0oooo08l0oooo0P00002J0?ooo`050000003o
ool0oooo0?ooo`0000000P3oool00`000000oooo0?ooo`0A0?ooo`030000003oool0oooo01@0oooo
00<000000?ooo`3oool0Q@3oool2000009/0oooo00<000000?ooo`3oool0903oool002D0oooo00<0
00000?ooo`3oool0S@3oool2000009/0oooo0P0000040?ooo`800000503oool00`000000oooo0?oo
o`0C0?ooo`030000003oool0oooo08P0oooo0P00002I0?ooo`030000003oool0oooo02@0oooo000U
0?ooo`030000003oool0oooo08/0oooo0P00002T0?ooo`030000003oool0oooo0140oooo00<00000
0?ooo`3oool04`3oool00`000000oooo0?ooo`2;0?ooo`800000U`3oool00`000000oooo0?ooo`0T
0?ooo`009@3oool00`000000oooo0?ooo`290?ooo`800000Y`3oool00`000000oooo0?ooo`0@0?oo
o`030000003oool0oooo0140oooo0P00002@0?ooo`800000U@3oool00`000000oooo0?ooo`0T0?oo
o`009@3oool00`000000oooo0?ooo`280?ooo`030000003oool0oooo0:P0oooo00<000000?ooo`3o
ool03`3oool00`000000oooo0?ooo`0@0?ooo`030000003oool0oooo0980oooo0P00002C0?ooo`03
0000003oool0oooo02@0oooo000U0?ooo`030000003oool0oooo08H0oooo0P00002/0?ooo`030000
003oool0oooo00h0oooo00<000000?ooo`3oool03`3oool00`000000oooo0?ooo`2E0?ooo`800000
T@3oool00`000000oooo0?ooo`0T0?ooo`009@3oool00`000000oooo0?ooo`240?ooo`800000[`3o
ool00`000000oooo0?ooo`0=0?ooo`030000003oool0oooo00h0oooo00<000000?ooo`3oool0V03o
ool2000008l0oooo00<000000?ooo`3oool0903oool002D0oooo00<000000?ooo`3oool0PP3oool2
00000;80oooo00<000000?ooo`3oool0303oool00`000000oooo0?ooo`0=0?ooo`030000003oool0
oooo09/0oooo0P00002=0?ooo`030000003oool0oooo02@0oooo000U0?ooo`030000003oool0oooo
0800oooo0P00002d0?ooo`030000003oool0oooo00`0oooo00<000000?ooo`3oool0303oool00`00
0000oooo0?ooo`2N0?ooo`800000R`3oool00`000000oooo0?ooo`0T0?ooo`009@3oool00`000000
oooo0?ooo`1n0?ooo`800000]`3oool00`000000oooo0?ooo`0;0?ooo`030000003oool0oooo00/0
oooo00<000000?ooo`3oool0X@3oool2000008T0oooo00<000000?ooo`3oool0903oool002D0oooo
00<000000?ooo`3oool0O@3oool00`000000oooo0?ooo`2h0?ooo`030000003oool0oooo00X0oooo
00<000000?ooo`3oool02P3oool00`000000oooo0?ooo`2T0?ooo`800000Q`3oool00`000000oooo
0?ooo`0T0?ooo`009@3oool00`000000oooo0?ooo`1k0?ooo`800000_03oool00`000000oooo0?oo
o`090?ooo`030000003oool0oooo00T0oooo00<000000?ooo`3oool0Y`3oool2000008D0oooo00<0
00000?ooo`3oool0903oool002D0oooo00<000000?ooo`3oool0N@3oool200000;l0oooo00<00000
0?ooo`3oool0203oool00`000000oooo0?ooo`080?ooo`030000003oool0oooo0:X0oooo0P000023
0?ooo`030000003oool0oooo02@0oooo000U0?ooo`030000003oool0oooo07L0oooo0P0000320?oo
o`030000003oool0oooo00L0oooo00<000000?ooo`3oool01`3oool00`000000oooo0?ooo`2]0?oo
o`800000P@3oool00`000000oooo0?ooo`0T0?ooo`009@3oool00`000000oooo0?ooo`1e0?ooo`80
0000a@3oool00`000000oooo0?ooo`060?ooo`030000003oool0oooo00H0oooo00<000000?ooo`3o
ool0/03oool2000007l0oooo00<000000?ooo`3oool0903oool002D0oooo00<000000?ooo`3oool0
L`3oool200000<P0oooo00<000000?ooo`3oool00`3oool4000000H0oooo00<000000?ooo`3oool0
/`3oool2000007d0oooo00<000000?ooo`3oool0903oool002D0oooo00<000000?ooo`3oool0L@3o
ool200000</0oooo00<000000?ooo`0000002@0000000`3oool000000000002h0?ooo`800000N`3o
ool00`000000oooo0?ooo`0T0?ooo`009@3oool00`000000oooo0?ooo`1`0?ooo`030000003oool0
oooo0<`0oooo3000002l0?ooo`800000N@3oool00`000000oooo0?ooo`0T0?ooo`009@3oool00`00
0000oooo0?ooo`1^0?ooo`800000cP3oool>00000;d0oooo0P00001g0?ooo`030000003oool0oooo
02@0oooo000U0?ooo`030000003oool0oooo06`0oooo0P00003?0?oooa000000_P3oool2000007D0
oooo00<000000?ooo`3oool0903oool002D0oooo00<000000?ooo`3oool0JP3oool200000=40oooo
400000300?ooo`800000L`3oool00`000000oooo0?ooo`0T0?ooo`009@3oool00`000000oooo0?oo
o`1X0?ooo`800000d`3oool@00000<80oooo0P00001a0?ooo`030000003oool0oooo02@0oooo000U
0?ooo`030000003oool0oooo06H0oooo0P00003D0?oooa800000``3oool2000006l0oooo00<00000
0?ooo`3oool0903oool002D0oooo00<000000?ooo`3oool0I03oool200000=H0oooo4P0000350?oo
o`800000K@3oool00`000000oooo0?ooo`0T0?ooo`009@3oool00`000000oooo0?ooo`1S0?ooo`03
0000003oool0oooo0=H0oooo4P0000370?ooo`800000J`3oool00`000000oooo0?ooo`0T0?ooo`00
9@3oool00`000000oooo0?ooo`1Q0?ooo`800000f@3ooolB00000<T0oooo0P00001Y0?ooo`030000
003oool0oooo02@0oooo000U0?ooo`030000003oool0oooo05l0oooo0P00003L0?oooa000000c03o
ool2000006L0oooo00<000000?ooo`3oool0903oool002D0oooo00<000000?ooo`3oool0G@3oool2
00000=h0oooo4000003>0?ooo`800000I@3oool00`000000oooo0?ooo`0T0?ooo`009@3oool00`00
0000oooo0?ooo`1K0?ooo`800000h03oool@00000=00oooo0P00001S0?ooo`030000003oool0oooo
02@0oooo000U0?ooo`030000003oool0oooo05T0oooo0P00003S0?ooo`h00000d`3oool200000640
oooo00<000000?ooo`3oool0903oool002D0oooo00<000000?ooo`3oool0E`3oool200000>H0oooo
3000003F0?ooo`800000G`3oool00`000000oooo0?ooo`0T0?ooo`009@3oool00`000000oooo0?oo
o`1F0?ooo`030000003oool0oooo0>L0oooo2P00003I0?ooo`800000G@3oool00`000000oooo0?oo
o`0T0?ooo`009@3oool00`000000oooo0?ooo`1D0?ooo`800000k@3oool400000=h0oooo0P00001K
0?ooo`030000003oool0oooo02@0oooo000U0?ooo`030000003oool0oooo0580oooo0P00003`0?oo
o`030000003oool0oooo0>00oooo0P00001I0?ooo`030000003oool0oooo02@0oooo000U0?ooo`03
0000003oool0oooo0500oooo0P00003b0?ooo`030000003oool0oooo0>80oooo0P00001G0?ooo`03
0000003oool0oooo02@0oooo000U0?ooo`030000003oool0oooo04h0oooo0P00003d0?ooo`030000
003oool0oooo0>@0oooo0P00001E0?ooo`030000003oool0oooo02@0oooo000U0?ooo`030000003o
ool0oooo04`0oooo0P00003f0?ooo`030000003oool0oooo0>H0oooo0P00001C0?ooo`030000003o
ool0oooo02@0oooo000U0?ooo`030000003oool0oooo04X0oooo0P00003h0?ooo`030000003oool0
oooo0>P0oooo0P00001A0?ooo`030000003oool0oooo02@0oooo000U0?ooo`030000003oool0oooo
04T0oooo00<000000?ooo`3oool0n03oool00`000000oooo0?ooo`3Z0?ooo`030000003oool0oooo
04h0oooo00<000000?ooo`3oool0903oool002D0oooo00<000000?ooo`3oool0A`3oool200000?/0
oooo00<000000?ooo`3oool0j`3oool2000004h0oooo00<000000?ooo`3oool0903oool002D0oooo
00<000000?ooo`3oool0A@3oool200000?d0oooo00<000000?ooo`3oool0k@3oool2000004`0oooo
00<000000?ooo`3oool0903oool002D0oooo00<000000?ooo`3oool0@`3oool200000?l0oooo00<0
00000?ooo`3oool0k`3oool2000004X0oooo00<000000?ooo`3oool0903oool002D0oooo00<00000
0?ooo`3oool0@@3oool200000?l0oooo0P3oool00`000000oooo0?ooo`3a0?ooo`800000B03oool0
0`000000oooo0?ooo`0T0?ooo`009@3oool00`000000oooo0?ooo`0o0?ooo`800000o`3oool40?oo
o`030000003oool0oooo0?<0oooo0P0000160?ooo`030000003oool0oooo02@0oooo000U0?ooo`03
0000003oool0oooo03d0oooo0P00003o0?ooo`H0oooo00<000000?ooo`3oool0m@3oool2000004@0
oooo00<000000?ooo`3oool0903oool002D0oooo00<000000?ooo`3oool0?03oool00`000000oooo
0?ooo`3o0?ooo`H0oooo00<000000?ooo`3oool0m`3oool200000480oooo00<000000?ooo`3oool0
903oool002D0oooo00<000000?ooo`3oool0>P3oool200000?l0oooo2@3oool00`000000oooo0?oo
o`3i0?ooo`800000@03oool00`000000oooo0?ooo`0T0?ooo`009@3oool00`000000oooo0?ooo`0h
0?ooo`800000o`3oool;0?ooo`030000003oool0oooo0?/0oooo0P00000n0?ooo`030000003oool0
oooo02@0oooo000U0?ooo`030000003oool0oooo03H0oooo0P00003o0?ooo`d0oooo00<000000?oo
o`3oool0o@3oool2000003`0oooo00<000000?ooo`3oool0903oool002D0oooo00<000000?ooo`3o
ool0=03oool200000?l0oooo3`3oool00`000000oooo0?ooo`3o0?ooo`800000>P3oool00`000000
oooo0?ooo`0T0?ooo`009@3oool00`000000oooo0?ooo`0b0?ooo`800000o`3ooolA0?ooo`030000
003oool0oooo0?l0oooo0P3oool2000003P0oooo00<000000?ooo`3oool0903oool000`0oooo1000
000E0?ooo`030000003oool0oooo0300oooo0P00003o0?oooa80oooo00<000000?ooo`3oool0o`3o
ool50?ooo`8000007P3oool3000001D0oooo00<000000?ooo`3oool0903oool000`0oooo00<00000
0?ooo`3oool05P3oool00`000000oooo0?ooo`0_0?ooo`030000003oool0oooo0?l0oooo4P3oool0
0`000000oooo0?ooo`3o0?ooo`L0oooo0P00000L0?ooo`040000003oool0oooo000001@0oooo00<0
00000?ooo`3oool0903oool000d0oooo00<000000?ooo`3oool05@3oool00`000000oooo0?ooo`0]
0?ooo`800000o`3ooolE0?ooo`030000003oool0oooo0?l0oooo2@3oool2000001X0oooo00@00000
0?ooo`3oool00000503oool00`000000oooo0?ooo`0T0?ooo`003P3oool00`000000oooo0?ooo`0D
0?ooo`030000003oool0oooo02/0oooo0P00003o0?oooaL0oooo00<000000?ooo`3oool0o`3oool;
0?ooo`800000603oool3000001D0oooo00<000000?ooo`3oool0903oool000`0oooo00@000000?oo
o`3oool000005@3oool00`000000oooo0?ooo`0Y0?ooo`800000o`3ooolI0?ooo`030000003oool0
oooo0?l0oooo3@3oool2000001L0oooo00<000000?ooo`3oool0503oool00`000000oooo0?ooo`0T
0?ooo`003@3oool2000001H0oooo00<000000?ooo`3oool09`3oool200000?l0oooo6`3oool00`00
0000oooo0?ooo`3o0?ooo`l0oooo0P00000E0?ooo`<00000503oool00`000000oooo0?ooo`0T0?oo
o`009@3oool00`000000oooo0?ooo`0U0?ooo`800000o`3ooolM0?ooo`030000003oool0oooo0?l0
oooo4@3oool2000002X0oooo00<000000?ooo`3oool0903oool002D0oooo00<000000?ooo`3oool0
903oool00`000000oooo0?ooo`3o0?oooad0oooo00<000000?ooo`3oool0o`3ooolC0?ooo`800000
:03oool00`000000oooo0?ooo`0T0?ooo`009@3oool00`000000oooo0?ooo`0R0?ooo`800000o`3o
oolP0?ooo`030000003oool0oooo0?l0oooo5@3oool2000002H0oooo00<000000?ooo`3oool0903o
ool002D0oooo00<000000?ooo`3oool0803oool200000?l0oooo8P3oool00`000000oooo0?ooo`3o
0?oooaL0oooo0P00000T0?ooo`030000003oool0oooo02@0oooo000U0?ooo`030000003oool0oooo
01h0oooo0P00003o0?ooob@0oooo00<000000?ooo`3oool0o`3ooolI0?ooo`8000008P3oool00`00
0000oooo0?ooo`0T0?ooo`009@3oool00`000000oooo0?ooo`0L0?ooo`800000o`3ooolV0?ooo`03
0000003oool0oooo0?l0oooo6`3oool200000200oooo00<000000?ooo`3oool0903oool002D0oooo
00<000000?ooo`3oool06P3oool200000?l0oooo:03oool00`000000oooo0?ooo`3o0?oooad0oooo
0P00000N0?ooo`030000003oool0oooo02@0oooo000U0?ooo`030000003oool0oooo01P0oooo0P00
003o0?ooobX0oooo00<000000?ooo`3oool0o`3ooolO0?ooo`800000703oool00`000000oooo0?oo
o`0T0?ooo`009@3oool00`000000oooo0?ooo`0G0?ooo`030000003oool0oooo0?l0oooo:P3oool0
0`000000oooo0?ooo`3o0?ooob40oooo0P00000J0?ooo`030000003oool0oooo02@0oooo000U0?oo
o`030000003oool0oooo01D0oooo0P00003o0?ooobd0oooo00<000000?ooo`3oool0o`3ooolS0?oo
o`800000603oool00`000000oooo0?ooo`0T0?ooo`009@3oool00`000000oooo0?ooo`0C0?ooo`80
0000o`3oool_0?ooo`030000003oool0oooo0?l0oooo9@3oool2000001H0oooo00<000000?ooo`3o
ool0903oool002D0oooo00<000000?ooo`3oool04@3oool200000?l0oooo<@3oool00`000000oooo
0?ooo`3o0?ooobL0oooo0P00000D0?ooo`030000003oool0oooo02@0oooo000U0?ooo`030000003o
ool0oooo00l0oooo0P00003o0?oooc<0oooo00<000000?ooo`3oool0o`3ooolY0?ooo`8000004P3o
ool00`000000oooo0?ooo`0T0?ooo`009@3oool00`000000oooo0?ooo`0=0?ooo`800000o`3ooole
0?ooo`030000003oool0oooo0?l0oooo:`3oool200000100oooo00<000000?ooo`3oool0903oool0
02<0oooo1000000<0?ooo`800000o`3ooolg0?ooo`030000003oool0oooo0?l0oooo;@3oool20000
00d0oooo1000000T0?ooo`00803oool:000000P0oooo00<000000?ooo`3oool0o`3ooolg0?ooo`03
0000003oool0oooo0?l0oooo;`3oool2000000P0oooo2P00000Q0?ooo`007`3oool<000000D0oooo
0P00003o0?ooocX0oooo00<000000?ooo`3oool0o`3ooola0?ooo`8000001@3oool<00000200oooo
000N0?ooo`h000000P3oool200000?l0oooo?03oool00`000000oooo0?ooo`3o0?oooc<0oooo0P00
00020?ooo`h000007`3oool001d0oooo4@00003o0?oooch0oooo00<000000?ooo`3oool0o`3ooole
0?oooa4000007P3oool001d0oooo4000003o0?ooocl0oooo00<000000?ooo`3oool0o`3ooolf0?oo
oa0000007P3oool001d0oooo4000003o0?ooocl0oooo00<000000?ooo`3oool0o`3ooolf0?oooa00
00007P3oool001`0oooo4P00003o0?oooch0oooo00<000000?ooo`3oool0o`3ooole0?oooa800000
7@3oool001`0oooo4P00003o0?oooch0oooo00<000000?ooo`3oool0o`3ooole0?oooa8000007@3o
ool001`0oooo4P00003o0?oooch0oooo00<000000?ooo`3oool0o`3ooole0?oooa8000007@3oool0
01`0oooo4P00003o0?oooch0oooo00<000000?ooo`3oool0o`3ooole0?oooa8000007@3oool001d0
oooo4000003o0?ooocl0oooo00<000000?ooo`3oool0o`3ooolf0?oooa0000007P3oool001d0oooo
4@00003o0?oooch0oooo00<000000?ooo`3oool0o`3ooole0?oooa4000007P3oool001d0oooo4000
00000`3oool000000000003o0?oooc`0oooo00<000000?ooo`3oool0o`3ooolc0?ooo`80000000<0
oooo0000000000003P00000N0?ooo`007P3oool>000000@0oooo0P00003o0?ooocX0oooo00<00000
0?ooo`3oool0o`3ooola0?ooo`800000103oool>000001l0oooo000O0?ooo``000001`3oool20000
0?l0oooo>03oool00`000000oooo0?ooo`3o0?ooobl0oooo0P0000070?ooo``00000803oool00200
oooo2P00000:0?ooo`800000o`3ooolf0?ooo`030000003oool0oooo0?l0oooo;@3oool2000000X0
oooo2P00000Q0?ooo`008`3oool4000000l0oooo0P00003o0?oooc@0oooo00<000000?ooo`3oool0
o`3oool[0?ooo`8000003`3oool4000002@0oooo000h0?ooo`800000o`3ooolb0?ooo`030000003o
ool0oooo0?l0oooo:@3oool2000003T0oooo000j0?ooo`800000o`3oool`0?ooo`030000003oool0
oooo0?l0oooo9`3oool2000003/0oooo000l0?ooo`800000o`3oool^0?ooo`030000003oool0oooo
0?l0oooo9@3oool2000003d0oooo000n0?ooo`800000o`3oool/0?ooo`030000003oool0oooo0?l0
oooo8`3oool2000003l0oooo00100?ooo`800000o`3ooolZ0?ooo`030000003oool0oooo0?l0oooo
8@3oool200000440oooo00120?ooo`800000o`3ooolX0?ooo`030000003oool0oooo0?l0oooo7`3o
ool2000004<0oooo00140?ooo`800000o`3ooolV0?ooo`030000003oool0oooo0?l0oooo7@3oool2
000004D0oooo00160?ooo`800000o`3ooolT0?ooo`030000003oool0oooo0?l0oooo6`3oool20000
04L0oooo00180?ooo`800000o`3ooolR0?ooo`030000003oool0oooo0?l0oooo6@3oool2000004T0
oooo001:0?ooo`800000o`3ooolP0?ooo`030000003oool0oooo0?l0oooo5`3oool2000004/0oooo
001<0?ooo`800000o`3ooolN0?ooo`030000003oool0oooo0?l0oooo5@3oool2000004d0oooo001>
0?ooo`800000o`3ooolL0?ooo`030000003oool0oooo0?l0oooo4`3oool2000004l0oooo001@0?oo
o`800000o`3ooolJ0?ooo`030000003oool0oooo0?l0oooo4@3oool200000540oooo001B0?ooo`80
0000o`3ooolH0?ooo`030000003oool0oooo0?l0oooo3`3oool2000005<0oooo001D0?ooo`800000
o`3ooolF0?ooo`030000003oool0oooo0?l0oooo3@3oool2000005D0oooo001F0?ooo`800000o`3o
oolD0?ooo`030000003oool0oooo0?l0oooo2`3oool2000005L0oooo001H0?ooo`800000o`3ooolB
0?ooo`030000003oool0oooo0?l0oooo2@3oool2000005T0oooo001J0?ooo`800000o`3oool?0?oo
o`030000003oool0oooo0?l0oooo2@3oool00`000000oooo0?ooo`1I0?ooo`00G03oool200000?l0
oooo3@3oool00`000000oooo0?ooo`3o0?ooo`L0oooo0P00001L0?ooo`00GP3oool200000?l0oooo
2`3oool00`000000oooo0?ooo`3o0?ooo`D0oooo0P00001N0?ooo`00H03oool200000?l0oooo2@3o
ool00`000000oooo0?ooo`3o0?ooo`<0oooo0P00001P0?ooo`00HP3oool200000?l0oooo1`3oool0
0`000000oooo0?ooo`3o0?ooo`40oooo0P00001R0?ooo`00I03oool200000?l0oooo1@3oool00`00
0000oooo0?ooo`3n0?ooo`800000I03oool006H0oooo00<000000?ooo`3oool0o`3oool20?ooo`03
0000003oool0oooo0?`0oooo0P00001V0?ooo`00I`3oool200000?l0oooo0P3oool00`000000oooo
0?ooo`3j0?ooo`800000J03oool006T0oooo0P00003o0?ooo`030000003oool0oooo0?P0oooo0P00
001Z0?ooo`00J`3oool200000?d0oooo00<000000?ooo`3oool0mP3oool2000006`0oooo001]0?oo
o`800000n`3oool00`000000oooo0?ooo`3d0?ooo`800000KP3oool006l0oooo0P00003i0?ooo`03
0000003oool0oooo0?80oooo0P00001`0?ooo`00L@3oool200000?L0oooo00<000000?ooo`3oool0
l03oool200000780oooo001c0?ooo`800000m@3oool00`000000oooo0?ooo`3^0?ooo`800000M03o
ool007D0oooo0P00003c0?ooo`030000003oool0oooo0>`0oooo0P00001f0?ooo`00M`3oool20000
0?40oooo00<000000?ooo`3oool0jP3oool2000007P0oooo001i0?ooo`800000k`3oool00`000000
oooo0?ooo`3X0?ooo`800000NP3oool007/0oooo0P00003]0?ooo`030000003oool0oooo0>H0oooo
0P00001l0?ooo`00O@3oool200000>/0oooo00<000000?ooo`3oool0i03oool2000007h0oooo001o
0?ooo`800000j@3oool00`000000oooo0?ooo`3R0?ooo`800000P03oool00840oooo0P00003W0?oo
o`030000003oool0oooo0>00oooo0P0000220?ooo`00P`3oool200000>D0oooo00<000000?ooo`3o
ool0gP3oool2000008@0oooo00250?ooo`800000h`3oool00`000000oooo0?ooo`3L0?ooo`800000
QP3oool008L0oooo0P00003Q0?ooo`030000003oool0oooo0=X0oooo0P0000280?ooo`00R@3oool2
00000=l0oooo00<000000?ooo`3oool0f03oool2000008X0oooo002;0?ooo`800000g@3oool00`00
0000oooo0?ooo`3F0?ooo`800000S03oool008d0oooo0P00003K0?ooo`030000003oool0oooo0=@0
oooo0P00002>0?ooo`00S`3oool200000=T0oooo00<000000?ooo`3oool0dP3oool200000900oooo
002A0?ooo`800000e`3oool00`000000oooo0?ooo`3A0?ooo`030000003oool0oooo0900oooo002C
0?ooo`800000e@3oool00`000000oooo0?ooo`3?0?ooo`800000T`3oool009D0oooo0P00003C0?oo
o`030000003oool0oooo0<d0oooo0P00002E0?ooo`00U`3oool200000=40oooo00<000000?ooo`3o
ool0b`3oool2000009L0oooo002I0?ooo`800000c`3oool00`000000oooo0?ooo`390?ooo`800000
V@3oool009/0oooo0P00003=0?ooo`030000003oool0oooo0<L0oooo0P00002K0?ooo`00W@3oool2
00000</0oooo00<000000?ooo`3oool0a@3oool2000009d0oooo002O0?ooo`800000b@3oool00`00
0000oooo0?ooo`330?ooo`800000W`3oool00:40oooo0P0000370?ooo`030000003oool0oooo0<40
oooo0P00002Q0?ooo`00X`3oool200000<D0oooo00<000000?ooo`3oool0_`3oool200000:<0oooo
002U0?ooo`800000``3oool00`000000oooo0?ooo`2m0?ooo`800000Y@3oool00:L0oooo00<00000
0?ooo`3oool0`03oool00`000000oooo0?ooo`2k0?ooo`800000Y`3oool00:P0oooo0P0000300?oo
o`030000003oool0oooo0;T0oooo0P00002Y0?ooo`00ZP3oool200000;h0oooo00<000000?ooo`3o
ool0]`3oool200000:/0oooo002/0?ooo`800000_03oool00`000000oooo0?ooo`2e0?ooo`800000
[@3oool00:h0oooo0P00002j0?ooo`030000003oool0oooo0;<0oooo0P00002_0?ooo`00/03oool2
00000;P0oooo00<000000?ooo`3oool0/@3oool200000;40oooo002b0?ooo`800000]P3oool00`00
0000oooo0?ooo`2_0?ooo`800000/`3oool00;@0oooo0P00002d0?ooo`030000003oool0oooo0:d0
oooo0P00002e0?ooo`00]P3oool200000;80oooo00<000000?ooo`3oool0Z`3oool200000;L0oooo
002h0?ooo`800000/03oool00`000000oooo0?ooo`2Y0?ooo`800000^@3oool00;X0oooo0P00002^
0?ooo`030000003oool0oooo0:L0oooo0P00002k0?ooo`00_03oool200000:`0oooo00<000000?oo
o`3oool0Y@3oool200000;d0oooo002n0?ooo`800000ZP3oool00`000000oooo0?ooo`2S0?ooo`80
0000_`3oool00<00oooo0P00002X0?ooo`030000003oool0oooo0:40oooo0P0000310?ooo`00`P3o
ool200000:H0oooo00<000000?ooo`3oool0W`3oool200000<<0oooo00340?ooo`800000Y03oool0
0`000000oooo0?ooo`2M0?ooo`800000a@3oool00<H0oooo0P00002Q0?ooo`030000003oool0oooo
09d0oooo00<000000?ooo`3oool0a@3oool00<P0oooo0P00002O0?ooo`030000003oool0oooo09/0
oooo0P0000380?ooo`00bP3oool2000009d0oooo00<000000?ooo`3oool0V@3oool200000<X0oooo
003<0?ooo`800000V`3oool00`000000oooo0?ooo`2G0?ooo`800000c03oool00<h0oooo0P00002I
0?ooo`030000003oool0oooo09D0oooo0P00003>0?ooo`00d03oool2000009L0oooo00<000000?oo
o`3oool0T`3oool200000=00oooo003B0?ooo`800000U@3oool00`000000oooo0?ooo`2A0?ooo`80
0000dP3oool00=@0oooo0P00002C0?ooo`030000003oool0oooo08l0oooo0P00003D0?ooo`00eP3o
ool200000940oooo00<000000?ooo`3oool0S@3oool200000=H0oooo003H0?ooo`800000S`3oool0
0`000000oooo0?ooo`2;0?ooo`800000f03oool00=X0oooo0P00002=0?ooo`030000003oool0oooo
08T0oooo0P00003J0?ooo`00g03oool2000008/0oooo00<000000?ooo`3oool0Q`3oool200000=`0
oooo003N0?ooo`800000R@3oool00`000000oooo0?ooo`250?ooo`800000gP3oool00>00oooo0P00
00270?ooo`030000003oool0oooo08<0oooo0P00003P0?ooo`00hP3oool2000008D0oooo00<00000
0?ooo`3oool0P@3oool200000>80oooo003T0?ooo`800000P`3oool00`000000oooo0?ooo`1o0?oo
o`800000i03oool00>H0oooo00<000000?ooo`3oool0P03oool00`000000oooo0?ooo`1m0?ooo`80
0000iP3oool00>L0oooo0P0000200?ooo`030000003oool0oooo07/0oooo0P00003X0?ooo`00j@3o
ool2000007h0oooo00<000000?ooo`3oool0N@3oool200000>X0oooo003[0?ooo`800000O03oool0
0`000000oooo0?ooo`1g0?ooo`800000k03oool00>d0oooo0P00001j0?ooo`030000003oool0oooo
07D0oooo0P00003^0?ooo`00k`3oool2000007P0oooo00<000000?ooo`3oool0L`3oool200000?00
oooo003a0?ooo`800000MP3oool00`000000oooo0?ooo`1a0?ooo`800000lP3oool00?<0oooo0P00
001d0?ooo`030000003oool0oooo06l0oooo0P00003d0?ooo`00m@3oool200000780oooo00<00000
0?ooo`3oool0K@3oool200000?H0oooo003g0?ooo`800000L03oool00`000000oooo0?ooo`1[0?oo
o`800000n03oool00?T0oooo0P00001^0?ooo`030000003oool0oooo06T0oooo0P00003j0?ooo`00
n`3oool2000006`0oooo00<000000?ooo`3oool0J03oool00`000000oooo0?ooo`3j0?ooo`00o@3o
ool2000006X0oooo00<000000?ooo`3oool0IP3oool200000?d0oooo003o0?ooo`800000J03oool0
0`000000oooo0?ooo`1T0?ooo`800000o`3oool00?l0oooo0P3oool2000006H0oooo00<000000?oo
o`3oool0HP3oool200000?l0oooo0P3oool00?l0oooo103oool2000006@0oooo00<000000?ooo`3o
ool0H03oool200000?l0oooo103oool00?l0oooo1P3oool200000680oooo00<000000?ooo`3oool0
GP3oool200000?l0oooo1P3oool00?l0oooo203oool200000600oooo00<000000?ooo`3oool0G03o
ool200000?l0oooo203oool00?l0oooo2P3oool2000005h0oooo00<000000?ooo`3oool0FP3oool2
00000?l0oooo2P3oool00?l0oooo303oool2000005`0oooo00<000000?ooo`3oool0F03oool20000
0?l0oooo303oool00?l0oooo3P3oool2000005X0oooo00<000000?ooo`3oool0EP3oool200000?l0
oooo3P3oool00?l0oooo403oool2000005P0oooo00<000000?ooo`3oool0E03oool200000?l0oooo
403oool00?l0oooo4P3oool2000005H0oooo00<000000?ooo`3oool0DP3oool200000?l0oooo4P3o
ool00?l0oooo503oool2000005@0oooo00<000000?ooo`3oool0D03oool200000?l0oooo503oool0
0?l0oooo5P3oool200000580oooo00<000000?ooo`3oool0CP3oool200000?l0oooo5P3oool00?l0
oooo603oool200000500oooo00<000000?ooo`3oool0C03oool200000?l0oooo603oool00?l0oooo
6P3oool2000004h0oooo00<000000?ooo`3oool0BP3oool200000?l0oooo6P3oool00?l0oooo703o
ool2000004`0oooo00<000000?ooo`3oool0B03oool200000?l0oooo703oool00?l0oooo7P3oool2
000004X0oooo00<000000?ooo`3oool0AP3oool200000?l0oooo7P3oool00?l0oooo803oool20000
04P0oooo00<000000?ooo`3oool0A03oool200000?l0oooo803oool00?l0oooo8P3oool2000004H0
oooo00<000000?ooo`3oool0@P3oool200000?l0oooo8P3oool00?l0oooo903oool2000004@0oooo
00<000000?ooo`3oool0@03oool200000?l0oooo903oool00?l0oooo9P3oool200000480oooo00<0
00000?ooo`3oool0?P3oool200000?l0oooo9P3oool00?l0oooo:03oool00`000000oooo0?ooo`0o
0?ooo`030000003oool0oooo03`0oooo0P00003o0?ooobP0oooo003o0?ooobT0oooo0P00000o0?oo
o`030000003oool0oooo03X0oooo0P00003o0?ooobX0oooo003o0?ooob/0oooo0P00000m0?ooo`03
0000003oool0oooo03P0oooo0P00003o0?ooob`0oooo003o0?ooobd0oooo0P00000k0?ooo`030000
003oool0oooo03H0oooo0P00003o0?ooobh0oooo003o0?ooobl0oooo0P00000i0?ooo`030000003o
ool0oooo03@0oooo0P00003o0?oooc00oooo003o0?oooc40oooo0P00000M0?ooo`D000005@3oool0
0`000000oooo0?ooo`0b0?ooo`800000o`3ooolb0?ooo`00o`3ooolc0?ooo`8000007@3oool00`00
0000oooo0?ooo`0D0?ooo`030000003oool0oooo0380oooo00<000000?ooo`3oool0o`3ooolb0?oo
o`00o`3ooole0?ooo`8000006`3oool00`000000oooo0?ooo`0D0?ooo`030000003oool0oooo0300
oooo0P00003o0?ooocD0oooo003o0?ooocL0oooo0P00000I0?ooo`030000003oool0oooo01@0oooo
00<000000?ooo`3oool0;P3oool200000?l0oooo=`3oool00?l0oooo>@3oool2000001L0oooo00<0
00000?ooo`3oool0503oool00`000000oooo0?ooo`0/0?ooo`800000o`3oooli0?ooo`00o`3ooolk
0?ooo`800000503oool2000001H0oooo00<000000?ooo`3oool0:P3oool200000?l0oooo>`3oool0
0?l0oooo?@3oool2000002X0oooo00<000000?ooo`3oool0:03oool200000?l0oooo?@3oool00?l0
oooo?`3oool2000002P0oooo00<000000?ooo`3oool09P3oool200000?l0oooo?`3oool00?l0oooo
@@3oool2000002H0oooo00<000000?ooo`3oool0903oool200000?l0oooo@@3oool00?l0oooo@`3o
ool2000002@0oooo00<000000?ooo`3oool08P3oool200000?l0oooo@`3oool00?l0ooooA@3oool2
00000280oooo00<000000?ooo`3oool0803oool200000?l0ooooA@3oool00?l0ooooA`3oool20000
0200oooo00<000000?ooo`3oool07P3oool200000?l0ooooA`3oool00?l0ooooB@3oool2000001h0
oooo00<000000?ooo`3oool0703oool200000?l0ooooB@3oool00?l0ooooB`3oool2000001`0oooo
00<000000?ooo`3oool06P3oool200000?l0ooooB`3oool00?l0ooooC@3oool2000001X0oooo00<0
00000?ooo`3oool0603oool200000?l0ooooC@3oool00?l0ooooC`3oool2000001P0oooo00<00000
0?ooo`3oool05P3oool200000?l0ooooC`3oool00?l0ooooD@3oool2000001H0oooo00<000000?oo
o`3oool0503oool200000?l0ooooD@3oool00?l0ooooD`3oool2000001@0oooo00<000000?ooo`3o
ool04P3oool200000?l0ooooD`3oool00?l0ooooE@3oool200000180oooo00<000000?ooo`3oool0
403oool200000?l0ooooE@3oool00?l0ooooE`3oool2000000h0oooo1000000?0?ooo`800000o`3o
oomG0?ooo`00o`3ooomI0?ooo`8000002@3oool:000000X0oooo0P00003o0?oooeT0oooo003o0?oo
oe/0oooo0P0000060?ooo``000001`3oool200000?l0ooooF`3oool00?l0ooooG@3oool2000000<0
oooo3P0000040?ooo`800000o`3ooomM0?ooo`00o`3ooomO0?oooa80000000<0oooo000000000000
o`3ooomO0?ooo`00o`3ooomQ0?oooa400000o`3ooomQ0?ooo`00o`3ooomQ0?oooa000000o`3ooomR
0?ooo`00o`3ooomP0?oooa800000o`3ooomQ0?ooo`00o`3ooomP0?oooa800000o`3ooomQ0?ooo`00
o`3ooomP0?oooa800000o`3ooomQ0?ooo`00o`3ooomP0?oooa800000o`3ooomQ0?ooo`00o`3ooomQ
0?oooa000000o`3ooomR0?ooo`00o`3ooomQ0?oooa000000o`3ooomR0?ooo`00o`3ooomQ0?oooa00
0000o`3ooomR0?ooo`00o`3ooomR0?ooo`h00000o`3ooomS0?ooo`00o`3ooomS0?ooo``00000o`3o
oomT0?ooo`00o`3ooomT0?ooo`X00000o`3ooomU0?ooo`00o`3ooomW0?ooo`@00000o`3ooomX0?oo
o`00o`3ooooo0?ooom<0oooo003o0?ooool0ooood`3oool00?l0ooooo`3ooooC0?ooo`00o`3ooooo
0?ooom<0oooo003o0?ooool0ooood`3oool00?l0ooooo`3ooooC0?ooo`00o`3ooooo0?ooom<0oooo
003o0?ooool0ooood`3oool00?l0ooooo`3ooooC0?ooo`00o`3ooooo0?ooom<0oooo003o0?ooool0
ooood`3oool00?l0ooooo`3ooooC0?ooo`00o`3ooooo0?ooom<0oooo003o0?ooool0ooood`3oool0
0?l0ooooo`3ooooC0?ooo`00o`3ooooo0?ooom<0oooo003o0?ooool0ooood`3oool00?l0ooooo`3o
oooC0?ooo`00o`3ooooo0?ooom<0oooo003o0?ooool0ooood`3oool00?l0ooooo`3ooooC0?ooo`00
o`3ooooo0?ooom<0oooo003o0?ooool0ooood`3oool00?l0ooooo`3ooooC0?ooo`00\
\>"],
  ImageRangeCache->{{{0, 720}, {720, 0}} -> {0.0169824, -0.0500054, \
0.00134171, 0.00152779}}],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: 1 
MathPictureStart
/Mabs {
Mgmatrix idtransform
Mtmatrix dtransform
} bind def
/Mabsadd { Mabs
3 -1 roll add
3 1 roll add
exch } bind def
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
0.5 0.524864 0.5 0.454545 [
[ 0 0 0 0 ]
[ 1 1 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 0 m
1 0 L
1 1 L
0 1 L
closepath
clip
newpath
0 g
.02 w
.5 .95455 Mdot
.04545 .72727 Mdot
.04545 .27273 Mdot
.5 .04545 Mdot
.95455 .27273 Mdot
.95455 .72727 Mdot
.74426 .62213 Mdot
.65522 .53912 Mdot
.54173 .52086 Mdot
.41269 .56564 Mdot
.2719 .60348 Mdot
.21893 .35946 Mdot
.48943 .27718 Mdot
.52198 .4017 Mdot
.61673 .59686 Mdot
.76939 .36397 Mdot
.38075 .44037 Mdot
.49866 .77006 Mdot
.65054 .57527 Mdot
.63582 .43328 Mdot
.42676 .46338 Mdot
.33148 .41574 Mdot
.50118 .63522 Mdot
.5 Mabswid
[ ] 0 setdash
.5 .95455 m
.04545 .72727 L
s
.5 .95455 m
.95455 .72727 L
s
.5 .95455 m
.49866 .77006 L
s
.04545 .72727 m
.04545 .27273 L
s
.04545 .72727 m
.2719 .60348 L
s
.04545 .27273 m
.5 .04545 L
s
.04545 .27273 m
.21893 .35946 L
s
.5 .04545 m
.95455 .27273 L
s
.5 .04545 m
.48943 .27718 L
s
.95455 .27273 m
.95455 .72727 L
s
.95455 .27273 m
.76939 .36397 L
s
.95455 .72727 m
.74426 .62213 L
s
.74426 .62213 m
.65522 .53912 L
s
.74426 .62213 m
.61673 .59686 L
s
.74426 .62213 m
.76939 .36397 L
s
.74426 .62213 m
.49866 .77006 L
s
.74426 .62213 m
.65054 .57527 L
s
.74426 .62213 m
.63582 .43328 L
s
.74426 .62213 m
.50118 .63522 L
s
.65522 .53912 m
.54173 .52086 L
s
.65522 .53912 m
.65054 .57527 L
s
.65522 .53912 m
.63582 .43328 L
s
.54173 .52086 m
.41269 .56564 L
s
.54173 .52086 m
.52198 .4017 L
s
.54173 .52086 m
.61673 .59686 L
s
.54173 .52086 m
.65054 .57527 L
s
.54173 .52086 m
.63582 .43328 L
s
.54173 .52086 m
.42676 .46338 L
s
.54173 .52086 m
.50118 .63522 L
s
.41269 .56564 m
.2719 .60348 L
s
.41269 .56564 m
.42676 .46338 L
s
.41269 .56564 m
.50118 .63522 L
s
.2719 .60348 m
.21893 .35946 L
s
.2719 .60348 m
.38075 .44037 L
s
.2719 .60348 m
.49866 .77006 L
s
.2719 .60348 m
.42676 .46338 L
s
.2719 .60348 m
.33148 .41574 L
s
.2719 .60348 m
.50118 .63522 L
s
.21893 .35946 m
.48943 .27718 L
s
.21893 .35946 m
.33148 .41574 L
s
.48943 .27718 m
.52198 .4017 L
s
.48943 .27718 m
.76939 .36397 L
s
.48943 .27718 m
.38075 .44037 L
s
.48943 .27718 m
.63582 .43328 L
s
.48943 .27718 m
.42676 .46338 L
s
.48943 .27718 m
.33148 .41574 L
s
.52198 .4017 m
.63582 .43328 L
s
.52198 .4017 m
.42676 .46338 L
s
.61673 .59686 m
.65054 .57527 L
s
.61673 .59686 m
.50118 .63522 L
s
.76939 .36397 m
.63582 .43328 L
s
.38075 .44037 m
.42676 .46338 L
s
.38075 .44037 m
.33148 .41574 L
s
.49866 .77006 m
.50118 .63522 L
s
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  ImageSize->{721, 721},
  ImageMargins->{{41, 0}, {0, 52}},
  ImageRegion->{{0, 1}, {0, 1}},
  ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`4000;A0002dB000`400?l00000o`00003oo`3ooooo
0?ooom<0oooo003o0?ooool0ooood`3oool00?l0ooooo`3ooooC0?ooo`00o`3ooooo0?ooom<0oooo
003o0?ooool0ooood`3oool00?l0ooooo`3ooooC0?ooo`00o`3ooooo0?ooom<0oooo003o0?ooool0
ooood`3oool00?l0ooooo`3ooooC0?ooo`00o`3ooooo0?ooom<0oooo003o0?ooool0ooood`3oool0
0?l0ooooo`3ooooC0?ooo`00o`3ooooo0?ooom<0oooo003o0?ooool0ooood`3oool00?l0ooooo`3o
oooC0?ooo`00o`3ooooo0?ooom<0oooo003o0?ooool0ooood`3oool00?l0ooooo`3ooooC0?ooo`00
o`3ooooo0?ooom<0oooo003o0?ooool0ooood`3oool00?l0ooooo`3ooooC0?ooo`00o`3ooooo0?oo
om<0oooo003o0?ooool0ooood`3oool00?l0ooooo`3ooooC0?ooo`00o`3ooooo0?ooom<0oooo003o
0?ooool0ooood`3oool00?l0ooooo`3ooooC0?ooo`00o`3ooomV0?ooo`H00000o`3ooomW0?ooo`00
o`3ooomU0?ooo`P00000o`3ooomV0?ooo`00o`3ooomT0?ooo`X00000o`3ooomU0?ooo`00o`3ooomS
0?ooo``00000o`3ooomT0?ooo`00o`3ooomR0?ooo`d00000o`3ooomT0?ooo`00o`3ooomR0?ooo`h0
0000o`3ooomS0?ooo`00o`3ooomR0?ooo`h00000o`3ooomS0?ooo`00o`3ooomR0?ooo`h00000o`3o
oomS0?ooo`00o`3ooomR0?ooo`h00000o`3ooomS0?ooo`00o`3ooomR0?ooo`h00000o`3ooomS0?oo
o`00o`3ooomQ0?ooo`h0000000<0oooo000000000000o`3ooomQ0?ooo`00o`3ooomO0?ooo`800000
0`3oool:000000@0oooo0P00003o0?oooel0oooo003o0?oooed0oooo0P0000060?ooo`P000001`3o
ool200000?l0ooooG@3oool00?l0ooooF`3oool2000000T0oooo1P00000:0?ooo`800000o`3ooomK
0?ooo`00o`3ooomI0?ooo`8000003P3oool00`000000oooo0?ooo`0<0?ooo`800000o`3ooomI0?oo
o`00o`3ooomG0?ooo`800000403oool00`000000oooo0?ooo`0>0?ooo`800000o`3ooomG0?ooo`00
o`3ooomE0?ooo`8000004P3oool00`000000oooo0?ooo`0@0?ooo`800000o`3ooomE0?ooo`00o`3o
oomC0?ooo`8000004`3oool00`000000oooo0?ooo`0C0?ooo`800000o`3ooomC0?ooo`00o`3ooomA
0?ooo`8000005@3oool00`000000oooo0?ooo`0E0?ooo`800000o`3ooomA0?ooo`00o`3ooom?0?oo
o`8000005`3oool00`000000oooo0?ooo`0G0?ooo`800000o`3ooom?0?ooo`00o`3ooom=0?ooo`80
00006@3oool00`000000oooo0?ooo`0I0?ooo`800000o`3ooom=0?ooo`00o`3ooom;0?ooo`800000
6`3oool00`000000oooo0?ooo`0K0?ooo`800000o`3ooom;0?ooo`00o`3ooom90?ooo`8000007@3o
ool00`000000oooo0?ooo`0M0?ooo`800000o`3ooom90?ooo`00o`3ooom70?ooo`8000007`3oool0
0`000000oooo0?ooo`0O0?ooo`800000o`3ooom70?ooo`00o`3ooom50?ooo`8000008@3oool00`00
0000oooo0?ooo`0Q0?ooo`800000o`3ooom50?ooo`00o`3ooom30?ooo`8000008`3oool00`000000
oooo0?ooo`0S0?ooo`800000o`3ooom30?ooo`00o`3ooom10?ooo`8000009@3oool00`000000oooo
0?ooo`0U0?ooo`800000o`3ooom10?ooo`00o`3ooolo0?ooo`8000009`3oool00`000000oooo0?oo
o`0W0?ooo`800000o`3ooolo0?ooo`00o`3ooolm0?ooo`800000:@3oool00`000000oooo0?ooo`0Y
0?ooo`800000o`3ooolm0?ooo`00o`3ooolk0?ooo`800000:`3oool00`000000oooo0?ooo`0[0?oo
o`800000o`3ooolk0?ooo`00o`3oooli0?ooo`800000;@3oool00`000000oooo0?ooo`0]0?ooo`80
0000o`3oooli0?ooo`00o`3ooolg0?ooo`800000;`3oool00`000000oooo0?ooo`0_0?ooo`800000
o`3ooolg0?ooo`00o`3ooole0?ooo`800000<@3oool00`000000oooo0?ooo`0a0?ooo`800000o`3o
oole0?ooo`00o`3ooolc0?ooo`800000<`3oool00`000000oooo0?ooo`0c0?ooo`800000o`3ooolc
0?ooo`00o`3ooola0?ooo`800000=@3oool00`000000oooo0?ooo`0e0?ooo`800000o`3ooola0?oo
o`00o`3oool_0?ooo`800000=`3oool00`000000oooo0?ooo`0g0?ooo`800000o`3oool_0?ooo`00
o`3oool]0?ooo`800000>@3oool00`000000oooo0?ooo`0i0?ooo`800000o`3oool]0?ooo`00o`3o
ool[0?ooo`800000>`3oool00`000000oooo0?ooo`0k0?ooo`800000o`3oool[0?ooo`00o`3ooolY
0?ooo`800000?03oool00`000000oooo0?ooo`0n0?ooo`800000o`3ooolY0?ooo`00o`3ooolW0?oo
o`800000?P3oool00`000000oooo0?ooo`100?ooo`800000o`3ooolW0?ooo`00o`3ooolU0?ooo`80
0000@03oool00`000000oooo0?ooo`120?ooo`800000o`3ooolU0?ooo`00o`3ooolS0?ooo`800000
@P3oool00`000000oooo0?ooo`140?ooo`800000o`3ooolS0?ooo`00o`3ooolQ0?ooo`800000A03o
ool00`000000oooo0?ooo`160?ooo`800000o`3ooolQ0?ooo`00o`3ooolO0?ooo`800000AP3oool0
0`000000oooo0?ooo`180?ooo`800000o`3ooolO0?ooo`00o`3ooolM0?ooo`800000B03oool00`00
0000oooo0?ooo`1:0?ooo`800000o`3ooolM0?ooo`00o`3ooolK0?ooo`800000BP3oool00`000000
oooo0?ooo`1<0?ooo`800000o`3ooolK0?ooo`00o`3ooolI0?ooo`800000C03oool00`000000oooo
0?ooo`1>0?ooo`800000o`3ooolI0?ooo`00o`3ooolG0?ooo`800000CP3oool00`000000oooo0?oo
o`1@0?ooo`800000o`3ooolG0?ooo`00o`3ooolE0?ooo`800000D03oool00`000000oooo0?ooo`1B
0?ooo`800000o`3ooolE0?ooo`00o`3ooolC0?ooo`800000DP3oool00`000000oooo0?ooo`1D0?oo
o`800000o`3ooolC0?ooo`00o`3ooolA0?ooo`800000E03oool00`000000oooo0?ooo`1F0?ooo`80
0000o`3ooolA0?ooo`00o`3oool?0?ooo`800000EP3oool00`000000oooo0?ooo`1H0?ooo`800000
o`3oool?0?ooo`00o`3oool=0?ooo`800000F03oool00`000000oooo0?ooo`1J0?ooo`800000o`3o
ool=0?ooo`00o`3oool;0?ooo`800000FP3oool00`000000oooo0?ooo`1L0?ooo`800000o`3oool;
0?ooo`00o`3oool90?ooo`800000G03oool00`000000oooo0?ooo`1N0?ooo`800000o`3oool90?oo
o`00o`3oool70?ooo`800000GP3oool00`000000oooo0?ooo`1P0?ooo`800000o`3oool70?ooo`00
o`3oool50?ooo`800000H03oool00`000000oooo0?ooo`1R0?ooo`800000o`3oool50?ooo`00o`3o
ool30?ooo`800000HP3oool00`000000oooo0?ooo`1T0?ooo`800000o`3oool30?ooo`00o`3oool1
0?ooo`800000I03oool00`000000oooo0?ooo`1V0?ooo`800000o`3oool10?ooo`00oP3oool20000
06D0oooo00<000000?ooo`3oool0J@3oool200000?h0oooo003l0?ooo`800000I`3oool00`000000
oooo0?ooo`1[0?ooo`800000o03oool00?X0oooo0P00001Y0?ooo`030000003oool0oooo06d0oooo
0P00003j0?ooo`00n03oool2000006/0oooo00<000000?ooo`3oool0K`3oool200000?P0oooo003f
0?ooo`800000K@3oool00`000000oooo0?ooo`1a0?ooo`800000mP3oool00?@0oooo0P00001_0?oo
o`030000003oool0oooo07<0oooo0P00003d0?ooo`00lP3oool200000740oooo00<000000?ooo`3o
ool0M@3oool200000?80oooo003`0?ooo`800000L`3oool00`000000oooo0?ooo`1g0?ooo`800000
l03oool00>h0oooo0P00001e0?ooo`030000003oool0oooo07T0oooo0P00003^0?ooo`00k03oool2
000007L0oooo00<000000?ooo`3oool0N`3oool200000>`0oooo003Z0?ooo`800000N@3oool00`00
0000oooo0?ooo`1m0?ooo`800000jP3oool00>P0oooo0P00001k0?ooo`030000003oool0oooo07l0
oooo0P00003X0?ooo`00iP3oool2000007d0oooo00<000000?ooo`3oool0P@3oool200000>H0oooo
003T0?ooo`800000O`3oool00`000000oooo0?ooo`230?ooo`800000i03oool00>80oooo0P000021
0?ooo`030000003oool0oooo08D0oooo0P00003R0?ooo`00h03oool2000008<0oooo00<000000?oo
o`3oool0Q`3oool200000>00oooo003N0?ooo`800000Q@3oool00`000000oooo0?ooo`290?ooo`80
0000gP3oool00=`0oooo0P0000270?ooo`030000003oool0oooo08/0oooo0P00003L0?ooo`00fP3o
ool2000008T0oooo00<000000?ooo`3oool0S@3oool200000=X0oooo003H0?ooo`800000R`3oool0
0`000000oooo0?ooo`2?0?ooo`800000f03oool00=H0oooo0P00002=0?ooo`030000003oool0oooo
0940oooo0P00003F0?ooo`00e03oool2000008h0oooo00<000000?ooo`3oool0U03oool200000=@0
oooo003B0?ooo`800000T03oool00`000000oooo0?ooo`2F0?ooo`800000dP3oool00=00oooo0P00
002B0?ooo`030000003oool0oooo09P0oooo0P00003@0?ooo`00cP3oool2000009@0oooo00<00000
0?ooo`3oool0VP3oool200000<h0oooo003<0?ooo`800000UP3oool00`000000oooo0?ooo`2L0?oo
o`800000c03oool00<X0oooo0P00002H0?ooo`030000003oool0oooo09h0oooo0P00003:0?ooo`00
b03oool2000009X0oooo00<000000?ooo`3oool0X03oool200000<P0oooo00360?ooo`800000W03o
ool00`000000oooo0?ooo`2R0?ooo`800000aP3oool00<@0oooo0P00002N0?ooo`030000003oool0
oooo0:@0oooo0P0000340?ooo`00`P3oool200000:00oooo00<000000?ooo`3oool0YP3oool20000
0<80oooo00300?ooo`800000XP3oool00`000000oooo0?ooo`2X0?ooo`800000`03oool00;h0oooo
0P00002T0?ooo`030000003oool0oooo0:X0oooo0P00002n0?ooo`00_03oool200000:H0oooo00<0
00000?ooo`3oool0[03oool200000;`0oooo002j0?ooo`800000Z03oool00`000000oooo0?ooo`2^
0?ooo`800000^P3oool00;P0oooo0P00002Z0?ooo`030000003oool0oooo0;00oooo0P00002h0?oo
o`00]P3oool200000:`0oooo00<000000?ooo`3oool0/P3oool200000;H0oooo002d0?ooo`800000
[P3oool00`000000oooo0?ooo`2d0?ooo`800000]03oool00;80oooo0P00002`0?ooo`030000003o
ool0oooo0;H0oooo0P00002b0?ooo`00/03oool200000;80oooo00<000000?ooo`3oool0^03oool2
00000;00oooo002^0?ooo`800000]03oool00`000000oooo0?ooo`2j0?ooo`800000[P3oool00:`0
oooo0P00002e0?ooo`030000003oool0oooo0;d0oooo0P00002/0?ooo`00ZP3oool200000;L0oooo
00<000000?ooo`3oool0_`3oool200000:X0oooo002X0?ooo`800000^@3oool00`000000oooo0?oo
o`310?ooo`800000Z03oool00:H0oooo0P00002k0?ooo`030000003oool0oooo0<<0oooo0P00002V
0?ooo`00Y03oool200000;d0oooo00<000000?ooo`3oool0a@3oool200000:@0oooo002R0?ooo`80
0000_`3oool00`000000oooo0?ooo`370?ooo`800000XP3oool00:00oooo0P0000310?ooo`030000
003oool0oooo0<T0oooo0P00002P0?ooo`00WP3oool200000<<0oooo00<000000?ooo`3oool0b`3o
ool2000009h0oooo002L0?ooo`800000a@3oool00`000000oooo0?ooo`3=0?ooo`800000W03oool0
09X0oooo0P0000370?ooo`030000003oool0oooo0<l0oooo0P00002J0?ooo`00V03oool200000<T0
oooo00<000000?ooo`3oool0d@3oool2000009P0oooo002F0?ooo`800000b`3oool00`000000oooo
0?ooo`3C0?ooo`800000UP3oool009@0oooo0P00003=0?ooo`030000003oool0oooo0=D0oooo0P00
002D0?ooo`00TP3oool200000<l0oooo00<000000?ooo`3oool0e`3oool200000980oooo002@0?oo
o`800000d@3oool00`000000oooo0?ooo`3I0?ooo`800000T03oool008h0oooo0P00003C0?ooo`03
0000003oool0oooo0=/0oooo0P00002>0?ooo`00S03oool200000=D0oooo00<000000?ooo`3oool0
g@3oool2000008`0oooo002:0?ooo`800000e`3oool00`000000oooo0?ooo`3O0?ooo`800000RP3o
ool008P0oooo0P00003I0?ooo`030000003oool0oooo0>40oooo0P0000280?ooo`00QP3oool20000
0=/0oooo00<000000?ooo`3oool0h`3oool2000008H0oooo00240?ooo`800000g@3oool00`000000
oooo0?ooo`3U0?ooo`800000Q03oool00880oooo0P00003N0?ooo`030000003oool0oooo0>P0oooo
0P0000220?ooo`00P03oool200000>00oooo00<000000?ooo`3oool0jP3oool200000800oooo001n
0?ooo`800000hP3oool00`000000oooo0?ooo`3/0?ooo`800000OP3oool007`0oooo0P00003T0?oo
o`030000003oool0oooo0>h0oooo0P00001l0?ooo`00NP3oool200000>H0oooo00<000000?ooo`3o
ool0l03oool2000007X0oooo001h0?ooo`800000j03oool00`000000oooo0?ooo`3b0?ooo`800000
N03oool007H0oooo0P00003Z0?ooo`030000003oool0oooo0?@0oooo0P00001f0?ooo`00M03oool2
00000>`0oooo00<000000?ooo`3oool0mP3oool2000007@0oooo001b0?ooo`800000kP3oool00`00
0000oooo0?ooo`3h0?ooo`800000LP3oool00700oooo0P00003`0?ooo`030000003oool0oooo0?X0
oooo0P00001`0?ooo`00KP3oool200000?80oooo00<000000?ooo`3oool0o03oool2000006h0oooo
001/0?ooo`800000m03oool00`000000oooo0?ooo`3n0?ooo`800000K03oool006X0oooo0P00003f
0?ooo`030000003oool0oooo0?l0oooo0@3oool2000006X0oooo001X0?ooo`800000n03oool00`00
0000oooo0?ooo`3o0?ooo`<0oooo0P00001X0?ooo`00IP3oool200000?X0oooo00<000000?ooo`3o
ool0o`3oool50?ooo`800000IP3oool006@0oooo0P00003l0?ooo`030000003oool0oooo0?l0oooo
1`3oool2000006@0oooo001R0?ooo`800000oP3oool00`000000oooo0?ooo`3o0?ooo`T0oooo0P00
001R0?ooo`00H03oool200000?l0oooo0@3oool00`000000oooo0?ooo`3o0?ooo`/0oooo0P00001P
0?ooo`00GP3oool200000?l0oooo0`3oool00`000000oooo0?ooo`3o0?ooo`d0oooo0P00001N0?oo
o`00G03oool200000?l0oooo1@3oool00`000000oooo0?ooo`3o0?ooo`l0oooo0P00001L0?ooo`00
FP3oool200000?l0oooo1`3oool00`000000oooo0?ooo`3o0?oooa40oooo0P00001J0?ooo`00F03o
ool200000?l0oooo203oool00`000000oooo0?ooo`3o0?oooa@0oooo0P00001H0?ooo`00EP3oool2
00000?l0oooo2P3oool00`000000oooo0?ooo`3o0?oooaH0oooo0P00001F0?ooo`00E03oool20000
0?l0oooo303oool00`000000oooo0?ooo`3o0?oooaP0oooo0P00001D0?ooo`00DP3oool200000?l0
oooo3P3oool00`000000oooo0?ooo`3o0?oooaX0oooo0P00001B0?ooo`00D03oool200000?l0oooo
403oool00`000000oooo0?ooo`3o0?oooa`0oooo0P00001@0?ooo`00CP3oool200000?l0oooo4P3o
ool00`000000oooo0?ooo`3o0?oooah0oooo0P00001>0?ooo`00C03oool200000?l0oooo503oool0
0`000000oooo0?ooo`3o0?ooob00oooo0P00001<0?ooo`00BP3oool200000?l0oooo5P3oool00`00
0000oooo0?ooo`3o0?ooob80oooo0P00001:0?ooo`00B03oool200000?l0oooo603oool00`000000
oooo0?ooo`3o0?ooob@0oooo0P0000180?ooo`00AP3oool200000?l0oooo6P3oool00`000000oooo
0?ooo`3o0?ooobH0oooo0P0000160?ooo`00A03oool200000?l0oooo703oool00`000000oooo0?oo
o`3o0?ooobP0oooo0P0000140?ooo`00@P3oool200000?l0oooo7P3oool00`000000oooo0?ooo`3o
0?ooobX0oooo0P0000120?ooo`00@03oool200000?l0oooo803oool00`000000oooo0?ooo`3o0?oo
ob`0oooo0P0000100?ooo`00?P3oool200000?l0oooo8P3oool00`000000oooo0?ooo`3o0?ooobh0
oooo0P00000n0?ooo`00?03oool200000?l0oooo903oool00`000000oooo0?ooo`3o0?oooc00oooo
0P00000l0?ooo`00>P3oool200000?l0oooo9P3oool00`000000oooo0?ooo`3o0?oooc80oooo0P00
000j0?ooo`00>03oool200000?l0oooo:03oool00`000000oooo0?ooo`3o0?oooc@0oooo0P00000h
0?ooo`00=P3oool200000?l0oooo:P3oool00`000000oooo0?ooo`3o0?ooocH0oooo0P00000f0?oo
o`00=03oool200000?l0oooo;03oool00`000000oooo0?ooo`3o0?ooocP0oooo0P00000d0?ooo`00
<P3oool200000?l0oooo;P3oool00`000000oooo0?ooo`3o0?ooocX0oooo0P00000b0?ooo`00<03o
ool200000?l0oooo<03oool00`000000oooo0?ooo`3o0?oooc`0oooo0P00000`0?ooo`00;P3oool2
00000?l0oooo<@3oool00`000000oooo0?ooo`3o0?ooocl0oooo0P00000^0?ooo`007P3oool60000
00P0oooo0P00003o0?oooc<0oooo00<000000?ooo`3oool0o`3ooom10?ooo`8000001`3oool60000
01l0oooo000M0?ooo`P000001@3oool200000?l0oooo=@3oool00`000000oooo0?ooo`3o0?oood<0
oooo0P0000040?ooo`P000007P3oool001`0oooo2P0000020?ooo`800000o`3ooolg0?ooo`030000
003oool0oooo0?l0ooooA@3oool2000000030?ooo`000000000000P000007@3oool001/0oooo3@00
003o0?ooocH0oooo1P00003o0?ooodL0oooo3000000L0?ooo`006P3oool=00000?l0oooo=P3oool8
00000?l0ooooA@3oool=000001`0oooo000J0?ooo`h00000o`3ooold0?ooo`X00000o`3ooom40?oo
o`h000006`3oool001X0oooo3P00003o0?oooc<0oooo3000003o0?oood<0oooo3P00000K0?ooo`00
6P3oool>00000?l0oooo<P3oool=00000?l0oooo@`3oool>000001/0oooo000J0?ooo`h00000o`3o
oolb0?ooo`h00000o`3ooom20?ooo`h000006`3oool001X0oooo3P00003o0?oooc80oooo3P00003o
0?oood80oooo3@00000L0?ooo`006`3oool<000000030?ooo`00000000000?l0oooo<03oool>0000
0?l0oooo@03oool2000000030?ooo`000000000000X00000703oool001`0oooo2P0000040?ooo`80
0000o`3oool]0?oooa000000o`3ooolm0?ooo`800000103oool:000001d0oooo000M0?ooo`P00000
1`3oool200000?l0oooo:03oool3000000030?ooo`000000000000/000000P3oool400000?l0oooo
=`3oool2000000L0oooo2000000N0?ooo`007P3oool6000000X0oooo0P00003o0?ooob<0oooo0`00
00050?ooo``000001P3oool300000?l0oooo<P3oool2000000X0oooo1P00000O0?ooo`00803oool0
0`000000oooo0?ooo`0=0?ooo`800000o`3ooolM0?ooo`@00000203oool<000000T0oooo0`00003o
0?ooobd0oooo0P00000?0?ooo`030000003oool0oooo01l0oooo000P0?ooo`030000003oool0oooo
00l0oooo0P00003o0?oooaP0oooo0`00000;0?ooo`030000003oool0oooo00P000000P3oool00`00
0000oooo0?ooo`090?ooo`<00000o`3ooolX0?ooo`8000004@3oool00`000000oooo0?ooo`0O0?oo
o`00803oool00`000000oooo0?ooo`0A0?ooo`800000o`3ooolC0?ooo`<000003@3oool01@000000
oooo0?ooo`000000oooo00H00000103oool00`000000oooo0?ooo`0;0?ooo`<00000o`3ooolS0?oo
o`8000004`3oool00`000000oooo0?ooo`0O0?ooo`00803oool00`000000oooo0?ooo`0C0?ooo`80
0000o`3oool=0?ooo`@000003`3oool01`000000oooo0?ooo`3oool000000?ooo`000000103oool0
0`000000oooo0?ooo`020?ooo`030000003oool0oooo00h0oooo1000003o0?oooad0oooo0P00000E
0?ooo`030000003oool0oooo01l0oooo000P0?ooo`030000003oool0oooo01D0oooo0P00003o0?oo
o`P0oooo0`00000B0?ooo`050000003oool0oooo0?ooo`0000000P3oool00`000000oooo0?ooo`02
0?ooo`030000003oool0oooo00<0oooo00<000000?ooo`3oool04@3oool300000?l0oooo603oool2
000001L0oooo00<000000?ooo`3oool07`3oool00200oooo00<000000?ooo`3oool05`3oool20000
0?l0oooo0`3oool3000001@0oooo00D000000?ooo`3oool0oooo000000030?ooo`030000003oool0
oooo00<0oooo00<000000?ooo`3oool00`3oool00`000000oooo0?ooo`0C0?ooo`<00000o`3ooolC
0?ooo`8000006@3oool00`000000oooo0?ooo`0O0?ooo`00803oool00`000000oooo0?ooo`0I0?oo
o`800000o03oool4000001D0oooo0P0000040?ooo`040000003oool0oooo000000H0oooo00<00000
0?ooo`3oool0103oool00`000000oooo0?ooo`0E0?ooo`<00000o`3oool>0?ooo`8000006`3oool0
0`000000oooo0?ooo`0O0?ooo`00803oool00`000000oooo0?ooo`0K0?ooo`800000m`3oool30000
01P0oooo00<000000?ooo`3oool00`3oool01@000000oooo0?ooo`3oool0000000H0oooo00<00000
0?ooo`3oool01@3oool00`000000oooo0?ooo`0G0?ooo`<00000o`3oool90?ooo`8000007@3oool0
0`000000oooo0?ooo`0O0?ooo`00803oool00`000000oooo0?ooo`0M0?ooo`800000lP3oool30000
01X0oooo00<000000?ooo`3oool00`3oool00`000000oooo0?ooo`020?ooo`030000003oool0oooo
00@0oooo00<000000?ooo`3oool01P3oool00`000000oooo0?ooo`0I0?ooo`@00000o`3oool30?oo
o`8000007`3oool00`000000oooo0?ooo`0O0?ooo`00803oool00`000000oooo0?ooo`0O0?ooo`80
0000k@3oool3000001`0oooo00<000000?ooo`3oool0103oool01@000000oooo0?ooo`3oool00000
00P0oooo00<000000?ooo`3oool01P3oool00`000000oooo0?ooo`0L0?ooo`<00000o@3oool20000
0240oooo00<000000?ooo`3oool07`3oool00200oooo00<000000?ooo`3oool08@3oool200000>L0
oooo1000000N0?ooo`030000003oool0oooo00@0oooo00<000000?ooo`3oool00P3oool00`000000
oooo0?ooo`060?ooo`030000003oool0oooo00L0oooo00<000000?ooo`3oool07P3oool300000?P0
oooo0P00000S0?ooo`030000003oool0oooo01l0oooo000P0?ooo`030000003oool0oooo02<0oooo
0P00003R0?ooo`<000008@3oool00`000000oooo0?ooo`040?ooo`030000003oool0oooo00<0oooo
00<000000?ooo`3oool01P3oool00`000000oooo0?ooo`080?ooo`030000003oool0oooo0200oooo
0`00003c0?ooo`8000009@3oool00`000000oooo0?ooo`0O0?ooo`00803oool00`000000oooo0?oo
o`0U0?ooo`800000g@3oool3000002<0oooo00<000000?ooo`3oool01@3oool00`000000oooo0?oo
o`020?ooo`030000003oool0oooo00L0oooo00<000000?ooo`3oool02@3oool00`000000oooo0?oo
o`0R0?ooo`<00000kP3oool2000002L0oooo00<000000?ooo`3oool07`3oool00200oooo00<00000
0?ooo`3oool09`3oool200000=L0oooo1000000T0?ooo`8000001`3oool00`000000oooo0?ooo`03
0?ooo`030000003oool0oooo00P0oooo00<000000?ooo`3oool02@3oool00`000000oooo0?ooo`0T
0?ooo`@00000j03oool2000002T0oooo00<000000?ooo`3oool07`3oool00200oooo00<000000?oo
o`3oool0:@3oool200000=80oooo0`00000W0?ooo`030000003oool0oooo00H0oooo00<000000?oo
o`3oool0103oool00`000000oooo0?ooo`080?ooo`030000003oool0oooo00X0oooo00<000000?oo
o`3oool09`3oool300000><0oooo0P00000[0?ooo`030000003oool0oooo01l0oooo000P0?ooo`03
0000003oool0oooo02/0oooo0P00003=0?ooo`<00000:@3oool00`000000oooo0?ooo`070?ooo`03
0000003oool0oooo00<0oooo00<000000?ooo`3oool02@3oool00`000000oooo0?ooo`0;0?ooo`03
0000003oool0oooo02T0oooo0`00003N0?ooo`800000;@3oool00`000000oooo0?ooo`0O0?ooo`00
803oool00`000000oooo0?ooo`0]0?ooo`800000a`3oool4000002/0oooo00<000000?ooo`3oool0
1`3oool00`000000oooo0?ooo`040?ooo`030000003oool0oooo00T0oooo00<000000?ooo`3oool0
303oool00`000000oooo0?ooo`0[0?ooo`<00000f@3oool2000002l0oooo00<000000?ooo`3oool0
7`3oool00200oooo00<000000?ooo`3oool0;`3oool200000<80oooo0`00000^0?ooo`030000003o
ool0oooo00L0oooo00<000000?ooo`3oool01@3oool00`000000oooo0?ooo`0:0?ooo`030000003o
ool0oooo00`0oooo00<000000?ooo`3oool0;@3oool300000=@0oooo0P00000a0?ooo`030000003o
ool0oooo01l0oooo000P0?ooo`030000003oool0oooo0340oooo0P00002m0?ooo`<00000<03oool0
0`000000oooo0?ooo`080?ooo`030000003oool0oooo00@0oooo00<000000?ooo`3oool02`3oool0
0`000000oooo0?ooo`0=0?ooo`030000003oool0oooo02l0oooo0`00003?0?ooo`800000<`3oool0
0`000000oooo0?ooo`0O0?ooo`00803oool00`000000oooo0?ooo`0c0?ooo`800000^03oool30000
0380oooo00<000000?ooo`3oool0203oool00`000000oooo0?ooo`050?ooo`030000003oool0oooo
00/0oooo00<000000?ooo`3oool03@3oool00`000000oooo0?ooo`0b0?ooo`@00000b@3oool20000
03D0oooo00<000000?ooo`3oool07`3oool00200oooo00<000000?ooo`3oool0=@3oool200000;80
oooo1000000c0?ooo`8000002P3oool00`000000oooo0?ooo`060?ooo`030000003oool0oooo00/0
oooo00<000000?ooo`3oool03P3oool00`000000oooo0?ooo`0e0?ooo`<00000a03oool2000003L0
oooo00<000000?ooo`3oool07`3oool00200oooo00<000000?ooo`3oool0=`3oool200000:d0oooo
0`00000f0?ooo`030000003oool0oooo00X0oooo00<000000?ooo`3oool01@3oool00`000000oooo
0?ooo`0=0?ooo`030000003oool0oooo00h0oooo00<000000?ooo`3oool0=`3oool300000;l0oooo
0P00000i0?ooo`030000003oool0oooo01l0oooo000P0?ooo`030000003oool0oooo03T0oooo0P00
002X0?ooo`<00000>03oool00`000000oooo0?ooo`0:0?ooo`030000003oool0oooo00H0oooo00<0
00000?ooo`3oool03@3oool00`000000oooo0?ooo`0?0?ooo`030000003oool0oooo03T0oooo0`00
002j0?ooo`800000>`3oool00`000000oooo0?ooo`0O0?ooo`00803oool00`000000oooo0?ooo`0k
0?ooo`800000XP3oool4000003X0oooo00<000000?ooo`3oool02P3oool00`000000oooo0?ooo`07
0?ooo`030000003oool0oooo00d0oooo00<000000?ooo`3oool0403oool00`000000oooo0?ooo`0k
0?ooo`<00000]@3oool2000003d0oooo00<000000?ooo`3oool07`3oool00200oooo00<000000?oo
o`3oool0?@3oool2000009d0oooo0`00000m0?ooo`030000003oool0oooo00/0oooo00<000000?oo
o`3oool01P3oool00`000000oooo0?ooo`0>0?ooo`030000003oool0oooo0140oooo00<000000?oo
o`3oool0?@3oool400000:l0oooo0P00000o0?ooo`030000003oool0oooo01l0oooo000P0?ooo`03
0000003oool0oooo03l0oooo0P00002H0?ooo`<00000?`3oool00`000000oooo0?ooo`0;0?ooo`03
0000003oool0oooo00L0oooo00<000000?ooo`3oool03`3oool00`000000oooo0?ooo`0A0?ooo`03
0000003oool0oooo0400oooo0`00002Y0?ooo`<00000@@3oool00`000000oooo0?ooo`0O0?ooo`00
803oool00`000000oooo0?ooo`110?ooo`800000TP3oool400000440oooo00<000000?ooo`3oool0
303oool00`000000oooo0?ooo`070?ooo`030000003oool0oooo00l0oooo00<000000?ooo`3oool0
4P3oool00`000000oooo0?ooo`120?ooo`<00000Y03oool2000004@0oooo00<000000?ooo`3oool0
7`3oool00200oooo00<000000?ooo`3oool0@`3oool2000008d0oooo0`0000130?ooo`8000003P3o
ool00`000000oooo0?ooo`070?ooo`030000003oool0oooo0100oooo00<000000?ooo`3oool04`3o
ool00`000000oooo0?ooo`140?ooo`<00000W`3oool2000004H0oooo00<000000?ooo`3oool07`3o
ool00200oooo00<000000?ooo`3oool0A@3oool2000008P0oooo0`0000150?ooo`030000003oool0
oooo00d0oooo00<000000?ooo`3oool0203oool00`000000oooo0?ooo`0@0?ooo`030000003oool0
oooo01@0oooo00<000000?ooo`3oool0AP3oool3000009X0oooo0P0000180?ooo`030000003oool0
oooo01l0oooo000P0?ooo`030000003oool0oooo04L0oooo0P0000220?ooo`@00000A`3oool00`00
0000oooo0?ooo`0>0?ooo`030000003oool0oooo00P0oooo00<000000?ooo`3oool04@3oool00`00
0000oooo0?ooo`0D0?ooo`030000003oool0oooo04P0oooo1000002D0?ooo`800000BP3oool00`00
0000oooo0?ooo`0O0?ooo`00803oool00`000000oooo0?ooo`190?ooo`800000O@3oool3000004X0
oooo00<000000?ooo`3oool03P3oool00`000000oooo0?ooo`080?ooo`030000003oool0oooo0180
oooo00<000000?ooo`3oool05@3oool00`000000oooo0?ooo`1;0?ooo`<00000S`3oool2000004`0
oooo00<000000?ooo`3oool07`3oool00200oooo00<000000?ooo`3oool0B`3oool2000007P0oooo
0`00001<0?ooo`030000003oool0oooo00h0oooo00<000000?ooo`3oool02@3oool00`000000oooo
0?ooo`0B0?ooo`030000003oool0oooo01H0oooo00<000000?ooo`3oool0C@3oool3000008X0oooo
0P00001>0?ooo`030000003oool0oooo01l0oooo000P0?ooo`030000003oool0oooo04d0oooo0P00
001c0?ooo`<00000CP3oool00`000000oooo0?ooo`0?0?ooo`030000003oool0oooo00T0oooo00<0
00000?ooo`3oool04P3oool00`000000oooo0?ooo`0G0?ooo`030000003oool0oooo04l0oooo0`00
00250?ooo`800000D03oool00`000000oooo0?ooo`0O0?ooo`00803oool00`000000oooo0?ooo`1?
0?ooo`800000K@3oool400000500oooo00<000000?ooo`3oool03`3oool00`000000oooo0?ooo`09
0?ooo`030000003oool0oooo01@0oooo00<000000?ooo`3oool05`3oool00`000000oooo0?ooo`1A
0?ooo`<00000P03oool200000580oooo00<000000?ooo`3oool07`3oool00200oooo00<000000?oo
o`3oool0D@3oool2000006P0oooo0`00001B0?ooo`8000004@3oool00`000000oooo0?ooo`0:0?oo
o`030000003oool0oooo01@0oooo00<000000?ooo`3oool0603oool00`000000oooo0?ooo`1C0?oo
o`@00000NP3oool2000005@0oooo00<000000?ooo`3oool07`3oool00200oooo00<000000?ooo`3o
ool0D`3oool2000006<0oooo0`00001D0?ooo`030000003oool0oooo0140oooo00<000000?ooo`3o
ool02P3oool00`000000oooo0?ooo`0D0?ooo`030000003oool0oooo01P0oooo00<000000?ooo`3o
ool0E`3oool3000007D0oooo0P00001F0?ooo`030000003oool0oooo01l0oooo000P0?ooo`030000
003oool0oooo05D0oooo0P00001M0?ooo`@00000EP3oool00`000000oooo0?ooo`0A0?ooo`030000
003oool0oooo00X0oooo00<000000?ooo`3oool05@3oool00`000000oooo0?ooo`0I0?ooo`030000
003oool0oooo05T0oooo0`00001`0?ooo`800000F03oool00`000000oooo0?ooo`0O0?ooo`00803o
ool00`000000oooo0?ooo`1G0?ooo`800000F03oool3000005T0oooo00<000000?ooo`3oool04@3o
ool00`000000oooo0?ooo`0;0?ooo`030000003oool0oooo01H0oooo00<000000?ooo`3oool06@3o
ool00`000000oooo0?ooo`1K0?ooo`<00000J`3oool2000005X0oooo00<000000?ooo`3oool07`3o
ool00200oooo00<000000?ooo`3oool0F@3oool2000005<0oooo0`00001K0?ooo`030000003oool0
oooo0180oooo00<000000?ooo`3oool02`3oool00`000000oooo0?ooo`0F0?ooo`030000003oool0
oooo01X0oooo00<000000?ooo`3oool0G@3oool3000006H0oooo0P00001L0?ooo`030000003oool0
oooo01l0oooo000P0?ooo`030000003oool0oooo05/0oooo0P00001=0?ooo`@00000G@3oool00`00
0000oooo0?ooo`0B0?ooo`030000003oool0oooo00/0oooo00<000000?ooo`3oool05`3oool00`00
0000oooo0?ooo`0K0?ooo`030000003oool0oooo05l0oooo0`00001Q0?ooo`800000GP3oool00`00
0000oooo0?ooo`0O0?ooo`00803oool00`000000oooo0?ooo`1M0?ooo`800000B03oool300000600
oooo00<000000?ooo`3oool04P3oool00`000000oooo0?ooo`0<0?ooo`030000003oool0oooo01L0
oooo00<000000?ooo`3oool0703oool00`000000oooo0?ooo`1Q0?ooo`@00000F`3oool200000600
oooo00<000000?ooo`3oool07`3oool00200oooo00<000000?ooo`3oool0G`3oool2000004<0oooo
0`00001Q0?ooo`8000005@3oool00`000000oooo0?ooo`0<0?ooo`030000003oool0oooo01P0oooo
00<000000?ooo`3oool0703oool00`000000oooo0?ooo`1T0?ooo`<00000EP3oool200000680oooo
00<000000?ooo`3oool07`3oool00200oooo00<000000?ooo`3oool0H@3oool2000003h0oooo0`00
001S0?ooo`030000003oool0oooo01@0oooo00<000000?ooo`3oool0303oool00`000000oooo0?oo
o`0I0?ooo`030000003oool0oooo01d0oooo00<000000?ooo`3oool0IP3oool300000540oooo0P00
001T0?ooo`030000003oool0oooo01l0oooo000P0?ooo`030000003oool0oooo06<0oooo0P00000h
0?ooo`@00000I@3oool00`000000oooo0?ooo`0D0?ooo`030000003oool0oooo00d0oooo00<00000
0?ooo`3oool06@3oool00`000000oooo0?ooo`0N0?ooo`030000003oool0oooo06P0oooo0`00001<
0?ooo`800000IP3oool00`000000oooo0?ooo`0O0?ooo`00803oool00`000000oooo0?ooo`1U0?oo
o`800000<`3oool3000006P0oooo00<000000?ooo`3oool05@3oool00`000000oooo0?ooo`0=0?oo
o`030000003oool0oooo01X0oooo00<000000?ooo`3oool07P3oool00`000000oooo0?ooo`1Z0?oo
o`<00000A`3oool2000006P0oooo00<000000?ooo`3oool07`3oool00200oooo00<000000?ooo`3o
ool0I`3oool2000002h0oooo0`00001Z0?ooo`030000003oool0oooo01D0oooo00<000000?ooo`3o
ool03@3oool00`000000oooo0?ooo`0K0?ooo`030000003oool0oooo01l0oooo00<000000?ooo`3o
ool0K03oool400000440oooo0P00001Z0?ooo`030000003oool0oooo01l0oooo000P0?ooo`030000
003oool0oooo06T0oooo0P00000X0?ooo`@00000K03oool00`000000oooo0?ooo`0E0?ooo`030000
003oool0oooo00h0oooo00<000000?ooo`3oool06`3oool00`000000oooo0?ooo`0P0?ooo`030000
003oool0oooo06l0oooo0`00000l0?ooo`800000K03oool00`000000oooo0?ooo`0O0?ooo`00803o
ool00`000000oooo0?ooo`1[0?ooo`8000008`3oool3000006l0oooo00<000000?ooo`3oool05P3o
ool00`000000oooo0?ooo`0>0?ooo`030000003oool0oooo01/0oooo00<000000?ooo`3oool08@3o
ool00`000000oooo0?ooo`1a0?ooo`<00000=`3oool2000006h0oooo00<000000?ooo`3oool07`3o
ool00200oooo00<000000?ooo`3oool0K@3oool2000000P0oooo1P00000@0?ooo`<00000L@3oool0
0`000000oooo0?ooo`0F0?ooo`030000003oool0oooo00h0oooo00<000000?ooo`3oool07@3oool0
0`000000oooo0?ooo`0Q0?ooo`030000003oool0oooo07<0oooo0`00000b0?ooo`800000L03oool0
0`000000oooo0?ooo`0O0?ooo`00803oool00`000000oooo0?ooo`1_0?ooo`8000001@3oool80000
00/0oooo1000001b0?ooo`800000603oool00`000000oooo0?ooo`0?0?ooo`030000003oool0oooo
01d0oooo00<000000?ooo`3oool08P3oool00`000000oooo0?ooo`1e0?ooo`<00000;@3oool20000
0780oooo00<000000?ooo`3oool07`3oool00200oooo00<000000?ooo`3oool0L@3oool200000080
oooo2P0000070?ooo`<00000M@3oool00`000000oooo0?ooo`0H0?ooo`030000003oool0oooo00l0
oooo00<000000?ooo`3oool07@3oool00`000000oooo0?ooo`0S0?ooo`030000003oool0oooo07L0
oooo1000000W0?ooo`800000M03oool00`000000oooo0?ooo`0O0?ooo`00803oool00`000000oooo
0?ooo`1c0?ooo`d000000`3oool3000007L0oooo00<000000?ooo`3oool0603oool00`000000oooo
0?ooo`0?0?ooo`030000003oool0oooo01h0oooo00<000000?ooo`3oool08`3oool00`000000oooo
0?ooo`1k0?ooo`<000004P3oool6000000X0oooo0P00001f0?ooo`030000003oool0oooo01l0oooo
000P0?ooo`030000003oool0oooo07<0oooo4000001i0?ooo`030000003oool0oooo01P0oooo00<0
00000?ooo`3oool0403oool00`000000oooo0?ooo`0O0?ooo`030000003oool0oooo02<0oooo00<0
00000?ooo`3oool0O@3oool3000000h0oooo200000070?ooo`800000N03oool00`000000oooo0?oo
o`0O0?ooo`00803oool00`000000oooo0?ooo`1c0?ooo`h00000NP3oool00`000000oooo0?ooo`0I
0?ooo`030000003oool0oooo0100oooo00<000000?ooo`3oool07`3oool00`000000oooo0?ooo`0T
0?ooo`030000003oool0oooo07l0oooo0`00000:0?ooo`X00000103oool2000007X0oooo00<00000
0?ooo`3oool07`3oool00200oooo00<000000?ooo`3oool0L`3oool>000007T0oooo00<000000?oo
o`3oool06@3oool00`000000oooo0?ooo`0@0?ooo`030000003oool0oooo0200oooo00<000000?oo
o`3oool09@3oool00`000000oooo0?ooo`210?ooo`<000001P3oool<000000030?ooo`0000000000
07`0oooo00<000000?ooo`3oool07`3oool00200oooo00<000000?ooo`3oool0L`3oool>000007P0
oooo00<000000?ooo`3oool06@3oool00`000000oooo0?ooo`0A0?ooo`030000003oool0oooo0200
oooo00<000000?ooo`3oool09P3oool00`000000oooo0?ooo`230?ooo`@0000000<0oooo00000000
00003000001n0?ooo`030000003oool0oooo01l0oooo000P0?ooo`030000003oool0oooo07<0oooo
3P00001f0?ooo`800000703oool00`000000oooo0?ooo`0A0?ooo`030000003oool0oooo0240oooo
00<000000?ooo`3oool09P3oool00`000000oooo0?ooo`260?ooo`l00000OP3oool00`000000oooo
0?ooo`0O0?ooo`00803oool00`000000oooo0?ooo`1c0?ooo`h00000M@3oool00`000000oooo0?oo
o`0K0?ooo`030000003oool0oooo0140oooo00<000000?ooo`3oool08P3oool00`000000oooo0?oo
o`0W0?ooo`030000003oool0oooo08H0oooo3P00001n0?ooo`030000003oool0oooo01l0oooo000P
0?ooo`030000003oool0oooo07@0oooo300000000`3oool000000000001b0?ooo`030000003oool0
oooo01/0oooo00<000000?ooo`3oool04P3oool00`000000oooo0?ooo`0R0?ooo`030000003oool0
oooo02P0oooo00<000000?ooo`3oool0Q@3oool>000007h0oooo00<000000?ooo`3oool07`3oool0
0200oooo00<000000?ooo`3oool0M@3oool:000000@0oooo0P00001_0?ooo`030000003oool0oooo
01`0oooo00<000000?ooo`3oool04P3oool00`000000oooo0?ooo`0R0?ooo`030000003oool0oooo
02T0oooo00<000000?ooo`3oool0Q03oool>000007h0oooo00<000000?ooo`3oool07`3oool00200
oooo00<000000?ooo`3oool0MP3oool8000000L0oooo0P00001/0?ooo`030000003oool0oooo01`0
oooo00<000000?ooo`3oool04P3oool00`000000oooo0?ooo`0T0?ooo`030000003oool0oooo02T0
oooo00<000000?ooo`3oool0P`3oool=000007l0oooo00<000000?ooo`3oool07`3oool00200oooo
00<000000?ooo`3oool0M`3oool6000000X0oooo0P00001Y0?ooo`030000003oool0oooo01`0oooo
00<000000?ooo`3oool04`3oool00`000000oooo0?ooo`0T0?ooo`030000003oool0oooo02X0oooo
00<000000?ooo`3oool0PP3oool=000007l0oooo00<000000?ooo`3oool07`3oool00200oooo00<0
00000?ooo`3oool0O03oool00`000000oooo0?ooo`0:0?ooo`800000IP3oool00`000000oooo0?oo
o`0M0?ooo`030000003oool0oooo0180oooo00<000000?ooo`3oool09@3oool00`000000oooo0?oo
o`0[0?ooo`030000003oool0oooo07l0oooo0P0000020?ooo`X00000P03oool00`000000oooo0?oo
o`0O0?ooo`00803oool00`000000oooo0?ooo`1l0?ooo`030000003oool0oooo00`0oooo0P00001R
0?ooo`8000007`3oool00`000000oooo0?ooo`0C0?ooo`030000003oool0oooo02D0oooo00<00000
0?ooo`3oool0;03oool00`000000oooo0?ooo`1l0?ooo`8000001@3oool800000840oooo00<00000
0?ooo`3oool07`3oool00200oooo00<000000?ooo`3oool0O03oool00`000000oooo0?ooo`0>0?oo
o`800000G`3oool00`000000oooo0?ooo`0N0?ooo`030000003oool0oooo01@0oooo00<000000?oo
o`3oool09P3oool00`000000oooo0?ooo`0/0?ooo`030000003oool0oooo07T0oooo0P0000080?oo
o`H00000PP3oool00`000000oooo0?ooo`0O0?ooo`00803oool00`000000oooo0?ooo`1l0?ooo`03
0000003oool0oooo0100oooo0P00001L0?ooo`030000003oool0oooo01l0oooo00<000000?ooo`3o
ool04`3oool00`000000oooo0?ooo`0W0?ooo`030000003oool0oooo02d0oooo00<000000?ooo`3o
ool0MP3oool2000000/0oooo00<000000?ooo`3oool0Q03oool00`000000oooo0?ooo`0O0?ooo`00
803oool00`000000oooo0?ooo`1m0?ooo`030000003oool0oooo0140oooo0P00001I0?ooo`030000
003oool0oooo01l0oooo00<000000?ooo`3oool0503oool00`000000oooo0?ooo`0W0?ooo`030000
003oool0oooo02h0oooo00<000000?ooo`3oool0L`3oool2000000d0oooo00<000000?ooo`3oool0
Q03oool00`000000oooo0?ooo`0O0?ooo`00803oool00`000000oooo0?ooo`1m0?ooo`030000003o
ool0oooo01<0oooo0P00001F0?ooo`030000003oool0oooo01l0oooo00<000000?ooo`3oool05@3o
ool00`000000oooo0?ooo`0W0?ooo`030000003oool0oooo02h0oooo00<000000?ooo`3oool0L@3o
ool2000000l0oooo00<000000?ooo`3oool0Q03oool00`000000oooo0?ooo`0O0?ooo`00803oool0
0`000000oooo0?ooo`1m0?ooo`030000003oool0oooo01D0oooo0P00001C0?ooo`030000003oool0
oooo0200oooo00<000000?ooo`3oool0503oool00`000000oooo0?ooo`0Y0?ooo`030000003oool0
oooo02h0oooo00<000000?ooo`3oool0KP3oool200000140oooo00<000000?ooo`3oool0Q03oool0
0`000000oooo0?ooo`0O0?ooo`00803oool00`000000oooo0?ooo`1m0?ooo`030000003oool0oooo
01L0oooo0P00001@0?ooo`030000003oool0oooo0200oooo00<000000?ooo`3oool05@3oool00`00
0000oooo0?ooo`0Y0?ooo`030000003oool0oooo02l0oooo00<000000?ooo`3oool0J`3oool20000
01<0oooo00<000000?ooo`3oool0Q03oool00`000000oooo0?ooo`0O0?ooo`00803oool00`000000
oooo0?ooo`1m0?ooo`030000003oool0oooo01T0oooo0P00001<0?ooo`8000008P3oool00`000000
oooo0?ooo`0F0?ooo`030000003oool0oooo02T0oooo00<000000?ooo`3oool0<03oool00`000000
oooo0?ooo`1X0?ooo`8000005@3oool00`000000oooo0?ooo`240?ooo`030000003oool0oooo01l0
oooo000P0?ooo`030000003oool0oooo07h0oooo00<000000?ooo`3oool06P3oool2000004T0oooo
00<000000?ooo`3oool08P3oool00`000000oooo0?ooo`0E0?ooo`030000003oool0oooo02X0oooo
00<000000?ooo`3oool0<@3oool00`000000oooo0?ooo`1U0?ooo`8000005`3oool00`000000oooo
0?ooo`240?ooo`030000003oool0oooo01l0oooo000P0?ooo`030000003oool0oooo07h0oooo00<0
00000?ooo`3oool0703oool2000004H0oooo00<000000?ooo`3oool08P3oool00`000000oooo0?oo
o`0F0?ooo`030000003oool0oooo02/0oooo00<000000?ooo`3oool0<@3oool00`000000oooo0?oo
o`1R0?ooo`8000006@3oool00`000000oooo0?ooo`240?ooo`030000003oool0oooo01l0oooo000P
0?ooo`030000003oool0oooo07h0oooo00<000000?ooo`3oool07P3oool2000004<0oooo00<00000
0?ooo`3oool08P3oool00`000000oooo0?ooo`0G0?ooo`030000003oool0oooo02/0oooo00<00000
0?ooo`3oool0<P3oool00`000000oooo0?ooo`1O0?ooo`8000006`3oool00`000000oooo0?ooo`24
0?ooo`030000003oool0oooo01l0oooo000P0?ooo`030000003oool0oooo07h0oooo00<000000?oo
o`3oool0803oool200000400oooo00<000000?ooo`3oool08`3oool00`000000oooo0?ooo`0F0?oo
o`030000003oool0oooo02`0oooo00<000000?ooo`3oool0<`3oool00`000000oooo0?ooo`1L0?oo
o`800000703oool00`000000oooo0?ooo`250?ooo`030000003oool0oooo01l0oooo000P0?ooo`03
0000003oool0oooo07l0oooo00<000000?ooo`3oool08@3oool2000003d0oooo00<000000?ooo`3o
ool08`3oool00`000000oooo0?ooo`0G0?ooo`030000003oool0oooo02`0oooo00<000000?ooo`3o
ool0=03oool00`000000oooo0?ooo`1I0?ooo`8000007P3oool00`000000oooo0?ooo`250?ooo`03
0000003oool0oooo01l0oooo000P0?ooo`030000003oool0oooo07l0oooo00<000000?ooo`3oool0
8`3oool2000003X0oooo00<000000?ooo`3oool08`3oool00`000000oooo0?ooo`0H0?ooo`030000
003oool0oooo02d0oooo00<000000?ooo`3oool0=03oool00`000000oooo0?ooo`1F0?ooo`800000
803oool00`000000oooo0?ooo`250?ooo`030000003oool0oooo01l0oooo000P0?ooo`030000003o
ool0oooo07l0oooo00<000000?ooo`3oool09@3oool2000003H0oooo0P00000V0?ooo`030000003o
ool0oooo01L0oooo00<000000?ooo`3oool0;P3oool00`000000oooo0?ooo`0e0?ooo`030000003o
ool0oooo05<0oooo0P00000R0?ooo`030000003oool0oooo08D0oooo00<000000?ooo`3oool07`3o
ool00200oooo00<000000?ooo`3oool0O`3oool00`000000oooo0?ooo`0W0?ooo`800000<`3oool0
0`000000oooo0?ooo`0U0?ooo`030000003oool0oooo01P0oooo00<000000?ooo`3oool0;P3oool6
000003<0oooo00<000000?ooo`3oool0D03oool2000002@0oooo00<000000?ooo`3oool0Q@3oool0
0`000000oooo0?ooo`0O0?ooo`00803oool00`000000oooo0?ooo`1o0?ooo`030000003oool0oooo
02T0oooo0P00000`0?ooo`030000003oool0oooo02D0oooo00<000000?ooo`3oool06@3oool00`00
0000oooo0?ooo`0]0?ooo`P00000<`3oool00`000000oooo0?ooo`1=0?ooo`8000009P3oool00`00
0000oooo0?ooo`250?ooo`030000003oool0oooo01l0oooo000P0?ooo`030000003oool0oooo0800
oooo00<000000?ooo`3oool0:P3oool2000002d0oooo00<000000?ooo`3oool09P3oool00`000000
oooo0?ooo`0H0?ooo`030000003oool0oooo02d0oooo2P00000c0?ooo`030000003oool0oooo04X0
oooo0P00000X0?ooo`030000003oool0oooo08D0oooo00<000000?ooo`3oool07`3oool00200oooo
00<000000?ooo`3oool0P03oool00`000000oooo0?ooo`0/0?ooo`800000:P3oool00`000000oooo
0?ooo`0V0?ooo`030000003oool0oooo01T0oooo00<000000?ooo`3oool0;03oool<000003<0oooo
00<000000?ooo`3oool0A`3oool2000002X0oooo00<000000?ooo`3oool0Q@3oool00`000000oooo
0?ooo`0O0?ooo`00803oool00`000000oooo0?ooo`200?ooo`030000003oool0oooo02h0oooo0P00
000W0?ooo`030000003oool0oooo02H0oooo00<000000?ooo`3oool06P3oool00`000000oooo0?oo
o`0[0?ooo`d00000=03oool00`000000oooo0?ooo`150?ooo`030000003oool0oooo02X0oooo00<0
00000?ooo`3oool0Q@3oool00`000000oooo0?ooo`0O0?ooo`00803oool00`000000oooo0?ooo`20
0?ooo`030000003oool0oooo0300oooo0P00000T0?ooo`030000003oool0oooo02L0oooo00<00000
0?ooo`3oool06@3oool00`000000oooo0?ooo`0/0?ooo`h00000<`3oool00`000000oooo0?ooo`13
0?ooo`800000;@3oool00`000000oooo0?ooo`250?ooo`030000003oool0oooo01l0oooo000P0?oo
o`030000003oool0oooo0800oooo00<000000?ooo`3oool0<P3oool200000200oooo0P00000Y0?oo
o`030000003oool0oooo01X0oooo00<000000?ooo`3oool0;03oool>000003@0oooo00<000000?oo
o`3oool0@03oool2000002h0oooo00<000000?ooo`3oool0QP3oool00`000000oooo0?ooo`0O0?oo
o`00803oool00`000000oooo0?ooo`210?ooo`030000003oool0oooo03<0oooo0P00000M0?ooo`03
0000003oool0oooo02T0oooo00<000000?ooo`3oool06P3oool00`000000oooo0?ooo`0/0?ooo`h0
0000=@3oool00`000000oooo0?ooo`0m0?ooo`800000<03oool00`000000oooo0?ooo`260?ooo`03
0000003oool0oooo01l0oooo000P0?ooo`030000003oool0oooo0840oooo00<000000?ooo`3oool0
=@3oool2000001X0oooo00<000000?ooo`3oool0:@3oool00`000000oooo0?ooo`0J0?ooo`030000
003oool0oooo02d0oooo3P00000f0?ooo`030000003oool0oooo03X0oooo0P00000b0?ooo`030000
003oool0oooo08H0oooo00<000000?ooo`3oool07`3oool00200oooo00<000000?ooo`3oool0P@3o
ool00`000000oooo0?ooo`0g0?ooo`8000005`3oool00`000000oooo0?ooo`0Y0?ooo`030000003o
ool0oooo01/0oooo00<000000?ooo`3oool0;@3oool@000003D0oooo00<000000?ooo`3oool0=`3o
ool2000003@0oooo00<000000?ooo`3oool0QP3oool00`000000oooo0?ooo`0O0?ooo`00803oool0
0`000000oooo0?ooo`210?ooo`030000003oool0oooo03T0oooo0P00000D0?ooo`030000003oool0
oooo02X0oooo00<000000?ooo`3oool06`3oool00`000000oooo0?ooo`0^0?ooo``000000`3oool4
00000380oooo00<000000?ooo`3oool0=03oool2000003H0oooo00<000000?ooo`3oool0QP3oool0
0`000000oooo0?ooo`0O0?ooo`00803oool00`000000oooo0?ooo`220?ooo`030000003oool0oooo
03X0oooo0P0000070?ooo`H00000103oool00`000000oooo0?ooo`0Z0?ooo`030000003oool0oooo
01/0oooo00<000000?ooo`3oool0;P3oool00`000000oooo00000009000000P0oooo0`00000`0?oo
o`030000003oool0oooo0340oooo0P00000h0?ooo`030000003oool0oooo08H0oooo00<000000?oo
o`3oool07`3oool00200oooo00<000000?ooo`3oool0PP3oool00`000000oooo0?ooo`0l0?ooo`80
0000103oool800000080oooo00<000000?ooo`3oool0:P3oool00`000000oooo0?ooo`0L0?ooo`03
0000003oool0oooo02`0oooo0P0000030?ooo`P00000303oool4000002d0oooo00<000000?ooo`3o
ool0;P3oool2000003X0oooo00<000000?ooo`3oool0QP3oool00`000000oooo0?ooo`0O0?ooo`00
803oool00`000000oooo0?ooo`220?ooo`030000003oool0oooo03h0oooo0P0000000`3oool00000
00000009000002d0oooo00<000000?ooo`3oool0703oool00`000000oooo0?ooo`0Z0?ooo`800000
1P3oool600000140oooo1000000Z0?ooo`030000003oool0oooo02/0oooo0P00000l0?ooo`030000
003oool0oooo08H0oooo00<000000?ooo`3oool07`3oool00200oooo00<000000?ooo`3oool0PP3o
ool00`000000oooo0?ooo`100?ooo``00000;03oool00`000000oooo0?ooo`0L0?ooo`030000003o
ool0oooo02X0oooo00<000000?ooo`3oool02@3oool00`000000oooo0?ooo`0E0?ooo`<00000:03o
ool00`000000oooo0?ooo`0X0?ooo`800000?P3oool00`000000oooo0?ooo`260?ooo`030000003o
ool0oooo01l0oooo000P0?ooo`030000003oool0oooo0880oooo00<000000?ooo`3oool0?`3oool=
000002/0oooo00<000000?ooo`3oool07@3oool00`000000oooo0?ooo`0X0?ooo`800000303oool0
0`000000oooo0?ooo`0H0?ooo`@000009@3oool00`000000oooo0?ooo`0U0?ooo`800000@03oool0
0`000000oooo0?ooo`260?ooo`030000003oool0oooo01l0oooo000P0?ooo`030000003oool0oooo
08<0oooo00<000000?ooo`3oool0?P3oool>000002X0oooo00<000000?ooo`3oool07@3oool00`00
0000oooo0?ooo`0W0?ooo`030000003oool0oooo00d0oooo00<000000?ooo`3oool06`3oool40000
0280oooo00<000000?ooo`3oool08P3oool200000440oooo00<000000?ooo`3oool0Q`3oool00`00
0000oooo0?ooo`0O0?ooo`00803oool00`000000oooo0?ooo`230?ooo`030000003oool0oooo03h0
oooo3P00000Y0?ooo`030000003oool0oooo01d0oooo00<000000?ooo`3oool09P3oool200000100
oooo00<000000?ooo`3oool07`3oool4000001l0oooo00<000000?ooo`3oool07`3oool2000004<0
oooo00<000000?ooo`3oool0Q`3oool00`000000oooo0?ooo`0O0?ooo`00803oool00`000000oooo
0?ooo`230?ooo`030000003oool0oooo03h0oooo3P00000X0?ooo`030000003oool0oooo01h0oooo
00<000000?ooo`3oool09@3oool00`000000oooo0?ooo`0@0?ooo`030000003oool0oooo02<0oooo
0`00000M0?ooo`030000003oool0oooo01`0oooo0P0000150?ooo`030000003oool0oooo08L0oooo
00<000000?ooo`3oool07`3oool00200oooo00<000000?ooo`3oool0P`3oool00`000000oooo0?oo
o`0n0?ooo`h00000:03oool00`000000oooo0?ooo`0N0?ooo`030000003oool0oooo02<0oooo0P00
000C0?ooo`030000003oool0oooo02H0oooo1000000J0?ooo`030000003oool0oooo01T0oooo0P00
00170?ooo`030000003oool0oooo08L0oooo00<000000?ooo`3oool07`3oool00200oooo00<00000
0?ooo`3oool0P`3oool00`000000oooo0?ooo`0n0?ooo`h000009`3oool00`000000oooo0?ooo`0N
0?ooo`030000003oool0oooo02<0oooo00<000000?ooo`3oool04`3oool00`000000oooo0?ooo`0Z
0?ooo`@000005`3oool00`000000oooo0?ooo`0F0?ooo`800000B@3oool00`000000oooo0?ooo`27
0?ooo`030000003oool0oooo01l0oooo000P0?ooo`030000003oool0oooo08@0oooo00<000000?oo
o`3oool0?P3oool<000000030?ooo`000000000002@0oooo00<000000?ooo`3oool07`3oool00`00
0000oooo0?ooo`0Q0?ooo`8000005P3oool00`000000oooo0?ooo`0^0?ooo`@000004`3oool00`00
0000oooo0?ooo`0D0?ooo`800000B`3oool00`000000oooo0?ooo`270?ooo`030000003oool0oooo
01l0oooo000P0?ooo`030000003oool0oooo08@0oooo00<000000?ooo`3oool0?`3oool:000000@0
oooo0P00000R0?ooo`030000003oool0oooo01l0oooo00<000000?ooo`3oool0803oool00`000000
oooo0?ooo`0G0?ooo`030000003oool0oooo0340oooo0`00000A0?ooo`030000003oool0oooo0140
oooo0P00001=0?ooo`030000003oool0oooo08L0oooo00<000000?ooo`3oool07`3oool00200oooo
00<000000?ooo`3oool0Q03oool00`000000oooo0?ooo`100?ooo`P000001`3oool2000001l0oooo
00<000000?ooo`3oool07`3oool00`000000oooo0?ooo`0O0?ooo`8000006P3oool00`000000oooo
0?ooo`0d0?ooo`@000003P3oool010000000oooo0?ooo`3oool6000000L0oooo0P00001?0?ooo`03
0000003oool0oooo08L0oooo00<000000?ooo`3oool07`3oool00200oooo00<000000?ooo`3oool0
Q03oool00`000000oooo0?ooo`110?ooo`H000002P3oool2000001`0oooo00<000000?ooo`3oool0
803oool00`000000oooo0?ooo`0M0?ooo`800000703oool00`000000oooo0?ooo`0h0?ooo`@00000
2`3oool00`000000oooo00000007000000@0oooo0P00001A0?ooo`030000003oool0oooo08L0oooo
00<000000?ooo`3oool07`3oool00200oooo00<000000?ooo`3oool0Q@3oool00`000000oooo0?oo
o`100?ooo`030000003oool0oooo00l0oooo0P00000J0?ooo`030000003oool0oooo0200oooo00<0
00000?ooo`3oool0703oool00`000000oooo0?ooo`0L0?ooo`030000003oool0oooo03`0oooo0`00
00090?ooo`X0000000<0oooo000000000000D`3oool00`000000oooo0?ooo`270?ooo`030000003o
ool0oooo01l0oooo000P0?ooo`030000003oool0oooo08D0oooo00<000000?ooo`3oool0@03oool0
0`000000oooo0?ooo`0A0?ooo`8000005`3oool00`000000oooo0?ooo`0P0?ooo`030000003oool0
oooo01/0oooo0P00000O0?ooo`030000003oool0oooo03l0oooo100000040?ooo``00000E@3oool0
0`000000oooo0?ooo`270?ooo`030000003oool0oooo01l0oooo000P0?ooo`030000003oool0oooo
08D0oooo00<000000?ooo`3oool0@03oool00`000000oooo0?ooo`0C0?ooo`800000503oool00`00
0000oooo0?ooo`0Q0?ooo`030000003oool0oooo01X0oooo00<000000?ooo`3oool07`3oool00`00
0000oooo0?ooo`130?oooa000000E03oool00`000000oooo0?ooo`280?ooo`030000003oool0oooo
01l0oooo000P0?ooo`030000003oool0oooo08D0oooo00<000000?ooo`3oool0?`3oool00`000000
oooo0?ooo`0F0?ooo`8000002P3oool600000080oooo00<000000?ooo`3oool08@3oool00`000000
oooo0?ooo`0H0?ooo`8000008`3oool00`000000oooo0?ooo`150?ooo`h00000D`3oool00`000000
oooo0?ooo`280?ooo`030000003oool0oooo01l0oooo000P0?ooo`030000003oool0oooo08D0oooo
00<000000?ooo`3oool0?`3oool00`000000oooo0?ooo`0H0?ooo`8000001`3oool9000002<0oooo
00<000000?ooo`3oool0603oool00`000000oooo0?ooo`0S0?ooo`030000003oool0oooo04D0oooo
3P00001C0?ooo`030000003oool0oooo08P0oooo00<000000?ooo`3oool07`3oool00200oooo00<0
00000?ooo`3oool0QP3oool00`000000oooo0?ooo`0n0?ooo`030000003oool0oooo01X0oooo0P00
00040?ooo`X000008`3oool00`000000oooo0?ooo`0F0?ooo`8000009P3oool00`000000oooo0?oo
o`150?ooo`h00000D`3oool00`000000oooo0?ooo`280?ooo`030000003oool0oooo01l0oooo000P
0?ooo`030000003oool0oooo08H0oooo00<000000?ooo`3oool0?P3oool00`000000oooo0?ooo`0L
0?ooo`80000000<0oooo0000000000002P00000R0?ooo`030000003oool0oooo01D0oooo00<00000
0?ooo`3oool09P3oool00`000000oooo0?ooo`150?ooo`h00000D`3oool00`000000oooo0?ooo`28
0?ooo`030000003oool0oooo01l0oooo000P0?ooo`030000003oool0oooo08H0oooo00<000000?oo
o`3oool0?@3oool00`000000oooo0?ooo`0O0?ooo`d000008@3oool00`000000oooo0?ooo`0D0?oo
o`800000:@3oool00`000000oooo0?ooo`150?ooo`d00000E03oool00`000000oooo0?ooo`280?oo
o`030000003oool0oooo01l0oooo000P0?ooo`030000003oool0oooo08H0oooo00<000000?ooo`3o
ool0?@3oool00`000000oooo0?ooo`0O0?ooo`h00000803oool00`000000oooo0?ooo`0C0?ooo`03
0000003oool0oooo02X0oooo00<000000?ooo`3oool0A@3oool<000005@0oooo00<000000?ooo`3o
ool0R03oool00`000000oooo0?ooo`0O0?ooo`00803oool00`000000oooo0?ooo`270?ooo`030000
003oool0oooo03`0oooo00<000000?ooo`3oool07`3oool>00000200oooo00<000000?ooo`3oool0
4@3oool2000002d0oooo00<000000?ooo`3oool0A@3oool;000005D0oooo00<000000?ooo`3oool0
R03oool00`000000oooo0?ooo`0O0?ooo`00803oool00`000000oooo0?ooo`270?ooo`030000003o
ool0oooo03/0oooo00<000000?ooo`3oool0803oool>000001l0oooo00<000000?ooo`3oool0403o
ool2000002l0oooo00<000000?ooo`3oool0A03oool00`000000oooo0?ooo`08000005H0oooo00<0
00000?ooo`3oool0R03oool00`000000oooo0?ooo`0O0?ooo`00803oool00`000000oooo0?ooo`27
0?ooo`030000003oool0oooo03/0oooo00<000000?ooo`3oool0803oool>000001l0oooo00<00000
0?ooo`3oool03`3oool00`000000oooo0?ooo`0_0?ooo`030000003oool0oooo04<0oooo00<00000
0?ooo`3oool00P3oool7000005H0oooo00<000000?ooo`3oool0R03oool00`000000oooo0?ooo`0O
0?ooo`00803oool00`000000oooo0?ooo`270?ooo`030000003oool0oooo03/0oooo00<000000?oo
o`3oool0803oool=00000200oooo00<000000?ooo`3oool03@3oool200000380oooo00<000000?oo
o`3oool0@P3oool00`000000oooo0?ooo`060?ooo`050000003oool0oooo0?ooo`000000E03oool0
0`000000oooo0?ooo`290?ooo`030000003oool0oooo01l0oooo000P0?ooo`030000003oool0oooo
08L0oooo00<000000?ooo`3oool0>P3oool00`000000oooo0?ooo`0R0?ooo`h000007@3oool00`00
0000oooo0?ooo`0=0?ooo`030000003oool0oooo0380oooo00<000000?ooo`3oool0@@3oool00`00
0000oooo0?ooo`080?ooo`040000003oool0oooo000005@0oooo00<000000?ooo`3oool0R@3oool0
0`000000oooo0?ooo`0O0?ooo`00803oool00`000000oooo0?ooo`280?ooo`030000003oool0oooo
03T0oooo00<000000?ooo`3oool08`3oool:000000<0oooo0P00000K0?ooo`030000003oool0oooo
00/0oooo0P00000f0?ooo`030000003oool0oooo03l0oooo00<000000?ooo`3oool02@3oool01@00
0000oooo0?ooo`3oool0000005<0oooo00<000000?ooo`3oool0R@3oool00`000000oooo0?ooo`0O
0?ooo`00803oool00`000000oooo0?ooo`280?ooo`030000003oool0oooo03T0oooo00<000000?oo
o`3oool0903oool8000000H0oooo0P00000I0?ooo`030000003oool0oooo00X0oooo00<000000?oo
o`3oool0=P3oool00`000000oooo0?ooo`0m0?ooo`800000303oool01@000000oooo0?ooo`3oool0
000005<0oooo00<000000?ooo`3oool0R@3oool00`000000oooo0?ooo`0O0?ooo`00803oool00`00
0000oooo0?ooo`280?ooo`030000003oool0oooo03P0oooo00<000000?ooo`3oool09@3oool70000
00T0oooo0P00000F0?ooo`030000003oool0oooo00T0oooo0P00000i0?ooo`030000003oool0oooo
03`0oooo00<000000?ooo`3oool0303oool00`000000oooo0?ooo`020?ooo`030000003oool0oooo
0500oooo00<000000?ooo`3oool0R@3oool00`000000oooo0?ooo`0O0?ooo`00803oool00`000000
oooo0?ooo`280?ooo`030000003oool0oooo03P0oooo00<000000?ooo`3oool0903oool00`000000
oooo0?ooo`0@0?ooo`800000503oool00`000000oooo0?ooo`080?ooo`030000003oool0oooo03T0
oooo00<000000?ooo`3oool0>`3oool00`000000oooo0?ooo`0=0?ooo`030000003oool0oooo0080
oooo00<000000?ooo`3oool0D03oool00`000000oooo0?ooo`290?ooo`030000003oool0oooo01l0
oooo000P0?ooo`030000003oool0oooo08P0oooo00<000000?ooo`3oool0>03oool00`000000oooo
0?ooo`0T0?ooo`030000003oool0oooo0180oooo0P00000B0?ooo`030000003oool0oooo00H0oooo
0P00000l0?ooo`030000003oool0oooo03X0oooo00<000000?ooo`3oool03`3oool00`000000oooo
0?ooo`020?ooo`030000003oool0oooo04l0oooo00<000000?ooo`3oool0R@3oool00`000000oooo
0?ooo`0O0?ooo`00803oool00`000000oooo0?ooo`290?ooo`030000003oool0oooo03H0oooo00<0
00000?ooo`3oool0903oool00`000000oooo0?ooo`0E0?ooo`8000003`3oool00`000000oooo0?oo
o`060?ooo`030000003oool0oooo03`0oooo00<000000?ooo`3oool0>@3oool00`000000oooo0?oo
o`0@0?ooo`030000003oool0oooo00<0oooo00<000000?ooo`3oool0CP3oool00`000000oooo0?oo
o`290?ooo`030000003oool0oooo01l0oooo000P0?ooo`030000003oool0oooo08T0oooo00<00000
0?ooo`3oool0=P3oool00`000000oooo0?ooo`0S0?ooo`030000003oool0oooo01P0oooo0P000008
0?ooo`H000001P3oool200000400oooo00<000000?ooo`3oool0=`3oool00`000000oooo0?ooo`0A
0?ooo`030000003oool0oooo00<0oooo00<000000?ooo`3oool0CP3oool00`000000oooo0?ooo`29
0?ooo`030000003oool0oooo01l0oooo000P0?ooo`030000003oool0oooo08T0oooo00<000000?oo
o`3oool0=P3oool00`000000oooo0?ooo`0S0?ooo`030000003oool0oooo01X0oooo0P0000050?oo
o`P000000`3oool200000480oooo00<000000?ooo`3oool0=P3oool00`000000oooo0?ooo`0B0?oo
o`030000003oool0oooo00@0oooo00<000000?ooo`3oool0C@3oool00`000000oooo0?ooo`290?oo
o`030000003oool0oooo01l0oooo000P0?ooo`030000003oool0oooo08T0oooo00<000000?ooo`3o
ool0=@3oool00`000000oooo0?ooo`0S0?ooo`030000003oool0oooo01d0oooo0P0000020?ooo`X0
000000<0oooo0000003oool0@`3oool00`000000oooo0?ooo`0e0?ooo`030000003oool0oooo01<0
oooo00<000000?ooo`3oool0103oool00`000000oooo0?ooo`1<0?ooo`030000003oool0oooo08X0
oooo00<000000?ooo`3oool07`3oool00200oooo00<000000?ooo`3oool0RP3oool00`000000oooo
0?ooo`0d0?ooo`030000003oool0oooo0280oooo00<000000?ooo`3oool0803oool=000004D0oooo
00<000000?ooo`3oool0=03oool00`000000oooo0?ooo`0D0?ooo`030000003oool0oooo00D0oooo
00<000000?ooo`3oool0B`3oool00`000000oooo0?ooo`2:0?ooo`030000003oool0oooo01l0oooo
000P0?ooo`030000003oool0oooo08X0oooo00<000000?ooo`3oool0=03oool00`000000oooo0?oo
o`0R0?ooo`030000003oool0oooo0200oooo3@0000150?ooo`030000003oool0oooo03<0oooo00<0
00000?ooo`3oool05P3oool00`000000oooo0?ooo`040?ooo`030000003oool0oooo04/0oooo00<0
00000?ooo`3oool0RP3oool00`000000oooo0?ooo`0O0?ooo`00803oool00`000000oooo0?ooo`2:
0?ooo`030000003oool0oooo03<0oooo00<000000?ooo`3oool08P3oool00`000000oooo0?ooo`0Q
0?ooo`h00000A03oool00`000000oooo0?ooo`0b0?ooo`030000003oool0oooo01L0oooo00<00000
0?ooo`3oool01@3oool00`000000oooo0?ooo`1:0?ooo`030000003oool0oooo08X0oooo00<00000
0?ooo`3oool07`3oool00200oooo00<000000?ooo`3oool0RP3oool00`000000oooo0?ooo`0c0?oo
o`030000003oool0oooo0240oooo00<000000?ooo`3oool08P3oool>000004D0oooo00<000000?oo
o`3oool0<03oool00`000000oooo0?ooo`0H0?ooo`030000003oool0oooo00H0oooo00<000000?oo
o`3oool0B@3oool00`000000oooo0?ooo`2:0?ooo`030000003oool0oooo01l0oooo000P0?ooo`03
0000003oool0oooo08X0oooo00<000000?ooo`3oool0<`3oool00`000000oooo0?ooo`0Q0?ooo`03
0000003oool0oooo0280oooo3P0000150?ooo`030000003oool0oooo02l0oooo00<000000?ooo`3o
ool06@3oool00`000000oooo0?ooo`060?ooo`030000003oool0oooo04T0oooo00<000000?ooo`3o
ool0RP3oool00`000000oooo0?ooo`0O0?ooo`00803oool00`000000oooo0?ooo`2;0?ooo`030000
003oool0oooo0380oooo00<000000?ooo`3oool0803oool00`000000oooo0?ooo`0S0?ooo`h00000
A@3oool00`000000oooo0?ooo`0^0?ooo`030000003oool0oooo01X0oooo00<000000?ooo`3oool0
1`3oool00`000000oooo0?ooo`180?ooo`030000003oool0oooo08X0oooo00<000000?ooo`3oool0
7`3oool00200oooo00<000000?ooo`3oool0R`3oool00`000000oooo0?ooo`0a0?ooo`030000003o
ool0oooo0200oooo00<000000?ooo`3oool0903oool>000004D0oooo00<000000?ooo`3oool0;@3o
ool00`000000oooo0?ooo`0L0?ooo`030000003oool0oooo00H0oooo00<000000?ooo`3oool0B03o
ool00`000000oooo0?ooo`2:0?ooo`030000003oool0oooo01l0oooo000P0?ooo`030000003oool0
oooo08/0oooo00<000000?ooo`3oool0<@3oool00`000000oooo0?ooo`0O0?ooo`030000003oool0
oooo02H0oooo300000000`3oool00000000000130?ooo`030000003oool0oooo02`0oooo00<00000
0?ooo`3oool07@3oool00`000000oooo0?ooo`070?ooo`030000003oool0oooo04L0oooo00<00000
0?ooo`3oool0RP3oool00`000000oooo0?ooo`0O0?ooo`00803oool00`000000oooo0?ooo`2;0?oo
o`030000003oool0oooo0340oooo00<000000?ooo`3oool07`3oool00`000000oooo0?ooo`0V0?oo
o`/00000103oool200000480oooo00<000000?ooo`3oool0:P3oool00`000000oooo0?ooo`0N0?oo
o`030000003oool0oooo00L0oooo00<000000?ooo`3oool0A`3oool00`000000oooo0?ooo`2:0?oo
o`030000003oool0oooo01l0oooo000P0?ooo`030000003oool0oooo08/0oooo00<000000?ooo`3o
ool0<03oool00`000000oooo0?ooo`0O0?ooo`030000003oool0oooo02H0oooo00<000000?ooo`3o
ool0200000070?ooo`800000@03oool00`000000oooo0?ooo`0Y0?ooo`030000003oool0oooo01l0
oooo00<000000?ooo`3oool0203oool00`000000oooo0?ooo`160?ooo`030000003oool0oooo08X0
oooo00<000000?ooo`3oool07`3oool00200oooo00<000000?ooo`3oool0S03oool00`000000oooo
0?ooo`0_0?ooo`030000003oool0oooo01h0oooo00<000000?ooo`3oool09P3oool00`000000oooo
0?ooo`020?ooo`H000002P3oool2000003h0oooo00<000000?ooo`3oool0:03oool00`000000oooo
0?ooo`0P0?ooo`030000003oool0oooo00T0oooo00<000000?ooo`3oool0A03oool00`000000oooo
0?ooo`2;0?ooo`030000003oool0oooo01l0oooo000P0?ooo`030000003oool0oooo08`0oooo00<0
00000?ooo`3oool0;`3oool00`000000oooo0?ooo`0N0?ooo`030000003oool0oooo02D0oooo00<0
00000?ooo`3oool01@3oool00`000000oooo0?ooo`0=0?ooo`800000?03oool00`000000oooo0?oo
o`0W0?ooo`030000003oool0oooo0240oooo00<000000?ooo`3oool02@3oool00`000000oooo0?oo
o`140?ooo`030000003oool0oooo08/0oooo00<000000?ooo`3oool07`3oool00200oooo00<00000
0?ooo`3oool0S03oool00`000000oooo0?ooo`0^0?ooo`030000003oool0oooo01h0oooo00<00000
0?ooo`3oool09@3oool00`000000oooo0?ooo`060?ooo`030000003oool0oooo00l0oooo0P00000j
0?ooo`030000003oool0oooo02H0oooo00<000000?ooo`3oool08`3oool00`000000oooo0?ooo`09
0?ooo`030000003oool0oooo04<0oooo00<000000?ooo`3oool0R`3oool00`000000oooo0?ooo`0O
0?ooo`00803oool00`000000oooo0?ooo`2<0?ooo`030000003oool0oooo02h0oooo00<000000?oo
o`3oool07@3oool00`000000oooo0?ooo`0U0?ooo`030000003oool0oooo00L0oooo00<000000?oo
o`3oool04@3oool2000003P0oooo00<000000?ooo`3oool0903oool2000002H0oooo00<000000?oo
o`3oool02@3oool00`000000oooo0?ooo`130?ooo`030000003oool0oooo08/0oooo00<000000?oo
o`3oool07`3oool00200oooo00<000000?ooo`3oool0S@3oool00`000000oooo0?ooo`0]0?ooo`03
0000003oool0oooo01d0oooo00<000000?ooo`3oool0903oool00`000000oooo0?ooo`080?ooo`03
0000003oool0oooo01<0oooo0P00000g0?ooo`030000003oool0oooo0280oooo00<000000?ooo`3o
ool09P3oool00`000000oooo0?ooo`0:0?ooo`030000003oool0oooo0480oooo00<000000?ooo`3o
ool0R`3oool00`000000oooo0?ooo`0O0?ooo`00803oool00`000000oooo0?ooo`2=0?ooo`030000
003oool0oooo02`0oooo00<000000?ooo`3oool07@3oool00`000000oooo0?ooo`0T0?ooo`030000
003oool0oooo00P0oooo00<000000?ooo`3oool05P3oool2000003D0oooo00<000000?ooo`3oool0
8@3oool00`000000oooo0?ooo`0W0?ooo`030000003oool0oooo00X0oooo00<000000?ooo`3oool0
@P3oool00`000000oooo0?ooo`2;0?ooo`030000003oool0oooo01l0oooo000P0?ooo`030000003o
ool0oooo08d0oooo00<000000?ooo`3oool0;03oool00`000000oooo0?ooo`0L0?ooo`030000003o
ool0oooo02@0oooo00<000000?ooo`3oool02@3oool00`000000oooo0?ooo`0H0?ooo`800000<`3o
ool00`000000oooo0?ooo`0P0?ooo`030000003oool0oooo02P0oooo00<000000?ooo`3oool02`3o
ool00`000000oooo0?ooo`110?ooo`030000003oool0oooo08/0oooo00<000000?ooo`3oool07`3o
ool00200oooo00<000000?ooo`3oool0S@3oool00`000000oooo0?ooo`0/0?ooo`030000003oool0
oooo01`0oooo00<000000?ooo`3oool08P3oool2000000`0oooo00<000000?ooo`3oool06P3oool2
00000340oooo00<000000?ooo`3oool07`3oool00`000000oooo0?ooo`0Z0?ooo`030000003oool0
oooo00/0oooo00<000000?ooo`3oool0@03oool00`000000oooo0?ooo`2;0?ooo`030000003oool0
oooo01l0oooo000P0?ooo`030000003oool0oooo08d0oooo00<000000?ooo`3oool0:`3oool00`00
0000oooo0?ooo`0L0?ooo`030000003oool0oooo0280oooo00<000000?ooo`3oool0303oool00`00
0000oooo0?ooo`0L0?ooo`800000;`3oool00`000000oooo0?ooo`0N0?ooo`030000003oool0oooo
02/0oooo00<000000?ooo`3oool02`3oool00`000000oooo0?ooo`100?ooo`030000003oool0oooo
08/0oooo00<000000?ooo`3oool07`3oool00200oooo00<000000?ooo`3oool0SP3oool00`000000
oooo0?ooo`0Z0?ooo`030000003oool0oooo01/0oooo00<000000?ooo`3oool08P3oool00`000000
oooo0?ooo`0=0?ooo`030000003oool0oooo01h0oooo0P00000]0?ooo`030000003oool0oooo01d0
oooo00<000000?ooo`3oool0;03oool00`000000oooo0?ooo`0<0?ooo`030000003oool0oooo03l0
oooo00<000000?ooo`3oool0R`3oool00`000000oooo0?ooo`0O0?ooo`00803oool00`000000oooo
0?ooo`2>0?ooo`030000003oool0oooo02X0oooo00<000000?ooo`3oool06`3oool00`000000oooo
0?ooo`0Q0?ooo`030000003oool0oooo00h0oooo00<000000?ooo`3oool0803oool2000002`0oooo
00<000000?ooo`3oool06`3oool00`000000oooo0?ooo`0]0?ooo`030000003oool0oooo00`0oooo
00<000000?ooo`3oool0?P3oool00`000000oooo0?ooo`2<0?ooo`030000003oool0oooo01l0oooo
000P0?ooo`030000003oool0oooo08h0oooo00<000000?ooo`3oool0:@3oool00`000000oooo0?oo
o`0K0?ooo`030000003oool0oooo0240oooo00<000000?ooo`3oool03`3oool00`000000oooo0?oo
o`0R0?ooo`800000:P3oool00`000000oooo0?ooo`0J0?ooo`030000003oool0oooo02h0oooo00<0
00000?ooo`3oool03@3oool00`000000oooo0?ooo`0m0?ooo`030000003oool0oooo08`0oooo00<0
00000?ooo`3oool07`3oool00200oooo00<000000?ooo`3oool0SP3oool00`000000oooo0?ooo`0Y
0?ooo`030000003oool0oooo01X0oooo00<000000?ooo`3oool08@3oool00`000000oooo0?ooo`0?
0?ooo`030000003oool0oooo02D0oooo0P00000X0?ooo`030000003oool0oooo01T0oooo00<00000
0?ooo`3oool0;`3oool00`000000oooo0?ooo`0>0?ooo`030000003oool0oooo03`0oooo00<00000
0?ooo`3oool0S03oool00`000000oooo0?ooo`0O0?ooo`00803oool00`000000oooo0?ooo`2?0?oo
o`030000003oool0oooo02P0oooo00<000000?ooo`3oool06P3oool00`000000oooo0?ooo`0P0?oo
o`030000003oool0oooo0100oooo00<000000?ooo`3oool09`3oool2000002H0oooo00<000000?oo
o`3oool0603oool00`000000oooo0?ooo`0a0?ooo`030000003oool0oooo00d0oooo00<000000?oo
o`3oool0?03oool00`000000oooo0?ooo`2<0?ooo`030000003oool0oooo01l0oooo000P0?ooo`03
0000003oool0oooo08l0oooo00<000000?ooo`3oool09`3oool00`000000oooo0?ooo`0J0?ooo`03
0000003oool0oooo0200oooo00<000000?ooo`3oool04@3oool00`000000oooo0?ooo`0Y0?ooo`80
0000903oool00`000000oooo0?ooo`0G0?ooo`030000003oool0oooo0380oooo00<000000?ooo`3o
ool03P3oool00`000000oooo0?ooo`0k0?ooo`030000003oool0oooo08`0oooo00<000000?ooo`3o
ool07`3oool00200oooo00<000000?ooo`3oool0S`3oool00`000000oooo0?ooo`0W0?ooo`030000
003oool0oooo01T0oooo00<000000?ooo`3oool0803oool00`000000oooo0?ooo`0B0?ooo`030000
003oool0oooo02/0oooo0P00000S0?ooo`030000003oool0oooo01D0oooo00<000000?ooo`3oool0
<`3oool00`000000oooo0?ooo`0>0?ooo`030000003oool0oooo03/0oooo00<000000?ooo`3oool0
S03oool00`000000oooo0?ooo`0O0?ooo`00803oool00`000000oooo0?ooo`2?0?ooo`030000003o
ool0oooo02L0oooo00<000000?ooo`3oool06@3oool00`000000oooo0?ooo`0N0?ooo`8000005@3o
ool00`000000oooo0?ooo`0]0?ooo`8000008@3oool00`000000oooo0?ooo`0D0?ooo`030000003o
ool0oooo03@0oooo00<000000?ooo`3oool03`3oool00`000000oooo0?ooo`0j0?ooo`030000003o
ool0oooo08`0oooo00<000000?ooo`3oool07`3oool00200oooo00<000000?ooo`3oool0S`3oool0
0`000000oooo0?ooo`0W0?ooo`030000003oool0oooo01P0oooo00<000000?ooo`3oool07P3oool0
0`000000oooo0?ooo`0E0?ooo`030000003oool0oooo02l0oooo0P00000O0?ooo`030000003oool0
oooo01<0oooo00<000000?ooo`3oool0=@3oool00`000000oooo0?ooo`0?0?ooo`030000003oool0
oooo03X0oooo00<000000?ooo`3oool0S03oool00`000000oooo0?ooo`0O0?ooo`00803oool00`00
0000oooo0?ooo`2@0?ooo`030000003oool0oooo02D0oooo00<000000?ooo`3oool0603oool00`00
0000oooo0?ooo`0N0?ooo`030000003oool0oooo01H0oooo00<000000?ooo`3oool0<@3oool20000
01d0oooo00<000000?ooo`3oool04P3oool00`000000oooo0?ooo`0g0?ooo`030000003oool0oooo
00l0oooo00<000000?ooo`3oool0>@3oool00`000000oooo0?ooo`2<0?ooo`030000003oool0oooo
01l0oooo000P0?ooo`030000003oool0oooo0900oooo00<000000?ooo`3oool09@3oool00`000000
oooo0?ooo`0H0?ooo`030000003oool0oooo01d0oooo00<000000?ooo`3oool05P3oool00`000000
oooo0?ooo`0d0?ooo`8000006`3oool00`000000oooo0?ooo`0A0?ooo`030000003oool0oooo03P0
oooo00<000000?ooo`3oool0403oool00`000000oooo0?ooo`0h0?ooo`030000003oool0oooo08`0
oooo00<000000?ooo`3oool07`3oool00200oooo00<000000?ooo`3oool0T03oool00`000000oooo
0?ooo`0U0?ooo`030000003oool0oooo01L0oooo00<000000?ooo`3oool07@3oool00`000000oooo
0?ooo`0G0?ooo`030000003oool0oooo03H0oooo0P00000I0?ooo`030000003oool0oooo0100oooo
00<000000?ooo`3oool0>@3oool00`000000oooo0?ooo`0@0?ooo`030000003oool0oooo03L0oooo
00<000000?ooo`3oool0S@3oool00`000000oooo0?ooo`0O0?ooo`00803oool00`000000oooo0?oo
o`2@0?ooo`030000003oool0oooo02@0oooo00<000000?ooo`3oool05`3oool00`000000oooo0?oo
o`0M0?ooo`030000003oool0oooo01P0oooo00<000000?ooo`3oool0>03oool2000001P0oooo00<0
00000?ooo`3oool03P3oool00`000000oooo0?ooo`0j0?ooo`030000003oool0oooo0140oooo00<0
00000?ooo`3oool0=P3oool00`000000oooo0?ooo`2=0?ooo`030000003oool0oooo01l0oooo000P
0?ooo`030000003oool0oooo0900oooo00<000000?ooo`3oool0903oool00`000000oooo0?ooo`0G
0?ooo`030000003oool0oooo01`0oooo00<000000?ooo`3oool06@3oool00`000000oooo0?ooo`0j
0?ooo`8000005P3oool00`000000oooo0?ooo`0=0?ooo`030000003oool0oooo03/0oooo00<00000
0?ooo`3oool04@3oool00`000000oooo0?ooo`0f0?ooo`030000003oool0oooo08d0oooo00<00000
0?ooo`3oool07`3oool00200oooo00<000000?ooo`3oool0T@3oool00`000000oooo0?ooo`0S0?oo
o`030000003oool0oooo01H0oooo00<000000?ooo`3oool0703oool00`000000oooo0?ooo`0J0?oo
o`030000003oool0oooo03`0oooo0P00000D0?ooo`030000003oool0oooo00`0oooo00<000000?oo
o`3oool0?03oool00`000000oooo0?ooo`0B0?ooo`030000003oool0oooo03D0oooo00<000000?oo
o`3oool0S@3oool00`000000oooo0?ooo`0O0?ooo`00803oool00`000000oooo0?ooo`2A0?ooo`03
0000003oool0oooo0280oooo00<000000?ooo`3oool05P3oool00`000000oooo0?ooo`0L0?ooo`03
0000003oool0oooo01/0oooo00<000000?ooo`3oool0?P3oool200000180oooo00<000000?ooo`3o
ool02P3oool200000400oooo00<000000?ooo`3oool04@3oool00`000000oooo0?ooo`0e0?ooo`03
0000003oool0oooo08d0oooo00<000000?ooo`3oool07`3oool00200oooo00<000000?ooo`3oool0
T@3oool00`000000oooo0?ooo`0R0?ooo`030000003oool0oooo01H0oooo00<000000?ooo`3oool0
6P3oool2000001h0oooo00<000000?ooo`3oool0@03oool200000100oooo00<000000?ooo`3oool0
2@3oool00`000000oooo0?ooo`100?ooo`030000003oool0oooo0180oooo00<000000?ooo`3oool0
=03oool00`000000oooo0?ooo`2=0?ooo`030000003oool0oooo01l0oooo000P0?ooo`030000003o
ool0oooo0940oooo00<000000?ooo`3oool08P3oool00`000000oooo0?ooo`0E0?ooo`030000003o
ool0oooo01X0oooo00<000000?ooo`3oool07P3oool00`000000oooo0?ooo`120?ooo`8000003P3o
ool00`000000oooo0?ooo`080?ooo`030000003oool0oooo0440oooo00<000000?ooo`3oool04`3o
ool00`000000oooo0?ooo`0c0?ooo`030000003oool0oooo08d0oooo00<000000?ooo`3oool07`3o
ool00200oooo00<000000?ooo`3oool0TP3oool00`000000oooo0?ooo`0P0?ooo`030000003oool0
oooo01D0oooo00<000000?ooo`3oool06P3oool00`000000oooo0?ooo`0N0?ooo`030000003oool0
oooo04D0oooo0P00000=0?ooo`030000003oool0oooo00H0oooo00<000000?ooo`3oool0@P3oool0
0`000000oooo0?ooo`0C0?ooo`030000003oool0oooo03<0oooo00<000000?ooo`3oool0S@3oool0
0`000000oooo0?ooo`0O0?ooo`00803oool00`000000oooo0?ooo`2B0?ooo`030000003oool0oooo
0200oooo00<000000?ooo`3oool05@3oool00`000000oooo0?ooo`0I0?ooo`030000003oool0oooo
01l0oooo00<000000?ooo`3oool0A`3oool2000000T0oooo1P0000040?ooo`030000003oool0oooo
04<0oooo00<000000?ooo`3oool0503oool00`000000oooo0?ooo`0b0?ooo`030000003oool0oooo
08d0oooo00<000000?ooo`3oool07`3oool00200oooo00<000000?ooo`3oool0TP3oool00`000000
oooo0?ooo`0P0?ooo`030000003oool0oooo01@0oooo00<000000?ooo`3oool06@3oool00`000000
oooo0?ooo`0P0?ooo`030000003oool0oooo04T0oooo0P0000060?ooo`P000000P3oool00`000000
oooo0?ooo`150?ooo`030000003oool0oooo01<0oooo00<000000?ooo`3oool0<P3oool00`000000
oooo0?ooo`2=0?ooo`030000003oool0oooo01l0oooo000P0?ooo`030000003oool0oooo0980oooo
00<000000?ooo`3oool07`3oool00`000000oooo0?ooo`0D0?ooo`030000003oool0oooo01T0oooo
00<000000?ooo`3oool08@3oool00`000000oooo0?ooo`1;0?ooo`8000000`3oool;000004P0oooo
00<000000?ooo`3oool0503oool00`000000oooo0?ooo`0`0?ooo`030000003oool0oooo08h0oooo
00<000000?ooo`3oool07`3oool00200oooo00<000000?ooo`3oool0TP3oool00`000000oooo0?oo
o`0O0?ooo`030000003oool0oooo01@0oooo00<000000?ooo`3oool0603oool00`000000oooo0?oo
o`0R0?ooo`030000003oool0oooo04d0oooo3P0000180?ooo`030000003oool0oooo01@0oooo00<0
00000?ooo`3oool0<03oool00`000000oooo0?ooo`2>0?ooo`030000003oool0oooo01l0oooo000P
0?ooo`030000003oool0oooo09<0oooo00<000000?ooo`3oool07P3oool00`000000oooo0?ooo`0C
0?ooo`030000003oool0oooo01P0oooo00<000000?ooo`3oool08`3oool00`000000oooo0?ooo`1>
0?ooo`d00000B03oool00`000000oooo0?ooo`0E0?ooo`030000003oool0oooo02l0oooo00<00000
0?ooo`3oool0SP3oool00`000000oooo0?ooo`0O0?ooo`00803oool00`000000oooo0?ooo`2C0?oo
o`030000003oool0oooo01d0oooo00<000000?ooo`3oool04`3oool00`000000oooo0?ooo`0H0?oo
o`030000003oool0oooo02@0oooo00<000000?ooo`3oool0CP3oool>000004L0oooo00<000000?oo
o`3oool05P3oool00`000000oooo0?ooo`0^0?ooo`030000003oool0oooo08h0oooo00<000000?oo
o`3oool07`3oool00200oooo00<000000?ooo`3oool0T`3oool00`000000oooo0?ooo`0M0?ooo`03
0000003oool0oooo01<0oooo00<000000?ooo`3oool05P3oool2000002H0oooo00<000000?ooo`3o
ool0C`3oool>000004L0oooo00<000000?ooo`3oool05P3oool00`000000oooo0?ooo`0^0?ooo`03
0000003oool0oooo08h0oooo00<000000?ooo`3oool07`3oool00200oooo00<000000?ooo`3oool0
T`3oool00`000000oooo0?ooo`0M0?ooo`030000003oool0oooo0180oooo00<000000?ooo`3oool0
5P3oool00`000000oooo0?ooo`0V0?ooo`030000003oool0oooo04l0oooo3P0000180?ooo`030000
003oool0oooo01H0oooo00<000000?ooo`3oool0;@3oool00`000000oooo0?ooo`2>0?ooo`030000
003oool0oooo01l0oooo000P0?ooo`030000003oool0oooo09<0oooo00<000000?ooo`3oool0703o
ool00`000000oooo0?ooo`0B0?ooo`030000003oool0oooo01H0oooo00<000000?ooo`3oool09`3o
ool00`000000oooo0?ooo`1?0?oooa400000A@3oool00`000000oooo0?ooo`0F0?ooo`030000003o
ool0oooo02d0oooo00<000000?ooo`3oool0SP3oool00`000000oooo0?ooo`0O0?ooo`00803oool0
0`000000oooo0?ooo`2D0?ooo`030000003oool0oooo01/0oooo00<000000?ooo`3oool04@3oool0
0`000000oooo0?ooo`0F0?ooo`030000003oool0oooo02P0oooo00<000000?ooo`3oool0C`3oool=
000000@0oooo1P00000o0?ooo`030000003oool0oooo01L0oooo00<000000?ooo`3oool0;03oool0
0`000000oooo0?ooo`2>0?ooo`030000003oool0oooo01l0oooo000P0?ooo`030000003oool0oooo
09@0oooo00<000000?ooo`3oool06`3oool00`000000oooo0?ooo`0A0?ooo`030000003oool0oooo
01D0oooo00<000000?ooo`3oool0:@3oool00`000000oooo0?ooo`1<0?ooo`<0000000<0oooo0000
000000002`0000090?ooo`H00000>@3oool00`000000oooo0?ooo`0G0?ooo`030000003oool0oooo
02`0oooo00<000000?ooo`3oool0SP3oool00`000000oooo0?ooo`0O0?ooo`00803oool00`000000
oooo0?ooo`2D0?ooo`030000003oool0oooo01/0oooo00<000000?ooo`3oool0403oool00`000000
oooo0?ooo`0E0?ooo`030000003oool0oooo02X0oooo00<000000?ooo`3oool0B@3oool3000000D0
oooo2P0000020?ooo`8000003@3oool700000380oooo00<000000?ooo`3oool0603oool00`000000
oooo0?ooo`0[0?ooo`030000003oool0oooo08h0oooo00<000000?ooo`3oool07`3oool00200oooo
00<000000?ooo`3oool0U03oool00`000000oooo0?ooo`0J0?ooo`030000003oool0oooo0100oooo
00<000000?ooo`3oool05@3oool00`000000oooo0?ooo`0[0?ooo`030000003oool0oooo04L0oooo
0P0000090?ooo`P0000000<0oooo0000003oool00P3oool200000180oooo1P00000]0?ooo`030000
003oool0oooo01P0oooo00<000000?ooo`3oool0:P3oool00`000000oooo0?ooo`2>0?ooo`030000
003oool0oooo01l0oooo000P0?ooo`030000003oool0oooo09D0oooo00<000000?ooo`3oool06@3o
ool00`000000oooo0?ooo`0@0?ooo`030000003oool0oooo01@0oooo00<000000?ooo`3oool0;03o
ool00`000000oooo0?ooo`140?ooo`<00000303oool6000000<0oooo00<000000?ooo`3oool00P3o
ool2000001H0oooo1P00000V0?ooo`H000005P3oool00`000000oooo0?ooo`0Y0?ooo`030000003o
ool0oooo08l0oooo00<000000?ooo`3oool07`3oool00200oooo00<000000?ooo`3oool0U@3oool0
0`000000oooo0?ooo`0I0?ooo`030000003oool0oooo00l0oooo00<000000?ooo`3oool0503oool0
0`000000oooo0?ooo`0/0?ooo`030000003oool0oooo0480oooo0`00000?0?ooo`030000003oool0
oooo00L0oooo00<000000?ooo`3oool00`3oool2000001X0oooo1P00000O0?ooo`P000005P3oool0
0`000000oooo0?ooo`0X0?ooo`030000003oool0oooo08l0oooo00<000000?ooo`3oool07`3oool0
0200oooo00<000000?ooo`3oool0U@3oool00`000000oooo0?ooo`0H0?ooo`030000003oool0oooo
00l0oooo00<000000?ooo`3oool0503oool00`000000oooo0?ooo`0]0?ooo`030000003oool0oooo
03l0oooo0`00000B0?ooo`030000003oool0oooo00P0oooo00<000000?ooo`3oool0103oool20000
01h0oooo1P00000H0?ooo`X000005@3oool00`000000oooo0?ooo`0X0?ooo`030000003oool0oooo
08l0oooo00<000000?ooo`3oool07`3oool00200oooo00<000000?ooo`3oool0U@3oool00`000000
oooo0?ooo`0H0?ooo`030000003oool0oooo00l0oooo00<000000?ooo`3oool04P3oool200000300
oooo00<000000?ooo`3oool0?03oool3000001D0oooo00<000000?ooo`3oool02@3oool00`000000
oooo0?ooo`050?ooo`8000008P3oool700000100oooo3000000E0?ooo`030000003oool0oooo02L0
oooo00<000000?ooo`3oool0S`3oool00`000000oooo0?ooo`0O0?ooo`00803oool00`000000oooo
0?ooo`2E0?ooo`030000003oool0oooo01P0oooo00<000000?ooo`3oool03P3oool00`000000oooo
0?ooo`0B0?ooo`030000003oool0oooo0300oooo00<000000?ooo`3oool0>@3oool3000001L0oooo
00<000000?ooo`3oool02`3oool00`000000oooo0?ooo`060?ooo`8000009`3oool6000000T0oooo
3@00000E0?ooo`030000003oool0oooo02L0oooo00<000000?ooo`3oool0S`3oool00`000000oooo
0?ooo`0O0?ooo`00803oool00`000000oooo0?ooo`2F0?ooo`030000003oool0oooo01H0oooo00<0
00000?ooo`3oool03P3oool00`000000oooo0?ooo`0B0?ooo`030000003oool0oooo0340oooo00<0
00000?ooo`3oool0=P3oool3000001X0oooo00<000000?ooo`3oool0303oool00`000000oooo0?oo
o`070?ooo`800000:`3oool6000000<0oooo3P00000E0?ooo`030000003oool0oooo02H0oooo00<0
00000?ooo`3oool0S`3oool00`000000oooo0?ooo`0O0?ooo`00803oool00`000000oooo0?ooo`2F
0?ooo`030000003oool0oooo01H0oooo00<000000?ooo`3oool03P3oool00`000000oooo0?ooo`0A
0?ooo`030000003oool0oooo0380oooo00<000000?ooo`3oool0<`3oool3000001d0oooo00<00000
0?ooo`3oool03@3oool00`000000oooo0?ooo`080?ooo`800000;`3ooolA000001H0oooo00<00000
0?ooo`3oool09@3oool00`000000oooo0?ooo`2?0?ooo`030000003oool0oooo01l0oooo000P0?oo
o`030000003oool0oooo09H0oooo00<000000?ooo`3oool05P3oool00`000000oooo0?ooo`0=0?oo
o`030000003oool0oooo0140oooo00<000000?ooo`3oool0<`3oool00`000000oooo0?ooo`0`0?oo
o`<000007`3oool00`000000oooo0?ooo`0?0?ooo`030000003oool0oooo00T0oooo0P00000`0?oo
o`h000005P3oool00`000000oooo0?ooo`0U0?ooo`030000003oool0oooo08l0oooo00<000000?oo
o`3oool07`3oool00200oooo00<000000?ooo`3oool0UP3oool00`000000oooo0?ooo`0E0?ooo`03
0000003oool0oooo00d0oooo00<000000?ooo`3oool04@3oool00`000000oooo0?ooo`0c0?ooo`03
0000003oool0oooo02h0oooo0`00000R0?ooo`030000003oool0oooo0100oooo00<000000?ooo`3o
ool02P3oool2000002h0oooo3P00000G0?ooo`030000003oool0oooo02@0oooo00<000000?ooo`3o
ool0S`3oool00`000000oooo0?ooo`0O0?ooo`00803oool00`000000oooo0?ooo`2F0?ooo`030000
003oool0oooo01D0oooo00<000000?ooo`3oool03@3oool00`000000oooo0?ooo`0@0?ooo`030000
003oool0oooo03@0oooo00<000000?ooo`3oool0:`3oool3000002D0oooo00<000000?ooo`3oool0
4@3oool00`000000oooo0?ooo`0;0?ooo`800000;03oool=000001P0oooo00<000000?ooo`3oool0
903oool00`000000oooo0?ooo`2?0?ooo`030000003oool0oooo01l0oooo000P0?ooo`030000003o
ool0oooo09L0oooo00<000000?ooo`3oool0503oool00`000000oooo0?ooo`0<0?ooo`030000003o
ool0oooo0100oooo00<000000?ooo`3oool0=@3oool00`000000oooo0?ooo`0Y0?ooo`8000009`3o
ool00`000000oooo0?ooo`0C0?ooo`030000003oool0oooo00`0oooo0P00000[0?ooo``000006@3o
ool00`000000oooo0?ooo`0R0?ooo`030000003oool0oooo0900oooo00<000000?ooo`3oool07`3o
ool00200oooo00<000000?ooo`3oool0U`3oool00`000000oooo0?ooo`0C0?ooo`030000003oool0
oooo00`0oooo00<000000?ooo`3oool0403oool00`000000oooo0?ooo`0f0?ooo`030000003oool0
oooo02H0oooo0`00000Y0?ooo`030000003oool0oooo01@0oooo00<000000?ooo`3oool03@3oool2
000002X0oooo2P00000J0?ooo`030000003oool0oooo0280oooo00<000000?ooo`3oool0T03oool0
0`000000oooo0?ooo`0O0?ooo`00803oool00`000000oooo0?ooo`2G0?ooo`030000003oool0oooo
01<0oooo00<000000?ooo`3oool0303oool00`000000oooo0?ooo`0>0?ooo`800000>@3oool00`00
0000oooo0?ooo`0S0?ooo`<00000:`3oool00`000000oooo0?ooo`0F0?ooo`030000003oool0oooo
00h0oooo0P00000Y0?ooo`T000006`3oool00`000000oooo0?ooo`0Q0?ooo`030000003oool0oooo
0900oooo00<000000?ooo`3oool07`3oool00200oooo00<000000?ooo`3oool0U`3oool00`000000
oooo0?ooo`0C0?ooo`030000003oool0oooo00/0oooo00<000000?ooo`3oool03P3oool00`000000
oooo0?ooo`0i0?ooo`030000003oool0oooo0200oooo0`00000^0?ooo`030000003oool0oooo01L0
oooo00<000000?ooo`3oool03`3oool2000002P0oooo1P0000020?ooo`8000006P3oool00`000000
oooo0?ooo`0P0?ooo`030000003oool0oooo0900oooo00<000000?ooo`3oool07`3oool00200oooo
00<000000?ooo`3oool0V03oool00`000000oooo0?ooo`0A0?ooo`030000003oool0oooo00/0oooo
00<000000?ooo`3oool03P3oool00`000000oooo0?ooo`0j0?ooo`030000003oool0oooo01d0oooo
0`00000a0?ooo`030000003oool0oooo01P0oooo00<000000?ooo`3oool0403oool2000002L0oooo
00<000000?ooo`3oool01P3oool00`000000oooo0?ooo`0G0?ooo`030000003oool0oooo0200oooo
00<000000?ooo`3oool0T03oool00`000000oooo0?ooo`0O0?ooo`00803oool00`000000oooo0?oo
o`2H0?ooo`030000003oool0oooo0140oooo00<000000?ooo`3oool02`3oool00`000000oooo0?oo
o`0=0?ooo`030000003oool0oooo03X0oooo00<000000?ooo`3oool06`3oool3000003<0oooo00<0
00000?ooo`3oool06P3oool00`000000oooo0?ooo`0A0?ooo`8000009@3oool00`000000oooo0?oo
o`070?ooo`030000003oool0oooo01L0oooo00<000000?ooo`3oool07`3oool00`000000oooo0?oo
o`2@0?ooo`030000003oool0oooo01l0oooo000P0?ooo`030000003oool0oooo09P0oooo00<00000
0?ooo`3oool04@3oool00`000000oooo0?ooo`0:0?ooo`030000003oool0oooo00d0oooo00<00000
0?ooo`3oool0>`3oool00`000000oooo0?ooo`0H0?ooo`<00000=P3oool00`000000oooo0?ooo`0K
0?ooo`030000003oool0oooo0180oooo0P00000S0?ooo`030000003oool0oooo00P0oooo00<00000
0?ooo`3oool05P3oool00`000000oooo0?ooo`0O0?ooo`030000003oool0oooo0900oooo00<00000
0?ooo`3oool07`3oool00200oooo00<000000?ooo`3oool0V03oool00`000000oooo0?ooo`0@0?oo
o`030000003oool0oooo00X0oooo00<000000?ooo`3oool03@3oool00`000000oooo0?ooo`0l0?oo
o`030000003oool0oooo01D0oooo0`00000i0?ooo`030000003oool0oooo01`0oooo00<000000?oo
o`3oool04`3oool200000240oooo00<000000?ooo`3oool02@3oool00`000000oooo0?ooo`0F0?oo
o`030000003oool0oooo01h0oooo00<000000?ooo`3oool0T03oool00`000000oooo0?ooo`0O0?oo
o`00803oool00`000000oooo0?ooo`2H0?ooo`030000003oool0oooo0100oooo00<000000?ooo`3o
ool02P3oool00`000000oooo0?ooo`0<0?ooo`030000003oool0oooo03d0oooo00<000000?ooo`3o
ool04P3oool3000003/0oooo00<000000?ooo`3oool07P3oool00`000000oooo0?ooo`0D0?ooo`80
00007`3oool00`000000oooo0?ooo`0:0?ooo`030000003oool0oooo01D0oooo00<000000?ooo`3o
ool07P3oool00`000000oooo0?ooo`2@0?ooo`030000003oool0oooo01l0oooo000P0?ooo`030000
003oool0oooo09T0oooo00<000000?ooo`3oool03`3oool00`000000oooo0?ooo`090?ooo`030000
003oool0oooo00`0oooo00<000000?ooo`3oool0>P3oool600000100oooo0`00000n0?ooo`030000
003oool0oooo01l0oooo00<000000?ooo`3oool05@3oool2000001d0oooo00<000000?ooo`3oool0
2`3oool00`000000oooo0?ooo`0E0?ooo`030000003oool0oooo01d0oooo00<000000?ooo`3oool0
T03oool00`000000oooo0?ooo`0O0?ooo`00803oool00`000000oooo0?ooo`2I0?ooo`030000003o
ool0oooo00l0oooo00<000000?ooo`3oool0203oool00`000000oooo0?ooo`0<0?ooo`030000003o
ool0oooo03X0oooo2000000<0?ooo`<00000@03oool00`000000oooo0?ooo`0Q0?ooo`030000003o
ool0oooo01H0oooo0P00000J0?ooo`030000003oool0oooo00d0oooo00<000000?ooo`3oool05@3o
ool00`000000oooo0?ooo`0K0?ooo`030000003oool0oooo0940oooo00<000000?ooo`3oool07`3o
ool00200oooo00<000000?ooo`3oool0V@3oool00`000000oooo0?ooo`0>0?ooo`030000003oool0
oooo00T0oooo00<000000?ooo`3oool02P3oool2000003`0oooo2P0000090?ooo`800000@`3oool0
0`000000oooo0?ooo`0R0?ooo`030000003oool0oooo01L0oooo0P00000H0?ooo`030000003oool0
oooo00h0oooo00<000000?ooo`3oool0503oool00`000000oooo0?ooo`0K0?ooo`030000003oool0
oooo0940oooo00<000000?ooo`3oool07`3oool00200oooo00<000000?ooo`3oool0V@3oool00`00
0000oooo0?ooo`0>0?ooo`030000003oool0oooo00P0oooo00<000000?ooo`3oool02P3oool00`00
0000oooo0?ooo`0k0?ooo``000001@3oool3000004D0oooo00<000000?ooo`3oool08`3oool00`00
0000oooo0?ooo`0H0?ooo`8000005P3oool00`000000oooo0?ooo`0?0?ooo`030000003oool0oooo
01@0oooo00<000000?ooo`3oool06P3oool00`000000oooo0?ooo`2A0?ooo`030000003oool0oooo
01l0oooo000P0?ooo`030000003oool0oooo09X0oooo00<000000?ooo`3oool03@3oool00`000000
oooo0?ooo`070?ooo`030000003oool0oooo00X0oooo00<000000?ooo`3oool0>`3oool=00000080
oooo0`0000170?ooo`030000003oool0oooo02D0oooo00<000000?ooo`3oool06@3oool2000001@0
oooo00<000000?ooo`3oool0403oool00`000000oooo0?ooo`0C0?ooo`030000003oool0oooo01X0
oooo00<000000?ooo`3oool0T@3oool00`000000oooo0?ooo`0O0?ooo`00803oool00`000000oooo
0?ooo`2J0?ooo`030000003oool0oooo00`0oooo00<000000?ooo`3oool0203oool00`000000oooo
0?ooo`090?ooo`030000003oool0oooo03`0oooo3`00001:0?ooo`030000003oool0oooo02H0oooo
00<000000?ooo`3oool06P3oool200000180oooo00<000000?ooo`3oool04@3oool00`000000oooo
0?ooo`0C0?ooo`030000003oool0oooo01T0oooo00<000000?ooo`3oool0T@3oool00`000000oooo
0?ooo`0O0?ooo`00803oool00`000000oooo0?ooo`2J0?ooo`030000003oool0oooo00`0oooo00<0
00000?ooo`3oool01`3oool00`000000oooo0?ooo`090?ooo`030000003oool0oooo03d0oooo3P00
001;0?ooo`030000003oool0oooo02L0oooo00<000000?ooo`3oool06`3oool200000100oooo00<0
00000?ooo`3oool04P3oool2000001<0oooo00<000000?ooo`3oool06@3oool00`000000oooo0?oo
o`2A0?ooo`030000003oool0oooo01l0oooo000P0?ooo`030000003oool0oooo09X0oooo00<00000
0?ooo`3oool0303oool00`000000oooo0?ooo`060?ooo`030000003oool0oooo00T0oooo00<00000
0?ooo`3oool0?P3oool>000004X0oooo00<000000?ooo`3oool0:@3oool00`000000oooo0?ooo`0L
0?ooo`8000002P3oool6000001D0oooo00<000000?ooo`3oool04@3oool00`000000oooo0?ooo`0H
0?ooo`030000003oool0oooo0940oooo00<000000?ooo`3oool07`3oool00200oooo00<000000?oo
o`3oool0VP3oool00`000000oooo0?ooo`0;0?ooo`030000003oool0oooo00L0oooo00<000000?oo
o`3oool0203oool00`000000oooo0?ooo`0o0?ooo`h00000BP3oool00`000000oooo0?ooo`0Z0?oo
o`030000003oool0oooo01d0oooo0P0000070?ooo`P000005@3oool00`000000oooo0?ooo`0A0?oo
o`030000003oool0oooo01L0oooo00<000000?ooo`3oool0T@3oool00`000000oooo0?ooo`0O0?oo
o`00803oool00`000000oooo0?ooo`2K0?ooo`030000003oool0oooo00X0oooo00<000000?ooo`3o
ool01P3oool00`000000oooo0?ooo`080?ooo`030000003oool0oooo03h0oooo3`00001;0?ooo`03
0000003oool0oooo02/0oooo00<000000?ooo`3oool07P3oool2000000@0oooo2P00000E0?ooo`03
0000003oool0oooo0100oooo00<000000?ooo`3oool05`3oool00`000000oooo0?ooo`2A0?ooo`03
0000003oool0oooo01l0oooo000P0?ooo`030000003oool0oooo09/0oooo00<000000?ooo`3oool0
2P3oool00`000000oooo0?ooo`050?ooo`030000003oool0oooo00P0oooo00<000000?ooo`3oool0
>`3oool4000000<0oooo3000001:0?ooo`030000003oool0oooo02d0oooo00<000000?ooo`3oool0
7`3oool2000000030?ooo`000000000000X000005@3oool00`000000oooo0?ooo`0@0?ooo`030000
003oool0oooo01H0oooo00<000000?ooo`3oool0T@3oool00`000000oooo0?ooo`0O0?ooo`00803o
ool00`000000oooo0?ooo`2K0?ooo`030000003oool0oooo00T0oooo00<000000?ooo`3oool01P3o
ool00`000000oooo0?ooo`060?ooo`800000>`3oool3000000P0oooo2`00001:0?ooo`030000003o
ool0oooo02h0oooo00<000000?ooo`3oool0803oool=000001H0oooo00<000000?ooo`3oool03`3o
ool00`000000oooo0?ooo`0F0?ooo`030000003oool0oooo0940oooo00<000000?ooo`3oool07`3o
ool00200oooo00<000000?ooo`3oool0V`3oool00`000000oooo0?ooo`090?ooo`030000003oool0
oooo00D0oooo00<000000?ooo`3oool01P3oool00`000000oooo0?ooo`0g0?ooo`@00000303oool8
00000080oooo00<000000?ooo`3oool0AP3oool00`000000oooo0?ooo`0`0?ooo`030000003oool0
oooo01l0oooo3P00000F0?ooo`030000003oool0oooo00l0oooo00<000000?ooo`3oool0503oool0
0`000000oooo0?ooo`2B0?ooo`030000003oool0oooo01l0oooo000P0?ooo`030000003oool0oooo
09/0oooo00<000000?ooo`3oool02@3oool00`000000oooo0?ooo`040?ooo`030000003oool0oooo
00H0oooo00<000000?ooo`3oool0=03oool400000140oooo1P0000040?ooo`800000AP3oool00`00
0000oooo0?ooo`0a0?ooo`030000003oool0oooo01h0oooo3P00000G0?ooo`030000003oool0oooo
00h0oooo00<000000?ooo`3oool0503oool00`000000oooo0?ooo`2B0?ooo`030000003oool0oooo
01l0oooo000P0?ooo`030000003oool0oooo09`0oooo00<000000?ooo`3oool01`3oool00`000000
oooo0?ooo`050?ooo`030000003oool0oooo00D0oooo00<000000?ooo`3oool0<@3oool400000240
oooo00<000000?ooo`3oool0@`3oool00`000000oooo0?ooo`0b0?ooo`030000003oool0oooo01d0
oooo3P00000H0?ooo`030000003oool0oooo00h0oooo00<000000?ooo`3oool04`3oool00`000000
oooo0?ooo`2B0?ooo`030000003oool0oooo01l0oooo000P0?ooo`030000003oool0oooo09`0oooo
00<000000?ooo`3oool01`3oool00`000000oooo0?ooo`040?ooo`030000003oool0oooo00D0oooo
00<000000?ooo`3oool0;P3oool4000002H0oooo00<000000?ooo`3oool0@@3oool00`000000oooo
0?ooo`0d0?ooo`030000003oool0oooo01`0oooo3P00000I0?ooo`030000003oool0oooo00h0oooo
00<000000?ooo`3oool04P3oool00`000000oooo0?ooo`2B0?ooo`030000003oool0oooo01l0oooo
000P0?ooo`030000003oool0oooo09`0oooo00<000000?ooo`3oool01`3oool00`000000oooo0?oo
o`030?ooo`030000003oool0oooo00D0oooo00<000000?ooo`3oool0;03oool3000002/0oooo00<0
00000?ooo`3oool0@03oool00`000000oooo0?ooo`0e0?ooo`030000003oool0oooo01/0oooo3@00
000K0?ooo`030000003oool0oooo00d0oooo00<000000?ooo`3oool04P3oool00`000000oooo0?oo
o`2B0?ooo`030000003oool0oooo01l0oooo000P0?ooo`030000003oool0oooo09`0oooo00<00000
0?ooo`3oool01P3oool00`000000oooo0?ooo`030?ooo`030000003oool0oooo00D0oooo00<00000
0?ooo`3oool0:@3oool4000002l0oooo0P0000100?ooo`030000003oool0oooo03H0oooo00<00000
0?ooo`3oool06`3oool>000001X0oooo00<000000?ooo`3oool03@3oool00`000000oooo0?ooo`0A
0?ooo`030000003oool0oooo0980oooo00<000000?ooo`3oool07`3oool00200oooo00<000000?oo
o`3oool0W@3oool00`000000oooo0?ooo`050?ooo`030000003oool0oooo00<0oooo00<000000?oo
o`3oool0103oool00`000000oooo0?ooo`0V0?ooo`@00000=@3oool00`000000oooo0?ooo`0l0?oo
o`030000003oool0oooo03P0oooo00<000000?ooo`3oool06@3oool<000000<0oooo0P00000I0?oo
o`8000003@3oool00`000000oooo0?ooo`0A0?ooo`030000003oool0oooo0980oooo00<000000?oo
o`3oool07`3oool00200oooo00<000000?ooo`3oool0W@3oool00`000000oooo0?ooo`050?ooo`03
0000003oool0oooo0080oooo00<000000?ooo`3oool0103oool00`000000oooo0?ooo`0S0?ooo`@0
0000>P3oool00`000000oooo0?ooo`0k0?ooo`030000003oool0oooo03T0oooo00<000000?ooo`3o
ool05`3oool010000000oooo0?ooo`3oool8000000H0oooo0P00000I0?ooo`030000003oool0oooo
00/0oooo00<000000?ooo`3oool0403oool00`000000oooo0?ooo`2B0?ooo`030000003oool0oooo
01l0oooo000P0?ooo`030000003oool0oooo09d0oooo00<000000?ooo`3oool0103oool00`000000
oooo0?ooo`020?ooo`030000003oool0oooo00<0oooo0P00000S0?ooo`<00000?`3oool2000003/0
oooo00<000000?ooo`3oool0>P3oool00`000000oooo0?ooo`0D0?ooo`8000001@3oool6000000T0
oooo0P00000H0?ooo`030000003oool0oooo00/0oooo00<000000?ooo`3oool03`3oool00`000000
oooo0?ooo`2B0?ooo`030000003oool0oooo01l0oooo000P0?ooo`030000003oool0oooo09d0oooo
00<000000?ooo`3oool0103oool00`000000oooo0?ooo`020?ooo`030000003oool0oooo0080oooo
00<000000?ooo`3oool07`3oool4000004@0oooo00<000000?ooo`3oool0=`3oool00`000000oooo
0?ooo`0l0?ooo`030000003oool0oooo0180oooo00<000000?ooo`3oool05P3oool2000001L0oooo
00<000000?ooo`3oool02P3oool00`000000oooo0?ooo`0?0?ooo`030000003oool0oooo0980oooo
00<000000?ooo`3oool07`3oool00200oooo00<000000?ooo`3oool0W@3oool00`000000oooo0?oo
o`040?ooo`050000003oool0oooo0?ooo`000000103oool00`000000oooo0?ooo`0L0?ooo`@00000
B@3oool00`000000oooo0?ooo`0f0?ooo`030000003oool0oooo03d0oooo00<000000?ooo`3oool0
3`3oool2000001/0oooo0P00000F0?ooo`030000003oool0oooo00X0oooo00<000000?ooo`3oool0
3@3oool00`000000oooo0?ooo`2C0?ooo`030000003oool0oooo01l0oooo000P0?ooo`030000003o
ool0oooo09h0oooo00<000000?ooo`3oool00`3oool010000000oooo0?ooo`0000040?ooo`030000
003oool0oooo01T0oooo1000001>0?ooo`030000003oool0oooo03@0oooo00<000000?ooo`3oool0
?`3oool00`000000oooo0?ooo`06000000H0oooo0P00000O0?ooo`8000005@3oool00`000000oooo
0?ooo`090?ooo`030000003oool0oooo00d0oooo00<000000?ooo`3oool0T`3oool00`000000oooo
0?ooo`0O0?ooo`00803oool00`000000oooo0?ooo`2N0?ooo`030000003oool0oooo0080oooo00D0
00000?ooo`3oool0oooo000000030?ooo`030000003oool0oooo01H0oooo1000001C0?ooo`800000
=03oool00`000000oooo0?ooo`100?ooo`T00000103oool00`000000oooo0?ooo`0Q0?ooo`800000
503oool00`000000oooo0?ooo`090?ooo`030000003oool0oooo00`0oooo00<000000?ooo`3oool0
T`3oool00`000000oooo0?ooo`0O0?ooo`00803oool00`000000oooo0?ooo`2N0?ooo`030000003o
ool0oooo0080oooo00@000000?ooo`3oool000000`3oool00`000000oooo0?ooo`0D0?ooo`<00000
F@3oool00`000000oooo0?ooo`0a0?ooo`030000003oool0oooo0400oooo2P0000000`3oool00000
0000000V0?ooo`8000004`3oool00`000000oooo0?ooo`080?ooo`030000003oool0oooo00`0oooo
00<000000?ooo`3oool0T`3oool00`000000oooo0?ooo`0O0?ooo`00803oool00`000000oooo0?oo
o`2N0?ooo`030000003oool0oooo0080oooo00<000000?ooo`0000000`3oool00`000000oooo0?oo
o`0A0?ooo`@00000G@3oool00`000000oooo0?ooo`0_0?ooo`030000003oool0oooo0400oooo3000
000Z0?ooo`8000004P3oool00`000000oooo0?ooo`080?ooo`030000003oool0oooo00/0oooo00<0
00000?ooo`3oool0T`3oool00`000000oooo0?ooo`0O0?ooo`00803oool00`000000oooo0?ooo`2N
0?ooo`050000003oool0oooo0?ooo`0000000P3oool010000000oooo0?ooo`00000@0?ooo`@00000
HP3oool00`000000oooo0?ooo`0^0?ooo`030000003oool0oooo03l0oooo3@00000/0?ooo`800000
4@3oool00`000000oooo0?ooo`080?ooo`030000003oool0oooo00X0oooo00<000000?ooo`3oool0
T`3oool00`000000oooo0?ooo`0O0?ooo`00803oool00`000000oooo0?ooo`2N0?ooo`L000000P3o
ool00`000000oooo0?ooo`0;0?ooo`@00000I`3oool2000002h0oooo00<000000?ooo`3oool0?`3o
ool>000002d0oooo0P00000@0?ooo`030000003oool0oooo00L0oooo00<000000?ooo`3oool02P3o
ool00`000000oooo0?ooo`2C0?ooo`030000003oool0oooo01l0oooo000P0?ooo`030000003oool0
oooo09d0oooo2P00000;0?ooo`<00000K@3oool00`000000oooo0?ooo`0Z0?ooo`030000003oool0
oooo0400oooo3P00000_0?ooo`8000003`3oool2000000P0oooo00<000000?ooo`3oool02@3oool0
0`000000oooo0?ooo`2C0?ooo`030000003oool0oooo01l0oooo000P0?ooo`030000003oool0oooo
09`0oooo2P0000080?ooo`@00000L@3oool00`000000oooo0?ooo`0Y0?ooo`030000003oool0oooo
0400oooo3`00000`0?ooo`8000003`3oool00`000000oooo0?ooo`050?ooo`030000003oool0oooo
00T0oooo00<000000?ooo`3oool0T`3oool00`000000oooo0?ooo`0O0?ooo`00803oool00`000000
oooo0?ooo`2K0?ooo``000000`3oool4000007H0oooo00<000000?ooo`3oool0:03oool00`000000
oooo0?ooo`100?ooo`h0000000<0oooo0000000000000`00000]0?ooo`8000003P3oool00`000000
oooo0?ooo`050?ooo`030000003oool0oooo00P0oooo00<000000?ooo`3oool0T`3oool00`000000
oooo0?ooo`0O0?ooo`00803oool00`000000oooo0?ooo`2J0?oooa000000N`3oool2000002L0oooo
00<000000?ooo`3oool0?P3oool@000000L0oooo1@00000Z0?ooo`8000003@3oool00`000000oooo
0?ooo`040?ooo`030000003oool0oooo00L0oooo00<000000?ooo`3oool0U03oool00`000000oooo
0?ooo`0O0?ooo`00803oool00`000000oooo0?ooo`2J0?ooo`h00000O`3oool00`000000oooo0?oo
o`0T0?ooo`030000003oool0oooo03/0oooo0`0000040?ooo``00000303oool5000002L0oooo0P00
000<0?ooo`030000003oool0oooo00@0oooo00<000000?ooo`3oool01P3oool00`000000oooo0?oo
o`2D0?ooo`030000003oool0oooo01l0oooo000P0?ooo`030000003oool0oooo09X0oooo3P000020
0?ooo`030000003oool0oooo0280oooo00<000000?ooo`3oool0>@3oool3000000P0oooo2P00000B
0?ooo`D00000903oool2000000/0oooo00<000000?ooo`3oool0103oool00`000000oooo0?ooo`05
0?ooo`030000003oool0oooo09@0oooo00<000000?ooo`3oool07`3oool00200oooo00<000000?oo
o`3oool0VP3ooolA000007h0oooo00<000000?ooo`3oool08@3oool00`000000oooo0?ooo`0f0?oo
o`<00000303oool8000001P0oooo1@00000Q0?ooo`8000002P3oool00`000000oooo0?ooo`030?oo
o`030000003oool0oooo00D0oooo00<000000?ooo`3oool0U03oool00`000000oooo0?ooo`0O0?oo
o`00803oool00`000000oooo0?ooo`2J0?ooo`h000000`3oool7000007P0oooo0P00000Q0?ooo`03
0000003oool0oooo03<0oooo0`00000@0?ooo`H000007P3oool5000001h0oooo0P0000090?ooo`03
0000003oool0oooo00<0oooo00<000000?ooo`3oool0103oool00`000000oooo0?ooo`2D0?ooo`03
0000003oool0oooo01l0oooo000P0?ooo`030000003oool0oooo09X0oooo3@00000;0?ooo`P00000
LP3oool00`000000oooo0?ooo`0M0?ooo`030000003oool0oooo0340oooo0`00000l0?ooo`D00000
6`3oool2000000P0oooo00<000000?ooo`3oool00P3oool00`000000oooo0?ooo`040?ooo`030000
003oool0oooo09@0oooo00<000000?ooo`3oool07`3oool00200oooo00<000000?ooo`3oool0V03o
ool2000000030?ooo`000000000000X000004`3oool7000006`0oooo00<000000?ooo`3oool0703o
ool00`000000oooo0?ooo`0^0?ooo`<00000A03oool6000001L0oooo0P0000070?ooo`030000003o
ool0oooo0080oooo00<000000?ooo`3oool00`3oool00`000000oooo0?ooo`2D0?ooo`030000003o
ool0oooo01l0oooo000P0?ooo`030000003oool0oooo09H0oooo0P0000040?ooo`X0000000<0oooo
0000003oool0603oool7000006H0oooo00<000000?ooo`3oool06`3oool00`000000oooo0?ooo`0[
0?ooo`<00000C@3oool5000001@0oooo0P0000060?ooo`050000003oool0oooo0?ooo`0000001@3o
ool00`000000oooo0?ooo`2D0?ooo`030000003oool0oooo01l0oooo000P0?ooo`030000003oool0
oooo09D0oooo00<000000?ooo`3oool01@3oool8000000<0oooo00<000000?ooo`3oool07@3oool7
00000600oooo0P00000J0?ooo`030000003oool0oooo02T0oooo0`00001E0?ooo`D000004@3oool2
000000D0oooo00D000000?ooo`3oool0oooo000000040?ooo`030000003oool0oooo09@0oooo00<0
00000?ooo`3oool07`3oool00200oooo00<000000?ooo`3oool0T`3oool2000000T0oooo1P000005
0?ooo`800000903oool7000005/0oooo00<000000?ooo`3oool05`3oool00`000000oooo0?ooo`0V
0?ooo`<00000G@3oool5000000h0oooo0P0000040?ooo`8000000P3oool7000009@0oooo00<00000
0?ooo`3oool07`3oool00200oooo00<000000?ooo`3oool0T@3oool2000001P0oooo00<000000?oo
o`3oool0:03oool7000005D0oooo00<000000?ooo`3oool05@3oool00`000000oooo0?ooo`0T0?oo
o`<00000I@3oool5000000/0oooo0P0000040?ooo`030000003oool0000000L00000T`3oool00`00
0000oooo0?ooo`0O0?ooo`00803oool00`000000oooo0?ooo`2?0?ooo`8000006`3oool00`000000
oooo0?ooo`0^0?ooo`P00000CP3oool00`000000oooo0?ooo`0D0?ooo`030000003oool0oooo0240
oooo0`00001]0?ooo`D00000203oool2000000<0oooo2P00002B0?ooo`030000003oool0oooo01l0
oooo000P0?ooo`030000003oool0oooo08d0oooo0P00000N0?ooo`800000=P3oool7000004P0oooo
0P00000D0?ooo`030000003oool0oooo01h0oooo0`00001e0?ooo`D000001@3oool>00000940oooo
00<000000?ooo`3oool07`3oool00200oooo00<000000?ooo`3oool0R`3oool200000280oooo00<0
00000?ooo`3oool0>P3oool7000004<0oooo00<000000?ooo`3oool0403oool00`000000oooo0?oo
o`0L0?ooo`<00000O@3oool5000000030?ooo`000000000000/00000T@3oool00`000000oooo0?oo
o`0O0?ooo`00803oool00`000000oooo0?ooo`2:0?ooo`030000003oool0oooo02<0oooo0P000011
0?ooo`L00000?@3oool00`000000oooo0?ooo`0?0?ooo`030000003oool0oooo01T0oooo0`000025
0?ooo`l00000T03oool00`000000oooo0?ooo`0O0?ooo`00803oool00`000000oooo0?ooo`280?oo
o`800000:03oool00`000000oooo0?ooo`150?ooo`L00000=`3oool2000000l0oooo00<000000?oo
o`3oool05P3oool3000008L0oooo4000002@0?ooo`030000003oool0oooo01l0oooo000P0?ooo`03
0000003oool0oooo08H0oooo0P00000[0?ooo`030000003oool0oooo04/0oooo2000000a0?ooo`03
0000003oool0oooo00/0oooo00<000000?ooo`3oool0503oool3000007P0oooo4P0000020?ooo`h0
0000T03oool00`000000oooo0?ooo`0O0?ooo`00803oool00`000000oooo0?ooo`240?ooo`800000
;P3oool2000005<0oooo1`00000[0?ooo`030000003oool0oooo00X0oooo00<000000?ooo`3oool0
4@3oool3000006X0oooo4@00000D0?ooo`h00000T03oool00`000000oooo0?ooo`0O0?ooo`00803o
ool00`000000oooo0?ooo`220?ooo`800000<P3oool00`000000oooo0?ooo`1G0?ooo`L000009@3o
ool00`000000oooo0?ooo`090?ooo`030000003oool0oooo00h0oooo0`00001K0?oooa8000009@3o
ool=00000940oooo00<000000?ooo`3oool07`3oool00200oooo00<000000?ooo`3oool0P03oool2
000003D0oooo00<000000?ooo`3oool0G@3oool7000001l0oooo0P0000040?ooo`H000003@3oool3
000004d0oooo4@00000f0?oooa000000S`3oool00`000000oooo0?ooo`0O0?ooo`00803oool00`00
0000oooo0?ooo`1o0?ooo`030000003oool0oooo03H0oooo0P00001T0?ooo`L000006P3oool00`00
0000oooo0?ooo`08000000T0oooo0`00000n0?oooa800000A@3oool2000000<0oooo2P0000030?oo
o`800000S@3oool00`000000oooo0?ooo`0O0?ooo`00803oool00`000000oooo0?ooo`1m0?ooo`80
0000>`3oool00`000000oooo0?ooo`1X0?ooo`L00000503oool;000000D0oooo0`00000`0?oooa40
0000EP3oool00`000000oooo0?ooo`040?ooo`P000001P3oool2000008/0oooo00<000000?ooo`3o
ool07`3oool00200oooo00<000000?ooo`3oool0N`3oool2000003h0oooo0P00001_0?ooo`P00000
303oool<000000040?ooo`000000000000000240oooo4P00001U0?ooo`800000203oool6000000T0
oooo0P0000290?ooo`030000003oool0oooo01l0oooo000P0?ooo`030000003oool0oooo07T0oooo
0P0000120?ooo`030000003oool0oooo07@0oooo1`0000040?ooo`h000004`3ooolA000007H0oooo
00<000000?ooo`3oool06@3oool2000008L0oooo00<000000?ooo`3oool07`3oool00200oooo00<0
00000?ooo`3oool0M`3oool2000004D0oooo00<000000?ooo`3oool0NP3ooolB000000030?ooo`00
0000000001000000Q@3oool2000001h0oooo0P0000250?ooo`030000003oool0oooo01l0oooo000P
0?ooo`030000003oool0oooo07D0oooo0P0000180?ooo`800000OP3oool?000009D0oooo0P00000R
0?ooo`800000P`3oool00`000000oooo0?ooo`0O0?ooo`00803oool00`000000oooo0?ooo`1d0?oo
o`030000003oool0oooo04X0oooo00<000000?ooo`3oool0N`3oool>000009D0oooo00<000000?oo
o`3oool0903oool200000840oooo00<000000?ooo`3oool07`3oool00200oooo00<000000?ooo`3o
ool0LP3oool2000004h0oooo00<000000?ooo`3oool0NP3oool>000009<0oooo0P00000Y0?ooo`80
0000O`3oool00`000000oooo0?ooo`0O0?ooo`00803oool00`000000oooo0?ooo`1`0?ooo`800000
D@3oool2000007X0oooo3@00002B0?ooo`800000;@3oool2000007d0oooo00<000000?ooo`3oool0
7`3oool00200oooo00<000000?ooo`3oool0KP3oool2000005D0oooo00<000000?ooo`3oool0N03o
ool<00000940oooo00<000000?ooo`3oool0;`3oool2000007/0oooo00<000000?ooo`3oool07`3o
ool00200oooo00<000000?ooo`3oool0K03oool2000005P0oooo00<000000?ooo`3oool0N03oool:
00000900oooo0P00000d0?ooo`800000N@3oool00`000000oooo0?ooo`0O0?ooo`00803oool00`00
0000oooo0?ooo`1Z0?ooo`800000F`3oool2000007T0oooo2000002?0?ooo`800000>03oool20000
07L0oooo00<000000?ooo`3oool07`3oool00200oooo00<000000?ooo`3oool0J@3oool00`000000
oooo0?ooo`1M0?ooo`030000003oool0oooo07L0oooo1P00002?0?ooo`030000003oool0oooo03X0
oooo0P00001e0?ooo`030000003oool0oooo01l0oooo000P0?ooo`030000003oool0oooo06L0oooo
0P00001Q0?ooo`800000N@3oool00`000000oooo0?ooo`2>0?ooo`800000?`3oool2000007<0oooo
00<000000?ooo`3oool07`3oool00200oooo00<000000?ooo`3oool0I@3oool2000006D0oooo00<0
00000?ooo`3oool0MP3oool00`000000oooo0?ooo`2<0?ooo`800000@`3oool200000740oooo00<0
00000?ooo`3oool07`3oool00200oooo00<000000?ooo`3oool0H`3oool2000006P0oooo00<00000
0?ooo`3oool0M@3oool00`000000oooo0?ooo`2;0?ooo`030000003oool0oooo04D0oooo0P00001_
0?ooo`030000003oool0oooo01l0oooo000P0?ooo`030000003oool0oooo0640oooo0P00001[0?oo
o`800000M@3oool00`000000oooo0?ooo`290?ooo`800000BP3oool2000006d0oooo00<000000?oo
o`3oool07`3oool00200oooo00<000000?ooo`3oool0G`3oool2000006l0oooo00<000000?ooo`3o
ool0LP3oool00`000000oooo0?ooo`270?ooo`800000CP3oool2000006/0oooo00<000000?ooo`3o
ool07`3oool00200oooo00<000000?ooo`3oool0GP3oool00`000000oooo0?ooo`1`0?ooo`030000
003oool0oooo0740oooo00<000000?ooo`3oool0QP3oool00`000000oooo0?ooo`1@0?ooo`800000
J@3oool00`000000oooo0?ooo`0O0?ooo`00803oool00`000000oooo0?ooo`1L0?ooo`800000M03o
ool200000740oooo00<000000?ooo`3oool0Q03oool2000005D0oooo0P00001W0?ooo`030000003o
ool0oooo01l0oooo000P0?ooo`030000003oool0oooo05X0oooo0P00001h0?ooo`030000003oool0
oooo06h0oooo00<000000?ooo`3oool0P`3oool00`000000oooo0?ooo`1G0?ooo`800000I@3oool0
0`000000oooo0?ooo`0O0?ooo`00803oool00`000000oooo0?ooo`1H0?ooo`800000N`3oool00`00
0000oooo0?ooo`1]0?ooo`030000003oool0oooo0840oooo0P00001L0?ooo`800000H`3oool00`00
0000oooo0?ooo`0O0?ooo`00803oool00`000000oooo0?ooo`1F0?ooo`800000OP3oool2000006d0
oooo00<000000?ooo`3oool0O`3oool200000600oooo0P00001Q0?ooo`030000003oool0oooo01l0
oooo000P0?ooo`030000003oool0oooo05@0oooo0P0000220?ooo`030000003oool0oooo06X0oooo
00<000000?ooo`3oool0OP3oool00`000000oooo0?ooo`1R0?ooo`800000G`3oool00`000000oooo
0?ooo`0O0?ooo`00803oool00`000000oooo0?ooo`1C0?ooo`030000003oool0oooo08<0oooo0P00
001Z0?ooo`030000003oool0oooo07`0oooo0P00001W0?ooo`800000G@3oool00`000000oooo0?oo
o`0O0?ooo`00803oool00`000000oooo0?ooo`1A0?ooo`800000R03oool00`000000oooo0?ooo`1W
0?ooo`030000003oool0oooo07X0oooo0P00001[0?ooo`800000F`3oool00`000000oooo0?ooo`0O
0?ooo`00803oool00`000000oooo0?ooo`1?0?ooo`800000R`3oool00`000000oooo0?ooo`1V0?oo
o`030000003oool0oooo07T0oooo00<000000?ooo`3oool0K@3oool2000005T0oooo00<000000?oo
o`3oool07`3oool00200oooo00<000000?ooo`3oool0C@3oool2000008h0oooo0P00001V0?ooo`03
0000003oool0oooo07L0oooo0P00001b0?ooo`800000E`3oool00`000000oooo0?ooo`0O0?ooo`00
803oool00`000000oooo0?ooo`1;0?ooo`800000TP3oool00`000000oooo0?ooo`1S0?ooo`030000
003oool0oooo07D0oooo0P00001f0?ooo`800000E@3oool00`000000oooo0?ooo`0O0?ooo`00803o
ool00`000000oooo0?ooo`1:0?ooo`030000003oool0oooo09<0oooo00<000000?ooo`3oool0HP3o
ool00`000000oooo0?ooo`1d0?ooo`030000003oool0oooo07P0oooo0P00001C0?ooo`030000003o
ool0oooo01l0oooo000P0?ooo`030000003oool0oooo04P0oooo0P00002G0?ooo`800000HP3oool0
0`000000oooo0?ooo`1b0?ooo`800000O@3oool200000540oooo00<000000?ooo`3oool07`3oool0
0200oooo00<000000?ooo`3oool0AP3oool2000009/0oooo00<000000?ooo`3oool0G`3oool00`00
0000oooo0?ooo`1`0?ooo`800000P@3oool2000004l0oooo00<000000?ooo`3oool07`3oool00200
oooo00<000000?ooo`3oool0A03oool2000009h0oooo0P00001O0?ooo`030000003oool0oooo06l0
oooo00<000000?ooo`3oool0P`3oool2000004d0oooo00<000000?ooo`3oool07`3oool00200oooo
00<000000?ooo`3oool0@P3oool200000:80oooo00<000000?ooo`3oool0G03oool00`000000oooo
0?ooo`1]0?ooo`800000R03oool2000004/0oooo00<000000?ooo`3oool07`3oool00200oooo00<0
00000?ooo`3oool0@03oool200000:D0oooo00<000000?ooo`3oool0F`3oool00`000000oooo0?oo
o`1/0?ooo`030000003oool0oooo08X0oooo0P0000190?ooo`030000003oool0oooo01l0oooo000P
0?ooo`030000003oool0oooo03l0oooo00<000000?ooo`3oool0YP3oool2000005/0oooo00<00000
0?ooo`3oool0JP3oool2000008l0oooo0P0000170?ooo`030000003oool0oooo01l0oooo000P0?oo
o`030000003oool0oooo03d0oooo0P00002[0?ooo`030000003oool0oooo05P0oooo00<000000?oo
o`3oool0J03oool2000009<0oooo0P0000150?ooo`030000003oool0oooo01l0oooo000P0?ooo`03
0000003oool0oooo03/0oooo0P00002^0?ooo`030000003oool0oooo05L0oooo00<000000?ooo`3o
ool0I`3oool00`000000oooo0?ooo`2E0?ooo`800000@`3oool00`000000oooo0?ooo`0O0?ooo`00
803oool00`000000oooo0?ooo`0i0?ooo`800000/@3oool2000005L0oooo00<000000?ooo`3oool0
I@3oool2000009X0oooo0P0000110?ooo`030000003oool0oooo01l0oooo000P0?ooo`030000003o
ool0oooo03L0oooo0P00002e0?ooo`030000003oool0oooo05@0oooo00<000000?ooo`3oool0H`3o
ool2000009h0oooo0P00000o0?ooo`030000003oool0oooo01l0oooo000P0?ooo`030000003oool0
oooo03D0oooo0P00002h0?ooo`030000003oool0oooo05<0oooo00<000000?ooo`3oool0HP3oool0
0`000000oooo0?ooo`2P0?ooo`800000?@3oool00`000000oooo0?ooo`0O0?ooo`00803oool00`00
0000oooo0?ooo`0d0?ooo`030000003oool0oooo0;T0oooo0P00001C0?ooo`030000003oool0oooo
0600oooo0P00002U0?ooo`800000>`3oool00`000000oooo0?ooo`0O0?ooo`00803oool00`000000
oooo0?ooo`0b0?ooo`800000_P3oool00`000000oooo0?ooo`1@0?ooo`030000003oool0oooo05h0
oooo0P00002Y0?ooo`800000>@3oool00`000000oooo0?ooo`0O0?ooo`00803oool00`000000oooo
0?ooo`0`0?ooo`800000`@3oool200000500oooo00<000000?ooo`3oool0G@3oool00`000000oooo
0?ooo`2[0?ooo`800000=`3oool00`000000oooo0?ooo`0O0?ooo`00803oool00`000000oooo0?oo
o`0^0?ooo`800000a@3oool00`000000oooo0?ooo`1=0?ooo`030000003oool0oooo05/0oooo0P00
002`0?ooo`800000=@3oool00`000000oooo0?ooo`0O0?ooo`00803oool00`000000oooo0?ooo`0/
0?ooo`800000b03oool00`000000oooo0?ooo`1<0?ooo`030000003oool0oooo05T0oooo0P00002d
0?ooo`800000<`3oool00`000000oooo0?ooo`0O0?ooo`00803oool00`000000oooo0?ooo`0Z0?oo
o`800000b`3oool2000004`0oooo00<000000?ooo`3oool0F03oool00`000000oooo0?ooo`2f0?oo
o`800000<@3oool00`000000oooo0?ooo`0O0?ooo`00803oool00`000000oooo0?ooo`0Y0?ooo`03
0000003oool0oooo0<d0oooo00<000000?ooo`3oool0B@3oool00`000000oooo0?ooo`1F0?ooo`80
0000^`3oool2000002l0oooo00<000000?ooo`3oool07`3oool00200oooo00<000000?ooo`3oool0
9`3oool200000=40oooo00<000000?ooo`3oool0B03oool00`000000oooo0?ooo`1E0?ooo`030000
003oool0oooo0;d0oooo0P00000]0?ooo`030000003oool0oooo01l0oooo000P0?ooo`030000003o
ool0oooo02D0oooo0P00003D0?ooo`800000B03oool00`000000oooo0?ooo`1C0?ooo`800000`P3o
ool2000002/0oooo00<000000?ooo`3oool07`3oool00200oooo00<000000?ooo`3oool08`3oool2
00000=P0oooo00<000000?ooo`3oool0A@3oool00`000000oooo0?ooo`1A0?ooo`800000aP3oool2
000002T0oooo00<000000?ooo`3oool07`3oool00200oooo00<000000?ooo`3oool08@3oool20000
0=/0oooo00<000000?ooo`3oool0A03oool00`000000oooo0?ooo`1@0?ooo`030000003oool0oooo
0<P0oooo0P00000W0?ooo`030000003oool0oooo01l0oooo000P0?ooo`030000003oool0oooo01l0
oooo0P00003N0?ooo`800000A03oool00`000000oooo0?ooo`1>0?ooo`800000c@3oool2000002D0
oooo00<000000?ooo`3oool07`3oool00200oooo00<000000?ooo`3oool07P3oool00`000000oooo
0?ooo`3P0?ooo`030000003oool0oooo0440oooo00<000000?ooo`3oool0C03oool200000=40oooo
0P00000S0?ooo`030000003oool0oooo01l0oooo000P0?ooo`030000003oool0oooo01`0oooo0P00
003T0?ooo`800000@03oool00`000000oooo0?ooo`1<0?ooo`030000003oool0oooo0=<0oooo0P00
000Q0?ooo`030000003oool0oooo01l0oooo000P0?ooo`030000003oool0oooo01X0oooo0P00003X
0?ooo`030000003oool0oooo03d0oooo00<000000?ooo`3oool0BP3oool200000=P0oooo0P00000O
0?ooo`030000003oool0oooo01l0oooo000P0?ooo`030000003oool0oooo01P0oooo0P00003[0?oo
o`030000003oool0oooo03`0oooo00<000000?ooo`3oool0B03oool200000=`0oooo0P00000M0?oo
o`030000003oool0oooo01l0oooo000P0?ooo`030000003oool0oooo01H0oooo0P00003^0?ooo`80
0000?03oool00`000000oooo0?ooo`170?ooo`030000003oool0oooo0=h0oooo0P00000K0?ooo`03
0000003oool0oooo01l0oooo000P0?ooo`030000003oool0oooo01@0oooo0P00003b0?ooo`030000
003oool0oooo03T0oooo00<000000?ooo`3oool0A@3oool200000><0oooo0P00000I0?ooo`030000
003oool0oooo01l0oooo000P0?ooo`030000003oool0oooo01<0oooo00<000000?ooo`3oool0l`3o
ool00`000000oooo0?ooo`0h0?ooo`030000003oool0oooo04<0oooo0P00003W0?ooo`8000005`3o
ool00`000000oooo0?ooo`0O0?ooo`00803oool00`000000oooo0?ooo`0A0?ooo`800000m`3oool2
000003P0oooo00<000000?ooo`3oool0@P3oool00`000000oooo0?ooo`3Y0?ooo`8000005@3oool0
0`000000oooo0?ooo`0O0?ooo`00803oool00`000000oooo0?ooo`0?0?ooo`800000n`3oool00`00
0000oooo0?ooo`0e0?ooo`030000003oool0oooo0400oooo0P00003^0?ooo`8000004`3oool00`00
0000oooo0?ooo`0O0?ooo`00803oool00`000000oooo0?ooo`0=0?ooo`800000oP3oool2000003D0
oooo00<000000?ooo`3oool0?P3oool200000?80oooo0P00000A0?ooo`030000003oool0oooo01l0
oooo000P0?ooo`030000003oool0oooo00/0oooo0P00003o0?ooo`<0oooo00<000000?ooo`3oool0
<P3oool00`000000oooo0?ooo`0m0?ooo`030000003oool0oooo0?@0oooo0P00000?0?ooo`030000
003oool0oooo01l0oooo000P0?ooo`030000003oool0oooo00T0oooo0P00003o0?ooo`H0oooo00<0
00000?ooo`3oool0<@3oool00`000000oooo0?ooo`0k0?ooo`800000n@3oool2000000d0oooo00<0
00000?ooo`3oool07`3oool001h0oooo1P0000070?ooo`030000003oool0oooo0?l0oooo1`3oool2
00000340oooo00<000000?ooo`3oool0>P3oool00`000000oooo0?ooo`3k0?ooo`800000203oool6
000001l0oooo000M0?ooo`P00000103oool200000?l0oooo303oool00`000000oooo0?ooo`0^0?oo
o`030000003oool0oooo03P0oooo0P00003o0?ooo`40oooo0P0000050?ooo`P000007P3oool001`0
oooo2P0000000`3oool000000000003o0?ooo`l0oooo00<000000?ooo`3oool0;@3oool00`000000
oooo0?ooo`0f0?ooo`800000o`3oool50?ooo`8000000P3oool:000001d0oooo000K0?ooo``00000
o`3ooolB0?ooo`800000;@3oool00`000000oooo0?ooo`0e0?ooo`030000003oool0oooo0?l0oooo
1`3oool=000001`0oooo000J0?ooo`d00000o`3ooolD0?ooo`030000003oool0oooo02X0oooo00<0
00000?ooo`3oool0<`3oool200000?l0oooo2P3oool=000001`0oooo000J0?ooo`h00000o`3ooolD
0?ooo`030000003oool0oooo02T0oooo00<000000?ooo`3oool0<@3oool200000?l0oooo303oool>
000001/0oooo000J0?ooo`h00000o`3ooolE0?ooo`800000:@3oool00`000000oooo0?ooo`0`0?oo
o`030000003oool0oooo0?l0oooo303oool>000001/0oooo000J0?ooo`h00000o`3ooolG0?ooo`03
0000003oool0oooo02H0oooo00<000000?ooo`3oool0;P3oool200000?l0oooo3`3oool>000001/0
oooo000J0?ooo`h00000o`3ooolH0?ooo`8000009P3oool00`000000oooo0?ooo`0/0?ooo`800000
o`3ooolA0?ooo`h000006`3oool001X0oooo3@00003o0?oooa/0oooo00<000000?ooo`3oool08`3o
ool00`000000oooo0?ooo`0[0?ooo`030000003oool0oooo0?l0oooo4@3oool=000001`0oooo000K
0?ooo`h00000o`3ooolJ0?ooo`030000003oool0oooo0280oooo00<000000?ooo`3oool0:@3oool2
00000?l0oooo4`3oool>000001`0oooo000L0?ooo`X000000`3oool200000?l0oooo6@3oool20000
0280oooo00<000000?ooo`3oool09`3oool200000?l0oooo4`3oool2000000<0oooo2P00000M0?oo
o`007@3oool8000000H0oooo0P00003o0?oooaT0oooo00<000000?ooo`3oool07`3oool00`000000
oooo0?ooo`0V0?ooo`030000003oool0oooo0?l0oooo4@3oool2000000H0oooo2000000N0?ooo`00
7P3oool6000000T0oooo0P00003o0?oooaP0oooo00<000000?ooo`3oool07P3oool00`000000oooo
0?ooo`0T0?ooo`800000o`3ooolB0?ooo`8000002@3oool6000001l0oooo000_0?ooo`800000o`3o
oolG0?ooo`8000007P3oool00`000000oooo0?ooo`0S0?ooo`030000003oool0oooo0?l0oooo403o
ool200000300oooo000a0?ooo`800000o`3ooolG0?ooo`030000003oool0oooo01/0oooo00<00000
0?ooo`3oool08@3oool200000?l0oooo4@3oool200000380oooo000c0?ooo`800000o`3ooolF0?oo
o`030000003oool0oooo01X0oooo00<000000?ooo`3oool07`3oool200000?l0oooo4@3oool20000
03@0oooo000e0?ooo`800000o`3ooolE0?ooo`8000006P3oool00`000000oooo0?ooo`0N0?ooo`03
0000003oool0oooo0?l0oooo3`3oool2000003H0oooo000g0?ooo`800000o`3ooolE0?ooo`030000
003oool0oooo01L0oooo00<000000?ooo`3oool0703oool200000?l0oooo403oool2000003P0oooo
000i0?ooo`800000o`3ooolD0?ooo`8000005`3oool00`000000oooo0?ooo`0J0?ooo`800000o`3o
ool@0?ooo`800000>P3oool003/0oooo0P00003o0?oooa@0oooo00<000000?ooo`3oool0503oool0
0`000000oooo0?ooo`0I0?ooo`030000003oool0oooo0?l0oooo3P3oool2000003`0oooo000m0?oo
o`800000o`3ooolC0?ooo`030000003oool0oooo01<0oooo00<000000?ooo`3oool05`3oool20000
0?l0oooo3`3oool2000003h0oooo000o0?ooo`800000o`3ooolB0?ooo`8000004`3oool00`000000
oooo0?ooo`0E0?ooo`800000o`3oool?0?ooo`800000@03oool00440oooo0P00003o0?oooa80oooo
00<000000?ooo`3oool0403oool00`000000oooo0?ooo`0D0?ooo`030000003oool0oooo0?l0oooo
3@3oool200000480oooo00130?ooo`800000o`3ooolA0?ooo`030000003oool0oooo00l0oooo00<0
00000?ooo`3oool04P3oool200000?l0oooo3P3oool2000004@0oooo00150?ooo`800000o`3oool@
0?ooo`8000003`3oool00`000000oooo0?ooo`0@0?ooo`800000o`3oool>0?ooo`800000AP3oool0
04L0oooo0P00003o0?oooa00oooo00<000000?ooo`3oool0303oool00`000000oooo0?ooo`0?0?oo
o`030000003oool0oooo0?l0oooo303oool2000004P0oooo00190?ooo`800000o`3oool?0?ooo`80
0000303oool00`000000oooo0?ooo`0=0?ooo`800000o`3oool=0?ooo`800000BP3oool004/0oooo
0P00003o0?ooo`l0oooo00<000000?ooo`3oool02@3oool00`000000oooo0?ooo`0;0?ooo`800000
o`3oool=0?ooo`800000C03oool004d0oooo0P00003o0?ooo`h0oooo00<000000?ooo`3oool0203o
ool00`000000oooo0?ooo`0:0?ooo`030000003oool0oooo0?l0oooo2`3oool2000004h0oooo001?
0?ooo`800000o`3oool=0?ooo`800000203oool00`000000oooo0?ooo`080?ooo`800000o`3oool<
0?ooo`800000D03oool00540oooo0P00003o0?ooo`d0oooo00<000000?ooo`3oool00P3oool60000
00L0oooo00<000000?ooo`3oool0o`3oool:0?ooo`800000DP3oool005<0oooo0P00003o0?ooo``0
oooo00<000000?ooo`3oool0200000040?ooo`800000o`3oool;0?ooo`800000E03oool005D0oooo
0P00003o0?ooo`/0oooo2`0000000`3oool000000000003o0?ooo`/0oooo0P00001F0?ooo`00E`3o
ool200000?l0oooo2@3oool<00000?l0oooo2`3oool2000005P0oooo001I0?ooo`800000o`3oool6
0?ooo`d00000o`3oool90?ooo`800000FP3oool005/0oooo0P00003o0?ooo`@0oooo3P00003o0?oo
o`H0oooo0P00001L0?ooo`00G@3oool200000?l0oooo0P3oool>00000?l0oooo103oool2000005h0
oooo001O0?ooo`800000o`3oool>00000?l0oooo0P3oool200000600oooo001Q0?ooo`800000o@3o
ool>00000?l0oooo0P00001R0?ooo`00H`3oool200000?/0oooo3@00003n0?ooo`800000I03oool0
06D0oooo0P00003j0?ooo``00000o03oool2000006H0oooo001W0?ooo`800000n@3oool:00000?/0
oooo0P00001X0?ooo`00J@3oool200000?P0oooo2000003j0?ooo`800000JP3oool006/0oooo0P00
003g0?ooo`H00000n@3oool2000006`0oooo001]0?ooo`800000n03oool00`000000oooo0?ooo`3g
0?ooo`800000KP3oool006l0oooo0P00003f0?ooo`030000003oool0oooo0?D0oooo0P00001`0?oo
o`00L@3oool200000?@0oooo00<000000?ooo`3oool0l`3oool200000780oooo001c0?ooo`800000
lP3oool00`000000oooo0?ooo`3a0?ooo`800000M03oool007D0oooo0P00003`0?ooo`030000003o
ool0oooo0>l0oooo0P00001f0?ooo`00M`3oool200000>h0oooo00<000000?ooo`3oool0k@3oool2
000007P0oooo001i0?ooo`800000k03oool00`000000oooo0?ooo`3[0?ooo`800000NP3oool007/0
oooo0P00003Z0?ooo`030000003oool0oooo0>T0oooo0P00001l0?ooo`00O@3oool200000>P0oooo
00<000000?ooo`3oool0i`3oool2000007h0oooo001o0?ooo`800000iP3oool00`000000oooo0?oo
o`3U0?ooo`800000P03oool00840oooo0P00003T0?ooo`030000003oool0oooo0><0oooo0P000022
0?ooo`00P`3oool200000>80oooo00<000000?ooo`3oool0h@3oool2000008@0oooo00250?ooo`80
0000h03oool00`000000oooo0?ooo`3O0?ooo`800000QP3oool008L0oooo0P00003N0?ooo`030000
003oool0oooo0=d0oooo0P0000280?ooo`00R@3oool200000=`0oooo00<000000?ooo`3oool0f`3o
ool2000008X0oooo002;0?ooo`800000fP3oool00`000000oooo0?ooo`3I0?ooo`800000S03oool0
08d0oooo0P00003H0?ooo`030000003oool0oooo0=L0oooo0P00002>0?ooo`00S`3oool200000=H0
oooo00<000000?ooo`3oool0e@3oool200000900oooo002A0?ooo`800000e03oool00`000000oooo
0?ooo`3C0?ooo`800000TP3oool009<0oooo0P00003B0?ooo`030000003oool0oooo0=40oooo0P00
002D0?ooo`00U@3oool200000=00oooo00<000000?ooo`3oool0c`3oool2000009H0oooo002G0?oo
o`800000cP3oool00`000000oooo0?ooo`3=0?ooo`800000V03oool009T0oooo0P00003<0?ooo`03
0000003oool0oooo0</0oooo0P00002J0?ooo`00V`3oool200000<X0oooo00<000000?ooo`3oool0
b@3oool2000009`0oooo002M0?ooo`800000b03oool00`000000oooo0?ooo`370?ooo`800000WP3o
ool009l0oooo0P0000360?ooo`030000003oool0oooo0<D0oooo0P00002P0?ooo`00X@3oool20000
0<@0oooo00<000000?ooo`3oool0``3oool200000:80oooo002S0?ooo`800000`P3oool00`000000
oooo0?ooo`310?ooo`800000Y03oool00:D0oooo0P0000300?ooo`030000003oool0oooo0;l0oooo
0P00002V0?ooo`00Y`3oool200000;h0oooo00<000000?ooo`3oool0_@3oool200000:P0oooo002Y
0?ooo`800000_03oool00`000000oooo0?ooo`2k0?ooo`800000ZP3oool00:/0oooo0P00002j0?oo
o`030000003oool0oooo0;T0oooo0P00002/0?ooo`00[@3oool200000;P0oooo00<000000?ooo`3o
ool0]`3oool200000:h0oooo002_0?ooo`800000]P3oool00`000000oooo0?ooo`2e0?ooo`800000
/03oool00;40oooo0P00002d0?ooo`030000003oool0oooo0;<0oooo0P00002b0?ooo`00/`3oool2
00000;80oooo00<000000?ooo`3oool0/@3oool200000;@0oooo002e0?ooo`800000/03oool00`00
0000oooo0?ooo`2_0?ooo`800000]P3oool00;L0oooo0P00002^0?ooo`030000003oool0oooo0:d0
oooo0P00002h0?ooo`00^@3oool200000:`0oooo00<000000?ooo`3oool0Z`3oool200000;X0oooo
002k0?ooo`800000ZP3oool00`000000oooo0?ooo`2Y0?ooo`800000_03oool00;d0oooo0P00002X
0?ooo`030000003oool0oooo0:L0oooo0P00002n0?ooo`00_`3oool200000:H0oooo00<000000?oo
o`3oool0Y@3oool200000<00oooo00310?ooo`800000Y03oool00`000000oooo0?ooo`2S0?ooo`80
0000`P3oool00<<0oooo0P00002R0?ooo`030000003oool0oooo0:40oooo0P0000340?ooo`00a@3o
ool200000:00oooo00<000000?ooo`3oool0W`3oool200000<H0oooo00370?ooo`800000WP3oool0
0`000000oooo0?ooo`2M0?ooo`800000b03oool00<T0oooo0P00002L0?ooo`030000003oool0oooo
09/0oooo0P00003:0?ooo`00b`3oool2000009X0oooo00<000000?ooo`3oool0V@3oool200000<`0
oooo003=0?ooo`800000V03oool00`000000oooo0?ooo`2G0?ooo`800000cP3oool00<l0oooo0P00
002F0?ooo`030000003oool0oooo09D0oooo0P00003@0?ooo`00d@3oool2000009@0oooo00<00000
0?ooo`3oool0T`3oool200000=80oooo003C0?ooo`800000TP3oool00`000000oooo0?ooo`2A0?oo
o`800000e03oool00=D0oooo0P00002@0?ooo`030000003oool0oooo08l0oooo0P00003F0?ooo`00
e`3oool2000008h0oooo00<000000?ooo`3oool0S@3oool200000=P0oooo003I0?ooo`800000S03o
ool00`000000oooo0?ooo`2;0?ooo`800000fP3oool00=/0oooo0P00002:0?ooo`030000003oool0
oooo08T0oooo0P00003L0?ooo`00g@3oool2000008P0oooo00<000000?ooo`3oool0Q`3oool20000
0=h0oooo003O0?ooo`800000QP3oool00`000000oooo0?ooo`250?ooo`800000h03oool00>40oooo
0P0000240?ooo`030000003oool0oooo08<0oooo0P00003R0?ooo`00h`3oool2000008<0oooo00<0
00000?ooo`3oool0P03oool200000>@0oooo003U0?ooo`800000P@3oool00`000000oooo0?ooo`1n
0?ooo`800000iP3oool00>L0oooo0P00001o0?ooo`030000003oool0oooo07`0oooo0P00003X0?oo
o`00j@3oool2000007d0oooo00<000000?ooo`3oool0NP3oool200000>X0oooo003[0?ooo`800000
N`3oool00`000000oooo0?ooo`1h0?ooo`800000k03oool00>d0oooo0P00001i0?ooo`030000003o
ool0oooo07H0oooo0P00003^0?ooo`00k`3oool2000007L0oooo00<000000?ooo`3oool0M03oool2
00000?00oooo003a0?ooo`800000M@3oool00`000000oooo0?ooo`1b0?ooo`800000lP3oool00?<0
oooo0P00001c0?ooo`030000003oool0oooo0700oooo0P00003d0?ooo`00m@3oool200000740oooo
00<000000?ooo`3oool0KP3oool200000?H0oooo003g0?ooo`800000K`3oool00`000000oooo0?oo
o`1/0?ooo`800000n03oool00?T0oooo0P00001]0?ooo`030000003oool0oooo06X0oooo0P00003j
0?ooo`00n`3oool2000006/0oooo00<000000?ooo`3oool0J03oool200000?`0oooo003m0?ooo`80
0000J@3oool00`000000oooo0?ooo`1V0?ooo`800000oP3oool00?l0oooo0P00001W0?ooo`030000
003oool0oooo06@0oooo0P00003o0?ooo`40oooo003o0?ooo`80oooo0P00001U0?ooo`030000003o
ool0oooo0680oooo0P00003o0?ooo`<0oooo003o0?ooo`@0oooo0P00001S0?ooo`030000003oool0
oooo0600oooo0P00003o0?ooo`D0oooo003o0?ooo`H0oooo0P00001Q0?ooo`030000003oool0oooo
05h0oooo0P00003o0?ooo`L0oooo003o0?ooo`P0oooo0P00001O0?ooo`030000003oool0oooo05`0
oooo0P00003o0?ooo`T0oooo003o0?ooo`X0oooo0P00001M0?ooo`030000003oool0oooo05X0oooo
0P00003o0?ooo`/0oooo003o0?ooo``0oooo0P00001K0?ooo`030000003oool0oooo05P0oooo0P00
003o0?ooo`d0oooo003o0?ooo`h0oooo0P00001I0?ooo`030000003oool0oooo05H0oooo0P00003o
0?ooo`l0oooo003o0?oooa00oooo0P00001G0?ooo`030000003oool0oooo05@0oooo0P00003o0?oo
oa40oooo003o0?oooa80oooo0P00001E0?ooo`030000003oool0oooo0580oooo0P00003o0?oooa<0
oooo003o0?oooa@0oooo0P00001C0?ooo`030000003oool0oooo0500oooo0P00003o0?oooaD0oooo
003o0?oooaH0oooo0P00001A0?ooo`030000003oool0oooo04h0oooo0P00003o0?oooaL0oooo003o
0?oooaP0oooo0P00001?0?ooo`030000003oool0oooo04`0oooo0P00003o0?oooaT0oooo003o0?oo
oaX0oooo0P00001=0?ooo`030000003oool0oooo04X0oooo0P00003o0?oooa/0oooo003o0?oooa`0
oooo0P00001;0?ooo`030000003oool0oooo04P0oooo0P00003o0?oooad0oooo003o0?oooah0oooo
0P0000190?ooo`030000003oool0oooo04H0oooo0P00003o0?oooal0oooo003o0?ooob00oooo0P00
00170?ooo`030000003oool0oooo04@0oooo0P00003o0?ooob40oooo003o0?ooob80oooo0P000015
0?ooo`030000003oool0oooo0480oooo0P00003o0?ooob<0oooo003o0?ooob@0oooo0P0000130?oo
o`030000003oool0oooo0400oooo0P00003o0?ooobD0oooo003o0?ooobH0oooo0P0000110?ooo`03
0000003oool0oooo03h0oooo0P00003o0?ooobL0oooo003o0?ooobP0oooo0P00000o0?ooo`030000
003oool0oooo03`0oooo0P00003o0?ooobT0oooo003o0?ooobX0oooo0P00000m0?ooo`030000003o
ool0oooo03X0oooo0P00003o0?ooob/0oooo003o0?ooob`0oooo0P00000k0?ooo`030000003oool0
oooo03P0oooo0P00003o0?ooobd0oooo003o0?ooobh0oooo0P00000i0?ooo`030000003oool0oooo
03H0oooo0P00003o0?ooobl0oooo003o0?oooc00oooo0P00000g0?ooo`030000003oool0oooo03@0
oooo0P00003o0?oooc40oooo003o0?oooc80oooo0P00000e0?ooo`030000003oool0oooo0380oooo
0P00003o0?oooc<0oooo003o0?oooc@0oooo0P00000c0?ooo`030000003oool0oooo0300oooo0P00
003o0?ooocD0oooo003o0?ooocH0oooo0P00000a0?ooo`030000003oool0oooo02h0oooo0P00003o
0?ooocL0oooo003o0?ooocP0oooo0P00000_0?ooo`030000003oool0oooo02`0oooo0P00003o0?oo
ocT0oooo003o0?ooocX0oooo0P00000]0?ooo`030000003oool0oooo02X0oooo0P00003o0?oooc/0
oooo003o0?oooc`0oooo0P00000[0?ooo`030000003oool0oooo02P0oooo0P00003o0?ooocd0oooo
003o0?oooch0oooo0P00000Y0?ooo`030000003oool0oooo02H0oooo0P00003o0?ooocl0oooo003o
0?oood00oooo0P00000W0?ooo`030000003oool0oooo02@0oooo0P00003o0?oood40oooo003o0?oo
od80oooo0P00000U0?ooo`030000003oool0oooo0280oooo0P00003o0?oood<0oooo003o0?oood@0
oooo0P00000S0?ooo`030000003oool0oooo0200oooo0P00003o0?ooodD0oooo003o0?ooodH0oooo
0P00000Q0?ooo`030000003oool0oooo01h0oooo0P00003o0?ooodL0oooo003o0?ooodP0oooo0P00
000O0?ooo`030000003oool0oooo01`0oooo0P00003o0?ooodT0oooo003o0?ooodX0oooo0P00000M
0?ooo`030000003oool0oooo01X0oooo0P00003o0?oood/0oooo003o0?oood`0oooo0P00000K0?oo
o`030000003oool0oooo01P0oooo0P00003o0?ooodd0oooo003o0?ooodh0oooo0P00000I0?ooo`03
0000003oool0oooo01H0oooo0P00003o0?ooodl0oooo003o0?oooe00oooo0P00000G0?ooo`030000
003oool0oooo01@0oooo0P00003o0?oooe40oooo003o0?oooe80oooo0P00000E0?ooo`030000003o
ool0oooo0180oooo0P00003o0?oooe<0oooo003o0?oooe@0oooo0P00000C0?ooo`030000003oool0
oooo0100oooo0P00003o0?oooeD0oooo003o0?oooeH0oooo0P00000A0?ooo`030000003oool0oooo
00h0oooo0P00003o0?oooeL0oooo003o0?oooeP0oooo0P00000?0?ooo`030000003oool0oooo00`0
oooo0P00003o0?oooeT0oooo003o0?oooeX0oooo0P00000:0?ooo`H000002P3oool200000?l0oooo
F`3oool00?l0ooooG03oool2000000L0oooo200000070?ooo`800000o`3ooomM0?ooo`00o`3ooomN
0?ooo`800000103oool:000000@0oooo0P00003o0?oooel0oooo003o0?ooof00oooo0P0000000`3o
ool000000000000:000000030?ooo`00000000000?l0ooooH@3oool00?l0ooooHP3oool>00000?l0
ooooH`3oool00?l0ooooHP3oool>00000?l0ooooH`3oool00?l0ooooHP3oool>00000?l0ooooH`3o
ool00?l0ooooHP3oool>00000?l0ooooH`3oool00?l0ooooHP3oool>00000?l0ooooH`3oool00?l0
ooooHP3oool=00000?l0ooooI03oool00?l0ooooH`3oool<00000?l0ooooI03oool00?l0ooooI03o
ool:00000?l0ooooI@3oool00?l0ooooI@3oool800000?l0ooooIP3oool00?l0ooooIP3oool60000
0?l0ooooI`3oool00?l0ooooo`3ooooC0?ooo`00o`3ooooo0?ooom<0oooo003o0?ooool0ooood`3o
ool00?l0ooooo`3ooooC0?ooo`00o`3ooooo0?ooom<0oooo003o0?ooool0ooood`3oool00?l0oooo
o`3ooooC0?ooo`00o`3ooooo0?ooom<0oooo003o0?ooool0ooood`3oool00?l0ooooo`3ooooC0?oo
o`00o`3ooooo0?ooom<0oooo003o0?ooool0ooood`3oool00?l0ooooo`3ooooC0?ooo`00o`3ooooo
0?ooom<0oooo003o0?ooool0ooood`3oool00?l0ooooo`3ooooC0?ooo`00o`3ooooo0?ooom<0oooo
003o0?ooool0ooood`3oool00?l0ooooo`3ooooC0?ooo`00o`3ooooo0?ooom<0oooo003o0?ooool0
ooood`3oool00?l0ooooo`3ooooC0?ooo`00o`3ooooo0?ooom<0oooo003o0?ooool0ooood`3oool0
0?l0ooooo`3ooooC0?ooo`00o`3ooooo0?ooom<0oooo0000\
\>"],
  ImageRangeCache->{{{0, 720}, {720, 0}} -> {-0.952637, -1.10001, 0.00264621, \
0.00305559}}],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: 1 
MathPictureStart
/Mabs {
Mgmatrix idtransform
Mtmatrix dtransform
} bind def
/Mabsadd { Mabs
3 -1 roll add
3 1 roll add
exch } bind def
%% Graphics3D
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
-0.0349639 1.12571 2.22045e-016 1.08654 [
[ 0 0 0 0 ]
[ 1 1 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
.25 Mabswid
[ ] 0 setdash
.0738 .23408 m
0 .70088 L
s
0 .70088 m
.41471 1 L
s
.41471 1 m
.42784 .57812 L
s
.42784 .57812 m
.0738 .23408 L
s
.66251 0 m
.94009 .4202 L
s
.94009 .4202 m
1 .86473 L
s
1 .86473 m
.6874 .48771 L
s
.6874 .48771 m
.66251 0 L
s
.0738 .23408 m
0 .70088 L
s
0 .70088 m
.6874 .48771 L
s
.6874 .48771 m
.66251 0 L
s
.66251 0 m
.0738 .23408 L
s
.42784 .57812 m
.94009 .4202 L
s
.94009 .4202 m
1 .86473 L
s
1 .86473 m
.41471 1 L
s
.41471 1 m
.42784 .57812 L
s
0 0 m
1 0 L
1 1 L
0 1 L
closepath
clip
newpath
.5 Mabswid
.6239 .46705 m
.66831 .66791 L
s
.6239 .46705 m
.78993 .33612 L
s
.6239 .46705 m
.36353 .47911 L
s
.02 w
.6239 .46705 Mdot
.5 Mabswid
.36353 .47911 m
.29071 .69296 L
s
.36353 .47911 m
.25961 .34386 L
s
.02 w
.36353 .47911 Mdot
.5 Mabswid
.66831 .66791 m
.68506 .79189 L
s
.29071 .69296 m
.66831 .66791 L
s
.88665 .55964 m
.66831 .66791 L
s
.02 w
.66831 .66791 Mdot
.5 Mabswid
.78993 .33612 m
.88665 .55964 L
s
.64977 .1705 m
.78993 .33612 L
s
.02 w
.78993 .33612 Mdot
.5 Mabswid
.29071 .69296 m
.68506 .79189 L
s
.29071 .69296 m
.18169 .54782 L
s
.29071 .69296 m
.30787 .73014 L
s
.29071 .69296 m
.19908 .60663 L
s
.29071 .69296 m
.1831 .47255 L
s
.46265 .83347 m
.29071 .69296 L
s
.02 w
.29071 .69296 Mdot
.5 Mabswid
.25961 .34386 m
.1831 .47255 L
s
.25961 .34386 m
.34677 .20465 L
s
.02 w
.25961 .34386 Mdot
.5 Mabswid
.82307 .70244 m
.68506 .79189 L
s
.46265 .83347 m
.68506 .79189 L
s
.70102 .76736 m
.68506 .79189 L
s
.88665 .55964 m
.68506 .79189 L
s
.02 w
.68506 .79189 Mdot
.5 Mabswid
.1831 .47255 m
.18169 .54782 L
s
.1831 .47255 m
.2636 .42723 L
s
.02 w
.1831 .47255 Mdot
.5 Mabswid
.46265 .83347 m
.30787 .73014 L
s
.70102 .76736 m
.46265 .83347 L
s
.02 w
.46265 .83347 Mdot
.5 Mabswid
.88665 .55964 m
.72704 .53396 L
s
.88665 .55964 m
.84582 .65836 L
s
.88665 .55964 m
.71944 .29424 L
s
.88665 .55964 m
.82307 .70244 L
s
.88665 .55964 m
.84312 .61831 L
s
.02 w
.88665 .55964 Mdot
.5 Mabswid
.82307 .70244 m
.84582 .65836 L
s
.70102 .76736 m
.82307 .70244 L
s
.02 w
.82307 .70244 Mdot
.5 Mabswid
.19908 .60663 m
.18169 .54782 L
s
.2636 .42723 m
.18169 .54782 L
s
.02 w
.18169 .54782 Mdot
.5 Mabswid
.64977 .1705 m
.71944 .29424 L
s
.34677 .20465 m
.64977 .1705 L
s
.02 w
.64977 .1705 Mdot
.5 Mabswid
.34677 .20465 m
.2636 .42723 L
s
.02 w
.34677 .20465 Mdot
.5 Mabswid
.19908 .60663 m
.30787 .73014 L
s
.2636 .42723 m
.19908 .60663 L
s
.02 w
.19908 .60663 Mdot
.5 Mabswid
.70102 .76736 m
.84582 .65836 L
s
.84312 .61831 m
.84582 .65836 L
s
.02 w
.84582 .65836 Mdot
.5 Mabswid
.46343 .62506 m
.30787 .73014 L
s
.2636 .42723 m
.30787 .73014 L
s
.70102 .76736 m
.30787 .73014 L
s
.02 w
.30787 .73014 Mdot
.5 Mabswid
.84312 .61831 m
.72704 .53396 L
s
.84312 .61831 m
.70102 .76736 L
s
.02 w
.84312 .61831 Mdot
.5 Mabswid
.70102 .76736 m
.72704 .53396 L
s
.70102 .76736 m
.46343 .62506 L
s
.02 w
.70102 .76736 Mdot
.5 Mabswid
.2636 .42723 m
.72704 .53396 L
s
.2636 .42723 m
.71944 .29424 L
s
.2636 .42723 m
.46343 .62506 L
s
.02 w
.2636 .42723 Mdot
.5 Mabswid
.71944 .29424 m
.72704 .53396 L
s
.02 w
.71944 .29424 Mdot
.5 Mabswid
.46343 .62506 m
.72704 .53396 L
s
.02 w
.72704 .53396 Mdot
.46343 .62506 Mdot
.25 Mabswid
.66251 0 m
.94009 .4202 L
s
.94009 .4202 m
1 .86473 L
s
1 .86473 m
.6874 .48771 L
s
.6874 .48771 m
.66251 0 L
s
.0738 .23408 m
0 .70088 L
s
0 .70088 m
.6874 .48771 L
s
.6874 .48771 m
.66251 0 L
s
.66251 0 m
.0738 .23408 L
s
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  ImageSize->{721, 721},
  ImageMargins->{{41, 0}, {0, 52}},
  ImageRegion->{{0, 1}, {0, 1}},
  ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`4000;A0002dB000`400?l00000o`00003oo`3ooooo
0?ooom<0oooo003o0?ooomd0oooo0P00003c0?ooo`00o`3ooooK0?ooo`80000000<0oooo00000000
0000lP3oool00?l0oooof03oool3000000<0oooo0P00003b0?ooo`00o`3ooooF0?ooo`8000001P3o
ool00`000000oooo0000003a0?ooo`00o`3ooooC0?ooo`<00000203oool010000000oooo0?ooo`00
003`0?ooo`00o`3ooooA0?ooo`8000002`3oool010000000oooo0?ooo`00003`0?ooo`00o`3oooo>
0?ooo`<000003@3oool01@000000oooo0?ooo`3oool000000>l0oooo003o0?oool`0oooo0P00000@
0?ooo`030000003oool0oooo0080oooo00<000000?ooo`3oool0k03oool00?l0oooob@3oool30000
0180oooo00<000000?ooo`3oool00P3oool00`000000oooo0?ooo`3/0?ooo`00o`3oooo70?ooo`80
00005@3oool00`000000oooo0?ooo`030?ooo`030000003oool0oooo0>/0oooo003o0?oool@0oooo
0`00000G0?ooo`030000003oool0oooo00@0oooo00<000000?ooo`3oool0jP3oool00?l0oooo`@3o
ool3000001/0oooo00<000000?ooo`3oool00`3oool00`000000oooo0?ooo`3Z0?ooo`00o`3ooono
0?ooo`8000007P3oool00`000000oooo0?ooo`040?ooo`030000003oool0oooo0>T0oooo003o0?oo
ok`0oooo0`00000P0?ooo`030000003oool0oooo00D0oooo00<000000?ooo`3oool0j03oool00?l0
oooo^P3oool2000002<0oooo00<000000?ooo`3oool01@3oool00`000000oooo0?ooo`3X0?ooo`00
o`3ooong0?ooo`<000009@3oool00`000000oooo0?ooo`060?ooo`030000003oool0oooo0>L0oooo
003o0?oookD0oooo0P00000X0?ooo`030000003oool0oooo00L0oooo00<000000?ooo`3oool0iP3o
ool00?l0oooo/P3oool3000002X0oooo00<000000?ooo`3oool01`3oool00`000000oooo0?ooo`3V
0?ooo`00o`3ooon`0?ooo`800000;@3oool00`000000oooo0?ooo`080?ooo`030000003oool0oooo
0>D0oooo003o0?ooojd0oooo0`00000_0?ooo`030000003oool0oooo00T0oooo00<000000?ooo`3o
ool0i03oool00?l0ooooZ`3oool200000380oooo00<000000?ooo`3oool02@3oool00`000000oooo
0?ooo`3T0?ooo`00o`3ooonX0?ooo`<00000=03oool00`000000oooo0?ooo`0:0?ooo`030000003o
ool0oooo0><0oooo003o0?ooojH0oooo0P00000g0?ooo`030000003oool0oooo00X0oooo00<00000
0?ooo`3oool0h`3oool00?l0ooooX`3oool3000003T0oooo00<000000?ooo`3oool02`3oool00`00
0000oooo0?ooo`3R0?ooo`00o`3ooonQ0?ooo`800000?03oool00`000000oooo0?ooo`0<0?ooo`03
0000003oool0oooo0>40oooo003o0?oooih0oooo0`00000n0?ooo`030000003oool0oooo00`0oooo
00<000000?ooo`3oool0h@3oool00?l0ooooW03oool200000440oooo00<000000?ooo`3oool03@3o
ool00`000000oooo0?ooo`3P0?ooo`00o`3ooonI0?ooo`<00000@`3oool00`000000oooo0?ooo`0>
0?ooo`030000003oool0oooo0=l0oooo003o0?oooiL0oooo0P0000160?ooo`030000003oool0oooo
00h0oooo00<000000?ooo`3oool0g`3oool00?l0ooooU03oool3000004P0oooo00<000000?ooo`3o
ool03`3oool00`000000oooo0?ooo`3N0?ooo`00o`3ooonB0?ooo`800000B`3oool00`000000oooo
0?ooo`0@0?ooo`030000003oool0oooo0=d0oooo003o0?ooohl0oooo0`00001>0?ooo`030000003o
ool0oooo00l0oooo00<000000?ooo`3oool0g@3oool00?l0ooooS03oool300000540oooo00<00000
0?ooo`3oool0403oool00`000000oooo0?ooo`3L0?ooo`00o`3ooon:0?ooo`800000E03oool00`00
0000oooo0?ooo`0A0?ooo`030000003oool0oooo0=/0oooo003o0?ooohL0oooo0`00001F0?ooo`03
0000003oool0oooo0140oooo00<000000?ooo`3oool0f`3oool00?l0ooooQ@3oool2000005T0oooo
00<000000?ooo`3oool04P3oool00`000000oooo0?ooo`3J0?ooo`00o`3ooon20?ooo`<00000F`3o
ool00`000000oooo0?ooo`0C0?ooo`030000003oool0oooo0=T0oooo003o0?oooh00oooo0P00001N
0?ooo`030000003oool0oooo01<0oooo00<000000?ooo`3oool0f@3oool00?l0ooooO@3oool30000
0600oooo00<000000?ooo`3oool0503oool00`000000oooo0?ooo`3H0?ooo`00o`3ooomk0?ooo`80
0000H`3oool00`000000oooo0?ooo`0E0?ooo`030000003oool0oooo0=L0oooo003o0?ooogP0oooo
0`00001U0?ooo`030000003oool0oooo01D0oooo00<000000?ooo`3oool0e`3oool00?l0ooooMP3o
ool2000006P0oooo00<000000?ooo`3oool05P3oool00`000000oooo0?ooo`3F0?ooo`00o`3ooomc
0?ooo`<00000JP3oool00`000000oooo0?ooo`0G0?ooo`030000003oool0oooo0=D0oooo003o0?oo
og40oooo0P00001]0?ooo`030000003oool0oooo01L0oooo00<000000?ooo`3oool0e@3oool00?l0
ooooKP3oool3000006l0oooo00<000000?ooo`3oool0603oool00`000000oooo0?ooo`3D0?ooo`00
o`3ooom/0?ooo`800000LP3oool00`000000oooo0?ooo`0I0?ooo`030000003oool0oooo0=<0oooo
003o0?ooofT0oooo0`00001d0?ooo`030000003oool0oooo01T0oooo00<000000?ooo`3oool0d`3o
ool00?l0ooooI`3oool2000007L0oooo00<000000?ooo`3oool06P3oool00`000000oooo0?ooo`3B
0?ooo`00o`3ooomT0?ooo`<00000N@3oool00`000000oooo0?ooo`0K0?ooo`030000003oool0oooo
0=40oooo003o0?ooof80oooo0P00001l0?ooo`030000003oool0oooo01/0oooo00<000000?ooo`3o
ool0d@3oool00?l0ooooG`3oool3000007h0oooo00<000000?ooo`3oool0703oool00`000000oooo
0?ooo`3@0?ooo`00o`3ooomM0?ooo`800000P@3oool00`000000oooo0?ooo`0M0?ooo`030000003o
ool0oooo0<l0oooo003o0?oooeX0oooo0`0000240?ooo`030000003oool0oooo01`0oooo00<00000
0?ooo`3oool0c`3oool00?l0ooooE`3oool3000008L0oooo00<000000?ooo`3oool07@3oool00`00
0000oooo0?ooo`3>0?ooo`00o`3ooomE0?ooo`800000RP3oool00`000000oooo0?ooo`0N0?ooo`03
0000003oool0oooo0<d0oooo003o0?oooe80oooo0`00002<0?ooo`030000003oool0oooo01h0oooo
00<000000?ooo`3oool0c@3oool00?l0ooooD03oool2000008l0oooo00<000000?ooo`3oool07`3o
ool00`000000oooo0?ooo`3<0?ooo`00o`3ooom=0?ooo`<00000T@3oool00`000000oooo0?ooo`0P
0?ooo`030000003oool0oooo0</0oooo003o0?oood/0oooo0P00002D0?ooo`030000003oool0oooo
0200oooo00<000000?ooo`3oool0b`3oool00?l0ooooB03oool3000009H0oooo00<000000?ooo`3o
ool08@3oool00`000000oooo0?ooo`3:0?ooo`00o`3ooom60?ooo`800000V@3oool00`000000oooo
0?ooo`0R0?ooo`030000003oool0oooo0<T0oooo003o0?oood<0oooo0`00002K0?ooo`030000003o
ool0oooo0280oooo00<000000?ooo`3oool0b@3oool00?l0oooo@@3oool2000009h0oooo00<00000
0?ooo`3oool08`3oool00`000000oooo0?ooo`380?ooo`00o`3oooln0?ooo`<00000X03oool00`00
0000oooo0?ooo`0T0?ooo`030000003oool0oooo0<L0oooo003o0?oooc`0oooo0P00002S0?ooo`03
0000003oool0oooo02@0oooo00<000000?ooo`3oool0a`3oool00?l0oooo>@3oool300000:D0oooo
00<000000?ooo`3oool09@3oool00`000000oooo0?ooo`360?ooo`00o`3ooolg0?ooo`800000Z03o
ool00`000000oooo0?ooo`0U0?ooo`030000003oool0oooo0<H0oooo003o0?oooc@0oooo0`00002Z
0?ooo`030000003oool0oooo02H0oooo00<000000?ooo`3oool0a@3oool00?l0oooo<P3oool20000
0:d0oooo00<000000?ooo`3oool09`3oool00`000000oooo0?ooo`340?ooo`00o`3oool_0?ooo`<0
0000[`3oool00`000000oooo0?ooo`0W0?ooo`030000003oool0oooo0<@0oooo003o0?ooobd0oooo
0P00002b0?ooo`030000003oool0oooo02P0oooo00<000000?ooo`3oool0``3oool00?l0oooo:P3o
ool300000;@0oooo00<000000?ooo`3oool0:@3oool00`000000oooo0?ooo`320?ooo`00o`3ooolX
0?ooo`800000]`3oool00`000000oooo0?ooo`0Y0?ooo`030000003oool0oooo0<80oooo003o0?oo
obD0oooo0`00002j0?ooo`030000003oool0oooo02T0oooo00<000000?ooo`3oool0`@3oool00?l0
oooo8P3oool300000;d0oooo00<000000?ooo`3oool0:P3oool00`000000oooo0?ooo`300?ooo`00
o`3ooolP0?ooo`800000`03oool00`000000oooo0?ooo`0Z0?ooo`030000003oool0oooo0<00oooo
003o0?oooad0oooo0`0000320?ooo`030000003oool0oooo02/0oooo00<000000?ooo`3oool0_`3o
ool00?l0oooo6`3oool200000<D0oooo00<000000?ooo`3oool0;03oool00`000000oooo0?ooo`2n
0?ooo`00o`3ooolH0?ooo`<00000a`3oool00`000000oooo0?ooo`0/0?ooo`030000003oool0oooo
0;h0oooo003o0?oooaH0oooo0P00003:0?ooo`030000003oool0oooo02d0oooo00<000000?ooo`3o
ool0_@3oool00?l0oooo4`3oool300000<`0oooo00<000000?ooo`3oool0;P3oool00`000000oooo
0?ooo`2l0?ooo`00o`3ooolA0?ooo`800000c`3oool00`000000oooo0?ooo`0^0?ooo`030000003o
ool0oooo0;`0oooo003o0?ooo`h0oooo0`00003A0?ooo`030000003oool0oooo02l0oooo00<00000
0?ooo`3oool0^`3oool00?l0oooo303oool200000=@0oooo00<000000?ooo`3oool0<03oool00`00
0000oooo0?ooo`2j0?ooo`00o`3oool90?ooo`<00000eP3oool00`000000oooo0?ooo`0`0?ooo`03
0000003oool0oooo0;X0oooo003o0?ooo`L0oooo0P00003I0?ooo`030000003oool0oooo0340oooo
00<000000?ooo`3oool0^@3oool00?l0oooo103oool300000=/0oooo00<000000?ooo`3oool0<P3o
ool00`000000oooo0?ooo`2h0?ooo`00o`3oool20?ooo`800000gP3oool00`000000oooo0?ooo`0b
0?ooo`030000003oool0oooo0;P0oooo003n0?ooo`<00000h03oool00`000000oooo0?ooo`0c0?oo
o`030000003oool0oooo0;L0oooo003l0?ooo`800000h`3oool00`000000oooo0?ooo`0d0?ooo`03
0000003oool0oooo0;H0oooo003i0?ooo`<00000i@3oool00`000000oooo0?ooo`0d0?ooo`030000
003oool0oooo0;H0oooo003g0?ooo`800000j03oool00`000000oooo0?ooo`0e0?ooo`030000003o
ool0oooo0;D0oooo003d0?ooo`<00000jP3oool00`000000oooo0?ooo`0f0?ooo`030000003oool0
oooo0;@0oooo003b0?ooo`800000kP3oool00`000000oooo0?ooo`0e0?ooo`030000003oool0oooo
0;@0oooo003_0?ooo`<00000l03oool00`000000oooo0?ooo`0f0?ooo`030000003oool0oooo0;<0
oooo003/0?ooo`<00000l`3oool00`000000oooo0?ooo`0g0?ooo`030000003oool0oooo0;80oooo
003Z0?ooo`800000mP3oool00`000000oooo0?ooo`0g0?ooo`030000003oool0oooo0;80oooo003W
0?ooo`<00000n03oool00`000000oooo0?ooo`0h0?ooo`030000003oool0oooo0;40oooo003U0?oo
o`800000n`3oool00`000000oooo0?ooo`0i0?ooo`030000003oool0oooo0;00oooo003R0?ooo`<0
0000o@3oool00`000000oooo0?ooo`0i0?ooo`030000003oool0oooo0;00oooo003P0?ooo`800000
o`3oool10?ooo`030000003oool0oooo03X0oooo00<000000?ooo`3oool0[`3oool00=d0oooo0`00
003o0?ooo`<0oooo00<000000?ooo`3oool0>`3oool00`000000oooo0?ooo`2^0?ooo`00f`3oool2
00000?l0oooo1P3oool00`000000oooo0?ooo`0k0?ooo`030000003oool0oooo0:h0oooo003H0?oo
o`<00000o`3oool80?ooo`030000003oool0oooo03`0oooo00<000000?ooo`3oool0[@3oool00=H0
oooo0P00003o0?ooo`/0oooo00<000000?ooo`3oool0?@3oool00`000000oooo0?ooo`2/0?ooo`00
d`3oool300000?l0oooo3@3oool00`000000oooo0?ooo`0m0?ooo`030000003oool0oooo0:`0oooo
003A0?ooo`800000o`3oool@0?ooo`030000003oool0oooo03h0oooo00<000000?ooo`3oool0Z`3o
ool00<h0oooo0`00003o0?oooa80oooo00<000000?ooo`3oool0?`3oool00`000000oooo0?ooo`2Z
0?ooo`00c03oool200000?l0oooo5@3oool00`000000oooo0?ooo`0o0?ooo`030000003oool0oooo
0:X0oooo00390?ooo`<00000o`3ooolG0?ooo`030000003oool0oooo0400oooo00<000000?ooo`3o
ool0Z@3oool00<L0oooo0P00003o0?oooaX0oooo00<000000?ooo`3oool0@03oool00`000000oooo
0?ooo`2Y0?ooo`00a03oool300000?l0oooo703oool00`000000oooo0?ooo`110?ooo`030000003o
ool0oooo0:P0oooo00320?ooo`800000o`3ooolO0?ooo`030000003oool0oooo0480oooo00<00000
0?ooo`3oool0Y`3oool00;l0oooo0`00003o0?ooob40oooo00<000000?ooo`3oool0@P3oool00`00
0000oooo0?ooo`2W0?ooo`00_@3oool200000?l0oooo9@3oool00`000000oooo0?ooo`120?ooo`03
0000003oool0oooo0:H0oooo002j0?ooo`<00000o`3ooolW0?ooo`030000003oool0oooo04<0oooo
00<000000?ooo`3oool0Y@3oool00;L0oooo0`00003o0?oooaP0oooo1P00000<0?ooo`030000003o
ool0oooo04<0oooo00<000000?ooo`3oool0Y@3oool00;D0oooo0P00003o0?oooaX0oooo2000000;
0?ooo`030000003oool0oooo04@0oooo00<000000?ooo`3oool0Y03oool00;80oooo0`00003o0?oo
oa/0oooo2P00000:0?ooo`030000003oool0oooo04D0oooo00<000000?ooo`3oool0X`3oool00;00
oooo0P00003o0?oooad0oooo300000090?ooo`030000003oool0oooo04D0oooo00<000000?ooo`3o
ool0X`3oool00:d0oooo0`00003o0?oooah0oooo3@0000090?ooo`030000003oool0oooo04H0oooo
00<000000?ooo`3oool0XP3oool00:/0oooo0P00003o0?ooob40oooo3P0000080?ooo`030000003o
ool0oooo04L0oooo00<000000?ooo`3oool0X@3oool00:P0oooo0`00003o0?ooob<0oooo3P000008
0?ooo`030000003oool0oooo04L0oooo00<000000?ooo`3oool0X@3oool00:H0oooo0P00003o0?oo
oal0oooo5@0000080?ooo`030000003oool0oooo04P0oooo00<000000?ooo`3oool0X03oool00:<0
oooo0`00003o0?oooaT0oooo200000070?ooo`h00000203oool00`000000oooo0?ooo`190?ooo`03
0000003oool0oooo09l0oooo002Q0?ooo`800000o`3ooolC0?ooo`T000003`3oool=000000T0oooo
00<000000?ooo`3oool0B@3oool00`000000oooo0?ooo`2O0?ooo`00WP3oool300000?l0oooo303o
ool9000001T0oooo300000090?ooo`030000003oool0oooo04X0oooo00<000000?ooo`3oool0WP3o
ool009`0oooo0P00003o0?ooo`L0oooo2000000S0?ooo`X000002P3oool00`000000oooo0?ooo`1;
0?ooo`030000003oool0oooo09d0oooo002I0?ooo`<00000o`3oool9000002`0oooo2@00000:0?oo
o`030000003oool0oooo04/0oooo00<000000?ooo`3oool0W@3oool009L0oooo0P00003i0?ooo`T0
0000=P3oool7000000030?ooo`000000oooo00P0oooo00<000000?ooo`3oool0C03oool00`000000
oooo0?ooo`2L0?ooo`00U03oool300000?80oooo2@0000150?ooo`040000003oool0oooo000000P0
oooo00<000000?ooo`3oool0C@3oool00`000000oooo0?ooo`2K0?ooo`00TP3oool200000>d0oooo
2000001?0?ooo`040000003oool0oooo000000L0oooo00<000000?ooo`3oool0C@3oool00`000000
oooo0?ooo`2K0?ooo`00S`3oool300000>H0oooo2@00001H0?ooo`030000003oool0000000L0oooo
00<000000?ooo`3oool0CP3oool00`000000oooo0?ooo`2J0?ooo`00S@3oool200000>00oooo2@00
001Q0?ooo`040000003oool0oooo000000H0oooo00<000000?ooo`3oool0C`3oool00`000000oooo
0?ooo`2I0?ooo`00RP3oool300000=X0oooo2000001[0?ooo`040000003oool0oooo000000D0oooo
00<000000?ooo`3oool0C`3oool00`000000oooo0?ooo`2I0?ooo`00R03oool200000=@0oooo2@00
001c0?ooo`050000003oool0oooo0?ooo`0000001@3oool00`000000oooo0?ooo`1?0?ooo`030000
003oool0oooo09P0oooo00250?ooo`<00000c@3oool9000007d0oooo00D000000?ooo`3oool0oooo
000000040?ooo`030000003oool0oooo0500oooo00<000000?ooo`3oool0U`3oool00880oooo0`00
00370?ooo`T00000QP3oool00`000000oooo0?ooo`020?ooo`050000003oool0oooo0?ooo`000000
DP3oool00`000000oooo0?ooo`2G0?ooo`00P03oool200000<80oooo2000002@0?ooo`050000003o
ool0oooo0?ooo`0000000`3oool00`000000oooo0?ooo`1A0?ooo`030000003oool0oooo09H0oooo
001m0?ooo`<00000^`3oool9000009T0oooo00D000000?ooo`3oool0oooo000000020?ooo`030000
003oool0oooo0580oooo00<000000?ooo`3oool0U@3oool007/0oooo0P00002e0?ooo`T00000XP3o
ool00`000000oooo0?ooo`020?ooo`030000003oool0000005@0oooo00<000000?ooo`3oool0U@3o
ool007P0oooo0`00001k0?ooo`H00000;@3oool900000:`0oooo00<000000?ooo`3oool00P3oool2
000005D0oooo00<000000?ooo`3oool0U03oool007H0oooo0P00001m0?ooo`P00000903oool80000
0;D0oooo00<000000?ooo`3oool00`3oool00`000000oooo0?ooo`1D0?ooo`030000003oool0oooo
09<0oooo001c0?ooo`<00000OP3oool:000001X0oooo2@00002n0?ooo`030000003oool0oooo0080
oooo0P00001E0?ooo`030000003oool0oooo09<0oooo001a0?ooo`800000P03oool<00000100oooo
2@0000370?ooo`030000003oool0oooo0080oooo00<000000?ooo`000000E@3oool00`000000oooo
0?ooo`2B0?ooo`00KP3oool300000840oooo3@0000080?ooo`P00000d@3oool01`000000oooo0?oo
o`3oool000000?ooo`000000EP3oool00`000000oooo0?ooo`2A0?ooo`00K03oool2000008@0oooo
5@00003I0?ooo`050000003oool0oooo0?ooo`0000000P3oool00`000000oooo0?ooo`1C0?ooo`03
0000003oool0oooo0940oooo001Y0?ooo`<00000QP3oool>00000>40oooo00@000000?ooo`3oool0
00000`3oool00`000000oooo0?ooo`1C0?ooo`030000003oool0oooo0900oooo001W0?ooo`800000
R@3oool>00000>80oooo00<000000?ooo`000000103oool00`000000oooo0?ooo`1C0?ooo`030000
003oool0oooo08l0oooo001T0?ooo`<00000R`3oool>00000>80oooo00<000000?ooo`0000001@3o
ool00`000000oooo0?ooo`1B0?ooo`030000003oool0oooo08l0oooo001R0?ooo`800000SP3oool=
00000>@0oooo0P0000060?ooo`030000003oool0oooo0580oooo00<000000?ooo`3oool0SP3oool0
05l0oooo0`00002A0?ooo``00000i03oool2000000H0oooo00<000000?ooo`3oool0DP3oool00`00
0000oooo0?ooo`2>0?ooo`00G@3oool2000009D0oooo2P00003V0?ooo`030000003oool0oooo00D0
oooo00<000000?ooo`3oool0DP3oool00`000000oooo0?ooo`2=0?ooo`00FP3oool3000009P0oooo
2000003W0?ooo`030000003oool0oooo00H0oooo00<000000?ooo`3oool0DP3oool00`000000oooo
0?ooo`2<0?ooo`00F03oool2000009/0oooo1`00003X0?ooo`800000203oool00`000000oooo0?oo
o`1A0?ooo`030000003oool0oooo08`0oooo001E0?ooo`<00000W03oool00`000000oooo0000003^
0?ooo`800000203oool00`000000oooo0?ooo`1A0?ooo`030000003oool0oooo08/0oooo001C0?oo
o`800000WP3oool010000000oooo0?ooo`00003^0?ooo`8000002@3oool00`000000oooo0?ooo`1A
0?ooo`030000003oool0oooo08X0oooo001@0?ooo`<00000X03oool00`000000oooo0000003_0?oo
o`030000003oool0000000P0oooo00<000000?ooo`3oool0D@3oool00`000000oooo0?ooo`2:0?oo
o`00C@3oool300000:80oooo00@000000?ooo`3oool00000k`3oool00`000000oooo000000090?oo
o`030000003oool0oooo0540oooo00<000000?ooo`3oool0R@3oool004/0oooo0P00002T0?ooo`04
0000003oool0oooo00000?00oooo00@000000?ooo`3oool000002@3oool00`000000oooo0?ooo`1A
0?ooo`030000003oool0oooo08P0oooo00180?ooo`<00000YP3oool010000000oooo0?ooo`00003`
0?ooo`040000003oool0oooo000000X0oooo00<000000?ooo`3oool0D03oool00`000000oooo0?oo
o`280?ooo`00AP3oool200000:P0oooo00D000000?ooo`3oool0oooo0000003`0?ooo`050000003o
ool0oooo0?ooo`0000002P3oool00`000000oooo0?ooo`1@0?ooo`030000003oool0oooo08L0oooo
00130?ooo`<00000ZP3oool010000000oooo0?ooo`00003a0?ooo`050000003oool0oooo0?ooo`00
00002`3oool00`000000oooo0?ooo`1@0?ooo`030000003oool0oooo08H0oooo00110?ooo`800000
[03oool01@000000oooo0?ooo`3oool000000?40oooo00<000000?ooo`3oool00P3oool00`000000
oooo0?ooo`090?ooo`030000003oool0oooo04l0oooo00<000000?ooo`3oool0QP3oool003h0oooo
0`00002]0?ooo`030000003oool0oooo0080oooo00<000000?ooo`3oool0k`3oool00`000000oooo
0?ooo`030?ooo`030000003oool0oooo00P0oooo00<000000?ooo`3oool0D03oool00`000000oooo
0?ooo`250?ooo`00?03oool200000;00oooo00D000000?ooo`3oool0oooo0000003b0?ooo`030000
003oool0oooo00<0oooo00<000000?ooo`3oool02@3oool00`000000oooo0?ooo`1@0?ooo`030000
003oool0oooo08@0oooo000i0?ooo`<00000/@3oool00`000000oooo0?ooo`020?ooo`030000003o
ool0oooo0?00oooo00<000000?ooo`3oool0103oool00`000000oooo0?ooo`090?ooo`030000003o
ool0oooo04l0oooo00<000000?ooo`3oool0Q03oool003L0oooo0P00002c0?ooo`030000003oool0
oooo0080oooo00<000000?ooo`3oool0l@3oool00`000000oooo0?ooo`040?ooo`030000003oool0
oooo00X0oooo00<000000?ooo`3oool0C`3oool00`000000oooo0?ooo`230?ooo`00=@3oool20000
0;D0oooo00<000000?ooo`3oool00P3oool00`000000oooo0?ooo`3a0?ooo`030000003oool0oooo
00D0oooo00<000000?ooo`3oool02P3oool00`000000oooo0?ooo`1?0?ooo`030000003oool0oooo
0880oooo000e0?ooo`800000]03oool00`000000oooo0?ooo`030?ooo`030000003oool0oooo0?40
oooo00<000000?ooo`3oool01@3oool00`000000oooo0?ooo`0;0?ooo`030000003oool0oooo04h0
oooo00<000000?ooo`3oool0PP3oool003D0oooo00<000000?ooo`000000/`3oool00`000000oooo
0?ooo`020?ooo`030000003oool0oooo0?80oooo00<000000?ooo`3oool01P3oool00`000000oooo
0?ooo`0:0?ooo`030000003oool0oooo04l0oooo00<000000?ooo`3oool0P@3oool003D0oooo00@0
00000?ooo`3oool00000/@3oool00`000000oooo0?ooo`030?ooo`030000003oool0oooo0?80oooo
00<000000?ooo`3oool01`3oool00`000000oooo0?ooo`0:0?ooo`030000003oool0oooo04l0oooo
00<000000?ooo`3oool0P03oool003@0oooo00<000000?ooo`3oool00P3oool00`000000oooo0?oo
o`2]0?ooo`030000003oool0oooo00@0oooo00<000000?ooo`3oool0lP3oool00`000000oooo0?oo
o`070?ooo`030000003oool0oooo00/0oooo00<000000?ooo`3oool0CP3oool00`000000oooo0?oo
o`200?ooo`00=03oool00`000000oooo0?ooo`030?ooo`030000003oool0oooo0:`0oooo00<00000
0?ooo`3oool00`3oool00`000000oooo0?ooo`3c0?ooo`030000003oool0oooo00P0oooo00<00000
0?ooo`3oool02`3oool00`000000oooo0?ooo`1>0?ooo`030000003oool0oooo07l0oooo000d0?oo
o`030000003oool0oooo00@0oooo00<000000?ooo`3oool0ZP3oool00`000000oooo0?ooo`040?oo
o`030000003oool0oooo0?<0oooo00<000000?ooo`3oool0203oool00`000000oooo0?ooo`0<0?oo
o`030000003oool0oooo04h0oooo00<000000?ooo`3oool0OP3oool003@0oooo00<000000?ooo`3o
ool01@3oool00`000000oooo0?ooo`2X0?ooo`030000003oool0oooo00@0oooo00<000000?ooo`3o
ool0m03oool00`000000oooo0?ooo`090?ooo`030000003oool0oooo00`0oooo00<000000?ooo`3o
ool0C@3oool00`000000oooo0?ooo`1n0?ooo`00=03oool00`000000oooo0?ooo`060?ooo`030000
003oool0oooo0:L0oooo00<000000?ooo`3oool0103oool00`000000oooo0?ooo`3e0?ooo`030000
003oool0oooo00P0oooo00<000000?ooo`3oool0303oool00`000000oooo0?ooo`1>0?ooo`030000
003oool0oooo07d0oooo000d0?ooo`030000003oool0oooo00L0oooo00<000000?ooo`3oool0Y@3o
ool00`000000oooo0?ooo`050?ooo`030000003oool0oooo0?D0oooo00<000000?ooo`3oool02@3o
ool00`000000oooo0?ooo`0<0?ooo`030000003oool0oooo04h0oooo00<000000?ooo`3oool0O03o
ool003<0oooo00<000000?ooo`3oool02@3oool00`000000oooo0?ooo`2S0?ooo`030000003oool0
oooo00D0oooo00<000000?ooo`3oool0mP3oool00`000000oooo0?ooo`090?ooo`030000003oool0
oooo00d0oooo00<000000?ooo`3oool0C@3oool00`000000oooo0?ooo`1l0?ooo`00<`3oool00`00
0000oooo0?ooo`0:0?ooo`030000003oool0oooo0:80oooo00<000000?ooo`3oool01@3oool00`00
0000oooo0?ooo`3f0?ooo`030000003oool0oooo00X0oooo00<000000?ooo`3oool03@3oool00`00
0000oooo0?ooo`1=0?ooo`030000003oool0oooo07/0oooo000c0?ooo`030000003oool0oooo00/0
oooo00<000000?ooo`3oool0X03oool00`000000oooo0?ooo`060?ooo`030000003oool0oooo0?H0
oooo00<000000?ooo`3oool02`3oool00`000000oooo0?ooo`0=0?ooo`030000003oool0oooo04d0
oooo00<000000?ooo`3oool0NP3oool003<0oooo00<000000?ooo`3oool0303oool00`000000oooo
0?ooo`2O0?ooo`030000003oool0oooo00D0oooo00<000000?ooo`3oool0m`3oool00`000000oooo
0?ooo`0;0?ooo`030000003oool0oooo00h0oooo00<000000?ooo`3oool0C03oool00`000000oooo
0?ooo`1j0?ooo`00<`3oool00`000000oooo0?ooo`0=0?ooo`030000003oool0oooo09d0oooo00<0
00000?ooo`3oool01P3oool00`000000oooo0?ooo`3g0?ooo`030000003oool0oooo00`0oooo00<0
00000?ooo`3oool03@3oool00`000000oooo0?ooo`1=0?ooo`030000003oool0oooo07T0oooo000c
0?ooo`030000003oool0oooo00h0oooo00<000000?ooo`3oool0V`3oool00`000000oooo0?ooo`06
0?ooo`030000003oool0oooo0?P0oooo00<000000?ooo`3oool0303oool00`000000oooo0?ooo`0>
0?ooo`030000003oool0oooo04d0oooo00<000000?ooo`3oool0N03oool00380oooo00<000000?oo
o`3oool0403oool00`000000oooo0?ooo`2J0?ooo`030000003oool0oooo00H0oooo00<000000?oo
o`3oool0n03oool00`000000oooo0?ooo`0=0?ooo`030000003oool0oooo00h0oooo00<000000?oo
o`3oool0C03oool00`000000oooo0?ooo`1h0?ooo`00<P3oool00`000000oooo0?ooo`0A0?ooo`03
0000003oool0oooo09P0oooo00<000000?ooo`3oool01`3oool00`000000oooo0?ooo`3h0?ooo`03
0000003oool0oooo00d0oooo00<000000?ooo`3oool03`3oool00`000000oooo0?ooo`1<0?ooo`03
0000003oool0oooo07L0oooo000b0?ooo`030000003oool0oooo0180oooo0P00002G0?ooo`030000
003oool0oooo00L0oooo00<000000?ooo`3oool0n@3oool00`000000oooo0?ooo`0>0?ooo`030000
003oool0oooo00l0oooo00<000000?ooo`3oool0C03oool00`000000oooo0?ooo`1f0?ooo`00<P3o
ool00`000000oooo0?ooo`0D0?ooo`030000003oool0oooo09@0oooo00<000000?ooo`3oool01`3o
ool00`000000oooo0?ooo`3i0?ooo`030000003oool0oooo00l0oooo00<000000?ooo`3oool03`3o
ool00`000000oooo0?ooo`1;0?ooo`030000003oool0oooo07H0oooo000b0?ooo`030000003oool0
oooo01D0oooo00<000000?ooo`3oool0TP3oool00`000000oooo0?ooo`080?ooo`030000003oool0
oooo0?T0oooo00<000000?ooo`3oool03`3oool00`000000oooo0?ooo`0@0?ooo`030000003oool0
oooo04/0oooo00<000000?ooo`3oool0M@3oool00380oooo00<000000?ooo`3oool05P3oool00`00
0000oooo0?ooo`2A0?ooo`030000003oool0oooo00L0oooo00<000000?ooo`3oool0nP3oool00`00
0000oooo0?ooo`0@0?ooo`030000003oool0oooo00l0oooo00<000000?ooo`3oool0C03oool00`00
0000oooo0?ooo`1d0?ooo`00<P3oool00`000000oooo0?ooo`0G0?ooo`030000003oool0oooo08l0
oooo00<000000?ooo`3oool0203oool00`000000oooo0?ooo`3j0?ooo`030000003oool0oooo0100
oooo00<000000?ooo`3oool0403oool00`000000oooo0?ooo`1;0?ooo`030000003oool0oooo07@0
oooo000a0?ooo`030000003oool0oooo01T0oooo00<000000?ooo`3oool0S@3oool00`000000oooo
0?ooo`080?ooo`030000003oool0oooo0?/0oooo00<000000?ooo`3oool04@3oool00`000000oooo
0?ooo`0@0?ooo`030000003oool0oooo04/0oooo00<000000?ooo`3oool0L`3oool00340oooo00<0
00000?ooo`3oool06P3oool00`000000oooo0?ooo`2<0?ooo`030000003oool0oooo00P0oooo00<0
00000?ooo`3oool0n`3oool00`000000oooo0?ooo`0A0?ooo`030000003oool0oooo0140oooo00<0
00000?ooo`3oool0B`3oool00`000000oooo0?ooo`1b0?ooo`00<@3oool00`000000oooo0?ooo`0K
0?ooo`030000003oool0oooo08X0oooo00<000000?ooo`3oool02@3oool00`000000oooo0?ooo`3k
0?ooo`030000003oool0oooo0180oooo00<000000?ooo`3oool04@3oool00`000000oooo0?ooo`1:
0?ooo`030000003oool0oooo0780oooo000a0?ooo`030000003oool0oooo01`0oooo00<000000?oo
o`3oool0R03oool00`000000oooo0?ooo`090?ooo`030000003oool0oooo0?`0oooo00<000000?oo
o`3oool04P3oool00`000000oooo0?ooo`0B0?ooo`030000003oool0oooo04X0oooo00<000000?oo
o`3oool0L@3oool00340oooo00<000000?ooo`3oool07@3oool00`000000oooo0?ooo`270?ooo`03
0000003oool0oooo00T0oooo00<000000?ooo`3oool0o03oool00`000000oooo0?ooo`0C0?ooo`03
0000003oool0oooo0140oooo00<000000?ooo`3oool0BP3oool00`000000oooo0?ooo`1a0?ooo`00
<@3oool00`000000oooo0?ooo`0N0?ooo`030000003oool0oooo08D0oooo00<000000?ooo`3oool0
2P3oool00`000000oooo0?ooo`3l0?ooo`030000003oool0oooo01@0oooo00<000000?ooo`3oool0
4@3oool00`000000oooo0?ooo`1:0?ooo`030000003oool0oooo0700oooo000`0?ooo`030000003o
ool0oooo0200oooo00<000000?ooo`3oool0P`3oool00`000000oooo0?ooo`0:0?ooo`030000003o
ool0oooo0?h0oooo00<000000?ooo`3oool04`3oool00`000000oooo0?ooo`0B0?ooo`030000003o
ool0oooo04X0oooo00<000000?ooo`3oool0K`3oool00300oooo00<000000?ooo`3oool08@3oool0
0`000000oooo0?ooo`220?ooo`030000003oool0oooo00X0oooo00<000000?ooo`3oool0oP3oool0
0`000000oooo0?ooo`0D0?ooo`030000003oool0oooo0180oooo00<000000?ooo`3oool0B@3oool0
0`000000oooo0?ooo`1_0?ooo`00<03oool00`000000oooo0?ooo`0R0?ooo`030000003oool0oooo
0800oooo00<000000?ooo`3oool02P3oool00`000000oooo0?ooo`3o0?ooo`030000003oool0oooo
01@0oooo00<000000?ooo`3oool04`3oool00`000000oooo0?ooo`190?ooo`030000003oool0oooo
06h0oooo000`0?ooo`030000003oool0oooo02<0oooo00<000000?ooo`3oool0O`3oool00`000000
oooo0?ooo`0:0?ooo`030000003oool0oooo0?l0oooo00<000000?ooo`3oool05@3oool00`000000
oooo0?ooo`0C0?ooo`030000003oool0oooo04T0oooo00<000000?ooo`3oool0K@3oool00300oooo
00<000000?ooo`3oool0903oool00`000000oooo0?ooo`1m0?ooo`030000003oool0oooo00/0oooo
00<000000?ooo`3oool0o`3oool00`000000oooo0?ooo`0E0?ooo`030000003oool0oooo01<0oooo
00<000000?ooo`3oool0B@3oool00`000000oooo0?ooo`1]0?ooo`00<03oool00`000000oooo0?oo
o`0U0?ooo`030000003oool0oooo07/0oooo00<000000?ooo`3oool02`3oool00`000000oooo0?oo
o`3o0?ooo`40oooo00<000000?ooo`3oool05P3oool00`000000oooo0?ooo`0C0?ooo`030000003o
ool0oooo04T0oooo00<000000?ooo`3oool0K03oool002l0oooo00<000000?ooo`3oool09`3oool0
0`000000oooo0?ooo`1j0?ooo`030000003oool0oooo00/0oooo00<000000?ooo`3oool0o`3oool1
0?ooo`030000003oool0oooo01L0oooo00<000000?ooo`3oool04`3oool00`000000oooo0?ooo`19
0?ooo`030000003oool0oooo06/0oooo000_0?ooo`030000003oool0oooo02P0oooo00<000000?oo
o`3oool0N03oool00`000000oooo0?ooo`0<0?ooo`030000003oool0oooo0?l0oooo0@3oool00`00
0000oooo0?ooo`0G0?ooo`030000003oool0oooo01@0oooo00<000000?ooo`3oool0B03oool00`00
0000oooo0?ooo`1[0?ooo`00;`3oool00`000000oooo0?ooo`0Y0?ooo`030000003oool0oooo07H0
oooo00<000000?ooo`3oool0303oool00`000000oooo0?ooo`3o0?ooo`80oooo00<000000?ooo`3o
ool0603oool700000100oooo00<000000?ooo`3oool0B03oool00`000000oooo0?ooo`1Z0?ooo`00
;`3oool00`000000oooo0?ooo`0Z0?ooo`030000003oool0oooo07D0oooo00<000000?ooo`3oool0
303oool00`000000oooo0?ooo`3o0?ooo`80oooo00<000000?ooo`3oool0603oool800000100oooo
00<000000?ooo`3oool0B03oool00`000000oooo0?ooo`1Y0?ooo`00;`3oool00`000000oooo0?oo
o`0[0?ooo`030000003oool0oooo07<0oooo00<000000?ooo`3oool0303oool00`000000oooo0?oo
o`3o0?ooo`<0oooo00<000000?ooo`3oool05`3oool:00000100oooo00<000000?ooo`3oool0A`3o
ool00`000000oooo0?ooo`1Y0?ooo`00;`3oool00`000000oooo0?ooo`0/0?ooo`030000003oool0
oooo0780oooo00<000000?ooo`3oool0303oool00`000000oooo0?ooo`3o0?ooo`<0oooo00<00000
0?ooo`3oool05P3oool<000000l0oooo00<000000?ooo`3oool0B03oool00`000000oooo0?ooo`1X
0?ooo`00;`3oool00`000000oooo0?ooo`0]0?ooo`030000003oool0oooo0700oooo00<000000?oo
o`3oool03@3oool00`000000oooo0?ooo`3o0?ooo`<0oooo00<000000?ooo`3oool05@3oool=0000
0100oooo00<000000?ooo`3oool0B03oool00`000000oooo0?ooo`1W0?ooo`00;P3oool00`000000
oooo0?ooo`0_0?ooo`030000003oool0oooo06h0oooo00<000000?ooo`3oool03@3oool00`000000
oooo0?ooo`3o0?ooo`@0oooo00<000000?ooo`3oool05@3oool>00000100oooo00<000000?ooo`3o
ool0A`3oool00`000000oooo0?ooo`1W0?ooo`00;P3oool00`000000oooo0?ooo`0`0?ooo`030000
003oool0oooo06d0oooo00<000000?ooo`3oool03@3oool00`000000oooo0?ooo`3o0?ooo`@0oooo
00<000000?ooo`3oool05@3oool>00000140oooo00<000000?ooo`3oool0A`3oool00`000000oooo
0?ooo`1V0?ooo`00;P3oool00`000000oooo0?ooo`0a0?ooo`030000003oool0oooo06/0oooo00<0
00000?ooo`3oool03P3oool00`000000oooo0?ooo`3o0?ooo`@0oooo00<000000?ooo`3oool05@3o
ool>00000180oooo00<000000?ooo`3oool0A`3oool00`000000oooo0?ooo`1U0?ooo`00;P3oool0
0`000000oooo0?ooo`0b0?ooo`030000003oool0oooo06T0oooo00<000000?ooo`3oool03P3oool0
0`000000oooo0?ooo`3o0?ooo`D0oooo00<000000?ooo`3oool04`3oool@000001<0oooo00<00000
0?ooo`3oool0AP3oool00`000000oooo0?ooo`1U0?ooo`00;P3oool00`000000oooo0?ooo`0c0?oo
o`030000003oool0oooo06P0oooo00<000000?ooo`3oool03P3oool00`000000oooo0?ooo`3o0?oo
o`D0oooo00<000000?ooo`3oool0403oool300000080oooo3@00000D0?ooo`030000003oool0oooo
04L0oooo00<000000?ooo`3oool0I03oool002h0oooo00<000000?ooo`3oool0=03oool00`000000
oooo0?ooo`1V0?ooo`030000003oool0oooo00h0oooo00<000000?ooo`3oool0o`3oool60?ooo`03
0000003oool0oooo00`0oooo100000060?ooo``000005@3oool00`000000oooo0?ooo`170?ooo`03
0000003oool0oooo06<0oooo000]0?ooo`030000003oool0oooo03H0oooo00<000000?ooo`3oool0
I@3oool00`000000oooo0?ooo`0>0?ooo`030000003oool0oooo0?l0oooo1P3oool00`000000oooo
0?ooo`090?ooo`<000002`3oool:000001L0oooo00<000000?ooo`3oool0AP3oool00`000000oooo
0?ooo`1S0?ooo`00;@3oool00`000000oooo0?ooo`0g0?ooo`030000003oool0oooo06<0oooo00<0
00000?ooo`3oool03`3oool00`000000oooo0?ooo`3o0?ooo`L0oooo00<000000?ooo`3oool0103o
ool4000000l0oooo2000000I0?ooo`030000003oool0oooo04H0oooo00<000000?ooo`3oool0HP3o
ool002d0oooo00<000000?ooo`3oool0>03oool00`000000oooo0?ooo`1Q0?ooo`030000003oool0
oooo00l0oooo00<000000?ooo`3oool0o`3oool80?ooo`040000003oool0oooo0?ooo`<00000503o
ool7000001X0oooo00<000000?ooo`3oool0AP3oool00`000000oooo0?ooo`1Q0?ooo`00;@3oool0
0`000000oooo0?ooo`0i0?ooo`030000003oool0oooo0600oooo00<000000?ooo`3oool03`3oool0
0`000000oooo0?ooo`3o0?ooo`P0oooo1000000I0?ooo`030000003oool0oooo0080oooo00<00000
0?ooo`3oool0603oool00`000000oooo0?ooo`150?ooo`030000003oool0oooo0640oooo000]0?oo
o`030000003oool0oooo03X0oooo00<000000?ooo`3oool0GP3oool00`000000oooo0?ooo`0@0?oo
o`030000003oool0oooo0?l0oooo1@3oool4000001`0oooo00<000000?ooo`3oool00`3oool00`00
0000oooo0?ooo`0G0?ooo`030000003oool0oooo04H0oooo00<000000?ooo`3oool0H03oool002d0
oooo00<000000?ooo`3oool0>`3oool2000005d0oooo00<000000?ooo`3oool0403oool00`000000
oooo0?ooo`3o0?ooo`<0oooo0`0000030?ooo`030000003oool0oooo01X0oooo00<000000?ooo`3o
ool00`3oool00`000000oooo0?ooo`0H0?ooo`030000003oool0oooo04H0oooo00<000000?ooo`3o
ool0G`3oool002`0oooo00<000000?ooo`3oool0?P3oool00`000000oooo0?ooo`1J0?ooo`030000
003oool0oooo0100oooo00<000000?ooo`3oool0oP3oool4000000H0oooo00<000000?ooo`3oool0
6P3oool00`000000oooo0?ooo`040?ooo`030000003oool0oooo01P0oooo00<000000?ooo`3oool0
A@3oool00`000000oooo0?ooo`1O0?ooo`00;03oool00`000000oooo0?ooo`0o0?ooo`030000003o
ool0oooo05P0oooo00<000000?ooo`3oool0403oool00`000000oooo0?ooo`3l0?ooo`<000002P3o
ool00`000000oooo0?ooo`0J0?ooo`030000003oool0oooo00D0oooo00<000000?ooo`3oool0603o
ool00`000000oooo0?ooo`150?ooo`030000003oool0oooo05h0oooo000/0?ooo`030000003oool0
oooo0400oooo00<000000?ooo`3oool0EP3oool00`000000oooo0?ooo`0A0?ooo`030000003oool0
oooo0?P0oooo1000000=0?ooo`030000003oool0oooo01X0oooo00<000000?ooo`3oool01@3oool0
0`000000oooo0?ooo`0I0?ooo`030000003oool0oooo04D0oooo00<000000?ooo`3oool0G@3oool0
02`0oooo00<000000?ooo`3oool0@@3oool00`000000oooo0?ooo`1E0?ooo`030000003oool0oooo
0140oooo00<000000?ooo`3oool0m@3oool300000140oooo00<000000?ooo`3oool06P3oool00`00
0000oooo0?ooo`060?ooo`030000003oool0oooo01T0oooo00<000000?ooo`3oool0A03oool00`00
0000oooo0?ooo`1M0?ooo`00;03oool00`000000oooo0?ooo`120?ooo`030000003oool0oooo05<0
oooo00<000000?ooo`3oool04@3oool00`000000oooo0?ooo`3c0?ooo`<00000503oool00`000000
oooo0?ooo`0K0?ooo`030000003oool0oooo00H0oooo00<000000?ooo`3oool06@3oool00`000000
oooo0?ooo`140?ooo`030000003oool0oooo05`0oooo000/0?ooo`030000003oool0oooo04<0oooo
00<000000?ooo`3oool0DP3oool00`000000oooo0?ooo`0A0?ooo`030000003oool0oooo0>l0oooo
1000000G0?ooo`030000003oool0oooo01/0oooo00<000000?ooo`3oool01P3oool00`000000oooo
0?ooo`0I0?ooo`030000003oool0oooo04D0oooo00<000000?ooo`3oool0F`3oool002`0oooo00<0
00000?ooo`3oool0A03oool00`000000oooo0?ooo`1@0?ooo`030000003oool0oooo0180oooo00<0
00000?ooo`3oool0k03oool3000001/0oooo00<000000?ooo`3oool06`3oool00`000000oooo0?oo
o`070?ooo`030000003oool0oooo01T0oooo00<000000?ooo`3oool0A03oool00`000000oooo0?oo
o`1K0?ooo`00:`3oool00`000000oooo0?ooo`160?ooo`030000003oool0oooo04h0oooo00<00000
0?ooo`3oool04P3oool00`000000oooo0?ooo`3Y0?ooo`@000007P3oool00`000000oooo0?ooo`0K
0?ooo`030000003oool0oooo00L0oooo00<000000?ooo`3oool06P3oool00`000000oooo0?ooo`14
0?ooo`030000003oool0oooo05X0oooo000[0?ooo`030000003oool0oooo04L0oooo00<000000?oo
o`3oool0C@3oool00`000000oooo0?ooo`0B0?ooo`030000003oool0oooo0>H0oooo0`00000R0?oo
o`030000003oool0oooo01/0oooo00<000000?ooo`3oool0203oool00`000000oooo0?ooo`0J0?oo
o`030000003oool0oooo04@0oooo00<000000?ooo`3oool0F@3oool002/0oooo00<000000?ooo`3o
ool0B03oool00`000000oooo0?ooo`1;0?ooo`030000003oool0oooo0180oooo00<000000?ooo`3o
ool0h`3oool4000002D0oooo00<000000?ooo`3oool06`3oool00`000000oooo0?ooo`090?ooo`03
0000003oool0oooo01X0oooo00<000000?ooo`3oool0@`3oool00`000000oooo0?ooo`1I0?ooo`00
:`3oool00`000000oooo0?ooo`190?ooo`030000003oool0oooo04T0oooo00<000000?ooo`3oool0
4`3oool00`000000oooo0?ooo`3P0?ooo`<00000:@3oool00`000000oooo0?ooo`0K0?ooo`030000
003oool0oooo00T0oooo00<000000?ooo`3oool06`3oool00`000000oooo0?ooo`130?ooo`030000
003oool0oooo05P0oooo000[0?ooo`030000003oool0oooo04X0oooo00<000000?ooo`3oool0B03o
ool00`000000oooo0?ooo`0C0?ooo`030000003oool0oooo0=d0oooo0`00000/0?ooo`030000003o
ool0oooo01/0oooo00<000000?ooo`3oool02P3oool00`000000oooo0?ooo`0J0?ooo`030000003o
ool0oooo04@0oooo00<000000?ooo`3oool0E`3oool002/0oooo00<000000?ooo`3oool0B`3oool0
0`000000oooo0?ooo`160?ooo`030000003oool0oooo01<0oooo00<000000?ooo`3oool0fP3oool4
000002l0oooo00<000000?ooo`3oool06`3oool00`000000oooo0?ooo`0;0?ooo`030000003oool0
oooo01X0oooo00<000000?ooo`3oool0@`3oool00`000000oooo0?ooo`1G0?ooo`00:P3oool00`00
0000oooo0?ooo`1=0?ooo`030000003oool0oooo04D0oooo00<000000?ooo`3oool04`3oool00`00
0000oooo0?ooo`3G0?ooo`<00000<`3oool00`000000oooo0?ooo`0K0?ooo`030000003oool0oooo
00/0oooo00<000000?ooo`3oool06`3oool010000000oooo0?ooo`3oool6000003`0oooo00<00000
0?ooo`3oool0EP3oool002X0oooo00<000000?ooo`3oool0CP3oool00`000000oooo0?ooo`130?oo
o`030000003oool0oooo01@0oooo00<000000?ooo`3oool0d`3oool4000003H0oooo00<000000?oo
o`3oool06`3oool00`000000oooo0?ooo`0<0?ooo`030000003oool0oooo01/0oooo00<000000?oo
o`0000001`00000l0?ooo`030000003oool0oooo05D0oooo000Z0?ooo`030000003oool0oooo04l0
oooo00<000000?ooo`3oool0@@3oool00`000000oooo0?ooo`0D0?ooo`030000003oool0oooo0=40
oooo0`00000j0?ooo`030000003oool0oooo01/0oooo00<000000?ooo`3oool0303oool00`000000
oooo0?ooo`0L0?ooo`X00000>`3oool00`000000oooo0?ooo`1E0?ooo`00:P3oool00`000000oooo
0?ooo`1@0?ooo`030000003oool0oooo0400oooo00<000000?ooo`3oool0503oool00`000000oooo
0?ooo`3>0?ooo`<00000?P3oool00`000000oooo0?ooo`0J0?ooo`030000003oool0oooo00d0oooo
00<000000?ooo`3oool06P3oool<000003/0oooo00<000000?ooo`3oool0E03oool002X0oooo00<0
00000?ooo`3oool0D@3oool00`000000oooo0?ooo`0n0?ooo`030000003oool0oooo01@0oooo00<0
00000?ooo`3oool0b`3oool400000440oooo00<000000?ooo`3oool06P3oool00`000000oooo0?oo
o`0>0?ooo`030000003oool0oooo01P0oooo3@00000k0?ooo`030000003oool0oooo05@0oooo000Z
0?ooo`030000003oool0oooo0580oooo00<000000?ooo`3oool0?03oool00`000000oooo0?ooo`0E
0?ooo`030000003oool0oooo0<P0oooo0`0000150?ooo`030000003oool0oooo01X0oooo00<00000
0?ooo`3oool03P3oool00`000000oooo0?ooo`0H0?ooo`h00000>`3oool00`000000oooo0?ooo`1C
0?ooo`00:@3oool00`000000oooo0?ooo`1D0?ooo`030000003oool0oooo03D0oooo1`00000G0?oo
o`030000003oool0oooo0<@0oooo100000180?ooo`030000003oool0oooo01X0oooo00<000000?oo
o`3oool03`3oool00`000000oooo0?ooo`0G0?ooo`h00000?03oool00`000000oooo0?ooo`1B0?oo
o`00:@3oool00`000000oooo0?ooo`1E0?ooo`030000003oool0oooo03<0oooo2000000F0?ooo`03
0000003oool0oooo0<80oooo0`00001<0?ooo`030000003oool0oooo01X0oooo00<000000?ooo`3o
ool0403oool00`000000oooo0?ooo`0F0?ooo`h00000?03oool00`000000oooo0?ooo`1B0?ooo`00
:@3oool00`000000oooo0?ooo`1F0?ooo`030000003oool0oooo0340oooo2P00000E0?ooo`030000
003oool0oooo0;h0oooo1000001?0?ooo`030000003oool0oooo01X0oooo00<000000?ooo`3oool0
403oool00`000000oooo0?ooo`0F0?ooo`h00000?@3oool00`000000oooo0?ooo`1A0?ooo`00:@3o
ool00`000000oooo0?ooo`1G0?ooo`030000003oool0oooo02l0oooo3000000D0?ooo`030000003o
ool0oooo0;/0oooo0`00001C0?ooo`030000003oool0oooo01X0oooo00<000000?ooo`3oool04@3o
ool00`000000oooo0?ooo`0E0?ooo`d00000?`3oool00`000000oooo0?ooo`1@0?ooo`00:@3oool0
0`000000oooo0?ooo`1H0?ooo`030000003oool0oooo02d0oooo3@00000C0?ooo`030000003oool0
oooo0;T0oooo0`00001F0?ooo`030000003oool0oooo01X0oooo00<000000?ooo`3oool04P3oool0
0`000000oooo0?ooo`0E0?ooo``00000?`3oool00`000000oooo0?ooo`1@0?ooo`00:@3oool00`00
0000oooo0?ooo`1I0?ooo`030000003oool0oooo02`0oooo3P00000B0?ooo`030000003oool0oooo
0;D0oooo1000001I0?ooo`030000003oool0oooo01X0oooo00<000000?ooo`3oool04P3oool00`00
0000oooo0?ooo`0E0?ooo`/00000@@3oool00`000000oooo0?ooo`1?0?ooo`00:@3oool00`000000
oooo0?ooo`1J0?ooo`030000003oool0oooo02/0oooo3P00000A0?ooo`030000003oool0oooo0;<0
oooo0`00001M0?ooo`030000003oool0oooo01X0oooo00<000000?ooo`3oool04`3oool00`000000
oooo0?ooo`0C0?ooo`030000003oool0oooo00P00000@`3oool00`000000oooo0?ooo`1>0?ooo`00
:03oool00`000000oooo0?ooo`1L0?ooo`030000003oool0oooo02X0oooo3P00000A0?ooo`030000
003oool0oooo0:l0oooo1000001P0?ooo`030000003oool0oooo01X0oooo00<000000?ooo`3oool0
4`3oool00`000000oooo0?ooo`0A0?ooo`800000103oool6000004@0oooo00<000000?ooo`3oool0
CP3oool002P0oooo00<000000?ooo`3oool0G@3oool00`000000oooo0?ooo`0Y0?ooo`h000004@3o
ool00`000000oooo0?ooo`2/0?ooo`<00000I03oool00`000000oooo0?ooo`0J0?ooo`030000003o
ool0oooo01@0oooo00<000000?ooo`3oool03`3oool00`000000oooo0?ooo`090?ooo`030000003o
ool0oooo04<0oooo00<000000?ooo`3oool0C@3oool002P0oooo00<000000?ooo`3oool0GP3oool0
0`000000oooo0?ooo`0X0?ooo`d000004@3oool00`000000oooo0?ooo`2Z0?ooo`<00000I`3oool0
0`000000oooo0?ooo`0J0?ooo`030000003oool0oooo01D0oooo00<000000?ooo`3oool03@3oool0
0`000000oooo0?ooo`0:0?ooo`030000003oool0oooo04@0oooo00<000000?ooo`3oool0C03oool0
02P0oooo00<000000?ooo`3oool0G`3oool00`000000oooo0?ooo`0X0?ooo``000004@3oool00`00
0000oooo0?ooo`2V0?ooo`@00000JP3oool00`000000oooo0?ooo`0J0?ooo`030000003oool0oooo
01D0oooo00<000000?ooo`3oool02`3oool2000000h0oooo00<000000?ooo`3oool0@`3oool00`00
0000oooo0?ooo`1<0?ooo`00:03oool00`000000oooo0?ooo`1P0?ooo`030000003oool0oooo02P0
oooo2P00000B0?ooo`030000003oool0oooo0:<0oooo0`00001^0?ooo`030000003oool0oooo01X0
oooo00<000000?ooo`3oool05P3oool00`000000oooo0?ooo`090?ooo`030000003oool0oooo00h0
oooo00<000000?ooo`3oool0A03oool00`000000oooo0?ooo`1;0?ooo`00:03oool00`000000oooo
0?ooo`1Q0?ooo`030000003oool0oooo02L0oooo2P00000A0?ooo`030000003oool0oooo0:00oooo
1000001a0?ooo`030000003oool0oooo01X0oooo00<000000?ooo`3oool05`3oool00`000000oooo
0?ooo`070?ooo`030000003oool0oooo0100oooo00<000000?ooo`3oool0A03oool00`000000oooo
0?ooo`1:0?ooo`009`3oool00`000000oooo0?ooo`1S0?ooo`030000003oool0oooo02H0oooo00<0
00000?ooo`0000001@0000000`3oool000000?ooo`0@0?ooo`030000003oool0oooo09d0oooo0`00
001e0?ooo`030000003oool0oooo01X0oooo00<000000?ooo`3oool05`3oool00`000000oooo0?oo
o`060?ooo`030000003oool0oooo0140oooo00<000000?ooo`3oool0A03oool00`000000oooo0?oo
o`1:0?ooo`009`3oool00`000000oooo0?ooo`1T0?ooo`030000003oool0oooo02@0oooo00<00000
0?ooo`3oool0203oool00`000000oooo0?ooo`0=0?ooo`030000003oool0oooo09X0oooo1000001h
0?ooo`030000003oool0oooo01/0oooo00<000000?ooo`3oool05`3oool00`000000oooo0?ooo`03
0?ooo`8000005@3oool00`000000oooo0?ooo`140?ooo`030000003oool0oooo04T0oooo000W0?oo
o`030000003oool0oooo06D0oooo00<000000?ooo`3oool08`3oool00`000000oooo0?ooo`090?oo
o`030000003oool0oooo00`0oooo00<000000?ooo`3oool0U`3oool3000007`0oooo00<000000?oo
o`3oool06`3oool00`000000oooo0?ooo`0H0?ooo`050000003oool0oooo0?ooo`0000005`3oool0
0`000000oooo0?ooo`150?ooo`030000003oool0oooo04P0oooo000W0?ooo`030000003oool0oooo
06H0oooo0P00000R0?ooo`030000003oool0oooo00/0oooo00<000000?ooo`3oool02`3oool00`00
0000oooo0?ooo`2D0?ooo`<00000O`3oool00`000000oooo0?ooo`0K0?ooo`030000003oool0oooo
01P0oooo00@000000?ooo`3oool000006@3oool00`000000oooo0?ooo`140?ooo`030000003oool0
oooo04P0oooo000W0?ooo`030000003oool0oooo06P0oooo00<000000?ooo`3oool07P3oool00`00
0000oooo0?ooo`0=0?ooo`030000003oool0oooo00T0oooo00<000000?ooo`3oool0T@3oool40000
0880oooo00<000000?ooo`3oool06`3oool00`000000oooo0?ooo`0I0?ooo`8000006P3oool00`00
0000oooo0?ooo`150?ooo`030000003oool0oooo04L0oooo000W0?ooo`030000003oool0oooo06T0
oooo00<000000?ooo`3oool07@3oool00`000000oooo0?ooo`0=0?ooo`030000003oool0oooo00T0
oooo00<000000?ooo`3oool0SP3oool3000008L0oooo00<000000?ooo`3oool06P3oool00`000000
oooo0?ooo`0H0?ooo`8000006`3oool00`000000oooo0?ooo`160?ooo`030000003oool0oooo04H0
oooo000V0?ooo`030000003oool0oooo06/0oooo00<000000?ooo`3oool06`3oool00`000000oooo
0?ooo`0?0?ooo`030000003oool0oooo00P0oooo00<000000?ooo`3oool0RP3oool4000008X0oooo
00<000000?ooo`3oool06P3oool00`000000oooo0?ooo`0G0?ooo`040000003oool0oooo000001/0
oooo00<000000?ooo`3oool0A@3oool00`000000oooo0?ooo`160?ooo`009P3oool00`000000oooo
0?ooo`1/0?ooo`030000003oool0oooo01X0oooo00<000000?ooo`3oool0403oool00`000000oooo
0?ooo`060?ooo`030000003oool0oooo08P0oooo0`00002>0?ooo`030000003oool0oooo01X0oooo
00<000000?ooo`3oool05P3oool00`000000oooo0?ooo`020?ooo`030000003oool0oooo01P0oooo
00<000000?ooo`3oool0AP3oool00`000000oooo0?ooo`150?ooo`009P3oool00`000000oooo0?oo
o`1]0?ooo`030000003oool0oooo01P0oooo00<000000?ooo`3oool04P3oool00`000000oooo0?oo
o`050?ooo`030000003oool0oooo08D0oooo0`00002A0?ooo`030000003oool0oooo01X0oooo00<0
00000?ooo`3oool05@3oool00`000000oooo0?ooo`030?ooo`030000003oool0oooo01T0oooo00<0
00000?ooo`3oool0AP3oool00`000000oooo0?ooo`140?ooo`009P3oool00`000000oooo0?ooo`1^
0?ooo`030000003oool0oooo01L0oooo00<000000?ooo`3oool04P3oool00`000000oooo0?ooo`04
0?ooo`030000003oool0oooo0880oooo1000002D0?ooo`030000003oool0oooo01X0oooo00<00000
0?ooo`3oool04`3oool2000000L0oooo00<000000?ooo`3oool0603oool00`000000oooo0?ooo`16
0?ooo`030000003oool0oooo04@0oooo000V0?ooo`030000003oool0oooo06l0oooo00<000000?oo
o`3oool05@3oool00`000000oooo0?ooo`0D0?ooo`030000003oool0oooo00<0oooo00<000000?oo
o`3oool0O`3oool3000009P0oooo00<000000?ooo`3oool06P3oool00`000000oooo0?ooo`0B0?oo
o`030000003oool0oooo00P0oooo00<000000?ooo`3oool0603oool00`000000oooo0?ooo`160?oo
o`030000003oool0oooo04<0oooo000V0?ooo`030000003oool0oooo0700oooo00<000000?ooo`3o
ool04`3oool00`000000oooo0?ooo`0F0?ooo`030000003oool0oooo0080oooo00<000000?ooo`3o
ool0N`3oool4000009/0oooo00<000000?ooo`3oool06P3oool00`000000oooo0?ooo`0A0?ooo`03
0000003oool0oooo00T0oooo00<000000?ooo`3oool0603oool00`000000oooo0?ooo`170?ooo`03
0000003oool0oooo0480oooo000V0?ooo`030000003oool0oooo0740oooo00<000000?ooo`3oool0
4P3oool00`000000oooo0?ooo`0G0?ooo`040000003oool0oooo000007/0oooo0`00002O0?ooo`03
0000003oool0oooo01X0oooo00<000000?ooo`3oool03`3oool2000000d0oooo00<000000?ooo`3o
ool05`3oool00`000000oooo0?ooo`170?ooo`030000003oool0oooo0480oooo000U0?ooo`030000
003oool0oooo07<0oooo00<000000?ooo`3oool0403oool00`000000oooo0?ooo`0H0?ooo`040000
003oool0oooo000007L0oooo1000002R0?ooo`030000003oool0oooo01X0oooo00<000000?ooo`3o
ool03P3oool00`000000oooo0?ooo`0=0?ooo`030000003oool0oooo01P0oooo00<000000?ooo`3o
ool0A`3oool00`000000oooo0?ooo`110?ooo`009@3oool00`000000oooo0?ooo`1d0?ooo`030000
003oool0oooo00l0oooo00<000000?ooo`3oool06@3oool00`000000oooo0000001d0?ooo`<00000
YP3oool00`000000oooo0?ooo`0J0?ooo`030000003oool0oooo00d0oooo00<000000?ooo`3oool0
3`3oool00`000000oooo0?ooo`0G0?ooo`030000003oool0oooo04P0oooo00<000000?ooo`3oool0
@03oool002D0oooo00<000000?ooo`3oool0M@3oool00`000000oooo0?ooo`0=0?ooo`030000003o
ool0oooo01/0oooo00<000000?ooo`3oool0L03oool300000:T0oooo00<000000?ooo`3oool06P3o
ool00`000000oooo0?ooo`0<0?ooo`030000003oool0oooo0140oooo00<000000?ooo`3oool05`3o
ool00`000000oooo0?ooo`170?ooo`030000003oool0oooo0400oooo000U0?ooo`030000003oool0
oooo07H0oooo00<000000?ooo`3oool02`3oool00`000000oooo0?ooo`0L0?ooo`800000K@3oool4
00000:`0oooo00<000000?ooo`3oool06P3oool00`000000oooo0?ooo`0:0?ooo`800000503oool0
0`000000oooo0?ooo`0G0?ooo`030000003oool0oooo04P0oooo00<000000?ooo`3oool0?`3oool0
02D0oooo00<000000?ooo`3oool0M`3oool00`000000oooo0?ooo`0:0?ooo`030000003oool0oooo
01/0oooo00@000000?ooo`3oool00000J@3oool300000;00oooo00<000000?ooo`3oool06P3oool0
0`000000oooo0?ooo`090?ooo`030000003oool0oooo01D0oooo00<000000?ooo`3oool05`3oool0
0`000000oooo0?ooo`180?ooo`030000003oool0oooo03h0oooo000U0?ooo`030000003oool0oooo
07P0oooo00<000000?ooo`3oool0203oool00`000000oooo0?ooo`0L0?ooo`040000003oool0oooo
000006D0oooo1000002c0?ooo`030000003oool0oooo01X0oooo00<000000?ooo`3oool0203oool0
0`000000oooo0?ooo`0G0?ooo`030000003oool0oooo01H0oooo00<000000?ooo`3oool0B03oool0
0`000000oooo0?ooo`0n0?ooo`00903oool00`000000oooo0?ooo`1j0?ooo`030000003oool0oooo
00L0oooo00<000000?ooo`3oool0703oool01@000000oooo0?ooo`3oool000000640oooo0`00002g
0?ooo`030000003oool0oooo01X0oooo00<000000?ooo`3oool01`3oool00`000000oooo0?ooo`0H
0?ooo`030000003oool0oooo01L0oooo00<000000?ooo`3oool0B03oool00`000000oooo0?ooo`0m
0?ooo`00903oool00`000000oooo0?ooo`1k0?ooo`030000003oool0oooo00D0oooo00<000000?oo
o`3oool0703oool00`000000oooo0?ooo`030?ooo`030000003oool0oooo05/0oooo0`00002j0?oo
o`030000003oool0oooo01X0oooo00<000000?ooo`3oool01@3oool2000001`0oooo00<000000?oo
o`3oool05P3oool00`000000oooo0?ooo`190?ooo`030000003oool0oooo03`0oooo000T0?ooo`03
0000003oool0oooo07`0oooo00<000000?ooo`3oool00`3oool00`000000oooo0?ooo`0M0?ooo`03
0000003oool0oooo00@0oooo00<000000?ooo`3oool0EP3oool400000;d0oooo00<000000?ooo`3o
ool06P3oool00`000000oooo0?ooo`040?ooo`030000003oool0oooo01d0oooo00<000000?ooo`3o
ool05@3oool00`000000oooo0?ooo`190?ooo`030000003oool0oooo03`0oooo000T0?ooo`030000
003oool0oooo07d0oooo00<000000?ooo`3oool00P3oool00`000000oooo0?ooo`0M0?ooo`030000
003oool0oooo00@0oooo00<000000?ooo`3oool0D`3oool300000<40oooo00<000000?ooo`3oool0
6P3oool00`000000oooo0?ooo`030?ooo`030000003oool0oooo01h0oooo00<000000?ooo`3oool0
5P3oool00`000000oooo0?ooo`190?ooo`030000003oool0oooo03/0oooo000T0?ooo`030000003o
ool0oooo07h0oooo00@000000?ooo`3oool000007`3oool00`000000oooo0?ooo`060?ooo`030000
003oool0oooo04h0oooo100000340?ooo`030000003oool0oooo01X0oooo00<000000?ooo`3oool0
0P3oool00`000000oooo0?ooo`0P0?ooo`030000003oool0oooo01D0oooo00<000000?ooo`3oool0
BP3oool00`000000oooo0?ooo`0j0?ooo`00903oool00`000000oooo0?ooo`1o0?ooo`030000003o
ool0000001l0oooo00<000000?ooo`3oool01`3oool00`000000oooo0?ooo`1:0?ooo`<00000b03o
ool00`000000oooo0?ooo`0J0?ooo`030000003oool0oooo008000008`3oool00`000000oooo0?oo
o`0F0?ooo`030000003oool0oooo04T0oooo00<000000?ooo`3oool0>P3oool002<0oooo00<00000
0?ooo`3oool0P@3oool00`000000oooo0?ooo`0M0?ooo`030000003oool0oooo00T0oooo00<00000
0?ooo`3oool0A@3oool400000<`0oooo00<000000?ooo`3oool06@3oool00`000000oooo0000000V
0?ooo`030000003oool0oooo01D0oooo00<000000?ooo`3oool0BP3oool00`000000oooo0?ooo`0i
0?ooo`008`3oool00`000000oooo0?ooo`200?ooo`030000003oool0000001h0oooo00<000000?oo
o`3oool02P3oool00`000000oooo0?ooo`110?ooo`<00000d03oool00`000000oooo0?ooo`0I0?oo
o`800000:03oool00`000000oooo0?ooo`0E0?ooo`030000003oool0oooo04X0oooo00<000000?oo
o`3oool0>03oool002<0oooo00<000000?ooo`3oool0P03oool010000000oooo0?ooo`00000M0?oo
o`030000003oool0oooo00X0oooo00<000000?ooo`3oool0?P3oool300000=<0oooo00<000000?oo
o`3oool0603oool2000002T0oooo00<000000?ooo`3oool05@3oool00`000000oooo0?ooo`1:0?oo
o`030000003oool0oooo03P0oooo000S0?ooo`030000003oool0oooo07l0oooo00<000000?ooo`3o
ool00P3oool00`000000oooo0?ooo`0I0?ooo`030000003oool0oooo00`0oooo00<000000?ooo`3o
ool0>@3oool400000=H0oooo00<000000?ooo`3oool05`3oool00`000000oooo0000000Z0?ooo`03
0000003oool0oooo01@0oooo00<000000?ooo`3oool0B`3oool00`000000oooo0?ooo`0g0?ooo`00
8`3oool00`000000oooo0?ooo`1o0?ooo`030000003oool0oooo00<0oooo00<000000?ooo`3oool0
603oool00`000000oooo0?ooo`0=0?ooo`030000003oool0oooo03D0oooo0`00003J0?ooo`030000
003oool0oooo01H0oooo00@000000?ooo`3oool00000:`3oool00`000000oooo0?ooo`0D0?ooo`03
0000003oool0oooo04X0oooo00<000000?ooo`3oool0=`3oool002<0oooo00<000000?ooo`3oool0
OP3oool00`000000oooo0?ooo`050?ooo`030000003oool0oooo01L0oooo00<000000?ooo`3oool0
3P3oool00`000000oooo0?ooo`0`0?ooo`@00000g@3oool00`000000oooo0?ooo`0E0?ooo`030000
003oool0oooo0080oooo00<000000?ooo`3oool0:03oool00`000000oooo0?ooo`0D0?ooo`030000
003oool0oooo04/0oooo00<000000?ooo`3oool0=P3oool002<0oooo00<000000?ooo`3oool0OP3o
ool00`000000oooo0?ooo`060?ooo`030000003oool0oooo01D0oooo00<000000?ooo`3oool03`3o
ool00`000000oooo0?ooo`0]0?ooo`<00000h@3oool00`000000oooo0?ooo`0C0?ooo`8000001@3o
ool00`000000oooo0?ooo`0Y0?ooo`030000003oool0oooo01@0oooo00<000000?ooo`3oool0B`3o
ool00`000000oooo0?ooo`0e0?ooo`008P3oool00`000000oooo0?ooo`1n0?ooo`030000003oool0
oooo00P0oooo00<000000?ooo`3oool0503oool00`000000oooo0?ooo`0@0?ooo`030000003oool0
oooo02T0oooo0`00003T0?ooo`030000003oool0oooo0180oooo00<000000?ooo`3oool01@3oool0
0`000000oooo0?ooo`0Z0?ooo`030000003oool0oooo01<0oooo00<000000?ooo`3oool0B`3oool0
0`000000oooo0?ooo`0e0?ooo`008P3oool00`000000oooo0?ooo`1m0?ooo`030000003oool0oooo
00X0oooo00<000000?ooo`3oool04P3oool00`000000oooo0?ooo`0B0?ooo`030000003oool0oooo
02@0oooo1000003W0?ooo`030000003oool0oooo0140oooo00<000000?ooo`3oool01P3oool00`00
0000oooo0?ooo`0Z0?ooo`030000003oool0oooo01@0oooo00<000000?ooo`3oool0B`3oool00`00
0000oooo0?ooo`0d0?ooo`008P3oool00`000000oooo0?ooo`1m0?ooo`030000003oool0oooo00/0
oooo00<000000?ooo`3oool04@3oool00`000000oooo0?ooo`0C0?ooo`030000003oool0oooo0200
oooo0`00003[0?ooo`030000003oool0oooo0100oooo00<000000?ooo`3oool01`3oool00`000000
oooo0?ooo`0[0?ooo`030000003oool0oooo01<0oooo00<000000?ooo`3oool0C03oool00`000000
oooo0?ooo`0c0?ooo`008P3oool00`000000oooo0?ooo`1l0?ooo`030000003oool0oooo00d0oooo
00<000000?ooo`3oool0403oool00`000000oooo0?ooo`0C0?ooo`030000003oool0oooo01`0oooo
1000003^0?ooo`030000003oool0oooo00h0oooo0P00000:0?ooo`030000003oool0oooo02/0oooo
00<000000?ooo`3oool0503oool00`000000oooo0?ooo`1;0?ooo`030000003oool0oooo03<0oooo
000R0?ooo`030000003oool0oooo07`0oooo00<000000?ooo`3oool03P3oool00`000000oooo0?oo
o`0>0?ooo`030000003oool0oooo01D0oooo00<000000?ooo`3oool0603oool300000?80oooo00<0
00000?ooo`3oool03@3oool00`000000oooo0?ooo`0:0?ooo`030000003oool0oooo02`0oooo00<0
00000?ooo`3oool04`3oool00`000000oooo0?ooo`1<0?ooo`030000003oool0oooo0380oooo000R
0?ooo`030000003oool0oooo07/0oooo00<000000?ooo`3oool0403oool00`000000oooo0?ooo`0=
0?ooo`030000003oool0oooo01H0oooo00<000000?ooo`3oool04`3oool400000?D0oooo00<00000
0?ooo`3oool0303oool00`000000oooo0?ooo`0;0?ooo`030000003oool0oooo02d0oooo00<00000
0?ooo`3oool04P3oool00`000000oooo0?ooo`1=0?ooo`030000003oool0oooo0340oooo000Q0?oo
o`030000003oool0oooo07/0oooo00<000000?ooo`3oool04P3oool2000000d0oooo00<000000?oo
o`3oool05`3oool00`000000oooo0?ooo`0?0?ooo`<00000n@3oool00`000000oooo0?ooo`0;0?oo
o`030000003oool0oooo00`0oooo00<000000?ooo`3oool0;@3oool00`000000oooo0?ooo`0C0?oo
o`030000003oool0oooo04`0oooo00<000000?ooo`3oool0<@3oool00240oooo00<000000?ooo`3o
ool0N`3oool00`000000oooo0?ooo`0D0?ooo`030000003oool0oooo00T0oooo00<000000?ooo`3o
ool06@3oool00`000000oooo0?ooo`0;0?ooo`<00000o03oool00`000000oooo0?ooo`090?ooo`80
00003`3oool00`000000oooo0?ooo`0^0?ooo`030000003oool0oooo0180oooo00<000000?ooo`3o
ool0C@3oool00`000000oooo0?ooo`0`0?ooo`008@3oool00`000000oooo0?ooo`1j0?ooo`030000
003oool0oooo01H0oooo00<000000?ooo`3oool0203oool00`000000oooo0?ooo`0I0?ooo`030000
003oool0oooo00L0oooo1000003o0?ooo`030000003oool0oooo00P0oooo00<000000?ooo`3oool0
3`3oool00`000000oooo0?ooo`0_0?ooo`030000003oool0oooo0180oooo00<000000?ooo`3oool0
C@3oool00`000000oooo0?ooo`0_0?ooo`008@3oool00`000000oooo0?ooo`1j0?ooo`030000003o
ool0oooo01L0oooo00<000000?ooo`3oool01P3oool00`000000oooo0?ooo`0K0?ooo`030000003o
ool0oooo00<0oooo0`00003o0?ooo`@0oooo00<000000?ooo`3oool01`3oool00`000000oooo0?oo
o`0@0?ooo`030000003oool0oooo02l0oooo00<000000?ooo`3oool04P3oool00`000000oooo0?oo
o`1=0?ooo`030000003oool0oooo02l0oooo000Q0?ooo`030000003oool0oooo07T0oooo00<00000
0?ooo`3oool06@3oool00`000000oooo0?ooo`050?ooo`030000003oool0oooo01`0oooo1@00003o
0?ooo`L0oooo00<000000?ooo`3oool01P3oool00`000000oooo0?ooo`0A0?ooo`030000003oool0
oooo0300oooo00<000000?ooo`3oool04P3oool00`000000oooo0?ooo`1=0?ooo`030000003oool0
oooo02h0oooo000Q0?ooo`030000003oool0oooo07P0oooo00<000000?ooo`3oool06`3oool00`00
0000oooo0?ooo`040?ooo`030000003oool0oooo01X0oooo1000003o0?ooo`X0oooo00<000000?oo
o`3oool0103oool2000001@0oooo00<000000?ooo`3oool0<03oool00`000000oooo0?ooo`0B0?oo
o`030000003oool0oooo04h0oooo00<000000?ooo`3oool0;@3oool00200oooo00<000000?ooo`3o
ool0N@3oool00`000000oooo0?ooo`0L0?ooo`030000003oool0oooo0080oooo00<000000?ooo`3o
ool0603oool3000000<0oooo00<000000?ooo`3oool0o`3oool80?ooo`030000003oool0oooo00<0
oooo00<000000?ooo`3oool0503oool00`000000oooo0?ooo`0a0?ooo`030000003oool0oooo0140
oooo00<000000?ooo`3oool0CP3oool00`000000oooo0?ooo`0]0?ooo`00803oool00`000000oooo
0?ooo`1h0?ooo`030000003oool0oooo01h0oooo00D000000?ooo`3oool0oooo0000000F0?ooo`@0
00001`3oool00`000000oooo0?ooo`3o0?ooo`L0oooo00<000000?ooo`3oool00P3oool00`000000
oooo0?ooo`0E0?ooo`030000003oool0oooo0380oooo00<000000?ooo`3oool04@3oool00`000000
oooo0?ooo`1>0?ooo`030000003oool0oooo02`0oooo000P0?ooo`030000003oool0oooo07P0oooo
00<000000?ooo`3oool07`3oool010000000oooo0?ooo`00000C0?ooo`<00000303oool00`000000
oooo0?ooo`3o0?ooo`L0oooo00@000000?ooo`0000000000603oool00`000000oooo0?ooo`0b0?oo
o`030000003oool0oooo0140oooo00<000000?ooo`3oool0C`3oool00`000000oooo0?ooo`0[0?oo
o`00803oool00`000000oooo0?ooo`1g0?ooo`030000003oool0oooo01h0oooo1P00000?0?ooo`@0
0000403oool00`000000oooo0?ooo`3o0?ooo`H0oooo0P00000J0?ooo`030000003oool0oooo03<0
oooo00<000000?ooo`3oool04@3oool00`000000oooo0?ooo`1>0?ooo`030000003oool0oooo02/0
oooo000P0?ooo`030000003oool0oooo07H0oooo00<000000?ooo`3oool07P3oool8000000/0oooo
0`00000E0?ooo`030000003oool0oooo0?l0oooo1@3oool00`000000oooo0?ooo`0I0?ooo`030000
003oool0oooo03@0oooo00<000000?ooo`3oool0403oool00`000000oooo0?ooo`1>0?ooo`800000
;03oool00200oooo00<000000?ooo`3oool0MP3oool00`000000oooo0?ooo`0M0?ooo`X000001P3o
ool4000001P0oooo00<000000?ooo`3oool0o`3oool40?ooo`8000006`3oool00`000000oooo0?oo
o`0d0?ooo`030000003oool0oooo0140oooo00<000000?ooo`3oool0BP3oool3000000030?ooo`00
0000oooo02/0oooo000P0?ooo`030000003oool0oooo07D0oooo00<000000?ooo`3oool07@3oool<
00000080oooo0`00000M0?ooo`030000003oool0oooo0?l0oooo0@3oool2000000030?ooo`000000
oooo01X0oooo00<000000?ooo`3oool0=@3oool00`000000oooo0?ooo`0@0?ooo`030000003oool0
oooo04H0oooo100000040?ooo`030000003oool0oooo02X0oooo000O0?ooo`030000003oool0oooo
07H0oooo00<000000?ooo`3oool0703oool?00000240oooo00<000000?ooo`3oool0oP3oool01@00
0000oooo0?ooo`3oool0000001/0oooo00<000000?ooo`3oool0=P3oool00`000000oooo0?ooo`0@
0?ooo`030000003oool0oooo0480oooo0`0000080?ooo`030000003oool0oooo02X0oooo000O0?oo
o`030000003oool0oooo07D0oooo00<000000?ooo`3oool07@3oool>000002<0oooo00<000000?oo
o`3oool0o03oool00`000000oooo0?ooo`020?ooo`030000003oool0oooo01T0oooo00<000000?oo
o`3oool0=P3oool00`000000oooo0?ooo`0@0?ooo`030000003oool0oooo03l0oooo0`00000<0?oo
o`030000003oool0oooo02T0oooo000O0?ooo`030000003oool0oooo07D0oooo00<000000?ooo`3o
ool07@3oool>000002<0oooo00<000000?ooo`3oool0n`3oool00`000000oooo0?ooo`030?ooo`03
0000003oool0oooo01T0oooo00<000000?ooo`3oool0=`3oool00`000000oooo0?ooo`0?0?ooo`03
0000003oool0oooo03`0oooo0`00000?0?ooo`030000003oool0oooo02T0oooo000O0?ooo`030000
003oool0oooo07@0oooo00<000000?ooo`3oool07P3oool?000002<0oooo00<000000?ooo`3oool0
n03oool2000000H0oooo00<000000?ooo`3oool06@3oool00`000000oooo0?ooo`0g0?ooo`030000
003oool0oooo0100oooo00<000000?ooo`3oool0>03oool300000180oooo00<000000?ooo`3oool0
:@3oool001l0oooo00<000000?ooo`3oool0L`3oool00`000000oooo0?ooo`0O0?oooa4000008P3o
ool00`000000oooo0?ooo`3f0?ooo`030000003oool0oooo00H0oooo00<000000?ooo`3oool06@3o
ool00`000000oooo0?ooo`0h0?ooo`030000003oool0oooo00l0oooo00<000000?ooo`3oool0=03o
ool4000001D0oooo00<000000?ooo`3oool0:@3oool001l0oooo00<000000?ooo`3oool0L`3oool0
0`000000oooo0?ooo`0O0?ooo`d000000`3oool6000001h0oooo00<000000?ooo`3oool0m03oool0
0`000000oooo0?ooo`070?ooo`030000003oool0oooo01T0oooo00<000000?ooo`3oool0>@3oool0
0`000000oooo0?ooo`0?0?ooo`030000003oool0oooo0300oooo0`00000I0?ooo`030000003oool0
oooo02T0oooo000N0?ooo`030000003oool0oooo07<0oooo00<000000?ooo`3oool07`3oool00`00
0000oooo0000000;000000@0oooo00<000000?ooo`3oool00P3oool4000001X0oooo00<000000?oo
o`3oool0l`3oool00`000000oooo0?ooo`080?ooo`030000003oool0oooo01T0oooo00<000000?oo
o`3oool0>@3oool00`000000oooo0?ooo`0?0?ooo`030000003oool0oooo02d0oooo0`00000L0?oo
o`030000003oool0oooo02T0oooo000N0?ooo`030000003oool0oooo07<0oooo00<000000?ooo`3o
ool07@3oool2000000<0oooo2P0000060?ooo`030000003oool0oooo00D0oooo1000000G0?ooo`03
0000003oool0oooo0?00oooo0P00000;0?ooo`030000003oool0oooo01X0oooo00<000000?ooo`3o
ool0>@3oool00`000000oooo0?ooo`0?0?ooo`030000003oool0oooo02T0oooo0`00000O0?ooo`03
0000003oool0oooo02T0oooo000N0?ooo`030000003oool0oooo0780oooo00<000000?ooo`3oool0
703oool2000000D0oooo2@0000000`3oool000000?ooo`050?ooo`030000003oool0oooo00P0oooo
1@00000C0?ooo`030000003oool0oooo0>h0oooo00<000000?ooo`3oool02`3oool00`000000oooo
0?ooo`0J0?ooo`030000003oool0oooo03X0oooo00<000000?ooo`3oool03P3oool00`000000oooo
0?ooo`0U0?ooo`@000008P3oool00`000000oooo0?ooo`0Y0?ooo`007P3oool00`000000oooo0?oo
o`1a0?ooo`030000003oool0oooo01/0oooo0P0000060?ooo`030000003oool0oooo00H000000`3o
ool00`000000oooo0?ooo`040?ooo`030000003oool0oooo00`0oooo1000000@0?ooo`030000003o
ool0oooo0>`0oooo00<000000?ooo`3oool0303oool00`000000oooo0?ooo`0J0?ooo`030000003o
ool0oooo03X0oooo00<000000?ooo`3oool03P3oool00`000000oooo0?ooo`0R0?ooo`<000009`3o
ool00`000000oooo0?ooo`0X0?ooo`007P3oool00`000000oooo0?ooo`1a0?ooo`030000003oool0
oooo01X0oooo00<000000?ooo`3oool01P3oool00`000000oooo000000030?ooo`030000003oool0
oooo00@0oooo00<000000?ooo`3oool0103oool00`000000oooo0?ooo`0?0?ooo`@000003@3oool0
0`000000oooo0?ooo`3Y0?ooo`8000003`3oool00`000000oooo0?ooo`0J0?ooo`030000003oool0
oooo03/0oooo00<000000?ooo`3oool03P3oool00`000000oooo0?ooo`0N0?ooo`<00000:P3oool0
0`000000oooo0?ooo`0X0?ooo`007P3oool00`000000oooo0?ooo`1`0?ooo`030000003oool0oooo
01T0oooo0P0000080?ooo`040000003oool0oooo000000<0oooo00<000000?ooo`3oool01@3oool0
0`000000oooo0?ooo`040?ooo`030000003oool0oooo0180oooo1@0000080?ooo`030000003oool0
oooo0>P0oooo00<000000?ooo`3oool03`3oool00`000000oooo0?ooo`0J0?ooo`030000003oool0
oooo03`0oooo00<000000?ooo`3oool03@3oool00`000000oooo0?ooo`0K0?ooo`<00000;@3oool0
0`000000oooo0?ooo`0X0?ooo`007@3oool00`000000oooo0?ooo`1a0?ooo`030000003oool0oooo
01L0oooo0P0000090?ooo`040000003oool0oooo000000@0oooo00<000000?ooo`3oool01P3oool0
0`000000oooo0?ooo`040?ooo`030000003oool0oooo01H0oooo100000050?ooo`030000003oool0
oooo0>H0oooo00<000000?ooo`3oool0403oool00`000000oooo0?ooo`0J0?ooo`030000003oool0
oooo03`0oooo00<000000?ooo`3oool03P3oool00`000000oooo0?ooo`0F0?ooo`@00000<03oool0
0`000000oooo0?ooo`0X0?ooo`007@3oool00`000000oooo0?ooo`1`0?ooo`030000003oool0oooo
01H0oooo0P00000;0?ooo`040000003oool0oooo000000D0oooo00<000000?ooo`3oool01P3oool0
0`000000oooo0?ooo`040?ooo`030000003oool0oooo01T0oooo100000020?ooo`030000003oool0
oooo0>@0oooo00<000000?ooo`3oool04@3oool00`000000oooo0?ooo`0J0?ooo`030000003oool0
oooo03d0oooo00<000000?ooo`3oool03@3oool00`000000oooo0?ooo`0C0?ooo`<00000=03oool0
0`000000oooo0?ooo`0X0?ooo`007@3oool00`000000oooo0?ooo`1_0?ooo`030000003oool0oooo
01H0oooo00<000000?ooo`3oool02P3oool01@000000oooo0?ooo`3oool0000000D0oooo00<00000
0?ooo`3oool01`3oool00`000000oooo0?ooo`040?ooo`030000003oool0oooo01`0oooo1@00003R
0?ooo`800000503oool00`000000oooo0?ooo`0J0?ooo`030000003oool0oooo03d0oooo00<00000
0?ooo`3oool03P3oool00`000000oooo0?ooo`0?0?ooo`<00000=`3oool00`000000oooo0?ooo`0X
0?ooo`007@3oool00`000000oooo0?ooo`1_0?ooo`030000003oool0oooo01@0oooo0P00000<0?oo
o`050000003oool0oooo0?ooo`0000001P3oool00`000000oooo0?ooo`080?ooo`030000003oool0
oooo00@0oooo00<000000?ooo`3oool07P3oool00`000000oooo0000000300000=d0oooo00<00000
0?ooo`3oool0503oool00`000000oooo0?ooo`0J0?ooo`030000003oool0oooo03h0oooo00<00000
0?ooo`3oool03@3oool00`000000oooo0?ooo`0<0?ooo`<00000>P3oool00`000000oooo0?ooo`0X
0?ooo`007@3oool00`000000oooo0?ooo`1^0?ooo`030000003oool0oooo01<0oooo0P00000>0?oo
o`050000003oool0oooo0?ooo`0000001P3oool00`000000oooo0?ooo`090?ooo`030000003oool0
oooo00@0oooo00<000000?ooo`3oool07P3oool00`000000oooo0?ooo`020?ooo`@00000f03oool0
0`000000oooo0?ooo`0F0?ooo`030000003oool0oooo01T0oooo00<000000?ooo`3oool0?`3oool0
0`000000oooo0?ooo`0=0?ooo`030000003oool0oooo00P0oooo0`00000n0?ooo`030000003oool0
oooo02L0oooo000M0?ooo`030000003oool0oooo06h0oooo00<000000?ooo`3oool04@3oool20000
00l0oooo00<000000?ooo`3oool00P3oool00`000000oooo0?ooo`040?ooo`030000003oool0oooo
00X0oooo00<000000?ooo`3oool0103oool00`000000oooo0?ooo`0N0?ooo`030000003oool0oooo
00D0oooo1@00003B0?ooo`030000003oool0oooo01L0oooo00<000000?ooo`3oool06@3oool00`00
0000oooo0?ooo`0o0?ooo`030000003oool0oooo00d0oooo00<000000?ooo`3oool0103oool40000
0440oooo00<000000?ooo`3oool09`3oool001d0oooo00<000000?ooo`3oool0K@3oool00`000000
oooo0?ooo`0A0?ooo`030000003oool0oooo00h0oooo00<000000?ooo`3oool00P3oool00`000000
oooo0?ooo`050?ooo`030000003oool0oooo00/0oooo00<000000?ooo`3oool0103oool00`000000
oooo0?ooo`0N0?ooo`030000003oool0oooo00T0oooo1000003<0?ooo`8000006P3oool00`000000
oooo0?ooo`0I0?ooo`030000003oool0oooo0400oooo00<000000?ooo`3oool0303oool010000000
oooo0?ooo`3oool3000004D0oooo00<000000?ooo`3oool09`3oool001`0oooo00<000000?ooo`3o
ool0K@3oool00`000000oooo0?ooo`0@0?ooo`800000403oool00`000000oooo0?ooo`030?ooo`03
0000003oool0oooo00D0oooo00<000000?ooo`3oool0303oool00`000000oooo0?ooo`040?ooo`03
0000003oool0oooo01h0oooo00<000000?ooo`3oool0303oool400000<L0oooo00<000000?ooo`3o
ool06P3oool00`000000oooo0?ooo`0I0?ooo`030000003oool0oooo0440oooo00<000000?ooo`3o
ool0303oool3000004P0oooo00<000000?ooo`3oool09`3oool001`0oooo00<000000?ooo`3oool0
K@3oool00`000000oooo0?ooo`0>0?ooo`8000004P3oool00`000000oooo0?ooo`030?ooo`030000
003oool0oooo00H0oooo00<000000?ooo`3oool0303oool00`000000oooo0?ooo`040?ooo`030000
003oool0oooo01d0oooo00<000000?ooo`3oool0403oool500000<40oooo00<000000?ooo`3oool0
6`3oool00`000000oooo0?ooo`0I0?ooo`030000003oool0oooo0440oooo00<000000?ooo`3oool0
2@3oool4000004X0oooo00<000000?ooo`3oool09`3oool001`0oooo00<000000?ooo`3oool0K03o
ool00`000000oooo0?ooo`0=0?ooo`8000004`3oool00`000000oooo0?ooo`030?ooo`030000003o
ool0oooo00L0oooo00<000000?ooo`3oool03@3oool00`000000oooo0?ooo`040?ooo`030000003o
ool0oooo01d0oooo00<000000?ooo`3oool0503oool400000;`0oooo00<000000?ooo`3oool0703o
ool00`000000oooo0?ooo`0I0?ooo`030000003oool0oooo0480oooo00<000000?ooo`3oool0103o
ool4000000@0oooo00<000000?ooo`3oool0A`3oool00`000000oooo0?ooo`0W0?ooo`00703oool0
0`000000oooo0?ooo`1/0?ooo`030000003oool0oooo00/0oooo0P00000D0?ooo`030000003oool0
oooo00@0oooo00<000000?ooo`3oool01`3oool00`000000oooo0?ooo`0>0?ooo`030000003oool0
oooo00@0oooo0P00000N0?ooo`030000003oool0oooo01L0oooo1000002f0?ooo`8000007`3oool0
0`000000oooo0?ooo`0I0?ooo`030000003oool0oooo0480oooo00@000000?ooo`3oool0oooo0`00
00080?ooo`030000003oool0oooo04L0oooo00<000000?ooo`3oool09`3oool001`0oooo00<00000
0?ooo`3oool0J`3oool00`000000oooo0?ooo`0;0?ooo`030000003oool0oooo01@0oooo00<00000
0?ooo`3oool0103oool00`000000oooo0?ooo`070?ooo`030000003oool0oooo00l0oooo00<00000
0?ooo`3oool01@3oool00`000000oooo0?ooo`0L0?ooo`030000003oool0oooo01X0oooo1@00002`
0?ooo`030000003oool0oooo01l0oooo00<000000?ooo`3oool06@3oool00`000000oooo0?ooo`13
0?ooo`<00000303oool00`000000oooo0?ooo`160?ooo`030000003oool0oooo02L0oooo000L0?oo
o`030000003oool0oooo06/0oooo00<000000?ooo`3oool02@3oool2000001H0oooo00<000000?oo
o`3oool0103oool00`000000oooo0?ooo`080?ooo`030000003oool0oooo0100oooo00<000000?oo
o`3oool01@3oool00`000000oooo0?ooo`0K0?ooo`030000003oool0oooo01l0oooo1000002O0?oo
o`H000001P3oool00`000000oooo0?ooo`0P0?ooo`030000003oool0oooo01T0oooo00<000000?oo
o`3oool0@03oool3000000030?ooo`000000oooo00`0oooo00<000000?ooo`3oool0A`3oool00`00
0000oooo0?ooo`0V0?ooo`006`3oool00`000000oooo0?ooo`1[0?ooo`030000003oool0oooo00P0
oooo0P00000G0?ooo`030000003oool0oooo00D0oooo00<000000?ooo`3oool0203oool00`000000
oooo0?ooo`0A0?ooo`030000003oool0oooo00D0oooo00<000000?ooo`3oool06`3oool00`000000
oooo0?ooo`0R0?ooo`@00000VP3oool8000000<0oooo0P00000S0?ooo`030000003oool0oooo01T0
oooo00<000000?ooo`3oool0?@3oool3000000@0oooo00<000000?ooo`3oool02`3oool00`000000
oooo0?ooo`170?ooo`030000003oool0oooo02H0oooo000K0?ooo`030000003oool0oooo06X0oooo
00<000000?ooo`3oool01`3oool2000001T0oooo00<000000?ooo`3oool0103oool00`000000oooo
0?ooo`0:0?ooo`030000003oool0oooo0140oooo00<000000?ooo`3oool01@3oool00`000000oooo
0?ooo`0K0?ooo`030000003oool0oooo02D0oooo1@00002D0?ooo`X0000000<0oooo0000003oool0
903oool00`000000oooo0?ooo`0I0?ooo`030000003oool0oooo03T0oooo100000080?ooo`030000
003oool0oooo00/0oooo00<000000?ooo`3oool0AP3oool00`000000oooo0?ooo`0V0?ooo`006`3o
ool00`000000oooo0?ooo`1Z0?ooo`030000003oool0oooo00H0oooo00<000000?ooo`3oool0603o
ool00`000000oooo0?ooo`050?ooo`030000003oool0oooo00X0oooo00<000000?ooo`3oool04P3o
ool00`000000oooo0?ooo`050?ooo`030000003oool0oooo01/0oooo00<000000?ooo`3oool0:@3o
ool4000008l0oooo3000000V0?ooo`030000003oool0oooo01T0oooo00<000000?ooo`3oool0=P3o
ool3000000d0oooo00<000000?ooo`3oool02P3oool00`000000oooo0?ooo`160?ooo`030000003o
ool0oooo02H0oooo000K0?ooo`030000003oool0oooo06<0oooo1`0000070?ooo`8000006P3oool0
0`000000oooo0?ooo`060?ooo`030000003oool0oooo00X0oooo00<000000?ooo`3oool04`3oool0
0`000000oooo0?ooo`050?ooo`030000003oool0oooo01X0oooo00<000000?ooo`3oool0;@3oool4
000008X0oooo3@00000V0?ooo`030000003oool0oooo01T0oooo00<000000?ooo`3oool0<`3oool3
00000100oooo00<000000?ooo`3oool02`3oool00`000000oooo0?ooo`150?ooo`030000003oool0
oooo02H0oooo000K0?ooo`030000003oool0oooo0680oooo200000050?ooo`800000703oool00`00
0000oooo0?ooo`050?ooo`030000003oool0oooo00/0oooo00<000000?ooo`3oool0503oool00`00
0000oooo0?ooo`050?ooo`030000003oool0oooo01X0oooo00<000000?ooo`3oool0<03oool50000
08D0oooo3P00000U0?ooo`030000003oool0oooo01T0oooo00<000000?ooo`3oool0<03oool30000
01@0oooo00<000000?ooo`3oool02P3oool00`000000oooo0?ooo`150?ooo`030000003oool0oooo
02H0oooo000K0?ooo`030000003oool0oooo0640oooo2P0000020?ooo`8000007@3oool00`000000
oooo0?ooo`060?ooo`030000003oool0oooo00/0oooo00<000000?ooo`3oool05@3oool00`000000
oooo0?ooo`050?ooo`030000003oool0oooo01X0oooo00<000000?ooo`3oool0=03oool400000840
oooo3P00000U0?ooo`030000003oool0oooo01T0oooo00<000000?ooo`3oool0;03oool4000001P0
oooo00<000000?ooo`3oool02P3oool00`000000oooo0?ooo`140?ooo`030000003oool0oooo02H0
oooo000J0?ooo`030000003oool0oooo0640oooo3@00000N0?ooo`030000003oool0oooo00L0oooo
00<000000?ooo`3oool02`3oool00`000000oooo0?ooo`0F0?ooo`030000003oool0oooo00D0oooo
00<000000?ooo`3oool06P3oool00`000000oooo0?ooo`0g0?ooo`@00000N@3ooolB000002D0oooo
00<000000?ooo`3oool06@3oool00`000000oooo0?ooo`0Y0?ooo`<00000703oool00`000000oooo
0?ooo`0:0?ooo`030000003oool0oooo04D0oooo00<000000?ooo`3oool09@3oool001X0oooo00<0
00000?ooo`3oool0H03oool=000001l0oooo00<000000?ooo`3oool01P3oool00`000000oooo0?oo
o`0<0?ooo`030000003oool0oooo01L0oooo00<000000?ooo`3oool01@3oool00`000000oooo0?oo
o`0J0?ooo`030000003oool0oooo03X0oooo1@00001L0?oooaP00000103oool>000002D0oooo00<0
00000?ooo`3oool06@3oool00`000000oooo0?ooo`0V0?ooo`<00000803oool00`000000oooo0?oo
o`0:0?ooo`030000003oool0oooo04@0oooo00<000000?ooo`3oool09@3oool001X0oooo00<00000
0?ooo`3oool0H03oool>000001d0oooo00<000000?ooo`3oool01`3oool00`000000oooo0?ooo`0=
0?ooo`030000003oool0oooo01L0oooo00<000000?ooo`3oool01@3oool00`000000oooo0?ooo`0I
0?ooo`030000003oool0oooo00H00000>@3oool400000440oooo5`00000L0?ooo`d000009P3oool0
0`000000oooo0?ooo`0I0?ooo`030000003oool0oooo02<0oooo0`00000S0?ooo`030000003oool0
oooo00X0oooo00<000000?ooo`3oool0A03oool00`000000oooo0?ooo`0U0?ooo`006P3oool00`00
0000oooo0?ooo`1P0?ooo`h00000703oool00`000000oooo0?ooo`080?ooo`030000003oool0oooo
00d0oooo00<000000?ooo`3oool0603oool00`000000oooo0?ooo`050?ooo`030000003oool0oooo
01T0oooo2@00000l0?ooo`@000009@3ooolH000003@0oooo3000000V0?ooo`030000003oool0oooo
01T0oooo00<000000?ooo`3oool07`3oool4000002L0oooo00<000000?ooo`3oool02@3oool00`00
0000oooo0?ooo`140?ooo`030000003oool0oooo02D0oooo000J0?ooo`030000003oool0oooo0600
oooo3P00000L0?ooo`030000003oool0oooo00L0oooo00<000000?ooo`3oool03P3oool00`000000
oooo0?ooo`0I0?ooo`030000003oool0oooo00D0oooo00<000000?ooo`3oool0603oool:000003l0
oooo1@0000090?oooaL00000C@3oool:000002L0oooo00<000000?ooo`3oool06@3oool00`000000
oooo0?ooo`0L0?ooo`<00000;03oool00`000000oooo0?ooo`090?ooo`030000003oool0oooo04<0
oooo00<000000?ooo`3oool09@3oool001X0oooo00<000000?ooo`3oool0H03oool>000001/0oooo
00<000000?ooo`3oool0203oool00`000000oooo0?ooo`0>0?ooo`030000003oool0oooo01X0oooo
00<000000?ooo`3oool01@3oool00`000000oooo0?ooo`0F0?ooo``00000=03ooolH000006D0oooo
2000000Y0?ooo`030000003oool0oooo01T0oooo00<000000?ooo`3oool0603oool3000002l0oooo
00<000000?ooo`3oool02@3oool00`000000oooo0?ooo`130?ooo`030000003oool0oooo02D0oooo
000J0?ooo`030000003oool0oooo0600oooo3@00000K0?ooo`030000003oool0oooo00T0oooo00<0
00000?ooo`3oool03P3oool00`000000oooo0?ooo`0K0?ooo`030000003oool0oooo00D0oooo00<0
00000?ooo`3oool0503oool=000001d0oooo5`00000C0?ooo`@00000I`3oool6000002X0oooo00<0
00000?ooo`3oool06@3oool00`000000oooo0?ooo`0E0?ooo`<00000<`3oool00`000000oooo0?oo
o`090?ooo`030000003oool0oooo0480oooo00<000000?ooo`3oool09@3oool001T0oooo00<00000
0?ooo`3oool0HP3oool<000001/0oooo00<000000?ooo`3oool0203oool00`000000oooo0?ooo`0?
0?ooo`030000003oool0oooo01`0oooo00<000000?ooo`3oool01@3oool00`000000oooo0?ooo`0C
0?ooo`h00000103ooolH000002h0oooo1@00001W0?ooo`030000003oool0oooo02P0oooo00<00000
0?ooo`3oool06@3oool00`000000oooo0?ooo`0B0?ooo`<00000=`3oool00`000000oooo0?ooo`08
0?ooo`030000003oool0oooo04<0oooo00<000000?ooo`3oool0903oool001T0oooo00<000000?oo
o`3oool0H`3oool:000001/0oooo00<000000?ooo`3oool02@3oool00`000000oooo0?ooo`0?0?oo
o`030000003oool0oooo01d0oooo00<000000?ooo`3oool01@3oool00`000000oooo0?ooo`0B0?oo
oa800000B`3oool4000006<0oooo00<000000?ooo`3oool0:03oool00`000000oooo0?ooo`0I0?oo
o`030000003oool0oooo00h0oooo1000000j0?ooo`030000003oool0oooo00T0oooo00<000000?oo
o`3oool0@P3oool00`000000oooo0?ooo`0T0?ooo`006@3oool00`000000oooo0?ooo`1T0?ooo`P0
00006`3oool00`000000oooo0?ooo`090?ooo`030000003oool0oooo0140oooo00<000000?ooo`3o
ool07@3oool00`000000oooo0?ooo`050?ooo`030000003oool0oooo0140oooo3P00001C0?ooo`@0
0000G`3oool00`000000oooo0?ooo`0X0?ooo`030000003oool0oooo01T0oooo00<000000?ooo`3o
ool02`3oool3000003l0oooo00<000000?ooo`3oool0203oool00`000000oooo0?ooo`120?ooo`03
0000003oool0oooo02@0oooo000I0?ooo`030000003oool0oooo06D0oooo1P00000L0?ooo`030000
003oool0oooo00T0oooo00<000000?ooo`3oool04@3oool00`000000oooo0?ooo`0N0?ooo`030000
003oool0oooo00D0oooo00<000000?ooo`3oool0403oool>000005L0oooo1@00001J0?ooo`030000
003oool0oooo02P0oooo00<000000?ooo`3oool06@3oool00`000000oooo0?ooo`080?ooo`<00000
@`3oool00`000000oooo0?ooo`070?ooo`030000003oool0oooo0480oooo00<000000?ooo`3oool0
903oool001T0oooo00<000000?ooo`3oool0I`3oool010000000oooo0?ooo`00000K0?ooo`030000
003oool0oooo00X0oooo00<000000?ooo`3oool04@3oool00`000000oooo0?ooo`0O0?ooo`030000
003oool0oooo00D0oooo00<000000?ooo`3oool03`3oool=000005d0oooo1000001F0?ooo`030000
003oool0oooo02P0oooo00<000000?ooo`3oool06@3oool00`000000oooo0?ooo`050?ooo`<00000
AP3oool00`000000oooo0?ooo`080?ooo`030000003oool0oooo0440oooo00<000000?ooo`3oool0
903oool001T0oooo00<000000?ooo`3oool0I`3oool01@000000oooo0?ooo`3oool0000001T0oooo
00<000000?ooo`3oool02P3oool00`000000oooo0?ooo`0B0?ooo`030000003oool0oooo0200oooo
00<000000?ooo`3oool01@3oool00`000000oooo0?ooo`0?0?ooo``00000H@3oool500000580oooo
00<000000?ooo`3oool09`3oool00`000000oooo0?ooo`0I0?ooo`040000003oool0oooo0?ooo`@0
0000BP3oool00`000000oooo0?ooo`070?ooo`030000003oool0oooo0440oooo00<000000?ooo`3o
ool0903oool001P0oooo00<000000?ooo`3oool0J03oool01@000000oooo0?ooo`3oool0000001T0
oooo00<000000?ooo`3oool02P3oool00`000000oooo0?ooo`0B0?ooo`030000003oool0oooo0240
oooo00<000000?ooo`3oool01@3oool00`000000oooo0?ooo`0?0?ooo`X00000I`3oool4000004h0
oooo00<000000?ooo`3oool09`3oool00`000000oooo0?ooo`0I0?ooo`@00000CP3oool00`000000
oooo0?ooo`080?ooo`030000003oool0oooo0400oooo00<000000?ooo`3oool0903oool001P0oooo
00<000000?ooo`3oool0J03oool00`000000oooo0?ooo`020?ooo`030000003oool0oooo01D0oooo
00<000000?ooo`3oool02`3oool00`000000oooo0?ooo`0B0?ooo`030000003oool0oooo0280oooo
00<000000?ooo`3oool01@3oool00`000000oooo0?ooo`0?0?ooo`P00000K03oool4000004X0oooo
00<000000?ooo`3oool09`3oool00`000000oooo0?ooo`0G0?ooo`<00000DP3oool00`000000oooo
0?ooo`070?ooo`030000003oool0oooo0400oooo00<000000?ooo`3oool0903oool001P0oooo00<0
00000?ooo`3oool0J03oool00`000000oooo0?ooo`020?ooo`030000003oool0oooo01@0oooo00<0
00000?ooo`3oool02`3oool00`000000oooo0?ooo`0C0?ooo`030000003oool0oooo02<0oooo00<0
00000?ooo`3oool01@3oool00`000000oooo0?ooo`0?0?ooo`H00000L@3oool5000004D0oooo00<0
00000?ooo`3oool09P3oool2000001H0oooo0`0000020?ooo`030000003oool0oooo0540oooo00<0
00000?ooo`3oool01`3oool00`000000oooo0?ooo`100?ooo`030000003oool0oooo02<0oooo000H
0?ooo`030000003oool0oooo06P0oooo00<000000?ooo`3oool00`3oool00`000000oooo0?ooo`0B
0?ooo`030000003oool0oooo00`0oooo00<000000?ooo`3oool0503oool00`000000oooo0?ooo`0S
0?ooo`030000003oool0oooo00D0oooo00<000000?ooo`3oool03@3oool00`000000oooo0?ooo`1j
0?ooo`@00000@P3oool00`000000oooo0?ooo`0R0?ooo`<000000P3oool00`000000oooo0?ooo`0?
0?ooo`@000001@3oool00`000000oooo0?ooo`1A0?ooo`030000003oool0oooo00L0oooo00<00000
0?ooo`3oool0@03oool00`000000oooo0?ooo`0S0?ooo`00603oool00`000000oooo0?ooo`1X0?oo
o`030000003oool0oooo00<0oooo00<000000?ooo`3oool04P3oool00`000000oooo0?ooo`0<0?oo
o`030000003oool0oooo01@0oooo00<000000?ooo`3oool0903oool00`000000oooo0?ooo`050?oo
o`030000003oool0oooo00`0oooo00<000000?ooo`3oool0OP3oool4000003h0oooo00<000000?oo
o`3oool07P3oool4000000H0oooo00<000000?ooo`3oool02`3oool3000000T0oooo00<000000?oo
o`3oool0DP3oool00`000000oooo0?ooo`070?ooo`030000003oool0oooo03l0oooo00<000000?oo
o`3oool08`3oool001P0oooo00<000000?ooo`3oool0J03oool00`000000oooo0?ooo`040?ooo`03
0000003oool0oooo0100oooo00<000000?ooo`3oool0303oool00`000000oooo0?ooo`0E0?ooo`03
0000003oool0oooo02D0oooo00<000000?ooo`3oool01@3oool00`000000oooo0?ooo`0;0?ooo`03
0000003oool0oooo0880oooo1@00000i0?ooo`030000003oool0oooo01/0oooo0`00000:0?ooo`03
0000003oool0oooo00P0oooo0`00000<0?ooo`030000003oool0oooo05<0oooo00<000000?ooo`3o
ool01P3oool00`000000oooo0?ooo`0o0?ooo`030000003oool0oooo02<0oooo000H0?ooo`030000
003oool0oooo06P0oooo00<000000?ooo`3oool0103oool00`000000oooo0?ooo`0?0?ooo`030000
003oool0oooo00d0oooo00<000000?ooo`3oool05@3oool00`000000oooo0?ooo`0V0?ooo`030000
003oool0oooo00D0oooo00<000000?ooo`3oool02@3oool00`000000oooo0?ooo`280?ooo`@00000
=@3oool00`000000oooo0?ooo`0H0?ooo`<000003P3oool00`000000oooo0?ooo`040?ooo`<00000
3`3oool00`000000oooo0?ooo`1C0?ooo`030000003oool0oooo00H0oooo00<000000?ooo`3oool0
?`3oool00`000000oooo0?ooo`0S0?ooo`005`3oool00`000000oooo0?ooo`1Y0?ooo`030000003o
ool0oooo00D0oooo00<000000?ooo`3oool03P3oool00`000000oooo0?ooo`0=0?ooo`030000003o
ool0oooo01D0oooo00<000000?ooo`3oool09`3oool00`000000oooo0?ooo`050?ooo`030000003o
ool0oooo00P0oooo00<000000?ooo`3oool0S03oool400000340oooo00<000000?ooo`3oool05@3o
ool300000180oooo00<000000?ooo`3oool00`00000B0?ooo`030000003oool0oooo05@0oooo00<0
00000?ooo`3oool01P3oool00`000000oooo0?ooo`0n0?ooo`030000003oool0oooo02<0oooo000G
0?ooo`030000003oool0oooo06T0oooo00<000000?ooo`3oool01@3oool00`000000oooo0?ooo`0=
0?ooo`030000003oool0oooo00d0oooo00<000000?ooo`3oool05P3oool00`000000oooo0?ooo`0X
0?ooo`030000003oool0oooo00D0oooo00<000000?ooo`3oool01`3oool00`000000oooo0?ooo`2@
0?ooo`D00000;@3oool00`000000oooo0?ooo`0A0?ooo`<00000503oool4000001D0oooo00<00000
0?ooo`3oool0E03oool00`000000oooo0?ooo`060?ooo`030000003oool0oooo03h0oooo00<00000
0?ooo`3oool08`3oool001L0oooo00<000000?ooo`3oool0J@3oool00`000000oooo0?ooo`060?oo
o`030000003oool0oooo00/0oooo00<000000?ooo`3oool03P3oool00`000000oooo0?ooo`0F0?oo
o`030000003oool0oooo02T0oooo00<000000?ooo`3oool01@3oool00`000000oooo0?ooo`050?oo
o`030000003oool0oooo09H0oooo1000000Y0?ooo`030000003oool0oooo00d0oooo1000000D0?oo
o`<000000`3oool00`000000oooo0?ooo`0C0?ooo`030000003oool0oooo05D0oooo00<000000?oo
o`3oool01P3oool00`000000oooo0?ooo`0n0?ooo`030000003oool0oooo0280oooo000G0?ooo`03
0000003oool0oooo06T0oooo00<000000?ooo`3oool01P3oool00`000000oooo0?ooo`0;0?ooo`03
0000003oool0oooo00d0oooo00<000000?ooo`3oool0603oool00`000000oooo0?ooo`0Y0?ooo`03
0000003oool0oooo00D0oooo00<000000?ooo`3oool0103oool00`000000oooo0?ooo`2J0?ooo`@0
00009@3oool00`000000oooo0?ooo`0:0?ooo`<000005@3oool3000000L0oooo00<000000?ooo`3o
ool04P3oool00`000000oooo0?ooo`1F0?ooo`030000003oool0oooo00D0oooo00<000000?ooo`3o
ool0?P3oool00`000000oooo0?ooo`0R0?ooo`005`3oool00`000000oooo0?ooo`1Y0?ooo`030000
003oool0oooo00L0oooo00<000000?ooo`3oool02@3oool00`000000oooo0?ooo`0>0?ooo`030000
003oool0oooo01P0oooo00<000000?ooo`3oool0:P3oool00`000000oooo0?ooo`050?ooo`030000
003oool0oooo00<0oooo00<000000?ooo`3oool0WP3oool500000200oooo00<000000?ooo`3oool0
1`3oool3000001D0oooo0`00000:0?ooo`030000003oool0oooo0180oooo00<000000?ooo`3oool0
EP3oool00`000000oooo0?ooo`060?ooo`030000003oool0oooo03d0oooo00<000000?ooo`3oool0
8P3oool001L0oooo00<000000?ooo`3oool0J@3oool00`000000oooo0?ooo`070?ooo`030000003o
ool0oooo00P0oooo00<000000?ooo`3oool03`3oool00`000000oooo0?ooo`0H0?ooo`030000003o
ool0oooo02/0oooo00<000000?ooo`3oool01@3oool01@000000oooo0?ooo`3oool000000:H0oooo
1000000M0?ooo`030000003oool0oooo00<0oooo0`00000D0?ooo`@000003P3oool00`000000oooo
0?ooo`0A0?ooo`030000003oool0oooo05L0oooo00<000000?ooo`3oool01@3oool00`000000oooo
0?ooo`0m0?ooo`030000003oool0oooo0280oooo000F0?ooo`030000003oool0oooo06X0oooo00<0
00000?ooo`3oool0203oool00`000000oooo0?ooo`070?ooo`030000003oool0oooo00h0oooo00<0
00000?ooo`3oool06@3oool00`000000oooo0?ooo`0/0?ooo`030000003oool0oooo00D0oooo00@0
00000?ooo`3oool00000ZP3oool4000001T0oooo00<000000?ooo`0000000`00000D0?ooo`<00000
4`3oool00`000000oooo0?ooo`0@0?ooo`030000003oool0oooo05P0oooo00<000000?ooo`3oool0
103oool00`000000oooo0?ooo`0m0?ooo`030000003oool0oooo0280oooo000F0?ooo`030000003o
ool0oooo06X0oooo00<000000?ooo`3oool0203oool00`000000oooo0?ooo`060?ooo`030000003o
ool0oooo00l0oooo00<000000?ooo`3oool06@3oool00`000000oooo0?ooo`0]0?ooo`030000003o
ool0oooo00D0oooo0`00002^0?ooo`D000004`3oool3000001D0oooo0`00000G0?ooo`030000003o
ool0oooo00l0oooo00<000000?ooo`3oool0F03oool00`000000oooo0?ooo`050?ooo`030000003o
ool0oooo03`0oooo00<000000?ooo`3oool08P3oool001H0oooo00<000000?ooo`3oool0JP3oool0
0`000000oooo0?ooo`090?ooo`030000003oool0oooo00@0oooo00<000000?ooo`3oool0403oool0
0`000000oooo0?ooo`0I0?ooo`030000003oool0oooo02h0oooo00<000000?ooo`3oool01@3oool2
00000;<0oooo1000000<0?ooo`<0000000<0oooo0000003oool04P3oool3000001/0oooo00<00000
0?ooo`3oool03P3oool00`000000oooo0?ooo`1I0?ooo`030000003oool0oooo00@0oooo00<00000
0?ooo`3oool0?03oool00`000000oooo0?ooo`0R0?ooo`005P3oool00`000000oooo0?ooo`1Z0?oo
o`030000003oool0oooo00T0oooo00<000000?ooo`3oool0103oool00`000000oooo0?ooo`0?0?oo
o`030000003oool0oooo01/0oooo00<000000?ooo`3oool0;P3oool00`000000oooo0?ooo`040?oo
o`030000003oool000000;H0oooo100000050?ooo`<00000103oool00`000000oooo0?ooo`0>0?oo
o`<000007`3oool00`000000oooo0?ooo`0=0?ooo`030000003oool0oooo05X0oooo00<000000?oo
o`3oool0103oool00`000000oooo0?ooo`0k0?ooo`030000003oool0oooo0280oooo000F0?ooo`03
0000003oool0oooo06X0oooo00<000000?ooo`3oool02P3oool00`000000oooo0?ooo`020?ooo`03
0000003oool0oooo0100oooo00<000000?ooo`3oool06`3oool00`000000oooo0?ooo`0_0?ooo`03
0000003oool0oooo00<0oooo00@000000?ooo`3oool00000^@3oool5000000P0oooo00<000000?oo
o`3oool02@3oool400000280oooo00<000000?ooo`3oool03@3oool00`000000oooo0?ooo`1J0?oo
o`030000003oool0oooo00@0oooo00<000000?ooo`3oool0?03oool00`000000oooo0?ooo`0Q0?oo
o`005P3oool00`000000oooo0?ooo`1Y0?ooo`030000003oool0oooo00/0oooo00D000000?ooo`3o
ool0oooo0000000C0?ooo`030000003oool0oooo01/0oooo00<000000?ooo`3oool0<03oool01@00
0000oooo0?ooo`3oool0000000@0oooo00<000000?ooo`3oool0]03oool3000000@0oooo10000004
0?ooo`030000003oool0oooo00H0oooo0`00000W0?ooo`030000003oool0oooo00`0oooo00<00000
0?ooo`3oool0F`3oool00`000000oooo0?ooo`040?ooo`030000003oool0oooo03/0oooo00<00000
0?ooo`3oool08@3oool001D0oooo00<000000?ooo`3oool0JP3oool00`000000oooo0?ooo`0<0?oo
o`040000003oool0oooo00000180oooo00<000000?ooo`3oool0703oool00`000000oooo0?ooo`0a
0?ooo`040000003oool0oooo000000D0oooo00<000000?ooo`3oool0/03oool3000000/0oooo1@00
00050?ooo`<00000:`3oool00`000000oooo0?ooo`0;0?ooo`030000003oool0oooo05/0oooo00<0
00000?ooo`3oool0103oool00`000000oooo0?ooo`0k0?ooo`030000003oool0oooo0240oooo000E
0?ooo`030000003oool0oooo06X0oooo00<000000?ooo`3oool0303oool00`000000oooo0000000C
0?ooo`030000003oool0oooo01`0oooo00<000000?ooo`3oool0<P3oool00`000000oooo00000006
0?ooo`030000003oool0oooo0:`0oooo0`00000B0?ooo`H00000;`3oool00`000000oooo0?ooo`0:
0?ooo`030000003oool0oooo05`0oooo00<000000?ooo`3oool0103oool00`000000oooo0?ooo`0j
0?ooo`030000003oool0oooo0240oooo000E0?ooo`030000003oool0oooo06X0oooo00<000000?oo
o`3oool03@3oool00`000000oooo0?ooo`0B0?ooo`030000003oool0oooo01`0oooo00<000000?oo
o`3oool0<`3oool00`000000oooo0?ooo`060?ooo`030000003oool0oooo0:P0oooo0`00000D0?oo
o`@000000P3oool4000002d0oooo00<000000?ooo`3oool02P3oool00`000000oooo0?ooo`1L0?oo
o`030000003oool0oooo00<0oooo00<000000?ooo`3oool0>P3oool00`000000oooo0?ooo`0Q0?oo
o`005@3oool00`000000oooo0?ooo`1Z0?ooo`030000003oool0oooo00d0oooo00<000000?ooo`3o
ool04@3oool00`000000oooo0?ooo`0M0?ooo`030000003oool0oooo03<0oooo0P0000080?ooo`03
0000003oool0oooo0:<0oooo1000000D0?ooo`<000000P3oool00`000000oooo0?ooo`050?ooo`@0
0000:P3oool00`000000oooo0?ooo`090?ooo`030000003oool0oooo05`0oooo00<000000?ooo`3o
ool00`3oool00`000000oooo0?ooo`0j0?ooo`030000003oool0oooo0240oooo000E0?ooo`030000
003oool0oooo06X0oooo00<000000?ooo`3oool0303oool00`000000oooo0000000B0?ooo`030000
003oool0oooo01h0oooo00<000000?ooo`3oool0<P3oool00`000000oooo000000080?ooo`030000
003oool0oooo09l0oooo0`00000E0?ooo`<000001@3oool00`000000oooo0?ooo`090?ooo`D00000
9@3oool00`000000oooo0?ooo`090?ooo`030000003oool0oooo05d0oooo00<000000?ooo`3oool0
0`3oool00`000000oooo0?ooo`0i0?ooo`030000003oool0oooo0240oooo000E0?ooo`030000003o
ool0oooo06X0oooo00<000000?ooo`3oool02`3oool010000000oooo0?ooo`00000A0?ooo`030000
003oool0oooo01l0oooo00<000000?ooo`3oool0<@3oool01@000000oooo0?ooo`3oool0000000P0
oooo00<000000?ooo`3oool0V`3oool3000001D0oooo0`0000080?ooo`030000003oool0oooo00h0
oooo1000000R0?ooo`030000003oool0oooo00P0oooo00<000000?ooo`3oool0GP3oool00`000000
oooo0?ooo`020?ooo`030000003oool0oooo03X0oooo00<000000?ooo`3oool0803oool001D0oooo
00<000000?ooo`3oool0JP3oool00`000000oooo0?ooo`0;0?ooo`050000003oool0oooo0?ooo`00
0000403oool00`000000oooo0?ooo`0O0?ooo`030000003oool0oooo0340oooo00<000000?ooo`3o
ool00P3oool00`000000oooo0?ooo`060?ooo`030000003oool0oooo09L0oooo0`00000D0?ooo`@0
00002`3oool00`000000oooo0?ooo`0B0?ooo`@000007`3oool00`000000oooo0?ooo`070?ooo`03
0000003oool0oooo05h0oooo00<000000?ooo`3oool00`3oool00`000000oooo0?ooo`0i0?ooo`03
0000003oool0oooo0200oooo000D0?ooo`030000003oool0oooo06/0oooo00<000000?ooo`3oool0
2P3oool00`000000oooo0?ooo`020?ooo`030000003oool0oooo00h0oooo00<000000?ooo`3oool0
7`3oool00`000000oooo0?ooo`0a0?ooo`030000003oool0oooo00<0oooo00<000000?ooo`3oool0
1P3oool00`000000oooo0?ooo`2B0?ooo`@00000503oool300000100oooo00<000000?ooo`3oool0
5@3oool5000001/0oooo00<000000?ooo`3oool01P3oool00`000000oooo0?ooo`1O0?ooo`030000
003oool0oooo0080oooo00<000000?ooo`3oool0>@3oool00`000000oooo0?ooo`0P0?ooo`00503o
ool00`000000oooo0?ooo`1[0?ooo`030000003oool0oooo00T0oooo00<000000?ooo`3oool0103o
ool00`000000oooo0?ooo`0<0?ooo`030000003oool0oooo0200oooo00<000000?ooo`3oool0<03o
ool00`000000oooo0?ooo`050?ooo`030000003oool0oooo00H0oooo00<000000?ooo`3oool0SP3o
ool3000001D0oooo0`00000C0?ooo`030000003oool0oooo01X0oooo1000000H0?ooo`030000003o
ool0oooo00D0oooo00<000000?ooo`3oool0H03oool00`000000oooo0?ooo`020?ooo`030000003o
ool0oooo03P0oooo00<000000?ooo`3oool0803oool001@0oooo00<000000?ooo`3oool0J`3oool0
0`000000oooo0?ooo`090?ooo`030000003oool0oooo00@0oooo00<000000?ooo`3oool0303oool0
0`000000oooo0?ooo`0P0?ooo`030000003oool0oooo0300oooo00<000000?ooo`3oool01P3oool0
0`000000oooo0?ooo`060?ooo`030000003oool0oooo08X0oooo0`00000E0?ooo`<000005P3oool0
0`000000oooo0?ooo`0N0?ooo`@000005@3oool00`000000oooo0?ooo`040?ooo`030000003oool0
oooo0600oooo00<000000?ooo`3oool00P3oool00`000000oooo0?ooo`0h0?ooo`030000003oool0
oooo0200oooo000D0?ooo`030000003oool0oooo06/0oooo00<000000?ooo`3oool0203oool00`00
0000oooo0?ooo`060?ooo`030000003oool0oooo00/0oooo00<000000?ooo`3oool0803oool00`00
0000oooo0?ooo`0`0?ooo`030000003oool0oooo00L0oooo00<000000?ooo`3oool01P3oool00`00
0000oooo0?ooo`260?ooo`<000005@3oool3000001T0oooo00<000000?ooo`3oool08P3oool50000
0100oooo00@000000?ooo`3oool0oooo1P00001Q0?ooo`050000003oool0oooo0?ooo`000000>P3o
ool00`000000oooo0?ooo`0P0?ooo`00503oool00`000000oooo0?ooo`1[0?ooo`030000003oool0
oooo00L0oooo00<000000?ooo`3oool01`3oool00`000000oooo0?ooo`0:0?ooo`030000003oool0
oooo0280oooo00<000000?ooo`3oool0;P3oool00`000000oooo0?ooo`090?ooo`8000001`3oool0
0`000000oooo0?ooo`210?ooo`@00000503oool4000001d0oooo00<000000?ooo`3oool09P3oool4
000000d0oooo00<000000?ooo`0000001`00001P0?ooo`030000003oool0oooo0080oooo00<00000
0?ooo`3oool0=`3oool00`000000oooo0?ooo`0P0?ooo`00503oool00`000000oooo0?ooo`1[0?oo
o`030000003oool0oooo00H0oooo00<000000?ooo`3oool02@3oool00`000000oooo0?ooo`090?oo
o`030000003oool0oooo0280oooo00<000000?ooo`3oool0;P3oool00`000000oooo0?ooo`0;0?oo
o`030000003oool0oooo00D0oooo00<000000?ooo`3oool0O@3oool3000001D0oooo0`00000Q0?oo
o`030000003oool0oooo02X0oooo1000000:0?ooo`X00000H03oool01@000000oooo0?ooo`3oool0
000003T0oooo00<000000?ooo`3oool0803oool001<0oooo00<000000?ooo`3oool0K03oool00`00
0000oooo0?ooo`060?ooo`030000003oool0oooo00T0oooo00<000000?ooo`3oool02@3oool00`00
0000oooo0?ooo`0R0?ooo`030000003oool0oooo02h0oooo00<000000?ooo`3oool0303oool00`00
0000oooo0?ooo`050?ooo`030000003oool0oooo07T0oooo0`00000E0?ooo`<00000903oool00`00
0000oooo0?ooo`0^0?ooo`D00000103oool<00000600oooo00D000000?ooo`3oool0oooo0000000i
0?ooo`030000003oool0oooo01l0oooo000C0?ooo`030000003oool0oooo06`0oooo00<000000?oo
o`3oool01@3oool00`000000oooo0?ooo`0;0?ooo`030000003oool0oooo00L0oooo00<000000?oo
o`3oool08`3oool00`000000oooo0?ooo`0]0?ooo`030000003oool0oooo00h0oooo00<000000?oo
o`3oool01@3oool00`000000oooo0?ooo`1e0?ooo`<000005@3oool3000002L0oooo00<000000?oo
o`3oool0<`3oool@00000600oooo00D000000?ooo`3oool0oooo0000000i0?ooo`030000003oool0
oooo01l0oooo000C0?ooo`030000003oool0oooo06`0oooo00<000000?ooo`3oool0103oool00`00
0000oooo0?ooo`0<0?ooo`030000003oool0oooo00L0oooo00<000000?ooo`3oool08`3oool00`00
0000oooo0?ooo`0]0?ooo`030000003oool0oooo00l0oooo00<000000?ooo`3oool01@3oool00`00
0000oooo0?ooo`1a0?ooo`<00000503oool4000002X0oooo00<000000?ooo`3oool0=P3oool>0000
0600oooo00D000000?ooo`3oool0oooo0000000h0?ooo`030000003oool0oooo01l0oooo000C0?oo
o`030000003oool0oooo06`0oooo00<000000?ooo`3oool0103oool00`000000oooo0?ooo`0=0?oo
o`030000003oool0oooo00H0oooo00<000000?ooo`3oool08`3oool00`000000oooo0?ooo`0/0?oo
o`030000003oool0oooo0140oooo00<000000?ooo`3oool01@3oool00`000000oooo0?ooo`1/0?oo
o`@00000503oool3000002l0oooo00<000000?ooo`3oool0=@3oool>00000640oooo00@000000?oo
o`3oool00000>03oool00`000000oooo0?ooo`0O0?ooo`004`3oool00`000000oooo0?ooo`1/0?oo
o`030000003oool0oooo00<0oooo00<000000?ooo`3oool03P3oool00`000000oooo0?ooo`050?oo
o`030000003oool0oooo02@0oooo00<000000?ooo`3oool0;03oool00`000000oooo0?ooo`0B0?oo
o`030000003oool0oooo00D0oooo00<000000?ooo`3oool0J03oool3000001D0oooo0`00000b0?oo
o`030000003oool0oooo03D0oooo4@00001N0?ooo`050000003oool0oooo0?ooo`000000=`3oool0
0`000000oooo0?ooo`0O0?ooo`004`3oool00`000000oooo0?ooo`1/0?ooo`030000003oool0oooo
0080oooo00<000000?ooo`3oool0403oool00`000000oooo0?ooo`040?ooo`030000003oool0oooo
02D0oooo00<000000?ooo`3oool0:`3oool00`000000oooo0?ooo`0C0?ooo`030000003oool0oooo
00D0oooo00<000000?ooo`3oool0I03oool3000001D0oooo0`00000e0?ooo`030000003oool0oooo
03D0oooo3P0000030?ooo`H00000F@3oool010000000oooo0?ooo`00000g0?ooo`030000003oool0
oooo01l0oooo000B0?ooo`030000003oool0oooo06d0oooo00<000000?ooo`3oool00P3oool00`00
0000oooo0?ooo`0@0?ooo`030000003oool0oooo00<0oooo00<000000?ooo`3oool09P3oool00`00
0000oooo0?ooo`0Z0?ooo`030000003oool0oooo01D0oooo00<000000?ooo`3oool01@3oool00`00
0000oooo0?ooo`1P0?ooo`<000005@3oool3000003P0oooo00<000000?ooo`3oool0<P3oool@0000
00X0oooo1`00001B0?ooo`040000003oool0oooo000003L0oooo00<000000?ooo`3oool07`3oool0
0180oooo00<000000?ooo`3oool0J`3oool7000001@0oooo00<000000?ooo`3oool00P3oool00`00
0000oooo0?ooo`0V0?ooo`030000003oool0oooo02X0oooo00<000000?ooo`3oool05P3oool00`00
0000oooo0?ooo`050?ooo`030000003oool0oooo05/0oooo1000000D0?ooo`@00000?03oool00`00
0000oooo0?ooo`0_0?ooo`800000103oool=00000100oooo1P00001=0?ooo`040000003oool0oooo
000003L0oooo00<000000?ooo`3oool07P3oool00180oooo00<000000?ooo`3oool0JP3oool80000
01@0oooo00<000000?ooo`3oool00P3oool00`000000oooo0?ooo`0V0?ooo`030000003oool0oooo
02X0oooo00<000000?ooo`3oool05`3oool00`000000oooo0?ooo`050?ooo`030000003oool0oooo
05L0oooo0`00000E0?ooo`<00000@03oool00`000000oooo0?ooo`0/0?ooo`<000001`3oool:0000
0080oooo00<000000?ooo`3oool04`3oool7000004L0oooo00<000000?ooo`000000=`3oool00`00
0000oooo0?ooo`0N0?ooo`004P3oool00`000000oooo0?ooo`1Y0?ooo`X00000503oool010000000
oooo0?ooo`00000Y0?ooo`030000003oool0oooo02T0oooo00<000000?ooo`3oool06@3oool00`00
0000oooo0?ooo`050?ooo`030000003oool0oooo05<0oooo0`00000E0?ooo`<00000@`3oool00`00
0000oooo0?ooo`0Y0?ooo`<000002`3oool8000000@0oooo00<000000?ooo`3oool06@3oool60000
0440oooo00@000000?ooo`3oool00000=P3oool00`000000oooo0?ooo`0N0?ooo`004P3oool00`00
0000oooo0?ooo`1X0?ooo``000004`3oool010000000oooo0?ooo`00000Y0?ooo`030000003oool0
oooo02T0oooo00<000000?ooo`3oool06P3oool00`000000oooo0?ooo`050?ooo`030000003oool0
oooo04l0oooo0`00000E0?ooo`<00000AP3oool00`000000oooo0?ooo`0V0?ooo`<000003`3oool6
000000030?ooo`000000oooo00<0oooo0P00000O0?ooo`H00000?03oool00`000000oooo0000000f
0?ooo`030000003oool0oooo01h0oooo000B0?ooo`030000003oool0oooo06L0oooo3@00000D0?oo
o`030000003oool0000002T0oooo00<000000?ooo`3oool0:@3oool00`000000oooo0?ooo`0K0?oo
o`030000003oool0oooo00D0oooo00<000000?ooo`3oool0B`3oool3000001@0oooo100000190?oo
o`030000003oool0oooo02<0oooo0`00000D0?ooo`030000003oool0oooo00<0oooo00<000000?oo
o`3oool00`3oool00`000000oooo0?ooo`0R0?ooo`L00000=P3oool00`000000oooo0000000e0?oo
o`030000003oool0oooo01h0oooo000B0?ooo`030000003oool0oooo06L0oooo3P00000C0?ooo`80
0000:`3oool00`000000oooo0?ooo`0W0?ooo`030000003oool0oooo01d0oooo00<000000?ooo`3o
ool01@3oool00`000000oooo0?ooo`160?ooo`@00000503oool3000004h0oooo00<000000?ooo`3o
ool07`3oool3000001L0oooo00<000000?ooo`3oool0103oool00`000000oooo0?ooo`030?ooo`80
0000:@3oool600000300oooo00<000000?ooo`000000=@3oool00`000000oooo0?ooo`0N0?ooo`00
4@3oool00`000000oooo0?ooo`1X0?ooo`h00000503oool00`000000oooo0?ooo`0Y0?ooo`030000
003oool0oooo02L0oooo00<000000?ooo`3oool07P3oool00`000000oooo0?ooo`050?ooo`030000
003oool0oooo0480oooo0`00000E0?ooo`<00000D@3oool00`000000oooo0?ooo`0L0?ooo`<00000
6P3oool00`000000oooo0?ooo`050?ooo`030000003oool0oooo00@0oooo00<000000?ooo`3oool0
;03oool7000002X0oooo0P00000e0?ooo`030000003oool0oooo01h0oooo000A0?ooo`030000003o
ool0oooo06P0oooo3P00000D0?ooo`030000003oool0oooo02T0oooo00<000000?ooo`3oool09`3o
ool00`000000oooo0?ooo`0O0?ooo`030000003oool0oooo00D0oooo00<000000?ooo`3oool0?P3o
ool3000001D0oooo0`00001D0?ooo`030000003oool0oooo01T0oooo0`00000M0?ooo`030000003o
ool0oooo00H0oooo00<000000?ooo`3oool0103oool00`000000oooo0?ooo`0b0?ooo`H000009@3o
ool2000003@0oooo00<000000?ooo`3oool07P3oool00140oooo00<000000?ooo`3oool0J03oool>
000001<0oooo00<000000?ooo`000000:P3oool00`000000oooo0?ooo`0V0?ooo`030000003oool0
oooo0240oooo00<000000?ooo`3oool01@3oool00`000000oooo0?ooo`0j0?ooo`<00000503oool4
000005L0oooo00<000000?ooo`3oool05`3oool200000200oooo00<000000?ooo`3oool01P3oool0
0`000000oooo0?ooo`050?ooo`800000>03oool6000001l0oooo1`00000`0?ooo`030000003oool0
oooo01d0oooo000A0?ooo`030000003oool0oooo06P0oooo3@00000D0?ooo`030000003oool00000
02X0oooo00<000000?ooo`3oool09P3oool00`000000oooo0?ooo`0R0?ooo`030000003oool0oooo
00D0oooo00<000000?ooo`3oool0=@3oool4000001@0oooo0`00001L0?ooo`030000003oool0oooo
01<0oooo0`00000R0?ooo`030000003oool0oooo00L0oooo00<000000?ooo`3oool01P3oool00`00
0000oooo0?ooo`0k0?ooo`L00000603oool8000002l0oooo00<000000?ooo`3oool07@3oool00140
oooo00<000000?ooo`3oool0J@3oool<000001@0oooo00@000000?ooo`3oool00000:@3oool00`00
0000oooo0?ooo`0V0?ooo`030000003oool0oooo02<0oooo00<000000?ooo`3oool01@3oool20000
0380oooo0`00000E0?ooo`<00000G`3oool00`000000oooo0?ooo`0@0?ooo`<00000903oool00`00
0000oooo0?ooo`090?ooo`030000003oool0oooo00H0oooo00<000000?ooo`3oool0@@3oool60000
0140oooo2P00000^0?ooo`030000003oool0oooo01d0oooo000A0?ooo`030000003oool0oooo06X0
oooo2P00000D0?ooo`050000003oool0oooo0?ooo`000000:P3oool00`000000oooo0?ooo`0T0?oo
o`030000003oool0oooo02D0oooo00<000000?ooo`3oool01P3oool00`000000oooo0?ooo`0/0?oo
o`<000005@3oool300000680oooo00<000000?ooo`3oool03@3oool3000002L0oooo00<000000?oo
o`3oool02P3oool00`000000oooo0?ooo`060?ooo`800000A`3oool7000000T0oooo3000000]0?oo
o`030000003oool0oooo01d0oooo000@0?ooo`030000003oool0oooo06`0oooo2@00000D0?ooo`03
0000003oool0oooo0080oooo00<000000?ooo`3oool09`3oool00`000000oooo0?ooo`0T0?ooo`03
0000003oool0oooo02H0oooo00<000000?ooo`3oool01P3oool00`000000oooo0?ooo`0X0?ooo`<0
00005@3oool3000006D0oooo00<000000?ooo`3oool02P3oool3000002X0oooo00<000000?ooo`3o
ool02`3oool00`000000oooo0?ooo`070?ooo`030000003oool0oooo04/0oooo1P0000020?ooo`d0
0000;@3oool00`000000oooo0?ooo`0M0?ooo`00403oool00`000000oooo0?ooo`1]0?ooo`H00000
00<0oooo0000003oool04P3oool00`000000oooo0?ooo`030?ooo`030000003oool0oooo02L0oooo
00<000000?ooo`3oool0903oool00`000000oooo0?ooo`0W0?ooo`030000003oool0oooo00H0oooo
00<000000?ooo`3oool08`3oool4000001@0oooo1000001X0?ooo`030000003oool0oooo00L0oooo
0`00000]0?ooo`030000003oool0oooo00`0oooo00<000000?ooo`3oool01`3oool200000540oooo
4000000/0?ooo`030000003oool0oooo01d0oooo000@0?ooo`030000003oool0oooo0740oooo00D0
00000?ooo`3oool0oooo0000000B0?ooo`030000003oool0oooo00@0oooo00<000000?ooo`3oool0
9P3oool00`000000oooo0?ooo`0S0?ooo`030000003oool0oooo02T0oooo00<000000?ooo`3oool0
1P3oool00`000000oooo0?ooo`0O0?ooo`<000005@3oool3000006d0oooo00<000000?ooo`3oool0
0`3oool300000300oooo00<000000?ooo`3oool0303oool00`000000oooo0?ooo`090?ooo`030000
003oool0oooo0500oooo3P00000/0?ooo`030000003oool0oooo01d0oooo000@0?ooo`030000003o
ool0oooo0780oooo00D000000?ooo`3oool0oooo0000000A0?ooo`030000003oool0oooo00@0oooo
00<000000?ooo`3oool09P3oool00`000000oooo0?ooo`0S0?ooo`030000003oool0oooo02X0oooo
00<000000?ooo`3oool01P3oool00`000000oooo0?ooo`0K0?ooo`<000005@3oool300000700oooo
00<000000?ooo`3oool00`00000c0?ooo`030000003oool0oooo00d0oooo00<000000?ooo`3oool0
2@3oool00`000000oooo0?ooo`1?0?ooo`h00000;@3oool00`000000oooo0?ooo`0L0?ooo`00403o
ool00`000000oooo0?ooo`1b0?ooo`030000003oool0oooo0080oooo00<000000?ooo`3oool03@3o
ool00`000000oooo0?ooo`060?ooo`030000003oool0oooo02D0oooo00<000000?ooo`3oool08`3o
ool00`000000oooo0?ooo`0[0?ooo`030000003oool0oooo00H0oooo00<000000?ooo`3oool05`3o
ool3000001D0oooo0`00001c0?ooo`<00000=P3oool00`000000oooo0?ooo`0>0?ooo`030000003o
ool0oooo00T0oooo0P00001?0?ooo`h00000;@3oool00`000000oooo0?ooo`0L0?ooo`00403oool0
0`000000oooo0?ooo`1b0?ooo`030000003oool0oooo0080oooo00<000000?ooo`3oool03@3oool0
0`000000oooo0?ooo`060?ooo`030000003oool0oooo02D0oooo00<000000?ooo`3oool08P3oool0
0`000000oooo0?ooo`0]0?ooo`030000003oool0oooo00H0oooo00<000000?ooo`3oool04`3oool3
000001@0oooo1000001d0?ooo`<00000>03oool00`000000oooo0?ooo`0?0?ooo`030000003oool0
oooo00X0oooo00<000000?ooo`3oool0C03oool=000002h0oooo00<000000?ooo`3oool0703oool0
00l0oooo00<000000?ooo`3oool0M03oool00`000000oooo0?ooo`020?ooo`030000003oool0oooo
00`0oooo00<000000?ooo`3oool01`3oool00`000000oooo0?ooo`0U0?ooo`030000003oool0oooo
0240oooo00<000000?ooo`3oool0;P3oool00`000000oooo0?ooo`060?ooo`030000003oool0oooo
00h0oooo1000000D0?ooo`<00000M@3oool3000000<0oooo00<000000?ooo`3oool0=@3oool00`00
0000oooo0?ooo`0@0?ooo`030000003oool0oooo00X0oooo00<000000?ooo`3oool0B@3oool20000
00030?ooo`000000000000X00000;P3oool00`000000oooo0?ooo`0L0?ooo`003`3oool00`000000
oooo0?ooo`1d0?ooo`030000003oool0oooo00<0oooo00<000000?ooo`3oool02P3oool00`000000
oooo0?ooo`080?ooo`030000003oool0oooo02D0oooo00<000000?ooo`3oool08@3oool00`000000
oooo0?ooo`0_0?ooo`030000003oool0oooo00H0oooo00<000000?ooo`3oool02P3oool3000001D0
oooo0`00001e0?ooo`<000001P3oool00`000000oooo0?ooo`0d0?ooo`030000003oool0oooo0140
oooo00<000000?ooo`3oool02`3oool2000004L0oooo0P0000040?ooo`X00000;`3oool00`000000
oooo0?ooo`0L0?ooo`003`3oool00`000000oooo0?ooo`1d0?ooo`030000003oool0oooo00@0oooo
00<000000?ooo`3oool02@3oool00`000000oooo0?ooo`090?ooo`030000003oool0oooo02@0oooo
00<000000?ooo`3oool0803oool00`000000oooo0?ooo`0a0?ooo`030000003oool0oooo00H0oooo
00<000000?ooo`3oool01P3oool3000001D0oooo0`00001e0?ooo`<000002@3oool00`000000oooo
0?ooo`0d0?ooo`030000003oool0oooo0180oooo00<000000?ooo`3oool0303oool00`000000oooo
0?ooo`120?ooo`8000001P3oool900000300oooo00<000000?ooo`3oool0703oool000l0oooo00<0
00000?ooo`3oool0M@3oool00`000000oooo0?ooo`030?ooo`030000003oool0oooo00T0oooo00<0
00000?ooo`3oool02@3oool00`000000oooo0?ooo`0T0?ooo`030000003oool0oooo0200oooo00<0
00000?ooo`3oool0<P3oool00`000000oooo0?ooo`060?ooo`030000003oool0oooo0080oooo0`00
000D0?ooo`@00000M@3oool3000000`0oooo00<000000?ooo`3oool0=03oool00`000000oooo0?oo
o`0C0?ooo`030000003oool0oooo00`0oooo0P0000100?ooo`8000001`3oool2000000030?ooo`00
0000000000@00000<@3oool00`000000oooo0?ooo`0L0?ooo`003`3oool00`000000oooo0?ooo`1e
0?ooo`030000003oool0oooo00@0oooo00<000000?ooo`3oool01`3oool00`000000oooo0?ooo`0;
0?ooo`030000003oool0oooo02<0oooo00<000000?ooo`3oool0803oool00`000000oooo0?ooo`0c
0?ooo`030000003oool0oooo00H0oooo1000000D0?ooo`<00000MP3oool3000000l0oooo00<00000
0?ooo`3oool0=03oool00`000000oooo0?ooo`0D0?ooo`030000003oool0oooo00d0oooo00<00000
0?ooo`3oool0>`3oool2000000P0oooo0P0000000`3oool000000000000g0?ooo`030000003oool0
oooo01/0oooo000?0?ooo`030000003oool0oooo07D0oooo00<000000?ooo`3oool01@3oool00`00
0000oooo0?ooo`060?ooo`030000003oool0oooo00/0oooo00<000000?ooo`3oool08`3oool00`00
0000oooo0?ooo`0O0?ooo`030000003oool0oooo03D0oooo00<000000?ooo`3oool00P3oool30000
00030?ooo`000000oooo0180oooo0`00001f0?ooo`<000004`3oool00`000000oooo0?ooo`0c0?oo
o`030000003oool0oooo01D0oooo00<000000?ooo`3oool03@3oool00`000000oooo0?ooo`0h0?oo
o`8000002@3oool01@000000oooo0000003oool0000003P0oooo00<000000?ooo`3oool06`3oool0
00l0oooo00<000000?ooo`3oool0MP3oool00`000000oooo0?ooo`050?ooo`030000003oool0oooo
00D0oooo00<000000?ooo`3oool0303oool00`000000oooo0?ooo`0R0?ooo`030000003oool0oooo
01l0oooo00<000000?ooo`3oool0=P3oool4000000D0oooo00<000000?ooo`3oool03@3oool30000
07H0oooo0`00000F0?ooo`030000003oool0oooo03<0oooo00<000000?ooo`3oool05P3oool00`00
0000oooo0?ooo`0=0?ooo`800000=P3oool2000000X0oooo00<000000?ooo`0000000P3oool00`00
0000oooo0?ooo`0f0?ooo`030000003oool0oooo01/0oooo000>0?ooo`030000003oool0oooo07L0
oooo00<000000?ooo`3oool01@3oool00`000000oooo0?ooo`040?ooo`030000003oool0oooo00d0
oooo00<000000?ooo`3oool08`3oool00`000000oooo0?ooo`0N0?ooo`030000003oool0oooo03@0
oooo100000080?ooo`030000003oool0oooo00T0oooo0`00001g0?ooo`8000006@3oool00`000000
oooo0?ooo`0c0?ooo`030000003oool0oooo01H0oooo00<000000?ooo`3oool03`3oool00`000000
oooo0?ooo`0a0?ooo`800000303oool200000080oooo00<000000?ooo`3oool0=`3oool00`000000
oooo0?ooo`0K0?ooo`003P3oool00`000000oooo0?ooo`1g0?ooo`030000003oool0oooo00H0oooo
00<000000?ooo`3oool00`3oool00`000000oooo0?ooo`0>0?ooo`030000003oool0oooo0280oooo
00<000000?ooo`3oool07@3oool00`000000oooo0?ooo`0a0?ooo`@00000103oool00`000000oooo
0?ooo`060?ooo`030000003oool0oooo00@0oooo1000001g0?ooo`<000006`3oool00`000000oooo
0?ooo`0c0?ooo`030000003oool0oooo01L0oooo00<000000?ooo`3oool03`3oool00`000000oooo
0?ooo`0^0?ooo`8000003@3oool2000000<0oooo00<000000?ooo`3oool0=`3oool00`000000oooo
0?ooo`0K0?ooo`003P3oool00`000000oooo0?ooo`1g0?ooo`030000003oool0oooo00L0oooo00D0
00000?ooo`3oool0oooo0000000A0?ooo`030000003oool0oooo0280oooo00<000000?ooo`3oool0
7@3oool00`000000oooo0?ooo`0^0?ooo`<000002@3oool00`000000oooo0?ooo`060?ooo`030000
003oool0oooo00<00000N03oool3000001l0oooo00<000000?ooo`3oool0<@3oool00`000000oooo
0?ooo`0I0?ooo`030000003oool0oooo00l0oooo0P00000/0?ooo`8000003P3oool00`000000oooo
000000020?ooo`800000>@3oool00`000000oooo0?ooo`0K0?ooo`003P3oool00`000000oooo0?oo
o`1h0?ooo`030000003oool0oooo00L0oooo00@000000?ooo`3oool000004P3oool00`000000oooo
0?ooo`0Q0?ooo`030000003oool0oooo01d0oooo00<000000?ooo`3oool0:`3oool3000000d0oooo
00<000000?ooo`3oool01P3oool2000007P0oooo0`00000R0?ooo`030000003oool0oooo0340oooo
00<000000?ooo`3oool06P3oool00`000000oooo0?ooo`0@0?ooo`030000003oool0oooo02L0oooo
0P00000?0?ooo`030000003oool0000000<0oooo00<000000?ooo`3oool0>03oool00`000000oooo
0?ooo`0K0?ooo`003P3oool00`000000oooo0?ooo`1h0?ooo`030000003oool0oooo00L0oooo00@0
00000?ooo`3oool000004P3oool00`000000oooo0?ooo`0Q0?ooo`030000003oool0oooo01`0oooo
00<000000?ooo`3oool0:@3oool300000140oooo00<000000?ooo`3oool01@3oool00`000000oooo
0?ooo`1d0?ooo`<000009@3oool00`000000oooo0?ooo`0a0?ooo`030000003oool0oooo01/0oooo
00<000000?ooo`3oool0403oool2000002D0oooo0P00000@0?ooo`030000003oool0000000<0oooo
0P00000j0?ooo`030000003oool0oooo01/0oooo000>0?ooo`030000003oool0oooo07P0oooo00<0
00000?ooo`3oool0203oool2000001@0oooo00<000000?ooo`3oool0803oool00`000000oooo0?oo
o`0L0?ooo`030000003oool0oooo02H0oooo0`00000E0?ooo`030000003oool0oooo00@0oooo00<0
00000?ooo`3oool0L@3oool3000002P0oooo00<000000?ooo`3oool0<@3oool00`000000oooo0?oo
o`0L0?ooo`030000003oool0oooo0140oooo00<000000?ooo`3oool0803oool200000140oooo00<0
00000?ooo`000000103oool00`000000oooo0?ooo`0j0?ooo`030000003oool0oooo01X0oooo000=
0?ooo`030000003oool0oooo07X0oooo00<000000?ooo`3oool0203oool00`000000oooo0?ooo`0B
0?ooo`030000003oool0oooo0200oooo00<000000?ooo`3oool0703oool00`000000oooo0?ooo`0R
0?ooo`@000006@3oool00`000000oooo0?ooo`030?ooo`030000003oool0oooo06h0oooo0`00000[
0?ooo`030000003oool0oooo0340oooo00<000000?ooo`3oool0703oool00`000000oooo0?ooo`0B
0?ooo`030000003oool0oooo01d0oooo0P00000B0?ooo`040000003oool0oooo000000<0oooo0P00
000l0?ooo`030000003oool0oooo01X0oooo000=0?ooo`030000003oool0oooo07X0oooo00<00000
0?ooo`3oool0203oool2000001<0oooo00<000000?ooo`3oool08@3oool00`000000oooo0?ooo`0J
0?ooo`030000003oool0oooo0200oooo0`00000N0?ooo`030000003oool0oooo0080oooo00<00000
0?ooo`3oool0J`3oool3000002l0oooo00<000000?ooo`3oool0<03oool00`000000oooo0?ooo`0M
0?ooo`030000003oool0oooo0180oooo0P00000K0?ooo`8000004`3oool010000000oooo0?ooo`00
00040?ooo`030000003oool0oooo03/0oooo00<000000?ooo`3oool06P3oool000d0oooo00<00000
0?ooo`3oool0NP3oool00`000000oooo0?ooo`070?ooo`040000003oool0oooo000001<0oooo00<0
00000?ooo`3oool0803oool00`000000oooo0?ooo`0J0?ooo`030000003oool0oooo01d0oooo0`00
000R0?ooo`050000003oool0oooo0?ooo`000000J`3oool200000380oooo00<000000?ooo`3oool0
<03oool00`000000oooo0?ooo`0N0?ooo`030000003oool0oooo01<0oooo00<000000?ooo`3oool0
5P3oool2000001D0oooo00<000000?ooo`0000001@3oool00`000000oooo0?ooo`0k0?ooo`030000
003oool0oooo01X0oooo000=0?ooo`030000003oool0oooo07/0oooo00<000000?ooo`3oool01P3o
ool010000000oooo0?ooo`00000C0?ooo`030000003oool0oooo0200oooo00<000000?ooo`3oool0
6P3oool00`000000oooo0?ooo`0J0?ooo`<000009P3oool010000000oooo0?ooo`00001X0?ooo`<0
0000=03oool00`000000oooo0?ooo`0`0?ooo`030000003oool0oooo01l0oooo00<000000?ooo`3o
ool04`3oool2000001@0oooo0P00000F0?ooo`040000003oool0oooo000000@0oooo0P00000m0?oo
o`030000003oool0oooo01X0oooo000=0?ooo`030000003oool0oooo07/0oooo00<000000?ooo`3o
ool01P3oool01@000000oooo0?ooo`3oool0000001<0oooo00<000000?ooo`3oool07`3oool00`00
0000oooo0?ooo`0I0?ooo`030000003oool0oooo01L0oooo1000000Z0?ooo`030000003oool00000
06D0oooo0`00000g0?ooo`030000003oool0oooo0300oooo00<000000?ooo`3oool0803oool00`00
0000oooo0?ooo`0D0?ooo`030000003oool0oooo00l0oooo0P00000G0?ooo`040000003oool0oooo
000000D0oooo00<000000?ooo`3oool0?03oool00`000000oooo0?ooo`0J0?ooo`003@3oool00`00
0000oooo0?ooo`1k0?ooo`030000003oool0oooo00D0oooo00<000000?ooo`3oool00`3oool00`00
0000oooo0?ooo`0@0?ooo`030000003oool0oooo01l0oooo00<000000?ooo`3oool06@3oool00`00
0000oooo0?ooo`0D0?ooo`<00000;`3oool200000680oooo0`00000k0?ooo`030000003oool0oooo
02h0oooo00<000000?ooo`3oool08P3oool00`000000oooo0?ooo`0D0?ooo`030000003oool0oooo
00`0oooo0P00000H0?ooo`040000003oool0oooo000000D0oooo0P00000n0?ooo`030000003oool0
oooo01X0oooo000<0?ooo`030000003oool0oooo07d0oooo00<000000?ooo`3oool0103oool00`00
0000oooo0?ooo`040?ooo`030000003oool0oooo0100oooo00<000000?ooo`3oool07P3oool00`00
0000oooo0?ooo`0I0?ooo`030000003oool0oooo0140oooo0`00000c0?ooo`030000003oool0oooo
05d0oooo0`00000n0?ooo`030000003oool0oooo02h0oooo00<000000?ooo`3oool08P3oool00`00
0000oooo0?ooo`0E0?ooo`8000002P3oool2000001T0oooo00@000000?ooo`3oool000001P3oool0
0`000000oooo0?ooo`0n0?ooo`030000003oool0oooo01T0oooo000<0?ooo`030000003oool0oooo
07d0oooo00<000000?ooo`3oool0103oool00`000000oooo0?ooo`040?ooo`030000003oool0oooo
0100oooo00<000000?ooo`3oool07P3oool00`000000oooo0?ooo`0H0?ooo`030000003oool0oooo
00l0oooo0`00000f0?ooo`800000F`3oool300000440oooo00<000000?ooo`3oool0;P3oool00`00
0000oooo0?ooo`0S0?ooo`030000003oool0oooo01H0oooo00<000000?ooo`3oool01@3oool20000
01X0oooo00D000000?ooo`3oool0oooo000000050?ooo`800000@03oool00`000000oooo0?ooo`0I
0?ooo`00303oool00`000000oooo0?ooo`1m0?ooo`030000003oool0oooo00<0oooo00<000000?oo
o`3oool01P3oool00`000000oooo0?ooo`0@0?ooo`030000003oool0oooo01h0oooo00<000000?oo
o`3oool05`3oool00`000000oooo0?ooo`0<0?ooo`<00000>@3oool00`000000oooo0000001G0?oo
o`<00000A03oool00`000000oooo0?ooo`0^0?ooo`030000003oool0oooo02@0oooo00<000000?oo
o`3oool05P3oool00`000000oooo0?ooo`020?ooo`8000006`3oool01@000000oooo0?ooo`3oool0
000000H0oooo0P0000100?ooo`030000003oool0oooo01T0oooo000<0?ooo`030000003oool0oooo
07h0oooo00<000000?ooo`3oool00P3oool00`000000oooo0?ooo`070?ooo`030000003oool0oooo
00l0oooo00<000000?ooo`3oool07P3oool00`000000oooo0?ooo`0G0?ooo`030000003oool0oooo
00P0oooo1000000l0?ooo`040000003oool0oooo000005<0oooo0`0000170?ooo`030000003oool0
oooo02h0oooo00<000000?ooo`3oool09@3oool00`000000oooo0?ooo`0F0?ooo`@000007@3oool0
10000000oooo0?ooo`0000060?ooo`800000@@3oool00`000000oooo0?ooo`0I0?ooo`00303oool0
0`000000oooo0?ooo`1n0?ooo`050000003oool0oooo0?ooo`0000002`3oool00`000000oooo0?oo
o`0?0?ooo`030000003oool0oooo01d0oooo00<000000?ooo`3oool05P3oool00`000000oooo0?oo
o`060?ooo`<00000@03oool01@000000oooo0?ooo`3oool000000500oooo0P00001;0?ooo`030000
003oool0oooo02d0oooo00<000000?ooo`3oool09P3oool00`000000oooo0?ooo`0E0?ooo`<00000
7@3oool01@000000oooo0?ooo`3oool0000000H0oooo0P0000110?ooo`030000003oool0oooo01T0
oooo000<0?ooo`030000003oool0oooo07d0oooo1P00000;0?ooo`030000003oool0oooo00l0oooo
00<000000?ooo`3oool07@3oool00`000000oooo0?ooo`0F0?ooo`030000003oool0oooo00<0oooo
0`0000130?ooo`030000003oool0oooo0080oooo00<000000?ooo`3oool0BP3oool3000004d0oooo
00<000000?ooo`3oool0;@3oool00`000000oooo0?ooo`0W0?ooo`030000003oool0oooo0180oooo
0P0000030?ooo`8000006P3oool01@000000oooo0?ooo`3oool0000000H0oooo0P0000120?ooo`03
0000003oool0oooo01T0oooo000<0?ooo`030000003oool0oooo07`0oooo2000000;0?ooo`030000
003oool0oooo00l0oooo00<000000?ooo`3oool0703oool00`000000oooo0?ooo`0F0?ooo`030000
003oool0oooo00<00000AP3oool00`000000oooo0?ooo`030?ooo`030000003oool0oooo04H0oooo
0`00001@0?ooo`030000003oool0oooo02d0oooo00<000000?ooo`3oool09`3oool00`000000oooo
0?ooo`0@0?ooo`8000001`3oool00`000000oooo0?ooo`0F0?ooo`050000003oool0oooo0?ooo`00
00001`3oool200000480oooo00<000000?ooo`3oool06@3oool000/0oooo00<000000?ooo`3oool0
O03oool:000000/0oooo00<000000?ooo`3oool03P3oool00`000000oooo0?ooo`0L0?ooo`030000
003oool0oooo01D0oooo100000180?ooo`030000003oool0oooo00D0oooo00<000000?ooo`3oool0
@P3oool3000005<0oooo00<000000?ooo`3oool0;@3oool00`000000oooo0?ooo`0X0?ooo`030000
003oool0oooo00d0oooo0P00000:0?ooo`030000003oool0oooo01@0oooo00D000000?ooo`3oool0
oooo000000080?ooo`030000003oool0oooo0440oooo00<000000?ooo`3oool06@3oool000/0oooo
00<000000?ooo`3oool0N`3oool<000000/0oooo00<000000?ooo`3oool03P3oool00`000000oooo
0?ooo`0K0?ooo`030000003oool0oooo0180oooo1000001;0?ooo`030000003oool0oooo00H0oooo
00<000000?ooo`3oool0?P3oool3000005L0oooo00<000000?ooo`3oool0:`3oool00`000000oooo
0?ooo`0Z0?ooo`030000003oool0oooo00X0oooo0P00000=0?ooo`8000004`3oool00`000000oooo
0?ooo`020?ooo`030000003oool0oooo00D0oooo0P0000140?ooo`030000003oool0oooo01P0oooo
000;0?ooo`030000003oool0oooo07X0oooo3@00000;0?ooo`030000003oool0oooo00h0oooo00<0
00000?ooo`3oool0703oool00`000000oooo0?ooo`0>0?ooo`<000000`3oool00`000000oooo0?oo
o`190?ooo`030000003oool0oooo00L0oooo00<000000?ooo`3oool0>P3oool3000005X0oooo00<0
00000?ooo`3oool0:`3oool00`000000oooo0?ooo`0[0?ooo`030000003oool0oooo00L0oooo0P00
000A0?ooo`030000003oool0oooo00l0oooo00<000000?ooo`3oool00P3oool00`000000oooo0?oo
o`060?ooo`800000A03oool00`000000oooo0?ooo`0H0?ooo`002`3oool00`000000oooo0?ooo`1j
0?ooo`h000002`3oool00`000000oooo0?ooo`0>0?ooo`030000003oool0oooo01/0oooo00<00000
0?ooo`3oool02`3oool3000000D0oooo00<000000?ooo`3oool0BP3oool00`000000oooo0?ooo`08
0?ooo`030000003oool0oooo03H0oooo0`00001M0?ooo`030000003oool0oooo02/0oooo00<00000
0?ooo`3oool0;03oool00`000000oooo0?ooo`040?ooo`800000503oool00`000000oooo0?ooo`0>
0?ooo`050000003oool0oooo0?ooo`000000203oool2000004D0oooo00<000000?ooo`3oool0603o
ool000/0oooo00<000000?ooo`3oool0NP3oool>000000`0oooo00<000000?ooo`3oool03@3oool0
0`000000oooo0?ooo`0K0?ooo`030000003oool0oooo00L0oooo100000080?ooo`030000003oool0
oooo04X0oooo00<000000?ooo`3oool02@3oool00`000000oooo0?ooo`0b0?ooo`<00000H03oool0
0`000000oooo0?ooo`0[0?ooo`030000003oool0oooo02d0oooo00@000000?ooo`3oool0oooo0P00
000G0?ooo`8000003@3oool01@000000oooo0?ooo`3oool0000000T0oooo0P0000150?ooo`030000
003oool0oooo01P0oooo000;0?ooo`030000003oool0oooo07X0oooo3P00000=0?ooo`030000003o
ool0oooo00d0oooo00<000000?ooo`3oool06P3oool00`000000oooo0?ooo`040?ooo`<00000303o
ool00`000000oooo0?ooo`1:0?ooo`030000003oool0oooo00X0oooo00<000000?ooo`3oool0;P3o
ool3000006<0oooo00<000000?ooo`3oool0:`3oool00`000000oooo0?ooo`0]0?ooo`040000003o
ool00000000001/0oooo00<000000?ooo`3oool02@3oool00`000000oooo0?ooo`020?ooo`030000
003oool0oooo00H0oooo0P0000160?ooo`030000003oool0oooo01P0oooo000:0?ooo`030000003o
ool0oooo07/0oooo3P00000=0?ooo`030000003oool0oooo00d0oooo00<000000?ooo`3oool06P3o
ool010000000oooo0?ooo`3oool3000000h0oooo00<000000?ooo`3oool0B`3oool00`000000oooo
0?ooo`0;0?ooo`030000003oool0oooo02/0oooo0P00001W0?ooo`030000003oool0oooo02X0oooo
00<000000?ooo`3oool0;@3oool2000001h0oooo0P0000050?ooo`H000000P3oool00`000000oooo
0?ooo`070?ooo`800000AP3oool00`000000oooo0?ooo`0H0?ooo`002P3oool00`000000oooo0?oo
o`1k0?ooo`d000003`3oool00`000000oooo0?ooo`0=0?ooo`030000003oool0oooo01T0oooo1000
000A0?ooo`030000003oool0oooo04/0oooo00<000000?ooo`3oool0303oool00`000000oooo0?oo
o`0W0?ooo`<00000J@3oool00`000000oooo0?ooo`0Z0?ooo`030000003oool0oooo02/0oooo0P00
00020?ooo`030000003oool0oooo01d0oooo00@000000?ooo`3oool0oooo2@0000090?ooo`030000
003oool0000004H0oooo00<000000?ooo`3oool0603oool000X0oooo00<000000?ooo`3oool0O03o
ool<00000100oooo00<000000?ooo`3oool0303oool00`000000oooo0?ooo`0G0?ooo`@000004`3o
ool00`000000oooo0?ooo`1;0?ooo`030000003oool0oooo00d0oooo00<000000?ooo`3oool08`3o
ool3000006`0oooo00<000000?ooo`3oool0:P3oool00`000000oooo0?ooo`0Y0?ooo`8000001@3o
ool00`000000oooo0?ooo`0M0?ooo`030000003oool0000000T000002@3oool2000004P0oooo00<0
00000?ooo`3oool05`3oool000X0oooo00<000000?ooo`3oool0O@3oool;00000140oooo00<00000
0?ooo`3oool0303oool00`000000oooo0?ooo`0B0?ooo`@000000`3oool00`000000oooo0?ooo`0@
0?ooo`030000003oool0oooo04`0oooo00<000000?ooo`3oool03P3oool00`000000oooo0?ooo`0O
0?ooo`<00000K`3oool00`000000oooo0?ooo`0Z0?ooo`030000003oool0oooo02L0oooo0P000008
0?ooo`030000003oool0oooo01d0oooo300000080?ooo`800000B03oool00`000000oooo0?ooo`0G
0?ooo`002P3oool00`000000oooo0?ooo`1n0?ooo`P0000000<0oooo000000000000403oool00`00
0000oooo0?ooo`0<0?ooo`030000003oool0oooo00l0oooo0`0000070?ooo`030000003oool0oooo
0100oooo00<000000?ooo`3oool0C03oool00`000000oooo0?ooo`0?0?ooo`030000003oool0oooo
01/0oooo0`00001c0?ooo`030000003oool0oooo02P0oooo00<000000?ooo`3oool09P3oool20000
00/0oooo00<000000?ooo`3oool06`3oool=000000L0oooo0P0000190?ooo`030000003oool0oooo
01L0oooo000:0?ooo`030000003oool0oooo07l0oooo1P0000030?ooo`800000403oool00`000000
oooo0?ooo`0<0?ooo`030000003oool0oooo00/0oooo0`00000:0?ooo`030000003oool0oooo0100
oooo00<000000?ooo`3oool0C03oool00`000000oooo0?ooo`0@0?ooo`040000003oool0oooo0?oo
o`H00000403oool3000007H0oooo00<000000?ooo`3oool0:03oool00`000000oooo0?ooo`0T0?oo
o`8000003@3oool00`000000oooo0?ooo`0K0?ooo`h000001P3oool2000004T0oooo00<000000?oo
o`3oool05`3oool000T0oooo00<000000?ooo`3oool0RP3oool3000000l0oooo00<000000?ooo`3o
ool02`3oool00`000000oooo0?ooo`080?ooo`<000003@3oool00`000000oooo0?ooo`0?0?ooo`03
0000003oool0oooo04d0oooo00<000000?ooo`3oool04@3oool00`000000oooo00000007000000`0
oooo0`00001i0?ooo`030000003oool0oooo02P0oooo00<000000?ooo`3oool08P3oool200000100
oooo00<000000?ooo`3oool06P3oool>000000D0oooo0P00001:0?ooo`030000003oool0oooo01L0
oooo00090?ooo`030000003oool0oooo08/0oooo00<000000?ooo`0000003`3oool00`000000oooo
0?ooo`0;0?ooo`030000003oool0oooo00<0oooo1000000@0?ooo`030000003oool0oooo00l0oooo
00<000000?ooo`3oool0C@3oool00`000000oooo0?ooo`0B0?ooo`X00000203oool3000007`0oooo
00<000000?ooo`3oool0:03oool00`000000oooo0?ooo`0P0?ooo`8000004`3oool00`000000oooo
0?ooo`0I0?ooo`h000001@3oool2000004X0oooo00<000000?ooo`3oool05`3oool000T0oooo00<0
00000?ooo`3oool0S03oool00`000000oooo0000000>0?ooo`030000003oool0oooo00/0oooo00<0
00000?ooo`3oool00`00000D0?ooo`030000003oool0oooo00l0oooo00<000000?ooo`3oool0C@3o
ool00`000000oooo0?ooo`0A0?ooo``000001@3oool2000007l0oooo00<000000?ooo`3oool0:03o
ool00`000000oooo0?ooo`0N0?ooo`8000005P3oool00`000000oooo0?ooo`0H0?ooo`h00000103o
ool00`000000oooo0000001:0?ooo`030000003oool0oooo01L0oooo00090?ooo`030000003oool0
oooo08d0oooo00<000000?ooo`0000003P3oool00`000000oooo0?ooo`0:0?ooo`<00000603oool0
0`000000oooo0?ooo`0=0?ooo`030000003oool0oooo04h0oooo00<000000?ooo`3oool0403oool=
00000080oooo0`0000220?ooo`030000003oool0oooo02L0oooo00<000000?ooo`3oool0703oool2
000001T0oooo00<000000?ooo`3oool05P3oool>000000D0oooo0P00001;0?ooo`030000003oool0
oooo01L0oooo00090?ooo`030000003oool0oooo08h0oooo00<000000?ooo`0000003P3oool00`00
0000oooo0?ooo`060?ooo`<0000000<0oooo0000003oool0603oool00`000000oooo0?ooo`0=0?oo
o`030000003oool0oooo04h0oooo00<000000?ooo`3oool0403oool?000008D0oooo00<000000?oo
o`3oool09`3oool00`000000oooo0?ooo`0J0?ooo`800000703oool00`000000oooo0?ooo`0D0?oo
o`030000003oool0oooo00`00000103oool00`000000oooo0000001<0?ooo`030000003oool0oooo
01H0oooo00090?ooo`030000003oool0oooo08h0oooo00@000000?ooo`3oool000003P3oool01000
0000oooo0?ooo`3oool4000000D0oooo00<000000?ooo`3oool05P3oool00`000000oooo0?ooo`0=
0?ooo`030000003oool0oooo04h0oooo00<000000?ooo`3oool0403oool>000008H0oooo00<00000
0?ooo`3oool09`3oool00`000000oooo0?ooo`0H0?ooo`8000007P3oool00`000000oooo0?ooo`0C
0?ooo`030000003oool0oooo0080oooo2P0000050?ooo`800000C@3oool00`000000oooo0?ooo`0F
0?ooo`002@3oool00`000000oooo0?ooo`2?0?ooo`040000003oool0oooo000000h0oooo0`000009
0?ooo`030000003oool0oooo01H0oooo00<000000?ooo`3oool0303oool00`000000oooo0?ooo`1?
0?ooo`030000003oool0oooo0100oooo3P0000260?ooo`030000003oool0oooo02L0oooo00<00000
0?ooo`3oool05P3oool200000240oooo00<000000?ooo`3oool04P3oool00`000000oooo0?ooo`02
0?ooo`T000001P3oool2000004d0oooo00<000000?ooo`3oool05P3oool000P0oooo00<000000?oo
o`3oool0T@3oool010000000oooo0?ooo`00000:0?ooo`@00000303oool00`000000oooo0?ooo`0E
0?ooo`030000003oool0oooo00`0oooo00<000000?ooo`3oool0C`3oool00`000000oooo0?ooo`0@
0?ooo`h00000Q`3oool00`000000oooo0?ooo`0U0?ooo`030000003oool0oooo01D0oooo0P00000T
0?ooo`030000003oool0oooo0100oooo00<000000?ooo`3oool00P3oool00`000000oooo0?ooo`06
000000H0oooo00<000000?ooo`000000C@3oool00`000000oooo0?ooo`0F0?ooo`00203oool00`00
0000oooo0?ooo`2B0?ooo`040000003oool0oooo000000H0oooo0`0000040?ooo`030000003oool0
oooo00T0oooo00<000000?ooo`3oool05@3oool00`000000oooo0?ooo`0<0?ooo`030000003oool0
oooo04l0oooo00<000000?ooo`3oool0403oool=000008P0oooo00<000000?ooo`3oool09@3oool0
0`000000oooo0?ooo`0C0?ooo`8000009`3oool00`000000oooo0?ooo`0>0?ooo`030000003oool0
oooo0080oooo00<000000?ooo`3oool0103oool00`000000oooo0?ooo`060?ooo`800000CP3oool0
0`000000oooo0?ooo`0F0?ooo`00203oool00`000000oooo0?ooo`2C0?ooo`040000003oool0oooo
00000080oooo0`0000080?ooo`030000003oool0oooo00T0oooo00<000000?ooo`3oool0503oool0
0`000000oooo0?ooo`0;0?ooo`030000003oool0oooo0500oooo00<000000?ooo`3oool04@3oool<
000008P0oooo00<000000?ooo`3oool09@3oool00`000000oooo0?ooo`0A0?ooo`800000:P3oool0
0`000000oooo0?ooo`0<0?ooo`030000003oool0oooo0080oooo00<000000?ooo`3oool01@3oool0
0`000000oooo0?ooo`050?ooo`030000003oool0000004h0oooo00<000000?ooo`3oool05P3oool0
00P0oooo00<000000?ooo`3oool0U03oool5000000`0oooo00<000000?ooo`3oool0203oool00`00
0000oooo0?ooo`0E0?ooo`030000003oool0oooo00X0oooo00<000000?ooo`3oool0D03oool00`00
0000oooo0?ooo`0A0?ooo`/0000000<0oooo000000000000QP3oool00`000000oooo0?ooo`0U0?oo
o`030000003oool0oooo00l0oooo0P00000]0?ooo`030000003oool0oooo00X0oooo00<000000?oo
o`3oool00P3oool00`000000oooo0?ooo`060?ooo`030000003oool0oooo00D0oooo0P00001?0?oo
o`030000003oool0oooo01H0oooo00080?ooo`030000003oool0oooo0980oooo100000020?ooo`03
0000003oool0oooo00X0oooo00<000000?ooo`3oool02@3oool00`000000oooo0?ooo`0D0?ooo`03
0000003oool0oooo00X0oooo00<000000?ooo`3oool0D03oool00`000000oooo0?ooo`0?0?ooo`80
00000P3oool8000000@0oooo0P0000240?ooo`030000003oool0oooo02D0oooo00<000000?ooo`3o
ool03@3oool2000002l0oooo00<000000?ooo`3oool02@3oool00`000000oooo0?ooo`020?ooo`03
0000003oool0oooo00L0oooo00<000000?ooo`3oool0103oool00`000000oooo0000001@0?ooo`03
0000003oool0oooo01D0oooo00080?ooo`030000003oool0oooo08l0oooo0`0000040?ooo`040000
003oool0oooo000000`0oooo00<000000?ooo`3oool0203oool00`000000oooo0?ooo`0D0?ooo`03
0000003oool0oooo00T0oooo00<000000?ooo`3oool0D@3oool00`000000oooo0?ooo`0>0?ooo`03
0000003oool0oooo00<0oooo1P0000070?ooo`030000003oool0oooo0880oooo00<000000?ooo`3o
ool0903oool00`000000oooo0?ooo`0;0?ooo`800000<P3oool00`000000oooo0?ooo`070?ooo`03
0000003oool0oooo0080oooo00<000000?ooo`3oool0203oool00`000000oooo0?ooo`040?ooo`80
0000D@3oool00`000000oooo0?ooo`0E0?ooo`001`3oool00`000000oooo0?ooo`2=0?ooo`<00000
1`3oool01@000000oooo0?ooo`3oool0000000`0oooo00<000000?ooo`3oool0203oool00`000000
oooo0?ooo`0C0?ooo`030000003oool0oooo00T0oooo00<000000?ooo`3oool0D@3oool00`000000
oooo0?ooo`0<0?ooo`800000503oool200000880oooo00<000000?ooo`3oool0903oool00`000000
oooo0?ooo`090?ooo`800000=@3oool00`000000oooo0?ooo`060?ooo`050000003oool0oooo0?oo
o`0000002`3oool00`000000oooo0?ooo`030?ooo`030000003oool000000540oooo00<000000?oo
o`3oool05@3oool000L0oooo00<000000?ooo`3oool0R@3oool4000000/0oooo00D000000?ooo`3o
ool0oooo0000000<0?ooo`030000003oool0oooo00L0oooo00<000000?ooo`3oool04`3oool00`00
0000oooo0?ooo`090?ooo`030000003oool0oooo0540oooo00<000000?ooo`3oool02`3oool00`00
0000oooo0?ooo`0F0?ooo`800000P03oool00`000000oooo0?ooo`0T0?ooo`030000003oool0oooo
00L0oooo0P00000h0?ooo`030000003oool0oooo00@0oooo00D000000?ooo`3oool0oooo0000000<
0?ooo`030000003oool0oooo00<0oooo00<000000?ooo`000000D@3oool00`000000oooo0?ooo`0E
0?ooo`001`3oool00`000000oooo0?ooo`260?ooo`<00000403oool010000000oooo0?ooo`3oool2
000000X0oooo00<000000?ooo`3oool0203oool00`000000oooo0?ooo`0B0?ooo`030000003oool0
oooo00P0oooo00<000000?ooo`3oool0DP3oool00`000000oooo0?ooo`090?ooo`8000006`3oool0
0`000000oooo0?ooo`1m0?ooo`030000003oool0oooo02@0oooo00<000000?ooo`3oool01@3oool2
000003/0oooo00<000000?ooo`3oool00P3oool00`000000oooo0?ooo`020?ooo`030000003oool0
oooo00X0oooo00<000000?ooo`3oool00`3oool200000580oooo00<000000?ooo`3oool05@3oool0
00L0oooo00<000000?ooo`3oool0P`3oool3000001@0oooo00<000000?ooo`3oool00P3oool00`00
0000oooo0?ooo`080?ooo`030000003oool0oooo00L0oooo00<000000?ooo`3oool04P3oool00`00
0000oooo0?ooo`080?ooo`030000003oool0oooo0580oooo00<000000?ooo`3oool0203oool00`00
0000oooo0?ooo`0L0?ooo`800000OP3oool00`000000oooo0?ooo`0R0?ooo`030000003oool0oooo
00@0oooo0P00000m0?ooo`050000003oool0oooo0?ooo`000000103oool00`000000oooo0?ooo`0<
0?ooo`070000003oool0oooo0?ooo`000000oooo0000001B0?ooo`030000003oool0oooo01D0oooo
00070?ooo`030000003oool0oooo0800oooo0`00000H0?ooo`030000003oool0oooo0080oooo00<0
00000?ooo`3oool0203oool00`000000oooo0?ooo`070?ooo`030000003oool0oooo0180oooo00<0
00000?ooo`3oool01P3oool00`000000oooo0?ooo`1C0?ooo`030000003oool0oooo00H0oooo0P00
000Q0?ooo`800000O03oool00`000000oooo0?ooo`0R0?ooo`030000003oool0oooo0080oooo0P00
00100?ooo`030000003oool0000000@0oooo00<000000?ooo`3oool03@3oool010000000oooo0?oo
o`3oool2000005<0oooo00<000000?ooo`3oool05@3oool000L0oooo00<000000?ooo`3oool0O03o
ool4000001`0oooo00<000000?ooo`3oool00P3oool00`000000oooo0?ooo`080?ooo`030000003o
ool0oooo00H0oooo00<000000?ooo`3oool04P3oool00`000000oooo0?ooo`060?ooo`030000003o
ool0oooo0580oooo00<000000?ooo`3oool01P3oool00`000000oooo0?ooo`0S0?ooo`030000003o
ool0oooo07T0oooo00<000000?ooo`3oool08P3oool00`000000oooo0?ooo`02000004<0oooo00<0
00000?ooo`3oool00P3oool00`000000oooo0?ooo`0>0?ooo`060000003oool0oooo0000003oool0
0000D`3oool00`000000oooo0?ooo`0E0?ooo`001P3oool00`000000oooo0?ooo`1j0?ooo`<00000
8@3oool00`000000oooo0?ooo`020?ooo`030000003oool0oooo00L0oooo00<000000?ooo`3oool0
1`3oool00`000000oooo0?ooo`0A0?ooo`030000003oool0oooo00H0oooo00<000000?ooo`3oool0
DP3oool00`000000oooo0?ooo`040?ooo`8000009`3oool2000007T0oooo00<000000?ooo`3oool0
8P3oool3000004@0oooo00<000000?ooo`0000000P3oool00`000000oooo0?ooo`0?0?ooo`060000
003oool0oooo0000003oool00000E03oool00`000000oooo0?ooo`0D0?ooo`001P3oool00`000000
oooo0?ooo`1g0?ooo`<000009@3oool00`000000oooo0?ooo`020?ooo`030000003oool0oooo00L0
oooo00<000000?ooo`3oool01P3oool00`000000oooo0?ooo`0A0?ooo`030000003oool0oooo00D0
oooo00<000000?ooo`3oool0D`3oool00`000000oooo0?ooo`030?ooo`030000003oool0oooo02T0
oooo0P00001g0?ooo`030000003oool0oooo0240oooo0P0000150?ooo`040000003oool0oooo0?oo
o`8000004P3oool01@000000oooo0000003oool0000005D0oooo00<000000?ooo`3oool0503oool0
00H0oooo00<000000?ooo`3oool0M03oool3000002P0oooo00<000000?ooo`3oool00`3oool00`00
0000oooo0?ooo`070?ooo`030000003oool0oooo00H0oooo00<000000?ooo`3oool0403oool00`00
0000oooo0?ooo`050?ooo`030000003oool0oooo05<0oooo00@000000?ooo`3oool0oooo0P00000^
0?ooo`030000003oool0oooo07D0oooo00<000000?ooo`3oool07P3oool2000000030?ooo`000000
oooo04@0oooo00@000000?ooo`3oool0oooo0P00000B0?ooo`050000003oool000000?ooo`000000
E@3oool00`000000oooo0?ooo`0D0?ooo`001P3oool00`000000oooo0?ooo`1a0?ooo`<00000;03o
ool00`000000oooo0?ooo`030?ooo`030000003oool0oooo00L0oooo00<000000?ooo`3oool01@3o
ool00`000000oooo0?ooo`0@0?ooo`030000003oool0oooo00D0oooo00<000000?ooo`3oool0D`3o
ool010000000oooo0?ooo`00000a0?ooo`800000M@3oool00`000000oooo0?ooo`0L0?ooo`800000
0`3oool00`000000oooo0?ooo`120?ooo`070000003oool0oooo0?ooo`000000oooo0000000B0?oo
o`80000000<0oooo0000003oool0E@3oool00`000000oooo0?ooo`0D0?ooo`001P3oool00`000000
oooo0?ooo`1]0?ooo`@00000<03oool00`000000oooo0?ooo`030?ooo`030000003oool0oooo00H0
oooo00<000000?ooo`3oool01P3oool00`000000oooo0?ooo`0?0?ooo`030000003oool0oooo00@0
oooo00<000000?ooo`3oool0E03oool3000003@0oooo0P00001c0?ooo`030000003oool0oooo01X0
oooo0P0000050?ooo`030000003oool0oooo0440oooo00D000000?ooo`3oool0oooo000000030?oo
o`030000003oool0oooo00d0oooo1P00001F0?ooo`030000003oool0oooo01@0oooo00060?ooo`03
0000003oool0oooo06X0oooo0`00000e0?ooo`030000003oool0oooo00<0oooo00<000000?ooo`3o
ool01P3oool00`000000oooo0?ooo`050?ooo`030000003oool0oooo0100oooo00<000000?ooo`3o
ool00`3oool00`000000oooo0?ooo`1D0?ooo`030000003oool0oooo03H0oooo0P00001a0?ooo`03
0000003oool0oooo01P0oooo0P0000060?ooo`030000003oool0oooo0440oooo00D000000?ooo`3o
ool0oooo000000050?ooo`030000003oool0oooo00/0oooo2000001E0?ooo`030000003oool0oooo
01@0oooo00060?ooo`030000003oool0oooo06L0oooo0`00000i0?ooo`030000003oool0oooo00<0
oooo00<000000?ooo`3oool01P3oool00`000000oooo0?ooo`050?ooo`030000003oool0oooo00l0
oooo00<000000?ooo`3oool00`3oool00`000000oooo0?ooo`1B0?ooo`<00000>P3oool00`000000
oooo0?ooo`1_0?ooo`030000003oool0oooo01D0oooo0P0000080?ooo`030000003oool0oooo0400
oooo00D000000?ooo`3oool0oooo000000070?ooo`030000003oool0oooo00T0oooo2P00001D0?oo
o`030000003oool0oooo01@0oooo00050?ooo`030000003oool0oooo06D0oooo0`00000m0?ooo`03
0000003oool0oooo00<0oooo00<000000?ooo`3oool01P3oool00`000000oooo0?ooo`040?ooo`03
0000003oool0oooo00l0oooo00<000000?ooo`3oool00P3oool00`000000oooo0?ooo`1B0?ooo`04
0000003oool0oooo000003/0oooo0P00001_0?ooo`030000003oool0oooo01<0oooo0P00000:0?oo
o`030000003oool0oooo03l0oooo00D000000?ooo`3oool0oooo000000090?ooo`030000003oool0
oooo00L0oooo3000001D0?ooo`030000003oool0oooo01<0oooo00050?ooo`030000003oool0oooo
0640oooo100000110?ooo`030000003oool0oooo00<0oooo00<000000?ooo`3oool01@3oool00`00
0000oooo0?ooo`050?ooo`030000003oool0oooo00h0oooo00<000000?ooo`3oool00P3oool00`00
0000oooo0?ooo`1@0?ooo`8000000`3oool00`000000oooo0?ooo`0k0?ooo`800000K@3oool00`00
0000oooo0?ooo`0A0?ooo`800000303oool00`000000oooo0?ooo`0n0?ooo`050000003oool0oooo
0?ooo`0000002`3oool00`000000oooo0?ooo`050?ooo`d00000E03oool00`000000oooo0?ooo`0C
0?ooo`001@3oool00`000000oooo0?ooo`1N0?ooo`<00000AP3oool00`000000oooo0?ooo`030?oo
o`030000003oool0oooo00D0oooo00<000000?ooo`3oool0103oool00`000000oooo0?ooo`0>0?oo
o`030000003oool0oooo0080oooo00<000000?ooo`3oool0C`3oool00`000000oooo0?ooo`030?oo
o`030000003oool0oooo03d0oooo00<000000?ooo`3oool0JP3oool00`000000oooo0?ooo`0?0?oo
o`8000003P3oool00`000000oooo0?ooo`0n0?ooo`040000003oool0oooo000000`0oooo00<00000
0?ooo`3oool01@3oool>000005<0oooo00<000000?ooo`3oool04`3oool000D0oooo00<000000?oo
o`3oool0F`3oool3000004T0oooo00<000000?ooo`3oool0103oool00`000000oooo0?ooo`050?oo
o`030000003oool0oooo00@0oooo00<000000?ooo`3oool03@3oool01@000000oooo0?ooo`3oool0
00000500oooo0P0000060?ooo`030000003oool0oooo03h0oooo0P00001Z0?ooo`030000003oool0
oooo00d0oooo0P00000@0?ooo`030000003oool0oooo03d0oooo00@000000?ooo`3oool000003P3o
ool00`000000oooo0?ooo`040?ooo`h00000D`3oool00`000000oooo0?ooo`0C0?ooo`001@3oool0
0`000000oooo0?ooo`1H0?ooo`<00000C@3oool00`000000oooo0?ooo`040?ooo`030000003oool0
oooo00D0oooo00<000000?ooo`3oool00`3oool00`000000oooo0?ooo`0>0?ooo`040000003oool0
oooo000004l0oooo00<000000?ooo`3oool01P3oool00`000000oooo0?ooo`100?ooo`800000I`3o
ool6000000T0oooo0P00000B0?ooo`030000003oool0oooo03`0oooo00@000000?ooo`3oool00000
403oool00`000000oooo0?ooo`030?ooo`h00000D`3oool00`000000oooo0?ooo`0C0?ooo`001@3o
ool00`000000oooo0?ooo`1E0?ooo`<00000D@3oool00`000000oooo0?ooo`040?ooo`8000001P3o
ool00`000000oooo0?ooo`030?ooo`030000003oool0oooo00d0oooo00@000000?ooo`3oool00000
C@3oool2000000T0oooo00<000000?ooo`3oool0@P3oool00`000000oooo0?ooo`1S0?ooo`P00000
1P3oool2000001@0oooo00<000000?ooo`3oool0>`3oool010000000oooo0?ooo`00000B0?ooo`03
0000003oool0oooo0080oooo3P00001C0?ooo`030000003oool0oooo01<0oooo00040?ooo`030000
003oool0oooo0580oooo1000001E0?ooo`030000003oool0oooo00D0oooo00<000000?ooo`3oool0
0`3oool00`000000oooo0?ooo`030?ooo`030000003oool0oooo00d0oooo00<000000?ooo`000000
C@3oool00`000000oooo0?ooo`090?ooo`030000003oool0oooo04<0oooo0P00001R0?ooo`X00000
0`3oool2000001H0oooo00<000000?ooo`3oool0>P3oool010000000oooo0?ooo`00000D0?ooo`04
0000003oool0oooo0?ooo`d00000E03oool00`000000oooo0?ooo`0C0?ooo`00103oool00`000000
oooo0?ooo`1?0?ooo`<00000FP3oool00`000000oooo0?ooo`050?ooo`030000003oool0oooo00<0
oooo00<000000?ooo`3oool00`3oool00`000000oooo0?ooo`0<0?ooo`030000003oool0000004/0
oooo0P00000<0?ooo`030000003oool0oooo04D0oooo0P00001O0?ooo`h000005`3oool00`000000
oooo0?ooo`0j0?ooo`040000003oool0oooo000001H0oooo00@000000?ooo`3oool0oooo3000001E
0?ooo`030000003oool0oooo0180oooo00040?ooo`030000003oool0oooo04`0oooo0`00001N0?oo
o`030000003oool0oooo00D0oooo00<000000?ooo`3oool00`3oool00`000000oooo0?ooo`020?oo
o`030000003oool0oooo00`0oooo00<000000?ooo`000000BP3oool00`000000oooo0?ooo`0<0?oo
o`030000003oool0oooo04L0oooo00<000000?ooo`3oool0F`3oool=000001T0oooo00<000000?oo
o`3oool0>@3oool010000000oooo0?ooo`00000G0?ooo`040000003oool0oooo0?ooo`/00000EP3o
ool00`000000oooo0?ooo`0B0?ooo`00103oool00`000000oooo0?ooo`190?ooo`<00000HP3oool0
0`000000oooo0?ooo`050?ooo`030000003oool0oooo00<0oooo00<000000?ooo`3oool00P3oool0
0`000000oooo0?ooo`0;0?ooo`800000B@3oool2000000l0oooo00<000000?ooo`3oool0B03oool2
000005/0oooo3P00000H0?ooo`030000003oool0oooo03T0oooo00<000000?ooo`0000006@3oool3
000000030?ooo`000000000000L00000E`3oool00`000000oooo0?ooo`0B0?ooo`00103oool00`00
0000oooo0?ooo`150?ooo`@00000IP3oool00`000000oooo0?ooo`050?ooo`030000003oool0oooo
0080oooo00<000000?ooo`3oool00P3oool00`000000oooo0?ooo`0;0?ooo`800000B03oool00`00
0000oooo0?ooo`0?0?ooo`030000003oool0oooo04X0oooo0P00001I0?ooo`h00000603oool00`00
0000oooo0?ooo`0h0?ooo`030000003oool0000001X0oooo0P0000000`3oool000000?ooo`070000
05P0oooo00<000000?ooo`3oool04P3oool000@0oooo00<000000?ooo`3oool0@P3oool3000006X0
oooo00<000000?ooo`3oool01P3oool00`000000oooo0?ooo`020?ooo`030000003oool0oooo0080
oooo00<000000?ooo`3oool02`3oool00`000000oooo0?ooo`140?ooo`8000004P3oool00`000000
oooo0?ooo`1<0?ooo`030000003oool0oooo04L0oooo7@00000H0?ooo`030000003oool0oooo03L0
oooo00<000000?ooo`0000006P3oool00`000000oooo0?ooo`03000005l0oooo00<000000?ooo`3o
ool04P3oool000<0oooo00<000000?ooo`3oool0@03oool3000006h0oooo00<000000?ooo`3oool0
1P3oool00`000000oooo0?ooo`020?ooo`050000003oool0oooo0?ooo`000000303oool2000004D0
oooo00<000000?ooo`3oool04P3oool00`000000oooo0?ooo`1=0?ooo`800000>03oool?000000l0
oooo3P00000H0?ooo`030000003oool0oooo03H0oooo00<000000?ooo`0000006@3oool2000000<0
oooo0`00001O0?ooo`030000003oool0oooo0180oooo00030?ooo`030000003oool0oooo03d0oooo
0`00001b0?ooo`030000003oool0oooo00H0oooo00<000000?ooo`3oool00P3oool01@000000oooo
0?ooo`3oool0000000/0oooo0P0000130?ooo`8000005@3oool00`000000oooo0?ooo`1?0?ooo`80
00009`3oool?000001h0oooo3@00000I0?ooo`030000003oool0oooo03D0oooo00<000000?ooo`00
00006@3oool00`000000oooo0?ooo`030?ooo`<00000G`3oool00`000000oooo0?ooo`0B0?ooo`00
0`3oool00`000000oooo0?ooo`0i0?ooo`@00000MP3oool00`000000oooo0?ooo`060?ooo`050000
003oool0oooo0?ooo`0000000`3oool00`000000oooo0?ooo`090?ooo`800000@P3oool00`000000
oooo0?ooo`0E0?ooo`030000003oool0oooo0540oooo00<000000?ooo`3oool05@3oool?000002h0
oooo3000000I0?ooo`030000003oool0oooo03@0oooo00<000000?ooo`0000006@3oool00`000000
oooo0?ooo`030?ooo`040000003oool00000000005l0oooo00<000000?ooo`3oool04P3oool000<0
oooo00<000000?ooo`3oool0=P3oool3000007/0oooo00<000000?ooo`3oool01P3oool01@000000
oooo0?ooo`3oool0000000<0oooo00<000000?ooo`3oool01`3oool00`000000oooo000000100?oo
o`800000603oool00`000000oooo0?ooo`1B0?ooo`8000001@3oool@000003h0oooo2P00000J0?oo
o`030000003oool0oooo03<0oooo00<000000?ooo`000000603oool2000000H0oooo0P0000020?oo
o`030000003oool0oooo05d0oooo00<000000?ooo`3oool04@3oool000<0oooo00<000000?ooo`3o
ool0<`3oool3000007l0oooo00<000000?ooo`3oool01P3oool01@000000oooo0?ooo`3oool00000
0080oooo00<000000?ooo`3oool01`3oool00`000000oooo0000000o0?ooo`030000003oool0oooo
01P0oooo00<000000?ooo`3oool0BP3oool?000004l0oooo2000000J0?ooo`030000003oool0oooo
03<0oooo00@000000?ooo`3oool000005`3oool00`000000oooo0?ooo`050?ooo`030000003oool0
000000<0oooo00<000000?ooo`3oool0G03oool00`000000oooo0?ooo`0A0?ooo`000`3oool00`00
0000oooo0?ooo`0`0?ooo`<00000P`3oool00`000000oooo0?ooo`060?ooo`050000003oool0oooo
0?ooo`0000000P3oool00`000000oooo0?ooo`060?ooo`030000003oool0000003h0oooo00<00000
0?ooo`3oool06@3oool00`000000oooo0?ooo`0k0?ooo`l00000303oool00`000000oooo0?ooo`1@
0?ooo`H000006`3oool00`000000oooo0?ooo`0c0?ooo`030000003oool0000001L0oooo00<00000
0?ooo`3oool01P3oool2000000D0oooo00<000000?ooo`3oool0F`3oool00`000000oooo0?ooo`0A
0?ooo`000`3oool00`000000oooo0?ooo`0]0?ooo`<00000Q`3oool00`000000oooo0?ooo`060?oo
o`040000003oool0oooo00000080oooo00<000000?ooo`3oool01@3oool01@000000oooo0?ooo`3o
ool0000003/0oooo0P00000L0?ooo`030000003oool0oooo02`0oooo3`00000L0?ooo`800000E03o
ool00`000000oooo0?ooo`0J0?ooo`030000003oool0oooo0380oooo00<000000?ooo`0000005P3o
ool2000000T0oooo0P0000060?ooo`030000003oool0oooo05X0oooo00<000000?ooo`3oool04@3o
ool00080oooo00<000000?ooo`3oool0:P3oool4000008X0oooo00<000000?ooo`3oool01`3oool0
10000000oooo0?ooo`0000020?ooo`030000003oool0oooo00@0oooo00D000000?ooo`3oool0oooo
0000000j0?ooo`030000003oool0oooo01`0oooo00<000000?ooo`3oool07@3oool?000002d0oooo
0P00001B0?ooo`030000003oool0oooo01X0oooo00<000000?ooo`3oool0<@3oool00`000000oooo
0000000F0?ooo`030000003oool0oooo00P0oooo0P0000080?ooo`030000003oool0oooo05T0oooo
00<000000?ooo`3oool04@3oool00080oooo00<000000?ooo`3oool09`3oool3000008l0oooo00<0
00000?ooo`3oool01`3oool2000000040?ooo`000000oooo000000H0oooo00D000000?ooo`3oool0
oooo0000000h0?ooo`8000007`3oool00`000000oooo0?ooo`0>0?ooo`l00000?P3oool00`000000
oooo0?ooo`1?0?ooo`030000003oool0oooo01X0oooo00<000000?ooo`3oool0<03oool00`000000
oooo0000000F0?ooo`030000003oool0oooo00T0oooo0P0000080?ooo`030000003oool0oooo05T0
oooo00<000000?ooo`3oool04@3oool00080oooo00<000000?ooo`3oool0903oool3000009<0oooo
00<000000?ooo`3oool0203oool01@000000oooo0000003oool0000000@0oooo00<000000?ooo`3o
ool00P3oool00`000000oooo0?ooo`0e0?ooo`030000003oool0oooo01l0oooo00<000000?ooo`00
00003P00001>0?ooo`800000C`3oool00`000000oooo0?ooo`0J0?ooo`030000003oool0oooo02l0
oooo00<000000?ooo`0000005@3oool2000000/0oooo0P00000:0?ooo`030000003oool0oooo05P0
oooo00<000000?ooo`3oool04@3oool00080oooo00<000000?ooo`3oool08@3oool3000009L0oooo
00<000000?ooo`3oool0203oool2000000030?ooo`000000000000@00000103oool00`000000oooo
0?ooo`0c0?ooo`8000005@3oool?000005l0oooo0P00001>0?ooo`030000003oool0oooo01T0oooo
00<000000?ooo`3oool0;P3oool00`000000oooo0000000E0?ooo`030000003oool0oooo00/0oooo
0P00000;0?ooo`030000003oool0oooo05P0oooo00<000000?ooo`3oool0403oool00080oooo00<0
00000?ooo`3oool07@3oool4000009/0oooo00<000000?ooo`3oool0203oool9000000<0oooo00<0
00000?ooo`3oool0<P3oool00`000000oooo0?ooo`060?ooo`l00000303oool00`000000oooo0?oo
o`1Q0?ooo`030000003oool0oooo04/0oooo00<000000?ooo`3oool06@3oool00`000000oooo0?oo
o`0]0?ooo`030000003oool0000001D0oooo00<000000?ooo`3oool02`3oool2000000d0oooo00<0
00000?ooo`3oool0E`3oool00`000000oooo0?ooo`0@0?ooo`000P3oool00`000000oooo0?ooo`0J
0?ooo`<00000X03oool00`000000oooo0?ooo`070?ooo`X000000P3oool00`000000oooo0?ooo`0[
0?oooa0000006`3oool00`000000oooo0?ooo`1R0?ooo`800000B`3oool00`000000oooo0?ooo`0I
0?ooo`030000003oool0oooo02d0oooo0P00000D0?ooo`8000003P3oool2000000h0oooo00<00000
0?ooo`3oool0EP3oool00`000000oooo0?ooo`0@0?ooo`0000<0oooo0000003oool06@3oool30000
0:@0oooo00<000000?ooo`3oool01@3oool<00000080oooo00<000000?ooo`3oool06`3oool?0000
00@0oooo00<000000?ooo`3oool0903oool00`000000oooo0?ooo`1T0?ooo`800000B@3oool00`00
0000oooo0?ooo`0H0?ooo`030000003oool0oooo02d0oooo0P00000D0?ooo`030000003oool0oooo
00d0oooo0P00000@0?ooo`030000003oool0oooo05D0oooo00<000000?ooo`3oool0403oool00003
0?ooo`000000oooo01H0oooo0`00002X0?ooo`030000003oool0oooo00<0oooo3@0000020?ooo`03
0000003oool0oooo00`0oooo3`00000A0?ooo`8000009`3oool00`000000oooo0?ooo`1V0?ooo`03
0000003oool0oooo04H0oooo00<000000?ooo`3oool0603oool00`000000oooo0?ooo`0/0?ooo`80
0000503oool00`000000oooo0?ooo`0>0?ooo`800000403oool00`000000oooo0?ooo`1E0?ooo`03
0000003oool0oooo0100oooo00000`3oool000000?ooo`0B0?ooo`@00000Z`3oool00`000000oooo
0?ooo`030?ooo`h0000000<0oooo0000000000003@00000O0?ooo`030000003oool0oooo02L0oooo
00<000000?ooo`3oool0I`3oool2000004H0oooo00<000000?ooo`3oool0603oool00`000000oooo
0?ooo`0[0?ooo`8000004`3oool200000140oooo00<000000?ooo`3oool0403oool00`000000oooo
0?ooo`1D0?ooo`030000003oool0oooo0100oooo00000`3oool000000?ooo`0?0?ooo`<00000/03o
ool00`000000oooo0?ooo`020?oooa000000:`3oool2000002X0oooo00<000000?ooo`3oool0J@3o
ool2000004@0oooo00<000000?ooo`3oool0603oool00`000000oooo0?ooo`0Z0?ooo`8000004`3o
ool00`000000oooo0?ooo`0@0?ooo`8000004`3oool00`000000oooo0?ooo`1C0?ooo`030000003o
ool0oooo0100oooo00000`3oool000000?ooo`0<0?ooo`<00000]03oool010000000oooo0?ooo`3o
ool>000000030?ooo`000000oooo02T0oooo00<000000?ooo`3oool0:P3oool00`000000oooo0?oo
o`1[0?ooo`030000003oool0oooo0480oooo00<000000?ooo`3oool05`3oool00`000000oooo0?oo
o`0Y0?ooo`8000004`3oool00`000000oooo0?ooo`0;0?ooo`L000005@3oool00`000000oooo0?oo
o`1B0?ooo`030000003oool0oooo0100oooo00000`3oool000000?ooo`090?ooo`<00000^03oool0
0`000000oooo0?ooo`0A000002L0oooo0P00000]0?ooo`030000003oool0oooo06`0oooo0P000012
0?ooo`030000003oool0oooo01L0oooo00<000000?ooo`3oool0:03oool200000180oooo0P00000=
0?ooo`P000005P3oool00`000000oooo0?ooo`1B0?ooo`030000003oool0oooo00l0oooo00000`00
0000oooo0?ooo`060?ooo`<00000_03oool00`000000oooo0000000<00000080oooo00<000000?oo
o`0000000`00000R0?ooo`030000003oool0oooo02d0oooo00<000000?ooo`3oool0KP3oool20000
0400oooo00<000000?ooo`3oool05`3oool00`000000oooo0?ooo`0X0?ooo`030000003oool0oooo
0100oooo00<000000?ooo`3oool0303oool:000001H0oooo00<000000?ooo`3oool0D@3oool00`00
0000oooo0?ooo`0?0?ooo`0000<000000?ooo`3oool00P3oool400000<00oooo00<000000?ooo`00
00002`0000030?ooo`030000003oool0oooo0080oooo1000000L0?ooo`800000<03oool00`000000
oooo0?ooo`1`0?ooo`800000?P3oool00`000000oooo0?ooo`0G0?ooo`030000003oool0oooo02L0
oooo00<000000?ooo`3oool0403oool00`000000oooo0?ooo`0<0?ooo``000005@3oool00`000000
oooo0?ooo`1A0?ooo`030000003oool0oooo00l0oooo00000`000000oooo0000000200000<D0oooo
00<000000?ooo`0000002@0000001@3oool000000?ooo`3oool0000000P0oooo1000000G0?ooo`03
0000003oool0oooo0300oooo00<000000?ooo`3oool0LP3oool00`000000oooo0?ooo`0k0?ooo`03
0000003oool0oooo01L0oooo00<000000?ooo`3oool09P3oool00`000000oooo0?ooo`0?0?ooo`80
00003P3oool=000001H0oooo00<000000?ooo`3oool0D03oool00`000000oooo0?ooo`0?0?ooo`00
0P0000390?ooo`030000003oool0000000L000000`3oool00`000000oooo0000000<0?ooo`@00000
4@3oool2000003<0oooo00<000000?ooo`3oool0L`3oool2000003/0oooo00<000000?ooo`3oool0
5P3oool00`000000oooo0?ooo`0V0?ooo`030000003oool0oooo00l0oooo00<000000?ooo`3oool0
3P3oool>000001H0oooo00<000000?ooo`3oool0C`3oool00`000000oooo0?ooo`0?0?ooo`0000<0
oooo000000000000b03oool00`000000oooo0?ooo`07000000@0oooo0P00000@0?ooo`@00000303o
ool00`000000oooo0?ooo`0c0?ooo`030000003oool0oooo07D0oooo0P00000i0?ooo`030000003o
ool0oooo01H0oooo00<000000?ooo`3oool09@3oool00`000000oooo0?ooo`0?0?ooo`030000003o
ool0oooo00l0oooo3P00000G0?ooo`030000003oool0oooo04h0oooo00<000000?ooo`3oool03`3o
ool000<0oooo00<000000?ooo`3oool0aP3oool00`000000oooo0?ooo`060?ooo`030000003oool0
oooo0080oooo0P00000C0?ooo`@000001P3oool2000003H0oooo00<000000?ooo`3oool0M`3oool0
0`000000oooo0?ooo`0f0?ooo`030000003oool0oooo01H0oooo00<000000?ooo`3oool0903oool0
0`000000oooo0?ooo`0>0?ooo`8000004P3oool>000001P0oooo00<000000?ooo`3oool0C@3oool0
0`000000oooo0?ooo`0?0?ooo`00103oool00`000000oooo0?ooo`360?ooo`030000003oool0oooo
00D0oooo00<000000?ooo`3oool00P3oool00`000000oooo0000000F0?ooo`@0000000<0oooo0000
003oool0=`3oool00`000000oooo0?ooo`1h0?ooo`800000=`3oool00`000000oooo0?ooo`0E0?oo
o`030000003oool0oooo02<0oooo00<000000?ooo`3oool03P3oool00`000000oooo0?ooo`0B0?oo
o`h000006@3oool00`000000oooo0?ooo`1=0?ooo`030000003oool0oooo00h0oooo00050?ooo`80
0000a`3oool00`000000oooo0?ooo`040?ooo`030000003oool0oooo00<0oooo00<000000?ooo`00
0000603oool5000003H0oooo00<000000?ooo`3oool0NP3oool2000003D0oooo00<000000?ooo`3o
ool05@3oool00`000000oooo0?ooo`0R0?ooo`8000003`3oool00`000000oooo0?ooo`0C0?ooo`d0
00006P3oool00`000000oooo0?ooo`1=0?ooo`030000003oool0oooo00h0oooo00070?ooo`030000
003oool0oooo0<D0oooo00<000000?ooo`3oool0103oool00`000000oooo0?ooo`020?ooo`040000
003oool0oooo000001H0oooo00<000000?ooo`3oool00`3oool400000380oooo00<000000?ooo`3o
ool0O03oool00`000000oooo0?ooo`0b0?ooo`030000003oool0oooo01D0oooo00<000000?ooo`3o
ool08@3oool2000000h0oooo0P00000E0?ooo`h000006`3oool00`000000oooo0?ooo`1<0?ooo`03
0000003oool0oooo00h0oooo00080?ooo`800000aP3oool00`000000oooo0?ooo`030?ooo`030000
003oool0oooo0080oooo00@000000?ooo`3oool0oooo0P00000B0?ooo`8000002P3oool4000002h0
oooo00<000000?ooo`3oool0O@3oool200000380oooo00<000000?ooo`3oool05@3oool00`000000
oooo0?ooo`0P0?ooo`8000003P3oool00`000000oooo0?ooo`0C0?ooo`@0000000<0oooo00000000
00002000000M0?ooo`030000003oool0oooo04/0oooo00<000000?ooo`3oool03P3oool000X0oooo
00<000000?ooo`3oool0a03oool00`000000oooo0?ooo`030?ooo`050000003oool0oooo0?ooo`00
00001@3oool00`000000oooo0?ooo`0>0?ooo`030000003oool0oooo00h0oooo1000000Z0?ooo`03
0000003oool0oooo07l0oooo0P00000`0?ooo`030000003oool0oooo01D0oooo00<000000?ooo`3o
ool07`3oool2000000h0oooo00<000000?ooo`3oool04P3oool2000000030?ooo`000000oooo00<0
oooo2000000O0?ooo`030000003oool0oooo04X0oooo00<000000?ooo`3oool03P3oool000/0oooo
00<000000?ooo`3oool0a03oool00`000000oooo0?ooo`020?ooo`050000003oool0oooo0?ooo`00
00001P3oool00`000000oooo0?ooo`0;0?ooo`8000005@3oool4000002H0oooo00<000000?ooo`3o
ool0P@3oool00`000000oooo0?ooo`0]0?ooo`030000003oool0oooo01D0oooo00<000000?ooo`3o
ool07`3oool00`000000oooo0?ooo`0;0?ooo`8000004`3oool2000000030?ooo`000000000000H0
oooo1P00000Q0?ooo`030000003oool0oooo04T0oooo00<000000?ooo`3oool03P3oool000`0oooo
0P0000340?ooo`030000003oool0oooo00<0oooo00@000000?ooo`3oool000001`3oool00`000000
oooo0?ooo`090?ooo`030000003oool0oooo01T0oooo1000000R0?ooo`030000003oool0oooo0880
oooo0P00000]0?ooo`030000003oool0oooo01@0oooo00<000000?ooo`3oool07`3oool00`000000
oooo0?ooo`0;0?ooo`030000003oool0oooo0180oooo00@000000?ooo`3oool00000<03oool00`00
0000oooo0?ooo`180?ooo`030000003oool0oooo00h0oooo000>0?ooo`030000003oool0oooo0<80
oooo00<000000?ooo`3oool00P3oool010000000oooo0?ooo`0000080?ooo`8000001`3oool20000
0200oooo1000000N0?ooo`030000003oool0oooo08@0oooo0P00000/0?ooo`030000003oool0oooo
01<0oooo00<000000?ooo`3oool07P3oool00`000000oooo0?ooo`0;0?ooo`030000003oool0oooo
0140oooo0P0000000`3oool000000000000a0?ooo`030000003oool0oooo04P0oooo00<000000?oo
o`3oool03P3oool000l0oooo00<000000?ooo`3oool0`P3oool00`000000oooo0?ooo`020?ooo`04
0000003oool0oooo000000T0oooo00<000000?ooo`3oool00`3oool00`000000oooo0?ooo`0T0?oo
o`@000006P3oool00`000000oooo0?ooo`260?ooo`030000003oool0oooo02T0oooo00<000000?oo
o`3oool04`3oool00`000000oooo0?ooo`0M0?ooo`030000003oool0oooo00X0oooo0P00000B0?oo
o`8000000P3oool00`000000oooo0?ooo`0b0?ooo`030000003oool0oooo04P0oooo00<000000?oo
o`3oool03@3oool00100oooo0P0000330?ooo`050000003oool0oooo0?ooo`0000000P3oool00`00
0000oooo0?ooo`080?ooo`030000003oool0oooo00800000:`3oool3000001L0oooo00<000000?oo
o`3oool0Q`3oool2000002T0oooo00<000000?ooo`3oool04`3oool00`000000oooo0?ooo`0L0?oo
o`8000002`3oool00`000000oooo0?ooo`0@0?ooo`8000000P3oool2000003H0oooo00<000000?oo
o`3oool0A`3oool00`000000oooo0?ooo`0=0?ooo`004P3oool00`000000oooo0?ooo`310?ooo`04
0000003oool0oooo00000080oooo00<000000?ooo`3oool02@3oool200000300oooo1000000C0?oo
o`030000003oool0oooo08T0oooo0P00000W0?ooo`030000003oool0oooo01<0oooo00<000000?oo
o`3oool06`3oool2000000/0oooo00<000000?ooo`3oool03`3oool200000080oooo0P00000i0?oo
o`030000003oool0oooo04H0oooo00<000000?ooo`3oool03@3oool001<0oooo0P0000320?ooo`06
0000003oool0oooo0000003oool000002P3oool3000003@0oooo1000000?0?ooo`030000003oool0
oooo08/0oooo00<000000?ooo`3oool0903oool00`000000oooo0?ooo`0C0?ooo`030000003oool0
oooo01X0oooo0P00000:0?ooo`800000403oool2000000<0oooo00<000000?ooo`3oool0>P3oool0
0`000000oooo0?ooo`150?ooo`030000003oool0oooo00d0oooo000E0?ooo`030000003oool0oooo
0<00oooo00<000000?ooo`0000001@0000060?ooo`040000003oool0oooo0?ooo`800000=P3oool4
000000/0oooo00<000000?ooo`3oool0S03oool2000002@0oooo00<000000?ooo`3oool04`3oool0
0`000000oooo0?ooo`0I0?ooo`8000002P3oool00`000000oooo0?ooo`0>0?ooo`8000000`3oool2
000003d0oooo00<000000?ooo`3oool0A@3oool00`000000oooo0?ooo`0=0?ooo`005P3oool00`00
0000oooo0?ooo`300?ooo`P000000`3oool2000000H0oooo00<000000?ooo`3oool0=`3oool40000
00L0oooo00<000000?ooo`3oool0SP3oool200000280oooo00<000000?ooo`3oool04`3oool00`00
0000oooo0?ooo`0H0?ooo`8000002P3oool00`000000oooo0?ooo`0=0?ooo`800000103oool00`00
0000oooo0?ooo`0n0?ooo`030000003oool0oooo04@0oooo00<000000?ooo`3oool03@3oool001L0
oooo0P00002o0?ooo`X0000000<0oooo0000003oool0203oool00`000000oooo0?ooo`0j0?ooo`@0
00000`3oool00`000000oooo0?ooo`2@0?ooo`030000003oool0oooo01l0oooo00<000000?ooo`3o
ool04`3oool00`000000oooo0?ooo`0G0?ooo`8000002@3oool2000000l0oooo00<000000?ooo`3o
ool00P3oool200000480oooo00<000000?ooo`3oool0@`3oool00`000000oooo0?ooo`0=0?ooo`00
6@3oool00`000000oooo0?ooo`2k0?ooo``000002`3oool00`000000oooo0?ooo`0m0?ooo`@00000
T`3oool200000200oooo00<000000?ooo`3oool04@3oool00`000000oooo0?ooo`0G0?ooo`800000
2@3oool00`000000oooo0?ooo`0=0?ooo`800000103oool00`000000oooo0?ooo`130?ooo`030000
003oool0oooo04<0oooo00<000000?ooo`3oool0303oool001X0oooo0P00002j0?ooo`d00000303o
ool00`000000oooo0?ooo`0n0?ooo`030000003oool0000000<00000T@3oool2000001h0oooo00<0
00000?ooo`3oool04@3oool00`000000oooo0?ooo`0F0?ooo`030000003oool0000000P0oooo00<0
00000?ooo`3oool0303oool2000000@0oooo0P0000170?ooo`030000003oool0oooo0480oooo00<0
00000?ooo`3oool0303oool001`0oooo00<000000?ooo`3oool0]`3oool>000000`0oooo0P00000n
0?ooo`030000003oool0oooo00<0oooo1000002?0?ooo`030000003oool0oooo01/0oooo00<00000
0?ooo`3oool04@3oool00`000000oooo0?ooo`0E0?ooo`030000003oool0000000L0oooo0P00000=
0?ooo`8000001@3oool00`000000oooo0?ooo`180?ooo`030000003oool0oooo0440oooo00<00000
0?ooo`3oool0303oool001d0oooo00<000000?ooo`3oool0]P3oool>000000h0oooo00<000000?oo
o`3oool0>`3oool00`000000oooo0?ooo`070?ooo`@00000S03oool2000001/0oooo00<000000?oo
o`3oool04@3oool00`000000oooo0?ooo`0D0?ooo`030000003oool0000000L0oooo00<000000?oo
o`3oool02`3oool2000000D0oooo0P00001;0?ooo`030000003oool0oooo0440oooo00<000000?oo
o`3oool0303oool001h0oooo0P00002f0?oooaL000001P3oool00`000000oooo0?ooo`0j0?ooo`03
0000003oool0oooo00/0oooo1000002:0?ooo`8000006@3oool00`000000oooo0?ooo`0A0?ooo`03
0000003oool0oooo01<0oooo00<000000?ooo`0000001`3oool00`000000oooo0?ooo`0:0?ooo`80
00001P3oool00`000000oooo0?ooo`1<0?ooo`030000003oool0oooo0400oooo00<000000?ooo`3o
ool0303oool00200oooo00<000000?ooo`3oool0/`3oool>000000T0oooo2`00000h0?ooo`030000
003oool0oooo00l0oooo100000280?ooo`030000003oool0oooo01H0oooo00<000000?ooo`3oool0
4@3oool00`000000oooo0?ooo`0B0?ooo`030000003oool0000000H0oooo0P00000;0?ooo`800000
1P3oool200000500oooo00<000000?ooo`3oool0?`3oool00`000000oooo0?ooo`0<0?ooo`008@3o
ool00`000000oooo0?ooo`2b0?ooo`d000004P3oool2000000030?ooo`000000000000P00000;P3o
ool00`000000oooo0?ooo`0C0?ooo`@00000Q@3oool2000001H0oooo00<000000?ooo`3oool04@3o
ool00`000000oooo0?ooo`0A0?ooo`030000003oool0000000H0oooo00<000000?ooo`3oool02P3o
ool00`000000oooo0?ooo`050?ooo`030000003oool0oooo0540oooo00<000000?ooo`3oool0?P3o
ool00`000000oooo0?ooo`0<0?ooo`008P3oool200000;<0oooo3@00000C0?ooo`030000003oool0
oooo00P0oooo2`00000S0?ooo`030000003oool0oooo01L0oooo100000230?ooo`8000005@3oool0
0`000000oooo0?ooo`0@0?ooo`030000003oool0oooo0100oooo00<000000?ooo`0000001P3oool0
0`000000oooo0?ooo`090?ooo`8000001P3oool2000005D0oooo00<000000?ooo`3oool0?P3oool0
0`000000oooo0?ooo`0;0?ooo`00903oool00`000000oooo0?ooo`2a0?ooo`X000000P3oool20000
0180oooo00<000000?ooo`3oool04P3oool:000001T0oooo00<000000?ooo`3oool06`3oool40000
0840oooo00<000000?ooo`3oool04P3oool00`000000oooo0?ooo`0?0?ooo`030000003oool0oooo
0100oooo00@000000?ooo`3oool00000103oool2000000X0oooo0P0000070?ooo`030000003oool0
oooo05H0oooo00<000000?ooo`3oool0?@3oool00`000000oooo0?ooo`0;0?ooo`009@3oool20000
0;80oooo200000050?ooo`030000003oool0oooo0100oooo00<000000?ooo`3oool06`3oool;0000
00h0oooo00<000000?ooo`3oool07`3oool4000007h0oooo0P00000B0?ooo`030000003oool0oooo
00l0oooo00<000000?ooo`3oool03`3oool010000000oooo0?ooo`0000040?ooo`030000003oool0
oooo00P0oooo0P0000070?ooo`800000F@3oool00`000000oooo0?ooo`0m0?ooo`030000003oool0
oooo00/0oooo000W0?ooo`030000003oool0oooo0;00oooo1P0000070?ooo`8000004@3oool00`00
0000oooo0?ooo`0U0?ooo`X00000103oool00`000000oooo0?ooo`0S0?ooo`@00000O03oool20000
0100oooo00<000000?ooo`3oool03`3oool00`000000oooo0?ooo`0>0?ooo`040000003oool0oooo
000000@0oooo00<000000?ooo`3oool01`3oool2000000P0oooo00<000000?ooo`3oool0FP3oool0
0`000000oooo0?ooo`0l0?ooo`030000003oool0oooo00/0oooo000X0?ooo`030000003oool0oooo
0;h0oooo00<000000?ooo`3oool03`3oool2000002l0oooo2`00000S0?ooo`@00000NP3oool00`00
0000oooo0?ooo`0=0?ooo`030000003oool0oooo00l0oooo00<000000?ooo`3oool03@3oool01000
0000oooo0?ooo`0000030?ooo`800000203oool2000000P0oooo0P00001N0?ooo`030000003oool0
oooo03/0oooo00<000000?ooo`3oool02`3oool002T0oooo0P00002o0?ooo`8000004@3oool00`00
0000oooo0?ooo`0`0?ooo`030000003oool0oooo00@0oooo2P00000M0?ooo`<00000N03oool20000
00d0oooo00<000000?ooo`3oool03`3oool00`000000oooo0?ooo`0<0?ooo`040000003oool0oooo
000000<0oooo00<000000?ooo`3oool01P3oool2000000T0oooo00<000000?ooo`3oool0G`3oool0
0`000000oooo0?ooo`0j0?ooo`030000003oool0oooo00/0oooo000[0?ooo`030000003oool0oooo
0;h0oooo00<000000?ooo`3oool03`3oool00`000000oooo0?ooo`0_0?ooo`030000003oool0oooo
00h0oooo2`00000E0?ooo`@00000MP3oool2000000/0oooo00<000000?ooo`3oool03`3oool00`00
0000oooo0?ooo`0;0?ooo`040000003oool0oooo000000<0oooo00<000000?ooo`3oool01@3oool2
000000T0oooo0P00001S0?ooo`030000003oool0oooo03T0oooo00<000000?ooo`3oool02`3oool0
02`0oooo0P00002o0?ooo`800000403oool00`000000oooo0?ooo`0^0?ooo`030000003oool0oooo
01T0oooo2P00000?0?ooo`@00000M03oool2000000T0oooo00<000000?ooo`3oool03`3oool00`00
0000oooo0?ooo`0:0?ooo`040000003oool0oooo00000080oooo0P0000070?ooo`030000003oool0
oooo00P0oooo00<000000?ooo`3oool0I03oool00`000000oooo0?ooo`0h0?ooo`030000003oool0
oooo00/0oooo000^0?ooo`030000003oool0oooo0;h0oooo00<000000?ooo`3oool03P3oool20000
02h0oooo00<000000?ooo`3oool08`3oool;000000P0oooo1000001b0?ooo`030000003oool0oooo
00L0oooo00<000000?ooo`3oool03P3oool00`000000oooo0?ooo`090?ooo`040000003oool0oooo
00000080oooo00<000000?ooo`3oool01@3oool2000000T0oooo0P00001W0?ooo`030000003oool0
oooo03T0oooo00<000000?ooo`3oool02P3oool002l0oooo00<000000?ooo`3oool0_P3oool20000
0100oooo00<000000?ooo`3oool0:`3oool00`000000oooo0?ooo`0^0?ooo`X000000P3oool40000
06l0oooo0P0000070?ooo`030000003oool0oooo00h0oooo00<000000?ooo`3oool0203oool01`00
0000oooo0?ooo`3oool000000?ooo`0000001P3oool2000000T0oooo0P00001Z0?ooo`030000003o
ool0oooo03P0oooo00<000000?ooo`3oool02P3oool00300oooo0P0000300?ooo`030000003oool0
oooo00h0oooo00<000000?ooo`3oool0:P3oool00`000000oooo0?ooo`0h0?ooo`X00000K@3oool2
000000D0oooo00<000000?ooo`3oool03@3oool00`000000oooo0?ooo`090?ooo`030000003oool0
oooo00<000001@3oool2000000X0oooo00<000000?ooo`3oool0J`3oool00`000000oooo0?ooo`0g
0?ooo`030000003oool0oooo00X0oooo000b0?ooo`030000003oool0oooo0;h0oooo0P00000?0?oo
o`030000003oool0oooo02T0oooo00<000000?ooo`3oool0@P3oool;000006@0oooo00<000000?oo
o`3oool00P3oool00`000000oooo0?ooo`0=0?ooo`030000003oool0oooo00P0oooo00<000000?oo
o`3oool00P0000050?ooo`8000002P3oool2000006l0oooo00<000000?ooo`3oool0=P3oool00`00
0000oooo0?ooo`0:0?ooo`00<`3oool00`000000oooo0?ooo`2o0?ooo`030000003oool0oooo00d0
oooo00<000000?ooo`3oool0:03oool00`000000oooo0?ooo`160?ooo`@000000`3oool:000005/0
oooo0P0000020?ooo`030000003oool0oooo00d0oooo00<000000?ooo`3oool01`3oool00`000000
oooo0?ooo`02000000@0oooo0P00000;0?ooo`030000003oool0oooo0700oooo00<000000?ooo`3o
ool0=@3oool00`000000oooo0?ooo`0:0?ooo`00=03oool200000<00oooo0P00000>0?ooo`800000
:03oool00`000000oooo0?ooo`1:0?ooo`@000002@3oool;00000580oooo0`00000?0?ooo`030000
003oool0oooo00H0oooo00<000000?ooo`3oool00P0000030?ooo`8000002`3oool2000007@0oooo
00<000000?ooo`3oool0=03oool00`000000oooo0?ooo`0:0?ooo`00=P3oool00`000000oooo0?oo
o`2o0?ooo`030000003oool0oooo00d0oooo00<000000?ooo`3oool09@3oool00`000000oooo0?oo
o`1>0?ooo`@00000403oool:000004X0oooo00<000000?ooo`3oool03@3oool00`000000oooo0?oo
o`050?ooo`040000003oool0oooo000000<0oooo0P00000<0?ooo`030000003oool0oooo07@0oooo
00<000000?ooo`3oool0=03oool00`000000oooo0?ooo`0:0?ooo`00=`3oool200000<00oooo0P00
000>0?ooo`030000003oool0oooo02@0oooo00<000000?ooo`3oool0DP3oool4000001H0oooo2`00
00100?ooo`8000003@3oool00`000000oooo0?ooo`040?ooo`040000003oool0oooo000000<0oooo
00<000000?ooo`3oool02P3oool2000007P0oooo00<000000?ooo`3oool0=03oool00`000000oooo
0?ooo`090?ooo`00>@3oool00`000000oooo0?ooo`2o0?ooo`030000003oool0oooo00`0oooo00<0
00000?ooo`3oool08`3oool00`000000oooo0?ooo`1F0?ooo`@000007@3oool:000003H0oooo00@0
00000?ooo`00000000002`3oool00`000000oooo0?ooo`030?ooo`030000003oool0000000800000
00<0oooo000000000000303oool00`000000oooo0?ooo`1i0?ooo`030000003oool0oooo03<0oooo
00<000000?ooo`3oool02@3oool003X0oooo00<000000?ooo`3oool0_`3oool2000000d0oooo00<0
00000?ooo`3oool08P3oool00`000000oooo0?ooo`1J0?ooo`@000008`3oool;000002/0oooo00D0
00000?ooo`3oool0oooo000000070?ooo`H000000P3oool010000000oooo0000003oool3000000`0
oooo0P00001m0?ooo`030000003oool0oooo0380oooo00<000000?ooo`3oool02@3oool003/0oooo
0P0000310?ooo`030000003oool0oooo00/0oooo0P00000R0?ooo`030000003oool0oooo05h0oooo
1000000Z0?ooo`X000008@3oool00`000000oooo0?ooo`020?ooo`800000103oool9000000030?oo
o`000000oooo008000003@3oool00`000000oooo0?ooo`1n0?ooo`030000003oool0oooo0340oooo
00<000000?ooo`3oool02@3oool003d0oooo00<000000?ooo`3oool0_`3oool2000000d0oooo00<0
00000?ooo`3oool07`3oool00`000000oooo0?ooo`1R0?ooo`@00000<03oool;000001H0oooo00<0
00000?ooo`3oool0103oool2000000030?ooo`000000000000/000003@3oool200000880oooo00<0
00000?ooo`3oool0<03oool00`000000oooo0?ooo`090?ooo`00?P3oool200000<40oooo00<00000
0?ooo`3oool02`3oool00`000000oooo0?ooo`0N0?ooo`030000003oool0oooo06H0oooo1000000g
0?ooo`X00000303oool00`000000oooo0?ooo`060?ooo`d000003@3oool00`000000oooo0?ooo`22
0?ooo`030000003oool0oooo0300oooo00<000000?ooo`3oool02@3oool00400oooo00<000000?oo
o`3oool0_`3oool2000000`0oooo00<000000?ooo`3oool07@3oool00`000000oooo0?ooo`1Z0?oo
o`@00000?@3oool;000000030?ooo`000000oooo00H0oooo3@00000<0?ooo`800000QP3oool00`00
0000oooo0?ooo`0_0?ooo`030000003oool0oooo00T0oooo00110?ooo`030000003oool0oooo0<00
oooo00<000000?ooo`3oool02P3oool2000001d0oooo00<000000?ooo`3oool0KP3oool4000004@0
oooo5`00000:0?ooo`030000003oool0oooo08L0oooo00<000000?ooo`3oool0;P3oool00`000000
oooo0?ooo`090?ooo`00@P3oool200000<40oooo0P00000<0?ooo`030000003oool0oooo01X0oooo
00<000000?ooo`3oool0LP3oool3000004<0oooo00<000000?ooo`3oool0103oool>000000P0oooo
0P00002;0?ooo`030000003oool0oooo02h0oooo00<000000?ooo`3oool0203oool004@0oooo00<0
00000?ooo`3oool0`03oool00`000000oooo0?ooo`0:0?ooo`030000003oool0oooo01P0oooo00<0
00000?ooo`3oool0MP3oool4000003l0oooo00<000000?ooo`3oool0103oool>000000L0oooo00<0
00000?ooo`3oool0S03oool00`000000oooo0?ooo`0]0?ooo`030000003oool0oooo00P0oooo0015
0?ooo`030000003oool0oooo0<00oooo0P00000;0?ooo`030000003oool0oooo01L0oooo00<00000
0?ooo`3oool0NP3oool4000003/0oooo00<000000?ooo`3oool00P3oool@000000D0oooo0P00002@
0?ooo`030000003oool0oooo02`0oooo00<000000?ooo`3oool0203oool004H0oooo0P0000320?oo
o`030000003oool0oooo00T0oooo00<000000?ooo`3oool05P3oool00`000000oooo0?ooo`1n0?oo
o`@00000=`3oool500000080oooo3@0000050?ooo`030000003oool0oooo0900oooo00<000000?oo
o`3oool0;03oool00`000000oooo0?ooo`080?ooo`00B03oool00`000000oooo0?ooo`300?ooo`80
00002P3oool2000001H0oooo00<000000?ooo`3oool0PP3oool400000300oooo100000070?ooo``0
00000`3oool2000009@0oooo00<000000?ooo`3oool0:`3oool00`000000oooo0?ooo`080?ooo`00
B@3oool200000<80oooo00<000000?ooo`3oool02@3oool00`000000oooo0?ooo`0C0?ooo`030000
003oool0oooo08H0oooo1000000Y0?ooo`<000000`3oool00`000000oooo0?ooo`060?ooo`X00000
0`3oool00`000000oooo0?ooo`2E0?ooo`030000003oool0oooo02X0oooo00<000000?ooo`3oool0
203oool004/0oooo00<000000?ooo`3oool0`03oool2000000X0oooo00<000000?ooo`3oool04P3o
ool00`000000oooo0?ooo`2:0?ooo`@000008@3oool4000000H0oooo00<000000?ooo`3oool01P3o
ool900000080oooo0P00002I0?ooo`030000003oool0oooo02T0oooo00<000000?ooo`3oool0203o
ool004`0oooo00<000000?ooo`3oool0`@3oool00`000000oooo0?ooo`080?ooo`030000003oool0
oooo0140oooo00<000000?ooo`3oool0SP3oool4000001X0oooo0`00000;0?ooo`030000003oool0
oooo00D0oooo00<000000?ooo`0000001@0000000`3oool000000000002L0?ooo`030000003oool0
oooo02T0oooo00<000000?ooo`3oool01`3oool004d0oooo0P0000320?ooo`8000002@3oool00`00
0000oooo0?ooo`0@0?ooo`030000003oool0oooo0980oooo1000000B0?ooo`@000003P3oool00`00
0000oooo0?ooo`040?ooo`040000003oool0oooo000000D0oooo00<000000?ooo`3oool0W@3oool0
0`000000oooo0?ooo`0X0?ooo`030000003oool0oooo00L0oooo001?0?ooo`030000003oool0oooo
0<40oooo00<000000?ooo`3oool01`3oool200000100oooo00<000000?ooo`3oool0UP3oool40000
00/0oooo0`00000B0?ooo`030000003oool0oooo00<0oooo00@000000?ooo`3oool00000103oool2
00000:00oooo00<000000?ooo`3oool0:03oool00`000000oooo0?ooo`070?ooo`00D03oool20000
0<80oooo00<000000?ooo`3oool0203oool00`000000oooo0?ooo`0=0?ooo`030000003oool0oooo
09X0oooo100000030?ooo`@000005@3oool00`000000oooo0?ooo`030?ooo`030000003oool00000
00@0oooo00<000000?ooo`3oool0X@3oool00`000000oooo0?ooo`0W0?ooo`030000003oool0oooo
00L0oooo001B0?ooo`030000003oool0oooo0<00oooo0P0000090?ooo`030000003oool0oooo00`0
oooo00<000000?ooo`3oool0WP3oool4000001H0oooo1P000000103oool000000?ooo`0000030?oo
o`800000Y@3oool00`000000oooo0?ooo`0V0?ooo`030000003oool0oooo00L0oooo001C0?ooo`03
0000003oool0oooo0<40oooo00<000000?ooo`3oool01`3oool00`000000oooo0?ooo`0;0?ooo`03
0000003oool0oooo09X0oooo100000040?ooo`@000004@3oool:000000<0oooo00<000000?ooo`3o
ool0YP3oool00`000000oooo0?ooo`0U0?ooo`030000003oool0oooo00L0oooo001D0?ooo`800000
`P3oool2000000P0oooo0P00000;0?ooo`030000003oool0oooo09H0oooo1000000<0?ooo`@00000
303oool:00000080oooo0P00002Z0?ooo`030000003oool0oooo02@0oooo00<000000?ooo`3oool0
1`3oool005H0oooo00<000000?ooo`3oool0`@3oool00`000000oooo0?ooo`070?ooo`030000003o
ool0oooo00P0oooo00<000000?ooo`3oool0T`3oool3000001@0oooo100000070?ooo`d00000[@3o
ool00`000000oooo0?ooo`0S0?ooo`030000003oool0oooo00L0oooo001G0?ooo`800000`P3oool2
000000P0oooo00<000000?ooo`3oool01`3oool00`000000oooo0?ooo`2?0?ooo`@000006`3oool4
00000080oooo3@00002^0?ooo`030000003oool0oooo02@0oooo00<000000?ooo`3oool01P3oool0
05T0oooo00<000000?ooo`3oool0`@3oool00`000000oooo0?ooo`060?ooo`030000003oool0oooo
00H0oooo00<000000?ooo`3oool0S03oool3000002<0oooo4000002^0?ooo`030000003oool0oooo
02<0oooo00<000000?ooo`3oool01P3oool005X0oooo00<000000?ooo`3oool0`@3oool2000000L0
oooo00<000000?ooo`3oool01@3oool00`000000oooo0?ooo`280?ooo`@00000:03oool>00000:l0
oooo00<000000?ooo`3oool08P3oool00`000000oooo0?ooo`060?ooo`00F`3oool200000<<0oooo
00<000000?ooo`3oool01@3oool2000000D0oooo00<000000?ooo`3oool0Q@3oool3000002`0oooo
3P00002`0?ooo`030000003oool0oooo0240oooo00<000000?ooo`3oool01P3oool005d0oooo00<0
00000?ooo`3oool0`@3oool2000000L0oooo00<000000?ooo`3oool00P3oool00`000000oooo0?oo
o`210?ooo`@00000;`3oool>00000;40oooo00<000000?ooo`3oool0803oool00`000000oooo0?oo
o`060?ooo`00GP3oool00`000000oooo0?ooo`320?ooo`030000003oool0oooo00D0oooo00D00000
0?ooo`3oool0oooo0000001o0?ooo`@00000;@3ooolC00000;80oooo00<000000?ooo`3oool0803o
ool00`000000oooo0?ooo`060?ooo`00G`3oool200000<<0oooo0P0000060?ooo`040000003oool0
oooo000007`0oooo0`00000/0?ooo`D000001`3oool<00000;<0oooo00<000000?ooo`3oool07`3o
ool00`000000oooo0?ooo`060?ooo`00H@3oool00`000000oooo0?ooo`320?ooo`030000003oool0
oooo00@0oooo00<000000?ooo`000000N03oool4000002X0oooo1@00000=0?ooo`X00000]@3oool0
0`000000oooo0?ooo`0O0?ooo`030000003oool0oooo00D0oooo001R0?ooo`800000``3oool20000
00D0oooo0P00001e0?ooo`<00000:03oool6000001<0oooo2000002g0?ooo`030000003oool0oooo
01h0oooo00<000000?ooo`3oool01@3oool006@0oooo00<000000?ooo`3oool0`P3oool00`000000
oooo0?ooo`030?ooo`800000L03oool4000002H0oooo1@00000J0?ooo`H00000^@3oool00`000000
oooo0?ooo`0M0?ooo`030000003oool0oooo00D0oooo001U0?ooo`030000003oool0oooo0<80oooo
0P0000030?ooo`030000003oool0000006`0oooo0`00000U0?ooo`D00000g`3oool00`000000oooo
0?ooo`0L0?ooo`030000003oool0oooo00D0oooo001V0?ooo`800000a03oool010000000oooo0?oo
o`0000020?ooo`030000003oool0oooo06D0oooo1000000R0?ooo`H00000i03oool00`000000oooo
0?ooo`0L0?ooo`030000003oool0oooo00D0oooo001X0?ooo`030000003oool0oooo0<80oooo0`00
00030?ooo`800000HP3oool300000240oooo1@00003[0?ooo`030000003oool0oooo01/0oooo00<0
00000?ooo`3oool01@3oool006T0oooo0P0000340?ooo`030000003oool0oooo00<0oooo00<00000
0?ooo`3oool0F`3oool4000001l0oooo1@00003a0?ooo`030000003oool0oooo01X0oooo00<00000
0?ooo`3oool01@3oool006/0oooo00<000000?ooo`3oool0`@3oool3000000@0oooo00<000000?oo
o`3oool0EP3oool4000001d0oooo1P00003g0?ooo`030000003oool0oooo01T0oooo00<000000?oo
o`3oool01@3oool006`0oooo00<000000?ooo`3oool0`03oool010000000oooo0?ooo`0000040?oo
o`030000003oool0oooo0580oooo0`00000L0?ooo`D00000oP3oool00`000000oooo0?ooo`0I0?oo
o`030000003oool0oooo00@0oooo001]0?ooo`800000_`3oool00`000000oooo0?ooo`020?ooo`80
00000`3oool00`000000oooo0?ooo`1=0?ooo`@000006P3oool500000?l0oooo1@3oool00`000000
oooo0?ooo`0H0?ooo`030000003oool0oooo00@0oooo001_0?ooo`030000003oool0oooo0;`0oooo
00<000000?ooo`3oool0103oool010000000oooo0?ooo`3oool2000004X0oooo0`00000H0?ooo`H0
0000o`3oool:0?ooo`030000003oool0oooo01P0oooo00<000000?ooo`3oool0103oool00700oooo
00<000000?ooo`3oool0^`3oool00`000000oooo0?ooo`050?ooo`8000000`3oool00`000000oooo
0?ooo`130?ooo`@000005P3oool500000?l0oooo4@3oool00`000000oooo0?ooo`0G0?ooo`030000
003oool0oooo00@0oooo001a0?ooo`800000^`3oool00`000000oooo0?ooo`070?ooo`050000003o
ool0oooo0?ooo`000000@@3oool3000001D0oooo1@00003o0?oooaL0oooo00<000000?ooo`3oool0
5P3oool00`000000oooo0?ooo`040?ooo`00L`3oool00`000000oooo0?ooo`2h0?ooo`030000003o
ool0oooo00P0oooo0P0000020?ooo`030000003oool0oooo03X0oooo1000000B0?ooo`H00000o`3o
oolM0?ooo`030000003oool0oooo01D0oooo00<000000?ooo`3oool0103oool007@0oooo0P00002h
0?ooo`030000003oool0oooo00X0oooo00<000000?ooo`3oool00P00000f0?ooo`@000004@3oool5
00000?l0oooo903oool00`000000oooo0?ooo`0D0?ooo`030000003oool0oooo00@0oooo001f0?oo
o`030000003oool0oooo0;D0oooo00<000000?ooo`3oool02`3oool200000080oooo00<000000?oo
o`3oool0<03oool300000100oooo1@00003o0?ooobX0oooo00<000000?ooo`3oool0503oool00`00
0000oooo0?ooo`030?ooo`00M`3oool00`000000oooo0?ooo`2d0?ooo`030000003oool0oooo00d0
oooo00@000000?ooo`3oool00000;@3oool4000000d0oooo1P00003o0?ooobl0oooo00<000000?oo
o`3oool0503oool00`000000oooo0?ooo`030?ooo`00N03oool200000;@0oooo00<000000?ooo`3o
ool03P3oool2000000030?ooo`000000oooo02P0oooo0`00000<0?ooo`D00000o`3ooolf0?ooo`03
0000003oool0oooo01<0oooo00<000000?ooo`3oool00`3oool007X0oooo00<000000?ooo`3oool0
/@3oool00`000000oooo0?ooo`0@0?ooo`030000003oool0000002@0oooo1000000:0?ooo`D00000
o`3oooll0?ooo`030000003oool0oooo0180oooo00<000000?ooo`3oool00`3oool007/0oooo0P00
002a0?ooo`030000003oool0oooo0140oooo100000040?ooo`H000005@3oool3000000P0oooo1P00
003o0?oood80oooo00<000000?ooo`3oool04@3oool00`000000oooo0?ooo`030?ooo`00O@3oool0
0`000000oooo0?ooo`2^0?ooo`030000003oool0oooo01<0oooo00<000000?ooo`0000000P3oool8
00000100oooo100000060?ooo`D00000o`3ooom90?ooo`030000003oool0oooo0100oooo00<00000
0?ooo`3oool00`3oool007h0oooo00<000000?ooo`3oool0[@3oool00`000000oooo0?ooo`0D0?oo
o`d00000303oool3000000D0oooo1@00003o0?ooodl0oooo00<000000?ooo`3oool03`3oool00`00
0000oooo0?ooo`030?ooo`00O`3oool200000:d0oooo00<000000?ooo`3oool05P3oool<000000L0
oooo100000020?ooo`H00000o`3ooomD0?ooo`030000003oool0oooo0100oooo00<000000?ooo`3o
ool00P3oool00840oooo00<000000?ooo`3oool0ZP3oool00`000000oooo0?ooo`0E0?ooo`d00000
0`3oool4000000030?ooo`000000000000<00000o`3ooomK0?ooo`030000003oool0oooo00l0oooo
00<000000?ooo`3oool00P3oool00880oooo00<000000?ooo`3oool0Z@3oool00`000000oooo0?oo
o`0E0?oooaD00000o`3ooomQ0?ooo`030000003oool0oooo00h0oooo00<000000?ooo`3oool00P3o
ool008<0oooo0P00002Y0?ooo`030000003oool0oooo01D0oooo4000003o0?ooofL0oooo00<00000
0?ooo`3oool03@3oool00`000000oooo0?ooo`020?ooo`00Q@3oool00`000000oooo0?ooo`2V0?oo
o`030000003oool0oooo01D0oooo3P00003o0?ooofX0oooo00<000000?ooo`3oool0303oool00`00
0000oooo0?ooo`020?ooo`00QP3oool200000:H0oooo00<000000?ooo`3oool05@3oool>00000?l0
ooooJ`3oool00`000000oooo0?ooo`0;0?ooo`030000003oool0oooo0080oooo00280?ooo`030000
003oool0oooo0:<0oooo00<000000?ooo`3oool05@3oool=00000?l0ooooK03oool00`000000oooo
0?ooo`0;0?ooo`030000003oool0oooo0080oooo00290?ooo`030000003oool0oooo0:80oooo00<0
00000?ooo`3oool05P3oool<00000?l0ooooK@3oool00`000000oooo0?ooo`0:0?ooo`030000003o
ool0oooo0080oooo002:0?ooo`800000XP3oool00`000000oooo0?ooo`0G0?ooo`X00000o`3ooom_
0?ooo`030000003oool0oooo00X0oooo00<000000?ooo`3oool00@3oool008`0oooo00<000000?oo
o`3oool0W`3oool00`000000oooo0?ooo`0H0?ooo`P00000o`3oooma0?ooo`030000003oool0oooo
00T0oooo00<000000?ooo`3oool00@3oool008d0oooo0P00002O0?ooo`030000003oool0oooo01T0
oooo1P00003o0?ooog<0oooo00<000000?ooo`3oool0203oool00`000000oooo0?ooo`010?ooo`00
S`3oool00`000000oooo0?ooo`2L0?ooo`030000003oool0oooo0?l0ooooT`3oool00`000000oooo
0?ooo`070?ooo`030000003oool0oooo0040oooo002@0?ooo`030000003oool0oooo09/0oooo00<0
00000?ooo`3oool0o`3ooonC0?ooo`030000003oool0oooo00L0oooo00<000000?ooo`3oool00@3o
ool00940oooo0P00002K0?ooo`030000003oool0oooo0?l0ooooU03oool00`000000oooo0?ooo`06
0?ooo`030000003oool0oooo0040oooo002C0?ooo`030000003oool0oooo09P0oooo00<000000?oo
o`3oool0o`3ooonE0?ooo`030000003oool0oooo00D0oooo00<000000?ooo`3oool00@3oool009@0
oooo00<000000?ooo`3oool0U`3oool00`000000oooo0?ooo`3o0?oooiH0oooo00<000000?ooo`3o
ool01@3oool100000040oooo0@3oool009D0oooo0P00002G0?ooo`030000003oool0oooo0?l0oooo
U`3oool00`000000oooo0?ooo`040?ooo`4000000@3oool10?ooo`00U`3oool00`000000oooo0?oo
o`2C0?ooo`030000003oool0oooo0?l0ooooV@3oool00`000000oooo0?ooo`030?ooo`4000000@3o
ool10?ooo`00V03oool2000009<0oooo00<000000?ooo`3oool0o`3ooonI0?ooo`030000003oool0
oooo00<0oooo0@0000010?ooo`40oooo002J0?ooo`030000003oool0oooo0900oooo00<000000?oo
o`3oool0o`3ooonJ0?ooo`030000003oool0oooo0080oooo0@0000010?ooo`40oooo002K0?ooo`03
0000003oool0oooo08l0oooo00<000000?ooo`3oool0o`3ooonK0?ooo`050000003oool0oooo0?oo
o`0000000P3oool009`0oooo0P00002?0?ooo`030000003oool0oooo0?l0ooooW03oool010000000
oooo0?ooo`0000020?ooo`00WP3oool00`000000oooo0?ooo`2<0?ooo`030000003oool0oooo0?l0
ooooW@3oool00`000000oooo000000020?ooo`00W`3oool2000008`0oooo00<000000?ooo`3oool0
o`3ooonN0?ooo`030000003oool000000040oooo002Q0?ooo`030000003oool0oooo08T0oooo00<0
00000?ooo`3oool0o`3ooonN0?ooo`030000003oool000000040oooo002R0?ooo`030000003oool0
oooo08P0oooo00<000000?ooo`3oool0o`3ooonO0?ooo`8000000@3oool00:<0oooo0P0000280?oo
o`030000003oool0oooo0?l0ooooWP3oool300000040oooo002U0?ooo`030000003oool0oooo08D0
oooo00<000000?ooo`3oool0o`3ooonJ0?ooo`@00000103oool00:H0oooo0P0000250?ooo`030000
003oool0oooo0?l0ooooUP3oool4000000P0oooo002X0?ooo`030000003oool0oooo0880oooo00<0
00000?ooo`3oool0o`3ooonA0?ooo`D00000303oool00:T0oooo00<000000?ooo`3oool0P@3oool0
0`000000oooo0?ooo`3o0?ooohd0oooo1000000A0?ooo`00ZP3oool200000840oooo00<000000?oo
o`3oool0o`3ooon90?ooo`@000005@3oool00:`0oooo00<000000?ooo`3oool0OP3oool00`000000
oooo0?ooo`3o0?oooh@0oooo1@00000I0?ooo`00[@3oool00`000000oooo0?ooo`1m0?ooo`030000
003oool0oooo0?l0ooooP03oool4000001h0oooo002^0?ooo`800000O@3oool00`000000oooo0?oo
o`3o0?ooog`0oooo1000000R0?ooo`00/03oool00`000000oooo0?ooo`1j0?ooo`030000003oool0
oooo0?l0ooooM`3oool5000002H0oooo002a0?ooo`800000NP3oool00`000000oooo0?ooo`3o0?oo
og<0oooo1000000[0?ooo`00/`3oool00`000000oooo0?ooo`1g0?ooo`030000003oool0oooo0?l0
ooooK`3oool4000002l0oooo002d0?ooo`030000003oool0oooo07H0oooo00<000000?ooo`3oool0
o`3ooomZ0?ooo`D00000<`3oool00;D0oooo0P00001f0?ooo`030000003oool0oooo0?l0ooooIP3o
ool4000003P0oooo002g0?ooo`030000003oool0oooo07<0oooo00<000000?ooo`3oool0o`3ooomR
0?ooo`@00000?03oool00;P0oooo0P00001c0?ooo`030000003oool0oooo0?l0ooooG@3oool50000
0400oooo002j0?ooo`030000003oool0oooo0700oooo00<000000?ooo`3oool0o`3ooomI0?ooo`@0
0000A@3oool00;/0oooo00<000000?ooo`3oool0K`3oool00`000000oooo0?ooo`3o0?oooeD0oooo
100000190?ooo`00_03oool2000006l0oooo00<000000?ooo`3oool0o`3ooom@0?ooo`D00000C@3o
ool00;h0oooo00<000000?ooo`3oool0K03oool00`000000oooo0?ooo`3o0?oood`0oooo1000001B
0?ooo`00_`3oool00`000000oooo0?ooo`1[0?ooo`030000003oool0oooo0?l0ooooB03oool40000
05H0oooo00300?ooo`800000J`3oool00`000000oooo0?ooo`3o0?oood<0oooo1@00001J0?ooo`00
`P3oool00`000000oooo0?ooo`1W0?ooo`030000003oool0oooo0?l0oooo@03oool4000005l0oooo
00330?ooo`800000I`3oool00`000000oooo0?ooo`3o0?oooc`0oooo1000001S0?ooo`00a@3oool0
0`000000oooo0?ooo`1T0?ooo`030000003oool0oooo0?l0oooo=`3oool5000006L0oooo00360?oo
o`030000003oool0oooo06<0oooo00<000000?ooo`3oool0o`3ooolc0?ooo`@00000K03oool00<L0
oooo0P00001S0?ooo`030000003oool0oooo0?l0oooo;P3oool500000700oooo00390?ooo`030000
003oool0oooo0600oooo00<000000?ooo`3oool0o`3ooolZ0?ooo`@00000M@3oool00<X0oooo0P00
001P0?ooo`030000003oool0oooo0?l0oooo9P3oool4000007T0oooo003<0?ooo`030000003oool0
oooo05d0oooo00<000000?ooo`3oool0o`3ooolQ0?ooo`D00000O@3oool00<d0oooo00<000000?oo
o`3oool0G03oool00`000000oooo0?ooo`3o0?oooad0oooo100000220?ooo`00cP3oool2000005`0
oooo00<000000?ooo`3oool0o`3ooolI0?ooo`@00000QP3oool00=00oooo00<000000?ooo`3oool0
F@3oool00`000000oooo0?ooo`3o0?oooa@0oooo1@00002:0?ooo`00d@3oool00`000000oooo0?oo
o`1H0?ooo`030000003oool0oooo0?l0oooo403oool4000008l0oooo003B0?ooo`800000F03oool0
0`000000oooo0?ooo`3o0?ooo``0oooo1000002C0?ooo`00e03oool00`000000oooo0?ooo`1E0?oo
o`030000003oool0oooo0?l0oooo1`3oool5000009L0oooo003E0?ooo`800000E@3oool00`000000
oooo0?ooo`3o0?ooo`<0oooo1000002L0?ooo`00e`3oool00`000000oooo0?ooo`1B0?ooo`030000
003oool0oooo0?h0oooo1000002P0?ooo`00f03oool00`000000oooo0?ooo`1A0?ooo`030000003o
ool0oooo0?T0oooo1@00002T0?ooo`00f@3oool200000540oooo00<000000?ooo`3oool0m@3oool4
00000:T0oooo003K0?ooo`030000003oool0oooo04h0oooo00<000000?ooo`3oool0l@3oool40000
0:d0oooo003L0?ooo`800000CP3oool00`000000oooo0?ooo`3/0?ooo`D00000/@3oool00=h0oooo
00<000000?ooo`3oool0B`3oool00`000000oooo0?ooo`3X0?ooo`@00000]P3oool00=l0oooo00<0
00000?ooo`3oool0BP3oool00`000000oooo0?ooo`3T0?ooo`@00000^P3oool00>00oooo0P00001:
0?ooo`030000003oool0oooo0=l0oooo1@00002n0?ooo`00hP3oool00`000000oooo0?ooo`170?oo
o`030000003oool0oooo0=/0oooo100000330?ooo`00h`3oool2000004L0oooo00<000000?ooo`3o
ool0e`3oool400000<L0oooo003U0?ooo`030000003oool0oooo04@0oooo00<000000?ooo`3oool0
dP3oool500000</0oooo003V0?ooo`030000003oool0oooo04<0oooo00<000000?ooo`3oool0cP3o
ool400000=00oooo003W0?ooo`800000@`3oool00`000000oooo0?ooo`3:0?ooo`@00000e03oool0
0>T0oooo00<000000?ooo`3oool0@03oool00`000000oooo0?ooo`350?ooo`D00000f03oool00>X0
oooo00<000000?ooo`3oool0?`3oool00`000000oooo0?ooo`310?ooo`@00000g@3oool00>/0oooo
0P00000n0?ooo`030000003oool0oooo0;h0oooo1000003Q0?ooo`00k@3oool00`000000oooo0?oo
o`0k0?ooo`030000003oool0oooo0;T0oooo1@00003U0?ooo`00kP3oool2000003/0oooo00<00000
0?ooo`3oool0]@3oool400000>X0oooo003`0?ooo`030000003oool0oooo03P0oooo00<000000?oo
o`3oool0/@3oool400000>h0oooo003a0?ooo`030000003oool0oooo03L0oooo00<000000?ooo`3o
ool0[03oool500000?80oooo003b0?ooo`800000=`3oool00`000000oooo0?ooo`2X0?ooo`@00000
m`3oool00?@0oooo00<000000?ooo`3oool0=03oool00`000000oooo0?ooo`2T0?ooo`@00000n`3o
ool00?D0oooo0P00000d0?ooo`030000003oool0oooo09l0oooo1@00003o0?ooo`00m`3oool00`00
0000oooo0?ooo`0a0?ooo`030000003oool0oooo09/0oooo1000003o0?ooo`D0oooo003h0?ooo`03
0000003oool0oooo0300oooo00<000000?ooo`3oool0U`3oool400000?l0oooo2@3oool00?T0oooo
0P00000`0?ooo`030000003oool0oooo0980oooo1@00003o0?ooo`d0oooo003k0?ooo`030000003o
ool0oooo02d0oooo00<000000?ooo`3oool0SP3oool400000?l0oooo4P3oool00?`0oooo00<00000
0?ooo`3oool0;03oool00`000000oooo0?ooo`2:0?ooo`@00000o`3ooolF0?ooo`00o@3oool20000
02`0oooo00<000000?ooo`3oool0Q@3oool500000?l0oooo6P3oool00?l0oooo00<000000?ooo`3o
ool0:@3oool00`000000oooo0?ooo`210?ooo`@00000o`3ooolO0?ooo`00o`3oool10?ooo`800000
:@3oool00`000000oooo0?ooo`1m0?ooo`@00000o`3ooolS0?ooo`00o`3oool30?ooo`030000003o
ool0oooo02H0oooo00<000000?ooo`3oool0N03oool500000?l0oooo9`3oool00?l0oooo103oool0
0`000000oooo0?ooo`0U0?ooo`030000003oool0oooo07@0oooo1000003o0?ooob`0oooo003o0?oo
o`D0oooo0P00000U0?ooo`030000003oool0oooo0700oooo1000003o0?oooc00oooo003o0?ooo`L0
oooo00<000000?ooo`3oool08P3oool00`000000oooo0?ooo`1[0?ooo`D00000o`3ooold0?ooo`00
o`3oool80?ooo`8000008P3oool00`000000oooo0?ooo`1W0?ooo`@00000o`3oooli0?ooo`00o`3o
ool:0?ooo`030000003oool0oooo01l0oooo00<000000?ooo`3oool0HP3oool500000?l0oooo?@3o
ool00?l0oooo2`3oool00`000000oooo0?ooo`0N0?ooo`030000003oool0oooo05h0oooo1000003o
0?oood80oooo003o0?ooo``0oooo0P00000N0?ooo`030000003oool0oooo05X0oooo1000003o0?oo
odH0oooo003o0?ooo`h0oooo00<000000?ooo`3oool06`3oool00`000000oooo0?ooo`1E0?ooo`D0
0000o`3ooom:0?ooo`00o`3oool?0?ooo`030000003oool0oooo01X0oooo00<000000?ooo`3oool0
D@3oool400000?l0ooooC`3oool00?l0oooo403oool2000001X0oooo00<000000?ooo`3oool0C@3o
ool400000?l0ooooD`3oool00?l0oooo4P3oool00`000000oooo0?ooo`0G0?ooo`030000003oool0
oooo04P0oooo1@00003o0?oooeL0oooo003o0?oooa<0oooo0P00000G0?ooo`030000003oool0oooo
04@0oooo1000003o0?oooe`0oooo003o0?oooaD0oooo00<000000?ooo`3oool0503oool00`000000
oooo0?ooo`100?ooo`@00000o`3ooomP0?ooo`00o`3ooolF0?ooo`030000003oool0oooo0180oooo
00<000000?ooo`3oool0?03oool500000?l0ooooI03oool00?l0oooo5`3oool200000180oooo00<0
00000?ooo`3oool0>03oool400000?l0ooooJ@3oool00?l0oooo6@3oool00`000000oooo0?ooo`0?
0?ooo`030000003oool0oooo03@0oooo1000003o0?ooofd0oooo003o0?oooaX0oooo0P00000?0?oo
o`030000003oool0oooo02l0oooo1@00003o0?ooog40oooo003o0?oooa`0oooo00<000000?ooo`3o
ool0303oool00`000000oooo0?ooo`0[0?ooo`@00000o`3ooomf0?ooo`00o`3ooolM0?ooo`030000
003oool0oooo00/0oooo00<000000?ooo`3oool09`3oool400000?l0ooooNP3oool00?l0oooo7P3o
ool2000000/0oooo00<000000?ooo`3oool08P3oool500000?l0ooooOP3oool00?l0oooo803oool0
0`000000oooo0?ooo`080?ooo`030000003oool0oooo01h0oooo1000003o0?oooh<0oooo003o0?oo
ob40oooo00<000000?ooo`3oool01`3oool00`000000oooo0?ooo`0J0?ooo`@00000o`3ooon70?oo
o`00o`3ooolR0?ooo`8000001`3oool00`000000oooo0?ooo`0E0?ooo`D00000o`3ooon;0?ooo`00
o`3ooolT0?ooo`030000003oool0oooo00@0oooo00<000000?ooo`3oool04@3oool400000?l0oooo
T03oool00?l0oooo9@3oool2000000@0oooo00<000000?ooo`3oool03@3oool400000?l0ooooU03o
ool00?l0oooo9`3oool01@000000oooo0?ooo`3oool0000000X0oooo1@00003o0?oooiP0oooo003o
0?ooobP0oooo00@000000?ooo`3oool000001P3oool400000?l0ooooW@3oool00?l0oooo:@3oool3
00000080oooo1000003o0?oooj40oooo003o0?ooob/0oooo0`00003o0?ooojD0oooo0000\
\>"],
  ImageRangeCache->{{{0, 720}, {720, 0}} -> {0.031055, -4.60181*^-06, \
0.0012338, 0.00127828}}],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: 1.03605 
MathPictureStart
/Mabs {
Mgmatrix idtransform
Mtmatrix dtransform
} bind def
/Mabsadd { Mabs
3 -1 roll add
3 1 roll add
exch } bind def
%% Graphics3D
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
-0.0349639 1.12571 3.33067e-016 1.12571 [
[ 0 0 0 0 ]
[ 1 1.03605 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
.25 Mabswid
[ ] 0 setdash
.0738 .24252 m
0 .72615 L
s
0 .72615 m
.41471 1.03605 L
s
.41471 1.03605 m
.42784 .59896 L
s
.42784 .59896 m
.0738 .24252 L
s
.66251 0 m
.94009 .43535 L
s
.94009 .43535 m
1 .8959 L
s
1 .8959 m
.6874 .50529 L
s
.6874 .50529 m
.66251 0 L
s
.0738 .24252 m
0 .72615 L
s
0 .72615 m
.6874 .50529 L
s
.6874 .50529 m
.66251 0 L
s
.66251 0 m
.0738 .24252 L
s
.42784 .59896 m
.94009 .43535 L
s
.94009 .43535 m
1 .8959 L
s
1 .8959 m
.41471 1.03605 L
s
.41471 1.03605 m
.42784 .59896 L
s
0 0 m
1 0 L
1 1.03605 L
0 1.03605 L
closepath
clip
newpath
.5 Mabswid
.29071 .71794 m .36353 .49638 L .6239 .48388 L p .76 .561 .628 r
F P
0 g
s
.6239 .48388 m .66831 .69199 L .29071 .71794 L p .76 .561 .628 r
F P
0 g
s
.88665 .57982 m .66831 .69199 L .6239 .48388 L p .437 .319 .621 r
F P
0 g
s
.6239 .48388 m .78993 .34824 L .88665 .57982 L p .437 .319 .621 r
F P
0 g
s
.64977 .17664 m .78993 .34824 L .6239 .48388 L p .712 .741 .874 r
F P
0 g
s
.34677 .21203 m .64977 .17664 L p .6239 .48388 L .712 .741 .874 r
F P
0 g
s
.25961 .35626 m .34677 .21203 L p .6239 .48388 L .712 .741 .874 r
F P
0 g
s
.6239 .48388 m .36353 .49638 L .25961 .35626 L p .712 .741 .874 r
F P
0 g
s
.1831 .48959 m .25961 .35626 L .36353 .49638 L p .927 .728 .615 r
F P
0 g
s
.36353 .49638 m .29071 .71794 L .1831 .48959 L p .927 .728 .615 r
F P
0 g
s
.68506 .82044 m .29071 .71794 L .66831 .69199 L closepath p .698 .358 .397 r
F P
0 g
s
.88665 .57982 m .68506 .82044 L .66831 .69199 L closepath p .285 .076 .41 r
F P
0 g
s
.88665 .57982 m .78993 .34824 L .64977 .17664 L p .659 .247 0 r
F P
0 g
s
.29071 .71794 m .68506 .82044 L .46265 .86351 L closepath p .703 .409 .474 r
F P
0 g
s
.29071 .71794 m .18169 .56757 L .1831 .48959 L closepath p .975 .707 .458 r
F P
0 g
s
.29071 .71794 m .30787 .75646 L .19908 .6285 L closepath p .624 .13 0 r
F P
0 g
s
.29071 .71794 m .19908 .6285 L .18169 .56757 L closepath p .938 .573 .185 r
F P
0 g
s
.46265 .86351 m .30787 .75646 L .29071 .71794 L closepath p .58 .03 0 r
F P
0 g
s
.2636 .44263 m .34677 .21203 L .25961 .35626 L p 0 0 0 r
F P
0 g
s
.25961 .35626 m .1831 .48959 L .2636 .44263 L p 0 0 0 r
F P
0 g
s
.46265 .86351 m .68506 .82044 L .70102 .79503 L closepath p .335 .817 .853 r
F P
0 g
s
.88665 .57982 m .82307 .72776 L .68506 .82044 L closepath p .414 .239 .533 r
F P
0 g
s
.70102 .79503 m .68506 .82044 L .82307 .72776 L closepath p .487 .88 .709 r
F P
0 g
s
.1831 .48959 m .18169 .56757 L .2636 .44263 L closepath p 0 0 .354 r
F P
0 g
s
.70102 .79503 m .30787 .75646 L .46265 .86351 L closepath p .568 .754 .965 r
F P
0 g
s
.88665 .57982 m .84582 .6821 L .82307 .72776 L closepath p 0 0 0 r
F P
0 g
s
.84312 .6406 m .84582 .6821 L .88665 .57982 L closepath p .952 .902 .52 r
F P
0 g
s
.88665 .57982 m .72704 .5532 L .84312 .6406 L closepath p .952 .649 .425 r
F P
0 g
s
.88665 .57982 m .71944 .30485 L .72704 .5532 L closepath p .968 .739 .539 r
F P
0 g
s
.64977 .17664 m .71944 .30485 L .88665 .57982 L p .659 .247 0 r
F P
0 g
s
.70102 .79503 m .82307 .72776 L .84582 .6821 L closepath p .841 .995 .842 r
F P
0 g
s
.2636 .44263 m .18169 .56757 L .19908 .6285 L closepath p .118 .104 .564 r
F P
0 g
s
.71944 .30485 m .64977 .17664 L .34677 .21203 L p .613 .339 .477 r
F P
0 g
s
.34677 .21203 m .2636 .44263 L .71944 .30485 L p .613 .339 .477 r
F P
0 g
s
.2636 .44263 m .19908 .6285 L .30787 .75646 L closepath p .381 .388 .742 r
F P
0 g
s
.70102 .79503 m .84582 .6821 L .84312 .6406 L closepath p .885 .947 .845 r
F P
0 g
s
.2636 .44263 m .30787 .75646 L .46343 .6476 L closepath p .487 .468 .762 r
F P
0 g
s
.70102 .79503 m .46343 .6476 L .30787 .75646 L closepath p .609 .733 .933 r
F P
0 g
s
.84312 .6406 m .72704 .5532 L .70102 .79503 L closepath p .847 .811 .815 r
F P
0 g
s
.70102 .79503 m .72704 .5532 L .46343 .6476 L closepath p .757 .732 .829 r
F P
0 g
s
.72704 .5532 m .2636 .44263 L .46343 .6476 L closepath p .687 .489 .613 r
F P
0 g
s
.2636 .44263 m .72704 .5532 L .71944 .30485 L closepath p .683 .509 .644 r
F P
0 g
s
.25 Mabswid
.66251 0 m
.94009 .43535 L
s
.94009 .43535 m
1 .8959 L
s
1 .8959 m
.6874 .50529 L
s
.6874 .50529 m
.66251 0 L
s
.0738 .24252 m
0 .72615 L
s
0 .72615 m
.6874 .50529 L
s
.6874 .50529 m
.66251 0 L
s
.66251 0 m
.0738 .24252 L
s
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  ImageSize->{721, 746.938},
  ImageMargins->{{41, 0}, {0, 52}},
  ImageRegion->{{0, 1}, {0, 1}},
  ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`4000;A0002jR000`400?l00000o`00003oo`3ooooM
0?ooo`800000l`3oool00?l0oooof`3oool2000000030?ooo`00000000000?80oooo003o0?ooomP0
oooo0`0000030?ooo`800000lP3oool00?l0ooooeP3oool2000000H0oooo00<000000?ooo`000000
l@3oool00?l0ooooe03oool2000000P0oooo00@000000?ooo`3oool00000l03oool00?l0ooood@3o
ool3000000X0oooo00@000000?ooo`3oool00000l03oool00?l0ooooc`3oool2000000d0oooo00D0
00000?ooo`3oool0oooo0000003_0?ooo`00o`3oooo<0?ooo`<000003`3oool01@000000oooo0?oo
o`3oool000000>l0oooo003o0?ooolX0oooo0P00000B0?ooo`030000003oool0oooo0080oooo00<0
00000?ooo`3oool0k03oool00?l0ooooa`3oool3000001@0oooo00<000000?ooo`3oool00`3oool0
0`000000oooo0?ooo`3[0?ooo`00o`3oooo50?ooo`8000005`3oool00`000000oooo0?ooo`030?oo
o`030000003oool0oooo0>/0oooo003o0?oool80oooo0`00000J0?ooo`030000003oool0oooo00<0
oooo00<000000?ooo`3oool0jP3oool00?l0oooo`03oool2000001d0oooo00<000000?ooo`3oool0
103oool00`000000oooo0?ooo`3Y0?ooo`00o`3ooonn0?ooo`8000007`3oool00`000000oooo0?oo
o`040?ooo`030000003oool0oooo0>T0oooo003o0?oook/0oooo0`00000Q0?ooo`030000003oool0
oooo00D0oooo00<000000?ooo`3oool0j03oool00?l0oooo^@3oool2000002@0oooo00<000000?oo
o`3oool01P3oool00`000000oooo0?ooo`3W0?ooo`00o`3ooonf0?ooo`<000009P3oool00`000000
oooo0?ooo`060?ooo`030000003oool0oooo0>L0oooo003o0?oook@0oooo0P00000Y0?ooo`030000
003oool0oooo00L0oooo00<000000?ooo`3oool0iP3oool00?l0oooo/@3oool3000002/0oooo00<0
00000?ooo`3oool01`3oool00`000000oooo0?ooo`3V0?ooo`00o`3ooon_0?ooo`800000;P3oool0
0`000000oooo0?ooo`080?ooo`030000003oool0oooo0>D0oooo003o0?ooojd0oooo0P00000`0?oo
o`030000003oool0oooo00T0oooo00<000000?ooo`3oool0i03oool00?l0ooooZP3oool300000380
oooo00<000000?ooo`3oool02@3oool00`000000oooo0?ooo`3T0?ooo`00o`3ooonX0?ooo`800000
=@3oool00`000000oooo0?ooo`0:0?ooo`030000003oool0oooo0><0oooo003o0?ooojD0oooo0`00
000g0?ooo`030000003oool0oooo00/0oooo00<000000?ooo`3oool0hP3oool00?l0ooooX`3oool2
000003X0oooo00<000000?ooo`3oool02`3oool00`000000oooo0?ooo`3R0?ooo`00o`3ooonP0?oo
o`<00000?03oool00`000000oooo0?ooo`0<0?ooo`030000003oool0oooo0>40oooo003o0?oooih0
oooo0P00000o0?ooo`030000003oool0oooo00d0oooo00<000000?ooo`3oool0h03oool00?l0oooo
V`3oool300000440oooo00<000000?ooo`3oool03@3oool00`000000oooo0?ooo`3P0?ooo`00o`3o
oonI0?ooo`800000A03oool00`000000oooo0?ooo`0>0?ooo`030000003oool0oooo0=l0oooo003o
0?oooiL0oooo0P0000160?ooo`030000003oool0oooo00h0oooo00<000000?ooo`3oool0g`3oool0
0?l0ooooU03oool3000004P0oooo00<000000?ooo`3oool03`3oool00`000000oooo0?ooo`3N0?oo
o`00o`3ooonB0?ooo`800000B`3oool00`000000oooo0?ooo`0@0?ooo`030000003oool0oooo0=d0
oooo003o0?ooohl0oooo0`00001=0?ooo`030000003oool0oooo0100oooo00<000000?ooo`3oool0
g@3oool00?l0ooooS@3oool200000540oooo00<000000?ooo`3oool0403oool00`000000oooo0?oo
o`3L0?ooo`00o`3ooon:0?ooo`<00000D`3oool00`000000oooo0?ooo`0A0?ooo`030000003oool0
oooo0=/0oooo003o0?ooohP0oooo0P00001F0?ooo`030000003oool0oooo0140oooo00<000000?oo
o`3oool0f`3oool00?l0ooooQP3oool2000005P0oooo00<000000?ooo`3oool04P3oool00`000000
oooo0?ooo`3J0?ooo`00o`3ooon30?ooo`<00000FP3oool00`000000oooo0?ooo`0C0?ooo`030000
003oool0oooo0=T0oooo003o0?oooh40oooo0P00001M0?ooo`030000003oool0oooo01<0oooo00<0
00000?ooo`3oool0f@3oool00?l0ooooOP3oool3000005l0oooo00<000000?ooo`3oool0503oool0
0`000000oooo0?ooo`3H0?ooo`00o`3oooml0?ooo`800000HP3oool00`000000oooo0?ooo`0D0?oo
o`030000003oool0oooo0=P0oooo003o0?ooogT0oooo0`00001T0?ooo`030000003oool0oooo01D0
oooo00<000000?ooo`3oool0e`3oool00?l0ooooM`3oool2000006L0oooo00<000000?ooo`3oool0
5P3oool00`000000oooo0?ooo`3F0?ooo`00o`3ooome0?ooo`800000J@3oool00`000000oooo0?oo
o`0F0?ooo`030000003oool0oooo0=H0oooo003o0?ooog80oooo0`00001[0?ooo`030000003oool0
oooo01L0oooo00<000000?ooo`3oool0e@3oool00?l0ooooL03oool2000006h0oooo00<000000?oo
o`3oool0603oool00`000000oooo0?ooo`3D0?ooo`00o`3ooom]0?ooo`<00000L03oool00`000000
oooo0?ooo`0H0?ooo`030000003oool0oooo0=@0oooo003o0?ooof/0oooo0P00001c0?ooo`030000
003oool0oooo01T0oooo00<000000?ooo`3oool0d`3oool00?l0ooooJ03oool3000007D0oooo00<0
00000?ooo`3oool06P3oool00`000000oooo0?ooo`3B0?ooo`00o`3ooomV0?ooo`800000N03oool0
0`000000oooo0?ooo`0J0?ooo`030000003oool0oooo0=80oooo003o0?ooof<0oooo0`00001j0?oo
o`030000003oool0oooo01/0oooo00<000000?ooo`3oool0d@3oool00?l0ooooH@3oool2000007d0
oooo00<000000?ooo`3oool06`3oool00`000000oooo0?ooo`3A0?ooo`00o`3ooomO0?ooo`800000
O`3oool00`000000oooo0?ooo`0L0?ooo`030000003oool0oooo0=00oooo003o0?oooe`0oooo0`00
00210?ooo`030000003oool0oooo01d0oooo00<000000?ooo`3oool0c`3oool00?l0ooooFP3oool2
000008D0oooo00<000000?ooo`3oool0703oool00`000000oooo0?ooo`3?0?ooo`00o`3ooomG0?oo
o`<00000Q`3oool00`000000oooo0?ooo`0M0?ooo`030000003oool0oooo0<h0oooo003o0?oooeD0
oooo0P00002:0?ooo`030000003oool0oooo01h0oooo00<000000?ooo`3oool0c@3oool00?l0oooo
DP3oool3000008`0oooo00<000000?ooo`3oool07P3oool00`000000oooo0?ooo`3=0?ooo`00o`3o
oom@0?ooo`800000S`3oool00`000000oooo0?ooo`0O0?ooo`030000003oool0oooo0<`0oooo003o
0?ooodh0oooo0P00002A0?ooo`030000003oool0oooo0200oooo00<000000?ooo`3oool0b`3oool0
0?l0ooooB`3oool3000009<0oooo00<000000?ooo`3oool0803oool00`000000oooo0?ooo`3;0?oo
o`00o`3ooom90?ooo`800000UP3oool00`000000oooo0?ooo`0Q0?ooo`030000003oool0oooo0<X0
oooo003o0?ooodH0oooo0`00002H0?ooo`030000003oool0oooo0240oooo00<000000?ooo`3oool0
bP3oool00?l0ooooA03oool2000009/0oooo00<000000?ooo`3oool08P3oool00`000000oooo0?oo
o`390?ooo`00o`3ooom10?ooo`<00000W@3oool00`000000oooo0?ooo`0S0?ooo`030000003oool0
oooo0<P0oooo003o0?ooocl0oooo0P00002P0?ooo`030000003oool0oooo02<0oooo00<000000?oo
o`3oool0b03oool00?l0oooo?03oool300000:80oooo00<000000?ooo`3oool0903oool00`000000
oooo0?ooo`370?ooo`00o`3ooolj0?ooo`800000Y@3oool00`000000oooo0?ooo`0U0?ooo`030000
003oool0oooo0<H0oooo003o0?ooocP0oooo0P00002W0?ooo`030000003oool0oooo02D0oooo00<0
00000?ooo`3oool0aP3oool00?l0oooo=@3oool300000:T0oooo00<000000?ooo`3oool09P3oool0
0`000000oooo0?ooo`350?ooo`00o`3ooolc0?ooo`800000[03oool00`000000oooo0?ooo`0W0?oo
o`030000003oool0oooo0<@0oooo003o0?oooc00oooo0`00002^0?ooo`030000003oool0oooo02L0
oooo00<000000?ooo`3oool0a03oool00?l0oooo;P3oool200000;40oooo00<000000?ooo`3oool0
:03oool00`000000oooo0?ooo`330?ooo`00o`3oool[0?ooo`<00000/`3oool00`000000oooo0?oo
o`0X0?ooo`030000003oool0oooo0<<0oooo003o0?ooobT0oooo0P00002f0?ooo`030000003oool0
oooo02T0oooo00<000000?ooo`3oool0`P3oool00?l0oooo9`3oool200000;T0oooo00<000000?oo
o`3oool0:@3oool00`000000oooo0?ooo`310?ooo`00o`3ooolT0?ooo`<00000^`3oool00`000000
oooo0?ooo`0Y0?ooo`030000003oool0oooo0<40oooo003o0?ooob80oooo0P00002n0?ooo`030000
003oool0oooo02X0oooo00<000000?ooo`3oool0`03oool00?l0oooo7`3oool300000<00oooo00<0
00000?ooo`3oool0:`3oool00`000000oooo0?ooo`2o0?ooo`00o`3ooolM0?ooo`800000``3oool0
0`000000oooo0?ooo`0[0?ooo`030000003oool0oooo0;l0oooo003o0?oooaX0oooo0`0000350?oo
o`030000003oool0oooo02`0oooo00<000000?ooo`3oool0_P3oool00?l0oooo603oool200000<P0
oooo00<000000?ooo`3oool0;03oool00`000000oooo0?ooo`2n0?ooo`00o`3ooolE0?ooo`<00000
bP3oool00`000000oooo0?ooo`0]0?ooo`030000003oool0oooo0;d0oooo003o0?oooa<0oooo0P00
003=0?ooo`030000003oool0oooo02h0oooo00<000000?ooo`3oool0_03oool00?l0oooo4@3oool2
00000<l0oooo00<000000?ooo`3oool0;P3oool00`000000oooo0?ooo`2l0?ooo`00o`3oool>0?oo
o`<00000d@3oool00`000000oooo0?ooo`0_0?ooo`030000003oool0oooo0;/0oooo003o0?ooo``0
oooo0P00003D0?ooo`030000003oool0oooo0300oooo00<000000?ooo`3oool0^P3oool00?l0oooo
2@3oool300000=H0oooo00<000000?ooo`3oool0<03oool00`000000oooo0?ooo`2j0?ooo`00o`3o
ool70?ooo`800000f@3oool00`000000oooo0?ooo`0a0?ooo`030000003oool0oooo0;T0oooo003o
0?ooo`@0oooo0`00003K0?ooo`030000003oool0oooo0380oooo00<000000?ooo`3oool0^03oool0
0?l0oooo0P3oool200000=h0oooo00<000000?ooo`3oool0<P3oool00`000000oooo0?ooo`2h0?oo
o`00o`3oool200000>00oooo00<000000?ooo`3oool0<`3oool00`000000oooo0?ooo`2g0?ooo`00
o03oool300000>80oooo00<000000?ooo`3oool0<`3oool00`000000oooo0?ooo`2g0?ooo`00nP3o
ool200000>D0oooo00<000000?ooo`3oool0=03oool00`000000oooo0?ooo`2f0?ooo`00m`3oool3
00000>L0oooo00<000000?ooo`3oool0=@3oool00`000000oooo0?ooo`2e0?ooo`00m@3oool20000
0>X0oooo00<000000?ooo`3oool0=@3oool00`000000oooo0?ooo`2e0?ooo`00lP3oool300000>`0
oooo00<000000?ooo`3oool0=P3oool00`000000oooo0?ooo`2d0?ooo`00l03oool200000?00oooo
00<000000?ooo`3oool0=P3oool00`000000oooo0?ooo`2c0?ooo`00k@3oool300000?80oooo00<0
00000?ooo`3oool0=P3oool00`000000oooo0?ooo`2c0?ooo`00j`3oool200000?D0oooo00<00000
0?ooo`3oool0=`3oool00`000000oooo0?ooo`2b0?ooo`00j@3oool200000?L0oooo00<000000?oo
o`3oool0>03oool00`000000oooo0?ooo`2a0?ooo`00iP3oool300000?T0oooo00<000000?ooo`3o
ool0>03oool00`000000oooo0?ooo`2a0?ooo`00i03oool200000?`0oooo00<000000?ooo`3oool0
>@3oool00`000000oooo0?ooo`2`0?ooo`00h@3oool300000?h0oooo00<000000?ooo`3oool0>@3o
ool00`000000oooo0?ooo`2`0?ooo`00g`3oool200000?l0oooo0P3oool00`000000oooo0?ooo`0j
0?ooo`030000003oool0oooo0:l0oooo003L0?ooo`<00000o`3oool40?ooo`030000003oool0oooo
03/0oooo00<000000?ooo`3oool0[P3oool00=X0oooo0P00003o0?ooo`L0oooo00<000000?ooo`3o
ool0>`3oool00`000000oooo0?ooo`2^0?ooo`00f03oool200000?l0oooo2@3oool00`000000oooo
0?ooo`0l0?ooo`030000003oool0oooo0:d0oooo003E0?ooo`<00000o`3oool;0?ooo`030000003o
ool0oooo03d0oooo00<000000?ooo`3oool0[03oool00=<0oooo0P00003o0?ooo`h0oooo00<00000
0?ooo`3oool0?@3oool00`000000oooo0?ooo`2/0?ooo`00d03oool300000?l0oooo403oool00`00
0000oooo0?ooo`0n0?ooo`030000003oool0oooo0:/0oooo003>0?ooo`800000o`3ooolC0?ooo`03
0000003oool0oooo03l0oooo00<000000?ooo`3oool0ZP3oool00</0oooo0`00003o0?oooaD0oooo
00<000000?ooo`3oool0?`3oool00`000000oooo0?ooo`2Z0?ooo`00b@3oool200000?l0oooo603o
ool00`000000oooo0?ooo`100?ooo`030000003oool0oooo0:T0oooo00360?ooo`<00000o`3ooolJ
0?ooo`030000003oool0oooo0400oooo00<000000?ooo`3oool0Z@3oool00<@0oooo0P00003o0?oo
oad0oooo00<000000?ooo`3oool0@@3oool00`000000oooo0?ooo`2X0?ooo`00`P3oool200000?l0
oooo7`3oool00`000000oooo0?ooo`120?ooo`030000003oool0oooo0:L0oooo002o0?ooo`<00000
o`3ooolQ0?ooo`030000003oool0oooo0480oooo00<000000?ooo`3oool0Y`3oool00;d0oooo0P00
003o0?ooobD0oooo00<000000?ooo`3oool0@P3oool00`000000oooo0?ooo`2V0?ooo`00^P3oool3
00000?l0oooo9`3oool00`000000oooo0?ooo`130?ooo`030000003oool0oooo0:D0oooo002h0?oo
o`800000o`3ooolZ0?ooo`030000003oool0oooo04<0oooo00<000000?ooo`3oool0Y@3oool00;D0
oooo0`00003o0?ooob`0oooo00<000000?ooo`3oool0A03oool00`000000oooo0?ooo`2T0?ooo`00
/`3oool200000?l0oooo;`3oool00`000000oooo0?ooo`150?ooo`030000003oool0oooo0:<0oooo
002a0?ooo`800000o`3ooola0?ooo`030000003oool0oooo04D0oooo00<000000?ooo`3oool0X`3o
ool00:h0oooo0`00003o0?oooc<0oooo00<000000?ooo`3oool0AP3oool00`000000oooo0?ooo`2R
0?ooo`00[03oool200000?l0oooo=P3oool00`000000oooo0?ooo`160?ooo`030000003oool0oooo
0:80oooo002Y0?ooo`<00000o`3ooolh0?ooo`030000003oool0oooo04L0oooo00<000000?ooo`3o
ool0X@3oool00:L0oooo0P00003o0?ooobL0oooo1@00000?0?ooo`030000003oool0oooo04P0oooo
00<000000?ooo`3oool0X03oool00:@0oooo0`00003o0?ooob00oooo2@00000509aFNP030000003o
ool0oooo00`0oooo00<000000?ooo`3oool0B03oool00`000000oooo0?ooo`2P0?ooo`00XP3oool2
00000?l0oooo6`3oool8000000h0W5Ij0P00000=0?ooo`030000003oool0oooo04T0oooo00<00000
0?ooo`3oool0W`3oool00:00oooo0P00003o0?oooa@0oooo2@00000G09aFNP030000003oool0oooo
00/0oooo00<000000?ooo`3oool0BP3oool00`000000oooo0?ooo`2N0?ooo`00W@3oool300000?l0
oooo3@3oool900000200W5Ij0P00000<0?ooo`030000003oool0oooo04X0oooo00<000000?ooo`3o
ool0WP3oool009/0oooo0P00003o0?ooo`P0oooo2000000Z09aFNP8000002`3oool00`000000oooo
0?ooo`1;0?ooo`030000003oool0oooo09d0oooo002H0?ooo`<00000o`3oool10?ooo`T00000<P2L
EWX00`000000Z3l00000000:0?ooo`030000003oool0oooo04`0oooo00<000000?ooo`3oool0W03o
ool009H0oooo0P00003j0?ooo`T00000?02LEWX00`000000Z3l0000000090?ooo`030000003oool0
oooo04`0oooo00<000000?ooo`3oool0W03oool009<0oooo0`00003c0?ooo`T00000A@2LEWX01000
0000Z3l00:Po000000080?ooo`030000003oool0oooo04d0oooo00<000000?ooo`3oool0V`3oool0
0940oooo0P00003^0?ooo`P00000C`2LEWX00`000000Z3l0000000080?ooo`030000003oool0oooo
04d0oooo00<000000?ooo`3oool0V`3oool008h0oooo0`00003W0?ooo`T00000E`2LEWX010000000
Z3l00:Po000000070?ooo`030000003oool0oooo04h0oooo00<000000?ooo`3oool0VP3oool008`0
oooo0P00003Q0?ooo`T00000H@2LEWX010000000Z3l00:Po000000060?ooo`030000003oool0oooo
04l0oooo00<000000?ooo`3oool0V@3oool008X0oooo0P00003K0?ooo`P00000J`2LEWX010000000
Z3l00:Po000000060?ooo`030000003oool0oooo04h0oooo00<000000?ooo`3oool0V@3oool008L0
oooo0`00003D0?ooo`T00000L`2LEWX01@000000Z3l00:Po002X?`00000000D0oooo00<000000?oo
o`3oool0C`3oool00`000000oooo0?ooo`2H0?ooo`00Q@3oool200000<h0oooo2@00001m09aFNP04
0000002X?`00Z3l0000000D0oooo00<000000?ooo`3oool0D03oool00`000000oooo0?ooo`2G0?oo
o`00PP3oool300000<L0oooo2@00002609aFNP050000002X?`00Z3l00:Po00000000103oool00`00
0000oooo0?ooo`1@0?ooo`030000003oool0oooo09L0oooo00200?ooo`800000`P3oool800000900
W5Ij00D000000:Po002X?`00Z3l0000000030?ooo`030000003oool0oooo0540oooo00<000000?oo
o`3oool0UP3oool007d0oooo0`00002k0?ooo`T00000V02LEWX00`000000Z3l00:Po00020:Po0004
0000003oool0oooo000005@0oooo00<000000?ooo`3oool0U@3oool007/0oooo0P00002e0?ooo`T0
0000XP2LEWX00`000000Z3l00:Po00020:Po00030000003oool0000005@0oooo00<000000?ooo`3o
ool0U@3oool007T0oooo0P00002^0?ooo`T00000Z`2LEWX00`000000Z3l00:Po00030:Po00800000
E@3oool00`000000oooo0?ooo`2D0?ooo`00MP3oool300000:P0oooo2000002e09aFNP030000002X
?`00Z3l00080Z3l00P00001E0?ooo`030000003oool0oooo09@0oooo001d0?ooo`800000XP3oool9
00000;d0W5Ij00<000000:Po002X?`000`2X?`000`000000oooo0?ooo`1D0?ooo`030000003oool0
oooo09<0oooo001a0?ooo`<00000V`3oool900000<L0W5Ij00<000000:Po002X?`000P2X?`020000
05H0oooo00<000000?ooo`3oool0TP3oool006l0oooo0P00002F0?ooo`P00000d02LEWX00`000000
Z3l00:Po00020:Po00030000002X?`00000005D0oooo00<000000?ooo`3oool0TP3oool006`0oooo
0`00002?0?ooo`T00000f@2LEWX01@000000Z3l00:Po002X?`0000000080Z3l000<000000?ooo`3o
ool0D`3oool00`000000oooo0?ooo`2A0?ooo`00JP3oool2000008d0oooo1@00003S09aFNP040000
002X?`00Z3l0000000<0Z3l000<000000?ooo`3oool0D`3oool00`000000oooo0?ooo`2@0?ooo`00
I`3oool3000008h0oooo0P00003W09aFNP040000002X?`00Z3l0000000<0Z3l000<000000?ooo`3o
ool0D`3oool00`000000oooo0?ooo`2@0?ooo`00I@3oool200000940oooo00<0000009aFNP2LEWX0
i`2LEWX00`000000Z3l0000000040:Po00030000003oool0oooo05<0oooo00<000000?ooo`3oool0
S`3oool006<0oooo0P00002B0?ooo`800000j@2LEWX00`000000Z3l0000000050:Po00030000003o
ool0oooo05<0oooo00<000000?ooo`3oool0SP3oool00600oooo0`00002D0?ooo`800000jP2LEWX2
000000H0Z3l000<000000?ooo`3oool0DP3oool00`000000oooo0?ooo`2>0?ooo`00GP3oool20000
09H0oooo0P00003[09aFNP8000001`2X?`000`000000oooo0?ooo`1B0?ooo`030000003oool0oooo
08d0oooo001K0?ooo`<00000U`3oool300000>`0W5Ij00<000000:Po002X?`001@2X?`000`000000
oooo0?ooo`1B0?ooo`030000003oool0oooo08d0oooo001I0?ooo`800000VP3oool200000>d0W5Ij
00<000000:Po002X?`001P2X?`000`000000oooo0?ooo`1B0?ooo`030000003oool0oooo08`0oooo
001F0?ooo`<00000V`3oool300000>d0W5Ij0P0000080:Po00030000003oool0oooo0580oooo00<0
00000?ooo`3oool0R`3oool005@0oooo0P00002N0?ooo`<00000kP2LEWX00`000000Z3l00:Po0007
0:Po00030000003oool0oooo0540oooo00<000000?ooo`3oool0R`3oool00580oooo0P00002O0?oo
o`<00000k`2LEWX2000000T0Z3l000<000000?ooo`3oool0D@3oool00`000000oooo0?ooo`2:0?oo
o`00C`3oool300000:00oooo1000003_09aFNP030000002LEWX0000000T0Z3l000<000000?ooo`3o
ool0D@3oool00`000000oooo0?ooo`290?ooo`00C@3oool200000:<0oooo1000003_09aFNP030000
002LEWX0000000T0Z3l000<000000?ooo`3oool0D@3oool00`000000oooo0?ooo`290?ooo`00BP3o
ool300000:@0oooo1000003`09aFNP040000002LEWX0W5Ij000000T0Z3l000<000000?ooo`3oool0
D@3oool00`000000oooo0?ooo`280?ooo`00B03oool200000:L0oooo1000003`09aFNP040000002L
EWX0W5Ij000000X0Z3l000<000000?ooo`3oool0D@3oool00`000000oooo0?ooo`270?ooo`00A@3o
ool300000:P0oooo1@00003`09aFNP050000002LEWX0W5Ij09aFNP0000002P2X?`000`000000oooo
0?ooo`1@0?ooo`030000003oool0oooo08L0oooo00130?ooo`800000ZP3oool500000?40W5Ij00D0
000009aFNP2LEWX0W5Ij0000000;0:Po00030000003oool0oooo0500oooo00<000000?ooo`3oool0
QP3oool00400oooo0`00002/0?ooo`D00000l@2LEWX00`000000W5Ij09aFNP0209aFNP030000002X
?`00Z3l000P0Z3l000<000000?ooo`3oool0D03oool00`000000oooo0?ooo`260?ooo`00?P3oool2
00000:h0oooo1@00003b09aFNP030000002LEWX0W5Ij0080W5Ij00<000000:Po002X?`002@2X?`00
0`000000oooo0?ooo`1@0?ooo`030000003oool0oooo08D0oooo000l0?ooo`800000[`3oool60000
0?80W5Ij00<0000009aFNP2LEWX00`2LEWX00`000000Z3l00:Po00090:Po00030000003oool0oooo
0500oooo00<000000?ooo`3oool0Q03oool003T0oooo0`00002a0?ooo`H00000lP2LEWX00`000000
W5Ij09aFNP0309aFNP030000002X?`00Z3l000X0Z3l000<000000?ooo`3oool0C`3oool00`000000
oooo0?ooo`240?ooo`00=`3oool200000;<0oooo1P00003c09aFNP030000002LEWX0W5Ij00@0W5Ij
00<000000:Po002X?`002P2X?`000`000000oooo0?ooo`1?0?ooo`030000003oool0oooo08<0oooo
000e0?ooo`800000]@3oool600000?<0W5Ij00<0000009aFNP2LEWX01@2LEWX00`000000Z3l00:Po
000:0:Po00030000003oool0oooo04l0oooo00<000000?ooo`3oool0PP3oool003D0oooo0P00002d
0?ooo`L00000l`2LEWX00`000000W5Ij09aFNP0509aFNP030000002X?`00Z3l000X0Z3l000<00000
0?ooo`3oool0C`3oool00`000000oooo0?ooo`220?ooo`00=@3oool00`000000oooo0000002b0?oo
o`L00000m02LEWX00`000000W5Ij09aFNP0609aFNP030000002X?`00Z3l000X0Z3l000<000000?oo
o`3oool0C`3oool00`000000oooo0?ooo`210?ooo`00=@3oool010000000oooo0?ooo`00002a0?oo
o`L00000m02LEWX00`000000W5Ij09aFNP0609aFNP030000002X?`00Z3l000/0Z3l000<000000?oo
o`3oool0C`3oool00`000000oooo0?ooo`200?ooo`00=03oool00`000000oooo0?ooo`020?ooo`03
0000003oool0oooo0:d0oooo2000003d09aFNP030000002LEWX0W5Ij00L0W5Ij00<000000:Po002X
?`002`2X?`000`000000oooo0?ooo`1>0?ooo`030000003oool0oooo0800oooo000d0?ooo`030000
003oool0oooo00<0oooo00<000000?ooo`3oool0[03oool700000?D0W5Ij00<0000009aFNP2LEWX0
1`2LEWX00`000000Z3l00:Po000<0:Po00030000003oool0oooo04h0oooo00<000000?ooo`3oool0
O`3oool003@0oooo00<000000?ooo`3oool0103oool00`000000oooo0?ooo`2Z0?ooo`P00000m@2L
EWX00`000000W5Ij09aFNP0809aFNP030000002X?`00Z3l000`0Z3l000<000000?ooo`3oool0C@3o
ool00`000000oooo0?ooo`1o0?ooo`00=03oool00`000000oooo0?ooo`050?ooo`030000003oool0
oooo0:P0oooo2@00003e09aFNP030000002LEWX0W5Ij00P0W5Ij00<000000:Po002X?`00302X?`00
0`000000oooo0?ooo`1>0?ooo`030000003oool0oooo07h0oooo000d0?ooo`030000003oool0oooo
00H0oooo00<000000?ooo`3oool0Y`3oool800000?L0W5Ij00<0000009aFNP2LEWX0202LEWX00`00
0000Z3l00:Po000<0:Po00030000003oool0oooo04h0oooo00<000000?ooo`3oool0O@3oool003@0
oooo00<000000?ooo`3oool01`3oool00`000000oooo0?ooo`2U0?ooo`T00000m`2LEWX00`000000
W5Ij09aFNP0809aFNP030000002X?`00Z3l000d0Z3l000<000000?ooo`3oool0C@3oool00`000000
oooo0?ooo`1m0?ooo`00<`3oool00`000000oooo0?ooo`090?ooo`030000003oool0oooo0:@0oooo
2000003h09aFNP030000002LEWX0W5Ij00T0W5Ij00<000000:Po002X?`003@2X?`000`000000oooo
0?ooo`1=0?ooo`030000003oool0oooo07`0oooo000c0?ooo`030000003oool0oooo00X0oooo00<0
00000?ooo`3oool0XP3oool900000?P0W5Ij00<0000009aFNP2LEWX02P2LEWX00`000000Z3l00:Po
000=0:Po00030000003oool0oooo04d0oooo00<000000?ooo`3oool0N`3oool003<0oooo00<00000
0?ooo`3oool02`3oool00`000000oooo0?ooo`2P0?ooo`X00000n02LEWX00`000000W5Ij09aFNP0:
09aFNP030000002X?`00Z3l000d0Z3l000<000000?ooo`3oool0C@3oool00`000000oooo0?ooo`1k
0?ooo`00<`3oool00`000000oooo0?ooo`0<0?ooo`030000003oool0oooo09l0oooo2@00003i09aF
NP030000002LEWX0W5Ij00/0W5Ij00<000000:Po002X?`003@2X?`000`000000oooo0?ooo`1=0?oo
o`030000003oool0oooo07X0oooo000c0?ooo`030000003oool0oooo00d0oooo00<000000?ooo`3o
ool0W@3oool:00000?T0W5Ij00<0000009aFNP2LEWX02`2LEWX00`000000Z3l00:Po000>0:Po0003
0000003oool0oooo04d0oooo00<000000?ooo`3oool0N@3oool003<0oooo00<000000?ooo`3oool0
3P3oool00`000000oooo0?ooo`2L0?ooo`X00000n@2LEWX00`000000W5Ij09aFNP0<09aFNP030000
002X?`00Z3l000h0Z3l000<000000?ooo`3oool0C03oool00`000000oooo0?ooo`1i0?ooo`00<`3o
ool00`000000oooo0?ooo`0?0?ooo`030000003oool0oooo09X0oooo2P00003j09aFNP030000002L
EWX0W5Ij00`0W5Ij00<000000:Po002X?`003`2X?`000`000000oooo0?ooo`1<0?ooo`030000003o
ool0oooo07P0oooo000b0?ooo`030000003oool0oooo0140oooo00<000000?ooo`3oool0V03oool;
00000?X0W5Ij00<0000009aFNP2LEWX03@2LEWX00`000000Z3l00:Po000?0:Po00030000003oool0
oooo04/0oooo00<000000?ooo`3oool0N03oool00380oooo00<000000?ooo`3oool04P3oool00`00
0000oooo0?ooo`2G0?ooo`/00000nP2LEWX00`000000W5Ij09aFNP0=09aFNP030000002X?`00Z3l0
00l0Z3l000<000000?ooo`3oool0C03oool00`000000oooo0?ooo`1g0?ooo`00<P3oool00`000000
oooo0?ooo`0C0?ooo`030000003oool0oooo09D0oooo2`00003k09aFNP030000002LEWX0W5Ij00h0
W5Ij00<000000:Po002X?`003`2X?`000`000000oooo0?ooo`1<0?ooo`030000003oool0oooo07H0
oooo000b0?ooo`030000003oool0oooo01@0oooo00<000000?ooo`3oool0U03oool;00000?/0W5Ij
00<0000009aFNP2LEWX03P2LEWX00`000000Z3l00:Po000@0:Po00030000003oool0oooo04/0oooo
00<000000?ooo`3oool0MP3oool00380oooo00<000000?ooo`3oool05@3oool00`000000oooo0?oo
o`2B0?ooo`/00000o02LEWX00`000000W5Ij09aFNP0?09aFNP030000002X?`00Z3l00100Z3l000<0
00000?ooo`3oool0B`3oool00`000000oooo0?ooo`1e0?ooo`00<P3oool00`000000oooo0?ooo`0F
0?ooo`030000003oool0oooo0900oooo3000003l09aFNP030000002LEWX0W5Ij00l0W5Ij00<00000
0:Po002X?`004@2X?`000`000000oooo0?ooo`1;0?ooo`030000003oool0oooo07@0oooo000a0?oo
o`030000003oool0oooo01P0oooo00<000000?ooo`3oool0S`3oool<00000?`0W5Ij00<0000009aF
NP2LEWX0402LEWX00`000000Z3l00:Po000@0:Po00030000003oool0oooo04/0oooo00<000000?oo
o`3oool0M03oool00340oooo00<000000?ooo`3oool06@3oool00`000000oooo0?ooo`2=0?ooo``0
0000o@2LEWX00`000000W5Ij09aFNP0A09aFNP030000002X?`00Z3l00100Z3l000<000000?ooo`3o
ool0B`3oool00`000000oooo0?ooo`1c0?ooo`00<@3oool00`000000oooo0?ooo`0J0?ooo`030000
003oool0oooo08`0oooo3000003m09aFNP030000002LEWX0W5Ij0140W5Ij00<000000:Po002X?`00
4@2X?`000`000000oooo0?ooo`1;0?ooo`030000003oool0oooo0780oooo000a0?ooo`030000003o
ool0oooo01/0oooo00<000000?ooo`3oool0RP3oool=00000?d0W5Ij00<0000009aFNP2LEWX04P2L
EWX00`000000Z3l00:Po000A0:Po00030000003oool0oooo04X0oooo00<000000?ooo`3oool0LP3o
ool00340oooo00<000000?ooo`3oool0703oool00`000000oooo0?ooo`280?ooo`d00000oP2LEWX0
0`000000W5Ij09aFNP0B09aFNP030000002X?`00Z3l00180Z3l000<000000?ooo`3oool0BP3oool0
0`000000oooo0?ooo`1a0?ooo`00<@3oool00`000000oooo0?ooo`0M0?ooo`030000003oool0oooo
08L0oooo3@00003n09aFNP030000002LEWX0W5Ij01<0W5Ij00<000000:Po002X?`004P2X?`000`00
0000oooo0?ooo`190?ooo`030000003oool0oooo0740oooo000a0?ooo`030000003oool0oooo01h0
oooo00<000000?ooo`3oool0Q@3oool>00000?l0W5Ij00<0000009aFNP2LEWX04P2LEWX00`000000
Z3l00:Po000B0:Po00030000003oool0oooo04X0oooo00<000000?ooo`3oool0L03oool00300oooo
00<000000?ooo`3oool0803oool00`000000oooo0?ooo`230?ooo`h00000o`2LEWX109aFNP030000
002LEWX0W5Ij01<0W5Ij00<000000:Po002X?`004P2X?`000`000000oooo0?ooo`1:0?ooo`030000
003oool0oooo06l0oooo000`0?ooo`030000003oool0oooo0240oooo00<000000?ooo`3oool0PP3o
ool>00000?l0W5Ij0@2LEWX00`000000W5Ij09aFNP0C09aFNP030000002X?`00Z3l001<0Z3l000<0
00000?ooo`3oool0B@3oool00`000000oooo0?ooo`1_0?ooo`00<03oool00`000000oooo0?ooo`0R
0?ooo`030000003oool0oooo0800oooo3P00003o09aFNP80W5Ij00<0000009aFNP2LEWX0502LEWX0
0`000000Z3l00:Po000C0:Po00030000003oool0oooo04T0oooo00<000000?ooo`3oool0KP3oool0
0300oooo00<000000?ooo`3oool08`3oool00`000000oooo0?ooo`1o0?ooo`h00000o`2LEWX209aF
NP030000002LEWX0W5Ij01@0W5Ij00<000000:Po002X?`00502X?`000`000000oooo0?ooo`190?oo
o`030000003oool0oooo06d0oooo000`0?ooo`030000003oool0oooo02@0oooo00<000000?ooo`3o
ool0O@3oool?00000?l0W5Ij0P2LEWX00`000000W5Ij09aFNP0E09aFNP030000002X?`00Z3l001@0
Z3l000<000000?ooo`3oool0B03oool00`000000oooo0?ooo`1]0?ooo`00<03oool00`000000oooo
0?ooo`0U0?ooo`030000003oool0oooo07/0oooo3`00003o09aFNP<0W5Ij00<0000009aFNP2LEWX0
5P2LEWX00`000000Z3l00:Po000C0:Po00030000003oool0oooo04T0oooo00<000000?ooo`3oool0
K03oool00300oooo00<000000?ooo`3oool09P3oool00`000000oooo0?ooo`1j0?ooo`l00000o`2L
EWX309aFNP030000002LEWX0W5Ij01H0W5Ij00<000000:Po002X?`00502X?`000`000000oooo0?oo
o`190?ooo`030000003oool0oooo06/0oooo000_0?ooo`030000003oool0oooo02P0oooo00<00000
0?ooo`3oool0N03oool@00000?l0W5Ij0`2LEWX00`000000W5Ij09aFNP0G09aFNP030000002X?`00
Z3l001@0Z3l000<000000?ooo`3oool0B03oool00`000000oooo0?ooo`1[0?ooo`00;`3oool00`00
0000oooo0?ooo`0Y0?ooo`030000003oool0oooo07L0oooo3`00003o09aFNP@0W5Ij00<0000009aF
NP2LEWX05`2LEWX00`000000Z3l00:Po000E0:Po00030000003oool0oooo04P0oooo00<000000?oo
o`3oool0JP3oool002l0oooo00<000000?ooo`3oool0:P3oool00`000000oooo0?ooo`1e0?oooa00
0000o`2LEWX409aFNP030000002LEWX0W5Ij01P0W5Ij00<000000:Po002X?`005@2X?`000`000000
oooo0?ooo`170?ooo`030000003oool0oooo06X0oooo000_0?ooo`030000003oool0oooo02/0oooo
00<000000?ooo`3oool0L`3ooolA00000?l0W5Ij102LEWX00`000000W5Ij09aFNP0H09aFNP030000
002X?`00Z3l001D0Z3l000<000000?ooo`3oool0B03oool00`000000oooo0?ooo`1Y0?ooo`00;`3o
ool00`000000oooo0?ooo`0/0?ooo`030000003oool0oooo0780oooo4000003o09aFNPD0W5Ij00<0
000009aFNP2LEWX06@2LEWX00`000000Z3l00:Po000E0:Po00030000003oool0oooo04P0oooo00<0
00000?ooo`3oool0J03oool002l0oooo00<000000?ooo`3oool0;@3oool00`000000oooo0?ooo`1`
0?oooa400000o`2LEWX509aFNP030000002LEWX0W5Ij01T0W5Ij00<000000:Po002X?`005P2X?`00
0`000000oooo0?ooo`170?ooo`030000003oool0oooo06P0oooo000^0?ooo`030000003oool0oooo
02l0oooo00<000000?ooo`3oool0K`3ooolA00000?l0W5Ij1@2LEWX00`000000W5Ij09aFNP0J09aF
NP030000002X?`00Z3l001H0Z3l000<000000?ooo`3oool0A`3oool00`000000oooo0?ooo`1W0?oo
o`00;P3oool00`000000oooo0?ooo`0`0?ooo`030000003oool0oooo06d0oooo4@00003o09aFNPH0
W5Ij00<0000009aFNP2LEWX06P2LEWX00`000000Z3l00:Po000G0:Po00030000003oool0oooo04L0
oooo00<000000?ooo`3oool0IP3oool002h0oooo00<000000?ooo`3oool0<@3oool00`000000oooo
0?ooo`1[0?oooa800000o`2LEWX609aFNP030000002LEWX0W5Ij01X0W5Ij0P00000I0:Po00030000
003oool0oooo04H0oooo00<000000?ooo`3oool0IP3oool002h0oooo00<000000?ooo`3oool0<P3o
ool00`000000oooo0?ooo`1Z0?oooa400000o`2LEWX709aFNP030000002LEWX0W5Ij01L0W5Ij0`00
00000`2^PZ@000000000000H0:Po00030000003oool0oooo04L0oooo00<000000?ooo`3oool0I@3o
ool002h0oooo00<000000?ooo`3oool0<`3oool00`000000oooo0?ooo`1X0?oooa800000o`2LEWX7
09aFNP030000002LEWX0W5Ij01<0W5Ij100000040:j2Y08000006@2X?`000`000000oooo0?ooo`17
0?ooo`030000003oool0oooo06@0oooo000^0?ooo`030000003oool0oooo03@0oooo00<000000?oo
o`3oool0I`3ooolB00000?l0W5Ij1`2LEWX00`000000W5Ij09aFNP0@09aFNP<00000202^PZ@00`00
0000mkf90000000I0:Po00030000003oool0oooo04H0oooo00<000000?ooo`3oool0I03oool002h0
oooo00<000000?ooo`3oool0=@3oool00`000000oooo0?ooo`1U0?oooa800000o`2LEWX809aFNP03
0000002LEWX0W5Ij00d0W5Ij0`00000;0:j2Y0030000003g_HT0000001X0Z3l000<000000?ooo`3o
ool0AP3oool00`000000oooo0?ooo`1S0?ooo`00;@3oool00`000000oooo0?ooo`0g0?ooo`030000
003oool0oooo06<0oooo4`00003o09aFNPP0W5Ij00<0000009aFNP2LEWX02@2LEWX4000000h0[X:T
00@000000?NmR@3g_HT000006P2X?`000`000000oooo0?ooo`150?ooo`030000003oool0oooo06<0
oooo000]0?ooo`030000003oool0oooo03P0oooo00<000000?ooo`3oool0HP3ooolC00000?l0W5Ij
2@2LEWX00`000000W5Ij09aFNP0509aFNP<000004P2^PZ@01@000000mkf90?NmR@3g_HT0000001T0
Z3l000<000000?ooo`3oool0AP3oool00`000000oooo0?ooo`1R0?ooo`00;@3oool00`000000oooo
0?ooo`0i0?ooo`030000003oool0oooo0600oooo4`00003o09aFNPX0W5Ij00<0000009aFNP2LEWX0
0P2LEWX3000001D0[X:T00D000000?NmR@3g_HT0mkf90000000J0:Po00030000003oool0oooo04H0
oooo00<000000?ooo`3oool0H@3oool002d0oooo00<000000?ooo`3oool0>P3oool00`000000oooo
0?ooo`1O0?oooa<00000o`2LEWX:09aFNPD00000602^PZ@00`000000mkf90?NmR@020?NmR@030000
002X?`00Z3l001P0Z3l000<000000?ooo`3oool0A@3oool00`000000oooo0?ooo`1Q0?ooo`00;@3o
ool00`000000oooo0?ooo`0k0?ooo`030000003oool0oooo05d0oooo5000003o09aFNPP0W5Ij0`00
000L0:j2Y0030000003g_HT0mkf90080mkf900<000000:Po002X?`006@2X?`000`000000oooo0?oo
o`150?ooo`030000003oool0oooo0600oooo000]0?ooo`030000003oool0oooo03`0oooo00<00000
0?ooo`3oool0F`3ooolD00000?l0W5Ij1P2LEWX300000080[X:T00<000000:j2Y02^PZ@06P2^PZ@0
0`000000mkf90?NmR@030?NmR@030000002X?`00Z3l001T0Z3l000<000000?ooo`3oool0A@3oool0
0`000000oooo0?ooo`1O0?ooo`00;03oool00`000000oooo0?ooo`0n0?ooo`030000003oool0oooo
05X0oooo5000003o09aFNP80W5Ij100000050:j2Y0030000002^PZ@0[X:T01X0[X:T00<000000?Nm
R@3g_HT0103g_HT00`000000Z3l00:Po000I0:Po00030000003oool0oooo04@0oooo00<000000?oo
o`3oool0G`3oool002`0oooo00<000000?ooo`3oool0?`3oool00`000000oooo0?ooo`1H0?oooa@0
0000o`2LEWX3000000T0[X:T00<000000:j2Y02^PZ@06P2^PZ@00`000000mkf90?NmR@040?NmR@03
0000002X?`00Z3l001T0Z3l000<000000?ooo`3oool0A@3oool00`000000oooo0?ooo`1N0?ooo`00
;03oool00`000000oooo0?ooo`100?ooo`030000003oool0oooo05L0oooo5000003l09aFNP<00000
302^PZ@00`000000[X:T0:j2Y00J0:j2Y0030000003g_HT0mkf900D0mkf900<000000:Po002X?`00
6@2X?`000`000000oooo0?ooo`150?ooo`030000003oool0oooo05d0oooo000/0?ooo`030000003o
ool0oooo0440oooo00<000000?ooo`3oool0E@3ooolE00000?P0W5Ij1000000?0:j2Y0030000002^
PZ@0[X:T01X0[X:T00<000000?NmR@3g_HT01P3g_HT00`000000Z3l00:Po000I0:Po00030000003o
ool0oooo04@0oooo00<000000?ooo`3oool0G@3oool002`0oooo00<000000?ooo`3oool0@P3oool0
0`000000oooo0?ooo`1C0?oooaD00000mP2LEWX3000001<0[X:T00<000000:j2Y02^PZ@06`2^PZ@0
0`000000mkf90?NmR@050?NmR@030000002X?`00Z3l001X0Z3l000<000000?ooo`3oool0A03oool0
0`000000oooo0?ooo`1L0?ooo`00;03oool00`000000oooo0?ooo`130?ooo`030000003oool0oooo
0580oooo5@00003c09aFNP<000005P2^PZ@00`000000[X:T0:j2Y00K0:j2Y0030000003g_HT0mkf9
00H0mkf900<000000:Po002X?`006P2X?`000`000000oooo0?ooo`130?ooo`030000003oool0oooo
05`0oooo000/0?ooo`030000003oool0oooo04@0oooo00<000000?ooo`3oool0D03ooolF00000?00
W5Ij0`00000I0:j2Y0030000002^PZ@0[X:T01/0[X:T00<000000?NmR@3g_HT01P3g_HT00`000000
Z3l00:Po000K0:Po00030000003oool0oooo04<0oooo00<000000?ooo`3oool0F`3oool002/0oooo
00<000000?ooo`3oool0AP3oool00`000000oooo0?ooo`1?0?oooaD00000k@2LEWX4000001`0[X:T
00<000000:j2Y02^PZ@06`2^PZ@00`000000mkf90?NmR@070?NmR@030000002X?`00Z3l001X0Z3l0
00<000000?ooo`3oool0A03oool00`000000oooo0?ooo`1J0?ooo`00:`3oool00`000000oooo0?oo
o`170?ooo`030000003oool0oooo04d0oooo5P00003Z09aFNP<00000802^PZ@00`000000[X:T0:j2
Y00K0:j2Y0030000003g_HT0mkf900P0mkf900<000000:Po002X?`006P2X?`000`000000oooo0?oo
o`130?ooo`030000003oool0oooo05X0oooo000[0?ooo`030000003oool0oooo04L0oooo00<00000
0?ooo`3oool0C03ooolG00000>L0W5Ij0`00000S0:j2Y0030000002^PZ@0[X:T01/0[X:T00<00000
0?NmR@3g_HT0203g_HT00`000000Z3l00:Po000K0:Po00030000003oool0oooo04<0oooo00<00000
0?ooo`3oool0F@3oool002/0oooo00<000000?ooo`3oool0B03oool00`000000oooo0?ooo`1;0?oo
oaH00000i02LEWX4000002H0[X:T00<000000:j2Y02^PZ@06`2^PZ@00`000000mkf90?NmR@090?Nm
R@030000002X?`00Z3l001/0Z3l000<000000?ooo`3oool0@`3oool00`000000oooo0?ooo`1H0?oo
o`00:`3oool00`000000oooo0?ooo`190?ooo`030000003oool0oooo04T0oooo5`00003Q09aFNP<0
0000:P2^PZ@00`000000[X:T0:j2Y00K0:j2Y0030000003g_HT0mkf900T0mkf900<000000:Po002X
?`00702X?`000`000000oooo0?ooo`120?ooo`030000003oool0oooo05P0oooo000[0?ooo`030000
003oool0oooo04X0oooo00<000000?ooo`3oool0A`3ooolG00000=l0W5Ij0`00000]0:j2Y0030000
002^PZ@0[X:T01/0[X:T00<000000?NmR@3g_HT02P3g_HT00`000000Z3l00:Po000K0:Po00030000
003oool0oooo04<0oooo00<000000?ooo`3oool0E`3oool002X0oooo00<000000?ooo`3oool0C03o
ool00`000000oooo0?ooo`160?oooaL00000f`2LEWX400000300[X:T00<000000:j2Y02^PZ@06`2^
PZ@00`000000mkf90?NmR@0;0?NmR@030000002X?`00Z3l001/0Z3l000<000000?ooo`3oool0@P3o
ool00`000000oooo0?ooo`1G0?ooo`00:P3oool00`000000oooo0?ooo`1=0?ooo`030000003oool0
oooo04@0oooo6000003H09aFNP<00000=02^PZ@00`000000[X:T0:j2Y00K0:j2Y0030000003g_HT0
mkf900/0mkf900<000000:Po002X?`00702X?`000`000000oooo0?ooo`120?ooo`030000003oool0
oooo05H0oooo000Z0?ooo`030000003oool0oooo04h0oooo00<000000?ooo`3oool0@`3ooolG0000
0=H0W5Ij0`00000g0:j2Y0030000002^PZ@0[X:T01/0[X:T00<000000?NmR@3g_HT0303g_HT00`00
0000Z3l00:Po000L0:Po00030000003oool0oooo0480oooo00<000000?ooo`3oool0E@3oool002X0
oooo00<000000?ooo`3oool0C`3oool00`000000oooo0?ooo`110?oooaP00000dP2LEWX4000003/0
[X:T00<000000:j2Y02^PZ@06P2^PZ@00`000000mkf90?NmR@0<0?NmR@030000002X?`00Z3l001d0
Z3l000<000000?ooo`3oool0@@3oool00`000000oooo0?ooo`1E0?ooo`00:P3oool00`000000oooo
0?ooo`1@0?ooo`030000003oool0oooo03l0oooo6@00003?09aFNP<00000?`2^PZ@00`000000[X:T
0:j2Y00J0:j2Y0030000003g_HT0mkf900d0mkf900<000000:Po002X?`007@2X?`000`000000oooo
0?ooo`110?ooo`030000003oool0oooo05@0oooo000Z0?ooo`030000003oool0oooo0540oooo00<0
00000?ooo`3oool0?P3ooolH00000<d0W5Ij0`0000120:j2Y0030000002^PZ@0[X:T01X0[X:T00<0
00000?NmR@3g_HT03P3g_HT00`000000Z3l00:Po000L0:Po00030000003oool0oooo0480oooo00<0
00000?ooo`3oool0D`3oool002X0oooo00<000000?ooo`3oool0DP3oool00`000000oooo0?ooo`0l
0?oooaT00000b@2LEWX4000004D0[X:T00<000000:j2Y02^PZ@06P2^PZ@00`000000mkf90?NmR@0>
0?NmR@030000002X?`00Z3l001d0Z3l000<000000?ooo`3oool0@@3oool00`000000oooo0?ooo`1C
0?ooo`00:@3oool00`000000oooo0?ooo`1D0?ooo`030000003oool0oooo03/0oooo6@00003609aF
NP<00000B@2^PZ@00`000000[X:T0:j2Y00J0:j2Y0030000003g_HT0mkf900l0mkf900<000000:Po
002X?`007@2X?`000`000000oooo0?ooo`110?ooo`030000003oool0oooo0580oooo000Y0?ooo`03
0000003oool0oooo05D0oooo00<000000?ooo`3oool0>@3ooolI00000<@0W5Ij0`00001<0:j2Y003
0000002^PZ@0[X:T01X0[X:T00<000000?NmR@3g_HT0403g_HT00`000000Z3l00:Po000L0:Po0003
0000003oool0oooo0480oooo00<000000?ooo`3oool0D@3oool002T0oooo00<000000?ooo`3oool0
EP3oool00`000000oooo0?ooo`0g0?oooaX00000`@2LEWX3000004l0[X:T00<000000:j2Y02^PZ@0
6P2^PZ@00`000000mkf90?NmR@0@0?NmR@030000002X?`00Z3l001d0Z3l000<000000?ooo`3oool0
@@3oool00`000000oooo0?ooo`1A0?ooo`00:@3oool00`000000oooo0?ooo`1G0?ooo`030000003o
ool0oooo03H0oooo6@00002n09aFNP@00000DP2^PZ@00`000000[X:T0:j2Y00J0:j2Y0030000003g
_HT0mkf90140mkf900<000000:Po002X?`00702X?`000`000000oooo0?ooo`120?ooo`030000003o
ool0oooo0500oooo000Y0?ooo`030000003oool0oooo05P0oooo00<000000?ooo`3oool0=03ooolJ
00000;/0W5Ij0`00001F0:j2Y0030000002^PZ@0[X:T01X0[X:T00<000000?NmR@3g_HT04@3g_HT0
0`000000Z3l00:Po000M0:Po00030000003oool0oooo0440oooo00<000000?ooo`3oool0D03oool0
02T0oooo00<000000?ooo`3oool0F@3oool00`000000oooo0?ooo`0c0?oooaX00000^02LEWX30000
05T0[X:T00<000000:j2Y02^PZ@06P2^PZ@00`000000mkf90?NmR@0B0?NmR@030000002X?`00Z3l0
01`0Z3l000<000000?ooo`3oool0@P3oool00`000000oooo0?ooo`1?0?ooo`00:@3oool00`000000
oooo0?ooo`1J0?ooo`030000003oool0oooo0340oooo6P00002e09aFNP@00000G02^PZ@00`000000
[X:T0:j2Y00J0:j2Y0030000003g_HT0mkf901<0mkf900<000000:Po002X?`00702X?`000`000000
oooo0?ooo`120?ooo`030000003oool0oooo04h0oooo000X0?ooo`030000003oool0oooo05`0oooo
00<000000?ooo`3oool0;`3ooolK00000;80W5Ij0`00001P0:j2Y0030000002^PZ@0[X:T01X0[X:T
00<000000?NmR@3g_HT04`3g_HT00`000000Z3l00:Po000L0:Po00030000003oool0oooo0480oooo
00<000000?ooo`3oool0CP3oool002P0oooo00<000000?ooo`3oool0G@3oool00`000000oooo0?oo
o`0^0?oooa/00000[`2LEWX3000006<0[X:T00<000000:j2Y02^PZ@06P2^PZ@00`000000mkf90?Nm
R@0D0?NmR@030000002X?`00Z3l001/0Z3l000<000000?ooo`3oool0@`3oool00`000000oooo0?oo
o`1=0?ooo`00:03oool00`000000oooo0?ooo`1N0?ooo`030000003oool0oooo02`0oooo6`00002/
09aFNP@00000IP2^PZ@00`000000[X:T0:j2Y00J0:j2Y0030000003g_HT0mkf901@0mkf900<00000
0:Po002X?`00702X?`000`000000oooo0?ooo`130?ooo`030000003oool0oooo04`0oooo000X0?oo
o`030000003oool0oooo05l0oooo00<000000?ooo`3oool0:`3ooolK00000:T0W5Ij0`00001Z0:j2
Y0030000002^PZ@0[X:T01X0[X:T00<000000?NmR@3g_HT05@3g_HT00`000000Z3l00:Po000K0:Po
00030000003oool0oooo04<0oooo00<000000?ooo`3oool0C03oool002P0oooo00<000000?ooo`3o
ool0H03oool00`000000oooo0?ooo`0Y0?oooa`00000YP2LEWX3000006d0[X:T00<000000:j2Y02^
PZ@06P2^PZ@00`000000mkf90?NmR@0F0?NmR@030000002X?`00Z3l001/0Z3l000<000000?ooo`3o
ool0@`3oool00`000000oooo0?ooo`1;0?ooo`00:03oool00`000000oooo0?ooo`1Q0?ooo`030000
003oool0oooo02P0oooo6`00002S09aFNP@00000L02^PZ@00`000000[X:T0:j2Y00J0:j2Y0030000
003g_HT0mkf901H0mkf900<000000:Po002X?`006`2X?`000`000000oooo0?ooo`140?ooo`030000
003oool0oooo04X0oooo000W0?ooo`030000003oool0oooo06<0oooo00<000000?ooo`3oool09P3o
oolL00000:00W5Ij0`00001d0:j2Y0030000002^PZ@0[X:T01X0[X:T00<000000?NmR@3g_HT05`3g
_HT00`000000Z3l00:Po000J0:Po00030000003oool0oooo04@0oooo00<000000?ooo`3oool0BP3o
ool002L0oooo00<000000?ooo`3oool0I03oool00`000000oooo0?ooo`0T0?oooad00000W@2LEWX3
000007L0[X:T00<000000:j2Y02^PZ@06`2^PZ@00`000000mkf90?NmR@0F0?NmR@030000002X?`00
Z3l001/0Z3l000<000000?ooo`3oool0A03oool00`000000oooo0?ooo`190?ooo`009`3oool00`00
0000oooo0?ooo`1U0?ooo`030000003oool0oooo02<0oooo7000002J09aFNP@00000NP2^PZ@00`00
0000[X:T0:j2Y00K0:j2Y0030000003g_HT0mkf901L0mkf900<000000:Po002X?`006P2X?`000`00
0000oooo0?ooo`140?ooo`030000003oool0oooo04T0oooo000W0?ooo`030000003oool0oooo06H0
oooo00<000000?ooo`3oool08@3ooolM000009L0W5Ij0`00001n0:j2Y0030000002^PZ@0[X:T01/0
[X:T00<000000?NmR@3g_HT0603g_HT00`000000Z3l00:Po000J0:Po00030000003oool0oooo04@0
oooo00<000000?ooo`3oool0B03oool002L0oooo00<000000?ooo`3oool0I`3oool00`000000oooo
0?ooo`0P0?oooa`00000U@2LEWX300000880[X:T00<000000:j2Y02^PZ@06P2^PZ@00`000000mkf9
0?NmR@0H0?NmR@030000002X?`00Z3l001X0Z3l000<000000?ooo`3oool0A@3oool00`000000oooo
0?ooo`170?ooo`009`3oool00`000000oooo0?ooo`1X0?ooo`030000003oool0oooo01h0oooo7@00
002B09aFNP<00000Q@2^PZ@00`000000[X:T0:j2Y00J0:j2Y0030000003g_HT0mkf901T0mkf900<0
00000:Po002X?`006P2X?`000`000000oooo0?ooo`140?ooo`030000003oool0oooo04L0oooo000W
0?ooo`030000003oool0oooo06T0oooo00<000000?ooo`3oool07@3ooolM000008h0W5Ij10000028
0:j2Y0030000002^PZ@0[X:T01X0[X:T00<000000?NmR@3g_HT06P3g_HT00`000000Z3l00:Po000I
0:Po00030000003oool0oooo04D0oooo00<000000?ooo`3oool0AP3oool002H0oooo00<000000?oo
o`3oool0J`3oool00`000000oooo0?ooo`0K0?oooad00000S02LEWX3000008`0[X:T00<000000:j2
Y02^PZ@06P2^PZ@00`000000mkf90?NmR@0J0?NmR@030000002X?`00Z3l001T0Z3l000<000000?oo
o`3oool0AP3oool00`000000oooo0?ooo`150?ooo`009P3oool00`000000oooo0?ooo`1/0?ooo`03
0000003oool0oooo01T0oooo7P00002909aFNP<00000S`2^PZ@00`000000[X:T0:j2Y00J0:j2Y003
0000003g_HT0mkf901/0mkf900<000000:Po002X?`006@2X?`000`000000oooo0?ooo`150?ooo`03
0000003oool0oooo04D0oooo000V0?ooo`030000003oool0oooo06d0oooo00<000000?ooo`3oool0
603ooolN000008D0W5Ij1000002B0:j2Y0030000002^PZ@0[X:T01X0[X:T00<000000?NmR@3g_HT0
6`3g_HT00`000000Z3l00:Po000I0:Po00030000003oool0oooo04H0oooo00<000000?ooo`3oool0
A03oool002H0oooo00<000000?ooo`3oool0KP3oool00`000000oooo0?ooo`0F0?oooah00000P`2L
EWX3000009H0[X:T00<000000:j2Y02^PZ@06P2^PZ@00`000000mkf90?NmR@0L0?NmR@030000002X
?`00Z3l001T0Z3l000<000000?ooo`3oool0AP3oool00`000000oooo0?ooo`130?ooo`009P3oool0
0`000000oooo0?ooo`1_0?ooo`030000003oool0oooo01D0oooo7P00002009aFNP<00000V@2^PZ@0
0`000000[X:T0:j2Y00J0:j2Y0030000003g_HT0mkf901d0mkf900<000000:Po002X?`00602X?`00
0`000000oooo0?ooo`160?ooo`030000003oool0oooo04<0oooo000V0?ooo`030000003oool0oooo
0700oooo00<000000?ooo`3oool04`3ooolO000007`0W5Ij1000002L0:j2Y0030000002^PZ@0[X:T
01X0[X:T00<000000?NmR@3g_HT07@3g_HT00`000000Z3l00:Po000H0:Po00030000003oool0oooo
04L0oooo00<000000?ooo`3oool0@P3oool002D0oooo00<000000?ooo`3oool0LP3oool00`000000
oooo0?ooo`0B0?oooah00000NP2LEWX300000:00[X:T00<000000:j2Y02^PZ@06P2^PZ@00`000000
mkf90?NmR@0N0?NmR@030000002X?`00Z3l001P0Z3l000<000000?ooo`3oool0AP3oool00`000000
oooo0?ooo`120?ooo`009@3oool00`000000oooo0?ooo`1c0?ooo`030000003oool0oooo0100oooo
7`00001g09aFNP<00000X`2^PZ@00`000000[X:T0:j2Y00J0:j2Y0030000003g_HT0mkf901h0mkf9
00<000000:Po002X?`00602X?`000`000000oooo0?ooo`170?ooo`030000003oool0oooo0440oooo
000U0?ooo`030000003oool0oooo07@0oooo00<000000?ooo`3oool03P3ooolO000007@0W5Ij1000
002V0:j2Y0030000002^PZ@0[X:T01X0[X:T00<000000?NmR@3g_HT07`3g_HT00`000000Z3l00:Po
000H0:Po00030000003oool0oooo04L0oooo00<000000?ooo`3oool0@03oool002D0oooo00<00000
0?ooo`3oool0M@3oool00`000000oooo0?ooo`0=0?oooal00000L@2LEWX300000:X0[X:T00<00000
0:j2Y02^PZ@06P2^PZ@00`000000mkf90?NmR@0P0?NmR@030000002X?`00Z3l001L0Z3l000<00000
0?ooo`3oool0A`3oool00`000000oooo0?ooo`100?ooo`009@3oool00`000000oooo0?ooo`1f0?oo
o`030000003oool0oooo00/0oooo8000001^09aFNP<00000[@2^PZ@00`000000[X:T0:j2Y00J0:j2
Y0030000003g_HT0mkf90200mkf900<000000:Po002X?`00602X?`000`000000oooo0?ooo`170?oo
o`030000003oool0oooo03l0oooo000U0?ooo`030000003oool0oooo07L0oooo00<000000?ooo`3o
ool02P3ooolO000006/0W5Ij1000002`0:j2Y0030000002^PZ@0[X:T01X0[X:T00<000000?NmR@3g
_HT08@3g_HT00`000000Z3l00:Po000G0:Po00030000003oool0oooo04P0oooo00<000000?ooo`3o
ool0?P3oool002D0oooo00<000000?ooo`3oool0N03oool00`000000oooo0?ooo`080?ooob000000
J02LEWX300000;@0[X:T00<000000:j2Y02^PZ@06P2^PZ@00`000000mkf90?NmR@0Q0?NmR@030000
002X?`00Z3l001L0Z3l000<000000?ooo`3oool0B03oool00`000000oooo0?ooo`0n0?ooo`00903o
ool00`000000oooo0?ooo`1j0?ooo`030000003oool0oooo00L0oooo8000001U09aFNP<00000]`2^
PZ@00`000000[X:T0:j2Y00J0:j2Y0030000003g_HT0mkf90280mkf900<000000:Po002X?`005`2X
?`000`000000oooo0?ooo`180?ooo`030000003oool0oooo03d0oooo000T0?ooo`030000003oool0
oooo07/0oooo00<000000?ooo`3oool01@3ooolP00000680W5Ij1000002j0:j2Y0030000002^PZ@0
[X:T01X0[X:T00<000000?NmR@3g_HT08`3g_HT00`000000Z3l00:Po000F0:Po00030000003oool0
oooo04T0oooo00<000000?ooo`3oool0?03oool002@0oooo00<000000?ooo`3oool0O03oool00`00
0000oooo0?ooo`030?ooob400000G`2LEWX300000;h0[X:T00<000000:j2Y02^PZ@06P2^PZ@00`00
0000mkf90?NmR@0S0?NmR@030000002X?`00Z3l001L0Z3l000<000000?ooo`3oool0B03oool00`00
0000oooo0?ooo`0l0?ooo`00903oool00`000000oooo0?ooo`1m0?ooo`030000003oool0oooo0080
oooo8@00001L09aFNP<00000`@2^PZ@00`000000[X:T0:j2Y00J0:j2Y0030000003g_HT0mkf902@0
mkf900<000000:Po002X?`005P2X?`000`000000oooo0?ooo`190?ooo`030000003oool0oooo03/0
oooo000T0?ooo`030000003oool0oooo07h0oooo00<000000?ooo`3oool08@00001J09aFNP<00000
a02^PZ@00`000000[X:T0:j2Y00J0:j2Y0030000003g_HT0mkf902D0mkf900<000000:Po002X?`00
5P2X?`000`000000oooo0?ooo`180?ooo`030000003oool0oooo03/0oooo000T0?ooo`030000003o
ool0oooo07l0oooo00<000000?ooo`0000008000001F09aFNP@00000a`2^PZ@00`000000[X:T0:j2
Y00J0:j2Y0030000003g_HT0mkf902D0mkf900<000000:Po002X?`005P2X?`000`000000oooo0?oo
o`190?ooo`030000003oool0oooo03X0oooo000S0?ooo`030000003oool0oooo0840oooo8@00001D
09aFNP<00000c02^PZ@00`000000[X:T0:j2Y00I0:j2Y0030000003g_HT0mkf902H0mkf900<00000
0:Po002X?`005@2X?`000`000000oooo0?ooo`1:0?ooo`030000003oool0oooo03T0oooo000S0?oo
o`030000003oool0oooo0840oooo8@00001A09aFNP<00000c`2^PZ@00`000000[X:T0:j2Y00I0:j2
Y0030000003g_HT0mkf902H0mkf900<000000:Po002X?`005P2X?`000`000000oooo0?ooo`190?oo
o`030000003oool0oooo03T0oooo000S0?ooo`030000003oool0oooo0800oooo8P00001=09aFNP@0
0000dP2^PZ@00`000000[X:T0:j2Y00I0:j2Y0030000003g_HT0mkf902L0mkf900<000000:Po002X
?`005@2X?`000`000000oooo0?ooo`1:0?ooo`030000003oool0oooo03P0oooo000S0?ooo`030000
003oool0oooo07l0oooo8P00001;09aFNP<00000eP2^PZ@00`000000[X:T0:j2Y00I0:j2Y0030000
003g_HT0mkf902P0mkf900<000000:Po002X?`005@2X?`000`000000oooo0?ooo`1:0?ooo`030000
003oool0oooo03L0oooo000S0?ooo`030000003oool0oooo07l0oooo8P00001809aFNP<00000f@2^
PZ@00`000000[X:T0:j2Y00I0:j2Y0030000003g_HT0mkf902P0mkf900<000000:Po002X?`005@2X
?`000`000000oooo0?ooo`1:0?ooo`030000003oool0oooo03L0oooo000S0?ooo`030000003oool0
oooo07h0oooo8`00001409aFNP@00000g02^PZ@00`000000[X:T0:j2Y00J0:j2Y0030000003g_HT0
mkf902P0mkf900<000000:Po002X?`00502X?`000`000000oooo0?ooo`1;0?ooo`030000003oool0
oooo03H0oooo000S0?ooo`030000003oool0oooo07h0oooo8P00001209aFNP<00000h02^PZ@00`00
0000[X:T0:j2Y00J0:j2Y0030000003g_HT0mkf902P0mkf900<000000:Po002X?`005@2X?`000`00
0000oooo0?ooo`1;0?ooo`030000003oool0oooo03D0oooo000R0?ooo`030000003oool0oooo07h0
oooo8`00000o09aFNP<00000h`2^PZ@00`000000[X:T0:j2Y00J0:j2Y0030000003g_HT0mkf902T0
mkf900<000000:Po002X?`00502X?`000`000000oooo0?ooo`1;0?ooo`030000003oool0oooo03D0
oooo000R0?ooo`030000003oool0oooo07h0oooo8`00000k09aFNP@00000iP2^PZ@00`000000[X:T
0:j2Y00J0:j2Y0030000003g_HT0mkf902X0mkf900<000000:Po002X?`00502X?`000`000000oooo
0?ooo`1;0?ooo`030000003oool0oooo03@0oooo000R0?ooo`030000003oool0oooo07d0oooo8`00
000i09aFNP<00000jP2^PZ@00`000000[X:T0:j2Y00J0:j2Y0030000003g_HT0mkf902X0mkf900<0
00000:Po002X?`00502X?`000`000000oooo0?ooo`1;0?ooo`030000003oool0oooo03@0oooo000R
0?ooo`030000003oool0oooo07`0oooo9000000f09aFNP<00000k@2^PZ@00`000000[X:T0:j2Y00J
0:j2Y0030000003g_HT0mkf902/0mkf900<000000:Po002X?`00502X?`000`000000oooo0?ooo`1;
0?ooo`030000003oool0oooo03<0oooo000R0?ooo`030000003oool0oooo07`0oooo9000000b09aF
NP@00000l02^PZ@00`000000[X:T0:j2Y00J0:j2Y0030000003g_HT0mkf902/0mkf900<000000:Po
002X?`00502X?`000`000000oooo0?ooo`1<0?ooo`030000003oool0oooo0380oooo000R0?ooo`03
0000003oool0oooo07/0oooo9000000`09aFNP<00000m02^PZ@00`000000[X:T0:j2Y00J0:j2Y003
0000003g_HT0mkf902`0mkf900<000000:Po002X?`004`2X?`000`000000oooo0?ooo`1<0?ooo`03
0000003oool0oooo0380oooo000R0?ooo`030000003oool0oooo07/0oooo9000000]09aFNP<00000
m`2^PZ@00`000000[X:T0:j2Y00J0:j2Y0030000003g_HT0mkf902d0mkf900<000000:Po002X?`00
4`2X?`000`000000oooo0?ooo`1<0?ooo`030000003oool0oooo0340oooo000Q0?ooo`030000003o
ool0oooo07/0oooo9000000[09aFNP<00000nP2^PZ@00`000000[X:T0:j2Y00J0:j2Y0030000003g
_HT0mkf902d0mkf900<000000:Po002X?`004`2X?`000`000000oooo0?ooo`1=0?ooo`030000003o
ool0oooo0300oooo000Q0?ooo`030000003oool0oooo07X0oooo9@00000W09aFNP@00000o@2^PZ@0
0`000000[X:T0:j2Y00J0:j2Y0030000003g_HT0mkf902h0mkf900<000000:Po002X?`004`2X?`00
0`000000oooo0?ooo`1<0?ooo`030000003oool0oooo0300oooo000Q0?ooo`030000003oool0oooo
07X0oooo9@00000T09aFNP<00000o`2^PZ@20:j2Y0030000002^PZ@0[X:T01X0[X:T00<000000?Nm
R@3g_HT0;`3g_HT00`000000Z3l00:Po000B0:Po00030000003oool0oooo04d0oooo00<000000?oo
o`3oool0;`3oool00240oooo00<000000?ooo`3oool0N@3ooolU00000280W5Ij0`00003o0:j2Y0D0
[X:T00<000000:j2Y02^PZ@06P2^PZ@00`000000mkf90?NmR@0_0?NmR@030000002X?`00Z3l00180
Z3l000<000000?ooo`3oool0CP3oool00`000000oooo0?ooo`0^0?ooo`008@3oool00`000000oooo
0?ooo`1i0?ooobD000007P2LEWX400000?l0[X:T202^PZ@00`000000[X:T0:j2Y00J0:j2Y0030000
003g_HT0mkf90300mkf900<000000:Po002X?`004P2X?`000`000000oooo0?ooo`1=0?ooo`030000
003oool0oooo02h0oooo000Q0?ooo`030000003oool0oooo07P0oooo9P00000K09aFNP<00000o`2^
PZ@<0:j2Y0030000002^PZ@0[X:T01X0[X:T00<000000?NmR@3g_HT0<03g_HT00`000000Z3l00:Po
000B0:Po00030000003oool0oooo04h0oooo00<000000?ooo`3oool0;@3oool00200oooo00<00000
0?ooo`3oool0N@3ooolU000001T0W5Ij0`00003o0:j2Y0l0[X:T00<000000:j2Y02^PZ@06P2^PZ@0
0`000000mkf90?NmR@0a0?NmR@030000002X?`00Z3l00180Z3l000<000000?ooo`3oool0C@3oool0
0`000000oooo0?ooo`0]0?ooo`00803oool00`000000oooo0?ooo`1h0?ooobH000005@2LEWX40000
0?l0[X:T4`2^PZ@00`000000[X:T0:j2Y00I0:j2Y0030000003g_HT0mkf90380mkf900<000000:Po
002X?`004@2X?`000`000000oooo0?ooo`1>0?ooo`030000003oool0oooo02`0oooo000P0?ooo`03
0000003oool0oooo07L0oooo9`00000B09aFNP<00000o`2^PZ@G0:j2Y0030000002^PZ@0[X:T01T0
[X:T00<000000?NmR@3g_HT0<P3g_HT00`000000Z3l00:Po000B0:Po00030000003oool0oooo04h0
oooo00<000000?ooo`3oool0:`3oool00200oooo00<000000?ooo`3oool0M`3ooolV00000100W5Ij
0`00003o0:j2Y1X0[X:T00<000000:j2Y02^PZ@06@2^PZ@00`000000mkf90?NmR@0c0?NmR@030000
002X?`00Z3l00140Z3l000<000000?ooo`3oool0CP3oool00`000000oooo0?ooo`0[0?ooo`00803o
ool00`000000oooo0?ooo`1f0?ooobL00000302LEWX400000?l0[X:T7@2^PZ@00`000000[X:T0:j2
Y00I0:j2Y0030000003g_HT0mkf903<0mkf900<000000:Po002X?`004@2X?`000`000000oooo0?oo
o`1>0?ooo`800000;03oool00200oooo00<000000?ooo`3oool0MP3ooolV000000X0W5Ij0`00003o
0:j2Y240[X:T00<000000:j2Y02^PZ@06@2^PZ@00`000000mkf90?NmR@0d0?NmR@030000002X?`00
Z3l00140Z3l000<000000?ooo`3oool0BP3oool3000000030?ooo`000000oooo02/0oooo000P0?oo
o`030000003oool0oooo07D0oooo9`00000709aFNP<00000o`2^PZ@T0:j2Y0030000002^PZ@0[X:T
01T0[X:T00<000000?NmR@3g_HT0=@3g_HT00`000000Z3l00:Po000@0:Po00030000003oool0oooo
04L0oooo0`0000040?ooo`030000003oool0oooo02X0oooo000O0?ooo`030000003oool0oooo07H0
oooo9`00000309aFNP@00000o`2^PZ@W0:j2Y0030000002^PZ@0[X:T01T0[X:T00<000000?NmR@3g
_HT0=@3g_HT00`000000Z3l00:Po000A0:Po00030000003oool0oooo04<0oooo0`0000070?ooo`03
0000003oool0oooo02X0oooo000O0?ooo`030000003oool0oooo07D0oooo9`000000102LEWX00000
00000000003o0:j2Y2/0[X:T00<000000:j2Y02^PZ@06@2^PZ@00`000000mkf90?NmR@0f0?NmR@03
0000002X?`00Z3l00100Z3l000<000000?ooo`3oool0?`3oool4000000/0oooo00<000000?ooo`3o
ool0:@3oool001l0oooo00<000000?ooo`3oool0M03ooolZ00000?l0[X:T;@2^PZ@00`000000[X:T
0:j2Y00I0:j2Y0030000003g_HT0mkf903H0mkf900<000000:Po002X?`004@2X?`000`000000oooo
0?ooo`0k0?ooo`<000003`3oool00`000000oooo0?ooo`0Y0?ooo`007`3oool00`000000oooo0?oo
o`1d0?ooobT0000000<0[gfL0000000000000P00003o0:j2Y2T0[X:T00<000000:j2Y02^PZ@06@2^
PZ@00`000000mkf90?NmR@0g0?NmR@030000002X?`00Z3l00100Z3l000<000000?ooo`3oool0>03o
ool300000180oooo00<000000?ooo`3oool0:@3oool001l0oooo00<000000?ooo`3oool0L`3ooolV
000000050000FP000000000007ag``000000102_OI`400000?l0[X:T9@2^PZ@00`000000[X:T0:j2
Y00I0:j2Y0030000003g_HT0mkf903P0mkf900<000000:Po002X?`003`2X?`000`000000oooo0?oo
o`0e0?ooo`<000005@3oool00`000000oooo0?ooo`0Y0?ooo`007`3oool00`000000oooo0?ooo`1c
0?ooob@000000P0005X300000080O7O300<000000:mmW02_OI`01@2_OI`400000?l0[X:T8@2^PZ@0
0`000000[X:T0:j2Y00I0:j2Y0030000003g_HT0mkf903P0mkf900<000000:Po002X?`00402X?`00
0`000000oooo0?ooo`0a0?ooo`<00000603oool00`000000oooo0?ooo`0Y0?ooo`007P3oool00`00
0000oooo0?ooo`1c0?ooob@000000P0005X01@0000007QZ@0000001QHkd000000080O7O300<00000
0:mmW02_OI`0202_OI`400000?l0[X:T7@2^PZ@00`000000[X:T0:j2Y00I0:j2Y0030000003g_HT0
mkf903T0mkf900<000000:Po002X?`003`2X?`000`000000oooo0?ooo`0^0?ooo`<000006`3oool0
0`000000oooo0?ooo`0Y0?ooo`007P3oool00`000000oooo0?ooo`1c0?ooob800000100005X20000
0080HF>m00D0000007ag``1lMl<0O7O30000000=0:mmW0@00000o`2^PZ@I0:j2Y0030000002^PZ@0
[X:T01T0[X:T00<000000?NmR@3g_HT0>P3g_HT00`000000Z3l00:Po000?0:Po00030000003oool0
oooo02X0oooo0`00000N0?ooo`030000003oool0oooo02T0oooo000N0?ooo`030000003oool0oooo
0780oooo8@0000050000FP030000000N6Y0000000080HF>m00<0000007ag``1lMl<00P1lMl<00`00
0000[gfL0:mmW00>0:mmW0D00000o`2^PZ@D0:j2Y0030000002^PZ@0[X:T01X0[X:T00<000000?Nm
R@3g_HT0>@3g_HT00`000000Z3l00:Po000?0:Po00030000003oool0oooo02L0oooo0`00000Q0?oo
o`030000003oool0oooo02T0oooo000N0?ooo`030000003oool0oooo0740oooo800000060000FP04
0000000N6Y007QZ@00000080HF>m00<0000007ag``1lMl<00`1lMl<00`000000[gfL0:mmW00B0:mm
W0@00000o`2^PZ@@0:j2Y0030000002^PZ@0[X:T01X0[X:T00<000000?NmR@3g_HT0>P3g_HT00`00
0000Z3l00:Po000>0:Po00030000003oool0oooo02@0oooo0`00000U0?ooo`030000003oool0oooo
02P0oooo000N0?ooo`030000003oool0oooo0740oooo7`0000070000FP030000000N6Y00000000<0
HF>m00<0000007ag``1lMl<0101lMl<00`000000[gfL0:mmW00E0:mmW0@00000o`2^PZ@<0:j2Y003
0000002^PZ@0[X:T01X0[X:T00<000000?NmR@3g_HT0>P3g_HT00`000000Z3l00:Po000?0:Po0003
0000003oool0oooo01l0oooo1000000X0?ooo`030000003oool0oooo02P0oooo000N0?ooo`030000
003oool0oooo0700oooo7P0000080000FP040000000N6Y007QZ@000000<0HF>m00<0000007ag``1l
Ml<01@1lMl<00`000000[gfL0:mmW00H0:mmW0@00000o`2^PZ@80:j2Y0030000002^PZ@0[X:T01X0
[X:T00<000000?NmR@3g_HT0>`3g_HT00`000000Z3l00:Po000>0:Po00030000003oool0oooo01`0
oooo0`00000/0?ooo`030000003oool0oooo02P0oooo000N0?ooo`030000003oool0oooo0700oooo
700000090000FP050000000N6Y007QZ@01hJT00000000`1QHkd00`000000O7O307ag``0607ag``03
0000002_OI`0[gfL01/0[gfL1000003o0:j2Y0@0[X:T00<000000:j2Y02^PZ@06P2^PZ@00`000000
mkf90?NmR@0l0?NmR@030000002X?`00Z3l000h0Z3l000<000000?ooo`3oool0603oool3000002l0
oooo00<000000?ooo`3oool0:03oool001d0oooo00<000000?ooo`3oool0L03ooolL000000X0001J
00@0000001hJT00N6Y0000001@1QHkd00`000000O7O307ag``0607ag``030000002_OI`0[gfL01h0
[gfL1@00003n0:j2Y0030000002^PZ@0[X:T01X0[X:T00<000000?NmR@3g_HT0?03g_HT00`000000
Z3l00:Po000>0:Po00030000003oool0oooo01D0oooo0`00000b0?ooo`030000003oool0oooo02P0
oooo000M0?ooo`030000003oool0oooo0700oooo6P00000;0000FP050000000N6Y007QZ@01hJT000
00001@1QHkd00`000000O7O307ag``0707ag``030000002_OI`0[gfL0280[gfL1000003j0:j2Y003
0000002^PZ@0[X:T01X0[X:T00<000000?NmR@3g_HT0?@3g_HT00`000000Z3l00:Po000>0:Po0003
0000003oool0oooo0140oooo0`00000e0?ooo`030000003oool0oooo02P0oooo000M0?ooo`030000
003oool0oooo06l0oooo6@00000<0000FP030000000N6Y007QZ@00807QZ@00<00000065S_@1QHkd0
0`1QHkd00`000000O7O307ag``0807ag``030000002_OI`0[gfL02D0[gfL1000003g0:j2Y0030000
002^PZ@0[X:T01T0[X:T00<000000?NmR@3g_HT0?@3g_HT00`000000Z3l00:Po000>0:Po00030000
003oool0oooo00h0oooo0`00000h0?ooo`030000003oool0oooo02P0oooo000M0?ooo`030000003o
ool0oooo06h0oooo6000000>0000FP050000000N6Y007QZ@01hJT00000001P1QHkd00`000000O7O3
07ag``0907ag``030000002_OI`0[gfL02P0[gfL1000003c0:j2Y0030000002^PZ@0[X:T01T0[X:T
00<000000?NmR@3g_HT0?P3g_HT00`000000Z3l00:Po000=0:Po00030000003oool0oooo00/0oooo
0`00000k0?ooo`030000003oool0oooo02P0oooo000M0?ooo`030000003oool0oooo06h0oooo5`00
000>0000FP030000000N6Y007QZ@00807QZ@00<00000065S_@1QHkd0101QHkd00`000000O7O307ag
``0:07ag``030000002_OI`0[gfL02/0[gfL1000003_0:j2Y0030000002^PZ@0[X:T01T0[X:T00<0
00000?NmR@3g_HT0?`3g_HT00`000000Z3l00:Po000=0:Po00030000003oool0oooo00L0oooo0`00
000o0?ooo`030000003oool0oooo02L0oooo000M0?ooo`030000003oool0oooo06d0oooo5P00000@
0000FP030000000N6Y007QZ@00807QZ@00<00000065S_@1QHkd0101QHkd00`000000O7O307ag``0;
07ag``030000002_OI`0[gfL02h0[gfL1000003[0:j2Y0030000002^PZ@0[X:T01T0[X:T00<00000
0?NmR@3g_HT0?`3g_HT00`000000Z3l00:Po000=0:Po00030000003oool0oooo00<0oooo10000012
0?ooo`030000003oool0oooo02L0oooo000L0?ooo`030000003oool0oooo06h0oooo5000000A0000
FP030000000N6Y007QZ@00807QZ@00<00000065S_@1QHkd01@1QHkd00`000000O7O307ag``0<07ag
``030000002_OI`0[gfL0340[gfL1@00003V0:j2Y0030000002^PZ@0[X:T01T0[X:T00<000000?Nm
R@3g_HT0@03g_HT00`000000Z3l00:Po000=0:Po00030000003oool0000000800000AP3oool00`00
0000oooo0?ooo`0W0?ooo`00703oool00`000000oooo0?ooo`1]0?oooa@000004@0005X00`000000
7QZ@01hJT00301hJT0030000001QHkd0HF>m00H0HF>m00<0000007ag``1lMl<0301lMl<00`000000
[gfL0:mmW00e0:mmW0@00000hP2^PZ@00`000000[X:T0:j2Y00I0:j2Y0030000003g_HT0mkf90400
mkf900<000000:Po002X?`003@2X?`02000004T0oooo00<000000?ooo`3oool09`3oool001`0oooo
00<000000?ooo`3oool0K@3ooolB000001<0001J00<0000001hJT00N6Y000P0N6Y000`000000HF>m
065S_@07065S_@030000001lMl<0O7O300`0O7O300<000000:mmW02_OI`0>@2_OI`400000=h0[X:T
00<000000:j2Y02^PZ@06@2^PZ@00`000000mkf90?NmR@110?NmR@030000002X?`00Z3l000`0Z3l0
00<000000?ooo`3oool0B03oool00`000000oooo0?ooo`0W0?ooo`00703oool00`000000oooo0?oo
o`1/0?oooa400000500005X00`0000007QZ@01hJT00301hJT0030000001QHkd0HF>m00L0HF>m00<0
000007ag``1lMl<03@1lMl<00`000000[gfL0:mmW00l0:mmW0@00000fP2^PZ@00`000000[X:T0:j2
Y00I0:j2Y0030000003g_HT0mkf90480mkf900<000000:Po002X?`00302X?`000`000000oooo0?oo
o`170?ooo`030000003oool0oooo02L0oooo000L0?ooo`030000003oool0oooo06/0oooo4@00000D
0000FP030000000N6Y007QZ@00@07QZ@00<00000065S_@1QHkd01`1QHkd00`000000O7O307ag``0>
07ag``030000002_OI`0[gfL03l0[gfL1000003F0:j2Y0030000002^PZ@0[X:T01T0[X:T00<00000
0?NmR@3g_HT0@P3g_HT00`000000Z3l00:Po000<0:Po00030000003oool0oooo04L0oooo00<00000
0?ooo`3oool09`3oool001`0oooo00<000000?ooo`3oool0J`3oool?000001H0001J00<0000001hJ
T00N6Y000`0N6Y000`000000HF>m065S_@08065S_@030000001lMl<0O7O300l0O7O300<000000:mm
W02_OI`0@P2_OI`400000=80[X:T00<000000:j2Y02^PZ@06@2^PZ@00`000000mkf90?NmR@130?Nm
R@030000002X?`00Z3l000`0Z3l000<000000?ooo`3oool0AP3oool00`000000oooo0?ooo`0W0?oo
o`00703oool00`000000oooo0?ooo`1Z0?ooo`h000005`0005X00`0000007QZ@01hJT00401hJT003
0000001QHkd0HF>m00P0HF>m00<0000007ag``1lMl<0401lMl<00`000000[gfL0:mmW0150:mmW0D0
0000c@2^PZ@00`000000[X:T0:j2Y00I0:j2Y0030000003g_HT0mkf904@0mkf900<000000:Po002X
?`002`2X?`000`000000oooo0?ooo`170?ooo`030000003oool0oooo02H0oooo000K0?ooo`030000
003oool0oooo06/0oooo3000000H0000FP030000000N6Y007QZ@00D07QZ@00<00000065S_@1QHkd0
201QHkd00`000000O7O307ag``0A07ag``030000002_OI`0[gfL04T0[gfL100000390:j2Y0030000
002^PZ@0[X:T01T0[X:T00<000000?NmR@3g_HT0A03g_HT00`000000Z3l00:Po000<0:Po00030000
003oool0oooo04H0oooo00<000000?ooo`3oool09P3oool001/0oooo00<000000?ooo`3oool0JP3o
ool<000001T0001J00<0000001hJT00N6Y00100N6Y000`000000HF>m065S_@0:065S_@030000001l
Ml<0O7O30140O7O300<000000:mmW02_OI`0C02_OI`400000<D0[X:T00<000000:j2Y02^PZ@06@2^
PZ@00`000000mkf90?NmR@150?NmR@030000002X?`00Z3l000/0Z3l000<000000?ooo`3oool0AP3o
ool00`000000oooo0?ooo`0V0?ooo`006`3oool00`000000oooo0?ooo`1Z0?ooo`X000006P0005X0
0`0000007QZ@01hJT00501hJT0030000001QHkd0HF>m00X0HF>m00<0000007ag``1lMl<04P1lMl<0
0`000000[gfL0:mmW01?0:mmW0@00000`@2^PZ@00`000000[X:T0:j2Y00I0:j2Y0030000003g_HT0
mkf904D0mkf900<000000:Po002X?`002`2X?`000`000000oooo0?ooo`160?ooo`030000003oool0
oooo02H0oooo000K0?ooo`030000003oool0oooo06T0oooo2@00000K0000FP030000000N6Y007QZ@
00H07QZ@00<00000065S_@1QHkd02P1QHkd00`000000O7O307ag``0C07ag``030000002_OI`0[gfL
0580[gfL1000002m0:j2Y0030000002^PZ@0[X:T01T0[X:T00<000000?NmR@3g_HT0AP3g_HT00`00
0000Z3l00:Po000;0:Po00030000003oool0oooo04D0oooo00<000000?ooo`3oool09P3oool001/0
oooo00<000000?ooo`3oool0J03oool9000001`0001J00<0000001hJT00N6Y001@0N6Y000`000000
HF>m065S_@0;065S_@030000001lMl<0O7O301@0O7O300<000000:mmW02_OI`0E@2_OI`400000;T0
[X:T00<000000:j2Y02^PZ@06@2^PZ@00`000000mkf90?NmR@170?NmR@030000002X?`00Z3l000X0
Z3l000<000000?ooo`3oool0A@3oool00`000000oooo0?ooo`0V0?ooo`006`3oool00`000000oooo
0?ooo`1X0?ooo`L000007@0005X00`0000007QZ@01hJT00601hJT0030000001QHkd0HF>m00/0HF>m
00<0000007ag``1lMl<05@1lMl<00`000000[gfL0:mmW01H0:mmW0D00000]02^PZ@00`000000[X:T
0:j2Y00I0:j2Y0030000003g_HT0mkf904L0mkf900<000000:Po002X?`002`2X?`000`000000oooo
0?ooo`140?ooo`030000003oool0oooo02H0oooo000J0?ooo`030000003oool0oooo06P0oooo1P00
000N0000FP030000000N6Y007QZ@00L07QZ@00<00000065S_@1QHkd02`1QHkd00`000000O7O307ag
``0F07ag``030000002_OI`0[gfL05`0[gfL1000002`0:j2Y0030000002^PZ@0[X:T01T0[X:T00<0
00000?NmR@3g_HT0B03g_HT00`000000Z3l00:Po000:0:Po00030000003oool0oooo04D0oooo00<0
00000?ooo`3oool09@3oool001X0oooo00<000000?ooo`3oool0J03oool400000200001J00<00000
01hJT00N6Y001P0N6Y000`000000HF>m065S_@0<065S_@030000001lMl<0O7O301L0O7O300<00000
0:mmW02_OI`0G`2_OI`400000:`0[X:T00<000000:j2Y02^PZ@06@2^PZ@00`000000mkf90?NmR@18
0?NmR@030000002X?`00Z3l000X0Z3l000<000000?ooo`3oool0A@3oool00`000000oooo0?ooo`0U
0?ooo`006P3oool00`000000oooo0?ooo`1W0?ooo`@00000800005X00`0000007QZ@01hJT00701hJ
T0030000001QHkd0HF>m00d0HF>m00<0000007ag``1lMl<05`1lMl<00`000000[gfL0:mmW01R0:mm
W0@00000Z02^PZ@00`000000[X:T0:j2Y00I0:j2Y0030000003g_HT0mkf904T0mkf900<000000:Po
002X?`002P2X?`000`000000oooo0?ooo`140?ooo`030000003oool0oooo02D0oooo000J0?ooo`03
0000003oool0oooo06L0oooo0P00000Q0000FP030000000N6Y007QZ@00P07QZ@00<00000065S_@1Q
Hkd03@1QHkd00`000000O7O307ag``0H07ag``030000002_OI`0[gfL06D0[gfL1000002T0:j2Y003
0000002^PZ@0[X:T01T0[X:T00<000000?NmR@3g_HT0BP3g_HT00`000000Z3l00:Po00090:Po0003
0000003oool0oooo04@0oooo00<000000?ooo`3oool09@3oool001X0oooo00<000000?ooo`3oool0
IP3oool00`000000001J0000FP0Q0000FP030000000N6Y007QZ@00L07QZ@00<00000065S_@1QHkd0
3P1QHkd00`000000O7O307ag``0I07ag``030000002_OI`0[gfL06P0[gfL1@00002O0:j2Y0030000
002^PZ@0[X:T01T0[X:T00<000000?NmR@3g_HT0BP3g_HT00`000000Z3l00:Po000:0:Po00030000
003oool0oooo04<0oooo00<000000?ooo`3oool09@3oool001X0oooo00<000000?ooo`3oool0IP3o
ool00`000000001J0000FP0P0000FP030000000N6Y007QZ@00P07QZ@00<00000065S_@1QHkd03P1Q
Hkd00`000000O7O307ag``0J07ag``030000002_OI`0[gfL06`0[gfL1000002L0:j2Y0030000002^
PZ@0[X:T01P0[X:T00<000000?NmR@3g_HT0B`3g_HT00`000000Z3l00:Po00090:Po00030000003o
ool0oooo04<0oooo00<000000?ooo`3oool09@3oool001X0oooo00<000000?ooo`3oool0IP3oool0
0`000000001J0000FP0O0000FP030000000N6Y007QZ@00T07QZ@00<00000065S_@1QHkd03P1QHkd0
0`000000O7O307ag``0K07ag``030000002_OI`0[gfL06l0[gfL1000002H0:j2Y0030000002^PZ@0
[X:T01T0[X:T00<000000?NmR@3g_HT0BP3g_HT00`000000Z3l00:Po000:0:Po00030000003oool0
oooo0480oooo00<000000?ooo`3oool09@3oool001T0oooo00<000000?ooo`3oool0I`3oool00`00
0000001J0000FP0O0000FP030000000N6Y007QZ@00P07QZ@00<00000065S_@1QHkd03`1QHkd00`00
0000O7O307ag``0L07ag``030000002_OI`0[gfL0780[gfL1000002D0:j2Y0030000002^PZ@0[X:T
01T0[X:T00<000000?NmR@3g_HT0B`3g_HT00`000000Z3l00:Po00090:Po00030000003oool0oooo
0480oooo00<000000?ooo`3oool09@3oool001T0oooo00<000000?ooo`3oool0I`3oool00`000000
001J0000FP0N0000FP030000000N6Y007QZ@00T07QZ@00<00000065S_@1QHkd03`1QHkd00`000000
O7O307ag``0M07ag``030000002_OI`0[gfL07D0[gfL1000002@0:j2Y0030000002^PZ@0[X:T01T0
[X:T00<000000?NmR@3g_HT0C03g_HT00`000000Z3l00:Po00080:Po00030000003oool0oooo04<0
oooo00<000000?ooo`3oool0903oool001T0oooo00<000000?ooo`3oool0I`3oool00`000000001J
0000FP0M0000FP030000000N6Y007QZ@00X07QZ@00<00000065S_@1QHkd0401QHkd00`000000O7O3
07ag``0M07ag``030000002_OI`0[gfL07P0[gfL1000002<0:j2Y0030000002^PZ@0[X:T01T0[X:T
00<000000?NmR@3g_HT0C03g_HT00`000000Z3l00:Po00090:Po00030000003oool0oooo0480oooo
00<000000?ooo`3oool0903oool001T0oooo00<000000?ooo`3oool0I`3oool00`000000001J0000
FP0M0000FP030000000N6Y007QZ@00T07QZ@00<00000065S_@1QHkd04@1QHkd00`000000O7O307ag
``0N07ag``030000002_OI`0[gfL07/0[gfL1@0000270:j2Y0030000002^PZ@0[X:T01T0[X:T00<0
00000?NmR@3g_HT0C@3g_HT00`000000Z3l00:Po00080:Po00030000003oool0oooo0480oooo00<0
00000?ooo`3oool0903oool001T0oooo00<000000?ooo`3oool0I`3oool00`000000001J0000FP0L
0000FP030000000N6Y007QZ@00X07QZ@00<00000065S_@1QHkd04@1QHkd00`000000O7O307ag``0O
07ag``030000002_OI`0[gfL07l0[gfL100000230:j2Y0030000002^PZ@0[X:T01T0[X:T00<00000
0?NmR@3g_HT0CP3g_HT00`000000Z3l00:Po00080:Po00030000003oool0oooo0440oooo00<00000
0?ooo`3oool0903oool001T0oooo00<000000?ooo`3oool0I`3oool00`000000001J0000FP0K0000
FP030000000N6Y007QZ@00/07QZ@00<00000065S_@1QHkd04@1QHkd00`000000O7O307ag``0P07ag
``030000002_OI`0[gfL0880[gfL1000001o0:j2Y0030000002^PZ@0[X:T01T0[X:T00<000000?Nm
R@3g_HT0CP3g_HT00`000000Z3l00:Po00080:Po00030000003oool0oooo0440oooo00<000000?oo
o`3oool0903oool001T0oooo00<000000?ooo`3oool0I`3oool00`000000001J0000FP0K0000FP03
0000000N6Y007QZ@00X07QZ@00<00000065S_@1QHkd04P1QHkd00`000000O7O307ag``0Q07ag``03
0000002_OI`0[gfL08D0[gfL1000001k0:j2Y0030000002^PZ@0[X:T01T0[X:T00<000000?NmR@3g
_HT0C`3g_HT00`000000Z3l00:Po00080:Po00030000003oool0oooo0400oooo00<000000?ooo`3o
ool0903oool001P0oooo00<000000?ooo`3oool0J03oool00`000000001J0000FP0J0000FP030000
000N6Y007QZ@00/07QZ@00<00000065S_@1QHkd04P1QHkd00`000000O7O307ag``0R07ag``030000
002_OI`0[gfL08P0[gfL1000001g0:j2Y0030000002^PZ@0[X:T01T0[X:T00<000000?NmR@3g_HT0
C`3g_HT00`000000Z3l00:Po00080:Po00030000003oool0oooo0400oooo00<000000?ooo`3oool0
903oool001P0oooo00<000000?ooo`3oool0J03oool00`000000001J0000FP0I0000FP030000000N
6Y007QZ@00`07QZ@00<00000065S_@1QHkd04P1QHkd00`000000O7O307ag``0S07ag``030000002_
OI`0[gfL08/0[gfL1000001b0:j2Y08000006`2^PZ@00`000000mkf90?NmR@1@0?NmR@030000002X
?`00Z3l000L0Z3l000<000000?ooo`3oool0@03oool00`000000oooo0?ooo`0T0?ooo`00603oool0
0`000000oooo0?ooo`1X0?ooo`030000000005X0001J01T0001J00<0000001hJT00N6Y002`0N6Y00
0`000000HF>m065S_@0D065S_@030000001lMl<0O7O302<0O7O300<000000:mmW02_OI`0SP2_OI`5
000006X0[X:T0`0000020:j2Y0030000002^PZ@0[X:T01P0[X:T00<000000?NmR@3g_HT0D@3g_HT0
0`000000Z3l00:Po00070:Po00030000003oool0oooo0400oooo00<000000?ooo`3oool08`3oool0
01P0oooo00<000000?ooo`3oool0J03oool00`000000001J0000FP0H0000FP030000000N6Y007QZ@
00`07QZ@00<00000065S_@1QHkd0501QHkd00`000000O7O307ag``0T07ag``030000002_OI`0[gfL
0980[gfL1000001S0:j2Y0<000001P2^PZ@00`000000[X:T0:j2Y00G0:j2Y0030000003g_HT0mkf9
0540mkf900<000000:Po002X?`001`2X?`000`000000oooo0?ooo`100?ooo`030000003oool0oooo
02<0oooo000H0?ooo`030000003oool0oooo06P0oooo00<000000000FP0005X0600005X00`000000
7QZ@01hJT00<01hJT0030000001QHkd0HF>m01@0HF>m00<0000007ag``1lMl<09@1lMl<00`000000
[gfL0:mmW02E0:mmW0@00000G02^PZ@3000000T0[X:T00<000000:j2Y02^PZ@05`2^PZ@00`000000
mkf90?NmR@1B0?NmR@030000002X?`00Z3l000L0Z3l000<000000?ooo`3oool0?`3oool00`000000
oooo0?ooo`0S0?ooo`00603oool00`000000oooo0?ooo`1X0?ooo`030000000005X0001J01L0001J
00<0000001hJT00N6Y00300N6Y000`000000HF>m065S_@0E065S_@030000001lMl<0O7O302H0O7O3
00<000000:mmW02_OI`0V02_OI`4000005D0[X:T0`00000=0:j2Y0030000002^PZ@0[X:T01H0[X:T
00<000000?NmR@3g_HT0DP3g_HT00`000000Z3l00:Po00070:Po00030000003oool0oooo03l0oooo
00<000000?ooo`3oool08`3oool001L0oooo00<000000?ooo`3oool0J@3oool00`000000001J0000
FP0F0000FP030000000N6Y007QZ@00d07QZ@00<00000065S_@1QHkd05@1QHkd00`000000O7O307ag
``0W07ag``030000002_OI`0[gfL09/0[gfL1000001=0:j2Y0@000004@2^PZ@00`000000[X:T0:j2
Y00E0:j2Y0030000003g_HT0mkf905<0mkf900<000000:Po002X?`001P2X?`000`000000oooo0?oo
o`0o0?ooo`030000003oool0oooo02<0oooo000G0?ooo`030000003oool0oooo06T0oooo00<00000
0000FP0005X05P0005X00`0000007QZ@01hJT00<01hJT0030000001QHkd0HF>m01H0HF>m00<00000
07ag``1lMl<0:01lMl<00`000000[gfL0:mmW02N0:mmW0D00000A@2^PZ@3000001H0[X:T00<00000
0:j2Y02^PZ@0502^PZ@00`000000mkf90?NmR@1D0?NmR@030000002X?`00Z3l000H0Z3l000<00000
0?ooo`3oool0?P3oool00`000000oooo0?ooo`0S0?ooo`005`3oool00`000000oooo0?ooo`1Y0?oo
o`030000000005X0001J01D0001J00<0000001hJT00N6Y003@0N6Y000`000000HF>m065S_@0F065S
_@030000001lMl<0O7O302T0O7O300<000000:mmW02_OI`0XP2_OI`4000003h0[X:T0`00000J0:j2
Y0030000002^PZ@0[X:T01<0[X:T00<000000?NmR@3g_HT0E03g_HT00`000000Z3l00:Po00060:Po
00030000003oool0oooo03h0oooo00<000000?ooo`3oool08`3oool001L0oooo00<000000?ooo`3o
ool0J@3oool00`000000001J0000FP0D0000FP030000000N6Y007QZ@00h07QZ@00<00000065S_@1Q
Hkd05`1QHkd00`000000O7O307ag``0Y07ag``030000002_OI`0[gfL0:D0[gfL1000000g0:j2Y0<0
00007@2^PZ@00`000000[X:T0:j2Y00C0:j2Y0030000003g_HT0mkf905D0mkf900<000000:Po002X
?`001P2X?`000`000000oooo0?ooo`0n0?ooo`030000003oool0oooo0280oooo000G0?ooo`030000
003oool0oooo06T0oooo00<000000000FP0005X0500005X00`0000007QZ@01hJT00=01hJT0030000
001QHkd0HF>m01P0HF>m00<0000007ag``1lMl<0:P1lMl<00`000000[gfL0:mmW02X0:mmW0@00000
<02^PZ@300000240[X:T00<000000:j2Y02^PZ@04P2^PZ@00`000000mkf90?NmR@1E0?NmR@030000
002X?`00Z3l000H0Z3l000<000000?ooo`3oool0?P3oool00`000000oooo0?ooo`0R0?ooo`005`3o
ool00`000000oooo0?ooo`1Y0?ooo`030000000005X0001J01<0001J00<0000001hJT00N6Y003P0N
6Y000`000000HF>m065S_@0H065S_@030000001lMl<0O7O302/0O7O300<000000:mmW02_OI`0Z`2_
OI`4000002T0[X:T0`00000U0:j2Y0030000002^PZ@0[X:T0140[X:T00<000000?NmR@3g_HT0EP3g
_HT00`000000Z3l00:Po00060:Po00030000003oool0oooo03d0oooo00<000000?ooo`3oool08P3o
ool001L0oooo00<000000?ooo`3oool0J@3oool00`000000001J0000FP0B0000FP030000000N6Y00
7QZ@00l07QZ@00<00000065S_@1QHkd0601QHkd00`000000O7O307ag``0[07ag``030000002_OI`0
[gfL0:l0[gfL1000000R0:j2Y0<00000:@2^PZ@00`000000[X:T0:j2Y00@0:j2Y0030000003g_HT0
mkf905L0mkf900<000000:Po002X?`001@2X?`000`000000oooo0?ooo`0m0?ooo`030000003oool0
oooo0280oooo000F0?ooo`030000003oool0oooo06X0oooo00<000000000FP0005X04P0005X00`00
00007QZ@01hJT00>01hJT0030000001QHkd0HF>m01T0HF>m00<0000007ag``1lMl<0;01lMl<00`00
0000[gfL0:mmW02b0:mmW0D000006P2^PZ@3000002d0[X:T00<000000:j2Y02^PZ@03`2^PZ@00`00
0000mkf90?NmR@1G0?NmR@030000002X?`00Z3l000D0Z3l000<000000?ooo`3oool0?@3oool00`00
0000oooo0?ooo`0R0?ooo`005P3oool00`000000oooo0?ooo`1Z0?ooo`030000000005X0001J0140
001J00<0000001hJT00N6Y003`0N6Y000`000000HF>m065S_@0I065S_@030000001lMl<0O7O302d0
O7O300<000000:mmW02_OI`0]P2_OI`4000001<0[X:T0`00000`0:j2Y0030000002^PZ@0[X:T00l0
[X:T00<000000?NmR@3g_HT0F03g_HT00`000000Z3l00:Po00050:Po00030000003oool0oooo03`0
oooo00<000000?ooo`3oool08P3oool001H0oooo00<000000?ooo`3oool0JP3oool00`000000001J
0000FP0@0000FP030000000N6Y007QZ@01007QZ@00<00000065S_@1QHkd06@1QHkd00`000000O7O3
07ag``0^07ag``030000002_OI`0[gfL0;T0[gfL1000000;0:j2Y0@00000=02^PZ@00`000000[X:T
0:j2Y00>0:j2Y0030000003g_HT0mkf905T0mkf900<000000:Po002X?`00102X?`000`000000oooo
0?ooo`0l0?ooo`030000003oool0oooo0280oooo000F0?ooo`030000003oool0oooo06X0oooo00<0
00000000FP0005X0400005X00`0000007QZ@01hJT00?01hJT0030000001QHkd0HF>m01X0HF>m00<0
000007ag``1lMl<0;`1lMl<00`000000[gfL0:mmW02l0:mmW0@00000102^PZ@3000003T0[X:T00<0
00000:j2Y02^PZ@03@2^PZ@00`000000mkf90?NmR@1I0?NmR@030000002X?`00Z3l000D0Z3l000<0
00000?ooo`3oool0>`3oool00`000000oooo0?ooo`0R0?ooo`005P3oool00`000000oooo0?ooo`1Z
0?ooo`030000000005X0001J00l0001J00<0000001hJT00N6Y00400N6Y000`000000HF>m065S_@0K
065S_@030000001lMl<0O7O302l0O7O300<000000:mmW02_OI`0_`2_OI`4000003d0[X:T00<00000
0:j2Y02^PZ@0302^PZ@00`000000mkf90?NmR@1J0?NmR@030000002X?`00Z3l000@0Z3l000<00000
0?ooo`3oool0?03oool00`000000oooo0?ooo`0Q0?ooo`005P3oool00`000000oooo0?ooo`1Y0?oo
o`030000000005X0001J00l0001J00<0000001hJT00N6Y004@0N6Y000`000000HF>m065S_@0K065S
_@030000001lMl<0O7O30300O7O300<000000:mmW02_OI`0_02_OI`3000000<0[gfL1000000j0:j2
Y0030000002^PZ@0[X:T00/0[X:T00<000000?NmR@3g_HT0FP3g_HT00`000000Z3l00:Po00040:Po
00030000003oool0oooo03`0oooo00<000000?ooo`3oool08@3oool001D0oooo00<000000?ooo`3o
ool0JP3oool00`000000001J0000FP0?0000FP030000000N6Y007QZ@01007QZ@00<00000065S_@1Q
Hkd0701QHkd00`000000O7O307ag``0a07ag``030000002_OI`0[gfL0;P0[gfL0`00000:0:mmW0D0
0000=@2^PZ@00`000000[X:T0:j2Y00;0:j2Y0030000003g_HT0mkf905/0mkf900<000000:Po002X
?`00102X?`000`000000oooo0?ooo`0k0?ooo`030000003oool0oooo0240oooo000E0?ooo`030000
003oool0oooo06X0oooo00<000000000FP0005X03P0005X00`0000007QZ@01hJT00A01hJT0030000
001QHkd0HF>m01`0HF>m00<0000007ag``1lMl<0<P1lMl<00`000000[gfL0:mmW02d0:mmW0<00000
4P2_OI`400000380[X:T00<000000:j2Y02^PZ@02P2^PZ@00`000000mkf90?NmR@1L0?NmR@030000
002X?`00Z3l000<0Z3l000<000000?ooo`3oool0>`3oool00`000000oooo0?ooo`0Q0?ooo`005@3o
ool00`000000oooo0?ooo`1Z0?ooo`030000000005X0001J00d0001J00<0000001hJT00N6Y004P0N
6Y000`000000HF>m065S_@0L065S_@030000001lMl<0O7O303<0O7O300<000000:mmW02_OI`0/02_
OI`3000001T0[gfL1000000_0:j2Y0030000002^PZ@0[X:T00T0[X:T00<000000?NmR@3g_HT0G03g
_HT00`000000Z3l00:Po00040:Po00030000003oool0oooo03X0oooo00<000000?ooo`3oool08@3o
ool001D0oooo00<000000?ooo`3oool0JP3oool00`000000001J0000FP0=0000FP030000000N6Y00
7QZ@01407QZ@00<00000065S_@1QHkd07@1QHkd00`000000O7O307ag``0d07ag``030000002_OI`0
[gfL0:`0[gfL0`00000P0:mmW0@00000;02^PZ@00`000000[X:T0:j2Y0090:j2Y0030000003g_HT0
mkf905`0mkf900<000000:Po002X?`000`2X?`000`000000oooo0?ooo`0j0?ooo`030000003oool0
oooo0240oooo000E0?ooo`030000003oool0oooo06X0oooo00<000000000FP0005X0300005X00`00
00007QZ@01hJT00B01hJT0030000001QHkd0HF>m01d0HF>m00<0000007ag``1lMl<0=@1lMl<00`00
0000[gfL0:mmW02X0:mmW0<000009`2_OI`4000002T0[X:T00<000000:j2Y02^PZ@0202^PZ@00`00
0000mkf90?NmR@1L0?NmR@030000002X?`00Z3l000@0Z3l000<000000?ooo`3oool0>@3oool00`00
0000oooo0?ooo`0Q0?ooo`005@3oool00`000000oooo0?ooo`1Z0?ooo`030000000005X0001J00/0
001J00<0000001hJT00N6Y004`0N6Y000`000000HF>m065S_@0N065S_@030000001lMl<0O7O303D0
O7O300<000000:mmW02_OI`0X`2_OI`4000002h0[gfL1000000U0:j2Y0030000002^PZ@0[X:T00P0
[X:T00<000000?NmR@3g_HT0G@3g_HT00`000000Z3l00:Po00030:Po00030000003oool0oooo03T0
oooo00<000000?ooo`3oool08@3oool001D0oooo00<000000?ooo`3oool0JP3oool00`000000001J
0000FP0;0000FP030000000N6Y007QZ@01807QZ@00<00000065S_@1QHkd07`1QHkd00`000000O7O3
07ag``0f07ag``030000002_OI`0[gfL09l0[gfL0`00000f0:mmW0D000008@2^PZ@00`000000[X:T
0:j2Y0070:j2Y0030000003g_HT0mkf905h0mkf900<000000:Po002X?`000P2X?`000`000000oooo
0?ooo`0j0?ooo`030000003oool0oooo0200oooo000D0?ooo`030000003oool0oooo06/0oooo00<0
00000000FP0005X02P0005X00`0000007QZ@01hJT00C01hJT0030000001QHkd0HF>m01l0HF>m00<0
000007ag``1lMl<0=`1lMl<00`000000[gfL0:mmW02K0:mmW0<00000?P2_OI`4000001h0[X:T00<0
00000:j2Y02^PZ@01P2^PZ@00`000000mkf90?NmR@1N0?NmR@030000002X?`00Z3l000<0Z3l000<0
00000?ooo`3oool0>@3oool00`000000oooo0?ooo`0P0?ooo`00503oool00`000000oooo0?ooo`1[
0?ooo`030000000005X0001J00T0001J00<0000001hJT00N6Y00500N6Y000`000000HF>m065S_@0O
065S_@030000001lMl<0O7O303P0O7O300<000000:mmW02_OI`0U`2_OI`3000004D0[gfL1000000K
0:j2Y0030000002^PZ@0[X:T00D0[X:T00<000000?NmR@3g_HT0G`3g_HT00`000000Z3l00:Po0002
0:Po00030000003oool0oooo03T0oooo00<000000?ooo`3oool0803oool001@0oooo00<000000?oo
o`3oool0J`3oool00`000000001J0000FP090000FP030000000N6Y007QZ@01<07QZ@00<00000065S
_@1QHkd0801QHkd00`000000O7O307ag``0i07ag``030000002_OI`0[gfL09<0[gfL0`00001<0:mm
W0@00000602^PZ@00`000000[X:T0:j2Y0040:j2Y0030000003g_HT0mkf905l0mkf900<000000:Po
002X?`000`2X?`000`000000oooo0?ooo`0h0?ooo`030000003oool0oooo0200oooo000D0?ooo`03
0000003oool0oooo06/0oooo00<000000000FP0005X0200005X00`0000007QZ@01hJT00D01hJT003
0000001QHkd0HF>m0200HF>m00<0000007ag``1lMl<0>P1lMl<00`000000[gfL0:mmW02?0:mmW0<0
0000D`2_OI`4000001@0[X:T00<000000:j2Y02^PZ@0102^PZ@00`000000mkf90?NmR@1P0?NmR@03
0000002X?`00Z3l00080Z3l000<000000?ooo`3oool0>03oool00`000000oooo0?ooo`0P0?ooo`00
503oool00`000000oooo0?ooo`1[0?ooo`030000000005X0001J00L0001J00<0000001hJT00N6Y00
5@0N6Y000`000000HF>m065S_@0P065S_@030000001lMl<0O7O303/0O7O300<000000:mmW02_OI`0
R`2_OI`3000005X0[gfL1@00000@0:j2Y0030000002^PZ@0[X:T00<0[X:T00<000000?NmR@3g_HT0
H@3g_HT00`000000Z3l00:Po00020:Po00030000003oool0oooo03L0oooo00<000000?ooo`3oool0
803oool001@0oooo00<000000?ooo`3oool0J`3oool00`000000001J0000FP070000FP030000000N
6Y007QZ@01@07QZ@00<00000065S_@1QHkd08P1QHkd00`000000O7O307ag``0k07ag``030000002_
OI`0[gfL08L0[gfL0`00001R0:mmW0@000003@2^PZ@00`000000[X:T0:j2Y0020:j2Y0030000003g
_HT0mkf90640mkf900<000000:Po002X?`000P2X?`000`000000oooo0?ooo`0g0?ooo`030000003o
ool0oooo0200oooo000C0?ooo`030000003oool0oooo06`0oooo00<000000000FP0005X01P0005X0
0`0000007QZ@01hJT00E01hJT0030000001QHkd0HF>m0280HF>m00<0000007ag``1lMl<0?01lMl<0
0`000000[gfL0:mmW0230:mmW0<00000J@2_OI`4000000X0[X:T00D000000:j2Y02^PZ@0[X:T0000
001T0?NmR@050000002X?`00Z3l00:Po00000000>@3oool00`000000oooo0?ooo`0P0?ooo`004`3o
ool00`000000oooo0?ooo`1/0?ooo`030000000005X0001J00H0001J00<0000001hJT00N6Y005@0N
6Y000`000000HF>m065S_@0R065S_@030000001lMl<0O7O303d0O7O300<000000:mmW02_OI`0O`2_
OI`300000700[gfL100000070:j2Y0040000002^PZ@0[X:T000006D0mkf900D000000:Po002X?`00
Z3l00000000i0?ooo`030000003oool0oooo01l0oooo000C0?ooo`030000003oool0oooo06`0oooo
00<000000000FP0005X01@0005X00`0000007QZ@01hJT00E01hJT0030000001QHkd0HF>m02<0HF>m
00<0000007ag``1lMl<0?P1lMl<00`000000[gfL0:mmW01j0:mmW0@00000M`2_OI`4000000<0[X:T
00@000000:j2Y02^PZ@00000I@3g_HT01@000000Z3l00:Po002X?`00000003T0oooo00<000000?oo
o`3oool07`3oool001<0oooo00<000000?ooo`3oool0K03oool00`000000001J0000FP040000FP03
0000000N6Y007QZ@01H07QZ@00<00000065S_@1QHkd08`1QHkd00`000000O7O307ag``0o07ag``03
0000002_OI`0[gfL07H0[gfL0`00001o0:mmW0D0000000<0[X:T0000003g_HT0I@3g_HT01@000000
Z3l00:Po002X?`00000003P0oooo00<000000?ooo`3oool07`3oool001<0oooo00<000000?ooo`3o
ool0K03oool00`000000001J0000FP040000FP030000000N6Y007QZ@01H07QZ@00<00000065S_@1Q
Hkd08`1QHkd00`000000O7O307ag``1007ag``030000002_OI`0[gfL0780[gfL0`0000260:mmW0H0
0000H`3g_HT01@000000Z3l00:Po002X?`00000003P0oooo00<000000?ooo`3oool07`3oool001<0
oooo00<000000?ooo`3oool0K03oool00`000000001J0000FP030000FP030000000N6Y007QZ@01H0
7QZ@00<00000065S_@1QHkd0901QHkd00`000000O7O307ag``1107ag``030000002_OI`0[gfL06h0
[gfL0`0000270:mmW0<0000000<0`K_D0000000000000P3cYV`6000005h0mkf900@000000:Po002X
?`000000>03oool00`000000oooo0?ooo`0O0?ooo`004`3oool00`000000oooo0?ooo`1/0?ooo`03
0000000005X0001J0080001J00<0000001hJT00N6Y005`0N6Y000`000000HF>m065S_@0U065S_@03
0000001lMl<0O7O30440O7O300<000000:mmW02_OI`0JP2_OI`3000008P0[gfL0P0000040<6ke0@0
00001P3cYV`6000005T0mkf900@000000:Po002X?`000000=`3oool00`000000oooo0?ooo`0O0?oo
o`004P3oool00`000000oooo0?ooo`1]0?ooo`030000000005X0001J0080001J00<0000001hJT00N
6Y005`0N6Y000`000000HF>m065S_@0U065S_@030000001lMl<0O7O30480O7O300<000000:mmW02_
OI`0IP2_OI`3000008P0[gfL0`0000060<6ke08000000P3Hcm000`000000ljI/0?>VK0090?>VK0H0
0000D`3g_HT010000000Z3l00:Po0000000g0?ooo`030000003oool0oooo01l0oooo000B0?ooo`03
0000003oool0oooo06d0oooo00D000000000FP0005X0001J0000000I01hJT0030000001QHkd0HF>m
02H0HF>m00<0000007ag``1lMl<0@`1lMl<00`000000[gfL0:mmW01R0:mmW0<00000R02_OI`30000
00T0`K_D00<000000=S?d00000000P3Hcm000`000000ljI/0?>VK00>0?>VK0H00000CP3g_HT01000
0000Z3l00:Po0000000g0?ooo`030000003oool0oooo01h0oooo000B0?ooo`030000003oool0oooo
06d0oooo00@000000000FP0005X000006P0N6Y000`000000HF>m065S_@0V065S_@030000001lMl<0
O7O304@0O7O300<000000:mmW02_OI`0GP2_OI`3000008P0[gfL0`00000;0<6ke0050000003Hcm00
f<o@0=S?d00000000P3Hcm02000001@0ljI/1P0000180?NmR@040000002X?`00Z3l0000003L0oooo
00<000000?ooo`3oool07P3oool00180oooo00<000000?ooo`3oool0K@3oool010000000001J0000
FP00000I01hJT0030000001QHkd0HF>m02L0HF>m00<0000007ag``1lMl<0A@1lMl<00`000000[gfL
0:mmW01J0:mmW0<00000R02_OI`3000000h0`K_D00<000000=S?d03Hcm000P3Hcm001@000000f<o@
0=S?d03Hcm00000001T0ljI/1P0000130?NmR@040000002X?`00Z3l0000003H0oooo00<000000?oo
o`3oool07P3oool00180oooo00<000000?ooo`3oool0K@3oool00`000000001J0000000J01hJT003
0000001QHkd0HF>m02L0HF>m00<0000007ag``1lMl<0AP1lMl<00`000000[gfL0:mmW01E0:mmW0@0
0000R@2_OI`200000140`K_D00<000000=S?d03Hcm000`3Hcm001@000000f<o@0=S?d03Hcm000000
01h0ljI/1P00000n0?NmR@030000002X?`00000003H0oooo00<000000?ooo`3oool07P3oool00180
oooo00<000000?ooo`3oool0K@3oool2000001/07QZ@00<00000065S_@1QHkd09`1QHkd00`000000
O7O307ag``1707ag``030000002_OI`0[gfL0540[gfL0`00002:0:mmW0<000004`31^m@00`000000
f<o@0=S?d0030=S?d0030000003Hcm00f<o@0080f<o@0P00000R0?>VK0H00000>03g_HT00`000000
Z3l00000000f0?ooo`030000003oool0oooo01h0oooo000B0?ooo`030000003oool0oooo06d0oooo
0P00000J01hJT0030000001QHkd0HF>m02T0HF>m00<0000007ag``1lMl<0A`1lMl<00`000000[gfL
0:mmW01=0:mmW0<00000RP2_OI`3000001H0`K_D00<000000=S?d03Hcm00103Hcm000`000000f<o@
0=S?d0030=S?d0030000003cYV`0ljI/02D0ljI/1P00000c0?NmR@030000002X?`00000003D0oooo
00<000000?ooo`3oool07P3oool00140oooo00<000000?ooo`3oool0KP3oool00`0000007QZ@01hJ
T00I01hJT0030000001QHkd0HF>m02T0HF>m00<0000007ag``1lMl<0B01lMl<00`000000[gfL0:mm
W0190:mmW0<00000RP2_OI`3000001T0`K_D00<000000=S?d03Hcm001@3Hcm000`000000f<o@0=S?
d0030=S?d0030000003cYV`0ljI/02X0ljI/1P00000]0?NmR@030000002X?`00000003D0oooo00<0
00000?ooo`3oool07P3oool00140oooo00<000000?ooo`3oool0KP3oool00`0000007QZ@01hJT00I
01hJT0030000001QHkd0HF>m02T0HF>m00<0000007ag``1lMl<0B@1lMl<00`000000[gfL0:mmW015
0:mmW0<00000RP2_OI`3000001`0`K_D00<000000=S?d03Hcm001P3Hcm000`000000f<o@0=S?d003
0=S?d0800000<03cYV`6000002P0mkf900<000000:Po00000000=03oool00`000000oooo0?ooo`0N
0?ooo`004@3oool00`000000oooo0?ooo`1_0?ooo`030000000N6Y007QZ@01L07QZ@00<00000065S
_@1QHkd0:P1QHkd00`000000O7O307ag``1:07ag``030000002_OI`0[gfL0440[gfL0`00002;0:mm
W08000007`31^m@00`000000f<o@0=S?d0060=S?d0030000003Hcm00f<o@00D0f<o@00<000000?>V
K03cYV`0<`3cYV`6000002<0mkf90P00000e0?ooo`030000003oool0oooo01d0oooo000A0?ooo`03
0000003oool0oooo06l0oooo00<0000001hJT00N6Y005`0N6Y000`000000HF>m065S_@0Z065S_@03
0000001lMl<0O7O304X0O7O300<000000:mmW02_OI`0?P2_OI`3000008/0[gfL0`00000Q0<6ke003
0000003Hcm00f<o@00L0f<o@00<000000=S?d03Hcm001@3Hcm000`000000ljI/0?>VK00h0?>VK0H0
00007@3g_HT2000003D0oooo00<000000?ooo`3oool07@3oool00140oooo00<000000?ooo`3oool0
K`3oool00`0000007QZ@01hJT00G01hJT0030000001QHkd0HF>m02X0HF>m00<0000007ag``1lMl<0
B`1lMl<00`000000[gfL0:mmW00j0:mmW0<00000R`2_OI`3000002<0`K_D00<000000=S?d03Hcm00
2@3Hcm000`000000f<o@0=S?d0050=S?d0800000?P3cYV`6000001P0mkf90P00000d0?ooo`030000
003oool0oooo01d0oooo000A0?ooo`030000003oool0oooo06l0oooo00<0000001hJT00N6Y005P0N
6Y000`000000HF>m065S_@0[065S_@030000001lMl<0O7O304`0O7O300<000000:mmW02_OI`0=P2_
OI`3000008/0[gfL0`00000V0<6ke0030000003Hcm00f<o@00X0f<o@00<000000=S?d03Hcm001P3H
cm000`000000ljI/0?>VK0110?>VK0H000004`3g_HT00`000000oooo0?ooo`0b0?ooo`030000003o
ool0oooo01d0oooo000@0?ooo`030000003oool0oooo0740oooo00<0000001hJT00N6Y005@0N6Y00
0`000000HF>m065S_@0/065S_@030000001lMl<0O7O304`0O7O300<000000:mmW02_OI`0<@2_OI`4
000008/0[gfL0`00000Y0<6ke0030000003Hcm00f<o@00/0f<o@00<000000=S?d03Hcm001P3Hcm00
0`000000ljI/0?>VK0160?>VK0H000003@3g_HT2000003<0oooo00<000000?ooo`3oool07@3oool0
0100oooo00<000000?ooo`3oool0L@3oool00`0000007QZ@01hJT00E01hJT0030000001QHkd0HF>m
02`0HF>m00<0000007ag``1lMl<0C@1lMl<00`000000[gfL0:mmW00]0:mmW0<00000S@2_OI`20000
02`0`K_D00<000000=S?d03Hcm002`3Hcm000`000000f<o@0=S?d0070=S?d0800000C03cYV`60000
00P0mkf900<000000?ooo`3oool0<@3oool00`000000oooo0?ooo`0M0?ooo`00403oool00`000000
oooo0?ooo`1a0?ooo`030000000N6Y007QZ@01@07QZ@00<00000065S_@1QHkd0;@1QHkd00`000000
O7O307ag``1>07ag``030000002_OI`0[gfL02T0[gfL0`00002=0:mmW0<00000;P31^m@00`000000
f<o@0=S?d00<0=S?d0030000003Hcm00f<o@00P0f<o@00<000000?>VK03cYV`0C`3cYV`600000080
mkf90P00000b0?ooo`030000003oool0oooo01d0oooo000@0?ooo`030000003oool0oooo0780oooo
00<0000001hJT00N6Y004`0N6Y000`000000HF>m065S_@0]065S_@030000001lMl<0O7O304l0O7O3
00<000000:mmW02_OI`09@2_OI`3000008d0[gfL0`00000a0<6ke0030000003Hcm00f<o@00d0f<o@
00<000000=S?d03Hcm00203Hcm000`000000ljI/0?>VK01D0?>VK0@00000<P3oool00`000000oooo
0?ooo`0M0?ooo`00403oool00`000000oooo0?ooo`1b0?ooo`030000000N6Y007QZ@01<07QZ@00<0
0000065S_@1QHkd0;@1QHkd00`000000O7O307ag``1@07ag``030000002_OI`0[gfL0240[gfL0`00
002=0:mmW0<00000=031^m@00`000000f<o@0=S?d00>0=S?d0030000003Hcm00f<o@00P0f<o@0P00
001F0?>VK0800000<`3oool00`000000oooo0?ooo`0L0?ooo`00403oool00`000000oooo0?ooo`1b
0?ooo`030000000N6Y007QZ@01807QZ@00<00000065S_@1QHkd0;P1QHkd00`000000O7O307ag``1A
07ag``030000002_OI`0[gfL01d0[gfL0`00002=0:mmW0<00000=`31^m@00`000000f<o@0=S?d00?
0=S?d0030000003Hcm00f<o@00T0f<o@00<000000?>VK03cYV`0D`3cYV`00`000000oooo0?ooo`0b
0?ooo`030000003oool0oooo01`0oooo000@0?ooo`030000003oool0oooo07<0oooo00<0000001hJ
T00N6Y004@0N6Y000`000000HF>m065S_@0^065S_@030000001lMl<0O7O30580O7O300<000000:mm
W02_OI`06@2_OI`3000008h0[gfL0P00000j0<6ke0030000003Hcm00f<o@00l0f<o@00<000000=S?
d03Hcm002P3Hcm000`000000ljI/0?>VK01A0?>VK0800000=03oool00`000000oooo0?ooo`0L0?oo
o`003`3oool00`000000oooo0?ooo`1d0?ooo`030000000N6Y007QZ@01407QZ@00<00000065S_@1Q
Hkd0;`1QHkd00`000000O7O307ag``1B07ag``030000002_OI`0[gfL01D0[gfL0`00002>0:mmW0<0
0000>`31^m@00`000000f<o@0=S?d00A0=S?d0030000003Hcm00f<o@00X0f<o@0P00001@0?>VK080
0000=@3oool00`000000oooo0?ooo`0L0?ooo`003`3oool00`000000oooo0?ooo`1d0?ooo`030000
000N6Y007QZ@01007QZ@00<00000065S_@1QHkd0<01QHkd00`000000O7O307ag``1C07ag``030000
002_OI`0[gfL0140[gfL0`00002>0:mmW0<00000?P31^m@00`000000f<o@0=S?d00B0=S?d0030000
003Hcm00f<o@00/0f<o@00<000000?>VK03cYV`0C03cYV`00`000000lnJ50000000e0?ooo`030000
003oool0oooo01`0oooo000?0?ooo`030000003oool0oooo07@0oooo00<0000001hJT00N6Y00400N
6Y000`000000HF>m065S_@0`065S_@030000001lMl<0O7O305@0O7O300<000000:mmW02_OI`03@2_
OI`3000008h0[gfL0`0000110<6ke0030000003Hcm00f<o@01<0f<o@00<000000=S?d03Hcm002`3H
cm000`000000ljI/0?>VK01;0?>VK0030000003ciXD0000003D0oooo00<000000?ooo`3oool0703o
ool000l0oooo00<000000?ooo`3oool0M@3oool00`0000007QZ@01hJT00?01hJT0030000001QHkd0
HF>m0300HF>m00<0000007ag``1lMl<0E@1lMl<00`000000[gfL0:mmW0080:mmW0@00000SP2_OI`3
000004@0`K_D00<000000=S?d03Hcm00503Hcm000`000000f<o@0=S?d00;0=S?d0800000BP3cYV`0
0`000000lnJ50000000f0?ooo`030000003oool0oooo01`0oooo000?0?ooo`030000003oool0oooo
07D0oooo00<0000001hJT00N6Y003P0N6Y000`000000HF>m065S_@0a065S_@030000001lMl<0O7O3
05H0O7O300<000000:mmW02_OI`0102_OI`300000900[gfL0P0000170<6ke0030000003Hcm00f<o@
01@0f<o@00<000000=S?d03Hcm003@3Hcm000`000000ljI/0?>VK0160?>VK0040000003ciXD0lnJ5
000003L0oooo00<000000?ooo`3oool06`3oool000l0oooo00<000000?ooo`3oool0M@3oool00`00
00007QZ@01hJT00>01hJT0030000001QHkd0HF>m0340HF>m00<0000007ag``1lMl<0E`1lMl<00`00
0000[gfL0:mmW00300000900[gfL0`0000190<6ke0030000003Hcm00f<o@01D0f<o@00<000000=S?
d03Hcm003@3Hcm000`000000ljI/0?>VK0150?>VK0030000003ciXD0000003P0oooo00<000000?oo
o`3oool06`3oool000h0oooo00<000000?ooo`3oool0M`3oool00`0000007QZ@01hJT00=01hJT003
0000001QHkd0HF>m0340HF>m00<0000007ag``1lMl<0E`1lMl<300000900[gfL0`00001<0<6ke003
0000003Hcm00f<o@01H0f<o@00<000000=S?d03Hcm003@3Hcm02000004@0ljI/00@000000??VQ@3c
iXD00000>03oool00`000000oooo0?ooo`0K0?ooo`003P3oool00`000000oooo0?ooo`1g0?ooo`03
0000000N6Y007QZ@00`07QZ@00<00000065S_@1QHkd0<`1QHkd00`000000O7O307ag``1C07ag``<0
00000P1lMl<00`000000[gfL0:mmW02;0:mmW0<00000C`31^m@00`000000f<o@0=S?d00G0=S?d003
0000003Hcm00f<o@00h0f<o@00<000000?>VK03cYV`0@03cYV`01@000000lnJ50??VQ@3ciXD00000
03P0oooo00<000000?ooo`3oool06`3oool000h0oooo00<000000?ooo`3oool0M`3oool00`000000
7QZ@01hJT00<01hJT0030000001QHkd0HF>m03<0HF>m00<0000007ag``1lMl<0D01lMl<3000000H0
O7O300<000000:mmW02_OI`0Q`2_OI`300000580`K_D00<000000=S?d03Hcm00603Hcm000`000000
f<o@0=S?d00>0=S?d0030000003cYV`0ljI/03l0ljI/00@000000??VQ@3ciXD00000>@3oool00`00
0000oooo0?ooo`0K0?ooo`003P3oool00`000000oooo0?ooo`1g0?ooo`030000000N6Y007QZ@00`0
7QZ@00<00000065S_@1QHkd0<`1QHkd00`000000O7O307ag``1=07ag``<000002P1lMl<00`000000
[gfL0:mmW0240:mmW0800000E@31^m@00`000000f<o@0=S?d00H0=S?d0030000003Hcm00f<o@00l0
f<o@0P00000n0?>VK0050000003ciXD0lnJ50??VQ@000000>@3oool00`000000oooo0?ooo`0K0?oo
o`003P3oool00`000000oooo0?ooo`1h0?ooo`030000000N6Y007QZ@00X07QZ@00<00000065S_@1Q
Hkd0=01QHkd00`000000O7O307ag``1:07ag``<000003P1lMl<00`000000[gfL0:mmW0200:mmW0<0
0000EP31^m@00`000000f<o@0=S?d00J0=S?d0030000003Hcm00f<o@0100f<o@00<000000?>VK03c
YV`0>P3cYV`01@000000lnJ50??VQ@3ciXD0000003X0oooo00<000000?ooo`3oool06`3oool000h0
oooo00<000000?ooo`3oool0N03oool00`0000007QZ@01hJT00:01hJT0030000001QHkd0HF>m03@0
HF>m00<0000007ag``1lMl<0A`1lMl<300000180O7O300<000000:mmW02_OI`0O02_OI`3000005T0
`K_D00<000000=S?d03Hcm006`3Hcm000`000000f<o@0=S?d00@0=S?d0030000003cYV`0ljI/03P0
ljI/00<000000??VQ@3ciXD00P3ciXD00`000000oooo0?ooo`0h0?ooo`030000003oool0oooo01/0
oooo000>0?ooo`030000003oool0oooo07P0oooo00<0000001hJT00N6Y002P0N6Y000`000000HF>m
065S_@0d065S_@030000001lMl<0O7O304<0O7O31000000F07ag``030000002_OI`0[gfL07P0[gfL
0`00001L0<6ke0030000003Hcm00f<o@01`0f<o@00<000000=S?d03Hcm00403Hcm02000003P0ljI/
00<000000??VQ@3ciXD00P3ciXD00`000000oooo0?ooo`0i0?ooo`030000003oool0oooo01X0oooo
000=0?ooo`030000003oool0oooo07X0oooo00<0000001hJT00N6Y00200N6Y000`000000HF>m065S
_@0e065S_@030000001lMl<0O7O30400O7O30`00000K07ag``030000002_OI`0[gfL07D0[gfL0P00
001O0<6ke0030000003Hcm00f<o@01d0f<o@00<000000=S?d03Hcm004@3Hcm000`000000ljI/0?>V
K00d0?>VK0030000003ciXD0lnJ50080lnJ500<000000?ooo`3oool0>P3oool00`000000oooo0?oo
o`0J0?ooo`003@3oool00`000000oooo0?ooo`1j0?ooo`030000000N6Y007QZ@00P07QZ@00<00000
065S_@1QHkd0=P1QHkd00`000000O7O307ag``0l07ag``<000007`1lMl<00`000000[gfL0:mmW01a
0:mmW0<00000H@31^m@00`000000f<o@0=S?d00M0=S?d0030000003Hcm00f<o@0180f<o@00<00000
0?>VK03cYV`0<P3cYV`00`000000lnJ50??VQ@030??VQ@030000003oool0oooo03X0oooo00<00000
0?ooo`3oool06P3oool000d0oooo00<000000?ooo`3oool0NP3oool00`0000007QZ@01hJT00701hJ
T0030000001QHkd0HF>m03L0HF>m00<0000007ag``1lMl<0>@1lMl<3000002<0O7O300<000000:mm
W02_OI`0K@2_OI`3000006@0`K_D00<000000=S?d03Hcm007P3Hcm000`000000f<o@0=S?d00B0=S?
d0800000<P3cYV`00`000000lnJ50??VQ@020??VQ@030000003oool0oooo03/0oooo00<000000?oo
o`3oool06P3oool000d0oooo00<000000?ooo`3oool0N`3oool00`0000007QZ@01hJT00601hJT003
0000001QHkd0HF>m03L0HF>m00<0000007ag``1lMl<0=P1lMl<3000002L0O7O300<000000:mmW02_
OI`0J@2_OI`3000006L0`K_D00<000000=S?d03Hcm007`3Hcm000`000000f<o@0=S?d00C0=S?d003
0000003cYV`0ljI/02h0ljI/00<000000??VQ@3ciXD00`3ciXD00`000000oooo0?ooo`0k0?ooo`03
0000003oool0oooo01X0oooo000=0?ooo`030000003oool0oooo07/0oooo00<0000001hJT00N6Y00
1P0N6Y000`000000HF>m065S_@0g065S_@030000001lMl<0O7O303<0O7O30`00000[07ag``030000
002_OI`0[gfL06D0[gfL0`00001Z0<6ke0030000003Hcm00f<o@0200f<o@00<000000=S?d03Hcm00
4`3Hcm000`000000ljI/0?>VK00/0?>VK0030000003ciXD0lnJ500<0lnJ500<000000?ooo`3oool0
?03oool00`000000oooo0?ooo`0J0?ooo`003@3oool00`000000oooo0?ooo`1k0?ooo`030000000N
6Y007QZ@00D07QZ@00<00000065S_@1QHkd0>01QHkd00`000000O7O307ag``0`07ag``<00000;`1l
Ml<00`000000[gfL0:mmW01R0:mmW0800000K@31^m@00`000000f<o@0=S?d00Q0=S?d0030000003H
cm00f<o@01<0f<o@0P00000[0?>VK0030000003ciXD0lnJ500@0lnJ500<000000?ooo`3oool0?03o
ool00`000000oooo0?ooo`0J0?ooo`00303oool00`000000oooo0?ooo`1l0?ooo`030000000N6Y00
7QZ@00D07QZ@00<00000065S_@1QHkd0>01QHkd00`000000O7O307ag``0]07ag``<00000<`1lMl<0
0`000000[gfL0:mmW01N0:mmW0<00000KP31^m@00`000000f<o@0=S?d00R0=S?d0030000003Hcm00
f<o@01D0f<o@00<000000?>VK03cYV`0:03cYV`00`000000lnJ50??VQ@040??VQ@030000003oool0
oooo03`0oooo00<000000?ooo`3oool06P3oool000`0oooo00<000000?ooo`3oool0O@3oool00`00
00007QZ@01hJT00401hJT0030000001QHkd0HF>m03P0HF>m00<0000007ag``1lMl<0:P1lMl<30000
03L0O7O300<000000:mmW02_OI`0FP2_OI`300000740`K_D00<000000=S?d03Hcm008`3Hcm000`00
0000f<o@0=S?d00E0=S?d0030000003cYV`0ljI/02H0ljI/00<000000??VQ@3ciXD0103ciXD00`00
0000oooo0?ooo`0n0?ooo`030000003oool0oooo01T0oooo000<0?ooo`030000003oool0oooo07d0
oooo00<0000001hJT00N6Y000`0N6Y000`000000HF>m065S_@0j065S_@030000001lMl<0O7O302H0
O7O30`00000k07ag``030000002_OI`0[gfL05H0[gfL0`00001d0<6ke0030000003Hcm00f<o@02@0
f<o@00<000000=S?d03Hcm005@3Hcm02000002D0ljI/00<000000??VQ@3ciXD01@3ciXD00`000000
oooo0?ooo`0n0?ooo`030000003oool0oooo01T0oooo000<0?ooo`030000003oool0oooo07d0oooo
00<0000001hJT00N6Y000`0N6Y000`000000HF>m065S_@0j065S_@030000001lMl<0O7O30280O7O3
1000000o07ag``030000002_OI`0[gfL0580[gfL0`00001g0<6ke0030000003Hcm00f<o@02D0f<o@
00<000000=S?d03Hcm005P3Hcm000`000000ljI/0?>VK00R0?>VK0030000003ciXD0lnJ500@0lnJ5
00<000000?ooo`3oool0?`3oool00`000000oooo0?ooo`0I0?ooo`00303oool00`000000oooo0?oo
o`1n0?ooo`030000000N6Y007QZ@00807QZ@00<00000065S_@1QHkd0>P1QHkd00`000000O7O307ag
``0O07ag``<00000A01lMl<00`000000[gfL0:mmW01?0:mmW0800000NP31^m@00`000000f<o@0=S?
d00V0=S?d0030000003Hcm00f<o@01H0f<o@00<000000?>VK03cYV`0803cYV`00`000000lnJ50??V
Q@050??VQ@030000003oool0oooo03l0oooo00<000000?ooo`3oool06@3oool000`0oooo00<00000
0?ooo`3oool0OP3oool01@0000007QZ@01hJT00N6Y00000003d0HF>m00<0000007ag``1lMl<0701l
Ml<3000004P0O7O300<000000:mmW02_OI`0B`2_OI`3000007`0`K_D00<000000=S?d03Hcm009P3H
cm000`000000f<o@0=S?d00G0=S?d08000007`3cYV`00`000000lnJ50??VQ@060??VQ@030000003o
ool0oooo03l0oooo00<000000?ooo`3oool06@3oool000`0oooo00<000000?ooo`3oool0OP3oool0
1@0000007QZ@01hJT00N6Y00000003d0HF>m00<0000007ag``1lMl<06@1lMl<3000004`0O7O300<0
00000:mmW02_OI`0A`2_OI`3000007l0`K_D00<000000=S?d03Hcm009`3Hcm000`000000f<o@0=S?
d00H0=S?d0030000003cYV`0ljI/01`0ljI/00<000000??VQ@3ciXD01@3ciXD00`000000oooo0?oo
o`100?ooo`030000003oool0oooo01T0oooo000;0?ooo`030000003oool0oooo0800oooo00@00000
01hJT00N6Y000000?@1QHkd00`000000O7O307ag``0F07ag``<00000D01lMl<00`000000[gfL0:mm
W0130:mmW0<00000PP31^m@00`000000f<o@0=S?d00X0=S?d0030000003Hcm00f<o@01P0f<o@00<0
00000?>VK03cYV`06P3cYV`00`000000lnJ50??VQ@060??VQ@030000003oool0oooo0400oooo00<0
00000?ooo`3oool06@3oool000/0oooo00<000000?ooo`3oool0P03oool00`0000007QZ@0000000n
065S_@030000001lMl<0O7O301<0O7O30`00001C07ag``030000002_OI`0[gfL0400[gfL0`000025
0<6ke0030000003Hcm00f<o@02T0f<o@00<000000=S?d03Hcm00603Hcm02000001T0ljI/00<00000
0??VQ@3ciXD01P3ciXD00`000000oooo0?ooo`110?ooo`030000003oool0oooo01T0oooo000;0?oo
o`030000003oool0oooo0800oooo00<0000001hJT0000000?`1QHkd00`000000O7O307ag``0?07ag
``<00000E`1lMl<00`000000[gfL0:mmW00m0:mmW0800000Q`31^m@00`000000f<o@0=S?d00[0=S?
d0030000003Hcm00f<o@01T0f<o@00<000000?>VK03cYV`05@3cYV`00`000000lnJ50??VQ@070??V
Q@030000003oool0oooo0480oooo00<000000?ooo`3oool0603oool000/0oooo00<000000?ooo`3o
ool0P03oool00`0000007QZ@0000000o065S_@030000001lMl<0O7O300`0O7O30`00001K07ag``03
0000002_OI`0[gfL03T0[gfL0`0000290<6ke0030000003Hcm00f<o@02/0f<o@00<000000=S?d03H
cm006P3Hcm000`000000ljI/0?>VK00D0?>VK0030000003ciXD0lnJ500L0lnJ500<000000?ooo`3o
ool0@P3oool00`000000oooo0?ooo`0H0?ooo`002`3oool00`000000oooo0?ooo`210?ooo`030000
001QHkd0HF>m03h0HF>m00<0000007ag``1lMl<02@1lMl<3000005l0O7O300<000000:mmW02_OI`0
=@2_OI`3000008`0`K_D00<000000=S?d03Hcm00;03Hcm000`000000f<o@0=S?d00J0=S?d0800000
4`3cYV`00`000000lnJ50??VQ@070??VQ@030000003oool0oooo04<0oooo00<000000?ooo`3oool0
603oool000/0oooo00<000000?ooo`3oool0P@3oool00`000000HF>m065S_@0n065S_@030000001l
Ml<0O7O300D0O7O31000001S07ag``030000002_OI`0[gfL0340[gfL0`00002?0<6ke0030000003H
cm00f<o@02d0f<o@00<000000=S?d03Hcm006`3Hcm000`000000ljI/0?>VK00?0?>VK0030000003c
iXD0lnJ500P0lnJ500<000000?ooo`3oool0@`3oool00`000000oooo0?ooo`0H0?ooo`002`3oool0
0`000000oooo0?ooo`220?ooo`030000001QHkd0HF>m03d0HF>m00<0000007ag``1lMl<00P1lMl<3
000006P0O7O300<000000:mmW02_OI`0;@2_OI`300000980`K_D00<000000=S?d03Hcm00;P3Hcm00
0`000000f<o@0=S?d00K0=S?d0030000003cYV`0ljI/00h0ljI/00<000000??VQ@3ciXD01`3ciXD0
0`000000oooo0?ooo`140?ooo`030000003oool0oooo01P0oooo000:0?ooo`030000003oool0oooo
08@0oooo00<00000065S_@1QHkd0?01QHkd00`000000O7O300000002000006`0O7O300<000000:mm
W02_OI`0:P2_OI`2000009D0`K_D00<000000=S?d03Hcm00;`3Hcm000`000000f<o@0=S?d00K0=S?
d08000003@3cYV`00`000000lnJ50??VQ@080??VQ@030000003oool0oooo04@0oooo00<000000?oo
o`3oool0603oool000X0oooo00<000000?ooo`3oool0Q@3oool00`000000HF>m065S_@0j065S_@<0
0000L01lMl<00`000000[gfL0:mmW00V0:mmW0<00000U`31^m@00`000000f<o@0=S?d00_0=S?d003
0000003Hcm00f<o@01d0f<o@00<000000?>VK03cYV`02@3cYV`00`000000lnJ50??VQ@090??VQ@03
0000003oool0oooo04@0oooo00<000000?ooo`3oool0603oool000X0oooo00<000000?ooo`3oool0
Q@3oool00`000000HF>m065S_@0g065S_@<000000P1QHkd00`000000O7O307ag``1_07ag``030000
002_OI`0[gfL0280[gfL0`00002J0<6ke0030000003Hcm00f<o@0300f<o@00<000000=S?d03Hcm00
7@3Hcm000`000000ljI/0?>VK0080?>VK0030000003ciXD0lnJ500P0lnJ500<000000?ooo`3oool0
AP3oool00`000000oooo0?ooo`0G0?ooo`002P3oool00`000000oooo0?ooo`260?ooo`030000001Q
Hkd0HF>m03<0HF>m0`000005065S_@030000001lMl<0O7O30700O7O300<000000:mmW02_OI`07P2_
OI`3000009d0`K_D00<000000=S?d03Hcm00<@3Hcm000`000000f<o@0=S?d00M0=S?d08000001`3c
YV`00`000000lnJ50??VQ@090??VQ@030000003oool0oooo04H0oooo00<000000?ooo`3oool05`3o
ool000X0oooo00<000000?ooo`3oool0Q`3oool00`000000HF>m065S_@0_065S_@<00000201QHkd0
0`000000O7O307ag``1a07ag``030000002_OI`0[gfL01X0[gfL0`00002O0<6ke0030000003Hcm00
f<o@03<0f<o@00<000000=S?d03Hcm007P3Hcm000`000000ljI/0?>VK0030?>VK0030000003ciXD0
lnJ500T0lnJ500<000000?ooo`3oool0A`3oool00`000000oooo0?ooo`0G0?ooo`002P3oool00`00
0000oooo0?ooo`280?ooo`030000001QHkd0HF>m02/0HF>m0`00000;065S_@030000001lMl<0O7O3
0780O7O300<000000:mmW02_OI`05`2_OI`200000:80`K_D00<000000=S?d03Hcm00=03Hcm000`00
0000f<o@0=S?d00N0=S?d0050000003cYV`0ljI/0?>VK0000000303ciXD00`000000oooo0?ooo`17
0?ooo`030000003oool0oooo01L0oooo00090?ooo`030000003oool0oooo08X0oooo00<00000065S
_@1QHkd09`1QHkd3000000h0HF>m00<0000007ag``1lMl<0L`1lMl<00`000000[gfL0:mmW00C0:mm
W0<00000Y031^m@00`000000f<o@0=S?d00d0=S?d0030000003Hcm00f<o@01l0f<o@0P0000000`3c
YV`000000??VQ@0;0??VQ@030000003oool0oooo04L0oooo00<000000?ooo`3oool05`3oool000T0
oooo00<000000?ooo`3oool0R`3oool00`000000HF>m065S_@0R065S_@@000004@1QHkd00`000000
O7O307ag``1d07ag``030000002_OI`0[gfL00l0[gfL0`00002W0<6ke0030000003Hcm00f<o@03D0
f<o@00<000000=S?d03Hcm00803Hcm000`000000lnJ50??VQ@0:0??VQ@030000003oool0oooo04P0
oooo00<000000?ooo`3oool05`3oool000T0oooo00<000000?ooo`3oool0R`3oool00`000000HF>m
065S_@0O065S_@<000005@1QHkd00`000000O7O307ag``1e07ag``030000002_OI`0[gfL00/0[gfL
0`00002Z0<6ke0030000003Hcm00f<o@03H0f<o@00<000000=S?d03Hcm007P3Hcm02000000`0lnJ5
00<000000?ooo`3oool0B03oool00`000000oooo0?ooo`0G0?ooo`002@3oool00`000000oooo0?oo
o`2<0?ooo`030000001QHkd0HF>m01/0HF>m0`00000I065S_@030000001lMl<0O7O307D0O7O300<0
00000:mmW02_OI`01`2_OI`300000:d0`K_D00<000000=S?d03Hcm00=`3Hcm000`000000f<o@0=S?
d00L0=S?d0030000003Rl]P0000000/0lnJ500<000000?ooo`3oool0B@3oool00`000000oooo0?oo
o`0G0?ooo`002@3oool00`000000oooo0?ooo`2=0?ooo`030000001QHkd0HF>m01L0HF>m0`00000L
065S_@030000001lMl<0O7O307H0O7O300<000000:mmW02_OI`0102_OI`200000;00`K_D00<00000
0=S?d03Hcm00>03Hcm000`000000f<o@0=S?d00J0=S?d0040000003Rl]P0h_;H000000/0lnJ500<0
00000?ooo`3oool0BP3oool00`000000oooo0?ooo`0F0?ooo`002@3oool00`000000oooo0?ooo`2>
0?ooo`030000001QHkd0HF>m01<0HF>m0`00000O065S_@030000001lMl<0O7O307L0O7O300<00000
0:mmW02_OI`00`00002b0<6ke0030000003Hcm00f<o@03P0f<o@00<000000=S?d03Hcm006@3Hcm00
1@000000h_;H0>;bf03Rl]P0000000/0lnJ500<000000?ooo`3oool0BP3oool00`000000oooo0?oo
o`0F0?ooo`002@3oool00`000000oooo0?ooo`2?0?ooo`030000001QHkd0HF>m00l0HF>m0`00000R
065S_@030000001lMl<0O7O307P0O7O30P00002e0<6ke0030000003Hcm00f<o@03T0f<o@00<00000
0=S?d03Hcm005`3Hcm000`000000h_;H0>;bf0020>;bf0030000003ciXD0lnJ500P0lnJ500<00000
0?ooo`3oool0B`3oool00`000000oooo0?ooo`0F0?ooo`00203oool00`000000oooo0?ooo`2A0?oo
o`030000001QHkd0HF>m00/0HF>m0`00000U065S_@030000001lMl<0O7O307H0O7O30P0000000`2K
^nh000000000002c0<6ke0030000003Hcm00f<o@03/0f<o@00<000000=S?d03Hcm005@3Hcm000`00
0000h_;H0>;bf0030>;bf0030000003ciXD0lnJ500P0lnJ500<000000?ooo`3oool0B`3oool00`00
0000oooo0?ooo`0F0?ooo`00203oool00`000000oooo0?ooo`2B0?ooo`030000001QHkd0HF>m00L0
HF>m0`00000X065S_@030000001lMl<0O7O307D0O7O300<0000009^kkP2K^nh00`2K^nh200000;40
`K_D00<000000=S?d03Hcm00?03Hcm000`000000f<o@0=S?d00D0=S?d0030000003Rl]P0h_;H00<0
h_;H00<000000??VQ@3ciXD01`3ciXD00`000000oooo0?ooo`1<0?ooo`030000003oool0oooo01H0
oooo00080?ooo`030000003oool0oooo0980oooo00<00000065S_@1QHkd0101QHkd3000002/0HF>m
00<0000007ag``1lMl<0L`1lMl<2000000P0Vk_^00<000000<6ke031^m@0[P31^m@00`000000f<o@
0=S?d00m0=S?d0030000003Hcm00f<o@0180f<o@00<000000>;bf03Rl]P0103Rl]P00`000000lnJ5
0??VQ@070??VQ@030000003oool0oooo04`0oooo00<000000?ooo`3oool05P3oool000P0oooo00<0
00000?ooo`3oool0T`3oool00`000000HF>m065S_@03000002l0HF>m00<0000007ag``1lMl<0L@1l
Ml<00`000000Vk_^09^kkP0909^kkP800000[P31^m@00`000000f<o@0=S?d00m0=S?d0030000003H
cm00f<o@0140f<o@00<000000>;bf03Rl]P01@3Rl]P00`000000lnJ50??VQ@070??VQ@030000003o
ool0oooo04`0oooo00<000000?ooo`3oool05P3oool000P0oooo00<000000?ooo`3oool0TP3oool4
00000380HF>m00<0000007ag``1lMl<0L01lMl<00`000000Vk_^09^kkP0<09^kkP0300000031^m@0
`K_D0:/0`K_D00<000000=S?d03Hcm00?P3Hcm000`000000f<o@0=S?d00?0=S?d0030000003Rl]P0
h_;H00H0h_;H00<000000??VQ@3ciXD01P3ciXD00`000000oooo0?ooo`1=0?ooo`030000003oool0
oooo01H0oooo00080?ooo`030000003oool0oooo08l0oooo0`0000030?ooo`030000001QHkd0HF>m
0300HF>m00<0000007ag``1lMl<0KP1lMl<200000100Vk_^0P00002[0<6ke0030000003Hcm00f<o@
03l0f<o@00<000000=S?d03Hcm003@3Hcm000`000000h_;H0>;bf0070>;bf0030000003ciXD0lnJ5
00H0lnJ500<000000?ooo`3oool0CP3oool00`000000oooo0?ooo`0E0?ooo`001`3oool00`000000
oooo0?ooo`2=0?ooo`<000001`3oool00`000000HF>m065S_@0_065S_@030000001lMl<0O7O306d0
O7O300<0000009^kkP2K^nh04P2K^nh200000:T0`K_D00<000000=S?d03Hcm00@03Hcm000`000000
f<o@0=S?d00;0=S?d0030000003Rl]P0h_;H00P0h_;H00<000000??VQ@3ciXD01@3ciXD00`000000
oooo0?ooo`1?0?ooo`030000003oool0oooo01D0oooo00070?ooo`030000003oool0oooo08X0oooo
0`00000;0?ooo`030000001QHkd0HF>m02h0HF>m00<0000007ag``1lMl<0J`1lMl<2000001L0Vk_^
00<000000<6ke031^m@0YP31^m@00`000000f<o@0=S?d0110=S?d0030000003Hcm00f<o@00T0f<o@
00<000000>;bf03Rl]P02@3Rl]P00`000000lnJ50??VQ@050??VQ@030000003oool0oooo04l0oooo
00<000000?ooo`3oool05@3oool000L0oooo00<000000?ooo`3oool0Q`3oool3000000h0oooo00<0
0000065S_@1QHkd0;P1QHkd00`000000O7O307ag``1Z07ag``030000002K^nh0Vk_^01P0Vk_^0P00
002V0<6ke0030000003Hcm00f<o@0440f<o@00<000000=S?d03Hcm00203Hcm000`000000h_;H0>;b
f00:0>;bf0030000003ciXD0lnJ500@0lnJ500<000000?ooo`3oool0D03oool00`000000oooo0?oo
o`0E0?ooo`001`3oool00`000000oooo0?ooo`240?ooo`<000004P3oool00`000000HF>m065S_@0]
065S_@030000001lMl<0O7O306P0O7O30P00000M09^kkP0300000031^m@0`K_D0:80`K_D00<00000
0=S?d03Hcm00@`3Hcm000`000000f<o@0=S?d0060=S?d0030000003Rl]P0h_;H00/0h_;H00<00000
0??VQ@3ciXD0103ciXD00`000000oooo0?ooo`1@0?ooo`030000003oool0oooo01D0oooo00070?oo
o`030000003oool0oooo0840oooo0`00000F0?ooo`030000001QHkd0HF>m02d0HF>m00<0000007ag
``1lMl<0IP1lMl<00`000000Vk_^09^kkP0N09^kkP800000XP31^m@00`000000f<o@0=S?d0140=S?
d0030000003Hcm00f<o@00@0f<o@00<000000>;bf03Rl]P03@3Rl]P00`000000lnJ50??VQ@030??V
Q@030000003oool0oooo0500oooo00<000000?ooo`3oool05@3oool000L0oooo00<000000?ooo`3o
ool0OP3oool3000001X0oooo00<00000065S_@1QHkd0;01QHkd00`000000O7O307ag``1U07ag``03
0000002K^nh0Vk_^0240Vk_^0P00002P0<6ke0030000003Hcm00f<o@04D0f<o@00<000000=S?d03H
cm000P3Hcm000`000000h_;H0>;bf00>0>;bf0030000003ciXD0lnJ50080lnJ500<000000?ooo`3o
ool0D@3oool00`000000oooo0?ooo`0E0?ooo`001`3oool00`000000oooo0?ooo`1k0?ooo`<00000
7P3oool00`000000HF>m065S_@0[065S_@030000001lMl<0O7O306<0O7O30P00000V09^kkP030000
0031^m@0`K_D09d0`K_D00<000000=S?d03Hcm00AP3Hcm0010000000f<o@0=S?d000000A0>;bf003
0000003ciXD0lnJ50080lnJ500<000000?ooo`3oool0D@3oool00`000000oooo0?ooo`0E0?ooo`00
1P3oool00`000000oooo0?ooo`1h0?ooo`@000008P3oool00`000000HF>m065S_@0Z065S_@030000
001lMl<0O7O30680O7O300<0000009^kkP2K^nh09`2K^nh2000009d0`K_D00<000000=S?d03Hcm00
AP3Hcm000`000000f<o@0000000B0>;bf0050000003ciXD0lnJ50??VQ@000000E@3oool00`000000
oooo0?ooo`0D0?ooo`001P3oool00`000000oooo0?ooo`1e0?ooo`<000009`3oool00`000000HF>m
065S_@0Y065S_@030000001lMl<0O7O30600O7O30P00000/09^kkP800000V`31^m@00`000000f<o@
0=S?d0170=S?d0030000003Rl]P0h_;H0140h_;H00D000000??VQ@3ciXD0lnJ50000001E0?ooo`03
0000003oool0oooo01@0oooo00060?ooo`030000003oool0oooo0780oooo0`00000Z0?ooo`030000
001QHkd0HF>m02T0HF>m00<0000007ag``1lMl<0G`1lMl<00`000000Vk_^09^kkP0^09^kkP030000
0031^m@0`K_D09P0`K_D00<000000=S?d03Hcm00A`3Hcm0200000180h_;H00D000000??VQ@3ciXD0
lnJ50000001E0?ooo`030000003oool0oooo01@0oooo00060?ooo`030000003oool0oooo06l0oooo
0`00000^0?ooo`030000001QHkd0HF>m02P0HF>m00<0000007ag``1lMl<0G@1lMl<200000380Vk_^
0P00002H0<6ke0030000003Hcm00f<o@04H0f<o@00@000000>;bf03Rl]P000004@3Rl]P010000000
lnJ50??VQ@00001F0?ooo`030000003oool0oooo01@0oooo00060?ooo`030000003oool0oooo06`0
oooo0`00000b0?ooo`030000001QHkd0HF>m02P0HF>m00<0000007ag``1lMl<0F`1lMl<00`000000
Vk_^09^kkP0d09^kkP0300000031^m@0`K_D09D0`K_D00<000000=S?d03Hcm00A@3Hcm000`000000
h_;H0>;bf0020>;bf0030000003Rl]P0h_;H00h0h_;H00@000000??VQ@3ciXD00000EP3oool00`00
0000oooo0?ooo`0D0?ooo`001P3oool00`000000oooo0?ooo`1Y0?ooo`<00000=P3oool00`000000
HF>m065S_@0W065S_@030000001lMl<0O7O305X0O7O300<0000009^kkP2K^nh0=P2K^nh2000009@0
`K_D00<000000=S?d03Hcm00A@3Hcm000`000000h_;H0>;bf0030>;bf0030000003Rl]P0h_;H00h0
h_;H00<000000??VQ@000000E`3oool00`000000oooo0?ooo`0D0?ooo`001@3oool00`000000oooo
0?ooo`1W0?ooo`<00000>P3oool00`000000HF>m065S_@0V065S_@030000001lMl<0O7O305P0O7O3
0P00000k09^kkP800000TP31^m@00`000000f<o@0=S?d0140=S?d0030000003Rl]P0h_;H00D0h_;H
00<000000>;bf03Rl]P03@3Rl]P00`000000lnJ50000001G0?ooo`030000003oool0oooo01@0oooo
00050?ooo`030000003oool0oooo06@0oooo0`00000n0?ooo`030000001QHkd0HF>m02D0HF>m00<0
000007ag``1lMl<0E`1lMl<00`000000Vk_^09^kkP0m09^kkP0300000031^m@0`K_D08l0`K_D00<0
00000=S?d03Hcm00@`3Hcm000`000000h_;H0>;bf0070>;bf0030000003Rl]P0h_;H00`0h_;H00<0
00000??VQ@000000F03oool00`000000oooo0?ooo`0C0?ooo`001@3oool00`000000oooo0?ooo`1Q
0?ooo`<00000@P3oool00`000000HF>m065S_@0T065S_@030000001lMl<0O7O305D0O7O30P000011
09^kkP800000S`31^m@00`000000f<o@0=S?d0120=S?d0030000003Rl]P0h_;H00T0h_;H00<00000
0>;bf03Rl]P02`3Rl]P2000005T0oooo00<000000?ooo`3oool04`3oool000D0oooo00<000000?oo
o`3oool0G@3oool4000004D0oooo00<00000065S_@1QHkd0901QHkd00`000000O7O307ag``1D07ag
``030000002K^nh0Vk_^04<0Vk_^00<000000<6ke031^m@0S031^m@00`000000f<o@0=S?d0110=S?
d0030000003Rl]P0h_;H00/0h_;H00<000000>;bf03Rl]P02P3Rl]P2000005T0oooo00<000000?oo
o`3oool04`3oool000D0oooo00<000000?ooo`3oool0FP3oool3000004X0oooo00<00000065S_@1Q
Hkd08`1QHkd00`000000O7O307ag``1B07ag``800000A`2K^nh2000008`0`K_D00<000000=S?d03H
cm00@03Hcm000`000000h_;H0>;bf00<0>;bf0030000003Rl]P0h_;H00X0h_;H00<000000?ooo`3o
ool0F03oool00`000000oooo0?ooo`0C0?ooo`001@3oool00`000000oooo0?ooo`1G0?ooo`<00000
CP3oool00`000000HF>m065S_@0R065S_@030000001lMl<0O7O30540O7O300<0000009^kkP2K^nh0
B@2K^nh2000008X0`K_D00<000000=S?d03Hcm00?`3Hcm000`000000h_;H0>;bf00>0>;bf0030000
003Rl]P0h_;H00T0h_;H00<000000?ooo`3oool0F03oool00`000000oooo0?ooo`0C0?ooo`001@3o
ool00`000000oooo0?ooo`1D0?ooo`<00000DP3oool00`000000HF>m065S_@0R065S_@030000001l
Ml<0O7O304h0O7O30P00001>09^kkP0300000031^m@0`K_D08L0`K_D00<000000=S?d03Hcm00?P3H
cm000`000000h_;H0>;bf00@0>;bf0030000003Rl]P0h_;H00L0h_;H0P00001J0?ooo`030000003o
ool0oooo01<0oooo00040?ooo`030000003oool0oooo0580oooo0`00001F0?ooo`030000001QHkd0
HF>m0240HF>m00<0000007ag``1lMl<0C@1lMl<00`000000Vk_^09^kkP1?09^kkP800000Q`31^m@0
0`000000f<o@0=S?d00m0=S?d0030000003Rl]P0h_;H0180h_;H00<000000>;bf03Rl]P0103Rl]P3
000005/0oooo00<000000?ooo`3oool04`3oool000@0oooo00<000000?ooo`3oool0C`3oool30000
05X0oooo00<00000065S_@1QHkd0801QHkd00`000000O7O307ag``1<07ag``030000002K^nh0Vk_^
0580Vk_^00<000000<6ke031^m@0Q031^m@00`000000f<o@0=S?d00l0=S?d0030000003Rl]P0h_;H
01@0h_;H00<000000>;bf03Rl]P00P3Rl]P010000000eokG0=One`00001K0?ooo`030000003oool0
oooo01<0oooo00040?ooo`030000003oool0oooo04`0oooo0`00001M0?ooo`030000001QHkd0HF>m
0200HF>m00<0000007ag``1lMl<0BP1lMl<2000005H0Vk_^0P0000230<6ke0030000003Hcm00f<o@
03`0f<o@00<000000>;bf03Rl]P05@3Rl]P01@000000h_;H0>;bf03Rl]P000000080eokG00<00000
0?ooo`3oool0F`3oool00`000000oooo0?ooo`0B0?ooo`00103oool00`000000oooo0?ooo`190?oo
o`<00000H@3oool00`000000HF>m065S_@0O065S_@030000001lMl<0O7O304T0O7O300<0000009^k
kP2K^nh0F02K^nh200000840`K_D00<000000=S?d03Hcm00?03Hcm000`000000h_;H0>;bf00F0>;b
f0<000000`3Go]L00`000000oooo0?ooo`1K0?ooo`030000003oool0oooo0180oooo00040?ooo`03
0000003oool0oooo04H0oooo0`00001U0?ooo`030000001QHkd0HF>m01h0HF>m00<0000007ag``1l
Ml<0A`1lMl<2000005d0Vk_^00<000000<6ke031^m@0OP31^m@00`000000f<o@0=S?d00k0=S?d003
0000003Rl]P0h_;H01L0h_;H0P0000030=One`030000003oool0oooo05`0oooo00<000000?ooo`3o
ool04P3oool000@0oooo00<000000?ooo`3oool0@`3oool3000006T0oooo00<00000065S_@1QHkd0
7@1QHkd00`000000O7O307ag``1607ag``030000002K^nh0Vk_^05h0Vk_^0P00001n0<6ke0030000
003Hcm00f<o@03X0f<o@00<000000>;bf03Rl]P05`3Rl]P010000000eokG0=One`0000020=One`03
0000003oool0oooo05`0oooo00<000000?ooo`3oool04P3oool000@0oooo00<000000?ooo`3oool0
?`3oool4000006d0oooo00<00000065S_@1QHkd07@1QHkd00`000000O7O307ag``1307ag``800000
H`2K^nh2000007`0`K_D00<000000=S?d03Hcm00>@3Hcm000`000000h_;H0>;bf00G0>;bf0030000
003Go]L0eokG0080eokG0P00001O0?ooo`030000003oool0oooo0180oooo00030?ooo`030000003o
ool0oooo03d0oooo0`00001b0?ooo`030000001QHkd0HF>m01`0HF>m00<0000007ag``1lMl<0@P1l
Ml<00`000000Vk_^09^kkP1U09^kkP0300000031^m@0`K_D07T0`K_D00<000000=S?d03Hcm00>03H
cm000`000000h_;H0>;bf00F0>;bf08000001@3Go]L2000005l0oooo00<000000?ooo`3oool04P3o
ool000<0oooo00<000000?ooo`3oool0>P3oool3000007H0oooo00<00000065S_@1QHkd06`1QHkd0
0`000000O7O307ag``1107ag``030000002K^nh0Vk_^06L0Vk_^0P00001i0<6ke0030000003Hcm00
f<o@03L0f<o@00<000000>;bf03Rl]P05P3Rl]P00`000000eokG0=One`050=One`800000G`3oool0
0`000000oooo0?ooo`0B0?ooo`000`3oool00`000000oooo0?ooo`0g0?ooo`<00000N@3oool00`00
0000HF>m065S_@0K065S_@030000001lMl<0O7O303l0O7O30P00001/09^kkP0300000031^m@0`K_D
07H0`K_D00<000000=S?d03Hcm00=P3Hcm000`000000h_;H0>;bf00F0>;bf0030000003Go]L0eokG
00H0eokG00<000000?ooo`000000GP3oool00`000000oooo0?ooo`0B0?ooo`000`3oool00`000000
oooo0?ooo`0d0?ooo`<00000O@3oool00`000000HF>m065S_@0J065S_@030000001lMl<0O7O303h0
O7O300<0000009^kkP2K^nh0K@2K^nh2000007H0`K_D00<000000=S?d03Hcm00=@3Hcm000`000000
h_;H0>;bf00E0>;bf0800000203Go]L01@000000oooo0?ooo`3oool0000005h0oooo00<000000?oo
o`3oool04@3oool000<0oooo00<000000?ooo`3oool0<@3oool300000840oooo00<00000065S_@1Q
Hkd06@1QHkd00`000000O7O307ag``0l07ag``800000LP2K^nh2000007<0`K_D00<000000=S?d03H
cm00=@3Hcm000`000000h_;H0>;bf00E0>;bf0030000003Go]L0eokG00P0eokG00D000000?ooo`3o
ool0oooo0000001N0?ooo`030000003oool0oooo0140oooo00030?ooo`030000003oool0oooo02h0
oooo0`0000250?ooo`030000001QHkd0HF>m01P0HF>m00<0000007ag``1lMl<0>`1lMl<00`000000
Vk_^09^kkP1d09^kkP0300000031^m@0`K_D0700`K_D00<000000=S?d03Hcm00=03Hcm000`000000
h_;H0>;bf00E0>;bf0030000003Go]L0eokG00P0eokG00<000000?ooo`3oool00`3oool00`000000
oooo0?ooo`1K0?ooo`030000003oool0oooo0140oooo00020?ooo`030000003oool0oooo02`0oooo
0`0000290?ooo`030000001QHkd0HF>m01P0HF>m00<0000007ag``1lMl<0>01lMl<2000007P0Vk_^
0P00001`0<6ke0030000003Hcm00f<o@03<0f<o@00<000000>;bf03Rl]P05@3Rl]P00`000000eokG
0=One`090=One`030000003oool0oooo00@0oooo00<000000?ooo`3oool0FP3oool00`000000oooo
0?ooo`0A0?ooo`000P3oool00`000000oooo0?ooo`0Y0?ooo`<00000S@3oool00`000000HF>m065S
_@0G065S_@030000001lMl<0O7O303L0O7O300<0000009^kkP2K^nh0NP2K^nh00`000000`K_D0<6k
e01]0<6ke0030000003Hcm00f<o@0380f<o@00<000000>;bf03Rl]P0503Rl]P2000000/0eokG00<0
00000?ooo`3oool01P3oool00`000000oooo0?ooo`1I0?ooo`030000003oool0oooo0140oooo0002
0?ooo`030000003oool0oooo02D0oooo1000002@0?ooo`030000001QHkd0HF>m01L0HF>m00<00000
07ag``1lMl<0=@1lMl<2000007h0Vk_^0P00001]0<6ke0030000003Hcm00f<o@0340f<o@00<00000
0>;bf03Rl]P0503Rl]P00`000000eokG0=One`0;0=One`030000003oool0oooo00L0oooo00<00000
0?ooo`3oool0F03oool00`000000oooo0?ooo`0A0?ooo`000P3oool00`000000oooo0?ooo`0R0?oo
o`<00000U@3oool00`000000HF>m065S_@0F065S_@030000001lMl<0O7O303@0O7O300<0000009^k
kP2K^nh0P02K^nh2000006/0`K_D00<000000=S?d03Hcm00<03Hcm000`000000h_;H0>;bf00D0>;b
f0030000003Go]L0eokG00/0eokG00<000000?ooo`3oool0203oool00`000000oooo0?ooo`1H0?oo
o`030000003oool0oooo0140oooo00020?ooo`030000003oool0oooo01l0oooo0`00002I0?ooo`03
0000001QHkd0HF>m01D0HF>m00<0000007ag``1lMl<0<`1lMl<00`000000Vk_^09^kkP2309^kkP03
00000031^m@0`K_D06P0`K_D00<000000=S?d03Hcm00<03Hcm000`000000h_;H0>;bf00B0>;bf080
00003P3Go]L00`000000oooo0?ooo`090?ooo`030000003oool0oooo05P0oooo00<000000?ooo`3o
ool0403oool00080oooo00<000000?ooo`3oool0703oool3000009d0oooo00<00000065S_@1QHkd0
501QHkd00`000000O7O307ag``0a07ag``800000Q`2K^nh2000006P0`K_D00<000000=S?d03Hcm00
;`3Hcm000`000000h_;H0>;bf00B0>;bf0030000003Go]L0eokG00d0eokG00<000000?ooo`3oool0
2`3oool00`000000oooo0?ooo`1G0?ooo`030000003oool0oooo0100oooo00020?ooo`030000003o
ool0oooo01T0oooo0`00002Q0?ooo`030000001QHkd0HF>m01<0HF>m00<0000007ag``1lMl<0<01l
Ml<00`000000Vk_^09^kkP2909^kkP800000IP31^m@00`000000f<o@0=S?d00^0=S?d0030000003R
l]P0h_;H0180h_;H00<000000=One`3Go]L03P3Go]L00`000000oooo0?ooo`0<0?ooo`030000003o
ool0oooo05H0oooo00<000000?ooo`3oool0403oool000030?ooo`000000oooo01P0oooo0`00002U
0?ooo`030000001QHkd0HF>m01<0HF>m00<0000007ag``1lMl<0;@1lMl<2000008h0Vk_^00<00000
0<6ke031^m@0HP31^m@00`000000f<o@0=S?d00^0=S?d0030000003Rl]P0h_;H0180h_;H00<00000
0=One`3Go]L03P3Go]L00`000000oooo0?ooo`0>0?ooo`030000003oool0oooo05D0oooo00<00000
0?ooo`3oool0403oool000030?ooo`000000oooo01D0oooo0`00002Y0?ooo`030000001QHkd0HF>m
0180HF>m00<0000007ag``1lMl<0;01lMl<00`000000Vk_^09^kkP2?09^kkP800000HP31^m@00`00
0000f<o@0=S?d00]0=S?d0030000003Rl]P0h_;H0140h_;H0P00000A0=One`030000003oool0oooo
00h0oooo00<000000?ooo`3oool0E@3oool00`000000oooo0?ooo`0@0?ooo`0000<0oooo0000003o
ool04P3oool300000:`0oooo00<00000065S_@1QHkd04P1QHkd00`000000O7O307ag``0Z07ag``80
0000U02K^nh00`000000`K_D0<6ke01O0<6ke0030000003Hcm00f<o@02`0f<o@00<000000>;bf03R
l]P04@3Rl]P00`000000eokG0=One`0@0=One`030000003oool0oooo0100oooo00<000000?ooo`3o
ool0E03oool00`000000oooo0?ooo`0@0?ooo`0000<0oooo0000003oool03`3oool300000;00oooo
00<00000065S_@1QHkd04@1QHkd00`000000O7O307ag``0Y07ag``030000002K^nh0Vk_^09D0Vk_^
0P00001O0<6ke0030000003Hcm00f<o@02/0f<o@00<000000>;bf03Rl]P04@3Rl]P00`000000eokG
0=One`0A0=One`030000003oool0oooo0140oooo00<000000?ooo`3oool0D`3oool00`000000oooo
0?ooo`0@0?ooo`0000<0oooo0000003oool02`3oool400000;@0oooo00<00000065S_@1QHkd0401Q
Hkd00`000000O7O307ag``0X07ag``030000002K^nh0Vk_^09P0Vk_^0P00001M0<6ke0030000003H
cm00f<o@02X0f<o@00<000000>;bf03Rl]P0403Rl]P2000001<0eokG00<000000?ooo`3oool04`3o
ool00`000000oooo0?ooo`1B0?ooo`030000003oool0oooo0100oooo00000`3oool000000?ooo`08
0?ooo`<00000^@3oool00`000000HF>m065S_@0?065S_@030000001lMl<0O7O302H0O7O30P00002M
09^kkP0300000031^m@0`K_D05X0`K_D00<000000=S?d03Hcm00:@3Hcm000`000000h_;H0>;bf00@
0>;bf0030000003Go]L0eokG01<0eokG00<000000?ooo`3oool0503oool00`000000oooo0?ooo`1B
0?ooo`030000003oool0oooo00l0oooo00000`000000oooo0?ooo`050?ooo`<00000_@3oool00`00
0000HF>m065S_@0>065S_@030000001lMl<0O7O302D0O7O300<0000009^kkP2K^nh0WP2K^nh20000
05X0`K_D00<000000=S?d03Hcm00:03Hcm000`000000h_;H0>;bf00@0>;bf0030000003Go]L0eokG
01<0eokG00<000000?ooo`3oool05@3oool00`000000oooo0?ooo`1B0?ooo`030000003oool0oooo
00l0oooo00000`000000oooo0?ooo`020?ooo`<00000`@3oool00`000000HF>m065S_@0>065S_@03
0000001lMl<0O7O30280O7O30P00002S09^kkP0300000031^m@0`K_D05L0`K_D00<000000=S?d03H
cm009`3Hcm000`000000h_;H0>;bf00@0>;bf0030000003Go]L0eokG01@0eokG00<000000?ooo`3o
ool05P3oool00`000000oooo0?ooo`1A0?ooo`030000003oool0oooo00l0oooo00000`000000oooo
0000000200000<@0oooo00<00000065S_@1QHkd03P1QHkd00`000000O7O307ag``0Q07ag``030000
002K^nh0Vk_^0:@0Vk_^0P00001G0<6ke0030000003Hcm00f<o@02H0f<o@00<000000>;bf03Rl]P0
3`3Rl]P2000001H0eokG00<000000?ooo`3oool0603oool00`000000oooo0?ooo`1@0?ooo`030000
003oool0oooo00l0oooo000200000<P0oooo00<00000065S_@1QHkd03@1QHkd00`000000O7O307ag
``0O07ag``800000Z@2K^nh2000005@0`K_D00<000000=S?d03Hcm009P3Hcm000`000000h_;H0>;b
f00?0>;bf0030000003Go]L0eokG01H0eokG00<000000?ooo`3oool06@3oool00`000000oooo0?oo
o`1?0?ooo`030000003oool0oooo00l0oooo00000`3oool00000000000380?ooo`030000001QHkd0
HF>m00`0HF>m00<0000007ag``1lMl<07P1lMl<00`000000Vk_^09^kkP2[09^kkP0300000031^m@0
`K_D0540`K_D00<000000=S?d03Hcm009@3Hcm000`000000h_;H0>;bf00?0>;bf0030000003Go]L0
eokG01H0eokG00<000000?ooo`3oool06`3oool00`000000oooo0?ooo`1>0?ooo`030000003oool0
oooo00l0oooo00030?ooo`030000003oool0oooo0<H0oooo00<00000065S_@1QHkd02`1QHkd00`00
0000O7O307ag``0M07ag``030000002K^nh0Vk_^0:d0Vk_^0P00001A0<6ke0030000003Hcm00f<o@
02D0f<o@00<000000>;bf03Rl]P03@3Rl]P2000001T0eokG00<000000?ooo`3oool06`3oool00`00
0000oooo0?ooo`1>0?ooo`030000003oool0oooo00l0oooo00040?ooo`030000003oool0oooo0<H0
oooo00<00000065S_@1QHkd02P1QHkd00`000000O7O307ag``0K07ag``800000/P2K^nh00`000000
`K_D0<6ke01>0<6ke0030000003Hcm00f<o@02@0f<o@00<000000>;bf03Rl]P03@3Rl]P00`000000
eokG0=One`0G0=One`8000007`3oool00`000000oooo0?ooo`1=0?ooo`030000003oool0oooo00l0
oooo00050?ooo`800000a`3oool00`000000HF>m065S_@09065S_@030000001lMl<0O7O301X0O7O3
00<0000009^kkP2K^nh0/`2K^nh2000004h0`K_D00<000000=S?d03Hcm008`3Hcm000`000000h_;H
0>;bf00=0>;bf0030000003Go]L0eokG01H0eokG0P00000R0?ooo`030000003oool0oooo04d0oooo
00<000000?ooo`3oool03P3oool000L0oooo00<000000?ooo`3oool0a@3oool00`000000HF>m065S
_@09065S_@030000001lMl<0O7O301L0O7O30P00002h09^kkP800000C031^m@00`000000f<o@0=S?
d00R0=S?d0030000003Rl]P0h_;H00d0h_;H00<000000=One`3Go]L05@3Go]L3000002@0oooo00<0
00000?ooo`3oool0C03oool00`000000oooo0?ooo`0>0?ooo`00203oool00`000000oooo0?ooo`34
0?ooo`030000001QHkd0HF>m00T0HF>m00<0000007ag``1lMl<05P1lMl<00`000000Vk_^09^kkP2j
09^kkP0300000031^m@0`K_D04T0`K_D00<000000=S?d03Hcm008@3Hcm000`000000h_;H0>;bf00<
0>;bf08000005P3Go]L3000002L0oooo00<000000?ooo`3oool0B`3oool00`000000oooo0?ooo`0>
0?ooo`002@3oool200000<D0oooo00<00000065S_@1QHkd0201QHkd00`000000O7O307ag``0D07ag
``800000_P2K^nh2000004T0`K_D00<000000=S?d03Hcm00803Hcm000`000000h_;H0>;bf00<0>;b
f0030000003Go]L0eokG01@0eokG1000000X0?ooo`030000003oool0oooo04/0oooo00<000000?oo
o`3oool03P3oool000/0oooo00<000000?ooo`3oool0``3oool00`000000HF>m065S_@07065S_@03
0000001lMl<0O7O301<0O7O300<0000009^kkP2K^nh0`02K^nh2000004L0`K_D00<000000=S?d03H
cm007`3Hcm000`000000h_;H0>;bf00<0>;bf0030000003Go]L0eokG01@0eokG00<0000007cQ]@00
0000:`3oool00`000000oooo0?ooo`1:0?ooo`030000003oool0oooo00h0oooo000<0?ooo`030000
003oool0oooo0<<0oooo00<00000065S_@1QHkd01P1QHkd00`000000O7O307ag``0A07ag``800000
a@2K^nh00`000000`K_D0<6ke0130<6ke0030000003Hcm00f<o@01l0f<o@00<000000>;bf03Rl]P0
303Rl]P00`000000eokG0=One`0C0=One`@00000;@3oool00`000000oooo0?ooo`190?ooo`030000
003oool0oooo00h0oooo000=0?ooo`800000a03oool00`000000HF>m065S_@05065S_@030000001l
Ml<0O7O30100O7O300<0000009^kkP2K^nh0aP2K^nh2000004<0`K_D00<000000=S?d03Hcm007P3H
cm000`000000h_;H0>;bf00;0>;bf0800000503Go]L20000000307cQ]@000000oooo02l0oooo00<0
00000?ooo`3oool0B03oool00`000000oooo0?ooo`0>0?ooo`003`3oool00`000000oooo0?ooo`32
0?ooo`030000001QHkd0HF>m00@0HF>m00<0000007ag``1lMl<03`1lMl<00`000000Vk_^09^kkP39
09^kkP0300000031^m@0`K_D0400`K_D00<000000=S?d03Hcm007@3Hcm000`000000h_;H0>;bf00;
0>;bf0030000003Go]L0eokG0180eokG0P0000000`1lhKD000000000000b0?ooo`030000003oool0
oooo04L0oooo00<000000?ooo`3oool03P3oool00100oooo00<000000?ooo`3oool0`P3oool00`00
0000HF>m065S_@04065S_@030000001lMl<0O7O300`0O7O30P00003=09^kkP800000@031^m@00`00
0000f<o@0=S?d00L0=S?d0030000003Rl]P0h_;H00/0h_;H00<000000=One`3Go]L04@3Go]L20000
0080O>6e00<000000?ooo`3oool0<P3oool00`000000oooo0?ooo`180?ooo`030000003oool0oooo
00d0oooo000A0?ooo`800000`P3oool00`000000HF>m065S_@04065S_@030000001lMl<0O7O300/0
O7O300<0000009^kkP2K^nh0c`2K^nh2000003h0`K_D00<000000=S?d03Hcm006`3Hcm000`000000
h_;H0>;bf00:0>;bf08000004P3Go]L200000080O>6e0P00000f0?ooo`030000003oool0oooo04L0
oooo00<000000?ooo`3oool03@3oool001<0oooo00<000000?ooo`3oool0`03oool00`000000HF>m
065S_@03065S_@030000001lMl<0O7O300T0O7O30P00003D09^kkP0300000031^m@0`K_D03/0`K_D
00<000000=S?d03Hcm006P3Hcm000`000000h_;H0>;bf00:0>;bf0030000003Go]L0eokG0140eokG
00D0000007cQ]@1lhKD0O>6e0000000i0?ooo`030000003oool0oooo04H0oooo00<000000?ooo`3o
ool03@3oool001@0oooo00<000000?ooo`3oool0`03oool00`000000HF>m065S_@02065S_@030000
001lMl<0O7O300P0O7O300<0000009^kkP2K^nh0e@2K^nh2000003/0`K_D00<000000=S?d03Hcm00
6@3Hcm000`000000h_;H0>;bf00:0>;bf0030000003Go]L0eokG0100eokG0P00000207cQ]@800000
>`3oool00`000000oooo0?ooo`150?ooo`030000003oool0oooo00d0oooo000E0?ooo`800000`@3o
ool01@000000HF>m065S_@1QHkd0000000P0O7O30P00003J09^kkP0300000031^m@0`K_D03P0`K_D
00<000000=S?d03Hcm006@3Hcm000`000000h_;H0>;bf0090>;bf0030000003Go]L0eokG00l0eokG
0P00000307cQ]@030000003oool0oooo03`0oooo00<000000?ooo`3oool0A03oool00`000000oooo
0?ooo`0=0?ooo`005`3oool00`000000oooo0?ooo`2o0?ooo`040000001QHkd0HF>m000000L0O7O3
00<0000009^kkP2K^nh0f`2K^nh2000003P0`K_D00<000000=S?d03Hcm00603Hcm000`000000h_;H
0>;bf0080>;bf0800000403Go]L2000000<0O>6e0P00000o0?ooo`030000003oool0oooo04@0oooo
00<000000?ooo`3oool03@3oool001P0oooo00<000000?ooo`3oool0_`3oool00`000000HF>m0000
000607ag``030000002K^nh0Vk_^0=h0Vk_^0P00000e0<6ke0030000003Hcm00f<o@01P0f<o@00<0
00000>;bf03Rl]P0203Rl]P00`000000eokG0=One`0>0=One`800000101lhKD00`000000oooo0?oo
o`100?ooo`030000003oool0oooo04<0oooo00<000000?ooo`3oool03@3oool001T0oooo0P00002o
0?ooo`040000001QHkd0HF>m000000<0O7O30P00003S09^kkP0300000031^m@0`K_D0380`K_D00<0
00000=S?d03Hcm005`3Hcm000`000000h_;H0>;bf0080>;bf0030000003Go]L0eokG00d0eokG0P00
000407cQ]@800000A03oool00`000000oooo0?ooo`130?ooo`030000003oool0oooo00`0oooo000K
0?ooo`030000003oool0oooo0;d0oooo00<00000065S_@0000000P1lMl<00`000000Vk_^09^kkP3T
09^kkP800000<P31^m@00`000000f<o@0=S?d00F0=S?d0030000003Rl]P0h_;H00L0h_;H0P00000?
0=One`030000001lhKD0O>6e00<0O>6e00<000000?ooo`3oool0A@3oool00`000000oooo0?ooo`12
0?ooo`030000003oool0oooo00`0oooo000L0?ooo`030000003oool0oooo0;d0oooo1000003Y09^k
kP800000<031^m@00`000000f<o@0=S?d00E0=S?d0030000003Rl]P0h_;H00L0h_;H00<000000=On
e`3Go]L03@3Go]L2000000@0O>6e0P0000190?ooo`030000003oool0oooo0440oooo00<000000?oo
o`3oool0303oool001d0oooo0P00002n0?ooo`H00000j02K^nh00`000000`K_D0<6ke00]0<6ke003
0000003Hcm00f<o@01@0f<o@00<000000>;bf03Rl]P01`3Rl]P00`000000eokG0=One`0<0=One`80
00001@1lhKD00`000000oooo0?ooo`190?ooo`030000003oool0oooo0440oooo00<000000?ooo`3o
ool0303oool001l0oooo00<000000?ooo`3oool0_03oool2000000<0TL7g2P00003O09^kkP800000
;@31^m@00`000000f<o@0=S?d00C0=S?d0030000003Rl]P0h_;H00L0h_;H00<000000=One`3Go]L0
2`3Go]L2000000D0O>6e0P00001=0?ooo`030000003oool0oooo0400oooo00<000000?ooo`3oool0
303oool00200oooo00<000000?ooo`3oool0_@3oool00`000000TL7g0971m`0:0971m`X00000e`2K
^nh00`000000`K_D0<6ke00Z0<6ke0030000003Hcm00f<o@0180f<o@00<000000>;bf03Rl]P01P3R
l]P2000000`0eokG0P00000607cQ]@030000003oool0oooo04h0oooo00<000000?ooo`3oool0?`3o
ool00`000000oooo0?ooo`0<0?ooo`008@3oool200000;h0oooo0P00000D0971m`X00000cP2K^nh2
000002X0`K_D00<000000=S?d03Hcm004@3Hcm000`000000h_;H0>;bf0060>;bf0030000003Go]L0
eokG00X0eokG0P00000607cQ]@800000DP3oool00`000000oooo0?ooo`0n0?ooo`030000003oool0
oooo00`0oooo000S0?ooo`030000003oool0oooo0;d0oooo00<000000971m`2A`OL06`2A`OL:0000
0<H0Vk_^0P00000X0<6ke0030000003Hcm00f<o@0100f<o@00<000000>;bf03Rl]P01P3Rl]P00`00
0000eokG0=One`0:0=One`030000001lhKD0O>6e00D0O>6e00<000000?ooo`3oool0D`3oool00`00
0000oooo0?ooo`0m0?ooo`030000003oool0oooo00`0oooo000T0?ooo`030000003oool0oooo0;d0
oooo00<000000971m`2A`OL0902A`OL:00000;h0Vk_^00<000000<6ke031^m@09@31^m@00`000000
f<o@0=S?d00?0=S?d0030000003Rl]P0h_;H00D0h_;H0P00000;0=One`8000001P1lhKD2000005H0
oooo00<000000?ooo`3oool0?P3oool00`000000oooo0?ooo`0;0?ooo`009@3oool200000;h0oooo
0P00000^0971m`X00000]@2K^nh2000002@0`K_D00<000000=S?d03Hcm003`3Hcm000`000000h_;H
0>;bf0050>;bf0030000003Go]L0eokG00T0eokG0P00000707cQ]@030000003oool0oooo05L0oooo
00<000000?ooo`3oool0?@3oool00`000000oooo0?ooo`0;0?ooo`009`3oool00`000000oooo0?oo
o`2m0?ooo`030000002A`OL0TL7g03D0TL7g2P00002]09^kkP0300000031^m@0`K_D0240`K_D00<0
00000=S?d03Hcm003P3Hcm000`000000h_;H0>;bf0050>;bf0030000003Go]L0eokG00P0eokG0P00
000707cQ]@800000F`3oool00`000000oooo0?ooo`0l0?ooo`030000003oool0oooo00/0oooo000X
0?ooo`030000003oool0oooo0;d0oooo0P00000o0971m`X00000Y02K^nh200000240`K_D00<00000
0=S?d03Hcm003P3Hcm000`000000h_;H0>;bf0040>;bf0030000003Go]L0eokG00L0eokG0P000008
07cQ]@030000003oool0oooo05`0oooo00<000000?ooo`3oool0>`3oool00`000000oooo0?ooo`0;
0?ooo`00:@3oool200000;l0oooo00<000000971m`2A`OL0AP2A`OL;000009/0Vk_^0P00000O0<6k
e0030000003Hcm00f<o@00d0f<o@00<000000>;bf03Rl]P00`3Rl]P2000000P0eokG0P00000807cQ
]@800000H03oool00`000000oooo0?ooo`0j0?ooo`030000003oool0oooo00/0oooo000[0?ooo`03
0000003oool0oooo0;d0oooo0P00001A0971m`X00000T`2K^nh00`000000`K_D0<6ke00L0<6ke003
0000003Hcm00f<o@00`0f<o@00<000000>;bf03Rl]P00`3Rl]P00`000000eokG0=One`070=One`03
0000001lhKD0O>6e00L0O>6e00<000000?ooo`3oool0H03oool00`000000oooo0?ooo`0j0?ooo`03
0000003oool0oooo00/0oooo000/0?ooo`030000003oool0oooo0;h0oooo00<000000971m`2A`OL0
F02A`OL:000008X0Vk_^0P00000L0<6ke0030000003Hcm00f<o@00/0f<o@00<000000>;bf03Rl]P0
0`3Rl]P00`000000eokG0=One`060=One`800000201lhKD2000006@0oooo00<000000?ooo`3oool0
>@3oool00`000000oooo0?ooo`0;0?ooo`00;@3oool200000;l0oooo0P00001R0971m`X00000PP2K
^nh00`000000`K_D0<6ke00I0<6ke0030000003Hcm00f<o@00X0f<o@00<000000>;bf03Rl]P00P3R
l]P2000000L0eokG0P00000907cQ]@030000003oool0oooo06D0oooo00<000000?ooo`3oool0>03o
ool00`000000oooo0?ooo`0;0?ooo`00;`3oool00`000000oooo0?ooo`2n0?ooo`030000002A`OL0
TL7g06T0TL7g2P00001i09^kkP8000006@31^m@00`000000f<o@0=S?d0090=S?d0030000003Rl]P0
h_;H0080h_;H00<000000=One`3Go]L01@3Go]L2000000T0O>6e0P00001Y0?ooo`030000003oool0
oooo03P0oooo00<000000?ooo`3oool02P3oool00300oooo00<000000?ooo`3oool0_P3oool20000
07<0TL7g2P00001a09^kkP8000005`31^m@00`000000f<o@0=S?d0080=S?d0030000003Rl]P0h_;H
0080h_;H00<000000=One`3Go]L0103Go]L2000000X0O>6e00<000000?ooo`3oool0JP3oool00`00
0000oooo0?ooo`0g0?ooo`030000003oool0oooo00X0oooo000a0?ooo`800000`03oool00`000000
TL7g0971m`1j0971m`X00000J@2K^nh00`000000`K_D0<6ke00C0<6ke0030000003Hcm00f<o@00P0
f<o@00<000000>;bf03Rl]P00P3Rl]P00`000000eokG0=One`030=One`8000002P1lhKD2000006d0
oooo00<000000?ooo`3oool0=`3oool00`000000oooo0?ooo`0:0?ooo`00<`3oool00`000000oooo
0?ooo`2n0?ooo`030000002A`OL0TL7g08<0TL7g2P00001P09^kkP8000004`31^m@00`000000f<o@
0=S?d0070=S?d0040000003Rl]P0h_;H0>;bf08000001@3Go]L00`000000O>6e07cQ]@0907cQ]@03
0000003oool0oooo06h0oooo00<000000?ooo`3oool0=P3oool00`000000oooo0?ooo`0:0?ooo`00
=03oool00`000000oooo0?ooo`2n0?ooo`800000S@2A`OL:000005P0Vk_^0P00000A0<6ke0030000
003Hcm00f<o@00H0f<o@00D000000>;bf03Rl]P0h_;H000000050=One`8000002P1lhKD200000780
oooo00<000000?ooo`3oool0=@3oool00`000000oooo0?ooo`0:0?ooo`00=@3oool200000<00oooo
00<000000971m`2A`OL0U02A`OL:00000500Vk_^00<000000<6ke031^m@03P31^m@00`000000f<o@
0=S?d0050=S?d0050000003Rl]P0h_;H0>;bf0000000103Go]L2000000/0O>6e00<000000?ooo`3o
ool0L`3oool00`000000oooo0?ooo`0d0?ooo`030000003oool0oooo00X0oooo000g0?ooo`030000
003oool0oooo0;h0oooo0P00002N0971m`/00000AP2K^nh2000000h0`K_D00<000000=S?d03Hcm00
103Hcm000`000000h_;H0>;bf002000000<0eokG0P00000;07cQ]@800000M`3oool00`000000oooo
0?ooo`0c0?ooo`030000003oool0oooo00X0oooo000h0?ooo`030000003oool0oooo0;l0oooo00<0
00000971m`2A`OL0YP2A`OL:000003h0Vk_^00<000000<6ke031^m@02`31^m@00`000000f<o@0=S?
d0030=S?d0040000003Rl]P0h_;H000000<0eokG0P00000<07cQ]@030000003oool0oooo07L0oooo
00<000000?ooo`3oool0=03oool00`000000oooo0?ooo`090?ooo`00>@3oool200000<00oooo0P00
002`0971m`X00000=@2K^nh2000000/0`K_D00<000000=S?d03Hcm000P3Hcm0010000000h_;H0>;b
f00000020=One`800000301lhKD2000007/0oooo00<000000?ooo`3oool0<`3oool00`000000oooo
0?ooo`090?ooo`00>`3oool00`000000oooo0?ooo`2o0?ooo`030000002A`OL0TL7g0;L0TL7g2P00
000]09^kkP8000002@31^m@00`000000f<o@0=S?d0020=S?d0030000003Rl]P000000080eokG00<0
000007cQ]@1lhKD02`1lhKD00`000000oooo0?ooo`1l0?ooo`030000003oool0oooo0380oooo00<0
00000?ooo`3oool02@3oool003`0oooo00<000000?ooo`3oool0_`3oool200000<40TL7g2P00000U
09^kkP0300000031^m@0`K_D00H0`K_D00@000000=S?d03Hcm00f<o@0`0000000`3Go]L000000000
000<07cQ]@800000P03oool00`000000oooo0?ooo`0a0?ooo`030000003oool0oooo00T0oooo000m
0?ooo`800000`@3oool00`000000TL7g0971m`380971m`X00000702K^nh2000000D0`K_D00@00000
0=S?d03Hcm00f<o@0P0000000`3Go]L000000000000=07cQ]@030000003oool0oooo0840oooo00<0
00000?ooo`3oool0<03oool00`000000oooo0?ooo`090?ooo`00?`3oool00`000000oooo0?ooo`2o
0?ooo`800000dP2A`OL:000001@0Vk_^00<000000<6ke031^m@00P31^m@00`000000f<o@0=S?d004
000000d0O>6e0P0000240?ooo`030000003oool0oooo0300oooo00<000000?ooo`3oool02@3oool0
0400oooo00<000000?ooo`3oool0`03oool00`000000TL7g0971m`3I0971m`X000002`2K^nh20000
0080`K_D00<000000=S?d00000000P00000>07cQ]@030000003oool0oooo08D0oooo00<000000?oo
o`3oool0;`3oool00`000000oooo0?ooo`090?ooo`00@@3oool200000<40oooo00<000000971m`2A
`OL0hP2A`OL:000000<0Vk_^1@00000>07cQ]@800000R@3oool00`000000oooo0?ooo`0^0?ooo`03
0000003oool0oooo00T0oooo00130?ooo`030000003oool0oooo0;l0oooo0P00003/0971m`H00000
3`1lhKD00`000000oooo0?ooo`2:0?ooo`030000003oool0oooo02h0oooo00<000000?ooo`3oool0
203oool004@0oooo00<000000?ooo`3oool0`03oool00`000000TL7g0971m`3Y0971m`D000003P1l
hKD2000008h0oooo00<000000?ooo`3oool0;@3oool00`000000oooo0?ooo`080?ooo`00A@3oool2
00000<40oooo0P00003V0971m`<00000101EdMX00`000000O>6e07cQ]@0;07cQ]@030000003oool0
oooo08h0oooo00<000000?ooo`3oool0;@3oool00`000000oooo0?ooo`080?ooo`00A`3oool00`00
0000oooo0?ooo`300?ooo`030000002A`OL0TL7g0=l0TL7g1000000605GAfP030000001lhKD0O>6e
00X0O>6e0P00002B0?ooo`030000003oool0oooo02`0oooo00<000000?ooo`3oool0203oool004P0
oooo00<000000?ooo`3oool0`03oool200000=`0TL7g0`00000:05GAfP030000001lhKD0O>6e00T0
O>6e00<000000?ooo`3oool0T`3oool00`000000oooo0?ooo`0[0?ooo`030000003oool0oooo00P0
oooo00190?ooo`800000`P3oool00`000000TL7g0971m`3E0971m`@00000301EdMX00`000000O>6e
07cQ]@0807cQ]@800000U`3oool00`000000oooo0?ooo`0Z0?ooo`030000003oool0oooo00P0oooo
001;0?ooo`030000003oool0oooo0<00oooo0P00003B0971m`<000003`1EdMX00`000000O>6e07cQ
]@0807cQ]@030000003oool0oooo09P0oooo00<000000?ooo`3oool0:@3oool00`000000oooo0?oo
o`080?ooo`00C03oool00`000000oooo0?ooo`310?ooo`030000002A`OL0TL7g0</0TL7g1000000B
05GAfP030000001lhKD0O>6e00H0O>6e0P00002K0?ooo`030000003oool0oooo02T0oooo00<00000
0?ooo`3oool0203oool004d0oooo0P0000320?ooo`800000b02A`OL3000001D0EM7J00<0000007cQ
]@1lhKD01P1lhKD00`000000oooo0?ooo`2L0?ooo`030000003oool0oooo02T0oooo00<000000?oo
o`3oool01`3oool004l0oooo00<000000?ooo`3oool0`@3oool00`000000TL7g0971m`310971m`@0
00005`1EdMX00`000000O>6e07cQ]@0507cQ]@800000X03oool00`000000oooo0?ooo`0X0?ooo`03
0000003oool0oooo00L0oooo001@0?ooo`030000003oool0oooo0<40oooo00<000000971m`2A`OL0
_@2A`OL3000001/0EM7J00<0000007cQ]@1lhKD0101lhKD00`000000oooo0?ooo`2Q0?ooo`030000
003oool0oooo02L0oooo00<000000?ooo`3oool01`3oool00540oooo0P0000320?ooo`800000^@2A
`OL4000001d0EM7J00<0000007cQ]@1lhKD00`1lhKD200000:D0oooo00<000000?ooo`3oool09P3o
ool00`000000oooo0?ooo`070?ooo`00D`3oool00`000000oooo0?ooo`310?ooo`030000002A`OL0
TL7g0;<0TL7g0`00000Q05GAfP030000001lhKD0O>6e0080O>6e00<000000?ooo`3oool0Y@3oool0
0`000000oooo0?ooo`0V0?ooo`030000003oool0oooo00L0oooo001D0?ooo`030000003oool0oooo
0<40oooo0P00002_0971m`@000008`1EdMX010000000O>6e07cQ]@1lhKD200000:T0oooo00<00000
0?ooo`3oool09@3oool00`000000oooo0?ooo`070?ooo`00E@3oool200000<<0oooo00<000000971
m`2A`OL0Z@2A`OL3000002H0EM7J00D0000007cQ]@1lhKD0O>6e0000002/0?ooo`030000003oool0
oooo02@0oooo00<000000?ooo`3oool01`3oool005L0oooo00<000000?ooo`3oool0`@3oool20000
0:D0TL7g1000000Y05GAfP040000001lhKD0000000000:h0oooo00<000000?ooo`3oool08`3oool0
0`000000oooo0?ooo`070?ooo`00F03oool00`000000oooo0?ooo`320?ooo`030000002A`OL0TL7g
09l0TL7g0`00000/05GAfP030000001lhKD000000;40oooo00<000000?ooo`3oool08`3oool00`00
0000oooo0?ooo`060?ooo`00F@3oool200000<<0oooo0P00002K0971m`@00000;`1EdMX200000;80
oooo00<000000?ooo`3oool08`3oool00`000000oooo0?ooo`060?ooo`00F`3oool00`000000oooo
0?ooo`320?ooo`030000002A`OL0TL7g09D0TL7g0`00000`05GAfP<00000]@3oool00`000000oooo
0?ooo`0R0?ooo`030000003oool0oooo00H0oooo001L0?ooo`030000003oool0oooo0<80oooo0P00
002A0971m`@00000;P1EdMX500000;T0oooo00<000000?ooo`3oool08@3oool00`000000oooo0?oo
o`060?ooo`00G@3oool200000<@0oooo00<000000971m`2A`OL0R`2A`OL3000002d0EM7J1@00002o
0?ooo`030000003oool0oooo0200oooo00<000000?ooo`3oool01P3oool005l0oooo00<000000?oo
o`3oool0`P3oool00`000000TL7g0971m`260971m`@00000:P1EdMX600000<D0oooo00<000000?oo
o`3oool07`3oool00`000000oooo0?ooo`060?ooo`00H03oool00`000000oooo0?ooo`320?ooo`80
0000P`2A`OL3000002T0EM7J1@00003;0?ooo`030000003oool0oooo01l0oooo00<000000?ooo`3o
ool01P3oool00640oooo0P0000340?ooo`030000002A`OL0TL7g07`0TL7g1000000W05GAfPD00000
d@3oool00`000000oooo0?ooo`0O0?ooo`030000003oool0oooo00D0oooo001S0?ooo`030000003o
ool0oooo0<80oooo0P00001i0971m`<000009P1EdMX500000=L0oooo00<000000?ooo`3oool07P3o
ool00`000000oooo0?ooo`050?ooo`00I03oool00`000000oooo0?ooo`330?ooo`030000002A`OL0
TL7g07<0TL7g0`00000T05GAfPD00000g@3oool00`000000oooo0?ooo`0M0?ooo`030000003oool0
oooo00D0oooo001U0?ooo`800000a03oool2000006l0TL7g1000000R05GAfPD00000hP3oool00`00
0000oooo0?ooo`0M0?ooo`030000003oool0oooo00D0oooo001W0?ooo`030000003oool0oooo0<<0
oooo00<000000971m`2A`OL0J@2A`OL300000200EM7J1P00003X0?ooo`030000003oool0oooo01`0
oooo00<000000?ooo`3oool01@3oool006P0oooo00<000000?ooo`3oool0``3oool2000006D0TL7g
1000000N05GAfPD00000k`3oool00`000000oooo0?ooo`0K0?ooo`030000003oool0oooo00D0oooo
001Y0?ooo`800000a03oool200000640TL7g0`00000M05GAfPD00000m@3oool00`000000oooo0?oo
o`0J0?ooo`030000003oool0oooo00D0oooo001[0?ooo`030000003oool0oooo0<40oooo00@00000
0?ooo`0000000000F`2A`OL4000001/0EM7J1@00003k0?ooo`030000003oool0oooo01T0oooo00<0
00000?ooo`3oool01@3oool006`0oooo00<000000?ooo`3oool0`03oool01@000000oooo0?ooo`3o
ool0000005L0TL7g0`00000J05GAfPD00000o`3oool10?ooo`030000003oool0oooo01X0oooo00<0
00000?ooo`3oool0103oool006d0oooo0P00002o0?ooo`030000003oool0oooo00<0oooo00<00000
0971m`2A`OL0D02A`OL4000001P0EM7J1@00003o0?ooo`L0oooo00<000000?ooo`3oool06@3oool0
0`000000oooo0?ooo`040?ooo`00K`3oool00`000000oooo0?ooo`2l0?ooo`030000003oool0oooo
00@0oooo0P00001=0971m`<000005`1EdMX500000?l0oooo3@3oool00`000000oooo0?ooo`0H0?oo
o`030000003oool0oooo00@0oooo001`0?ooo`030000003oool0oooo0;/0oooo00<000000?ooo`3o
ool01P3oool00`000000TL7g0971m`160971m`@00000501EdMX600000?l0oooo4`3oool00`000000
oooo0?ooo`0G0?ooo`030000003oool0oooo00@0oooo001a0?ooo`800000^`3oool00`000000oooo
0?ooo`070?ooo`800000@`2A`OL3000001<0EM7J1@00003o0?oooaX0oooo00<000000?ooo`3oool0
5P3oool00`000000oooo0?ooo`040?ooo`00L`3oool00`000000oooo0?ooo`2h0?ooo`030000003o
ool0oooo00T0oooo00<000000971m`2A`OL0?02A`OL400000140EM7J1@00003o0?oooal0oooo00<0
00000?ooo`3oool05P3oool00`000000oooo0?ooo`040?ooo`00M03oool00`000000oooo0?ooo`2g
0?ooo`030000003oool0oooo00X0oooo0P00000i0971m`<00000401EdMX500000?l0oooo9@3oool0
0`000000oooo0?ooo`0E0?ooo`030000003oool0oooo00@0oooo001e0?ooo`800000]`3oool00`00
0000oooo0?ooo`0<0?ooo`030000002A`OL0TL7g0380TL7g1000000>05GAfPD00000o`3oool[0?oo
o`030000003oool0oooo01@0oooo00<000000?ooo`3oool0103oool007L0oooo00<000000?ooo`3o
ool0]03oool00`000000oooo0?ooo`0=0?ooo`800000;`2A`OL3000000d0EM7J1@00003o0?oooc40
oooo00<000000?ooo`3oool0503oool00`000000oooo0?ooo`030?ooo`00N03oool00`000000oooo
0?ooo`2c0?ooo`030000003oool0oooo00l0oooo00<000000971m`2A`OL0:02A`OL4000000X0EM7J
1P00003o0?ooocL0oooo00<000000?ooo`3oool04`3oool00`000000oooo0?ooo`030?ooo`00N@3o
ool200000;<0oooo00<000000?ooo`3oool0403oool2000002D0TL7g0`00000905GAfPD00000o`3o
oolm0?ooo`030000003oool0oooo01<0oooo00<000000?ooo`3oool00`3oool007/0oooo00<00000
0?ooo`3oool0/03oool00`000000oooo0?ooo`0B0?ooo`030000002A`OL0TL7g01h0TL7g10000007
05GAfPD00000o`3ooom30?ooo`030000003oool0oooo0180oooo00<000000?ooo`3oool00`3oool0
07`0oooo00<000000?ooo`3oool0[`3oool00`000000oooo0?ooo`0C0?ooo`030000002A`OL0TL7g
01X0TL7g0`00000605GAfPD00000o`3ooom90?ooo`030000003oool0oooo0140oooo00<000000?oo
o`3oool00`3oool007d0oooo0P00002_0?ooo`030000003oool0oooo01@0oooo0P00000F0971m`@0
0000101EdMX500000?l0ooooC`3oool00`000000oooo0?ooo`0@0?ooo`030000003oool0oooo00<0
oooo001o0?ooo`030000003oool0oooo0:`0oooo00<000000?ooo`3oool05P3oool00`000000TL7g
0971m`0@0971m`<000000`1EdMX500000?l0ooooE@3oool00`000000oooo0?ooo`0?0?ooo`030000
003oool0oooo00<0oooo00200?ooo`030000003oool0oooo0:/0oooo00<000000?ooo`3oool05`3o
ool2000000`0TL7g2P00003o0?oooeX0oooo00<000000?ooo`3oool0403oool00`000000oooo0?oo
o`020?ooo`00P@3oool200000:/0oooo00<000000?ooo`3oool06@3oool00`000000TL7g0971m`06
0971m`L00000o`3ooomQ0?ooo`030000003oool0oooo00l0oooo00<000000?ooo`3oool00P3oool0
08<0oooo00<000000?ooo`3oool0Z03oool00`000000oooo0?ooo`0J0?ooo`8000000P2A`OL60000
0?l0ooooI`3oool00`000000oooo0?ooo`0>0?ooo`030000003oool0oooo0080oooo00240?ooo`03
0000003oool0oooo0:L0oooo00<000000?ooo`3oool0703oool300000?l0ooooK@3oool00`000000
oooo0?ooo`0=0?ooo`030000003oool0oooo0080oooo00250?ooo`800000Y`3oool00`000000oooo
0?ooo`3o0?ooohd0oooo00<000000?ooo`3oool0303oool00`000000oooo0?ooo`020?ooo`00Q`3o
ool00`000000oooo0?ooo`2T0?ooo`030000003oool0oooo0?l0ooooS@3oool00`000000oooo0?oo
o`0<0?ooo`030000003oool0oooo0080oooo00280?ooo`030000003oool0oooo0:<0oooo00<00000
0?ooo`3oool0o`3ooon>0?ooo`030000003oool0oooo00/0oooo00<000000?ooo`3oool00P3oool0
08T0oooo0P00002S0?ooo`030000003oool0oooo0?l0ooooS`3oool00`000000oooo0?ooo`0:0?oo
o`030000003oool0oooo0080oooo002;0?ooo`030000003oool0oooo0:00oooo00<000000?ooo`3o
ool0o`3ooon@0?ooo`030000003oool0oooo00X0oooo00<000000?ooo`3oool00@3oool008`0oooo
00<000000?ooo`3oool0W`3oool00`000000oooo0?ooo`3o0?oooi40oooo00<000000?ooo`3oool0
2@3oool00`000000oooo0?ooo`010?ooo`00S@3oool2000009l0oooo00<000000?ooo`3oool0o`3o
oonA0?ooo`030000003oool0oooo00T0oooo00<000000?ooo`3oool00@3oool008l0oooo00<00000
0?ooo`3oool0W03oool00`000000oooo0?ooo`3o0?oooi80oooo00<000000?ooo`3oool0203oool0
0`000000oooo0?ooo`010?ooo`00T03oool00`000000oooo0?ooo`2K0?ooo`030000003oool0oooo
0?l0ooooT`3oool00`000000oooo0?ooo`070?ooo`030000003oool0oooo0040oooo002A0?ooo`80
0000V`3oool00`000000oooo0?ooo`3o0?oooi@0oooo00<000000?ooo`3oool01P3oool00`000000
oooo0?ooo`010?ooo`00T`3oool00`000000oooo0?ooo`2H0?ooo`030000003oool0oooo0?l0oooo
U@3oool00`000000oooo0?ooo`050?ooo`030000003oool0oooo0040oooo002D0?ooo`030000003o
ool0oooo09L0oooo00<000000?ooo`3oool0o`3ooonE0?ooo`030000003oool0oooo00D0oooo00<0
00000?ooo`3oool00@3oool009D0oooo0P00002G0?ooo`030000003oool0oooo0?l0ooooUP3oool0
0`000000oooo0?ooo`050?ooo`4000000@3oool10?ooo`00U`3oool00`000000oooo0?ooo`2D0?oo
o`030000003oool0oooo0?l0ooooU`3oool00`000000oooo0?ooo`040?ooo`4000000@3oool10?oo
o`00V03oool2000009<0oooo00<000000?ooo`3oool0o`3ooonI0?ooo`030000003oool0oooo00<0
oooo0@0000010?ooo`40oooo002J0?ooo`030000003oool0oooo0900oooo00<000000?ooo`3oool0
o`3ooonJ0?ooo`030000003oool0oooo0080oooo0@0000010?ooo`40oooo002K0?ooo`030000003o
ool0oooo08l0oooo00<000000?ooo`3oool0o`3ooonJ0?ooo`030000003oool0oooo0080oooo0@00
00010?ooo`40oooo002L0?ooo`800000S`3oool00`000000oooo0?ooo`3o0?oooi/0oooo00D00000
0?ooo`3oool0oooo000000020?ooo`00WP3oool00`000000oooo0?ooo`2<0?ooo`030000003oool0
oooo0?l0ooooW03oool010000000oooo0?ooo`0000020?ooo`00W`3oool00`000000oooo0?ooo`2;
0?ooo`030000003oool0oooo0?l0ooooW@3oool00`000000oooo000000020?ooo`00X03oool20000
08/0oooo00<000000?ooo`3oool0o`3ooonN0?ooo`030000003oool000000040oooo002R0?ooo`03
0000003oool0oooo08P0oooo00<000000?ooo`3oool0o`3ooonN0?ooo`030000003oool000000040
oooo002S0?ooo`030000003oool0oooo08L0oooo00<000000?ooo`3oool0o`3ooonO0?ooo`800000
0@3oool00:@0oooo0P0000270?ooo`030000003oool0oooo0?l0ooooWP3oool300000040oooo002V
0?ooo`030000003oool0oooo08@0oooo00<000000?ooo`3oool0o`3ooonJ0?ooo`@00000103oool0
0:L0oooo00<000000?ooo`3oool0P`3oool00`000000oooo0?ooo`3o0?oooiH0oooo100000080?oo
o`00Z03oool2000008<0oooo00<000000?ooo`3oool0o`3ooonB0?ooo`@00000303oool00:X0oooo
00<000000?ooo`3oool0P03oool00`000000oooo0?ooo`3o0?ooohh0oooo1000000@0?ooo`00Z`3o
ool00`000000oooo0?ooo`1o0?ooo`030000003oool0oooo0?l0ooooR@3oool5000001@0oooo002/
0?ooo`800000O`3oool00`000000oooo0?ooo`3o0?ooohD0oooo1000000I0?ooo`00[P3oool00`00
0000oooo0?ooo`1l0?ooo`030000003oool0oooo0?l0ooooP@3oool4000001d0oooo002_0?ooo`03
0000003oool0oooo07/0oooo00<000000?ooo`3oool0o`3ooomm0?ooo`@000008@3oool00;00oooo
0P00001k0?ooo`030000003oool0oooo0?l0ooooN@3oool4000002D0oooo002b0?ooo`030000003o
ool0oooo07P0oooo00<000000?ooo`3oool0o`3ooomd0?ooo`D00000:@3oool00;<0oooo00<00000
0?ooo`3oool0M`3oool00`000000oooo0?ooo`3o0?ooog00oooo1000000^0?ooo`00]03oool20000
07L0oooo00<000000?ooo`3oool0o`3ooom/0?ooo`@00000<P3oool00;H0oooo00<000000?ooo`3o
ool0M03oool00`000000oooo0?ooo`3o0?ooofP0oooo1000000f0?ooo`00]`3oool00`000000oooo
0?ooo`1c0?ooo`030000003oool0oooo0?l0ooooH`3oool5000003X0oooo002h0?ooo`800000L`3o
ool00`000000oooo0?ooo`3o0?oooel0oooo1000000o0?ooo`00^P3oool00`000000oooo0?ooo`1`
0?ooo`030000003oool0oooo0?l0ooooF`3oool4000004<0oooo002k0?ooo`030000003oool0oooo
06l0oooo00<000000?ooo`3oool0o`3ooomG0?ooo`@00000A`3oool00;`0oooo0P00001_0?ooo`03
0000003oool0oooo0?l0ooooD`3oool4000004/0oooo002n0?ooo`030000003oool0oooo06`0oooo
00<000000?ooo`3oool0o`3ooom>0?ooo`D00000C`3oool00;l0oooo00<000000?ooo`3oool0J`3o
ool00`000000oooo0?ooo`3o0?ooodX0oooo1000001D0?ooo`00`03oool2000006/0oooo00<00000
0?ooo`3oool0o`3ooom60?ooo`@00000F03oool00<80oooo00<000000?ooo`3oool0I`3oool00`00
0000oooo0?ooo`3o0?oood<0oooo1000001L0?ooo`00``3oool00`000000oooo0?ooo`1V0?ooo`03
0000003oool0oooo0?l0oooo?`3oool400000600oooo00340?ooo`800000IP3oool00`000000oooo
0?ooo`3o0?ooocX0oooo1@00001T0?ooo`00aP3oool00`000000oooo0?ooo`1S0?ooo`030000003o
ool0oooo0?l0oooo=P3oool4000006T0oooo00370?ooo`030000003oool0oooo0680oooo00<00000
0?ooo`3oool0o`3ooolb0?ooo`@00000K@3oool00<P0oooo0P00001R0?ooo`030000003oool0oooo
0?l0oooo;P3oool400000740oooo003:0?ooo`030000003oool0oooo05l0oooo00<000000?ooo`3o
ool0o`3ooolZ0?ooo`@00000M@3oool00</0oooo00<000000?ooo`3oool0GP3oool00`000000oooo
0?ooo`3o0?ooobD0oooo1@00001i0?ooo`00c03oool2000005h0oooo00<000000?ooo`3oool0o`3o
oolQ0?ooo`@00000OP3oool00<h0oooo00<000000?ooo`3oool0F`3oool00`000000oooo0?ooo`3o
0?oooad0oooo100000220?ooo`00c`3oool00`000000oooo0?ooo`1J0?ooo`030000003oool0oooo
0?l0oooo6@3oool4000008H0oooo003@0?ooo`800000FP3oool00`000000oooo0?ooo`3o0?oooa@0
oooo1@00002:0?ooo`00dP3oool00`000000oooo0?ooo`1G0?ooo`030000003oool0oooo0?l0oooo
403oool4000008l0oooo003C0?ooo`030000003oool0oooo05H0oooo00<000000?ooo`3oool0o`3o
ool<0?ooo`@00000T`3oool00=@0oooo0P00001F0?ooo`030000003oool0oooo0?l0oooo203oool4
000009L0oooo003F0?ooo`030000003oool0oooo05<0oooo00<000000?ooo`3oool0o`3oool40?oo
o`@00000V`3oool00=L0oooo00<000000?ooo`3oool0DP3oool00`000000oooo0?ooo`3n0?ooo`D0
0000W`3oool00=P0oooo0P00001B0?ooo`030000003oool0oooo0?X0oooo1000002T0?ooo`00fP3o
ool00`000000oooo0?ooo`1?0?ooo`030000003oool0oooo0?H0oooo1000002X0?ooo`00f`3oool0
0`000000oooo0?ooo`1>0?ooo`030000003oool0oooo0?80oooo1000002/0?ooo`00g03oool20000
04h0oooo00<000000?ooo`3oool0kP3oool400000;00oooo003N0?ooo`030000003oool0oooo04/0
oooo00<000000?ooo`3oool0j@3oool500000;@0oooo003O0?ooo`030000003oool0oooo04X0oooo
00<000000?ooo`3oool0i@3oool400000;T0oooo003P0?ooo`800000BP3oool00`000000oooo0?oo
o`3Q0?ooo`@00000_@3oool00>80oooo00<000000?ooo`3oool0A`3oool00`000000oooo0?ooo`3M
0?ooo`@00000`@3oool00><0oooo00<000000?ooo`3oool0AP3oool00`000000oooo0?ooo`3I0?oo
o`@00000a@3oool00>@0oooo0P0000160?ooo`030000003oool0oooo0=@0oooo1@0000390?ooo`00
iP3oool00`000000oooo0?ooo`130?ooo`030000003oool0oooo0=00oooo1000003>0?ooo`00i`3o
ool00`000000oooo0?ooo`120?ooo`030000003oool0oooo0<`0oooo1000003B0?ooo`00j03oool2
00000480oooo00<000000?ooo`3oool0b03oool400000=H0oooo003Z0?ooo`030000003oool0oooo
03l0oooo00<000000?ooo`3oool0``3oool500000=X0oooo003[0?ooo`030000003oool0oooo03d0
oooo00<000000?ooo`3oool0`03oool400000=l0oooo003/0?ooo`800000?@3oool00`000000oooo
0?ooo`2l0?ooo`@00000h`3oool00>h0oooo00<000000?ooo`3oool0>P3oool00`000000oooo0?oo
o`2h0?ooo`@00000i`3oool00>l0oooo00<000000?ooo`3oool0>@3oool00`000000oooo0?ooo`2d
0?ooo`@00000j`3oool00?00oooo0P00000i0?ooo`030000003oool0oooo0:l0oooo1@00003_0?oo
o`00lP3oool00`000000oooo0?ooo`0f0?ooo`030000003oool0oooo0:/0oooo1000003d0?ooo`00
l`3oool00`000000oooo0?ooo`0e0?ooo`030000003oool0oooo0:L0oooo1000003h0?ooo`00m03o
ool2000003D0oooo00<000000?ooo`3oool0X`3oool400000?`0oooo003f0?ooo`030000003oool0
oooo0380oooo00<000000?ooo`3oool0W`3oool400000?l0oooo0@3oool00?L0oooo00<000000?oo
o`3oool0<@3oool00`000000oooo0?ooo`2J0?ooo`D00000o`3oool50?ooo`00n03oool200000340
oooo00<000000?ooo`3oool0UP3oool400000?l0oooo2P3oool00?X0oooo00<000000?ooo`3oool0
;P3oool00`000000oooo0?ooo`2B0?ooo`@00000o`3oool>0?ooo`00n`3oool00`000000oooo0?oo
o`0]0?ooo`030000003oool0oooo08h0oooo1000003o0?oooa80oooo003l0?ooo`800000;@3oool0
0`000000oooo0?ooo`2:0?ooo`@00000o`3ooolF0?ooo`00oP3oool00`000000oooo0?ooo`0Z0?oo
o`030000003oool0oooo08D0oooo1@00003o0?oooaX0oooo003o0?ooo`030000003oool0oooo02T0
oooo00<000000?ooo`3oool0P@3oool400000?l0oooo7`3oool00?l0oooo0@3oool2000002T0oooo
00<000000?ooo`3oool0O@3oool400000?l0oooo8`3oool00?l0oooo0`3oool00`000000oooo0?oo
o`0V0?ooo`030000003oool0oooo07T0oooo1000003o0?ooobL0oooo003o0?ooo`@0oooo00<00000
0?ooo`3oool09@3oool00`000000oooo0?ooo`1d0?ooo`D00000o`3oool[0?ooo`00o`3oool50?oo
o`8000009@3oool00`000000oooo0?ooo`1`0?ooo`@00000o`3oool`0?ooo`00o`3oool70?ooo`03
0000003oool0oooo0280oooo00<000000?ooo`3oool0K03oool400000?l0oooo=03oool00?l0oooo
203oool00`000000oooo0?ooo`0Q0?ooo`030000003oool0oooo06P0oooo1000003o0?ooocP0oooo
003o0?ooo`T0oooo0P00000Q0?ooo`030000003oool0oooo06@0oooo1000003o0?oooc`0oooo003o
0?ooo`/0oooo00<000000?ooo`3oool07P3oool00`000000oooo0?ooo`1O0?ooo`D00000o`3ooom0
0?ooo`00o`3oool<0?ooo`030000003oool0oooo01d0oooo00<000000?ooo`3oool0F`3oool40000
0?l0ooooA@3oool00?l0oooo3@3oool2000001d0oooo00<000000?ooo`3oool0E`3oool400000?l0
ooooB@3oool00?l0oooo3`3oool00`000000oooo0?ooo`0J0?ooo`030000003oool0oooo05<0oooo
1000003o0?ooodd0oooo003o0?oooa00oooo00<000000?ooo`3oool06@3oool00`000000oooo0?oo
o`1?0?ooo`@00000o`3ooomA0?ooo`00o`3ooolA0?ooo`8000006@3oool00`000000oooo0?ooo`1:
0?ooo`D00000o`3ooomE0?ooo`00o`3ooolC0?ooo`030000003oool0oooo01H0oooo00<000000?oo
o`3oool0AP3oool400000?l0ooooFP3oool00?l0oooo503oool00`000000oooo0?ooo`0E0?ooo`03
0000003oool0oooo0480oooo1000003o0?oooeh0oooo003o0?oooaD0oooo0P00000E0?ooo`030000
003oool0oooo03h0oooo1000003o0?ooof80oooo003o0?oooaL0oooo00<000000?ooo`3oool04@3o
ool00`000000oooo0?ooo`0k0?ooo`@00000o`3ooomV0?ooo`00o`3ooolH0?ooo`030000003oool0
oooo0100oooo00<000000?ooo`3oool0=P3oool500000?l0ooooJP3oool00?l0oooo6@3oool20000
0100oooo00<000000?ooo`3oool0<P3oool400000?l0ooooK`3oool00?l0oooo6`3oool00`000000
oooo0?ooo`0=0?ooo`030000003oool0oooo02h0oooo1000003o0?ooog<0oooo003o0?oooa`0oooo
00<000000?ooo`3oool0303oool00`000000oooo0?ooo`0Z0?ooo`@00000o`3ooomg0?ooo`00o`3o
oolM0?ooo`800000303oool00`000000oooo0?ooo`0U0?ooo`D00000o`3ooomk0?ooo`00o`3ooolO
0?ooo`030000003oool0oooo00T0oooo00<000000?ooo`3oool08@3oool400000?l0ooooP03oool0
0?l0oooo803oool00`000000oooo0?ooo`080?ooo`030000003oool0oooo01d0oooo1000003o0?oo
oh@0oooo003o0?ooob40oooo0P0000080?ooo`030000003oool0oooo01T0oooo1000003o0?ooohP0
oooo003o0?ooob<0oooo00<000000?ooo`3oool01@3oool00`000000oooo0?ooo`0E0?ooo`@00000
o`3ooon<0?ooo`00o`3ooolT0?ooo`030000003oool0oooo00@0oooo00<000000?ooo`3oool0403o
ool500000?l0ooooT03oool00?l0oooo9@3oool2000000@0oooo00<000000?ooo`3oool0303oool4
00000?l0ooooU@3oool00?l0oooo9`3oool01@000000oooo0?ooo`3oool0000000X0oooo1000003o
0?oooiT0oooo003o0?ooobP0oooo00@000000?ooo`3oool000001P3oool400000?l0ooooW@3oool0
0?l0oooo:@3oool300000080oooo1000003o0?oooj40oooo003o0?ooob/0oooo0`00003o0?ooojD0
oooo0000\
\>"],
  ImageRangeCache->{{{0, 720}, {745.938, 0}} -> {0.031044, -4.60181*^-06, \
0.00123383, 0.00123383}}]
}, Open  ]],

Cell[BoxData[
    TagBox[\(\[SkeletonIndicator]  Graphics3D  \[SkeletonIndicator]\),
      False,
      Editable->False]], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    \(Position[F, \ _?\((Function[n, n\  != \ 0])\)]\)], "Input"],

Cell[BoxData[
    \({{1, 1}, {2, 2}, {3, 3}, {4, 4}, {5, 5}, {6, 6}, {7, 6}, {7, 8}, {7, 
        15}, {7, 16}, {7, 18}, {7, 19}, {7, 20}, {7, 23}, {8, 7}, {8, 9}, {8, 
        19}, {8, 20}, {9, 8}, {9, 10}, {9, 14}, {9, 15}, {9, 19}, {9, 
        20}, {9, 21}, {9, 23}, {10, 9}, {10, 11}, {10, 21}, {10, 23}, {11, 
        10}, {11, 12}, {11, 17}, {11, 18}, {11, 21}, {11, 22}, {11, 23}, {12, 
        3}, {12, 11}, {12, 13}, {12, 22}, {13, 4}, {13, 12}, {13, 14}, {13, 
        16}, {13, 17}, {13, 20}, {13, 21}, {13, 22}, {14, 9}, {14, 13}, {14, 
        20}, {14, 21}, {15, 7}, {15, 9}, {15, 19}, {15, 23}, {16, 5}, {16, 
        7}, {16, 13}, {16, 20}, {17, 11}, {17, 13}, {17, 21}, {17, 22}, {18, 
        1}, {18, 7}, {18, 11}, {18, 23}, {19, 7}, {19, 8}, {19, 9}, {19, 
        15}, {20, 7}, {20, 8}, {20, 9}, {20, 13}, {20, 14}, {20, 16}, {21, 
        9}, {21, 10}, {21, 11}, {21, 13}, {21, 14}, {21, 17}, {22, 11}, {22, 
        12}, {22, 13}, {22, 17}, {23, 7}, {23, 9}, {23, 10}, {23, 11}, {23, 
        15}, {23, 18}}\)], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    \(mm\)], "Input"],

Cell[BoxData[
    \({{0, 1, 0, 0, 0, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, 
        0}, {1, 0, 1, 0, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 
        0, 0}, {0, 1, 0, 1, 0, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, 0, 0, 0, 0, 
        0, 0, 0}, {0, 0, 1, 0, 1, 0, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, 0, 0, 
        0, 0, 0, 0}, {0, 0, 0, 1, 0, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 0, 0, 
        0, 0, 0, 0, 0}, {1, 0, 0, 0, 1, 0, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 
        0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 1, 0, 1, 0, 0, 0, 0, 0, 0, 1, 1, 
        0, 1, 1, 1, 0, 0, 1}, {0, 0, 0, 0, 0, 0, 1, 0, 1, 0, 0, 0, 0, 0, 0, 
        0, 0, 0, 1, 1, 0, 0, 0}, {0, 0, 0, 0, 0, 0, 0, 1, 0, 1, 0, 0, 0, 1, 
        1, 0, 0, 0, 1, 1, 1, 0, 1}, {0, 0, 0, 0, 0, 0, 0, 0, 1, 0, 1, 0, 0, 
        0, 0, 0, 0, 0, 0, 1, 0, 0, 1}, {0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 0, 1, 
        0, 0, 0, 0, 1, 1, 0, 0, 1, 1, 1}, {0, 0, 1, 0, 0, 0, 0, 0, 0, 0, 1, 
        0, 1, 0, 0, 0, 0, 0, 0, 0, 0, 1, 0}, {0, 0, 0, 1, 0, 0, 0, 0, 0, 0, 
        0, 1, 0, 1, 0, 1, 1, 0, 0, 1, 1, 1, 0}, {0, 0, 0, 0, 0, 0, 0, 0, 1, 
        0, 0, 0, 1, 0, 0, 0, 0, 0, 0, 1, 1, 0, 0}, {0, 0, 0, 0, 0, 0, 1, 0, 
        1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 1}, {0, 0, 0, 0, 1, 0, 1, 
        0, 0, 0, 0, 0, 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0}, {0, 0, 0, 0, 0, 0, 
        0, 0, 0, 0, 1, 0, 1, 0, 0, 0, 0, 0, 0, 0, 1, 1, 0}, {1, 0, 0, 0, 0, 
        0, 1, 0, 0, 0, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1}, {0, 0, 0, 0, 
        0, 0, 1, 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, 0, 0, 0, 0}, {0, 0, 0, 
        0, 0, 0, 1, 1, 1, 0, 0, 0, 1, 1, 0, 1, 0, 0, 0, 0, 0, 0, 0}, {0, 0, 
        0, 0, 0, 0, 0, 0, 1, 1, 1, 0, 1, 1, 0, 0, 1, 0, 0, 0, 0, 0, 0}, {0, 
        0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 1, 1, 0, 0, 0, 1, 0, 0, 0, 0, 0, 
        0}, {0, 0, 0, 0, 0, 0, 1, 1, 1, 1, 0, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, 
        0, 0}}\)], "Output"]
}, Open  ]]
},
FrontEndVersion->"5.0 for Microsoft Windows",
ScreenRectangle->{{0, 1024}, {0, 695}},
WindowSize->{907, 622},
WindowMargins->{{37, Automatic}, {2, Automatic}},
PrintingCopies->1,
PrintingPageRange->{Automatic, Automatic}
]

(*******************************************************************
Cached data follows.  If you edit this Notebook file directly, not
using Mathematica, you must remove the line containing CacheID at
the top of  the file.  The cache data will then be recreated when
you save this file from within Mathematica.
*******************************************************************)

(*CellTagsOutline
CellTagsIndex->{}
*)

(*CellTagsIndex
CellTagsIndex->{}
*)

(*NotebookFileOutline
Notebook[{
Cell[1754, 51, 168, 4, 30, "Input"],
Cell[1925, 57, 4830, 85, 413, "Text"],
Cell[6758, 144, 557, 13, 121, "Input"],
Cell[7318, 159, 563, 17, 41, "Text"],

Cell[CellGroupData[{
Cell[7906, 180, 503, 12, 121, "Input"],
Cell[8412, 194, 213, 3, 48, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[8662, 202, 606, 13, 157, "Input"],
Cell[9271, 217, 258, 4, 67, "Output"]
}, Open  ]],
Cell[9544, 224, 770, 15, 52, "Text"],

Cell[CellGroupData[{
Cell[10339, 243, 809, 22, 109, "Input"],
Cell[11151, 267, 147, 2, 44, "Output"]
}, Open  ]],
Cell[11313, 272, 265, 5, 33, "Text"],

Cell[CellGroupData[{
Cell[11603, 281, 451, 13, 147, "Input"],
Cell[12057, 296, 142, 2, 47, "Output"]
}, Open  ]],
Cell[12214, 301, 1455, 19, 109, "Text"],

Cell[CellGroupData[{
Cell[13694, 324, 897, 16, 270, "Input"],
Cell[14594, 342, 181, 3, 24, "Message"],
Cell[14778, 347, 181, 3, 24, "Message"]
}, Open  ]],
Cell[14974, 353, 134, 2, 33, "Text"],

Cell[CellGroupData[{
Cell[15133, 359, 65, 1, 30, "Input"],
Cell[15201, 362, 26337, 431, 296, 1407, 119, "GraphicsData", "PostScript", \
"Graphics"],
Cell[41541, 795, 130, 3, 29, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[41708, 803, 55, 1, 30, "Input"],
Cell[41766, 806, 30172, 478, 296, 1463, 119, "GraphicsData", "PostScript", \
"Graphics"],
Cell[71941, 1286, 130, 3, 29, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[72108, 1294, 71, 1, 30, "Input"],
Cell[72182, 1297, 13874, 276, 296, 1449, 118, "GraphicsData", "PostScript", \
"Graphics"]
}, Open  ]],

Cell[CellGroupData[{
Cell[86093, 1578, 279, 4, 50, "Input"],
Cell[86375, 1584, 269, 4, 48, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[86681, 1593, 350, 5, 76, "Input"],
Cell[87034, 1600, 320, 4, 76, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[87391, 1609, 187, 3, 48, "Input"],
Cell[87581, 1614, 150, 2, 47, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[87768, 1621, 87, 1, 30, "Input"],
Cell[87858, 1624, 26388, 438, 296, 1458, 126, "GraphicsData", "PostScript", \
"Graphics"],
Cell[114249, 2064, 130, 3, 29, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[114416, 2072, 55, 1, 30, "Input"],
Cell[114474, 2075, 29353, 475, 296, 1494, 126, "GraphicsData", "PostScript", \
"Graphics"],
Cell[143830, 2552, 130, 3, 29, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[143997, 2560, 63, 1, 30, "Input"],
Cell[144063, 2563, 28238, 460, 296, 1530, 126, "GraphicsData", "PostScript", \
"Graphics"],
Cell[172304, 3025, 130, 3, 29, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[172471, 3033, 73, 1, 30, "Input"],
Cell[172547, 3036, 32102, 508, 296, 1530, 126, "GraphicsData", "PostScript", \
"Graphics"],
Cell[204652, 3546, 130, 3, 29, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[204819, 3554, 350, 5, 76, "Input"],
Cell[205172, 3561, 320, 4, 76, "Output"]
}, Open  ]],
Cell[205507, 3568, 462, 6, 52, "Text"],
Cell[205972, 3576, 2750, 57, 542, "Input"],
Cell[208725, 3635, 2065, 36, 329, "Input"],

Cell[CellGroupData[{
Cell[210815, 3675, 87, 1, 30, "Input"],
Cell[210905, 3678, 16317, 445, 296, 2488, 270, "GraphicsData", "PostScript", \
"Graphics"]
}, Open  ]],

Cell[CellGroupData[{
Cell[227259, 4128, 55, 1, 30, "Input"],
Cell[227317, 4131, 22857, 517, 296, 3188, 270, "GraphicsData", "PostScript", \
"Graphics"]
}, Open  ]],

Cell[CellGroupData[{
Cell[250211, 4653, 232, 4, 30, "Input"],
Cell[250446, 4659, 25668, 552, 296, 3212, 270, "GraphicsData", "PostScript", \
"Graphics"]
}, Open  ]],

Cell[CellGroupData[{
Cell[276151, 5216, 77, 1, 30, "Input"],
Cell[276231, 5219, 25613, 551, 296, 3206, 270, "GraphicsData", "PostScript", \
"Graphics"]
}, Open  ]],
Cell[301859, 5773, 1506, 22, 128, "Text"],
Cell[303368, 5797, 1533, 28, 690, "Input"],
Cell[304904, 5827, 1800, 38, 128, "Text"],
Cell[306707, 5867, 482, 11, 105, "Input"],
Cell[307192, 5880, 354, 9, 32, "Text"],
Cell[307549, 5891, 697, 15, 233, "Input"],
Cell[308249, 5908, 886, 16, 233, "Input"],
Cell[309138, 5926, 1454, 26, 233, "Input"],
Cell[310595, 5954, 1885, 40, 209, "Text"],

Cell[CellGroupData[{
Cell[312505, 5998, 58, 1, 30, "Input"],
Cell[312566, 6001, 25658, 552, 296, 3214, 270, "GraphicsData", "PostScript", \
"Graphics"]
}, Open  ]],
Cell[338239, 6556, 1053, 18, 71, "Text"],
Cell[339295, 6576, 1739, 29, 710, "Input"],
Cell[341037, 6607, 131, 2, 33, "Text"],

Cell[CellGroupData[{
Cell[341193, 6613, 66, 1, 30, "Input"],
Cell[341262, 6616, 23394, 524, 296, 3214, 270, "GraphicsData", "PostScript", \
"Graphics"]
}, Open  ]],
Cell[364671, 7143, 261, 4, 52, "Text"],

Cell[CellGroupData[{
Cell[364957, 7151, 63, 1, 30, "Input"],
Cell[365023, 7154, 26634, 564, 296, 3198, 270, "GraphicsData", "PostScript", \
"Graphics"]
}, Open  ]],
Cell[391672, 7721, 973, 13, 90, "Text"],
Cell[392648, 7736, 286, 5, 130, "Input"],
Cell[392937, 7743, 469, 6, 52, "Text"],

Cell[CellGroupData[{
Cell[393431, 7753, 537, 9, 110, "Input"],
Cell[393971, 7764, 23218, 522, 296, 3157, 270, "GraphicsData", "PostScript", \
"Graphics"]
}, Open  ]],
Cell[417204, 8289, 97175, 2842, 2031, "Text"],
Cell[514382, 11133, 2001, 26, 470, "Input"],

Cell[CellGroupData[{
Cell[516408, 11163, 51, 1, 30, "Input"],
Cell[516462, 11166, 1883, 25, 447, "Output"]
}, Open  ]],
Cell[518360, 11194, 2219, 29, 470, "Input"],

Cell[CellGroupData[{
Cell[520604, 11227, 2228, 29, 470, "Input"],
Cell[522835, 11258, 4158, 67, 529, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[527030, 11330, 43, 1, 30, "Input"],
Cell[527076, 11333, 195, 3, 42, "Message"],
Cell[527274, 11338, 2254, 29, 706, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[529565, 11372, 2253, 29, 708, "Input"],
Cell[531821, 11403, 2377, 45, 352, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[534235, 11453, 49, 1, 30, "Input"],
Cell[534287, 11456, 441, 7, 48, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[534765, 11468, 539, 9, 90, "Input"],
Cell[535307, 11479, 856, 27, 377, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[536200, 11511, 43, 1, 30, "Input"],
Cell[536246, 11514, 361, 6, 80, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[536644, 11525, 86, 1, 30, "Input"],
Cell[536733, 11528, 33477, 764, 296, 3052, 384, "GraphicsData", "PostScript", \
"Graphics"],
Cell[570213, 12294, 130, 3, 29, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[570380, 12302, 101, 2, 30, "Input"],
Cell[570484, 12306, 38496, 824, 296, 3462, 387, "GraphicsData", "PostScript", \
"Graphics"],
Cell[608983, 13132, 130, 3, 29, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[609150, 13140, 111, 2, 30, "Input"],
Cell[609264, 13144, 52893, 993, 296, 4182, 387, "GraphicsData", "PostScript", \
"Graphics"],
Cell[662160, 14139, 130, 3, 29, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[662327, 14147, 211, 4, 30, "Input"],
Cell[662541, 14153, 131016, 1956, 625, 4322, 387, "GraphicsData", \
"PostScript", "Graphics"],
Cell[793560, 16111, 130, 3, 29, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[793727, 16119, 56, 1, 30, "Input"],

Cell[CellGroupData[{
Cell[793808, 16124, 92790, 1774, 781, 8890, 734, "GraphicsData", \
"PostScript", "Graphics"],
Cell[886601, 17900, 113355, 1594, 781, 2828, 225, "GraphicsData", \
"PostScript", "Graphics"],
Cell[999959, 19496, 171665, 2416, 781, 3925, 341, "GraphicsData", \
"PostScript", "Graphics"],
Cell[1171627, 21914, 143524, 1999, 807, 4756, 281, "GraphicsData", \
"PostScript", "Graphics"]
}, Open  ]],
Cell[1315166, 23916, 132, 3, 29, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[1315335, 23924, 79, 1, 30, "Input"],
Cell[1315417, 23927, 1045, 14, 162, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[1316499, 23946, 35, 1, 30, "Input"],
Cell[1316537, 23949, 1883, 25, 447, "Output"]
}, Open  ]]
}
]
*)



(*******************************************************************
End of Mathematica Notebook file.
*******************************************************************)

