(***********************************************************************

                    Mathematica-Compatible Notebook

This notebook can be used on any computer system with Mathematica 3.0,
MathReader 3.0, or any compatible application. The data for the notebook 
starts with the line of stars above.

To get the notebook into a Mathematica-compatible application, do one of 
the following:

* Save the data starting with the line of stars above into a file
  with a name ending in .nb, then open the file inside the application;

* Copy the data starting with the line of stars above to the
  clipboard, then use the Paste menu command inside the application.

Data for notebooks contains only printable 7-bit ASCII and can be
sent directly in email or through ftp in text mode.  Newlines can be
CR, LF or CRLF (Unix, Macintosh or MS-DOS style).

NOTE: If you modify the data for this notebook not in a Mathematica-
compatible application, you must delete the line below containing the 
word CacheID, otherwise Mathematica-compatible applications may try to 
use invalid cache data.

For more information on notebooks and Mathematica-compatible 
applications, contact Wolfram Research:
  web: http://www.wolfram.com
  email: info@wolfram.com
  phone: +1-217-398-0700 (U.S.)

Notebook reader applications are available free of charge from 
Wolfram Research.
***********************************************************************)

(*CacheID: 232*)


(*NotebookFileLineBreakTest
NotebookFileLineBreakTest*)
(*NotebookOptionsPosition[     51969,       1122]*)
(*NotebookOutlinePosition[     52680,       1147]*)
(*  CellTagsIndexPosition[     52636,       1143]*)
(*WindowFrame->Normal*)



Notebook[{
Cell[BoxData[
    \(\(\:ff11\:ff10\:ff0e\) 
      \:ff16\:3000\:5177\:4f53\:7684\:554f\:984c\:3078\:306e\:5fdc\:7528\)], 
  "Input"],

Cell[TextData[
"\:3000\:30b0\:30e9\:30d5\:7406\:8ad6\:306f\:591a\:304f\:306e\:5177\:4f53\
\:7684\:554f\:984c\:306b\:5fdc\:7528\:3055\:308c\:3001\:8c4a\:304b\:306a\:6210\
\:679c\:3092\:4e0a\:3052\:3066\:304d\:305f\:3002\:3053\:3053\:3067\:306f\:3001\
\:6700\:77ed\:5f84\:8def\:554f\:984c\:3001\:7d50\:5408\:554f\:984c\:3001\:6700\
\:5927\:30de\:30c3\:30c1\:30f3\:30b0\:554f\:984c\:3001\:5de1\:56de\:30bb\:30fc\
\:30eb\:30b9\:554f\:984c\:306b\:3064\:3044\:3066\:8003\:3048\:308b\:3002\n\
\:3000\:3053\:306e\:7bc0\:3067\:8003\:3048\:308b\:30b0\:30e9\:30d5\:306f\:3001\
\:3059\:3079\:3066\:8377\:91cd\:30b0\:30e9\:30d5\:3067\:3042\:308b\:3002\:30b0\
\:30e9\:30d5\:ff27\:306b\:3001\:8fba\:306e\:96c6\:5408E(G)\:304b\:3089\:5b9f\
\:6570\:3078\:306e\:5199\:50cf\:ff57\:304c\:5b9a\:3081\:3089\:308c\:3066\:3044\
\:308b\:3068\:304d\:3001(G, w) \:3092\:8377\:91cd\:30b0\:30e9\:30d5(weighted \
graph)\:3068\:547c\:3076\:3002\:ff27\:306e\:8fba (u,v) \:306b\:5bfe\:3057\
\:3066\:3001w((u,w)) \:3092w(u,v) \:3068\:66f8\:3044\:3066\:3001\:8fba (u,v) \
\:306e\:8377\:91cd\:3068\:8a00\:3046\:3002\:307e\:305f\:3001i \:756a\:76ee\
\:306e\:9802\:70b9\:3068j \:756a\:76ee\:306e\:9802\:70b9\:306e\:9593\:306e\
\:8fba\:306e\:8377\:91cd\:3092 w(i,j) \:3068\:3082\:8868\:3059\:3002",
Cell[BoxData[
    \(TraditionalForm\`\(\n \)\)]]], "Text"],

Cell[TextData[{
  "\:3000",
  Cell[BoxData[
      \(TraditionalForm\`\(\(G\_w = \)\ \)\)]],
  "(G, w) \:3092\:ff11\:3064\:306e\:8377\:91cd\:30b0\:30e9\:30d5\:3068\:3059\
\:308b\:3002\:3053\:306e\:3068\:304d\:3001",
  Cell[BoxData[
      \(TraditionalForm\`G\_w\)]],
  "\:306e\:96a3\:63a5\:884c\:5217 ",
  Cell[BoxData[
      \(TraditionalForm\`A(G\_w)\)]],
  "\:ff1d",
  Cell[BoxData[
      \(TraditionalForm\`{a\_ij}\)]],
  "\:3092",
  Cell[BoxData[
      \(TraditionalForm\`a\_ij\)]],
  "\:ff1dw(i,j) \:3067\:8868\:3059\:3002\n\:3000",
  Cell[BoxData[
      \(TraditionalForm\`\(\:307e\:305f\:3001\) G\_w\)]],
  "\:306e\:90e8\:5206\:30b0\:30e9\:30d5\:3092",
  Cell[BoxData[
      \(TraditionalForm\`H\_w\)]],
  "\:3068\:3059\:308b\:3068\:304d\:3001",
  Cell[BoxData[
      \(TraditionalForm\`H\_w\)]],
  "\:306e\:8377\:91cdw(",
  Cell[BoxData[
      \(TraditionalForm\`H\_w\)]],
  ") \:3092",
  Cell[BoxData[
      \(TraditionalForm\`H\_w\)]],
  "\:306b\:542b\:307e\:308c\:308b\:8fba\:306e\:8377\:91cd\:306e\:7dcf\:548c\
\:3068\:3059\:308b\:3002"
}], "Text"],

Cell[BoxData[
    \(\(\(\:ff11\:ff10\:ff0e\) \:ff16\:ff0e\) 
      \:ff11\:3000\:6700\:77ed\:5f84\:8def\:554f\:984c\)], "Input"],

Cell[TextData[
"\:3000\:4e16\:754c\:306e9\:5927\:9996\:90fd\:3001\:6771\:4eac\:3001\:5317\
\:4eac\:3001\:30b7\:30f3\:30ac\:30dd\:30fc\:30eb\:3001\:30e2\:30b9\:30af\:30ef\
\:3001\:30ad\:30e3\:30f3\:30d9\:30e9\:3001\:30ed\:30f3\:30c9\:30f3\:3001\:30d1\
\:30ea\:3001\:30ef\:30b7\:30f3\:30c8\:30f3\:3001\:30e1\:30ad\:30b7\:30b3\:30fb\
\:30b7\:30c6\:30a3\:306e\:9593\:306e\:76f4\:7dda\:8ddd\:96e2\:306f\:3001\:6b21\
\:306e\:884c\:5217\:3067\:4e0e\:3048\:3089\:308c\:308b\:3002\:305f\:3060\:3057\
\:3001\:6570\:5024\:306e\:5358\:4f4d\:306f\:30ad\:30ed\:30fb\:30e1\:30fc\:30c8\
\:30eb\:3068\:3059\:308b\:3002"], "Text"],

Cell[BoxData[
    RowBox[{"mm", "=", 
      TagBox[
        RowBox[{"(", GridBox[{
              {"0", "2104", "5317", "7502", "7924", "9585", "9738", "10925", 
                "11319"},
              {"2104", "0", "4465", "5809", "8987", "8160", "8236", "11170", 
                "12478"},
              {"5317", "4465", "0", "8426", "6210", "10860", "10743", 
                "15555", "16623"},
              {"7502", "5809", "8426", "0", "14477", "2506", "2492", "7842", 
                "10740"},
              {"7924", "8987", "6210", "14477", "0", "16984", "16924", 
                "15943", "13173"},
              {"9585", "8160", "10860", "2506", "16984", "0", "341", "5915", 
                "8947"},
              {"9738", "8236", "10743", "2492", "16924", "341", "0", "6180", 
                "9213"},
              {"10925", "11170", "15555", "7842", "15943", "5915", "6180", 
                "0", "3033"},
              {"11319", "12478", "16623", "10740", "13173", "8947", "9213", 
                "3033", "0"}
              }], ")"}],
        (MatrixForm[ #]&)]}]], "Input"],

Cell[TextData[
"\:3000\:3053\:306e\:3068\:304d\:3001\:6b21\:306e\:3088\:3046\:306a\:554f\
\:984c\:3092\:8003\:3048\:308b\:3002\n\[CloseCurlyDoubleQuote]\:98db\:884c\
\:6a5f\:306e\:6700\:9577\:822a\:7d9a\:8ddd\:96e2\:304c10000Km\:3067\:3042\
\:308b\:3068\:3059\:308b\:3068\:304d\:3001\:6771\:4eac\:3092\:8d77\:70b9\:3068\
\:3057\:3066\:3001\:5404\:90fd\:5e02\:3078\:306e\:6700\:77ed\:30eb\:30fc\:30c8\
\:3092\:6c42\:3081\:308b\:3002\:305f\:3060\:3057\:3001\:98db\:884c\:6a5f\:306e\
\:7d4c\:7531\:5730\:306f\:4e0a\:306e 9\:5927\:90fd\:5e02\:306e\:307f\:3067\
\:3001\:8ddd\:96e2\:304c10000Km\:672a\:6e80\:306e\:ff12\:90fd\:5e02\:9593\
\:306b\:306f\:76f4\:884c\:4fbf\:304c\:3042\:308b\:3082\:306e\:3068\:3059\:308b\
\:3002\[CloseCurlyDoubleQuote]\n \:3053\:306e\:554f\:984c\:3092\:89e3\:304f\
\:306b\:306f\:3001\:6b21\:306e\:3088\:3046\:306a\:96a3\:63a5\:884c\:5217\:3092\
\:6301\:30649\:9802\:70b9\:306e\:8377\:91cd\:30b0\:30e9\:30d5",
Cell[BoxData[
    \(TraditionalForm\`G\_w\)]],
"\:306e\:ff11\:756a\:76ee\:306e\:9802\:70b9\:ff08\:6771\:4eac\:ff09\:304b\
\:3089\:5404\:9802\:70b9\:3078\:306e\:6700\:77ed\:5f84\:8def\:3092\:6c42\:3081\
\:308c\:3070\:3088\:3044\:ff08\:98db\:884c\:6a5f\:306e\:6700\:9577\:822a\:7d9a\
\:8ddd\:96e2\:304c10000Km\:3067\:3042\:308b\:306e\:3067\:3001\:90fd\:5e02\
\:9593\:8ddd\:96e2\:304c10000Km\:4ee5\:4e0a\:3067\:3042\:308b\:884c\:5217\
\:306e\:30a8\:30f3\:30c8\:30ea\:30fc\:3092\[Infinity]\:3068\:3059\:308b\:ff09\
\:3002\:3053\:3053\:3067\:3001\:9802\:70b9 i \:304b\:3089 j \
\:3078\:306e\:6700\:77ed\:5f84\:8def\:3068\:306f\:3001\:9802\:70b9 i \:304b\
\:3089 j \:3078\:306e\:9053\:ff30\:306e\:5185\:3067\:3001\:8377\:91cdw(P) \
\:304c\:6700\:5c0f\:3067\:3042\:308b\:9053\:306e\:3053\:3068\:3067\:3042\:308b\
\:3002"], "Text"],

Cell[CellGroupData[{

Cell[BoxData[
    RowBox[{
      RowBox[{"mm", "=", 
        TagBox[
          RowBox[{"(", GridBox[{
                {"0", "2104", "5317", "7502", "7924", "9585", "9738", 
                  InterpretationBox["\[Infinity]",
                    DirectedInfinity[ 1]], 
                  InterpretationBox["\[Infinity]",
                    DirectedInfinity[ 1]]},
                {"2104", "0", "4465", "5809", "8987", "8160", "8236", 
                  InterpretationBox["\[Infinity]",
                    DirectedInfinity[ 1]], 
                  InterpretationBox["\[Infinity]",
                    DirectedInfinity[ 1]]},
                {"5317", "4465", "0", "8426", "6210", 
                  InterpretationBox["\[Infinity]",
                    DirectedInfinity[ 1]], 
                  InterpretationBox["\[Infinity]",
                    DirectedInfinity[ 1]], 
                  InterpretationBox["\[Infinity]",
                    DirectedInfinity[ 1]], 
                  InterpretationBox["\[Infinity]",
                    DirectedInfinity[ 1]]},
                {"7502", "5809", "8426", "0", 
                  InterpretationBox["\[Infinity]",
                    DirectedInfinity[ 1]], "2506", "2492", "7842", 
                  InterpretationBox["\[Infinity]",
                    DirectedInfinity[ 1]]},
                {"7924", "8987", "6210", 
                  InterpretationBox["\[Infinity]",
                    DirectedInfinity[ 1]], "0", 
                  InterpretationBox["\[Infinity]",
                    DirectedInfinity[ 1]], 
                  InterpretationBox["\[Infinity]",
                    DirectedInfinity[ 1]], 
                  InterpretationBox["\[Infinity]",
                    DirectedInfinity[ 1]], 
                  InterpretationBox["\[Infinity]",
                    DirectedInfinity[ 1]]},
                {"9585", "8160", 
                  InterpretationBox["\[Infinity]",
                    DirectedInfinity[ 1]], "2506", 
                  InterpretationBox["\[Infinity]",
                    DirectedInfinity[ 1]], "0", "341", "5915", "8947"},
                {"9738", "8236", 
                  InterpretationBox["\[Infinity]",
                    DirectedInfinity[ 1]], "2492", 
                  InterpretationBox["\[Infinity]",
                    DirectedInfinity[ 1]], "341", "0", "6180", "9213"},
                {
                  InterpretationBox["\[Infinity]",
                    DirectedInfinity[ 1]], 
                  InterpretationBox["\[Infinity]",
                    DirectedInfinity[ 1]], 
                  InterpretationBox["\[Infinity]",
                    DirectedInfinity[ 1]], "7842", 
                  InterpretationBox["\[Infinity]",
                    DirectedInfinity[ 1]], "5915", "6180", "0", "3033"},
                {
                  InterpretationBox["\[Infinity]",
                    DirectedInfinity[ 1]], 
                  InterpretationBox["\[Infinity]",
                    DirectedInfinity[ 1]], 
                  InterpretationBox["\[Infinity]",
                    DirectedInfinity[ 1]], 
                  InterpretationBox["\[Infinity]",
                    DirectedInfinity[ 1]], 
                  InterpretationBox["\[Infinity]",
                    DirectedInfinity[ 1]], "8947", "9213", "3033", "0"}
                }], ")"}],
          (MatrixForm[ #]&)]}], ";", "\n", \(c9 = getgraph[mm]\), ";", "\n", 
      \(Dijkstra[c9, 1]\)}]], "Input"],

Cell[OutputFormData["\<\
{{1, 1, 1, 1, 1, 1, 1, 4, 8}, 
  {0, 2104, 5317, 7502, 7924, 9585, 9738, 15344, 18377}}\
\>", "\<\
{{1, 1, 1, 1, 1, 1, 1, 4, 8}, 
 
  {0, 2104, 5317, 7502, 7924, 9585, 9738, 15344, 18377}}\
\>"], "Output"]
}, Open  ]],

Cell[TextData[
"\:3000Combinatorica.m\:306e\:95a2\:6570Dijkstra\:306f\:3001\:8377\:91cd\:30b0\
\:30e9\:30d5\:3068\:3001\:51fa\:767a\:70b9\:3092\:4e0e\:3048\:308b\:3068\:3001\
\:51fa\:767a\:70b9\:304b\:3089\:5404\:9802\:70b9\:3078\:306e\:6700\:77ed\:5f84\
\:8def\:3092\:3001\:30c0\:30a4\:30af\:30b9\:30c8\:30e9(Dijkstra)\:306e\:30a2\
\:30eb\:30b4\:30ea\:30ba\:30e0\:306b\:3088\:308a\:6c42\:3081\:308b\:3002\:3053\
\:306e\:95a2\:6570\:306e\:8fd4\:3059\:5024\:306f\:3001\:30ea\:30b9\:30c8{\
parent, shortestpath}\:3067\:3042\:308b\:3002parent[i]\:306f \:3001\:51fa\
\:767a\:70b9\:304b\:3089parent[i]\:756a\:76ee\:306e\:9802\:70b9\:307e\:3067\
\:306e\:6700\:77ed\:5f84\:8def\:306e\:9577\:3055\:3068\:3001\:8fba \
(parent[i], i) \:306e\:8377\:91cd\:306e\:548c\:304c\:3001\:51fa\:767a\:70b9\
\:304b\:3089\:9802\:70b9 i \:3078\:306e\:6700\:77ed\:5f84\:8def\:306e\:9577\
\:3055\:3067\:3042\:308b\:3053\:3068\:3092\:793a\:3059\:3002\:307e\:305f\:3001\
shortestpath\:306f\:51fa\:767a\:70b9\:304b\:3089\:5404\:9802\:70b9\:3078\:306e\
\:6700\:77ed\:5f84\:8def\:306e\:9577\:3055\:3067\:3042\:308b\:3002\n\:3000\
\:5f93\:3063\:3066\:3001\:4e0a\:306e\:51fa\:529b\:7d50\:679c\:306b\:3088\:308c\
\:3070\:3001\:6771\:4eac\:304b\:3089\:30ef\:30b7\:30f3\:30c8\:30f3\:3078\:306e\
\:6700\:77ed\:5f84\:8def\:306f\:3001\:6771\:4eac\:304b\:3089\:30e2\:30b9\:30af\
\:30ef\:3092\:7d4c\:7531\:3057\:3066\:3001\:30ef\:30b7\:30f3\:30c8\:30f3\:3078\
\:5411\:304b\:3046\:30eb\:30fc\:30c8\:304c\:6700\:77ed\:3067\:3001\:305d\:306e\
\:822a\:7d9a\:8ddd\:96e2\:306f15344 = 7502+7842 \:3067\:3042\:308b\:3002\n\
\:554f\:ff11\:ff0e\:4e0a\:3068\:540c\:3058\:6761\:4ef6\:3067\:3001\:30ad\:30e3\
\:30f3\:30d9\:30e9\:304b\:3089\:5404\:90fd\:5e02\:3078\:306e\:6700\:77ed\:30eb\
\:30fc\:30c8\:3092\:6c42\:3081\:3088\:3002\n\:554f\:ff12\:ff0e\:6b21\:306e\
\:3088\:3046\:306a\:96a3\:63a5\:884c\:5217\:3092\:6301\:3064\:8377\:91cd\:30b0\
\:30e9\:30d5\:306e\:3001\:9802\:70b9\:ff15\:304b\:3089\:306e\:6700\:77ed\:5f84\
\:8def\:3092\:6c42\:3081\:3088\:3002"], "Text"],

Cell[BoxData[
    RowBox[{"\t\t\t\t\t\t", 
      TagBox[
        RowBox[{"(", GridBox[{
              {"0", "17", "48", "38", "43", "49", "58", "74", 
                InterpretationBox["\[Infinity]",
                  DirectedInfinity[ 1]], "91"},
              {"17", "0", "54", "70", "13", "44", 
                InterpretationBox["\[Infinity]",
                  DirectedInfinity[ 1]], "46", "79", "67"},
              {"48", "54", "0", 
                InterpretationBox["\[Infinity]",
                  DirectedInfinity[ 1]], "94", "40", "85", "43", "66", "37"},
              {"38", "70", 
                InterpretationBox["\[Infinity]",
                  DirectedInfinity[ 1]], "0", "54", "29", "74", "75", "53", 
                "55"},
              {"43", "13", "94", "54", "0", "45", 
                InterpretationBox["\[Infinity]",
                  DirectedInfinity[ 1]], "49", "49", "34"},
              {"49", "44", "40", "29", "45", "0", "65", "29", "54", "56"},
              {"58", 
                InterpretationBox["\[Infinity]",
                  DirectedInfinity[ 1]], "85", "74", 
                InterpretationBox["\[Infinity]",
                  DirectedInfinity[ 1]], "65", "0", "59", "59", "52"},
              {"74", "46", "43", "75", "49", "29", "59", "0", "62", "57"},
              {
                InterpretationBox["\[Infinity]",
                  DirectedInfinity[ 1]], "79", "66", "53", "49", "54", "59", 
                "62", "0", "19"},
              {"91", "67", "37", "55", "34", "56", "52", "57", "19", "0"}
              }], ")"}],
        (MatrixForm[ #]&)]}]], "Input"],

Cell[BoxData[
    \(\:30c0\:30a4\:30af\:30b9\:30c8\:30e9\:306e\:30a2\:30eb\:30b4\:30ea\:30ba\
\:30e0\)], "Input"],

Cell[TextData[{
  "\:3000\:30c0\:30a4\:30af\:30b9\:30c8\:30e9\:306e\:30a2\:30eb\:30b4\:30ea\
\:30ba\:30e0\:306f\:3001\:4ee5\:4e0b\:306b\:8ff0\:3079\:308b\:3088\:3046\:306b\
\:6975\:3081\:3066\:7c21\:5358\:3067\:3042\:308b\:3002\n\:ff08\:ff11\:ff09\
\:51fa\:767a\:70b9",
  Cell[BoxData[
      \(TraditionalForm\`u\_0\)]],
  "\:3092\:6c7a\:3081\:3001S \:3092{",
  Cell[BoxData[
      \(TraditionalForm\`u\_0\)]],
  "}\:3068\:7f6e\:304f\:3002\:307e\:305f\:3001parent[",
  Cell[BoxData[
      \(TraditionalForm\`u\_0\)]],
  "]\:306b",
  Cell[BoxData[
      \(TraditionalForm\`u\_0\)]],
  "\:3092\:4ee3\:5165\:3057\:3001shortestpath[",
  Cell[BoxData[
      \(TraditionalForm\`u\_0\)]],
  "] \:306b 0\:3092\:3001\:305d\:308c\:4ee5\:5916\:306e\:4ed6\:306e\:8981\
\:7d20\:306b\:306f\[Infinity] \
\:3092\:4ee3\:5165\:3059\:308b\:3002\:66f4\:306b\:3001i = 0 \
\:3068\:7f6e\:304f\:3002\n\:ff08\:ff12\:ff09",
  Cell[BoxData[
      \(TraditionalForm\`S\&_\)]],
  " \:306e\:5404\:9802\:70b9 ",
  Cell[BoxData[
      \(TraditionalForm\`v\_j\)]],
  "\:306b\:5bfe\:3057\:3066\:3001\:3082\:3057\:3001shortestpath[ ",
  Cell[BoxData[
      \(TraditionalForm\`v\_j\)]],
  "]\[GreaterEqual]shortestpath[",
  Cell[BoxData[
      \(TraditionalForm\`u\_i\)]],
  "]+w(",
  Cell[BoxData[
      \(TraditionalForm\`u\_i\)]],
  ",",
  Cell[BoxData[
      \(TraditionalForm\`v\_j\)]],
  ") \:306a\:3089\:3070\:3001parent[",
  Cell[BoxData[
      \(TraditionalForm\`v\_j\)]],
  "] \:306b ",
  Cell[BoxData[
      \(TraditionalForm\`u\_i\)]],
  "\:3092\:3001shortestpath[ ",
  Cell[BoxData[
      \(TraditionalForm\`v\_j\)]],
  "]\:306bshortestpath[",
  Cell[BoxData[
      \(TraditionalForm\`u\_i\)]],
  "]+w(",
  Cell[BoxData[
      \(TraditionalForm\`u\_i\)]],
  ",",
  Cell[BoxData[
      \(TraditionalForm\`v\_j\)]],
  ") \:3092\:4ee3\:5165\:3059\:308b\:3002\:6b21\:306b l(",
  Cell[BoxData[
      \(TraditionalForm\`u\_\(i + 1\)\)]],
  ") = ",
  Cell[BoxData[
      \(TraditionalForm\`min\+\(\(v\_j\) \[Epsilon]  S\&_\ \)\)]],
  "{shortestpath[ ",
  Cell[BoxData[
      \(TraditionalForm\`v\_j\)]],
  "]}\:3068\:306a\:308b\:9802\:70b9 ",
  Cell[BoxData[
      \(TraditionalForm\`u\_\(i + 1\)\)]],
  "\:3092\:6c7a\:3081\:3001shortestpath[",
  Cell[BoxData[
      \(TraditionalForm\`u\_\(i + 1\)\)]],
  "] \:306b l(",
  Cell[BoxData[
      \(TraditionalForm\`u\_\(i + 1\)\)]],
  ") \:3092\:4ee3\:5165\:3057\:3001S \:3092 S\[Union]{",
  Cell[BoxData[
      \(TraditionalForm\`u\_\(i + 1\)\)]],
  "}\:3068\:3059\:308b\:3002\n\:ff08\:ff13\:ff09i = \:ff5cV(G)\:ff5c-\:ff11\
\:306a\:3089\:3070\:3001\:7d42\:4e86\:3059\:308b\:3002i \
\:ff1c\:ff5cV(G)\:ff5c-\:ff11\:306a\:3089\:3070\:3001i \:3092 i+1 \
\:3068\:3057\:3066\:30b9\:30c6\:30c3\:30d7\:ff08\:ff12\:ff09\:306b\:623b\:308b\
\:3002\n\:305f\:3060\:3057\:3001",
  Cell[BoxData[
      \(TraditionalForm\`S\&_\)]],
  " \:306f S \:306e\:88dc\:96c6\:5408 V(G)-S \:3068\:3059\:308b\:3002 \n\n\
\:554f\:ff13\:3000\:4e0a\:306b\:8ff0\:3079\:305f\:624b\:9806\:3067\:3001\:6700\
\:77ed\:5f84\:8def\:3092\:6c42\:3081\:308b\:95a2\:6570 dijkstra \:3092\:4f5c\
\:308c\:3002\n\:554f\:ff14\:3000\:30c0\:30a4\:30af\:30b9\:30c8\:30e9\:306e\
\:30a2\:30eb\:30b4\:30ea\:30ba\:30e0\:306f\:3001\:3042\:308b\:8fba\:306e\:8377\
\:91cd\:304c\:8ca0\:3067\:3042\:308b\:5834\:5408\:306b\:3001\:6b63\:3057\:3044\
\:7d50\:679c\:3092\:671f\:5f85\:3067\:304d\:306a\:3044\:3002\:3053\:308c\:306b\
\:3064\:3044\:3066\:8003\:5bdf\:305b\:3088\:3002\n\:30d2\:30f3\:30c8\:ff1a\
\:4f8b\:3048\:3070\:3001m4={{0,3,1,1},{3,0,1,\[Infinity]},{1,1,0,-1},{1,\
\[Infinity],-1,0}}\n\:3092\:96a3\:63a5\:884c\:5217\:3068\:3059\:308b\:3068\
\:3001Dijkstra[\:ff47,1]\:306e\:5024\:306f\:ff08\:ff47\:306fm4\:306e\:5b9a\
\:3081\:308b\:30b0\:30e9\:30d5\:ff09\n\t",
  Cell[OutputFormData["\<\
{{1, 3, 4, 3}, {0, 2, -1, 0}}\
\>", "\<\
{{1, 3, 4, 3}, {0, 2, -1, 0}}\
\>"], "Output"],
  "\n\:3067\:3042\:308b\:304c\:3001\:ff11\:304b\:3089\:ff13\:3078\:306e\:6700\
\:77ed\:5f84\:8def\:306f {1,4,3}\:3067\:3001\:305d\:306e\:9577\:3055\:306f\
\:3001\:5b9f\:969b\:306b\:306f\:ff10\:3067\:3042\:308b\:3002\:4e00\:65b9\:3001\
\:ff11\:304b\:3089\:ff14\:3078\:306e\:6700\:77ed\:5f84\:8def\:306f {1,3,4}\
\:3067\:3001\:305d\:306e\:9577\:3055\:306f\:ff10\:3067\:3042\:308b\:3002\:6700\
\:77ed\:5f84\:8def\:306e\:76f8\:4e92\:53c2\:7167\:306b\:3088\:308a\:3001\:7b54\
\:3048\:304c\:8aa4\:3063\:3066\:3044\:308b\:3002\n\:3000\n\:3000\:8377\:91cd\
\:304c\:8ca0\:3067\:3042\:308b\:5834\:5408\:306b\:3082\:3001\:6b63\:3057\:3044\
\:7d50\:679c\:3092\:5c0e\:304f\:30d5\:30ed\:30a4\:30c9\:30fb\:30a2\:30ea\:30b4\
\:30ea\:30ba\:30e0[Fl]\:304c\:3042\:308b\:3002\:3053\:306e\:30a2\:30eb\:30b4\
\:30ea\:30ba\:30e0\:306f\:3001\:6b21\:306e\:3088\:3046\:306b\:7c21\:5358\:306a\
\:3082\:306e\:3067\:3042\:308b\:3002\n\:3000mm = {",
  Cell[BoxData[
      \(TraditionalForm\`m\_ij\)]],
  "}\:3092\:8377\:91cd\:30b0\:30e9\:30d5\:306e\:96a3\:63a5\:884c\:5217\:3068\
\:3057\:3001\:ff4e\:3092 mm\:306e\:30b5\:30a4\:30ba\:3068\:3059\:308b\:3002\n\
\:ff08\:ff11\:ff09k = 1 \:3068\:3057\:3001",
  Cell[BoxData[
      \(TraditionalForm\`P\_k\)]],
  "\:3092 mm\:3068\:3059\:308b\:3002\n\:ff08\:ff12\:ff09",
  Cell[BoxData[
      \(TraditionalForm\`P\_\(k + 1\)\)]],
  "={",
  Cell[BoxData[
      \(TraditionalForm\`p\_ij\^\(k + 1\)\)]],
  "}\:3092\:6b21\:306e\:3088\:3046\:306b\:5b9a\:3081\:308b\:3002\n\t",
  Cell[BoxData[
      \(TraditionalForm\`p\_ij\^\(k + 1\)\)]],
  " = ",
  Cell[BoxData[
      FormBox[
        RowBox[{"(", GridBox[{
              {\(p\_ij\^k\), 
                \(i = \(j\ \:307e\:305f\:306f\ i = 
                    \(k\ \:307e\:305f\:306f\ j = k\)\)\)},
              {\(min(p\_ij\^k, p\_ik\^k + p\_kj\^k)\), 
                \(i \[NotEqual] k \[NotEqual] j\:304b\:3064\ i \[NotEqual] j
                  \)}
              }]}], TraditionalForm]]],
  "\n\:9802\:70b9 i \:3068\:9802\:70b9 j \:3092\:7d50\:3076\:73fe\:5728\:306e\
\:9053\:306e\:9577\:3055\:3092\:3001\:9802\:70b9 i \:3068\:9802\:70b9 k \
\:3068\:3092\:7d50\:3076\:9053\:306e\:9577\:3055\:3068\:3001\:9802\:70b9 k \
\:3068\:9802\:70b9 j \:3068\:3092\:7d50\:3076\:9053\:306e\:9577\:3055\:306e\
\:548c\:306e\:65b9\:304c\:5c0f\:3055\:3044\:3068\:304d\:306b\:7f6e\:304d\:63db\
\:3048\:308b\:3002\n\:ff08\:ff13\:ff09k \:304c\:ff4e\:306b\:7b49\:3057\:3044\
\:3068\:304d\:306f\:7d42\:4e86\:3059\:308b\:3002\:305d\:3046\:3067\:306a\:3044\
\:3068\:304d\:306f\:3001k \:3092 k+1 \:3068\:3057\:3066\:3001\:30b9\:30c6\
\:30c3\:30d7\:ff08\:ff12\:ff09\:3092\:7e70\:308a\:8fd4\:3059\:3002\n\:3000\
\:30d7\:30ed\:30b0\:30e9\:30e0\:306f\:6b21\:306e\:3088\:3046\:306b\:306a\:308b\
\:3002\nfloyd[m_] :=Module[{p=m,i,j,k,n=Length[m]},\n\t\tDo [p = Table[ \
If[i!=k && j!=k && i!=j,\n\t\t\t\
Min[p[[i,k]]+p[[k,j]],p[[i,j]]],p[[i,j]]],{i,n},{j,n}],\n\t\t\t{k,n}\n\t\t];\n\
\t\tp\n\t] \n\:30c0\:30a4\:30af\:30b9\:30c8\:30e9\:306e\:30a2\:30eb\:30b4\
\:30ea\:30ba\:30e0\:306e\:8a08\:7b97\:30aa\:30fc\:30c0\:306f ",
  Cell[BoxData[
      \(TraditionalForm\`n\^2\)]],
  "\:3067\:3042\:308b\:304c\:3001\:3053\:306e\:30a2\:30eb\:30b4\:30ea\:30ba\
\:30e0\:306e\:305d\:308c\:306f ",
  Cell[BoxData[
      \(TraditionalForm\`n\^3\)]],
  "\:3067\:3042\:308b\:306e\:3067\:3001\:8a08\:7b97\:306e\:52b9\:7387\:306f\
\:3042\:307e\:308a\:826f\:304f\:306a\:3044\:3002\n\:30d5\:30ed\:30a4\:30c9\
\:306e\:30a2\:30eb\:30b4\:30ea\:30ba\:30e0\:3092\:7528\:3044\:305f\:3001\
Combinatorica.m\:306e\:95a2\:6570 \
AllPairsShortestPath\:3082\:3001\:96a3\:63a5\:884c\:5217 m4\:306b\:5bfe\:3057\
\:3066\:3001\:9593\:9055\:3063\:305f\:7b54\:3048\:3092\:51fa\:3059\:3002\:305d\
\:306e\:7406\:7531\:306f\:3001\:95a2\:6570 AllPairsShortestPath\:306e\:5b9a\
\:7fa9\:304c\:9593\:9055\:3063\:3066\:3044\:308b\:3053\:3068\:ff08\:884c\:5217\
\:306e\:5bfe\:89d2\:7dda\:90e8\:5206\:306e\:51e6\:7406\:306b\:8aa4\:308a\:304c\
\:3042\:308b\:ff09\:3001\:66f4\:306b m4\:306b\:5bfe\:3057\:3066\:3001\:30d5\
\:30ed\:30a4\:30c9\:30fb\:30a2\:30ea\:30b4\:30ea\:30ba\:30e0\:305d\:306e\:3082\
\:306e\:304c\:3001\:6700\:77ed\:5f84\:8def\:306e\:76f8\:4e92\:53c2\:7167\:306b\
\:3088\:308a\:ff08\:ff4b\:ff1d\:ff13\:306e\:3068\:304d\:3001\:ff11\:304b\:3089\
\:ff14\:3078\:306e\:9053\:306e\:9577\:3055\:306f\:ff10\:306b\:306a\:308a\:3001\
\:ff4b\:ff1d\:ff14\:306e\:3068\:304d\:3001\:ff11\:304b\:3089\:ff13\:3078\:306e\
\:9053\:306e\:9577\:3055\:306f\:3001\:ff14\:3092\:7d4c\:7531\:3059\:308b\:306e\
\:3067\:30fc\:ff11\:3068\:306a\:308b\:3002\:3057\:304b\:3057\:3001\:ff11\:304b\
\:3089\:ff13\:3078\:306e\:6700\:77ed\:5f84\:8def\:306e\:6b63\:3057\:3044\:9577\
\:3055\:306f\:3001\:ff10\:3067\:3042\:308b\:3002\:ff09\:3001\:6b63\:3057\:3044\
\:7b54\:3048\:3092\:5c0e\:304b\:306a\:3044\:304b\:3089\:3067\:3042\:308b\:3002\
"
}], "Text"],

Cell[BoxData[
    \(\(\(\:ff11\:ff10\:ff0e\) \:ff16\:ff0e\) 
      \:ff12\:3000\:7d50\:5408\:554f\:984c\)], "Input"],

Cell[TextData[
"\:3000\:30ac\:30b9\:7ba1\:3001\:6c34\:9053\:7ba1\:3092\:6577\:8a2d\:3057\
\:305f\:308a\:3001\:9244\:9053\:7db2\:3001\:822a\:7a7a\:8def\:3001\:901a\:4fe1\
\:7db2\:7b49\:3092\:6700\:5c0f\:306e\:30b3\:30b9\:30c8\:3067\:5efa\:8a2d\:3059\
\:308b\:5834\:5408\:306e\:3001\:6700\:9069\:89e3\:3092\:6c42\:3081\:308b\:554f\
\:984c\:3092\:7d50\:5408\:554f\:984c\:3068\:547c\:3076\:3002\n\:3000\:4f8b\
\:3048\:3070\:3001\:4e16\:754c\:306e9\:5927\:9996\:90fd\:3001\:6771\:4eac\
\:3001\:5317\:4eac\:3001\:30b7\:30f3\:30ac\:30dd\:30fc\:30eb\:3001\:30e2\:30b9\
\:30af\:30ef\:3001\:30ad\:30e3\:30f3\:30d9\:30e9\:3001\:30ed\:30f3\:30c9\:30f3\
\:3001\:30d1\:30ea\:3001\:30ef\:30b7\:30f3\:30c8\:30f3\:3001\:30e1\:30ad\:30b7\
\:30b3\:30fb\:30b7\:30c6\:30a3\:3092\:6700\:5c0f\:306e\:30b3\:30b9\:30c8\:3067\
\:7d50\:3076\:822a\:7a7a\:8def\:7db2\:3092\:69cb\:7bc9\:3059\:308b\:3053\:3068\
\:3092\:8003\:3048\:308b\:3002\:52ff\:8ad6\:3001\:30b3\:30b9\:30c8\:306f\:8ddd\
\:96e2\:306e\:307f\:306b\:4f9d\:5b58\:3059\:308b\:3082\:306e\:3068\:3059\:308b\
\:3002\n\:3000\:3053\:306e\:554f\:984c\:3092\:89e3\:304f\:306b\:306f\:3001mm \
\:3092\:96a3\:63a5\:884c\:5217\:3068\:3059\:308b\:30b0\:30e9\:30d5\:ff27\:306e\
\:751f\:6210\:6728\:ff34\:3067\:3001\:305d\:306e\:30b3\:30b9\:30c8\:304c\:6700\
\:5c0f\:306a\:3082\:306e\:3092\:898b\:3064\:3051\:308c\:3070\:3088\:3044\:3002\
\:305d\:308c\:306b\:306f\:3001\:6b21\:306e\:3088\:3046\:306b\:3059\:308c\:3070\
\:3088\:3044\:3002"], "Text"],

Cell[CellGroupData[{

Cell[BoxData[
    \(mm\  = mm\  /. \ \[Infinity] -> 99999\ ; 
    \ \ \ \ \  (*\ 
      \:884c\:5217\:306e\:8981\:7d20\:306e\:5024\[Infinity]\:3092\:5927\:304d\
\:306a\:5024\:3067\:7f6e\:304d\:63db\:3048\:308b\:3000*) \nc9 = getgraph[mm]; 
    \nShowLabeledGraph[MinimumSpanningTree[c9]]\)], "Input"],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: 1 
MathPictureStart
/Mabs {
Mgmatrix idtransform
Mtmatrix dtransform
} bind def
/Mabsadd { Mabs
3 -1 roll add
3 1 roll add
exch } bind def
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
0.0242882 0.951424 0.0454545 0.909091 [
[ 0 0 0 0 ]
[ 1 1 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 0 m
1 0 L
1 1 L
0 1 L
closepath
clip
newpath
0 g
.025 w
.5 .95455 Mdot
.22038 .86773 Mdot
.04757 .64046 Mdot
.04757 .35954 Mdot
.22038 .13227 Mdot
.5 .04545 Mdot
.77962 .13227 Mdot
.95243 .35954 Mdot
.95243 .64046 Mdot
.77962 .86773 Mdot
.5 Mabswid
.5 .95455 m
.22038 .86773 L
s
.5 .95455 m
.04757 .35954 L
s
.22038 .86773 m
.5 .95455 L
s
.22038 .86773 m
.22038 .13227 L
s
.04757 .64046 m
.77962 .86773 L
s
.04757 .35954 m
.5 .95455 L
s
.04757 .35954 m
.5 .04545 L
s
.22038 .13227 m
.22038 .86773 L
s
.22038 .13227 m
.77962 .86773 L
s
.5 .04545 m
.04757 .35954 L
s
.5 .04545 m
.95243 .35954 L
s
.77962 .13227 m
.77962 .86773 L
s
.95243 .35954 m
.5 .04545 L
s
.95243 .64046 m
.77962 .86773 L
s
.77962 .86773 m
.04757 .64046 L
s
.77962 .86773 m
.22038 .13227 L
s
.77962 .86773 m
.77962 .13227 L
s
.77962 .86773 m
.95243 .64046 L
s
.5 .95455 m
.22038 .86773 L
s
.5 .95455 m
.04757 .35954 L
s
.22038 .86773 m
.5 .95455 L
s
.22038 .86773 m
.22038 .13227 L
s
.04757 .64046 m
.77962 .86773 L
s
.04757 .35954 m
.5 .95455 L
s
.04757 .35954 m
.5 .04545 L
s
.22038 .13227 m
.22038 .86773 L
s
.22038 .13227 m
.77962 .86773 L
s
.5 .04545 m
.04757 .35954 L
s
.5 .04545 m
.95243 .35954 L
s
.77962 .13227 m
.77962 .86773 L
s
.95243 .35954 m
.5 .04545 L
s
.95243 .64046 m
.77962 .86773 L
s
.77962 .86773 m
.04757 .64046 L
s
.77962 .86773 m
.22038 .13227 L
s
.77962 .86773 m
.77962 .13227 L
s
.77962 .86773 m
.95243 .64046 L
s
[(1)] .47146 .92727 0 1 Mshowa
[(2)] .19184 .84046 0 1 Mshowa
[(3)] .01903 .61319 0 1 Mshowa
[(4)] .01903 .33227 0 1 Mshowa
[(5)] .19184 .10499 0 1 Mshowa
[(6)] .47146 .01818 0 1 Mshowa
[(7)] .75107 .10499 0 1 Mshowa
[(8)] .92389 .33227 0 1 Mshowa
[(9)] .92389 .61319 0 1 Mshowa
[(10)] .75107 .84046 0 1 Mshowa
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  ImageSize->{288, 288},
  ImageMargins->{{43, 0}, {0, 0}},
  ImageRegion->{{0, 1}, {0, 1}},
  ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`40004P000180P10`40000100000800002008200000
P800P020P<30`<3L`:K:l:C8l3<006H009T00<`0000c03<c06Hc09Tc0<`c0?lc001V03=V06IV09UV
0<aV0?mV002I03>I06JI09VI0<bI0?nI003<03?<06K<09W<0<c<0?o<03?o06Ko09Wo0<co0000<c<0
<fH0<iT0<l`0<ol0<`0c<c<c<fHc<iTc<l`c<olc<`1V<c=V<fIV<iUV<laV<omV<`2I<c>I<fJI<iVI
<lbI<onI<`3<<c?<<fK<<iW<<lc<<oo<<`3o<c?o<fKo<iWo<lco<ooo<`00IS<0IVH0IYT0I/`0I_l0
IP0cIS<cIVHcIYTcI/`cI_lcIP1VIS=VIVIVIYUVI/aVI_mVIP2IIS>IIVJIIYVII/bII_nIIP3<IS?<
IVK<IYW<I/c<I_o<IP3oIS?oIVKoIYWoI/coI_ooIP00VC<0VFH0VIT0VL`0VOl0V@0cVC<cVFHcVITc
VL`cVOlcV@1VVC=VVFIVVIUVVLaVVOmVV@2IVC>IVFJIVIVIVLbIVOnIV@3<VC?<VFK<VIW<VLc<VOo<
V@3oVC?oVFKoVIWoVLcoVOooV@00c3<0c6H0c9T0c<`0c?l0c00cc3<cc6Hcc9Tcc<`cc?lcc01Vc3=V
c6IVc9UVc<aVc?mVc02Ic3>Ic6JIc9VIc<bIc?nIc03<c3?<c6K<c9W<c<c<c?o<c03oc3?oc6Koc9Wo
c<coc?ooc3<0ofH0oiT0ol`0o`0coc<cofHcoiTcol`coolco`1Voc=VofIVoiUVolaVoomVo`2Ioc>I
ofJIoiVIolbIoonIo`3<oc?<ofK<oiW<olc<ooo<oc?oofKooiWoolcoo`410@820P<30`@410D51@H6
1PL71`P820T92@X:2P/;2``<30h>3Pl?3a0@414A4A8B4Q<C4a@D5000000000000000000000000000
00000?okl:2PY820P?l0003o0?oo0000ool0o`3oooooohGo00<0o`00V?l008Go0P2Io`00QOl00`3o
o`2Ho`00Q_l209So003oob7o003oob7o003oob7o003oob7o003oob7o003oob7o003oob7o002>o`<0
Sol008go1@2>o`00S?l708go002<o`L0SOl008co1`2=o`00S?l708go002:o`800_l300;o0P2;o`00
ROl00`3oo`09o`030?oo08So0028o`030?oo00_o00<0ool0Qol008Ko0P0?o`80Qol008Go00<0ool0
4Ol00`3oo`24o`00Pol201Go0P24o`00=_l00`3oo`19o`030?oo01Oo00<0ool0>?l00`3oo`16o`00
=Ol00`3o0018o`806ol203So00<0ool0A_l003Oo00<0ool0AOl00`3oo`0Mo`030?oo03Go00<0ool0
A_l003Go0P16o`808Ol203Ko00<0ool0AOl003Go00<0ool0A?l00`3oo`0So`030?oo037o00<0o`00
Aol003Go0`13o`030?oo02Go00<0ool0<?l304Oo001io`80:Ol207[o001ho`030?oo02_o00<0ool0
Mol007Ko0P0_o`80Mol007Go00<0ool0<Ol00`3oo`1do`00Lol203Go0P1do`00L_l00`3oo`0go`03
0?oo077o001`o`80>ol2077o000no`<0;_l00`3oo`0mo`030?oo02co0`0oo`00?Ol502co00<0ool0
?ol00`3oo`0Zo`D0?_l003co1`0Yo`80@ol202Wo1`0mo`00??l702So00<0ool0AOl00`3oo`0Vo`L0
?Ol003co1`0Vo`80BOl202Ko1`0mo`00?Ol502Ko00<0ool0Bol00`3oo`0To`D0?_l003ko0`000ol0
o`0Ro`80Col202Go0`0oo`00?ol01@3oool0027o00<0ool0DOl00`3oo`0So`030?oo03ko000oo`03
0?oo00;o00<0ool07?l205Go0P0So`030?oo03ko000oo`030?oo00;o00<0ool06ol00`3oo`1Go`03
0?oo023o00<0ool0?_l003oo00<0ool00ol00`3oo`0Io`030?oo05Wo00<0ool07ol00`3oo`0no`00
?ol00`3oo`04o`030?oo01Ko0P1Mo`807ol00`3oo`0no`00?ol00`3oo`05o`030?oo01Co00<0ool0
Gol00`3oo`0Lo`030?oo03ko000oo`030?oo00Go00<0ool04_l206?o0P0Lo`030?oo03ko000oo`03
0?oo00Ko00<0ool04?l00`3oo`1Uo`030?oo01Wo00<0ool0?_l003oo00<0ool01ol00`3oo`0=o`80
JOl201Wo00<0ool0?_l003oo00<0ool02?l00`3oo`0;o`030?oo06_o00<0ool05_l00`3oo`0no`00
?ol00`3oo`08o`030?oo00Wo0P1_o`805_l00`3oo`0no`00?ol00`3oo`09o`030?oo00Oo00<0ool0
LOl00`3oo`0Co`030?oo03ko000oo`030?oo00[o00<0ool01Ol00`3oo`1co`030?oo01;o00<0ool0
?_l003oo00<0ool02ol00`3oo`02o`80Mol201;o00<0ool0?_l003oo00<0ool02ol01@3oool007_o
00<0ool03ol00`3oo`0no`00?ol00`3oo`0<o`<0OOl200oo00<0ool0?_l003oo00<0ool03?l2083o
00<0ool03?l00`3oo`0no`00?ol00`3oo`0:o`800_l00`3oo`1no`803?l00`3oo`0no`00?ol00`3o
o`09o`030?oo00;o00<0ool0P?l00`3oo`09o`030?oo03ko000oo`030?oo00Oo0P06o`030?oo083o
0P09o`030?oo03ko000oo`030?oo00Ko00<0ool01ol00`3oo`21o`030?oo00Ko00<0ool0?_l003oo
00<0ool01Ol00`3oo`09o`030?oo087o00<0ool01Ol00`3oo`0no`00?ol00`3oo`03o`803?l00`3o
o`22o`801Ol00`3oo`0no`00?ol00`3oo`02o`030?oo00go00<0ool0Pol00`3oo`02o`030?oo03ko
000oo`030?oo00804Ol00`3oo`23o`800_l00`3oo`0no`00?ol00`3o000Do`030?oo08Co00<0o`00
@?l003oo0P0Eo`030?oo08Go0P10o`00?_l201Oo00<0ool0QOl203oo000lo`8000?o0?l05ol00`3o
o`24o`040?l003go000ko`050?ooo`006Ol00`3oo`23o`050?ooo`00??l003[o00<0ool00_l00`3o
o`0Go`030?oo08?o00<0ool00_l00`3oo`0io`00>?l200Go00<0ool06?l00`3oo`22o`030?oo00?o
0P0io`00=ol00`3oo`05o`030?oo01Wo00<0ool0POl00`3oo`05o`030?oo03Ko000eo`802?l00`3o
o`0Jo`030?oo083o00<0ool01_l203Ko000do`030?oo00So00<0ool06_l00`3oo`20o`030?oo00So
00<0ool0<ol003;o0P0;o`030?oo01_o00<0ool0Ool00`3oo`09o`80<ol0037o00<0ool02ol00`3o
o`0Lo`030?oo07ko00<0ool02ol00`3oo`0`o`00;ol200ko00<0ool07Ol00`3oo`1mo`030?oo00co
0P0`o`00;_l00`3oo`0>o`030?oo01go00<0ool0OOl00`3oo`0>o`030?oo02go000]o`030?oo00oo
00<0ool07_l00`3oo`1lo`030?oo00oo00<0ool0;?l002_o0P0Bo`030?oo01oo00<0ool0Nol00`3o
o`0@o`80;?l002[o00<0ool04_l00`3oo`0Po`030?oo07[o00<0ool04_l00`3oo`0Yo`00:?l201Go
00<0ool08?l00`3oo`1jo`030?oo01?o0P0Yo`009ol00`3oo`0Eo`030?oo027o00<0ool0NOl00`3o
o`0Eo`030?oo02Ko000Uo`806?l00`3oo`0Ro`030?oo07So00<0ool05_l202Ko0004o`<07Ol00`3o
o`0Ho`030?oo02?o00<0ool0Mol00`3oo`0Ho`030?oo00_o00<0ool05Ol000Go00<0ool06_l201_o
00<0ool08ol00`3oo`1go`030?oo01Wo0P0:o`030?l001Ko0003o`@06_l00`3oo`0Ko`030?oo02Co
00<0ool0M_l00`3oo`0Ko`030?oo00Oo00<0o`005_l000?o00<0o`006_l00`3oo`0Lo`030?oo02Go
00<0ool0MOl00`3oo`0Lo`030?oo00Oo00<0ool05Ol000Co0P0Ho`807ol00`3oo`0Vo`030?oo07Co
00<0ool07Ol200Ko00<0o`005_l000Go00<0ool05Ol00`3oo`0Oo`030?oo02Oo00<0ool0Lol00`3o
o`0Oo`030?oo00Co00<0ool05Ol001_o0P0Ro`030?oo02Oo00<0ool0Lol00`3oo`0Po`807?l001[o
00<0ool08_l00`3oo`0Xo`030?oo07;o00<0ool08_l00`3oo`0Io`006?l202Go00<0ool0:Ol00`3o
o`1ao`030?oo02?o0P0Io`005ol00`3oo`0Uo`030?oo02[o00<0ool0L?l00`3oo`0Uo`030?oo01Ko
000Eo`80:?l00`3oo`0Zo`030?oo073o00<0ool09_l201Ko000Do`030?oo02So00<0ool0:ol00`3o
o`1_o`030?oo02So00<0ool04ol001?o00<0ool0:Ol00`3oo`0/o`030?oo06ko00<0ool0:Ol00`3o
o`0Bo`003?l300;o0P0/o`030?oo02go00<0ool0KOl00`3oo`0Zo`800_l300go000;o`H0;_l00`3o
o`0]o`030?oo06go00<0ool0;?l600co000:o`L0;_l00`3oo`0^o`030?oo06co00<0ool0;?l700_o
000:o`L0;_l00`3oo`0_o`030?oo06_o00<0ool0;?l700_o000:o`L0;_l00`3oo`0`o`030?oo06[o
00<0ool0;?l700_o000;o`D0;ol00`3oo`0`o`030?oo06[o00<0ool0;Ol500co000<o`@0;ol00`3o
o`0ao`030?oo06Wo00<0ool0;_l300go000@o`030?oo02co00<0ool0<_l00`3oo`1Xo`030?oo03ko
000Ao`030?oo02_o00<0ool0<ol00`3oo`1Wo`030?oo03ko000Bo`030?oo02[o00<0ool0<ol00`3o
o`1Wo`030?oo03ko000Bo`030?oo02[o00<0ool0=?l00`3oo`1Vo`030?oo03ko000Co`030?oo02Wo
00<0ool0=Ol00`3oo`1Uo`030?oo03ko000Do`030?oo02So00<0ool0=_l00`3oo`1To`030?oo03ko
000Eo`030?oo02Oo00<0ool0=_l00`3oo`1To`030?oo03ko000Eo`030?oo02Oo00<0ool0=ol00`3o
o`1So`030?oo03ko000Fo`030?oo02Ko00<0ool0>?l00`3oo`1Ro`030?oo03ko000Go`030?oo02Go
00<0ool0>Ol00`3oo`1Qo`030?oo03ko000Ho`030?oo02Co00<0ool0>Ol00`3oo`1Qo`030?oo03ko
000Ho`030?oo02Co00<0ool0>_l00`3oo`1Po`030?oo03ko000Io`030?oo02?o00<0ool0>ol00`3o
o`1Oo`030?oo03ko000Jo`030?oo02;o00<0ool0??l00`3oo`1No`030?oo03ko000Ko`030?oo027o
00<0ool0??l00`3oo`1No`030?oo03ko000Lo`030?oo023o00<0ool0?Ol00`3oo`1Mo`030?oo03ko
000Lo`030?oo023o00<0ool0?_l00`3oo`1Lo`030?oo03ko000Mo`030?oo01oo00<0ool0?ol00`3o
o`1Ko`030?oo03ko000No`030?oo01ko00<0ool0?ol00`3oo`1Ko`030?oo03ko000Oo`030?oo01go
00<0ool0@?l00`3oo`1Jo`030?oo03ko000Oo`030?oo01go00<0ool0@Ol00`3oo`1Io`030?oo03ko
000Po`030?oo01co00<0ool0@_l00`3oo`1Ho`030?oo03ko000Qo`030?oo01_o00<0ool0@_l00`3o
o`1Ho`030?oo03ko000Ro`030?oo01[o00<0ool0@ol00`3oo`1Go`030?oo03ko000Ro`030?oo01[o
00<0ool0A?l00`3oo`1Fo`030?oo03ko000So`030?oo01Wo00<0ool0AOl00`3oo`1Eo`030?oo03ko
000To`030?oo01So00<0ool0AOl00`3oo`1Eo`030?oo03ko000Uo`030?oo01Oo00<0ool0A_l00`3o
o`1Do`030?oo03ko000Uo`030?oo01Oo00<0ool0Aol00`3oo`1Co`030?oo03ko000Vo`030?oo01Ko
00<0ool0B?l00`3oo`1Bo`030?oo03ko000Wo`030?oo01Go00<0ool0B?l00`3oo`1Bo`030?oo03ko
000Xo`030?oo01Co00<0ool0BOl00`3oo`1Ao`030?oo03ko000Yo`030?oo01?o00<0ool0B_l00`3o
o`1@o`030?oo03ko000Yo`030?oo01?o00<0ool0Bol00`3oo`1?o`030?oo03ko000Zo`030?oo01;o
00<0ool0Bol00`3oo`1?o`030?oo03ko000[o`030?oo017o00<0ool0C?l00`3oo`1>o`030?oo03ko
000/o`030?oo013o00<0ool0COl00`3oo`1=o`030?oo03ko000/o`030?oo013o00<0ool0C_l00`3o
o`1<o`030?oo03ko000]o`030?oo00oo00<0ool0Col00`3oo`1;o`030?oo03ko000^o`030?oo00ko
00<0ool0Col00`3oo`1;o`030?oo03ko000_o`030?oo00go00<0ool0D?l00`3oo`1:o`030?oo03ko
000_o`030?oo00go00<0ool0DOl00`3oo`19o`030?oo03ko000`o`030?oo00co00<0ool0D_l00`3o
o`18o`030?oo03ko000ao`030?oo00_o00<0ool0D_l00`3oo`18o`030?oo03ko000bo`030?oo00[o
00<0ool0Dol00`3oo`17o`030?oo03ko000bo`030?oo00[o00<0ool0E?l00`3oo`16o`030?oo03ko
000co`030?oo00Wo00<0ool0EOl00`3oo`15o`030?oo03ko000do`030?oo00So00<0ool0EOl00`3o
o`15o`030?oo03ko000eo`030?oo00Oo00<0ool0E_l00`3oo`14o`030?oo03ko000fo`030?oo00Ko
00<0ool0Eol00`3oo`13o`030?oo03ko000fo`030?oo00Ko00<0ool0F?l00`3oo`12o`030?oo03ko
000go`030?oo00Go00<0ool0F?l00`3oo`12o`030?oo03ko000ho`030?oo00Co00<0ool0FOl00`3o
o`11o`030?oo03ko000io`030?oo00?o00<0ool0F_l00`3oo`10o`030?oo03ko000io`030?oo00?o
00<0ool0Fol00`3oo`0oo`030?oo03ko000jo`030?oo00;o00<0ool0Fol00`3oo`0oo`030?oo03ko
000ko`050?ooo`00G_l00`3oo`0no`030?oo03ko000lo`040?oo05oo00<0ool0?Ol00`3oo`0no`00
??l0103oo`1Po`030?oo03co00<0ool0?_l003go00<0o`00H?l00`3oo`0lo`030?oo03ko0003o`80
>Ol2067o00<0ool0>ol00`3oo`0Uo`805ol000Go00<0ool0=ol00`3oo`1Po`030?oo03[o00<0ool0
9ol00`3oo`0Do`001?l00`3oo`0ho`030?oo067o00<0ool0>Ol00`3oo`0Vo`805_l000Go00<0ool0
=ol206;o00<0ool0>Ol00`3oo`0Uo`030?l001Ko0003o`030?l003Wo00<0o`00H_l00`3oo`0ho`03
0?oo02Go00<0o`005_l000Co00<0ool0>?l0103oo`1Ro`030?oo03Oo00<0ool09_l201Ko000oo`05
0?ooo`00H_l00`3oo`0fo`030?oo03ko000oo`050?ooo`00H_l00`3oo`0fo`030?oo03ko000oo`03
0?oo00;o00<0ool0H?l00`3oo`0eo`030?oo03ko000oo`030?oo00?o00<0ool0H?l00`3oo`0do`03
0?oo03ko000oo`030?oo00Co00<0ool0H?l00`3oo`0co`030?oo03ko000oo`030?oo00Co00<0ool0
H?l00`3oo`0co`030?oo03ko000oo`030?oo00Go00<0ool0H?l00`3oo`0bo`030?oo03ko000<o`<0
<?l00`3oo`06o`030?oo063o00<0ool0<Ol00`3oo`0^o`<03Ol000_o1@0_o`030?oo00Oo00<0ool0
H?l00`3oo`0`o`030?oo02go1@0<o`002_l702ko00<0ool01ol00`3oo`1Po`030?oo033o00<0ool0
;?l700_o000:o`L0;_l00`3oo`08o`030?oo063o00<0ool0;ol00`3oo`0/o`L02ol000[o200]o`03
0?oo00Wo00<0ool0H?l00`3oo`0^o`030?oo02co1`0;o`002ol500;o0`0Zo`030?oo00[o00<0ool0
H?l00`3oo`0]o`030?oo02go1@0<o`003?l300Ko100Vo`030?oo00[o00<0ool0H?l00`3oo`0]o`03
0?oo02go100=o`006Ol302?o00<0ool02ol00`3oo`1Po`030?oo02co00<0ool0;?l00`3oo`0?o`00
7?l3023o00<0ool03?l00`3oo`1Po`030?oo02_o00<0ool0:ol00`3oo`0@o`007ol301go00<0ool0
3Ol00`3oo`1Po`030?oo02[o00<0ool0:_l00`3oo`0Ao`008_l301[o00<0ool03_l00`3oo`1Oo`03
0?oo02[o00<0ool0:_l00`3oo`0Ao`009Ol401Ko00<0ool03_l00`3oo`1Po`030?oo02Wo00<0ool0
:Ol00`3oo`0Bo`00:Ol301?o00<0ool03ol00`3oo`1Po`030?oo02So00<0ool0:?l00`3oo`0Co`00
;?l3013o00<0ool04?l00`3oo`1Po`030?oo02Oo00<0ool09ol00`3oo`0Do`00;ol300go00<0ool0
4Ol00`3oo`1Oo`030?oo02Oo00<0ool09ol00`3oo`0Do`00<_l300[o00<0ool04Ol00`3oo`1Po`03
0?oo02Ko00<0ool09_l00`3oo`0Eo`00=Ol300Oo00<0ool04_l00`3oo`1Po`030?oo02Go00<0ool0
9Ol00`3oo`0Fo`00>?l400?o00<0ool04ol00`3oo`1Po`030?oo02Co00<0ool09?l00`3oo`0Go`00
??l401Ko00<0ool0H?l00`3oo`0So`030?oo02Co00<0ool05ol003oo0`0Do`030?oo063o00<0ool0
8ol00`3oo`0So`030?oo01So000oo`030?oo00<04_l00`3oo`1Po`030?oo02;o00<0ool08_l00`3o
o`0Io`00?ol00`3oo`03o`<04?l00`3oo`1Po`030?oo027o00<0ool08Ol00`3oo`0Jo`00?ol00`3o
o`06o`@03Ol00`3oo`1Po`030?oo023o00<0ool08Ol00`3oo`0Jo`00?ol00`3oo`0:o`<02_l00`3o
o`1Po`030?oo023o00<0ool08?l00`3oo`0Ko`00?ol00`3oo`0=o`<02?l00`3oo`1Po`030?oo01oo
00<0ool07ol00`3oo`0Lo`00?ol00`3oo`0@o`<01_l00`3oo`1Po`030?oo01ko00<0ool07_l00`3o
o`0Mo`00?ol00`3oo`0Co`<01?l00`3oo`1Po`030?oo01go00<0ool07_l00`3oo`0Mo`00?ol00`3o
o`0Fo`<00_l00`3oo`1Oo`030?oo01go00<0ool07Ol00`3oo`0No`00?ol00`3oo`0Io`@0HOl00`3o
o`0Lo`030?oo01co00<0ool07ol003oo00<0ool07?l405oo00<0ool06ol00`3oo`0Ko`030?oo023o
000oo`030?oo01go00<0ool00`1Mo`030?oo01[o00<0ool06ol00`3oo`0Po`00?ol00`3oo`0No`03
0?oo00;o0`1Jo`030?oo01[o00<0ool06_l00`3oo`0Qo`00?ol00`3oo`0No`030?oo00Go0`1Ho`03
0?oo01Wo00<0ool06Ol00`3oo`0Ro`00?ol00`3oo`0Oo`030?oo00Oo101Eo`030?oo01So00<0ool0
6?l00`3oo`0So`00?ol00`3oo`0Po`030?oo00[o0`1Co`030?oo01Oo00<0ool06?l00`3oo`0So`00
?ol00`3oo`0Qo`030?oo00co0`1@o`030?oo01Oo00<0ool05ol00`3oo`0To`00?ol00`3oo`0Qo`03
0?oo00oo0`1>o`030?oo01Ko00<0ool05_l00`3oo`0Uo`00?ol00`3oo`0Ro`030?oo017o0`1<o`03
0?oo01Go00<0ool05Ol00`3oo`0Vo`00?ol00`3oo`0So`030?oo01?o0`1:o`030?oo01Co00<0ool0
5?l00`3oo`0Wo`00?ol00`3oo`0To`030?oo01Go1016o`030?oo01Co00<0ool05?l00`3oo`0Wo`00
?ol00`3oo`0To`030?oo01Wo0`14o`030?oo01?o00<0ool04ol00`3oo`0Xo`00?ol00`3oo`0Uo`03
0?oo01_o0`12o`030?oo01;o00<0ool04_l00`3oo`0Yo`00?ol00`3oo`0Vo`030?oo01go0`10o`03
0?oo017o00<0ool04Ol00`3oo`0Zo`00?ol00`3oo`0Wo`030?oo01oo0`0mo`030?oo017o00<0ool0
4Ol00`3oo`0Zo`00?ol00`3oo`0Xo`030?oo027o100jo`030?oo013o00<0ool04?l00`3oo`0[o`00
?ol00`3oo`0Xo`030?oo02Go0`0ho`030?oo00oo00<0ool03ol00`3oo`0/o`00?ol00`3oo`0Yo`03
0?oo02Oo0`0fo`030?oo00ko00<0ool03_l00`3oo`0]o`00?ol00`3oo`0Zo`030?oo02Wo0`0co`03
0?oo00ko00<0ool03_l00`3oo`0]o`00?ol00`3oo`0[o`030?oo02_o0`0ao`030?oo00go00<0ool0
3Ol00`3oo`0^o`00?ol00`3oo`0[o`030?oo02ko0`0_o`030?oo00co00<0ool03?l00`3oo`0_o`00
?ol00`3oo`0/o`030?oo033o100/o`030?oo00_o00<0ool02ol00`3oo`0`o`00?ol00`3oo`0]o`03
0?oo03?o0`0Yo`030?oo00_o00<0ool02ol00`3oo`0`o`00?ol00`3oo`0^o`030?oo03Go0`0Wo`03
0?oo00[o00<0ool02_l00`3oo`0ao`00=Ol300Oo00<0ool0;_l00`3oo`0ho`<09?l500;o00<0ool0
0ol00`3oo`09o`030?oo03;o000eo`030?oo00Oo00<0ool0;ol00`3oo`0jo`<08ol01`3oool0o`00
1?l00`3oo`08o`030?oo03?o000fo`030?oo00Ko00<0ool0<?l00`3oo`0lo`@07ol01`3oool0o`00
1?l00`3oo`08o`030?oo03?o000fo`030?oo00Ko00<0ool0<Ol00`3oo`0oo`<07?l200;o00<0o`00
1?l00`3oo`07o`030?oo03Co000eo`030?l000Oo00<0ool0<Ol00`3oo`12o`<06Ol01`3o0?l0o`00
1?l00`3oo`06o`030?oo03Go000fo`030?oo00Ko00<0ool0<_l00`3oo`14o`<05Ol200;o00<0o`00
1Ol00`3oo`05o`030?oo03Ko000oo`030?oo03?o00<0ool0A_l301Ko00<0ool01Ol00`3oo`05o`03
0?oo03Ko000oo`030?oo03Co00<0ool0B?l301Co00<0ool01?l00`3oo`04o`030?oo03Oo000oo`03
0?oo03Go00<0ool0B_l4017o00<0ool00ol00`3oo`03o`030?oo03So000oo`030?oo03Go00<0ool0
C_l300oo00<0ool00_l00`3oo`02o`030?oo03Wo000oo`030?oo03Ko00<0ool0D?l300co00<0ool0
0_l00`3oo`02o`030?oo03Wo000oo`030?oo03Oo00<0ool0D_l300[o00D0oooo0003o`030?oo03[o
000oo`030?oo03So00<0ool0E?l300So00@0ool00_l00`3oo`0ko`00?_l303Wo00<0ool0Eol400Go
1@0no`00?Ol503Wo00<0ool0F_l300;o1@0no`00??l703Wo00<0ool0G?l803go000lo`L0>_l00`3o
o`1Lo`L0?Ol003co200io`030?oo05co1`0mo`00?Ol500;o100fo`030?oo05co1@0no`00?_l300Oo
0`0do`030?oo05co0`0oo`00Bol303;o00<0ool0WOl004ko100^o`030?oo09go001Bo`<0;?l00`3o
o`2Lo`00EOl302[o00<0ool0Vol005So100Wo`030?oo09[o001Lo`<09Ol509Oo001Oo`<08_l00`3o
002Io`00H_l401oo0P2Io`00I_l301go00<0ool0Uol006Wo0`0Jo`80V?l006co100Eo`<0V?l0073o
0`0Eo`030?oo09Go001co`<04ol00`3oo`2Do`00M_l4013o00<0ool0Tol007[o0`0=o`030?oo09?o
001mo`<02ol00`3oo`2Bo`00P?l400So00<0ool0TOl008Co0`06o`030?oo093o0027o`<00ol408oo
002:o`P0S_l008co1`2=o`00S?l708go002<o`L0SOl008go1@2>o`00S_l308oo003oob7o003oob7o
003oob7o003oob7o003oob7o003oob7o003oob7o003oob7o003oob7o0000\
\>"],
  ImageRangeCache->{{{0, 287}, {287, 0}} -> {-0.0255335, -0.0500054, 
  0.00366225, 0.00383279}}]
}, Open  ]],

Cell[TextData[
"Combinatorica.m\:306e\:95a2\:6570MinimumSpanningTree\:306f\:3001\:8377\:91cd\
\:30b0\:30e9\:30d5\:3092\:4e0e\:3048\:308b\:3068\:3001\:305d\:306e\:30b0\:30e9\
\:30d5\:306e\:30b3\:30b9\:30c8\:6700\:5c0f\:306e\:751f\:6210\:6728\:3092\:6c42\
\:3081\:308b\:3002\:305f\:3060\:3057\:3001\:96a3\:63a5\:884c\:5217\:306e\:8981\
\:7d20\:306b\[Infinity]\:304c\:3042\:308b\:3068\:6b63\:3057\:3044\:89e3\:3092\
\:6c42\:3081\:306a\:3044\:306e\:3067\:3001\[Infinity] \
\:3092\:89e3\:306b\:5f71\:97ff\:3092\:4e0e\:3048\:306a\:3044\:9069\:5ea6\:306b\
\:5927\:304d\:306a\:5024\:306b\:5909\:66f4\:3059\:308b\:3002\:3053\:306e\:95a2\
\:6570\:306f\:3001\:30af\:30eb\:30b9\:30ab\:30eb(Kruskal)\:306e\:30a2\:30eb\
\:30b4\:30ea\:30ba\:30e0\:3068\:547c\:3070\:308c\:308b\:3001\:6b21\:306e\:3088\
\:3046\:306a\:65b9\:6cd5\:3092\:7528\:3044\:3066\:3044\:308b\:3002"], "Text"],

Cell[BoxData[
    \(\:30af\:30eb\:30b9\:30ab\:30eb\:306e\:30a2\:30eb\:30b4\:30ea\:30ba\:30e0\
\)], "Input"],

Cell[TextData[{
  "\:3000\:8377\:91cd\:30b0\:30e9\:30d5",
  Cell[BoxData[
      \(TraditionalForm\`G\_w\)]],
  "\:304c\:4e0e\:3048\:3089\:308c\:305f\:3068\:304d\:3001",
  Cell[BoxData[
      \(TraditionalForm\`G\_w\)]],
  "\:306e\:6700\:9069\:6728\:3092\:6c42\:3081\:308b\:3002\n\
\:ff08\:ff11\:ff09i \:3092\:ff11\:3068\:3057\:3001\:8377\:91cd\:304c\:6700\
\:5c0f\:306e\:8fba\:3092",
  Cell[BoxData[
      \(TraditionalForm\`e\_1\)]],
  "\:3068\:3057\:3001",
  Cell[BoxData[
      \(TraditionalForm\`T\_i\)]],
  "\:3092 {",
  Cell[BoxData[
      \(TraditionalForm\`e\_1\)]],
  "}\:3068\:7f6e\:304f\:3002\n\:ff08\:ff12\:ff09\:65e2\:306b",
  Cell[BoxData[
      \(TraditionalForm\`T\_i\)]],
  "\:304c\:4f5c\:3089\:308c\:305f\:3068\:304d\:3001\:65b0\:305f\:306a\:8fba ",
  
  Cell[BoxData[
      \(TraditionalForm\`e\_\(i + 1\)\)]],
  "\:3092\:6b21\:306e\:6027\:8cea\:3092\:6e80\:305f\:3059\:3088\:3046\:306b\
\:9078\:3076\:3002\n\t\:ff08\:ff12\:ff0e\:ff11\:ff09",
  Cell[BoxData[
      \(TraditionalForm\`e\_\(i + 1\)\)]],
  "\:306f",
  Cell[BoxData[
      \(TraditionalForm\`T\_i\)]],
  "\:306b\:542b\:307e\:308c\:306a\:3044\:3001",
  Cell[BoxData[
      \(TraditionalForm\`G\_w\)]],
  "\:306e\:8fba\:3067\:3042\:308b\:3002\n\t\:ff08\:ff12\:ff0e\:ff12\:ff09\
\:90e8\:5206\:30b0\:30e9\:30d5",
  Cell[BoxData[
      \(TraditionalForm\`G\_w\)]],
  "[{",
  Cell[BoxData[
      \(TraditionalForm\`e\_1\)]],
  ", ",
  Cell[BoxData[
      \(TraditionalForm\`e\_2\)]],
  ",... , ",
  Cell[BoxData[
      \(TraditionalForm\`e\_\(i + 1\)\)]],
  "}] \:306f\:30b5\:30a4\:30af\:30eb\:3092\:542b\:307e\:306a\:3044\:3002\n\t\
\:ff08\:ff12\:ff0e\:ff13\:ff09w(",
  Cell[BoxData[
      \(TraditionalForm\`e\_\(i + 1\)\)]],
  ") \:306f\:6027\:8cea\:ff08\:ff12\:ff0e\:ff11\:ff09\:3092\:6e80\:305f\:3059\
\:3082\:306e\:306e\:5185\:3067\:6700\:5c0f\:3067\:3042\:308b\:3002\n\:ff08\
\:ff13\:ff09",
  Cell[BoxData[
      \(TraditionalForm\`T\_\(i + 1\)\)]],
  "\:3092",
  Cell[BoxData[
      \(TraditionalForm\`T\_i\)]],
  "\[Union]{",
  Cell[BoxData[
      \(TraditionalForm\`e\_\(i + 1\)\)]],
  "}\:3068\:3057\:3001i \:3092 i+1 \
\:3068\:3059\:308b\:3002\:3082\:3057\:3001i \:304c\:ff5cv(",
  Cell[BoxData[
      \(TraditionalForm\`G\_w\)]],
  ")\:ff5c - 1 \:306b\:7b49\:3057\:3044\:306a\:3089\:7d42\:4e86\:3059\:308b\
\:3002\:305d\:3046\:3067\:306a\:3044\:3068\:304d\:3001\:30b9\:30c6\:30c3\:30d7\
\:ff08\:ff12\:ff09\:306b\:623b\:308b\:3002\n\n\
\:3000\:95a2\:6570MinimumSpanningTree\:306e\:8fd4\:3059\:5024\:304b\:3089\
\:3001\:6700\:9069\:5024\:ff08\:6700\:9069\:6728\:306e\:8377\:91cd\:ff09\:3092\
\:6c42\:3081\:308b\:306b\:306f\:3001\:6b21\:306e\:3088\:3046\:306b\:3059\:308c\
\:3070\:3088\:3044\:3002"
}], "Text"],

Cell[CellGroupData[{

Cell[BoxData[{
    \(costofspanningtree[g_] := 
      Module[{ed, ted, mtx}, \n\ted = Edges[MinimumSpanningTree[g]]; \n\t
        mtx = Edges[g]; \n\t
        ted = Map[mtx[\([First[#], Last[#]]\)]&, 
            Position[ed, \ _?\((Function[n, n\  != \ 0])\)\ ]]; \n\t
        Apply[Plus, ted]/2.0\n]\), 
    \(costofspanningtree[c9]\)}], "Input"],

Cell[OutputFormData["\<\
268.\
\>", "\<\
268.\
\>"], "Output"]
}, Open  ]],

Cell[TextData[{
  "\:554f\:ff15\:ff0e\:8377\:91cd\:30b0\:30e9\:30d5\:306e\:30b3\:30b9\:30c8\
\:6700\:5927\:306e\:751f\:6210\:6728\:3092\:6c42\:3081\:308b\:30d7\:30ed\:30b0\
\:30e9\:30e0\:3092\:4f5c\:308c\:3002\n\:30d2\:30f3\:30c8\:ff1a\:4e0e\:3048\
\:3089\:308c\:305f\:8377\:91cd\:30b0\:30e9\:30d5\:306e\:96a3\:63a5\:884c\:5217\
\:306b\:3001-1 \:3092\:639b\:3051\:3066\:304b\:3089\:3001\:30b3\:30b9\:30c8\
\:6700\:5c0f\:306e\:751f\:6210\:6728\:3092\:6c42\:3081\:3088\:3002\n\:554f\
\:ff16\:ff0e\:8377\:91cd\:30b0\:30e9\:30d5\:306e\:9053\:ff30\:3092\:3001\:9802\
\:70b9\:306e\:30ea\:30b9\:30c8{",
  Cell[BoxData[
      \(TraditionalForm\`v\_1\)]],
  ", ",
  Cell[BoxData[
      \(TraditionalForm\`v\_2\)]],
  ", ... , ",
  Cell[BoxData[
      \(TraditionalForm\`v\_k\)]],
  "}\:3067\:4e0e\:3048\:305f\:3068\:304d\:3001\:ff30\:306e\:30b3\:30b9\:30c8\
\:3092\:8a08\:7b97\:3059\:308b\:30d7\:30ed\:30b0\:30e9\:30e0\:3092\:4f5c\:308c\
\:3002\:305f\:3060\:3057\:3001\:8377\:91cd\:30b0\:30e9\:30d5\:306f\:96a3\:63a5\
\:884c\:5217\:3067\:4e0e\:3048\:308b\:3082\:306e\:3068\:3059\:308b\:3002\n\
\:30d2\:30f3\:30c8\:ff1aelement[m_,{index___}]:=m[[index]]\n                \
costofpath[m_,p_]:=Apply[Plus,Map[element[m,#]&,Partition[p,2,1]]]"
}], "Text"],

Cell[TextData[
"\:3000\:30af\:30eb\:30b9\:30ab\:30eb\:306e\:30a2\:30eb\:30b4\:30ea\:30ba\
\:30e0\:306f\:3001\:30b9\:30c6\:30c3\:30d7\:ff08\:ff12\:ff09\:306e\:5224\:5b9a\
\:304c\:9762\:5012\:3067\:3042\:308b\:3002\:305d\:3053\:3067\:3001\:3082\:3063\
\:3068\:5358\:7d14\:306a\:30bd\:30ea\:30f3(Solin)\:306e\:30a2\:30eb\:30b4\
\:30ea\:30ba\:30e0\:3092\:7d39\:4ecb\:3059\:308b\:3002"], "Text"],

Cell[BoxData[
    \(\:30bd\:30ea\:30f3\:306e\:30a2\:30eb\:30b4\:30ea\:30ba\:30e0\)], "Input"],

Cell[TextData[{
  "\:3000\:96a3\:63a5\:884c\:5217 \
mm\:304c\:4e0e\:3048\:3089\:308c\:305f\:3068\:304d\:3001mm\:306e\:5b9a\:3081\
\:308b\:8377\:91cd\:30b0\:30e9\:30d5",
  Cell[BoxData[
      \(TraditionalForm\`\:306e\)]],
  "\:6700\:9069\:6728\:3092\:6c42\:3081\:308b\:3002\n\:ff08\:ff11\:ff09mm \
\:306e\:ff10\:306e\:8981\:7d20\:3092\:3059\:3079\:3066\[Infinity]\:306b\:5909\
\:66f4\:3059\:308b\:3002\:9802\:70b9\:306e\:96c6\:5408\:ff33\:3092 {1}\:3068\
\:3057\:3001jp \
\:3092\:ff11\:3068\:3059\:308b\:3002\:307e\:305f\:3001\:ff34={",
  Cell[BoxData[
      \(TraditionalForm\`t\_ij\)]],
  "}\:3092\:ff4e\:884c\:3001\:ff4e\:5217\:306e\:96f6\:884c\:5217\:3068\:3059\
\:308b\:3002\:305f\:3060\:3057\:3001\:ff4e\:306f mm\:306e\:30b5\:30a4\:30ba\
\:3067\:3042\:308b\:3002\n\:ff08\:ff12\:ff09mm\:306e jp\:5217\:306e\:8981\
\:7d20\:3059\:3079\:3066\:3092\[Infinity]\:306b\:5909\:3048\:308b\:3002\:ff33\
\:306e\:8981\:7d20\:306b\:5bfe\:5fdc\:3059\:308b mm\:306e\:3059\:3079\:3066\
\:306e\:884c\:5185\:306e\:6700\:5c0f\:5024\:3092",
  Cell[BoxData[
      \(TraditionalForm\`m\_ij\)]],
  "\:3068\:3059\:308b\:3068\:304d\:3001",
  Cell[BoxData[
      \(TraditionalForm\`t\_ij\)]],
  "\:3068",
  Cell[BoxData[
      \(TraditionalForm\`t\_ji\)]],
  "\:3068\:3092",
  Cell[BoxData[
      \(TraditionalForm\`m\_ij\)]],
  "\:3068\:7f6e\:304f\:3002\:307e\:305f\:3001jp \:3092 j \:3068\:3057\:3001\
\:ff33\:306b jp \:3092\:52a0\:3048\:308b\:3002\n\
\:ff08\:ff13\:ff09\:ff33\:306e\:9577\:3055\:304c\:ff4e\:4ee5\:4e0b\:306e\:3068\
\:304d\:3001\:30b9\:30c6\:30c3\:30d7\:ff08\:ff12\:ff09\:3092\:7e70\:308a\:8fd4\
\:3059\:3002\:305d\:3046\:3067\:306a\:3044\:3068\:304d\:306f\:7d42\:4e86\:3059\
\:308b\:3002\:3053\:306e\:3068\:304d\:3001\:ff33\:306f\:3059\:3079\:3066\:306e\
\:9802\:70b9\:3092\:542b\:307f\:3001\:ff34\:306f\:6700\:9069\:6728\:306e\:96a3\
\:63a5\:884c\:5217\:3067\:3042\:308b\:3002\n\n\:3000\:3053\:306e\:30a2\:30eb\
\:30b4\:30ea\:30ba\:30e0\:3092\:30d7\:30ed\:30b0\:30e9\:30e0\:3059\:308b\:3068\
\:3001\:6b21\:306e\:3088\:3046\:306b\:66f8\:3051\:308b\:3002"
}], "Text"],

Cell[BoxData[
    \(solin[m_] := 
      Module[{i, j, n = Length[m], tree, set, sl, si, mm, ip, jp, min}, \n\t\t
        mm = \((m\  /. \ 0 -> \[Infinity])\); \n\t\t
        tree = Table[0, {i, n}, {j, n}]; \n\t\tset = {1}; \ jp = 1; 
        sl = Length[set]; \n\t\t
        While[sl < n, \n\t\t\t
          For[i = 1, i <= n, \(i++\), mm[\([i, jp]\)] = \[Infinity]]; \n\t\t\t
          ip = set[\([1]\)]; jp = 1; min = mm[\([ip, jp]\)]; \n\t\t\t
          For[i = 1, i <= sl, \(i++\), si = set[\([i]\)]; \n\t\t\t\t
            For[j = 2, j <= n, \(j++\), 
              If[min > mm[\([si, j]\)], min = mm[\([si, j]\)]; ip = si; 
                jp = j]]]; \n\t\t\t
          tree[\([ip, jp]\)] = \(tree[\([jp, ip]\)] = min\); \n\t\t\t
          set = Append[set, jp]; \(sl++\)]; \n\t\ttree\n]\)], "Input"],

Cell[TextData[
"\:554f\:ff17\:3000\:6b21\:306e\:95a2\:6570\:306b\:3088\:308a\:3001\:8377\
\:91cd\:30b0\:30e9\:30d5\:306e\:96a3\:63a5\:884c\:5217\:3092\:4f5c\:308a\:3001\
\:30af\:30eb\:30b9\:30ab\:30eb\:3001\:30bd\:30ea\:30f3\:ff12\:3064\:306e\:30a2\
\:30eb\:30b4\:30ea\:30ba\:30e0\:306e\:901f\:5ea6\:6bd4\:8f03\:3092\:884c\:3048\
\:3002"], "Text"],

Cell[BoxData[{
    \(randommatrix[n_, p_, r_]\  := 
      Module[{i, mt}, \n\t\t
        mt\  = \ Table[
            Join[Table[0, {i}], 
              Table[\ \n\t\t\t\t\t
                If[Random[Real] < p, Random[Integer, r], \ 0], \n
                \t\t\t\t\t{n - i}]], {i, n}\n\t\t]; \n\t\tmt + Transpose[mt]\n
        \t]\), 
    \(solin[randommatrix[100, 1, {1, 10}]] // Timing\)}], "Input"]
},
FrontEndVersion->"Microsoft Windows 3.0",
ScreenRectangle->{{0, 640}, {0, 424}},
WindowSize->{437, 294},
WindowMargins->{{62, Automatic}, {Automatic, 7}},
PrintingCopies->1,
PrintingPageRange->{Automatic, Automatic}
]


(***********************************************************************
Cached data follows.  If you edit this Notebook file directly, not using
Mathematica, you must remove the line containing CacheID at the top of 
the file.  The cache data will then be recreated when you save this file 
from within Mathematica.
***********************************************************************)

(*CellTagsOutline
CellTagsIndex->{}
*)

(*CellTagsIndex
CellTagsIndex->{}
*)

(*NotebookFileOutline
Notebook[{
Cell[1709, 49, 132, 3, 30, "Input"],
Cell[1844, 54, 1318, 18, 183, "Text"],
Cell[3165, 74, 1060, 34, 90, "Text"],
Cell[4228, 110, 128, 2, 30, "Input"],
Cell[4359, 114, 612, 8, 71, "Text"],
Cell[4974, 124, 1090, 23, 357, "Input"],
Cell[6067, 149, 1756, 25, 185, "Text"],

Cell[CellGroupData[{
Cell[7848, 178, 3461, 72, 263, "Input"],
Cell[11312, 252, 230, 7, 47, "Output"]
}, Open  ]],
Cell[11557, 262, 2018, 26, 261, "Text"],
Cell[13578, 290, 1615, 33, 168, "Input"],
Cell[15196, 325, 113, 2, 30, "Input"],
Cell[15312, 329, 8666, 184, 1059, "Text"],
Cell[23981, 515, 116, 2, 30, "Input"],
Cell[24100, 519, 1469, 19, 185, "Text"],

Cell[CellGroupData[{
Cell[25594, 542, 300, 5, 90, "Input"],
Cell[25897, 549, 16567, 348, 296, 2253, 167, "GraphicsData", 
"PostScript", "Graphics"]
}, Open  ]],
Cell[42479, 900, 863, 11, 109, "Text"],
Cell[43345, 913, 107, 2, 30, "Input"],
Cell[43455, 917, 2696, 74, 261, "Text"],

Cell[CellGroupData[{
Cell[46176, 995, 348, 7, 170, "Input"],
Cell[46527, 1004, 62, 4, 27, "Output"]
}, Open  ]],
Cell[46604, 1011, 1242, 23, 166, "Text"],
Cell[47849, 1036, 390, 5, 52, "Text"],
Cell[48242, 1043, 93, 1, 30, "Input"],
Cell[48338, 1046, 2064, 40, 261, "Text"],
Cell[50405, 1088, 807, 14, 310, "Input"],
Cell[51215, 1104, 347, 5, 52, "Text"],
Cell[51565, 1111, 400, 9, 170, "Input"]
}
]
*)




(***********************************************************************
End of Mathematica Notebook file.
***********************************************************************)

