(***********************************************************************

                    Mathematica-Compatible Notebook

This notebook can be used on any computer system with Mathematica 4.0,
MathReader 4.0, or any compatible application. The data for the notebook 
starts with the line containing stars above.

To get the notebook into a Mathematica-compatible application, do one of 
the following:

* Save the data starting with the line of stars above into a file
  with a name ending in .nb, then open the file inside the application;

* Copy the data starting with the line of stars above to the
  clipboard, then use the Paste menu command inside the application.

Data for notebooks contains only printable 7-bit ASCII and can be
sent directly in email or through ftp in text mode.  Newlines can be
CR, LF or CRLF (Unix, Macintosh or MS-DOS style).

NOTE: If you modify the data for this notebook not in a Mathematica-
compatible application, you must delete the line below containing the 
word CacheID, otherwise Mathematica-compatible applications may try to 
use invalid cache data.

For more information on notebooks and Mathematica-compatible 
applications, contact Wolfram Research:
  web: http://www.wolfram.com
  email: info@wolfram.com
  phone: +1-217-398-0700 (U.S.)

Notebook reader applications are available free of charge from 
Wolfram Research.
***********************************************************************)

(*CacheID: 232*)


(*NotebookFileLineBreakTest
NotebookFileLineBreakTest*)
(*NotebookOptionsPosition[     45447,        953]*)
(*NotebookOutlinePosition[     46100,        976]*)
(*  CellTagsIndexPosition[     46056,        972]*)
(*WindowFrame->Normal*)



Notebook[{
Cell[BoxData[
    \(\(\(\:ff11\:ff10\:ff0e\) \:ff16\:ff0e\) 
      \:ff13\:3000\:4eba\:6750\:5272\:308a\:5f53\:3066\:554f\:984c\)], "Input"],

Cell[BoxData[
    \(\(\:30de\:30c3\) \:30c1\:30f3\:30b0\)], "Input"],

Cell[TextData[{
  "\:3000\:30b0\:30e9\:30d5\:ff27\:306e\:30de\:30c3\:30c1\:30f3\:30b0 \
(matching) \
M\:3068\:306f\:3001\:305d\:308c\:306e\:3069\:306e\:ff12\:8fba\:3082\:4e92\
\:3044\:306b\:96a3\:63a5\:3057\:306a\:3044E(G)\:306e\:90e8\:5206\:96c6\:5408 \
\:306e\:3053\:3068\:3067\:3042\:308b\:3002\:9802\:70b9\:ff56\:304c\:30de\:30c3\
\:30c1\:30f3\:30b0 M\:306b\:5c5e\:3059\:308b\:8fba\:306e\:ff11\:3064\:306e\
\:7aef\:70b9\:306e\:3068\:304d\:3001\:ff56\:306f \
M\:30fc\:98fd\:548c(M-saturated)\:3068\:8a00\:3044\:3001\:305d\:3046\:3067\
\:306a\:3044\:3068\:304d\:3001\:ff56\:3092\:306fM\:30fc\:4e0d\:98fd\:548c(M-\
unsaturated)\:3068\:8a00\:3046\:3002\n\:3000\:ff27\:306e\:3059\:3079\:3066\
\:306e\:9802\:70b9\:304cM\:30fc\:98fd\:548c\:306e\:3068\:304d\:3001 M\:306f\
\:5b8c\:5168(complete)\:30de\:30c3\:30c1\:30f3\:30b0\:3067\:3042\:308b\:3068\
\:8a00\:3046\:3002|M'| > |M| \:3068\:306a\:308b\:4ed6\:306e\:30de\:30c3\:30c1\
\:30f3\:30b0 M'\:304c\:5b58\:5728\:3057\:306a\:3044\:3068\:304d\:3001M\:3092\
\:6700\:5927(maximal)\:30de\:30c3\:30c1\:30f3\:30b0\:3068\:8a00\:3046\:3002\n\
\:3000M\:3092\:30b0\:30e9\:30d5\:ff27\:306e\:30de\:30c3\:30c1\:30f3\:30b0\
\:3068\:3059\:308b\:3068\:304d\:3001\:ff27\:306e\:9053\:ff30\:304c E(G) \\ M\
\:3068 M\:306e\:8fba\:3092\:4ea4\:4e92\:306b\:542b\:3080\:3068\:304d\:3001\
\:ff30\:3092M\:30fc\:4ea4\:4e92\:9053(M-alternating path)\:3068\:8a00\:3046\
\:3002\:7279\:306b\:3001M\:30fc\:4ea4\:4e92\:9053\:ff30\:306e\:59cb\:70b9\
\:3068\:7d42\:70b9\:304c\:5171\:306b M\:30fc\:4e0d\:98fd\:548c\:3067\:3042\
\:308b\:3068\:304d\:3001\:ff30\:3092 M\:30fc\:5897\:5927\:9053(M-augumenting \
path)\:3068\:8a00\:3046\:3002\n\:3000\:30b0\:30e9\:30d5\:ff27\:306e\:30de\
\:30c3\:30c1\:30f3\:30b0 M\:304c M\:30fc\:5897\:5927\:9053",
  Cell[BoxData[
      \(TraditionalForm\`v\_0\)]],
  Cell[BoxData[
      \(TraditionalForm\`v\_1\)]],
  "...",
  Cell[BoxData[
      \(TraditionalForm\`v\_\(2  k + 1\)\)]],
  "\:3092\:542b\:3081\:3070\:3001\:6b21\:306e\:3088\:3046\:306a\:30de\:30c3\
\:30c1\:30f3\:30b0 M'\n\tM'=(M\\{",
  Cell[BoxData[
      \(TraditionalForm\`v\_1\)]],
  Cell[BoxData[
      \(TraditionalForm\`v\_2\)]],
  ",",
  Cell[BoxData[
      \(TraditionalForm\`v\_3\)]],
  Cell[BoxData[
      \(TraditionalForm\`v\_4\)]],
  ",..., ",
  Cell[BoxData[
      \(TraditionalForm\`v\_\(2  k - 1\)\)]],
  Cell[BoxData[
      \(TraditionalForm\`v\_\(2  k\)\)]],
  "})\[Union]{",
  Cell[BoxData[
      \(TraditionalForm\`v\_0\)]],
  Cell[BoxData[
      \(TraditionalForm\`v\_1\)]],
  ",",
  Cell[BoxData[
      \(TraditionalForm\`v\_2\)]],
  Cell[BoxData[
      \(TraditionalForm\`v\_3\)]],
  ",... ,",
  Cell[BoxData[
      \(TraditionalForm\`v\_\(2  k\)\)]],
  Cell[BoxData[
      \(TraditionalForm\`v\_\(2  k + 1\)\)]],
  "}\n\:306f\:3001|M'|=|M|+1\:3092\:6e80\:305f\:3059\:30de\:30c3\:30c1\:30f3\
\:30b0\:3067\:3042\:308b\:3002\n\:3000\:9006\:306b\:3001M\:304c\:6700\:5927\
\:3067\:306a\:3044\:3068\:3057\:3001\:ff27\:306e\:6700\:5927\:30de\:30c3\:30c1\
\:30f3\:30b0\:3092 M'\:3068\:3059\:308b\:3068\:3001H=M\[CapitalDelta]M' \
\:ff08\:305f\:3060\:3057\:3001\[CapitalDelta]\:306f\:96c6\:5408\:306e\:5bfe\
\:79f0\:5dee\:3092\:8868\:3057\:3001M\:3068 M'\:3068\:306e\:3069\:3061\:3089\
\:304b\:4e00\:65b9\:306b\:306e\:307f\:542b\:307e\:308c\:308b\:8981\:7d20\:306e\
\:96c6\:5408\:3067\:3042\:308b\:ff09\:306e\:9023\:7d50\:6210\:5206\:306e\:5404\
\:3005\:306f\:3001M\:3068 M'\:306e\:8fba\:304c\:4ea4\:4e92\:306b\:73fe\:308c\
\:308b\:5076\:30b5\:30a4\:30af\:30eb\:304b\:3001\:307e\:305f\:306f M\:3068 M'\
\:306e\:8fba\:304c\:4ea4\:4e92\:306b\:73fe\:308c\:308b\:9053\:3067\:3042\:308b\
\:3002\:9023\:7d50\:6210\:5206\:304cM\:30fc\:4ea4\:4e92\:9053\:ff30\:306e\
\:5834\:5408\:306b\:306f\:3001|M'| > |M|\:3088\:308a\:3001\:ff30\:306e\:59cb\
\:70b9\:3068\:7d42\:70b9\:306f M\:30fc\:4e0d\:98fd\:548c\:70b9\:3067\:3042\
\:308b\:306e\:3067\:3001\:ff30\:306f M\:30fc\:5897\:5927\:9053\:3067\:3042\
\:308b\:3002\n\:3000\:5f93\:3063\:3066\:3001\[CloseCurlyDoubleQuote]\:30b0\
\:30e9\:30d5\:ff27\:306e\:30de\:30c3\:30c1\:30f3\:30b0 M\:304c\:6700\:5927\
\:3067\:3042\:308b\:305f\:3081\:306e\:5fc5\:8981\:5341\:5206\:6761\:4ef6\:306f\
\:3001\:ff27\:304c M\:30fc\:5897\:5927\:9053\:3092\:542b\:307e\:306a\:3044\
\:3053\:3068\:3067\:3042\:308b\[CloseCurlyDoubleQuote]\:3002"
}], "Text"],

Cell[BoxData[
    \(\(\:ff12\:90e8\:30b0\:30e9\:30d5\:306e\:30de\:30c3\) 
      \:30c1\:30f3\:30b0\)], "Input"],

Cell[TextData[{
  "\:3000\:30b0\:30e9\:30d5\:ff27\:306e\:4efb\:610f\:306e\:9802\:70b9\:96c6\
\:5408\:ff33\:306b\:5bfe\:3057\:3066\:3001\:ff33\:306e\:3069\:308c\:304b\:306e\
\:9802\:70b9\:306b\:96a3\:63a5\:3059\:308b\:ff27\:306e\:9802\:70b9\:306e\:5168\
\:4f53\:3092\:ff33\:306e\:8fd1\:508d(neighbor)\:3068\:547c\:3073\:3001",
  Cell[BoxData[
      \(TraditionalForm\`N\_G\)]],
  "(S)\:307e\:305f\:306fN(S)\:3068\:8868\:3059\:3002\n\
\:3000\:ff27\:3092\:ff12\:90e8\:5206\:5272(X,Y)\:3092\:6301\:3064\:ff12\:90e8\
\:30b0\:30e9\:30d5\:3068\:3059\:308b\:3002\:4eca\:3001\:ff27\:304c\:ff38\:306e\
\:3059\:3079\:3066\:306e\:8fba\:3067\:98fd\:548c\:3057\:3066\:3044\:308b\:30de\
\:30c3\:30c1\:30f3\:30b0 M\:3092\:6301\:3064\:3082\:306e\:3068\:3059\:308b\
\:3002\:307e\:305f\:ff33\:3092\:ff38\:306e\:4efb\:610f\:306e\:90e8\:5206\:96c6\
\:5408\:3068\:3059\:308b\:3002\:3053\:306e\:3068\:304d\:3001\:ff33\:306e\:5404\
\:9802\:70b9\:306fM\:30fc\:98fd\:548c\:3067\:3042\:308b\:306e\:3067\:3001\
\:ff33\:306e\:5404\:9802\:70b9\:306bN(S)\:306b\:5c5e\:3059\:308b\:7570\:306a\
\:308b\:96a3\:63a5\:9802\:70b9\:3092\:5bfe\:5fdc\:3065\:3051\:308b\:3053\:3068\
\:304c\:53ef\:80fd\:3067\:3042\:308b\:3002\:5f93\:3063\:3066\:3001|S|\
\[LessEqual]N(S)\:304c\:6210\:308a\:7acb\:3064\:3002\:9006\:306b\:3001V(G)\
\:306e\:4efb\:610f\:306e\:90e8\:5206\:96c6\:5408\:ff33\:306b\:5bfe\:3057\:3066\
\:3001|S|\[LessEqual]N(S)\:304c\:6210\:308a\:7acb\:3064\:3082\:306e\:3068\
\:3059\:308b\:3002\:3053\:306e\:3068\:304d\:3001\:ff27\:304c\:ff38\:306e\:3059\
\:3079\:3066\:306e\:8fba\:3067\:98fd\:548c\:3057\:3066\:3044\:308b\:30de\:30c3\
\:30c1\:30f3\:30b0 \:3092\:6301\:305f\:306a\:3044\:3068\:3059\:308b\:3068\
\:3001\:ff27\:306e\:6700\:5927\:30de\:30c3\:30c1\:30f3\:30b0M*\:3068M*\:30fc\
\:4e0d\:98fd\:548c\:306a\:9802\:70b9 u \:304c\:ff38\:306b\:5b58\:5728\:3059\
\:308b\:3002\:6b21\:306b\:3001\:ff3a\:3092M*\:30fc\:4ea4\:4e92\:9053\:3067 u \
\:3068\:7d50\:3079\:308b\:ff27\:306e\:9802\:70b9\:306e\:5168\:4f53\:3068\:3057\
\:3001\:ff33\:ff1d\:ff3a\[Intersection]\:ff38\:3001\:ff34\:ff1d\:ff3a\
\[Intersection]\:ff39\:3068\:3059\:308b\:3002M*\:306f\:6700\:5927\:30de\:30c3\
\:30c1\:30f3\:30b0\:3067\:3042\:308b\:306e\:3067\:3001u \:306e\:307f\:304c\
\:ff33\:3067\:306eM*\:30fc\:4e0d\:98fd\:548c\:306a\:9802\:70b9\:3067\:3042\
\:308b\:3002\:307e\:305f\:3001u \:4ee5\:5916\:306e\:ff33\:306e\:5404\:9802\
\:70b9\:306f\:3001M*\:306e\:8fba\:3067\:ff34\:306e\:9802\:70b9\:3068\:96a3\
\:63a5\:3057\:3066\:3044\:308b\:306e\:3067\:3001|T| = |S| - 1\:304c\:6210\
\:308a\:7acb\:3064\:3002\:66f4\:306b\:3001\:ff34\:3068N(S)\:306e\:5404\:9802\
\:70b9\:306f\:3001\:5171\:306bM*\:30fc\:4ea4\:4e92\:9053\:3067 u \:3068\:7d50\
\:3079\:308b\:306e\:3067\:3001N(S)\:3068\:ff34\:3068\:306f\:4e00\:81f4\:3059\
\:308b\:3002\:5f93\:3063\:3066\:3001|S|\:ff1eN(S)\:304c\:6210\:308a\:7acb\
\:3064\:3002\:3057\:304b\:3057\:3001\:3053\:308c\:306f\:521d\:3081\:306e\:4eee\
\:5b9a\:306b\:53cd\:3059\:308b\:3002\:6545\:306b\:3001\:ff27\:306f\:ff38\:306e\
\:3059\:3079\:3066\:306e\:8fba\:3067\:98fd\:548c\:3057\:3066\:3044\:308b\:30de\
\:30c3\:30c1\:30f3\:30b0 \:3092\:6301\:3064\:3002\n\:3000\:3053\:308c\:307e\
\:3067\:306e\:8003\:5bdf\:306b\:3088\:308a\:3001\:6b21\:306e\:30db\:30fc\:30eb\
(Hall)\:306e\:5b9a\:7406\:304c\:6210\:308a\:7acb\:3064\:3002\n\n",
  StyleBox["Hall \:306e\:5b9a\:7406",
    FontWeight->"Bold"],
  "\:3000\:ff27\:3092\:ff12\:90e8\:5206\:5272(X,Y)\:3092\:6301\:3064\:ff12\
\:90e8\:30b0\:30e9\:30d5\:3068\:3059\:308b\:3002\:3053\:306e\:3068\:304d\:3001\
\:ff27\:304c\:ff38\:306e\:3059\:3079\:3066\:306e\:8fba\:3067\:98fd\:548c\:3057\
\:3066\:3044\:308b\:30de\:30c3\:30c1\:30f3\:30b0 M\:3092\:6301\:3064\:305f\
\:3081\:306e\:5fc5\:8981\:5341\:5206\:6761\:4ef6\:306f\:3001\:ff38\:306e\:4efb\
\:610f\:306e\:90e8\:5206\:96c6\:5408\:ff33\:306b\:5bfe\:3057\:3066\:3001|S|\
\[LessEqual]N(S)\:304c\:6210\:308a\:7acb\:3064\:3053\:3068\:3067\:3042\:308b\
\:3002\n\n\:554f\:ff11\:ff0e\:96c6\:56e3\:304a\:898b\:5408\:3044\:306b\:304a\
\:3044\:3066\:3001\:3069\:306e\:7537\:6027\:3082\:ff4b\:4eba\:306e\:5973\:6027\
\:306b\:597d\:610f\:3092\:6301\:3061\:3001\:3069\:306e\:5973\:6027\:3082\:ff4b\
\:4eba\:306e\:7537\:6027\:306b\:597d\:610f\:3092\:6301\:3063\:3066\:3044\:308c\
\:3070\:3001\:3069\:306e\:7537\:6027\:3082\:3069\:306e\:5973\:6027\:3082\:4e92\
\:3044\:306b\:597d\:610f\:3092\:62b1\:3044\:3066\:3044\:308b\:76f8\:624b\:3068\
\:7d50\:5a5a\:3067\:304d\:308b\:7d44\:307f\:5408\:308f\:305b\:304c\:3042\:308b\
\:3053\:3068\:3092\:793a\:305b\:3002\n\:554f\:ff12\:ff0e\:975e\:8ca0\:306e\
\:5b9f\:6570\:3092\:8981\:7d20\:306b\:6301\:3064\:6b63\:65b9\:884c\:5217 A\
\:306b\:304a\:3044\:3066\:3001\:5404\:884c\:306e\:8981\:7d20\:306e\:7dcf\:548c\
\:304c\:ff11\:3067\:3001\:304b\:3064\:5404\:5217\:306e\:7dcf\:548c\:3082\:ff11\
\:3067\:3042\:308b\:3068\:304d\:3001A\:3092\:ff12\:91cd\:78ba\:7387\:884c\
\:5217\:3068\:8a00\:3046\:3002\:3053\:306e\:3068\:304d\:3001\:ff12\:91cd\:78ba\
\:7387\:884c\:5217 A\:306f\:3001\:6b21\:306e\:3088\:3046\:306b\:7f6e\:63db\
\:884c\:5217\:306e\:7dda\:5f62\:7d50\:5408\:306b\:5206\:89e3\:3067\:304d\:308b\
\:3053\:3068\:3092\:793a\:305b\:3002\n\tA = ",
  Cell[BoxData[
      \(TraditionalForm\`c\_1\)]],
  Cell[BoxData[
      \(TraditionalForm\`P\_1\)]],
  "+",
  Cell[BoxData[
      \(TraditionalForm\`c\_2\)]],
  Cell[BoxData[
      \(TraditionalForm\`P\_2\)]],
  "+...+",
  Cell[BoxData[
      \(TraditionalForm\`c\_k\)]],
  Cell[BoxData[
      \(TraditionalForm\`P\_k\)]],
  "\n\:305f\:3060\:3057\:3001",
  Cell[BoxData[
      \(TraditionalForm\`P\_i\)]],
  " (i=1,2,...,k)\:306f\:7f6e\:63db\:884c\:5217\:ff08\:ff10\:ff0c\:ff11\:3092\
\:8981\:7d20\:306b\:6301\:3064\:884c\:5217\:3067\:3001\:5404\:884c\:5404\:5217\
\:306b\:4e01\:5ea6\:ff11\:500b\:306e\:ff11\:3092\:6301\:3064\:ff12\:91cd\:78ba\
\:7387\:884c\:5217\:ff09\:3067\:3001",
  Cell[BoxData[
      \(TraditionalForm\`c\_i\)]],
  "\:306f\:975e\:8ca0\:306e\:5b9f\:6570\:3067\:3001",
  Cell[BoxData[
      \(TraditionalForm\`\[Sum]\+\(i = 1\)\%k c\_i\)]],
  "=1 \:3067\:3042\:308b\:3002"
}], "Text"],

Cell[BoxData[
    \(\:30cf\:30f3\:30ac\:30ea\:30fc\:6cd5\)], "Input"],

Cell["\<\
\:3000\:30b0\:30e9\:30d5\:ff27\:3092\:ff12\:90e8\:5206\:5272\:ff08\:ff38\:3001\
\:ff39\:ff09\:ff08\:305f\:3060\:3057\:3001\:ff5c\:ff38\:ff5c\:ff1d\:ff5c\:ff39\
\:ff5c\:ff09\:3092\:6e80\:305f\:3059\:ff12\:90e8\:30b0\:30e9\:30d5\:3068\:3059\
\:308b\:3002\:3053\:306e\:3068\:304d\:3001\:ff27\:306e\:6700\:5927\:30de\:30c3\
\:30c1\:30f3\:30b0\:3092\:63a2\:7d22\:3059\:308b\:65b9\:6cd5\:3068\:3057\:3066\
\:3001\:6b21\:306e\:3088\:3046\:306a\:6709\:540d\:306a\:3082\:306e\:304c\:77e5\
\:3089\:308c\:3066\:3044\:308b\:3002
\:3000\:307e\:3065\:3001\:ff2d\:3092\:ff27\:306e\:4efb\:610f\:306e\:30de\:30c3\
\:30c1\:30f3\:30b0\:3068\:3059\:308b\:3002
\:ff11\:ff0e\:3082\:3057\:3001\:ff38\:306e\:3059\:3079\:3066\:306e\:9802\:70b9\
\:304cM\:30fc\:98fd\:548c\:3067\:3042\:308c\:3070\:3001\:7d42\:4e86\:3059\
\:308b\:3002\:305d\:3046\:3067\:306a\:3044\:3068\:304d\:3001u \:3092\:ff38\
\:306eM\:30fc\:4e0d\:98fd\:548c\:306a\:9802\:70b9\:3001\:ff33\:3092{u}\:3001\
\:ff34\:3092\[Phi]\:3068\:7f6e\:304f\:3002
\:ff12\:ff0e\:3082\:3057\:3001N(S)\:3068\:ff34\:3068\:304c\:7b49\:3057\:3044\
\:3068\:304d\:306f\:3001|T|=|S| - 1 \:3088\:308a\:3001|N(S)| < |S| \:3068\
\:306a\:308b\:306e\:3067\:3001Hall\:306e\:5b9a\:7406\:3088\:308a\:ff27\:306b\
\:306f\:ff38\:306e\:3059\:3079\:3066\:306e\:9802\:70b9\:3092\:98fd\:548c\:3055\
\:305b\:308b\:30de\:30c3\:30c1\:30f3\:30b0\:306f\:5b58\:5728\:3057\:306a\:3044\
\:306e\:3067\:3001\:7d42\:4e86\:3059\:308b\:3002\:305d\:3046\:3067\:306a\:3044\
\:3068\:304d\:306f\:3001N(S)\:306e\:8981\:7d20\:3067\:ff34\:306b\:542b\:307e\
\:308c\:306a\:3044\:8981\:7d20\:ff59\:3092\:9078\:3076\:ff08\:ff34\:306fN(S)\
\:306e\:90e8\:5206\:96c6\:5408\:3067\:3042\:308b\:306e\:3067\:3001\:3053\:306e\
\:3088\:3046\:306a\:8981\:7d20\:306f\:5b58\:5728\:3059\:308b\:ff09\:3002
\:ff13\:ff0e\:3082\:3057\:3001\:ff59\:304cM\:30fc\:98fd\:548c\:3067\:3042\
\:308c\:3070\:3001M\:306e\:8fba yz \:3092\:9078\:3073\:3001\:ff33\:3092\:ff33\
\[Union]{z}\:3001\:ff34\:3092\:ff34\[Union]{y}\:3068\:7f6e\:304d\:ff08\:3053\
\:306e\:3068\:304d\:3001\:ff33\:3001\:ff34\:5171\:306b\:8981\:7d20\:304c\:ff11\
\:3064\:5897\:3048\:308b\:ff09\:3001\:30b9\:30c6\:30c3\:30d7\:ff12\:306b\:623b\
\:308b\:3002\:ff59\:304cM\:30fc\:4e0d\:98fd\:548c\:3067\:3042\:308c\:3070\
\:3001u \:3068\:ff59\:3068\:3092\:7d50\:3076M\:30fc\:5897\:5927\:9053\:ff30\
\:304c\:3042\:308b\:306e\:3067\:3001\:30de\:30c3\:30c1\:30f3\:30b0 M\:3092\
\:65b0\:305f\:306a\:30de\:30c3\:30c1\:30f3\:30b0 M'\:ff1dM\[CapitalDelta]\
\:ff30\:306b\:7f6e\:304d\:63db\:3048\:3066\:3001\:30b9\:30c6\:30c3\:30d7\:ff11\
\:306b\:623b\:308b\:3002

\:3000\:30cf\:30f3\:30ac\:30ea\:30fc\:6cd5(hungarian \
method)\:3068\:547c\:3070\:308c\:308b\:3053\:306e\:65b9\:6cd5\:306e\:96e3\
\:70b9\:306f\:3001\:30b9\:30c6\:30c3\:30d7\:ff13\:306e\:524d\:534a\:3067\:9078\
\:3070\:308c\:308b\:8fba yz \:306e\:96c6\:307e\:308a\:304b\:3089\:3001M\:30fc\
\:5897\:5927\:9053\:ff30\:3092\:5177\:4f53\:7684\:306b\:6c42\:3081\:308b\:624b\
\:9806\:304c\:660e\:89e3\:3067\:306a\:3044\:70b9\:306b\:3042\:308b\:3002
 \:3000\:4f8b\:3048\:3070\:3001\:6b21\:306e\:3088\:3046\:306a\:96a3\:63a5\
\:884c\:5217 mm \:3067\:5b9a\:307e\:308b\:ff12\:90e8\:30b0\:30e9\:30d5\:ff27\
\:3068\:30de\:30c3\:30c1\:30f3\:30b0 \
match\:306b\:5bfe\:3057\:3066\:3001\:30cf\:30f3\:30ac\:30ea\:30fc\:6cd5\:3092\
\:9069\:7528\:3059\:308b\:3068\:3001\:6b21\:306e\:3088\:3046\:306a\:8fba\:306e\
\:96c6\:5408tree\:304c\:5f97\:3089\:308c\:308b\:3002\
\>", "Text"],

Cell[BoxData[
    \(\(mm = {{0, \ 0, \ 0, \ 0, \ 0, \ 0, \ 1, \ 1, \ 1, \ 1}, \ \ \ {0, \ 
            0, \ 0, \ 0, \ 0, \ 0, \ 1, \ 0, \ 0, \ 0}, \ \ \n\ \ \ \ \ {0, \ 
            0, \ 0, \ 0, \ 0, \ 1, \ 0, \ 0, \ 0, \ 0}, \ \ \ {0, \ 0, \ 0, \ 
            0, \ 0, \ 0, \ 0, \ 1, \ 0, \ 0}, \ \ \n\ \ \ \ \ {0, \ 0, \ 0, \ 
            0, \ 0, \ 0, \ 0, \ 0, \ 0, \ 1}, \ \ {0, \ 0, \ 1, \ 0, \ 0, \ 
            0, \ 0, \ 0, \ 0, \ 0}, \ \ \n\ \ \ \ \ {1, \ 1, \ 0, \ 0, \ 0, \ 
            0, \ 0, \ 0, \ 0, \ 0}, \ \ {1, \ 0, \ 0, \ 1, \ 0, \ 0, \ 0, \ 
            0, \ 0, \ 0}, \ \n\ \ \ \ \ {1, \ 0, \ 0, \ 0, \ 0, \ 0, \ 0, \ 
            0, \ 0, \ 0}, \ {1, \ 0, \ 0, \ 0, \ 1, \ 0, \ 0, \ 0, \ 0, \ 
            0}};\)\)], "Input"],

Cell[BoxData[{
    \(\(match = {{1, \ 7}, \ {3, \ 6}, \ {4, \ 8}, \ {5, \ 10}};\)\), "\n", 
    \(s = {2, \ 1, \ 5, \ 4}; ngs = {7, \ 8, \ 9, \ 10}; 
    t = {7, \ 10, \ 8};\), "\n", 
    \(\(y = 1;\)\), "\n", 
    \(\(tree = {{2, \ 7}, \ {7, \ 1}, \ {1, \ 10}, \ {10, \ 5}, \ {1, \ 
            8}, \ {8, \ 4}, \ {1, \ 9}};\)\)}], "Input"],

Cell["\<\
\:3000\:3053\:306e\:8fba\:96c6\:5408tree\:306f\:3001\:9802\:70b9\:ff12\:3092\
\:6839\:3068\:3057\:3001\:9802\:70b9\:ff15\:ff0c\:ff14\:ff0c\:ff19\:3092\:8449\
\:3068\:3059\:308b\:6728\:306e\:69cb\:9020\:3092\:6301\:3064\:3002\:307e\:305f\
\:3001\:6700\:521d\:306e\:9802\:70b9\:ff12\:3068\:6700\:5f8c\:306e\:9802\:70b9\
\:ff19\:304c\:4e0d\:98fd\:548c\:306a\:9802\:70b9\:3067\:3042\:308b\:3002\:5f93\
\:3063\:3066\:3001\:6c42\:3081\:308b\:5897\:5927\:9053\:306f\:3001{{2, 7}, \
{7, 1}, {1, 9}}\:3068\:306a\:308b\:3002
\:3000\:30cf\:30f3\:30ac\:30ea\:30fc\:6cd5\:306f\:6b21\:306e\:3088\:3046\:306b\
\:66f8\:3051\:308b\:3002\:7279\:306b\:3001\:8fba\:96c6\:5408tree\:304b\:3089\
\:3001\:5897\:5927\:9053\:3092\:6c42\:3081\:308b\:306b\:306f\:3001\:6700\:5f8c\
\:306e\:8fba({1,9})\:304b\:3089\:59cb\:3081\:3066\:3001\:9014\:4e2d\:306e\
\:4e0d\:5fc5\:8981\:306a\:679d({{1,8},{8,4}},{{1,10},{10,5}})\:3092\:9806\
\:756a\:306b\:5208\:308a\:8fbc\:3093\:3067\:884c\:304f\:65b9\:6cd5\:3092\:7528\
\:3044\:308b\:3002\:3053\:306e\:305f\:3081\:306e\:95a2\:6570\:304c\:3001\
findaugmentingpath\:3067\:3042\:308b\:3002\:3053\:306e\:95a2\:6570\:306f\:6728\
\:6210\:9577\:6cd5\:3067\:4f5c\:6210\:3055\:308c\:305f\[CloseCurlyDoubleQuote]\
\:6839\:304b\:3089\:8449\:306b\:5411\:304b\:3046\:65b9\:5411\:3092\:6301\:3064\
\:6728\[CloseCurlyDoubleQuote]\:306b\:5bfe\:3057\:3066\:9069\:7528\:3055\:308c\
\:308b\:306e\:3067\:3001\:9802\:70b9\:ff19\:3092\:7d42\:70b9\:3068\:3059\:308b\
\:8fba\:ff08\:ff11\:ff0c\:ff19\:ff09\:304c\:5b9a\:307e\:308a\:3001\:ff11\:3092\
\:7d42\:70b9\:3068\:3059\:308b\:8fba\:ff08\:ff17\:ff0c\:ff11\:ff09\:304c\:6b21\
\:306b\:6c7a\:308a\:3001\:6b21\:306b\:ff17\:3092\:7d42\:70b9\:3068\:3059\:308b\
\:8fba\:ff08\:ff12\:ff0c\:ff17\:ff09\:304c\:6c7a\:307e\:308a\:9802\:70b9\:ff12\
\:3067\:7d42\:4e86\:3059\:308b\:3002\:8fba\:ff08\:ff11\:ff0c\:ff18\:ff09\:3067\
\:306f\:9802\:70b9\:ff11\:306f\:59cb\:70b9\:3067\:3042\:308b\:3053\:3068\:306b\
\:6ce8\:610f\:305b\:3088\:3002\
\>", "Text"],

Cell[CellGroupData[{

Cell[BoxData[
    \(findaugmentingpath[tree]\)], "Input"],

Cell[BoxData[
    \({{2, 7}, {1, 7}, {1, 9}}\)], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[{
    \(initialmatching[mm_] := 
      Module[{n, e, edges, match = {}}, \n\t
        edges = Position[mm, _?\((Function[n, n != 0])\)]; \n\t
        e = First[edges]; \n\t
        While[First[e] < Last[e], \n\t\tIf[
            Not[MemberQ[Flatten[match], First[e]]]\  && \ 
              Not[MemberQ[Flatten[match], Last[e]]], 
            AppendTo[match, e]]; \n\t\tedges = Rest[edges]; 
          e = First[edges]\[IndentingNewLine]\ \ ]; \n\t
        Return[match]\n]\), "\n", 
    \(newmatching[match_, path_] := 
      Union[Complement[Union[match, path], 
          Intersection[match, path]]]\n\), "\n", 
    \(getmatchingedge[y_, mt_] := 
      First[mt[\([First[First[Position[Map[Last, mt], y]]]]\)]]\n\), "\n", 
    \(findneighbour[mm_, s_] := 
      Union[Flatten[
          Union[Map[Position[mm[\([#]\)], _?\((Function[n, n != 0])\)] &, 
              s]]]]\n\), "\[IndentingNewLine]", 
    \(searchparent[y_, s_, mm_] := \n\t
      Scan[\((If[mm[\([#, y]\)] == 1, Return[#]])\) &, 
        s]\[IndentingNewLine]\), "\n", 
    \(findaugmentingpath[tree_] := 
      Block[{start, tmp, topedge, endedge, path = {}}, \n\t
        If[Length[tree] == 1, Return[tree]]; \n\t
        start = First[First[tree]]; \n\t
        If[start == First[Last[tree]], Return[{Last[tree]}]]; \n\t
        topedge = \(endedge = First[Reverse[tree]]\); \n\t
        tmp = Rest[Reverse[tree]]; \n\t
        Scan[\((If[First[topedge] == Last[#], topedge = #; 
                AppendTo[path, #]; \n\t
                If[First[#] == start, path = Reverse[path]; \n\t
                  AppendTo[path, endedge]; Return[]]])\) &, tmp]; \n\t
        Return[Map[Sort, path]]\n]\), "\n", 
    \(hungarianmethod[m_] := 
      Module[\n (*\ 
          The\ complete\ bipartite\ graph, \ \(\(|\)\(x\)\(|\)\) = \(\(|\)\(Y\
\)\(|\)\)\ *) \n{i, n = Length[m], n1, xset, yset, ngl, s, t, lastx, path, 
          match}, \n\tn1 = n/2; \n\txset = Table[i, {i, n1}]; \n\t
        yset = Table[n1 + i, {i, n1}]; \n\tmatch = initialmatching[m]; \n\t
        While[Length[match] < n1, \n\t\ts = 
            Complement[xset, Map[First, match]]; \n\t\tlastx = First[s]; 
          path = {}; \n\t\ts = {lastx}; 
          t = {}; \n\t\tWhile[
            True, \n\t\t\tngl = findneighbour[m, s]; \n\t\t\tIf[
              Length[ngl] == Length[t], \n\t\t\t\tReturn[
                match]\n\t\t\t]; \[IndentingNewLine]\t\ty = 
              First[Complement[ngl, t]]; \[IndentingNewLine]\t\tIf[
              m[\([lastx, y]\)] == 1, \ \  (*\ 
                BugFix\ \(2002/10\)/10\ *) \n\t\t\t\tAppendTo[
                path, {lastx, y}], \n\t\t\t\tAppendTo[
                path, {searchparent[y, s, m], 
                  y}]\[IndentingNewLine]\t\ \ \ \ \ \ ]; \n\t\t\tIf[
              MemberQ[Map[Last, match], y], \n\t\t\t\tz = 
                getmatchingedge[y, match]; \n\t\t\t\tAppendTo[
                path, {y, z}]; \n\t\t\t\tlastx = z; \n\t\t\t\ts = 
                Append[s, z]; t = Append[t, y], 
              Break[]\n\t\t\t]\n\t\t]; \n\t\tpath = 
            findaugmentingpath[path];  (*\ 
            find\ a\ path\ in\ a\ tree\ *) \n\t\tmatch = 
            Union[Complement[Union[match, path], 
                Intersection[match, path]]];\n\t]; \n\t
        Return[match]\n]\)}], "Input"],

Cell[BoxData[
    \(General::"spell1" \(\(:\)\(\ \)\) 
      "Possible spelling error: new symbol name \"\!\(yset\)\" is similar to \
existing symbol \"\!\(xset\)\"."\)], "Message"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    \(hungarianmethod[mm]\)], "Input"],

Cell[BoxData[
    \({{1, 9}, {2, 7}, {3, 6}, {4, 8}, {5, 10}}\)], "Output"]
}, Open  ]],

Cell[BoxData[
    \(\:30af\:30fc\:30f3\:30fb\:30e0\:30f3\:30af\:30ec\:30b9\:306e\:30a2\:30eb\
\:30b4\:30ea\:30ba\:30e0\)], "Input"],

Cell[TextData[{
  "\:3000\:ff4e\:4eba\:306e\:52b4\:50cd\:8005",
  Cell[BoxData[
      \(TraditionalForm\`X\_1\)]],
  ",",
  Cell[BoxData[
      \(TraditionalForm\`X\_2\)]],
  ",... ,",
  Cell[BoxData[
      \(TraditionalForm\`X\_n\)]],
  "\:306b\:ff4e\:7a2e\:306e\:4ed5\:4e8b",
  Cell[BoxData[
      \(TraditionalForm\`Y\_1\)]],
  ",",
  Cell[BoxData[
      \(TraditionalForm\`Y\_2\)]],
  ",... ,",
  Cell[BoxData[
      \(TraditionalForm\`Y\_n\)]],
  "\:3092\:5272\:308a\:5f53\:3066\:308b\:3002\:52b4\:50cd\:8005",
  Cell[BoxData[
      \(TraditionalForm\`X\_i\)]],
  "\:306b\:4ed5\:4e8b",
  Cell[BoxData[
      \(TraditionalForm\`Y\_j\)]],
  "\:3092\:5272\:308a\:5f53\:3066\:305f\:3068\:304d\:306b\:3001\:5f97\:3089\
\:308c\:308b\:5229\:76ca\:304c w(i,j)\:3068\:3059\:308b\:3002\:3053\:306e\
\:3068\:304d\:3001\:5229\:76ca\:304c\:6700\:5927\:306b\:306a\:308b\:3088\:3046\
\:306b\:3001\:52b4\:50cd\:8005\:306b\:4ed5\:4e8b\:3092\:5272\:308a\:5f53\:3066\
\:308b\:3053\:3068\:3092\:8003\:3048\:308b\:3002\:6700\:9069\:4eba\:6750\:5272\
\:308a\:5f53\:3066\:554f\:984c\:3068\:547c\:3070\:308c\:308b\:3053\:306e\:3088\
\:3046\:306a\:554f\:984c\:3092\:89e3\:304f\:305f\:3081\:306e\:65b9\:6cd5\:304c\
\:3001\:30af\:30fc\:30f3\:30fb\:30e0\:30f3\:30af\:30ec\:30b9(Kuhn-Munkres)\
\:306e\:30a2\:30eb\:30b4\:30ea\:30ba\:30e0\:3067\:3042\:308b\:3002\n\:3000",
  Cell[BoxData[
      \(TraditionalForm\`G\_w\)]],
  "\:3092\:ff12\:90e8\:5206\:5272\:ff08\:ff38\:3001\:ff39\:ff09\:ff08\:ff5c\
\:ff38\:ff5c\:ff1d\:ff5c\:ff39\:ff5c\:ff09\:3092\:6301\:3064\:3001\:ff12\:90e8\
\:8377\:91cd\:30b0\:30e9\:30d5\:3068\:3059\:308b\:3002\:3053\:306e\:3068\:304d\
\:3001",
  Cell[BoxData[
      \(TraditionalForm\`G\_w\)]],
  "\:306e\:9802\:70b9\:ff56\:306e\:8a8d\:5bb9\:30e9\:30d9\:30eb(feasible \
vertex labeling)l(v)\:3092\:3001\:ff38\:3001\:ff39\:306e\:5404\:9802\:70b9\
\:ff58\:3001\:ff59\:306b\:5bfe\:3057\:3066\:3001l(x)+l(y)\[GreaterEqual]w(x,y)\
 \:3092\:6e80\:305f\:3059\:3088\:3046\:306b\:5b9a\:3081\:308b\:3002\n\:3000\
\:4f8b\:3048\:3070\:3001\n\tl(x) = ",
  Cell[BoxData[
      \(TraditionalForm\`max\+y\[Epsilon]Y\)]],
  "w(x,y) \tx \[Epsilon] X \t,  l(y) = 0    y \[Epsilon] Y\n\
\:306f\:3001\:ff11\:3064\:306e\:8a8d\:5bb9\:30e9\:30d9\:30eb\:3067\:3042\:308b\
\:ff08\:30af\:30fc\:30f3\:30fb\:30e0\:30f3\:30af\:30ec\:30b9\:306e\:30a2\:30eb\
\:30b4\:30ea\:30ba\:30e0\:3067\:306f\:3001\:3053\:308c\:3092\:521d\:671f\:8a8d\
\:5bb9\:30e9\:30d9\:30eb\:3068\:3057\:3066\:7528\:3044\:308b\:ff09\:3002\n\
\:3000\:307e\:305f\:3001",
  Cell[BoxData[
      \(TraditionalForm\`G\_w\)]],
  "\:306e\:751f\:6210\:90e8\:5206\:30b0\:30e9\:30d5G(l)\:3092\:6b21\:306e\
\:3088\:3046\:306b\:5b9a\:3081\:3001\:3053\:308c\:3092\:8a8d\:5bb9\:30e9\:30d9\
\:30eb l(v)\:306e\:5b9a\:3081\:308b",
  Cell[BoxData[
      \(TraditionalForm\`G\_w\)]],
  "\:306e\:7b49\:4fa1\:30b0\:30e9\:30d5(equality graph)\:3068\:547c\:3076\
\:3002\n\tE(l) = E(G(l)) = {xy | l(x) + l(y) = w(x,y), x , y \[Epsilon] V(",
  Cell[BoxData[
      \(TraditionalForm\`G\_w\)]],
  ") }\n\n\:3000\:3053\:306e\:3068\:304d\:3001\:30b3\:30b9\:30c8\:6700\:5927\
\:306e\:30de\:30c3\:30c1\:30f3\:30b0\:ff08\:3053\:308c\:3092\:6700\:9069\:30de\
\:30c3\:30c1\:30f3\:30b0(optimal \
matching)\:3068\:547c\:3076\:ff09\:3092\:6c42\:3081\:308b\:305f\:3081\:306e\
\:3001\:30af\:30fc\:30f3\:30fb\:30e0\:30f3\:30af\:30ec\:30b9\:30fb\:30a2\:30eb\
\:30b4\:30ea\:30ba\:30e0\:306f\:6b21\:306e\:3088\:3046\:306b\:66f8\:3051\:308b\
\:3002\n\:ff11\:ff0e",
  Cell[BoxData[
      \(TraditionalForm\`G\_w\)]],
  "\:306e\:8a8d\:5bb9\:30e9\:30d9\:30eb l(v) \:3092\:9078\:3073\:3001\:3053\
\:306e\:8a8d\:5bb9\:30e9\:30d9\:30eb l(v)\:306e\:5b9a\:3081\:308b",
  Cell[BoxData[
      \(TraditionalForm\`G\_w\)]],
  "\:306e\:7b49\:4fa1\:30b0\:30e9\:30d5 G(l) \:3068\:3001G(l)\:306e\:30de\
\:30c3\:30c1\:30f3\:30b0 M\:3092\:5b9a\:3081\:308b\:3002\n\:ff12\:ff0e\:3082\
\:3057\:3001\:ff38\:306e\:3059\:3079\:3066\:306e\:9802\:70b9\:304cM\:30fc\
\:98fd\:548c\:306a\:3089\:3070\:3001|X|=|Y| \:3088\:308a M\:306f\:5b8c\:5168\
\:30de\:30c3\:30c1\:30f3\:30b0\:3067\:3042\:308a\:3001\:5f8c\:3067\:8ff0\:3079\
\:308b\:3088\:3046\:306b\:6700\:9069\:30de\:30c3\:30c1\:30f3\:30b0\:3067\:3042\
\:308b\:306e\:3067\:3001\:7d42\:4e86\:3059\:308b\:3002\:305d\:3046\:3067\:306a\
\:3044\:3068\:304d\:3001u \:3092\:ff38\:306eM\:30fc\:4e0d\:98fd\:548c\:306a\
\:9802\:70b9\:3001\:ff33\:3092{u}\:3001\:ff34\:3092\[Phi]\:3068\:7f6e\:304f\
\:3002\n\:ff13\:ff0e\:3082\:3057\:3001N(S)\:3068\:ff34\:3068\:304c\:7b49\:3057\
\:3044\:3068\:304d\:306f\:3001",
  Cell[BoxData[
      \(TraditionalForm\`a\_l\)]],
  " = ",
  Cell[BoxData[
      \(TraditionalForm\`min\+\(x\[Epsilon]X, y\[Epsilon]Y\\T\)\)]],
  "{l(x)+l(y) - w(x,y) } \:3092\:8a08\:7b97\:3057\:3001\:65b0\:305f\:306a\
\:8a8d\:5bb9\:30e9\:30d9\:30eb l'(v) \:3092\:6b21\:306e\:3088\:3046\:306b\
\:5b9a\:3081\:308b\:3002\n\t\tl'(v) = ",
  Cell[BoxData[
      FormBox[
        RowBox[{"(", GridBox[{
              {GridBox[{
                    {\(l(v) - a\_l\), "v\[Epsilon]S"},
                    {\(l(v) + a\_l\), "v\[Epsilon]T"}
                    }], "\[Placeholder]"},
              {\(l(v)\), "\:305d\:308c\:4ee5\:5916"}
              }]}], TraditionalForm]]],
  "\n\:6b21\:306b\:3001l(v)\:3092 \
l'(v)\:3067\:3001G(l)\:3092G(l')\:3067\:7f6e\:304d\:63db\:3048\:3066\:304b\
\:3089\:3001\:30b9\:30c6\:30c3\:30d7\:ff14\:306b\:884c\:304f\:3002\:305d\:3046\
\:3067\:306a\:3044\:3068\:304d\:306f\:3001N(S)\:306e\:8981\:7d20\:3067\:ff34\
\:306b\:542b\:307e\:308c\:306a\:3044\:8981\:7d20\:ff59\:3092\:9078\:3073\:3001\
\:30b9\:30c6\:30c3\:30d7\:ff14\:306b\:884c\:304f\:3002\n\:ff14\:ff0e\:3082\
\:3057\:3001\:ff59\:304cM\:30fc\:98fd\:548c\:3067\:3042\:308c\:3070\:3001M\
\:306e\:8fba yz \:3092\:9078\:3073\:3001\:ff33\:3092\:ff33\[Union]{z}\:3001\
\:ff34\:3092\:ff34\[Union]{y}\:3068\:7f6e\:304d\:3001\:30b9\:30c6\:30c3\:30d7\
\:ff13\:306b\:623b\:308b\:3002\:ff59\:304cM\:30fc\:4e0d\:98fd\:548c\:3067\
\:3042\:308c\:3070\:3001u \:3068\:ff59\:3068\:3092\:7d50\:3076M\:30fc\:5897\
\:5927\:9053\:ff30\:304c\:3042\:308b\:306e\:3067\:3001\:30de\:30c3\:30c1\:30f3\
\:30b0 M\:3092\:65b0\:305f\:306a\:30de\:30c3\:30c1\:30f3\:30b0 M'\:ff1dM\
\[CapitalDelta]\:ff30\:306b\:7f6e\:304d\:63db\:3048\:3066\:3001\:30b9\:30c6\
\:30c3\:30d7\:ff12\:306b\:623b\:308b\:3002\n\:3000\:3053\:306e\:30a2\:30eb\
\:30b4\:30ea\:30ba\:30e0\:306f\:3001\:6b21\:306e\:3088\:3046\:306b\:66f8\:3051\
\:308b\:3002"
}], "Text"],

Cell[BoxData[{
    \(firstequalitygraph[m_, n_, n1_] := 
      Module[{i, j, lxy, egl}, \n\tegl = Table[0, {i, n}, {j, n}]; \n\t
        lxy = Map[Max, m]; \n\t
        For[i = 1, 
          i <= n1, \(i++\), \n\t\tlxy[\([i + n1]\)] = 0; \n\t\tFor[
            j = n1 + 1, 
            j <= n, \(j++\), \n\t\t\tIf[
              m[\([i, j]\)] == 
                lxy[\([i]\)], \n\t\t\t\tegl[\([i, j]\)] = \(egl[\([j, i]\)] = 
                  1\)]]]; \n\t{egl, lxy}\t\t\n]\), "\n", 
    \(getnewequalitygraph[m_, n1_, lxy_, s_, t_, ct_] := 
      Module[{i, j, k, al, b, si, lxy1, egl}, \n\tal = \[Infinity]; \n\t
        For[i = 1, 
          i <= Length[s], \(i++\), \n\t\tsi = s[\([i]\)]; \n\t\tFor[j = 1, 
            j <= Length[ct], \(j++\), \n\t\t\tb = 
              lxy[\([si]\)] + lxy[\([ct[\([j]\)]]\)] - 
                m[\([si, ct[\([j]\)]]\)\[IndentingNewLine]\ ]; \n\t\tIf[
              al > b, al = b]]\[IndentingNewLine]\ ]; \n\tlxy1 = lxy; \n\t
        For[i = 1, 
          i <= Length[s], \(i++\), \n\t\tlxy1[\([s[\([i]\)]]\)] = 
            lxy[\([s[\([i]\)]]\)] - al\[IndentingNewLine]\ ]; \n\t
        For[j = 1, 
          j <= Length[t], \(j++\), \n\t\tlxy1[\([t[\([j]\)]]\)] = 
            lxy[\([t[\([j]\)]]\)] + al\[IndentingNewLine]\ ]; \n\n\t
        egl = Table[0, {i, 2  n1}, {j, 2  n1}]; \n\t
        For[i = 1, 
          i <= n1, \(i++\), \n\t\tFor[k = 1 + n1, 
            k <= 2  n1, \(k++\), \n\t\t\tIf[
              m[\([i, k]\)] == 
                lxy1[\([i]\)] + 
                  lxy1[\([k]\)], \n\t\t\t\tegl[\([i, 
                    k]\)] = \(egl[\([k, i]\)] = 
                  1\)]\[IndentingNewLine]\t]\[IndentingNewLine]\ \ ]; \n\t\
{egl, lxy1}\t\t\t\t\n]\[IndentingNewLine]\), "\n", 
    \(kuhnmunkres[m_] := 
      Module[\n (*\ 
          The\ complete\ bipartite\ graph, \ \(\(|\)\(x\)\(|\)\) = \(\(|\)\(Y\
\)\(|\)\)\ *) \n{i, n = Length[m], n1, lxy, g, xset, yset, egl, \n\tngl, tmp, 
          s, t, path, match}, \n\tn1 = n/2; \n\txset = Table[i, {i, n1}]; \n\t
        yset = Table[n1 + i, {i, n1}]; \n\t
        tmp = firstequalitygraph[m, n, n1]; \n\tegl = tmp[\([1]\)]; \n\t
        lxy = tmp[\([2]\)]; \n\tmatch = hungarianmethod[egl]; \n\t
        While[Length[match] < n1, \n\t\ts = 
            Complement[xset, Map[First, match]]; \n\t\tlastx = First[s]; 
          path = {}; \n\t\ts = {lastx}; 
          t = {}; \n\t\tWhile[
            True, \n\t\t\tngl = findneighbour[egl, s]; \n\t\t\tIf[
              Length[ngl] == Length[t], \n\t\t\t\tct = 
                Complement[yset, t]; \n\t\t\t\ttmp = 
                getnewequalitygraph[m, n1, lxy, s, t, ct]; \n\t\t\t\tegl = 
                tmp[\([1]\)]; \n\t\t\t\tlxy = tmp[\([2]\)]; \n\t\t\t\tngl = 
                findneighbour[egl, s];\ \ \ \ \ \n\t\t\t]; \n\t\t\ty = 
              First[Complement[ngl, t]]; \n\t\t\tIf[
              egl[\([lastx, y]\)] == 1, \n\t\t\t\tAppendTo[
                path, {lastx, y}], \n\t\t\t\tAppendTo[
                path, {searchparent[y, s, egl], 
                  y}]\[IndentingNewLine]\t\ \ \ \ \ \ ]; \n\t\t\tIf[
              MemberQ[Map[Last, match], y], \n\t\t\t\tz = 
                getmatchingedge[y, match]; \n\t\t\t\tAppendTo[
                path, {y, z}]; \n\t\t\t\tlastx = z; \n\t\t\t\tAppendTo[s, z]; 
              AppendTo[t, y], Break[]\n\t\t\t]\n\t\t]; \n\t\tpath = 
            findaugmentingpath[
              path]; \[IndentingNewLine]\ \ \ \ \ \ \ \ \ \ \  (*\ 
            find\ a\ path\ in\ a\ tree, \ 
            in\ the\ case\ the\ last\ vertex\ is\ \(\(unsaturated\)\(.\)\)\ \
*) \n\t\tmatch = 
            Union[Complement[Union[match, path], 
                Intersection[match, path]]];\n\t]; \n\t
        Return[match]\n]\[IndentingNewLine]\), "\[IndentingNewLine]", 
    \(ConvertWMatrixToAMatrix[wm_List] := 
      Module[{i, ex, len, am = {}, zerolist, tr}, \[IndentingNewLine]len = 
          Length[wm]; \[IndentingNewLine]zerolist = 
          Table[0, {i, len}]; \[IndentingNewLine]For[i = 1, 
          i \[LessEqual] len, \(i++\), \[IndentingNewLine]ex = 
            Join[zerolist, wm[\([i]\)]]; \[IndentingNewLine]am = 
            Append[am, ex]]; \[IndentingNewLine]tr = 
          Transpose[wm]; \[IndentingNewLine]For[i = 1, 
          i \[LessEqual] len, \(i++\), \[IndentingNewLine]ex = 
            Join[tr[\([i]\)], zerolist]; \[IndentingNewLine]am = 
            Append[am, ex]]; \[IndentingNewLine]Return[
          am]]\[IndentingNewLine]\), "\[IndentingNewLine]", 
    \(KuhnMunkres[wm_List] := 
      Module[{mm, n1, match}, \[IndentingNewLine]n1 = 
          Length[wm]; \[IndentingNewLine]mm = 
          ConvertWMatrixToAMatrix[wm]; \[IndentingNewLine]match = 
          kuhnmunkres[
            mm]; \[IndentingNewLine]Print["\<The optimal cost = \>", \n\t\t\t\
Apply[Plus, Map[mm[\([First[#], Last[#]]\)] &, 
              match]]]; \[IndentingNewLine]match = 
          Map[\(({First[#], Last[#] - n1})\) &, 
            match]; \[IndentingNewLine]Return[match]]\)}], "Input"],

Cell[TextData["\:3000\:4eca\:3001",
Cell[BoxData[
    \(TraditionalForm\`G\_w\)]],
"\:3092\:6b21\:306e\:3088\:3046\:306a\:96a3\:63a5\:884c\:5217 mm \:3067\:5b9a\
\:3081\:3089\:308c\:308b\:ff12\:90e8\:8377\:91cd\:30b0\:30e9\:30d5\:3068\:3059\
\:308b\:3002"], "Text"],

Cell[BoxData[{
    \(\[IndentingNewLine]\(A = {{7, \ 14, \ 12, \ 8, \ 
            13}, \ \n\ \ \ \ \ \ \ \ \ {10, \ 17, \ 10, \ 8, \ 
            15}, \ \n\ \ \ \ \ \ \ \ \ {20, \ 11, \ 17, \ 3, \ 
            8}, \ \n\ \ \ \ \ \ \ \ \ {12, \ 13, \ 18, \ 13, \ 
            12}, \ \n\ \ \ \ \ \ \ \ \ {5, \ 12, \ 12, \ 11, \ 
            17}};\)\), "\[IndentingNewLine]", 
    \(\(mm = {{0, \ 0, \ 0, \ 0, \ 0, \ 7, \ 14, \ 12, \ 8, \ 
            13}, \ \n\ \ {0, \ 0, \ 0, \ 0, \ 0, \ 10, \ 17, \ 10, \ 8, \ 
            15}, \ \n\ \ {0, \ 0, \ 0, \ 0, \ 0, \ 20, \ 11, \ 17, \ 3, \ 
            8}, \ \n\ \ {0, \ 0, \ 0, \ 0, \ 0, \ 12, \ 13, \ 18, \ 13, \ 
            12}, \ \n\ \ {0, \ 0, \ 0, \ 0, \ 0, \ 5, \ 12, \ 12, \ 11, \ 
            17}, \ \n\ \ {7, \ 10, \ 20, \ 12, \ 5, \ 0, \ 0, \ 0, \ 0, \ 
            0}, \ \n\ \ {14, \ 17, \ 11, \ 13, \ 12, \ 0, \ 0, \ 0, \ 0, \ 
            0}, \ \n\ \ {12, \ 10, \ 17, \ 18, \ 12, \ 0, \ 0, \ 0, \ 0, \ 
            0}, \ \n\ \ {8, \ 8, \ 3, \ 13, \ 11, \ 0, \ 0, \ 0, \ 0, \ 
            0}, \ \n\ \ {13, \ 15, \ 8, \ 12, \ 17, \ 0, \ 0, \ 0, \ 0, \ 
            0}};\)\)}], "Input"],

Cell[TextData[
"\:3000\:3053\:306e\:3068\:304d\:3001\:6700\:9069\:30de\:30c3\:30c1\:30f3\
\:30b0\:3092\:6c42\:3081\:308b\:3002"], "Text"],

Cell[CellGroupData[{

Cell[BoxData[
    \(kuhnmunkres[mm]\)], "Input"],

Cell[BoxData[
    \({{1, 9}, {2, 7}, {3, 6}, {4, 8}, {5, 10}}\)], "Output"]
}, Open  ]],

Cell[TextData[{
  "\:3000l(v) \:3092",
  Cell[BoxData[
      \(TraditionalForm\`G\_w\)]],
  "\:306e\:4efb\:610f\:306e\:8a8d\:5bb9\:30e9\:30d9\:30eb\:3068\:3057\:3001M*\
\:3092G(l)\:306e\:5b8c\:5168\:30de\:30c3\:30c1\:30f3\:30b0\:3068\:3059\:308b\
\:3068\:3001G(l)\:306f",
  Cell[BoxData[
      \(TraditionalForm\`G\_w\)]],
  "\:306e\:6700\:9069\:30de\:30c3\:30c1\:30f3\:30b0\:3067\:3082\:3042\:308b\
\:3002\:3053\:308c\:306f\:3001\:6b21\:306e\:3088\:3046\:306b\:793a\:305b\:308b\
\:3002\:307e\:305a\:3001G(l) \:306f",
  Cell[BoxData[
      \(TraditionalForm\`G\_w\)]],
  "\:306e\:751f\:6210\:90e8\:5206\:30b0\:30e9\:30d5\:3067\:3042\:308b\:306e\
\:3067\:3001M*\:306f",
  Cell[BoxData[
      \(TraditionalForm\`G\_w\)]],
  "\:306e\:5b8c\:5168\:30de\:30c3\:30c1\:30f3\:30b0\:3067\:3042\:308a\:3001w(\
M*) = ",
  Cell[BoxData[
      \(TraditionalForm
      \`\[Sum]\+\(e\[Epsilon]M\^*\)\%\[Placeholder] w(e)\)]],
  " = ",
  Cell[BoxData[
      \(TraditionalForm\`\[Sum]\+v\[Epsilon]V\%\[Placeholder] l(v)\)]],
  " \:304c\:6210\:308a\:7acb\:3064\:3002\:307e\:305f\:3001M\:3092",
  Cell[BoxData[
      \(TraditionalForm\`G\_w\)]],
  "\:306e\:4efb\:610f\:306e\:30de\:30c3\:30c1\:30f3\:30b0\:3068\:3059\:308b\
\:3068\:3001\:8a8d\:5bb9\:30e9\:30d9\:30eb\:306e\:5b9a\:7fa9\:3088\:308a\:3001\
w(M) = ",
  Cell[BoxData[
      \(TraditionalForm\`\[Sum]\+e\[Epsilon]M\%\[Placeholder] w(e)\)]],
  " \[LessEqual] ",
  Cell[BoxData[
      \(TraditionalForm\`\[Sum]\+v\[Epsilon]V\%\[Placeholder] l(v)\)]],
  "\:304c\:6210\:308a\:7acb\:3064\:3002\:5f93\:3063\:3066\:3001w(M) \
\[LessEqual] w(M*) \:3067\:3042\:308b\:3002\n\n\:3000\:30af\:30fc\:30f3\:30fb\
\:30e0\:30f3\:30af\:30ec\:30b9\:30fb\:30a2\:30eb\:30b4\:30ea\:30ba\:30e0\:306e\
\:8a08\:7b97\:30aa\:30fc\:30c0\:306fO(",
  Cell[BoxData[
      \(TraditionalForm\`\(\[Nu](G\_w)\)\^3\)]],
  ")\:3067\:3042\:308b\:3002\:ff11\:65b9\:3001\:3059\:3079\:3066\:306e\:53ef\
\:80fd\:306a\:30de\:30c3\:30c1\:30f3\:30b0\:304b\:3089\:3001\:6700\:9069\:30de\
\:30c3\:30c1\:30f3\:30b0\:3092\:63a2\:7d22\:3059\:308b\:65b9\:6cd5\:306e\:8a08\
\:7b97\:30aa\:30fc\:30c0\:306f\:3001O(",
  Cell[BoxData[
      \(TraditionalForm\`\((\(\[Nu] \((G\_w)\)\)\/2)\)\)]],
  "!)\:3067\:3042\:308b\:3002\:30af\:30fc\:30f3\:30fb\:30e0\:30f3\:30af\:30ec\
\:30b9\:30fb\:30a2\:30eb\:30b4\:30ea\:30ba\:30e0\:306e\:8a08\:7b97\:7d50\:679c\
\:306e\:6b63\:5f53\:6027\:3092\:691c\:8a3c\:3059\:308b\:305f\:3081\:306b\:3001\
\:3059\:3079\:3066\:306e\:53ef\:80fd\:306a\:30de\:30c3\:30c1\:30f3\:30b0\:304b\
\:3089\:3001\:6700\:9069\:30de\:30c3\:30c1\:30f3\:30b0\:3092\:63a2\:7d22\:3059\
\:308b\:65b9\:6cd5\:3092\:30d7\:30ed\:30b0\:30e9\:30e0\:306b\:66f8\:304f\:3002\
"
}], "Text"],

Cell[BoxData[{
    \(getmatching[lst_] := 
      Module[{i = 1}, \n\t\tMap[\(({\(i++\), #})\) &, 
          lst]\[IndentingNewLine]]\[IndentingNewLine]\), "\n", 
    \(OptimalMatching[wm_] := 
      Block[{mm, n1, lst, cost, maxcost, match, maxmatch, 
          matchlist}, \[IndentingNewLine]\ \ \ \ \ mm = 
          ConvertWMatrixToAMatrix[wm]; \n\tn1 = Length[mm]/2; \n\t
        lst = Table[n1 + i, {i, n1}]; \n\tmaxcost = 0; \n\t
        matchlist = Map[getmatching, Permutations[lst]]; \n\t
        While[matchlist != {}, \n\t\tmatch = First[matchlist]; \n\t\tcost = 
            Apply[Plus, Map[mm[\([First[#], Last[#]]\)] &, match]]; \n\t\tIf[
            cost > maxcost, maxcost = cost; 
            maxmatch = match]; \n\t\tmatchlist = 
            Rest[matchlist]\[IndentingNewLine]\ \ ]; \[IndentingNewLine]\ \ \ \
\ \ match = Map[\(({First[#], Last[#] - n1})\) &, maxmatch]; \n\t
        Return[{maxcost, match}]\n]\)}], "Input"],

Cell[CellGroupData[{

Cell[BoxData[
    \(OptimalMatching[A]\)], "Input"],

Cell[BoxData[
    \({80, {{1, 4}, {2, 2}, {3, 1}, {4, 3}, {5, 5}}}\)], "Output"]
}, Open  ]],

Cell[TextData[
"\:3000\:7b54\:3048\:306f\:3001\:30af\:30fc\:30f3\:30fb\:30e0\:30f3\:30af\
\:30ec\:30b9\:30fb\:30a2\:30eb\:30b4\:30ea\:30ba\:30e0\:306e\:7d50\:679c\:3068\
\:4e00\:81f4\:3059\:308b\:3002\n\:554f\:ff13\:ff0e\:4efb\:610f\:306e\:ff12\
\:90e8\:8377\:91cd\:30b0\:30e9\:30d5\:306e\:96a3\:63a5\:884c\:5217\:3092\:3001\
\:4e71\:6570\:3092\:7528\:3044\:3066\:751f\:6210\:3059\:308b\:30d7\:30ed\:30b0\
\:30e9\:30e0\:306f\:3001\:6b21\:306e\:3088\:3046\:306b\:66f8\:3051\:308b\:3002\
"], "Text"],

Cell[BoxData[
    \(randombipartitematrix[n1_, p_, r_]\  := 
      Module[{i, n = 2  n1, mt}, \n\t
        mt\  = \ Table[
            If[i <= n1, 
              Join[Table[0, {n1}], 
                Table[\ \n\t\t\t\t\tIf[Random[Real] < p, 
                    Random[Integer, r], \ 0], \n\t\t\t\t\t{n1}]], 
              Join[Table[\ \n\t\t\t\t\tIf[Random[Real] < p, 
                    Random[Integer, r], \ 0], \n\t\t\t\t\t{n1}], 
                Table[0, {n1}]]], {i, n}\n\t\t]; \n\t\tmt + 
          Transpose[mt]\n\t]\)], "Input"],

Cell[TextData[
"\:3000\:3053\:306e\:30d7\:30ed\:30b0\:30e9\:30e0\:3092\:7528\:3044\:3066\
\:3001\:ff12\:90e8\:8377\:91cd\:30b0\:30e9\:30d5\:3092\:4f5c\:308a\:3001\:305d\
\:308c\:306e\:6700\:9069\:30de\:30c3\:30c1\:30f3\:30b0\:3092\:6c42\:3081\:3088\
\:3002\:4f8b\:3048\:3070\:3001|X|=|Y|=20\:306e\:4f8b\:3092\:4f5c\:308a\:3001\
\:6700\:9069\:30de\:30c3\:30c1\:30f3\:30b0\:3092\:8a08\:7b97\:3059\:308b\:3002\
"], "Text"],

Cell[BoxData[
    \(\(mm = randombipartitematrix[20, 1, 100];\)\)], "Input"],

Cell[CellGroupData[{

Cell[BoxData[
    \(kuhnmunkres[mm]\)], "Input"],

Cell[BoxData[
    \({{1, 23}, {2, 33}, {3, 22}, {4, 25}, {5, 21}, {6, 31}, {7, 40}, {8, 
        36}, {9, 29}, {10, 39}, {11, 24}, {12, 26}, {13, 27}, {14, 32}, {15, 
        38}, {16, 35}, {17, 28}, {18, 34}, {19, 30}, {20, 37}}\)], "Output"]
}, Open  ]],

Cell[TextData[
"\:554f\:ff14\:ff0e\:ff4e\:6b21\:306e\:6b63\:65b9\:884c\:5217 A\:306e\:5bfe\
\:89d2\:7dda\:3068\:306f\:3001A\:306e\:ff4e\:500b\:306e\:30a8\:30f3\:30c8\
\:30ea\:30fc\:306e\:96c6\:5408\:3067\:3001\:305d\:306e\:96c6\:5408\:306e\:3069\
\:306e\:ff12\:3064\:306e\:8981\:7d20\:3082\:3001\:540c\:3058\:884c\:306b\:3082\
\:540c\:3058\:5217\:306b\:3082\:5c5e\:3055\:306a\:3044\:3088\:3046\:306a\:3082\
\:306e\:306e\:96c6\:5408\:3067\:3042\:308b\:3002A\:3092\:6b21\:306e\:3088\
\:3046\:306a\:6b63\:65b9\:884c\:5217\:3068\:3059\:308b\:3068\:304d\:3001A\
\:306e\:30b3\:30b9\:30c8\:6700\:5927\:306e\:5bfe\:89d2\:7dda\:3092\:6c42\:3081\
\:3088\:3002"], "Text"],

Cell[BoxData[
    \(\(A = {{7, \ 14, \ 12, \ 8, \ 13}, \ \n\ \ \ \ \ \ \ \ \ {10, \ 17, \ 
            10, \ 8, \ 15}, \ \n\ \ \ \ \ \ \ \ \ {20, \ 11, \ 17, \ 3, \ 
            8}, \ \n\ \ \ \ \ \ \ \ \ {12, \ 13, \ 18, \ 13, \ 
            12}, \ \n\ \ \ \ \ \ \ \ \ {5, \ 12, \ 12, \ 11, \ 
            17}};\)\)], "Input"],

Cell[BoxData[
    \(\(mm = ConvertWMatrixToAMatrix[A];\)\)], "Input"],

Cell[CellGroupData[{

Cell[BoxData[
    \(hungarianmethod[mm]\)], "Input"],

Cell[BoxData[
    \({{1, 6}, {2, 7}, {3, 8}, {4, 9}, {5, 10}}\)], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    \(OptimalMatching[A]\)], "Input"],

Cell[BoxData[
    \({80, {{1, 4}, {2, 2}, {3, 1}, {4, 3}, {5, 5}}}\)], "Output"]
}, Open  ]],

Cell[BoxData[
    \(\(A = {{0, 0, 2, 0, 2, 1}, \[IndentingNewLine]{4, 2, 1, 4, 2, 
            3}, \[IndentingNewLine]{3, 5, 3, 1, 5, 1}, \[IndentingNewLine]{0, 
            1, 1, 1, 0, 1}, \[IndentingNewLine]{6, 2, 4, 6, 6, 
            5}, \[IndentingNewLine]{1, 3, 3, 2, 3, 1}};\)\)], "Input"],

Cell[CellGroupData[{

Cell[BoxData[
    \(KuhnMunkres[A]\)], "Input"],

Cell[BoxData[
    InterpretationBox[\("The optimal cost = "\[InvisibleSpace]21\),
      SequenceForm[ "The optimal cost = ", 21],
      Editable->False]], "Print"],

Cell[BoxData[
    \({{1, 5}, {2, 4}, {3, 2}, {4, 6}, {5, 1}, {6, 3}}\)], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    \(OptimalMatching[A]\)], "Input"],

Cell[BoxData[
    \({21, {{1, 3}, {2, 1}, {3, 2}, {4, 6}, {5, 4}, {6, 5}}}\)], "Output"]
}, Open  ]],

Cell[BoxData[
    \(\(A = {{3, 5, 5, 4, 1}, \[IndentingNewLine]{2, 2, 0, 2, 
            2}, \[IndentingNewLine]{2, 4, 4, 1, 0}, \[IndentingNewLine]{0, 1, 
            1, 0, 0}, \[IndentingNewLine]{1, 2, 1, 3, 3}};\)\)], "Input"],

Cell[CellGroupData[{

Cell[BoxData[
    \(KuhnMunkres[A]\)], "Input"],

Cell[BoxData[
    InterpretationBox[\("The optimal cost = "\[InvisibleSpace]14\),
      SequenceForm[ "The optimal cost = ", 14],
      Editable->False]], "Print"],

Cell[BoxData[
    \({{1, 2}, {2, 4}, {3, 3}, {4, 1}, {5, 5}}\)], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    \(OptimalMatching[A]\)], "Input"],

Cell[BoxData[
    \({14, {{1, 2}, {2, 1}, {3, 3}, {4, 4}, {5, 5}}}\)], "Output"]
}, Open  ]],

Cell[BoxData[
    \(\(A = {{4, 5, 8, 10, 11}, \[IndentingNewLine]{7, 6, 5, 7, 
            4}, \[IndentingNewLine]{8, 5, 12, 9, 6}, \[IndentingNewLine]{6, 
            6, 13, 10, 7}, \[IndentingNewLine]{4, 5, 7, 9, 8}};\)\)], "Input"],

Cell[CellGroupData[{

Cell[BoxData[
    \(KuhnMunkres[A]\)], "Input"],

Cell[BoxData[
    InterpretationBox[\("The optimal cost = "\[InvisibleSpace]47\),
      SequenceForm[ "The optimal cost = ", 47],
      Editable->False]], "Print"],

Cell[BoxData[
    \({{1, 5}, {2, 2}, {3, 1}, {4, 3}, {5, 4}}\)], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    \(OptimalMatching[A]\)], "Input"],

Cell[BoxData[
    \({47, {{1, 5}, {2, 2}, {3, 1}, {4, 3}, {5, 4}}}\)], "Output"]
}, Open  ]]
},
FrontEndVersion->"4.0 for Microsoft Windows",
ScreenRectangle->{{0, 1024}, {0, 685}},
WindowSize->{976, 579},
WindowMargins->{{0, Automatic}, {Automatic, 0}}
]


(***********************************************************************
Cached data follows.  If you edit this Notebook file directly, not using
Mathematica, you must remove the line containing CacheID at the top of 
the file.  The cache data will then be recreated when you save this file 
from within Mathematica.
***********************************************************************)

(*CellTagsOutline
CellTagsIndex->{}
*)

(*CellTagsIndex
CellTagsIndex->{}
*)

(*NotebookFileOutline
Notebook[{
Cell[1717, 49, 140, 2, 30, "Input"],
Cell[1860, 53, 68, 1, 30, "Input"],
Cell[1931, 56, 4291, 83, 261, "Text"],
Cell[6225, 141, 111, 2, 30, "Input"],
Cell[6339, 145, 6038, 97, 356, "Text"],
Cell[12380, 244, 69, 1, 30, "Input"],
Cell[12452, 247, 3442, 49, 242, "Text"],
Cell[15897, 298, 744, 10, 110, "Input"],
Cell[16644, 310, 340, 6, 90, "Input"],
Cell[16987, 318, 1991, 27, 128, "Text"],

Cell[CellGroupData[{
Cell[19003, 349, 57, 1, 30, "Input"],
Cell[19063, 352, 58, 1, 29, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[19158, 358, 3297, 63, 1250, "Input"],
Cell[22458, 423, 181, 3, 24, "Message"]
}, Open  ]],

Cell[CellGroupData[{
Cell[22676, 431, 52, 1, 30, "Input"],
Cell[22731, 434, 75, 1, 29, "Output"]
}, Open  ]],
Cell[22821, 438, 131, 2, 30, "Input"],
Cell[22955, 442, 6411, 124, 443, "Text"],
Cell[29369, 568, 5012, 91, 2010, "Input"],
Cell[34384, 661, 265, 5, 33, "Text"],
Cell[34652, 668, 1144, 17, 330, "Input"],
Cell[35799, 687, 137, 2, 33, "Text"],

Cell[CellGroupData[{
Cell[35961, 693, 48, 1, 30, "Input"],
Cell[36012, 696, 75, 1, 29, "Output"]
}, Open  ]],
Cell[36102, 700, 2671, 56, 155, "Text"],
Cell[38776, 758, 943, 16, 390, "Input"],

Cell[CellGroupData[{
Cell[39744, 778, 51, 1, 30, "Input"],
Cell[39798, 781, 80, 1, 29, "Output"]
}, Open  ]],
Cell[39893, 785, 497, 7, 52, "Text"],
Cell[40393, 794, 538, 11, 190, "Input"],
Cell[40934, 807, 419, 6, 33, "Text"],
Cell[41356, 815, 76, 1, 30, "Input"],

Cell[CellGroupData[{
Cell[41457, 820, 48, 1, 30, "Input"],
Cell[41508, 823, 243, 3, 48, "Output"]
}, Open  ]],
Cell[41766, 829, 660, 9, 52, "Text"],
Cell[42429, 840, 326, 5, 110, "Input"],
Cell[42758, 847, 69, 1, 30, "Input"],

Cell[CellGroupData[{
Cell[42852, 852, 52, 1, 30, "Input"],
Cell[42907, 855, 75, 1, 29, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[43019, 861, 51, 1, 30, "Input"],
Cell[43073, 864, 80, 1, 29, "Output"]
}, Open  ]],
Cell[43168, 868, 296, 4, 130, "Input"],

Cell[CellGroupData[{
Cell[43489, 876, 47, 1, 30, "Input"],
Cell[43539, 879, 163, 3, 25, "Print"],
Cell[43705, 884, 82, 1, 29, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[43824, 890, 51, 1, 30, "Input"],
Cell[43878, 893, 88, 1, 29, "Output"]
}, Open  ]],
Cell[43981, 897, 229, 3, 110, "Input"],

Cell[CellGroupData[{
Cell[44235, 904, 47, 1, 30, "Input"],
Cell[44285, 907, 163, 3, 25, "Print"],
Cell[44451, 912, 74, 1, 29, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[44562, 918, 51, 1, 30, "Input"],
Cell[44616, 921, 80, 1, 29, "Output"]
}, Open  ]],
Cell[44711, 925, 234, 3, 110, "Input"],

Cell[CellGroupData[{
Cell[44970, 932, 47, 1, 30, "Input"],
Cell[45020, 935, 163, 3, 25, "Print"],
Cell[45186, 940, 74, 1, 29, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[45297, 946, 51, 1, 30, "Input"],
Cell[45351, 949, 80, 1, 29, "Output"]
}, Open  ]]
}
]
*)




(***********************************************************************
End of Mathematica Notebook file.
***********************************************************************)

