(************** Content-type: application/mathematica **************
                     CreatedBy='Mathematica 5.0'

                    Mathematica-Compatible Notebook

This notebook can be used with any Mathematica-compatible
application, such as Mathematica, MathReader or Publicon. The data
for the notebook starts with the line containing stars above.

To get the notebook into a Mathematica-compatible application, do
one of the following:

* Save the data starting with the line of stars above into a file
  with a name ending in .nb, then open the file inside the
  application;

* Copy the data starting with the line of stars above to the
  clipboard, then use the Paste menu command inside the application.

Data for notebooks contains only printable 7-bit ASCII and can be
sent directly in email or through ftp in text mode.  Newlines can be
CR, LF or CRLF (Unix, Macintosh or MS-DOS style).

NOTE: If you modify the data for this notebook not in a Mathematica-
compatible application, you must delete the line below containing
the word CacheID, otherwise Mathematica-compatible applications may
try to use invalid cache data.

For more information on notebooks and Mathematica-compatible 
applications, contact Wolfram Research:
  web: http://www.wolfram.com
  email: info@wolfram.com
  phone: +1-217-398-0700 (U.S.)

Notebook reader applications are available free of charge from 
Wolfram Research.
*******************************************************************)

(*CacheID: 232*)


(*NotebookFileLineBreakTest
NotebookFileLineBreakTest*)
(*NotebookOptionsPosition[     33789,        899]*)
(*NotebookOutlinePosition[     34495,        923]*)
(*  CellTagsIndexPosition[     34451,        919]*)
(*WindowFrame->Normal*)



Notebook[{
Cell[TextData[{
  "2.5  \:6697\:53f7\:306b\:3064\:3044\:3066",
  StyleBox["\n",
    FontWeight->"Bold"],
  "2.5.1.  \:30b7\:30fc\:30b6\:6697\:53f7\n     ",
  StyleBox[
  "\:6697\:53f7\:306e\:6b74\:53f2\:306f\:3001\:7d00\:5143\:524d\:306e\:30ae\
\:30ea\:30b7\:30e3\:3001\:30ed\:30fc\:30de\:6642\:4ee3\:307e\:3067\:6eaf\:308b\
\:3002\:7279\:306b\:3001\:7d00\:5143\:524d\:ff14\:ff14\:5e74\:306b\:6697\:6bba\
\:3055\:308c\:305f\:30b8\:30e5\:30ea\:30a2\:30b9\:30fb\:30b7\:30fc\:30b6\:304c\
\:7528\:3044\:305f\:3068\:3055\:308c\:308b\:30b7\:30fc\:30b6\:6697\:53f7(\
Caeser encryption)\:306f\:3088\:304f\:77e5\:3089\:308c\:3066\:3044\:308b\:3002\
\:3053\:306e\:6697\:53f7\:65b9\:5f0f\:3067\:306f\:3001\:539f\:6587\:306e\:30a2\
\:30eb\:30d5\:30a1\:30d9\:30c3\:30c8\:3092\:3001\:ff21\:3092\:ff24\:306b\:3001\
\:ff22\:3092\:ff25\:306b\:3001\:ff0e\:ff0e\:ff0e\:3001\:ff3a\:3092\:ff23\:3078\
\:3068\:ff13\:6587\:5b57\:3065\:3064\:5358\:7d14\:306b\:305a\:3089\:3059\:3002\
\:3057\:304b\:3057\:3001\:305a\:3089\:3059\:3068\:3044\:3046\:624b\:9806\:3084\
\:3001\:4f55\:6587\:5b57\:305a\:3089\:3059\:304b\:304c\:89e3\:3089\:306a\:3051\
\:308c\:3070\:3001\:7b2c\:ff13\:8005\:306b\:306f\:89e3\:8aad\:3067\:304d\:306a\
\:3044\:3002",
    FontFamily->"\.82l\.82r \.96\.be\.92\[Copyright]"],
  "\n",
  StyleBox[
  "\:3000\:5927\:6587\:5b57\:306e\:30a2\:30eb\:30d5\:30a1\:30d9\:30c3\:30c8\
\:ff21\:3001\:ff22\:3001\:ff0e\:ff0e\:ff0e\:3001\:ff3a\:3092\:3001",
    FontFamily->"\.82l\.82r \.96\.be\.92\[Copyright]"],
  StyleBox["key",
    FontFamily->"Century"],
  StyleBox[
  "\:3060\:3051\:305a\:3089\:3059\:30b7\:30fc\:30b6\:6697\:53f7\:306e\:305f\
\:3081\:306e\:30d7\:30ed\:30b0\:30e9\:30e0\:306f\:3001\:6b21\:306e\:3088\:3046\
\:306b\:66f8\:3051\:308b\:3002",
    FontFamily->"\.82l\.82r \.96\.be\.92\[Copyright]"]
}], "Text"],

Cell[CellGroupData[{

Cell[BoxData[{
    RowBox[{
      StyleBox[" ",
        FontFamily->"Century",
        FontSize->10.5], 
      StyleBox[\(cton[key_, \ c_] := \ First[ToCharacterCode[c]] - 65 + key\),
        
        FontFamily->"Times New Roman",
        FontWeight->"Bold"]}], "\n", 
    StyleBox[\(\(MyEncode[key_, s_]\)\(:=\)\(\ \)\(\n\)\(\t\)\(Map[
          FromCharacterCode, 
          Map[Plus[#, 65] &, \ \n\t\ \ Map[Mod[#, 26] &, \ 
              Map[cton[key, \ #] &, \ Characters[s]]]]]\)\(\n\)\),
      FontFamily->"Century",
      FontWeight->"Bold"], "\n", 
    StyleBox[\(MyEncode[3, \ "\<ABCXYZ\>"]\),
      FontFamily->"Century",
      FontWeight->"Bold"]}], "Input"],

Cell[BoxData[
    \({"D", "E", "F", "A", "B", "C"}\)], "Output"]
}, Open  ]],

Cell[TextData[{
  "\:554f\:ff11\:ff0e ",
  StyleBox["\:95a2\:6570",
    FontFamily->"\.82l\.82r \.96\.be\.92\[Copyright]",
    FontSize->10.5],
  StyleBox["cton",
    FontFamily->"Century"],
  StyleBox["\:3092\:7528\:3044\:308b\:3053\:3068\:306a\:304f\:3001",
    FontFamily->"\.82l\.82r \.96\.be\.92\[Copyright]"],
  StyleBox["MyEncode",
    FontFamily->"Century"],
  StyleBox["\:3092\:5b9a\:7fa9\:305b\:3088\:3002",
    FontFamily->"\.82l\.82r \.96\.be\.92\[Copyright]"],
  "\n",
  StyleBox["\:3000\:30d2\:30f3\:30c8\:ff1a\:ff08",
    FontFamily->"\.82l\.82r \.96\.be\.92\[Copyright]"],
  StyleBox["First[ToCharacterCode[#]]-65+key",
    FontFamily->"Times New Roman"],
  StyleBox["\:ff09",
    FontFamily->"\.82l\.82r \.96\.be\.92\[Copyright]"],
  StyleBox["&",
    FontFamily->"Times New Roman"],
  StyleBox["\:3092\:7528\:3044\:3088\:3002",
    FontFamily->"\.82l\.82r \.96\.be\.92\[Copyright]"],
  "\n\:554f\:ff12\:ff0e ",
  StyleBox["MyEncode",
    FontFamily->"Century",
    FontSize->10.5],
  StyleBox[
  "\:306e\:51fa\:529b\:3092\:5143\:306e\:6587\:5b57\:306e\:30ea\:30b9\:30c8\
\:306b\:623b\:3059\:30d7\:30ed\:30b0\:30e9\:30e0\:3092\:4f5c\:308c\:3002\:4f8b\
\:3048\:3070\:3001",
    FontFamily->"\.82l\.82r \.96\.be\.92\[Copyright]"],
  "{",
  StyleBox["D, E, F, A, B, C}",
    FontFamily->"Century"],
  StyleBox["\:3092",
    FontFamily->"\.82l\.82r \.96\.be\.92\[Copyright]"],
  "{",
  StyleBox["A, B, C, X, Y, Z}",
    FontFamily->"Century"],
  StyleBox["\:306b\:623b\:3059\:3002\n\:554f\:ff13\:ff0e",
    FontFamily->"\.82l\.82r \.96\.be\.92\[Copyright]"],
  " ",
  StyleBox["MyEncode",
    FontFamily->"Century",
    FontSize->10.5],
  StyleBox[
  "\:3092\:5c0f\:6587\:5b57\:306e\:30a2\:30eb\:30d5\:30a1\:30d9\:30c3\:30c8\
\:3068\:7a7a\:767d\:3082\:6271\:3048\:308b\:3088\:3046\:306b\:62e1\:5f35\:305b\
\:3088\:3002\n\:554f\:ff14\:ff0e",
    FontFamily->"\.82l\.82r \.96\.be\.92\[Copyright]"],
  " ",
  StyleBox["MyEncode",
    FontFamily->"Century",
    FontSize->10.5],
  StyleBox[
  "\:3067\:4f5c\:3089\:308c\:305f\:3001\:6b21\:306e\:6697\:53f7\:6587\:3092\
\:89e3\:8aad\:305b\:3088\:3002\:305f\:3060\:3057\:3001\:6587\:5b57\:306f\:3059\
\:3079\:3066\:5927\:6587\:5b57\:3067\:3001\:6587\:7ae0\:5185\:306e\:7a7a\:767d\
\:306f\:9664\:3044\:3066\:3042\:308b\:3002",
    FontFamily->"\.82l\.82r \.96\.be\.92\[Copyright]"]
}], "Text"],

Cell[OutputFormData["\<\
{\"W\", \"K\", \"H\", \"Q\", \"H\", \"H\", \"G\", \"W\", \"R\", \"V\", 
  \"H\", \"W\", \"W\", \"K\", \"H\", \"U\", \"H\", \"F\", \"R\", \"U\", 
  \"G\", \"V\", \"W\", \"U\", \"D\", \"L\", \"J\", \"K\", \"W\"}\
\>", "\<\
{W, K, H, Q, H, H, G, W, R, V, H, W, W, K, H, U, H, 
 
  F, R, U, G, V, W, U, D, L, J, K, W}\
\>"], "Output"],

Cell[TextData[{
  StyleBox["\n2.5.2. RSA\:6697\:53f7\n",
    FontFamily->"\.82l\.82r \.96\.be\.92\[Copyright]"],
  "    ",
  StyleBox["\:6697\:53f7\:306f\:8cb4\:91cd\:306a\:60c5\:5831\:3092\:3001\:6575\
\:56fd\:306b\:79d8\:5bc6\:88cf\:306b\:4f1d\:9054\:3059\:308b\:8ecd\:4e8b\:30fb\
\:5916\:4ea4\:4e0a\:306e\:6280\:8853\:3068\:3057\:3066\:767a\:9054\:3057\:3001\
\:305d\:306e\:6280\:8853\:306f\:307b\:3068\:3093\:3069\:56fd\:5bb6\:6a5f\:5bc6\
\:3068\:3055\:308c\:3066\:304d\:305f\:304c\:3001",
    FontFamily->"\.82l\.82r \.96\.be\.92\[Copyright]"],
  StyleBox["1970",
    FontFamily->"Century"],
  StyleBox["\:4ee3\:306b\:516c\:958b\:30ab\:30ae\:65b9\:5f0f\:ff08",
    FontFamily->"\.82l\.82r \.96\.be\.92\[Copyright]"],
  StyleBox["Public-key cryptosystem",
    FontFamily->"Century"],
  StyleBox["\:ff09\:304c\:767b\:5834\:3057\:3001\:305d\:306e\:6280\:8853\:304c\
\:516c\:958b\:3055\:308c\:305f\:3053\:3068\:306b\:3088\:308a\:3001\:5287\:7684\
\:306a\:5909\:5316\:3092\:9042\:3052\:305f\:3002",
    FontFamily->"\.82l\.82r \.96\.be\.92\[Copyright]"],
  StyleBox["1978",
    FontFamily->"Century"],
  StyleBox["\:5e74",
    FontFamily->"\.82l\.82r \.96\.be\.92\[Copyright]"],
  StyleBox["MIT",
    FontFamily->"Century"],
  StyleBox["\:306e\:ff13\:4eba\:306e\:6570\:5b66\:8005\:30ec\:30f4\:30a7\:30b9\
\:30c8",
    FontFamily->"\.82l\.82r \.96\.be\.92\[Copyright]"],
  StyleBox["(Rivest)",
    FontFamily->"Century"],
  StyleBox["\:3001\:30b7\:30e3\:30df\:30eb",
    FontFamily->"\.82l\.82r \.96\.be\.92\[Copyright]"],
  StyleBox["(Shamir)",
    FontFamily->"Century"],
  StyleBox["\:3001\:30a2\:30c9\:30ec\:30de\:30f3",
    FontFamily->"\.82l\.82r \.96\.be\.92\[Copyright]"],
  StyleBox["(Adleman)",
    FontFamily->"Century"],
  StyleBox["\:306f",
    FontFamily->"\.82l\.82r \.96\.be\.92\[Copyright]"],
  StyleBox["RSA",
    FontFamily->"Century"],
  StyleBox["\:6cd5\:3068\:547c\:3070\:308c\:308b\:3001\:73fe\:5728\:6700\:3082\
\:666e\:53ca\:3057\:3066\:3044\:308b\:516c\:958b\:30ab\:30ae\:6697\:53f7\:4f5c\
\:6210\:6cd5\:3092\:767a\:898b\:3057\:305f\:3002",
    FontFamily->"\.82l\.82r \.96\.be\.92\[Copyright]"],
  "\n",
  StyleBox[" ",
    FontFamily->"Century"],
  StyleBox["\:3053\:306e\:65b9\:5f0f\:306e\:7279\:5fb4\:306f\:3001\:6697\:53f7\
\:4f5c\:6210\:8005\:304c\:ff12\:3064\:306e\:30ab\:30ae",
    FontFamily->"\.82l\.82r \.96\.be\.92\[Copyright]"],
  StyleBox["Ckey",
    FontFamily->"Century"],
  StyleBox["\:3001",
    FontFamily->"\.82l\.82r \.96\.be\.92\[Copyright]"],
  StyleBox["Ekey",
    FontFamily->"Century"],
  StyleBox["\:3092\:516c\:958b\:3057\:3001",
    FontFamily->"\.82l\.82r \.96\.be\.92\[Copyright]"],
  StyleBox["Dkey",
    FontFamily->"Century"],
  StyleBox["\:3092\:79d8\:5bc6\:306e\:30ab\:30ae\:3068\:3059\:308b\:3068\:3053\
\:308d\:306b\:3042\:308b\:3002\:3053\:306e\:ff13\:3064\:306e\:30ab\:30ae\:306f\
\:6b21\:306e\:3088\:3046\:306a\:6027\:8cea\:3092\:6301\:3064\:3002",
    FontFamily->"\.82l\.82r \.96\.be\.92\[Copyright]"],
  "\n\:ff08\:ff11\:ff09",
  StyleBox["Ckey",
    FontFamily->"Century"],
  StyleBox["\:306f\:ff12\:3064\:306e\:7d20\:6570\:ff50\:3001\:ff51\:306e\:7a4d\
\:3067\:3042\:308b\:3002",
    FontFamily->"\.82l\.82r \.96\.be\.92\[Copyright]"],
  "\n\:ff08\:ff12\:ff09",
  StyleBox["Dkey",
    FontFamily->"Century"],
  StyleBox["\:306f\:3001\:6761\:4ef6",
    FontFamily->"\.82l\.82r \.96\.be\.92\[Copyright]"],
  StyleBox["0",
    FontFamily->"Century"],
  StyleBox["\:ff1c",
    FontFamily->"\.82l\.82r \.96\.be\.92\[Copyright]"],
  StyleBox["Dkey ",
    FontFamily->"Century"],
  StyleBox["\:ff1c",
    FontFamily->"\.82l\.82r \.96\.be\.92\[Copyright]"],
  StyleBox["Ckey",
    FontFamily->"Century"],
  StyleBox["\:3092\:6e80\:305f\:3059\:3001",
    FontFamily->"\.82l\.82r \.96\.be\.92\[Copyright]"],
  StyleBox["(p-1)(q-1)",
    FontFamily->"Century"],
  StyleBox["\:3068\:4e92\:3044\:306b\:7d20\:306a\:6574\:6570\:3067\:3042\:308b\
\:3002",
    FontFamily->"\.82l\.82r \.96\.be\.92\[Copyright]"],
  "\n\:ff08\:ff13\:ff09",
  StyleBox["Ekey",
    FontFamily->"Century"],
  StyleBox["\:306f\:3001\:6761\:4ef6",
    FontFamily->"\.82l\.82r \.96\.be\.92\[Copyright]"],
  StyleBox["Ekey",
    FontFamily->"Century"],
  StyleBox["\:30fb",
    FontFamily->"\.82l\.82r \.96\.be\.92\[Copyright]"],
  StyleBox["Dkey ",
    FontFamily->"Century"],
  StyleBox["\[Congruent] 1 mod (p-1)(q-1) \:3068",
    FontFamily->"\.82l\.82r \.96\.be\.92\[Copyright]"],
  StyleBox["0",
    FontFamily->"Century"],
  StyleBox["\:ff1c",
    FontFamily->"\.82l\.82r \.96\.be\.92\[Copyright]"],
  StyleBox["Ekey ",
    FontFamily->"Century"],
  StyleBox["\:ff1c",
    FontFamily->"\.82l\.82r \.96\.be\.92\[Copyright]"],
  StyleBox["Ckey",
    FontFamily->"Century"],
  StyleBox["\:3092\:6e80\:305f\:3059\:6574\:6570\:3067\:3042\:308b\:3002",
    FontFamily->"\.82l\.82r \.96\.be\.92\[Copyright]"],
  "\n",
  StyleBox["\:3000\:4f8b\:3048\:3070\:3001",
    FontFamily->"\.82l\.82r \.96\.be\.92\[Copyright]"],
  StyleBox["Ckey",
    FontFamily->"Century"],
  StyleBox["\:304c",
    FontFamily->"\.82l\.82r \.96\.be\.92\[Copyright]"],
  StyleBox["21877 = 131",
    FontFamily->"Century"],
  StyleBox["\:30fb",
    FontFamily->"\.82l\.82r \.96\.be\.92\[Copyright]"],
  StyleBox["167",
    FontFamily->"Century"],
  StyleBox["\:3067\:3001",
    FontFamily->"\.82l\.82r \.96\.be\.92\[Copyright]"],
  StyleBox["Dkey",
    FontFamily->"Century"],
  StyleBox["\:304c",
    FontFamily->"\.82l\.82r \.96\.be\.92\[Copyright]"],
  StyleBox["15233",
    FontFamily->"Century"],
  StyleBox["\:306a\:3089\:3070\:3001",
    FontFamily->"\.82l\.82r \.96\.be\.92\[Copyright]"],
  StyleBox["Ekey",
    FontFamily->"Century"],
  StyleBox["\:306f",
    FontFamily->"\.82l\.82r \.96\.be\.92\[Copyright]"],
  StyleBox["17",
    FontFamily->"Century"],
  StyleBox["\:3067\:3042\:308b\:3002",
    FontFamily->"\.82l\.82r \.96\.be\.92\[Copyright]"]
}], "Text"],

Cell[CellGroupData[{

Cell[BoxData[
    RowBox[{
      RowBox[{
        StyleBox["PrimeQ",
          FontFamily->"Century"], 
        StyleBox["[",
          FontFamily->"Century"], 
        StyleBox["131",
          FontFamily->"Times New Roman"], 
        StyleBox["]",
          FontFamily->"Times New Roman"]}], 
      StyleBox[" ",
        FontFamily->"Times New Roman"], 
      StyleBox["&&",
        FontFamily->"Times New Roman"], 
      StyleBox[" ",
        FontFamily->"Times New Roman"], 
      StyleBox[\(PrimeQ[167]\),
        FontFamily->"Times New Roman"]}]], "Input"],

Cell[BoxData[
    \(True\)], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    StyleBox[\(GCD[15233, \ 130\ 166]\),
      FontFamily->"Century"]], "Input"],

Cell[BoxData[
    \(1\)], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    RowBox[{"Solve", "[", 
      RowBox[{\({\ 15233\ x\  == 1, \ Modulus == 130\ 166}\), ",", " ", 
        StyleBox[\(Mode -> Modular\),
          FontFamily->"Century",
          FontSize->10.5]}], 
      StyleBox["]",
        FontFamily->"Century",
        FontSize->10.5]}]], "Input"],

Cell[BoxData[
    \({{Modulus \[Rule] 21580, x \[Rule] 17}}\)], "Output"]
}, Open  ]],

Cell[TextData[{
  "\:554f",
  StyleBox["\:ff15\:ff0e",
    FontFamily->"\.82l\.82r \.96\.be\.92\[Copyright]",
    FontSize->10.5],
  StyleBox["100",
    FontFamily->"Century"],
  StyleBox["\:6841\:3088\:308a\:5927\:304d\:306a\:7d20\:6570\:ff50\:3001\:ff51\
\:3068(p-1)(q-1)\:3068\:4e92\:3044\:306b\:7d20\:306a",
    FontFamily->"\.82l\.82r \.96\.be\.92\[Copyright]"],
  StyleBox["Dkey",
    FontFamily->"Century"],
  StyleBox["\:3092\:4e0e\:3048\:305f\:3068\:304d\:3001",
    FontFamily->"\.82l\.82r \.96\.be\.92\[Copyright]"],
  StyleBox["Ekey",
    FontFamily->"Century"],
  StyleBox["\:3092\:6c42\:3081\:308b\:30d7\:30ed\:30b0\:30e9\:30e0\:3092\:4f5c\
\:308c\:3002",
    FontFamily->"\.82l\.82r \.96\.be\.92\[Copyright]"],
  "\n\n  ",
  StyleBox["RSA",
    FontFamily->"Century"],
  StyleBox["\:65b9\:5f0f\:3067\:30e1\:30c3\:30bb\:30fc\:30b8\:3092\:6697\:53f7\
\:5316\:3059\:308b\:306b\:306f\:3001\:6b21\:306e\:3088\:3046\:306b\:3059\:308b\
\:3002",
    FontFamily->"\.82l\.82r \.96\.be\.92\[Copyright]"],
  "\n\:ff08\:ff11\:ff09",
  StyleBox["\:30e1\:30c3\:30bb\:30fc\:30b8\:3092\:9069\:5f53\:306a\:9577\:3055\
\:306e\:30d6\:30ed\:30c3\:30af\:306b\:5206\:5272\:3057\:3001\:5404\:30d6\:30ed\
\:30c3\:30af\:3092\:6570\:5b57\:ff58\:306b\:5909\:63db\:3059\:308b\:3002",
    FontFamily->"\.82l\.82r \.96\.be\.92\[Copyright]"],
  "\n\:ff08\:ff12\:ff09",
  StyleBox["PowerMod[x, Ekey, Ckey]",
    FontFamily->"Century"],
  StyleBox["\:3092\:8a08\:7b97\:3059\:308b\:3002\:3059\:306a\:308f\:3061\:3001\
\:ff58\:306e",
    FontFamily->"\.82l\.82r \.96\.be\.92\[Copyright]"],
  StyleBox["Ekey",
    FontFamily->"Century"],
  StyleBox["\:4e57\:3092",
    FontFamily->"\.82l\.82r \.96\.be\.92\[Copyright]"],
  StyleBox["Ckey",
    FontFamily->"Century"],
  StyleBox["\:3067\:5272\:3063\:305f\:4f59\:308a\:ff59\:3092\:6c42\:3081\:308b\
\:3002",
    FontFamily->"\.82l\.82r \.96\.be\.92\[Copyright]"],
  "\n\:ff08\:ff13\:ff09",
  StyleBox["\:5404\:30d6\:30ed\:30c3\:30af\:6bce\:306b\:8a08\:7b97\:3057\:305f\
\:ff08\:ff12\:ff09\:3067\:5f97\:3089\:308c\:305f\:5024\:306e\:30ea\:30b9\:30c8\
\:3092\:6697\:53f7\:6587\:3068\:3059\:308b\:3002",
    FontFamily->"\.82l\.82r \.96\.be\.92\[Copyright]"]
}], "Text"],

Cell[CellGroupData[{

Cell[BoxData[{
    \(FactorInteger[68718821377]\), "\[IndentingNewLine]", 
    \(GCD[
      1777, \((131071 - 1)\)\ \((524287 - 1)\)]\), "\[IndentingNewLine]", 
    \(Solve[
      1777\ x \[Equal] 1 && 
        Modulus \[Equal] \((131071 - 1)\)\ \((524287 - 1)\), x]\)}], "Input"],

Cell[BoxData[
    \({{131071, 1}, {524287, 1}}\)], "Output"],

Cell[BoxData[
    \(1\)], "Output"],

Cell[BoxData[
    \({{Modulus \[Rule] 68718166020, x \[Rule] 47603861773}}\)], "Output"]
}, Open  ]],

Cell[BoxData[{
    RowBox[{
      RowBox[{
        StyleBox["CCkey",
          FontFamily->"Century",
          FontSize->10.5], 
        StyleBox[" ",
          FontFamily->"Century",
          FontSize->10.5], 
        StyleBox["=",
          FontFamily->"Century",
          FontSize->10.5], 
        StyleBox[" ",
          FontFamily->"Century",
          FontSize->10.5], 
        StyleBox["68718821377",
          FontFamily->"\.82l\.82r \.82o\.96\.be\.92\[Copyright]",
          FontSize->10.5]}], 
      StyleBox[";",
        FontFamily->"Century",
        FontSize->10.5], 
      "          ", \( (*\ \ 255*256^3 + 255*256^2 + 255*256 + 255\  = \ 
          4294967295\ *) \), "\n", 
      StyleBox[\(EEkey\  = \ 47603861773\),
        FontFamily->"Century",
        FontSize->10.5], 
      StyleBox[";",
        FontFamily->"Century",
        FontSize->10.5]}], "\n", \(MyEncode[nl_, m_, n_] := 
      Block[{j, s = 0}, \n\ \ For[j = m, j <= n, 
          s = s*256 + First[nl[\([{j}]\)]]; \(j++\)]; \n\ \ s = 
          PowerMod[s, EEkey, CCkey]; \n\ \ Return[s]\n]\), "\n", 
    RowBox[{
      RowBox[{
        StyleBox[\(RSAEncode[msg_]\),
          FontFamily->"Century"], 
        StyleBox[":=",
          FontFamily->"Century"], 
        StyleBox[" ",
          FontFamily->"Century"], 
        RowBox[{
          StyleBox["Block",
            FontFamily->"Century"], 
          StyleBox["[",
            FontFamily->"Century"], 
          RowBox[{
            StyleBox[\({j, \ code = {}, \ len, \ l3, \ nl}\),
              FontFamily->"Century"], 
            StyleBox[",",
              FontFamily->"Century"], 
            StyleBox["\n",
              FontFamily->"Century"], 
            RowBox[{
              StyleBox[\(len\  = \ StringLength[msg]\),
                FontFamily->"Century"], 
              StyleBox[";",
                FontFamily->"Century"], 
              StyleBox["\n",
                FontFamily->"Century"], 
              StyleBox[\(nl\  = \ ToCharacterCode[msg]\),
                FontFamily->"Century"], 
              StyleBox[";",
                FontFamily->"Century"], 
              StyleBox["\n",
                FontFamily->"Century"], 
              StyleBox[\(l3\  = \ len\  - 3\),
                FontFamily->"Century"], 
              StyleBox[";",
                FontFamily->"Century"], 
              StyleBox["\n",
                FontFamily->"Century"], 
              
              StyleBox[\(For[j = 1, \ j < l3, \ 
                  j\  += 4, \ \n\ \ \ \ \ \ \ \ \ \ \ \ \ code = 
                    Append[code, \ MyEncode[nl, \ j, \ j + 3]]]\),
                FontFamily->"Century"], 
              StyleBox[";",
                FontFamily->"Century"], 
              StyleBox[" ",
                FontFamily->"Century"], "\n", "\t", 
              RowBox[{"(*", 
                StyleBox[" ",
                  FontFamily->"Century"], 
                
                StyleBox[\(4  \
\:6587\:5b57\:305a\:3064\:30d6\:30ed\:30c3\:30af\:5316\),
                  FontFamily->"\.82l\.82r \.96\.be\.92\[Copyright]"], 
                StyleBox[" ",
                  FontFamily->"\.82l\.82r \.96\.be\.92\[Copyright]"], 
                StyleBox["*)",
                  FontFamily->"\.82l\.82r \.96\.be\.92\[Copyright]"]}], "\n", 
              "\t", 
              
              StyleBox[\(If[j <= len, \ 
                  code\  = \ Append[code, \ MyEncode[nl, \ j, \ len]]]\),
                FontFamily->"Century"], 
              StyleBox[";",
                FontFamily->"Century"], 
              StyleBox["\n",
                FontFamily->"Century"], 
              StyleBox[\(Return[code]\),
                FontFamily->"Century"]}]}], "\[IndentingNewLine]", 
          StyleBox["]",
            FontFamily->"Century"]}]}], "\n"}], "\[IndentingNewLine]", 
    RowBox[{
      RowBox[{"DDkey", "=", 
        StyleBox["1777",
          FontFamily->"Century"]}], ";"}], "\n", \(MyDecode[msg_] := 
      Block[{cl = {}, q}, \n\ \ q = PowerMod[msg, DDkey, CCkey]; \n\ \ While[
          q > 0, \n\ \ \ \ cl = 
            Append[cl, FromCharacterCode[Mod[q, 256]]]; \n\ \ \ \ q = 
            Quotient[q, 256]\n\ \ ]; \n\ \ Return[
          Reverse[cl]]\n]\), "\n", \(RSADecode[code_] := 
      Block[{cl = {}, cc, str}, \n\ \ cc\  = \ code; \n\ \ While[
          cc != {}, \n\ \ \ \ cl = 
            Append[cl, MyDecode[First[cc]]]; \n\ \ \ \ cc = 
            Rest[cc]\n\ \ ]; \n\ \ str = StringJoin[cl]; \n\ \ Return[
          str]\n]\), "\n", }], "Input"],

Cell[CellGroupData[{

Cell[BoxData[
    StyleBox[\(res\  = \ RSAEncode["\<American Dream\>"]\),
      FontFamily->"Century"]], "Input"],

Cell[BoxData[
    \({35476636370, 18162420129, 1540848472, 31519593521}\)], "Output"]
}, Open  ]],

Cell[TextData[{
  " ",
  StyleBox["\:4e0a\:3067\:4f5c\:3089\:308c\:305f\:6697\:53f7\:6587\:3092\:89e3\
\:8aad\:3059\:308b\:306b\:306f\:3001\:6b21\:306e\:3088\:3046\:306b\:3059\:308b\
\:3002",
    FontFamily->"\.82l\.82r \.96\.be\.92\[Copyright]",
    FontSize->10.5],
  "\n\:ff08\:ff11\:ff09",
  StyleBox["\:6697\:53f7\:ff59\:3092",
    FontFamily->"\.82l\.82r \.96\.be\.92\[Copyright]"],
  StyleBox["PowerMode[y, DDkey, CCkey] ",
    FontFamily->"Century"],
  StyleBox["\:3067\:5fa9\:53f7\:5316\:3057\:3001\:5143\:306e\:30d6\:30ed\:30c3\
\:30af\:306b\:5bfe\:5fdc\:3059\:308b\:6570\:5b57\:ff58\:3092\:5f97\:308b\:3002\
",
    FontFamily->"\.82l\.82r \.96\.be\.92\[Copyright]"],
  "\n\:ff08\:ff12\:ff09",
  StyleBox["\:ff58\:3092\:6587\:5b57\:5217\:306b\:5909\:63db\:3057\:3001\:5168\
\:4f53\:306e\:6587\:5b57\:5217\:3092\:5fa9\:5143\:3059\:308b\:3002\n",
    FontFamily->"\.82l\.82r \.96\.be\.92\[Copyright]"]
}], "Text"],

Cell[CellGroupData[{

Cell[BoxData[
    StyleBox[\(RSADecode[res]\),
      FontFamily->"Century",
      FontSize->10.5]], "Input"],

Cell[BoxData[
    \("American Dream"\)], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[{
    StyleBox[\(res\  = \ RSAEncode["\<Japanese Dream\>"]\),
      FontFamily->"Century"], "\[IndentingNewLine]", 
    StyleBox[\(RSADecode[res]\),
      FontFamily->"Century",
      FontSize->10.5]}], "Input"],

Cell[BoxData[
    \({50682269808, 65906219646, 1540848472, 31519593521}\)], "Output"],

Cell[BoxData[
    \("Japanese Dream"\)], "Output"]
}, Open  ]],

Cell[TextData[{
  StyleBox["\:554f\:ff16\:ff0eCCkey=68718821377, EEkey=13 \:3068\:3057\:3066\
\:3001\:95a2\:6570 RSAEncode\:3092\:7528\:3044\:3066\:3042\:308b\:82f1\:6587\
\:306e\:6587\:7ae0\:3092\:6697\:53f7\:5316\:3057\:3066\:3001\:6b21\:306e\:3088\
\:3046\:306a\:30b3\:30fc\:30c9\:3092\:5f97\:305f\:3002\n\
{9686589191,33671371686,7288443647,7589310551,31672101653,16463166338,\n  \
58418820492,2157477497,51826649819}\n  \:5fa9\:53f7\:30ad\:30fcDDkey\:3092\
\:63a2\:7d22\:3057\:3066\:3001\:3053\:306e\:30b3\:30fc\:30c9\:3092\:5143\:306e\
\:6587\:7ae0\:306b\:623b\:305b\:3002\n \:300c\:30d2\:30f3\:30c8\:ff1a",
    FontFamily->"\.82l\.82r \.82o\.96\.be\.92\[Copyright]"],
  "FactorInteger[68718821377]\n Solve[13 x ==1 && Modulus==(131071-1) \
(524287-1),x]",
  StyleBox["\n \:3067Dkey\:3092\:63a2\:7d22\:305b\:3088\:3002\:300d \n   ",
    FontFamily->"\.82l\.82r \.82o\.96\.be\.92\[Copyright]"],
  StyleBox["RSA",
    FontFamily->"\.82l\.82r \.82o\.96\.be\.92\[Copyright]",
    FontSize->10.5],
  StyleBox["\:65b9\:5f0f\:306e\:6697\:53f7\:5316\:306f\:6975\:3081\:3066\:7c21\
\:5358\:306a\:539f\:7406\:306b\:57fa\:3065\:3044\:3066\:3044\:308b\:3002\:3059\
\:306a\:308f\:3061\:30010<x<CCkey \
\:3092\:6e80\:305f\:3059\:6570\:ff58\:3092EEkey\:4e57\:3057\:3066\:5f97\:3089\
\:308c\:308b\:5024\:3092\:3001CCkey\:3067\:5272\:3063\:305f\:3068\:304d\:306e\
\:4f59\:308a\:3092\:ff59\:3068\:3059\:308b\:3002\:3053\:306e\:3068\:304d\:3001\
\:ff59\:3092DDkey\:4e57\:3057\:3066\:5f97\:3089\:308c\:308b\:5024\:3092\:3001\
CCkey\:3067\:5272\:3063\:305f\:4f59\:308a\:304c\:ff58\:306b\:623b\:308b\:3068\
\:3044\:3046\:4e8b\:5b9f\:3092\:5229\:7528\:3057\:3066\:3044\:308b\:3002\n \
\:4f8b\:3048\:3070\:300112345\:3001\:ff11\:3001CCkey-1\:306b\:5bfe\:3057\:3066\
\:306f\:3001\:78ba\:304b\:306b\:6b63\:3057\:3044\:3002\n",
    FontFamily->"\.82l\.82r \.82o\.96\.be\.92\[Copyright]"],
  "\t\t\t\t"
}], "Text"],

Cell[CellGroupData[{

Cell[BoxData[{
    RowBox[{"PowerMod", "[", 
      StyleBox[\(PowerMod[12345, \ EEkey, \ CCkey], \ DDkey, \ CCkey\),
        FontFamily->"Century",
        FontSize->10.5], 
      StyleBox["]",
        FontFamily->"Century",
        FontSize->10.5]}], "\n", 
    StyleBox[\(PowerMod[PowerMod[1, \ EEkey, \ CCkey], \ DDkey, \ CCkey]\),
      FontFamily->"Century",
      FontSize->10.5], "\n", 
    RowBox[{
      StyleBox[" ",
        FontFamily->"Century",
        FontSize->10.5], 
      StyleBox[\(PowerMod[PowerMod[CCkey - 1, \ EEkey, \ CCkey], \ DDkey, \ 
          CCkey]\),
        FontFamily->"Century",
        FontSize->10.5]}]}], "Input"],

Cell[BoxData[
    \(12345\)], "Output"],

Cell[BoxData[
    \(1\)], "Output"],

Cell[BoxData[
    \(68718821376\)], "Output"]
}, Open  ]],

Cell[TextData[{
  " ",
  StyleBox["\:ff12\:3064\:306e\:7d20\:6570\:ff50",
    FontFamily->"\.82l\.82r \.96\.be\.92\[Copyright]"],
  StyleBox[", ",
    FontFamily->"Century"],
  StyleBox["\:ff51\:3068\:3001",
    FontFamily->"\.82l\.82r \.96\.be\.92\[Copyright]"],
  StyleBox["(p-1)(q-1)",
    FontFamily->"Century"],
  StyleBox["\:3068\:4e92\:3044\:306b\:7d20\:306a\:6570\:ff44\:3068\:3001\:ff44\
",
    FontFamily->"\.82l\.82r \.96\.be\.92\[Copyright]"],
  StyleBox["e",
    FontFamily->"Century"],
  StyleBox["\[Congruent] 1 mod (p-1)(q-1) \:3092\:6e80\:305f\:3059\:6570e \
\:306b\:5bfe\:3057\:3066\:3001",
    FontFamily->"\.82l\.82r \.96\.be\.92\[Copyright]"],
  StyleBox["0",
    FontFamily->"Times New Roman"],
  StyleBox["\:3068\:ff50\:ff51\:3068\:306e\:9593\:306e\:6570\:ff58\:306e",
    FontFamily->"\.82l\.82r \.96\.be\.92\[Copyright]"],
  StyleBox["ed ",
    FontFamily->"Times New Roman"],
  StyleBox["\:4e57\:3092\:ff50\:ff51\:3067\:5272\:3063\:305f\:4f59\:308a\:304c\
\:ff58\:306b\:623b\:308b\:3053\:3068\:306f\:3001\:6b21\:306e\:ff13\:3064\:306e\
\:5834\:5408\:306b\:5206\:3051\:3066\:793a\:3055\:308c\:308b\:3002",
    FontFamily->"\.82l\.82r \.96\.be\.92\[Copyright]"],
  "\n\:ff08\:ff11\:ff09",
  StyleBox["\:ff58\:306f\:ff50\:3082\:ff51\:3082\:7d04\:6570\:306b\:6301\:3064\
\:3002",
    FontFamily->"\.82l\.82r \.96\.be\.92\[Copyright]"],
  "\n\:ff08\:ff12\:ff09",
  StyleBox["\:ff58\:306f\:ff50\:ff08\:307e\:305f\:306f\:ff51\:ff09\:3092\:7d04\
\:6570\:306b\:306f\:6301\:305f\:306a\:3044\:304c\:3001\:ff51\:ff08\:307e\:305f\
\:306f\:ff50\:ff09\:3092\:7d04\:6570\:306b\:306f\:6301\:3064\:3002",
    FontFamily->"\.82l\.82r \.96\.be\.92\[Copyright]"],
  "\n\:ff08\:ff13\:ff09",
  StyleBox["\:ff58\:306f\:ff50\:3082\:ff51\:3082\:7d04\:6570\:306b\:306f\:5f85\
\:305f\:306a\:3044\:3002",
    FontFamily->"\.82l\.82r \.96\.be\.92\[Copyright]"],
  StyleBox[" ",
    FontFamily->"Times New Roman"],
  "\n",
  StyleBox[" ",
    FontFamily->"Century"],
  StyleBox["\:ff08\:ff11\:ff09\:3001\:ff08\:ff12\:ff09\:306e\:5834\:5408\:306f\
\:6613\:3057\:3044\:306e\:3067\:3001\:6700\:5f8c\:306e\:5834\:5408\:306e\:307f\
\:6b63\:3057\:3044\:3053\:3068\:3092\:793a\:3059\:3002",
    FontFamily->"\.82l\.82r \.96\.be\.92\[Copyright]"],
  "\n",
  StyleBox[" ",
    FontFamily->"Century"],
  StyleBox["\:307e\:305a\:3001\:ff44",
    FontFamily->"\.82l\.82r \.96\.be\.92\[Copyright]"],
  StyleBox["e",
    FontFamily->"Century"],
  StyleBox["\[Congruent] 1 mod (p-1)(q-1)\:3088\:308a\:3001\:9069\:5f53\:306a\
\:6574\:6570\:ff4b\:306b\:5bfe\:3057\:3066\:3001de = \
k(p-1)(q-1)+1\:304c\:6210\:308a\:7acb\:3064\:3002\:307e\:305f\:3001\:ff58\
\:3068\:ff50\:3068\:306f\:4e92\:3044\:306b\:7d20\:3067\:3042\:308b\:306e\:3067\
\:3001\:30aa\:30a4\:30e9\:30fc\:306e\:5c0f\:5b9a\:7406\:306b\:3088\:308a\:3001\
",
    FontFamily->"\.82l\.82r \.96\.be\.92\[Copyright]"],
  Cell[BoxData[
      \(TraditionalForm\`x\^\(p - 1\)\)]],
  StyleBox["\:306f",
    FontFamily->"\.82l\.82r \.96\.be\.92\[Copyright]"],
  StyleBox["modulo ",
    FontFamily->"Century"],
  StyleBox["\:ff50\:3067\:ff11\:306b\:7b49\:3057\:3044\:306e\:3067\:3001",
    FontFamily->"\.82l\.82r \.96\.be\.92\[Copyright]"],
  Cell[BoxData[
      \(TraditionalForm\`x\^\(\((p - 1)\) \((q - 1)\)\)\)]],
  StyleBox["\:3082",
    FontFamily->"\.82l\.82r \.96\.be\.92\[Copyright]"],
  StyleBox["modulo ",
    FontFamily->"Century"],
  StyleBox["\:ff50\:3067\:ff11\:306b\:7b49\:3057\:3044\:3002\:ff51\:306b\:3064\
\:3044\:3066\:3082\:540c\:69d8\:306b\:3001",
    FontFamily->"\.82l\.82r \.96\.be\.92\[Copyright]"],
  Cell[BoxData[
      \(TraditionalForm\`x\^\(\((p - 1)\) \((q - 1)\)\)\)]],
  StyleBox["\:306f",
    FontFamily->"\.82l\.82r \.96\.be\.92\[Copyright]"],
  StyleBox["modulo  q",
    FontFamily->"Century"],
  StyleBox["\:3067\:ff11\:306b\:7b49\:3057\:3044\:3002\:5f93\:3063\:3066\:3001\
",
    FontFamily->"\.82l\.82r \.96\.be\.92\[Copyright]"],
  Cell[BoxData[
      \(TraditionalForm\`x\^\(\((p - 1)\) \((q - 1)\) + 1\)\)]],
  StyleBox["\:306f",
    FontFamily->"\.82l\.82r \.96\.be\.92\[Copyright]"],
  StyleBox["modulo ",
    FontFamily->"Century"],
  StyleBox["\:ff50\:3067\:3082",
    FontFamily->"\.82l\.82r \.96\.be\.92\[Copyright]"],
  StyleBox["modulo q",
    FontFamily->"Century"],
  StyleBox["\:3067\:3082\:ff58\:306b\:7b49\:3057\:3044\:3002\:6545\:306b\:3001\
",
    FontFamily->"\.82l\.82r \.96\.be\.92\[Copyright]"],
  Cell[BoxData[
      \(TraditionalForm\`x\^ed\)]],
  StyleBox["\:306f",
    FontFamily->"\.82l\.82r \.96\.be\.92\[Copyright]"],
  StyleBox["modulo ",
    FontFamily->"Century"],
  StyleBox["\:ff50",
    FontFamily->"\.82l\.82r \.96\.be\.92\[Copyright]"],
  StyleBox["q",
    FontFamily->"Century"],
  StyleBox["\:3067",
    FontFamily->"\.82l\.82r \.96\.be\.92\[Copyright]"],
  StyleBox["x",
    FontFamily->"Century"],
  StyleBox["\:306b\:7b49\:3057\:3044\:3002\n ",
    FontFamily->"\.82l\.82r \.96\.be\.92\[Copyright]"],
  "\n",
  StyleBox["\:554f",
    FontFamily->"\.82l\.82r \.96\.be\.92\[Copyright]"],
  StyleBox[" ",
    FontFamily->"Century"],
  StyleBox["\:ff15\:ff0e\:30aa\:30a4\:30e9\:30fc\:306e\:5c0f\:5b9a\:7406\:3001\
\[OpenCurlyDoubleQuote]\:ff58\:304c\:7d20\:6570\:ff50\:3092\:7d04\:6570\:306b\
\:6301\:305f\:306a\:3044\:3068\:304d\:3001",
    FontFamily->"\.82l\.82r \.96\.be\.92\[Copyright]"],
  Cell[BoxData[
      \(TraditionalForm\`x\^\(p - 1\)\)]],
  StyleBox["\[Congruent]",
    FontFamily->"\.82l\.82r \.96\.be\.92\[Copyright]"],
  "1 mod p",
  StyleBox["\:304c\:6210\:308a\:7acb\:3064\[CloseCurlyDoubleQuote]\:3001\:304c\
\:6b63\:3057\:3044\:3053\:3068\:3092\:793a\:305b\:3002",
    FontFamily->"\.82l\.82r \.96\.be\.92\[Copyright]"],
  "\n",
  StyleBox[" ",
    FontFamily->"Century"],
  StyleBox["\:30d2\:30f3\:30c8\:ff1a\:3044\:304f\:3064\:304b\:306e\:5177\:4f53\
\:7684\:7d20\:6570\:ff50\:306b\:5bfe\:3057\:3066\:3001",
    FontFamily->"\.82l\.82r \.96\.be\.92\[Copyright]"],
  Cell[BoxData[
      \(TraditionalForm\`\((a + b)\)\^p\)]],
  StyleBox["\:3092",
    FontFamily->"\.82l\.82r \.96\.be\.92\[Copyright]"],
  StyleBox["modulo p",
    FontFamily->"Century"],
  StyleBox["\:3067\:8a08\:7b97\:305b\:3088\:3002",
    FontFamily->"\.82l\.82r \.96\.be\.92\[Copyright]"]
}], "Text"],

Cell[CellGroupData[{

Cell[BoxData[{
    RowBox[{"Clear", "[", 
      StyleBox[\(a, b\),
        FontFamily->"Century",
        FontSize->10.5], 
      StyleBox["]",
        FontFamily->"Century",
        FontSize->10.5]}], 
    StyleBox[\(PolynomialMod[Expand[\((a + b)\)^13], 13]\),
      FontFamily->"Century",
      FontSize->10.5]}], "Input"],

Cell[BoxData[
    \(a\^13 + b\^13\)], "Output"]
}, Open  ]],

Cell[TextData[{
  "  ",
  StyleBox["RSA",
    FontFamily->"Century"],
  StyleBox["\:65b9\:5f0f\:306e\:6697\:53f7\:3092\:89e3\:8aad\:3059\:308b\:306b\
\:306f\:3001\:516c\:958b\:30ab\:30ae",
    FontFamily->"\.82l\.82r \.96\.be\.92\[Copyright]"],
  StyleBox["Ckey",
    FontFamily->"Century"],
  StyleBox["\:3092\:7d20\:56e0\:6570\:6570\:5206\:89e3\:3057\:3066\:3001\:7d20\
\:6570\:ff50\:3001\:ff51\:3092\:898b\:3064\:3051\:51fa\:3059\:5fc5\:8981\:304c\
\:3042\:308b\:3002\:3057\:304b\:3057\:3001\:6574\:6570\:3092\:7d20\:56e0\:6570\
\:6570\:5206\:89e3\:3059\:308b\:305f\:3081\:306e\:591a\:9805\:5f0f\:30aa\:30fc\
\:30c0\:306e\:9ad8\:901f\:306a\:30a2\:30eb\:30b4\:30ea\:30ba\:30e0\:306f\:3001\
\:307e\:3060\:77e5\:3089\:308c\:3066\:3044\:306a\:3044\:306e\:3067\:3001\:ff50\
\:3001\:ff51\:304c\:6841\:6570\:306e\:5927\:304d\:306a\:7d20\:6570\:306e\:5834\
\:5408\:306b\:6570\:ff50\:ff51\:3092\:7d20\:56e0\:6570\:5206\:89e3\:3059\:308b\
\:3053\:3068\:306f\:3001\:6975\:3081\:3066\:56f0\:96e3\:3067\:3042\:308b\:3002\
\:5f93\:3063\:3066\:3001\:6697\:53f7\:5316\:3068\:5fa9\:53f7\:5316\:304c\:6bd4\
\:8f03\:7684\:7c21\:5358\:306a\:5272\:306b\:3001\:79d8\:533f\:6027\:306e\:5f37\
\:56fa\:306a\:6697\:53f7\:4f5c\:6210\:6cd5\:3067\:3042\:308b\:3002",
    FontFamily->"\.82l\.82r \.96\.be\.92\[Copyright]"]
}], "Text"]
},
FrontEndVersion->"5.0 for Microsoft Windows",
ScreenRectangle->{{0, 1024}, {0, 695}},
WindowSize->{1013, 668},
WindowMargins->{{0, Automatic}, {Automatic, 0}},
PrintingCopies->1,
PrintingPageRange->{Automatic, Automatic}
]

(*******************************************************************
Cached data follows.  If you edit this Notebook file directly, not
using Mathematica, you must remove the line containing CacheID at
the top of  the file.  The cache data will then be recreated when
you save this file from within Mathematica.
*******************************************************************)

(*CellTagsOutline
CellTagsIndex->{}
*)

(*CellTagsIndex
CellTagsIndex->{}
*)

(*NotebookFileOutline
Notebook[{
Cell[1754, 51, 1807, 33, 123, "Text"],

Cell[CellGroupData[{
Cell[3586, 88, 670, 17, 130, "Input"],
Cell[4259, 107, 64, 1, 29, "Output"]
}, Open  ]],
Cell[4338, 111, 2348, 62, 111, "Text"],
Cell[6689, 175, 355, 8, 47, "Output"],
Cell[7047, 185, 5872, 151, 206, "Text"],

Cell[CellGroupData[{
Cell[12944, 340, 562, 18, 30, "Input"],
Cell[13509, 360, 38, 1, 29, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[13584, 366, 94, 2, 30, "Input"],
Cell[13681, 370, 35, 1, 29, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[13753, 376, 302, 8, 30, "Input"],
Cell[14058, 386, 73, 1, 29, "Output"]
}, Open  ]],
Cell[14146, 390, 2194, 51, 131, "Text"],

Cell[CellGroupData[{
Cell[16365, 445, 280, 6, 70, "Input"],
Cell[16648, 453, 60, 1, 29, "Output"],
Cell[16711, 456, 35, 1, 29, "Output"],
Cell[16749, 459, 88, 1, 29, "Output"]
}, Open  ]],
Cell[16852, 463, 4536, 117, 750, "Input"],

Cell[CellGroupData[{
Cell[21413, 584, 113, 2, 30, "Input"],
Cell[21529, 588, 85, 1, 29, "Output"]
}, Open  ]],
Cell[21629, 592, 921, 20, 88, "Text"],

Cell[CellGroupData[{
Cell[22575, 616, 108, 3, 29, "Input"],
Cell[22686, 621, 50, 1, 29, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[22773, 627, 224, 5, 50, "Input"],
Cell[23000, 634, 85, 1, 29, "Output"],
Cell[23088, 637, 50, 1, 29, "Output"]
}, Open  ]],
Cell[23153, 641, 1892, 30, 199, "Text"],

Cell[CellGroupData[{
Cell[25070, 675, 649, 18, 70, "Input"],
Cell[25722, 695, 39, 1, 29, "Output"],
Cell[25764, 698, 35, 1, 29, "Output"],
Cell[25802, 701, 45, 1, 29, "Output"]
}, Open  ]],
Cell[25862, 705, 6201, 150, 243, "Text"],

Cell[CellGroupData[{
Cell[32088, 859, 325, 10, 50, "Input"],
Cell[32416, 871, 47, 1, 29, "Output"]
}, Open  ]],
Cell[32478, 875, 1307, 22, 66, "Text"]
}
]
*)



(*******************************************************************
End of Mathematica Notebook file.
*******************************************************************)

